/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","electron","vs/base/common/errors","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/extpath","vs/base/common/map","vs/base/common/uuid","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","fs","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","vs/base/common/errorMessage","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/window/common/window","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/files/common/watcher","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/remote/common/remoteHosts","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/node/unc","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/codiconsUtil","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/common/codiconsLibrary","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],oe=function(X){for(var e=[],n=0,C=X.length;n<C;n++)e[n]=re[X[n]];return e};define(re[136],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mb=void 0,e.$fb=n,e.$gb=C,e.$hb=E,e.$ib=R,e.$jb=j,e.$kb=k,e.$lb=h,e.$nb=d,e.$ob=b,e.$pb=v,e.$qb=m,e.$rb=f;function n(y,p){const $=C(y,p);if($!==-1)return y[$]}function C(y,p,$=y.length-1){for(let c=$;c>=0;c--){const w=y[c];if(p(w))return c}return-1}function E(y,p){const $=R(y,p);return $===-1?void 0:y[$]}function R(y,p,$=0,c=y.length){let w=$,P=c;for(;w<P;){const a=Math.floor((w+P)/2);p(y[a])?w=a+1:P=a}return w-1}function j(y,p){const $=k(y,p);return $===y.length?void 0:y[$]}function k(y,p,$=0,c=y.length){let w=$,P=c;for(;w<P;){const a=Math.floor((w+P)/2);p(y[a])?P=a:w=a+1}return w}function h(y,p,$=0,c=y.length){const w=k(y,p,$,c);return w===y.length?-1:w}class l{static{this.assertInvariants=!1}constructor(p){this.e=p,this.c=0}findLastMonotonous(p){if(l.assertInvariants){if(this.d){for(const c of this.e)if(this.d(c)&&!p(c))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=p}const $=R(this.e,p,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=l;function d(y,p){if(y.length===0)return;let $=y[0];for(let c=1;c<y.length;c++){const w=y[c];p(w,$)>0&&($=w)}return $}function b(y,p){if(y.length===0)return;let $=y[0];for(let c=1;c<y.length;c++){const w=y[c];p(w,$)>=0&&($=w)}return $}function v(y,p){return d(y,($,c)=>-p($,c))}function m(y,p){if(y.length===0)return-1;let $=0;for(let c=1;c<y.length;c++){const w=y[c];p(w,y[$])>0&&($=c)}return $}function f(y,p){for(const $ of y){const c=p($);if(c!==void 0)return c}}}),define(re[137],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K=n,e.$L=C,e.$M=E,e.$N=R;function n(j,k){const h=Object.create(null);for(const l of j){const d=k(l);let b=h[d];b||(b=h[d]=[]),b.push(l)}return h}function C(j,k){const h=[],l=[];for(const d of j)k.has(d)||h.push(d);for(const d of k)j.has(d)||l.push(d);return{removed:h,added:l}}function E(j,k){const h=[],l=[];for(const[d,b]of j)k.has(d)||h.push(b);for(const[d,b]of k)j.has(d)||l.push(b);return{removed:h,added:l}}function R(j,k){const h=new Set;for(const l of k)j.has(l)&&h.add(l);return h}}),define(re[138],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ot=e.$Nt=e.$Mt=e.$Lt=void 0;function n(k,h){const l=Math.pow(10,h);return Math.round(k*l)/l}class C{constructor(h,l,d,b=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,d))|0,this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.$Lt=C;class E{constructor(h,l,d,b){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.l=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,b=h.b/255,v=h.a,m=Math.max(l,d,b),f=Math.min(l,d,b);let y=0,p=0;const $=(f+m)/2,c=m-f;if(c>0){switch(p=Math.min($<=.5?c/(2*$):c/(2-2*$),1),m){case l:y=(d-b)/c+(d<b?6:0);break;case d:y=(b-l)/c+2;break;case b:y=(l-d)/c+4;break}y*=60,y=Math.round(y)}return new E(y,p,$,v)}static i(h,l,d){return d<0&&(d+=1),d>1&&(d-=1),d<1/6?h+(l-h)*6*d:d<1/2?l:d<2/3?h+(l-h)*(2/3-d)*6:h}static toRGBA(h){const l=h.h/360,{s:d,l:b,a:v}=h;let m,f,y;if(d===0)m=f=y=b;else{const p=b<.5?b*(1+d):b+d-b*d,$=2*b-p;m=E.i($,p,l+1/3),f=E.i($,p,l),y=E.i($,p,l-1/3)}return new C(Math.round(m*255),Math.round(f*255),Math.round(y*255),v)}}e.$Mt=E;class R{constructor(h,l,d,b){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=n(Math.max(Math.min(1,l),0),3),this.v=n(Math.max(Math.min(1,d),0),3),this.a=n(Math.max(Math.min(1,b),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,d=h.g/255,b=h.b/255,v=Math.max(l,d,b),m=Math.min(l,d,b),f=v-m,y=v===0?0:f/v;let p;return f===0?p=0:v===l?p=((d-b)/f%6+6)%6:v===d?p=(b-l)/f+2:p=(l-d)/f+4,new R(Math.round(p*60),y,v,h.a)}static toRGBA(h){const{h:l,s:d,v:b,a:v}=h,m=b*d,f=m*(1-Math.abs(l/60%2-1)),y=b-m;let[p,$,c]=[0,0,0];return l<60?(p=m,$=f):l<120?(p=f,$=m):l<180?($=m,c=f):l<240?($=f,c=m):l<300?(p=f,c=m):l<=360&&(p=m,c=f),p=Math.round((p+y)*255),$=Math.round(($+y)*255),c=Math.round((c+y)*255),new C(p,$,c,v)}}e.$Nt=R;class j{static fromHex(h){return j.Format.CSS.parseHex(h)||j.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:E.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:R.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof C)this.rgba=h;else if(h instanceof E)this.i=h,this.rgba=E.toRGBA(h);else if(h instanceof R)this.j=h,this.rgba=R.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&C.equals(this.rgba,h.rgba)&&E.equals(this.hsla,h.hsla)&&R.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=j.k(this.rgba.r),l=j.k(this.rgba.g),d=j.k(this.rgba.b),b=.2126*h+.7152*l+.0722*d;return n(b,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d?(l+.05)/(d+.05):(d+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l>d}isDarkerThan(h){const l=this.getRelativeLuminance(),d=h.getRelativeLuminance();return l<d}lighten(h){return new j(new E(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new j(new E(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:d,b,a:v}=this.rgba;return new j(new C(l,d,b,v*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new j(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,d=this.rgba.a,b=l.a,v=d+b*(1-d);if(v<1e-6)return j.transparent;const m=this.rgba.r*d/v+l.r*b*(1-d)/v,f=this.rgba.g*d/v+l.g*b*(1-d)/v,y=this.rgba.b*d/v+l.b*b*(1-d)/v;return new j(new C(m,f,y,v))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:d,b,a:v}=this.rgba;return new j(new C(h.rgba.r-v*(h.rgba.r-l),h.rgba.g-v*(h.rgba.g-d),h.rgba.b-v*(h.rgba.b-b),1))}flatten(...h){const l=h.reduceRight((d,b)=>j.o(b,d));return j.o(this,l)}static o(h,l){const d=1-h.rgba.a;return new j(new C(d*l.rgba.r+h.rgba.a*h.rgba.r,d*l.rgba.g+h.rgba.a*h.rgba.g,d*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=j.Format.CSS.format(this)),this.u}static getLighterColor(h,l,d){if(h.isLighterThan(l))return h;d=d||.5;const b=h.getRelativeLuminance(),v=l.getRelativeLuminance();return d=d*(v-b)/v,h.lighten(d)}static getDarkerColor(h,l,d){if(h.isDarkerThan(l))return h;d=d||.5;const b=h.getRelativeLuminance(),v=l.getRelativeLuminance();return d=d*(b-v)/b,h.darken(d)}static{this.white=new j(new C(255,255,255,1))}static{this.black=new j(new C(0,0,0,1))}static{this.red=new j(new C(255,0,0,1))}static{this.blue=new j(new C(0,0,255,1))}static{this.green=new j(new C(0,255,0,1))}static{this.cyan=new j(new C(0,255,255,1))}static{this.lightgrey=new j(new C(211,211,211,1))}static{this.transparent=new j(new C(0,0,0,0))}}e.$Ot=j,function(k){let h;(function(l){let d;(function(b){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}b.formatRGB=v;function m(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}b.formatRGBA=m;function f(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}b.formatHSL=f;function y(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}b.formatHSLA=y;function p(t){const r=t.toString(16);return r.length!==2?"0"+r:r}function $(t){return`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}`}b.formatHex=$;function c(t,r=!1){return r&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${p(t.rgba.r)}${p(t.rgba.g)}${p(t.rgba.b)}${p(Math.round(t.rgba.a*255))}`}b.formatHexA=c;function w(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}b.format=w;function P(t){const r=t.length;if(r===0||t.charCodeAt(0)!==35)return null;if(r===7){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6));return new k(new C(s,i,o,1))}if(r===9){const s=16*a(t.charCodeAt(1))+a(t.charCodeAt(2)),i=16*a(t.charCodeAt(3))+a(t.charCodeAt(4)),o=16*a(t.charCodeAt(5))+a(t.charCodeAt(6)),u=16*a(t.charCodeAt(7))+a(t.charCodeAt(8));return new k(new C(s,i,o,u/255))}if(r===4){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3));return new k(new C(16*s+s,16*i+i,16*o+o))}if(r===5){const s=a(t.charCodeAt(1)),i=a(t.charCodeAt(2)),o=a(t.charCodeAt(3)),u=a(t.charCodeAt(4));return new k(new C(16*s+s,16*i+i,16*o+o,(16*u+u)/255))}return null}b.parseHex=P;function a(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(d=l.CSS||(l.CSS={}))})(h=k.Format||(k.Format={}))}(j||(e.$Ot=j={}))}),define(re[51],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=C,e.$1h=E,e.$2h=R;function n(j){return(k,h,l)=>{let d=null,b=null;if(typeof l.value=="function"?(d="value",b=l.value):typeof l.get=="function"&&(d="get",b=l.get),!b)throw new Error("not supported");l[d]=j(b,h)}}function C(j,k,h){let l=null,d=null;if(typeof h.value=="function"?(l="value",d=h.value,d.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",d=h.get),!d)throw new Error("not supported");const b=`$memoize$${k}`;h[l]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:d.apply(this,v)}),this[b]}}function E(j,k,h){return n((l,d)=>{const b=`$debounce$${d}`,v=`$debounce$result$${d}`;return function(...m){this[v]||(this[v]=h?h():void 0),clearTimeout(this[b]),k&&(this[v]=k(this[v],...m),m=[this[v]]),this[b]=setTimeout(()=>{l.apply(this,m),this[v]=h?h():void 0},j)}})}function R(j,k,h){return n((l,d)=>{const b=`$throttle$timer$${d}`,v=`$throttle$result$${d}`,m=`$throttle$lastRun$${d}`,f=`$throttle$pending$${d}`;return function(...y){if(this[v]||(this[v]=h?h():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...y)),this[f])return;const p=this[m]+j;p<=Date.now()?(this[m]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0):(this[f]=!0,this[b]=setTimeout(()=>{this[f]=!1,this[m]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0},p-Date.now()))}})}}),define(re[15],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$9=e.$5=e.$X=e.$W=void 0,e.setUnexpectedErrorHandler=C,e.$Z=E,e.$1=R,e.$2=j,e.$3=k,e.$4=l,e.$6=b,e.$7=v,e.$8=m,e.$0=y;class n{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?w.isErrorNoTelemetry(t)?new w(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(r=>{r(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=n,e.$X=new n;function C(a){e.$X.setUnexpectedErrorHandler(a)}function E(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}function R(a){l(a)||e.$X.onUnexpectedError(a)}function j(a){l(a)||e.$X.onUnexpectedExternalError(a)}function k(a){if(a instanceof Error){const{name:t,message:r}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:r,stack:s,noTelemetry:w.isErrorNoTelemetry(a)}}return a}const h="Canceled";function l(a){return a instanceof d?!0:a instanceof Error&&a.name===h&&a.message===h}class d extends Error{constructor(){super(h),this.name=this.message}}e.$5=d;function b(){const a=new Error(h);return a.name=a.message,a}function v(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}function m(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}class f extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=f;function y(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}class p extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=p;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class c extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=c;class w extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof w)return t;const r=new w;return r.message=t.message,r.stack=t.stack,r}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=w;class P extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,P.prototype)}}e.$cb=P}),define(re[22],oe([0,1,15,136]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bc=e.$ac=e.$_b=e.$0b=e.$9b=e.CompareResult=void 0,e.$sb=E,e.$tb=R,e.$ub=j,e.$vb=k,e.$wb=h,e.$xb=l,e.$yb=d,e.$zb=b,e.$Ab=v,e.$Bb=m,e.$Cb=f,e.$Db=y,e.$Eb=p,e.top=$,e.$Gb=c,e.$Hb=P,e.$Ib=a,e.$Jb=t,e.$Kb=r,e.$Lb=s,e.$Mb=i,e.$Nb=o,e.$Ob=u,e.$Pb=g,e.$Qb=S,e.$Rb=D,e.$Sb=I,e.$Tb=O,e.$Ub=M,e.$Vb=W,e.$Wb=F,e.$Xb=T,e.$Yb=q,e.$Zb=ue,e.$1b=ee,e.$2b=ce,e.$3b=K,e.$4b=Q,e.$5b=B,e.$6b=L,e.$7b=ae,e.$8b=G,e.$$b=A;function E(J,V=0){return J[J.length-(1+V)]}function R(J){if(J.length===0)throw new Error("Invalid tail call");return[J.slice(0,J.length-1),J[J.length-1]]}function j(J,V,x=(H,se)=>H===se){if(J===V)return!0;if(!J||!V||J.length!==V.length)return!1;for(let H=0,se=J.length;H<se;H++)if(!x(J[H],V[H]))return!1;return!0}function k(J,V){const x=J.length-1;V<x&&(J[V]=J[x]),J.pop()}function h(J,V,x){return l(J.length,H=>x(J[H],V))}function l(J,V){let x=0,H=J-1;for(;x<=H;){const se=(x+H)/2|0,he=V(se);if(he<0)x=se+1;else if(he>0)H=se-1;else return se}return-(x+1)}function d(J,V,x){if(J=J|0,J>=V.length)throw new TypeError("invalid index");const H=V[Math.floor(V.length*Math.random())],se=[],he=[],me=[];for(const $e of V){const ye=x($e,H);ye<0?se.push($e):ye>0?he.push($e):me.push($e)}return J<se.length?d(J,se,x):J<se.length+me.length?me[0]:d(J-(se.length+me.length),he,x)}function b(J,V){const x=[];let H;for(const se of J.slice(0).sort(V))!H||V(H[0],se)!==0?(H=[se],x.push(H)):H.push(se);return x}function*v(J,V){let x,H;for(const se of J)H!==void 0&&V(H,se)?x.push(se):(x&&(yield x),x=[se]),H=se;x&&(yield x)}function m(J,V){for(let x=0;x<=J.length;x++)V(x===0?void 0:J[x-1],x===J.length?void 0:J[x])}function f(J,V){for(let x=0;x<J.length;x++)V(x===0?void 0:J[x-1],J[x],x+1===J.length?void 0:J[x+1])}function y(J,V,x){const H=[];function se($e,ye,Pe){if(ye===0&&Pe.length===0)return;const ke=H[H.length-1];ke&&ke.start+ke.deleteCount===$e?(ke.deleteCount+=ye,ke.toInsert.push(...Pe)):H.push({start:$e,deleteCount:ye,toInsert:Pe})}let he=0,me=0;for(;;){if(he===J.length){se(he,0,V.slice(me));break}if(me===V.length){se(he,J.length-he,[]);break}const $e=J[he],ye=V[me],Pe=x($e,ye);Pe===0?(he+=1,me+=1):Pe<0?(se(he,1,[]),he+=1):Pe>0&&(se(he,0,[ye]),me+=1)}return H}function p(J,V,x){const H=y(J,V,x),se=[],he=[];for(const me of H)se.push(...J.slice(me.start,me.start+me.deleteCount)),he.push(...me.toInsert);return{removed:se,added:he}}function $(J,V,x){if(x===0)return[];const H=J.slice(0,x).sort(V);return w(J,V,H,x,J.length),H}function c(J,V,x,H,se){return x===0?Promise.resolve([]):new Promise((he,me)=>{(async()=>{const $e=J.length,ye=J.slice(0,x).sort(V);for(let Pe=x,ke=Math.min(x+H,$e);Pe<$e;Pe=ke,ke=Math.min(ke+H,$e)){if(Pe>x&&await new Promise(Oe=>setTimeout(Oe)),se&&se.isCancellationRequested)throw new n.$5;w(J,V,ye,Pe,ke)}return ye})().then(he,me)})}function w(J,V,x,H,se){for(const he=x.length;H<se;H++){const me=J[H];if(V(me,x[he-1])<0){x.pop();const $e=(0,C.$kb)(x,ye=>V(me,ye)<0);x.splice($e,0,me)}}}function P(J){return J.filter(V=>!!V)}function a(J){let V=0;for(let x=0;x<J.length;x++)J[x]&&(J[V]=J[x],V+=1);J.length=V}function t(J,V,x){J.splice(x,0,J.splice(V,1)[0])}function r(J){return!Array.isArray(J)||J.length===0}function s(J){return Array.isArray(J)&&J.length>0}function i(J,V=x=>x){const x=new Set;return J.filter(H=>{const se=V(H);return x.has(se)?!1:(x.add(se),!0)})}function o(J){const V=new Set;return x=>{const H=J(x);return V.has(H)?!1:(V.add(H),!0)}}function u(J,V){return J.length>0?J[0]:V}function g(J,V){return J.length>0?J[J.length-1]:V}function S(J,V,x=(H,se)=>H===se){let H=0;for(let se=0,he=Math.min(J.length,V.length);se<he&&x(J[se],V[se]);se++)H++;return H}function D(J){return[].concat(...J)}function I(J,V){let x=typeof V=="number"?J:0;typeof V=="number"?x=J:(x=0,V=J);const H=[];if(x<=V)for(let se=x;se<V;se++)H.push(se);else for(let se=x;se>V;se--)H.push(se);return H}function O(J,V,x){return J.reduce((H,se)=>(H[V(se)]=x?x(se):se,H),Object.create(null))}function M(J,V){return J.push(V),()=>W(J,V)}function W(J,V){const x=J.indexOf(V);if(x>-1)return J.splice(x,1),V}function F(J,V,x){const H=J.slice(0,V),se=J.slice(V);return H.concat(x,se)}function T(J,V){let x;if(typeof V=="number"){let H=V;x=()=>{const se=Math.sin(H++)*179426549;return se-Math.floor(se)}}else x=Math.random;for(let H=J.length-1;H>0;H-=1){const se=Math.floor(x()*(H+1)),he=J[H];J[H]=J[se],J[se]=he}}function q(J,V){const x=J.indexOf(V);x>-1&&(J.splice(x,1),J.unshift(V))}function ue(J,V){const x=J.indexOf(V);x>-1&&(J.splice(x,1),J.push(V))}function ee(J,V){for(const x of V)J.push(x)}function ce(J,V){return Array.isArray(J)?J.map(V):V(J)}function K(J){return Array.isArray(J)?J:[J]}function Q(J){return J[Math.floor(Math.random()*J.length)]}function B(J,V,x){const H=z(J,V),se=J.length,he=x.length;J.length=se+he;for(let me=se-1;me>=H;me--)J[me+he]=J[me];for(let me=0;me<he;me++)J[me+H]=x[me]}function L(J,V,x,H){const se=z(J,V);let he=J.splice(se,x);return he===void 0&&(he=[]),B(J,se,H),he}function z(J,V){return V<0?Math.max(V+J.length,0):Math.min(V,J.length)}var U;(function(J){function V(he){return he<0}J.isLessThan=V;function x(he){return he<=0}J.isLessThanOrEqual=x;function H(he){return he>0}J.isGreaterThan=H;function se(he){return he===0}J.isNeitherLessOrGreaterThan=se,J.greaterThan=1,J.lessThan=-1,J.neitherLessOrGreaterThan=0})(U||(e.CompareResult=U={}));function ae(J,V){return(x,H)=>V(J(x),J(H))}function G(...J){return(V,x)=>{for(const H of J){const se=H(V,x);if(!U.isNeitherLessOrGreaterThan(se))return se}return U.neitherLessOrGreaterThan}}const le=(J,V)=>J-V;e.$9b=le;const Y=(J,V)=>(0,e.$9b)(J?1:0,V?1:0);e.$0b=Y;function A(J){return(V,x)=>-J(V,x)}class N{constructor(V){this.g=V,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(V){let x=this.c;for(;x<this.g.length&&V(this.g[x]);)x++;const H=x===this.c?null:this.g.slice(this.c,x);return this.c=x,H}takeFromEndWhile(V){let x=this.d;for(;x>=0&&V(this.g[x]);)x--;const H=x===this.d?null:this.g.slice(x+1,this.d+1);return this.d=x,H}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const V=this.g[this.c];return this.c++,V}removeLast(){const V=this.g[this.d];return this.d--,V}takeCount(V){const x=this.g.slice(this.c,this.c+V);return this.c+=V,x}}e.$_b=N;class _{static{this.empty=new _(V=>{})}constructor(V){this.iterate=V}forEach(V){this.iterate(x=>(V(x),!0))}toArray(){const V=[];return this.iterate(x=>(V.push(x),!0)),V}filter(V){return new _(x=>this.iterate(H=>V(H)?x(H):!0))}map(V){return new _(x=>this.iterate(H=>x(V(H))))}some(V){let x=!1;return this.iterate(H=>(x=V(H),!x)),x}findFirst(V){let x;return this.iterate(H=>V(H)?(x=H,!1):!0),x}findLast(V){let x;return this.iterate(H=>(V(H)&&(x=H),!0)),x}findLastMaxBy(V){let x,H=!0;return this.iterate(se=>((H||U.isGreaterThan(V(se,x)))&&(H=!1,x=se),!0)),x}}e.$ac=_;class ne{constructor(V){this.c=V}static createSortPermutation(V,x){const H=Array.from(V.keys()).sort((se,he)=>x(V[se],V[he]));return new ne(H)}apply(V){return V.map((x,H)=>V[this.c[H]])}inverse(){const V=this.c.slice();for(let x=0;x<this.c.length;x++)V[this.c[x]]=x;return new ne(V)}}e.$bc=ne}),define(re[139],oe([0,1,15]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=C,e.$fd=E,e.$gd=R,e.$hd=j,e.$id=k,e.$jd=h;function C(l,d){if(!l)throw new Error(d?`Assertion failed (${d})`:"Assertion Failed")}function E(l,d="Unreachable"){throw new Error(d)}function R(l){if(!l)throw new n.$cb("Assertion Failed")}function j(l){l||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function k(l){if(!l()){debugger;l(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function h(l,d){let b=0;for(;b<l.length-1;){const v=l[b],m=l[b+1];if(!d(v,m))return!1;b++}return!0}}),define(re[86],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=n;function n(C,E){const R=this;let j=!1,k;return function(){if(j)return k;if(j=!0,E)try{k=C.apply(R,arguments)}finally{E()}else k=C.apply(R,arguments);return k}}}),define(re[71],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var n;(function(C){function E(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}C.is=E;const R=Object.freeze([]);function j(){return R}C.empty=j;function*k(t){yield t}C.single=k;function h(t){return E(t)?t:k(t)}C.wrap=h;function l(t){return t||R}C.from=l;function*d(t){for(let r=t.length-1;r>=0;r--)yield t[r]}C.reverse=d;function b(t){return!t||t[Symbol.iterator]().next().done===!0}C.isEmpty=b;function v(t){return t[Symbol.iterator]().next().value}C.first=v;function m(t,r){for(const s of t)if(r(s))return!0;return!1}C.some=m;function f(t,r){for(const s of t)if(r(s))return s}C.find=f;function*y(t,r){for(const s of t)r(s)&&(yield s)}C.filter=y;function*p(t,r){let s=0;for(const i of t)yield r(i,s++)}C.map=p;function*$(...t){for(const r of t)yield*r}C.concat=$;function c(t,r,s){let i=s;for(const o of t)i=r(i,o);return i}C.reduce=c;function*w(t,r,s=t.length){for(r<0&&(r+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);r<s;r++)yield t[r]}C.slice=w;function P(t,r=Number.POSITIVE_INFINITY){const s=[];if(r===0)return[s,t];const i=t[Symbol.iterator]();for(let o=0;o<r;o++){const u=i.next();if(u.done)return[s,C.empty()];s.push(u.value)}return[s,{[Symbol.iterator](){return i}}]}C.consume=P;async function a(t){const r=[];for await(const s of t)r.push(s);return Promise.resolve(r)}C.asyncToArray=a})(n||(e.Iterable=n={}))}),define(re[42],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Gn=j,e.$Hn=b,e.$In=v,e.$Jn=m,e.$Kn=f,e.$Ln=y,e.$Mn=p,e.$Nn=$,e.$On=c,e.$Pn=w,e.$Qn=P,e.$Rn=a;var n;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var C;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(C||(e.SyntaxKind=C={}));var E;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(E||(e.ParseErrorCode=E={}));var R;(function(t){t.DEFAULT={allowTrailingComma:!0}})(R||(e.ParseOptions=R={}));function j(t,r=!1){let s=0;const i=t.length;let o="",u=0,g=16,S=0;function D(q){let ue=0,ee=0;for(;ue<q;){const ce=t.charCodeAt(s);if(ce>=48&&ce<=57)ee=ee*16+ce-48;else if(ce>=65&&ce<=70)ee=ee*16+ce-65+10;else if(ce>=97&&ce<=102)ee=ee*16+ce-97+10;else break;s++,ue++}return ue<q&&(ee=-1),ee}function I(q){s=q,o="",u=0,g=16,S=0}function O(){const q=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&l(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&l(t.charCodeAt(s)))for(s++;s<t.length&&l(t.charCodeAt(s));)s++;else return S=3,t.substring(q,s);let ue=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&l(t.charCodeAt(s))){for(s++;s<t.length&&l(t.charCodeAt(s));)s++;ue=s}else S=3;return t.substring(q,ue)}function M(){let q="",ue=s;for(;;){if(s>=i){q+=t.substring(ue,s),S=2;break}const ee=t.charCodeAt(s);if(ee===34){q+=t.substring(ue,s),s++;break}if(ee===92){if(q+=t.substring(ue,s),s++,s>=i){S=2;break}switch(t.charCodeAt(s++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const K=D(4);K>=0?q+=String.fromCharCode(K):S=4;break}default:S=5}ue=s;continue}if(ee>=0&&ee<=31)if(h(ee)){q+=t.substring(ue,s),S=2;break}else S=6;s++}return q}function W(){if(o="",S=0,u=s,s>=i)return u=i,g=17;let q=t.charCodeAt(s);if(k(q)){do s++,o+=String.fromCharCode(q),q=t.charCodeAt(s);while(k(q));return g=15}if(h(q))return s++,o+=String.fromCharCode(q),q===13&&t.charCodeAt(s)===10&&(s++,o+=`
`),g=14;switch(q){case 123:return s++,g=1;case 125:return s++,g=2;case 91:return s++,g=3;case 93:return s++,g=4;case 58:return s++,g=6;case 44:return s++,g=5;case 34:return s++,o=M(),g=10;case 47:{const ue=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<i&&!h(t.charCodeAt(s));)s++;return o=t.substring(ue,s),g=12}if(t.charCodeAt(s+1)===42){s+=2;const ee=i-1;let ce=!1;for(;s<ee;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,ce=!0;break}s++}return ce||(s++,S=1),o=t.substring(ue,s),g=13}return o+=String.fromCharCode(q),s++,g=16}case 45:if(o+=String.fromCharCode(q),s++,s===i||!l(t.charCodeAt(s)))return g=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),g=11;default:for(;s<i&&F(q);)s++,q=t.charCodeAt(s);if(u!==s){switch(o=t.substring(u,s),o){case"true":return g=8;case"false":return g=9;case"null":return g=7}return g=16}return o+=String.fromCharCode(q),s++,g=16}}function F(q){if(k(q)||h(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let q;do q=W();while(q>=12&&q<=15);return q}return{setPosition:I,getPosition:()=>s,scan:r?T:W,getToken:()=>g,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>s-u,getTokenError:()=>S}}function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var d;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(d||(d={}));function b(t,r){const s=[],i=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let g=!1;function S(D,I,O,M){u.value=D,u.offset=I,u.length=O,u.type=M,u.colonOffset=void 0,o=u}try{w(t,{onObjectBegin:(D,I)=>{if(r<=D)throw i;o=void 0,g=r>D,s.push("")},onObjectProperty:(D,I,O)=>{if(r<I||(S(D,I,O,"property"),s[s.length-1]=D,r<=I+O))throw i},onObjectEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onArrayBegin:(D,I)=>{if(r<=D)throw i;o=void 0,s.push(0)},onArrayEnd:(D,I)=>{if(r<=D)throw i;o=void 0,s.pop()},onLiteralValue:(D,I,O)=>{if(r<I||(S(D,I,O,a(D)),r<=I+O))throw i},onSeparator:(D,I,O)=>{if(r<=I)throw i;if(D===":"&&o&&o.type==="property")o.colonOffset=I,g=!1,o=void 0;else if(D===","){const M=s[s.length-1];typeof M=="number"?s[s.length-1]=M+1:(g=!0,s[s.length-1]=""),o=void 0}}})}catch(D){if(D!==i)throw D}return{path:s,previousNode:o,isAtPropertyKey:g,matches:D=>{let I=0;for(let O=0;I<D.length&&O<s.length;O++)if(D[I]===s[O]||D[I]==="*")I++;else if(D[I]!=="**")return!1;return I===D.length}}}function v(t,r=[],s=R.DEFAULT){let i=null,o=[];const u=[];function g(D){Array.isArray(o)?o.push(D):i!==null&&(o[i]=D)}return w(t,{onObjectBegin:()=>{const D={};g(D),u.push(o),o=D,i=null},onObjectProperty:D=>{i=D},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const D=[];g(D),u.push(o),o=D,i=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:g,onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s),o[0]}function m(t,r=[],s=R.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(D){i.type==="property"&&(i.length=D-i.offset,i=i.parent)}function u(D){return i.children.push(D),D}w(t,{onObjectBegin:D=>{i=u({type:"object",offset:D,length:-1,parent:i,children:[]})},onObjectProperty:(D,I,O)=>{i=u({type:"property",offset:I,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:D,offset:I,length:O,parent:i})},onObjectEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onArrayBegin:(D,I)=>{i=u({type:"array",offset:D,length:-1,parent:i,children:[]})},onArrayEnd:(D,I)=>{i.length=D+I-i.offset,i=i.parent,o(D+I)},onLiteralValue:(D,I,O)=>{u({type:a(D),offset:I,length:O,parent:i,value:D}),o(I+O)},onSeparator:(D,I,O)=>{i.type==="property"&&(D===":"?i.colonOffset=I:D===","&&o(I))},onError:(D,I,O)=>{r.push({error:D,offset:I,length:O})}},s);const S=i.children[0];return S&&delete S.parent,S}function f(t,r){if(!t)return;let s=t;for(const i of r)if(typeof i=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let o=!1;for(const u of s.children)if(Array.isArray(u.children)&&u.children[0].value===i){s=u.children[1],o=!0;break}if(!o)return}else{const o=i;if(s.type!=="array"||o<0||!Array.isArray(s.children)||o>=s.children.length)return;s=s.children[o]}return s}function y(t){if(!t.parent||!t.parent.children)return[];const r=y(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;r.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&r.push(s)}return r}function p(t){switch(t.type){case"array":return t.children.map(p);case"object":{const r=Object.create(null);for(const s of t.children){const i=s.children[1];i&&(r[s.children[0].value]=p(i))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}function $(t,r,s=!1){return r>=t.offset&&r<t.offset+t.length||s&&r===t.offset+t.length}function c(t,r,s=!1){if($(t,r,s)){const i=t.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const u=c(i[o],r,s);if(u)return u}return t}}function w(t,r,s=R.DEFAULT){const i=j(t,!1);function o(ae){return ae?()=>ae(i.getTokenOffset(),i.getTokenLength()):()=>!0}function u(ae){return ae?G=>ae(G,i.getTokenOffset(),i.getTokenLength()):()=>!0}const g=o(r.onObjectBegin),S=u(r.onObjectProperty),D=o(r.onObjectEnd),I=o(r.onArrayBegin),O=o(r.onArrayEnd),M=u(r.onLiteralValue),W=u(r.onSeparator),F=o(r.onComment),T=u(r.onError),q=s&&s.disallowComments,ue=s&&s.allowTrailingComma;function ee(){for(;;){const ae=i.scan();switch(i.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:q||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(ae){case 12:case 13:q?ce(10):F();break;case 16:ce(1);break;case 15:case 14:break;default:return ae}}}function ce(ae,G=[],le=[]){if(T(ae),G.length+le.length>0){let Y=i.getToken();for(;Y!==17;){if(G.indexOf(Y)!==-1){ee();break}else if(le.indexOf(Y)!==-1)break;Y=ee()}}}function K(ae){const G=i.getTokenValue();return ae?M(G):S(G),ee(),!0}function Q(){switch(i.getToken()){case 11:{let ae=0;try{ae=JSON.parse(i.getTokenValue()),typeof ae!="number"&&(ce(2),ae=0)}catch{ce(2)}M(ae);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return ee(),!0}function B(){return i.getToken()!==10?(ce(3,[],[2,5]),!1):(K(!1),i.getToken()===6?(W(":"),ee(),U()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function L(){g(),ee();let ae=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),i.getToken()===2&&ue)break}else ae&&ce(6,[],[]);B()||ce(4,[],[2,5]),ae=!0}return D(),i.getToken()!==2?ce(7,[2],[]):ee(),!0}function z(){I(),ee();let ae=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(ae||ce(4,[],[]),W(","),ee(),i.getToken()===4&&ue)break}else ae&&ce(6,[],[]);U()||ce(4,[],[4,5]),ae=!0}return O(),i.getToken()!==4?ce(8,[4],[]):ee(),!0}function U(){switch(i.getToken()){case 3:return z();case 1:return L();case 10:return K(!0);default:return Q()}}return ee(),i.getToken()===17?s.allowEmptyContent?!0:(ce(4,[],[]),!1):U()?(i.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function P(t,r){const s=j(t),i=[];let o,u=0,g;do switch(g=s.getPosition(),o=s.scan(),o){case 12:case 13:case 17:u!==g&&i.push(t.substring(u,g)),r!==void 0&&i.push(s.getTokenValue().replace(/[^\r\n]/g,r)),u=s.getPosition();break}while(o!==17);return i.join("")}function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}}),define(re[140],oe([0,1,42]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sn=C,e.$Tn=E,e.$Un=k,e.$Vn=h;function C(l,d,b){let v,m,f,y,p;if(d){for(y=d.offset,p=y+d.length,f=y;f>0&&!h(l,f-1);)f--;let g=p;for(;g<l.length&&!h(l,g);)g++;m=l.substring(f,g),v=j(m,b)}else m=l,v=0,f=0,y=0,p=l.length;const $=k(b,l);let c=!1,w=0,P;b.insertSpaces?P=R(" ",b.tabSize||4):P="	";const a=(0,n.$Gn)(m,!1);let t=!1;function r(){return $+R(P,v+w)}function s(){let g=a.scan();for(c=!1;g===15||g===14;)c=c||g===14,g=a.scan();return t=g===16||a.getTokenError()!==0,g}const i=[];function o(g,S,D){!t&&S<p&&D>y&&l.substring(S,D)!==g&&i.push({offset:S,length:D-S,content:g})}let u=s();if(u!==17){const g=a.getTokenOffset()+f,S=R(P,v);o(S,f,g)}for(;u!==17;){let g=a.getTokenOffset()+a.getTokenLength()+f,S=s(),D="";for(;!c&&(S===12||S===13);){const O=a.getTokenOffset()+f;o(" ",g,O),g=a.getTokenOffset()+a.getTokenLength()+f,D=S===12?r():"",S=s()}if(S===2)u!==1&&(w--,D=r());else if(S===4)u!==3&&(w--,D=r());else{switch(u){case 3:case 1:w++,D=r();break;case 5:case 12:D=r();break;case 13:c?D=r():D=" ";break;case 6:D=" ";break;case 10:if(S===6){D="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?D=" ":S!==5&&S!==17&&(t=!0);break;case 16:t=!0;break}c&&(S===12||S===13)&&(D=r())}const I=a.getTokenOffset()+f;o(D,g,I),u=S}return i}function E(l,d){const b=JSON.stringify(l,void 0,d.insertSpaces?d.tabSize||4:"	");return d.eol!==void 0?b.replace(/\r\n|\r|\n/g,d.eol):b}function R(l,d){let b="";for(let v=0;v<d;v++)b+=l;return b}function j(l,d){let b=0,v=0;const m=d.tabSize||4;for(;b<l.length;){const f=l.charAt(b);if(f===" ")v++;else if(f==="	")v+=m;else break;b++}return Math.floor(v/m)}function k(l,d){for(let b=0;b<d.length;b++){const v=d.charAt(b);if(v==="\r")return b+1<d.length&&d.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}function h(l,d){return`\r
`.indexOf(l.charAt(d))!==-1}}),define(re[103],oe([0,1,42,140]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wn=E,e.$Xn=R,e.$Yn=j,e.$Zn=k,e.$1n=h;function E(l,d,b){return R(l,d,void 0,b)}function R(l,d,b,v,m){const f=d.slice(),y=[],p=(0,n.$Jn)(l,y);let $,c;for(;f.length>0&&(c=f.pop(),$=(0,n.$Kn)(p,f),$===void 0&&b!==void 0);)typeof c=="string"?b={[c]:b}:b=[b];if($)if($.type==="object"&&typeof c=="string"&&Array.isArray($.children)){const w=(0,n.$Kn)($,[c]);if(w!==void 0)if(b===void 0){if(!w.parent)throw new Error("Malformed AST");const P=$.children.indexOf(w.parent);let a,t=w.parent.offset+w.parent.length;if(P>0){const r=$.children[P-1];a=r.offset+r.length}else a=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return j(l,{offset:a,length:t-a,content:""},v)}else return j(l,{offset:w.offset,length:w.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const P=`${JSON.stringify(c)}: ${JSON.stringify(b)}`,a=m?m($.children.map(r=>r.children[0].value)):$.children.length;let t;if(a>0){const r=$.children[a-1];t={offset:r.offset+r.length,length:0,content:","+P}}else $.children.length===0?t={offset:$.offset+1,length:0,content:P}:t={offset:$.offset+1,length:0,content:P+","};return j(l,t,v)}}else if($.type==="array"&&typeof c=="number"&&Array.isArray($.children))if(b!==void 0){const w=`${JSON.stringify(b)}`;let P;if($.children.length===0||c===0)P={offset:$.offset+1,length:0,content:$.children.length===0?w:w+","};else{const a=c===-1||c>$.children.length?$.children.length:c,t=$.children[a-1];P={offset:t.offset+t.length,length:0,content:","+w}}return j(l,P,v)}else{const w=c,P=$.children[w];let a;if($.children.length===1)a={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===w){const t=$.children[w-1],r=t.offset+t.length,s=$.offset+$.length;a={offset:r,length:s-2-r,content:""}}else a={offset:P.offset,length:$.children[w+1].offset-P.offset,content:""};return j(l,a,v)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${$.type}`);else return b===void 0?[]:j(l,{offset:p?p.offset:0,length:p?p.length:0,content:JSON.stringify(b)},v)}function j(l,d,b){let v=k(l,d),m=d.offset,f=d.offset+d.content.length;if(d.length===0||d.content.length===0){for(;m>0&&!(0,C.$Vn)(v,m-1);)m--;for(;f<v.length&&!(0,C.$Vn)(v,f);)f++}const y=(0,C.$Sn)(v,{offset:m,length:f-m},b);for(let $=y.length-1;$>=0;$--){const c=y[$];v=k(v,c),m=Math.min(m,c.offset),f=Math.max(f,c.offset+c.length),f+=c.content.length-c.length}const p=l.length-(v.length-f)-m;return[{offset:m,length:p,content:v.substring(m,f)}]}function k(l,d){return l.substring(0,d.offset)+d.content+l.substring(d.offset+d.length)}function h(l,d){const b=d.slice(0).sort((m,f)=>{const y=m.offset-f.offset;return y===0?m.length-f.length:y});let v=l.length;for(let m=b.length-1;m>=0;m--){const f=b[m];if(f.offset+f.length<=v)l=k(l,f);else throw new Error("Overlapping edit");v=f.offset}return l}}),define(re[62],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class n{constructor(E){this.d=E,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(E){this.c=E}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=n}),define(re[104],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(R){this.element=R,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let R=this.a;for(;R!==n.Undefined;){const j=R.next;R.prev=n.Undefined,R.next=n.Undefined,R=j}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,j){const k=new n(R);if(this.a===n.Undefined)this.a=k,this.b=k;else if(j){const l=this.b;this.b=k,k.prev=l,l.next=k}else{const l=this.a;this.a=k,k.next=l,l.prev=k}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(k))}}shift(){if(this.a!==n.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==n.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==n.Undefined&&R.next!==n.Undefined){const j=R.prev;j.next=R.next,R.next.prev=j}else R.prev===n.Undefined&&R.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):R.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):R.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==n.Undefined;)yield R.element,R=R.next}}e.$6c=C}),define(re[32],oe([0,1]),function(X,e){"use strict";var n,C,E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Ic=e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.Touch=e.$Cc=e.$Bc=void 0,e.$yc=R,e.$zc=j,e.$Ac=k,e.$Jc=P;function R(a,t,r){let s=a.get(t);return s===void 0&&(s=r,a.set(t,s)),s}function j(a){const t=[];return a.forEach((r,s)=>{t.push(`${s} => ${r}`)}),`Map(${a.size}) {${t.join(", ")}}`}function k(a){const t=[];return a.forEach(r=>{t.push(r)}),`Set(${a.size}) {${t.join(", ")}}`}class h{constructor(t,r){this.uri=t,this.value=r}}function l(a){return Array.isArray(a)}class d{static{this.c=t=>t.toString()}constructor(t,r){if(this[n]="ResourceMap",t instanceof d)this.d=new Map(t.d),this.e=r??d.c;else if(l(t)){this.d=new Map,this.e=r??d.c;for(const[s,i]of t)this.set(s,i)}else this.d=new Map,this.e=t??d.c}set(t,r){return this.d.set(this.e(t),new h(t,r)),this}get(t){return this.d.get(this.e(t))?.value}has(t){return this.d.has(this.e(t))}get size(){return this.d.size}clear(){this.d.clear()}delete(t){return this.d.delete(this.e(t))}forEach(t,r){typeof r<"u"&&(t=t.bind(r));for(const[s,i]of this.d)t(i.value,i.uri,this)}*values(){for(const t of this.d.values())yield t.value}*keys(){for(const t of this.d.values())yield t.uri}*entries(){for(const t of this.d.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.d)yield[t.uri,t.value]}}e.$Bc=d;class b{constructor(t,r){this[C]="ResourceSet",!t||typeof t=="function"?this.c=new d(t):(this.c=new d(r),t.forEach(this.add,this))}get size(){return this.c.size}add(t){return this.c.set(t,t),this}clear(){this.c.clear()}delete(t){return this.c.delete(t)}forEach(t,r){this.c.forEach((s,i)=>t.call(r,i,i,this))}has(t){return this.c.has(t)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Cc=b;var v;(function(a){a[a.None=0]="None",a[a.AsOld=1]="AsOld",a[a.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class m{constructor(){this[E]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(t){return this.c.has(t)}get(t,r=0){const s=this.c.get(t);if(s)return r!==0&&this.m(s,r),s.value}set(t,r,s=0){let i=this.c.get(t);if(i)i.value=r,s!==0&&this.m(i,s);else{switch(i={key:t,value:r,next:void 0,previous:void 0},s){case 0:this.k(i);break;case 1:this.j(i);break;case 2:this.k(i);break;default:this.k(i);break}this.c.set(t,i),this.f++}return this}delete(t){return!!this.remove(t)}remove(t){const r=this.c.get(t);if(r)return this.c.delete(t),this.l(r),this.f--,r.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const t=this.d;return this.c.delete(t.key),this.l(t),this.f--,t.value}forEach(t,r){const s=this.g;let i=this.d;for(;i;){if(r?t.bind(r)(i.value,i.key,this):t(i.value,i.key,this),this.g!==s)throw new Error("LinkedMap got modified during iteration.");i=i.next}}keys(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.key,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}values(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:s.value,done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}entries(){const t=this,r=this.g;let s=this.d;const i={[Symbol.iterator](){return i},next(){if(t.g!==r)throw new Error("LinkedMap got modified during iteration.");if(s){const o={value:[s.key,s.value],done:!1};return s=s.next,o}else return{value:void 0,done:!0}}};return i}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.d,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.next,s--;this.d=r,this.f=s,r&&(r.previous=void 0),this.g++}i(t){if(t>=this.size)return;if(t===0){this.clear();return}let r=this.e,s=this.size;for(;r&&s>t;)this.c.delete(r.key),r=r.previous,s--;this.e=r,this.f=s,r&&(r.next=void 0),this.g++}j(t){if(!this.d&&!this.e)this.e=t;else if(this.d)t.next=this.d,this.d.previous=t;else throw new Error("Invalid list");this.d=t,this.g++}k(t){if(!this.d&&!this.e)this.d=t;else if(this.e)t.previous=this.e,this.e.next=t;else throw new Error("Invalid list");this.e=t,this.g++}l(t){if(t===this.d&&t===this.e)this.d=void 0,this.e=void 0;else if(t===this.d){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.d=t.next}else if(t===this.e){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.e=t.previous}else{const r=t.next,s=t.previous;if(!r||!s)throw new Error("Invalid list");r.previous=s,s.next=r}t.next=void 0,t.previous=void 0,this.g++}m(t,r){if(!this.d||!this.e)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(t===this.d)return;const s=t.next,i=t.previous;t===this.e?(i.next=void 0,this.e=i):(s.previous=i,i.next=s),t.previous=void 0,t.next=this.d,this.d.previous=t,this.d=t,this.g++}else if(r===2){if(t===this.e)return;const s=t.next,i=t.previous;t===this.d?(s.previous=void 0,this.d=s):(s.previous=i,i.next=s),t.next=void 0,t.previous=this.e,this.e.next=t,this.e=t,this.g++}}}toJSON(){const t=[];return this.forEach((r,s)=>{t.push([s,r])}),t}fromJSON(t){this.clear();for(const[r,s]of t)this.set(r,s)}}e.$Dc=m;class f extends m{constructor(t,r=1){super(),this.n=t,this.o=Math.min(Math.max(0,r),1)}get limit(){return this.n}set limit(t){this.n=t,this.p()}get ratio(){return this.o}set ratio(t){this.o=Math.min(Math.max(0,t),1),this.p()}get(t,r=2){return super.get(t,r)}peek(t){return super.get(t,0)}set(t,r){return super.set(t,r,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class y extends f{constructor(t,r=1){super(t,r)}q(t){this.h(t)}set(t,r){return super.set(t,r),this.p(),this}}e.$Ec=y;class p extends f{constructor(t,r=1){super(t,r)}q(t){this.i(t)}set(t,r){return this.n<=this.size&&!this.has(t)&&this.q(Math.round(this.n*this.o)-1),super.set(t,r),this}}e.$Fc=p;class ${constructor(){this.c=new Map}add(t){return this.c.set(t,(this.c.get(t)||0)+1),this}delete(t){let r=this.c.get(t)||0;return r===0?!1:(r--,r===0?this.c.delete(t):this.c.set(t,r),!0)}has(t){return this.c.has(t)}}e.$Gc=$;class c{constructor(t){if(this.c=new Map,this.d=new Map,t)for(const[r,s]of t)this.set(r,s)}clear(){this.c.clear(),this.d.clear()}set(t,r){this.c.set(t,r),this.d.set(r,t)}get(t){return this.c.get(t)}getKey(t){return this.d.get(t)}delete(t){const r=this.c.get(t);return r===void 0?!1:(this.c.delete(t),this.d.delete(r),!0)}forEach(t,r){this.c.forEach((s,i)=>{t.call(r,s,i,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Hc=c;class w{constructor(){this.c=new Map}add(t,r){let s=this.c.get(t);s||(s=new Set,this.c.set(t,s)),s.add(r)}delete(t,r){const s=this.c.get(t);s&&(s.delete(r),s.size===0&&this.c.delete(t))}forEach(t,r){const s=this.c.get(t);s&&s.forEach(r)}get(t){const r=this.c.get(t);return r||new Set}}e.$Ic=w;function P(a,t){if(a===t)return!0;if(a.size!==t.size)return!1;for(const[r,s]of a)if(!t.has(r)||t.get(r)!==s)return!1;for(const[r]of t)if(!a.has(r))return!1;return!0}}),define(re[2],oe([0,1,22,137,32,86,71]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5c=e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Kc=void 0,e.$Lc=d,e.$Mc=b,e.$Nc=v,e.$Oc=y,e.$Pc=p,e.$Qc=$,e.$Rc=c,e.$Sc=w,e.$Tc=P,e.$4c=D;const k=!1;let h=null;class l{constructor(){this.b=new Map}static{this.a=0}c(M){let W=this.b.get(M);return W||(W={parent:null,source:null,isSingleton:!1,value:M,idx:l.a++},this.b.set(M,W)),W}trackDisposable(M){const W=this.c(M);W.source||(W.source=new Error().stack)}setParent(M,W){const F=this.c(M);F.parent=W}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,W){const F=W.get(M);if(F)return F;const T=M.parent?this.f(this.c(M.parent),W):M;return W.set(M,T),T}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,F])=>F.source!==null&&!this.f(F,M).isSingleton).flatMap(([F])=>F)}computeLeakingDisposables(M=10,W){let F;if(W)F=W;else{const ce=new Map,K=[...this.b.values()].filter(B=>B.source!==null&&!this.f(B,ce).isSingleton);if(K.length===0)return;const Q=new Set(K.map(B=>B.value));if(F=K.filter(B=>!(B.parent&&Q.has(B.parent))),F.length===0)throw new Error("There are cyclic diposable chains!")}if(!F)return;function T(ce){function K(B,L){for(;B.length>0&&L.some(z=>typeof z=="string"?z===B[0]:B[0].match(z));)B.shift()}const Q=ce.source.split(`
`).map(B=>B.trim().replace("at ","")).filter(B=>B!=="");return K(Q,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Q.reverse()}const q=new E.$Ic;for(const ce of F){const K=T(ce);for(let Q=0;Q<=K.length;Q++)q.add(K.slice(0,Q).join(`
`),ce)}F.sort((0,n.$7b)(ce=>ce.idx,n.$9b));let ue="",ee=0;for(const ce of F.slice(0,M)){ee++;const K=T(ce),Q=[];for(let B=0;B<K.length;B++){let L=K[B];L=`(shared with ${q.get(K.slice(0,B+1).join(`
`)).size}/${F.length} leaks) at ${L}`;const U=q.get(K.slice(0,B).join(`
`)),ae=(0,C.$K)([...U].map(G=>T(G)[B]),G=>G);delete ae[K[B]];for(const[G,le]of Object.entries(ae))Q.unshift(`    - stacktraces of ${le.length} other leaks continue with ${G}`);Q.unshift(L)}ue+=`


==================== Leaking disposable ${ee}/${F.length}: ${ce.value.constructor.name} ====================
${Q.join(`
`)}
============================================================

`}return F.length>M&&(ue+=`


... and ${F.length-M} more leaking disposables

`),{leaks:F,details:ue}}}e.$Kc=l;function d(O){h=O}if(k){const O="__is_disposable_tracked__";d(new class{trackDisposable(M){const W=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[O]||console.log(W)},3e3)}setParent(M,W){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[O]=!0}catch{}}markAsSingleton(M){}})}function b(O){return h?.trackDisposable(O),O}function v(O){h?.markAsDisposed(O)}function m(O,M){h?.setParent(O,M)}function f(O,M){if(h)for(const W of O)h.setParent(W,M)}function y(O){return h?.markAsSingleton(O),O}function p(O){return typeof O=="object"&&O!==null&&typeof O.dispose=="function"&&O.dispose.length===0}function $(O){if(j.Iterable.is(O)){const M=[];for(const W of O)if(W)try{W.dispose()}catch(F){M.push(F)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(O)?[]:O}else if(O)return O.dispose(),O}function c(O){for(const M of O)p(M)&&M.dispose();return[]}function w(...O){const M=P(()=>$(O));return f(O,M),M}function P(O){const M=b({dispose:(0,R.$db)(()=>{v(M),O()})});return M}class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,b(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return m(M,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),m(M,null))}}e.$Uc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,b(this),m(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Vc=t;class r{constructor(){this.b=!1,b(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&m(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&m(M,null),M}}e.$Wc=r;class s{constructor(M){this.a=new r,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Xc=s;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Yc=i;class o{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(M){let W=M;return this.unset=()=>W=void 0,this.isset=()=>W!==void 0,this.dispose=()=>{W&&(W(),W=void 0,v(this))},this}}e.$Zc=o;class u{constructor(){this.a=new Map}acquire(M,...W){let F=this.a.get(M);F||(F={counter:0,object:this.b(M,...W)},this.a.set(M,F));const{object:T}=F,q=(0,R.$db)(()=>{--F.counter===0&&(this.c(M,F.object),this.a.delete(M))});return F.counter++,{object:T,dispose:q}}}e.$1c=u;class g{constructor(M){this.a=M}async acquire(M,...W){const F=this.a.acquire(M,...W);try{return{object:await F.object,dispose:()=>F.dispose()}}catch(T){throw F.dispose(),T}}}e.$2c=g;class S{constructor(M){this.object=M}dispose(){}}e.$3c=S;function D(O){const M=new a;try{O(M)}finally{M.dispose()}}class I{constructor(){this.a=new Map,this.b=!1,b(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,W,F=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),F||this.a.get(M)?.dispose(),this.a.set(M,W)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$5c=I}),define(re[72],oe([0,1,32]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cm=void 0,e.$am=E,e.$bm=j;const C=new n.$Ec(1e4);function E(l){return h(l,"NFC",C)}const R=new n.$Ec(1e4);function j(l){return h(l,"NFD",R)}const k=/[^\u0000-\u0080]/;function h(l,d,b){if(!l)return l;const v=b.get(l);if(v)return v;let m;return k.test(l)?m=l.normalize(d):m=l,b.set(l,m),m}e.$cm=function(){const l=/[\u0300-\u036f]/g;return function(d){return j(d).replace(l,"")}}()}),define(re[141],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=void 0,e.$Am=n,e.rot=C;function n(k,h,l){return Math.min(Math.max(k,h),l)}function C(k,h){return(h+k%h)%h}class E{constructor(){this.a=0}getNext(){return this.a++}}e.$Cm=E;class R{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Dm=R;class j{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Em=j}),function(){function X(E){const R=[];typeof E=="number"&&R.push("code/timeOrigin",E);function j(h){R.push(h,Date.now())}function k(){const h=[];for(let l=0;l<R.length;l+=2)h.push({name:R[l],startTime:R[l+1]});return h}return{mark:j,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const j of performance.getEntriesByType("mark"))R.push({name:j.name,startTime:Math.round(E+j.startTime)});return R}};if(typeof process=="object"){const E=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function n(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var C;typeof global=="object"?C=global:typeof self=="object"?C=self:C={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(C)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(C):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),C.perf=n(C))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var C in n)(typeof exports=="object"?exports:X)[C]=n[C]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function n(C){if(e[C])return e[C].exports;var E=e[C]={i:C,l:!1,exports:{}};return X[C].call(E.exports,E,E.exports,n),E.l=!0,E.exports}return n.m=X,n.c=e,n.d=function(C,E,R){n.o(C,E)||Object.defineProperty(C,E,{enumerable:!0,get:R})},n.r=function(C){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(C,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(C,"__esModule",{value:!0})},n.t=function(C,E){if(1&E&&(C=n(C)),8&E||4&E&&typeof C=="object"&&C&&C.__esModule)return C;var R=Object.create(null);if(n.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:C}),2&E&&typeof C!="string")for(var j in C)n.d(R,j,function(k){return C[k]}.bind(null,j));return R},n.n=function(C){var E=C&&C.__esModule?function(){return C.default}:function(){return C};return n.d(E,"a",E),E},n.o=function(C,E){return Object.prototype.hasOwnProperty.call(C,E)},n.p="",n(n.s=0)}([function(X,e,n){(function(C){var E;e=X.exports=le,E=typeof C=="object"&&C.env&&C.env.NODE_DEBUG&&/\bsemver\b/i.test(C.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,j=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],h=e.src=[],l=0,d=l++;h[d]="0|[1-9]\\d*";var b=l++;h[b]="[0-9]+";var v=l++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var m=l++;h[m]="("+h[d]+")\\.("+h[d]+")\\.("+h[d]+")";var f=l++;h[f]="("+h[b]+")\\.("+h[b]+")\\.("+h[b]+")";var y=l++;h[y]="(?:"+h[d]+"|"+h[v]+")";var p=l++;h[p]="(?:"+h[b]+"|"+h[v]+")";var $=l++;h[$]="(?:-("+h[y]+"(?:\\."+h[y]+")*))";var c=l++;h[c]="(?:-?("+h[p]+"(?:\\."+h[p]+")*))";var w=l++;h[w]="[0-9A-Za-z-]+";var P=l++;h[P]="(?:\\+("+h[w]+"(?:\\."+h[w]+")*))";var a=l++,t="v?"+h[m]+h[$]+"?"+h[P]+"?";h[a]="^"+t+"$";var r="[v=\\s]*"+h[f]+h[c]+"?"+h[P]+"?",s=l++;h[s]="^"+r+"$";var i=l++;h[i]="((?:<|>)?=?)";var o=l++;h[o]=h[b]+"|x|X|\\*";var u=l++;h[u]=h[d]+"|x|X|\\*";var g=l++;h[g]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[$]+")?"+h[P]+"?)?)?";var S=l++;h[S]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[P]+"?)?)?";var D=l++;h[D]="^"+h[i]+"\\s*"+h[g]+"$";var I=l++;h[I]="^"+h[i]+"\\s*"+h[S]+"$";var O=l++;h[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=l++;h[M]="(?:~>?)";var W=l++;h[W]="(\\s*)"+h[M]+"\\s+",k[W]=new RegExp(h[W],"g");var F=l++;h[F]="^"+h[M]+h[g]+"$";var T=l++;h[T]="^"+h[M]+h[S]+"$";var q=l++;h[q]="(?:\\^)";var ue=l++;h[ue]="(\\s*)"+h[q]+"\\s+",k[ue]=new RegExp(h[ue],"g");var ee=l++;h[ee]="^"+h[q]+h[g]+"$";var ce=l++;h[ce]="^"+h[q]+h[S]+"$";var K=l++;h[K]="^"+h[i]+"\\s*("+r+")$|^$";var Q=l++;h[Q]="^"+h[i]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[i]+"\\s*("+r+"|"+h[g]+")",k[B]=new RegExp(h[B],"g");var L=l++;h[L]="^\\s*("+h[g]+")\\s+-\\s+("+h[g]+")\\s*$";var z=l++;h[z]="^\\s*("+h[S]+")\\s+-\\s+("+h[S]+")\\s*$";var U=l++;h[U]="(<|>)?=?\\s*\\*";for(var ae=0;ae<35;ae++)E(ae,h[ae]),k[ae]||(k[ae]=new RegExp(h[ae]));function G(Z,fe){if(Z instanceof le)return Z;if(typeof Z!="string"||Z.length>R||!(fe?k[s]:k[a]).test(Z))return null;try{return new le(Z,fe)}catch{return null}}function le(Z,fe){if(Z instanceof le){if(Z.loose===fe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof le))return new le(Z,fe);E("SemVer",Z,fe),this.loose=fe;var ge=Z.trim().match(fe?k[s]:k[a]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>j||this.major<0)throw new TypeError("Invalid major version");if(this.minor>j||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>j||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(je){if(/^[0-9]+$/.test(je)){var Re=+je;if(Re>=0&&Re<j)return Re}return je}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=G,e.valid=function(Z,fe){var ge=G(Z,fe);return ge?ge.version:null},e.clean=function(Z,fe){var ge=G(Z.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=le,le.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},le.prototype.toString=function(){return this.version},le.prototype.compare=function(Z){return E("SemVer.compare",this.version,this.loose,Z),Z instanceof le||(Z=new le(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},le.prototype.compareMain=function(Z){return Z instanceof le||(Z=new le(Z,this.loose)),A(this.major,Z.major)||A(this.minor,Z.minor)||A(this.patch,Z.patch)},le.prototype.comparePre=function(Z){if(Z instanceof le||(Z=new le(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],je=Z.prerelease[fe];if(E("prerelease compare",fe,ge,je),ge===void 0&&je===void 0)return 0;if(je===void 0)return 1;if(ge===void 0)return-1;if(ge!==je)return A(ge,je)}while(++fe)},le.prototype.inc=function(Z,fe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,fe,ge,je){typeof ge=="string"&&(je=ge,ge=void 0);try{return new le(Z,ge).inc(fe,je).version}catch{return null}},e.diff=function(Z,fe){if(J(Z,fe))return null;var ge=G(Z),je=G(fe);if(ge.prerelease.length||je.prerelease.length){for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return"pre"+Re;return"prerelease"}for(var Re in ge)if((Re==="major"||Re==="minor"||Re==="patch")&&ge[Re]!==je[Re])return Re},e.compareIdentifiers=A;var Y=/^[0-9]+$/;function A(Z,fe){var ge=Y.test(Z),je=Y.test(fe);return ge&&je&&(Z=+Z,fe=+fe),ge&&!je?-1:je&&!ge?1:Z<fe?-1:Z>fe?1:0}function N(Z,fe,ge){return new le(Z,ge).compare(new le(fe,ge))}function _(Z,fe,ge){return N(Z,fe,ge)>0}function ne(Z,fe,ge){return N(Z,fe,ge)<0}function J(Z,fe,ge){return N(Z,fe,ge)===0}function V(Z,fe,ge){return N(Z,fe,ge)!==0}function x(Z,fe,ge){return N(Z,fe,ge)>=0}function H(Z,fe,ge){return N(Z,fe,ge)<=0}function se(Z,fe,ge,je){var Re;switch(fe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Re=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Re=Z!==ge;break;case"":case"=":case"==":Re=J(Z,ge,je);break;case"!=":Re=V(Z,ge,je);break;case">":Re=_(Z,ge,je);break;case">=":Re=x(Z,ge,je);break;case"<":Re=ne(Z,ge,je);break;case"<=":Re=H(Z,ge,je);break;default:throw new TypeError("Invalid operator: "+fe)}return Re}function he(Z,fe){if(Z instanceof he){if(Z.loose===fe)return Z;Z=Z.value}if(!(this instanceof he))return new he(Z,fe);E("comparator",Z,fe),this.loose=fe,this.parse(Z),this.semver===me?this.value="":this.value=this.operator+this.semver.version,E("comp",this)}e.rcompareIdentifiers=function(Z,fe){return A(fe,Z)},e.major=function(Z,fe){return new le(Z,fe).major},e.minor=function(Z,fe){return new le(Z,fe).minor},e.patch=function(Z,fe){return new le(Z,fe).patch},e.compare=N,e.compareLoose=function(Z,fe){return N(Z,fe,!0)},e.rcompare=function(Z,fe,ge){return N(fe,Z,ge)},e.sort=function(Z,fe){return Z.sort(function(ge,je){return e.compare(ge,je,fe)})},e.rsort=function(Z,fe){return Z.sort(function(ge,je){return e.rcompare(ge,je,fe)})},e.gt=_,e.lt=ne,e.eq=J,e.neq=V,e.gte=x,e.lte=H,e.cmp=se,e.Comparator=he;var me={};function $e(Z,fe){if(Z instanceof $e)return Z.loose===fe?Z:new $e(Z.raw,fe);if(Z instanceof he)return new $e(Z.value,fe);if(!(this instanceof $e))return new $e(Z,fe);if(this.loose=fe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function ye(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function Pe(Z,fe,ge,je,Re,Be,Le,Fe,Ue,Ve,Je,Te,te){return((fe=ye(ge)?"":ye(je)?">="+ge+".0.0":ye(Re)?">="+ge+"."+je+".0":">="+fe)+" "+(Fe=ye(Ue)?"":ye(Ve)?"<"+(+Ue+1)+".0.0":ye(Je)?"<"+Ue+"."+(+Ve+1)+".0":Te?"<="+Ue+"."+Ve+"."+Je+"-"+Te:"<="+Fe)).trim()}function ke(Z,fe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(E(Z[ge].semver),Z[ge].semver!==me&&Z[ge].semver.prerelease.length>0){var je=Z[ge].semver;if(je.major===fe.major&&je.minor===fe.minor&&je.patch===fe.patch)return!0}return!1}return!0}function Oe(Z,fe,ge){try{fe=new $e(fe,ge)}catch{return!1}return fe.test(Z)}function we(Z,fe,ge,je){var Re,Be,Le,Fe,Ue;switch(Z=new le(Z,je),fe=new $e(fe,je),ge){case">":Re=_,Be=H,Le=ne,Fe=">",Ue=">=";break;case"<":Re=ne,Be=x,Le=_,Fe="<",Ue="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(Z,fe,je))return!1;for(var Ve=0;Ve<fe.set.length;++Ve){var Je=fe.set[Ve],Te=null,te=null;if(Je.forEach(function(de){de.semver===me&&(de=new he(">=0.0.0")),Te=Te||de,te=te||de,Re(de.semver,Te.semver,je)?Te=de:Le(de.semver,te.semver,je)&&(te=de)}),Te.operator===Fe||Te.operator===Ue||(!te.operator||te.operator===Fe)&&Be(Z,te.semver)||te.operator===Ue&&Le(Z,te.semver))return!1}return!0}he.prototype.parse=function(Z){var fe=this.loose?k[K]:k[Q],ge=Z.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new le(ge[2],this.loose):this.semver=me},he.prototype.toString=function(){return this.value},he.prototype.test=function(Z){return E("Comparator.test",Z,this.loose),this.semver===me||(typeof Z=="string"&&(Z=new le(Z,this.loose)),se(Z,this.operator,this.semver,this.loose))},he.prototype.intersects=function(Z,fe){if(!(Z instanceof he))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new $e(Z.value,fe),Oe(this.value,ge,fe);if(Z.operator==="")return ge=new $e(this.value,fe),Oe(Z.semver,ge,fe);var je=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Re=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Be=this.semver.version===Z.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),Fe=se(this.semver,"<",Z.semver,fe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),Ue=se(this.semver,">",Z.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return je||Re||Be&&Le||Fe||Ue},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(Z){var fe=this.loose;Z=Z.trim(),E("range",Z,fe);var ge=fe?k[z]:k[L];Z=Z.replace(ge,Pe),E("hyphen replace",Z),Z=Z.replace(k[B],"$1$2$3"),E("comparator trim",Z,k[B]),Z=(Z=(Z=Z.replace(k[W],"$1~")).replace(k[ue],"$1^")).split(/\s+/).join(" ");var je=fe?k[K]:k[Q],Re=Z.split(" ").map(function(Be){return function(Le,Fe){return E("comp",Le),Le=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Je){return function(Te,te){E("caret",Te,te);var de=te?k[ce]:k[ee];return Te.replace(de,function(pe,ve,Se,Me,ze){var Qe;return E("caret",Te,pe,ve,Se,Me,ze),ye(ve)?Qe="":ye(Se)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Qe=ve==="0"?">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+".0 <"+(+ve+1)+".0.0":ze?(E("replaceCaret pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Qe=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+Me+ze+" <"+ve+"."+Se+"."+(+Me+1):">="+ve+"."+Se+"."+Me+ze+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+Me+ze+" <"+(+ve+1)+".0.0"):(E("no pr"),Qe=ve==="0"?Se==="0"?">="+ve+"."+Se+"."+Me+" <"+ve+"."+Se+"."+(+Me+1):">="+ve+"."+Se+"."+Me+" <"+ve+"."+(+Se+1)+".0":">="+ve+"."+Se+"."+Me+" <"+(+ve+1)+".0.0"),E("caret return",Qe),Qe})}(Je,Ve)}).join(" ")}(Le,Fe),E("caret",Le),Le=function(Ue,Ve){return Ue.trim().split(/\s+/).map(function(Je){return function(Te,te){var de=te?k[T]:k[F];return Te.replace(de,function(pe,ve,Se,Me,ze){var Qe;return E("tilde",Te,pe,ve,Se,Me,ze),ye(ve)?Qe="":ye(Se)?Qe=">="+ve+".0.0 <"+(+ve+1)+".0.0":ye(Me)?Qe=">="+ve+"."+Se+".0 <"+ve+"."+(+Se+1)+".0":ze?(E("replaceTilde pr",ze),ze.charAt(0)!=="-"&&(ze="-"+ze),Qe=">="+ve+"."+Se+"."+Me+ze+" <"+ve+"."+(+Se+1)+".0"):Qe=">="+ve+"."+Se+"."+Me+" <"+ve+"."+(+Se+1)+".0",E("tilde return",Qe),Qe})}(Je,Ve)}).join(" ")}(Le,Fe),E("tildes",Le),Le=function(Ue,Ve){return E("replaceXRanges",Ue,Ve),Ue.split(/\s+/).map(function(Je){return function(Te,te){Te=Te.trim();var de=te?k[I]:k[D];return Te.replace(de,function(pe,ve,Se,Me,ze,Qe){E("xRange",Te,pe,ve,Se,Me,ze,Qe);var Ze=ye(Se),Ye=Ze||ye(Me),Ke=Ye||ye(ze);return ve==="="&&Ke&&(ve=""),Ze?pe=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Ke?(Ye&&(Me=0),Ke&&(ze=0),ve===">"?(ve=">=",Ye?(Se=+Se+1,Me=0,ze=0):Ke&&(Me=+Me+1,ze=0)):ve==="<="&&(ve="<",Ye?Se=+Se+1:Me=+Me+1),pe=ve+Se+"."+Me+"."+ze):Ye?pe=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ke&&(pe=">="+Se+"."+Me+".0 <"+Se+"."+(+Me+1)+".0"),E("xRange return",pe),pe})}(Je,Ve)}).join(" ")}(Le,Fe),E("xrange",Le),Le=function(Ue,Ve){return E("replaceStars",Ue,Ve),Ue.trim().replace(k[U],"")}(Le,Fe),E("stars",Le),Le}(Be,fe)}).join(" ").split(/\s+/);return this.loose&&(Re=Re.filter(function(Be){return!!Be.match(je)})),Re=Re.map(function(Be){return new he(Be,fe)})},$e.prototype.intersects=function(Z,fe){if(!(Z instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(je){return Z.set.some(function(Re){return Re.every(function(Be){return je.intersects(Be,fe)})})})})},e.toComparators=function(Z,fe){return new $e(Z,fe).set.map(function(ge){return ge.map(function(je){return je.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new le(Z,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],Z))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(Z,fe,ge){var je=null,Re=null;try{var Be=new $e(fe,ge)}catch{return null}return Z.forEach(function(Le){Be.test(Le)&&(je&&Re.compare(Le)!==-1||(Re=new le(je=Le,ge)))}),je},e.minSatisfying=function(Z,fe,ge){var je=null,Re=null;try{var Be=new $e(fe,ge)}catch{return null}return Z.forEach(function(Le){Be.test(Le)&&(je&&Re.compare(Le)!==1||(Re=new le(je=Le,ge)))}),je},e.validRange=function(Z,fe){try{return new $e(Z,fe).range||"*"}catch{return null}},e.ltr=function(Z,fe,ge){return we(Z,fe,"<",ge)},e.gtr=function(Z,fe,ge){return we(Z,fe,">",ge)},e.outside=we,e.prerelease=function(Z,fe){var ge=G(Z,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,fe,ge){return Z=new $e(Z,ge),fe=new $e(fe,ge),Z.intersects(fe)},e.coerce=function(Z){if(Z instanceof le)return Z;if(typeof Z!="string")return null;var fe=Z.match(k[O]);return fe==null?null:G((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,n(1))},function(X,e){var n,C,E=X.exports={};function R(){throw new Error("setTimeout has not been defined")}function j(){throw new Error("clearTimeout has not been defined")}function k(p){if(n===setTimeout)return setTimeout(p,0);if((n===R||!n)&&setTimeout)return n=setTimeout,setTimeout(p,0);try{return n(p,0)}catch{try{return n.call(null,p,0)}catch{return n.call(this,p,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:R}catch{n=R}try{C=typeof clearTimeout=="function"?clearTimeout:j}catch{C=j}})();var h,l=[],d=!1,b=-1;function v(){d&&h&&(d=!1,h.length?l=h.concat(l):b=-1,l.length&&m())}function m(){if(!d){var p=k(v);d=!0;for(var $=l.length;$;){for(h=l,l=[];++b<$;)h&&h[b].run();b=-1,$=l.length}h=null,d=!1,function(c){if(C===clearTimeout)return clearTimeout(c);if((C===j||!C)&&clearTimeout)return C=clearTimeout,clearTimeout(c);try{C(c)}catch{try{return C.call(null,c)}catch{return C.call(this,c)}}}(p)}}function f(p,$){this.fun=p,this.array=$}function y(){}E.nextTick=function(p){var $=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)$[c-1]=arguments[c];l.push(new f(p,$)),l.length!==1||d||k(m)},f.prototype.run=function(){this.fun.apply(null,this.array)},E.title="browser",E.browser=!0,E.env={},E.argv=[],E.version="",E.versions={},E.on=y,E.addListener=y,E.once=y,E.off=y,E.removeListener=y,E.removeAllListeners=y,E.emit=y,E.prependListener=y,E.prependOnceListener=y,E.listeners=function(p){return[]},E.binding=function(p){throw new Error("process.binding is not supported")},E.cwd=function(){return"/"},E.chdir=function(p){throw new Error("process.chdir is not supported")},E.umask=function(){return 0}}])}),define(re[142],oe([0,1]),function(X,e){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$ys=void 0;class C{constructor(k,h,l){this.level=k,this.key=h,this.value=l,this.forward=[]}}const E=void 0;class R{constructor(k,h=2**16){this.comparator=k,this[n]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new C(this.c,E,E)}get size(){return this.f}clear(){this.e=new C(this.c,E,E),this.f=0}has(k){return!!R.g(this,k,this.comparator)}get(k){return R.g(this,k,this.comparator)?.value}set(k,h){return R.h(this,k,h,this.comparator)&&(this.f+=1),this}delete(k){const h=R.k(this,k,this.comparator);return h&&(this.f-=1),h}forEach(k,h){let l=this.e.forward[0];for(;l;)k.call(h,l.value,l.key,this),l=l.forward[0]}[(n=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",h=this.e.forward[0];for(;h;)k+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return k}static g(k,h,l){let d=k.e;for(let b=k.d-1;b>=0;b--)for(;d.forward[b]&&l(d.forward[b].key,h)<0;)d=d.forward[b];if(d=d.forward[0],d&&l(d.key,h)===0)return d}static h(k,h,l,d){const b=[];let v=k.e;for(let m=k.d-1;m>=0;m--){for(;v.forward[m]&&d(v.forward[m].key,h)<0;)v=v.forward[m];b[m]=v}if(v=v.forward[0],v&&d(v.key,h)===0)return v.value=l,!1;{const m=R.j(k);if(m>k.d){for(let f=k.d;f<m;f++)b[f]=k.e;k.d=m}v=new C(m,h,l);for(let f=0;f<m;f++)v.forward[f]=b[f].forward[f],b[f].forward[f]=v;return!0}}static j(k,h=.5){let l=1;for(;Math.random()<h&&l<k.c;)l+=1;return l}static k(k,h,l){const d=[];let b=k.e;for(let v=k.d-1;v>=0;v--){for(;b.forward[v]&&l(b.forward[v].key,h)<0;)b=b.forward[v];d[v]=b}if(b=b.forward[0],!b||l(b.key,h)!==0)return!1;for(let v=0;v<k.d&&d[v].forward[v]===b;v++)d[v].forward[v]=b.forward[v];for(;k.d>0&&k.e.forward[k.d-1]===E;)k.d-=1;return!0}}e.$ys=R}),define(re[73],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ae=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(R){return new C(R)}constructor(R){this.c=n&&R===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$ae=C}),define(re[3],oe([0,1,15,86,2,104,73]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$ce=e.Event=void 0,e.$de=m;const k=!1,h=!1,l=!1;var d;(function(W){W.None=()=>E.$Vc.None;function F($e){if(l){const{onDidAddListener:ye}=$e,Pe=y.create();let ke=0;$e.onDidAddListener=()=>{++ke===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Pe.print()),ye?.()}}}function T($e,ye){return U($e,()=>{},0,void 0,!0,void 0,ye)}W.defer=T;function q($e){return(ye,Pe=null,ke)=>{let Oe=!1,we;return we=$e(Z=>{if(!Oe)return we?we.dispose():Oe=!0,ye.call(Pe,Z)},null,ke),Oe&&we.dispose(),we}}W.once=q;function ue($e,ye,Pe){return L((ke,Oe=null,we)=>$e(Z=>ke.call(Oe,ye(Z)),null,we),Pe)}W.map=ue;function ee($e,ye,Pe){return L((ke,Oe=null,we)=>$e(Z=>{ye(Z),ke.call(Oe,Z)},null,we),Pe)}W.forEach=ee;function ce($e,ye,Pe){return L((ke,Oe=null,we)=>$e(Z=>ye(Z)&&ke.call(Oe,Z),null,we),Pe)}W.filter=ce;function K($e){return $e}W.signal=K;function Q(...$e){return(ye,Pe=null,ke)=>{const Oe=(0,E.$Sc)(...$e.map(we=>we(Z=>ye.call(Pe,Z))));return z(Oe,ke)}}W.any=Q;function B($e,ye,Pe,ke){let Oe=Pe;return ue($e,we=>(Oe=ye(Oe,we),Oe),ke)}W.reduce=B;function L($e,ye){let Pe;const ke={onWillAddFirstListener(){Pe=$e(Oe.fire,Oe)},onDidRemoveLastListener(){Pe?.dispose()}};ye||F(ke);const Oe=new a(ke);return ye?.add(Oe),Oe.event}function z($e,ye){return ye instanceof Array?ye.push($e):ye&&ye.add($e),$e}function U($e,ye,Pe=100,ke=!1,Oe=!1,we,Z){let fe,ge,je,Re=0,Be;const Le={leakWarningThreshold:we,onWillAddFirstListener(){fe=$e(Ue=>{Re++,ge=ye(ge,Ue),ke&&!je&&(Fe.fire(ge),ge=void 0),Be=()=>{const Ve=ge;ge=void 0,je=void 0,(!ke||Re>1)&&Fe.fire(Ve),Re=0},typeof Pe=="number"?(clearTimeout(je),je=setTimeout(Be,Pe)):je===void 0&&(je=0,queueMicrotask(Be))})},onWillRemoveListener(){Oe&&Re>0&&Be?.()},onDidRemoveLastListener(){Be=void 0,fe.dispose()}};Z||F(Le);const Fe=new a(Le);return Z?.add(Fe),Fe.event}W.debounce=U;function ae($e,ye=0,Pe){return W.debounce($e,(ke,Oe)=>ke?(ke.push(Oe),ke):[Oe],ye,void 0,!0,void 0,Pe)}W.accumulate=ae;function G($e,ye=(ke,Oe)=>ke===Oe,Pe){let ke=!0,Oe;return ce($e,we=>{const Z=ke||!ye(we,Oe);return ke=!1,Oe=we,Z},Pe)}W.latch=G;function le($e,ye,Pe){return[W.filter($e,ye,Pe),W.filter($e,ke=>!ye(ke),Pe)]}W.split=le;function Y($e,ye=!1,Pe=[],ke){let Oe=Pe.slice(),we=$e(ge=>{Oe?Oe.push(ge):fe.fire(ge)});ke&&ke.add(we);const Z=()=>{Oe?.forEach(ge=>fe.fire(ge)),Oe=null},fe=new a({onWillAddFirstListener(){we||(we=$e(ge=>fe.fire(ge)),ke&&ke.add(we))},onDidAddFirstListener(){Oe&&(ye?setTimeout(Z):Z())},onDidRemoveLastListener(){we&&we.dispose(),we=null}});return ke&&ke.add(fe),fe.event}W.buffer=Y;function A($e,ye){return(ke,Oe,we)=>{const Z=ye(new _);return $e(function(fe){const ge=Z.evaluate(fe);ge!==N&&ke.call(Oe,ge)},void 0,we)}}W.chain=A;const N=Symbol("HaltChainable");class _{constructor(){this.f=[]}map(ye){return this.f.push(ye),this}forEach(ye){return this.f.push(Pe=>(ye(Pe),Pe)),this}filter(ye){return this.f.push(Pe=>ye(Pe)?Pe:N),this}reduce(ye,Pe){let ke=Pe;return this.f.push(Oe=>(ke=ye(ke,Oe),ke)),this}latch(ye=(Pe,ke)=>Pe===ke){let Pe=!0,ke;return this.f.push(Oe=>{const we=Pe||!ye(Oe,ke);return Pe=!1,ke=Oe,we?Oe:N}),this}evaluate(ye){for(const Pe of this.f)if(ye=Pe(ye),ye===N)break;return ye}}function ne($e,ye,Pe=ke=>ke){const ke=(...fe)=>Z.fire(Pe(...fe)),Oe=()=>$e.on(ye,ke),we=()=>$e.removeListener(ye,ke),Z=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Z.event}W.fromNodeEventEmitter=ne;function J($e,ye,Pe=ke=>ke){const ke=(...fe)=>Z.fire(Pe(...fe)),Oe=()=>$e.addEventListener(ye,ke),we=()=>$e.removeEventListener(ye,ke),Z=new a({onWillAddFirstListener:Oe,onDidRemoveLastListener:we});return Z.event}W.fromDOMEventEmitter=J;function V($e){return new Promise(ye=>q($e)(ye))}W.toPromise=V;function x($e){const ye=new a;return $e.then(Pe=>{ye.fire(Pe)},()=>{ye.fire(void 0)}).finally(()=>{ye.dispose()}),ye.event}W.fromPromise=x;function H($e,ye,Pe){return ye(Pe),$e(ke=>ye(ke))}W.runAndSubscribe=H;class se{constructor(ye,Pe){this._observable=ye,this.f=0,this.g=!1;const ke={onWillAddFirstListener:()=>{ye.addObserver(this)},onDidRemoveLastListener:()=>{ye.removeObserver(this)}};Pe||F(ke),this.emitter=new a(ke),Pe&&Pe.add(this.emitter)}beginUpdate(ye){this.f++}handlePossibleChange(ye){}handleChange(ye,Pe){this.g=!0}endUpdate(ye){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function he($e,ye){return new se($e,ye).emitter.event}W.fromObservable=he;function me($e){return(ye,Pe,ke)=>{let Oe=0,we=!1;const Z={beginUpdate(){Oe++},endUpdate(){Oe--,Oe===0&&($e.reportChanges(),we&&(we=!1,ye.call(Pe)))},handlePossibleChange(){},handleChange(){we=!0}};$e.addObserver(Z),$e.reportChanges();const fe={dispose(){$e.removeObserver(Z)}};return ke instanceof E.$Uc?ke.add(fe):Array.isArray(ke)&&ke.push(fe),fe}}W.fromObservableLight=me})(d||(e.Event=d={}));class b{static{this.all=new Set}static{this.f=0}constructor(F){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${F}_${b.f++}`,b.all.add(this)}start(F){this.g=new j.$ae,this.listenerCount=F}stop(){if(this.g){const F=this.g.elapsed();this.durations.push(F),this.elapsedOverall+=F,this.invocationCount+=1,this.g=void 0}}}e.$ce=b;let v=-1;function m(W){const F=v;return v=W,{dispose(){v=F}}}class f{constructor(F,T=Math.random().toString(18).slice(2,5)){this.threshold=F,this.name=T,this.g=0}dispose(){this.f?.clear()}check(F,T){const q=this.threshold;if(q<=0||T<q)return;this.f||(this.f=new Map);const ue=this.f.get(F.value)||0;if(this.f.set(F.value,ue+1),this.g-=1,this.g<=0){this.g=q*.5;let ee,ce=0;for(const[K,Q]of this.f)(!ee||ce<Q)&&(ee=K,ce=Q);console.warn(`[${this.name}] potential listener LEAK detected, having ${T} listeners already. MOST frequent listener (${ce}):`),console.warn(ee)}return()=>{const ee=this.f.get(F.value)||0;this.f.set(F.value,ee-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(F){this.value=F}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let p=0;class ${constructor(F){this.value=F,this.id=p++}}const c=2,w=(W,F)=>{if(W instanceof $)F(W);else for(let T=0;T<W.length;T++){const q=W[T];q&&F(q)}},P=k?new FinalizationRegistry(W=>{typeof W=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(W))}):void 0;class a{constructor(F){this.w=0,this.f=F,this.g=v>0||this.f?.leakWarningThreshold?new f(this.f?.leakWarningThreshold??v):void 0,this.j=this.f?._profName?new b(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(h){const F=this.t;queueMicrotask(()=>{w(F,T=>T.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(F,T,q)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),E.$Vc.None;if(this.m)return E.$Vc.None;T&&(F=F.bind(T));const ue=new $(F);let ee,ce;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ue.stack=y.create(),ee=this.g.check(ue.stack,this.w+1)),h&&(ue.stack=ce??y.create()),this.t?this.t instanceof $?(this.u??=new r,this.t=[this.t,ue]):this.t.push(ue):(this.f?.onWillAddFirstListener?.(this),this.t=ue,this.f?.onDidAddFirstListener?.(this)),this.w++;const K=(0,E.$Tc)(()=>{P?.unregister(K),ee?.(),this.x(ue)});if(q instanceof E.$Uc?q.add(K):Array.isArray(q)&&q.push(K),P){const Q=new Error().stack.split(`
`).slice(2).join(`
`).trim();P.register(K,Q,K)}return K},this.q}x(F){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const T=this.t,q=T.indexOf(F);if(q===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,T[q]=void 0;const ue=this.u.current===this;if(this.w*c<=T.length){let ee=0;for(let ce=0;ce<T.length;ce++)T[ce]?T[ee++]=T[ce]:ue&&(this.u.end--,ee<this.u.i&&this.u.i--);T.length=ee}}y(F,T){if(!F)return;const q=this.f?.onListenerError||n.$1;if(!q){F.value(T);return}try{F.value(T)}catch(ue){q(ue)}}z(F){const T=F.current.t;for(;F.i<F.end;)this.y(T[F.i++],F.value);F.reset()}fire(F){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof $)this.y(this.t,F);else{const T=this.u;T.enqueue(this,F,this.t.length),this.z(T)}this.j?.stop()}hasListeners(){return this.w>0}}e.$ee=a;const t=()=>new r;e.$fe=t;class r{constructor(){this.i=-1,this.end=0}enqueue(F,T,q){this.i=0,this.end=q,this.current=F,this.value=T}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class s extends a{async fireAsync(F,T,q){if(this.t)for(this.h||(this.h=new R.$6c),w(this.t,ue=>this.h.push([ue.value,F]));this.h.size>0&&!T.isCancellationRequested;){const[ue,ee]=this.h.shift(),ce=[],K={...ee,token:T,waitUntil:Q=>{if(Object.isFrozen(ce))throw new Error("waitUntil can NOT be called asynchronous");q&&(Q=q(Q,ue)),ce.push(Q)}};try{ue(K)}catch(Q){(0,n.$1)(Q);continue}Object.freeze(ce),await Promise.allSettled(ce).then(Q=>{for(const B of Q)B.status==="rejected"&&(0,n.$1)(B.reason)})}}}e.$ge=s;class i extends a{get isPaused(){return this.h!==0}constructor(F){super(F),this.h=0,this.s=new R.$6c,this.A=F?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const F=Array.from(this.s);this.s.clear(),super.fire(this.A(F))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(F){this.w&&(this.h!==0?this.s.push(F):super.fire(F))}}e.$he=i;class o extends i{constructor(F){super(F),this.k=F.delay??100}fire(F){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(F)}}e.$ie=o;class u extends a{constructor(F){super(F),this.h=[],this.k=F?.merge}fire(F){this.hasListeners()&&(this.h.push(F),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(T=>super.fire(T)),this.h=[]}))}}e.$je=u;class g{constructor(){this.g=!1,this.h=[],this.f=new a({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(F){const T={event:F,listener:null};this.h.push(T),this.g&&this.m(T);const q=()=>{this.g&&this.o(T);const ue=this.h.indexOf(T);this.h.splice(ue,1)};return(0,E.$Tc)((0,C.$db)(q))}j(){this.g=!0,this.h.forEach(F=>this.m(F))}k(){this.g=!1,this.h.forEach(F=>this.o(F))}m(F){F.listener=F.event(T=>this.f.fire(T))}o(F){F.listener?.dispose(),F.listener=null}dispose(){this.f.dispose();for(const F of this.h)F.listener?.dispose();this.h=[]}}e.$ke=g;class S{constructor(F,T,q,ue){this.f=new E.$Uc;const ee=this.f.add(new g),ce=this.f.add(new E.$5c);function K(Q){ce.set(Q,ee.add(ue(Q)))}for(const Q of F)K(Q);this.f.add(T(Q=>{K(Q)})),this.f.add(q(Q=>{ce.deleteAndDispose(Q)})),this.event=ee.event}dispose(){this.f.dispose()}}e.$le=S;class D{constructor(){this.f=[]}wrapEvent(F){return(T,q,ue)=>F(ee=>{const ce=this.f[this.f.length-1];ce?ce.push(()=>T.call(q,ee)):T.call(q,ee)},void 0,ue)}bufferEvents(F){const T=[];this.f.push(T);const q=F();return this.f.pop(),T.forEach(ue=>ue()),q}}e.$me=D;class I{constructor(){this.f=!1,this.g=d.None,this.h=E.$Vc.None,this.j=new a({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(F){this.g=F,this.f&&(this.h.dispose(),this.h=F(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$ne=I;class O{static const(F){return new M(F)}constructor(F){this.g=F,this.f=new a,this.onDidChange=this.f.event}get value(){return this.g}set value(F){F!==this.g&&(this.g=F,this.f.fire(void 0))}}e.$oe=O;class M{constructor(F){this.value=F,this.onDidChange=d.None}}}),define(re[23],oe([0,1,3]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pe=e.CancellationToken=void 0;const C=Object.freeze(function(k,h){const l=setTimeout(k.bind(h),0);return{dispose(){clearTimeout(l)}}});var E;(function(k){function h(l){return l===k.None||l===k.Cancelled||l instanceof R?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}k.isCancellationToken=h,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(E||(e.CancellationToken=E={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class j{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new R),this.f}cancel(){this.f?this.f instanceof R&&this.f.cancel():this.f=E.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof R&&this.f.dispose():this.f=E.None}}e.$pe=j}),define(re[143],oe([0,1,23]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4e=e.$3e=e.$1e=void 0,e.$2e=E;class C{constructor(h){this.b=h,this.a=null}get(){if(this.a)return this.a;const h=new n.$pe,l=this.b(h.token);return this.a={promise:l,dispose:()=>{this.a=null,h.cancel(),h.dispose()}},this.a}}e.$1e=C;function E(k){return k}class R{constructor(h,l){this.a=void 0,this.b=void 0,typeof h=="function"?(this.c=h,this.d=E):(this.c=l,this.d=h.getCacheKey)}get(h){const l=this.d(h);return this.b!==l&&(this.b=l,this.a=this.c(h)),this.a}}e.$3e=R;class j{get cachedValues(){return this.a}constructor(h,l){this.a=new Map,this.b=new Map,typeof h=="function"?(this.c=h,this.d=E):(this.c=l,this.d=h.getCacheKey)}get(h){const l=this.d(h);if(this.b.has(l))return this.b.get(l);const d=this.c(h);return this.a.set(h,d),this.b.set(l,d),d}}e.$4e=j}),define(re[63],oe([0,1,15,2]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=E,e.$re=R,e.$se=j,e.$te=k,e.$ue=l,e.$ve=d,e.$we=b,e.$xe=v,e.$ye=m,e.$ze=f,e.$Ae=y,e.$Be=p,e.$Ce=$,e.$De=c,e.$Ee=w;function E(P){const a=P;return a?typeof a.read=="function":!1}function R(P){const a=P;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}function j(P){const a=P;return a?R(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}function k(P,a){return new h(P,a)}class h{constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,n.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let r;switch(a){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const s=r.indexOf(t);s>=0&&r.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(P,a){const t=[];let r;for(;(r=P.read())!==null;)t.push(r);return a(t)}function d(P,a,t){const r=[];let s;for(;(s=P.read())!==null&&r.length<t;)r.push(s);return s===null&&r.length>0?a(r):{read:()=>{if(r.length>0)return r.shift();if(typeof s<"u"){const i=s;return s=void 0,i}return P.read()}}}function b(P,a){return new Promise((t,r)=>{const s=[];v(P,{onData:i=>{a&&s.push(i)},onError:i=>{a?r(i):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}function v(P,a,t){P.on("error",r=>{t?.isCancellationRequested||a.onError(r)}),P.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),P.on("data",r=>{t?.isCancellationRequested||a.onData(r)})}function m(P,a){return new Promise((t,r)=>{const s=new C.$Uc,i=[],o=S=>{if(i.push(S),i.length>a)return s.dispose(),P.pause(),t({stream:P,buffer:i,ended:!1})},u=S=>(s.dispose(),r(S)),g=()=>(s.dispose(),t({stream:P,buffer:i,ended:!0}));s.add((0,C.$Tc)(()=>P.removeListener("error",u))),P.on("error",u),s.add((0,C.$Tc)(()=>P.removeListener("end",g))),P.on("end",g),s.add((0,C.$Tc)(()=>P.removeListener("data",o))),P.on("data",o)})}function f(P,a){const t=k(a);return t.end(P),t}function y(){const P=k(()=>{throw new Error("not supported")});return P.end(),P}function p(P){let a=!1;return{read:()=>a?null:(a=!0,P)}}function $(P,a,t){const r=k(t);return v(P,{onData:s=>r.write(a.data(s)),onError:s=>r.error(a.error?a.error(s):s),onEnd:()=>r.end()}),r}function c(P,a,t){let r=!1;return{read:()=>{const s=a.read();return r?s:(r=!0,s!==null?t([P,s]):P)}}}function w(P,a,t){let r=!1;const s=k(t);return v(a,{onData:i=>r?s.write(i):(r=!0,s.write(t([P,i]))),onError:i=>s.error(i),onEnd:()=>{r||(r=!0,s.write(P)),s.end()}}),s}}),define(re[17],oe([0,1,62,63]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=l,e.$He=d,e.$Ie=b,e.$Je=v,e.$Ke=m,e.$Le=f,e.$Me=y,e.$Ne=p,e.$Oe=$,e.$Pe=c,e.$Qe=w,e.$Re=P,e.$Se=a,e.$Te=t,e.$Ue=r,e.$Ve=s,e.$We=i,e.$Xe=o,e.$Ye=u,e.$Ze=D;const E=typeof Buffer<"u",R=new n.$V(()=>new Uint8Array(256));let j,k;class h{static alloc(O){return E?new h(Buffer.allocUnsafe(O)):new h(new Uint8Array(O))}static wrap(O){return E&&!Buffer.isBuffer(O)&&(O=Buffer.from(O.buffer,O.byteOffset,O.byteLength)),new h(O)}static fromString(O,M){return!(M?.dontUseNodeBuffer||!1)&&E?new h(Buffer.from(O)):(j||(j=new TextEncoder),new h(j.encode(O)))}static fromByteArray(O){const M=h.alloc(O.length);for(let W=0,F=O.length;W<F;W++)M.buffer[W]=O[W];return M}static concat(O,M){if(typeof M>"u"){M=0;for(let T=0,q=O.length;T<q;T++)M+=O[T].byteLength}const W=h.alloc(M);let F=0;for(let T=0,q=O.length;T<q;T++){const ue=O[T];W.set(ue,F),F+=ue.byteLength}return W}constructor(O){this.buffer=O,this.byteLength=this.buffer.byteLength}clone(){const O=h.alloc(this.byteLength);return O.set(this),O}toString(){return E?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(O,M){return new h(this.buffer.subarray(O,M))}set(O,M){if(O instanceof h)this.buffer.set(O.buffer,M);else if(O instanceof Uint8Array)this.buffer.set(O,M);else if(O instanceof ArrayBuffer)this.buffer.set(new Uint8Array(O),M);else if(ArrayBuffer.isView(O))this.buffer.set(new Uint8Array(O.buffer,O.byteOffset,O.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(O){return v(this.buffer,O)}writeUInt32BE(O,M){m(this.buffer,O,M)}readUInt32LE(O){return f(this.buffer,O)}writeUInt32LE(O,M){y(this.buffer,O,M)}readUInt8(O){return p(this.buffer,O)}writeUInt8(O,M){$(this.buffer,O,M)}indexOf(O,M=0){return l(this.buffer,O instanceof h?O.buffer:O,M)}}e.$Fe=h;function l(I,O,M=0){const W=O.byteLength,F=I.byteLength;if(W===0)return 0;if(W===1)return I.indexOf(O[0]);if(W>F-M)return-1;const T=R.value;T.fill(O.length);for(let ce=0;ce<O.length;ce++)T[O[ce]]=O.length-ce-1;let q=M+O.length-1,ue=q,ee=-1;for(;q<F;)if(I[q]===O[ue]){if(ue===0){ee=q;break}q--,ue--}else q+=Math.max(O.length-ue,T[I[q]]),ue=O.length-1;return ee}function d(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0}function b(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255}function v(I,O){return I[O]*2**24+I[O+1]*2**16+I[O+2]*2**8+I[O+3]}function m(I,O,M){I[M+3]=O,O=O>>>8,I[M+2]=O,O=O>>>8,I[M+1]=O,O=O>>>8,I[M]=O}function f(I,O){return I[O+0]<<0>>>0|I[O+1]<<8>>>0|I[O+2]<<16>>>0|I[O+3]<<24>>>0}function y(I,O,M){I[M+0]=O&255,O=O>>>8,I[M+1]=O&255,O=O>>>8,I[M+2]=O&255,O=O>>>8,I[M+3]=O&255}function p(I,O){return I[O]}function $(I,O,M){I[M]=O}function c(I){return C.$ue(I,O=>h.concat(O))}function w(I){return C.$Be(I)}function P(I){return C.$we(I,O=>h.concat(O))}async function a(I){return I.ended?h.concat(I.buffer):h.concat([...I.buffer,await P(I.stream)])}function t(I){return C.$ze(I,O=>h.concat(O))}function r(I){return C.$Ce(I,{data:O=>typeof O=="string"?h.fromString(O):h.wrap(O)},O=>h.concat(O))}function s(I){return C.$te(O=>h.concat(O),I)}function i(I,O){return C.$De(I,O,M=>h.concat(M))}function o(I,O){return C.$Ee(I,O,M=>h.concat(M))}function u(I){let O=0,M=0,W=0;const F=new Uint8Array(Math.floor(I.length/4*3)),T=ue=>{switch(M){case 3:F[W++]=O|ue,M=0;break;case 2:F[W++]=O|ue>>>2,O=ue<<6,M=3;break;case 1:F[W++]=O|ue>>>4,O=ue<<4,M=2;break;default:O=ue<<2,M=1}};for(let ue=0;ue<I.length;ue++){const ee=I.charCodeAt(ue);if(ee>=65&&ee<=90)T(ee-65);else if(ee>=97&&ee<=122)T(ee-97+26);else if(ee>=48&&ee<=57)T(ee-48+52);else if(ee===43||ee===45)T(62);else if(ee===47||ee===95)T(63);else{if(ee===61)break;throw new SyntaxError(`Unexpected base64 character ${I[ue]}`)}}const q=W;for(;M>0;)T(0);return h.wrap(F).slice(0,q)}const g="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function D({buffer:I},O=!0,M=!1){const W=M?S:g;let F="";const T=I.byteLength%3;let q=0;for(;q<I.byteLength-T;q+=3){const ue=I[q+0],ee=I[q+1],ce=I[q+2];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[(ee<<2|ce>>>6)&63],F+=W[ce&63]}if(T===1){const ue=I[q+0];F+=W[ue>>>2],F+=W[ue<<4&63],O&&(F+="==")}else if(T===2){const ue=I[q+0],ee=I[q+1];F+=W[ue>>>2],F+=W[(ue<<4|ee>>>4)&63],F+=W[ee<<2&63],O&&(F+="=")}return F}}),define(re[25],oe([0,1,143,62]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7f=e.$6f=e.$5f=e.GraphemeBreakType=e.$Uf=e.$Nf=e.$Gf=e.$Ff=void 0,e.$7e=E,e.$8e=j,e.$9e=h,e.$0e=l,e.$$e=d,e.$_e=b,e.$af=v,e.$bf=m,e.$cf=f,e.$df=y,e.$ef=p,e.$ff=$,e.$gf=c,e.$hf=w,e.$if=P,e.$jf=a,e.$kf=t,e.$lf=r,e.$mf=s,e.$nf=i,e.$of=o,e.$pf=u,e.$qf=g,e.$rf=S,e.$sf=D,e.$tf=I,e.$uf=O,e.$vf=M,e.$wf=W,e.$xf=F,e.$yf=T,e.$zf=q,e.$Af=ue,e.$Bf=ee,e.$Cf=ce,e.$Df=K,e.$Ef=Q,e.$Hf=U,e.$If=ae,e.$Jf=G,e.$Kf=le,e.$Lf=N,e.$Mf=ne,e.$Of=J,e.$Pf=V,e.$Qf=x,e.$Rf=H,e.$Sf=he,e.$Tf=me,e.$Vf=$e,e.$Wf=ye,e.$Xf=Pe,e.$Yf=ke,e.$Zf=Oe,e.$1f=we,e.$2f=Z,e.$3f=fe,e.$4f=Le;function E(te){return!te||typeof te!="string"?!0:te.trim().length===0}const R=/{(\d+)}/g;function j(te,...de){return de.length===0?te:te.replace(R,function(pe,ve){const Se=parseInt(ve,10);return isNaN(Se)||Se<0||Se>=de.length?pe:de[Se]})}const k=/{([^}]+)}/g;function h(te,de){return Object.keys(de).length===0?te:te.replace(k,(pe,ve)=>de[ve]??pe)}function l(te){return te.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}function d(te){return te.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}function b(te){return te.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function v(te,de){let pe=0;const ve=de.charCodeAt(0);for(let Se=te.length-1;Se>=0;Se--)te.charCodeAt(Se)===ve&&pe++;return pe}function m(te,de,pe="\u2026"){return te.length<=de?te:`${te.substr(0,de)}${pe}`}function f(te,de,pe="\u2026"){if(te.length<=de)return te;const ve=Math.ceil(de/2)-pe.length/2,Se=Math.floor(de/2)-pe.length/2;return`${te.substr(0,ve)}${pe}${te.substr(te.length-Se)}`}function y(te,de=" "){const pe=p(te,de);return $(pe,de)}function p(te,de){if(!te||!de)return te;const pe=de.length;if(pe===0||te.length===0)return te;let ve=0;for(;te.indexOf(de,ve)===ve;)ve=ve+pe;return te.substring(ve)}function $(te,de){if(!te||!de)return te;const pe=de.length,ve=te.length;if(pe===0||ve===0)return te;let Se=ve,Me=-1;for(;Me=te.lastIndexOf(de,Se-1),!(Me===-1||Me+pe!==Se);){if(Me===0)return"";Se=Me}return te.substring(0,Se)}function c(te){return te.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function w(te){return te.replace(/\*/g,"")}function P(te,de,pe={}){if(!te)throw new Error("Cannot create regex from empty string");de||(te=b(te)),pe.wholeWord&&(/\B/.test(te.charAt(0))||(te="\\b"+te),/\B/.test(te.charAt(te.length-1))||(te=te+"\\b"));let ve="";return pe.global&&(ve+="g"),pe.matchCase||(ve+="i"),pe.multiline&&(ve+="m"),pe.unicode&&(ve+="u"),new RegExp(te,ve)}function a(te){return te.source==="^"||te.source==="^$"||te.source==="$"||te.source==="^\\s*$"?!1:!!(te.exec("")&&te.lastIndex===0)}function t(te){return te.split(/\r\n|\r|\n/)}function r(te){const de=[],pe=te.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil(pe.length/2);ve++)de.push(pe[2*ve]+(pe[2*ve+1]??""));return de}function s(te){for(let de=0,pe=te.length;de<pe;de++){const ve=te.charCodeAt(de);if(ve!==32&&ve!==9)return de}return-1}function i(te,de=0,pe=te.length){for(let ve=de;ve<pe;ve++){const Se=te.charCodeAt(ve);if(Se!==32&&Se!==9)return te.substring(de,ve)}return te.substring(de,pe)}function o(te,de=te.length-1){for(let pe=de;pe>=0;pe--){const ve=te.charCodeAt(pe);if(ve!==32&&ve!==9)return pe}return-1}function u(te,de,pe){const ve=[];let Se=0;for(const Me of te.matchAll(de)){if(ve.push(te.slice(Se,Me.index)),Me.index===void 0)throw new Error("match.index should be defined");Se=Me.index+Me[0].length,ve.push(pe(Me[0],...Me.slice(1),Me.index,te,Me.groups))}return ve.push(te.slice(Se)),Promise.all(ve).then(Me=>Me.join(""))}function g(te,de){return te<de?-1:te>de?1:0}function S(te,de,pe=0,ve=te.length,Se=0,Me=de.length){for(;pe<ve&&Se<Me;pe++,Se++){const Ze=te.charCodeAt(pe),Ye=de.charCodeAt(Se);if(Ze<Ye)return-1;if(Ze>Ye)return 1}const ze=ve-pe,Qe=Me-Se;return ze<Qe?-1:ze>Qe?1:0}function D(te,de){return I(te,de,0,te.length,0,de.length)}function I(te,de,pe=0,ve=te.length,Se=0,Me=de.length){for(;pe<ve&&Se<Me;pe++,Se++){let Ze=te.charCodeAt(pe),Ye=de.charCodeAt(Se);if(Ze===Ye)continue;if(Ze>=128||Ye>=128)return S(te.toLowerCase(),de.toLowerCase(),pe,ve,Se,Me);M(Ze)&&(Ze-=32),M(Ye)&&(Ye-=32);const Ke=Ze-Ye;if(Ke!==0)return Ke}const ze=ve-pe,Qe=Me-Se;return ze<Qe?-1:ze>Qe?1:0}function O(te){return te>=48&&te<=57}function M(te){return te>=97&&te<=122}function W(te){return te>=65&&te<=90}function F(te,de){return te.length===de.length&&I(te,de)===0}function T(te,de){const pe=de.length;return de.length>te.length?!1:I(te,de,0,pe)===0}function q(te,de){const pe=Math.min(te.length,de.length);let ve;for(ve=0;ve<pe;ve++)if(te.charCodeAt(ve)!==de.charCodeAt(ve))return ve;return pe}function ue(te,de){const pe=Math.min(te.length,de.length);let ve;const Se=te.length-1,Me=de.length-1;for(ve=0;ve<pe;ve++)if(te.charCodeAt(Se-ve)!==de.charCodeAt(Me-ve))return ve;return pe}function ee(te){return 55296<=te&&te<=56319}function ce(te){return 56320<=te&&te<=57343}function K(te,de){return(te-55296<<10)+(de-56320)+65536}function Q(te,de,pe){const ve=te.charCodeAt(pe);if(ee(ve)&&pe+1<de){const Se=te.charCodeAt(pe+1);if(ce(Se))return K(ve,Se)}return ve}function B(te,de){const pe=te.charCodeAt(de-1);if(ce(pe)&&de>1){const ve=te.charCodeAt(de-2);if(ee(ve))return K(ve,pe)}return pe}class L{get offset(){return this.e}constructor(de,pe=0){this.c=de,this.d=de.length,this.e=pe}setOffset(de){this.e=de}prevCodePoint(){const de=B(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=Q(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$Ff=L;class z{get offset(){return this.c.offset}constructor(de,pe=0){this.c=new L(de,pe)}nextGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Se=de.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.nextCodePoint());if(ge(Se,ze)){pe.setOffset(Me);break}Se=ze}return pe.offset-ve}prevGraphemeLength(){const de=Re.getInstance(),pe=this.c,ve=pe.offset;let Se=de.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Me=pe.offset,ze=de.getGraphemeBreakType(pe.prevCodePoint());if(ge(ze,Se)){pe.setOffset(Me);break}Se=ze}return ve-pe.offset}eol(){return this.c.eol()}}e.$Gf=z;function U(te,de){return new z(te,de).nextGraphemeLength()}function ae(te,de){return new z(te,de).prevGraphemeLength()}function G(te,de){de>0&&ce(te.charCodeAt(de))&&de--;const pe=de+U(te,de);return[pe-ae(te,pe),pe]}function le(te){const de=new z(te);let pe=0;for(;!de.eol();)pe++,de.nextGraphemeLength();return pe}let Y;function A(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function N(te){return Y||(Y=A()),Y.test(te)}const _=/^[\t\n\r\x20-\x7E]*$/;function ne(te){return _.test(te)}e.$Nf=/[\u2028\u2029]/;function J(te){return e.$Nf.test(te)}function V(te){return te>=11904&&te<=55215||te>=63744&&te<=64255||te>=65281&&te<=65374}function x(te){return te>=127462&&te<=127487||te===8986||te===8987||te===9200||te===9203||te>=9728&&te<=10175||te===11088||te===11093||te>=127744&&te<=128591||te>=128640&&te<=128764||te>=128992&&te<=129008||te>=129280&&te<=129535||te>=129648&&te<=129782}function H(te,de,pe=""){const ve=te.trimStart();if(ve.length<de)return ve;const Se=/\b/g;let Me=0;for(;Se.test(ve)&&!(ve.length-Se.lastIndex<de);)Me=Se.lastIndex,Se.lastIndex+=1;return Me===0?ve:pe+ve.substring(Me).trimStart()}const se=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*he(te){let de=0;for(const pe of te.matchAll(se))de!==pe.index&&(yield{isCode:!1,str:te.substring(de,pe.index)}),yield{isCode:!0,str:pe[0]},de=pe.index+pe[0].length;de!==te.length&&(yield{isCode:!1,str:te.substring(de)})}function me(te){return te&&(te=te.replace(se,"")),te}e.$Uf="\uFEFF";function $e(te){return!!(te&&te.length>0&&te.charCodeAt(0)===65279)}function ye(te){return $e(te)?te.substr(1):te}function Pe(te,de){if(!te||!de||te.length<de.length)return!1;const pe=de.length,ve=te.toLowerCase();let Se=0,Me=-1;for(;Se<pe;){const ze=ve.indexOf(de[Se],Me+1);if(ze<0)return!1;Me=ze,Se++}return!0}function ke(te,de=!1){return te?(de&&(te=te.replace(/\\./g,"")),te.toLowerCase()!==te):!1}function Oe(te){return te.charAt(0).toUpperCase()+te.slice(1)}function we(te,de=1){if(de===0)return"";let pe=-1;do pe=te.indexOf(`
`,pe+1),de--;while(de>0&&pe>=0);return pe===-1?te:(te[pe-1]==="\r"&&pe--,te.substr(0,pe))}function Z(te){return te=te%(2*26),te<26?String.fromCharCode(97+te):String.fromCharCode(65+te-26)}function fe(te){return Re.getInstance().getGraphemeBreakType(te)}function ge(te,de){return te===0?de!==5&&de!==7:te===2&&de===3?!1:te===4||te===2||te===3||de===4||de===2||de===3?!0:!(te===8&&(de===8||de===9||de===11||de===12)||(te===11||te===9)&&(de===9||de===10)||(te===12||te===10)&&de===10||de===5||de===13||de===7||te===1||te===13&&de===14||te===6&&de===6)}var je;(function(te){te[te.Other=0]="Other",te[te.Prepend=1]="Prepend",te[te.CR=2]="CR",te[te.LF=3]="LF",te[te.Control=4]="Control",te[te.Extend=5]="Extend",te[te.Regional_Indicator=6]="Regional_Indicator",te[te.SpacingMark=7]="SpacingMark",te[te.L=8]="L",te[te.V=9]="V",te[te.T=10]="T",te[te.LV=11]="LV",te[te.LVT=12]="LVT",te[te.ZWJ=13]="ZWJ",te[te.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class Re{static{this.c=null}static getInstance(){return Re.c||(Re.c=new Re),Re.c}constructor(){this.d=Be()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const pe=this.d,ve=pe.length/3;let Se=1;for(;Se<=ve;)if(de<pe[3*Se])Se=2*Se;else if(de>pe[3*Se+1])Se=2*Se+1;else return pe[3*Se+2];return 0}}function Be(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(te,de){if(te===0)return 0;const pe=Fe(te,de);if(pe!==void 0)return pe;const ve=new L(de,te);return ve.prevCodePoint(),ve.offset}function Fe(te,de){const pe=new L(de,te);let ve=pe.prevCodePoint();for(;Ue(ve)||ve===65039||ve===8419;){if(pe.offset===0)return;ve=pe.prevCodePoint()}if(!x(ve))return;let Se=pe.offset;return Se>0&&pe.prevCodePoint()===8205&&(Se=pe.offset),Se}function Ue(te){return 127995<=te&&te<=127999}var Ve;(function(te){te[te.zwj=8205]="zwj",te[te.emojiVariantSelector=65039]="emojiVariantSelector",te[te.enclosingKeyCap=8419]="enclosingKeyCap"})(Ve||(Ve={})),e.$5f="\xA0";class Je{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$3e({getCacheKey:JSON.stringify},de=>{function pe(Ke){const st=new Map;for(let it=0;it<Ke.length;it+=2)st.set(Ke[it],Ke[it+1]);return st}function ve(Ke,st){const it=new Map(Ke);for(const[ot,at]of st)it.set(ot,at);return it}function Se(Ke,st){if(!Ke)return st;const it=new Map;for(const[ot,at]of Ke)st.has(ot)&&it.set(ot,at);return it}const Me=this.c.value;let ze=de.filter(Ke=>!Ke.startsWith("_")&&Ke in Me);ze.length===0&&(ze=["_default"]);let Qe;for(const Ke of ze){const st=pe(Me[Ke]);Qe=Se(Qe,st)}const Ze=pe(Me._common),Ye=ve(Ze,Qe);return new Je(Ye)})}static getInstance(de){return Je.d.get(Array.from(de))}static{this.e=new C.$V(()=>Object.keys(Je.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Je.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$6f=Je;class Te{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Te.c())),this.d}static isInvisibleCharacter(de){return Te.e().has(de)}static get codePoints(){return Te.e()}}e.$7f=Te}),define(re[46],oe([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pj=e.$nj=void 0,e.$jj=C,e.$kj=E,e.$lj=R,e.$mj=k,e.$oj=y;function C($){return E($,0)}function E($,c){switch(typeof $){case"object":return $===null?R(349,c):Array.isArray($)?h($,c):l($,c);case"string":return k($,c);case"boolean":return j($,c);case"number":return R($,c);case"undefined":return R(937,c);default:return R(617,c)}}function R($,c){return(c<<5)-c+$|0}function j($,c){return R($?433:863,c)}function k($,c){c=R(149417,c);for(let w=0,P=$.length;w<P;w++)c=R($.charCodeAt(w),c);return c}function h($,c){return c=R(104579,c),$.reduce((w,P)=>E(P,w),c)}function l($,c){return c=R(181387,c),Object.keys($).sort().reduce((w,P)=>(w=k(P,w),E($[P],w)),c)}class d{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=E(c,this.g),this.g}}e.$nj=d;var b;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v($,c,w=32){const P=w-c,a=~((1<<P)-1);return($<<c|(a&$)>>>P)>>>0}function m($,c=0,w=$.byteLength,P=0){for(let a=0;a<w;a++)$[c+a]=P}function f($,c,w="0"){for(;$.length<c;)$=w+$;return $}function y($,c=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(w=>w.toString(16).padStart(2,"0")).join(""):f(($>>>0).toString(16),c/4)}class p{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const w=c.length;if(w===0)return;const P=this.p;let a=this.r,t=this.u,r,s;for(t!==0?(r=t,s=-1,t=0):(r=c.charCodeAt(0),s=0);;){let i=r;if(n.$Bf(r))if(s+1<w){const o=c.charCodeAt(s+1);n.$Cf(o)?(s++,i=n.$Df(r,o)):i=65533}else{t=r;break}else n.$Cf(r)&&(i=65533);if(a=this.w(P,a,i),s++,s<w)r=c.charCodeAt(s);else break}this.r=a,this.u=t}w(c,w,P){return P<128?c[w++]=P:P<2048?(c[w++]=192|(P&1984)>>>6,c[w++]=128|(P&63)>>>0):P<65536?(c[w++]=224|(P&61440)>>>12,c[w++]=128|(P&4032)>>>6,c[w++]=128|(P&63)>>>0):(c[w++]=240|(P&1835008)>>>18,c[w++]=128|(P&258048)>>>12,c[w++]=128|(P&4032)>>>6,c[w++]=128|(P&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,c[0]=c[64],c[1]=c[65],c[2]=c[66]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),y(this.h)+y(this.l)+y(this.m)+y(this.n)+y(this.o)}x(){this.p[this.r++]=128,m(this.p,this.r),this.r>56&&(this.y(),m(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=p.g,w=this.q;for(let g=0;g<64;g+=4)c.setUint32(g,w.getUint32(g,!1),!1);for(let g=64;g<320;g+=4)c.setUint32(g,v(c.getUint32(g-12,!1)^c.getUint32(g-32,!1)^c.getUint32(g-56,!1)^c.getUint32(g-64,!1),1),!1);let P=this.h,a=this.l,t=this.m,r=this.n,s=this.o,i,o,u;for(let g=0;g<80;g++)g<20?(i=a&t|~a&r,o=1518500249):g<40?(i=a^t^r,o=1859775393):g<60?(i=a&t|a&r|t&r,o=2400959708):(i=a^t^r,o=3395469782),u=v(P,5)+i+s+o+c.getUint32(g*4,!1)&4294967295,s=r,r=t,t=v(a,30),a=P,P=u;this.h=this.h+P&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+s&4294967295}}e.$pj=p}),define(re[74],oe([0,1,25]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var C;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(C||(C={})),function(E){const R="error",j="warning",k="warn",h="info",l="ignore";function d(v){return v?n.$xf(R,v)?E.Error:n.$xf(j,v)||n.$xf(k,v)?E.Warning:n.$xf(h,v)?E.Info:E.Ignore:E.Ignore}E.fromValue=d;function b(v){switch(v){case E.Error:return R;case E.Warning:return j;case E.Info:return h;default:return l}}E.toString=b}(C||(C={})),e.default=C}),define(re[144],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(re[59],oe([0,1,22,25]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class E{constructor(){this.b="",this.c=0}reset(m){return this.b=m,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(m){const f=m.charCodeAt(0),y=this.b.charCodeAt(this.c);return f-y}value(){return this.b[this.c]}}e.$xi=E;class R{constructor(m=!0){this.e=m}reset(m){return this.b=m,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let m=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(m)this.c++;else break;else m=!1;return this}cmp(m){return this.e?(0,C.$rf)(m,this.b,0,m.length,this.c,this.d):(0,C.$tf)(m,this.b,0,m.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$yi=R;class j{constructor(m=!0,f=!0){this.f=m,this.g=f}reset(m){this.d=0,this.e=0,this.b=m,this.c=m.length;for(let f=m.length-1;f>=0;f--,this.c--){const y=this.b.charCodeAt(f);if(!(y===47||this.f&&y===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let m=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(m)this.d++;else break;else m=!1}return this}cmp(m){return this.g?(0,C.$rf)(m,this.b,0,m.length,this.d,this.e):(0,C.$tf)(m,this.b,0,m.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$zi=j;var k;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(k||(k={}));class h{constructor(m,f){this.f=m,this.g=f,this.d=[],this.e=0}reset(m){return this.c=m,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new j(!1,!this.f(m)),this.b.reset(m.path),this.b.value()&&this.d.push(3)),this.g(m)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(m){if(this.d[this.e]===1)return(0,C.$sf)(m,this.c.scheme);if(this.d[this.e]===2)return(0,C.$sf)(m,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(m);if(this.d[this.e]===4)return(0,C.$qf)(m,this.c.query);if(this.d[this.e]===5)return(0,C.$qf)(m,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Ai=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const m=this.right;return this.right=m.left,m.left=this,this.updateHeight(),m.updateHeight(),m}rotateRight(){const m=this.left;return this.left=m.right,m.right=this,this.updateHeight(),m.updateHeight(),m}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(d||(d={}));class b{static forUris(m=()=>!1,f=()=>!1){return new b(new h(m,f))}static forPaths(m=!1){return new b(new j(void 0,!m))}static forStrings(){return new b(new E)}static forConfigKeys(){return new b(new R)}constructor(m){this.b=m}clear(){this.c=void 0}fill(m,f){if(f){const y=f.slice(0);(0,n.$Xb)(y);for(const p of y)this.set(p,m)}else{const y=m.slice(0);(0,n.$Xb)(y);for(const p of y)this.set(p[0],p[1])}}set(m,f){const y=this.b.reset(m);let p;this.c||(this.c=new l,this.c.segment=y.value());const $=[];for(p=this.c;;){const w=y.cmp(p.segment);if(w>0)p.left||(p.left=new l,p.left.segment=y.value()),$.push([-1,p]),p=p.left;else if(w<0)p.right||(p.right=new l,p.right.segment=y.value()),$.push([1,p]),p=p.right;else if(y.hasNext())y.next(),p.mid||(p.mid=new l,p.mid.segment=y.value()),$.push([0,p]),p=p.mid;else break}const c=p.value;p.value=f,p.key=m;for(let w=$.length-1;w>=0;w--){const P=$[w][1];P.updateHeight();const a=P.balanceFactor();if(a<-1||a>1){const t=$[w][0],r=$[w+1][0];if(t===1&&r===1)$[w][1]=P.rotateLeft();else if(t===-1&&r===-1)$[w][1]=P.rotateRight();else if(t===1&&r===-1)P.right=$[w+1][1]=$[w+1][1].rotateRight(),$[w][1]=P.rotateLeft();else if(t===-1&&r===1)P.left=$[w+1][1]=$[w+1][1].rotateLeft(),$[w][1]=P.rotateRight();else throw new Error;if(w>0)switch($[w-1][0]){case-1:$[w-1][1].left=$[w][1];break;case 1:$[w-1][1].right=$[w][1];break;case 0:$[w-1][1].mid=$[w][1];break}else this.c=$[0][1]}}return c}get(m){return this.d(m)?.value}d(m){const f=this.b.reset(m);let y=this.c;for(;y;){const p=f.cmp(y.segment);if(p>0)y=y.left;else if(p<0)y=y.right;else if(f.hasNext())f.next(),y=y.mid;else break}return y}has(m){const f=this.d(m);return!(f?.value===void 0&&f?.mid===void 0)}delete(m){return this.e(m,!1)}deleteSuperstr(m){return this.e(m,!0)}e(m,f){const y=this.b.reset(m),p=[];let $=this.c;for(;$;){const c=y.cmp($.segment);if(c>0)p.push([-1,$]),$=$.left;else if(c<0)p.push([1,$]),$=$.right;else if(y.hasNext())y.next(),p.push([0,$]),$=$.mid;else break}if($){if(f?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const c=this.f($.right);if(c.key){const{key:w,value:P,segment:a}=c;this.e(c.key,!1),$.key=w,$.value=P,$.segment=a}}else{const c=$.left??$.right;if(p.length>0){const[w,P]=p[p.length-1];switch(w){case-1:P.left=c;break;case 0:P.mid=c;break;case 1:P.right=c;break}}else this.c=c}for(let c=p.length-1;c>=0;c--){const w=p[c][1];w.updateHeight();const P=w.balanceFactor();if(P>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),p[c][1]=w.rotateLeft()):P<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),p[c][1]=w.rotateRight()),c>0)switch(p[c-1][0]){case-1:p[c-1][1].left=p[c][1];break;case 1:p[c-1][1].right=p[c][1];break;case 0:p[c-1][1].mid=p[c][1];break}else this.c=p[0][1]}}}f(m){for(;m.left;)m=m.left;return m}findSubstr(m){const f=this.b.reset(m);let y=this.c,p;for(;y;){const $=f.cmp(y.segment);if($>0)y=y.left;else if($<0)y=y.right;else if(f.hasNext())f.next(),p=y.value||p,y=y.mid;else break}return y&&y.value||p}findSuperstr(m){return this.g(m,!1)}g(m,f){const y=this.b.reset(m);let p=this.c;for(;p;){const $=y.cmp(p.segment);if($>0)p=p.left;else if($<0)p=p.right;else if(y.hasNext())y.next(),p=p.mid;else return p.mid?this.h(p.mid):f?p.value:void 0}}hasElementOrSubtree(m){return this.g(m,!0)!==void 0}forEach(m){for(const[f,y]of this)m(y,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(m){const f=[];return this.j(m,f),f[Symbol.iterator]()}j(m,f){m&&(m.left&&this.j(m.left,f),m.value&&f.push([m.key,m.value]),m.mid&&this.j(m.mid,f),m.right&&this.j(m.right,f))}_isBalanced(){const m=f=>{if(!f)return!0;const y=f.balanceFactor();return y<-1||y>1?!1:m(f.left)&&m(f.right)};return m(this.c)}}e.$Bi=b}),define(re[12],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8f=n,e.$9f=C,e.$0f=E,e.$$f=R,e.$_f=j,e.$ag=k,e.$bg=h,e.$cg=l,e.$dg=d,e.$eg=b,e.$fg=v,e.$gg=m,e.$hg=f,e.$ig=p,e.$jg=$,e.$kg=c,e.$lg=w,e.$mg=P;function n(a){return typeof a=="string"}function C(a){return Array.isArray(a)&&a.every(t=>n(t))}function E(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}function R(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}function j(a){return typeof a=="number"&&!isNaN(a)}function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}function h(a){return a===!0||a===!1}function l(a){return typeof a>"u"}function d(a){return!b(a)}function b(a){return l(a)||a===null}function v(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}function m(a){if(b(a))throw new Error("Assertion Failed: argument is undefined or null");return a}function f(...a){const t=[];for(let r=0;r<a.length;r++){const s=a[r];if(b(s))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);t.push(s)}return t}const y=Object.prototype.hasOwnProperty;function p(a){if(!E(a))return!1;for(const t in a)if(y.call(a,t))return!1;return!0}function $(a){return typeof a=="function"}function c(...a){return a.length>0&&a.every($)}function w(a,t){const r=Math.min(a.length,t.length);for(let s=0;s<r;s++)P(a[s],t[s])}function P(a,t){if(n(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(a instanceof t)return}catch{}if(!b(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(re[105],oe([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pj=E,e.$Qj=R;const C=Object.create(null);function E(j,k){if((0,n.$8f)(k)){const h=C[k];if(h===void 0)throw new Error(`${j} references an unknown codicon: ${k}`);k=h}return C[j]=k,{id:j}}function R(){return C}}),define(re[145],oe([0,1,105]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0,e.$Rj={add:(0,n.$Pj)("add",6e4),plus:(0,n.$Pj)("plus",6e4),gistNew:(0,n.$Pj)("gist-new",6e4),repoCreate:(0,n.$Pj)("repo-create",6e4),lightbulb:(0,n.$Pj)("lightbulb",60001),lightBulb:(0,n.$Pj)("light-bulb",60001),repo:(0,n.$Pj)("repo",60002),repoDelete:(0,n.$Pj)("repo-delete",60002),gistFork:(0,n.$Pj)("gist-fork",60003),repoForked:(0,n.$Pj)("repo-forked",60003),gitPullRequest:(0,n.$Pj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Pj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Pj)("record-keys",60005),keyboard:(0,n.$Pj)("keyboard",60005),tag:(0,n.$Pj)("tag",60006),gitPullRequestLabel:(0,n.$Pj)("git-pull-request-label",60006),tagAdd:(0,n.$Pj)("tag-add",60006),tagRemove:(0,n.$Pj)("tag-remove",60006),person:(0,n.$Pj)("person",60007),personFollow:(0,n.$Pj)("person-follow",60007),personOutline:(0,n.$Pj)("person-outline",60007),personFilled:(0,n.$Pj)("person-filled",60007),gitBranch:(0,n.$Pj)("git-branch",60008),gitBranchCreate:(0,n.$Pj)("git-branch-create",60008),gitBranchDelete:(0,n.$Pj)("git-branch-delete",60008),sourceControl:(0,n.$Pj)("source-control",60008),mirror:(0,n.$Pj)("mirror",60009),mirrorPublic:(0,n.$Pj)("mirror-public",60009),star:(0,n.$Pj)("star",60010),starAdd:(0,n.$Pj)("star-add",60010),starDelete:(0,n.$Pj)("star-delete",60010),starEmpty:(0,n.$Pj)("star-empty",60010),comment:(0,n.$Pj)("comment",60011),commentAdd:(0,n.$Pj)("comment-add",60011),alert:(0,n.$Pj)("alert",60012),warning:(0,n.$Pj)("warning",60012),search:(0,n.$Pj)("search",60013),searchSave:(0,n.$Pj)("search-save",60013),logOut:(0,n.$Pj)("log-out",60014),signOut:(0,n.$Pj)("sign-out",60014),logIn:(0,n.$Pj)("log-in",60015),signIn:(0,n.$Pj)("sign-in",60015),eye:(0,n.$Pj)("eye",60016),eyeUnwatch:(0,n.$Pj)("eye-unwatch",60016),eyeWatch:(0,n.$Pj)("eye-watch",60016),circleFilled:(0,n.$Pj)("circle-filled",60017),primitiveDot:(0,n.$Pj)("primitive-dot",60017),closeDirty:(0,n.$Pj)("close-dirty",60017),debugBreakpoint:(0,n.$Pj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Pj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Pj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Pj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Pj)("primitive-square",60018),edit:(0,n.$Pj)("edit",60019),pencil:(0,n.$Pj)("pencil",60019),info:(0,n.$Pj)("info",60020),issueOpened:(0,n.$Pj)("issue-opened",60020),gistPrivate:(0,n.$Pj)("gist-private",60021),gitForkPrivate:(0,n.$Pj)("git-fork-private",60021),lock:(0,n.$Pj)("lock",60021),mirrorPrivate:(0,n.$Pj)("mirror-private",60021),close:(0,n.$Pj)("close",60022),removeClose:(0,n.$Pj)("remove-close",60022),x:(0,n.$Pj)("x",60022),repoSync:(0,n.$Pj)("repo-sync",60023),sync:(0,n.$Pj)("sync",60023),clone:(0,n.$Pj)("clone",60024),desktopDownload:(0,n.$Pj)("desktop-download",60024),beaker:(0,n.$Pj)("beaker",60025),microscope:(0,n.$Pj)("microscope",60025),vm:(0,n.$Pj)("vm",60026),deviceDesktop:(0,n.$Pj)("device-desktop",60026),file:(0,n.$Pj)("file",60027),fileText:(0,n.$Pj)("file-text",60027),more:(0,n.$Pj)("more",60028),ellipsis:(0,n.$Pj)("ellipsis",60028),kebabHorizontal:(0,n.$Pj)("kebab-horizontal",60028),mailReply:(0,n.$Pj)("mail-reply",60029),reply:(0,n.$Pj)("reply",60029),organization:(0,n.$Pj)("organization",60030),organizationFilled:(0,n.$Pj)("organization-filled",60030),organizationOutline:(0,n.$Pj)("organization-outline",60030),newFile:(0,n.$Pj)("new-file",60031),fileAdd:(0,n.$Pj)("file-add",60031),newFolder:(0,n.$Pj)("new-folder",60032),fileDirectoryCreate:(0,n.$Pj)("file-directory-create",60032),trash:(0,n.$Pj)("trash",60033),trashcan:(0,n.$Pj)("trashcan",60033),history:(0,n.$Pj)("history",60034),clock:(0,n.$Pj)("clock",60034),folder:(0,n.$Pj)("folder",60035),fileDirectory:(0,n.$Pj)("file-directory",60035),symbolFolder:(0,n.$Pj)("symbol-folder",60035),logoGithub:(0,n.$Pj)("logo-github",60036),markGithub:(0,n.$Pj)("mark-github",60036),github:(0,n.$Pj)("github",60036),terminal:(0,n.$Pj)("terminal",60037),console:(0,n.$Pj)("console",60037),repl:(0,n.$Pj)("repl",60037),zap:(0,n.$Pj)("zap",60038),symbolEvent:(0,n.$Pj)("symbol-event",60038),error:(0,n.$Pj)("error",60039),stop:(0,n.$Pj)("stop",60039),variable:(0,n.$Pj)("variable",60040),symbolVariable:(0,n.$Pj)("symbol-variable",60040),array:(0,n.$Pj)("array",60042),symbolArray:(0,n.$Pj)("symbol-array",60042),symbolModule:(0,n.$Pj)("symbol-module",60043),symbolPackage:(0,n.$Pj)("symbol-package",60043),symbolNamespace:(0,n.$Pj)("symbol-namespace",60043),symbolObject:(0,n.$Pj)("symbol-object",60043),symbolMethod:(0,n.$Pj)("symbol-method",60044),symbolFunction:(0,n.$Pj)("symbol-function",60044),symbolConstructor:(0,n.$Pj)("symbol-constructor",60044),symbolBoolean:(0,n.$Pj)("symbol-boolean",60047),symbolNull:(0,n.$Pj)("symbol-null",60047),symbolNumeric:(0,n.$Pj)("symbol-numeric",60048),symbolNumber:(0,n.$Pj)("symbol-number",60048),symbolStructure:(0,n.$Pj)("symbol-structure",60049),symbolStruct:(0,n.$Pj)("symbol-struct",60049),symbolParameter:(0,n.$Pj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Pj)("symbol-type-parameter",60050),symbolKey:(0,n.$Pj)("symbol-key",60051),symbolText:(0,n.$Pj)("symbol-text",60051),symbolReference:(0,n.$Pj)("symbol-reference",60052),goToFile:(0,n.$Pj)("go-to-file",60052),symbolEnum:(0,n.$Pj)("symbol-enum",60053),symbolValue:(0,n.$Pj)("symbol-value",60053),symbolRuler:(0,n.$Pj)("symbol-ruler",60054),symbolUnit:(0,n.$Pj)("symbol-unit",60054),activateBreakpoints:(0,n.$Pj)("activate-breakpoints",60055),archive:(0,n.$Pj)("archive",60056),arrowBoth:(0,n.$Pj)("arrow-both",60057),arrowDown:(0,n.$Pj)("arrow-down",60058),arrowLeft:(0,n.$Pj)("arrow-left",60059),arrowRight:(0,n.$Pj)("arrow-right",60060),arrowSmallDown:(0,n.$Pj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Pj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Pj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Pj)("arrow-small-up",60064),arrowUp:(0,n.$Pj)("arrow-up",60065),bell:(0,n.$Pj)("bell",60066),bold:(0,n.$Pj)("bold",60067),book:(0,n.$Pj)("book",60068),bookmark:(0,n.$Pj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Pj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Pj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Pj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Pj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Pj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Pj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Pj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Pj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Pj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Pj)("briefcase",60076),broadcast:(0,n.$Pj)("broadcast",60077),browser:(0,n.$Pj)("browser",60078),bug:(0,n.$Pj)("bug",60079),calendar:(0,n.$Pj)("calendar",60080),caseSensitive:(0,n.$Pj)("case-sensitive",60081),check:(0,n.$Pj)("check",60082),checklist:(0,n.$Pj)("checklist",60083),chevronDown:(0,n.$Pj)("chevron-down",60084),chevronLeft:(0,n.$Pj)("chevron-left",60085),chevronRight:(0,n.$Pj)("chevron-right",60086),chevronUp:(0,n.$Pj)("chevron-up",60087),chromeClose:(0,n.$Pj)("chrome-close",60088),chromeMaximize:(0,n.$Pj)("chrome-maximize",60089),chromeMinimize:(0,n.$Pj)("chrome-minimize",60090),chromeRestore:(0,n.$Pj)("chrome-restore",60091),circleOutline:(0,n.$Pj)("circle-outline",60092),circle:(0,n.$Pj)("circle",60092),debugBreakpointUnverified:(0,n.$Pj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Pj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Pj)("circle-slash",60093),circuitBoard:(0,n.$Pj)("circuit-board",60094),clearAll:(0,n.$Pj)("clear-all",60095),clippy:(0,n.$Pj)("clippy",60096),closeAll:(0,n.$Pj)("close-all",60097),cloudDownload:(0,n.$Pj)("cloud-download",60098),cloudUpload:(0,n.$Pj)("cloud-upload",60099),code:(0,n.$Pj)("code",60100),collapseAll:(0,n.$Pj)("collapse-all",60101),colorMode:(0,n.$Pj)("color-mode",60102),commentDiscussion:(0,n.$Pj)("comment-discussion",60103),creditCard:(0,n.$Pj)("credit-card",60105),dash:(0,n.$Pj)("dash",60108),dashboard:(0,n.$Pj)("dashboard",60109),database:(0,n.$Pj)("database",60110),debugContinue:(0,n.$Pj)("debug-continue",60111),debugDisconnect:(0,n.$Pj)("debug-disconnect",60112),debugPause:(0,n.$Pj)("debug-pause",60113),debugRestart:(0,n.$Pj)("debug-restart",60114),debugStart:(0,n.$Pj)("debug-start",60115),debugStepInto:(0,n.$Pj)("debug-step-into",60116),debugStepOut:(0,n.$Pj)("debug-step-out",60117),debugStepOver:(0,n.$Pj)("debug-step-over",60118),debugStop:(0,n.$Pj)("debug-stop",60119),debug:(0,n.$Pj)("debug",60120),deviceCameraVideo:(0,n.$Pj)("device-camera-video",60121),deviceCamera:(0,n.$Pj)("device-camera",60122),deviceMobile:(0,n.$Pj)("device-mobile",60123),diffAdded:(0,n.$Pj)("diff-added",60124),diffIgnored:(0,n.$Pj)("diff-ignored",60125),diffModified:(0,n.$Pj)("diff-modified",60126),diffRemoved:(0,n.$Pj)("diff-removed",60127),diffRenamed:(0,n.$Pj)("diff-renamed",60128),diff:(0,n.$Pj)("diff",60129),diffSidebyside:(0,n.$Pj)("diff-sidebyside",60129),discard:(0,n.$Pj)("discard",60130),editorLayout:(0,n.$Pj)("editor-layout",60131),emptyWindow:(0,n.$Pj)("empty-window",60132),exclude:(0,n.$Pj)("exclude",60133),extensions:(0,n.$Pj)("extensions",60134),eyeClosed:(0,n.$Pj)("eye-closed",60135),fileBinary:(0,n.$Pj)("file-binary",60136),fileCode:(0,n.$Pj)("file-code",60137),fileMedia:(0,n.$Pj)("file-media",60138),filePdf:(0,n.$Pj)("file-pdf",60139),fileSubmodule:(0,n.$Pj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Pj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Pj)("file-symlink-file",60142),fileZip:(0,n.$Pj)("file-zip",60143),files:(0,n.$Pj)("files",60144),filter:(0,n.$Pj)("filter",60145),flame:(0,n.$Pj)("flame",60146),foldDown:(0,n.$Pj)("fold-down",60147),foldUp:(0,n.$Pj)("fold-up",60148),fold:(0,n.$Pj)("fold",60149),folderActive:(0,n.$Pj)("folder-active",60150),folderOpened:(0,n.$Pj)("folder-opened",60151),gear:(0,n.$Pj)("gear",60152),gift:(0,n.$Pj)("gift",60153),gistSecret:(0,n.$Pj)("gist-secret",60154),gist:(0,n.$Pj)("gist",60155),gitCommit:(0,n.$Pj)("git-commit",60156),gitCompare:(0,n.$Pj)("git-compare",60157),compareChanges:(0,n.$Pj)("compare-changes",60157),gitMerge:(0,n.$Pj)("git-merge",60158),githubAction:(0,n.$Pj)("github-action",60159),githubAlt:(0,n.$Pj)("github-alt",60160),globe:(0,n.$Pj)("globe",60161),grabber:(0,n.$Pj)("grabber",60162),graph:(0,n.$Pj)("graph",60163),gripper:(0,n.$Pj)("gripper",60164),heart:(0,n.$Pj)("heart",60165),home:(0,n.$Pj)("home",60166),horizontalRule:(0,n.$Pj)("horizontal-rule",60167),hubot:(0,n.$Pj)("hubot",60168),inbox:(0,n.$Pj)("inbox",60169),issueReopened:(0,n.$Pj)("issue-reopened",60171),issues:(0,n.$Pj)("issues",60172),italic:(0,n.$Pj)("italic",60173),jersey:(0,n.$Pj)("jersey",60174),json:(0,n.$Pj)("json",60175),kebabVertical:(0,n.$Pj)("kebab-vertical",60176),key:(0,n.$Pj)("key",60177),law:(0,n.$Pj)("law",60178),lightbulbAutofix:(0,n.$Pj)("lightbulb-autofix",60179),linkExternal:(0,n.$Pj)("link-external",60180),link:(0,n.$Pj)("link",60181),listOrdered:(0,n.$Pj)("list-ordered",60182),listUnordered:(0,n.$Pj)("list-unordered",60183),liveShare:(0,n.$Pj)("live-share",60184),loading:(0,n.$Pj)("loading",60185),location:(0,n.$Pj)("location",60186),mailRead:(0,n.$Pj)("mail-read",60187),mail:(0,n.$Pj)("mail",60188),markdown:(0,n.$Pj)("markdown",60189),megaphone:(0,n.$Pj)("megaphone",60190),mention:(0,n.$Pj)("mention",60191),milestone:(0,n.$Pj)("milestone",60192),gitPullRequestMilestone:(0,n.$Pj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Pj)("mortar-board",60193),move:(0,n.$Pj)("move",60194),multipleWindows:(0,n.$Pj)("multiple-windows",60195),mute:(0,n.$Pj)("mute",60196),noNewline:(0,n.$Pj)("no-newline",60197),note:(0,n.$Pj)("note",60198),octoface:(0,n.$Pj)("octoface",60199),openPreview:(0,n.$Pj)("open-preview",60200),package:(0,n.$Pj)("package",60201),paintcan:(0,n.$Pj)("paintcan",60202),pin:(0,n.$Pj)("pin",60203),play:(0,n.$Pj)("play",60204),run:(0,n.$Pj)("run",60204),plug:(0,n.$Pj)("plug",60205),preserveCase:(0,n.$Pj)("preserve-case",60206),preview:(0,n.$Pj)("preview",60207),project:(0,n.$Pj)("project",60208),pulse:(0,n.$Pj)("pulse",60209),question:(0,n.$Pj)("question",60210),quote:(0,n.$Pj)("quote",60211),radioTower:(0,n.$Pj)("radio-tower",60212),reactions:(0,n.$Pj)("reactions",60213),references:(0,n.$Pj)("references",60214),refresh:(0,n.$Pj)("refresh",60215),regex:(0,n.$Pj)("regex",60216),remoteExplorer:(0,n.$Pj)("remote-explorer",60217),remote:(0,n.$Pj)("remote",60218),remove:(0,n.$Pj)("remove",60219),replaceAll:(0,n.$Pj)("replace-all",60220),replace:(0,n.$Pj)("replace",60221),repoClone:(0,n.$Pj)("repo-clone",60222),repoForcePush:(0,n.$Pj)("repo-force-push",60223),repoPull:(0,n.$Pj)("repo-pull",60224),repoPush:(0,n.$Pj)("repo-push",60225),report:(0,n.$Pj)("report",60226),requestChanges:(0,n.$Pj)("request-changes",60227),rocket:(0,n.$Pj)("rocket",60228),rootFolderOpened:(0,n.$Pj)("root-folder-opened",60229),rootFolder:(0,n.$Pj)("root-folder",60230),rss:(0,n.$Pj)("rss",60231),ruby:(0,n.$Pj)("ruby",60232),saveAll:(0,n.$Pj)("save-all",60233),saveAs:(0,n.$Pj)("save-as",60234),save:(0,n.$Pj)("save",60235),screenFull:(0,n.$Pj)("screen-full",60236),screenNormal:(0,n.$Pj)("screen-normal",60237),searchStop:(0,n.$Pj)("search-stop",60238),server:(0,n.$Pj)("server",60240),settingsGear:(0,n.$Pj)("settings-gear",60241),settings:(0,n.$Pj)("settings",60242),shield:(0,n.$Pj)("shield",60243),smiley:(0,n.$Pj)("smiley",60244),sortPrecedence:(0,n.$Pj)("sort-precedence",60245),splitHorizontal:(0,n.$Pj)("split-horizontal",60246),splitVertical:(0,n.$Pj)("split-vertical",60247),squirrel:(0,n.$Pj)("squirrel",60248),starFull:(0,n.$Pj)("star-full",60249),starHalf:(0,n.$Pj)("star-half",60250),symbolClass:(0,n.$Pj)("symbol-class",60251),symbolColor:(0,n.$Pj)("symbol-color",60252),symbolConstant:(0,n.$Pj)("symbol-constant",60253),symbolEnumMember:(0,n.$Pj)("symbol-enum-member",60254),symbolField:(0,n.$Pj)("symbol-field",60255),symbolFile:(0,n.$Pj)("symbol-file",60256),symbolInterface:(0,n.$Pj)("symbol-interface",60257),symbolKeyword:(0,n.$Pj)("symbol-keyword",60258),symbolMisc:(0,n.$Pj)("symbol-misc",60259),symbolOperator:(0,n.$Pj)("symbol-operator",60260),symbolProperty:(0,n.$Pj)("symbol-property",60261),wrench:(0,n.$Pj)("wrench",60261),wrenchSubaction:(0,n.$Pj)("wrench-subaction",60261),symbolSnippet:(0,n.$Pj)("symbol-snippet",60262),tasklist:(0,n.$Pj)("tasklist",60263),telescope:(0,n.$Pj)("telescope",60264),textSize:(0,n.$Pj)("text-size",60265),threeBars:(0,n.$Pj)("three-bars",60266),thumbsdown:(0,n.$Pj)("thumbsdown",60267),thumbsup:(0,n.$Pj)("thumbsup",60268),tools:(0,n.$Pj)("tools",60269),triangleDown:(0,n.$Pj)("triangle-down",60270),triangleLeft:(0,n.$Pj)("triangle-left",60271),triangleRight:(0,n.$Pj)("triangle-right",60272),triangleUp:(0,n.$Pj)("triangle-up",60273),twitter:(0,n.$Pj)("twitter",60274),unfold:(0,n.$Pj)("unfold",60275),unlock:(0,n.$Pj)("unlock",60276),unmute:(0,n.$Pj)("unmute",60277),unverified:(0,n.$Pj)("unverified",60278),verified:(0,n.$Pj)("verified",60279),versions:(0,n.$Pj)("versions",60280),vmActive:(0,n.$Pj)("vm-active",60281),vmOutline:(0,n.$Pj)("vm-outline",60282),vmRunning:(0,n.$Pj)("vm-running",60283),watch:(0,n.$Pj)("watch",60284),whitespace:(0,n.$Pj)("whitespace",60285),wholeWord:(0,n.$Pj)("whole-word",60286),window:(0,n.$Pj)("window",60287),wordWrap:(0,n.$Pj)("word-wrap",60288),zoomIn:(0,n.$Pj)("zoom-in",60289),zoomOut:(0,n.$Pj)("zoom-out",60290),listFilter:(0,n.$Pj)("list-filter",60291),listFlat:(0,n.$Pj)("list-flat",60292),listSelection:(0,n.$Pj)("list-selection",60293),selection:(0,n.$Pj)("selection",60293),listTree:(0,n.$Pj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Pj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Pj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Pj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Pj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Pj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Pj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Pj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Pj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Pj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Pj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Pj)("symbol-string",60301),debugReverseContinue:(0,n.$Pj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Pj)("debug-step-back",60303),debugRestartFrame:(0,n.$Pj)("debug-restart-frame",60304),debugAlt:(0,n.$Pj)("debug-alt",60305),callIncoming:(0,n.$Pj)("call-incoming",60306),callOutgoing:(0,n.$Pj)("call-outgoing",60307),menu:(0,n.$Pj)("menu",60308),expandAll:(0,n.$Pj)("expand-all",60309),feedback:(0,n.$Pj)("feedback",60310),gitPullRequestReviewer:(0,n.$Pj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Pj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Pj)("ungroup-by-ref-type",60312),account:(0,n.$Pj)("account",60313),gitPullRequestAssignee:(0,n.$Pj)("git-pull-request-assignee",60313),bellDot:(0,n.$Pj)("bell-dot",60314),debugConsole:(0,n.$Pj)("debug-console",60315),library:(0,n.$Pj)("library",60316),output:(0,n.$Pj)("output",60317),runAll:(0,n.$Pj)("run-all",60318),syncIgnored:(0,n.$Pj)("sync-ignored",60319),pinned:(0,n.$Pj)("pinned",60320),githubInverted:(0,n.$Pj)("github-inverted",60321),serverProcess:(0,n.$Pj)("server-process",60322),serverEnvironment:(0,n.$Pj)("server-environment",60323),pass:(0,n.$Pj)("pass",60324),issueClosed:(0,n.$Pj)("issue-closed",60324),stopCircle:(0,n.$Pj)("stop-circle",60325),playCircle:(0,n.$Pj)("play-circle",60326),record:(0,n.$Pj)("record",60327),debugAltSmall:(0,n.$Pj)("debug-alt-small",60328),vmConnect:(0,n.$Pj)("vm-connect",60329),cloud:(0,n.$Pj)("cloud",60330),merge:(0,n.$Pj)("merge",60331),export:(0,n.$Pj)("export",60332),graphLeft:(0,n.$Pj)("graph-left",60333),magnet:(0,n.$Pj)("magnet",60334),notebook:(0,n.$Pj)("notebook",60335),redo:(0,n.$Pj)("redo",60336),checkAll:(0,n.$Pj)("check-all",60337),pinnedDirty:(0,n.$Pj)("pinned-dirty",60338),passFilled:(0,n.$Pj)("pass-filled",60339),circleLargeFilled:(0,n.$Pj)("circle-large-filled",60340),circleLarge:(0,n.$Pj)("circle-large",60341),circleLargeOutline:(0,n.$Pj)("circle-large-outline",60341),combine:(0,n.$Pj)("combine",60342),gather:(0,n.$Pj)("gather",60342),table:(0,n.$Pj)("table",60343),variableGroup:(0,n.$Pj)("variable-group",60344),typeHierarchy:(0,n.$Pj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Pj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Pj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Pj)("git-pull-request-create",60348),runAbove:(0,n.$Pj)("run-above",60349),runBelow:(0,n.$Pj)("run-below",60350),notebookTemplate:(0,n.$Pj)("notebook-template",60351),debugRerun:(0,n.$Pj)("debug-rerun",60352),workspaceTrusted:(0,n.$Pj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Pj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Pj)("workspace-unknown",60355),terminalCmd:(0,n.$Pj)("terminal-cmd",60356),terminalDebian:(0,n.$Pj)("terminal-debian",60357),terminalLinux:(0,n.$Pj)("terminal-linux",60358),terminalPowershell:(0,n.$Pj)("terminal-powershell",60359),terminalTmux:(0,n.$Pj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Pj)("terminal-ubuntu",60361),terminalBash:(0,n.$Pj)("terminal-bash",60362),arrowSwap:(0,n.$Pj)("arrow-swap",60363),copy:(0,n.$Pj)("copy",60364),personAdd:(0,n.$Pj)("person-add",60365),filterFilled:(0,n.$Pj)("filter-filled",60366),wand:(0,n.$Pj)("wand",60367),debugLineByLine:(0,n.$Pj)("debug-line-by-line",60368),inspect:(0,n.$Pj)("inspect",60369),layers:(0,n.$Pj)("layers",60370),layersDot:(0,n.$Pj)("layers-dot",60371),layersActive:(0,n.$Pj)("layers-active",60372),compass:(0,n.$Pj)("compass",60373),compassDot:(0,n.$Pj)("compass-dot",60374),compassActive:(0,n.$Pj)("compass-active",60375),azure:(0,n.$Pj)("azure",60376),issueDraft:(0,n.$Pj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Pj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Pj)("git-pull-request-draft",60379),debugAll:(0,n.$Pj)("debug-all",60380),debugCoverage:(0,n.$Pj)("debug-coverage",60381),runErrors:(0,n.$Pj)("run-errors",60382),folderLibrary:(0,n.$Pj)("folder-library",60383),debugContinueSmall:(0,n.$Pj)("debug-continue-small",60384),beakerStop:(0,n.$Pj)("beaker-stop",60385),graphLine:(0,n.$Pj)("graph-line",60386),graphScatter:(0,n.$Pj)("graph-scatter",60387),pieChart:(0,n.$Pj)("pie-chart",60388),bracket:(0,n.$Pj)("bracket",60175),bracketDot:(0,n.$Pj)("bracket-dot",60389),bracketError:(0,n.$Pj)("bracket-error",60390),lockSmall:(0,n.$Pj)("lock-small",60391),azureDevops:(0,n.$Pj)("azure-devops",60392),verifiedFilled:(0,n.$Pj)("verified-filled",60393),newline:(0,n.$Pj)("newline",60394),layout:(0,n.$Pj)("layout",60395),layoutActivitybarLeft:(0,n.$Pj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Pj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Pj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Pj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Pj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Pj)("layout-panel-right",60401),layoutPanel:(0,n.$Pj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Pj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Pj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Pj)("layout-statusbar",60405),layoutMenubar:(0,n.$Pj)("layout-menubar",60406),layoutCentered:(0,n.$Pj)("layout-centered",60407),target:(0,n.$Pj)("target",60408),indent:(0,n.$Pj)("indent",60409),recordSmall:(0,n.$Pj)("record-small",60410),errorSmall:(0,n.$Pj)("error-small",60411),terminalDecorationError:(0,n.$Pj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Pj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Pj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Pj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Pj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Pj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Pj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Pj)("layout-sidebar-left-off",60418),blank:(0,n.$Pj)("blank",60419),heartFilled:(0,n.$Pj)("heart-filled",60420),map:(0,n.$Pj)("map",60421),mapHorizontal:(0,n.$Pj)("map-horizontal",60421),foldHorizontal:(0,n.$Pj)("fold-horizontal",60421),mapFilled:(0,n.$Pj)("map-filled",60422),mapHorizontalFilled:(0,n.$Pj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Pj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Pj)("circle-small",60423),bellSlash:(0,n.$Pj)("bell-slash",60424),bellSlashDot:(0,n.$Pj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Pj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Pj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Pj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Pj)("search-fuzzy",60429),commentDraft:(0,n.$Pj)("comment-draft",60430),send:(0,n.$Pj)("send",60431),sparkle:(0,n.$Pj)("sparkle",60432),insert:(0,n.$Pj)("insert",60433),mic:(0,n.$Pj)("mic",60434),thumbsdownFilled:(0,n.$Pj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Pj)("thumbsup-filled",60436),coffee:(0,n.$Pj)("coffee",60437),snake:(0,n.$Pj)("snake",60438),game:(0,n.$Pj)("game",60439),vr:(0,n.$Pj)("vr",60440),chip:(0,n.$Pj)("chip",60441),piano:(0,n.$Pj)("piano",60442),music:(0,n.$Pj)("music",60443),micFilled:(0,n.$Pj)("mic-filled",60444),repoFetch:(0,n.$Pj)("repo-fetch",60445),copilot:(0,n.$Pj)("copilot",60446),lightbulbSparkle:(0,n.$Pj)("lightbulb-sparkle",60447),robot:(0,n.$Pj)("robot",60448),sparkleFilled:(0,n.$Pj)("sparkle-filled",60449),diffSingle:(0,n.$Pj)("diff-single",60450),diffMultiple:(0,n.$Pj)("diff-multiple",60451),surroundWith:(0,n.$Pj)("surround-with",60452),share:(0,n.$Pj)("share",60453),gitStash:(0,n.$Pj)("git-stash",60454),gitStashApply:(0,n.$Pj)("git-stash-apply",60455),gitStashPop:(0,n.$Pj)("git-stash-pop",60456),vscode:(0,n.$Pj)("vscode",60457),vscodeInsiders:(0,n.$Pj)("vscode-insiders",60458),codeOss:(0,n.$Pj)("code-oss",60459),runCoverage:(0,n.$Pj)("run-coverage",60460),runAllCoverage:(0,n.$Pj)("run-all-coverage",60461),coverage:(0,n.$Pj)("coverage",60462),githubProject:(0,n.$Pj)("github-project",60463),mapVertical:(0,n.$Pj)("map-vertical",60464),foldVertical:(0,n.$Pj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Pj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Pj)("fold-vertical-filled",60465),goToSearch:(0,n.$Pj)("go-to-search",60466),percentage:(0,n.$Pj)("percentage",60467),sortPercentage:(0,n.$Pj)("sort-percentage",60467)}}),define(re[75],oe([0,1,105,145]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uj=e.$Tj=void 0,e.$Sj=E;function E(){return Object.values(e.$Uj)}e.$Tj={dialogError:(0,n.$Pj)("dialog-error","error"),dialogWarning:(0,n.$Pj)("dialog-warning","warning"),dialogInfo:(0,n.$Pj)("dialog-info","info"),dialogClose:(0,n.$Pj)("dialog-close","close"),treeItemExpanded:(0,n.$Pj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Pj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Pj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Pj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Pj)("tree-item-loading","loading"),menuSelection:(0,n.$Pj)("menu-selection","check"),menuSubmenu:(0,n.$Pj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Pj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Pj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Pj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Pj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Pj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Pj)("toolbar-more","more"),quickInputBack:(0,n.$Pj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Pj)("drop-down-button",60084),symbolCustomColor:(0,n.$Pj)("symbol-customcolor",60252),exportIcon:(0,n.$Pj)("export",60332),workspaceUnspecified:(0,n.$Pj)("workspace-unspecified",60355),newLine:(0,n.$Pj)("newline",60394),thumbsDownFilled:(0,n.$Pj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Pj)("thumbsup-filled",60436),gitFetch:(0,n.$Pj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Pj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Pj)("debug-breakpoint-pending",60377)},e.$Uj={...C.$Rj,...e.$Tj}}),define(re[35],oe([0,1,12]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=C,e.$3n=E,e.$4n=j,e.$5n=h,e.$6n=l,e.$7n=d,e.$8n=b,e.$9n=v,e.$0n=m,e.$$n=f,e.$_n=y,e.$ao=p;function C($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const c=Array.isArray($)?[]:{};return Object.entries($).forEach(([w,P])=>{c[w]=P&&typeof P=="object"?C(P):P}),c}function E($){if(!$||typeof $!="object")return $;const c=[$];for(;c.length>0;){const w=c.shift();Object.freeze(w);for(const P in w)if(R.call(w,P)){const a=w[P];typeof a=="object"&&!Object.isFrozen(a)&&!(0,n.$$f)(a)&&c.push(a)}}return $}const R=Object.prototype.hasOwnProperty;function j($,c){return k($,c,new Set)}function k($,c,w){if((0,n.$eg)($))return $;const P=c($);if(typeof P<"u")return P;if(Array.isArray($)){const a=[];for(const t of $)a.push(k(t,c,w));return a}if((0,n.$0f)($)){if(w.has($))throw new Error("Cannot clone recursive data-structure");w.add($);const a={};for(const t in $)R.call($,t)&&(a[t]=k($[t],c,w));return w.delete($),a}return $}function h($,c,w=!0){return(0,n.$0f)($)?((0,n.$0f)(c)&&Object.keys(c).forEach(P=>{P in $?w&&((0,n.$0f)($[P])&&(0,n.$0f)(c[P])?h($[P],c[P],w):$[P]=c[P]):$[P]=c[P]}),$):c}function l($,c){if($===c)return!0;if($==null||c===null||c===void 0||typeof $!=typeof c||typeof $!="object"||Array.isArray($)!==Array.isArray(c))return!1;let w,P;if(Array.isArray($)){if($.length!==c.length)return!1;for(w=0;w<$.length;w++)if(!l($[w],c[w]))return!1}else{const a=[];for(P in $)a.push(P);a.sort();const t=[];for(P in c)t.push(P);if(t.sort(),!l(a,t))return!1;for(w=0;w<a.length;w++)if(!l($[a[w]],c[a[w]]))return!1}return!0}function d($){const c=new Set;return JSON.stringify($,(w,P)=>{if((0,n.$0f)(P)||Array.isArray(P)){if(c.has(P))return"[Circular]";c.add(P)}return typeof P=="bigint"?`[BigInt ${P.toString()}]`:P})}function b($,c){const w=Object.create(null);return!$||!c||Object.keys(c).forEach(a=>{const t=$[a],r=c[a];l(t,r)||(w[a]=r)}),w}function v($,c){const w=c.toLowerCase(),P=Object.keys($).find(a=>a.toLowerCase()===w);return P?$[P]:$[c]}function m($,c){const w=Object.create(null);for(const[P,a]of Object.entries($))c(P,a)&&(w[P]=a);return w}function f($){let c=[];for(;Object.prototype!==$;)c=c.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return c}function y($){const c=[];for(const w of f($))typeof $[w]=="function"&&c.push(w);return c}function p($,c){const w=a=>function(){const t=Array.prototype.slice.call(arguments,0);return c(a,t)},P={};for(const a of $)P[a]=w(a);return P}}),define(re[106],oe([0,1,75]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Vj=E;var C;(function(j){function k(h){return h&&typeof h=="object"&&typeof h.id=="string"}j.isThemeColor=k})(C||(e.ThemeColor=C={}));function E(j){return{id:j}}var R;(function(j){j.iconNameSegment="[A-Za-z0-9]+",j.iconNameExpression="[A-Za-z0-9-]+",j.iconModifierExpression="~[A-Za-z]+",j.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${j.iconNameExpression})(${j.iconModifierExpression})?$`);function h(c){const w=k.exec(c.id);if(!w)return h(n.$Uj.error);const[,P,a]=w,t=["codicon","codicon-"+P];return a&&t.push("codicon-modifier-"+a.substring(1)),t}j.asClassNameArray=h;function l(c){return h(c).join(" ")}j.asClassName=l;function d(c){return"."+h(c).join(".")}j.asCSSSelector=d;function b(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||C.isThemeColor(c.color))}j.isThemeIcon=b;const v=new RegExp(`^\\$\\((${j.iconNameExpression}(?:${j.iconModifierExpression})?)\\)$`);function m(c){const w=v.exec(c);if(!w)return;const[,P]=w;return{id:P}}j.fromString=m;function f(c){return{id:c}}j.fromId=f;function y(c,w){let P=c.id;const a=P.lastIndexOf("~");return a!==-1&&(P=P.substring(0,a)),w&&(P=`${P}~${w}`),{id:P}}j.modify=y;function p(c){const w=c.id.lastIndexOf("~");if(w!==-1)return c.id.substring(w+1)}j.getModifier=p;function $(c,w){return c.id===w.id&&c.color?.id===w.color?.id}j.isEqual=$})(R||(e.ThemeIcon=R={}))}),define(re[33],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=void 0,e.$Qg=C;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function C(E){return n.test(E)}e.$Rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let E;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?E=crypto.getRandomValues.bind(crypto):E=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const R=new Uint8Array(16),j=[];for(let k=0;k<256;k++)j.push(k.toString(16).padStart(2,"0"));return function(){E(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let h=0,l="";return l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+="-",l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l+=j[R[h++]],l}}()}),define(re[146],oe([0,1,87,43,86]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HW=R;async function R(j,k){if(await new Promise((d,b)=>{const v=C.createReadStream(j),m=n.createHash("sha256");v.pipe(m);const f=(0,E.$db)((y,p)=>{v.removeAllListeners(),m.removeAllListeners(),y?b(y):d(p)});v.once("error",f),v.once("end",f),m.once("error",f),m.once("data",y=>f(void 0,y.toString("hex")))})!==k)throw new Error("Hash mismatch")}}),define(re[147],oe([0,1,26]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cn=R;const C=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function E(j){const k=j.replace(/\-/g,":").toLowerCase();return!C.has(k)}function R(){const j=(0,n.networkInterfaces)();for(const k in j){const h=j[k];if(h){for(const{mac:l}of h)if(E(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(re[107],oe([0,1,88]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=C,e.$Vg=R;function C(k,h,l,d=1){let b=!1;return new Promise(v=>{const m=setTimeout(()=>{if(!b)return b=!0,v(0)},l);E(k,h,d,f=>{if(!b)return b=!0,clearTimeout(m),v(f)})})}function E(k,h,l,d){if(h===0)return d(0);const b=new n.Socket;b.once("connect",()=>(j(b),E(k+l,h-1,l,d))),b.once("data",()=>{}),b.once("error",v=>(j(b),v.code!=="ECONNREFUSED"?E(k+l,h-1,l,d):d(k))),b.connect(k,"127.0.0.1")}e.$Ug={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function R(k,h,l,d="127.0.0.1"){let b=!1,v,m=1;const f=n.createServer({pauseOnConnect:!0});function y(p,$){b||(b=!0,f.removeAllListeners(),f.close(),v&&clearTimeout(v),$(p))}return new Promise(p=>{v=setTimeout(()=>{y(0,p)},l),f.on("listening",()=>{y(k,p)}),f.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&m<h?(k++,m++,f.listen(k,d)):y(0,p)}),f.on("close",()=>{y(0,p)}),f.listen(k,d)})}function j(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(h){console.error(h)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function n(h){const l=new Set;if(Array.isArray(h))for(const d of h)typeof d=="string"&&l.add(d);return Array.from(l)}function C(){const h=e();return h?Array.from(h):[]}function E(h){if(process.platform!=="win32")return;const l=e();if(l)if(typeof h=="string")l.add(h.toLowerCase());else for(const d of n(h))E(d)}function R(h){if(typeof h!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let d;for(const b of l){if(h.indexOf(b)!==0)continue;const m=h.indexOf("\\",b.length);if(m===-1)continue;const f=h.substring(b.length,m);if(f){d=f;break}}return d}function j(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function k(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:C,addUNCHostToAllowlist:E,getUNCHost:R,disableUNCAccessRestrictions:j,isUNCAccessRestrictionsDisabled:k}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(re[148],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NW=e.$MW=void 0,e.$MW="vscode:contextmenu",e.$NW="vscode:onCloseContextMenu"}),define(re[149],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UW=void 0;class n{constructor(E,R){this.a=E,this.onMessage=R}send(E){try{this.a.send("vscode:message",E.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$UW=n}),define(re[150],oe([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(re[151],oe([0,1,150]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=l,e.$2m=d,e.$3m=b;const C=60,E=C*60,R=E*24,j=R*7,k=R*30,h=R*365;function l(v,m,f,y){typeof v!="number"&&(v=v.getTime());const p=Math.round((new Date().getTime()-v)/1e3);if(p<-30)return(0,n.localize)(0,null,l(new Date().getTime()+p*1e3,!1));if(!y&&p<30)return(0,n.localize)(1,null);let $;return p<C?($=p,m?$===1?f?(0,n.localize)(2,null,$):(0,n.localize)(3,null,$):f?(0,n.localize)(4,null,$):(0,n.localize)(5,null,$):$===1?f?(0,n.localize)(6,null,$):(0,n.localize)(7,null,$):f?(0,n.localize)(8,null,$):(0,n.localize)(9,null,$)):p<E?($=Math.floor(p/C),m?$===1?f?(0,n.localize)(10,null,$):(0,n.localize)(11,null,$):f?(0,n.localize)(12,null,$):(0,n.localize)(13,null,$):$===1?f?(0,n.localize)(14,null,$):(0,n.localize)(15,null,$):f?(0,n.localize)(16,null,$):(0,n.localize)(17,null,$)):p<R?($=Math.floor(p/E),m?$===1?f?(0,n.localize)(18,null,$):(0,n.localize)(19,null,$):f?(0,n.localize)(20,null,$):(0,n.localize)(21,null,$):$===1?f?(0,n.localize)(22,null,$):(0,n.localize)(23,null,$):f?(0,n.localize)(24,null,$):(0,n.localize)(25,null,$)):p<j?($=Math.floor(p/R),m?$===1?(0,n.localize)(26,null,$):(0,n.localize)(27,null,$):$===1?(0,n.localize)(28,null,$):(0,n.localize)(29,null,$)):p<k?($=Math.floor(p/j),m?$===1?f?(0,n.localize)(30,null,$):(0,n.localize)(31,null,$):f?(0,n.localize)(32,null,$):(0,n.localize)(33,null,$):$===1?f?(0,n.localize)(34,null,$):(0,n.localize)(35,null,$):f?(0,n.localize)(36,null,$):(0,n.localize)(37,null,$)):p<h?($=Math.floor(p/k),m?$===1?f?(0,n.localize)(38,null,$):(0,n.localize)(39,null,$):f?(0,n.localize)(40,null,$):(0,n.localize)(41,null,$):$===1?f?(0,n.localize)(42,null,$):(0,n.localize)(43,null,$):f?(0,n.localize)(44,null,$):(0,n.localize)(45,null,$)):($=Math.floor(p/h),m?$===1?f?(0,n.localize)(46,null,$):(0,n.localize)(47,null,$):f?(0,n.localize)(48,null,$):(0,n.localize)(49,null,$):$===1?f?(0,n.localize)(50,null,$):(0,n.localize)(51,null,$):f?(0,n.localize)(52,null,$):(0,n.localize)(53,null,$))}function d(v,m){const f=Math.abs(v/1e3);return f<1?m?(0,n.localize)(54,null,v):(0,n.localize)(55,null,v):f<C?m?(0,n.localize)(56,null,Math.round(v)/1e3):(0,n.localize)(57,null,Math.round(v)/1e3):f<E?m?(0,n.localize)(58,null,Math.round(v/(1e3*C))):(0,n.localize)(59,null,Math.round(v/(1e3*C))):f<R?m?(0,n.localize)(60,null,Math.round(v/(1e3*E))):(0,n.localize)(61,null,Math.round(v/(1e3*E))):(0,n.localize)(62,null,Math.round(v/(1e3*R)))}function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(re[152],oe([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(re[47],oe([0,1,22,12,152]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=h,e.$hj=l,e.$ij=d;function R(b,v){return v&&(b.stack||b.stacktrace)?E.localize(0,null,k(b),j(b.stack)||j(b.stacktrace)):k(b)}function j(b){return Array.isArray(b)?b.join(`
`):b}function k(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?E.localize(1,null,b.message):b.message||E.localize(2,null)}function h(b=null,v=!1){if(!b)return E.localize(3,null);if(Array.isArray(b)){const m=n.$Hb(b),f=h(m[0],v);return m.length>1?E.localize(4,null,f,m.length):f}if(C.$8f(b))return b;if(b.detail){const m=b.detail;if(m.error)return R(m.error,v);if(m.exception)return R(m.exception,v)}return b.stack?R(b,v):b.message?b.message:E.localize(5,null)}function l(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}function d(b,v){let m;return typeof b=="string"?m=new Error(b):m=b,m.actions=v,m}}),define(re[153],oe([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(re[154],oe([0,1,153]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qq=C;function C(E){switch(E){case 1:return(0,n.localize)(0,null);case 2:return(0,n.localize)(1,null);case 3:return(0,n.localize)(2,null);case 4:return(0,n.localize)(3,null);case 5:return(0,n.localize)(4,null);case 6:return(0,n.localize)(5,null);case 7:return(0,n.localize)(6,null);case 8:return(0,n.localize)(7,null);case 9:return(0,n.localize)(8,null);default:return""}}}),define(re[155],oe([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(re[4],oe([0,1,155]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I=e.$H=e.$G=e.$F=e.$E=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.Platform=e.$g=void 0,e.$h=r,e.$D=S,e.$J=D,e.$g="en";let C=!1,E=!1,R=!1,j=!1,k=!1,h=!1,l=!1,d=!1,b=!1,v=!1,m,f=e.$g,y=e.$g,p,$;const c=globalThis;let w;typeof c.vscode<"u"&&typeof c.vscode.process<"u"?w=c.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(w=process);const P=typeof w?.versions?.electron=="string",a=P&&w?.type==="renderer";if(typeof w=="object"){C=w.platform==="win32",E=w.platform==="darwin",R=w.platform==="linux",j=R&&!!w.env.SNAP&&!!w.env.SNAP_REVISION,l=P,b=!!w.env.CI||!!w.env.BUILD_ARTIFACTSTAGINGDIRECTORY,m=e.$g,f=e.$g;const I=w.env.VSCODE_NLS_CONFIG;if(I)try{const O=JSON.parse(I),M=O.availableLanguages["*"];m=O.locale,y=O.osLocale,f=M||e.$g,p=O._translationsConfigFile}catch{}k=!0}else typeof navigator=="object"&&!a?($=navigator.userAgent,C=$.indexOf("Windows")>=0,E=$.indexOf("Macintosh")>=0,d=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,R=$.indexOf("Linux")>=0,v=$?.indexOf("Mobi")>=0,h=!0,m=n.getConfiguredDefaultLocale(n.localize(0,null))||e.$g,f=m,y=navigator.language):console.error("Unable to resolve platform.");var t;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(t||(e.Platform=t={}));function r(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let s=0;E?s=1:C?s=3:R&&(s=2),e.$i=C,e.$j=E,e.$k=R,e.$l=j,e.$m=k,e.$n=l,e.$o=h,e.$p=h&&typeof c.importScripts=="function",e.$q=e.$p?c.origin:void 0,e.$r=d,e.$s=v,e.$t=b,e.$u=s,e.$v=$,e.$w=f;var i;(function(I){function O(){return e.$w}I.value=O;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}I.isDefaultVariant=M;function W(){return e.$w==="en"}I.isDefault=W})(i||(e.Language=i={})),e.$x=m,e.$y=y,e.$z=p,e.$A=typeof c.postMessage=="function"&&!c.importScripts,e.$B=(()=>{if(e.$A){const I=[];c.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let W=0,F=I.length;W<F;W++){const T=I[W];if(T.id===M.data.vscodeScheduleAsyncWork){I.splice(W,1),T.callback();return}}});let O=0;return M=>{const W=++O;I.push({id:W,callback:M}),c.postMessage({vscodeScheduleAsyncWork:W},"*")}}return I=>setTimeout(I)})();var o;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(o||(e.OperatingSystem=o={})),e.OS=E||d?2:C?1:3;let u=!0,g=!1;function S(){if(!g){g=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,u=new Uint16Array(I.buffer)[0]===513}return u}e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function D(I){return parseFloat(I)>=20}}),define(re[36],oe([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fc=e.$ec=e.env=e.cwd=void 0;let C;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.process<"u"){const R=E.process;C={get platform(){return R.platform},get arch(){return R.arch},get env(){return R.env},cwd(){return R.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=C.cwd,e.env=C.env,e.$ec=C.platform,e.$fc=C.arch}),define(re[9],oe([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uc=e.sep=e.$sc=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=void 0;const C=65,E=97,R=90,j=122,k=46,h=47,l=92,d=58,b=63;class v extends Error{constructor(r,s,i){let o;typeof s=="string"&&s.indexOf("not ")===0?(o="must not be",s=s.replace(/^not /,"")):o="must be";const u=r.indexOf(".")!==-1?"property":"argument";let g=`The "${r}" ${u} ${o} of type ${s}`;g+=`. Received type ${typeof i}`,super(g),this.code="ERR_INVALID_ARG_TYPE"}}function m(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function f(t,r){if(typeof t!="string")throw new v(r,"string",t)}const y=n.$ec==="win32";function p(t){return t===h||t===l}function $(t){return t===h}function c(t){return t>=C&&t<=R||t>=E&&t<=j}function w(t,r,s,i){let o="",u=0,g=-1,S=0,D=0;for(let I=0;I<=t.length;++I){if(I<t.length)D=t.charCodeAt(I);else{if(i(D))break;D=h}if(i(D)){if(!(g===I-1||S===1))if(S===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const O=o.lastIndexOf(s);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(s)),g=I,S=0;continue}else if(o.length!==0){o="",u=0,g=I,S=0;continue}}r&&(o+=o.length>0?`${s}..`:"..",u=2)}else o.length>0?o+=`${s}${t.slice(g+1,I)}`:o=t.slice(g+1,I),u=I-g-1;g=I,S=0}else D===k&&S!==-1?++S:S=-1}return o}function P(t,r){m(r,"pathObject");const s=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return s?s===r.root?`${s}${i}`:`${s}${t}${i}`:i}e.$gc={resolve(...t){let r="",s="",i=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],f(u,"path"),u.length===0)continue}else r.length===0?u=n.cwd():(u=n.env[`=${r}`]||n.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${r}\\`));const g=u.length;let S=0,D="",I=!1;const O=u.charCodeAt(0);if(g===1)p(O)&&(S=1,I=!0);else if(p(O))if(I=!0,p(u.charCodeAt(1))){let M=2,W=M;for(;M<g&&!p(u.charCodeAt(M));)M++;if(M<g&&M!==W){const F=u.slice(W,M);for(W=M;M<g&&p(u.charCodeAt(M));)M++;if(M<g&&M!==W){for(W=M;M<g&&!p(u.charCodeAt(M));)M++;(M===g||M!==W)&&(D=`\\\\${F}\\${u.slice(W,M)}`,S=M)}}}else S=1;else c(O)&&u.charCodeAt(1)===d&&(D=u.slice(0,2),S=2,g>2&&p(u.charCodeAt(2))&&(I=!0,S=3));if(D.length>0)if(r.length>0){if(D.toLowerCase()!==r.toLowerCase())continue}else r=D;if(i){if(r.length>0)break}else if(s=`${u.slice(S)}\\${s}`,i=I,I&&r.length>0)break}return s=w(s,!i,"\\",p),i?`${r}\\${s}`:`${r}${s}`||"."},normalize(t){f(t,"path");const r=t.length;if(r===0)return".";let s=0,i,o=!1;const u=t.charCodeAt(0);if(r===1)return $(u)?"\\":t;if(p(u))if(o=!0,p(t.charCodeAt(1))){let S=2,D=S;for(;S<r&&!p(t.charCodeAt(S));)S++;if(S<r&&S!==D){const I=t.slice(D,S);for(D=S;S<r&&p(t.charCodeAt(S));)S++;if(S<r&&S!==D){for(D=S;S<r&&!p(t.charCodeAt(S));)S++;if(S===r)return`\\\\${I}\\${t.slice(D)}\\`;S!==D&&(i=`\\\\${I}\\${t.slice(D,S)}`,s=S)}}}else s=1;else c(u)&&t.charCodeAt(1)===d&&(i=t.slice(0,2),s=2,r>2&&p(t.charCodeAt(2))&&(o=!0,s=3));let g=s<r?w(t.slice(s),!o,"\\",p):"";return g.length===0&&!o&&(g="."),g.length>0&&p(t.charCodeAt(r-1))&&(g+="\\"),i===void 0?o?`\\${g}`:g:o?`${i}\\${g}`:`${i}${g}`},isAbsolute(t){f(t,"path");const r=t.length;if(r===0)return!1;const s=t.charCodeAt(0);return p(s)||r>2&&c(s)&&t.charCodeAt(1)===d&&p(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,s;for(let u=0;u<t.length;++u){const g=t[u];f(g,"path"),g.length>0&&(r===void 0?r=s=g:r+=`\\${g}`)}if(r===void 0)return".";let i=!0,o=0;if(typeof s=="string"&&p(s.charCodeAt(0))){++o;const u=s.length;u>1&&p(s.charCodeAt(1))&&(++o,u>2&&(p(s.charCodeAt(2))?++o:i=!1))}if(i){for(;o<r.length&&p(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.$gc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r)return"";const s=e.$gc.resolve(t),i=e.$gc.resolve(r);if(s===i||(t=s.toLowerCase(),r=i.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===l;)u--;const g=u-o;let S=0;for(;S<r.length&&r.charCodeAt(S)===l;)S++;let D=r.length;for(;D-1>S&&r.charCodeAt(D-1)===l;)D--;const I=D-S,O=g<I?g:I;let M=-1,W=0;for(;W<O;W++){const T=t.charCodeAt(o+W);if(T!==r.charCodeAt(S+W))break;T===l&&(M=W)}if(W!==O){if(M===-1)return i}else{if(I>O){if(r.charCodeAt(S+W)===l)return i.slice(S+W+1);if(W===2)return i.slice(S+W)}g>O&&(t.charCodeAt(o+W)===l?M=W:W===2&&(M=3)),M===-1&&(M=0)}let F="";for(W=o+M+1;W<=u;++W)(W===u||t.charCodeAt(W)===l)&&(F+=F.length===0?"..":"\\..");return S+=M,F.length>0?`${F}${i.slice(S,D)}`:(i.charCodeAt(S)===l&&++S,i.slice(S,D))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.$gc.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===l){if(r.charCodeAt(1)===l){const s=r.charCodeAt(2);if(s!==b&&s!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(c(r.charCodeAt(0))&&r.charCodeAt(1)===d&&r.charCodeAt(2)===l)return`\\\\?\\${r}`;return t},dirname(t){f(t,"path");const r=t.length;if(r===0)return".";let s=-1,i=0;const o=t.charCodeAt(0);if(r===1)return p(o)?t:".";if(p(o)){if(s=i=1,p(t.charCodeAt(1))){let S=2,D=S;for(;S<r&&!p(t.charCodeAt(S));)S++;if(S<r&&S!==D){for(D=S;S<r&&p(t.charCodeAt(S));)S++;if(S<r&&S!==D){for(D=S;S<r&&!p(t.charCodeAt(S));)S++;if(S===r)return t;S!==D&&(s=i=S+1)}}}}else c(o)&&t.charCodeAt(1)===d&&(s=r>2&&p(t.charCodeAt(2))?3:2,i=s);let u=-1,g=!0;for(let S=r-1;S>=i;--S)if(p(t.charCodeAt(S))){if(!g){u=S;break}}else g=!1;if(u===-1){if(s===-1)return".";u=s}return t.slice(0,u)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===d&&(s=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let g=r.length-1,S=-1;for(u=t.length-1;u>=s;--u){const D=t.charCodeAt(u);if(p(D)){if(!o){s=u+1;break}}else S===-1&&(o=!1,S=u+1),g>=0&&(D===r.charCodeAt(g)?--g===-1&&(i=u):(g=-1,i=S))}return s===i?i=S:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=s;--u)if(p(t.charCodeAt(u))){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=0,s=-1,i=0,o=-1,u=!0,g=0;t.length>=2&&t.charCodeAt(1)===d&&c(t.charCodeAt(0))&&(r=i=2);for(let S=t.length-1;S>=r;--S){const D=t.charCodeAt(S);if(p(D)){if(!u){i=S+1;break}continue}o===-1&&(u=!1,o=S+1),D===k?s===-1?s=S:g!==1&&(g=1):s!==-1&&(g=-1)}return s===-1||o===-1||g===0||g===1&&s===o-1&&s===i+1?"":t.slice(s,o)},format:P.bind(null,"\\"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.length;let i=0,o=t.charCodeAt(0);if(s===1)return p(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(p(o)){if(i=1,p(t.charCodeAt(1))){let M=2,W=M;for(;M<s&&!p(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&p(t.charCodeAt(M));)M++;if(M<s&&M!==W){for(W=M;M<s&&!p(t.charCodeAt(M));)M++;M===s?i=M:M!==W&&(i=M+1)}}}}else if(c(o)&&t.charCodeAt(1)===d){if(s<=2)return r.root=r.dir=t,r;if(i=2,p(t.charCodeAt(2))){if(s===3)return r.root=r.dir=t,r;i=3}}i>0&&(r.root=t.slice(0,i));let u=-1,g=i,S=-1,D=!0,I=t.length-1,O=0;for(;I>=i;--I){if(o=t.charCodeAt(I),p(o)){if(!D){g=I+1;break}continue}S===-1&&(D=!1,S=I+1),o===k?u===-1?u=I:O!==1&&(O=1):u!==-1&&(O=-1)}return S!==-1&&(u===-1||O===0||O===1&&u===S-1&&u===g+1?r.base=r.name=t.slice(g,S):(r.name=t.slice(g,u),r.base=t.slice(g,S),r.ext=t.slice(u,S))),g>0&&g!==i?r.dir=t.slice(0,g-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(y){const t=/\\/g;return()=>{const r=n.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>n.cwd()})();e.$hc={resolve(...t){let r="",s=!1;for(let i=t.length-1;i>=-1&&!s;i--){const o=i>=0?t[i]:a();f(o,"path"),o.length!==0&&(r=`${o}/${r}`,s=o.charCodeAt(0)===h)}return r=w(r,!s,"/",$),s?`/${r}`:r.length>0?r:"."},normalize(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h,s=t.charCodeAt(t.length-1)===h;return t=w(t,!r,"/",$),t.length===0?r?"/":s?"./":".":(s&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return f(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let r;for(let s=0;s<t.length;++s){const i=t[s];f(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.$hc.normalize(r)},relative(t,r){if(f(t,"from"),f(r,"to"),t===r||(t=e.$hc.resolve(t),r=e.$hc.resolve(r),t===r))return"";const s=1,i=t.length,o=i-s,u=1,g=r.length-u,S=o<g?o:g;let D=-1,I=0;for(;I<S;I++){const M=t.charCodeAt(s+I);if(M!==r.charCodeAt(u+I))break;M===h&&(D=I)}if(I===S)if(g>S){if(r.charCodeAt(u+I)===h)return r.slice(u+I+1);if(I===0)return r.slice(u+I)}else o>S&&(t.charCodeAt(s+I)===h?D=I:I===0&&(D=0));let O="";for(I=s+D+1;I<=i;++I)(I===i||t.charCodeAt(I)===h)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(u+D)}`},toNamespacedPath(t){return t},dirname(t){if(f(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===h;let s=-1,i=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!i){s=o;break}}else i=!1;return s===-1?r?"/":".":r&&s===1?"//":t.slice(0,s)},basename(t,r){r!==void 0&&f(r,"ext"),f(t,"path");let s=0,i=-1,o=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let g=r.length-1,S=-1;for(u=t.length-1;u>=0;--u){const D=t.charCodeAt(u);if(D===h){if(!o){s=u+1;break}}else S===-1&&(o=!1,S=u+1),g>=0&&(D===r.charCodeAt(g)?--g===-1&&(i=u):(g=-1,i=S))}return s===i?i=S:i===-1&&(i=t.length),t.slice(s,i)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!o){s=u+1;break}}else i===-1&&(o=!1,i=u+1);return i===-1?"":t.slice(s,i)},extname(t){f(t,"path");let r=-1,s=0,i=-1,o=!0,u=0;for(let g=t.length-1;g>=0;--g){const S=t.charCodeAt(g);if(S===h){if(!o){s=g+1;break}continue}i===-1&&(o=!1,i=g+1),S===k?r===-1?r=g:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||i===-1||u===0||u===1&&r===i-1&&r===s+1?"":t.slice(r,i)},format:P.bind(null,"/"),parse(t){f(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const s=t.charCodeAt(0)===h;let i;s?(r.root="/",i=1):i=0;let o=-1,u=0,g=-1,S=!0,D=t.length-1,I=0;for(;D>=i;--D){const O=t.charCodeAt(D);if(O===h){if(!S){u=D+1;break}continue}g===-1&&(S=!1,g=D+1),O===k?o===-1?o=D:I!==1&&(I=1):o!==-1&&(I=-1)}if(g!==-1){const O=u===0&&s?1:u;o===-1||I===0||I===1&&o===g-1&&o===u+1?r.base=r.name=t.slice(O,g):(r.name=t.slice(O,o),r.base=t.slice(O,g),r.ext=t.slice(o,g))}return u>0?r.dir=t.slice(0,u-1):s&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.$hc.win32=e.$gc.win32=e.$gc,e.$hc.posix=e.$gc.posix=e.$hc,e.$ic=y?e.$gc.normalize:e.$hc.normalize,e.$jc=y?e.$gc.isAbsolute:e.$hc.isAbsolute,e.$kc=y?e.$gc.join:e.$hc.join,e.$lc=y?e.$gc.resolve:e.$hc.resolve,e.$mc=y?e.$gc.relative:e.$hc.relative,e.$nc=y?e.$gc.dirname:e.$hc.dirname,e.$oc=y?e.$gc.basename:e.$hc.basename,e.$pc=y?e.$gc.extname:e.$hc.extname,e.$qc=y?e.$gc.format:e.$hc.format,e.$rc=y?e.$gc.parse:e.$hc.parse,e.$sc=y?e.$gc.toNamespacedPath:e.$hc.toNamespacedPath,e.sep=y?e.$gc.sep:e.$hc.sep,e.$uc=y?e.$gc.delimiter:e.$hc.delimiter}),define(re[31],oe([0,1,9,4,25,12]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=j,e.$og=k,e.$pg=h,e.$qg=l,e.$rg=d,e.$sg=f,e.$tg=y,e.$ug=p,e.$vg=$,e.$wg=c,e.$xg=w,e.$yg=P,e.$zg=a,e.$Ag=t,e.$Bg=r,e.$Cg=s,e.$Dg=u;function j(g){return g===47||g===92}function k(g){return g.replace(/[\\/]/g,n.$hc.sep)}function h(g){return g.indexOf("/")===-1&&(g=k(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}function l(g,S=n.$hc.sep){if(!g)return"";const D=g.length,I=g.charCodeAt(0);if(j(I)){if(j(g.charCodeAt(1))&&!j(g.charCodeAt(2))){let M=3;const W=M;for(;M<D&&!j(g.charCodeAt(M));M++);if(W!==M&&!j(g.charCodeAt(M+1))){for(M+=1;M<D;M++)if(j(g.charCodeAt(M)))return g.slice(0,M+1).replace(/[\\/]/g,S)}}return S}else if($(I)&&g.charCodeAt(1)===58)return j(g.charCodeAt(2))?g.slice(0,2)+S:g.slice(0,2);let O=g.indexOf("://");if(O!==-1){for(O+=3;O<D;O++)if(j(g.charCodeAt(O)))return g.slice(0,O+1)}return""}function d(g){if(!C.$i||!g||g.length<5)return!1;let S=g.charCodeAt(0);if(S!==92||(S=g.charCodeAt(1),S!==92))return!1;let D=2;const I=D;for(;D<g.length&&(S=g.charCodeAt(D),S!==92);D++);return!(I===D||(S=g.charCodeAt(D+1),isNaN(S)||S===92))}const b=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(g,S=C.$i){const D=S?b:v;return!(!g||g.length===0||/^\s+$/.test(g)||(D.lastIndex=0,D.test(g))||S&&m.test(g)||g==="."||g===".."||S&&g[g.length-1]==="."||S&&g.length!==g.trim().length||g.length>255)}function y(g,S,D){const I=g===S;return!D||I?I:!g||!S?!1:(0,E.$xf)(g,S)}function p(g,S,D,I=n.sep){if(g===S)return!0;if(!g||!S||S.length>g.length)return!1;if(D){if(!(0,E.$yf)(g,S))return!1;if(S.length===g.length)return!0;let M=S.length;return S.charAt(S.length-1)===I&&M--,g.charAt(M)===I}return S.charAt(S.length-1)!==I&&(S+=I),g.indexOf(S)===0}function $(g){return g>=65&&g<=90||g>=97&&g<=122}function c(g,S){return C.$i&&g.endsWith(":")&&(g+=n.sep),(0,n.$jc)(g)||(g=(0,n.$kc)(S,g)),g=(0,n.$ic)(g),w(g)}function w(g){return C.$i?(g=(0,E.$ff)(g,n.sep),g.endsWith(":")&&(g+=n.sep)):(g=(0,E.$ff)(g,n.sep),g||(g=n.sep)),g}function P(g){const S=(0,n.$ic)(g);return C.$i?g.length>3?!1:a(S)&&(g.length===2||S.charCodeAt(2)===92):S===n.$hc.sep}function a(g,S=C.$i){return S?$(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}function t(g,S=C.$i){return a(g,S)?g[0]:void 0}function r(g,S,D){return S.length>g.length?-1:g===S?0:(D&&(g=g.toLowerCase(),S=S.toLowerCase()),g.indexOf(S))}function s(g){const S=g.split(":");let D,I,O;for(const M of S){const W=Number(M);(0,R.$_f)(W)?I===void 0?I=W:O===void 0&&(O=W):D=D?[D,M].join(":"):M}if(!D)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:D,line:I!==void 0?I:void 0,column:O!==void 0?O:I!==void 0?1:void 0}}const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",o="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(g,S,D=8){let I="";for(let M=0;M<D;M++){let W;M===0&&C.$i&&!S&&(D===3||D===4)?W=o:W=i,I+=W.charAt(Math.floor(Math.random()*W.length))}let O;return S?O=`${S}-${I}`:O=I,g?(0,n.$kc)(g,O):O}}),define(re[76],oe([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$lm=R,e.$mm=j;var C;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(C||(e.Source=C={}));var E;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(E||(e.TerminateResponseCode=E={}));function R(k,...h){const l=h.reduce((v,m)=>(v[m]=!0,v),{}),d=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(v=>!l[v]).forEach(v=>{for(let m=0;m<d.length;m++)if(v.search(d[m])!==-1){delete k[v];break}})}function j(k){k&&(delete k.DEBUG,n.$j&&delete k.DYLD_LIBRARY_PATH,n.$k&&delete k.LD_PRELOAD)}}),define(re[7],oe([0,1,9,4]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URI=void 0,e.$wc=f,e.$xc=P;const E=/^\w[\w\d+.-]*$/,R=/^\//,j=/^\/\//;function k(i,o){if(!i.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!E.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!R.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(j.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,o){return!i&&!o?"file":i}function l(i,o){switch(i){case"https":case"http":case"file":o?o[0]!==b&&(o=b+o):o=b;break}return o}const d="",b="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{static isUri(o){return o instanceof m?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,u,g,S,D,I=!1){typeof o=="object"?(this.scheme=o.scheme||d,this.authority=o.authority||d,this.path=o.path||d,this.query=o.query||d,this.fragment=o.fragment||d):(this.scheme=h(o,I),this.authority=u||d,this.path=l(this.scheme,g||d),this.query=S||d,this.fragment=D||d,k(this,I))}get fsPath(){return P(this,!1)}with(o){if(!o)return this;let{scheme:u,authority:g,path:S,query:D,fragment:I}=o;return u===void 0?u=this.scheme:u===null&&(u=d),g===void 0?g=this.authority:g===null&&(g=d),S===void 0?S=this.path:S===null&&(S=d),D===void 0?D=this.query:D===null&&(D=d),I===void 0?I=this.fragment:I===null&&(I=d),u===this.scheme&&g===this.authority&&S===this.path&&D===this.query&&I===this.fragment?this:new p(u,g,S,D,I)}static parse(o,u=!1){const g=v.exec(o);return g?new p(g[2]||d,s(g[4]||d),s(g[5]||d),s(g[7]||d),s(g[9]||d),u):new p(d,d,d,d,d)}static file(o){let u=d;if(C.$i&&(o=o.replace(/\\/g,b)),o[0]===b&&o[1]===b){const g=o.indexOf(b,2);g===-1?(u=o.substring(2),o=b):(u=o.substring(2,g),o=o.substring(g)||b)}return new p("file",u,o,d,d)}static from(o,u){return new p(o.scheme,o.authority,o.path,o.query,o.fragment,u)}static joinPath(o,...u){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return C.$i&&o.scheme==="file"?g=m.file(n.$gc.join(P(o,!0),...u)).path:g=n.$hc.join(o.path,...u),o.with({path:g})}toString(o=!1){return a(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof m)return o;{const u=new p(o);return u._formatted=o.external??null,u._fsPath=o._sep===y?o.fsPath??null:null,u}}else return o}}e.URI=m;function f(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}const y=C.$i?1:void 0;class p extends m{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=P(this,!1)),this._fsPath}toString(o=!1){return o?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=y),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const $={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function c(i,o,u){let g,S=-1;for(let D=0;D<i.length;D++){const I=i.charCodeAt(D);if(I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57||I===45||I===46||I===95||I===126||o&&I===47||u&&I===91||u&&I===93||u&&I===58)S!==-1&&(g+=encodeURIComponent(i.substring(S,D)),S=-1),g!==void 0&&(g+=i.charAt(D));else{g===void 0&&(g=i.substr(0,D));const O=$[I];O!==void 0?(S!==-1&&(g+=encodeURIComponent(i.substring(S,D)),S=-1),g+=O):S===-1&&(S=D)}}return S!==-1&&(g+=encodeURIComponent(i.substring(S))),g!==void 0?g:i}function w(i){let o;for(let u=0;u<i.length;u++){const g=i.charCodeAt(u);g===35||g===63?(o===void 0&&(o=i.substr(0,u)),o+=$[g]):o!==void 0&&(o+=i[u])}return o!==void 0?o:i}function P(i,o){let u;return i.authority&&i.path.length>1&&i.scheme==="file"?u=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?o?u=i.path.substr(1):u=i.path[1].toLowerCase()+i.path.substr(2):u=i.path,C.$i&&(u=u.replace(/\//g,"\\")),u}function a(i,o){const u=o?w:c;let g="",{scheme:S,authority:D,path:I,query:O,fragment:M}=i;if(S&&(g+=S,g+=":"),(D||S==="file")&&(g+=b,g+=b),D){let W=D.indexOf("@");if(W!==-1){const F=D.substr(0,W);D=D.substr(W+1),W=F.lastIndexOf(":"),W===-1?g+=u(F,!1,!1):(g+=u(F.substr(0,W),!1,!1),g+=":",g+=u(F.substr(W+1),!1,!0)),g+="@"}D=D.toLowerCase(),W=D.lastIndexOf(":"),W===-1?g+=u(D,!1,!0):(g+=u(D.substr(0,W),!1,!0),g+=D.substr(W))}if(I){if(I.length>=3&&I.charCodeAt(0)===47&&I.charCodeAt(2)===58){const W=I.charCodeAt(1);W>=65&&W<=90&&(I=`/${String.fromCharCode(W+32)}:${I.substr(3)}`)}else if(I.length>=2&&I.charCodeAt(1)===58){const W=I.charCodeAt(0);W>=65&&W<=90&&(I=`${String.fromCharCode(W+32)}:${I.substr(2)}`)}g+=u(I,!0,!1)}return O&&(g+="?",g+=u(O,!1,!1)),M&&(g+="#",g+=o?M:c(M,!1,!1)),g}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const r=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(i){return i.match(r)?i.replace(r,o=>t(o)):i}}),define(re[156],oe([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=C,e.$Vq=E,e.$Wq=R,e.log=k;function C(l){const d=l;return d&&typeof d.type=="string"&&typeof d.severity=="string"}function E(l){const d=[];let b;try{const v=JSON.parse(l.arguments),m=v[v.length-1];m&&m.__$stack&&(v.pop(),b=m.__$stack),d.push(...v)}catch{d.push("Unable to log remote console arguments",l.arguments)}return{args:d,stack:b}}function R(l){if(typeof l!="string")return R(E(l).stack);const d=l;if(d){const b=j(d),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:n.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function j(l){if(!l)return l;const d=l.indexOf(`
`);return d===-1?l:l.substring(0,d)}function k(l,d){const{args:b,stack:v}=E(l),m=typeof b[0]=="string"&&b.length===1;let f=j(v);f&&(f=`(${f.trim()})`);let y=[];if(typeof b[0]=="string"?f&&m?y=[`%c[${d}] %c${b[0]} %c${f}`,h("blue"),h(""),h("grey")]:y=[`%c[${d}] %c${b[0]}`,h("blue"),h(""),...b.slice(1)]:y=[`%c[${d}]%`,h("blue"),...b],f&&!m&&y.push(f),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,y)}function h(l){return`color: ${l}`}}),define(re[77],oe([0,1,17,7]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=E,e.$4h=R,e.$5h=k;function E(h){return JSON.stringify(h,j)}function R(h){let l=JSON.parse(h);return l=k(l),l}function j(h,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function k(h,l=0){if(!h||l>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return C.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof n.$Fe||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let d=0;d<h.length;++d)h[d]=k(h[d],l+1);else for(const d in h)Object.hasOwnProperty.call(h,d)&&(h[d]=k(h[d],l+1))}return h}}),define(re[13],oe([0,1,15,4,25,7,9]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Ig=e.$Hg=e.$Gg=e.Schemas=void 0,e.$Eg=h,e.$Fg=l,e.$Jg=b;var k;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(k||(e.Schemas=k={}));function h(f,y){return R.URI.isUri(f)?(0,E.$xf)(f.scheme,y):(0,E.$yf)(f,y+":")}function l(f,...y){return y.some(p=>h(f,p))}e.$Gg="vscode-tkn",e.$Hg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(y){this.d=y}setDelegate(y){this.e=y}setServerRootPath(y,p){this.f=b(y,p)}getServerRootPath(){return this.f}get g(){return j.$hc.join(this.f,k.vscodeRemoteResource)}set(y,p,$){this.a[y]=p,this.b[y]=$}setConnectionToken(y,p){this.c[y]=p}getPreferredWebSchema(){return this.d}rewrite(y){if(this.e)try{return this.e(y)}catch(a){return n.$1(a),y}const p=y.authority;let $=this.a[p];$&&$.indexOf(":")!==-1&&$.indexOf("[")===-1&&($=`[${$}]`);const c=this.b[p],w=this.c[p];let P=`path=${encodeURIComponent(y.path)}`;return typeof w=="string"&&(P+=`&${e.$Hg}=${encodeURIComponent(w)}`),R.URI.from({scheme:C.$o?this.d:k.vscodeRemoteResource,authority:`${$}:${c}`,path:this.g,query:P})}}e.$Ig=new d;function b(f,y){return j.$hc.join(y??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Kg="vs/../../extensions",e.$Lg="vs/../../node_modules",e.$Mg="vs/../../node_modules.asar",e.$Ng="vs/../../node_modules.asar.unpacked",e.$Og="vscode-app";class v{static{this.a=e.$Og}asBrowserUri(y){const p=this.b(y,X);return this.uriToBrowserUri(p)}uriToBrowserUri(y){return y.scheme===k.vscodeRemote?e.$Ig.rewrite(y):y.scheme===k.file&&(C.$m||C.$q===`${k.vscodeFileResource}://${v.a}`)?y.with({scheme:k.vscodeFileResource,authority:y.authority||v.a,query:null,fragment:null}):y}asFileUri(y){const p=this.b(y,X);return this.uriToFileUri(p)}uriToFileUri(y){return y.scheme===k.vscodeFileResource?y.with({scheme:k.file,authority:y.authority!==v.a?y.authority:null,query:null,fragment:null}):y}b(y,p){return R.URI.isUri(y)?y:R.URI.parse(p.toUrl(y))}}e.$Pg=new v;var m;(function(f){const y=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(y.get("3"));const p="vscode-coi";function $(w){let P;typeof w=="string"?P=new URL(w).searchParams:w instanceof URL?P=w.searchParams:R.URI.isUri(w)&&(P=new URL(w.toString(!0)).searchParams);const a=P?.get(p);if(a)return y.get(a)}f.getHeadersFromQuery=$;function c(w,P,a){if(!globalThis.crossOriginIsolated)return;const t=P&&a?"3":a?"2":"1";w instanceof URLSearchParams?w.set(p,t):w[p]=t}f.addSearchParam=c})(m||(e.COI=m={}))}),define(re[19],oe([0,1,31,13,9,4,25,7]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0,e.$Wg=h,e.$fh=d,e.$gh=v;function h(m){return(0,k.$xc)(m,!0)}class l{constructor(f){this.a=f}compare(f,y,p=!1){return f===y?0:(0,j.$qf)(this.getComparisonKey(f,p),this.getComparisonKey(y,p))}isEqual(f,y,p=!1){return f===y?!0:!f||!y?!1:this.getComparisonKey(f,p)===this.getComparisonKey(y,p)}getComparisonKey(f,y=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:y?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,y,p=!1){if(f.scheme===y.scheme){if(f.scheme===C.Schemas.file)return n.$ug(h(f),h(y),this.a(f))&&f.query===y.query&&(p||f.fragment===y.fragment);if((0,e.$bh)(f.authority,y.authority))return n.$ug(f.path,y.path,this.a(f),"/")&&f.query===y.query&&(p||f.fragment===y.fragment)}return!1}joinPath(f,...y){return k.URI.joinPath(f,...y)}basenameOrAuthority(f){return(0,e.$6g)(f)||f.authority}basename(f){return E.$hc.basename(f.path)}extname(f){return E.$hc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let y;return f.scheme===C.Schemas.file?y=k.URI.file(E.$nc(h(f))).path:(y=E.$hc.dirname(f.path),f.authority&&y.length&&y.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),y="/")),f.with({path:y})}normalizePath(f){if(!f.path.length)return f;let y;return f.scheme===C.Schemas.file?y=k.URI.file(E.$ic(h(f))).path:y=E.$hc.normalize(f.path),f.with({path:y})}relativePath(f,y){if(f.scheme!==y.scheme||!(0,e.$bh)(f.authority,y.authority))return;if(f.scheme===C.Schemas.file){const c=E.$mc(h(f),h(y));return R.$i?n.$og(c):c}let p=f.path||"/";const $=y.path||"/";if(this.a(f)){let c=0;for(const w=Math.min(p.length,$.length);c<w&&!(p.charCodeAt(c)!==$.charCodeAt(c)&&p.charAt(c).toLowerCase()!==$.charAt(c).toLowerCase());c++);p=$.substr(0,c)+p.substr(c)}return E.$hc.relative(p,$)}resolvePath(f,y){if(f.scheme===C.Schemas.file){const p=k.URI.file(E.$lc(h(f),y));return f.with({authority:p.authority,path:p.path})}return y=n.$pg(y),f.with({path:E.$hc.resolve(f.path,y)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,y){return f===y||f!==void 0&&y!==void 0&&(0,j.$xf)(f,y)}hasTrailingPathSeparator(f,y=E.sep){if(f.scheme===C.Schemas.file){const p=h(f);return p.length>n.$qg(p).length&&p[p.length-1]===y}else{const p=f.path;return p.length>1&&p.charCodeAt(p.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,y=E.sep){return(0,e.$ch)(f,y)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,y=E.sep){let p=!1;if(f.scheme===C.Schemas.file){const $=h(f);p=$!==void 0&&$.length===n.$qg($).length&&$[$.length-1]===y}else{y="/";const $=f.path;p=$.length===1&&$.charCodeAt($.length-1)===47}return!p&&!(0,e.$ch)(f,y)?f.with({path:f.path+"/"}):f}}e.$Xg=l,e.$Yg=new l(()=>!1),e.$Zg=new l(m=>m.scheme===C.Schemas.file?!R.$k:!0),e.$1g=new l(m=>!0),e.$2g=e.$Yg.isEqual.bind(e.$Yg),e.$3g=e.$Yg.isEqualOrParent.bind(e.$Yg),e.$4g=e.$Yg.getComparisonKey.bind(e.$Yg),e.$5g=e.$Yg.basenameOrAuthority.bind(e.$Yg),e.$6g=e.$Yg.basename.bind(e.$Yg),e.$7g=e.$Yg.extname.bind(e.$Yg),e.$8g=e.$Yg.dirname.bind(e.$Yg),e.$9g=e.$Yg.joinPath.bind(e.$Yg),e.$0g=e.$Yg.normalizePath.bind(e.$Yg),e.$$g=e.$Yg.relativePath.bind(e.$Yg),e.$_g=e.$Yg.resolvePath.bind(e.$Yg),e.$ah=e.$Yg.isAbsolutePath.bind(e.$Yg),e.$bh=e.$Yg.isEqualAuthority.bind(e.$Yg),e.$ch=e.$Yg.hasTrailingPathSeparator.bind(e.$Yg),e.$dh=e.$Yg.removeTrailingPathSeparator.bind(e.$Yg),e.$eh=e.$Yg.addTrailingPathSeparator.bind(e.$Yg);function d(m,f){const y=[];for(let p=0;p<m.length;p++){const $=f(m[p]);m.some((c,w)=>w===p?!1:(0,e.$3g)($,f(c)))||y.push(m[p])}return y}var b;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function f(y){const p=new Map;y.path.substring(y.path.indexOf(";")+1,y.path.lastIndexOf(";")).split(";").forEach(w=>{const[P,a]=w.split(":");P&&a&&p.set(P,a)});const c=y.path.substring(0,y.path.indexOf(";"));return c&&p.set(m.META_DATA_MIME,c),p}m.parseMetaData=f})(b||(e.DataUri=b={}));function v(m,f,y){if(f){let p=m.path;return p&&p[0]!==E.$hc.sep&&(p=E.$hc.sep+p),m.with({scheme:y,authority:f,path:p})}return m.with({scheme:y})}}),define(re[8],oe([0,1,23,15,3,2,19,4,144,62]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.Promises=e.$Sh=e.$Rh=e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0,e.$hh=d,e.$ih=b,e.$jh=v,e.$kh=m,e.$lh=f,e.$mh=y,e.$nh=p,e.$oh=$,e.$wh=u,e.$xh=g,e.$yh=S,e.$zh=D,e.$Ah=I,e.$Ph=L,e.$Xh=J;function d(x){return!!x&&typeof x.then=="function"}function b(x){const H=new n.$pe,se=x(H.token),he=new Promise((me,$e)=>{const ye=H.token.onCancellationRequested(()=>{ye.dispose(),$e(new C.$5)});Promise.resolve(se).then(Pe=>{ye.dispose(),H.dispose(),me(Pe)},Pe=>{ye.dispose(),H.dispose(),$e(Pe)})});return new class{cancel(){H.cancel(),H.dispose()}then(me,$e){return he.then(me,$e)}catch(me){return this.then(void 0,me)}finally(me){return he.finally(me)}}}function v(x,H,se){return new Promise((he,me)=>{const $e=H.onCancellationRequested(()=>{$e.dispose(),he(se)});x.then(he,me).finally(()=>$e.dispose())})}function m(x,H){return new Promise((se,he)=>{const me=H.onCancellationRequested(()=>{me.dispose(),he(new C.$5)});x.then(se,he).finally(()=>me.dispose())})}async function f(x){let H=-1;const se=x.map((he,me)=>he.then($e=>(H=me,$e)));try{return await Promise.race(se)}finally{x.forEach((he,me)=>{me!==H&&he.cancel()})}}function y(x,H,se){let he;const me=setTimeout(()=>{he?.(void 0),se?.()},H);return Promise.race([x.finally(()=>clearTimeout(me)),new Promise($e=>he=$e)])}function p(x){return new Promise((H,se)=>{const he=x();d(he)?he.then(H,se):H(he)})}function $(){let x,H;return{promise:new Promise((he,me)=>{x=he,H=me}),resolve:x,reject:H}}class c{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(H){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=H,!this.b){const se=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(se,se).then(he)})}return new Promise((se,he)=>{this.b.then(se,he)})}return this.a=H(),new Promise((se,he)=>{this.a.then(me=>{this.a=null,se(me)},me=>{this.a=null,he(me)})})}dispose(){this.f=!0}}e.$ph=c;class w{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.$qh=w;class P{constructor(){this.a=new Map}queue(H,se){const me=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(se).finally(()=>{this.a.get(H)===me&&this.a.delete(H)});return this.a.set(H,me),me}}e.$rh=P;const a=(x,H)=>{let se=!0;const he=setTimeout(()=>{se=!1,H()},x);return{isTriggered:()=>se,dispose:()=>{clearTimeout(he),se=!1}}},t=x=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,x())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class r{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,se=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((me,$e)=>{this.d=me,this.f=$e}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=se===h.$be?t(he):a(se,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sh=r;class s{constructor(H){this.a=new r(H),this.b=new c}trigger(H,se){return this.a.trigger(()=>this.b.queue(H),se)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$th=s;class i{constructor(){this.a=!1,this.b=new Promise((H,se)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$uh=i;class o extends i{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.$vh=o;function u(x,H){return H?new Promise((se,he)=>{const me=setTimeout(()=>{$e.dispose(),se()},x),$e=H.onCancellationRequested(()=>{clearTimeout(me),$e.dispose(),he(new C.$5)})}):b(se=>u(x,se))}function g(x,H=0,se){const he=setTimeout(()=>{x(),se&&me.dispose()},H),me=(0,R.$Tc)(()=>{clearTimeout(he),se?.deleteAndLeak(me)});return se?.add(me),me}function S(x){const H=[];let se=0;const he=x.length;function me(){return se<he?x[se++]():null}function $e(ye){ye!=null&&H.push(ye);const Pe=me();return Pe?Pe.then($e):Promise.resolve(H)}return Promise.resolve(null).then($e)}function D(x,H=he=>!!he,se=null){let he=0;const me=x.length,$e=()=>{if(he>=me)return Promise.resolve(se);const ye=x[he++];return Promise.resolve(ye()).then(ke=>H(ke)?Promise.resolve(ke):$e())};return $e()}function I(x,H=he=>!!he,se=null){if(x.length===0)return Promise.resolve(se);let he=x.length;const me=()=>{he=-1;for(const $e of x)$e.cancel?.()};return new Promise(($e,ye)=>{for(const Pe of x)Pe.then(ke=>{--he>=0&&H(ke)?(me(),$e(ke)):he===0&&$e(se)}).catch(ke=>{--he>=0&&(me(),ye(ke))})})}class O{constructor(H){this.a=0,this.b=!1,this.f=H,this.g=[],this.d=0,this.h=new E.$ee}whenIdle(){return this.size>0?E.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(H){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((se,he)=>{this.g.push({factory:H,c:se,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const H=this.g.shift();this.d++;const se=H.factory();se.then(H.c,H.e),se.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Bh=O;class M extends O{constructor(){super(1)}}e.$Ch=M;class W{constructor(){this.a=new z,this.b=0}queue(H){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,H())):this.a.run(this.b++,H())}}e.$Dh=W;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const H=new G;return this.b.add(H),H.p}g(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueSize(H,se=j.$Yg){const he=se.getComparisonKey(H);return this.a.get(he)?.size??0}queueFor(H,se,he=j.$Yg){const me=he.getComparisonKey(H);let $e=this.a.get(me);if(!$e){$e=new M;const ye=this.f++,Pe=E.Event.once($e.onDrained)(()=>{$e?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(ye),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new R.$5c),this.d.set(ye,Pe),this.a.set(me,$e)}return $e.queue(se)}h(){this.g()&&this.j()}j(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Eh=F;class T{constructor(H,se){this.a=-1,typeof H=="function"&&typeof se=="number"&&this.setIfNotSet(H,se)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,se){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},se)}setIfNotSet(H,se){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},se))}}e.$Fh=T;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(H,se,he=globalThis){this.cancel();const me=he.setInterval(()=>{H()},se);this.d=(0,R.$Tc)(()=>{he.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$Gh=q;class ue{constructor(H,se){this.b=-1,this.a=H,this.d=se,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Hh=ue;class ee{constructor(H,se){se%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${se}ms is not a multiple of 1000ms.`),this.a=H,this.b=se,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ih=ee;class ce extends ue{constructor(H,se){super(H,se),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.$Jh=ce;class K extends R.$Vc{constructor(H,se){super(),this.g=H,this.h=se,this.a=[],this.b=this.B(new R.$Wc),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const se of H)this.a.push(se);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ue(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Kh=K,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Mh=(x,H)=>{(0,k.$B)(()=>{if(se)return;const he=Date.now()+15;H(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let se=!1;return{dispose(){se||(se=!0)}}}:e.$Mh=(x,H,se)=>{const he=x.requestIdleCallback(H,typeof se=="number"?{timeout:se}:void 0);let me=!1;return{dispose(){me||(me=!0,x.cancelIdleCallback(he))}}},e.$Lh=x=>(0,e.$Mh)(globalThis,x)}();class Q{constructor(H,se){this.g=!1,this.d=()=>{try{this.j=se()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Mh)(H,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Nh=Q;class B extends Q{constructor(H){super(globalThis,H)}}e.$Oh=B;async function L(x,H,se){let he;for(let me=0;me<se;me++)try{return await x()}catch($e){he=$e,await u(H)}throw he}class z{isRunning(H){return typeof H=="number"?this.a?.taskId===H:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(H,se,he){return this.a={taskId:H,cancel:()=>he?.(),promise:se},se.then(()=>this.d(H),()=>this.d(H)),se}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}queue(H){if(this.b)this.b.run=H;else{const{promise:se,resolve:he,reject:me}=$();this.b={run:H,promise:se,promiseResolve:he,promiseReject:me}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Qh=z;class U{constructor(H,se=()=>Date.now()){this.d=H,this.f=se,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.$Rh=U;var ae;(function(x){x[x.Resolved=0]="Resolved",x[x.Rejected=1]="Rejected"})(ae||(ae={}));class G{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((H,se)=>{this.a=H,this.b=se})}complete(H){return new Promise(se=>{this.a(H),this.d={outcome:0,value:H},se()})}error(H){return new Promise(se=>{this.b(H),this.d={outcome:1,value:H},se()})}cancel(){return this.error(new C.$5)}}e.$Sh=G;var le;(function(x){async function H(he){let me;const $e=await Promise.all(he.map(ye=>ye.then(Pe=>Pe,Pe=>{me||(me=Pe)})));if(typeof me<"u")throw me;return $e}x.settled=H;function se(he){return new Promise(async(me,$e)=>{try{await he(me,$e)}catch(ye){$e(ye)}})}x.withAsyncBody=se})(le||(e.Promises=le={}));class Y{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(H){this.a=void 0,this.b=void 0,this.d=!1,this.promise=H.then(se=>(this.a=se,this.d=!0,se),se=>{throw this.b=se,this.d=!0,se})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Th=Y;class A{constructor(H){this.b=H,this.a=new l.$V(()=>new Y(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Uh=A;var N;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(N||(N={}));class _{static fromArray(H){return new _(se=>{se.emitMany(H)})}static fromPromise(H){return new _(async se=>{se.emitMany(await H)})}static fromPromises(H){return new _(async se=>{await Promise.all(H.map(async he=>se.emitOne(await he)))})}static merge(H){return new _(async se=>{await Promise.all(H.map(async he=>{for await(const me of he)se.emitOne(me)}))})}static{this.EMPTY=_.fromArray([])}constructor(H,se){this.a=0,this.b=[],this.d=null,this.f=se,this.g=new E.$ee,queueMicrotask(async()=>{const he={emitOne:me=>this.h(me),emitMany:me=>this.j(me),reject:me=>this.l(me)};try{await Promise.resolve(H(he)),this.k()}catch(me){this.l(me)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await E.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(H,se){return new _(async he=>{for await(const me of H)he.emitOne(se(me))})}map(H){return _.map(this,H)}static filter(H,se){return new _(async he=>{for await(const me of H)se(me)&&he.emitOne(me)})}filter(H){return _.filter(this,H)}static coalesce(H){return _.filter(H,se=>!!se)}coalesce(){return _.coalesce(this)}static async toPromise(H){const se=[];for await(const he of H)se.push(he);return se}toPromise(){return _.toPromise(this)}h(H){this.a===0&&(this.b.push(H),this.g.fire())}j(H){this.a===0&&(this.b=this.b.concat(H),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(H){this.a===0&&(this.a=2,this.d=H,this.g.fire())}}e.$Vh=_;class ne extends _{constructor(H,se){super(se),this.m=H}cancel(){this.m.cancel()}}e.$Wh=ne;function J(x){const H=new n.$pe,se=x(H.token);return new ne(H,async he=>{const me=H.token.onCancellationRequested(()=>{me.dispose(),H.dispose(),he.reject(new C.$5)});try{for await(const $e of se){if(H.token.isCancellationRequested)return;he.emitOne($e)}me.dispose(),H.dispose()}catch($e){me.dispose(),H.dispose(),he.reject($e)}})}class V{constructor(H){this.a=new G,this.b=new _(me=>{if(se){me.reject(se);return}return he&&me.emitMany(he),this.d=$e=>me.reject($e),this.f=$e=>me.emitOne($e),this.a.p},H);let se,he;this.f=me=>{he||(he=[]),he.push(me)},this.d=me=>{se||(se=me)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(H){this.d(H),this.a.complete()}emitOne(H){this.f(H)}}e.$Yh=V}),define(re[108],oe([0,1,22,8,31,32,9,4,25]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$kk=l,e.$nk=f,e.$ok=M,e.$pk=W,e.$qk=F,e.$rk=T,e.$sk=q,e.$tk=K;function l(){return Object.create(null)}e.$lk="**",e.$mk="/";const d="[/\\\\]",b="[^/\\\\]",v=/\//g;function m(Q,B){switch(Q){case 0:return"";case 1:return`${b}*?`;default:return`(?:${d}|${b}+${d}${B?`|${d}${b}+`:""})*?`}}function f(Q,B){if(!Q)return[];const L=[];let z=!1,U=!1,ae="";for(const G of Q){switch(G){case B:if(!z&&!U){L.push(ae),ae="";continue}break;case"{":z=!0;break;case"}":z=!1;break;case"[":U=!0;break;case"]":U=!1;break}ae+=G}return ae&&L.push(ae),L}function y(Q){if(!Q)return"";let B="";const L=f(Q,e.$mk);if(L.every(z=>z===e.$lk))B=".*";else{let z=!1;L.forEach((U,ae)=>{if(U===e.$lk){if(z)return;B+=m(2,ae===L.length-1)}else{let G=!1,le="",Y=!1,A="";for(const N of U){if(N!=="}"&&G){le+=N;continue}if(Y&&(N!=="]"||!A)){let _;N==="-"?_=N:(N==="^"||N==="!")&&!A?_="^":N===e.$mk?_="":_=(0,h.$_e)(N),A+=_;continue}switch(N){case"{":G=!0;continue;case"[":Y=!0;continue;case"}":{const ne=`(?:${f(le,",").map(J=>y(J)).join("|")})`;B+=ne,G=!1,le="";break}case"]":{B+="["+A+"]",Y=!1,A="";break}case"?":B+=b;continue;case"*":B+=m(1);continue;default:B+=(0,h.$_e)(N)}}ae<L.length-1&&(L[ae+1]!==e.$lk||ae+2<L.length)&&(B+=d)}z=U===e.$lk})}return B}const p=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,w=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,P=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new R.$Ec(1e4),r=function(){return!1},s=function(){return null};function i(Q,B){if(!Q)return s;let L;typeof Q!="string"?L=Q.pattern:L=Q,L=L.trim();const z=`${L}_${!!B.trimForExclusions}`;let U=t.get(z);if(U)return o(U,Q);let ae;return p.test(L)?U=g(L.substr(4),L):(ae=$.exec(u(L,B)))?U=S(ae[1],L):(B.trimForExclusions?w:c).test(L)?U=D(L,B):(ae=P.exec(u(L,B)))?U=I(ae[1].substr(1),L,!0):(ae=a.exec(u(L,B)))?U=I(ae[1],L,!1):U=O(L),t.set(z,U),o(U,Q)}function o(Q,B){if(typeof B=="string")return Q;const L=function(z,U){return(0,E.$ug)(z,B.base,!k.$k)?Q((0,h.$ef)(z.substr(B.base.length),j.sep),U):null};return L.allBasenames=Q.allBasenames,L.allPaths=Q.allPaths,L.basenames=Q.basenames,L.patterns=Q.patterns,L}function u(Q,B){return B.trimForExclusions&&Q.endsWith("/**")?Q.substr(0,Q.length-2):Q}function g(Q,B){return function(L,z){return typeof L=="string"&&L.endsWith(Q)?B:null}}function S(Q,B){const L=`/${Q}`,z=`\\${Q}`,U=function(G,le){return typeof G!="string"?null:le?le===Q?B:null:G===Q||G.endsWith(L)||G.endsWith(z)?B:null},ae=[Q];return U.basenames=ae,U.patterns=[B],U.allBasenames=ae,U}function D(Q,B){const L=ce(Q.slice(1,-1).split(",").map(le=>i(le,B)).filter(le=>le!==s),Q),z=L.length;if(!z)return s;if(z===1)return L[0];const U=function(le,Y){for(let A=0,N=L.length;A<N;A++)if(L[A](le,Y))return Q;return null},ae=L.find(le=>!!le.allBasenames);ae&&(U.allBasenames=ae.allBasenames);const G=L.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return G.length&&(U.allPaths=G),U}function I(Q,B,L){const z=j.sep===j.$hc.sep,U=z?Q:Q.replace(v,j.sep),ae=j.sep+U,G=j.$hc.sep+Q;let le;return L?le=function(Y,A){return typeof Y=="string"&&(Y===U||Y.endsWith(ae)||!z&&(Y===Q||Y.endsWith(G)))?B:null}:le=function(Y,A){return typeof Y=="string"&&(Y===U||!z&&Y===Q)?B:null},le.allPaths=[(L?"*/":"./")+Q],le}function O(Q){try{const B=new RegExp(`^${y(Q)}$`);return function(L){return B.lastIndex=0,typeof L=="string"&&B.test(L)?Q:null}}catch{return s}}function M(Q,B,L){return!Q||typeof B!="string"?!1:W(Q)(B,void 0,L)}function W(Q,B={}){if(!Q)return r;if(typeof Q=="string"||F(Q)){const L=i(Q,B);if(L===s)return r;const z=function(U,ae){return!!L(U,ae)};return L.allBasenames&&(z.allBasenames=L.allBasenames),L.allPaths&&(z.allPaths=L.allPaths),z}return ue(Q,B)}function F(Q){const B=Q;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}function T(Q){return Q.allBasenames||[]}function q(Q){return Q.allPaths||[]}function ue(Q,B){const L=ce(Object.getOwnPropertyNames(Q).map(le=>ee(le,Q[le],B)).filter(le=>le!==s)),z=L.length;if(!z)return s;if(!L.some(le=>!!le.requiresSiblings)){if(z===1)return L[0];const le=function(N,_){let ne;for(let J=0,V=L.length;J<V;J++){const x=L[J](N,_);if(typeof x=="string")return x;(0,C.$hh)(x)&&(ne||(ne=[]),ne.push(x))}return ne?(async()=>{for(const J of ne){const V=await J;if(typeof V=="string")return V}return null})():null},Y=L.find(N=>!!N.allBasenames);Y&&(le.allBasenames=Y.allBasenames);const A=L.reduce((N,_)=>_.allPaths?N.concat(_.allPaths):N,[]);return A.length&&(le.allPaths=A),le}const U=function(le,Y,A){let N,_;for(let ne=0,J=L.length;ne<J;ne++){const V=L[ne];V.requiresSiblings&&A&&(Y||(Y=(0,j.$oc)(le)),N||(N=Y.substr(0,Y.length-(0,j.$pc)(le).length)));const x=V(le,Y,N,A);if(typeof x=="string")return x;(0,C.$hh)(x)&&(_||(_=[]),_.push(x))}return _?(async()=>{for(const ne of _){const J=await ne;if(typeof J=="string")return J}return null})():null},ae=L.find(le=>!!le.allBasenames);ae&&(U.allBasenames=ae.allBasenames);const G=L.reduce((le,Y)=>Y.allPaths?le.concat(Y.allPaths):le,[]);return G.length&&(U.allPaths=G),U}function ee(Q,B,L){if(B===!1)return s;const z=i(Q,L);if(z===s)return s;if(typeof B=="boolean")return z;if(B){const U=B.when;if(typeof U=="string"){const ae=(G,le,Y,A)=>{if(!A||!z(G,le))return null;const N=U.replace("$(basename)",()=>Y),_=A(N);return(0,C.$hh)(_)?_.then(ne=>ne?Q:null):_?Q:null};return ae.requiresSiblings=!0,ae}}return z}function ce(Q,B){const L=Q.filter(le=>!!le.basenames);if(L.length<2)return Q;const z=L.reduce((le,Y)=>{const A=Y.basenames;return A?le.concat(A):le},[]);let U;if(B){U=[];for(let le=0,Y=z.length;le<Y;le++)U.push(B)}else U=L.reduce((le,Y)=>{const A=Y.patterns;return A?le.concat(A):le},[]);const ae=function(le,Y){if(typeof le!="string")return null;if(!Y){let N;for(N=le.length;N>0;N--){const _=le.charCodeAt(N-1);if(_===47||_===92)break}Y=le.substr(N)}const A=z.indexOf(Y);return A!==-1?U[A]:null};ae.basenames=z,ae.patterns=U,ae.allBasenames=z;const G=Q.filter(le=>!le.basenames);return G.push(ae),G}function K(Q,B){return(0,n.$ub)(Q,B,(L,z)=>typeof L=="string"&&typeof z=="string"?L===z:typeof L!="string"&&typeof z!="string"?L.base===z.base&&L.pattern===z.pattern:!1)}}),define(re[48],oe([0,1,22,31,9,4,19,25]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=h,e.$xw=d,e.$yw=v,e.$zw=m,e.$Aw=$,e.$Bw=w,e.$Cw=P,e.$Dw=a,e.$Ew=t,e.$Fw=r;function h(i,o){const{os:u,tildify:g,relative:S}=o;if(S){const O=l(i,S,u);if(typeof O=="string")return O}let D=i.fsPath;if(u===1&&!R.$i?D=D.replace(/\//g,"\\"):u!==1&&R.$i&&(D=D.replace(/\\/g,"/")),u!==1&&g?.userHome){const O=g.userHome.fsPath;let M;i.scheme!==g.userHome.scheme&&i.path[0]===E.$hc.sep&&i.path[1]!==E.$hc.sep?M=g.userHome.with({path:i.path}).fsPath:M=D,D=v(M,O,u)}return(u===1?E.$gc:E.$hc).normalize(d(D,u===1))}function l(i,o,u){const g=u===1?E.$gc:E.$hc,S=u===3?j.$Yg:j.$1g,D=o.getWorkspace(),I=(0,n.$Ob)(D.folders);if(!I)return;i.scheme!==I.uri.scheme&&i.path[0]===E.$hc.sep&&i.path[1]!==E.$hc.sep&&(i=I.uri.with({path:i.path}));const O=o.getWorkspaceFolder(i);if(!O)return;let M;if(S.isEqual(O.uri,i)?M="":M=S.relativePath(O.uri,i)??"",M&&(M=g.normalize(M)),D.folders.length>1&&!o.noPrefix){const W=O.name?O.name:S.basenameOrAuthority(O.uri);M=M?`${W} \u2022 ${M}`:W}return M}function d(i,o=R.$i){return(0,C.$zg)(i,o)?i.charAt(0).toUpperCase()+i.slice(1):i}let b=Object.create(null);function v(i,o,u=R.OS){if(u===1||!i||!o)return i;let g=b.original===o?b.normalized:void 0;g||(g=o,R.$i&&(g=(0,C.$og)(g)),g=`${(0,k.$ff)(g,E.$hc.sep)}${E.$hc.sep}`,b={original:o,normalized:g});let S=i;return R.$i&&(S=(0,C.$og)(S)),(u===3?S.startsWith(g):(0,k.$yf)(S,g))?`~/${S.substr(g.length)}`:i}function m(i,o){return i.replace(/^~($|\/|\\)/,`${o}$1`)}const f="\u2026",y="\\\\",p="~";function $(i,o=E.sep){const u=new Array(i.length);let g=!1;for(let S=0;S<i.length;S++){const D=i[S];if(D===""){u[S]=`.${o}`;continue}if(!D){u[S]=D;continue}g=!0;let I="",O=D;O.indexOf(y)===0?(I=O.substr(0,O.indexOf(y)+y.length),O=O.substr(O.indexOf(y)+y.length)):O.indexOf(o)===0?(I=O.substr(0,O.indexOf(o)+o.length),O=O.substr(O.indexOf(o)+o.length)):O.indexOf(p)===0&&(I=O.substr(0,O.indexOf(p)+p.length),O=O.substr(O.indexOf(p)+p.length));const M=O.split(o);for(let W=1;g&&W<=M.length;W++)for(let F=M.length-W;g&&F>=0;F--){g=!1;let T=M.slice(F,F+W).join(o);for(let q=0;!g&&q<i.length;q++)if(q!==S&&i[q]&&i[q].indexOf(T)>-1){const ue=F+W===M.length,ee=F>0&&i[q].indexOf(o)>-1?o+T:T,ce=i[q].endsWith(ee);g=!ue||ce}if(!g){let q="";(M[0].endsWith(":")||I!=="")&&(F===1&&(F=0,W++,T=M[0]+o+T),F>0&&(q=M[0]+o),q=I+q),F>0&&(q=q+f+o),q=q+T,F+W<M.length&&(q=q+o+f),u[S]=q}}g&&(u[S]=D)}return u}var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function w(i,o=Object.create(null)){const u=[];let g=!1,S="";for(const D of i)if(D==="$"||g&&D==="{")S&&u.push({value:S,type:c.TEXT}),S="",g=!0;else if(D==="}"&&g){const I=o[S];if(typeof I=="string")I.length&&u.push({value:I,type:c.VARIABLE});else if(I){const O=u[u.length-1];(!O||O.type!==c.SEPARATOR)&&u.push({value:I.label,type:c.SEPARATOR})}S="",g=!1}else S+=D;return S&&!g&&u.push({value:S,type:c.TEXT}),u.filter((D,I)=>{if(D.type===c.SEPARATOR){const O=u[I-1],M=u[I+1];return[O,M].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(D=>D.value).join("")}function P(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.$j?"&":"&&"):i.replace(/&&|&/g,u=>u==="&"?"&&":"&")}function a(i,o){return R.$j||o?i.replace(/\(&&\w\)|&&/g,""):R.$i?i.replace(/&&|&/g,u=>u==="&"?"&&":"&"):i.replace(/&&/g,"_")}function t(i){return i.replace(/&/g,"&&")}function r(i){if(i.endsWith("]")){const o=i.lastIndexOf(" [",i.length-2);if(o!==-1){const u=s(i.substring(0,o)),g=i.substring(o);return{name:u.name+g,parentPath:u.parentPath}}}return s(i)}function s(i){const o=i.indexOf("/")!==-1?E.$hc:E.$gc,u=o.basename(i),g=o.dirname(i);return u.length?{name:u,parentPath:g}:{name:g,parentPath:""}}}),define(re[157],oe([0,1,17,7]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0,e.$zn=k,e.$An=l,e.$Bn=d;function E(b){return b.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const m=this.a.transformIncoming(v);return m===v?v:E(C.URI.from(m))}transformOutgoing(v){const m=this.a.transformOutgoing(v);return m===v?v:E(C.URI.from(m))}transformOutgoingURI(v){const m=this.a.transformOutgoing(v);return m===v?v:C.URI.from(m)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$xn=R,e.$yn=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function j(b,v,m){if(!b||m>200)return null;if(typeof b=="object"){if(b instanceof C.URI)return v.transformOutgoing(b);for(const f in b)if(Object.hasOwnProperty.call(b,f)){const y=j(b[f],v,m+1);y!==null&&(b[f]=y)}}return null}function k(b,v){const m=j(b,v,0);return m===null?b:m}function h(b,v,m,f){if(!b||f>200)return null;if(typeof b=="object"){if(b.$mid===1)return m?C.URI.revive(v.transformIncoming(b)):v.transformIncoming(b);if(b instanceof n.$Fe)return null;for(const y in b)if(Object.hasOwnProperty.call(b,y)){const p=h(b[y],v,m,f+1);p!==null&&(b[y]=p)}}return null}function l(b,v){const m=h(b,v,!1,0);return m===null?b:m}function d(b,v){const m=h(b,v,!0,0);return m===null?b:m}}),define(re[89],oe([0,1,26,59,33,147,4]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dn=void 0,e.$En=h,e.$Fn=b,e.$Dn=new class{c(v){return this.a||(this.a=C.$Bi.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,m=0;const f=(0,n.networkInterfaces)();for(const y in f){const p=f[y];if(p)for(const{mac:$,internal:c}of p)c||(m+=1,this.c($.toUpperCase())&&(v+=1))}this.b=m>0?v/m:0}return this.b}};let k;async function h(v){return k||(k=(async()=>await l(v)||E.$Rg())()),k}async function l(v){try{const m=await new Promise((y,p)=>{X(["crypto"],y,p)}),f=(0,R.$Cn)();return m.createHash("sha256").update(f,"utf8").digest("hex")}catch(m){v(m);return}}const d="Software\\Microsoft\\SQMClient";async function b(v){if(j.$i){const m=await new Promise((f,y)=>{X(["@vscode/windows-registry"],f,y)});try{return m.GetStringRegKey("HKEY_LOCAL_MACHINE",d,"MachineId")||""}catch(f){return v(f),""}}return""}}),define(re[21],oe([0,1,43,26,158,8,31,72,9,4,19,7]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.SymlinkSupport=e.RimRafMode=void 0,e.rimrafSync=p,e.readdirSync=w,e.whenDeleted=t,e.configureFlushOnWrite=u,e.writeFileSync=S;var v;(function(ee){ee[ee.UNLINK=0]="UNLINK",ee[ee.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function m(ee,ce=v.UNLINK,K){if((0,j.$yg)(ee))throw new Error("rimraf - will refuse to recursively delete root");return ce===v.UNLINK?y(ee):f(ee,K)}async function f(ee,ce=(0,j.$Dg)((0,C.tmpdir)())){try{try{await n.promises.rename(ee,ce)}catch(K){return K.code==="ENOENT"?void 0:y(ee)}y(ce).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function y(ee){return(0,E.promisify)(n.rm)(ee,{recursive:!0,force:!0,maxRetries:3})}function p(ee){if((0,j.$yg)(ee))throw new Error("rimraf - will refuse to recursively delete root");n.rmSync(ee,{recursive:!0,force:!0,maxRetries:3})}async function $(ee,ce){return P(await(ce?c(ee):(0,E.promisify)(n.readdir)(ee)))}async function c(ee){try{return await(0,E.promisify)(n.readdir)(ee,{withFileTypes:!0})}catch(Q){console.warn("[node.js fs] readdir with filetypes failed with error: ",Q)}const ce=[],K=await $(ee);for(const Q of K){let B=!1,L=!1,z=!1;try{const U=await e.Promises.lstat((0,h.$kc)(ee,Q));B=U.isFile(),L=U.isDirectory(),z=U.isSymbolicLink()}catch(U){console.warn("[node.js fs] unexpected error from lstat after readdir: ",U)}ce.push({name:Q,isFile:()=>B,isDirectory:()=>L,isSymbolicLink:()=>z})}return ce}function w(ee){return P(n.readdirSync(ee))}function P(ee){return ee.map(ce=>typeof ce=="string"?l.$j?(0,k.$am)(ce):ce:(ce.name=l.$j?(0,k.$am)(ce.name):ce.name,ce))}async function a(ee){const ce=await $(ee),K=[];for(const Q of ce)await r.existsDirectory((0,h.$kc)(ee,Q))&&K.push(Q);return K}function t(ee,ce=1e3){return new Promise(K=>{let Q=!1;const B=setInterval(()=>{Q||(Q=!0,n.access(ee,L=>{Q=!1,L&&(clearInterval(B),K(void 0))}))},ce)})}var r;(function(ee){async function ce(B){let L;try{if(L=await e.Promises.lstat(B),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(B),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(B)),symbolicLink:{dangling:!1}}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw U}throw z}}ee.stat=ce;async function K(B){try{const{stat:L,symbolicLink:z}=await ee.stat(B);return L.isFile()&&z?.dangling!==!0}catch{}return!1}ee.existsFile=K;async function Q(B){try{const{stat:L,symbolicLink:z}=await ee.stat(B);return L.isDirectory()&&z?.dangling!==!0}catch{}return!1}ee.existsDirectory=Q})(r||(e.SymlinkSupport=r={}));const s=new R.$Eh;function i(ee,ce,K){return s.queueFor(b.URI.file(ee),()=>{const Q=D(K);return new Promise((B,L)=>g(ee,ce,Q,z=>z?L(z):B()))},d.$Zg)}let o=!0;function u(ee){o=ee}function g(ee,ce,K,Q){if(!o)return n.writeFile(ee,ce,{mode:K.mode,flag:K.flag},Q);n.open(ee,K.flag,K.mode,(B,L)=>{if(B)return Q(B);n.writeFile(L,ce,z=>{if(z)return n.close(L,()=>Q(z));n.fdatasync(L,U=>(U&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",U),u(!1)),n.close(L,ae=>Q(ae))))})})}function S(ee,ce,K){const Q=D(K);if(!o)return n.writeFileSync(ee,ce,{mode:Q.mode,flag:Q.flag});const B=n.openSync(ee,Q.flag,Q.mode);try{n.writeFileSync(B,ce);try{n.fdatasyncSync(B)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),u(!1)}}finally{n.closeSync(B)}}function D(ee){return ee?{mode:typeof ee.mode=="number"?ee.mode:438,flag:typeof ee.flag=="string"?ee.flag:"w"}:{mode:438,flag:"w"}}async function I(ee,ce,K=6e4){if(ee!==ce)try{l.$i&&typeof K=="number"?await O(ee,ce,Date.now(),K):await(0,E.promisify)(n.rename)(ee,ce)}catch(Q){if(ee.toLowerCase()!==ce.toLowerCase()&&Q.code==="EXDEV"||ee.endsWith("."))await M(ee,ce,{preserveSymlinks:!1}),await m(ee,v.MOVE);else throw Q}}async function O(ee,ce,K,Q,B=0){try{return await(0,E.promisify)(n.rename)(ee,ce)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-K>=Q)throw console.error(`[node.js fs] rename failed after ${B} retries with error: ${L}`),L;if(B===0){let z=!1;try{const{stat:U}=await r.stat(ce);U.isFile()||(z=!0)}catch{}if(z)throw L}return await(0,R.$wh)(Math.min(100,B*10)),O(ee,ce,K,Q,B+1)}}async function M(ee,ce,K){return F(ee,ce,{root:{source:ee,target:ce},options:K,handledSourcePaths:new Set})}const W=511;async function F(ee,ce,K){if(K.handledSourcePaths.has(ee))return;K.handledSourcePaths.add(ee);const{stat:Q,symbolicLink:B}=await r.stat(ee);if(B){if(K.options.preserveSymlinks)try{return await ue(ee,ce,K)}catch{}if(B.dangling)return}return Q.isDirectory()?T(ee,ce,Q.mode&W,K):q(ee,ce,Q.mode&W)}async function T(ee,ce,K,Q){await e.Promises.mkdir(ce,{recursive:!0,mode:K});const B=await $(ee);for(const L of B)await F((0,h.$kc)(ee,L),(0,h.$kc)(ce,L),Q)}async function q(ee,ce,K){await e.Promises.copyFile(ee,ce),await e.Promises.chmod(ce,K)}async function ue(ee,ce,K){let Q=await e.Promises.readlink(ee);(0,j.$ug)(Q,K.root.source,!l.$k)&&(Q=(0,h.$kc)(K.root.target,Q.substr(K.root.source.length+1))),await e.Promises.symlink(Q,ce)}e.Promises=new class{get access(){return(0,E.promisify)(n.access)}get stat(){return(0,E.promisify)(n.stat)}get lstat(){return(0,E.promisify)(n.lstat)}get utimes(){return(0,E.promisify)(n.utimes)}get read(){return(ee,ce,K,Q,B)=>new Promise((L,z)=>{n.read(ee,ce,K,Q,B,(U,ae,G)=>U?z(U):L({bytesRead:ae,buffer:G}))})}get readFile(){return(0,E.promisify)(n.readFile)}get write(){return(ee,ce,K,Q,B)=>new Promise((L,z)=>{n.write(ee,ce,K,Q,B,(U,ae,G)=>U?z(U):L({bytesWritten:ae,buffer:G}))})}get appendFile(){return(0,E.promisify)(n.appendFile)}get fdatasync(){return(0,E.promisify)(n.fdatasync)}get truncate(){return(0,E.promisify)(n.truncate)}get copyFile(){return(0,E.promisify)(n.copyFile)}get open(){return(0,E.promisify)(n.open)}get close(){return(0,E.promisify)(n.close)}get symlink(){return(0,E.promisify)(n.symlink)}get readlink(){return(0,E.promisify)(n.readlink)}get chmod(){return(0,E.promisify)(n.chmod)}get mkdir(){return(0,E.promisify)(n.mkdir)}get unlink(){return(0,E.promisify)(n.unlink)}get rmdir(){return(0,E.promisify)(n.rmdir)}get realpath(){return(0,E.promisify)(n.realpath)}async exists(ee){try{return await e.Promises.access(ee),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return a}get writeFile(){return i}get rm(){return m}get rename(){return I}get copy(){return M}}}),define(re[109],oe([0,1,43,9,4,25,21]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3q=k,e.$4q=h,e.$5q=l,e.$6q=d;function k(v){if(E.$k)return v;const m=(0,C.$nc)(v);if(v===m)return v;const f=((0,C.$oc)(v)||v).toLowerCase();try{const p=(0,j.readdirSync)(m).filter($=>$.toLowerCase()===f);if(p.length===1){const $=k(m);if($)return(0,C.$kc)($,p[0])}else if(p.length>1){const $=p.indexOf(f);if($>=0){const c=k(m);if(c)return(0,C.$kc)(c,p[$])}}}catch{}return null}async function h(v,m){if(E.$k)return v;const f=(0,C.$nc)(v);if(v===f)return v;const y=((0,C.$oc)(v)||v).toLowerCase();try{if(m?.isCancellationRequested)return null;const $=(await j.Promises.readdir(f)).filter(c=>c.toLowerCase()===y);if($.length===1){const c=await h(f,m);if(c)return(0,C.$kc)(c,$[0])}else if($.length>1){const c=$.indexOf(y);if(c>=0){const w=await h(f,m);if(w)return(0,C.$kc)(w,$[c])}}}catch{}return null}async function l(v){try{return await j.Promises.realpath(v)}catch{const f=b(v);return await j.Promises.access(f,n.constants.R_OK),f}}function d(v){try{return n.realpathSync(v)}catch{const f=b(v);return n.accessSync(f,n.constants.R_OK),f}}function b(v){return(0,R.$ff)((0,C.$ic)(v),C.sep)}}),define(re[110],oe([0,1,26,9,21]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jm=c,e.$km=w;const R=/^\d+$/,j=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(P){P[P.x64=0]="x64",P[P.x86=1]="x86",P[P.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let d;process.env.PROCESSOR_ARCHITEW6432?d=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?d=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?d=1:d=0;class b{constructor(a,t,r){this.exePath=a,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await E.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:P=!1}={}){return P?l===0?process.env["ProgramFiles(x86)"]||null:d===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:P=!1,findPreview:a=!1}={}){const t=v({useAlternateBitness:P});if(!t)return null;const r=C.$kc(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(r))return null;let s=-1,i=null;for(const g of await E.Promises.readdir(r)){let S=-1;if(a){const I=g.indexOf("-");if(I<0)continue;const O=g.substring(0,I);if(!R.test(O)||g.substring(I+1)!=="preview")continue;S=parseInt(O,10)}else{if(!R.test(g))continue;S=parseInt(g,10)}if(S<=s)continue;const D=C.$kc(r,g,"pwsh.exe");await E.SymlinkSupport.existsFile(D)&&(i=D,s=S)}if(!i)return null;const o=t.includes("x86")?" (x86)":"",u=a?" Preview":"";return new b(i,`PowerShell${u}${o}`,!0)}async function f({findPreview:P}={}){if(!process.env.LOCALAPPDATA)return null;const a=C.$kc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=P?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:j,pwshMsixName:"PowerShell (Store)"};for(const s of await E.Promises.readdir(a))if(t.test(s)){const i=C.$kc(a,s,"pwsh.exe");return new b(i,r)}return null}function y(){const P=C.$kc(n.homedir(),".dotnet","tools","pwsh.exe");return new b(P,".NET Core PowerShell Global Tool")}function p(){const P=C.$kc(process.env.windir,l===1&&d!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(P,"Windows PowerShell",!0)}async function*$(){let P=await m();P&&(yield P),P=await m({useAlternateBitness:!0}),P&&(yield P),P=await f(),P&&(yield P),P=y(),P&&(yield P),P=await m({findPreview:!0}),P&&(yield P),P=await f({findPreview:!0}),P&&(yield P),P=await m({useAlternateBitness:!0,findPreview:!0}),P&&(yield P),P=p(),P&&(yield P)}async function*c(){for await(const P of $())await P.exists()&&(yield P)}async function w(){for await(const P of c())return P;return null}}),define(re[90],oe([0,1,9,4,36,76,12,21]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$nm=h,e.$om=l,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function h(b=E.env){return b.comspec||"cmd.exe"}function l(b){let v=[],m=!1;const f=function(y){if(m){v.push(y);return}(!b.send(y,$=>{if($&&console.error($),m=!1,v.length>0){const c=v.slice(0);v=[],c.forEach(w=>f(w))}})||C.$i)&&(m=!0)};return{send:f}}var d;(function(b){async function v(m,f,y){if(n.$jc(m))return m;if(f===void 0&&(f=E.cwd()),n.$nc(m)!=="."||(y===void 0&&j.$8f(E.env.PATH)&&(y=E.env.PATH.split(n.$uc)),y===void 0||y.length===0))return n.$kc(f,m);async function $(c){if(await k.Promises.exists(c)){let w;try{w=await k.Promises.stat(c)}catch(P){P.message.startsWith("EACCES")&&(w=await k.Promises.lstat(c))}return w?!w.isDirectory():!1}return!1}for(const c of y){let w;if(n.$jc(c)?w=n.$kc(c,m):w=n.$kc(f,c,m),await $(w))return w;let P=w+".com";if(await $(P)||(P=w+".exe",await $(P)))return P}return n.$kc(f,m)}b.findExecutable=v})(d||(e.win32=d={}))}),define(re[111],oe([0,1,49,13]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cs=E;function E(j){return new Promise((k,h)=>{let l;const d=new Map;function b(m,f,y,p,$){const c=d.get(f);if(m===j||c){const w={name:v(y),cmd:y,pid:m,ppid:f,load:p,mem:$};d.set(m,w),m===j&&(l=w),c&&(c.children||(c.children=[]),c.children.push(w),c.children.length>1&&(c.children=c.children.sort((P,a)=>P.pid-a.pid)))}}function v(m){const f=/--utility-sub-type=network/i,y=/--crashes-directory/i,p=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,c=/--type=([a-zA-Z-]+)/;if(y.exec(m))return"electron-crash-reporter";if(p.exec(m))return"winpty-agent";if($.exec(m))return"conpty-agent";let w=c.exec(m);if(w&&w.length===2)return w[1]==="renderer"?"window":w[1]==="utility"?f.exec(m)?"utility-network-service":"utility-process":w[1]==="extensionHost"?"extension-host":w[1];const P=/[a-zA-Z-]+\.js/g;let a="";do w=P.exec(m),w&&(a+=w+" ");while(w);return a&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron-nodejs (${a})`:m}if(process.platform==="win32"){const m=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substring(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substring(5):f;new Promise((f,y)=>{X(["@vscode/windows-process-tree"],f,y)}).then(f=>{f.getProcessList(j,y=>{if(!y){h(new Error(`Root process ${j} not found`));return}f.getProcessCpuUsage(y,p=>{const $=new Map;p.forEach(c=>{const w=m(c.commandLine||"");$.set(c.pid,{name:v(w),cmd:w,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),l=$.get(j),l?($.forEach(c=>{const w=$.get(c.ppid);w&&(w.children||(w.children=[]),w.children.push(c))}),$.forEach(c=>{c.children&&(c.children=c.children.sort((w,P)=>w.pid-P.pid))}),k(l)):h(new Error(`Root process ${j} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let m=function(){let f=[l];const y=[];for(;f.length;){const $=f.shift();$&&(y.push($.pid),$.children&&(f=f.concat($.children)))}let p=JSON.stringify(C.$Pg.asFileUri("vs/base/node/cpuUsage.sh").fsPath);p+=" "+y.join(" "),(0,n.exec)(p,{},($,c,w)=>{if($||w)h($||new Error(w.toString()));else{const P=c.toString().split(`
`);for(let a=0;a<y.length;a++){const t=d.get(y[a]);t.load=parseFloat(P[a])}if(!l){h(new Error(`Root process ${j} not found`));return}k(l)}})};(0,n.exec)("which ps",{},(f,y,p)=>{if(f||p)if(process.platform!=="linux")h(f||new Error(p.toString()));else{const $=JSON.stringify(C.$Pg.asFileUri("vs/base/node/ps.sh").fsPath);(0,n.exec)($,{},(c,w,P)=>{c||P?h(c||new Error(P.toString())):(R(w,b),m())})}else{const $=y.toString().trim();(0,n.exec)(`${$} -ax -o pid=,ppid=,pcpu=,pmem=,command=`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(w,P,a)=>{w||a&&!a.includes("screen size is bogus")?h(w||new Error(a.toString())):(R(P,b),process.platform==="linux"?m():l?k(l):h(new Error(`Root process ${j} not found`)))})}})}})}function R(j,k){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=j.toString().split(`
`);for(const d of l){const b=h.exec(d.trim());b&&b.length===6&&k(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(re[112],oe([0,1,26,4,110,90]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pm=j;async function j(b,v){return b===1?C.$i?d():R.$nm(v):h(b,v)}let k=null;function h(b,v){if(C.$k&&b===2||C.$j&&b===3)return"/bin/bash";if(!k){let m;if(C.$i)m="/bin/bash";else{if(m=v.SHELL,!m)try{m=(0,n.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}k=m}return k}let l=null;async function d(){return l||(l=(await(0,E.$km)()).exePath),l}});var Ee=this&&this.__decorate||function(X,e,n,C){var E=arguments.length,R=E<3?e:C===null?C=Object.getOwnPropertyDescriptor(e,n):C,j;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(X,e,n,C);else for(var k=X.length-1;k>=0;k--)(j=X[k])&&(R=(E<3?j(R):E>3?j(e,n,R):j(e,n))||R);return E>3&&R&&Object.defineProperty(e,n,R),R};define(re[44],oe([0,1,22,8,17,23,51,15,3,2,77,25,12]),function(X,e,n,C,E,R,j,k,h,l,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ei=e.ProxyChannel=e.$di=e.$ai=e.$_h=e.$$h=e.RequestInitiator=e.$0h=e.$7h=e.$6h=void 0,e.$8h=u,e.$9h=g,e.$bi=W,e.$ci=F;var m;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(m||(m={}));function f(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var y;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(y||(y={}));function p(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})($||($={}));function c(B){let L=0;for(let z=0;;z+=7){const U=B.read(1);if(L|=(U.buffer[0]&127)<<z,!(U.buffer[0]&128))return L}}const w=s(0);function P(B,L){if(L===0){B.write(w);return}let z=0;for(let ae=L;ae!==0;ae=ae>>>7)z++;const U=E.$Fe.alloc(z);for(let ae=0;L!==0;ae++)U.buffer[ae]=L&127,L=L>>>7,L>0&&(U.buffer[ae]|=128);B.write(U)}class a{constructor(L){this.b=L,this.a=0}read(L){const z=this.b.slice(this.a,this.a+L);return this.a+=z.byteLength,z}}e.$6h=a;class t{constructor(){this.a=[]}get buffer(){return E.$Fe.concat(this.a)}write(L){this.a.push(L)}}e.$7h=t;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function s(B){const L=E.$Fe.alloc(1);return L.writeUInt8(B,0),L}const i={Undefined:s(r.Undefined),String:s(r.String),Buffer:s(r.Buffer),VSBuffer:s(r.VSBuffer),Array:s(r.Array),Object:s(r.Object),Uint:s(r.Int)},o=typeof Buffer<"u";function u(B,L){if(typeof L>"u")B.write(i.Undefined);else if(typeof L=="string"){const z=E.$Fe.fromString(L);B.write(i.String),P(B,z.byteLength),B.write(z)}else if(o&&Buffer.isBuffer(L)){const z=E.$Fe.wrap(L);B.write(i.Buffer),P(B,z.byteLength),B.write(z)}else if(L instanceof E.$Fe)B.write(i.VSBuffer),P(B,L.byteLength),B.write(L);else if(Array.isArray(L)){B.write(i.Array),P(B,L.length);for(const z of L)u(B,z)}else if(typeof L=="number"&&(L|0)===L)B.write(i.Uint),P(B,L);else{const z=E.$Fe.fromString(JSON.stringify(L));B.write(i.Object),P(B,z.byteLength),B.write(z)}}function g(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(c(B)).toString();case r.Buffer:return B.read(c(B)).buffer;case r.VSBuffer:return B.read(c(B));case r.Array:{const z=c(B),U=[];for(let ae=0;ae<z;ae++)U.push(g(B));return U}case r.Object:return JSON.parse(B.read(c(B)).toString());case r.Int:return c(B)}}class S{constructor(L,z,U=null,ae=1e3){this.h=L,this.j=z,this.k=U,this.l=ae,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(G=>this.q(G)),this.m({type:200})}registerChannel(L,z){this.b.set(L,z),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const z=this.o([L.type]);this.k?.logOutgoing(z,0,1,p(L.type));return}case 201:case 202:case 204:case 203:{const z=this.o([L.type,L.id],L.data);this.k?.logOutgoing(z,L.id,1,p(L.type),L.data);return}}}o(L,z=void 0){const U=new t;return u(U,L),u(U,z),this.p(U.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const z=new a(L),U=g(z),ae=g(z),G=U[0];switch(G){case 100:return this.k?.logIncoming(L.byteLength,U[1],1,`${f(G)}: ${U[2]}.${U[3]}`,ae),this.s({type:G,id:U[1],channelName:U[2],name:U[3],arg:ae});case 102:return this.k?.logIncoming(L.byteLength,U[1],1,`${f(G)}: ${U[2]}.${U[3]}`,ae),this.t({type:G,id:U[1],channelName:U[2],name:U[3],arg:ae});case 101:return this.k?.logIncoming(L.byteLength,U[1],1,`${f(G)}`),this.u({type:G,id:U[1]});case 103:return this.k?.logIncoming(L.byteLength,U[1],1,`${f(G)}`),this.u({type:G,id:U[1]})}}s(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const U=new R.$pe;let ae;try{ae=z.call(this.j,L.name,L.arg,U.token)}catch(Y){ae=Promise.reject(Y)}const G=L.id;ae.then(Y=>{this.m({id:G,data:Y,type:201})},Y=>{Y instanceof Error?this.m({id:G,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.m({id:G,data:Y,type:203})}).finally(()=>{le.dispose(),this.d.delete(L.id)});const le=(0,l.$Tc)(()=>U.cancel());this.d.set(L.id,le)}t(L){const z=this.b.get(L.channelName);if(!z){this.v(L);return}const U=L.id,G=z.listen(this.j,L.name,L.arg)(le=>this.m({id:U,data:le,type:204}));this.d.set(L.id,G)}u(L){const z=this.d.get(L.id);z&&(z.dispose(),this.d.delete(L.id))}v(L){let z=this.g.get(L.channelName);z||(z=[],this.g.set(L.channelName,z));const U=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);z.push({request:L,timeoutTimer:U})}w(L){const z=this.g.get(L);if(z){for(const U of z)switch(clearTimeout(U.timeoutTimer),U.request.type){case 100:this.s(U.request);break;case 102:this.t(U.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$0h=S;var D;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(D||(e.RequestInitiator=D={}));class I{constructor(L,z=null){this.l=L,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(U=>this.s(U)),this.j=z}getChannel(L){const z=this;return{call(U,ae,G){return z.a?Promise.reject(new k.$5):z.m(L,U,ae,G)},listen(U,ae){return z.a?h.Event.None:z.o(L,U,ae)}}}m(L,z,U,ae=R.CancellationToken.None){const G=this.g++,Y={id:G,type:100,channelName:L,name:z,arg:U};if(ae.isCancellationRequested)return Promise.reject(new k.$5);let A;return new Promise((_,ne)=>{if(ae.isCancellationRequested)return ne(new k.$5);const J=()=>{const se=he=>{switch(he.type){case 201:this.f.delete(G),_(he.data);break;case 202:{this.f.delete(G);const me=new Error(he.data.message);me.stack=Array.isArray(he.data.stack)?he.data.stack.join(`
`):he.data.stack,me.name=he.data.name,ne(me);break}case 203:this.f.delete(G),ne(he.data);break}};this.f.set(G,se),this.p(Y)};let V=null;this.b===$.Idle?J():(V=(0,C.$ih)(se=>this.u()),V.then(()=>{V=null,J()}));const x=()=>{V?(V.cancel(),V=null):this.p({id:G,type:101}),ne(new k.$5)},H=ae.onCancellationRequested(x);A=(0,l.$Sc)((0,l.$Tc)(x),H),this.d.add(A)}).finally(()=>{A.dispose(),this.d.delete(A)})}o(L,z,U){const ae=this.g++,le={id:ae,type:102,channelName:L,name:z,arg:U};let Y=null;const A=new h.$ee({onWillAddFirstListener:()=>{Y=(0,C.$ih)(_=>this.u()),Y.then(()=>{Y=null,this.d.add(A),this.p(le)})},onDidRemoveLastListener:()=>{Y?(Y.cancel(),Y=null):(this.d.delete(A),this.p({id:ae,type:103}))}}),N=_=>A.fire(_.data);return this.f.set(ae,N),A.event}p(L){switch(L.type){case 100:case 102:{const z=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(z,L.id,0,`${f(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const z=this.q([L.type,L.id]);this.j?.logOutgoing(z,L.id,0,f(L.type));return}}}q(L,z=void 0){const U=new t;return u(U,L),u(U,z),this.r(U.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const z=new a(L),U=g(z),ae=g(z),G=U[0];switch(G){case 200:return this.j?.logIncoming(L.byteLength,0,0,p(G)),this.t({type:U[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,U[1],0,p(G),ae),this.t({type:U[0],id:U[1],data:ae})}}t(L){if(L.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Qc)(this.d.values()),this.d.clear()}}e.$$h=I,Ee([j.$Zh],I.prototype,"onDidInitializePromise",null);class O{get connections(){const L=[];return this.f.forEach(z=>L.push(z)),L}constructor(L,z,U){this.a=new Map,this.f=new Set,this.g=new h.$ee,this.onDidAddConnection=this.g.event,this.h=new h.$ee,this.onDidRemoveConnection=this.h.event,this.j=new l.$Uc,this.j.add(L(({protocol:ae,onDidClientDisconnect:G})=>{const le=h.Event.once(ae.onMessage);this.j.add(le(Y=>{const A=new a(Y),N=g(A),_=new S(ae,N,z,U),ne=new I(ae,z);this.a.forEach((V,x)=>_.registerChannel(x,V));const J={channelServer:_,channelClient:ne,ctx:N};this.f.add(J),this.g.fire(J),this.j.add(G(()=>{_.dispose(),ne.dispose(),this.f.delete(J),this.h.fire(J)}))}))}))}getChannel(L,z){const U=this;return{call(ae,G,le){let Y;if((0,v.$jg)(z)){const N=(0,n.$4b)(U.connections.filter(z));Y=N?Promise.resolve(N):h.Event.toPromise(h.Event.filter(U.onDidAddConnection,z))}else Y=z.routeCall(U,ae,G);const A=Y.then(N=>N.channelClient.getChannel(L));return W(A).call(ae,G,le)},listen(ae,G){if((0,v.$jg)(z))return U.k(L,z,ae,G);const le=z.routeEvent(U,ae,G).then(Y=>Y.channelClient.getChannel(L));return W(le).listen(ae,G)}}}k(L,z,U,ae){const G=this;let le;const Y=new h.$ee({onWillAddFirstListener:()=>{le=new l.$Uc;const A=new h.$ke,N=new Map,_=J=>{const x=J.channelClient.getChannel(L).listen(U,ae),H=A.add(x);N.set(J,H)},ne=J=>{const V=N.get(J);V&&(V.dispose(),N.delete(J))};G.connections.filter(z).forEach(_),h.Event.filter(G.onDidAddConnection,z)(_,void 0,le),G.onDidRemoveConnection(ne,void 0,le),A.event(Y.fire,Y,le),le.add(A)},onDidRemoveLastListener:()=>{le?.dispose(),le=void 0}});return Y.event}registerChannel(L,z){this.a.set(L,z);for(const U of this.f)U.channelServer.registerChannel(L,z)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$_h=O;class M{constructor(L,z,U=null){const ae=new t;u(ae,z),L.send(ae.buffer),this.a=new I(L,U),this.d=new S(L,z,U)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,z){this.d.registerChannel(L,z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$ai=M;function W(B){return{call(L,z,U){return B.then(ae=>ae.call(L,z,U))},listen(L,z){const U=new h.$ne;return B.then(ae=>U.input=ae.listen(L,z)),U.event}}}function F(B){let L=!1;return{call(z,U,ae){return L?B.call(z,U,ae):(0,C.$wh)(0).then(()=>L=!0).then(()=>B.call(z,U,ae))},listen(z,U){if(L)return B.listen(z,U);const ae=new h.$ne;return(0,C.$wh)(0).then(()=>L=!0).then(()=>ae.input=B.listen(z,U)),ae.event}}}class T{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const z of L.connections)if(await Promise.resolve(this.a(z.ctx)))return Promise.resolve(z);return await h.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$di=T;var q;(function(B){function L(G,le,Y){const A=G,N=Y&&Y.disableMarshalling,_=new Map;for(const ne in A)U(ne)&&_.set(ne,h.Event.buffer(A[ne],!0,void 0,le));return new class{listen(ne,J,V){const x=_.get(J);if(x)return x;const H=A[J];if(typeof H=="function"){if(ae(J))return H.call(A,V);if(U(J))return _.set(J,h.Event.buffer(A[J],!0,void 0,le)),_.get(J)}throw new k.$bb(`Event not found: ${J}`)}call(ne,J,V){const x=A[J];if(typeof x=="function"){if(!N&&Array.isArray(V))for(let se=0;se<V.length;se++)V[se]=(0,d.$5h)(V[se]);let H=x.apply(A,V);return H instanceof Promise||(H=Promise.resolve(H)),H}throw new k.$bb(`Method not found: ${J}`)}}}B.fromService=L;function z(G,le){const Y=le&&le.disableMarshalling;return new Proxy({},{get(A,N){if(typeof N=="string")return le?.properties?.has(N)?le.properties.get(N):ae(N)?function(_){return G.listen(N,_)}:U(N)?G.listen(N):async function(..._){let ne;le&&!(0,v.$eg)(le.context)?ne=[le.context,..._]:ne=_;const J=await G.call(N,ne);return Y?J:(0,d.$5h)(J)};throw new k.$bb(`Property not found: ${String(N)}`)}})}B.toService=z;function U(G){return G[0]==="o"&&G[1]==="n"&&b.$wf(G.charCodeAt(2))}function ae(G){return/^onDynamic/.test(G)&&b.$wf(G.charCodeAt(9))}})(q||(e.ProxyChannel=q={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ee(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const L=B.toString();if(L!=="[object Object]")return L}return B}function ce(B){return Array.isArray(B)?B.map(ee):ee(B)}function K(B,L,z,U,ae,G,le){le=ce(le);const Y=ue[ae],A=Y[U%Y.length];let N=[`%c[${B}]%c[${String(L).padStart(7," ")}]%c[len: ${String(z).padStart(5," ")}]%c${String(U).padStart(5," ")} - ${G}`,"color: darkgreen","color: grey","color: grey",`color: ${A}`];/\($/.test(G)?(N=N.concat(le),N.push(")")):N.push(le),console.log.apply(console,N)}class Q{constructor(L,z){this.d=L,this.f=z,this.a=0,this.b=0}logOutgoing(L,z,U,ae,G){this.b+=L,K(this.d,this.b,L,z,U,ae,G)}logIncoming(L,z,U,ae,G){this.a+=L,K(this.f,this.a,L,z,U,ae,G)}}e.$ei=Q}),define(re[159],oe([0,1,17,3,44]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SW=e.$RW=void 0;class R{constructor(h){this.a=h,this.onMessage=C.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?n.$Fe.wrap(l.data):n.$Fe.alloc(0)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.$RW=R;class j extends E.$ai{constructor(h,l){const d=new R(h);super(d,l),this.b=d}dispose(){this.b.disconnect(),super.dispose()}}e.$SW=j}),define(re[113],oe([0,1,17,3,2,44]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ji=e.$ii=e.$hi=e.$gi=e.ProtocolConstants=e.$fi=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var j;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(j||(e.SocketDiagnosticsEventType=j={}));var k;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let u=0;function g(D,I){if(!o.has(D)){const O=String(++u);o.set(D,O)}return o.get(D)}function S(D,I,O,M){if(!i.enableDiagnostics)return;const W=g(D,I);if(M instanceof n.$Fe||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const F=n.$Fe.alloc(M.byteLength);F.set(M),i.records.push({timestamp:Date.now(),id:W,label:I,type:O,buff:F})}else i.records.push({timestamp:Date.now(),id:W,label:I,type:O,data:M})}i.traceSocketEvent=S})(k||(e.SocketDiagnostics=k={}));var h;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(h||(e.SocketCloseEventType=h={}));let l=null;function d(){return l||(l=n.$Fe.alloc(0)),l}class b{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(o){this.a.push(o),this.b+=o.byteLength}read(o){return this.c(o,!0)}peek(o){return this.c(o,!1)}c(o,u){if(o===0)return d();if(o>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===o){const I=this.a[0];return u&&(this.a.shift(),this.b-=o),I}if(this.a[0].byteLength>o){const I=this.a[0].slice(0,o);return u&&(this.a[0]=this.a[0].slice(o),this.b-=o),I}const g=n.$Fe.alloc(o);let S=0,D=0;for(;o>0;){const I=this.a[D];if(I.byteLength>o){const O=I.slice(0,o);g.set(O,S),S+=o,u&&(this.a[D]=I.slice(o),this.b-=o),o-=o}else g.set(I,S),S+=I.byteLength,u?(this.a.shift(),this.b-=I.byteLength):D++,o-=I.byteLength}return g}}e.$fi=b;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function m(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(f||(e.ProtocolConstants=f={}));class y{constructor(o,u,g,S){this.type=o,this.id=u,this.ack=g,this.data=S,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends E.$Vc{constructor(o){super(),this.f=this.B(new C.$ee),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=o,this.b=!1,this.c=new b,this.B(this.a.onData(u=>this.acceptChunk(u))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(o);this.c.byteLength>=this.g.readLen;){const u=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=u.readUInt32BE(9),this.g.messageType=u.readUInt8(0),this.g.id=u.readUInt32BE(1),this.g.ack=u.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const g=this.g.messageType,S=this.g.id,D=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",u),this.f.fire(new y(g,S,D,u)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(o){this.k=null,this.a=!1,this.b=!1,this.c=o,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(o){if(this.a)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const u=n.$Fe.alloc(13);u.writeUInt8(o.type,0),u.writeUInt32BE(o.id,1),u.writeUInt32BE(o.ack,5),u.writeUInt32BE(o.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",o.data),this.j(u,o.data)}g(o,u){const g=this.f===0;return this.d.push(o,u),this.f+=o.byteLength+u.byteLength,g}h(){const o=n.$Fe.concat(this.d,this.f);return this.d.length=0,this.f=0,o}j(o,u){this.g(o,u)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const o=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this.c.write(o)}}class c extends E.$Vc{constructor(o){super(),this.f=new C.$ee,this.onMessage=this.f.event,this.g=new C.$ee,this.onDidDispose=this.g.event,this.a=o,this.b=this.B(new $(this.a)),this.c=this.B(new p(this.a)),this.B(this.c.onMessage(u=>{u.type===1&&this.f.fire(u.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(o){this.b.write(new y(1,0,0,o))}}e.$gi=c;class w extends R.$ai{static fromSocket(o,u){return new w(new c(o),u)}get onDidDispose(){return this.b.onDidDispose}constructor(o,u,g=null){super(o,u,g),this.b=o}dispose(){super.dispose();const o=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),o.end()}}e.$hi=w;class P{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new C.$ee({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(o){this.b?this.d.length>0?this.d.push(o):this.a.fire(o):this.d.push(o)}flushBuffer(){this.d=[]}}e.$ii=P;class a{constructor(o){this.data=o,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let o=0,u=this.a;for(;u;)u=u.next,o++;return o}peek(){return this.a?this.a.data:null}toArray(){const o=[];let u=0,g=this.a;for(;g;)o[u++]=g.data,g=g.next;return o}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(o){const u=new a(o);if(!this.a){this.a=u,this.b=u;return}this.b.next=u,this.b=u}}class r{static{this.a=10}static{this.b=null}static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const o=Date.now();for(let u=0;u<r.a;u++)this.c[u]=o-1e3*u;setInterval(()=>{for(let u=r.a;u>=1;u--)this.c[u]=this.c[u-1];this.c[0]=Date.now()},1e3)}d(){const o=Date.now(),u=(1+r.a)*1e3;let g=0;for(let S=0;S<r.a;S++)o-this.c[S]<=u&&g++;return 1-g/r.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(o){this.u=new P,this.onControlMessage=this.u.event,this.v=new P,this.onMessage=this.v.event,this.w=new P,this.onDidDispose=this.w.event,this.x=new P,this.onSocketClose=this.x.event,this.y=new P,this.onSocketTimeout=this.y.event,this.s=o.loadEstimator??r.getInstance(),this.t=o.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new E.$Uc,this.o=o.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(u=>this.z(u))),this.r.add(this.o.onClose(u=>this.x.fire(u))),o.initialChunk&&this.q.acceptChunk(o.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const o=new y(5,0,0,d());this.p.write(o),this.p.flush()}sendPause(){const o=new y(7,0,0,d());this.p.write(o)}sendResume(){const o=new y(8,0,0,d());this.p.write(o)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(o,u){this.a=!0,this.r.dispose(),this.r=new E.$Uc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=o,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new p(this.o)),this.r.add(this.q.onMessage(g=>this.z(g))),this.r.add(this.o.onClose(g=>this.x.fire(g))),this.q.acceptChunk(u)}endAcceptReconnection(){this.a=!1,this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o);const u=this.b.toArray();for(let g=0,S=u.length;g<S;g++)this.p.write(u[g]);this.B()}acceptDisconnect(){this.w.fire()}z(o){if(o.ack>this.d){this.d=o.ack;do{const u=this.b.peek();if(u&&u.id<=o.ack)this.b.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this.g)if(o.id!==this.g+1){const u=Date.now();u-this.m>1e4&&(this.m=u,this.p.write(new y(6,0,0,d())))}else this.g=o.id,this.j=Date.now(),this.A(),this.v.fire(o.data);break}case 2:{this.u.fire(o.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const u=this.b.toArray();for(let g=0,S=u.length;g<S;g++)this.p.write(u[g]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(o){const u=++this.c;this.h=this.g;const g=new y(1,u,this.h,o);this.b.push(g),this.a||(this.p.write(g),this.B())}sendControl(o){const u=new y(2,0,0,o);this.p.write(u)}A(){if(this.g<=this.h||this.k)return;const o=Date.now()-this.j;if(o>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-o+5)}B(){if(this.c<=this.d||this.f||this.a)return;const o=this.b.peek(),u=Date.now()-o.writtenTime,g=Date.now()-this.q.lastReadTime,S=Date.now()-this.n;if(u>=2e4&&g>=2e4&&S>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:u,timeSinceLastReceivedSomeData:g});return}const D=Math.max(2e4-u,2e4-g,2e4-S,500);this.f=setTimeout(()=>{this.f=null,this.B()},D)}C(){if(this.g<=this.h)return;this.h=this.g;const o=new y(3,0,this.h,d());this.p.write(o)}D(){this.h=this.g;const o=new y(9,0,this.h,d());this.p.write(o)}}e.$ji=s}),define(re[37],oe([0,1,14,15,13]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OW=void 0;class R{constructor(){this.a=new WeakMap}on(k,h){const l=(d,...b)=>{this.b(k,d)&&h(d,...b)};return this.a.set(h,l),n.ipcMain.on(k,l),this}once(k,h){return n.ipcMain.once(k,(l,...d)=>{this.b(k,l)&&h(l,...d)}),this}handle(k,h){return n.ipcMain.handle(k,(l,...d)=>this.b(k,l)?h(l,...d):Promise.reject(`Invalid channel '${k}' or sender for ipcMain.handle() usage.`)),this}removeHandler(k){return n.ipcMain.removeHandler(k),this}removeListener(k,h){const l=this.a.get(h);return l&&(n.ipcMain.removeListener(k,l),this.a.delete(h)),this}b(k,h){if(!k||!k.startsWith("vscode:"))return(0,C.$1)(`Refused to handle ipcMain event for channel '${k}' because the channel is unknown.`),!1;const l=h.senderFrame,d=l.url;if(!d||d==="about:blank")return!0;let b="unknown";try{b=new URL(d).host}catch{return(0,C.$1)(`Refused to handle ipcMain event for channel '${k}' because of a malformed URL '${d}'.`),!1}return b!==E.$Og?((0,C.$1)(`Refused to handle ipcMain event for channel '${k}' because of a bad origin of '${b}'.`),!1):l.parent!==null?((0,C.$1)(`Refused to handle ipcMain event for channel '${k}' because sender of origin '${b}' is not a main frame.`),!1):!0}}e.$OW=new R}),define(re[160],oe([0,1,14,37,148]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$PW=R;function R(){C.$OW.on(E.$MW,(k,h,l,d,b)=>{const v=j(k,d,l);v.popup({x:b?b.x:void 0,y:b?b.y:void 0,positioningItem:b?b.positioningItem:void 0,callback:()=>{v&&k.sender.send(E.$NW,h)}})})}function j(k,h,l){const d=new n.Menu;return l.forEach(b=>{let v;b.type==="separator"?v=new n.MenuItem({type:b.type}):Array.isArray(b.submenu)?v=new n.MenuItem({submenu:j(k,h,b.submenu),label:b.label}):v=new n.MenuItem({label:b.label,type:b.type,accelerator:b.accelerator,checked:b.checked,enabled:b.enabled,visible:b.visible,click:(m,f,y)=>k.sender.send(h,b.id,y)}),d.append(v)}),d}}),define(re[161],oe([0,1,37,17,3,2,44,149]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VW=void 0;function h(d,b){const v=E.Event.fromNodeEventEmitter(n.$OW,b,(f,y)=>({event:f,message:y})),m=E.Event.filter(v,({event:f})=>f.sender.id===d);return E.Event.map(m,({message:f})=>f&&C.$Fe.wrap(f))}class l extends j.$_h{static{this.b=new Map}static d(){const b=E.Event.fromNodeEventEmitter(n.$OW,"vscode:hello",({sender:v})=>v);return E.Event.map(b,v=>{const m=v.id;l.b.get(m)?.dispose();const y=new E.$ee;l.b.set(m,(0,R.$Tc)(()=>y.fire()));const p=h(m,"vscode:message"),$=E.Event.any(E.Event.signal(h(m,"vscode:disconnect")),y.event);return{protocol:new k.$UW(v,p),onDidClientDisconnect:$}})}constructor(){super(l.d())}}e.$VW=l}),define(re[114],oe([0,1,37,3,33,159]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WW=void 0,e.$XW=k;class j extends R.$SW{constructor(l,d){super({addEventListener:(b,v)=>l.addListener(b,v),removeEventListener:(b,v)=>l.removeListener(b,v),postMessage:b=>l.postMessage(b),start:()=>l.start(),close:()=>l.close()},d)}}e.$WW=j;async function k(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,E.$Rg)();h.webContents.send("vscode:createMessageChannel",l);const d=C.Event.fromNodeEventEmitter(n.$OW,"vscode:createMessageChannelResult",(v,m)=>({nonce:m,port:v.ports[0]})),{port:b}=await C.Event.toPromise(C.Event.once(C.Event.filter(d,v=>v.nonce===l)));return b}}),define(re[162],oe([0,1,49,8,17,23,156,15,3,2,35,90,76,44]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=e.$Yq=void 0;class f extends m.$0h{constructor($){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",c=>E.$Fe.wrap(Buffer.from(c,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$Yq=f;class y{constructor($,c){this.i=$,this.j=c,this.c=new Set,this.g=new Map,this.h=new h.$ee,this.onDidProcessExit=this.h.event;const w=c&&c.timeout?c.timeout:6e4;this.b=new C.$sh(w),this.d=null,this.f=null}getChannel($){const c=this;return{call(w,P,a){return c.k($,w,P,a)},listen(w,P){return c.l($,w,P)}}}k($,c,w,P=R.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(P.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const a=this.n($),t=(0,C.$ih)(i=>a.call(c,w,i)),r=P.onCancellationRequested(()=>t.cancel()),s=(0,l.$Tc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{r.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,c,w){if(!this.b)return h.Event.None;this.b.cancel();let P;const a=new h.$ee({onWillAddFirstListener:()=>{P=this.n($).listen(c,w)(a.fire,a),this.c.add(P)},onDidRemoveLastListener:()=>{this.c.delete(P),P.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,d.$2n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,v.$mm)(c.env),this.d=(0,n.fork)(this.i,$,c);const w=new h.$ee,a=h.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,j.$Uq)(u)){(0,j.log)(u,`IPC Library: ${this.j.serverName}`);return}w.fire(E.$Fe.wrap(Buffer.from(u,"base64")))}),t=this.j.useQueue?(0,b.$om)(this.d):this.d,r=u=>this.d&&this.d.connected&&t.send(u.buffer.toString("base64")),s=w.event,i={send:r,onMessage:s};this.f=new m.$$h(i);const o=()=>this.o();process.once("exit",o),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,g)=>{process.removeListener("exit",o),a.dispose(),this.c.forEach(S=>(0,l.$Qc)(S)),this.c.clear(),u!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+g),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:g})})}return this.f}n($){let c=this.g.get($);return c||(c=this.m.getChannel($),this.g.set($,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$Zq=y}),define(re[115],oe([0,1,8,3,2,77,12]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.StorageState=e.StorageHint=void 0,e.$Up=h;var k;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function h(v){const m=v;return m?.changed instanceof Map||m?.deleted instanceof Set}var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class d extends E.$Vc{static{this.a=100}constructor(m,f=Object.create(null)){super(),this.r=m,this.s=f,this.b=this.B(new C.$he),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new n.$th(d.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(m=>this.u(m)))}u(m){this.b.pause();try{m.changed?.forEach((f,y)=>this.w(y,f)),m.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(m,f){if(this.c===l.Closed)return;let y=!1;(0,j.$eg)(f)?y=this.f.delete(m):this.f.get(m)!==f&&(this.f.set(m,f),y=!0),y&&this.b.fire({key:m,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(m,f){const y=this.f.get(m);return(0,j.$eg)(y)?f:y}getBoolean(m,f){const y=this.get(m);return(0,j.$eg)(y)?f:y==="true"}getNumber(m,f){const y=this.get(m);return(0,j.$eg)(y)?f:parseInt(y,10)}getObject(m,f){const y=this.get(m);return(0,j.$eg)(y)?f:(0,R.$4h)(y)}async set(m,f,y=!1){if(this.c===l.Closed)return;if((0,j.$eg)(f))return this.delete(m,y);const p=(0,j.$0f)(f)||Array.isArray(f)?(0,R.$3h)(f):String(f);if(this.f.get(m)!==p)return this.f.set(m,p),this.j.set(m,p),this.h.delete(m),this.b.fire({key:m,external:y}),this.D()}async delete(m,f=!1){if(!(this.c===l.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire({key:m,external:f}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(m).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(m){if(this.z)return this.D(m)}async D(m){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),m)}async whenFlushed(){if(this.z)return new Promise(m=>this.n.push(m))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$Vp=d;class b{constructor(){this.onDidChangeItemsExternal=C.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((f,y)=>this.a.set(y,f)),m.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$Wp=b}),define(re[163],oe([0,1,8,3,32,9,21]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hX=void 0;class k{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return C.Event.None}static{this.a=2e3}static{this.b=256}constructor(d,b=Object.create(null)){this.g=d,this.h=b,this.c=(0,R.$oc)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const d=await this.f,b=new Map;return(await this.s(d,"SELECT * FROM ItemTable")).forEach(m=>b.set(m.key,m.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${b.size} rows`),b}async updateItems(d){const b=await this.f;return this.j(b,d)}j(d,b){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${b.insert?(0,E.$zc)(b.insert):"0"}), delete(${b.delete?(0,E.$Ac)(b.delete):"0"})`),this.t(d,()=>{const v=b.insert,m=b.delete;if(v&&v.size>0){const f=[];f.push([]);let y=0;v.forEach((p,$)=>{let c=f[y];c.length>k.b&&(y++,c=[],f.push(c)),c.push($,p)}),f.forEach(p=>{this.u(d,`INSERT INTO ItemTable VALUES ${new Array(p.length/2).fill("(?,?)").join(",")}`,$=>$.run(p),()=>{const $=[];let c=0;return v.forEach((w,P)=>{$.push(P),c+=w.length}),`Keys: ${$.join(", ")} Length: ${c}`})})}if(m&&m.size){const f=[];f.push([]);let y=0;m.forEach(p=>{let $=f[y];$.length>k.b&&(y++,$=[],f.push($)),$.push(p)}),f.forEach(p=>{this.u(d,`DELETE FROM ItemTable WHERE key IN (${new Array(p.length).fill("?").join(",")})`,$=>$.run(p),()=>{const $=[];return m.forEach(c=>{$.push(c)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const d=await this.f;return this.q(d,"VACUUM")}async close(d){this.d.trace(`[storage ${this.c}] close()`);const b=await this.f;return this.k(b,d)}k(d,b){return new Promise((v,m)=>{d.db.close(f=>(f&&this.o(d,`[storage ${this.c}] close(): ${f}`),this.g===k.IN_MEMORY_PATH?v():!d.isErroneous&&!d.isInMemory?this.l().then(v,y=>(this.d.error(`[storage ${this.c}] backup(): ${y}`),v())):typeof b=="function"?j.Promises.unlink(this.g).then(()=>this.p(this.g).then(y=>{const p=()=>this.k(y,void 0);return this.j(y,{insert:b()}).then(()=>p(),$=>(p(),Promise.reject($)))})).then(v,m):m(f||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const d=this.m(this.g);return j.Promises.copy(this.g,d,{preserveSymlinks:!1})}m(d){return`${d}.backup`}async checkIntegrity(d){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${d})`);const b=await this.f,v=await this.r(b,d?"PRAGMA integrity_check":"PRAGMA quick_check"),m=d?v.integrity_check:v.quick_check;return b.isErroneous?`${m} (last error: ${b.lastError})`:b.isInMemory?`${m} (in-memory!)`:m}async n(d,b=!0){this.d.trace(`[storage ${this.c}] open(${d}, retryOnBusy: ${b})`);try{return await this.p(d)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&b)return await(0,n.$wh)(k.a),this.n(d,!1);try{await j.Promises.unlink(d);try{await j.Promises.rename(this.m(d),d,!1)}catch{}return await this.p(d)}catch(m){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${m}`),this.p(k.IN_MEMORY_PATH)}}}o(d,b){d.isErroneous=!0,d.lastError=b,this.d.error(b)}p(d){return new Promise((b,v)=>{new Promise((m,f)=>{X(["@vscode/sqlite3"],m,f)}).then(m=>{const f={db:new(this.d.isTracing?m.verbose().Database:m.Database)(d,y=>y?f.db&&y.code!=="SQLITE_CANTOPEN"?f.db.close(()=>v(y)):v(y):this.q(f,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>b(f),p=>f.db.close(()=>v(p)))),isInMemory:d===k.IN_MEMORY_PATH};f.db.on("error",y=>this.o(f,`[storage ${this.c}] Error (event): ${y}`)),this.d.isTracing&&f.db.on("trace",y=>this.d.trace(`[storage ${this.c}] Trace (event): ${y}`))},v)})}q(d,b){return new Promise((v,m)=>{d.db.exec(b,f=>f?(this.o(d,`[storage ${this.c}] exec(): ${f}`),m(f)):v())})}r(d,b){return new Promise((v,m)=>{d.db.get(b,(f,y)=>f?(this.o(d,`[storage ${this.c}] get(): ${f}`),m(f)):v(y))})}s(d,b){return new Promise((v,m)=>{d.db.all(b,(f,y)=>f?(this.o(d,`[storage ${this.c}] all(): ${f}`),m(f)):v(y))})}t(d,b){return new Promise((v,m)=>{d.db.serialize(()=>{d.db.run("BEGIN TRANSACTION"),b(),d.db.run("END TRANSACTION",f=>f?(this.o(d,`[storage ${this.c}] transaction(): ${f}`),m(f)):v())})})}u(d,b,v,m){const f=d.db.prepare(b),y=p=>{this.o(d,`[storage ${this.c}] prepare(): ${p} (${b}). Details: ${m()}`)};f.on("error",y),v(f),f.finalize(p=>{p&&y(p),f.removeListener("error",y)})}}e.$hX=k;class h{static{this.a="VSCODE_TRACE_STORAGE"}constructor(d){d&&typeof d.logTrace=="function"&&process.env[h.a]&&(this.b=d.logTrace),d&&typeof d.logError=="function"&&(this.c=d.logError)}get isTracing(){return!!this.b}trace(d){this.b?.(d)}error(d){this.c?.(d)}}}),define(re[164],oe([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(re[165],oe([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[166],oe([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(re[167],oe([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(re[168],oe([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(re[169],oe([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(re[170],oe([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(re[171],oe([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(re[172],oe([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[173],oe([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(re[174],oe([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[175],oe([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[176],oe([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(re[177],oe([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(re[178],oe([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(re[179],oe([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(re[180],oe([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(re[181],oe([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[182],oe([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(re[183],oe([11,10]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(re[184],oe([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(re[185],oe([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(re[186],oe([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(re[187],oe([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(re[188],oe([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[189],oe([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[190],oe([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[191],oe([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(re[192],oe([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[193],oe([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(re[194],oe([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(re[195],oe([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(re[196],oe([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(re[197],oe([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(re[198],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$fb=n,e.$_fb=C;function n(E){return E&&E.hasOwnProperty("folderUri")}function C(E){return E&&E.hasOwnProperty("workspace")}}),define(re[199],oe([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nbc=C,e.$obc=E,e.$pbc=R;function C(j){return typeof j?.backupFolder=="string"}function E(j){let k=[];try{Array.isArray(j.workspaces)&&(k=j.workspaces.map(h=>({workspace:{id:h.id,configPath:n.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return k}function R(j){let k=[];try{Array.isArray(j.folders)&&(k=j.folders.map(h=>({folderUri:n.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return k}}),define(re[200],oe([0,1,15,167]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.TokenType=void 0;var E;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(E||(e.TokenType=E={}));function R(...l){switch(l.length){case 1:return(0,C.localize)(0,null,l[0]);case 2:return(0,C.localize)(1,null,l[0],l[1]);case 3:return(0,C.localize)(2,null,l[0],l[1],l[2]);default:return}}const j=(0,C.localize)(3,null),k=(0,C.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(d){switch(d.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return d.isTripleEq?"===":"==";case 4:return d.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return d.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return d.lexeme;case 18:return d.lexeme;case 19:return d.lexeme;case 20:return"EOF";default:throw(0,n.$8)(`unhandled token type: ${JSON.stringify(d)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(d=>d.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(d){return this.c=d,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(R("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(R("&&"));break;case 124:this.h(124)?this.k(16):this.l(R("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(d){return this.r()||this.c.charCodeAt(this.e)!==d?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(d){this.f.push({type:d,offset:this.d})}l(d){const b=this.d,v=this.c.substring(this.d,this.e),m={type:19,offset:this.d,lexeme:v};this.g.push({offset:b,lexeme:v,additionalInfo:d}),this.f.push(m)}n(){this.m.lastIndex=this.d;const d=this.m.exec(this.c);if(d){this.e=this.d+d[0].length;const b=this.c.substring(this.d,this.e),v=h.b.get(b);v?this.k(v):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(j);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let d=this.e,b=!1,v=!1;for(;;){if(d>=this.c.length){this.e=d,this.l(k);return}const f=this.c.charCodeAt(d);if(b)b=!1;else if(f===47&&!v){d++;break}else f===91?v=!0:f===92?b=!0:f===93&&(v=!1);d++}for(;d<this.c.length&&h.a.has(this.c.charCodeAt(d));)d++;this.e=d;const m=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:m,offset:this.d})}r(){return this.e>=this.c.length}}e.$qj=h}),define(re[201],oe([0,1,3,2]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=void 0;class E{constructor(){this.a=new n.$ee,this.b=new n.$ee,this.c=new n.$ee,this.d=new n.$ee}static{this.ChannelName="extensionhostdebugservice"}call(k,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(k,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$Ho=E;class R extends C.$Vc{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,h,l){this.b.call("attach",[k,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,h){this.b.call("terminate",[k,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,h){return this.b.call("openExtensionDevelopmentHostWindow",[k,h])}}e.$Io=R}),define(re[202],oe([0,1,151,51,13,9,36,19,7]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5m=e.$4m=void 0,e.$6m=d,e.$7m=b,e.$4m=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,R.$nc)(E.$Pg.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.$9g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:E.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$9g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const m=(0,n.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,R.$kc)(this.userDataPath,"logs",m)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$9g)(h.URI.file((0,R.$kc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$9g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$9g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$9g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=j.env.VSCODE_PORTABLE;return m?h.URI.file((0,R.$kc)(m,"argv.json")):(0,k.$9g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,R.$kc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,R.$lc)(m):(0,R.$ic)((0,R.$kc)(E.$Pg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const m=this.args["extensions-download-dir"];return m?h.URI.file((0,R.$lc)(m)):h.URI.file((0,R.$kc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,R.$lc)(m);const f=j.env.VSCODE_EXTENSIONS;if(f)return f;const y=j.env.VSCODE_PORTABLE;return y?(0,R.$kc)(y,"extensions"):(0,k.$9g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(f=>/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,R.$ic)(f)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?h.URI.parse(m):h.URI.file((0,R.$ic)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return d(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!j.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(m=>!e.$4m.test(m))}get extensionLogLevel(){const m=[];for(const f of this.args.log||[]){const y=e.$4m.exec(f);y&&y[1]&&y[2]&&m.push([y[1],y[2]])}return m.length?m:void 0}get serviceMachineIdResource(){return(0,k.$9g)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=j.env.VSCODE_PORTABLE;return m?h.URI.file((0,R.$kc)(m,"policy.json")):(0,k.$9g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(m){this.args.continueOn=m}get args(){return this.a}constructor(m,f,y){this.a=m,this.b=f,this.c=y,this.editSessionId=this.args.editSessionId}}e.$5m=l,Ee([C.$Zh],l.prototype,"appRoot",null),Ee([C.$Zh],l.prototype,"userHome",null),Ee([C.$Zh],l.prototype,"userDataPath",null),Ee([C.$Zh],l.prototype,"appSettingsHome",null),Ee([C.$Zh],l.prototype,"tmpDir",null),Ee([C.$Zh],l.prototype,"cacheHome",null),Ee([C.$Zh],l.prototype,"stateResource",null),Ee([C.$Zh],l.prototype,"userRoamingDataHome",null),Ee([C.$Zh],l.prototype,"userDataSyncHome",null),Ee([C.$Zh],l.prototype,"sync",null),Ee([C.$Zh],l.prototype,"machineSettingsResource",null),Ee([C.$Zh],l.prototype,"workspaceStorageHome",null),Ee([C.$Zh],l.prototype,"localHistoryHome",null),Ee([C.$Zh],l.prototype,"keyboardLayoutResource",null),Ee([C.$Zh],l.prototype,"argvResource",null),Ee([C.$Zh],l.prototype,"isExtensionDevelopment",null),Ee([C.$Zh],l.prototype,"untitledWorkspacesHome",null),Ee([C.$Zh],l.prototype,"builtinExtensionsPath",null),Ee([C.$Zh],l.prototype,"extensionsPath",null),Ee([C.$Zh],l.prototype,"extensionDevelopmentLocationURI",null),Ee([C.$Zh],l.prototype,"extensionDevelopmentKind",null),Ee([C.$Zh],l.prototype,"extensionTestsLocationURI",null),Ee([C.$Zh],l.prototype,"debugExtensionHost",null),Ee([C.$Zh],l.prototype,"logLevel",null),Ee([C.$Zh],l.prototype,"extensionLogLevel",null),Ee([C.$Zh],l.prototype,"serviceMachineIdResource",null),Ee([C.$Zh],l.prototype,"disableTelemetry",null),Ee([C.$Zh],l.prototype,"disableWorkspaceTrust",null),Ee([C.$Zh],l.prototype,"useInMemorySecretStorage",null),Ee([C.$Zh],l.prototype,"policyFile",null);function d(v,m){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,m,v.debugId,v.extensionEnvironment)}function b(v,m,f,y,p,$){const w=Number(m||v)||(y?null:f),P=w?!!m:!1;let a;if($)try{a=JSON.parse($)}catch{}return{port:w,break:P,debugId:p,env:a}}}),define(re[116],oe([0,1,313,4,170]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rm=e.$qm=void 0,e.$sm=k,e.$tm=l,e.$um=m,e.$vm=f;const R={o:(0,E.localize)(0,null),e:(0,E.localize)(1,null),t:(0,E.localize)(2,null)};e.$qm=["tunnel","serve-web"],e.$rm={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,E.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,E.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,E.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,E.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,E.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,E.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,E.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,E.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,E.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,E.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,E.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,E.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,E.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,E.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,E.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,E.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,E.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,E.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,E.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,E.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,E.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,E.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,E.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,E.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,E.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,E.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,E.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,E.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,E.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,E.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,E.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,E.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,E.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},"ozone-platform":{type:"string"},_:{type:"string[]"}};const j={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(y,p,$=j){const c=y.find(u=>u.length>0&&u[0]!=="-"),w={},P=["_"],a=[],t={};let r;for(const u in p){const g=p[u];g.type==="subcommand"?u===c&&(r=g):(g.alias&&(w[u]=g.alias),g.type==="string"||g.type==="string[]"?(P.push(u),g.deprecates&&P.push(...g.deprecates)):g.type==="boolean"&&(a.push(u),g.deprecates&&a.push(...g.deprecates)),g.global&&(t[u]=g))}if(r&&c){const u=t;for(const I in r.options)u[I]=r.options[I];const g=y.filter(I=>I!==c),S=$.getSubcommandReporter?$.getSubcommandReporter(c):void 0,D=k(g,u,S);return{[c]:D,_:[]}}const s=n(y,{string:P,boolean:a,alias:w}),i={},o=s;i._=s._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in p){const g=p[u];if(g.type==="subcommand")continue;g.alias&&delete o[g.alias];let S=o[u];if(g.deprecates)for(const D of g.deprecates)o.hasOwnProperty(D)&&(S||(S=o[D],S&&$.onDeprecatedOption(D,g.deprecationMessage||(0,E.localize)(38,null,u))),delete o[D]);if(typeof S<"u"){if(g.type==="string[]"){if(Array.isArray(S)||(S=[S]),!g.allowEmptyValue){const D=S.filter(I=>I.length>0);D.length!==S.length&&($.onEmptyValue(u),S=D.length>0?D:void 0)}}else g.type==="string"&&(Array.isArray(S)?(S=S.pop(),$.onMultipleValues(u,S)):!S&&!g.allowEmptyValue&&($.onEmptyValue(u),S=void 0));i[u]=S,g.deprecationMessage&&$.onDeprecatedOption(u,g.deprecationMessage)}delete o[u]}for(const u in o)$.onUnknownOption(u);return i}function h(y,p){let $="";return p.args&&(Array.isArray(p.args)?$=` <${p.args.join("> <")}>`:$=` <${p.args}>`),p.alias?`-${p.alias} --${y}${$}`:`--${y}${$}`}function l(y,p){const $=[];for(const c in y){const w=y[c],P=h(c,w);$.push([P,w.description])}return d($,p)}function d(y,p){const c=y.reduce((a,t)=>Math.max(a,t[0].length),12)+2+1;if(p-c<25)return y.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const w=p-c-1,P=[];for(const a of y){const t=a[0],r=v(a[1],w),s=b(c-t.length-2);P.push("  "+t+s+r[0]);for(let i=1;i<r.length;i++)P.push(b(c)+r[i])}return P}function b(y){return" ".repeat(y)}function v(y,p){const $=[];for(;y.length;){const c=y.length<p?y.length:y.lastIndexOf(" ",p),w=y.slice(0,c).trim();y=y.slice(c),$.push(w)}return $}function m(y,p,$,c,w){const P=process.stdout.isTTY&&process.stdout.columns||80,a=w?.noInputFiles!==!0?`[${(0,E.localize)(39,null)}...]`:"",t=[`${y} ${$}`];t.push(""),t.push(`${(0,E.localize)(40,null)}: ${p} [${(0,E.localize)(41,null)}]${a}`),t.push(""),w?.noPipe!==!0&&(C.$i?t.push((0,E.localize)(42,null,p)):t.push((0,E.localize)(43,null,p)),t.push(""));const r={},s=[];for(const i in c){const o=c[i];if(o.type==="subcommand")o.description&&s.push({command:i,description:o.description});else if(o.description&&o.cat){let u=r[o.cat];u||(r[o.cat]=u={}),u[i]=o}}for(const i in r){const o=i,u=r[o];u&&(t.push(R[o]),t.push(...l(u,P)),t.push(""))}return s.length&&(t.push((0,E.localize)(44,null)),t.push(...d(s.map(i=>[i.command,i.description]),P)),t.push("")),t.join(`
`)}function f(y,p){return`${y||(0,E.localize)(45,null)}
${p||(0,E.localize)(46,null)}
${process.arch}`}}),define(re[203],oe([0,1,88,201,116]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2bc=void 0;class R extends C.$Ho{constructor(k){super(),this.f=k}call(k,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(k,h,l)}async g(k,h){const l=(0,E.$sm)(k,E.$rm);l.debugRenderer=h;const d=l.extensionDevelopmentPath;if(!d)return{success:!1};const[b]=await this.f.openExtensionDevelopmentHostWindow(d,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const v=b.win;if(!v)return{success:!0};const m=v.webContents.debugger;let f=m.isAttached()?1/0:0;const y=(0,n.createServer)(p=>{f++===0&&m.attach();let $=!1;const c=a=>{$||p.write(JSON.stringify(a)+"\0")},w=(a,t,r,s)=>c({method:t,params:r,sessionId:s});v.on("close",()=>{m.removeListener("message",w),p.end(),$=!0}),m.addListener("message",w);let P=Buffer.alloc(0);p.on("data",a=>{P=Buffer.concat([P,a]);for(let t=P.indexOf(0);t!==-1;t=P.indexOf(0)){let r;try{const s=P.slice(0,t).toString("utf8");P=P.slice(t+1),r=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(r.method,r.params,r.sessionId).then(s=>c({id:r.id,sessionId:r.sessionId,result:s})).catch(s=>c({id:r.id,sessionId:r.sessionId,error:{code:0,message:s.message}}))}}),p.on("error",a=>{console.error("error on cdp pipe:",a)}),p.on("close",()=>{$=!0,--f===0&&m.detach()})});return await new Promise(p=>y.listen(0,p)),v.on("close",()=>y.close()),{rendererDebugPort:y.address().port,success:!0}}}e.$2bc=R}),define(re[64],oe([0,1,314,171,116]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=k,e.$xm=h,e.$ym=l,e.$zm=d;function R(b,v){const m=(w,P)=>{console.warn((0,C.localize)(0,null,w,P))},f=w=>{console.warn((0,C.localize)(1,null,w))},y=(w,P)=>{console.warn((0,C.localize)(2,null,w,P))},p=w=>({onUnknownOption:P=>{E.$qm.includes(w)||console.warn((0,C.localize)(3,null,P,w))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:E.$qm.includes(w)?p:void 0}),$={onUnknownOption:w=>{console.warn((0,C.localize)(4,null,w))},onMultipleValues:m,onEmptyValue:f,onDeprecatedOption:y,getSubcommandReporter:p},c=(0,E.$sm)(b,E.$rm,v?$:void 0);return c.goto&&c._.forEach(w=>n(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(w),(0,C.localize)(5,null))),c}function j(b){const v=b.findIndex(m=>!/^-/.test(m));if(v>-1)return[...b.slice(0,v),...b.slice(v+1)]}function k(b){let[,...v]=b;process.env.VSCODE_DEV&&(v=j(v)||[]);const m=!d(process.env);return R(v,m)}function h(b){let[,,...v]=b;return process.env.VSCODE_DEV&&(v=j(v)||[]),R(v,!0)}function l(b,...v){const m=b.indexOf("--");return m===-1?b.push(...v):b.splice(m,0,...v),b}function d(b){return b.VSCODE_CLI==="1"}}),function(){"use strict";function X(e,n,C){function E(j,k){const h=R(j,k),l=[h];return e.isAbsolute(h)||l.unshift(C),e.resolve(...l)}function R(j,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,k);const d=j["user-data-dir"];if(d)return d;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(b,"AppData","Roaming")}break;case"darwin":l=e.join(n.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(n.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,k)}return{getUserDataPath:E}}if(typeof define=="function")define(re[204],oe([117,26,36]),function(e,n,C){return X(e,n,C.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),n=require("os");module.exports=X(e,n,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[91],oe([0,1,26,202,204]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=void 0,e.$9m=j,e.$0m=k;class R extends C.$5m{constructor(l,d){super(l,{homeDir:(0,n.homedir)(),tmpDir:(0,n.tmpdir)(),userDataDir:(0,E.getUserDataPath)(l,d.nameShort)},d)}}e.$8m=R;function j(h,l){return(0,C.$7m)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}function k(h,l){return(0,C.$7m)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}}),define(re[205],oe([0,1,43,26,31]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$idc=R;function R(j){const k=(0,E.$Dg)((0,C.tmpdir)());try{return(0,n.writeFileSync)(k,""),j&&console.log(`Marker file for --wait created: ${k}`),k}catch(h){j&&console.error(`Failed to create marker file for --wait: ${h}`);return}}}),define(re[206],oe([0,1,12,173]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=E;function E(j,k,h,l){try{R(j,k,h,l)}catch(d){j.error(d?.message??d)}return k}function R(j,k,h,l){const d=(b,v,m)=>{const f=b[v];if((0,n.$8f)(f)){const y=f,p=y.length;if(p>1&&y[0]==="%"&&y[p-1]==="%"){const $=y.substr(1,p-2);let c=h[$];c===void 0&&l&&(c=l[$]);const w=typeof c=="string"?c:c?.message,P=l?.[$],a=typeof P=="string"?P:P?.message;if(!w){a||j.warn(`[${k.name}]: ${(0,C.localize)(0,null,$)}`);return}if(m&&(v==="title"||v==="category")&&a&&a!==w){const t={value:w,original:a};b[v]=t}else b[v]=w}}else if((0,n.$0f)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?d(f,y,!0):d(f,y,m));else if(Array.isArray(f))for(let y=0;y<f.length;y++)d(f,y,m)};for(const b in k)k.hasOwnProperty(b)&&d(k,b)}}),define(re[207],oe([0,1,19,74,175,208]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=h,e.$Gp=l,e.$Hp=d,e.$Ip=b,e.$Jp=v,e.$Kp=m,e.$Lp=f;const j=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function h($){return $=$.trim(),$==="*"||j.test($)}function l($){if(!h($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=$.match(j);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}function d($){if(!$)return null;const c=$.majorBase,w=$.majorMustEqual,P=$.minorBase;let a=$.minorMustEqual;const t=$.patchBase;let r=$.patchMustEqual;$.hasCaret&&(c===0||(a=!1),r=!1);let s=0;if($.preRelease){const i=k.exec($.preRelease);if(i){const[,o,u,g]=i;s=Date.UTC(Number(o),Number(u)-1,Number(g))}}return{majorBase:c,majorMustEqual:w,minorBase:P,minorMustEqual:a,patchBase:t,patchMustEqual:r,isMinimum:$.hasGreaterEquals,notBefore:s}}function b($,c,w){let P;typeof $=="string"?P=d(l($)):P=$;let a;c instanceof Date?a=c.getTime():typeof c=="string"&&(a=new Date(c).getTime());let t;if(typeof w=="string"?t=d(l(w)):t=w,!P||!t)return!1;const r=P.majorBase,s=P.minorBase,i=P.patchBase;let o=t.majorBase,u=t.minorBase,g=t.patchBase;const S=t.notBefore;let D=t.majorMustEqual,I=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:s>u?!0:s<u||a&&a<S?!1:i>=g:(r===1&&o===0&&(!D||!I||!O)&&(o=1,u=0,g=0,D=!0,I=!1,O=!1),r<o?!1:r>o?!D:s<u?!1:s>u?!I:i<g?!1:i>g?!O:!(a&&a<S))}function v($,c,w,P,a){const t=[];if(typeof P.publisher<"u"&&typeof P.publisher!="string")return t.push([C.default.Error,E.localize(0,null)]),t;if(typeof P.name!="string")return t.push([C.default.Error,E.localize(1,null,"name")]),t;if(typeof P.version!="string")return t.push([C.default.Error,E.localize(2,null,"version")]),t;if(!P.engines)return t.push([C.default.Error,E.localize(3,null,"engines")]),t;if(typeof P.engines.vscode!="string")return t.push([C.default.Error,E.localize(4,null,"engines.vscode")]),t;if(typeof P.extensionDependencies<"u"&&!p(P.extensionDependencies))return t.push([C.default.Error,E.localize(5,null,"extensionDependencies")]),t;if(typeof P.activationEvents<"u"){if(!p(P.activationEvents))return t.push([C.default.Error,E.localize(6,null,"activationEvents")]),t;if(typeof P.main>"u"&&typeof P.browser>"u")return t.push([C.default.Error,E.localize(7,null,"activationEvents","main","browser")]),t}if(typeof P.extensionKind<"u"&&typeof P.main>"u"&&t.push([C.default.Warning,E.localize(8,null,"extensionKind")]),typeof P.main<"u"){if(typeof P.main!="string")return t.push([C.default.Error,E.localize(9,null,"main")]),t;{const i=(0,n.$9g)(w,P.main);(0,n.$3g)(i,w)||t.push([C.default.Warning,E.localize(10,null,i.path,w.path)])}}if(typeof P.browser<"u"){if(typeof P.browser!="string")return t.push([C.default.Error,E.localize(11,null,"browser")]),t;{const i=(0,n.$9g)(w,P.browser);(0,n.$3g)(i,w)||t.push([C.default.Warning,E.localize(12,null,i.path,w.path)])}}if(!R.valid(P.version))return t.push([C.default.Error,E.localize(13,null)]),t;const r=[];if(!m($,c,P,a,r))for(const i of r)t.push([C.default.Error,i]);return t}function m($,c,w,P,a){return P||typeof w.main>"u"&&typeof w.browser>"u"?!0:y($,c,w.engines.vscode,a)}function f($,c,w){return $==="*"||y(c,w,$)}function y($,c,w,P=[]){const a=d(l(w));if(!a)return P.push(E.localize(14,null,w)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return P.push(E.localize(15,null,w)),!1}else if(!a.majorMustEqual)return P.push(E.localize(16,null,w)),!1;return b($,c,a)?!0:(P.push(E.localize(17,null,$,w)),!1)}function p($){if(!Array.isArray($))return!1;for(let c=0,w=$.length;c<w;c++)if(typeof $[c]!="string")return!1;return!0}}),define(re[209],oe([0,1,17,33]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=E;async function E(R,j,k){let h=k&&k.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const d=(await j.readFile(R.serviceMachineIdResource)).value.toString();h=(0,C.$Qg)(d)?d:null}catch{h=null}if(!h){h=(0,C.$Rg)();try{await j.writeFile(R.serviceMachineIdResource,n.$Fe.fromString(h))}catch{}}return k?.store("storage.serviceMachineId",h,-1,1),h}}),define(re[78],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=void 0;class n{constructor(E,R=[],j=!1){this.ctor=E,this.staticArguments=R,this.supportsDelayedInstantiation=j}}e.$si=n}),define(re[210],oe([0,1,78]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ws=R,e.$xs=j;const C=[];var E;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(E||(e.InstantiationType=E={}));function R(k,h,l){h instanceof n.$si||(h=new n.$si(h,[],!!l)),C.push([k,h])}function j(){return C}}),define(re[211],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class n{constructor(R,j){this.key=R,this.data=j,this.incoming=new Map,this.outgoing=new Map}}e.$_q=n;class C{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const j of this.a.values())j.outgoing.size===0&&R.push(j);return R}insertEdge(R,j){const k=this.lookupOrInsertNode(R),h=this.lookupOrInsertNode(j);k.outgoing.set(h.key,h),h.incoming.set(k.key,k)}removeNode(R){const j=this.b(R);this.a.delete(j);for(const k of this.a.values())k.outgoing.delete(j),k.incoming.delete(j)}lookupOrInsertNode(R){const j=this.b(R);let k=this.a.get(j);return k||(k=new n(j,R),this.a.set(j,k)),k}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[j,k]of this.a)R.push(`${j}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,j]of this.a){const k=new Set([R]),h=this.c(j,k);if(h)return h}}c(R,j){for(const[k,h]of R.outgoing){if(j.has(k))return[...j,k].join(" -> ");j.add(k);const l=this.c(h,j);if(l)return l;j.delete(k)}}}e.$ar=C}),define(re[6],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e._util=void 0,e.$vi=E,e.$wi=R;var n;(function(j){j.serviceIds=new Map,j.DI_TARGET="$di$target",j.DI_DEPENDENCIES="$di$dependencies";function k(h){return h[j.DI_DEPENDENCIES]||[]}j.getServiceDependencies=k})(n||(e._util=n={})),e.$ui=E("instantiationService");function C(j,k,h){k[n.DI_TARGET]===k?k[n.DI_DEPENDENCIES].push({id:j,index:h}):(k[n.DI_DEPENDENCIES]=[{id:j,index:h}],k[n.DI_TARGET]=k)}function E(j){if(n.serviceIds.has(j))return n.serviceIds.get(j);const k=function(h,l,d){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(k,h,d)};return k.toString=()=>j,n.serviceIds.set(j,k),k}function R(j){return j}}),define(re[79],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hcc=void 0,e.$hcc=(0,n.$vi)("auxiliaryWindowsMainService")}),define(re[65],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qbc=void 0,e.$qbc=(0,n.$vi)("backupMainService")}),define(re[18],oe([0,1,12,7,6]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$2i=void 0,e.$3i=R,e.$4i=j,e.$5i=h,e.$6i=l,e.$7i=d,e.$8i=b,e.$9i=v,e.$0i=f,e.$$i=y,e.$_i=p,e.$2i=(0,E.$vi)("configurationService");function R($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof C.URI)}function j($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof C.URI)}var k;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function h($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function l($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}function d($,c){const w=Object.create(null);for(const P in $)b(w,P,$[P],c);return w}function b($,c,w,P){const a=c.split("."),t=a.pop();let r=$;for(let s=0;s<a.length;s++){const i=a[s];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":if(o===null){P(`Ignoring ${c} as ${a.slice(0,s+1).join(".")} is null`);return}break;default:P(`Ignoring ${c} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[t]=w}catch{P(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(r)}`)}else P(`Ignoring ${c} as ${a.join(".")} is ${JSON.stringify(r)}`)}function v($,c){const w=c.split(".");m($,w)}function m($,c){const w=c.shift();if(c.length===0){delete $[w];return}if(Object.keys($).indexOf(w)!==-1){const P=$[w];typeof P=="object"&&!Array.isArray(P)&&(m(P,c),Object.keys(P).length===0&&delete $[w])}}function f($,c,w){function P(r,s){let i=r;for(const o of s){if(typeof i!="object"||i===null)return;i=i[o]}return i}const a=c.split("."),t=P($,a);return typeof t>"u"?w:t}function y($,c,w){Object.keys(c).forEach(P=>{P!=="__proto__"&&(P in $?n.$0f($[P])&&n.$0f(c[P])?y($[P],c[P],w):w&&($[P]=c[P]):$[P]=c[P])})}function p($){return $.replace(/[\[\]]/g,"")}}),define(re[118],oe([0,1,4,25,200,6,166,15]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$tj=e.$sj=e.ContextKeyExprType=void 0,e.$rj=l,e.$uj=r,e.$vj=s,e.$Oj=ae;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",n.$j),h.set("isLinux",n.$k),h.set("isWindows",n.$i),h.set("isWeb",n.$o),h.set("isMacNative",n.$j&&!n.$o),h.set("isEdge",n.$H),h.set("isFirefox",n.$F),h.set("isChrome",n.$E),h.set("isSafari",n.$G);function l(Y,A){if(h.get(Y)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(Y,A)}const d=Object.prototype.hasOwnProperty;var b;(function(Y){Y[Y.False=0]="False",Y[Y.True=1]="True",Y[Y.Defined=2]="Defined",Y[Y.Not=3]="Not",Y[Y.Equals=4]="Equals",Y[Y.NotEquals=5]="NotEquals",Y[Y.And=6]="And",Y[Y.Regex=7]="Regex",Y[Y.NotRegex=8]="NotRegex",Y[Y.Or=9]="Or",Y[Y.In=10]="In",Y[Y.NotIn=11]="NotIn",Y[Y.Greater=12]="Greater",Y[Y.GreaterEquals=13]="GreaterEquals",Y[Y.Smaller=14]="Smaller",Y[Y.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const v={regexParsingWithErrorRecovery:!0},m=(0,j.localize)(0,null),f=(0,j.localize)(1,null),y=(0,j.localize)(2,null),p=(0,j.localize)(3,null),$=(0,j.localize)(4,null),c=(0,j.localize)(5,null),w=(0,j.localize)(6,null),P=(0,j.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(A=v){this.k=A,this.d=new E.$qj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(A){if(A===""){this.h.push({message:m,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(A).scan(),this.g=0,this.h=[];try{const N=this.l();if(!this.E()){const _=this.D(),ne=_.type===17?c:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:E.$qj.getLexeme(_),additionalInfo:ne}),a.c}return N}catch(N){if(N!==a.c)throw N;return}}l(){return this.m()}m(){const A=[this.o()];for(;this.y(16);){const N=this.o();A.push(N)}return A.length===1?A[0]:t.or(...A)}o(){const A=[this.s()];for(;this.y(15);){const N=this.s();A.push(N)}return A.length===1?A[0]:t.and(...A)}s(){if(this.y(2)){const A=this.D();switch(A.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const N=this.l();return this.A(1,p),N?.negate()}case 17:return this.z(),M.create(A.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",A)}}return this.t()}t(){const A=this.D();switch(A.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const N=this.l();return this.A(1,p),N}case 17:{const N=A.lexeme;if(this.z(),this.y(9)){const ne=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),ne.type!==10)throw this.B("REGEX",ne);const J=ne.lexeme,V=J.lastIndexOf("/"),x=V===J.length-1?void 0:this.w(J.substring(V+1));let H;try{H=new RegExp(J.substring(1,V),x)}catch{throw this.B("REGEX",ne)}return ee.create(N,H)}switch(ne.type){case 10:case 19:{const J=[ne.lexeme];this.z();let V=this.D(),x=0;for(let $e=0;$e<ne.lexeme.length;$e++)ne.lexeme.charCodeAt($e)===40?x++:ne.lexeme.charCodeAt($e)===41&&x--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:x++;break;case 1:x--;break;case 10:case 18:for(let $e=0;$e<V.lexeme.length;$e++)V.lexeme.charCodeAt($e)===40?x++:ne.lexeme.charCodeAt($e)===41&&x--}if(x<0)break;J.push(E.$qj.getLexeme(V)),this.z(),V=this.D()}const H=J.join(""),se=H.lastIndexOf("/"),he=se===H.length-1?void 0:this.w(H.substring(se+1));let me;try{me=new RegExp(H.substring(1,se),he)}catch{throw this.B("REGEX",ne)}return t.regex(N,me)}case 18:{const J=ne.lexeme;this.z();let V=null;if(!(0,C.$7e)(J)){const x=J.indexOf("/"),H=J.lastIndexOf("/");if(x!==H&&x>=0){const se=J.slice(x+1,H),he=J[H+1]==="i"?"i":"";try{V=new RegExp(se,he)}catch{throw this.B("REGEX",ne)}}}if(V===null)throw this.B("REGEX",ne);return ee.create(N,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,y);const ne=this.u();return t.notIn(N,ne)}switch(this.D().type){case 3:{this.z();const ne=this.u();if(this.x().type===18)return t.equals(N,ne);switch(ne){case"true":return t.has(N);case"false":return t.not(N);default:return t.equals(N,ne)}}case 4:{this.z();const ne=this.u();if(this.x().type===18)return t.notEquals(N,ne);switch(ne){case"true":return t.not(N);case"false":return t.has(N);default:return t.notEquals(N,ne)}}case 5:return this.z(),q.create(N,this.u());case 6:return this.z(),ue.create(N,this.u());case 7:return this.z(),F.create(N,this.u());case 8:return this.z(),T.create(N,this.u());case 13:return this.z(),t.in(N,this.u());default:return t.has(N)}}case 20:throw this.h.push({message:w,offset:A.offset,lexeme:"",additionalInfo:P}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const A=this.D();switch(A.type){case 17:case 18:return this.z(),A.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(A){return A.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(A){return this.C(A)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(A,N){if(this.C(A))return this.z();throw this.B(N,this.D())}B(A,N,_){const ne=(0,j.localize)(8,null,A,E.$qj.getLexeme(N)),J=N.offset,V=E.$qj.getLexeme(N);return this.h.push({message:ne,offset:J,lexeme:V,additionalInfo:_}),a.c}C(A){return this.D().type===A}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$sj=a;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(A){return g.create(A)}static equals(A,N){return S.create(A,N)}static notEquals(A,N){return O.create(A,N)}static regex(A,N){return ee.create(A,N)}static in(A,N){return D.create(A,N)}static notIn(A,N){return I.create(A,N)}static not(A){return M.create(A)}static and(...A){return Q.create(A,null,!0)}static or(...A){return B.create(A,null,!0)}static greater(A,N){return F.create(A,N)}static greaterEquals(A,N){return T.create(A,N)}static smaller(A,N){return q.create(A,N)}static smallerEquals(A,N){return ue.create(A,N)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(A){return A==null?void 0:this.c.parse(A)}}e.$tj=t;function r(Y){const A=new a({regexParsingWithErrorRecovery:!1});return Y.map(N=>(A.parse(N),A.lexingErrors.length>0?A.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,j.localize)(9,null,_.additionalInfo):(0,j.localize)(10,null),offset:_.offset,length:_.lexeme.length})):A.parsingErrors.length>0?A.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}function s(Y,A){const N=Y?Y.substituteConstants():void 0,_=A?A.substituteConstants():void 0;return!N&&!_?!0:!N||!_?!1:N.equals(_)}function i(Y,A){return Y.cmp(A)}class o{static{this.INSTANCE=new o}constructor(){this.type=0}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!1}serialize(){return"false"}keys(){return[]}map(A){return this}negate(){return u.INSTANCE}}e.$wj=o;class u{static{this.INSTANCE=new u}constructor(){this.type=1}cmp(A){return this.type-A.type}equals(A){return A.type===this.type}substituteConstants(){return this}evaluate(A){return!0}serialize(){return"true"}keys(){return[]}map(A){return this}negate(){return o.INSTANCE}}e.$xj=u;class g{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?u.INSTANCE:o.INSTANCE:new g(A,N)}constructor(A,N){this.key=A,this.c=N,this.type=2}cmp(A){return A.type!==this.type?this.type-A.type:z(this.key,A.key)}equals(A){return A.type===this.type?this.key===A.key:!1}substituteConstants(){const A=h.get(this.key);return typeof A=="boolean"?A?u.INSTANCE:o.INSTANCE:this}evaluate(A){return!!A.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(A){return A.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$yj=g;class S{static create(A,N,_=null){if(typeof N=="boolean")return N?g.create(A,_):M.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?u.INSTANCE:o.INSTANCE:new S(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=4}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?u.INSTANCE:o.INSTANCE}return this}evaluate(A){return A.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(A){return A.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$zj=S;class D{static create(A,N){return new D(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=10,this.c=null}cmp(A){return A.type!==this.type?this.type-A.type:U(this.d,this.f,A.d,A.f)}equals(A){return A.type===this.type?this.d===A.d&&this.f===A.f:!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.f),_=A.getValue(this.d);return Array.isArray(N)?N.includes(_):typeof _=="string"&&typeof N=="object"&&N!==null?d.call(N,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(A){return A.mapIn(this.d,this.f)}negate(){return this.c||(this.c=I.create(this.d,this.f)),this.c}}e.$Aj=D;class I{static create(A,N){return new I(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=11,this.c=D.create(A,N)}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(A){return A.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bj=I;class O{static create(A,N,_=null){if(typeof N=="boolean")return N?M.create(A,_):g.create(A,_);const ne=h.get(A);return typeof ne=="boolean"?N===(ne?"true":"false")?o.INSTANCE:u.INSTANCE:new O(A,N,_)}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=5}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){const A=h.get(this.c);if(typeof A=="boolean"){const N=A?"true":"false";return this.d===N?o.INSTANCE:u.INSTANCE}return this}evaluate(A){return A.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(A){return A.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Cj=O;class M{static create(A,N=null){const _=h.get(A);return typeof _=="boolean"?_?o.INSTANCE:u.INSTANCE:new M(A,N)}constructor(A,N){this.c=A,this.d=N,this.type=3}cmp(A){return A.type!==this.type?this.type-A.type:z(this.c,A.c)}equals(A){return A.type===this.type?this.c===A.c:!1}substituteConstants(){const A=h.get(this.c);return typeof A=="boolean"?A?o.INSTANCE:u.INSTANCE:this}evaluate(A){return!A.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(A){return A.mapNot(this.c)}negate(){return this.d||(this.d=g.create(this.c,this)),this.d}}e.$Dj=M;function W(Y,A){if(typeof Y=="string"){const N=parseFloat(Y);isNaN(N)||(Y=N)}return typeof Y=="string"||typeof Y=="number"?A(Y):o.INSTANCE}class F{static create(A,N,_=null){return W(N,ne=>new F(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=12}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Ej=F;class T{static create(A,N,_=null){return W(N,ne=>new T(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=13}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(A){return A.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fj=T;class q{static create(A,N,_=null){return W(N,ne=>new q(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=14}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$Gj=q;class ue{static create(A,N,_=null){return W(N,ne=>new ue(A,ne,_))}constructor(A,N,_){this.c=A,this.d=N,this.f=_,this.type=15}cmp(A){return A.type!==this.type?this.type-A.type:U(this.c,this.d,A.c,A.d)}equals(A){return A.type===this.type?this.c===A.c&&this.d===A.d:!1}substituteConstants(){return this}evaluate(A){return typeof this.d=="string"?!1:parseFloat(A.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(A){return A.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=F.create(this.c,this.d,this)),this.f}}e.$Hj=ue;class ee{static create(A,N){return new ee(A,N)}constructor(A,N){this.d=A,this.f=N,this.type=7,this.c=null}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.d<A.d)return-1;if(this.d>A.d)return 1;const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return N<_?-1:N>_?1:0}equals(A){if(A.type===this.type){const N=this.f?this.f.source:"",_=A.f?A.f.source:"";return this.d===A.d&&N===_}return!1}substituteConstants(){return this}evaluate(A){const N=A.getValue(this.d);return this.f?this.f.test(N):!1}serialize(){const A=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${A}`}keys(){return[this.d]}map(A){return A.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Ij=ee;class ce{static create(A){return new ce(A)}constructor(A){this.c=A,this.type=8}cmp(A){return A.type!==this.type?this.type-A.type:this.c.cmp(A.c)}equals(A){return A.type===this.type?this.c.equals(A.c):!1}substituteConstants(){return this}evaluate(A){return!this.c.evaluate(A)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(A){return new ce(this.c.map(A))}negate(){return this.c}}e.$Jj=ce;function K(Y){let A=null;for(let N=0,_=Y.length;N<_;N++){const ne=Y[N].substituteConstants();if(Y[N]!==ne&&A===null){A=[];for(let J=0;J<N;J++)A[J]=Y[J]}A!==null&&(A[N]=ne)}return A===null?Y:A}class Q{static create(A,N,_){return Q.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=6}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=i(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:Q.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].evaluate(A))return!1;return!0}static d(A,N,_){const ne=[];let J=!1;for(const V of A)if(V){if(V.type===1){J=!0;continue}if(V.type===0)return o.INSTANCE;if(V.type===6){ne.push(...V.expr);continue}ne.push(V)}if(ne.length===0&&J)return u.INSTANCE;if(ne.length!==0){if(ne.length===1)return ne[0];ne.sort(i);for(let V=1;V<ne.length;V++)ne[V-1].equals(ne[V])&&(ne.splice(V,1),V--);if(ne.length===1)return ne[0];for(;ne.length>1;){const V=ne[ne.length-1];if(V.type!==9)break;ne.pop();const x=ne.pop(),H=ne.length===0,se=B.create(V.expr.map(he=>Q.create([he,x],null,_)),null,H);se&&(ne.push(se),ne.sort(i))}if(ne.length===1)return ne[0];if(_){for(let V=0;V<ne.length;V++)for(let x=V+1;x<ne.length;x++)if(ne[V].negate().equals(ne[x]))return o.INSTANCE;if(ne.length===1)return ne[0]}return new Q(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" && ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new Q(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());this.c=B.create(A,this,!0)}return this.c}}e.$Kj=Q;class B{static create(A,N,_){return B.d(A,N,_)}constructor(A,N){this.expr=A,this.c=N,this.type=9}cmp(A){if(A.type!==this.type)return this.type-A.type;if(this.expr.length<A.expr.length)return-1;if(this.expr.length>A.expr.length)return 1;for(let N=0,_=this.expr.length;N<_;N++){const ne=i(this.expr[N],A.expr[N]);if(ne!==0)return ne}return 0}equals(A){if(A.type===this.type){if(this.expr.length!==A.expr.length)return!1;for(let N=0,_=this.expr.length;N<_;N++)if(!this.expr[N].equals(A.expr[N]))return!1;return!0}return!1}substituteConstants(){const A=K(this.expr);return A===this.expr?this:B.create(A,this.c,!1)}evaluate(A){for(let N=0,_=this.expr.length;N<_;N++)if(this.expr[N].evaluate(A))return!0;return!1}static d(A,N,_){let ne=[],J=!1;if(A){for(let V=0,x=A.length;V<x;V++){const H=A[V];if(H){if(H.type===0){J=!0;continue}if(H.type===1)return u.INSTANCE;if(H.type===9){ne=ne.concat(H.expr);continue}ne.push(H)}}if(ne.length===0&&J)return o.INSTANCE;ne.sort(i)}if(ne.length!==0){if(ne.length===1)return ne[0];for(let V=1;V<ne.length;V++)ne[V-1].equals(ne[V])&&(ne.splice(V,1),V--);if(ne.length===1)return ne[0];if(_){for(let V=0;V<ne.length;V++)for(let x=V+1;x<ne.length;x++)if(ne[V].negate().equals(ne[x]))return u.INSTANCE;if(ne.length===1)return ne[0]}return new B(ne,N)}}serialize(){return this.expr.map(A=>A.serialize()).join(" || ")}keys(){const A=[];for(const N of this.expr)A.push(...N.keys());return A}map(A){return new B(this.expr.map(N=>N.map(A)),null)}negate(){if(!this.c){const A=[];for(const N of this.expr)A.push(N.negate());for(;A.length>1;){const N=A.shift(),_=A.shift(),ne=[];for(const J of le(N))for(const V of le(_))ne.push(Q.create([J,V],null,!1));A.unshift(B.create(ne,null,!1))}this.c=B.create(A,this,!0)}return this.c}}e.$Lj=B;class L extends g{static{this.d=[]}static all(){return L.d.values()}constructor(A,N,_){super(A,null),this.f=N,typeof _=="object"?L.d.push({..._,key:A}):_!==!0&&L.d.push({key:A,description:_,type:N!=null?typeof N:void 0})}bindTo(A){return A.createKey(this.key,this.f)}getValue(A){return A.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(A){return S.create(this.key,A)}notEqualsTo(A){return O.create(this.key,A)}}e.$Mj=L,e.$Nj=(0,R.$vi)("contextKeyService");function z(Y,A){return Y<A?-1:Y>A?1:0}function U(Y,A,N,_){return Y<N?-1:Y>N?1:A<_?-1:A>_?1:0}function ae(Y,A){if(Y.type===0||A.type===1)return!0;if(Y.type===9)return A.type===9?G(Y.expr,A.expr):!1;if(A.type===9){for(const N of A.expr)if(ae(Y,N))return!0;return!1}if(Y.type===6){if(A.type===6)return G(A.expr,Y.expr);for(const N of Y.expr)if(ae(N,A))return!0;return!1}return Y.equals(A)}function G(Y,A){let N=0,_=0;for(;N<Y.length&&_<A.length;){const ne=Y[N].cmp(A[_]);if(ne<0)return!1;ne===0&&N++,_++}return N===Y.length}function le(Y){return Y.type===9?Y.expr:[Y]}}),define(re[92],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$en=e.$cn=e.ID=void 0,e.$dn=C,e.ID="diagnosticsService",e.$cn=(0,n.$vi)(e.ID);function C(R){return!!R.hostName&&!!R.errorMessage}class E{async getPerformanceInfo(j,k){return{}}async getSystemInfo(j,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(j,k){return""}async getWorkspaceFileExtensions(j){return{extensions:[]}}async reportWorkspaceStats(j){}}e.$en=E}),define(re[119],oe([0,1,19,74,168,6,48,4,35]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfirmResult=e.$Iw=e.$Hw=e.$Gw=void 0,e.$Jw=m,e.$Kw=f,e.$Gw=(0,R.$vi)("dialogService");var l;(function(y){y[y.Confirmation=1]="Confirmation",y[y.Prompt=2]="Prompt",y[y.Input=3]="Input"})(l||(l={}));class d{a(p){return this.d(p,l.Confirmation)}b(p){return this.d(p,l.Prompt)}c(p){return this.d(p,l.Input)}d(p,$){const c=[];switch($){case l.Confirmation:{const w=p;w.primaryButton?c.push(w.primaryButton):c.push((0,E.localize)(0,null)),w.cancelButton?c.push(w.cancelButton):c.push((0,E.localize)(1,null));break}case l.Prompt:{const w=p;Array.isArray(w.buttons)&&w.buttons.length>0&&c.push(...w.buttons.map(P=>P.label)),w.cancelButton&&(w.cancelButton===!0?c.push((0,E.localize)(2,null)):typeof w.cancelButton=="string"?c.push(w.cancelButton):w.cancelButton.label?c.push(w.cancelButton.label):c.push((0,E.localize)(3,null))),c.length===0&&c.push((0,E.localize)(4,null));break}case l.Input:{const w=p;w.primaryButton?c.push(w.primaryButton):c.push((0,E.localize)(5,null)),w.cancelButton?c.push(w.cancelButton):c.push((0,E.localize)(6,null));break}}return c}e(p){if(typeof p=="string")return p;if(typeof p=="number")return p===C.default.Info?"info":p===C.default.Error?"error":p===C.default.Warning?"warning":"none"}f(p,$,c){const w=[...p.buttons??[]];p.cancelButton&&typeof p.cancelButton!="string"&&typeof p.cancelButton!="boolean"&&w.push(p.cancelButton);let P=w[$]?.run({checkboxChecked:c});return P instanceof Promise||(P=Promise.resolve(P)),{result:P,checkboxChecked:c}}}e.$Hw=d,e.$Iw=(0,R.$vi)("fileDialogService");var b;(function(y){y[y.SAVE=0]="SAVE",y[y.DONT_SAVE=1]="DONT_SAVE",y[y.CANCEL=2]="CANCEL"})(b||(e.ConfirmResult=b={}));const v=10;function m(y){const p=[];return p.push(...y.slice(0,v).map($=>typeof $=="string"?$:(0,n.$6g)($))),y.length>v&&(y.length-v===1?p.push((0,E.localize)(7,null)):p.push((0,E.localize)(8,null,y.length-v))),p.push(""),p.join(`
`)}function f(y,p){const $=(0,h.$2n)(y);let c=($.buttons??[]).map(t=>(0,j.$Dw)(t)),w=(y.buttons||[]).map((t,r)=>r),P=0,a=$.cancelId??c.length-1;if(c.length>1){const t=typeof a=="number"?c[a]:void 0;if(k.$k||k.$j){if(typeof t=="string"&&c.length>1&&a!==1){c.splice(a,1),c.splice(1,0,t);const r=w[a];w.splice(a,1),w.splice(1,0,r),a=1}k.$k&&c.length>1&&(c=c.reverse(),w=w.reverse(),P=c.length-1,typeof t=="string"&&(a=P-1))}else if(k.$i&&typeof t=="string"&&c.length>1&&a!==c.length-1){c.splice(a,1),c.push(t);const r=w[a];w.splice(a,1),w.push(r),a=c.length-1}}return $.buttons=c,$.defaultId=P,$.cancelId=a,$.noLink=!0,$.title=$.title||p.nameLong,{options:$,buttonIndeces:w}}}),define(re[120],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$xX=e.$wX=void 0,e.$yX=R,e.$zX=j,e.$wX=(0,n.$vi)("encryptionService"),e.$xX=(0,n.$vi)("encryptionMainService");var C;(function(k){k.kwallet="kwallet",k.kwallet5="kwallet5",k.gnomeLibsecret="gnome-libsecret",k.basic="basic"})(C||(e.PasswordStoreCLIOption=C={}));var E;(function(k){k.unknown="unknown",k.basicText="basic_text",k.gnomeAny="gnome_any",k.gnomeLibsecret="gnome_libsecret",k.gnomeKeyring="gnome_keyring",k.kwallet="kwallet",k.kwallet5="kwallet5",k.kwallet6="kwallet6",k.dplib="dpapi",k.keychainAccess="keychain_access"})(E||(e.KnownStorageProvider=E={}));function R(k){return k==="kwallet"||k==="kwallet5"||k==="kwallet6"}function j(k){return k==="gnome_any"||k==="gnome_libsecret"||k==="gnome_keyring"}}),define(re[38],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=void 0,e.$Ci=(0,n.$vi)("environmentService"),e.$Di=(0,n.$wi)(e.$Ci)}),define(re[121],oe([0,1,172,6]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.ExtensionGalleryErrorCode=e.$6o=e.ExtensionManagementErrorCode=e.$5o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Yo=E,e.$Zo=R,e.$1o=j,e.$2o=k,e.$3o=h,e.$4o=l,e.$So="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$To=new RegExp(e.$So),e.$Uo="__web_extension",e.$Vo="skipWalkthrough",e.$Wo="extensionsSync",e.$Xo="dependecyOrPackExtensionInstall";function E(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function R(c){switch(c){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function j(c,w){switch(c){case 3:return w==="x64"?"win32-x64":w==="arm64"?"win32-arm64":"unknown";case 2:return w==="x64"?"linux-x64":w==="arm64"?"linux-arm64":w==="arm"?"linux-armhf":"unknown";case"alpine":return w==="x64"?"alpine-x64":w==="arm64"?"alpine-arm64":"unknown";case 1:return w==="x64"?"darwin-x64":w==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function k(c,w){return w==="web"&&!c.includes("web")}function h(c,w,P){return k(w,P)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===P}function l(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}var d;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(d||(e.SortBy=d={}));var b;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(b||(e.SortOrder=b={}));var v;(function(c){c.Install="install",c.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var m;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(m||(e.InstallOperation=m={})),e.$5o=(0,C.$vi)("extensionGalleryService");var f;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.DownloadSignature="DownloadSignature",c.UpdateMetadata="UpdateMetadata",c.Extract="Extract",c.Scanning="Scanning",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.NotAllowed="NotAllowed",c.Gallery="Gallery",c.Cancelled="Cancelled",c.Unknown="Unknown",c.Internal="Internal"})(f||(e.ExtensionManagementErrorCode=f={}));class y extends Error{constructor(w,P){super(w),this.code=P,this.name=P}}e.$6o=y;var p;(function(c){c.Timeout="Timeout",c.Cancelled="Cancelled",c.Failed="Failed"})(p||(e.ExtensionGalleryErrorCode=p={}));class $ extends Error{constructor(w,P){super(w),this.code=P,this.name=P}}e.$7o=$,e.$8o=(0,C.$vi)("extensionManagementService"),e.$9o="extensionsIdentifiers/disabled",e.$0o="extensionsIdentifiers/enabled",e.$$o=(0,C.$vi)("IGlobalExtensionEnablementService"),e.$_o=(0,C.$vi)("IExtensionTipsService"),e.$ap=(0,n.localize2)(0,"Extensions"),e.$bp=(0,n.localize2)(1,"Preferences")}),define(re[212],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0bc=e.$9bc=void 0,e.$9bc=(0,n.$vi)("extensionHostStarter"),e.$0bc="extensionHostStarter"}),define(re[213],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$56b=e.$46b=void 0,e.$46b=(0,n.$vi)("externalTerminal"),e.$56b="Terminal.app"}),define(re[214],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_bc=void 0,e.$_bc=(0,n.$vi)("externalTerminal")}),define(re[215],oe([0,1,49,51,13,9,4,76,21,90,176,213]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ccc=e.$bcc=e.$acc=void 0;const v=d.localize(0,null);class m{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await p.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends m{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(n,a,l.$nm(),t)}spawnTerminal(a,t,r,s){const i=t.windowsExec||f.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=R.$oc(i,".exe").toLowerCase();if(o==="cmder")return a.spawn(i,s?[s]:void 0),Promise.resolve(void 0);const u=["/c","start","/wait"];return i.indexOf(" ")>=0&&u.push('""'),u.push(i),o==="wt"&&u.push("-d ."),new Promise((g,S)=>{const D=$(process),I=a.spawn(r,u,{cwd:s,env:D,detached:!0});I.on("error",S),I.on("exit",()=>g())})}async runInTerminal(a,t,r,s,i){const o="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows(),u=await f.f();return new Promise((g,S)=>{const D=`"${t} - ${v}"`,I=`"${r.join('" "')}" & pause`,O=Object.assign({},$(process),s);Object.keys(O).filter(q=>O[q]===null).forEach(q=>delete O[q]);const M={cwd:t,env:O,windowsVerbatimArguments:!0};let W,F;R.$oc(o,".exe")==="wt"?(W=o,F=["-d",".",f.b,"/c",I]):u?(W=u,F=["-d",".",o,"/c",I]):(W=f.b,F=["/c","start",D,"/wait",o,"/c",`"${I}"`]),n.spawn(W,F,M).on("error",q=>{S(c(q))}),g(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return f.d}static async f(){try{const a=await l.win32.findExecutable("wt");return await h.Promises.exists(a)?a:void 0}catch{return}}}e.$acc=f,Ee([C.$Zh],f,"f",null);class y extends m{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.osxExec||b.$56b;return new Promise((u,g)=>{if(o===b.$56b||o==="iTerm.app"){const S=o===b.$56b?"TerminalHelper":"iTermHelper",I=[E.$Pg.asFileUri(`vs/workbench/contrib/externalTerminal/node/${S}.scpt`).fsPath,"-t",a||v,"-w",t];for(const W of r)I.push("-a"),I.push(W);if(s){const W=Object.assign({},$(process),s);for(const F in W){const T=W[F];T===null?(I.push("-u"),I.push(F)):(I.push("-e"),I.push(`${F}=${T}`))}}let O="";const M=n.spawn(y.b,I);M.on("error",W=>{g(c(W))}),M.stderr.on("data",W=>{O+=W.toString()}),M.on("exit",W=>{if(W===0)u(void 0);else if(O){const F=O.split(`
`,1);g(new Error(F[0]))}else g(new Error(d.localize(1,null,S,W)))})}else g(new Error(d.localize(2,null,o)))})}spawnTerminal(a,t,r){const s=t.osxExec||b.$56b;return new Promise((i,o)=>{const u=["-a",s];r&&u.push(r);const g=$(process),S=a.spawn("/usr/bin/open",u,{cwd:r,env:g});S.on("error",o),S.on("exit",()=>i())})}}e.$bcc=y;class p extends m{static{this.b=d.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(n,a,t)}runInTerminal(a,t,r,s,i){const o=i.linuxExec?Promise.resolve(i.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((u,g)=>{const S=[];o.then(D=>{D.indexOf("gnome-terminal")>=0?S.push("-x"):S.push("-e"),S.push("bash"),S.push("-c");const I=`${w(r)}; echo; read -p "${p.b}" -n1;`;S.push(`''${I}''`);const O=Object.assign({},$(process),s);Object.keys(O).filter(T=>O[T]===null).forEach(T=>delete O[T]);const M={cwd:t,env:O};let W="";const F=n.spawn(D,S,M);F.on("error",T=>{g(c(T))}),F.stderr.on("data",T=>{W+=T.toString()}),F.on("exit",T=>{if(T===0)u(void 0);else if(W){const q=W.split(`
`,1);g(new Error(q[0]))}else g(new Error(d.localize(4,null,D,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!p.d)if(!j.$k)p.d=Promise.resolve("xterm");else{const a=await h.Promises.exists("/etc/debian_version");p.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return p.d}spawnTerminal(a,t,r){const s=t.linuxExec?Promise.resolve(t.linuxExec):p.getDefaultTerminalLinuxReady();return new Promise((i,o)=>{s.then(u=>{const g=$(process),S=a.spawn(u,[],{cwd:r,env:g});S.on("error",o),S.on("exit",()=>i())})})}}e.$ccc=p;function $(P){const a={...P.env};return(0,k.$lm)(a),a}function c(P){return"errno"in P&&P.errno==="ENOENT"&&"path"in P&&typeof P.path=="string"?new Error(d.localize(5,null,P.path)):P}function w(P){let a="";for(const t of P)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(re[16],oe([0,1,59,9,25,12,7,178,6,4,13,62]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$ul=e.FileKind=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.FileOperationResult=e.$ml=e.$ll=e.$kl=e.$il=e.FileChangeType=e.$hl=e.FileOperation=e.$bl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$2k=void 0,e.$3k=v,e.$4k=p,e.$5k=c,e.$6k=w,e.$7k=P,e.$8k=a,e.$9k=t,e.$0k=r,e.$$k=s,e.$_k=i,e.$al=o,e.$cl=S,e.$dl=D,e.$el=I,e.$fl=O,e.$gl=M,e.$jl=ue,e.$vl=L,e.$wl=z,e.$yl=ae,e.$2k=(0,h.$vi)("fileService");function v(G){return G.create===!0}var m;(function(G){G[G.Unknown=0]="Unknown",G[G.File=1]="File",G[G.Directory=2]="Directory",G[G.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var f;(function(G){G[G.Readonly=1]="Readonly",G[G.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var y;(function(G){G[G.UPDATED=2]="UPDATED",G[G.ADDED=4]="ADDED",G[G.DELETED=8]="DELETED"})(y||(e.FileChangeFilter=y={}));function p(G){const le=G;return!!le&&typeof le.onDidChange=="function"}var $;(function(G){G[G.None=0]="None",G[G.FileReadWrite=2]="FileReadWrite",G[G.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",G[G.FileReadStream=16]="FileReadStream",G[G.FileFolderCopy=8]="FileFolderCopy",G[G.PathCaseSensitive=1024]="PathCaseSensitive",G[G.Readonly=2048]="Readonly",G[G.Trash=4096]="Trash",G[G.FileWriteUnlock=8192]="FileWriteUnlock",G[G.FileAtomicRead=16384]="FileAtomicRead",G[G.FileAtomicWrite=32768]="FileAtomicWrite",G[G.FileAtomicDelete=65536]="FileAtomicDelete",G[G.FileClone=131072]="FileClone"})($||(e.FileSystemProviderCapabilities=$={}));function c(G){return!!(G.capabilities&2)}function w(G){return!!(G.capabilities&8)}function P(G){return!!(G.capabilities&131072)}function a(G){return!!(G.capabilities&4)}function t(G){return!!(G.capabilities&16)}function r(G){return c(G)?!!(G.capabilities&16384):!1}function s(G){return c(G)?!!(G.capabilities&32768):!1}function i(G){return!!(G.capabilities&65536)}function o(G){return!!(G.capabilities&2048)}var u;(function(G){G.FileExists="EntryExists",G.FileNotFound="EntryNotFound",G.FileNotADirectory="EntryNotADirectory",G.FileIsADirectory="EntryIsADirectory",G.FileExceedsStorageQuota="EntryExceedsStorageQuota",G.FileTooLarge="EntryTooLarge",G.FileWriteLocked="EntryWriteLocked",G.NoPermissions="NoPermissions",G.Unavailable="Unavailable",G.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class g extends Error{static create(le,Y){const A=new g(le.toString(),Y);return I(A,Y),A}constructor(le,Y){super(le),this.code=Y}}e.$bl=g;function S(G,le){return g.create(G,le)}function D(G){return G||S((0,k.localize)(0,null),u.Unknown)}function I(G,le){return G.name=le?`${le} (FileSystemError)`:"FileSystemError",G}function O(G){if(!G)return u.Unknown;if(G instanceof g)return G.code;const le=/^(.+) \(FileSystemError\)$/.exec(G.name);if(!le)return u.Unknown;switch(le[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}function M(G){if(G instanceof ee)return G.fileOperationResult;switch(O(G)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}var W;(function(G){G[G.CREATE=0]="CREATE",G[G.DELETE=1]="DELETE",G[G.MOVE=2]="MOVE",G[G.COPY=3]="COPY",G[G.WRITE=4]="WRITE"})(W||(e.FileOperation=W={}));class F{constructor(le,Y,A){this.resource=le,this.operation=Y,this.target=A}isOperation(le){return this.operation===le}}e.$hl=F;var T;(function(G){G[G.UPDATED=0]="UPDATED",G[G.ADDED=1]="ADDED",G[G.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class q{static{this.a=null}constructor(le,Y){this.c=Y,this.b=void 0,this.d=new b.$V(()=>{const A=n.$Bi.forUris(()=>this.c);return A.fill(this.rawAdded.map(N=>[N,!0])),A}),this.f=new b.$V(()=>{const A=n.$Bi.forUris(()=>this.c);return A.fill(this.rawUpdated.map(N=>[N,!0])),A}),this.g=new b.$V(()=>{const A=n.$Bi.forUris(()=>this.c);return A.fill(this.rawDeleted.map(N=>[N,!0])),A}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const A of le){switch(A.type){case 1:this.rawAdded.push(A.resource);break;case 0:this.rawUpdated.push(A.resource);break;case 2:this.rawDeleted.push(A.resource);break}this.b!==q.a&&(typeof A.cId=="number"?this.b===void 0?this.b=A.cId:this.b!==A.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(le,...Y){return this.h(le,{includeChildren:!1},...Y)}affects(le,...Y){return this.h(le,{includeChildren:!0},...Y)}h(le,Y,...A){if(!le)return!1;const N=A.length>0;return!!((!N||A.includes(1))&&(this.d.value.get(le)||Y.includeChildren&&this.d.value.findSuperstr(le))||(!N||A.includes(0))&&(this.f.value.get(le)||Y.includeChildren&&this.f.value.findSuperstr(le))||(!N||A.includes(2))&&(this.g.value.findSubstr(le)||Y.includeChildren&&this.g.value.findSuperstr(le)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(le){return this.b===le}hasCorrelation(){return typeof this.b=="number"}}e.$il=q;function ue(G,le,Y){return!G||!le||G===le||le.length>G.length?!1:(le.charAt(le.length-1)!==C.sep&&(le+=C.sep),Y?(0,E.$yf)(G,le):G.indexOf(le)===0)}class ee extends Error{constructor(le,Y,A){super(le),this.fileOperationResult=Y,this.options=A}}e.$kl=ee;class ce extends ee{constructor(le,Y,A,N){super(le,Y,N),this.fileOperationResult=Y,this.size=A}}e.$ll=ce;class K extends ee{constructor(le,Y,A){super(le,2,A),this.stat=Y}}e.$ml=K;var Q;(function(G){G[G.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",G[G.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",G[G.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",G[G.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",G[G.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",G[G.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",G[G.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",G[G.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",G[G.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",G[G.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",G[G.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Q||(e.FileOperationResult=Q={})),e.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$pl="files.associations",e.$ql="files.exclude",e.$rl="files.readonlyInclude",e.$sl="files.readonlyExclude",e.$tl="files.readonlyFromPermissions";var B;(function(G){G[G.FILE=0]="FILE",G[G.FOLDER=1]="FOLDER",G[G.ROOT_FOLDER=2]="ROOT_FOLDER"})(B||(e.FileKind=B={})),e.$ul="";function L(G){if(!(typeof G.size!="number"||typeof G.mtime!="number"))return G.mtime.toString(29)+G.size.toString(31)}async function z(G,le){if(!le.hasProvider(j.URI.from({scheme:G.scheme})))return new Promise(Y=>{const A=le.onDidChangeFileSystemProviderRegistrations(N=>{N.scheme===G.scheme&&N.added&&(A.dispose(),Y())})})}class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(le){return(0,R.$_f)(le)||(le=0),le<U.KB?(0,k.localize)(1,null,le.toFixed(0)):le<U.MB?(0,k.localize)(2,null,(le/U.KB).toFixed(2)):le<U.GB?(0,k.localize)(3,null,(le/U.MB).toFixed(2)):le<U.TB?(0,k.localize)(4,null,(le/U.GB).toFixed(2)):(0,k.localize)(5,null,(le/U.TB).toFixed(2))}}e.$xl=U;function ae(G){const le=typeof G=="string"||G?.scheme===d.Schemas.vscodeRemote;return typeof G!="string"&&G?.scheme===d.Schemas.file?1024*U.MB:le?10*U.MB:l.$o?50*U.MB:1024*U.MB}}),define(re[122],oe([0,1,17,15,179,16]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=j;async function j(d,b,v,m,f,y){let p;try{await k(d,b,v,m,f,y)}catch($){p=$}finally{p&&f.errorTransformer&&(p=f.errorTransformer(p)),typeof p<"u"&&v.error(p),v.end()}}async function k(d,b,v,m,f,y){h(y);const p=await d.open(b,{create:!1});try{h(y);let $=0,c=0,w=f&&typeof f.length=="number"?f.length:void 0,P=n.$Fe.alloc(Math.min(f.bufferSize,typeof w=="number"?w:f.bufferSize)),a=f&&typeof f.position=="number"?f.position:0,t=0;do c=await d.read(p,a,P.buffer,t,P.byteLength-t),a+=c,t+=c,$+=c,typeof w=="number"&&(w-=c),t===P.byteLength&&(await v.write(m(P)),P=n.$Fe.alloc(Math.min(f.bufferSize,typeof w=="number"?w:f.bufferSize)),t=0);while(c>0&&(typeof w!="number"||w>0)&&h(y)&&l($,f));if(t>0){let r=t;typeof w=="number"&&(r=Math.min(t,w)),v.write(m(P.slice(0,r)))}}catch($){throw(0,R.$dl)($)}finally{await d.close(p)}}function h(d){if(d.isCancellationRequested)throw(0,C.$6)();return!0}function l(d,b){if(typeof b?.limits?.size=="number"&&d>b.limits.size)throw(0,R.$cl)((0,E.localize)(0,null),R.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(re[60],oe([0,1,108,2,9,4,7,16]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=e.$Lq=e.$Kq=void 0,e.$Iq=h,e.$Jq=l,e.$Nq=m,e.$Oq=f,e.$Pq=y,e.$Qq=p,e.$Rq=c,e.$Sq=w;function h(P){return typeof P.correlationId=="number"}function l(P){return P.recursive===!0}class d extends C.$Vc{static{this.a=5}constructor(a,t,r,s){super(),this.h=a,this.j=t,this.m=r,this.n=s,this.c=this.B(new C.$Wc),this.f=void 0,this.g=0}s(){const a=new C.$Uc;this.c.value=a,this.b=this.r(a),this.b.setVerboseLogging(this.m),a.add(this.b.onDidChangeFile(t=>this.h(t))),a.add(this.b.onDidLogMessage(t=>this.j(t))),a.add(this.b.onDidError(t=>this.t(t)))}t(a){this.n.restartOnError?this.g<d.a&&this.f?(this.w(`restarting watcher after error: ${a}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${a}`):this.w(a)}u(a){this.g++,this.s(),this.watch(a)}async watch(a){this.f=a,await this.b?.watch(a)}async setVerboseLogging(a){this.m=a,await this.b?.setVerboseLogging(a)}w(a){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${a}`})}y(a){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${a}`})}dispose(){return this.b=void 0,super.dispose()}}e.$Kq=d;class b extends d{constructor(a,t,r){super(a,t,r,{type:"node.js",restartOnError:!1})}}e.$Lq=b;class v extends d{constructor(a,t,r){super(a,t,r,{type:"universal",restartOnError:!0})}}e.$Mq=v;function m(P){return P.map(a=>({type:a.type,resource:j.URI.revive(a.resource),cId:a.cId}))}function f(P){const a=new $;for(const t of P)a.processEvent(t);return a.coalesce()}function y(P,a){return typeof a=="string"&&!a.startsWith(n.$lk)&&!(0,E.$jc)(a)?{base:P,pattern:a}:a}function p(P,a){const t=[];for(const r of a)t.push((0,n.$pk)(y(P,r)));return t}class ${constructor(){this.a=new Set,this.b=new Map}c(a){return R.$k?a.resource.fsPath:a.resource.fsPath.toLowerCase()}processEvent(a){const t=this.b.get(this.c(a));let r=!1;if(t){const s=t.type,i=a.type;t.resource.fsPath!==a.resource.fsPath&&(a.type===2||a.type===1)?r=!0:s===1&&i===2?(this.b.delete(this.c(a)),this.a.delete(t)):s===2&&i===1?t.type=0:s===1&&i===0||(t.type=i)}else r=!0;r&&(this.a.add(a),this.b.set(this.c(a),a))}coalesce(){const a=[],t=[];return Array.from(this.a).filter(r=>r.type!==2?(a.push(r),!1):!0).sort((r,s)=>r.resource.fsPath.length-s.resource.fsPath.length).filter(r=>t.some(s=>(0,k.$jl)(r.resource.fsPath,s,!R.$k))?!1:(t.push(r.resource.fsPath),!0)).concat(a)}}function c(P,a){if(typeof a=="number")switch(P.type){case 1:return(a&4)===0;case 2:return(a&8)===0;case 0:return(a&2)===0}return!1}function w(P){if(typeof P=="number"){const a=[];return P&4&&a.push("Added"),P&8&&a.push("Deleted"),P&2&&a.push("Updated"),a.length===0?"<all>":`[${a.join(", ")}]`}return"<none>"}}),define(re[216],oe([0,1,17,47,15,3,2,63,33,16,60]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=e.$rQ=void 0,e.$rQ="localFilesystem";class b extends j.$Vc{constructor(m,f){super(),this.a=m,this.b=f,this.onDidChangeCapabilities=R.Event.None,this.f=this.B(new R.$ee),this.onDidChangeFile=this.f.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.h=(0,h.$Rg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(m){return this.a.call("stat",[m])}readdir(m){return this.a.call("readdir",[m])}async readFile(m,f){const{buffer:y}=await this.a.call("readFile",[m,f]);return y}readFileStream(m,f,y){const p=(0,k.$te)(c=>n.$Fe.concat(c.map(w=>n.$Fe.wrap(w))).buffer),$=new j.$Uc;return $.add(this.a.listen("readFileStream",[m,f])(c=>{if(c instanceof n.$Fe)p.write(c.buffer);else{if(c==="end")p.end();else{let w;if(c instanceof Error)w=c;else{const P=c;w=(0,l.$cl)(P.message??(0,C.$gj)(P),P.code??l.FileSystemProviderErrorCode.Unknown)}p.error(w),p.end()}$.dispose()}})),$.add(y.onCancellationRequested(()=>{p.error((0,E.$6)()),p.end(),$.dispose()})),p}writeFile(m,f,y){return this.a.call("writeFile",[m,n.$Fe.wrap(f),y])}open(m,f){return this.a.call("open",[m,f])}close(m){return this.a.call("close",[m])}async read(m,f,y,p,$){const[c,w]=await this.a.call("read",[m,f,$]);return y.set(c.buffer.slice(0,w),p),w}write(m,f,y,p,$){return this.a.call("write",[m,f,n.$Fe.wrap(y),p,$])}mkdir(m){return this.a.call("mkdir",[m])}delete(m,f){return this.a.call("delete",[m,f])}rename(m,f,y){return this.a.call("rename",[m,f,y])}copy(m,f,y){return this.a.call("copy",[m,f,y])}cloneFile(m,f){return this.a.call("cloneFile",[m,f])}j(){this.B(this.a.listen("fileChange",[this.h])(m=>{if(Array.isArray(m)){const f=m;this.f.fire((0,d.$Nq)(f))}else{const f=m;this.g.fire(f)}}))}watch(m,f){const y=(0,h.$Rg)();return this.a.call("watch",[this.h,y,m,f]),(0,j.$Tc)(()=>this.a.call("unwatch",[this.h,y]))}}e.$sQ=b}),define(re[217],oe([0,1,43,2,60,3,7,8]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2q=void 0;class h extends C.$Vc{constructor(){super(),this.a=this.B(new R.$ee),this.onDidChangeFile=this.a.event,this.b=this.B(new R.$ee),this.onDidLogMessage=this.b.event,this.c=this.B(new R.$ee),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new C.$5c),this.m=new Set,this.n=5007,this.r=new k.$Sh,this.P=!1,this.B(this.f(d=>this.s(d)))}s(d){this.t(d)&&this.w(d)}t(d){return(0,E.$Iq)(d)}async watch(d){this.r.isSettled||this.r.complete(),this.r=new k.$Sh;try{this.h.clear(),this.g.clear();for(const b of d)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(d=>!this.j.has(d.correlationId))])}isSuspended(d){return typeof d.correlationId!="number"?!1:this.m.has(d.correlationId)?"polling":this.j.has(d.correlationId)}async w(d){if(this.j.has(d.correlationId))return;const b=new C.$Uc;this.j.set(d.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(d,b),this.u())}y(d){this.j.deleteAndDispose(d.correlationId),this.m.delete(d.correlationId),this.u()}z(d,b){this.C(d,b)?(this.N(`reusing an existing recursive watcher to monitor ${d.path}`),this.m.delete(d.correlationId)):(this.D(d,b),this.m.add(d.correlationId))}C(d,b){const v=this.M?.subscribe(d.path,(m,f)=>{b.isDisposed||(m?this.z(d,b):f?.type===1&&this.F(d))});return v?(b.add(v),!0):!1}D(d,b){let v=!1;const m=(f,y)=>{if(b.isDisposed)return;const p=this.G(f),$=this.G(y),c=v;v=p,!p&&($||c)&&this.F(d)};this.N(`starting fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.watchFile)(d.path,{persistent:!1,interval:this.n},m)}catch(f){this.O(`fs.watchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}b.add((0,C.$Tc)(()=>{this.N(`stopping fs.watchFile() on ${d.path} (correlationId: ${d.correlationId})`);try{(0,n.unwatchFile)(d.path,m)}catch(f){this.O(`fs.unwatchFile() failed with error ${f} on path ${d.path} (correlationId: ${d.correlationId})`)}}))}F(d){this.N(`detected ${d.path} exists again, resuming watcher (correlationId: ${d.correlationId})`);const b={resource:j.URI.file(d.path),type:1,cId:d.correlationId};this.a.fire([b]),this.H(b,d),this.y(d)}G(d){return d.ctimeMs===0&&d.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(d,b){if(this.P){const v=` >> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`;this.I(v,b)}}I(d,b){this.P&&this.N(`${d}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(d){return`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"}, filter: ${(0,E.$Sq)(d.filter)}, correlationId: ${typeof d.correlationId=="number"?d.correlationId:"<none>"})`}async setVerboseLogging(d){this.P=d}}e.$2q=h}),define(re[218],oe([0,1,43,8,23,31,2,72,9,4,19,7,109,21,60]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0,e.$8q=p;class y extends j.$Vc{static{this.a=100}static{this.b=75}get isReusingRecursiveWatcher(){return this.n}get failed(){return this.r}constructor(c,w,P,a,t,r){super(),this.s=c,this.t=w,this.u=P,this.w=a,this.y=t,this.z=r,this.c=this.B(new C.$Kh({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},s=>this.u(s))),this.f=this.B(new C.$Jh(s=>this.M(s),y.b)),this.g=(0,f.$Qq)(this.s.path,this.s.excludes),this.h=this.s.includes?(0,f.$Qq)(this.s.path,this.s.includes):void 0,this.j=(0,f.$Iq)(this.s)?this.s.filter:void 0,this.m=new E.$pe,this.ready=this.C(),this.n=!1,this.r=!1}async C(){try{const c=await this.F(this.s);if(this.m.token.isCancellationRequested)return;const w=await m.Promises.stat(c);if(this.m.token.isCancellationRequested)return;this.B(await this.G(c,w.isDirectory()))}catch(c){c.code!=="ENOENT"?this.O(c):this.Q(`ignoring a path for watching who's stat info failed to resolve: ${this.s.path} (error: ${c})`),this.D()}}D(){this.r=!0,this.w?.()}async F(c){let w=c.path;try{w=await m.Promises.realpath(c.path),c.path===w&&(w=await(0,v.$4q)(c.path,this.m.token)??c.path),c.path!==w&&this.Q(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${w})`)}catch{}return w}async G(c,w){const P=new j.$Uc;return this.H(c,w,P)?(this.Q(`reusing an existing recursive watcher for ${this.s.path}`),this.n=!0):(this.n=!1,await this.I(c,w,P)),P}H(c,w,P){if(w)return!1;const a=b.URI.file(this.s.path),t=this.t?.subscribe(this.s.path,async(r,s)=>{if(!P.isDisposed)if(r){const i=await this.G(c,w);P.isDisposed?i.dispose():P.add(i)}else s&&(typeof s.cId=="number"||typeof this.s.correlationId=="number")&&this.L({resource:a,type:s.type,cId:this.s.correlationId},!0)});return t?(P.add(t),!0):!1}async I(c,w,P){if(l.$j&&(0,R.$ug)(c,"/Volumes/",!0)){this.O(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`);return}const a=new E.$pe(this.m.token);P.add((0,j.$Tc)(()=>a.dispose(!0)));const t=new j.$Uc;P.add(t);try{const r=b.URI.file(this.s.path),s=(0,h.$oc)(c),i=(0,n.watch)(c);t.add((0,j.$Tc)(()=>{i.removeAllListeners(),i.close()})),this.Q(`Started watching: '${c}'`);const o=new Set;if(w)try{for(const g of await m.Promises.readdir(c))o.add(g)}catch(g){this.O(g)}if(a.token.isCancellationRequested)return;const u=new Map;t.add((0,j.$Tc)(()=>{for(const[,g]of u)g.dispose();u.clear()})),i.on("error",(g,S)=>{a.token.isCancellationRequested||(this.O(`Failed to watch ${c} for changes using fs.watch() (${g}, ${S})`),this.D())}),i.on("change",(g,S)=>{if(a.token.isCancellationRequested)return;this.z&&this.R(`[raw] ["${g}"] ${S}`);let D="";if(S&&(D=S.toString(),l.$j&&(D=(0,k.$am)(D))),!(!D||g!=="change"&&g!=="rename"))if(w)if(g==="rename"){u.get(D)?.dispose();const I=setTimeout(async()=>{if(u.delete(D),D===s&&!await m.Promises.exists(c)){this.J(r);return}if(a.token.isCancellationRequested)return;const O=await this.N((0,h.$kc)(c,D));if(a.token.isCancellationRequested)return;let M;O?o.has(D)?M=0:(M=1,o.add(D)):(o.delete(D),M=2),this.L({resource:(0,d.$9g)(r,D),type:M,cId:this.s.correlationId})},y.a);u.set(D,(0,j.$Tc)(()=>clearTimeout(I)))}else{let I;o.has(D)?I=0:(I=1,o.add(D)),this.L({resource:(0,d.$9g)(r,D),type:I,cId:this.s.correlationId})}else if(g==="rename"||D!==s){const I=setTimeout(async()=>{const O=await m.Promises.exists(c);a.token.isCancellationRequested||(O?(this.L({resource:r,type:0,cId:this.s.correlationId},!0),t.add(await this.G(c,!1))):this.J(r))},y.a);t.clear(),t.add((0,j.$Tc)(()=>clearTimeout(I)))}else this.L({resource:r,type:0,cId:this.s.correlationId},!0)})}catch(r){a.token.isCancellationRequested||this.O(`Failed to watch ${c} for changes using fs.watch() (${r.toString()})`),this.D()}}J(c){this.P("Watcher shutdown because watched path got deleted"),this.L({resource:c,type:2,cId:this.s.correlationId},!0),this.f.flush(),this.D()}L(c,w=!1){this.m.token.isCancellationRequested||(this.z&&this.R(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`),!w&&this.g.some(P=>P(c.resource.fsPath))?this.z&&this.R(` >> ignored (excluded) ${c.resource.fsPath}`):!w&&this.h&&this.h.length>0&&!this.h.some(P=>P(c.resource.fsPath))?this.z&&this.R(` >> ignored (not included) ${c.resource.fsPath}`):this.f.work(c))}M(c){const w=(0,f.$Oq)(c),P=[];for(const t of w){if((0,f.$Rq)(t,this.j)){this.z&&this.R(` >> ignored (filtered) ${t.resource.fsPath}`);continue}P.push(t)}if(P.length===0)return;if(this.z)for(const t of P)this.R(` >> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.resource.fsPath}`);this.c.work(P)?this.c.pending>0&&this.Q(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${P[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.P(`started ignoring events due to too many file change events at once (incoming: ${P.length}, most recent change: ${P[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}async N(c){if(l.$k)return m.Promises.exists(c);try{const w=(0,h.$oc)(c);return(await m.Promises.readdir((0,h.$nc)(c))).some(a=>a===w)}catch(w){return this.Q(w),!1}}setVerboseLogging(c){this.z=c}O(c){this.m.token.isCancellationRequested||this.y?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}P(c){this.m.token.isCancellationRequested||this.y?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}Q(c){!this.m.token.isCancellationRequested&&this.z&&this.y?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}R(c){!this.m.token.isCancellationRequested&&this.z&&this.Q(`${c}${typeof this.s.correlationId=="number"?` <${this.s.correlationId}> `:""}`)}dispose(){this.m.dispose(!0),super.dispose()}}e.$7q=y;async function p($,c,w,P,a=512){const t=await m.Promises.open($,"r"),r=Buffer.allocUnsafe(a),s=new E.$pe(P);let i,o=!1;const u={path:$,excludes:[],recursive:!1},g=new y(u,void 0,S=>{(async()=>{for(const{type:D}of S)if(D===0){if(o)return;o=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(t,r,0,a,null);if(!I||s.token.isCancellationRequested)break;c(r.slice(0,I))}}catch(I){i=new Error(I),s.dispose(!0)}finally{o=!1}}})()});return await g.ready,w(),new Promise((S,D)=>{s.token.onCancellationRequested(async()=>{g.dispose();try{await m.Promises.close(t)}catch(I){i=new Error(I)}i?D(i):S()})})}}),define(re[219],oe([0,1,3,108,217,4,218,31]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9q=void 0;class h extends E.$2q{constructor(d){super(),this.M=d,this.onDidError=n.Event.None,this.watchers=new Set}async L(d){d=this.X(d);const b=[],v=new Set(Array.from(this.watchers));for(const m of d){const f=this.S(m);f&&(0,C.$tk)(f.request.excludes,m.excludes)&&(0,C.$tk)(f.request.includes,m.includes)?v.delete(f):b.push(m)}b.length&&this.N(`Request to start watching: ${b.map(m=>this.J(m)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map(m=>this.J(m.request)).join(",")}`);for(const m of v)this.W(m);for(const m of b)this.U(m)}S(d){for(const b of this.watchers)if(typeof d.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===d.correlationId)return b}else if((0,k.$tg)(b.request.path,d.path,!R.$k))return b}U(d){const b=new j.$7q(d,this.M,m=>this.a.fire(m),()=>this.c.fire(d),m=>this.b.fire(m),this.P),v={request:d,instance:b};this.watchers.add(v)}async stop(){await super.stop();for(const d of this.watchers)this.W(d)}W(d){this.N("stopping file watcher",d),this.watchers.delete(d),d.instance.dispose()}X(d){const b=new Map;for(const v of d){const m=R.$k?v.path:v.path.toLowerCase();let f=b.get(v.correlationId);f||(f=new Map,b.set(v.correlationId,f)),f.has(m)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),f.set(m,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(d){super.setVerboseLogging(d);for(const b of this.watchers)b.instance.setVerboseLogging(d)}N(d,b){this.P&&this.b.fire({type:"trace",message:this.$(d,b)})}O(d){this.b.fire({type:"warn",message:this.$(d)})}$(d,b){return b?`[File Watcher (node.js)] ${d} (${this.J(b.request)})`:`[File Watcher (node.js)] ${d}`}}e.$9q=h}),define(re[220],oe([0,1,60,219]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0q=void 0;class E extends n.$Lq{constructor(j,k,h){super(j,k,h),this.s()}r(j){return j.add(new C.$9q(void 0))}}e.$0q=E}),define(re[221],oe([0,1,13,44,162,60]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=void 0;class j extends R.$Mq{constructor(h,l,d){super(h,l,d),this.s()}r(h){const l=h.add(new E.$Zq(n.$Pg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:d,signal:b})=>this.t(`terminated by itself with code ${d}, signal: ${b} (ETERM)`))),C.ProxyChannel.toService((0,C.$ci)(l.getChannel("watcher")))}}e.$1q=j}),define(re[93],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class n{constructor(...E){this.a=new Map;for(const[R,j]of E)this.set(R,j)}set(E,R){const j=this.a.get(E);return this.a.set(E,R),j}has(E){return this.a.has(E)}get(E){return this.a.get(E)}}e.$ti=n}),define(re[222],oe([0,1,8,15,2,78,211,6,93,104]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;const d=!1;class b extends Error{constructor(p){super("cyclic dependency between services"),this.message=p.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${p.toString()}`}}class v{constructor(p=new h.$ti,$=!1,c,w=d){this.i=p,this.j=$,this.k=c,this.l=w,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(k.$ui,this),this._globalGraph=w?c?._globalGraph??new j.$ar(P=>P):void 0}dispose(){if(!this.f){this.f=!0,(0,E.$Qc)(this.h),this.h.clear();for(const p of this.g)(0,E.$Pc)(p)&&p.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(p){this.m();const $=new class extends v{dispose(){this.h.delete($),super.dispose()}}(p,this.j,this,this.l);return this.h.add($),$}invokeFunction(p,...$){this.m();const c=f.traceInvocation(this.l,p);let w=!1;try{return p({get:a=>{if(w)throw(0,C.$8)("service accessor is only valid during the invocation of its target method");const t=this.s(a,c);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...$)}finally{w=!0,c.stop()}}createInstance(p,...$){this.m();let c,w;return p instanceof R.$si?(c=f.traceCreation(this.l,p.ctor),w=this.o(p.ctor,p.staticArguments.concat($),c)):(c=f.traceCreation(this.l,p),w=this.o(p,$,c)),c.stop(),w}o(p,$=[],c){const w=k._util.getServiceDependencies(p).sort((t,r)=>t.index-r.index),P=[];for(const t of w){const r=this.s(t.id,c);r||this.y(`[createInstance] ${p.name} depends on UNKNOWN service ${t.id}.`,!1),P.push(r)}const a=w.length>0?w[0].index:$.length;if($.length!==a){console.trace(`[createInstance] First service dependency of ${p.name} at position ${a+1} conflicts with ${$.length} static arguments`);const t=a-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,a)}return Reflect.construct(p,$.concat(P))}q(p,$){if(this.i.get(p)instanceof R.$si)this.i.set(p,$);else if(this.k)this.k.q(p,$);else throw new Error("illegalState - setting UNKNOWN service instance")}r(p){const $=this.i.get(p);return!$&&this.k?this.k.r(p):$}s(p,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(p));const c=this.r(p);return c instanceof R.$si?this.u(p,c,$.branch(p,!0)):($.branch(p,!1),c)}u(p,$,c){if(this.t.has(p))throw new Error(`illegal state - RECURSIVELY instantiating service '${p}'`);this.t.add(p);try{return this.v(p,$,c)}finally{this.t.delete(p)}}v(p,$,c){const w=new j.$ar(t=>t.id.toString());let P=0;const a=[{id:p,desc:$,_trace:c}];for(;a.length;){const t=a.pop();if(w.lookupOrInsertNode(t),P++>1e3)throw new b(w);for(const r of k._util.getServiceDependencies(t.desc.ctor)){const s=this.r(r.id);if(s||this.y(`[createInstance] ${p} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),s instanceof R.$si){const i={id:r.id,desc:s,_trace:t._trace.branch(r.id,!0)};w.insertEdge(t,i),a.push(i)}}}for(;;){const t=w.roots();if(t.length===0){if(!w.isEmpty())throw new b(w);break}for(const{data:r}of t){if(this.r(r.id)instanceof R.$si){const i=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,i)}w.removeNode(r)}}return this.r(p)}w(p,$,c=[],w,P){if(this.i.get(p)instanceof R.$si)return this.x(p,$,c,w,P,this.g);if(this.k)return this.k.w(p,$,c,w,P);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}x(p,$,c=[],w,P,a){if(w){const t=new v(void 0,this.j,this,this.l);t.c=String(p);const r=new Map,s=new n.$Oh(()=>{const i=t.o($,c,P);for(const[o,u]of r){const g=i[o];if(typeof g=="function")for(const S of u)S.disposable=g.apply(i,S.listener)}return r.clear(),a.add(i),i});return new Proxy(Object.create(null),{get(i,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let S=r.get(o);return S||(S=new l.$6c,r.set(o,S)),(I,O,M)=>{if(s.isInitialized)return s.value[o](I,O,M);{const W={listener:[I,O,M],disposable:void 0},F=S.push(W);return(0,E.$Tc)(()=>{F(),W.disposable?.dispose()})}}}if(o in i)return i[o];const u=s.value;let g=u[o];return typeof g!="function"||(g=g.bind(u),i[o]=g),g},set(i,o,u){return s.value[o]=u,!0},getPrototypeOf(i){return $.prototype}})}else{const t=this.o($,c,P);return a.add(t),t}}y(p,$){if($&&console.warn(p),this.j)throw new Error(p)}}e.$br=v;var m;(function(y){y[y.None=0]="None",y[y.Creation=1]="Creation",y[y.Invocation=2]="Invocation",y[y.Branch=3]="Branch"})(m||(m={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(p,$){return p?new f(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(p,$){return p?new f(1,$.name):f.c}static{this.f=0}constructor(p,$){this.type=p,this.name=$,this.g=Date.now(),this.h=[]}branch(p,$){const c=new f(3,p.toString());return this.h.push([p,$,c]),c}stop(){const p=Date.now()-this.g;f.f+=p;let $=!1;function c(P,a){const t=[],r=new Array(P+1).join("	");for(const[s,i,o]of a.h)if(i&&o){$=!0,t.push(`${r}CREATES -> ${s}`);const u=c(P+1,o);u&&t.push(u)}else t.push(`${r}uses -> ${s}`);return t.join(`
`)}const w=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${p.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(p>2||$)&&f.all.add(w.join(`
`))}}e.$cr=f}),define(re[223],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QJb=e.IssueSource=e.IssueType=void 0;var C;(function(R){R[R.Bug=0]="Bug",R[R.PerformanceIssue=1]="PerformanceIssue",R[R.FeatureRequest=2]="FeatureRequest"})(C||(e.IssueType=C={}));var E;(function(R){R.VSCode="vscode",R.Extension="extension",R.Marketplace="marketplace"})(E||(e.IssueSource=E={})),e.$QJb=(0,n.$vi)("issueService")}),define(re[5],oe([0,1,183,47,3,46,2,32,4,19,12,7,118,6]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$5j=e.LogLevel=e.$3j=e.$2j=void 0,e.$4j=y,e.log=$,e.$dk=g,e.$ek=S,e.$fk=D,e.$gk=I,e.$2j=(0,m.$vi)("logService"),e.$3j=(0,m.$vi)("loggerService");function f(){return new Date().toISOString()}function y(O){return(0,d.$_f)(O)}var p;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(p||(e.LogLevel=p={})),e.$5j=p.Info;function $(O,M,W){switch(M){case p.Trace:O.trace(W);break;case p.Debug:O.debug(W);break;case p.Info:O.info(W);break;case p.Warning:O.warn(W);break;case p.Error:O.error(W);break;case p.Off:break;default:throw new Error(`Invalid log level ${M}`)}}function c(O,M=!1){let W="";for(let F=0;F<O.length;F++){let T=O[F];if(T instanceof Error&&(T=(0,C.$gj)(T,M)),typeof T=="object")try{T=JSON.stringify(T)}catch{}W+=(F>0?" ":"")+T}return W}class w extends j.$Vc{constructor(){super(...arguments),this.b=e.$5j,this.c=this.B(new E.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(M){this.b!==M&&(this.b=M,this.c.fire(this.b))}getLevel(){return this.b}f(M){return this.b!==p.Off&&this.b<=M}}e.$7j=w;class P extends w{constructor(M){super(),this.h=M}f(M){return this.h||super.f(M)}trace(M,...W){this.f(p.Trace)&&this.g(p.Trace,c([M,...W],!0))}debug(M,...W){this.f(p.Debug)&&this.g(p.Debug,c([M,...W]))}info(M,...W){this.f(p.Info)&&this.g(p.Info,c([M,...W]))}warn(M,...W){this.f(p.Warning)&&this.g(p.Warning,c([M,...W]))}error(M,...W){if(this.f(p.Error))if(M instanceof Error){const F=Array.prototype.slice.call(arguments);F[0]=M.stack,this.g(p.Error,c(F))}else this.g(p.Error,c([M,...W]))}flush(){}}e.$8j=P;class a extends w{constructor(M=e.$5j){super(),this.setLevel(M),this.g=!h.$i}trace(M,...W){this.f(p.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}debug(M,...W){this.f(p.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}info(M,...W){this.f(p.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,M,...W):console.log(`[main ${f()}]`,M,...W))}warn(M,...W){this.f(p.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,M,...W):console.warn(`[main ${f()}]`,M,...W))}error(M,...W){this.f(p.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,M,...W):console.error(`[main ${f()}]`,M,...W))}flush(){}}e.$9j=a;class t extends w{constructor(M=e.$5j,W=!0){super(),this.g=W,this.setLevel(M)}trace(M,...W){this.f(p.Trace)&&(this.g?console.log("%cTRACE","color: #888",M,...W):console.log(M,...W))}debug(M,...W){this.f(p.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",M,...W):console.log(M,...W))}info(M,...W){this.f(p.Info)&&(this.g?console.log("%c INFO","color: #33f",M,...W):console.log(M,...W))}warn(M,...W){this.f(p.Warning)&&(this.g?console.log("%c WARN","color: #993",M,...W):console.log(M,...W))}error(M,...W){this.f(p.Error)&&(this.g?console.log("%c  ERR","color: #f33",M,...W):console.error(M,...W))}flush(){}}e.$0j=t;class r extends w{constructor(M,W=e.$5j){super(),this.g=M,this.setLevel(W)}trace(M,...W){this.f(p.Trace)&&this.g.log(p.Trace,[this.h(M),...W])}debug(M,...W){this.f(p.Debug)&&this.g.log(p.Debug,[this.h(M),...W])}info(M,...W){this.f(p.Info)&&this.g.log(p.Info,[this.h(M),...W])}warn(M,...W){this.f(p.Warning)&&this.g.log(p.Warning,[this.h(M),...W])}error(M,...W){this.f(p.Error)&&this.g.log(p.Error,[this.h(M),...W])}h(M){return typeof M=="string"?M:(0,C.$gj)(M,this.f(p.Trace))}flush(){}}e.$$j=r;class s extends w{constructor(M){super(),this.g=M,M.length&&this.setLevel(M[0].getLevel())}setLevel(M){for(const W of this.g)W.setLevel(M);super.setLevel(M)}trace(M,...W){for(const F of this.g)F.trace(M,...W)}debug(M,...W){for(const F of this.g)F.debug(M,...W)}info(M,...W){for(const F of this.g)F.info(M,...W)}warn(M,...W){for(const F of this.g)F.warn(M,...W)}error(M,...W){for(const F of this.g)F.error(M,...W)}flush(){for(const M of this.g)M.flush()}dispose(){for(const M of this.g)M.dispose();super.dispose()}}e.$_j=s;class i extends j.$Vc{constructor(M,W,F){if(super(),this.h=M,this.j=W,this.b=new k.$Bc,this.c=this.B(new E.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new E.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new E.$ee),this.onDidChangeVisibility=this.g.event,F)for(const T of F)this.b.set(T.resource,{logger:void 0,info:T})}m(M){return(0,d.$8f)(M)?[...this.b.values()].find(W=>W.info.id===M):this.b.get(M)}getLogger(M){return this.m(M)?.logger}createLogger(M,W){const F=this.n(M),T=(0,d.$8f)(M)?M:W?.id??(0,R.$jj)(F.toString()).toString(16);let q=this.b.get(F)?.logger;const ue=W?.logLevel==="always"?p.Trace:W?.logLevel;q||(q=this.s(F,ue??this.getLogLevel(F)??this.h,{...W,id:T}));const ee={logger:q,info:{resource:F,id:T,logLevel:ue,name:W?.name,hidden:W?.hidden,extensionId:W?.extensionId,when:W?.when}};return this.registerLogger(ee.info),this.b.set(F,ee),q}n(M){return(0,d.$8f)(M)?(0,l.$9g)(this.j,`${M}.log`):M}setLogLevel(M,W){if(b.URI.isUri(M)){const F=M,T=W,q=this.b.get(F);q&&T!==q.info.logLevel&&(q.info.logLevel=T===this.h?void 0:T,q.logger?.setLevel(T),this.b.set(q.info.resource,q),this.f.fire([F,T]))}else{this.h=M;for(const[F,T]of this.b.entries())this.b.get(F)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(M,W){const F=this.m(M);F&&W!==!F.info.hidden&&(F.info.hidden=!W,this.b.set(F.info.resource,F),this.g.fire([F.info.resource,W]))}getLogLevel(M){let W;return M&&(W=this.b.get(M)?.info.logLevel),W??this.h}registerLogger(M){const W=this.b.get(M.resource);W?W.info.hidden!==M.hidden&&this.setVisibility(M.resource,!M.hidden):(this.b.set(M.resource,{info:M,logger:void 0}),this.c.fire({added:[M],removed:[]}))}deregisterLogger(M){const W=this.b.get(M);W&&(W.logger&&W.logger.dispose(),this.b.delete(M),this.c.fire({added:[],removed:[W.info]}))}*getRegisteredLoggers(){for(const M of this.b.values())yield M.info}getRegisteredLogger(M){return this.b.get(M)?.info}dispose(){this.b.forEach(M=>M.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ak=i;class o{constructor(){this.onDidChangeLogLevel=new E.$ee().event}setLevel(M){}getLevel(){return p.Info}trace(M,...W){}debug(M,...W){}info(M,...W){}warn(M,...W){}error(M,...W){}critical(M,...W){}dispose(){}flush(){}}e.$bk=o;class u extends o{}e.$ck=u;function g(O){if(O.verbose)return p.Trace;if(typeof O.logLevel=="string"){const M=I(O.logLevel.toLowerCase());if(M!==void 0)return M}return e.$5j}function S(O){switch(O){case p.Trace:return"trace";case p.Debug:return"debug";case p.Info:return"info";case p.Warning:return"warn";case p.Error:return"error";case p.Off:return"off"}}function D(O){switch(O){case p.Trace:return{original:"Trace",value:n.localize(0,null)};case p.Debug:return{original:"Debug",value:n.localize(1,null)};case p.Info:return{original:"Info",value:n.localize(2,null)};case p.Warning:return{original:"Warning",value:n.localize(3,null)};case p.Error:return{original:"Error",value:n.localize(4,null)};case p.Off:return{original:"Off",value:n.localize(5,null)}}}function I(O){switch(O){case"trace":return p.Trace;case"debug":return p.Debug;case"info":return p.Info;case"warn":return p.Warning;case"error":return p.Error;case"critical":return p.Error;case"off":return p.Off}}e.$hk=new v.$Mj("logLevel",S(p.Info))});var ie=this&&this.__param||function(X,e){return function(n,C){e(n,C,X)}};define(re[224],oe([0,1,14,4,5]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8bc=void 0;const R=n.safeStorage;let j=class{constructor(h){this.a=h,n.app.commandLine.getSwitchValue("password-store")==="basic"&&R.setUsePlainTextEncryption?.(!0)}async encrypt(h){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(R.encryptString(h));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(h){let l;try{if(l=JSON.parse(h),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${h}`);const d=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const b=R.decryptString(d);return this.a.trace("[EncryptionMainService] Decrypted value."),b}catch(d){throw this.a.error(d),d}}isEncryptionAvailable(){return Promise.resolve(R.isEncryptionAvailable())}getKeyStorageProvider(){if(C.$i)return Promise.resolve("dpapi");if(C.$j)return Promise.resolve("keychain_access");if(R.getSelectedStorageBackend)try{const h=R.getSelectedStorageBackend();return Promise.resolve(h)}catch(h){this.a.error(h)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(C.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(C.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!R.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");R.setUsePlainTextEncryption(!0)}};e.$8bc=j,e.$8bc=j=Ee([ie(0,E.$2j)],j)}),define(re[225],oe([0,1,22,8,15,3,31,2,9,60,5]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tq=void 0;class b extends k.$Vc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new R.$ee),this.onDidChangeFile=this.c.event,this.g=this.B(new R.$ee),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new C.$th(0)),this.w=[],this.y=this.B(new C.$th(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const y={path:this.J(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,filter:f.filter,correlationId:f.correlationId},p=(0,n.$Ub)(this.j,y);return this.r(),(0,k.$Tc)(()=>{p(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,E.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,l.$Nq)(f)),f=>this.G(f),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,l.$Jq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,l.$Jq)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const y={path:this.J(m),excludes:f.excludes,includes:f.includes,recursive:!1,filter:f.filter,correlationId:f.correlationId},p=(0,n.$Ub)(this.w,y);return this.C(),(0,k.$Tc)(()=>{p(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,E.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,l.$Nq)(m)),m=>this.G(m),this.a.getLevel()===d.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===d.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.H(m)}H(m){this.a[m.type](m.message)}I(m){return(0,h.$ic)(m.fsPath)}J(m){const f=this.I(m);return(0,j.$xg)(f)}}e.$Tq=b}),define(re[226],oe([0,1,22,8,17,23,3,46,71,2,59,13,66,19,63,177,16,122,5,15]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;let a=class extends l.$Vc{static{P=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new j.$ee),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new j.$ee),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new j.$ee),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new j.$ee),this.onDidRunOperation=this.r.event,this.X=this.B(new j.$ee),this.Y=this.B(new j.$ee),this.onDidFilesChange=this.Y.event,this.Z=this.B(new j.$ee),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new C.$Eh)}registerProvider(r,s){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const i=new l.$Uc;return this.h.set(r,s),this.c.fire({added:!0,scheme:r,provider:s}),i.add(s.onDidChangeFile(o=>{const u=new p.$il(o,!this.S(s));this.X.fire(u),u.hasCorrelation()||this.Y.fire(u)})),typeof s.onDidWatchError=="function"&&i.add(s.onDidWatchError(o=>this.Z.fire(new Error(o)))),i.add(s.onDidChangeCapabilities(()=>this.g.fire({provider:s,scheme:r}))),(0,l.$Tc)(()=>{this.c.fire({added:!1,scheme:r,provider:s}),this.h.delete(r),(0,l.$Qc)(i)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const s=[];this.f.fire({scheme:r,join(i){s.push(i)}}),!this.h.has(r)&&await C.Promises.settled(s)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,s){const i=this.h.get(r.scheme);return!!(i&&i.capabilities&s)}listCapabilities(){return h.Iterable.map(this.h,([r,s])=>({scheme:r,capabilities:s.capabilities}))}async j(r){if(!(0,m.$ah)(r))throw new p.$kl((0,y.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const s=this.h.get(r.scheme);if(!s){const i=new w.$bb;throw i.message=(0,y.localize)(1,null,r.toString()),i}return s}async m(r){const s=await this.j(r);if((0,p.$8k)(s)||(0,p.$5k)(s)||(0,p.$9k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const s=await this.j(r);if((0,p.$8k)(s)||(0,p.$5k)(s))return s;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,s){try{return await this.s(r,s)}catch(i){throw(0,p.$fl)(i)===p.FileSystemProviderErrorCode.FileNotFound?new p.$kl((0,y.localize)(2,null,this.sb(r)),1):(0,p.$dl)(i)}}async s(r,s){const i=await this.j(r),o=this.S(i),u=s?.resolveTo,g=s?.resolveSingleChildDescendants,S=s?.resolveMetadata,D=await i.stat(r);let I;return this.t(i,r,D,void 0,!!S,(O,M)=>(I||(I=d.$Bi.forUris(()=>!o),I.set(r,!0),u&&I.fill(!0,u)),I.get(O.resource)||I.findSuperstr(O.resource.with({query:null,fragment:null}))?!0:O.isDirectory&&g?M===1:!1))}async t(r,s,i,o,u,g){const{providerExtUri:S}=this.R(r),D={resource:s,name:S.basename(s),isFile:(i.type&p.FileType.File)!==0,isDirectory:(i.type&p.FileType.Directory)!==0,isSymbolicLink:(i.type&p.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&p.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((i.permissions??0)&p.FilePermission.Locked),etag:(0,p.$vl)({mtime:i.mtime,size:i.size}),children:void 0};if(D.isDirectory&&g(D,o)){try{const I=await r.readdir(s),O=await C.Promises.settled(I.map(async([M,W])=>{try{const F=S.joinPath(s,M),T=u?await r.stat(F):{type:W};return await this.t(r,F,T,I.length,u,g)}catch(F){return this.b.trace(F),null}}));D.children=(0,n.$Hb)(O)}catch(I){this.b.trace(I),D.children=[]}return D}return D}async resolveAll(r){return C.Promises.settled(r.map(async s=>{try{return{stat:await this.s(s.resource,s.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(r){const s=await this.j(r),i=await s.stat(r);return this.t(s,r,i,void 0,!0,()=>!1)}async exists(r){const s=await this.j(r);try{return!!await s.stat(r)}catch{return!1}}async canCreateFile(r,s){try{await this.u(r,s)}catch(i){return i}return!0}async u(r,s){if(!s?.overwrite&&await this.exists(r))throw new p.$kl((0,y.localize)(3,null,this.sb(r)),3,s)}async createFile(r,s=E.$Fe.fromString(""),i){await this.u(r,i);const o=await this.writeFile(r,s);return this.r.fire(new p.$hl(r,0,o)),o}async writeFile(r,s,i){const o=this.qb(await this.n(r),r),{providerExtUri:u}=this.R(o);let g=i;if((0,p.$$k)(o)&&!g?.atomic){const S=o.enforceAtomicWriteFile?.(r);S&&(g={...i,atomic:S})}try{await this.w(o,r,g)||await this.U(o,u.dirname(r));let D;if((0,p.$5k)(o)&&!(s instanceof E.$Fe))if((0,f.$re)(s)){const I=await(0,f.$ye)(s,3);I.ended?D=E.$Fe.concat(I.buffer):D=I}else D=(0,f.$ve)(s,I=>E.$Fe.concat(I),3);else D=s;!(0,p.$8k)(o)||(0,p.$5k)(o)&&D instanceof E.$Fe||(0,p.$5k)(o)&&(0,p.$$k)(o)&&g?.atomic?await this.hb(o,r,g,D):await this.db(o,r,g,D instanceof E.$Fe?(0,E.$Qe)(D):D),this.r.fire(new p.$hl(r,4))}catch(S){throw new p.$kl((0,y.localize)(4,null,this.sb(r),(0,p.$dl)(S).toString()),(0,p.$gl)(S),g)}return this.resolve(r,{resolveMetadata:!0})}async w(r,s,i){const o=!!i?.unlock;if(o&&!(r.capabilities&8192))throw new Error((0,y.localize)(5,null,this.sb(s)));if(!!i?.atomic){if(!(r.capabilities&32768))throw new Error((0,y.localize)(6,null,this.sb(s)));if(!(r.capabilities&2))throw new Error((0,y.localize)(7,null,this.sb(s)));if(o)throw new Error((0,y.localize)(8,null,this.sb(s)))}let g;try{g=await r.stat(s)}catch{return}if(g.type&p.FileType.Directory)throw new p.$kl((0,y.localize)(9,null,this.sb(s)),0,i);if(this.rb(s,g),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==p.$ul&&typeof g.mtime=="number"&&typeof g.size=="number"&&i.mtime<g.mtime&&i.etag!==(0,p.$vl)({mtime:i.mtime,size:g.size}))throw new p.$kl((0,y.localize)(10,null),3,i);return g}async readFile(r,s,i){const o=await this.m(r);return s?.atomic?this.z(o,r,s,i):this.C(o,r,s,i)}async z(r,s,i,o){return new Promise((u,g)=>{this.cb.queueFor(s,async()=>{try{const S=await this.C(r,s,i,o);u(S)}catch(S){g(S)}},this.R(r).providerExtUri)})}async C(r,s,i,o){const u=await this.D(r,s,{...i,preferUnbuffered:!0},o);return{...u,value:await(0,E.$Re)(u.value)}}async readFileStream(r,s,i){const o=await this.m(r);return this.D(o,r,s,i)}async D(r,s,i,o){const u=new R.$pe(o);let g=i;(0,p.$0k)(r)&&r.enforceAtomicReadFile?.(s)&&(g={...i,atomic:!0});const S=this.J(s,g).then(I=>I,I=>{throw u.dispose(!0),I});let D;try{return typeof g?.etag=="string"&&g.etag!==p.$ul&&await S,g?.atomic&&(0,p.$0k)(r)||!((0,p.$8k)(r)||(0,p.$9k)(r))||(0,p.$5k)(r)&&g?.preferUnbuffered?D=this.I(r,s,g):(0,p.$9k)(r)?D=this.G(r,s,u.token,g):D=this.H(r,s,u.token,g),D.on("end",()=>u.dispose()),D.on("error",()=>u.dispose()),{...await S,value:D}}catch(I){throw D&&await(0,f.$we)(D),this.F(I,s,g)}}F(r,s,i){const o=(0,y.localize)(11,null,this.sb(s),(0,p.$dl)(r).toString());return r instanceof p.$ml?new p.$ml(o,r.stat,i):r instanceof p.$ll?new p.$ll(o,r.fileOperationResult,r.size,r.options):new p.$kl(o,(0,p.$gl)(r),i)}G(r,s,i,o=Object.create(null)){const u=r.readFileStream(s,o,i);return(0,f.$Ce)(u,{data:g=>g instanceof E.$Fe?g:E.$Fe.wrap(g),error:g=>this.F(g,s,o)},g=>E.$Fe.concat(g))}H(r,s,i,o=Object.create(null)){const u=(0,E.$Ve)();return(0,$.$Gq)(r,s,u,g=>g,{...o,bufferSize:this.a,errorTransformer:g=>this.F(g,s,o)},i),u}I(r,s,i){const o=(0,f.$te)(u=>E.$Fe.concat(u));return(async()=>{try{let u;i?.atomic&&(0,p.$0k)(r)?u=await r.readFile(s,{atomic:!0}):u=await r.readFile(s),typeof i?.position=="number"&&(u=u.slice(i.position)),typeof i?.length=="number"&&(u=u.slice(0,i.length)),this.L(s,u.byteLength,i),o.end(E.$Fe.wrap(u))}catch(u){o.error(u),o.end()}})(),o}async J(r,s){const i=await this.resolve(r,{resolveMetadata:!0});if(i.isDirectory)throw new p.$kl((0,y.localize)(12,null,this.sb(r)),0,s);if(typeof s?.etag=="string"&&s.etag!==p.$ul&&s.etag===i.etag)throw new p.$ml((0,y.localize)(13,null),i,s);return this.L(r,i.size,s),i}L(r,s,i){if(typeof i?.limits?.size=="number"&&s>i.limits.size)throw new p.$ll((0,y.localize)(14,null,this.sb(r)),7,s,i)}async canMove(r,s,i){return this.M(r,s,"move",i)}async canCopy(r,s,i){return this.M(r,s,"copy",i)}async M(r,s,i,o){if(r.toString()!==s.toString())try{const u=i==="move"?this.qb(await this.n(r),r):await this.m(r),g=this.qb(await this.n(s),s);await this.Q(u,r,g,s,i,o)}catch(u){return u}return!0}async move(r,s,i){const o=this.qb(await this.n(r),r),u=this.qb(await this.n(s),s),g=await this.N(o,r,u,s,"move",!!i),S=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$hl(r,g==="move"?2:3,S)),S}async copy(r,s,i){const o=await this.m(r),u=this.qb(await this.n(s),s),g=await this.N(o,r,u,s,"copy",!!i),S=await this.resolve(s,{resolveMetadata:!0});return this.r.fire(new p.$hl(r,g==="copy"?3:2,S)),S}async N(r,s,i,o,u,g){if(s.toString()===o.toString())return u;const{exists:S,isSameResourceWithDifferentPathCase:D}=await this.Q(r,s,i,o,u,g);if(S&&!D&&g&&await this.del(o,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(o)),u==="copy"){if(r===i&&(0,p.$6k)(r))await r.copy(s,o,{overwrite:g});else{const I=await this.resolve(s);I.isDirectory?await this.P(r,I,i,o):await this.O(r,s,i,o)}return u}else return r===i?(await r.rename(s,o,{overwrite:g}),u):(await this.N(r,s,i,o,"copy",g),await this.del(s,{recursive:!0}),"copy")}async O(r,s,i,o){if((0,p.$8k)(r)&&(0,p.$8k)(i))return this.jb(r,s,i,o);if((0,p.$8k)(r)&&(0,p.$5k)(i))return this.pb(r,s,i,o);if((0,p.$5k)(r)&&(0,p.$8k)(i))return this.nb(r,s,i,o);if((0,p.$5k)(r)&&(0,p.$5k)(i))return this.lb(r,s,i,o)}async P(r,s,i,o){await i.mkdir(o),Array.isArray(s.children)&&await C.Promises.settled(s.children.map(async u=>{const g=this.R(i).providerExtUri.joinPath(o,u.name);return u.isDirectory?this.P(r,await this.resolve(u.resource),i,g):this.O(r,u.resource,i,g)}))}async Q(r,s,i,o,u,g){let S=!1;if(r===i){const{providerExtUri:I,isPathCaseSensitive:O}=this.R(r);if(O||(S=I.isEqual(s,o)),S&&u==="copy")throw new Error((0,y.localize)(15,null,this.sb(s),this.sb(o)));if(!S&&I.isEqualOrParent(o,s))throw new Error((0,y.localize)(16,null,this.sb(s),this.sb(o)))}const D=await this.exists(o);if(D&&!S){if(!g)throw new p.$kl((0,y.localize)(17,null,this.sb(s),this.sb(o)),4);if(r===i){const{providerExtUri:I}=this.R(r);if(I.isEqualOrParent(s,o))throw new Error((0,y.localize)(18,null,this.sb(s),this.sb(o)))}}return{exists:D,isSameResourceWithDifferentPathCase:S}}R(r){const s=this.S(r);return{providerExtUri:s?m.$Yg:m.$1g,isPathCaseSensitive:s}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const s=this.qb(await this.j(r),r);await this.U(s,r);const i=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new p.$hl(r,0,i)),i}async U(r,s){const i=[],{providerExtUri:o}=this.R(r);for(;!o.isEqual(s,o.dirname(s));)try{if(!((await r.stat(s)).type&p.FileType.Directory))throw new Error((0,y.localize)(19,null,this.sb(s)));break}catch(u){if((0,p.$fl)(u)!==p.FileSystemProviderErrorCode.FileNotFound)throw u;i.push(o.basename(s)),s=o.dirname(s)}for(let u=i.length-1;u>=0;u--){s=o.joinPath(s,i[u]);try{await r.mkdir(s)}catch(g){if((0,p.$fl)(g)!==p.FileSystemProviderErrorCode.FileExists)throw g}}}async canDelete(r,s){try{await this.W(r,s)}catch(i){return i}return!0}async W(r,s){const i=this.qb(await this.j(r),r),o=!!s?.useTrash;if(o&&!(i.capabilities&4096))throw new Error((0,y.localize)(20,null,this.sb(r)));const u=s?.atomic;if(u&&!(i.capabilities&65536))throw new Error((0,y.localize)(21,null,this.sb(r)));if(o&&u)throw new Error((0,y.localize)(22,null,this.sb(r)));let g;try{g=await i.stat(r)}catch{}if(g)this.rb(r,g);else throw new p.$kl((0,y.localize)(23,null,this.sb(r)),1);if(!!!s?.recursive){const D=await this.resolve(r);if(D.isDirectory&&Array.isArray(D.children)&&D.children.length>0)throw new Error((0,y.localize)(24,null,this.sb(r)))}return i}async del(r,s){const i=await this.W(r,s);let o=s;if((0,p.$_k)(i)&&!o?.atomic){const D=i.enforceAtomicDelete?.(r);D&&(o={...s,atomic:D})}const u=!!o?.useTrash,g=!!o?.recursive,S=o?.atomic??!1;await i.delete(r,{recursive:g,useTrash:u,atomic:S}),this.r.fire(new p.$hl(r,1))}async cloneFile(r,s){const i=await this.j(r),o=this.qb(await this.n(s),s);if(!(i===o&&this.R(i).providerExtUri.isEqual(r,s)))return i===o&&(0,p.$7k)(i)?i.cloneFile(r,s):(await this.U(o,this.R(o).providerExtUri.dirname(s)),i===o&&(0,p.$6k)(i)?this.cb.queueFor(r,()=>i.copy(r,s,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(r,()=>this.O(i,r,o,s),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(r,s){return this.watch(r,{...s,correlationId:P.ab++})}watch(r,s={recursive:!1,excludes:[]}){const i=new l.$Uc;let o=!1,u=()=>{o=!0};i.add((0,l.$Tc)(()=>u())),(async()=>{try{const S=await this.bb(r,s);o?(0,l.$Qc)(S):u=()=>(0,l.$Qc)(S)}catch(S){this.b.error(S)}})();const g=s.correlationId;if(typeof g=="number"){const S=i.add(new j.$ee);return i.add(this.X.event(I=>{I.correlates(g)&&S.fire(I)})),{onDidChange:S.event,dispose:()=>i.dispose()}}return i}async bb(r,s){const i=await this.j(r),o=(0,k.$jj)([this.R(i).providerExtUri.getComparisonKey(r),s]);let u=this.$.get(o);return u||(u={count:0,disposable:i.watch(r,s)},this.$.set(o,u)),u.count+=1,(0,l.$Tc)(()=>{u&&(u.count--,u.count===0&&((0,l.$Qc)(u.disposable),this.$.delete(o)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,l.$Qc)(r.disposable);this.$.clear()}async db(r,s,i,o){return this.cb.queueFor(s,async()=>{const u=await r.open(s,{create:!0,unlock:i?.unlock??!1});try{(0,f.$re)(o)||(0,f.$se)(o)?await this.eb(r,u,o):await this.fb(r,u,o)}catch(g){throw(0,p.$dl)(g)}finally{await r.close(u)}},this.R(r).providerExtUri)}async eb(r,s,i){let o=0,u;if((0,f.$se)(i)){if(i.buffer.length>0){const g=E.$Fe.concat(i.buffer);await this.gb(r,s,g,g.byteLength,o,0),o+=g.byteLength}if(i.ended)return;u=i.stream}else u=i;return new Promise((g,S)=>{(0,f.$xe)(u,{onData:async D=>{u.pause();try{await this.gb(r,s,D,D.byteLength,o,0)}catch(I){return S(I)}o+=D.byteLength,setTimeout(()=>u.resume())},onError:D=>S(D),onEnd:()=>g()})})}async fb(r,s,i){let o=0,u;for(;(u=i.read())!==null;)await this.gb(r,s,u,u.byteLength,o,0),o+=u.byteLength}async gb(r,s,i,o,u,g){let S=0;for(;S<o;){const D=await r.write(s,u+S,i.buffer,g+S,o-S);S+=D}}async hb(r,s,i,o){return this.cb.queueFor(s,()=>this.ib(r,s,i,o),this.R(r).providerExtUri)}async ib(r,s,i,o){let u;o instanceof E.$Fe?u=o:(0,f.$re)(o)?u=await(0,E.$Re)(o):(0,f.$se)(o)?u=await(0,E.$Se)(o):u=(0,E.$Pe)(o),await r.writeFile(s,u.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(r,s,i,o){return this.cb.queueFor(o,()=>this.kb(r,s,i,o),this.R(i).providerExtUri)}async kb(r,s,i,o){let u,g;try{u=await r.open(s,{create:!1}),g=await i.open(o,{create:!0,unlock:!1});const S=E.$Fe.alloc(this.a);let D=0,I=0,O=0;do O=await r.read(u,D,S.buffer,I,S.byteLength-I),await this.gb(i,g,S,O,D,I),D+=O,I+=O,I===S.byteLength&&(I=0);while(O>0)}catch(S){throw(0,p.$dl)(S)}finally{await C.Promises.settled([typeof u=="number"?r.close(u):Promise.resolve(),typeof g=="number"?i.close(g):Promise.resolve()])}}async lb(r,s,i,o){return this.cb.queueFor(o,()=>this.mb(r,s,i,o),this.R(i).providerExtUri)}async mb(r,s,i,o){return i.writeFile(o,await r.readFile(s),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,s,i,o){return this.cb.queueFor(o,()=>this.ob(r,s,i,o),this.R(i).providerExtUri)}async ob(r,s,i,o){const u=await i.open(o,{create:!0,unlock:!1});try{const g=await r.readFile(s);await this.gb(i,u,E.$Fe.wrap(g),g.byteLength,0,0)}catch(g){throw(0,p.$dl)(g)}finally{await i.close(u)}}async pb(r,s,i,o){const u=await(0,E.$Re)(this.H(r,s,R.CancellationToken.None));await this.hb(i,o,void 0,u)}qb(r,s){if(r.capabilities&2048)throw new p.$kl((0,y.localize)(25,null,this.sb(s)),6);return r}rb(r,s){if((s.permissions??0)&p.FilePermission.Readonly)throw new p.$kl((0,y.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Hq=a,e.$Hq=a=P=Ee([ie(0,c.$2j)],a)}),define(re[94],oe([0,1,43,315,8,32,17,3,31,2,9,4,19,63,21,181,16,122,225,47,221,220]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$q=void 0,(()=>{try{(0,C.gracefulify)(n)}catch(r){console.error(`Error enabling graceful-fs: ${(0,w.$gj)(r)}`)}})();class t extends c.$Tq{static{this.L=!1}constructor(s,i){super(s,i),this.onDidChangeCapabilities=k.Event.None,this.P=new R.$Bc(o=>v.$Zg.getComparisonKey(o)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(s){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.I(s));return{type:this.O(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:p.FilePermission.Locked}}catch(i){throw this.hb(i)}}async N(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const i=await f.Promises.readdir(this.I(s),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async u=>{try{let g;u.isSymbolicLink()?g=(await this.stat((0,v.$9g)(s,u.name))).type:g=this.O(u),o.push([u.name,g])}catch(g){this.a.trace(g)}})),o}catch(i){throw this.hb(i)}}O(s,i){let o;return i?.dangling?o=p.FileType.Unknown:s.isFile()?o=p.FileType.File:s.isDirectory()?o=p.FileType.Directory:o=p.FileType.Unknown,i&&(o|=p.FileType.SymbolicLink),o}async Q(s){const i=this.I(s);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.P.get(s);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const u=new E.$uh;return this.P.set(s,u),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Tc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.P.get(s)===u&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.P.delete(s)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),u.open()})}async readFile(s,i){let o;try{i?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(s)})`),o=await this.Q(s));const u=this.I(s);return await f.Promises.readFile(u)}catch(u){throw this.hb(u)}finally{o?.dispose()}}R(s){t.L&&this.a.trace(s)}readFileStream(s,i,o){const u=(0,m.$te)(g=>j.$Fe.concat(g.map(S=>j.$Fe.wrap(S))).buffer);return(0,$.$Gq)(this,s,u,g=>g.buffer,{...i,bufferSize:256*1024},o),u}async writeFile(s,i,o){return o?.atomic!==!1&&o?.atomic?.postfix&&await this.S(s)?this.U(s,(0,v.$9g)((0,v.$8g)(s),`${(0,v.$6g)(s)}${o.atomic.postfix}`),i,o):this.W(s,i,o)}async S(s){try{const i=this.I(s),{symbolicLink:o}=await f.SymlinkSupport.stat(i);if(o)return!1}catch{}return!0}async U(s,i,o,u){const g=new l.$Uc;try{g.add(await this.Q(s)),g.add(await this.Q(i)),await this.W(i,o,u,!0);try{await this.rename(i,s,{overwrite:!0})}catch(S){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{g.dispose()}}async W(s,i,o,u){let g;try{const S=this.I(s);if(!o.create||!o.overwrite){if(await f.Promises.exists(S)){if(!o.overwrite)throw(0,p.$cl)((0,y.localize)(0,null),p.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,p.$cl)((0,y.localize)(1,null),p.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(s,{create:!0,unlock:o.unlock},u),await this.write(g,0,i,0,i.byteLength)}catch(S){throw await this.ib(s,S)}finally{typeof g=="number"&&await this.close(g)}}static{this.$=!0}static configureFlushOnWrite(s){t.$=s}async open(s,i,o){const u=this.I(s);let g;(0,p.$3k)(i)&&!o&&(g=await this.Q(s));let S;try{if((0,p.$3k)(i)&&i.unlock)try{const{stat:I}=await f.SymlinkSupport.stat(u);I.mode&128||await f.Promises.chmod(u,I.mode|128)}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}let D;if((0,p.$3k)(i)){if(b.$i)try{await f.Promises.truncate(u,0),D="r+"}catch(I){I.code!=="ENOENT"&&this.a.trace(I)}D||(D="w")}else D="r";S=await f.Promises.open(u,D)}catch(D){throw g?.dispose(),(0,p.$3k)(i)?await this.ib(s,D):this.hb(D)}if(this.X.set(S,0),(0,p.$3k)(i)&&this.Z.set(S,s),g){const D=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${u})`),this.Y.set(S,g),D&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${u})`),D.dispose())}return S}async close(s){const i=this.Y.get(s);try{if(this.X.delete(s),this.Z.delete(s)&&t.$)try{await f.Promises.fdatasync(s)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await f.Promises.close(s)}catch(o){throw this.hb(o)}finally{i&&(this.Y.get(s)===i&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.Y.delete(s)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),i.dispose())}}async read(s,i,o,u,g){const S=this.ab(s,i);let D=null;try{D=(await f.Promises.read(s,o,u,g,S)).bytesRead}catch(I){throw this.hb(I)}finally{this.bb(s,S,D)}return D}ab(s,i){return i===this.X.get(s)?null:i}bb(s,i,o){const u=this.X.get(s);typeof u=="number"&&(typeof i=="number"||(typeof o=="number"?this.X.set(s,u+o):this.X.delete(s)))}async write(s,i,o,u,g){return(0,E.$Ph)(()=>this.cb(s,i,o,u,g),100,3)}async cb(s,i,o,u,g){const S=this.ab(s,i);let D=null;try{D=(await f.Promises.write(s,o,u,g,S)).bytesWritten}catch(I){throw await this.ib(this.Z.get(s),I)}finally{this.bb(s,S,D)}return D}async mkdir(s){try{await f.Promises.mkdir(this.I(s))}catch(i){throw this.hb(i)}}async delete(s,i){try{const o=this.I(s);if(i.recursive){let u;i?.atomic!==!1&&i.atomic.postfix&&(u=(0,d.$kc)((0,d.$nc)(o),`${(0,d.$oc)(o)}${i.atomic.postfix}`)),await f.Promises.rm(o,f.RimRafMode.MOVE,u)}else try{await f.Promises.unlink(o)}catch(u){if(u.code==="EPERM"||u.code==="EISDIR"){let g=!1;try{const{stat:S,symbolicLink:D}=await f.SymlinkSupport.stat(o);g=S.isDirectory()&&!D}catch{}if(g)await f.Promises.rmdir(o);else throw u}else throw u}}catch(o){throw this.hb(o)}}async rename(s,i,o){const u=this.I(s),g=this.I(i);if(u!==g)try{await this.db(s,i,"move",o.overwrite),await f.Promises.rename(u,g)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(2,null,(0,d.$oc)(u),(0,d.$oc)((0,d.$nc)(g)),S.toString()))),this.hb(S)}}async copy(s,i,o){const u=this.I(s),g=this.I(i);if(u!==g)try{await this.db(s,i,"copy",o.overwrite),await f.Promises.copy(u,g,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,y.localize)(3,null,(0,d.$oc)(u),(0,d.$oc)((0,d.$nc)(g)),S.toString()))),this.hb(S)}}async db(s,i,o,u){const g=this.I(s),S=this.I(i);let D=!1;if(!!(this.capabilities&1024)||(D=(0,h.$tg)(g,S,!0)),D){if(o==="copy")throw(0,p.$cl)((0,y.localize)(4,null),p.FileSystemProviderErrorCode.FileExists);if(o==="move")return}const O=await this.N(s);if(!O)throw(0,p.$cl)((0,y.localize)(5,null),p.FileSystemProviderErrorCode.FileNotFound);const M=await this.N(i);if(M){if(!u)throw(0,p.$cl)((0,y.localize)(6,null),p.FileSystemProviderErrorCode.FileExists);O.type&p.FileType.File&&M.type&p.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,i){return this.eb(s,i,!1)}async eb(s,i,o){const u=this.I(s),g=this.I(i),S=!!(this.capabilities&1024);if((0,h.$tg)(u,g,!S))return;const D=new l.$Uc;try{D.add(await this.Q(s)),D.add(await this.Q(i)),o&&await f.Promises.mkdir((0,d.$nc)(g),{recursive:!0}),await f.Promises.copyFile(u,g)}catch(I){if(I.code==="ENOENT"&&!o)return this.eb(s,i,!0);throw this.hb(I)}finally{D.dispose()}}t(s,i,o){return new P.$1q(u=>s(u),u=>i(u),o)}F(s,i,o){return new a.$0q(u=>s(u),u=>i(u),o)}hb(s){if(s instanceof p.$bl)return s;let i=s,o;switch(s.code){case"ENOENT":o=p.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=p.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=p.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=p.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=p.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=p.FileSystemProviderErrorCode.Unknown;break;default:o=p.FileSystemProviderErrorCode.Unknown}return(0,p.$cl)(i,o)}async ib(s,i){let o=this.hb(i);if(s&&o.code===p.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await f.SymlinkSupport.stat(this.I(s));u.mode&128||(o=(0,p.$cl)(i,p.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.$$q=t}),define(re[227],oe([0,1,3,94,2,17,63,23]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Js=e.$Is=void 0;class h extends E.$Vc{constructor(b,v){super(),this.a=b,this.b=v,this.F=new Map,this.G=new Map}call(b,v,m){const f=this.c(b);switch(v){case"stat":return this.g(f,m[0]);case"readdir":return this.h(f,m[0]);case"open":return this.r(f,m[0],m[1]);case"close":return this.s(m[0]);case"read":return this.t(m[0],m[1],m[2]);case"readFile":return this.j(f,m[0],m[1]);case"write":return this.u(m[0],m[1],m[2],m[3],m[4]);case"writeFile":return this.n(f,m[0],m[1],m[2]);case"rename":return this.z(f,m[0],m[1],m[2]);case"copy":return this.C(f,m[0],m[1],m[2]);case"cloneFile":return this.D(f,m[0],m[1]);case"mkdir":return this.w(f,m[0]);case"delete":return this.y(f,m[0],m[1]);case"watch":return this.I(f,m[0],m[1],m[2],m[3]);case"unwatch":return this.J(m[0],m[1])}throw new Error(`IPC Command ${v} not found`)}listen(b,v,m){const f=this.c(b);switch(v){case"fileChange":return this.H(f,m[0]);case"readFileStream":return this.m(f,m[0],m[1])}throw new Error(`Unknown event ${v}`)}g(b,v){const m=this.f(b,v,!0);return this.a.stat(m)}h(b,v){const m=this.f(b,v);return this.a.readdir(m)}async j(b,v,m){const f=this.f(b,v,!0),y=await this.a.readFile(f,m);return R.$Fe.wrap(y)}m(b,v,m){const f=this.f(b,v,!0),y=new k.$pe,p=new n.$ee({onDidRemoveLastListener:()=>{y.cancel()}}),$=this.a.readFileStream(f,m,y.token);return(0,j.$xe)($,{onData:c=>p.fire(R.$Fe.wrap(c)),onError:c=>p.fire(c),onEnd:()=>{p.fire("end"),p.dispose(),y.dispose()}}),p.event}n(b,v,m,f){const y=this.f(b,v);return this.a.writeFile(y,m.buffer,f)}r(b,v,m){const f=this.f(b,v,!0);return this.a.open(f,m)}s(b){return this.a.close(b)}async t(b,v,m){const f=R.$Fe.alloc(m),p=await this.a.read(b,v,f.buffer,0,m);return[f,p]}u(b,v,m,f,y){return this.a.write(b,v,m.buffer,f,y)}w(b,v){const m=this.f(b,v);return this.a.mkdir(m)}y(b,v,m){const f=this.f(b,v);return this.a.delete(f,m)}z(b,v,m,f){const y=this.f(b,v),p=this.f(b,m);return this.a.rename(y,p,f)}C(b,v,m,f){const y=this.f(b,v),p=this.f(b,m);return this.a.copy(y,p,f)}D(b,v,m){const f=this.f(b,v),y=this.f(b,m);return this.a.cloneFile(f,y)}H(b,v){const m=new n.$ee({onWillAddFirstListener:()=>{this.F.set(v,this.L(b,m))},onDidRemoveLastListener:()=>{(0,E.$Qc)(this.F.get(v)),this.F.delete(v)}});return m.event}async I(b,v,m,f,y){const p=this.F.get(v);if(p){const $=this.f(b,f),c=p.watch(m,$,y);this.G.set(v+m,c)}}async J(b,v){const m=b+v,f=this.G.get(m);f&&((0,E.$Qc)(f),this.G.delete(m))}dispose(){super.dispose();for(const[,b]of this.G)b.dispose();this.G.clear();for(const[,b]of this.F)b.dispose();this.F.clear()}}e.$Is=h;class l extends E.$Vc{constructor(b,v,m,f){super(),this.c=b,this.f=m,this.g=f,this.a=new Map,this.b=this.B(new C.$$q(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(b){const v=this.B(new n.$ee);this.B(v.event(m=>{b.fire(m.map(f=>({resource:this.c.transformOutgoingURI(f.resource),type:f.type,cId:f.cId})))})),this.B(this.b.onDidChangeFile(m=>v.fire(m))),this.B(this.b.onDidWatchError(m=>b.fire(m)))}j(b){}m(b){}watch(b,v,m){const f=this.m(this.g);return Array.isArray(f)&&(m.excludes=[...m.excludes,...f]),this.a.set(b,this.b.watch(v,m)),(0,E.$Tc)(()=>{(0,E.$Qc)(this.a.get(b)),this.a.delete(b)})}dispose(){for(const[,b]of this.a)b.dispose();this.a.clear(),super.dispose()}}e.$Js=l}),define(re[228],oe([0,1,14,180,4,7,16,9,227,157,47]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dcc=void 0;class b extends h.$Is{constructor(f,y,p){super(f,y),this.M=p}c(f){return l.$yn}f(f,y){return R.URI.revive(y)}async y(f,y,p){if(!p.useTrash)return super.y(f,y,p);const $=this.f(f,y),c=(0,k.$ic)($.fsPath);try{await n.shell.trashItem(c)}catch(w){throw(0,j.$cl)(E.$i?(0,C.localize)(0,null,(0,k.$oc)(c),(0,d.$gj)(w)):(0,C.localize)(1,null,(0,k.$oc)(c),(0,d.$gj)(w)),j.FileSystemProviderErrorCode.Unknown)}}L(f,y){return new v(f,y,this.b,this.M)}}e.$dcc=b;class v extends h.$Js{watch(f,y,p){if(p.recursive)throw(0,j.$cl)("Recursive file watching is not supported from main process for performance reasons.",j.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,p)}}}),define(re[229],oe([0,1,5]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;class C extends n.$8j{constructor(R=n.$5j){super(),this.m=[],this.n=void 0,this.setLevel(R),this.B(this.onDidChangeLogLevel(j=>{this.n?.setLevel(j)}))}set logger(R){this.n=R;for(const{level:j,message:k}of this.m)(0,n.log)(R,j,k);this.m=[]}g(R,j){this.n?(0,n.log)(this.n,R,j):this.getLevel()<=R&&this.m.push({level:R,message:j})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$4$b=C}),define(re[230],oe([0,1,7,3,5,2]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$as=e.$_r=e.$$r=void 0;class j extends E.$ak{constructor(b,v,m,f,y){super(v,m,f),this.r=b,this.t=y,this.B(y.listen("onDidChangeLogLevel",b)(p=>{(0,E.$4j)(p)?super.setLogLevel(p):super.setLogLevel(n.URI.revive(p[0]),p[1])})),this.B(y.listen("onDidChangeVisibility",b)(([p,$])=>super.setVisibility(n.URI.revive(p),$))),this.B(y.listen("onDidChangeLoggers",b)(({added:p,removed:$})=>{for(const c of p)super.registerLogger({...c,resource:n.URI.revive(c.resource)});for(const c of $)super.deregisterLogger(c.resource)}))}createConsoleMainLogger(){return new E.$$j({log:(b,v)=>{this.t.call("consoleLog",[b,v])}})}registerLogger(b){super.registerLogger(b),this.t.call("registerLogger",[b,this.r])}deregisterLogger(b){super.deregisterLogger(b),this.t.call("deregisterLogger",[b,this.r])}setLogLevel(b,v){super.setLogLevel(b,v),this.t.call("setLogLevel",[b,v])}setVisibility(b,v){super.setVisibility(b,v),this.t.call("setVisibility",[this.n(b),v])}s(b,v,m){return new k(this.t,b,v,m,this.r)}static setLogLevel(b,v,m){return b.call("setLogLevel",[v,m])}}e.$$r=j;class k extends E.$8j{constructor(b,v,m,f,y){super(f?.logLevel==="always"),this.r=b,this.s=v,this.m=!1,this.n=[],this.setLevel(m),this.r.call("createLogger",[v,f,y]).then(()=>{this.u(this.n),this.m=!0})}g(b,v){const m=[[b,v]];this.m?this.u(m):this.n.push(...m)}u(b){this.r.call("log",[this.s,b])}}class h{constructor(b,v){this.a=b,this.b=v}listen(b,v){const m=this.b(b);switch(v){case"onDidChangeLoggers":return C.Event.map(this.a.onDidChangeLoggers,f=>({added:[...f.added].map(y=>this.c(y,m)),removed:[...f.removed].map(y=>this.c(y,m))}));case"onDidChangeVisibility":return C.Event.map(this.a.onDidChangeVisibility,f=>[m.transformOutgoingURI(f[0]),f[1]]);case"onDidChangeLogLevel":return C.Event.map(this.a.onDidChangeLogLevel,f=>(0,E.$4j)(f)?f:[m.transformOutgoingURI(f[0]),f[1]])}throw new Error(`Event not found: ${v}`)}async call(b,v,m){const f=this.b(b);switch(v){case"setLogLevel":return(0,E.$4j)(m[0])?this.a.setLogLevel(m[0]):this.a.setLogLevel(n.URI.revive(f.transformIncoming(m[0][0])),m[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(y=>this.c(y,f)))}throw new Error(`Call not found: ${v}`)}c(b,v){return{...b,resource:v.transformOutgoingURI(b.resource)}}}e.$_r=h;class l extends R.$Vc{constructor(b,v){super(),v.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(m=>v.call("setLogLevel",[m]))),v.call("getRegisteredLoggers").then(m=>{for(const f of m)b.registerLogger({...f,resource:n.URI.revive(f.resource)})}),this.B(v.listen("onDidChangeVisibility")(([m,f])=>b.setVisibility(n.URI.revive(m),f))),this.B(v.listen("onDidChangeLoggers")(({added:m,removed:f})=>{for(const y of m)b.registerLogger({...y,resource:n.URI.revive(y.resource)});for(const y of f)b.deregisterLogger(y.resource)}))}}e.$as=l}),define(re[231],oe([0,1,2,5]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;class E extends n.$Vc{constructor(j,k=[]){super(),this.a=new C.$_j([j,...k]),this.B(j.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(j){this.a.setLevel(j)}getLevel(){return this.a.getLevel()}trace(j,...k){this.a.trace(j,...k)}debug(j,...k){this.a.debug(j,...k)}info(j,...k){this.a.info(j,...k)}warn(j,...k){this.a.warn(j,...k)}error(j,...k){this.a.error(j,...k)}flush(){this.a.flush()}}e.$JQ=E}),define(re[232],oe([0,1,32,7,5]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$cc=void 0;class R{constructor(k){this.b=k,this.a=new n.$Bc}listen(k,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(k,h,l){switch(h){case"createLogger":this.c(C.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(C.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,E.$4j)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(C.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(C.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:C.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(C.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(k,h,l){this.a.set(k,this.b.createLogger(k,h,l))}d(k,h){let l=console.log;switch(k){case E.LogLevel.Error:l=console.error;break;case E.LogLevel.Warning:l=console.warn;break;case E.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(k,h){const l=this.a.get(k);if(!l)throw new Error("Create the logger before logging");for(const[d,b]of h)(0,E.log)(l,d,b)}}e.$$cc=R}),define(re[233],oe([0,1,16,5]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yQ=void 0;var E;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(E||(E={}));async function R(l,d,b,v,m){try{const f=await new Promise((p,$)=>{X(["@vscode/spdlog"],p,$)});f.setFlushOn(E.Trace);const y=await f.createAsyncRotatingLogger(l,d,b,v);return m?y.clearFormatters():y.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),y}catch(f){console.error(f)}return null}function j(l,d,b){switch(d){case C.LogLevel.Trace:l.trace(b);break;case C.LogLevel.Debug:l.debug(b);break;case C.LogLevel.Info:l.info(b);break;case C.LogLevel.Warning:l.warn(b);break;case C.LogLevel.Error:l.error(b);break;case C.LogLevel.Off:break;default:throw new Error(`Invalid log level ${d}`)}}function k(l,d){switch(d){case C.LogLevel.Trace:l.setLevel(E.Trace);break;case C.LogLevel.Debug:l.setLevel(E.Debug);break;case C.LogLevel.Info:l.setLevel(E.Info);break;case C.LogLevel.Warning:l.setLevel(E.Warning);break;case C.LogLevel.Error:l.setLevel(E.Error);break;case C.LogLevel.Off:l.setLevel(E.Off);break;default:throw new Error(`Invalid log level ${d}`)}}class h extends C.$8j{constructor(d,b,v,m,f){super(),this.m=[],this.setLevel(f),this.n=this.s(d,b,v,m),this.B(this.onDidChangeLogLevel(y=>{this.r&&k(this.r,y)}))}async s(d,b,v,m){const f=v?6:1,y=30/f*n.$xl.MB,p=await R(d,b,y,f,m);if(p){this.r=p,k(this.r,this.getLevel());for(const{level:$,message:c}of this.m)j(this.r,$,c);this.m=[]}}g(d,b){this.r?j(this.r,d,b):this.getLevel()<=d&&this.m.push({level:d,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$yQ=h}),define(re[234],oe([0,1,33,5,233]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zQ=void 0;class R extends C.$ak{s(k,h,l){return new E.$yQ((0,n.$Rg)(),k.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.$zQ=R}),define(re[67],oe([0,1,32,3,6,5,234]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lbc=e.$Kbc=void 0,e.$Kbc=(0,E.$wi)(R.$3j);class k extends j.$zQ{constructor(){super(...arguments),this.u=new n.$Bc}createLogger(l,d,b){b!==void 0&&this.u.set(this.n(l),b);try{return super.createLogger(l,d)}catch(v){throw this.u.delete(this.n(l)),v}}registerLogger(l,d){d!==void 0&&this.u.set(l.resource,d),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const d=[];for(const b of super.getRegisteredLoggers())l===this.u.get(b.resource)&&d.push(b);return d}getOnDidChangeLogLevelEvent(l){return C.Event.filter(this.onDidChangeLogLevel,d=>(0,R.$4j)(d)||this.w(d[0],l))}getOnDidChangeVisibilityEvent(l){return C.Event.filter(this.onDidChangeVisibility,([d])=>this.w(d,l))}getOnDidChangeLoggersEvent(l){return C.Event.filter(C.Event.map(this.onDidChangeLoggers,d=>({added:[...d.added].filter(v=>this.w(v.resource,l)),removed:[...d.removed].filter(v=>this.w(v.resource,l))})),d=>d.added.length>0||d.removed.length>0)}deregisterLoggers(l){for(const[d,b]of this.u)b===l&&this.deregisterLogger(d)}w(l,d){const b=this.u.get(l);return b===void 0||b===d}dispose(){super.dispose(),this.u.clear()}}e.$Lbc=k}),define(re[235],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qcc=n,e.$rcc=C,e.$scc=E,e.$tcc=R;function n(j){return j.submenu!==void 0}function C(j){return j.id==="vscode.menubar.separator"}function E(j){return j.uri!==void 0}function R(j){return!n(j)&&!C(j)&&!E(j)}}),define(re[39],oe([0,1,3,71,2,6]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=e.$eo=e.$do=void 0,e.$do=(0,R.$vi)("policy");class j extends E.$Vc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new n.$ee),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const d=Object.keys(this.f).length;return this.f={...l,...this.f},d!==Object.keys(this.f).length&&await this.j(l),C.Iterable.reduce(this.g.entries(),(b,[v,m])=>({...b,[v]:m}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return C.Iterable.reduce(Object.entries(this.f),(l,[d,b])=>({...l,[d]:{definition:b,value:this.g.get(d)}}),{})}}e.$eo=j;class k{constructor(){this.onDidChange=n.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$fo=k}),define(re[236],oe([0,1,8,3,71,12,16,5,39]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rdc=void 0;function l(b,v){const m=[];for(const f of new Set(E.Iterable.concat(b.keys(),v.keys())))b.get(f)!==v.get(f)&&m.push(f);return m}let d=class extends h.$eo{constructor(v,m,f){super(),this.m=v,this.n=m,this.s=f,this.c=this.B(new n.$th(500));const y=C.Event.filter(m.onDidFilesChange,p=>p.affects(v));this.B(m.watch(v)),this.B(y(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const m=await this.n.readFile(this.m),f=JSON.parse(m.value.toString());if(!(0,R.$0f)(f))throw new Error("Policy file isn't a JSON object");for(const y of Object.keys(f))this.f[y]&&v.set(y,f[y])}catch(m){m.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",m)}return v}async w(){const v=await this.u(),m=l(this.g,v);this.g=v,m.length>0&&this.h.fire(m)}};e.$rdc=d,e.$rdc=d=Ee([ie(1,j.$2k),ie(2,k.$2j)],d)}),define(re[237],oe([0,1,3,2,39]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3cc=e.$2cc=void 0;class R{constructor(h){this.b=h,this.a=new C.$Uc}listen(h,l){switch(l){case"onDidChange":return n.Event.map(this.b.onDidChange,d=>d.reduce((b,v)=>({...b,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,d){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(d)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$2cc=R;class j extends E.$eo{constructor(h,l){super(),this.a=l;for(const d in h){const{definition:b,value:v}=h[d];this.f[d]=b,v!==void 0&&this.g.set(d,v)}this.a.listen("onDidChange")(d=>{for(const b in d){const v=d[b];v===null?this.g.delete(b):this.g.set(b,v)}this.h.fire(Object.keys(d))})}async j(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const d in l)this.g.set(d,l[d])}}e.$3cc=j}),define(re[238],oe([0,1,39,8,2,5]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qdc=void 0;let j=class extends n.$eo{constructor(h,l){super(),this.m=h,this.n=l,this.a=new C.$ph,this.b=this.B(new E.$Wc)}async j(h){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(h).length} policy definitions`);const{createWatcher:l}=await new Promise((d,b)=>{X(["@vscode/policy-watcher"],d,b)});await this.a.queue(()=>new Promise((d,b)=>{try{this.b.value=l(this.n,h,v=>{this.t(v),d()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),b(v)}}))}t(h){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(h)}`);for(const l in h){const d=h[l];d===void 0?this.g.delete(l):this.g.set(l,d)}this.h.fire(Object.keys(h))}};e.$qdc=j,e.$qdc=j=Ee([ie(0,R.$2j)],j)}),define(re[80],oe([0,1,36]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let C;const E=globalThis.vscode;if(typeof E<"u"&&typeof E.context<"u"){const R=E.context.configuration();if(R)C=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(C=globalThis._VSCODE_PRODUCT_JSON,n.env.VSCODE_DEV&&Object.assign(C,{nameShort:`${C.nameShort} Dev`,nameLong:`${C.nameLong} Dev`,dataFolderName:`${C.dataFolderName}-dev`,serverDataFolderName:C.serverDataFolderName?`${C.serverDataFolderName}-dev`:void 0}),!C.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(C,{version:R.version})}}else C={},Object.keys(C).length===0&&Object.assign(C,{version:"1.87.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=C}),define(re[27],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=void 0,e.$ik=(0,n.$vi)("productService"),e.$jk="vscode://schemas/vscode-product"}),define(re[239],oe([0,1,8,5]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gcc=void 0;let E=class{constructor(j,k,h){this.a=j,this.b=k,this.c=h}async inspect(j){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,n.$wh)(j);const h=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const j=this.a.webContents.debugger;j.attach(),await j.sendCommand("Profiler.enable")}async e(){const j=this.a.webContents.debugger;await j.sendCommand("Profiler.disable"),j.detach()}};e.$gcc=E,e.$gcc=E=Ee([ie(2,C.$2j)],E)}),define(re[81],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tbc=void 0,e.$tbc=(0,n.$vi)("protocolMainService")}),define(re[45],oe([0,1,139,12]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class E{constructor(){this.a=new Map}add(j,k){n.ok(C.$8f(j)),n.ok(C.$0f(k)),n.ok(!this.a.has(j),"There is already an extension with this id"),this.a.set(j,k)}knows(j){return this.a.has(j)}as(j){return this.a.get(j)||null}}e.$bo=new E}),define(re[240],oe([0,1,3,45]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co={JSONContribution:"base.contributions.json"};function E(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class R{constructor(){this.b=new n.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[E(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const j=new R;C.$bo.add(e.$co.JSONContribution,j)}),define(re[52],oe([0,1,22,3,12,165,18,240,45]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.ConfigurationScope=e.$go=e.EditPresentationTypes=void 0,e.$ro=y,e.$so=p,e.$to=$,e.$uo=w,e.$vo=P;var l;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$go={Configuration:"base.contributions.configuration"};var d;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(d||(e.ConfigurationScope=d={})),e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no="vscode://schemas/settings/resourceLanguage",e.$oo="vscode://schemas/settings/configurationDefaults";const b=h.$bo.as(k.$co.JSONContribution);class v{constructor(){this.h=new Set,this.i=new C.$ee,this.onDidSchemaChange=this.i.event,this.j=new C.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$no,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const s=new Set;this.n(t,r,s),b.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const r=new Set;this.o(t,r),b.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const s=new Set;this.o(r,s),this.n(t,!1,s),b.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const s=[];for(const{overrides:i,source:o}of t)for(const u in i)if(r.add(u),e.$qo.test(u)){const g=this.a.get(u),S=g?.valuesSources??new Map;if(o)for(const M of Object.keys(i[u]))S.set(M,o);const D={...g?.value||{},...i[u]};this.a.set(u,{source:o,value:D,valuesSources:S});const I=(0,j.$_i)(u),O={type:"object",default:D,description:R.localize(1,null,I),$ref:e.$no,defaultDefaultValue:D,source:E.$8f(o)?void 0:o,defaultValueSource:o};s.push(...y(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:i[u],source:o});const g=this.d[u];g&&(this.w(u,g),this.r(u,g))}this.m(s)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:s,source:i}of t)for(const o in s){const u=this.a.get(o),g=E.$8f(i)?i:i?.id,S=E.$8f(u?.source)?u?.source:u?.source?.id;if(g===S)if(r.add(o),this.a.delete(o),e.$qo.test(o))delete this.d[o],delete this.b.properties[o];else{const D=this.d[o];D&&(this.w(o,D),this.r(o,D))}}this.u()}deltaConfiguration(t){let r=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,s){t.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,s),this.c.push(i),this.q(i)})}o(t,r){const s=i=>{if(i.properties)for(const o in i.properties){r.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,i.properties[o])}i.allOf?.forEach(o=>s(o))};for(const i of t){s(i);const o=this.c.indexOf(i);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,s,i,o=3,u){o=E.$eg(t.scope)?o:t.scope;const g=t.properties;if(g)for(const D in g){const I=g[D];if(r&&w(D,I)){delete g[D];continue}if(I.source=s,I.defaultDefaultValue=g[D].default,this.w(D,I),e.$qo.test(D)?I.scope=void 0:(I.scope=E.$eg(I.scope)?o:I.scope,I.restricted=E.$eg(I.restricted)?!!i?.includes(D):I.restricted),g[D].hasOwnProperty("included")&&!g[D].included){this.f[D]=g[D],delete g[D];continue}else this.d[D]=g[D],g[D].policy?.name&&this.e.set(g[D].policy.name,D);!g[D].deprecationMessage&&g[D].markdownDeprecationMessage&&(g[D].deprecationMessage=g[D].markdownDeprecationMessage),u.add(D)}const S=t.allOf;if(S)for(const D of S)this.p(D,r,s,i,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=s=>{const i=s.properties;if(i)for(const u in i)this.r(u,i[u]);s.allOf?.forEach(r)};r(t)}r(t,r){switch(e.$ho.properties[t]=r,r.scope){case 1:e.$io.properties[t]=r;break;case 2:e.$jo.properties[t]=r;break;case 6:e.$ko.properties[t]=r;break;case 3:e.$lo.properties[t]=r;break;case 4:e.$mo.properties[t]=r;break;case 5:e.$mo.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.$ho.properties[t],r.scope){case 1:delete e.$io.properties[t];break;case 2:delete e.$jo.properties[t];break;case 6:delete e.$ko.properties[t];break;case 3:delete e.$lo.properties[t];break;case 4:case 5:delete e.$mo.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,s={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.$no};this.w(r,s),e.$ho.properties[r]=s,e.$io.properties[r]=s,e.$jo.properties[r]=s,e.$ko.properties[r]=s,e.$lo.properties[r]=s,e.$mo.properties[r]=s}}v(){const t={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.$no};e.$ho.patternProperties[e.$po]=t,e.$io.patternProperties[e.$po]=t,e.$jo.patternProperties[e.$po]=t,e.$ko.patternProperties[e.$po]=t,e.$lo.patternProperties[e.$po]=t,e.$mo.patternProperties[e.$po]=t,this.i.fire()}w(t,r){const s=this.a.get(t);let i=s?.value,o=s?.source;E.$cg(i)&&(i=r.defaultDefaultValue,o=void 0),E.$cg(i)&&(i=$(r.type)),r.default=i,r.defaultValueSource=o}}const m="\\[([^\\]]+)\\]",f=new RegExp(m,"g");e.$po=`^(${m})+$`,e.$qo=new RegExp(e.$po);function y(a){const t=[];if(e.$qo.test(a)){let r=f.exec(a);for(;r?.length;){const s=r[1].trim();s&&t.push(s),r=f.exec(a)}}return(0,n.$Mb)(t)}function p(a){return a.reduce((t,r)=>`${t}[${r}]`,"")}function $(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const c=new v;h.$bo.add(e.$go.Configuration,c);function w(a,t){return a.trim()?e.$qo.test(a)?R.localize(7,null,a):c.getConfigurationProperties()[a]!==void 0?R.localize(8,null,a):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?R.localize(9,null,a,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:R.localize(6,null)}function P(){const a=[],t=c.getConfigurationProperties();for(const r of Object.keys(t))a.push([r,t[r].scope]);return a.push(["launch",4]),a.push(["task",4]),a}}),define(re[123],oe([0,1,22,3,42,2,32,35,12,7,18,52,45]),function(X,e,n,C,E,R,j,k,h,l,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$Ao=w;function m(r){return Object.isFrozen(r)?r:k.$3n(r)}class f{static createEmptyModel(s){return new f({},[],[],void 0,s)}constructor(s,i,o,u,g){this.b=s,this.c=i,this.d=o,this.raw=u,this.f=g,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const s=this.raw.map(i=>{if(i instanceof f)return i;const o=new y("",this.f);return o.parseRaw(i),o.configurationModel});this.g=s.reduce((i,o)=>o===i?o:i.merge(o),s[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,d.$0i)(this.contents,s):this.contents}inspect(s,i){const o=this;return{get value(){return m(o.rawConfiguration.getValue(s))},get override(){return i?m(o.rawConfiguration.getOverrideValue(s,i)):void 0},get merged(){return m(i?o.rawConfiguration.override(i).getValue(s):o.rawConfiguration.getValue(s))},get overrides(){const u=[];for(const{contents:g,identifiers:S,keys:D}of o.rawConfiguration.overrides){const I=new f(g,D,[],void 0,o.f).getValue(s);I!==void 0&&u.push({identifiers:S,value:I})}return u.length?m(u):void 0}}}getOverrideValue(s,i){const o=this.j(i);return o?s?(0,d.$0i)(o,s):o:void 0}getKeysForOverrideIdentifier(s){const i=[];for(const o of this.overrides)o.identifiers.includes(s)&&i.push(...o.keys);return n.$Mb(i)}getAllOverrideIdentifiers(){const s=[];for(const i of this.overrides)s.push(...i.identifiers);return n.$Mb(s)}override(s){let i=this.a.get(s);return i||(i=this.h(s),this.a.set(s,i)),i}merge(...s){const i=k.$2n(this.contents),o=k.$2n(this.overrides),u=[...this.keys],g=this.raw?.length?[...this.raw]:[this];for(const S of s)if(g.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(i,S.contents);for(const D of S.overrides){const[I]=o.filter(O=>n.$ub(O.identifiers,D.identifiers));I?(this.i(I.contents,D.contents),I.keys.push(...D.keys),I.keys=n.$Mb(I.keys)):o.push(k.$2n(D))}for(const D of S.keys)u.indexOf(D)===-1&&u.push(D)}return new f(i,u,o,g.every(S=>S instanceof f)?void 0:g,this.f)}h(s){const i=this.j(s);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const o={};for(const u of n.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let g=this.contents[u];const S=i[u];S&&(typeof g=="object"&&typeof S=="object"?(g=k.$2n(g),this.i(g,S)):g=S),o[u]=g}return new f(o,this.keys,this.overrides,void 0,this.f)}i(s,i){for(const o of Object.keys(i)){if(o in s&&h.$0f(s[o])&&h.$0f(i[o])){this.i(s[o],i[o]);continue}s[o]=k.$2n(i[o])}}j(s){let i=null,o=null;const u=g=>{g&&(o?this.i(o,g):o=k.$2n(g))};for(const g of this.overrides)g.identifiers.length===1&&g.identifiers[0]===s?i=g.contents:g.identifiers.includes(s)&&u(g.contents);return u(i),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,i){this.k(s,i,!0)}setValue(s,i){this.k(s,i,!1)}removeValue(s){const i=this.keys.indexOf(s);i!==-1&&(this.keys.splice(i,1),(0,d.$9i)(this.contents,s),b.$qo.test(s)&&this.overrides.splice(this.overrides.findIndex(o=>n.$ub(o.identifiers,(0,b.$ro)(s))),1))}k(s,i,o){(0,d.$8i)(this.contents,s,i,u=>this.f.error(u)),o=o||this.keys.indexOf(s)===-1,o&&this.keys.push(s),b.$qo.test(s)&&this.overrides.push({identifiers:(0,b.$ro)(s),keys:Object.keys(this.contents[s]),contents:(0,d.$7i)(this.contents[s],u=>this.f.error(u))})}}e.$wo=f;class y{constructor(s,i){this.f=s,this.g=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,i){if(!h.$eg(s)){const o=this.h(s);this.parseRaw(o,i)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,i){this.a=s;const{contents:o,keys:u,overrides:g,restricted:S,hasExcludedProperties:D}=this.i(s,i);this.b=new f(o,u,g,D?[s]:void 0,this.g),this.c=S||[]}h(s){let i={},o=null,u=[];const g=[],S=[];function D(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const I={onObjectBegin:()=>{const O={};D(O),g.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const O=[];D(O),g.push(u),u=O,o=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:D,onError:(O,M,W)=>{S.push({error:O,offset:M,length:W})}};if(s)try{E.$Pn(s,I),i=u[0]||{}}catch(O){this.g.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return i}i(s,i){const o=v.$bo.as(b.$go.Configuration).getConfigurationProperties(),u=this.j(s,o,!0,i);s=u.raw;const g=(0,d.$7i)(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`)),S=Object.keys(s),D=this.l(s,I=>this.g.error(`Conflict in settings file ${this.f}: ${I}`));return{contents:g,keys:S,overrides:D,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}j(s,i,o,u){let g=!1;if(!u?.scopes&&!u?.skipRestricted&&!u?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:g};const S={},D=[];for(const I in s)if(b.$qo.test(I)&&o){const O=this.j(s[I],i,!1,u);S[I]=O.raw,g=g||O.hasExcludedProperties,D.push(...O.restricted)}else{const O=i[I],M=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&D.push(I),!u.exclude?.includes(I)&&(u.include?.includes(I)||(M===void 0||u.scopes===void 0||u.scopes.includes(M))&&!(u.skipRestricted&&O?.restricted))?S[I]=s[I]:g=!0}return{raw:S,restricted:D,hasExcludedProperties:g}}l(s,i){const o=[];for(const u of Object.keys(s))if(b.$qo.test(u)){const g={};for(const S in s[u])g[S]=s[u][S];o.push({identifiers:(0,b.$ro)(u),keys:Object.keys(g),contents:(0,d.$7i)(g,i)})}return o}}e.$xo=y;class p extends R.$Vc{constructor(s,i,o,u,g){super(),this.c=s,this.f=i,this.g=u,this.h=g,this.b=this.B(new C.$ee),this.onDidChange=this.b.event,this.a=new y(this.c.toString(),g),this.B(this.g.watch(o.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(C.Event.any(C.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),C.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&o.isEqual(S.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yo=p;class ${constructor(s,i,o,u,g,S,D,I,O,M,W,F,T){this.a=s,this.b=i,this.c=o,this.overrideIdentifiers=u,this.d=g,this.f=S,this.g=D,this.h=I,this.i=O,this.j=M,this.k=W,this.l=F,this.m=T}get value(){return m(this.c)}n(s){return s?.value!==void 0||s?.override!==void 0||s?.overrides!==void 0?s:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class c{constructor(s,i,o,u,g,S,D,I,O,M){this.j=s,this.l=i,this.m=o,this.n=u,this.p=g,this.q=S,this.r=D,this.s=I,this.t=O,this.u=M,this.h=null,this.i=new j.$Bc,this.v=null}getValue(s,i,o){return this.w(s,i,o).getValue(s)}updateValue(s,i,o={}){let u;o.resource?(u=this.t.get(o.resource),u||(u=f.createEmptyModel(this.u),this.t.set(o.resource,u))):u=this.s,i===void 0?u.removeValue(s):u.setValue(s,i),o.resource||(this.h=null)}inspect(s,i,o){const u=this.w(s,i,o),g=this.A(i.resource,o),S=i.resource?this.t.get(i.resource)||this.s:this.s,D=new Set;for(const I of u.overrides)for(const O of I.identifiers)u.getOverrideValue(s,O)!==void 0&&D.add(O);return new $(s,i,u.getValue(s),D.size?[...D]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.q:void 0,g||void 0,S)}keys(s){const i=this.A(void 0,s);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(s){this.j=s,this.h=null,this.i.clear()}updatePolicyConfiguration(s){this.l=s}updateApplicationConfiguration(s){this.m=s,this.h=null,this.i.clear()}updateLocalUserConfiguration(s){this.n=s,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(s){this.p=s,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(s){this.q=s,this.h=null,this.i.clear()}updateFolderConfiguration(s,i){this.r.set(s,i),this.i.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.i.delete(s)}compareAndUpdateDefaultConfiguration(s,i){const o=[];if(!i){const{added:u,updated:g,removed:S}=a(this.j,s);i=[...u,...g,...S]}for(const u of i)for(const g of(0,b.$ro)(u)){const S=this.j.getKeysForOverrideIdentifier(g),D=s.getKeysForOverrideIdentifier(g),I=[...D.filter(O=>S.indexOf(O)===-1),...S.filter(O=>D.indexOf(O)===-1),...S.filter(O=>!k.$6n(this.j.override(g).getValue(O),s.override(g).getValue(O)))];o.push([g,I])}return this.updateDefaultConfiguration(s),{keys:i,overrides:o}}compareAndUpdatePolicyConfiguration(s){const{added:i,updated:o,removed:u}=a(this.l,s),g=[...i,...o,...u];return g.length&&this.updatePolicyConfiguration(s),{keys:g,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.applicationConfiguration,s),S=[...i,...o,...u];return S.length&&this.updateApplicationConfiguration(s),{keys:S,overrides:g}}compareAndUpdateLocalUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.localUserConfiguration,s),S=[...i,...o,...u];return S.length&&this.updateLocalUserConfiguration(s),{keys:S,overrides:g}}compareAndUpdateRemoteUserConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.remoteUserConfiguration,s),S=[...i,...o,...u];return S.length&&this.updateRemoteUserConfiguration(s),{keys:S,overrides:g}}compareAndUpdateWorkspaceConfiguration(s){const{added:i,updated:o,removed:u,overrides:g}=a(this.workspaceConfiguration,s),S=[...i,...o,...u];return S.length&&this.updateWorkspaceConfiguration(s),{keys:S,overrides:g}}compareAndUpdateFolderConfiguration(s,i){const o=this.folderConfigurations.get(s),{added:u,updated:g,removed:S,overrides:D}=a(o,i),I=[...u,...g,...S];return(I.length||!o)&&this.updateFolderConfiguration(s,i),{keys:I,overrides:D}}compareAndDeleteFolderConfiguration(s){const i=this.folderConfigurations.get(s);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:o,updated:u,removed:g,overrides:S}=a(i,void 0);return{keys:[...o,...u,...g],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(s,i,o){let u=this.x(i,o);return i.overrideIdentifier&&(u=u.override(i.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(s)!==void 0&&(u=u.merge(this.l)),u}x({resource:s},i){let o=this.y();if(i&&s){const u=i.getFolder(s);u&&(o=this.z(u.uri)||o);const g=this.t.get(s);g&&(o=o.merge(g))}return o}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(s){let i=this.i.get(s);if(!i){const o=this.y(),u=this.r.get(s);u?(i=o.merge(u),this.i.set(s,i)):i=o}return i}A(s,i){if(i&&s){const o=i.getFolder(s);if(o)return this.r.get(o.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((s,i)=>{const{contents:o,overrides:u,keys:g}=this.r.get(i);return s.push([i,{contents:o,overrides:u,keys:g}]),s},[])}}allKeys(){const s=new Set;return this.j.keys.forEach(i=>s.add(i)),this.userConfiguration.keys.forEach(i=>s.add(i)),this.q.keys.forEach(i=>s.add(i)),this.r.forEach(i=>i.keys.forEach(o=>s.add(o))),[...s.values()]}B(){const s=new Set;return this.j.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.q.getAllOverrideIdentifiers().forEach(i=>s.add(i)),this.r.forEach(i=>i.getAllOverrideIdentifiers().forEach(o=>s.add(o))),[...s.values()]}D(s){const i=new Set;return this.j.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.q.getKeysForOverrideIdentifier(s).forEach(o=>i.add(o)),this.r.forEach(o=>o.getKeysForOverrideIdentifier(s).forEach(u=>i.add(u))),[...i.values()]}static parse(s,i){const o=this.E(s.defaults,i),u=this.E(s.policy,i),g=this.E(s.application,i),S=this.E(s.user,i),D=this.E(s.workspace,i),I=s.folders.reduce((O,M)=>(O.set(l.URI.revive(M[0]),this.E(M[1],i)),O),new j.$Bc);return new c(o,u,g,S,f.createEmptyModel(i),D,I,f.createEmptyModel(i),new j.$Bc,i)}static E(s,i){return new f(s.contents,s.keys,s.overrides,void 0,i)}}e.$zo=c;function w(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const s=new Set,i=new Map;for(const u of r)u.keys.forEach(g=>s.add(g)),u.overrides.forEach(([g,S])=>{const D=(0,j.$yc)(i,g,new Set);S.forEach(I=>D.add(I))});const o=[];return i.forEach((u,g)=>o.push([g,[...u.values()]])),{keys:[...s.values()],overrides:o}}class P{constructor(s,i,o,u,g){this.change=s,this.f=i,this.g=o,this.h=u,this.i=g,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of s.keys)this.affectedKeys.add(S);for(const[,S]of s.overrides)for(const D of S)this.affectedKeys.add(D);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=c.parse(this.f.data,this.i)),this.j}affectsConfiguration(s,i){const o=this.a+s,u=this.d.indexOf(o);if(u<0)return!1;const g=u+o.length;if(g>=this.d.length)return!1;const S=this.d.charCodeAt(g);if(S!==this.b&&S!==this.c)return!1;if(i){const D=this.previousConfiguration?this.previousConfiguration.getValue(s,i,this.f?.workspace):void 0,I=this.g.getValue(s,i,this.h);return!k.$6n(D,I)}return!0}}e.$Bo=P;function a(r,s){const{added:i,removed:o,updated:u}=t(s?.rawConfiguration,r?.rawConfiguration),g=[],S=r?.getAllOverrideIdentifiers()||[],D=s?.getAllOverrideIdentifiers()||[];if(s){const I=D.filter(O=>!S.includes(O));for(const O of I)g.push([O,s.getKeysForOverrideIdentifier(O)])}if(r){const I=S.filter(O=>!D.includes(O));for(const O of I)g.push([O,r.getKeysForOverrideIdentifier(O)])}if(s&&r){for(const I of S)if(D.includes(I)){const O=t({contents:r.getOverrideValue(void 0,I)||{},keys:r.getKeysForOverrideIdentifier(I)},{contents:s.getOverrideValue(void 0,I)||{},keys:s.getKeysForOverrideIdentifier(I)});g.push([I,[...O.added,...O.removed,...O.updated]])}}return{added:i,removed:o,updated:u,overrides:g}}function t(r,s){const i=r?s?r.keys.filter(g=>s.keys.indexOf(g)===-1):[...r.keys]:[],o=s?r?s.keys.filter(g=>r.keys.indexOf(g)===-1):[...s.keys]:[],u=[];if(r&&s){for(const g of s.keys)if(r.keys.indexOf(g)!==-1){const S=(0,d.$0i)(s.contents,g),D=(0,d.$0i)(r.contents,g);k.$6n(S,D)||u.push(g)}}return{added:i,removed:o,updated:u}}}),define(re[241],oe([0,1,22,3,2,35,12,123,52,5,39,45]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eo=e.$Do=e.$Co=void 0;class v extends E.$Vc{get configurationModel(){return this.b}constructor(p){super(),this.c=p,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=k.$wo.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$bo.as(h.$go.Configuration).onDidUpdateConfiguration(({properties:p,defaultsOverrides:$})=>this.f(Array.from(p),$))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(p,$){this.j(p,b.$bo.as(h.$go.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:p})}g(){return{}}h(){this.b=k.$wo.createEmptyModel(this.c);const p=b.$bo.as(h.$go.Configuration).getConfigurationProperties();this.j(Object.keys(p),p)}j(p,$){const c=this.g();for(const w of p){const P=c[w],a=$[w];P!==void 0?this.b.addValue(w,P):a?this.b.addValue(w,a.default):this.b.removeValue(w)}}}e.$Co=v;class m{constructor(){this.onDidChangeConfiguration=C.Event.None,this.configurationModel=k.$wo.createEmptyModel(new l.$ck)}async initialize(){return this.configurationModel}}e.$Do=m;let f=class extends E.$Vc{get configurationModel(){return this.b}constructor(p,$,c){super(),this.c=p,this.f=$,this.g=c,this.a=this.B(new C.$ee),this.onDidChangeConfiguration=this.a.event,this.b=k.$wo.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(p=>this.j(p))),this.B(this.c.onDidChangeConfiguration(async({properties:p})=>this.m(await this.h(p),!0))),this.b}async h(p){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",p);const $={},c=[],w=b.$bo.as(h.$go.Configuration).getConfigurationProperties();for(const P of p){const a=w[P];if(!a){c.push(P);continue}if(a.policy){if(a.type!=="string"&&a.type!=="number"){this.g.warn(`Policy ${a.policy.name} has unsupported type ${a.type}`);continue}c.push(P),$[a.policy.name]={type:a.type}}}return(0,j.$ig)($)||await this.f.updatePolicyDefinitions($),c}j(p){this.g.trace("PolicyConfiguration#onDidChangePolicies",p);const $=b.$bo.as(h.$go.Configuration).getPolicyConfigurations(),c=(0,n.$Hb)(p.map(w=>$.get(w)));this.m(c,!0)}m(p,$){this.g.trace("PolicyConfiguration#update",p);const c=b.$bo.as(h.$go.Configuration).getConfigurationProperties(),w=[],P=this.b.isEmpty();for(const a of p){const t=c[a]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(P?r!==void 0:!(0,R.$6n)(this.b.getValue(a),r))&&w.push([a,r])}else this.b.getValue(a)!==void 0&&w.push([a,void 0])}if(w.length){this.g.trace("PolicyConfiguration#changed",w);const a=this.b;this.b=k.$wo.createEmptyModel(this.g);for(const t of a.keys)this.b.setValue(t,a.getValue(t));for(const[t,r]of w)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);$&&this.a.fire(this.b)}}};e.$Eo=f,e.$Eo=f=Ee([ie(1,d.$do),ie(2,l.$2j)],f)}),define(re[242],oe([0,1,22,8,17,3,42,103,2,32,35,4,19,18,123,52,241,39]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=void 0;class c extends h.$Vc{constructor(a,t,r,s){super(),this.m=a,this.n=s,this.h=this.B(new R.$ee),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new p.$Co(s)),this.c=r instanceof $.$fo?new p.$Do:this.B(new p.$Eo(this.b,r,s)),this.f=this.B(new f.$yo(this.m,{},v.$Zg,t,s)),this.a=new f.$zo(this.b.configurationModel,this.c.configurationModel,f.$wo.createEmptyModel(s),f.$wo.createEmptyModel(s),f.$wo.createEmptyModel(s),f.$wo.createEmptyModel(s),new l.$Bc,f.$wo.createEmptyModel(s),new l.$Bc,s),this.j=new w(a,t,this),this.g=this.B(new C.$Hh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:i,properties:o})=>this.s(i,o))),this.B(this.c.onDidChangeConfiguration(i=>this.t(i))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[a,t,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$zo(a,t,f.$wo.createEmptyModel(this.n),r,f.$wo.createEmptyModel(this.n),f.$wo.createEmptyModel(this.n),new l.$Bc,f.$wo.createEmptyModel(this.n),new l.$Bc,this.n)}getConfigurationData(){return this.a.toData()}getValue(a,t){const r=typeof a=="string"?a:void 0,s=(0,m.$3i)(a)?a:(0,m.$3i)(t)?t:{};return this.a.getValue(r,s,void 0)}async updateValue(a,t,r,s,i){const o=(0,m.$4i)(r)?r:(0,m.$3i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,u=o?s:r;if(u!==void 0&&u!==3&&u!==2)throw new Error(`Unable to write ${a} to target ${u}.`);o?.overrideIdentifiers&&(o.overrideIdentifiers=(0,n.$Mb)(o.overrideIdentifiers),o.overrideIdentifiers=o.overrideIdentifiers.length?o.overrideIdentifiers:void 0);const g=this.inspect(a,{resource:o?.resource,overrideIdentifier:o?.overrideIdentifiers?o.overrideIdentifiers[0]:void 0});if(g.policyValue!==void 0)throw new Error(`Unable to write ${a} because it is configured in system policy.`);if((0,d.$6n)(t,g.defaultValue)&&(t=void 0),o?.overrideIdentifiers?.length&&o.overrideIdentifiers.length>1){const D=o.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(O=>(0,n.$ub)([...O.identifiers].sort(),D));I&&(o.overrideIdentifiers=I.identifiers)}const S=o?.overrideIdentifiers?.length?[(0,y.$so)(o.overrideIdentifiers),a]:[a];await this.j.write(S,t),await this.reloadConfiguration()}inspect(a,t={}){return this.a.inspect(a,t,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const a=await this.f.loadConfiguration();this.r(a)}r(a){const t=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(a);this.u(r,t,2)}s(a,t){const r=this.a.toData(),s=this.a.compareAndUpdateDefaultConfiguration(a,t);this.u(s,r,7)}t(a){const t=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(a);this.u(r,t,7)}u(a,t,r){const s=new f.$Bo(a,{data:t},this.a,void 0,this.n);s.source=r,this.h.fire(s)}}e.$Fo=c;class w{constructor(a,t,r){this.b=a,this.c=t,this.d=r,this.a=new C.$Ch}write(a,t){return this.a.queue(()=>this.e(a,t))}async e(a,t){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(o){if(o.fileOperationResult===1)r="{}";else throw o}const s=[];if((0,j.$In)(r,s,{allowTrailingComma:!0,allowEmptyContent:!0}),s.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const i=this.f(r,a,t);r=(0,k.$1n)(r,i),await this.c.writeFile(this.b,E.$Fe.fromString(r))}f(a,t,r){const{tabSize:s,insertSpaces:i,eol:o}=this.h;if(!t.length){const u=JSON.stringify(r,null,i?" ".repeat(s):"	");return[{content:u,length:u.length,offset:0}]}return(0,k.$Xn)(a,t,r,{tabSize:s,insertSpaces:i,eol:o})}get h(){if(!this.g){let a=b.OS===3||b.OS===2?`
`:`\r
`;const t=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});t&&typeof t=="string"&&t!=="auto"&&(a=t),this.g={eol:a,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(re[243],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fdc=e.$edc=e.$ddc=void 0,e.$ddc="request",e.$edc="remoteResourceHandler";class n{async routeCall(E,R,j){if(R!==e.$ddc)throw new Error(`Call not found: ${R}`);const k=j[0];if(k?.authority){const h=E.connections.find(l=>l.ctx===k.authority);if(h)return h}throw new Error("Caller not found")}routeEvent(E,R){throw new Error(`Event not found: ${R}`)}}e.$fdc=n}),define(re[244],oe([0,1,15,6]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.RemoteAuthorityResolverErrorCode=e.$Il=e.$Hl=e.RemoteConnectionType=e.$Gl=void 0,e.$Kl=l,e.$Gl=(0,C.$vi)("remoteAuthorityResolverService");var E;(function(d){d[d.WebSocket=0]="WebSocket",d[d.Managed=1]="Managed"})(E||(e.RemoteConnectionType=E={}));class R{constructor(b){this.id=b,this.type=1}toString(){return`Managed(${this.id})`}}e.$Hl=R;class j{constructor(b,v){this.host=b,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Il=j;var k;(function(d){d.Unknown="Unknown",d.NotAvailable="NotAvailable",d.TemporarilyNotAvailable="TemporarilyNotAvailable",d.NoResolverFound="NoResolverFound",d.InvalidAuthority="InvalidAuthority"})(k||(e.RemoteAuthorityResolverErrorCode=k={}));class h extends n.$bb{static isNotAvailable(b){return b instanceof h&&b._code===k.NotAvailable}static isTemporarilyNotAvailable(b){return b instanceof h&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof h&&b._code===k.NoResolverFound}static isInvalidAuthority(b){return b instanceof h&&b._code===k.InvalidAuthority}static isHandled(b){return b instanceof h&&b.isHandled}constructor(b,v=k.Unknown,m){super(b),this._message=b,this._code=v,this._detail=m,this.isHandled=v===k.NotAvailable&&m===!0,Object.setPrototypeOf(this,h.prototype)}}e.$Jl=h;function l(d){const b=d.indexOf("+");return b===-1?d:d.substring(0,b)}}),define(re[245],oe([0,1,8,17,23,15,3,2,13,66,73,33,113,244]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zl=e.$Yl=e.$Xl=e.$Wl=e.$Vl=e.$Ul=e.$Tl=e.$Sl=e.PersistentConnectionEventType=e.ConnectionType=void 0,e.$Pl=S,e.$Ql=D,e.$Rl=O;const f=30*1e3;var y;(function(Y){Y[Y.Management=1]="Management",Y[Y.ExtensionHost=2]="ExtensionHost",Y[Y.Tunnel=3]="Tunnel"})(y||(e.ConnectionType=y={}));function p(Y){switch(Y){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(Y){const A=new E.$pe;return setTimeout(()=>A.cancel(),Y),A.token}function c(Y,A){if(Y.isCancellationRequested||A.isCancellationRequested)return E.CancellationToken.Cancelled;const N=new E.$pe;return Y.onCancellationRequested(()=>N.cancel()),A.onCancellationRequested(()=>N.cancel()),N.token}class w{get didTimeout(){return this.c==="timedout"}constructor(A){this.c="pending",this.d=new k.$Uc,{promise:this.promise,resolve:this.f,reject:this.g}=(0,n.$oh)(),A.isCancellationRequested?this.h():this.d.add(A.onCancellationRequested(()=>this.h()))}registerDisposable(A){this.c==="pending"?this.d.add(A):A.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const A=new Error("Time limit reached");return A.code="ETIMEDOUT",A.syscall="connect",A}resolve(A){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(A))}reject(A){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(A))}}function P(Y,A){const N=new w(A);return N.registerDisposable(Y.onControlMessage(_=>{const ne=JSON.parse(_.toString()),J=L(ne);J?N.reject(J):N.resolve(ne)})),N.promise}function a(Y,A,N,_,ne,J,V,x){const H=new w(x),se=d.$ae.create(!1);return Y.info(`Creating a socket (${V})...`),l.mark(`code/willCreateSocket/${J}`),A.connect(N,_,ne,V).then(he=>{H.didTimeout?(l.mark(`code/didCreateSocketError/${J}`),Y.info(`Creating a socket (${V}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),he?.dispose()):(l.mark(`code/didCreateSocketOK/${J}`),Y.info(`Creating a socket (${V}) was successful after ${se.elapsed()} ms.`),H.resolve(he))},he=>{l.mark(`code/didCreateSocketError/${J}`),Y.info(`Creating a socket (${V}) returned an error after ${se.elapsed()} ms.`),Y.error(he),H.reject(he)}),H.promise}function t(Y,A){const N=new w(A);return Y.then(_=>{N.didTimeout||N.resolve(_)},_=>{N.didTimeout||N.reject(_)}),N.promise}async function r(Y,A,N,_){const ne=G(Y,A);Y.logService.trace(`${ne} 1/6. invoking socketFactory.connect().`);let J;try{J=await a(Y.logService,Y.remoteSocketFactoryService,Y.connectTo,h.$Ig.getServerRootPath(),`reconnectionToken=${Y.reconnectionToken}&reconnection=${Y.reconnectionProtocol?"true":"false"}`,p(A),`renderer-${p(A)}-${Y.reconnectionToken}`,_)}catch(he){throw Y.logService.error(`${ne} socketFactory.connect() failed or timed out. Error:`),Y.logService.error(he),he}Y.logService.trace(`${ne} 2/6. socketFactory.connect() was successful.`);let V,x;Y.reconnectionProtocol?(Y.reconnectionProtocol.beginAcceptReconnection(J,null),V=Y.reconnectionProtocol,x=!1):(V=new v.$ji({socket:J}),x=!0),Y.logService.trace(`${ne} 3/6. sending AuthRequest control message.`);const H=await t(Y.signService.createNewMessage((0,b.$Rg)()),_),se={type:"auth",auth:Y.connectionToken||"00000000000000000000",data:H.data};V.sendControl(C.$Fe.fromString(JSON.stringify(se)));try{const he=await P(V,c(_,$(1e4)));if(he.type!=="sign"||typeof he.data!="string"){const Pe=new Error("Unexpected handshake message");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}if(Y.logService.trace(`${ne} 4/6. received SignRequest control message.`),!await t(Y.signService.validate(H,he.signedData),_)){const Pe=new Error("Refused to connect to unsupported server");throw Pe.code="VSCODE_CONNECTION_ERROR",Pe}const $e=await t(Y.signService.sign(he.data),_),ye={type:"connectionType",commit:Y.commit,signedData:$e,desiredConnectionType:A};return N&&(ye.args=N),Y.logService.trace(`${ne} 5/6. sending ConnectionTypeRequest control message.`),V.sendControl(C.$Fe.fromString(JSON.stringify(ye))),{protocol:V,ownsProtocol:x}}catch(he){throw he&&he.code==="ETIMEDOUT"&&(Y.logService.error(`${ne} the handshake timed out. Error:`),Y.logService.error(he)),he&&he.code==="VSCODE_CONNECTION_ERROR"&&(Y.logService.error(`${ne} received error control message when negotiating connection. Error:`),Y.logService.error(he)),x&&B(V),he}}async function s(Y,A,N,_){const ne=Date.now(),J=G(Y,A),{protocol:V,ownsProtocol:x}=await r(Y,A,N,_),H=new w(_);return H.registerDisposable(V.onControlMessage(se=>{const he=JSON.parse(se.toString()),me=L(he);me?(Y.logService.error(`${J} received error control message when negotiating connection. Error:`),Y.logService.error(me),x&&B(V),H.reject(me)):(Y.reconnectionProtocol?.endAcceptReconnection(),Y.logService.trace(`${J} 6/6. handshake finished, connection is up and running after ${le(ne)}!`),H.resolve({protocol:V,firstMessage:he}))})),H.promise}async function i(Y,A){const{protocol:N}=await s(Y,1,void 0,A);return{protocol:N}}async function o(Y,A,N){const{protocol:_,firstMessage:ne}=await s(Y,2,A,N),J=ne&&ne.debugPort;return{protocol:_,debugPort:J}}async function u(Y,A,N){const _=Date.now(),ne=G(Y,3),{protocol:J}=await r(Y,3,A,N);return Y.logService.trace(`${ne} 6/6. handshake finished, connection is up and running after ${le(_)}!`),J}async function g(Y,A,N){const{connectTo:_,connectionToken:ne}=await Y.addressProvider.getAddress();return{commit:Y.commit,quality:Y.quality,connectTo:_,connectionToken:ne,reconnectionToken:A,reconnectionProtocol:N,remoteSocketFactoryService:Y.remoteSocketFactoryService,signService:Y.signService,logService:Y.logService}}async function S(Y,A,N){return I(Y,async _=>{const{protocol:ne}=await i(_,E.CancellationToken.None);return new K(Y,A,N,_.reconnectionToken,ne)})}async function D(Y,A){return I(Y,async N=>{const{protocol:_,debugPort:ne}=await o(N,A,E.CancellationToken.None);return new Q(Y,A,N.reconnectionToken,_,ne)})}async function I(Y,A){for(let _=1;;_++)try{const ne=(0,b.$Rg)(),J=await g(Y,ne,null);return await A(J)}catch(ne){if(_<5)Y.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),Y.logService.error(ne);else throw Y.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),Y.logService.error(ne),ce.triggerPermanentFailure(0,0,m.$Jl.isHandled(ne)),ne}}async function O(Y,A,N){const _=await g(Y,(0,b.$Rg)(),null);return await u(_,{host:A,port:N},E.CancellationToken.None)}function M(Y){return(0,n.$ih)(A=>new Promise((N,_)=>{const ne=setTimeout(N,Y*1e3);A.onCancellationRequested(()=>{clearTimeout(ne),N()})}))}var W;(function(Y){Y[Y.ConnectionLost=0]="ConnectionLost",Y[Y.ReconnectionWait=1]="ReconnectionWait",Y[Y.ReconnectionRunning=2]="ReconnectionRunning",Y[Y.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",Y[Y.ConnectionGain=4]="ConnectionGain"})(W||(e.PersistentConnectionEventType=W={}));class F{constructor(A,N){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.type=0}}e.$Sl=F;class T{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.durationSeconds=_,this.c=ne,this.type=1}skipWait(){this.c.cancel()}}e.$Tl=T;class q{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=2}}e.$Ul=q;class ue{constructor(A,N,_){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.type=4}}e.$Vl=ue;class ee{constructor(A,N,_,ne){this.reconnectionToken=A,this.millisSinceLastIncomingData=N,this.attempt=_,this.handled=ne,this.type=3}}e.$Wl=ee;class ce extends k.$Vc{static triggerPermanentFailure(A,N,_){this._permanentFailure=!0,this.f=A,this.g=N,this.h=_,this.j.forEach(ne=>ne.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(A=>A.y())}static debugPauseSocketWriting(){this.j.forEach(A=>A.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ce._permanentFailure}constructor(A,N,_,ne,J){super(),this.t=A,this.u=N,this.reconnectionToken=_,this.protocol=ne,this.w=J,this.m=this.B(new j.$ee),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ue(this.reconnectionToken,0,0)),this.B(ne.onSocketClose(V=>{const x=ae(this.t,this.reconnectionToken,!0);V?V.type===0?(this.u.logService.info(`${x} received socket close event (hadError: ${V.hadError}).`),V.error&&this.u.logService.error(V.error)):(this.u.logService.info(`${x} received socket close event (wasClean: ${V.wasClean}, code: ${V.code}, reason: ${V.reason}).`),V.event&&this.u.logService.error(V.event)):this.u.logService.info(`${x} received socket close event.`),this.y()})),this.B(ne.onSocketTimeout(V=>{const x=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${x} received socket timeout event (unacknowledgedMsgCount: ${V.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${V.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${V.timeSinceLastReceivedSomeData}).`),this.y()})),ce.j.push(this),this.B((0,k.$Tc)(()=>{const V=ce.j.indexOf(this);V>=0&&ce.j.splice(V,1)})),this.n&&this.D(ce.f,ce.g,ce.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const A=ae(this.t,this.reconnectionToken,!0);this.u.logService.info(`${A} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const ne=_<N.length?N[_]:N[N.length-1];try{if(ne>0){const V=M(ne);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ne,V)),this.u.logService.info(`${A} waiting for ${ne} seconds before reconnecting...`);try{await V}catch{}}if(this.n){this.u.logService.error(`${A} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new q(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${A} resolving connection...`);const J=await g(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${A} connecting to ${J.connectTo}...`),await this.G(J,$(f)),this.u.logService.info(`${A} reconnected!`),this.m.fire(new ue(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(J){if(J.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${A} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${A} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(m.$Jl.isTemporarilyNotAvailable(J)){this.u.logService.info(`${A} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((J.code==="ETIMEDOUT"||J.code==="ENETUNREACH"||J.code==="ECONNREFUSED"||J.code==="ECONNRESET")&&J.syscall==="connect"){this.u.logService.info(`${A} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if((0,R.$4)(J)){this.u.logService.info(`${A} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(J);continue}if(J instanceof m.$Jl){this.u.logService.error(`${A} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,m.$Jl.isHandled(J));break}this.u.logService.error(`${A} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(J),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(A,N,_){this.w?ce.triggerPermanentFailure(A,N,_):this.D(A,N,_)}D(A,N,_){this.m.fire(new ee(this.reconnectionToken,A,N,_)),B(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$Xl=ce;class K extends ce{constructor(A,N,_,ne,J){super(1,A,ne,J,!0),this.client=this.B(new v.$hi(J,{remoteAuthority:N,clientId:_},A.ipcLogger))}async G(A,N){await i(A,N)}}e.$Yl=K;class Q extends ce{constructor(A,N,_,ne,J){super(2,A,_,ne,!1),this.H=N,this.debugPort=J}async G(A,N){await o(A,this.H,N)}}e.$Zl=Q;function B(Y){try{Y.acceptDisconnect();const A=Y.getSocket();Y.dispose(),A.dispose()}catch(A){(0,R.$1)(A)}}function L(Y){if(Y&&Y.type==="error"){const A=new Error(`Connection error: ${Y.reason}`);return A.code="VSCODE_CONNECTION_ERROR",A}return null}function z(Y,A){for(;Y.length<A;)Y+=" ";return Y}function U(Y,A){return`[remote-connection][${z(p(Y),13)}][${A.substr(0,5)}\u2026]`}function ae(Y,A,N){return`${U(Y,A)}[${N?"reconnect":"initial"}]`}function G(Y,A){return`${ae(A,Y.reconnectionToken,!!Y.reconnectionProtocol)}[${Y.connectTo}]`}function le(Y){return`${Date.now()-Y} ms`}}),define(re[68],oe([0,1,13]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=C,e.$Hm=E,e.$Im=R,e.$Jm=j;function C(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}function E(h){if(!h)return;const l=h.indexOf("+");return l<0?h:h.substr(0,l)}function R(h){const{host:l,port:d}=k(h);if(typeof d>"u")throw new Error(`Invalid remote authority: ${h}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:l,port:d}}function j(h,l){let{host:d,port:b}=k(h);return typeof b>"u"&&(b=l),{host:d,port:b}}function k(h){const l=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(l)return{host:l[1],port:parseInt(l[2],10)};const d=h.match(/^(\[[0-9a-z:]+\])$/);if(d)return{host:d[1],port:void 0};const b=h.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:h,port:void 0}}}),define(re[124],oe([0,1,25,6,68]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Sm=e.$Rm=e.$Qm=e.TargetPlatform=e.ExtensionType=e.$Pm=e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Om=R,e.$Tm=b,e.$Um=v,e.$Vm=m,e.$Wm=f,e.$Km="extensions.user.cache",e.$Lm="extensions.builtin.cache",e.$Mm="undefined_publisher",e.$Nm=["ui","workspace","web"];function R(y){if(typeof y=="object"&&y!==null&&y.supported!==!0)return y.description}e.$Pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var j;(function(y){y[y.System=0]="System",y[y.User=1]="User"})(j||(e.ExtensionType=j={}));var k;(function(y){y.WIN32_X64="win32-x64",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class h{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,$){if(typeof p>"u"||p===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof p=="string"||typeof $=="string"){const c=typeof p=="string"?p:p.value,w=typeof $=="string"?$:$.value;return n.$xf(c,w)}return p._lower===$._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}e.$Qm=h;class l{get size(){return this.c.size}constructor(p){if(this.c=new Set,p)for(const $ of p)this.add($)}add(p){this.c.add(h.toKey(p))}delete(p){return this.c.delete(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}}e.$Rm=l;class d{constructor(){this.c=new Map}clear(){this.c.clear()}delete(p){this.c.delete(h.toKey(p))}get(p){return this.c.get(h.toKey(p))}has(p){return this.c.has(h.toKey(p))}set(p,$){this.c.set(h.toKey(p),$)}values(){return this.c.values()}forEach(p){this.c.forEach(p)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Sm=d;function b(y){return v(y)}function v(y){return y.contributes&&y.contributes.localizations?y.contributes.localizations.length>0:!1}function m(y){return y.contributes&&y.contributes.authentication?y.contributes.authentication.length>0:!1}function f(y,p){if(p){const $=`onResolveRemoteAuthority:${(0,E.$Hm)(p)}`;return!!y.activationEvents?.includes($)}return!1}e.$Xm=(0,C.$vi)("IBuiltinExtensionsScannerService")}),define(re[246],oe([0,1,2,6]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.$Ll=void 0,e.$Ll=(0,C.$vi)("remoteSocketFactoryService");class E{constructor(){this.a={}}register(j,k){return this.a[j]??=[],this.a[j].push(k),(0,n.$Tc)(()=>{const h=this.a[j]?.indexOf(k);typeof h=="number"&&h>=0&&this.a[j]?.splice(h,1)})}b(j){return(this.a[j.type]||[]).find(h=>h.supports(j))}connect(j,k,h,l){const d=this.b(j);if(!d)throw new Error(`No socket factory found for ${j}`);return d.connect(j,k,h,l)}}e.$Ml=E}),define(re[247],oe([0,1,26,49,21,117]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fcc=k;let j;async function k(m=!1){return(j===void 0||m)&&(j=h()),j}async function h(){const m=l();if(m===void 0)return!1;if(m>=22e3){const f=b();if(f)return new Promise(y=>{C.execFile(f,["--status"],p=>y(!p))})}else{const f=v();if(f)try{if((await E.Promises.stat(f)).isFile())return!0}catch{}}return!1}function l(){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());if(m)return parseInt(m[3])}function d(m){const f=process.env.SystemRoot;if(f){const y=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return R.join(f,y?"Sysnative":"System32",m)}}function b(){return d("wsl.exe")}function v(){return d("lxss\\LxssManager.dll")}}),define(re[53],oe([0,1,17,15,2,186,52,6,5,45]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Np=e.$Mp=void 0,e.$Op=v,e.$Pp=m,e.$Qp=f,e.$Rp=y,e.$Sp=p,e.$Tp=$,e.$Mp=(0,k.$vi)("requestService");class d{constructor(a){this.b=a}toJSON(){if(!this.a){const a=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?a[t]="*****":a[t]=this.b[t];this.a=a}return this.a}}class b extends E.$Vc{constructor(a){super(),this.b=0,this.a=a.createLogger("network",{name:(0,R.localize)(0,null),when:h.$hk.isEqualTo((0,h.$ek)(h.LogLevel.Trace)).serialize()})}async c(a,t,r){const s=`${a} #${++this.b}: ${t.url}`;this.a.trace(`${s} - begin`,t.type,new d(t.headers??{}));try{const i=await r();return this.a.trace(`${s} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${s} - error`,t.type,(0,C.$0)(i)),i}}}e.$Np=b;function v(P){return P.res.statusCode&&P.res.statusCode>=200&&P.res.statusCode<300||P.res.statusCode===1223}function m(P){return P.res.statusCode===204}async function f(P){return m(P)?null:(await(0,n.$Re)(P.stream)).toString()}async function y(P){if(!v(P))throw new Error("Server returned "+P.res.statusCode);return f(P)}async function p(P){if(!v(P))throw new Error("Server returned "+P.res.statusCode);if(m(P))return null;const t=(await(0,n.$Re)(P.stream)).toString();try{return JSON.parse(t)}catch(r){throw r.message+=`:
`+t,r}}function $(P){w(P)}let c;function w(P){const a=l.$bo.as(j.$go.Configuration),t=c;c={id:"http",order:15,title:(0,R.localize)(1,null),type:"object",scope:P,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,R.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,R.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,R.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,R.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,R.localize)(6,null),(0,R.localize)(7,null),(0,R.localize)(8,null),(0,R.localize)(9,null)],default:"override",description:(0,R.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,R.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,R.localize)(12,null),restricted:!0}}},a.updateConfigurations({add:[c],remove:t?[t]:[]})}w(1)}),define(re[248],oe([0,1,17,23]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ur=e.$Tr=void 0;class E{constructor(k){this.a=k}listen(k,h){throw new Error("Invalid listen")}call(k,h,l,d=C.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],d).then(async({res:b,stream:v})=>{const m=await(0,n.$Re)(v);return[{statusCode:b.statusCode,headers:b.headers},m]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$Tr=E;class R{constructor(k){this.a=k}async request(k,h){const[l,d]=await this.a.call("request",[k],h);return{res:l,stream:(0,n.$Te)(d)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$Ur=R}),define(re[249],oe([0,1,250,12]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=R;function E(j,k){return j.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:j.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function R(j,k,h={}){const l=(0,n.parse)(j),d=h.proxyUrl||E(l,k);if(!d)return null;const b=(0,n.parse)(d);if(!/^https?:$/.test(b.protocol||""))return null;const v={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,C.$bg)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((m,f)=>{X(["http-proxy-agent"],m,f)})).HttpProxyAgent(d,v):new(await new Promise((m,f)=>{X(["https-proxy-agent"],m,f)})).HttpsProxyAgent(d,v)}}),define(re[251],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bcc=e.$Acc=e.$zcc=void 0,e.$zcc={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$Acc={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$Bcc={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(re[95],oe([0,1,49,9,187,23,47,15,4,33,112,64,8,141]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fm=y;let f;async function y($,c,w,P){return w["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.$i?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$zm)(P)&&!w["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$zm)(P)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(a,t)=>{const r=new R.$pe;let s=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(s=(0,m.$Am)(i,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,E.localize)(0,null)))},s);try{a(await p(c,r.token))}catch(u){!(0,k.$4)(u)&&!r.token.isCancellationRequested?t(new Error((0,E.localize)(1,null,(0,j.$gj)(u)))):a({})}finally{clearTimeout(o),r.dispose()}})),f)}async function p($,c){const w=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",w);const P=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",P);const a=(0,l.$Rg)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"({.*})"+a),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",r);const s=await(0,d.$pm)(h.OS,r);return $.trace("getUnixShellEnvironment#shell",s),new Promise((i,o)=>{if(c.isCancellationRequested)return o(new k.$5);const u=(0,C.$oc)(s);let g,S;const D="";/^pwsh(-preview)?$/.test(u)?(g=`& '${process.execPath}' ${D} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,S=["-Login","-Command"]):u==="nu"?(g=`^'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,S=["-i","-l","-c"]):u==="xonsh"?(g=`import os, json; print("${a}", json.dumps(dict(os.environ)), "${a}")`,S=["-i","-l","-c"]):(g=`'${process.execPath}' ${D} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,u==="tcsh"||u==="csh"?S=["-ic"]:S=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),g);const I=(0,n.spawn)(s,[...S,g],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});c.onCancellationRequested(()=>(I.kill(),o(new k.$5))),I.on("error",W=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,j.$gj)(W)),o(W)});const O=[];I.stdout.on("data",W=>O.push(W));const M=[];I.stderr.on("data",W=>M.push(W)),I.on("close",(W,F)=>{const T=Buffer.concat(O).toString("utf8");$.trace("getUnixShellEnvironment#raw",T);const q=Buffer.concat(M).toString("utf8");if(q.trim()&&$.trace("getUnixShellEnvironment#stderr",q),W||F)return o(new Error((0,E.localize)(2,null,W,F)));const ue=t.exec(T),ee=ue?ue[1]:"{}";try{const ce=JSON.parse(ee);w?ce.ELECTRON_RUN_AS_NODE=w:delete ce.ELECTRON_RUN_AS_NODE,P?ce.ELECTRON_NO_ATTACH_CONSOLE=P:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ce),i(ce)}catch(ce){$.error("getUnixShellEnvironment#errorCaught",(0,j.$gj)(ce)),o(ce)}})})}}),define(re[252],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t$b=void 0;class n{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(E){try{const R=await this.c();if(R){const j=String(n.a++);return this.b.set(j,R),{id:j,data:R.createNewMessage(E)}}}catch{}return{id:"",data:E}}async validate(E,R){if(!E.id)return!0;const j=this.b.get(E.id);if(!j)return!1;this.b.delete(E.id);try{return j.validate(R)==="ok"}catch{return!1}finally{j.dispose?.()}}async sign(E){try{return await this.d(E)}catch{}return E}}e.$t$b=n}),define(re[96],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ol=e.$Nl=void 0,e.$Nl="signService",e.$Ol=(0,n.$vi)(e.$Nl)}),define(re[253],oe([0,1,252]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pdc=void 0;class C extends n.$t$b{c(){return this.h().then(R=>new R.validator)}d(R){return this.h().then(j=>new j.signer().sign(R))}h(){return new Promise((R,j)=>X(["vsda"],R,j))}}e.$pdc=C}),define(re[34],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BQ=e.$AQ=void 0,e.$AQ=(0,n.$vi)("stateReadService"),e.$BQ=(0,n.$vi)("stateService")}),define(re[125],oe([0,1,8,17,2,12,38,16,5]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EQ=e.$DQ=e.$CQ=e.SaveStrategy=void 0;var l;(function(m){m[m.IMMEDIATE=0]="IMMEDIATE",m[m.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class d extends E.$Vc{constructor(f,y,p,$){super(),this.h=f,this.j=y,this.m=p,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new n.$th(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.m.error(f)}}getItem(f,y){const p=this.a[f];return(0,R.$eg)(p)?y:p}setItem(f,y){this.setItems([{key:f,data:y}])}setItems(f){let y=!1;for(const{key:p,data:$}of f)this.a[p]!==$&&((0,R.$eg)($)?(0,R.$cg)(this.a[p])||(this.a[p]=void 0,y=!0):(this.a[p]=$,y=!0));y&&this.s()}removeItem(f){(0,R.$cg)(this.a[f])||(this.a[f]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.n.writeFile(this.h,C.$Fe.fromString(f),{atomic:{postfix:".vsctmp"}}),this.b=f}catch(y){this.m.error(y)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$CQ=d;let b=class extends E.$Vc{constructor(f,y,p,$){super(),this.a=this.B(new d(y.stateResource,f,p,$))}async init(){await this.a.init()}getItem(f,y){return this.a.getItem(f,y)}};e.$DQ=b,e.$DQ=b=Ee([ie(1,j.$Ci),ie(2,h.$2j),ie(3,k.$2k)],b);class v extends b{setItem(f,y){this.a.setItem(f,y)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.$EQ=v}),define(re[126],oe([0,1,4,36,33]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=j,e.$dp=k;function R(h){if(n.$u===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function j(h,l,d,b,v,m,f,y,p){const $=Object.create(null);$["common.machineId"]=m,$["common.sqmId"]=f,$.sessionID=(0,E.$Rg)()+Date.now(),$.commitHash=b,$.version=v,$["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,n.$h)(n.$u),$["common.nodePlatform"]=C.$ec,$["common.nodeArch"]=d,$["common.product"]=p||"desktop",y&&($["common.msftInternal"]=y);let c=0;const w=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-w,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),n.$l&&($["common.snap"]="true");const P=R(l);return P&&($["common.platformDetail"]=P),$}function k(h){const l=C.env.USERDNSDOMAIN;if(!l)return!1;const d=l.toLowerCase();return h.some(b=>d===b)}}),define(re[28],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l=(0,n.$vi)("telemetryService"),e.$2l=(0,n.$vi)("customEndpointTelemetryService"),e.$3l="telemetry.currentSessionDate",e.$4l="telemetry.firstSessionDate",e.$5l="telemetry.lastSessionDate",e.$6l="telemetry.machineId",e.$7l="telemetry.sqmId",e.$8l="telemetry",e.$9l="telemetry.telemetryLevel",e.$0l="telemetry.enableCrashReporter",e.$$l="telemetry.enableTelemetry";var C;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(C||(e.TelemetryLevel=C={}));var E;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(E||(e.TelemetryConfiguration=E={}))}),define(re[254],oe([0,1,26,8,42,13,9,4,7,89,21,111,92,16,27,28]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gs=void 0,e.$Ds=$,e.$Es=w,e.$Fs=P;const p=new Map;async function $(t,r){const s=`${t}::${r.join(":")}`,i=p.get(s);if(i)return i;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,g=new Map,S=2e4;function D(O,M,W,F){const T=M.substring(O.length+1);return C.Promises.withAsyncBody(async q=>{let ue;try{ue=await d.Promises.readdir(M,{withFileTypes:!0})}catch{q();return}if(F.count>=S){F.count+=ue.length,F.maxReached=!0,q();return}let ee=ue.length;if(ee===0){q();return}let ce=ue;F.count+ue.length>S&&(F.maxReached=!0,ee=S-F.count,ce=ue.slice(0,ee)),F.count+=ue.length;for(const K of ce)if(K.isDirectory()){if(W.includes(K.name)||await D(O,(0,j.$kc)(M,K.name),W,F),--ee===0){q();return}}else{const Q=K.name.lastIndexOf(".");if(Q>=0){const B=K.name.substring(Q+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(T)!==!1&&B.filePattern.test(K.name)&&g.set(B.tag,(g.get(B.tag)??0)+1);if(--ee===0){q();return}}})}const I=C.Promises.withAsyncBody(async O=>{const M={count:0,maxReached:!1};await D(t,t,r,M);const W=await P(t);O({configFiles:c(g),fileTypes:c(u),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:W})});return p.set(s,I),I}function c(t){return Array.from(t.entries(),([r,s])=>({name:r,count:s})).sort((r,s)=>s.count-r.count)}function w(){const t={os:`${n.type()} ${n.arch()} ${n.release()}`,memory:`${(n.totalmem()/m.$xl.GB).toFixed(2)}GB (${(n.freemem()/m.$xl.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$Dn.value()*100)}%`},r=n.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}async function P(t){try{const r=new Map,s=(0,j.$kc)(t,".vscode","launch.json"),i=await d.Promises.readFile(s),o=[],u=(0,E.$In)(i.toString(),o);if(o.length)return console.log(`Unable to parse ${s}`),[];if((0,E.$Rn)(u)==="object"&&u.configurations)for(const g of u.configurations){const S=g.type;S&&(r.has(S)?r.set(S,r.get(S)+1):r.set(S,1))}return c(r)}catch{return[]}}let a=class{constructor(r,s){this.c=r,this.d=s}f(r){const s=[];return s.push(`OS Version:       ${r.os}`),s.push(`CPUs:             ${r.cpus}`),s.push(`Memory (System):  ${r.memory}`),s.push(`VM:               ${r.vmHint}`),s.join(`
`)}g(r){const s=[];s.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),s.push(`OS Version:       ${n.type()} ${n.arch()} ${n.release()}`);const i=n.cpus();return i&&i.length>0&&s.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),s.push(`Memory (System):  ${(n.totalmem()/m.$xl.GB).toFixed(2)}GB (${(n.freemem()/m.$xl.GB).toFixed(2)}GB free)`),k.$i||s.push(`Load (avg):       ${n.loadavg().map(o=>Math.round(o)).join(", ")}`),s.push(`VM:               ${Math.round(l.$Dn.value()*100)}%`),s.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${r.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(r,s){return Promise.all([(0,b.$Cs)(r.mainPID),this.k(r)]).then(async i=>{let[o,u]=i,g=this.m(r,o);return s.forEach(S=>{if((0,v.$dn)(S))g+=`
${S.errorMessage}`,u+=`
${S.errorMessage}`;else if(g+=`

Remote: ${S.hostName}`,S.processes&&(g+=`
${this.m(r,S.processes)}`),S.workspaceMetadata){u+=`
|  Remote: ${S.hostName}`;for(const D of Object.keys(S.workspaceMetadata)){const I=S.workspaceMetadata[D];let O=`${I.fileCount} files`;I.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${D}): ${O}`,u+=this.h(I)}}}),{processInfo:g,workspaceInfo:u}})}async getSystemInfo(r,s){const{memory:i,vmHint:o,os:u,cpus:g}=w(),S={os:u,memory:i,cpus:g,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:s};return k.$i||(S.load=`${n.loadavg().map(D=>Math.round(D)).join(", ")}`),k.$k&&(S.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(S)}async getDiagnostics(r,s){const i=[];return(0,b.$Cs)(r.mainPID).then(async o=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,o)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),s.forEach(u=>{if((0,v.$dn)(u))i.push(`
${u.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${u.hostName}`),i.push(this.f(u.machineInfo)),u.processes&&i.push(this.m(r,u.processes)),u.workspaceMetadata)for(const g of Object.keys(u.workspaceMetadata)){const S=u.workspaceMetadata[g];let D=`${S.fileCount} files`;S.maxFilesReached&&(D=`more than ${D}`),i.push(`Folder (${g}): ${D}`),i.push(this.h(S))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const s=[];let o=0;const u=(I,O)=>{const M=` ${I}(${O})`;o+M.length>60?(s.push(g),g="|                 ",o=g.length):o+=M.length,g+=M};let g="|      File types:";const S=10,D=r.fileTypes.length>S?S:r.fileTypes.length;for(let I=0;I<D;I++){const O=r.fileTypes[I];u(O.name,O.count)}if(s.push(g),r.configFiles.length>=0&&(g="|      Conf files:",o=0,r.configFiles.forEach(I=>{u(I.name,I.count)}),s.push(g)),r.launchConfigFiles.length>0){let I="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{const M=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`;I+=M}),s.push(I)}return s.join(`
`)}j(r){const s=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(s-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const s=[],i=[];return r.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(s.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const g=h.URI.revive(u);if(g.scheme===R.Schemas.file){const S=g.fsPath;i.push($(S,["node_modules",".git"]).then(D=>{let I=`${D.fileCount} files`;D.maxFilesReached&&(I=`more than ${I}`),s.push(`|    Folder (${(0,j.$oc)(S)}): ${I}`),s.push(this.h(D))}).catch(D=>{s.push(`|      Error: Unable to collect workspace stats for folder ${S} (${D.toString()})`)}))}else s.push(`|    Folder (${g.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(o=>s.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,s){const i=new Map;r.windows.forEach(u=>i.set(u.pid,`window [${u.id}] (${u.title})`)),r.pidToNames.forEach(({pid:u,name:g})=>i.set(u,g));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),s&&this.n(r.mainPID,i,o,s,0),o.join(`
`)}n(r,s,i,o,u){const g=u===0;let S;g?S=o.pid===r?`${this.d.applicationName} main`:"remote agent":s.has(o.pid)?S=s.get(o.pid):S=`${"  ".repeat(u)} ${o.name}`;const D=process.platform==="win32"?o.mem:n.totalmem()*(o.mem/100);i.push(`${o.load.toFixed(0).padStart(5," ")}	${(D/m.$xl.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${S}`),Array.isArray(o.children)&&o.children.forEach(I=>this.n(r,s,i,I,u+1))}async getWorkspaceFileExtensions(r){const s=new Set;for(const{uri:i}of r.folders){const o=h.URI.revive(i);if(o.scheme!==R.Schemas.file)continue;const u=o.fsPath;try{(await $(u,["node_modules",".git"])).fileTypes.forEach(S=>s.add(S.name))}catch{}}return{extensions:[...s]}}async reportWorkspaceStats(r){for(const{uri:s}of r.folders){const i=h.URI.revive(s);if(i.scheme!==R.Schemas.file)continue;const o=i.fsPath;try{const u=await $(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(g=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})}),u.launchConfigFiles.forEach(g=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})}),u.configFiles.forEach(g=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:g.name,count:g.count})})}catch{}}}};e.$Gs=a,e.$Gs=a=Ee([ie(0,y.$1l),ie(1,f.$ik)],a)}),define(re[255],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fcc=e.$Ecc=void 0;class n{constructor(R){this.b=R}listen(R,j){throw new Error(`Event not found: ${j}`)}call(R,j,{eventName:k,data:h}){return this.b.forEach(l=>l.log(k,h)),Promise.resolve(null)}}e.$Ecc=n;class C{constructor(R){this.b=R}log(R,j){return this.b.call("log",{eventName:R,data:j}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$Fcc=C}),define(re[54],oe([0,1,35,12,68,126,28]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=d,e.$mp=b,e.$np=v,e.$op=m,e.$pp=y,e.$qp=$,e.$rp=c,e.$sp=a;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$ep=k;class h{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$fp=h,e.$gp=new h;class l{async publicLog(r,s,i){}async publicLogError(r,s,i){}}e.$hp=l,e.$ip="telemetry",e.$jp="extensionTelemetryLog",e.$kp={log:()=>null,flush:()=>Promise.resolve(null)};function d(t,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!t.enableTelemetry)}function b(t,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}function v(t){const r=t.getValue(j.$9l),s=t.getValue(j.$0l);if(t.getValue(j.$$l)===!1||s===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function m(t){const r={},s={},i={};p(t,i);for(let o in i){o=o.length>150?o.substr(o.length-149):o;const u=i[o];typeof u=="number"?s[o]=u:typeof u=="boolean"?s[o]=u?1:0:typeof u=="string"?(u.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${u.length}`),r[o]=u.substring(0,8191)):typeof u<"u"&&u!==null&&(r[o]=u)}return{properties:r,measurements:s}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function y(t){if(!t)return"none";const r=(0,E.$Hm)(t);return f.has(r)?r:"other"}function p(t,r,s=0,i){if(t)for(const o of Object.getOwnPropertyNames(t)){const u=t[o],g=i?i+o:o;Array.isArray(u)?r[g]=(0,n.$7n)(u):u instanceof Date?r[g]=u.toISOString():(0,C.$0f)(u)?s<2?p(u,r,s+1,g+"."):r[g]=(0,n.$7n)(u):r[g]=u}}function $(t,r){const s=t.msftInternalDomains||[],i=r.getValue("telemetry.internalTesting");return(0,R.$dp)(s)||i}function c(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}function w(t,r){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const i=[];for(const S of r)for(;;){const D=S.exec(t);if(!D)break;i.push([D.index,S.lastIndex])}const o=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,u=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let g=0;for(s="";;){const S=u.exec(t);if(!S)break;const D=i.some(([I,O])=>S.index<O&&I<u.lastIndex);!o.test(S[0])&&!D&&(s+=t.substring(g,S.index)+"<REDACTED: user-file-path>",g=u.lastIndex)}return g<t.length&&(s+=t.substr(g)),s}function P(t){if(!t)return t;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of r)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,r){return(0,n.$4n)(t,s=>{if(s instanceof k||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let i=s.replaceAll("%20"," ");i=w(i,r);for(const o of r)i=i.replace(o,"");return i=P(i),i}})}}),define(re[127],oe([0,1,25,121,124,4,7,15,36,54]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$up=void 0,e.$tp=d,e.$vp=f,e.$wp=y,e.$xp=p,e.$yp=$,e.$zp=c,e.$Ap=w,e.$Bp=P,e.$Dp=a,e.$Ep=r;function d(s,i){return s.uuid&&i.uuid?s.uuid===i.uuid:s.id===i.id?!0:(0,n.$sf)(s.id,i.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const o=i.manifest?i.manifest.version:i.version,u=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,o,u)}static parse(i){const o=b.exec(i);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(i,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?d(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$up=v;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(s){const i=m.exec(s);return i&&i[1]?[p(i[1]),i[2]]:[p(s),void 0]}function y(s,i){return`${s}.${i}`}function p(s){return s.toLowerCase()}function $(s,i){return p(y(s??E.$Mm,i))}function c(s,i){const o=[],u=g=>{for(const S of o)if(S.some(D=>d(i(D),i(g))))return S;return null};for(const g of s){const S=u(g);S?S.push(g):o.push([g])}return o}function w(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}function P(s){return{id:new l.$ep(s.identifier.id),name:new l.$ep(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$Cp=new E.$Qm("pprice.better-merge");function a(s,i){const o=[],u=i.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const g=u.shift();if(g&&o.every(S=>!d(S.identifier,{id:g}))){const S=s.filter(D=>d(D.identifier,{id:g}));S.length===1&&(o.push(S[0]),u.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}async function t(s,i){if(!R.$k)return!1;let o;try{o=(await s.readFile(j.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await s.readFile(j.URI.file("/usr/lib/os-release"))).value.toString()}catch(g){i.debug("Error while getting the os-release file.",(0,k.$0)(g))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(s,i){const o=await t(s,i),u=(0,C.$1o)(o?"alpine":R.$u,h.$fc);return i.debug("ComputeTargetPlatform:",u),u}}),define(re[256],oe([0,1,209,54]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=E;async function E(R,j,k,h,l,d,b){const v={"X-Market-Client-Id":`VSCode ${R}`,"User-Agent":`VSCode ${R} (${j.nameShort})`};if((0,C.$lp)(j,k)&&(0,C.$np)(h)===3){const m=await(0,n.$6p)(k,l,d);v["X-Market-User-Id"]=m,v["VSCode-SessionId"]=b.machineId||m}return v}}),define(re[257],oe([0,1,2,35,4,25,188,18,52,80,27,45,28,54]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;let f=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,c,w){this.k=c,this.l=w,this.d={},this.i=new n.$Uc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const P of this.f)this.j.push(new RegExp((0,R.$_e)(P),"gi")),P.indexOf("\\")>=0&&this.j.push(new RegExp((0,R.$_e)(P.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(P=>{(P.affectsConfiguration(v.$9l)||P.affectsConfiguration(v.$$l)||P.affectsConfiguration(v.$0l))&&this.m()}))}setExperimentProperty($,c){this.d[$]=c}m(){let $=(0,m.$np)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const w=c.usage?3:c.error?2:0;$=Math.min($,w)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,c,w){this.g<c||(w=(0,C.$5n)(w,this.d),w=(0,m.$sp)(w,this.j),w=(0,C.$5n)(w,this.c),this.b.forEach(P=>P.log($,w)))}publicLog($,c){this.n($,3,c)}publicLog2($,c){this.publicLog($,c)}publicLogError($,c){this.h&&this.n($,2,c)}publicLogError2($,c){this.publicLogError($,c)}};e.$Yr=f,e.$Yr=f=Ee([ie(1,k.$2i),ie(2,d.$ik)],f);function y(){const p=(0,j.localize)(0,null,l.default.nameLong),$=l.default.privacyStatementUrl?(0,j.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,j.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=E.$o?"":(0,j.localize)(3,null),w=(0,j.localize)(4,null),P=(0,j.localize)(5,null),a=(0,j.localize)(6,null),t=(0,j.localize)(7,null),r=`
|       | ${w} | ${P} | ${a} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,j.localize)(8,null);return`
${p} ${$} ${c}

&nbsp;

${t}
${r}

&nbsp;

${s}
`}b.$bo.as(h.$go.Configuration).registerConfiguration({id:v.$8l,order:1,type:"object",title:(0,j.localize)(9,null),properties:{[v.$9l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,j.localize)(10,null),(0,j.localize)(11,null),(0,j.localize)(12,null),(0,j.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$bo.as(h.$go.Configuration).registerConfiguration({id:v.$8l,order:110,type:"object",title:(0,j.localize)(14,null),properties:{[v.$$l]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,j.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,j.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,j.localize)(17,null,`\`#${v.$9l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[258],oe([0,1,4,89,28]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7cc=R,e.$8cc=j;async function R(k,h){let l=k.getItem(E.$6l);return(typeof l!="string"||n.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,C.$En)(h.error.bind(h))),l}async function j(k,h){let l=k.getItem(E.$7l);return typeof l!="string"&&(l=await(0,C.$Fn)(h.error.bind(h))),l}}),define(re[259],oe([0,1,28,258]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9cc=E,e.$0cc=R;async function E(j,k){const h=await(0,C.$7cc)(j,k);return j.setItem(n.$6l,h),h}async function R(j,k){const h=await(0,C.$8cc)(j,k);return j.setItem(n.$7l,h),h}}),define(re[128],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var n;(function(C){C[C.Replace=1]="Replace",C[C.Append=2]="Append",C[C.Prepend=3]="Prepend"})(n||(e.EnvironmentVariableMutatorType=n={}))}),define(re[260],oe([0,1,4,128]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=void 0;const E=new Map([[C.EnvironmentVariableMutatorType.Append,"APPEND"],[C.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[C.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class R{constructor(d){this.collections=d,this.a=new Map,this.b=new Map,d.forEach((b,v)=>{this.d(b,v);const m=b.map.entries();let f=m.next();for(;!f.done;){const y=f.value[1],p=f.value[0];let $=this.a.get(p);if($||($=[],this.a.set(p,$)),$.length>0&&$[0].type===C.EnvironmentVariableMutatorType.Replace){f=m.next();continue}const c={extensionIdentifier:v,value:y.value,type:y.type,scope:y.scope,variable:y.variable,options:y.options};c.scope||delete c.scope,$.unshift(c),f=m.next()}})}async applyToProcessEnvironment(d,b,v){let m;n.$i&&(m={},Object.keys(d).forEach(f=>m[f.toLowerCase()]=f));for(const[f,y]of this.getVariableMap(b)){const p=n.$i&&m[f.toLowerCase()]||f;for(const $ of y){const c=v?await v($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case C.EnvironmentVariableMutatorType.Append:d[p]=(d[p]||"")+c;break;case C.EnvironmentVariableMutatorType.Prepend:d[p]=c+(d[p]||"");break;case C.EnvironmentVariableMutatorType.Replace:d[p]=c;break}if($.options?.applyAtShellIntegration??!1){const w=`VSCODE_ENV_${E.get($.type)}`;d[w]=(d[w]?d[w]+":":"")+f+"="+this.c(c)}}}}c(d){return d.replaceAll(":","\\x3a")}diff(d,b){const v=new Map,m=new Map,f=new Map;if(d.getVariableMap(b).forEach((y,p)=>{const $=this.getVariableMap(b).get(p),c=k(y,$);c&&v.set(p,c)}),this.getVariableMap(b).forEach((y,p)=>{const $=d.getVariableMap(b).get(p),c=k(y,$);c&&f.set(p,c)}),this.getVariableMap(b).forEach((y,p)=>{const $=d.getVariableMap(b).get(p),c=h(y,$);c&&m.set(p,c)}),!(v.size===0&&m.size===0&&f.size===0))return{added:v,changed:m,removed:f}}getVariableMap(d){const b=new Map;for(const v of this.a.values()){const m=v.filter(f=>j(f,d));m.length>0&&b.set(m[0].variable,m)}return b}getDescriptionMap(d){const b=new Map;for(const v of this.b.values()){const m=v.filter(f=>j(f,d,!0));for(const f of m)b.set(f.extensionIdentifier,f.description)}return b}d(d,b){if(!d.descriptionMap)return;const v=d.descriptionMap.entries();let m=v.next();for(;!m.done;){const f=m.value[1],y=m.value[0];let p=this.b.get(y);p||(p=[],this.b.set(y,p));const $={extensionIdentifier:b,scope:f.scope,description:f.description};$.scope||delete $.scope,p.push($),m=v.next()}}}e.$qs=R;function j(l,d,b=!1){return l.scope?!!(l.scope.workspaceFolder&&d?.workspaceFolder&&l.scope.workspaceFolder.index===d.workspaceFolder.index):b?d===l.scope:!0}function k(l,d){if(!d)return l;const b=new Set;d.forEach(m=>b.add(m.extensionIdentifier));const v=[];return l.forEach(m=>{b.has(m.extensionIdentifier)||v.push(m)}),v.length===0?void 0:v}function h(l,d){if(!d)return;const b=new Map;d.forEach(m=>b.set(m.extensionIdentifier,m));const v=[];return l.forEach(m=>{const f=b.get(m.extensionIdentifier);f&&(m.type!==f.type||m.value!==f.value||m.scope?.workspaceFolder?.index!==f.scope?.workspaceFolder?.index)&&v.push(f)}),v.length===0?void 0:v}}),define(re[261],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=n,e.$ls=C,e.$ms=E,e.$ns=R,e.$os=j,e.$ps=k;function n(h){return[...h.entries()]}function C(h){return h?[...h.entries()]:[]}function E(h){return new Map(h)}function R(h){return new Map(h??[])}function j(h){return Array.from(h.entries()).map(l=>[l[0],n(l[1].map),C(l[1].descriptionMap)])}function k(h){return new Map(h.map(l=>[l[0],{map:E(l[1]),descriptionMap:R(l[2])}]))}}),define(re[262],oe([0,1,8,23,3,2,5]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bs=void 0;let k=class extends R.$Vc{constructor(l,d){super(),this.h=d,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new E.$ee),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,R.$Tc)(()=>{for(const b of this.f.values())(0,R.$Qc)(b)}))}createRequest(l){return new Promise((d,b)=>{const v=++this.a;this.c.set(v,d),this.g.fire({requestId:v,...l});const m=new C.$pe;(0,n.$wh)(this.b,m.token).then(()=>b(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,R.$Tc)(()=>m.cancel())])})}acceptReply(l,d){const b=this.c.get(l);b?(this.c.delete(l),(0,R.$Qc)(this.f.get(l)||[]),this.f.delete(l),b(d)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$bs=k,e.$bs=k=Ee([ie(1,j.$2j)],k)}),define(re[129],oe([0,1,6,118,45]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0r=e.$9r=e.$8r=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$7r=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$6r=void 0,e.$6r=new C.$Mj("terminalTabFocusMode",!1,!0);var R;(function(a){a.AutomationProfile="terminal.integrated.automationProfile.",a.DefaultProfile="terminal.integrated.defaultProfile.",a.Profiles="terminal.integrated.profiles."})(R||(e.TerminalSettingPrefix=R={}));var j;(function(a){a.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",a.AutomationProfileLinux="terminal.integrated.automationProfile.linux",a.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",a.AutomationProfileWindows="terminal.integrated.automationProfile.windows",a.ProfilesWindows="terminal.integrated.profiles.windows",a.ProfilesMacOs="terminal.integrated.profiles.osx",a.ProfilesLinux="terminal.integrated.profiles.linux",a.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",a.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",a.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",a.UseWslProfiles="terminal.integrated.useWslProfiles",a.TabsDefaultColor="terminal.integrated.tabs.defaultColor",a.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",a.TabsEnabled="terminal.integrated.tabs.enabled",a.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",a.TabsHideCondition="terminal.integrated.tabs.hideCondition",a.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",a.TabsShowActions="terminal.integrated.tabs.showActions",a.TabsLocation="terminal.integrated.tabs.location",a.TabsFocusMode="terminal.integrated.tabs.focusMode",a.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",a.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",a.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",a.CopyOnSelection="terminal.integrated.copyOnSelection",a.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",a.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",a.FontFamily="terminal.integrated.fontFamily",a.FontSize="terminal.integrated.fontSize",a.LetterSpacing="terminal.integrated.letterSpacing",a.LineHeight="terminal.integrated.lineHeight",a.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",a.TabStopWidth="terminal.integrated.tabStopWidth",a.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",a.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",a.BellDuration="terminal.integrated.bellDuration",a.FontWeight="terminal.integrated.fontWeight",a.FontWeightBold="terminal.integrated.fontWeightBold",a.CursorBlinking="terminal.integrated.cursorBlinking",a.CursorStyle="terminal.integrated.cursorStyle",a.CursorStyleInactive="terminal.integrated.cursorStyleInactive",a.CursorWidth="terminal.integrated.cursorWidth",a.Scrollback="terminal.integrated.scrollback",a.DetectLocale="terminal.integrated.detectLocale",a.DefaultLocation="terminal.integrated.defaultLocation",a.GpuAcceleration="terminal.integrated.gpuAcceleration",a.TerminalTitleSeparator="terminal.integrated.tabs.separator",a.TerminalTitle="terminal.integrated.tabs.title",a.TerminalDescription="terminal.integrated.tabs.description",a.RightClickBehavior="terminal.integrated.rightClickBehavior",a.MiddleClickBehavior="terminal.integrated.middleClickBehavior",a.Cwd="terminal.integrated.cwd",a.ConfirmOnExit="terminal.integrated.confirmOnExit",a.ConfirmOnKill="terminal.integrated.confirmOnKill",a.EnableBell="terminal.integrated.enableBell",a.EnableVisualBell="terminal.integrated.enableVisualBell",a.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",a.AllowChords="terminal.integrated.allowChords",a.AllowMnemonics="terminal.integrated.allowMnemonics",a.TabFocusMode="terminal.integrated.tabFocusMode",a.EnvMacOs="terminal.integrated.env.osx",a.EnvLinux="terminal.integrated.env.linux",a.EnvWindows="terminal.integrated.env.windows",a.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",a.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",a.ShowExitAlert="terminal.integrated.showExitAlert",a.SplitCwd="terminal.integrated.splitCwd",a.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",a.WordSeparators="terminal.integrated.wordSeparators",a.EnableFileLinks="terminal.integrated.enableFileLinks",a.AllowedLinkSchemes="terminal.integrated.allowedLinkSchemes",a.UnicodeVersion="terminal.integrated.unicodeVersion",a.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",a.LocalEchoEnabled="terminal.integrated.localEchoEnabled",a.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",a.LocalEchoStyle="terminal.integrated.localEchoStyle",a.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",a.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",a.HideOnStartup="terminal.integrated.hideOnStartup",a.CustomGlyphs="terminal.integrated.customGlyphs",a.RescaleOverlappingGlyphs="terminal.integrated.rescaleOverlappingGlyphs",a.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",a.InheritEnv="terminal.integrated.inheritEnv",a.ShowLinkHover="terminal.integrated.showLinkHover",a.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",a.AutoReplies="terminal.integrated.autoReplies",a.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",a.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",a.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",a.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",a.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",a.EnableImages="terminal.integrated.enableImages",a.SmoothScrolling="terminal.integrated.smoothScrolling",a.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",a.FocusAfterRun="terminal.integrated.focusAfterRun",a.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",a.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",a.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",a.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",a.MouseWheelZoom="terminal.integrated.mouseWheelZoom",a.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",a.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",a.DevMode="terminal.integrated.developer.devMode"})(j||(e.TerminalSettingId=j={}));var k;(function(a){a.PowerShell="pwsh",a.Bash="bash",a.Fish="fish",a.Sh="sh",a.Csh="csh",a.Ksh="ksh",a.Zsh="zsh",a.Python="python"})(k||(e.PosixShellType=k={}));var h;(function(a){a.CommandPrompt="cmd",a.PowerShell="pwsh",a.Wsl="wsl",a.GitBash="gitbash",a.Python="python"})(h||(e.WindowsShellType=h={}));var l;(function(a){a[a.Api=0]="Api",a[a.Process=1]="Process",a[a.Sequence=2]="Sequence",a[a.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var d;(function(a){a.LocalPty="localPty",a.PtyHost="ptyHost",a.PtyHostWindow="ptyHostWindow",a.Logger="logger",a.Heartbeat="heartbeat"})(d||(e.TerminalIpcChannels=d={}));var b;(function(a){a.Cwd="cwd",a.InitialCwd="initialCwd",a.FixedDimensions="fixedDimensions",a.Title="title",a.ShellType="shellType",a.HasChildProcesses="hasChildProcesses",a.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",a.OverrideDimensions="overrideDimensions",a.FailedShellIntegrationActivation="failedShellIntegrationActivation",a.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(b||(e.ProcessPropertyType=b={})),e.$7r=(0,n.$vi)("ptyService");var v;(function(a){a[a.BeatInterval=5e3]="BeatInterval",a[a.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",a[a.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",a[a.SecondWaitMultiplier=1]="SecondWaitMultiplier",a[a.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var m;(function(a){a[a.Panel=1]="Panel",a[a.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var f;(function(a){a.TerminalView="view",a.Editor="editor"})(f||(e.TerminalLocationString=f={}));var y;(function(a){a[a.GraceTime=6e4]="GraceTime",a[a.ShortGraceTime=6e3]="ShortGraceTime"})(y||(e.LocalReconnectConstants=y={}));var p;(function(a){a[a.HighWatermarkChars=1e5]="HighWatermarkChars",a[a.LowWatermarkChars=5e3]="LowWatermarkChars",a[a.CharCountAckSize=5e3]="CharCountAckSize"})(p||(e.FlowControlConstants=p={}));var $;(function(a){a.GitBash="Git Bash",a.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var c;(function(a){a[a.Off=0]="Off",a[a.FinalTerm=1]="FinalTerm",a[a.VSCode=2]="VSCode"})(c||(e.ShellIntegrationStatus=c={}));var w;(function(a){a[a.Unknown=0]="Unknown",a[a.Shutdown=1]="Shutdown",a[a.Process=2]="Process",a[a.User=3]="User",a[a.Extension=4]="Extension"})(w||(e.TerminalExitReason=w={})),e.$8r={Backend:"workbench.contributions.terminal.processBackend"};class P{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const r=this.b(t.remoteAuthority);if(this.a.has(r))throw new Error(`A terminal backend with remote authority '${r}' was already registered.`);this.a.set(r,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}E.$bo.add(e.$8r.Backend,new P),e.$9r=(0,n.$vi)("localPtyService"),e.$0r=(0,n.$vi)("terminalLogService")}),define(re[263],oe([0,1,75,7,190,106]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cs=j,e.$ds=l,e.$es=d,e.$fs=b;function j(v,m){const f=[{name:null,description:(0,E.localize)(0,null)}];return f.push(...v.map(y=>({name:y.profileName,description:k(y)}))),m&&f.push(...m.map(y=>({name:y.title,description:h(y)}))),{values:f.map(y=>y.name),markdownDescriptions:f.map(y=>y.description)}}function k(v){let m=`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Uj.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?m+=`
- args: "${v.args}"`:m+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(m+=`
- overrideName: ${v.overrideName}`),v.color&&(m+=`
- color: ${v.color}`),v.env&&(m+=`
- env: ${JSON.stringify(v.env)}`),m}function h(v){return`$(${R.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:n.$Uj.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function l(v,m){if(!v&&!m)return!0;if(typeof v=="string"&&typeof m=="string")return v===m;if(Array.isArray(v)&&Array.isArray(m)){if(v.length!==m.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==m[f])return!1;return!0}return!1}function d(v,m){if(!v&&!m)return!0;if(!v||!m)return!1;if(R.ThemeIcon.isThemeIcon(v)&&R.ThemeIcon.isThemeIcon(m))return v.id===m.id&&v.color===m.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof m=="object"&&"light"in m&&"dark"in m){const f=v,y=m;if((C.URI.isUri(f.light)||b(f.light))&&(C.URI.isUri(f.dark)||b(f.dark))&&(C.URI.isUri(y.light)||b(y.light))&&(C.URI.isUri(y.dark)||b(y.dark)))return f.light.path===y.light.path&&f.dark.path===y.dark.path}if(C.URI.isUri(v)&&C.URI.isUri(m)||b(v)||b(m)){const f=v,y=m;return f.path===y.path&&f.scheme===y.scheme}return!1}function b(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}}),define(re[264],oe([0,1,75,4,189,52,45,263]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hs=e.$gs=void 0,e.$is=m,e.$js=y,e.$gs={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$hs={type:"string",enum:Array.from((0,n.$Sj)(),p=>p.id),markdownEnumDescriptions:Array.from((0,n.$Sj)(),p=>`$(${p.id})`)};const h={args:{description:(0,E.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,E.localize)(1,null),type:"boolean"},icon:{description:(0,E.localize)(2,null),...e.$hs},color:{description:(0,E.localize)(3,null),...e.$gs},env:{markdownDescription:(0,E.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(5,null),type:["string","array"],items:{type:"string"}},...h}},d={type:"object",required:["path"],properties:{path:{description:(0,E.localize)(6,null),type:["string"],items:{type:"string"}},...h}};function b(p){const $=p===2?"linux":p===1?"osx":"windows";return(0,E.localize)(7,null,(0,C.$h)(p),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,E.localize)(8,null),type:"object",properties:{"terminal.integrated.automationProfile.linux":{restricted:!0,markdownDescription:(0,E.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.osx":{restricted:!0,markdownDescription:(0,E.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.automationProfile.windows":{restricted:!0,markdownDescription:(0,E.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},d],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},"terminal.integrated.profiles.windows":{restricted:!0,markdownDescription:b(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,E.localize)(12,null),enum:["PowerShell","Git Bash"]},...h}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(13,null),type:"string"},id:{description:(0,E.localize)(14,null),type:"string"},title:{description:(0,E.localize)(15,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.osx":{restricted:!0,markdownDescription:b(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(16,null),type:"string"},id:{description:(0,E.localize)(17,null),type:"string"},title:{description:(0,E.localize)(18,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.profiles.linux":{restricted:!0,markdownDescription:b(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,E.localize)(19,null),type:"string"},id:{description:(0,E.localize)(20,null),type:"string"},title:{description:(0,E.localize)(21,null),type:"string"},...h}},{type:"null"},l]}},"terminal.integrated.useWslProfiles":{description:(0,E.localize)(22,null),type:"boolean",default:!0},"terminal.integrated.inheritEnv":{scope:1,description:(0,E.localize)(23,null),type:"boolean",default:!0},"terminal.integrated.persistentSessionScrollback":{scope:1,markdownDescription:(0,E.localize)(24,null),type:"number",default:100},"terminal.integrated.showLinkHover":{scope:1,description:(0,E.localize)(25,null),type:"boolean",default:!0},"terminal.integrated.ignoreProcessNames":{markdownDescription:(0,E.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){j.$bo.as(R.$go.Configuration).registerConfiguration(v),y()}let f;function y(p,$){const c=j.$bo.as(R.$go.Configuration);let w;p&&(w=(0,k.$cs)(p?.profiles,$));const P=f;f={id:"terminal",order:100,title:(0,E.localize)(27,null),type:"object",properties:{"terminal.integrated.defaultProfile.linux":{restricted:!0,markdownDescription:(0,E.localize)(28,null),type:["string","null"],default:null,enum:p?.os===3?w?.values:void 0,markdownEnumDescriptions:p?.os===3?w?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.osx":{restricted:!0,markdownDescription:(0,E.localize)(29,null),type:["string","null"],default:null,enum:p?.os===2?w?.values:void 0,markdownEnumDescriptions:p?.os===2?w?.markdownDescriptions:void 0},"terminal.integrated.defaultProfile.windows":{restricted:!0,markdownDescription:(0,E.localize)(30,null),type:["string","null"],default:null,enum:p?.os===1?w?.values:void 0,markdownEnumDescriptions:p?.os===1?w?.markdownDescriptions:void 0}}},c.updateConfigurations({add:[f],remove:P?[P]:[]})}}),define(re[265],oe([0,1,26,13,35,9,4,36,25,12,21,128,261,260]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rs=f,e.$ss=y,e.$ts=p;function f(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(n.release());let g=0;return u&&u.length===4&&(g=parseInt(u[3])),g}async function y(u,g,S,D=k.env,I=d.Promises.exists){if(R.$jc(u))return await I(u)?u:void 0;if(g===void 0&&(g=k.cwd()),R.$nc(u)!=="."){const F=R.$kc(g,u);return await I(F)?F:void 0}const M=(0,E.$9n)(D,"PATH");if(S===void 0&&(0,l.$8f)(M)&&(S=M.split(R.$uc)),S===void 0||S.length===0){const F=R.$kc(g,u);return await I(F)?F:void 0}for(const F of S){let T;if(R.$jc(F)?T=R.$kc(F,u):T=R.$kc(g,F,u),await I(T))return T;if(j.$i){let q=T+".com";if(await I(q)||(q=T+".exe",await I(q)))return q}}const W=R.$kc(g,u);return await I(W)?W:void 0}function p(u,g,S,D,I){const O=j.$i&&(!g.windowsEnableConpty||f()<18309);if(!g.shellIntegration.enabled||!u.executable||u.isFeatureTerminal&&!u.forceShellIntegration||u.ignoreShellIntegration||O)return;const M=u.args,W=k.$ec==="win32"?R.$oc(u.executable).toLowerCase():R.$oc(u.executable),F=R.$nc(C.$Pg.asFileUri("").fsPath);let T;const q={VSCODE_INJECTION:"1"};if(g.shellIntegration.nonce&&(q.VSCODE_NONCE=g.shellIntegration.nonce),j.$i){if(W==="pwsh.exe"||W==="powershell.exe")return!M||i(M)?T=w.get(c.WindowsPwsh):s(M)&&(T=w.get(c.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,h.$8e)(T[T.length-1],F,""),g.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:q}):void 0;if(W==="bash.exe")return!M||M.length===0?T=w.get(c.Bash):o(M)&&(q.VSCODE_SHELL_LOGIN="1",$(g,q),T=w.get(c.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$8e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args);return}switch(W){case"bash":return!M||M.length===0?T=w.get(c.Bash):o(M)&&(q.VSCODE_SHELL_LOGIN="1",$(g,q),T=w.get(c.Bash)),T?(T=[...T],T[T.length-1]=(0,h.$8e)(T[T.length-1],F),{newArgs:T,envMixin:q}):void 0;case"fish":{const ue=S?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return q.XDG_DATA_DIRS=`${ue}:${ee}`,$(g,q),{newArgs:void 0,envMixin:q}}case"pwsh":return!M||i(M)?T=w.get(c.Pwsh):s(M)&&(T=w.get(c.PwshLogin)),T?(g.shellIntegration.suggestEnabled&&(q.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,h.$8e)(T[T.length-1],F,""),{newArgs:T,envMixin:q}):void 0;case"zsh":{if(!M||M.length===0?T=w.get(c.Zsh):o(M)?(T=w.get(c.ZshLogin),$(g,q)):(M===w.get(c.Zsh)||M===w.get(c.ZshLogin))&&(T=M),!T)return;T=[...T],T[T.length-1]=(0,h.$8e)(T[T.length-1],F);let ue;try{ue=n.userInfo().username}catch{ue="unknown"}const ee=R.$kc(n.tmpdir(),`${ue}-${I.applicationName}-zsh`);q.ZDOTDIR=ee;const ce=S?.ZDOTDIR??n.homedir()??"~";q.USER_ZDOTDIR=ce;const K=[];return K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:R.$kc(ee,".zshrc")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:R.$kc(ee,".zprofile")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:R.$kc(ee,".zshenv")}),K.push({source:R.$kc(F,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:R.$kc(ee,".zlogin")}),{newArgs:T,envMixin:q,filesToCopy:K}}}D.warn(`Shell integration cannot be enabled for executable "${u.executable}" and args`,u.args)}function $(u,g){if(j.$j&&u.environmentVariableCollections){const S=(0,v.$ps)(u.environmentVariableCollections),I=new m.$qs(S).getVariableMap({workspaceFolder:u.workspaceFolder}).get("PATH"),O=[];if(I)for(const M of I)M.type===b.EnvironmentVariableMutatorType.Prepend&&O.push(M.value);O.length>0&&(g.VSCODE_PATH_PREFIX=O.join(""))}}var c;(function(u){u.WindowsPwsh="windows-pwsh",u.WindowsPwshLogin="windows-pwsh-login",u.Pwsh="pwsh",u.PwshLogin="pwsh-login",u.Zsh="zsh",u.ZshLogin="zsh-login",u.Bash="bash"})(c||(c={}));const w=new Map;w.set(c.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(c.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),w.set(c.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),w.set(c.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),w.set(c.Zsh,["-i"]),w.set(c.ZshLogin,["-il"]),w.set(c.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const P=["-login","-l"],a=["--login","-l"],t=["-i","--interactive"],r=["-nol","-nologo"];function s(u){return typeof u=="string"?P.includes(u.toLowerCase()):u.length===1&&P.includes(u[0].toLowerCase())||u.length===2&&(P.includes(u[0].toLowerCase())||P.includes(u[1].toLowerCase()))&&(r.includes(u[0].toLowerCase())||r.includes(u[1].toLowerCase()))}function i(u){return typeof u=="string"?r.includes(u.toLowerCase()):u.length===0||u?.length===1&&r.includes(u[0].toLowerCase())}function o(u){return typeof u!="string"&&(u=u.filter(g=>!t.includes(g.toLowerCase()))),u==="string"&&a.includes(u.toLowerCase())||typeof u!="string"&&u.length===1&&a.includes(u[0].toLowerCase())}}),define(re[266],oe([0,1,49,75,9,4,12,21,110,265,117]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$us=f;var b;(function(u){u.UnixShellsPath="/etc/shells"})(b||(b={}));let v,m=!0;function f(u,g,S,D,I=process.env,O,M,W,F){return O=O||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},R.$i?y(S,O,I,M,D.getValue("terminal.integrated.useWslProfiles")!==!1,u&&typeof u=="object"?{...u}:D.getValue("terminal.integrated.profiles.windows"),typeof g=="string"?g:D.getValue("terminal.integrated.defaultProfile.windows"),F,W):s(O,M,S,u&&typeof u=="object"?{...u}:D.getValue(R.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof g=="string"?g:D.getValue(R.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),F,W,I)}async function y(u,g,S,D,I,O,M,W,F){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),q=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let ue=!1;(0,l.$rs)()>=16299&&(ue=!0),await w(W);const ee=new Map;if(u){ee.set("PowerShell",{source:"PowerShell",icon:C.$Uj.terminalPowershell,isAutoDetected:!0}),ee.set("Windows PowerShell",{path:`${q}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:C.$Uj.terminalPowershell,isAutoDetected:!0}),ee.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),ee.set("Command Prompt",{path:`${q}\\cmd.exe`,icon:C.$Uj.terminalCmd,isAutoDetected:!0}),ee.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),ee.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],env:{CHERE_INVOKING:"1"},icon:C.$Uj.terminalBash,isAutoDetected:!0});const K=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;ee.set("Cmder",{path:`${q}\\cmd.exe`,args:["/K",K],requiresPath:process.env.CMDER_ROOT?K:{path:K,isUnsafe:!0},isAutoDetected:!0})}i(O,ee);const ce=await p(ee.entries(),M,g,S,D,F);if(u&&I)try{const K=await t(`${q}\\${ue?"wsl":"bash"}.exe`,M);for(const Q of K)(!O||!(Q.profileName in O))&&ce.push(Q)}catch{m&&(D?.trace("WSL is not installed, so could not detect WSL profiles"),m=!1)}return ce}async function p(u,g,S,D=process.env,I,O){const M=[];for(const[W,F]of u)M.push($(W,F,g,S,D,I,O));return(await Promise.all(M)).filter(W=>!!W)}async function $(u,g,S,D,I=process.env,O,M){if(g===null)return;let W,F,T;if("source"in g&&!("path"in g)){const ce=v?.get(g.source);if(!ce)return;W=ce.paths,F=g.args||ce.args,g.icon?T=c(g.icon):ce.icon&&(T=ce.icon)}else W=Array.isArray(g.path)?g.path:[g.path],F=R.$i||Array.isArray(g.args)?g.args:void 0,T=c(g.icon);let q;if(M){const ce=W.map(Q=>typeof Q=="string"?Q:Q.path),K=await M(ce);q=new Array(W.length);for(let Q=0;Q<W.length;Q++)typeof W[Q]=="string"?q[Q]=K[Q]:q[Q]={path:K[Q],isUnsafe:!0}}else q=W.slice();let ue;if(g.requiresPath){let ce;if((0,j.$8f)(g.requiresPath)?ce=g.requiresPath:(ce=g.requiresPath.path,g.requiresPath.isUnsafe&&(ue=ce)),!await D.existsFile(ce))return}const ee=await o(u,S,q,D,I,F,g.env,g.overrideName,g.isAutoDetected,ue);if(!ee){O?.debug("Terminal profile not validated",u,W);return}return ee.isAutoDetected=g.isAutoDetected,ee.icon=T,ee.color=g.color,ee}function c(u){return typeof u=="string"?{id:u}:u}async function w(u){if(v&&!u)return;const[g,S]=await Promise.all([P(),u||a()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:g,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:S,icon:C.$Uj.terminalPowershell})}async function P(){const u=new Set,g=await(0,l.$ss)("git.exe");if(g){const I=(0,d.dirname)(g);u.add((0,d.resolve)(I,"../.."))}function S(I,O){O&&I.add(O)}S(u,process.env.ProgramW6432),S(u,process.env.ProgramFiles),S(u,process.env["ProgramFiles(X86)"]),S(u,`${process.env.LocalAppData}\\Program`);const D=[];for(const I of u)D.push(`${I}\\Git\\bin\\bash.exe`,`${I}\\Git\\usr\\bin\\bash.exe`,`${I}\\usr\\bin\\bash.exe`);return D.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),D.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),D}async function a(){const u=[];for await(const g of(0,h.$jm)())u.push(g.exePath);return u}async function t(u,g){const S=[],D=await new Promise((M,W)=>{n.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(F,T)=>{if(F)return W("Problem occurred when getting wsl distros");M(T)})});if(!D)return[];const I=new RegExp(/[\r?\n]/),O=D.split(I).filter(M=>M.trim().length>0&&M!=="");for(const M of O){if(M===""||M.startsWith("docker-desktop"))continue;const W=`${M} (WSL)`,F={profileName:W,path:u,args:["-d",`${M}`],isDefault:W===g,icon:r(M),isAutoDetected:!1};S.push(F)}return S}function r(u){return u.includes("Ubuntu")?C.$Uj.terminalUbuntu:u.includes("Debian")?C.$Uj.terminalDebian:C.$Uj.terminalLinux}async function s(u,g,S,D,I,O,M,W){const F=new Map;if(S&&await u.existsFile("/etc/shells")){const T=(await u.readFile("/etc/shells")).toString(),q=(O||T.split(`
`)).map(ee=>{const ce=ee.indexOf("#");return ce===-1?ee:ee.substring(0,ce)}).filter(ee=>ee.trim().length>0),ue=new Map;for(const ee of q){let ce=(0,E.$oc)(ee),K=ue.get(ce)||0;K++,K>1&&(ce=`${ce} (${K})`),ue.set(ce,K),F.set(ce,{path:ee,isAutoDetected:!0})}}return i(D,F),await p(F.entries(),I,u,W,g,M)}function i(u,g){if(u)for(const[S,D]of Object.entries(u))D===null||typeof D!="object"||!("path"in D)&&!("source"in D)?g.delete(S):(D.icon=D.icon||g.get(S)?.icon,g.set(S,D))}async function o(u,g,S,D,I,O,M,W,F,T){if(S.length===0)return Promise.resolve(void 0);const q=S.shift();if(q==="")return o(u,g,S,D,I,O,M,W,F);const ue=typeof q!="string"&&q.isUnsafe,ee=typeof q=="string"?q:q.path,ce={profileName:u,path:ee,args:O,env:M,overrideName:W,isAutoDetected:F,isDefault:u===g,isUnsafePath:ue,requiresUnsafePath:T};if((0,E.$oc)(ee)===ee){const Q=I.PATH?I.PATH.split(E.$uc):void 0,B=await(0,l.$ss)(ee,void 0,Q,void 0,D.existsFile);return B?(ce.path=B,ce.isFromPath=!0,ce):o(u,g,S,D,I,O)}return await D.existsFile((0,E.$ic)(ee))?ce:o(u,g,S,D,I,O,M,W,F)}}),define(re[267],oe([0,1,3,2,4,44,18,5,230,95,262,129,264,266,112,73]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vs=void 0;var p;(function(c){c[c.MaxRestarts=5]="MaxRestarts"})(p||(p={}));let $=class extends C.$Vc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(w,P,a,t){super(),this.M=w,this.N=P,this.O=a,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new n.$ee),this.onPtyHostExit=this.u.event,this.w=this.B(new n.$ee),this.onPtyHostStart=this.w.event,this.y=this.B(new n.$ee),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new n.$ee),this.onPtyHostResponsive=this.z.event,this.C=this.B(new n.$ee),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new n.$ee),this.onProcessData=this.D.event,this.F=this.B(new n.$ee),this.onProcessReady=this.F.event,this.G=this.B(new n.$ee),this.onProcessReplay=this.G.event,this.H=this.B(new n.$ee),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new n.$ee),this.onDidRequestDetach=this.I.event,this.J=this.B(new n.$ee),this.onDidChangeProperty=this.J.event,this.L=this.B(new n.$ee),this.onProcessExit=this.L.event,(0,v.$is)(),this.B(this.M),this.B((0,C.$Tc)(()=>this.W())),this.j=this.B(new d.$bs(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&n.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(E.$i)return process.env;try{return await(0,l.$Fm)(this.N,this.O,{_:[]},process.env)}catch(w){return this.O.error("ptyHost was unable to resolve shell environment",w),{}}}U(){const w=this.M.start(),P=w.client;this.O.getLevel()===k.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),R.ProxyChannel.toService(P.getChannel(b.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(w.onDidProcessExit(r=>{this.u.fire(r.code),!this.m&&!this.q.isDisposed&&(this.n<=p.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${r.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${r.code}, giving up`))}));const t=R.ProxyChannel.toService(P.getChannel(b.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(r=>this.D.fire(r))),this.B(t.onProcessReady(r=>this.F.fire(r))),this.B(t.onProcessExit(r=>this.L.fire(r))),this.B(t.onDidChangeProperty(r=>this.J.fire(r))),this.B(t.onProcessReplay(r=>this.G.fire(r))),this.B(t.onProcessOrphanQuestion(r=>this.H.fire(r))),this.B(t.onDidRequestDetach(r=>this.I.fire(r))),this.B(new h.$as(this.P,P.getChannel(b.TerminalIpcChannels.Logger))),this.a=w,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async r=>{r.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[w,t]}async createProcess(w,P,a,t,r,s,i,o,u,g,S){const D=setTimeout(()=>this.$(),b.HeartbeatConstants.CreateProcessTimeout),I=await this.f.createProcess(w,P,a,t,r,s,i,o,u,g,S);return clearTimeout(D),I}updateTitle(w,P,a){return this.f.updateTitle(w,P,a)}updateIcon(w,P,a,t){return this.f.updateIcon(w,P,a,t)}attachToProcess(w){return this.f.attachToProcess(w)}detachFromProcess(w,P){return this.f.detachFromProcess(w,P)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(w){return this.f.start(w)}shutdown(w,P){return this.f.shutdown(w,P)}input(w,P){return this.f.input(w,P)}processBinary(w,P){return this.f.processBinary(w,P)}resize(w,P,a){return this.f.resize(w,P,a)}clearBuffer(w){return this.f.clearBuffer(w)}acknowledgeDataEvent(w,P){return this.f.acknowledgeDataEvent(w,P)}setUnicodeVersion(w,P){return this.f.setUnicodeVersion(w,P)}getInitialCwd(w){return this.f.getInitialCwd(w)}getCwd(w){return this.f.getCwd(w)}async getLatency(){const w=new y.$ae,P=await this.f.getLatency();return w.stop(),[{label:"ptyhostservice<->ptyhost",latency:w.elapsed()},...P]}orphanQuestionReply(w){return this.f.orphanQuestionReply(w)}installAutoReply(w,P){return this.f.installAutoReply(w,P)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(w){return this.f.uninstallAutoReply(w)}getDefaultSystemShell(w){return this.g?.getDefaultSystemShell(w)??(0,f.$pm)(w??E.OS,process.env)}async getProfiles(w,P,a,t=!1){const r=await this.S();return(0,m.$us)(P,a,t,this.N,r,void 0,this.O,this.bb.bind(this,w))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(w,P){return this.f.getWslPath(w,P)}getRevivedPtyNewId(w,P){return this.f.getRevivedPtyNewId(w,P)}setTerminalLayoutInfo(w){return this.f.setTerminalLayoutInfo(w)}async getTerminalLayoutInfo(w){return this.g?.getTerminalLayoutInfo(w)}async requestDetachInstance(w,P){return this.f.requestDetachInstance(w,P)}async acceptDetachInstanceReply(w,P){return this.f.acceptDetachInstanceReply(w,P)}async freePortKillProcess(w){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(w)}async serializeTerminalState(w){return this.f.serializeTerminalState(w)}async reviveTerminalProcesses(w,P,a){return this.f.reviveTerminalProcesses(w,P,a)}async refreshProperty(w,P){return this.f.refreshProperty(w,P)}async updateProperty(w,P,a){return this.f.updateProperty(w,P,a)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(w){this.ab(),this.s=setTimeout(()=>this.Y(),w?b.HeartbeatConstants.ConnectingBeatInterval:b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier+b.HeartbeatConstants.BeatInterval*b.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${b.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(w,P){return this.j.createRequest({workspaceId:w,originalText:P})}async acceptPtyHostResolvedVariables(w,P){this.j.acceptReply(w,P)}};e.$vs=$,e.$vs=$=Ee([ie(1,j.$2i),ie(2,k.$2j),ie(3,k.$3j)],$)}),define(re[69],oe([0,1,14,3,2,4,18,6,34]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vbc=e.$ubc=void 0;const l="#FFFFFF",d="#1E1E1E",b="#000000",v="#FFFFFF",m="theme",f="themeBackground",y="windowSplash";e.$ubc=(0,k.$vi)("themeMainService");let p=class extends E.$Vc{constructor(c,w){super(),this.b=c,this.c=w,this.a=this.B(new C.$ee),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(P=>{P.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(C.Event.fromNodeEventEmitter(n.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":n.nativeTheme.themeSource="dark";break;case"light":n.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":n.nativeTheme.themeSource="light";break;case"vs-dark":n.nativeTheme.themeSource="dark";break;default:n.nativeTheme.themeSource="system"}break;default:n.nativeTheme.themeSource="system";break}}getColorScheme(){if(R.$i){if(n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(R.$j){if(n.nativeTheme.shouldUseInvertedColorScheme||n.nativeTheme.shouldUseHighContrastColors)return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(R.$k&&n.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:n.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const c=this.getColorScheme();if(c.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return c.dark?b:v;let w=this.b.getItem(f,null);if(!w)switch(this.g()){case"vs":w=l;break;case"hc-black":w=b;break;case"hc-light":w=v;break;default:w=d}return R.$j&&w.toUpperCase()===d&&(w="#171717"),w}g(){switch(this.b.getItem(m,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(c,w){this.b.setItems([{key:m,data:w.baseTheme},{key:f,data:w.colorInfo.background},{key:y,data:w}]),typeof c=="number"&&this.h(c,w),this.f()}h(c,w){for(const P of n.BrowserWindow.getAllWindows())if(P.id===c){P.setBackgroundColor(w.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(y)}};e.$vbc=p,e.$vbc=p=Ee([ie(0,h.$BQ),ie(1,j.$2i)],p)}),define(re[130],oe([0,1,3,7,18,6,5]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$iw=e.$gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$cw=e.$bw=void 0,e.$dw=l,e.$ew=b,e.$fw=v,e.$hw=m,e.$jw=f,e.$kw=y,e.$bw=(0,R.$vi)("tunnelService"),e.$cw=(0,R.$vi)("sharedTunnelsService");var k;(function(c){c.Http="http",c.Https="https"})(k||(e.TunnelProtocol=k={}));var h;(function(c){c.ConstantPrivate="constantPrivate",c.Private="private",c.Public="public"})(h||(e.TunnelPrivacyId=h={}));function l(c){return!!c.forwardPort}var d;(function(c){c[c.Notify=1]="Notify",c[c.OpenBrowser=2]="OpenBrowser",c[c.OpenPreview=3]="OpenPreview",c[c.Silent=4]="Silent",c[c.Ignore=5]="Ignore",c[c.OpenBrowserOnce=6]="OpenBrowserOnce"})(d||(e.ProvidedOnAutoForward=d={}));function b(c){if(c.scheme!=="http"&&c.scheme!=="https")return;const w=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(c.authority);if(w)return{address:w[1],port:+w[2]}}function v(c){if(c.scheme!=="http"&&c.scheme!=="https"||!c.query)return;const w=c.query.split("&");for(const P of w){const a=P.split("=")[1];if(/^https?:/.exec(a)){const t=b(C.URI.parse(a));if(t)return t}}}e.$gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function m(c){return e.$gw.indexOf(c)>=0}e.$iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(c){return e.$iw.indexOf(c)>=0}function y(c,w,P,a){if(P===1)return!1;if(P===2&&f(w)){const t=/(\d+)\.(\d+)\.(\d+)/g.exec(a);if(t?.length===4&&parseInt(t[1])>=18)return!1}return c<1024}class p{constructor(w,P,a){this.remoteAddress=w,this.localAddress=P,this.b=a,this.a=new n.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lw=p;let $=class{constructor(w,P){this.k=w,this.l=P,this.a=new n.$ee,this.onTunnelOpened=this.a.event,this.b=new n.$ee,this.onTunnelClosed=this.b.event,this.c=new n.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const w=this.l.getValue("remote.localPortHost");return!w||w==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(w){return this.f=w,w?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(w){this.g=w.elevation,this.i=w.privacyOptions,this.h=w.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const w=[],P=Array.from(this.e.values());for(const a of P){const t=Array.from(a.values());for(const r of t){const s=await r.value;s&&typeof s!="string"&&w.push(s)}}return w}async dispose(){for(const w of this.e.values()){for(const{value:P}of w.values())await P.then(a=>typeof a!="string"?a?.dispose():void 0);w.clear()}this.e.clear()}setEnvironmentTunnel(w,P,a,t,r){this.q(w,P,Promise.resolve({tunnelRemoteHost:w,tunnelRemotePort:P,localAddress:a,privacy:t,protocol:r,dispose:()=>Promise.resolve()}))}async getExistingTunnel(w,P){(f(w)||m(w))&&(w=e.$gw[0]);const a=this.s(w,P);if(a)return++a.refcount,a.value}openTunnel(w,P,a,t,r,s=!1,i,o){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${P}:${a} on local port ${r}.`);const u=this.f??w;if(!u)return;if(P||(P="localhost"),t||(t=this.m),this.f&&this.j.has(a)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const g=this.t(u,P,a,t,r,s,i,o);return g?g.then(S=>{if(S){if(typeof S=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(P,a),S}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(P,a);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const D=this.o(S);return(S.tunnelRemoteHost!==P||S.tunnelRemotePort!==a)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),i&&S.privacy!==i&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(D),D}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),g)}o(w){return{tunnelRemotePort:w.tunnelRemotePort,tunnelRemoteHost:w.tunnelRemoteHost,tunnelLocalPort:w.tunnelLocalPort,localAddress:w.localAddress,privacy:w.privacy,protocol:w.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${w.tunnelRemoteHost}:${w.tunnelRemotePort} `);const P=this.e.get(w.tunnelRemoteHost);if(P){const a=P.get(w.tunnelRemotePort);a&&(a.refcount--,await this.p(w.tunnelRemoteHost,w.tunnelRemotePort,a))}}}}async p(w,P,a){if(a.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${w}:${P}.`);const t=a.value.then(async r=>{r&&typeof r!="string"&&(await r.dispose(!0),this.b.fire({host:r.tunnelRemoteHost,port:r.tunnelRemotePort}))});return this.e.has(w)&&this.e.get(w).delete(P),t}}async closeTunnel(w,P){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${w}:${P} `);const a=this.e.get(w);if(a&&a.has(P)){const t=a.get(P);t.refcount=0,await this.p(w,P,t)}}q(w,P,a){this.e.has(w)||this.e.set(w,new Map),this.e.get(w).set(P,{refcount:1,value:a})}async r(w,P){const a=this.e.get(w);if(a){const t=a.get(P),r=t?await t.value:void 0;(!r||typeof r=="string")&&a.delete(P),a.size===0&&this.e.delete(w)}}s(w,P){const a=[w];m(w)?(a.push(...e.$gw),a.push(...e.$iw)):f(w)&&a.push(...e.$iw);const t=a.map(r=>this.e.get(r));for(const r of t){const s=r?.get(P);if(s)return s}}canTunnel(w){return!!b(w)}u(w,P,a,t,r,s,i){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${P}:${a} on local port ${t}.`);const o=a;this.j.add(o);const u=t===void 0?a:t,g={elevationRequired:r?this.isPortPrivileged(u):!1},S={remoteAddress:{host:P,port:a},localAddressPort:t,privacy:s,public:s?s!==h.Private:void 0,protocol:i},D=w.forwardPort(S,g);return D?(this.q(P,a,D),D.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(o)})):this.j.delete(o),D}};e.$mw=$,e.$mw=$=Ee([ie(0,j.$2j),ie(1,E.$2i)],$)}),define(re[50],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NX=e.$MX=e.DisablementReason=e.UpdateType=e.StateType=void 0;var C;(function(j){j.Uninitialized="uninitialized",j.Idle="idle",j.Disabled="disabled",j.CheckingForUpdates="checking for updates",j.AvailableForDownload="available for download",j.Downloading="downloading",j.Downloaded="downloaded",j.Updating="updating",j.Ready="ready"})(C||(e.StateType=C={}));var E;(function(j){j[j.Setup=0]="Setup",j[j.Archive=1]="Archive",j[j.Snap=2]="Snap"})(E||(e.UpdateType=E={}));var R;(function(j){j[j.NotBuilt=0]="NotBuilt",j[j.DisabledByEnvironment=1]="DisabledByEnvironment",j[j.ManuallyDisabled=2]="ManuallyDisabled",j[j.MissingConfiguration=3]="MissingConfiguration",j[j.InvalidConfiguration=4]="InvalidConfiguration",j[j.RunningAsAdmin=5]="RunningAsAdmin"})(R||(e.DisablementReason=R={})),e.$MX={Uninitialized:{type:"uninitialized"},Disabled:j=>({type:"disabled",reason:j}),Idle:(j,k)=>({type:"idle",updateType:j,error:k}),CheckingForUpdates:j=>({type:"checking for updates",explicit:j}),AvailableForDownload:j=>({type:"available for download",update:j}),Downloading:{type:"downloading"},Downloaded:j=>({type:"downloaded",update:j}),Updating:j=>({type:"updating",update:j}),Ready:j=>({type:"ready",update:j})},e.$NX=(0,n.$vi)("updateService")}),define(re[268],oe([0,1,4,191,52,45]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),R.$bo.as(E.$go.Configuration).registerConfiguration({id:"update",order:15,title:(0,C.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,C.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,C.localize)(2,null),(0,C.localize)(3,null),(0,C.localize)(4,null),(0,C.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,C.localize)(6,null),deprecationMessage:(0,C.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,C.localize)(8,null),description:(0,C.localize)(9,null),included:n.$i&&!n.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,C.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(re[269],oe([0,1,3,50]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hcc=e.$Gcc=void 0;class E{constructor(k){this.a=k}listen(k,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(k,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.$Gcc=E;class R{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new n.$ee,this.onStateChange=this.a.event,this.b=C.$MX.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.$Hcc=R}),define(re[40],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zl=void 0,e.$zl=(0,n.$vi)("IUriIdentityService")}),define(re[270],oe([0,1,40,210,16,19,142,3,2]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zs=void 0;class l{static{this._clock=0}constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let d=class{constructor(v){this.g=v,this.c=new h.$Uc,this.f=2**16;const m=new Map,f=y=>{let p=m.get(y.scheme);return p===void 0&&(p=v.hasProvider(y)&&!this.g.hasCapability(y,1024),m.set(y.scheme,p)),p};this.c.add(k.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(y=>{m.delete(y.scheme)})),this.extUri=new R.$Xg(f),this.d=new j.$ys((y,p)=>this.extUri.compare(y,p,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,R.$0g)(v));const m=this.d.get(v);return m?m.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((f,y)=>f[1].time<y[1].time?1:f[1].time>y[1].time?-1:0);l._clock=0,this.d.clear();const m=this.f*.5;for(let f=0;f<m;f++)this.d.set(v[f][0],v[f][1].touch())}};e.$zs=d,e.$zs=d=Ee([ie(0,E.$2k)],d),(0,C.$ws)(n.$zl,d,1)}),define(re[131],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DX=void 0,e.$DX=(0,n.$vi)("urlService")}),define(re[271],oe([0,1,7]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qcc=e.$Pcc=e.$Occ=void 0;class C{constructor(k){this.a=k}listen(k,h){throw new Error(`Event not found: ${h}`)}call(k,h,l){switch(h){case"handleURL":return this.a.handleURL(n.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.$Occ=C;class E{constructor(k){this.a=k}handleURL(k,h){return this.a.call("handleURL",[k.toJSON(),h])}}e.$Pcc=E;class R{constructor(k,h){this.a=k,this.b=h}async routeCall(k,h,l,d){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const b=n.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",b.toString(!0)),b.query){const v=/\bwindowId=(\d+)/.exec(b.query);if(v){const m=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${m}"`,b.toString(!0));const f=new RegExp(`window:${m}`),y=k.connections.find(p=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",p.ctx),f.test(p.ctx)));if(y)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",b.toString(!0)),y;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",b.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",b.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,h,l,d)}routeEvent(k,h){throw new Error(`Event not found: ${h}`)}}e.$Qcc=R}),define(re[272],oe([0,1,8,2,7,27]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FX=e.$EX=void 0;class j extends C.$Vc{constructor(){super(...arguments),this.a=new Set}open(l,d){const b=[...this.a.values()];return(0,n.$zh)(b.map(v=>()=>v.handleURL(l,d)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,C.$Tc)(()=>this.a.delete(l))}}e.$EX=j;let k=class extends j{constructor(l){super(),this.b=l}create(l){let{authority:d,path:b,query:v,fragment:m}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return d&&b&&b.indexOf("/")!==0&&(b=`/${b}`),E.URI.from({scheme:this.b.urlProtocol,authority:d,path:b,query:v,fragment:m})}};e.$FX=k,e.$FX=k=Ee([ie(0,R.$ik)],k)}),define(re[273],oe([0,1,14,8,3,2,4,7]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rcc=void 0;class h extends R.$Vc{constructor(d,b,v,m,f,y){if(super(),this.c=b,this.f=y,this.a=[],this.b=0,d&&(y.trace("ElectronURLListener initialUrisToHandle:",d.map(c=>c.originalUrl)),this.a=d),j.$i){const c=m.isBuilt?[]:[`"${m.appRoot}"`];c.push("--open-url","--"),n.app.setAsDefaultProtocolClient(f.urlProtocol,process.execPath,c)}const p=E.Event.map(E.Event.fromNodeEventEmitter(n.app,"open-url",(c,w)=>({event:c,url:w})),({event:c,url:w})=>(c.preventDefault(),w));this.B(p(c=>{const w=this.g(c);w&&this.c.open(w,{originalUrl:c})})),v.getWindows().filter(c=>c.isReady).length>0?(y.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(y.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(E.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(d){try{return k.URI.parse(d)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const d=[];for(const b of this.a)await this.c.open(b.uri,{originalUrl:b.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",b.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",b.originalUrl),d.push(b));d.length!==0&&(this.a=d,(0,C.$xh)(()=>this.h(),500,this.q))}}e.$Rcc=h}),define(re[274],oe([0,1,3,2,16,59,32]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdc=void 0;class k extends C.$Vc{constructor(l,d,b,v,m,f){super(),this.f=l,this.g=d,this.h=b,this.j=v,this.m=m,this.n=f,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new n.$ee),this.onDidChangeFile=this.a.event,this.b=R.$Bi.forUris(()=>!(this.capabilities&1024)),this.c=new j.$Cc(y=>this.m.extUri.getComparisonKey(this.t(y))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(y=>this.s(y)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,d){return this.g.open(this.t(l),d)}close(l){return this.g.close(l)}read(l,d,b,v,m){return this.g.read(l,d,b,v,m)}write(l,d,b,v,m){return this.g.write(l,d,b,v,m)}watch(l,d){this.b.set(l,l);const b=this.g.watch(this.t(l),d);return(0,C.$Tc)(()=>{this.b.delete(l),b.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,d,b){return this.g.rename(this.t(l),this.t(d),b)}readFile(l,d){return this.g.readFile(this.t(l),d)}readFileStream(l,d,b){return this.g.readFileStream(this.t(l),d,b)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,d,b){return this.g.writeFile(this.t(l),d,b)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,d){return this.g.delete(this.t(l),d)}copy(l,d,b){if((0,E.$6k)(this.g))return this.g.copy(this.t(l),this.t(d),b);throw new Error("copy not supported")}cloneFile(l,d){if((0,E.$7k)(this.g))return this.g.cloneFile(this.t(l),this.t(d));throw new Error("clone not supported")}s(l){const d=[];for(const b of l){if(b.resource.scheme!==this.f)continue;const v=this.u(b.resource);this.b.findSubstr(v)&&d.push({resource:v,type:b.type,cId:b.cId})}d.length&&(this.n.debug("User data changed"),this.a.fire(d))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$sdc=k}),define(re[275],oe([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_cc=void 0,e.$_cc="utilityProcessWorker"}),define(re[276],oe([0,1,6]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Scc=void 0,e.$Scc=(0,n.$vi)("webviewManagerService")}),define(re[277],oe([0,1,14,2,13,7]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tcc=void 0;class j extends C.$Vc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const h=this.b.bind(this);n.protocol.registerFileProtocol(E.Schemas.vscodeWebview,h)}b(h,l){try{const d=R.URI.parse(h.url),b=j.a.get(d.path);if(typeof b=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${b}`,m=E.$Pg.asFileUri(v);return l({path:m.fsPath,headers:{...E.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$Tcc=j}),define(re[55],oe([0,1,4]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomTitleBarVisibility=e.TitlebarStyle=e.TitleBarSetting=e.$tD=void 0,e.$uD=C,e.$vD=E,e.$wD=R,e.$xD=j,e.$yD=k,e.$zD=b,e.$AD=v,e.$BD=m,e.$CD=f,e.$DD=y,e.$ED=p,e.$tD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C($){return typeof $.parentId=="number"}function E($){return!!$.workspaceUri}function R($){return!!$.folderUri}function j($){return!!$.fileUri}function k($){const c=v($),w=$.getValue("window.menuBarVisibility");return w==="default"||c&&w==="compact"||n.$j&&n.$m?"classic":w}var h;(function($){$.TITLE_BAR_STYLE="window.titleBarStyle",$.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(h||(e.TitleBarSetting=h={}));var l;(function($){$.NATIVE="native",$.CUSTOM="custom"})(l||(e.TitlebarStyle=l={}));var d;(function($){$.AUTO="auto",$.WINDOWED="windowed",$.NEVER="never"})(d||(e.CustomTitleBarVisibility=d={}));function b($,c){return!0}function v($,c){return c||(c=m($)),c==="native"}function m($){if(n.$o)return"custom";const c=$.getValue("window");if(c){if(n.$j&&c.nativeTabs===!0||n.$j&&c.nativeFullScreen===!1)return"native";const a=c.titleBarStyle;if(a==="native"||a==="custom")return a}return n.$k?"native":"custom"}function f($){return!(!n.$i||n.$o||v($))}function y($){const c=$.getValue("window");return!c||typeof c.nativeFullScreen!="boolean"||c.nativeTabs?!0:c.nativeFullScreen!==!1}function p($=0){return Math.pow(1.2,$)}}),define(re[82],oe([0,1,14]),function(X,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$kbc=e.$jbc=e.UnloadReason=e.LoadReason=void 0;var C;(function(l){l[l.INITIAL=1]="INITIAL",l[l.LOAD=2]="LOAD",l[l.RELOAD=3]="RELOAD"})(C||(e.LoadReason=C={}));var E;(function(l){l[l.CLOSE=1]="CLOSE",l[l.QUIT=2]="QUIT",l[l.RELOAD=3]="RELOAD",l[l.LOAD=4]="LOAD"})(E||(e.UnloadReason=E={}));const R=function(l=1){return{width:1024,height:768,mode:l}};e.$jbc=R;const j=function(){const b=n.screen.getPrimaryDisplay().workArea,v=Math.max(b.x+b.width/2-800/2,0),m=Math.max(b.y+b.height/2-600/2,0);return{x:v,y:m,width:800,height:600,mode:1}};e.$kbc=j;var k;(function(l){l[l.Maximized=0]="Maximized",l[l.Normal=1]="Normal",l[l.Minimized=2]="Minimized",l[l.Fullscreen=3]="Fullscreen"})(k||(e.WindowMode=k={}));var h;(function(l){l[l.UNRESPONSIVE=1]="UNRESPONSIVE",l[l.PROCESS_GONE=2]="PROCESS_GONE",l[l.LOAD=3]="LOAD"})(h||(e.WindowError=h={}))}),define(re[278],oe([0,1,8,3,2]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zcc=void 0;class R extends E.$Vc{constructor({onDidOpenMainWindow:k,onDidFocusMainWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new E.$Uc),C.Event.latch(C.Event.any(k,h))(this.f,this,this.a),this.b=(0,n.$ih)(()=>l()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$Zcc=R}),define(re[30],oe([0,1,195,9,59,19,7,6,13]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Pi=e.$Oi=e.WorkbenchState=e.$Ii=e.$Hi=e.$Ei=void 0,e.$Fi=l,e.$Gi=d,e.$Ji=b,e.$Ki=v,e.$Li=m,e.$Mi=y,e.$Ni=p,e.$Qi=w,e.$Vi=P,e.$Wi=a,e.$Yi=t,e.$Zi=r,e.$1i=s,e.$Ei=(0,k.$vi)("contextService");function l(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.uri)}function d(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.$Hi={id:"ext-dev"},e.$Ii={id:"empty-window"};function b(i,o){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,C.$oc)(i)}:o?e.$Hi:e.$Ii;const u=i;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}function v(i){const o=i;return typeof o?.id=="string"&&j.URI.isUri(o.configPath)}function m(i){const o=i;if(o?.uri)return{id:o.id,uri:j.URI.revive(o.uri)};const u=i;if(u?.configPath)return{id:u.id,configPath:j.URI.revive(u.configPath)};if(i?.id)return{id:i.id}}var f;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function y(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}function p(i){const o=i;return!!(o&&typeof o=="object"&&j.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}class ${constructor(o,u,g,S,D){this.h=o,this.j=g,this.k=S,this.l=D,this.c=E.$Bi.forUris(this.l,()=>!0),this.folders=u}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=E.$Bi.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Oi=$;class c{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.$9g)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Pi=c;function w(i){return new c({uri:i,index:0,name:(0,R.$5g)(i)},{uri:i.toString()})}e.$Ri="code-workspace",e.$Si=`.${e.$Ri}`,e.$Ti=[{name:(0,n.localize)(0,null),extensions:[e.$Ri]}],e.$Ui="workspace.json";function P(i,o){return R.$Zg.isEqualOrParent(i,o.untitledWorkspacesHome)}function a(i){let o;return j.URI.isUri(i)?o=i:o=i.configuration,o?.scheme===h.Schemas.tmp}e.$Xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$Xi}function r(i,o){return!P(i,o)&&!a(i)}function s(i){return(typeof i=="string"?(0,C.$pc)(i):(0,R.$7g)(i))===e.$Si}}),define(re[56],oe([0,1,14,8,46,48,2,72,4,21,169,119,6,5,27,30]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sbc=e.$rbc=void 0,e.$rbc=(0,v.$vi)("dialogMainService");let p=class{constructor(c,w){this.d=c,this.e=w,this.a=new Map,this.b=new Map,this.c=new C.$Ch}pickFileFolder(c,w){return this.f({...c,pickFolders:!0,pickFiles:!0,title:(0,d.localize)(0,null)},w)}pickFolder(c,w){return this.f({...c,pickFolders:!0,title:(0,d.localize)(1,null)},w)}pickFile(c,w){return this.f({...c,pickFiles:!0,title:(0,d.localize)(2,null)},w)}pickWorkspace(c,w){const P=(0,d.localize)(3,null),a=(0,R.$Dw)((0,d.localize)(4,null)),t=y.$Ti;return this.f({...c,pickFiles:!0,title:P,filters:t,buttonLabel:a},w)}async f(c,w){const P={title:c.title,buttonLabel:c.buttonLabel,filters:c.filters,defaultPath:c.defaultPath};(typeof c.pickFiles=="boolean"||typeof c.pickFolders=="boolean")&&(P.properties=void 0,c.pickFiles&&c.pickFolders&&(P.properties=["multiSelections","openDirectory","openFile","createDirectory"])),P.properties||(P.properties=["multiSelections",c.pickFolders?"openDirectory":"openFile","createDirectory"]),h.$j&&P.properties.push("treatPackageAsDirectory");const a=await this.showOpenDialog(P,(w||n.BrowserWindow.getFocusedWindow())??void 0);if(a&&a.filePaths&&a.filePaths.length>0)return a.filePaths}g(c){if(c){let w=this.b.get(c.id);return w||(w=new C.$Ch,this.b.set(c.id,w)),w}else return this.c}showMessageBox(c,w){return this.g(w).queue(async()=>{const{options:P,buttonIndeces:a}=(0,b.$Kw)(c,this.e);let t;return w?t=await n.dialog.showMessageBox(w,P):t=await n.dialog.showMessageBox(P),{response:a[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(c,w){const P=this.j(c,w);if(!P)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(w).queue(async()=>{let a;return w?a=await n.dialog.showSaveDialog(w,c):a=await n.dialog.showSaveDialog(c),a.filePath=this.h(a.filePath),a})}finally{(0,j.$Qc)(P)}}h(c){return c&&h.$j&&(c=(0,k.$am)(c)),c}i(c){return c.map(w=>this.h(w))}async showOpenDialog(c,w){c.defaultPath&&(await l.Promises.exists(c.defaultPath)||(c.defaultPath=void 0));const P=this.j(c,w);if(!P)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(w).queue(async()=>{let a;return w?a=await n.dialog.showOpenDialog(w,c):a=await n.dialog.showOpenDialog(c),a.filePaths=this.i(a.filePaths),a})}finally{(0,j.$Qc)(P)}}j(c,w){if(!w)return j.$Vc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",c);let P=this.a.get(w.id);P||(P=new Set,this.a.set(w.id,P));const a=(0,E.$jj)(c);if(!P.has(a))return this.d.trace("[DialogMainService]: new file dialog lock created",c),P.add(a),(0,j.$Tc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",c),P?.delete(a),P?.size===0&&this.a.delete(w.id)})}};e.$sbc=p,e.$sbc=p=Ee([ie(0,m.$2j),ie(1,f.$ik)],p)}),define(re[279],oe([0,1,3,2,77,30]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dcc=void 0;class j extends C.$Vc{static{this.a=100}constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new n.$ee),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(n.Event.debounce(h.onDidChangeStorage,(d,b)=>(d?d.push(b):d=[b],d),j.a)(d=>{d.length&&l.fire(this.j(d,h))}))}j(h,l){const d=new Map,b=new Set;return h.forEach(v=>{const m=l.get(v.key);typeof m=="string"?d.set(v.key,m):b.add(v.key)}),{changed:Array.from(d.entries()),deleted:Array.from(b.values())}}listen(h,l,d){switch(l){case"onDidChangeStorage":{const b=d.profile?(0,E.$5h)(d.profile):void 0;if(!b)return this.b.event;let v=this.c.get(b.id);return v||(v=this.B(new n.$ee),this.h(this.g.profileStorage(b),v),this.c.set(b.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,d){const b=d.profile?(0,E.$5h)(d.profile):void 0,v=(0,R.$Li)(d.workspace),m=await this.m(b,v);switch(l){case"getItems":return Array.from(m.items.entries());case"updateItems":{const f=d;if(f.insert)for(const[y,p]of f.insert)m.set(y,p);f.delete?.forEach(y=>m.delete(y));break}case"optimize":return m.optimize();case"isUsed":{const f=d.payload;if(typeof f=="string")return this.g.isUsed(f)}default:throw new Error(`Call not found: ${l}`)}}async m(h,l){let d;l?d=this.g.workspaceStorage(l):h?d=this.g.profileStorage(h):d=this.g.applicationStorage;try{await d.init()}catch(b){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${b}`)}return d}}e.$Dcc=j}),define(re[41],oe([0,1,46,3,2,19,7,192,38,16,6,5,30,32,40,8,33,25,12]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fl=e.$El=e.$Bl=e.ProfileResourceType=void 0,e.$Al=P,e.$Cl=a,e.$Dl=t;var w;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(w||(e.ProfileResourceType=w={}));function P(i){const o=i;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&typeof o.isDefault=="boolean"&&typeof o.name=="string"&&j.URI.isUri(o.location)&&j.URI.isUri(o.globalStorageHome)&&j.URI.isUri(o.settingsResource)&&j.URI.isUri(o.keybindingsResource)&&j.URI.isUri(o.tasksResource)&&j.URI.isUri(o.snippetsHome)&&j.URI.isUri(o.extensionsResource))}e.$Bl=(0,d.$vi)("IUserDataProfilesService");function a(i,o){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:j.URI.revive(i.location).with({scheme:o}),globalStorageHome:j.URI.revive(i.globalStorageHome).with({scheme:o}),settingsResource:j.URI.revive(i.settingsResource).with({scheme:o}),keybindingsResource:j.URI.revive(i.keybindingsResource).with({scheme:o}),tasksResource:j.URI.revive(i.tasksResource).with({scheme:o}),snippetsHome:j.URI.revive(i.snippetsHome).with({scheme:o}),extensionsResource:j.URI.revive(i.extensionsResource).with({scheme:o}),cacheHome:j.URI.revive(i.cacheHome).with({scheme:o}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}function t(i,o,u,g,S,D){return{id:i,name:o,location:u,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:D&&S?.useDefaultFlags?.globalState?D.globalStorageHome:(0,R.$9g)(u,"globalStorage"),settingsResource:D&&S?.useDefaultFlags?.settings?D.settingsResource:(0,R.$9g)(u,"settings.json"),keybindingsResource:D&&S?.useDefaultFlags?.keybindings?D.keybindingsResource:(0,R.$9g)(u,"keybindings.json"),tasksResource:D&&S?.useDefaultFlags?.tasks?D.tasksResource:(0,R.$9g)(u,"tasks.json"),snippetsHome:D&&S?.useDefaultFlags?.snippets?D.snippetsHome:(0,R.$9g)(u,"snippets"),extensionsResource:D&&S?.useDefaultFlags?.extensions?D.extensionsResource:(0,R.$9g)(u,"extensions.json"),cacheHome:(0,R.$9g)(g,i),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends E.$Vc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(o,u,g,S){super(),this.t=o,this.u=u,this.w=g,this.y=S,this.f=!0,this.h=this.B(new C.$ee),this.onDidChangeProfiles=this.h.event,this.j=this.B(new C.$ee),this.onWillCreateProfile=this.j.event,this.m=this.B(new C.$ee),this.onWillRemoveProfile=this.m.event,this.n=this.B(new C.$ee),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new m.$Bc,emptyWindows:new Map},this.profilesHome=(0,R.$9g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,R.$9g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(o){this.f!==o&&(this.z=void 0,this.f=o)}isEnabled(){return this.f}get C(){if(!this.z){const o=this.D(),u=[o];if(this.f)try{for(const D of this.O()){if(!D.name||!(0,c.$8f)(D.name)||!D.location){this.y.warn("Skipping the invalid stored profile",D.location||D.name);continue}u.push(t((0,R.$6g)(D.location),D.name,D.location,this.g,{shortName:D.shortName,icon:D.icon,useDefaultFlags:D.useDefaultFlags},o))}}catch(D){this.y.error(D)}const g=new m.$Bc,S=new Map;if(u.length)try{const D=this.Q();if(D.workspaces)for(const[I,O]of Object.entries(D.workspaces)){const M=j.URI.parse(I),W=u.find(F=>F.id===O);W&&g.set(M,W)}if(D.emptyWindows)for(const[I,O]of Object.entries(D.emptyWindows)){const M=u.find(W=>W.id===O);M&&S.set(I,M)}}catch(D){this.y.error(D)}this.z={profiles:u,workspaces:g,emptyWindows:S}}return this.z}D(){const o=t("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...o,extensionsResource:this.S()??o.extensionsResource,isDefault:!0}}async createTransientProfile(o){const u="Temp",g=new RegExp(`${(0,$.$_e)(u)}\\s(\\d+)`);let S=0;for(const I of this.profiles){const O=g.exec(I.name),M=O?parseInt(O[1]):0;S=M>S?M:S}const D=`${u} ${S+1}`;return this.createProfile((0,n.$jj)((0,p.$Rg)()).toString(16),D,{transient:!0},o)}async createNamedProfile(o,u,g){return this.createProfile((0,n.$jj)((0,p.$Rg)()).toString(16),o,u,g)}async createProfile(o,u,g,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const D=await this.F(o,u,g);return S&&await this.setProfileForWorkspace(S,D),D}async F(o,u,g){if(!(0,c.$8f)(u)||!u)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(u);return S||(S=(async()=>{try{if(this.profiles.find(M=>M.name===u||M.id===o))throw new Error(`Profile with ${u} name already exists`);const I=t(o,u,(0,R.$9g)(this.profilesHome,o),this.g,g,this.defaultProfile);await this.u.createFolder(I.location);const O=[];return this.j.fire({profile:I,join(M){O.push(M)}}),await y.Promises.settled(O),this.I([I],[],[]),I}finally{this.r.delete(u)}})(),this.r.set(u,S)),S}async updateProfile(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let g=this.profiles.find(S=>S.id===o.id);if(!g)throw new Error(`Profile '${o.name}' does not exist`);return g=t(g.id,u.name??g.name,g.location,this.g,{shortName:u.shortName??g.shortName,icon:u.icon===null?void 0:u.icon??g.icon,transient:u.transient??g.isTransient,useDefaultFlags:u.useDefaultFlags??g.useDefaultFlags},this.defaultProfile),this.I([],[],[g]),g}async removeProfile(o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(o.isDefault)throw new Error("Cannot remove default profile");const u=this.profiles.find(S=>S.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);const g=[];this.m.fire({profile:u,join(S){g.push(S)}});try{await Promise.allSettled(g)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])u.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])u.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[u],[]);try{await this.u.del(u.cacheHome,{recursive:!0})}catch(S){(0,l.$gl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const g=this.profiles.find(S=>S.id===u.id);if(!g)throw new Error(`Profile '${u.name}' does not exist`);this.L(o,g)}unsetWorkspace(o,u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(o,void 0,u)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const o=await this.u.resolve(this.profilesHome);await Promise.all((o.children||[]).filter(u=>u.isDirectory&&this.profiles.every(g=>!this.w.extUri.isEqual(g.location,u.resource))).map(u=>this.u.del(u.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const o=this.s.profiles.filter(u=>!this.H(u));await Promise.allSettled(o.map(u=>this.removeProfile(u)))}getProfileForWorkspace(o){const u=this.G(o);return j.URI.isUri(u)?this.s.workspaces.get(u)??this.C.workspaces.get(u):this.s.emptyWindows.get(u)??this.C.emptyWindows.get(u)}G(o){return(0,v.$Fi)(o)?o.uri:(0,v.$Ki)(o)?o.configPath:o.id}H(o){return!!([...this.s.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.s.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.emptyWindows.values()].some(u=>this.w.extUri.isEqual(u.location,o.location))||[...this.C.workspaces.values()].some(u=>this.w.extUri.isEqual(u.location,o.location)))}I(o,u,g){const S=[...this.profiles,...o],D=[];this.s.profiles=[];for(let I of S)I.isDefault||u.some(O=>I.id===O.id)||(I=g.find(O=>I.id===O.id)??I,I.isTransient?this.s.profiles.push(I):D.push({location:I.location,name:I.name,shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags}));this.P(D),this.z=void 0,this.J(o,u,g)}J(o,u,g){this.h.fire({added:o,removed:u,updated:g,all:this.profiles})}L(o,u,g){g=u?.isTransient?!0:g,g||this.L(o,void 0,!0);const S=this.G(o),D=g?this.s:this.C;j.URI.isUri(S)?(D.workspaces.delete(S),u&&D.workspaces.set(S,u)):(D.emptyWindows.delete(S),u&&D.emptyWindows.set(S,u)),g||this.M()}M(){const o={};for(const[g,S]of this.C.workspaces.entries())o[g.toString()]=S.id;const u={};for(const[g,S]of this.C.emptyWindows.entries())u[g.toString()]=S.id;this.R({workspaces:o,emptyWindows:u}),this.z=void 0}N(o){const u={},g=this.D();if(o.workspaces)for(const[D,I]of Object.entries(o.workspaces)){const O=j.URI.parse(I);u[D]=this.w.extUri.isEqual(O,g.location)?g.id:this.w.extUri.basename(O)}const S={};if(o.emptyWindows)for(const[D,I]of Object.entries(o.emptyWindows)){const O=j.URI.parse(I);S[D]=this.w.extUri.isEqual(O,g.location)?g.id:this.w.extUri.basename(O)}return{workspaces:u,emptyWindows:S}}O(){return[]}P(o){throw new Error("not implemented")}Q(){return{}}R(o){throw new Error("not implemented")}S(){}};e.$El=r,e.$El=r=Ee([ie(0,h.$Ci),ie(1,l.$2k),ie(2,f.$zl),ie(3,b.$2j)],r);class s extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(o){this.a=o}Q(){return this.X}R(o){this.X=o}}e.$Fl=s}),define(re[83],oe([0,1,8,17,2,3,32,7,121,127,16,6,5,41,40,12,15,28]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pq=e.$oq=e.$nq=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class w extends Error{constructor(s,i){super(s),this.code=i}}e.$nq=w,e.$oq=(0,b.$vi)("IExtensionsProfileScannerService");let P=class extends E.$Vc{constructor(s,i,o,u,g,S){super(),this.j=s,this.m=i,this.n=o,this.r=u,this.s=g,this.t=S,this.b=this.B(new R.$ee),this.onAddExtensions=this.b.event,this.c=this.B(new R.$ee),this.onDidAddExtensions=this.c.event,this.f=this.B(new R.$ee),this.onRemoveExtensions=this.f.event,this.g=this.B(new R.$ee),this.onDidRemoveExtensions=this.g.event,this.h=new j.$Bc}scanProfileExtensions(s,i){return this.u(s,void 0,i)}async addExtensionsToProfile(s,i,o){const u=[],g=[];try{return await this.u(i,S=>{const D=[];if(o)D.push(...S);else for(const I of S)s.some(([O])=>(0,l.$tp)(O.identifier,I.identifier)&&O.manifest.version!==I.version)?u.push(I):D.push(I);for(const[I,O]of s){const M=D.findIndex(F=>(0,l.$tp)(F.identifier,I.identifier)&&F.version===I.manifest.version),W={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:O};M===-1?(g.push(W),D.push(W)):D.splice(M,1,W)}return g.length&&this.b.fire({extensions:g,profileLocation:i}),u.length&&this.f.fire({extensions:u,profileLocation:i}),D}),g.length&&this.c.fire({extensions:g,profileLocation:i}),u.length&&this.g.fire({extensions:u,profileLocation:i}),g}catch(S){throw g.length&&this.c.fire({extensions:g,error:S,profileLocation:i}),u.length&&this.g.fire({extensions:u,error:S,profileLocation:i}),S}}async updateMetadata(s,i){const o=[];return await this.u(i,u=>{const g=[];for(const S of u){const D=s.find(([I])=>(0,l.$tp)(I.identifier,S.identifier)&&I.manifest.version===S.version);D&&(S.metadata={...S.metadata,...D[1]},o.push(S)),g.push(S)}return g}),o}async removeExtensionFromProfile(s,i){const o=[];try{await this.u(i,u=>{const g=[];for(const S of u)(0,l.$tp)(S.identifier,s.identifier)?o.push(S):g.push(S);return o.length&&this.f.fire({extensions:o,profileLocation:i}),g}),o.length&&this.g.fire({extensions:o,profileLocation:i})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:i}),u}}async u(s,i,o){return this.F(s).queue(async()=>{let u=[],g;try{const S=await this.m.readFile(s);g=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,d.$gl)(S)!==1)throw S;if(this.r.extUri.isEqual(s,this.n.defaultProfile.extensionsResource)&&(g=await this.D()),!g&&o?.bailOutWhenFileNotFound)throw new w((0,p.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(g){Array.isArray(g)||this.w(s);let S=!1;for(const D of g){a(D)||this.w(s);let I;if((0,y.$8f)(D.relativeLocation)&&D.relativeLocation)I=this.z(D.relativeLocation);else if((0,y.$8f)(D.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${D.location}`);continue}else{I=k.URI.revive(D.location);const O=this.y(I);O&&(S=!0,D.relativeLocation=O)}(0,y.$cg)(D.metadata?.hasPreReleaseVersion)&&D.metadata?.preRelease&&(S=!0,D.metadata.hasPreReleaseVersion=!0),u.push({identifier:D.identifier,location:I,version:D.version,metadata:D.metadata})}S&&await this.m.writeFile(s,C.$Fe.fromString(JSON.stringify(g)))}if(i){u=i(u);const S=u.map(D=>({identifier:D.identifier,version:D.version,location:D.location.toJSON(),relativeLocation:this.y(D.location),metadata:D.metadata}));await this.m.writeFile(s,C.$Fe.fromString(JSON.stringify(S)))}return u})}w(s){const i=new w(`Invalid extensions content in ${s.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(s){return this.r.extUri.isEqual(this.r.extUri.dirname(s),this.j)?this.r.extUri.basename(s):void 0}z(s){return this.r.extUri.joinPath(this.j,s)}async D(){return this.C||(this.C=(async()=>{const s=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let o;try{o=(await this.m.readFile(s)).value.toString()}catch(g){if((0,d.$gl)(g)===1)return;throw g}this.t.info("Migrating extensions from old default profile location",s.toString());let u;try{const g=JSON.parse(o);Array.isArray(g)&&g.every(S=>a(S))?u=g:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",g)}catch(g){this.t.error(g)}if(u)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,C.$Fe.fromString(JSON.stringify(u)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",s.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(g){if((0,d.$gl)(g)===3)this.t.info("Migration from old default profile location to new location is done by another window",s.toString(),this.n.defaultProfile.extensionsResource.toString());else throw g}try{await this.m.del(s)}catch(g){(0,d.$gl)(g)!==1&&this.t.error(g)}try{await this.m.del(i)}catch(g){(0,d.$gl)(g)!==1&&this.t.error(g)}return u})()),this.C}F(s){let i=this.h.get(s);return i||(i=new n.$Ch,this.h.set(s,i)),i}};e.$pq=P,e.$pq=P=Ee([ie(1,d.$2k),ie(2,m.$Bl),ie(3,f.$zl),ie(4,$.$1l),ie(5,v.$2j)],P);function a(r){return(0,y.$0f)(r)&&(0,h.$4o)(r.identifier)&&(t(r.location)||(0,y.$8f)(r.location)&&r.location)&&((0,y.$cg)(r.relativeLocation)||(0,y.$8f)(r.relativeLocation))&&r.version&&(0,y.$8f)(r.version)}function t(r){return r?(0,y.$8f)(r.path)&&(0,y.$8f)(r.scheme):!1}}),define(re[132],oe([0,1,22,8,35,17,15,42,154,2,13,9,4,19,208,74,12,7,174,38,127,124,207,16,6,5,27,3,77,83,41,40,206]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$uq=e.$tq=e.$sq=e.Translations=void 0,e.$vq=ue;var M;(function(ce){function K(Q,B){if(Q===B)return!0;const L=Object.keys(Q),z=new Set;for(const U of Object.keys(B))z.add(U);if(L.length!==z.size)return!1;for(const U of L){if(Q[U]!==B[U])return!1;z.delete(U)}return z.size===0}ce.equals=K})(M||(e.Translations=M={})),e.$sq=(0,s.$vi)("IExtensionsScannerService");let W=class extends l.$Vc{constructor(K,Q,B,L,z,U,ae,G,le,Y,A,N){super(),this.systemExtensionsLocation=K,this.userExtensionsLocation=Q,this.r=B,this.s=L,this.t=z,this.u=U,this.w=ae,this.y=G,this.z=le,this.C=Y,this.D=A,this.F=N,this.g=this.B(new u.$ee),this.onDidChangeCache=this.g.event,this.h=(0,m.$9g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(q,this.s,this.h)),this.m=this.B(this.F.createInstance(q,this.s,this.h)),this.n=this.B(this.F.createInstance(T,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,P.$Ep)(this.w,this.y)),this.G}async scanAllExtensions(K,Q,B){const[L,z]=await Promise.all([this.scanSystemExtensions(K),this.scanUserExtensions(Q)]),U=B?await this.scanExtensionsUnderDevelopment(K,[...L,...z]):[];return this.L(L,z,U,await this.getTargetPlatform(),!0)}async scanSystemExtensions(K){const Q=[];Q.push(this.M(!!K.useCache,K.language)),Q.push(this.N(K.language,!!K.checkControlFile));const[B,L]=await Promise.all(Q);return this.J([...B,...L],0,K,!1)}async scanUserExtensions(K){const Q=K.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const B=this.D.extUri.isEqual(K.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Q,!!K.profileLocation,1,!K.includeUninstalled,K.language,!0,B,K.productVersion??this.R()),z=K.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let U;try{U=await z.scanExtensions(L)}catch(ae){if(ae instanceof S.$nq&&ae.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),U=await z.scanExtensions(L);else throw ae}return U=await this.J(U,1,K,!0),this.y.trace("Scanned user extensions:",U.length),U}async scanExtensionsUnderDevelopment(K,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===d.Schemas.file).map(async L=>{const z=await this.P(L,!1,1,!0,K.language,!1,void 0,K.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(z)).map(ae=>(ae.type=Q.find(G=>(0,P.$tp)(G.identifier,ae.identifier))?.type??ae.type,this.n.validate(ae,z)))}))).flat();return this.J(B,"development",K,!0)}return[]}async scanExistingExtension(K,Q,B){const L=await this.P(K,!1,Q,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanExtension(L);return!z||!B.includeInvalid&&!z.isValid?null:z}async scanOneOrMultipleExtensions(K,Q,B){const L=await this.P(K,!1,Q,!0,B.language,!0,void 0,B.productVersion??this.R()),z=await this.n.scanOneOrMultipleExtensions(L);return this.J(z,Q,B,!0)}async scanMultipleExtensions(K,Q,B){const L=[];return await Promise.all(K.map(async z=>{const U=await this.scanOneOrMultipleExtensions(z,Q,B);L.push(...U)})),this.J(L,Q,B,!0)}async scanMetadata(K){const Q=(0,m.$9g)(K,"package.json"),B=(await this.w.readFile(Q)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(K,Q){const B=(0,m.$9g)(K,"package.json"),L=(await this.w.readFile(B)).value.toString(),z=JSON.parse(L);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,z.__metadata={...z.__metadata,...Q},await this.w.writeFile((0,m.$9g)(K,"package.json"),R.$Fe.fromString(JSON.stringify(z,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(K){if(K instanceof S.$nq&&K.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw K}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const K=await this.scanUserExtensions({includeInvalid:!0});if(K.length)await this.u.addExtensionsToProfile(K.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,R.$Fe.fromString(JSON.stringify([])))}catch(Q){(0,r.$gl)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,j.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(K){this.y.error(K)}finally{this.H=void 0}})()),this.H}async J(K,Q,B,L){return B.includeAllVersions||(K=this.L(Q===0?K:void 0,Q===1?K:void 0,Q==="development"?K:void 0,await this.getTargetPlatform(),L)),B.includeInvalid||(K=K.filter(z=>z.isValid)),K.sort((z,U)=>{const ae=b.$oc(z.location.fsPath),G=b.$oc(U.location.fsPath);return ae<G?-1:ae>G?1:0})}L(K,Q,B,L,z){const U=(G,le,Y)=>{if(G.isValid&&!le.isValid)return!1;if(G.isValid===le.isValid){if(z&&f.gt(G.manifest.version,le.manifest.version))return this.y.debug(`Skipping extension ${le.location.path} with lower version ${le.manifest.version} in favour of ${G.location.path} with version ${G.manifest.version}`),!1;if(f.eq(G.manifest.version,le.manifest.version)){if(G.type===0)return this.y.debug(`Skipping extension ${le.location.path} in favour of system extension ${G.location.path} with same version`),!1;if(G.targetPlatform===L)return this.y.debug(`Skipping extension ${le.location.path} from different target platform ${le.targetPlatform}`),!1}}return Y?this.y.warn(`Overwriting user extension ${G.location.path} with ${le.location.path}.`):this.y.debug(`Overwriting user extension ${G.location.path} with ${le.location.path}.`),!0},ae=new a.$Sm;return K?.forEach(G=>{const le=ae.get(G.identifier.id);(!le||U(le,G,!1))&&ae.set(G.identifier.id,G)}),Q?.forEach(G=>{const le=ae.get(G.identifier.id);if(!le&&K&&G.type===0){this.y.debug(`Skipping obsolete system extension ${G.location.path}.`);return}(!le||U(le,G,!1))&&ae.set(G.identifier.id,G)}),B?.forEach(G=>{const le=ae.get(G.identifier.id);(!le||U(le,G,!0))&&ae.set(G.identifier.id,G),ae.set(G.identifier.id,G)}),[...ae.values()]}async M(K,Q){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0,this.R()),z=await(K&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",z.length),z}async N(K,Q){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Q?await this.O():{},z=[],U=$.URI.file(b.$ic(b.$kc(d.$Pg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const G of B){const le=L[G.name]||"marketplace";switch(le){case"disabled":break;case"marketplace":z.push((0,m.$9g)(U,G.name));break;default:z.push($.URI.file(le));break}}const ae=await Promise.all(z.map(async G=>this.n.scanExtension(await this.P(G,!1,0,!0,K,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",ae.length),(0,n.$Hb)(ae)}async O(){try{const K=await this.w.readFile(this.r);return JSON.parse(K.value.toString())}catch{return{}}}async P(K,Q,B,L,z,U,ae,G){const le=await this.f(z??v.$w),Y=await this.Q(K),A=Q&&!this.D.extUri.isEqual(K,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,N=A?await this.Q(A):void 0;return new F(K,Y,A,N,Q,ae,B,L,U,G.version,G.date,this.C.commit,!this.z.isBuilt,z,le)}async Q(K){try{const Q=await this.w.stat(K);if(typeof Q.mtime=="number")return Q.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$tq=W,e.$tq=W=Ee([ie(4,D.$Bl),ie(5,S.$oq),ie(6,r.$2k),ie(7,i.$2j),ie(8,w.$Ci),ie(9,o.$ik),ie(10,I.$zl),ie(11,s.$ui)],W);class F{constructor(K,Q,B,L,z,U,ae,G,le,Y,A,N,_,ne,J){this.location=K,this.mtime=Q,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=L,this.profile=z,this.profileScanOptions=U,this.type=ae,this.excludeObsolete=G,this.validate=le,this.productVersion=Y,this.productDate=A,this.productCommit=N,this.devMode=_,this.language=ne,this.translations=J}static createNlsConfiguration(K){return{language:K.language,pseudo:K.language==="pseudo",devMode:K.devMode,translations:K.translations}}static equals(K,Q){return(0,m.$2g)(K.location,Q.location)&&K.mtime===Q.mtime&&(0,m.$2g)(K.applicationExtensionslocation,Q.applicationExtensionslocation)&&K.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&K.profile===Q.profile&&E.$6n(K.profileScanOptions,Q.profileScanOptions)&&K.type===Q.type&&K.excludeObsolete===Q.excludeObsolete&&K.validate===Q.validate&&K.productVersion===Q.productVersion&&K.productDate===Q.productDate&&K.productCommit===Q.productCommit&&K.devMode===Q.devMode&&K.language===Q.language&&M.equals(K.translations,Q.translations)}}e.$uq=F;let T=class extends l.$Vc{constructor(K,Q,B,L,z){super(),this.f=K,this.g=Q,this.h=B,this.j=L,this.m=z}async scanExtensions(K){const Q=K.profile?await this.r(K):await this.n(K);let B={};if(K.excludeObsolete&&K.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(L)}catch{}return(0,p.$ig)(B)?Q:Q.filter(L=>!B[P.$up.create(L).toString()])}async n(K){const Q=await this.j.resolve(K.location);if(!Q.children?.length)return[];const B=await Promise.all(Q.children.map(async L=>{if(!L.isDirectory||K.type===1&&(0,m.$6g)(L.resource).indexOf(".")===0)return null;const z=new F(L.resource,K.mtime,K.applicationExtensionslocation,K.applicationExtensionslocationMtime,K.profile,K.profileScanOptions,K.type,K.excludeObsolete,K.validate,K.productVersion,K.productDate,K.productCommit,K.devMode,K.language,K.translations);return this.scanExtension(z)}));return(0,n.$Hb)(B).sort((L,z)=>L.location.path<z.location.path?-1:1)}async r(K){let Q=await this.s(K.location,()=>!0,K);if(K.applicationExtensionslocation&&!this.h.extUri.isEqual(K.location,K.applicationExtensionslocation)){Q=Q.filter(L=>!L.metadata?.isApplicationScoped);const B=await this.s(K.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,K);Q.push(...B)}return Q}async s(K,Q,B){const L=await this.g.scanProfileExtensions(K,B.profileScanOptions);if(!L.length)return[];const z=await Promise.all(L.map(async U=>{if(Q(U)){const ae=new F(U.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(ae,U.metadata)}return null}));return(0,n.$Hb)(z)}async scanOneOrMultipleExtensions(K){try{if(await this.j.exists((0,m.$9g)(K.location,"package.json"))){const Q=await this.scanExtension(K);return Q?[Q]:[]}else return await this.scanExtensions(K)}catch(Q){return this.m.error(`Error scanning extensions at ${K.location.path}:`,(0,j.$0)(Q)),[]}}async scanExtension(K,Q){try{let B=await this.scanExtensionManifest(K.location);if(B){B.publisher||(B.publisher=a.$Mm),Q=Q??B.__metadata,delete B.__metadata;const L=(0,P.$yp)(B.publisher,B.name),z=Q?.id?{id:L,uuid:Q.id}:{id:L},U=Q?.isSystem?0:K.type,ae=U===0||!!Q?.isBuiltin;B=await this.t(K.location,B,F.createNlsConfiguration(K));const G={type:U,identifier:z,manifest:B,location:K.location,isBuiltin:ae,targetPlatform:Q?.targetPlatform??"undefined",publisherDisplayName:Q?.publisherDisplayName,metadata:Q,isValid:!0,validations:[]};return K.validate?this.validate(G,K):G}}catch(B){K.type!==0&&this.m.error(B)}return null}validate(K,Q){let B=!0;const L=(0,t.$Jp)(Q.productVersion,Q.productDate,Q.location,K.manifest,K.isBuiltin);for(const[z,U]of L)z===y.default.Error&&(B=!1,this.m.error(this.z(Q.location,U)));return K.isValid=B,K.validations=L,K}async scanExtensionManifest(K){const Q=(0,m.$9g)(K,"package.json");let B;try{B=(await this.j.readFile(Q)).value.toString()}catch(z){return(0,r.$gl)(z)!==1&&this.m.error(this.z(K,(0,c.localize)(0,null,Q.path,z.message))),null}let L;try{L=JSON.parse(B)}catch{const U=[];(0,k.$In)(B,U);for(const ae of U)this.m.error(this.z(K,(0,c.localize)(1,null,Q.path,ae.offset,ae.length,(0,h.$qq)(ae.error))));return null}return(0,k.$Rn)(L)!=="object"?(this.m.error(this.z(K,(0,c.localize)(2,null,Q.path))),null):L}async t(K,Q,B){const L=await this.u(K,Q,B);if(L)try{const z=[],U=await this.w(L.default,z);if(z.length>0)return z.forEach(G=>{this.m.error(this.z(K,(0,c.localize)(3,null,L.default?.path,(0,h.$qq)(G.error))))}),Q;if((0,k.$Rn)(L)!=="object")return this.m.error(this.z(K,(0,c.localize)(4,null,L.default?.path))),Q;const ae=L.values||Object.create(null);return(0,O.$rq)(this.m,Q,ae,U)}catch{}return Q}async u(K,Q,B){const L=(0,m.$9g)(K,"package.nls.json"),z=(le,Y)=>{Y.forEach(A=>{this.m.error(this.z(K,(0,c.localize)(5,null,le?.path,(0,h.$qq)(A.error))))})},U=le=>{this.m.error(this.z(K,(0,c.localize)(6,null,le?.path)))},ae=`${Q.publisher}.${Q.name}`,G=B.translations[ae];if(G)try{const le=$.URI.file(G),Y=(await this.j.readFile(le)).value.toString(),A=[],N=(0,k.$In)(Y,A);return A.length>0?(z(le,A),{values:void 0,default:L}):(0,k.$Rn)(N)!=="object"?(U(le),{values:void 0,default:L}):{values:N.contents?N.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let Y;try{Y=await this.y(K,B)}catch{return}if(!Y.localized)return{values:void 0,default:Y.original};try{const A=(await this.j.readFile(Y.localized)).value.toString(),N=[],_=(0,k.$In)(A,N);return N.length>0?(z(Y.localized,N),{values:void 0,default:Y.original}):(0,k.$Rn)(_)!=="object"?(U(Y.localized),{values:void 0,default:Y.original}):{values:_,default:Y.original}}catch{return{values:void 0,default:Y.original}}}}async w(K,Q){if(K)try{const B=(await this.j.readFile(K)).value.toString();return(0,k.$In)(B,Q)}catch{}}y(K,Q){return new Promise((B,L)=>{const z=U=>{const ae=(0,m.$9g)(K,`package.nls.${U}.json`);this.j.exists(ae).then(G=>{G&&B({localized:ae,original:(0,m.$9g)(K,"package.nls.json")});const le=U.lastIndexOf("-");le===-1?B({localized:(0,m.$9g)(K,"package.nls.json"),original:null}):(U=U.substring(0,le),z(U))})};if(Q.devMode||Q.pseudo||!Q.language)return B({localized:(0,m.$9g)(K,"package.nls.json"),original:null});z(Q.language)})}z(K,Q){return`[${K.path}]: ${Q}`}};T=Ee([ie(1,S.$oq),ie(2,I.$zl),ie(3,r.$2k),ie(4,i.$2j)],T);let q=class extends T{constructor(K,Q,B,L,z,U,ae){super(Q,L,z,U,ae),this.G=K,this.H=B,this.D=this.B(new C.$th(3e3)),this.F=this.B(new u.$ee),this.onDidChangeCache=this.F.event}async scanExtensions(K){const Q=this.M(K),B=await this.I(Q);if(this.C=K,B&&B.input&&F.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",K.location.toString()),this.D.trigger(()=>this.L()),B.result.map(z=>(z.location=$.URI.revive(z.location),z));const L=await super.scanExtensions(K);return await this.J(Q,{input:K,result:L}),L}async I(K){try{const Q=await this.j.readFile(K),B=JSON.parse(Q.value.toString());return{result:B.result,input:(0,g.$5h)(B.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",K.path,(0,j.$0)(Q))}return null}async J(K,Q){try{await this.j.writeFile(K,R.$Fe.fromString(JSON.stringify(Q)))}catch(B){this.m.debug("Error while writing the extension cache file:",K.path,(0,j.$0)(B))}}async L(){if(!this.C)return;const K=this.M(this.C),Q=await this.I(K);if(!Q)return;const B=Q.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!E.$6n(L,B))try{this.m.info("Invalidating Cache",B,L),await this.j.del(K),this.F.fire()}catch(z){this.m.error(z)}}M(K){const Q=this.N(K);return this.h.extUri.joinPath(Q.cacheHome,K.type===0?a.$Lm:a.$Km)}N(K){return K.type===0?this.H.defaultProfile:K.profile?this.h.extUri.isEqual(K.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(K.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};q=Ee([ie(2,D.$Bl),ie(3,S.$oq),ie(4,I.$zl),ie(5,r.$2k),ie(6,i.$2j)],q);function ue(ce,K){const Q=(0,P.$wp)(ce.manifest.publisher,ce.manifest.name);return{id:Q,identifier:new a.$Qm(Q),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:K,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class ee extends W{constructor(K,Q,B,L,z,U,ae,G,le,Y,A,N){super(K,Q,(0,m.$9g)(B,".vscode-oss-dev","extensions","control.json"),L,z,U,ae,G,le,Y,A,N),this.S=(async()=>{if(v.$z)try{const _=await this.w.readFile($.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(K){return this.S}}e.$wq=ee}),define(re[280],oe([0,1,5,41,40,28,83,16,38,7]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IQ=void 0;let d=class extends j.$pq{constructor(v,m,f,y,p,$){super(l.URI.file(v.extensionsPath),m,f,y,p,$)}};e.$IQ=d,e.$IQ=d=Ee([ie(0,h.$Di),ie(1,k.$2k),ie(2,C.$Bl),ie(3,E.$zl),ie(4,R.$1l),ie(5,n.$2j)],d)}),define(re[281],oe([0,1,7,38,83,132,16,6,5,27,40,41]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4cc=void 0;let v=class extends R.$wq{constructor(f,y,p,$,c,w,P,a){super(n.URI.file(c.builtinExtensionsPath),n.URI.file(c.extensionsPath),c.userHome,f.defaultProfile,f,y,p,$,c,w,P,a)}};e.$4cc=v,e.$4cc=v=Ee([ie(0,b.$Bl),ie(1,E.$oq),ie(2,j.$2k),ie(3,h.$2j),ie(4,C.$Di),ie(5,l.$ik),ie(6,d.$zl),ie(7,k.$ui)],v)}),define(re[282],oe([0,1,14,2,13,9,4,59,7,33,37,38,5,41]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jdc=void 0;let f=class extends C.$Vc{constructor(p,$,c){super(),this.c=p,this.f=c,this.a=k.$Bi.forPaths(!j.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp",".mp4"]),this.addValidFileRoot(p.appRoot),this.addValidFileRoot(p.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:E.Schemas.file}).fsPath),this.addValidFileRoot(p.workspaceStorageHome.with({scheme:E.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:p}=n.session;p.protocol.registerFileProtocol(E.Schemas.vscodeFileResource,($,c)=>this.j($,c)),p.protocol.interceptFileProtocol(E.Schemas.file,($,c)=>this.h($,c)),this.B((0,C.$Tc)(()=>{p.protocol.unregisterProtocol(E.Schemas.vscodeFileResource),p.protocol.uninterceptProtocol(E.Schemas.file)}))}addValidFileRoot(p){const $=(0,R.$ic)(p);return this.a.get($)?C.$Vc.None:(this.a.set($,!0),(0,C.$Tc)(()=>this.a.delete($)))}h(p,$){const c=h.URI.parse(p.url);return this.f.error(`Refused to load resource ${c.fsPath} from ${E.Schemas.file}: protocol (original URL: ${p.url})`),$({error:-3})}j(p,$){const c=this.m(p);let w;return this.c.crossOriginIsolated&&((0,R.$oc)(c)==="workbench.html"||(0,R.$oc)(c)==="workbench-dev.html"?w=E.COI.CoopAndCoep:w=E.COI.getHeadersFromQuery(p.url)),this.a.findSubstr(c)?$({path:c,headers:w}):this.b.has((0,R.$pc)(c).toLowerCase())?$({path:c}):(this.f.error(`${E.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${E.Schemas.vscodeFileResource}: protocol (original URL: ${p.url})`),$({error:-3}))}m(p){const $=h.URI.parse(p.url),c=E.$Pg.uriToFileUri($);return(0,R.$ic)(c.fsPath)}createIPCObjectUrl(){let p;const $=h.URI.from({scheme:"vscode",path:(0,l.$Rg)()}),c=$.toString(),w=async()=>p;return d.$OW.handle(c,w),this.f.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:$,update:P=>p=P,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${c}.`),d.$OW.removeHandler(c)}}}};e.$jdc=f,e.$jdc=f=Ee([ie(0,b.$Di),ie(1,m.$Bl),ie(2,v.$2j)],f)}),define(re[97],oe([0,1,8,3,2,66,12,115,6,41]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$2p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$Zp=e.$Yp=e.$Xp=void 0,e.$1p=m,e.$3p=y,e.$5p=$,e.$Xp="__$__isNewStorageMarker",e.$Yp="__$__targetStorageMarker",e.$Zp=(0,h.$vi)("storageService");var d;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(d||(e.WillSaveStateReason=d={}));var b;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var v;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function m(c){const w=c.get(e.$Yp);if(w)try{return JSON.parse(w)}catch{}return Object.create(null)}class f extends E.$Vc{static{this.a=60*1e3}constructor(w={flushInterval:f.a}){super(),this.m=w,this.b=this.B(new C.$he),this.c=this.B(new C.$he),this.onDidChangeTarget=this.c.event,this.f=this.B(new C.$ee),this.onWillSaveState=this.f.event,this.h=this.B(new n.$Hh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new E.$Wc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(w,P,a){return C.Event.filter(this.b.event,t=>t.scope===w&&(P===void 0||t.key===P),a)}n(){this.j.value=(0,n.$Lh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,E.$Qc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,R.mark)("code/willInitStorage");try{await this.O()}finally{(0,R.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(w,P){const{key:a,external:t}=P;if(a===e.$Yp){switch(w){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:w})}else this.b.fire({scope:w,key:a,target:this.J(w)[a],external:t})}w(w){this.f.fire({reason:w})}get(w,P,a){return this.P(P)?.get(w,a)}getBoolean(w,P,a){return this.P(P)?.getBoolean(w,a)}getNumber(w,P,a){return this.P(P)?.getNumber(w,a)}getObject(w,P,a){return this.P(P)?.getObject(w,a)}storeAll(w,P){this.y(()=>{for(const a of w)this.store(a.key,a.value,a.scope,a.target,P)})}store(w,P,a,t,r=!1){if((0,j.$eg)(P)){this.remove(w,a,r);return}this.y(()=>{this.z(w,a,t),this.P(a)?.set(w,P,r)})}remove(w,P,a=!1){this.y(()=>{this.z(w,P,void 0),this.P(P)?.delete(w,a)})}y(w){this.b.pause(),this.c.pause();try{w()}finally{this.b.resume(),this.c.resume()}}keys(w,P){const a=[],t=this.J(w);for(const r of Object.keys(t))t[r]===P&&a.push(r);return a}z(w,P,a,t=!1){const r=this.J(P);typeof a=="number"?r[w]!==a&&(r[w]=a,this.P(P)?.set(e.$Yp,JSON.stringify(r),t)):typeof r[w]=="number"&&(delete r[w],this.P(P)?.set(e.$Yp,JSON.stringify(r),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(w){switch(w){case-1:return this.I;case 0:return this.G;default:return this.D}}L(w){const P=this.P(w);return P?m(P):Object.create(null)}isNew(w){return this.getBoolean(e.$Xp,w)===!0}async flush(w=d.NONE){this.f.fire({reason:w});const P=this.P(-1),a=this.P(0),t=this.P(1);switch(w){case d.NONE:await n.Promises.settled([P?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case d.SHUTDOWN:await n.Promises.settled([P?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const w=this.P(-1)?.items??new Map,P=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return $(w,P,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(w){return await this.flush(),this.P(w)?.optimize()}async switch(w,P){return this.w(d.NONE),(0,l.$Al)(w)?this.R(w,P):this.S(w,P)}M(w,P){return!(w.id===P.id||y(P)&&y(w))}N(w,P,a){this.y(()=>{const t=new Set;for(const[r,s]of w)t.add(r),P.get(r)!==s&&this.u(a,{key:r,external:!0});for(const[r]of P.items)t.has(r)||this.u(a,{key:r,external:!0})})}}e.$2p=f;function y(c){return c.isDefault||!!c.useDefaultFlags?.globalState}class p extends f{constructor(){super(),this.U=this.B(new k.$Vp(new k.$Wp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$Vp(new k.$Wp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$Vp(new k.$Wp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(w=>this.u(1,w))),this.B(this.W.onDidChangeStorage(w=>this.u(0,w))),this.B(this.U.onDidChangeStorage(w=>this.u(-1,w)))}P(w){switch(w){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(w){switch(w){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(w){return!1}}e.$4p=p;async function $(c,w,P,a,t,r){const s=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,o=new Map;c.forEach((M,W)=>{i.set(W,M),o.set(W,s(M))});const u=new Map,g=new Map;w.forEach((M,W)=>{u.set(W,M),g.set(W,s(M))});const S=new Map,D=new Map;P.forEach((M,W)=>{S.set(W,M),D.set(W,s(M))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const I=[];if(i.forEach((M,W)=>{I.push({key:W,value:M})}),console.table(I),console.groupEnd(),console.log(o),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];u.forEach((W,F)=>{M.push({key:F,value:W})}),console.table(M),console.groupEnd(),console.log(g)}console.group(`Storage: Workspace (path: ${r})`);const O=[];S.forEach((M,W)=>{O.push({key:W,value:M})}),console.table(O),console.groupEnd(),console.log(D)}}),define(re[283],oe([0,1,22,8,3,2,9,73,7,21,115,163,5,97,28,30,13]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ubc=e.$Tbc=e.$Sbc=e.$Rbc=void 0;class $ extends R.$Vc{static{this.a=2e3}get storage(){return this.f}constructor(s,i){super(),this.m=s,this.n=i,this.b=this.B(new E.$ee),this.onDidChangeStorage=this.b.event,this.c=this.B(new E.$ee),this.onDidCloseStorage=this.c.event,this.f=this.B(new d.$Vp(new d.$Wp,{hint:d.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new C.$Sh,this.whenInit=this.h.p,this.j=d.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===d.StorageState.None)try{const s=this.B(await this.t());this.f.dispose(),this.f=s,this.B(s.onDidChangeStorage(o=>this.b.fire(o))),await this.s(s);const i=s.getBoolean(m.$Xp);i===void 0?s.set(m.$Xp,!0):i&&s.set(m.$Xp,!1)}catch(s){this.m.error(`[storage main] initialize(): Unable to init storage due to ${s}`)}finally{this.j=d.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?s=>this.m.trace(s):void 0,logError:s=>this.m.error(s)}}s(s){return s.init()}get items(){return this.f.items}get(s,i){return this.f.get(s,i)}set(s,i){return this.f.set(s,i)}delete(s){return this.f.delete(s)}optimize(){return this.f.optimize()}async close(){const s=new k.$ae(!1);await this.w(),s.stop(),s.elapsed()>$.a&&await this.u(s),this.c.fire()}async u(s){if(this.path)try{const i=(0,n.top)(Array.from(this.f.items.entries()).map(([u,g])=>({key:u,length:g.length})),(u,g)=>g.length-u.length,5).map(u=>`${u.key}:${u.length}`).join(", "),o=(await this.n.stat(h.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${s.elapsed()}ms, DB size: ${o}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=d.StorageState.Closed,await this.f.close()}}class c extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,j.$kc)(this.z.globalStorageHome.with({scheme:p.Schemas.file}).fsPath,c.y)}constructor(s,i,o,u){super(o,u),this.z=s,this.C=i}async t(){return new d.$Vp(new b.$hX(this.path??b.$hX.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:d.StorageHint.STORAGE_IN_MEMORY})}}class w extends c{constructor(s,i,o,u){super(s,i,o,u)}}e.$Rbc=w;class P extends c{constructor(s,i,o,u){super(i.defaultProfile,s,o,u)}async s(s){await super.s(s),this.G(s)}G(s){s.get(f.$4l,void 0)===void 0&&s.set(f.$4l,new Date().toUTCString());const o=s.get(f.$3l,void 0),u=new Date().toUTCString();s.set(f.$5l,typeof o>"u"?null:o),s.set(f.$3l,u)}}e.$Sbc=P;class a extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id,a.y)}constructor(s,i,o,u,g){super(o,g),this.C=s,this.D=i,this.F=u}async t(){const{storageFilePath:s,wasCreated:i}=await this.H();return new d.$Vp(new b.$hX(s,{logging:this.r()}),{hint:this.D.useInMemoryStorage?d.StorageHint.STORAGE_IN_MEMORY:i?d.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:b.$hX.IN_MEMORY_PATH,wasCreated:!0};const s=(0,j.$kc)(this.F.workspaceStorageHome.with({scheme:p.Schemas.file}).fsPath,this.C.id),i=(0,j.$kc)(s,a.y);return await l.Promises.exists(s)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(s,{recursive:!0}),this.I(s),{storageFilePath:i,wasCreated:!0})}async I(s){let i;if((0,y.$Fi)(this.C)?i={folder:this.C.uri.toString()}:(0,y.$Ki)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const o=(0,j.$kc)(s,a.z);await l.Promises.exists(o)||await l.Promises.writeFile(o,JSON.stringify(i,void 0,2))}catch(o){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${o}`)}}}e.$Tbc=a;class t extends ${get path(){}async t(){return new d.$Vp(new d.$Wp,{hint:d.StorageHint.STORAGE_IN_MEMORY})}}e.$Ubc=t}),define(re[284],oe([0,1,3,2,97]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6cc=void 0;class R extends C.$Vc{constructor(k,h,l){super(),this.b=k,this.c=h,this.f=l;const d=this.B(new C.$Wc);this.a=this.B(new n.$ee({onWillAddFirstListener:()=>d.value=this.g(),onDidRemoveLastListener:()=>d.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new C.$Uc;return k.add(n.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),k.add(n.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let d=h.get(l.profile.id);return d||h.set(l.profile.id,d={profile:l.profile,keys:[],storage:l.storage}),d.keys.push(l.key),h},100)(h=>this.j(h))),k}h(k){const h=k.includes(E.$Yp)?[this.c.defaultProfile]:[],l=[];if(k=k.filter(d=>d!==E.$Yp),k.length){const d=(0,E.$1p)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:k.map(b=>({key:b,scope:0,target:d[b]}))})}this.m(h,l)}j(k){const h=[],l=new Map;for(const[d,b]of k.entries()){b.keys.includes(E.$Yp)&&h.push(b.profile);const v=b.keys.filter(m=>m!==E.$Yp);if(v.length){const m=(0,E.$1p)(b.storage.storage);l.set(d,{profile:b.profile,changes:v.map(f=>({key:f,scope:0,target:m[f]}))})}}this.m(h,[...l.values()])}m(k,h){(k.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:k})}listen(k,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`[ProfileStorageChangesListenerChannel] Event not found: ${h}`)}async call(k,h){throw new Error(`Call not found: ${h}`)}}e.$6cc=R}),define(re[285],oe([0,1,7,38,16,5,34,40,41,12,125]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";var b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$HQ=e.$GQ=e.$FQ=void 0;let m=class extends h.$El{static{b=this}static{this.a="profileAssociationsMigration"}constructor($,c,w,P,a){super(w,P,c,a),this.U=$,this.W=w}O(){return this.U.getItem(b.b,[]).map(c=>({...c,location:(0,l.$8f)(c.location)?this.w.extUri.joinPath(this.profilesHome,c.location):n.URI.revive(c.location)}))}Q(){const $=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(n.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$FQ=m,e.$FQ=m=b=Ee([ie(0,j.$AQ),ie(1,k.$zl),ie(2,C.$Di),ie(3,E.$2k),ie(4,R.$2j)],m);let f=v=class extends m{constructor($,c,w,P,a){super($,c,w,P,a),this.$=$}P($){$.length?this.$.setItem(v.b,$.map(c=>({...c,location:this.w.extUri.basename(c.location)}))):this.$.removeItem(v.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(v.c,$):this.$.removeItem(v.c)}Q(){const $="workspaceAndProfileInfo",c=this.$.getItem($,void 0);if(c){this.$.removeItem($);const P=c.reduce((a,{workspace:t,profile:r})=>(a[n.URI.revive(t).toString()]=n.URI.revive(r).toString(),a),{});this.$.setItem(v.c,{workspaces:P})}const w=super.Q();return this.$.getItem(v.a,!1)||(this.R(w),this.$.setItem(v.a,!0)),w}};e.$GQ=f,e.$GQ=f=v=Ee([ie(0,j.$BQ),ie(1,k.$zl),ie(2,C.$Di),ie(3,E.$2k),ie(4,R.$2j)],f);let y=class extends f{constructor($,c,w,P){super(new d.$EQ(0,c,P,w),$,c,w,P)}async init(){return await this.$.init(),super.init()}};e.$HQ=y,e.$HQ=y=Ee([ie(0,k.$zl),ie(1,C.$Di),ie(2,E.$2k),ie(3,R.$2j)],y)}),define(re[57],oe([0,1,38,16,6,5,40,41,285,34]),function(X,e,n,C,E,R,j,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Abc=e.$zbc=void 0,e.$zbc=(0,E.$wi)(k.$Bl);let d=class extends h.$GQ{constructor(v,m,f,y,p){super(v,m,f,y,p)}getAssociatedEmptyWindows(){const v=[];for(const m of this.C.emptyWindows.keys())v.push({id:m});return v}};e.$Abc=d,e.$Abc=d=Ee([ie(0,l.$BQ),ie(1,j.$zl),ie(2,n.$Di),ie(3,C.$2k),ie(4,R.$2j)],d)}),define(re[133],oe([0,1,19,7,30]),function(X,e,n,C,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bbc=R,e.$Cbc=j,e.$Dbc=k;async function R(h,l,d){for(const v of h){const m=v.openedWorkspace;if((0,E.$Ki)(m)){const f=await d(m);if(f){if(f.folders.some(y=>n.$Zg.isEqualOrParent(l,y.uri)))return v}else if(n.$Zg.isEqualOrParent(l,m.configPath))return v}}const b=h.filter(v=>(0,E.$Fi)(v.openedWorkspace)&&n.$Zg.isEqualOrParent(l,v.openedWorkspace.uri));if(b.length)return b.sort((v,m)=>-(v.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}function j(h,l){for(const d of h)if((0,E.$Ki)(d.openedWorkspace)&&n.$Zg.isEqual(d.openedWorkspace.configPath,l)||(0,E.$Fi)(d.openedWorkspace)&&n.$Zg.isEqual(d.openedWorkspace.uri,l))return d}function k(h,l){const d=b=>l.some(v=>n.$Zg.isEqual(C.URI.file(v),C.URI.file(b)));for(const b of h)if(b.config?.extensionDevelopmentPath?.some(v=>d(v)))return b}}),define(re[98],oe([0,1,31,42,103,48,13,9,4,19,7,6,68,30]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$agb=void 0,e.$bgb=f,e.$cgb=y,e.$dgb=p,e.$egb=$,e.$fgb=P,e.$ggb=t,e.$hgb=r,e.$igb=g,e.$jgb=S,e.$agb=(0,b.$vi)("workspacesService");function f(D){return D.hasOwnProperty("workspace")}function y(D){return D.hasOwnProperty("folderUri")}function p(D){return D.hasOwnProperty("fileUri")}function $(D){return c(D)||w(D)}function c(D){const I=D;return typeof I?.path=="string"&&(!I.name||typeof I.name=="string")}function w(D){const I=D;return typeof I?.uri=="string"&&(!I.name||typeof I.name=="string")}function P(D,I,O,M,W){if(D.scheme!==M.scheme)return{name:O,uri:D.toString(!0)};let F=I?void 0:W.relativePath(M,D);if(F!==void 0)F.length===0?F=".":h.$i&&(F=a(F));else if(D.scheme===j.Schemas.file)F=D.fsPath,h.$i&&(F=a(F));else if(W.isEqualAuthority(D.authority,M.authority))F=D.path;else return{name:O,uri:D.toString(!0)};return{name:O,path:F}}function a(D){return D=(0,R.$xw)(D),(0,n.$rg)(D)||(D=(0,n.$og)(D)),D}function t(D,I,O){const M=[],W=new Set,F=O.dirname(I);for(const T of D){let q;if(c(T))T.path&&(q=O.resolvePath(F,T.path));else if(w(T))try{q=d.URI.parse(T.uri),q.path[0]!==k.$hc.sep&&(q=q.with({path:k.$hc.sep+q.path}))}catch(ue){console.warn(ue)}if(q){const ue=O.getComparisonKey(q);if(!W.has(ue)){W.add(ue);const ee=T.name||O.basenameOrAuthority(q);M.push(new m.$Pi({uri:q,name:ee,index:M.length},T))}}}return M}function r(D,I,O,M,W){const F=s(I,D),T=W.dirname(I),q=W.dirname(M),ue=[];for(const Q of F.folders){const B=c(Q)?W.resolvePath(T,Q.path):d.URI.parse(Q.uri);let L;O?L=!1:L=!c(Q)||(0,k.$jc)(Q.path),ue.push(P(B,L,Q.name,q,W))}const ee={insertSpaces:!1,tabSize:4,eol:h.$k||h.$j?`
`:`\r
`},ce=E.$Xn(D,["folders"],ue,ee);let K=E.$1n(D,ce);return(0,l.$bh)(F.remoteAuthority,(0,v.$Gm)(M))&&(K=E.$1n(K,E.$Wn(K,["remoteAuthority"],ee))),K}function s(D,I){const O=C.$In(I);if(O&&Array.isArray(O.folders))O.folders=O.folders.filter(M=>$(M));else throw new Error(`${D} looks like an invalid workspace file.`);return O}function i(D){return D.workspace&&typeof D.workspace=="object"&&typeof D.workspace.id=="string"&&typeof D.workspace.configPath=="string"}function o(D){return typeof D.folderUri=="string"}function u(D){return typeof D.fileUri=="string"}function g(D,I){const O={workspaces:[],files:[]};if(D){const M=function(F,T){for(let q=0;q<F.length;q++)try{T(F[q],q)}catch(ue){I.warn(`Error restoring recent entry ${JSON.stringify(F[q])}: ${ue.toString()}. Skip entry.`)}},W=D;Array.isArray(W.entries)&&M(W.entries,F=>{const T=F.label,q=F.remoteAuthority;i(F)?O.workspaces.push({label:T,remoteAuthority:q,workspace:{id:F.workspace.id,configPath:d.URI.parse(F.workspace.configPath)}}):o(F)?O.workspaces.push({label:T,remoteAuthority:q,folderUri:d.URI.parse(F.folderUri)}):u(F)&&O.files.push({label:T,remoteAuthority:q,fileUri:d.URI.parse(F.fileUri)})})}return O}function S(D){const I={entries:[]};for(const O of D.workspaces)y(O)?I.entries.push({folderUri:O.folderUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority}):I.entries.push({workspace:{id:O.workspace.id,configPath:O.workspace.configPath.toString()},label:O.label,remoteAuthority:O.remoteAuthority});for(const O of D.files)I.entries.push({fileUri:O.fileUri.toString(),label:O.label,remoteAuthority:O.remoteAuthority});return I}}),define(re[99],oe([0,1,87,13,4,19]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ebc=void 0,e.$Fbc=j,e.$Gbc=k,e.$Hbc=h,e.$Ebc=128/4;function j(l){function d(){let b=l.scheme===C.Schemas.file?(0,R.$Wg)(l):l.toString();return E.$k||(b=b.toLowerCase()),(0,n.createHash)("md5").update(b).digest("hex")}return{id:d(),configPath:l}}function k(l,d){function b(){if(l.scheme!==C.Schemas.file)return(0,n.createHash)("md5").update(l.toString()).digest("hex");if(!d)return;let m;return E.$k?m=d.ino:E.$j?m=d.birthtime.getTime():E.$i&&(typeof d.birthtimeMs=="number"?m=Math.floor(d.birthtimeMs):m=d.birthtime.getTime()),(0,n.createHash)("md5").update(l.fsPath).update(m?String(m):"").digest("hex")}const v=b();if(typeof v=="string")return{id:v,uri:l}}function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}}),define(re[100],oe([0,1,87,88,26,286,17,15,3,2,9,4,33,44,113]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pi=e.$mi=e.$li=e.$ki=void 0,e.$ni=s,e.$oi=i,e.$qi=g,e.$ri=S;class y{traceSocketEvent(I,O){f.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,I,O)}constructor(I,O=""){this.f=!0,this.debugLabel=O,this.socket=I,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,k.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(I){const O=M=>{this.traceSocketEvent("read",M),I(j.$Fe.wrap(M))};return this.socket.on("data",O),{dispose:()=>this.socket.off("data",O)}}onClose(I){const O=M=>{I({type:0,hadError:M,error:void 0})};return this.socket.on("close",O),{dispose:()=>this.socket.off("close",O)}}onEnd(I){const O=()=>{I()};return this.socket.on("end",O),{dispose:()=>this.socket.off("end",O)}}write(I){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",I),this.socket.write(I.buffer,O=>{if(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}})}catch(O){if(O.code==="EPIPE")return;(0,k.$1)(O)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((I,O)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),I();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),I()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$ki=y;var p;(function(D){D[D.MinHeaderByteSize=2]="MinHeaderByteSize",D[D.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(p||(p={}));var $;(function(D){D[D.PeekHeader=1]="PeekHeader",D[D.ReadHeader=2]="ReadHeader",D[D.ReadBody=3]="ReadBody",D[D.Fin=4]="Fin"})($||($={}));class c extends l.$Vc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(I,O){this.socket.traceSocketEvent(I,O)}constructor(I,O,M,W){super(),this.f=this.B(new h.$ee),this.g=this.B(new h.$ee),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=I,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:O,inflateBytesLength:M?.byteLength||0,recordInflateBytes:W}),this.a=this.B(new w(this,O,M,W,this.f,(F,T)=>this.m(F,T))),this.B(this.a.onError(F=>{console.error(F),(0,k.$1)(F),this.g.fire({type:0,hadError:!0,error:F})})),this.b=new f.$fi,this.B(this.socket.onData(F=>this.n(F))),this.B(this.socket.onClose(async F=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(F)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(I){return this.f.event(I)}onClose(I){return this.g.event(I)}onEnd(I){return this.socket.onEnd(I)}write(I){let O=0;for(;O<I.byteLength;)this.a.writeMessage(I.slice(O,Math.min(O+262144,I.byteLength)),{compressed:!0,opcode:2}),O+=262144}m(I,{compressed:O,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",I);let W=2;I.byteLength<126?W+=0:I.byteLength<2**16?W+=2:W+=8;const F=j.$Fe.alloc(W),T=O?64:0,q=M&15;if(F.writeUInt8(128|T|q,0),I.byteLength<126)F.writeUInt8(I.byteLength,1);else if(I.byteLength<2**16){F.writeUInt8(126,1);let ue=1;F.writeUInt8(I.byteLength>>>8&255,++ue),F.writeUInt8(I.byteLength>>>0&255,++ue)}else{F.writeUInt8(127,1);let ue=1;F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(0,++ue),F.writeUInt8(I.byteLength>>>24&255,++ue),F.writeUInt8(I.byteLength>>>16&255,++ue),F.writeUInt8(I.byteLength>>>8&255,++ue),F.writeUInt8(I.byteLength>>>0&255,++ue)}this.socket.write(j.$Fe.concat([F,I]))}end(){this.h=!0,this.socket.end()}n(I){if(I.byteLength!==0){for(this.b.acceptChunk(I);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const O=this.b.peek(this.j.readLen),M=O.readUInt8(0),W=(M&128)>>>7,F=(M&64)>>>6,T=M&15,q=O.readUInt8(1),ue=(q&128)>>>7,ee=q&127;this.j.state=2,this.j.readLen=2+(ue?4:0)+(ee===126?2:0)+(ee===127?8:0),this.j.fin=W,this.j.firstFrameOfMessage&&(this.j.compressed=!!F),this.j.firstFrameOfMessage=!!W,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const O=this.b.read(this.j.readLen),M=O.readUInt8(1),W=(M&128)>>>7;let F=M&127,T=1;F===126?F=O.readUInt8(++T)*2**8+O.readUInt8(++T):F===127&&(F=O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*0+O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T));let q=0;W&&(q=O.readUInt8(++T)*2**24+O.readUInt8(++T)*2**16+O.readUInt8(++T)*2**8+O.readUInt8(++T)),this.j.state=3,this.j.readLen=F,this.j.mask=q,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const O=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",O),t(O,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",O),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(O,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(O,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$li=c;class w extends l.$Vc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:j.$Fe.alloc(0)}constructor(I,O,M,W,F,T){super(),this.n=I,this.r=F,this.s=T,this.a=this.B(new h.$ee),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.$ee),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new h.$ee),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,O?(this.b=this.B(new P(this.n,W,M,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(q=>this.a.fire(q))),this.B(this.f.onError(q=>this.a.fire(q)))):(this.b=null,this.f=null)}writeMessage(I,O){this.g.push({data:I,options:O}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:I,options:O}=this.g.shift();if(this.f&&O.compressed){const M=await this.w(this.f,I);this.s(M,O)}else this.s(I,{...O,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(I,O){return new Promise((M,W)=>{I.write(O),I.flush(F=>M(F))})}acceptFrame(I,O,M){this.h.push({data:I,isCompressed:O,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const I=this.h.shift();if(this.b&&I.isCompressed){const O=await this.C(this.b,I.data,I.isLastFrameOfMessage);this.r.fire(O)}else this.r.fire(I.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(I,O,M){return new Promise((W,F)=>{I.write(O),M&&I.write(j.$Fe.fromByteArray([0,0,255,255])),I.flush(T=>W(T))})}}class P extends l.$Vc{get recordedInflateBytes(){return this.j?j.$Fe.concat(this.f):j.$Fe.alloc(0)}constructor(I,O,M,W){super(),this.h=I,this.j=O,this.a=this.B(new h.$ee),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,R.createInflateRaw)(W),this.b.on("error",F=>{this.h.traceSocketEvent("zlibInflateError",{message:F?.message,code:F?.code}),this.a.fire(F)}),this.b.on("data",F=>{this.h.traceSocketEvent("zlibInflateData",F),this.g.push(j.$Fe.wrap(F))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(I){this.j&&this.f.push(I.clone()),this.h.traceSocketEvent("zlibInflateWrite",I),this.b.write(I.buffer)}flush(I){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const O=j.$Fe.concat(this.g);this.g.length=0,I(O)})}}class a extends l.$Vc{constructor(I,O){super(),this.g=I,this.a=this.B(new h.$ee),this.onError=this.a.event,this.f=[],this.b=(0,R.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(j.$Fe.wrap(M))})}write(I){this.g.traceSocketEvent("zlibDeflateWrite",I.buffer),this.b.write(I.buffer)}flush(I){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let O=j.$Fe.concat(this.f);this.f.length=0,O=O.slice(0,O.byteLength-4),I(O)})}}function t(D,I){if(I===0)return;const O=D.byteLength>>>2;for(let ue=0;ue<O;ue++){const ee=D.readUInt32BE(ue*4);D.writeUInt32BE(ee^I,ue*4)}const M=O*4,W=D.byteLength-M,F=I>>>24&255,T=I>>>16&255,q=I>>>8&255;W>=1&&D.writeUInt8(D.readUInt8(M)^F,M),W>=2&&D.writeUInt8(D.readUInt8(M+1)^T,M+1),W>=3&&D.writeUInt8(D.readUInt8(M+2)^q,M+2)}e.$mi=process.env.XDG_RUNTIME_DIR;const r={2:107,1:103};function s(){const D=(0,v.$Rg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${D}-sock`;const I=process.platform!=="darwin"&&e.$mi?e.$mi:(0,E.tmpdir)(),O=(0,d.$kc)(I,`vscode-ipc-${D}.sock`);return o(O),O}function i(D,I,O){const W=(0,n.createHash)("sha256").update(D).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${O}-${I}-sock`;const F=O.substr(0,4),T=I.substr(0,6);let q;return process.platform!=="darwin"&&e.$mi&&!process.env.VSCODE_PORTABLE?q=(0,d.$kc)(e.$mi,`vscode-${W}-${F}-${T}.sock`):q=(0,d.$kc)(D,`${F}-${T}.sock`),o(q),q}function o(D){const I=r[b.$u];typeof I=="number"&&D.length>=I&&console.warn(`WARNING: IPC handle "${D}" is longer than ${I} chars, try a shorter --user-data-dir`)}class u extends m.$_h{static b(I){const O=h.Event.fromNodeEventEmitter(I,"connection");return h.Event.map(O,M=>({protocol:new f.$gi(new y(M,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(M,"close"))}))}constructor(I){super(u.b(I)),this.d=I}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$pi=u;function g(D){return new Promise((I,O)=>{const M=(0,C.createServer)();M.on("error",O),M.listen(D,()=>{M.removeListener("error",O),I(new u(M))})})}function S(D,I){return new Promise((O,M)=>{const W=(0,C.createConnection)(D,()=>{W.removeListener("error",M),O(f.$hi.fromSocket(new y(W,`ipc-client${I}`),I))});W.once("error",M)})}}),define(re[24],oe([0,1,51,9,4,100,38,91,6]),function(X,e,n,C,E,R,j,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mbc=e.$lbc=void 0,e.$lbc=(0,h.$wi)(j.$Ci);class l extends k.$8m{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,C.$kc)(this.userDataPath,"clp")}get backupHome(){return(0,C.$kc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,R.$oi)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,C.$kc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(E.$k){for(const b in process.env)if(b.endsWith("_VSCODE_SNAP_ORIG")){const v=b.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[b]?process.env[v]=process.env[b]:delete process.env[v]}}}restoreSnapExportedVariables(){if(E.$k)for(const b in this.d)process.env[b]=this.d[b],delete this.d[b]}}e.$mbc=l,Ee([n.$Zh],l.prototype,"cachedLanguagesPath",null),Ee([n.$Zh],l.prototype,"backupHome",null),Ee([n.$Zh],l.prototype,"mainIPCHandle",null),Ee([n.$Zh],l.prototype,"mainLockfile",null),Ee([n.$Zh],l.prototype,"disableUpdates",null),Ee([n.$Zh],l.prototype,"crossOriginIsolated",null),Ee([n.$Zh],l.prototype,"codeCachePath",null),Ee([n.$Zh],l.prototype,"useCodeCache",null)}),define(re[287],oe([0,1,87,31,13,9,4,19,21,199,18,24,34,16,5,198,30,99]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$1bc=void 0;let w=class{static{c=this}static{this.a="backupWorkspaces"}constructor(a,t,r,s){this.j=a,this.k=t,this.l=r,this.m=s,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.$Zg,this.i={isEqual:(i,o)=>(0,C.$tg)(i,o,!j.$k)}}async initialize(){const a=this.m.getItem(c.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(a.emptyWindows),this.d=await this.u((0,l.$obc)(a)),this.e=await this.v((0,l.$pbc)(a)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==m.$ol.OFF}q(){return this.s()===m.$ol.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||m.$ol.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(a,t){this.d.some(s=>a.workspace.id===s.workspace.id)||(this.d.push(a),this.C());const r=(0,R.$kc)(this.c,a.workspace.id);return t?this.t(r,t).then(()=>r):r}async t(a,t){if(await h.Promises.exists(a)&&await this.z(a),await h.Promises.exists(t))try{await h.Promises.rename(t,a,!1)}catch(r){this.l.error(`Backup: Could not move backup folder to new location: ${r.toString()}`)}}registerFolderBackup(a){return this.e.some(t=>this.h.isEqual(a.folderUri,t.folderUri))||(this.e.push(a),this.C()),(0,R.$kc)(this.c,this.D(a))}registerEmptyWindowBackup(a){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.backupFolder))||(this.g.push(a),this.C()),(0,R.$kc)(this.c,a.backupFolder)}async u(a){if(!Array.isArray(a))return[];const t=new Set,r=[];for(const s of a){const i=s.workspace;if(!(0,p.$Ki)(i))return[];if(!t.has(i.id)){t.add(i.id);const o=(0,R.$kc)(this.c,i.id);await this.B(o)?i.configPath.scheme!==E.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?r.push(s):await this.z(o):await this.x(o)}}return r}async v(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.folderUri,o=this.h.getComparisonKey(i);if(!r.has(o)){r.add(o);const u=(0,R.$kc)(this.c,this.D(s));await this.B(u)?i.scheme!==E.Schemas.file||await h.Promises.exists(i.fsPath)?t.push(s):await this.z(u):await this.x(u)}}return t}async w(a){if(!Array.isArray(a))return[];const t=[],r=new Set;for(const s of a){const i=s.backupFolder;if(typeof i!="string")return[];if(!r.has(i)){r.add(i);const o=(0,R.$kc)(this.c,i);await this.B(o)?t.push(s):await this.x(o)}}return t}async x(a){try{await h.Promises.rm(a,h.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let a=(0,$.$Hbc)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,a.id));)a=(0,$.$Hbc)();return{backupFolder:a.id}}async z(a){const t=this.y(),r=(0,R.$kc)(this.c,t.backupFolder);try{await h.Promises.rename(a,r,!1)}catch(s){return this.l.error(`Backup: Could not rename backup folder: ${s.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const a=[];for(const t of this.d)await this.A(t)&&a.push(t);for(const t of this.e)await this.A(t)&&a.push(t);return a}A(a){let t;return(0,l.$nbc)(a)?t=(0,R.$kc)(this.c,a.backupFolder):(0,y.$$fb)(a)?t=(0,R.$kc)(this.c,this.D(a)):t=(0,R.$kc)(this.c,a.workspace.id),this.B(t)}async B(a){try{const t=await h.Promises.readdir(a);for(const r of t)try{if((await h.Promises.readdir((0,R.$kc)(a,r))).length>0)return!0}catch{}}catch{}return!1}C(){const a={workspaces:this.d.map(({workspace:t,remoteAuthority:r})=>{const s={id:t.id,configURIPath:t.configPath.toString()};return r&&(s.remoteAuthority=r),s}),folders:this.e.map(({folderUri:t,remoteAuthority:r})=>{const s={folderUri:t.toString()};return r&&(s.remoteAuthority=r),s}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:r})=>{const s={backupFolder:t};return r&&(s.remoteAuthority=r),s})};this.m.setItem(c.a,a)}D(a){const t=a.folderUri;let r;return t.scheme===E.Schemas.file?r=j.$k?t.fsPath:t.fsPath.toLowerCase():r=t.toString().toLowerCase(),(0,n.createHash)("md5").update(r).digest("hex")}};e.$1bc=w,e.$1bc=w=c=Ee([ie(0,b.$lbc),ie(1,d.$2i),ie(2,f.$2j),ie(3,v.$BQ)],w)}),define(re[20],oe([0,1,14,37,8,3,2,4,36,12,6,5,34,24]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qbc=e.LifecycleMainPhase=e.ShutdownReason=e.$Pbc=void 0,e.$Pbc=(0,d.$vi)("lifecycleMainService");var y;(function(c){c[c.QUIT=1]="QUIT",c[c.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var p;(function(c){c[c.Starting=1]="Starting",c[c.Ready=2]="Ready",c[c.AfterWindowOpen=3]="AfterWindowOpen",c[c.Eventually=4]="Eventually"})(p||(e.LifecycleMainPhase=p={}));let $=class extends j.$Vc{static{f=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(w,P,a){super(),this.F=w,this.G=P,this.H=a,this.c=this.B(new R.$ee),this.onBeforeShutdown=this.c.event,this.f=this.B(new R.$ee),this.onWillShutdown=this.f.event,this.g=this.B(new R.$ee),this.onWillLoadWindow=this.g.event,this.h=this.B(new R.$ee),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(f.b),this.m&&this.G.removeItem(f.b)}J(){const w=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.$j&&this.t===0&&this.L(1))};n.app.addListener("before-quit",w);const P=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!k.$j)&&n.app.quit()};n.app.addListener("window-all-closed",P),n.app.once("will-quit",a=>{this.S("Lifecycle#app.on(will-quit) - begin"),a.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),n.app.removeListener("before-quit",w),n.app.removeListener("window-all-closed",P),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),n.app.quit()})})}L(w){if(this.y)return this.y;const P=this.F;this.S("Lifecycle#onWillShutdown.fire()");const a=[];return this.f.fire({reason:w,join(t,r){P.trace(`Lifecycle#onWillShutdown - begin '${t}'`),a.push(r.finally(()=>{P.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await E.Promises.settled(a)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(w){if(w<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===w)return;this.S(`lifecycle (main): phase changed (value: ${w})`),this.n=w;const P=this.C.get(this.n);P&&(P.open(),this.C.delete(this.n))}async when(w){if(w<=this.n)return;let P=this.C.get(w);P||(P=new E.$uh,this.C.set(w,P)),await P.wait()}registerWindow(w){const P=new j.$Uc;this.t++,P.add(w.onWillLoad(t=>this.g.fire({window:w,workspace:t.workspace,reason:t.reason})));const a=(0,l.$gg)(w.win);P.add(R.Event.fromNodeEventEmitter(a,"close")(t=>{const r=w.id;if(this.r.has(r)){this.r.delete(r);return}this.S(`Lifecycle#window.on('close') - window ID ${w.id}`),t.preventDefault(),this.unload(w,1).then(s=>{if(s){this.r.delete(r);return}this.r.add(r),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${r}`),this.h.fire(w),w.close()})})),P.add(R.Event.fromNodeEventEmitter(a,"closed")(()=>{this.S(`Lifecycle#window.on('closed') - window ID ${w.id}`),this.t--,P.dispose(),this.t===0&&(!k.$j||this.j)&&this.L(1)}))}registerAuxWindow(w){const P=(0,l.$gg)(w.win),a=new j.$Uc;a.add(R.Event.fromNodeEventEmitter(P,"close")(t=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${w.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),t.preventDefault())})),a.add(R.Event.fromNodeEventEmitter(P,"closed")(()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${w.id}`),a.dispose()}))}async reload(w,P){await this.unload(w,3)||w.reload(P)}unload(w,P){const a=this.z.get(w.id);if(a)return a;const t=this.M(w,P).finally(()=>{this.z.delete(w.id)});return this.z.set(w.id,t),t}async M(w,P){if(!w.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${w.id}`);const a=this.j?2:P,t=await this.P(w,a);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${w.id})`),this.N(t)):(await this.Q(w,a),!1)}N(w){return w?(this.O(!0),this.j=!1,!0):!1}O(w){this.w&&(this.w(w),this.w=void 0,this.u=void 0)}P(w,P){return new Promise(a=>{const t=this.s++,r=`vscode:ok${t}`,s=`vscode:cancel${t}`;C.$OW.once(r,()=>{a(!1)}),C.$OW.once(s,()=>{a(!0)}),w.send("vscode:onBeforeUnload",{okChannel:r,cancelChannel:s,reason:P})})}Q(w,P){return new Promise(a=>{const r=`vscode:reply${this.s++}`;C.$OW.once(r,()=>a()),w.send("vscode:onWillUnload",{replyChannel:r,reason:P})})}quit(w){return this.R(w).then(P=>{if(!P&&w)try{if(k.$i){const a=(0,h.cwd)();a!==process.cwd()&&process.chdir(a)}}catch(a){this.F.error(a)}return P})}R(w){return this.S(`Lifecycle#quit() - begin (willRestart: ${w})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(w&&this.G.setItem(f.b,!0),this.u=new Promise(P=>{this.w=P,this.S("Lifecycle#quit() - calling app.quit()"),n.app.quit()}),this.u)}S(w){this.H.args["enable-smoke-test-driver"]?this.F.info(w):this.F.trace(w)}setRelaunchHandler(w){this.D=w}async relaunch(w){this.S("Lifecycle#relaunch()");const P=process.argv.slice(1);if(w?.addArgs&&P.push(...w.addArgs),w?.removeArgs)for(const r of w.removeArgs){const s=P.indexOf(r);s>=0&&P.splice(s,1)}const a=()=>{this.D?.handleRelaunch(w)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),n.app.relaunch({args:P}))};n.app.once("quit",a),await this.quit(!0)&&n.app.removeListener("quit",a)}async kill(w){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,E.$wh)(1e3),(async()=>{for(const P of n.BrowserWindow.getAllWindows())if(P&&!P.isDestroyed()){let a;P.webContents&&!P.webContents.isDestroyed()?a=new Promise(t=>P.once("closed",t)):a=Promise.resolve(),P.destroy(),await a}})()]),n.app.exit(w)}};e.$Qbc=$,e.$Qbc=$=f=Ee([ie(0,b.$2j),ie(1,v.$BQ),ie(2,m.$lbc)],$)}),define(re[288],oe([0,1,4,3,2,6,20]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mcc=e.$lcc=void 0,e.$lcc=(0,R.$vi)("keyboardLayoutMainService");let k=class extends E.$Vc{constructor(d){super(),this.a=this.B(new C.$ee),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,d.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const d=await new Promise((b,v)=>{X(["native-keymap"],b,v)});this.c=h(d),n.$t||d.onDidChangeKeyboardLayout(()=>{this.c=h(d),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$mcc=k,e.$mcc=k=Ee([ie(0,j.$Pbc)],k);function h(l){const d=l.getKeyMap(),b=l.getCurrentKeyboardLayout();return{keyboardMapping:d,keyboardLayoutInfo:b}}}),define(re[289],oe([0,1,250,8,17,15,12,18,38,95,5,53,249,286]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0,e.$Xr=p;let f=class extends b.$Np{constructor(c,w,P,a){super(a),this.m=c,this.n=w,this.r=P,this.s(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const c=this.m.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,w){const{f:P,g:a}=this;let t;try{t=await(0,l.$Fm)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,R.$0)(i)))}const r={...process.env,...t},s=c.agent?c.agent:await(0,v.$Vr)(c.url||"",r,{proxyUrl:P,strictSSL:a});return c.agent=s,c.strictSSL=a,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>p(c,w))}async resolveProxy(c){}async loadCertificates(){return(await new Promise((w,P)=>{X(["@vscode/proxy-agent"],w,P)})).loadSystemCertificates({log:this.r})}};e.$Wr=f,e.$Wr=f=Ee([ie(0,k.$2i),ie(1,h.$Di),ie(2,d.$2j),ie(3,d.$3j)],f);async function y($){return((0,n.parse)($.url).protocol==="https:"?await new Promise((P,a)=>{X(["https"],P,a)}):await new Promise((P,a)=>{X(["http"],P,a)})).request}async function p($,c){return C.Promises.withAsyncBody(async(w,P)=>{const a=(0,n.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await y($),r={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,j.$bg)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(r.auth=$.user+":"+$.password);const s=t(r,i=>{const o=(0,j.$_f)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&o>0&&i.headers.location)p({...$,url:i.headers.location,followRedirects:o-1},c).then(w,P);else{let u=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(u=i.pipe((0,m.createGunzip)())),w({res:i,stream:(0,E.$Ue)(u)})}});s.on("error",P),$.timeout&&s.setTimeout($.timeout),$.isChromiumNetwork&&s.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&s.write($.data),s.end(),c.onCancellationRequested(()=>{s.abort(),P(new R.$5)})})}}),define(re[290],oe([0,1,14,289]),function(X,e,n,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$odc=void 0;function E(j){return n.net.request}class R extends C.$Wr{request(k,h){return super.request({...k||{},getRawRequest:E,isChromiumNetwork:!0},h)}}e.$odc=R}),define(re[84],oe([0,1,7,3,2,38,16,6,20,5,97,283,41,57,40,13]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ybc=e.$Xbc=e.$Wbc=e.$Vbc=void 0,e.$Vbc=(0,k.$vi)("storageMainService");let p=class extends E.$Vc{constructor(w,P,a,t,r,s){super(),this.c=w,this.f=P,this.g=a,this.h=t,this.j=r,this.m=s,this.a=void 0,this.b=this.B(new C.$ee),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(w=>{w.window.profile&&this.profileStorage(w.window.profile).init(),w.workspace&&this.workspaceStorage(w.workspace).init()})),this.B(this.h.onWillShutdown(w=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=w.reason,w.join("applicationStorage",this.applicationStorage.close());for(const[,P]of this.t)w.join("profileStorage",P.close());for(const[,P]of this.w)w.join("workspaceStorage",P.close())})),this.B(this.g.onWillCreateProfile(w=>{w.join((async()=>{await this.j.exists(w.profile.globalStorageHome)||await this.j.createFolder(w.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(w=>{const P=this.t.get(w.profile.id);P&&w.join(P.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const w=new b.$Sbc(this.n(),this.g,this.c,this.j);return this.B(C.Event.once(w.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),w}profileStorage(w){if((0,d.$3p)(w))return this.applicationStorage;let P=this.t.get(w.id);if(!P){this.c.trace(`StorageMainService: creating profile storage (${w.name})`),P=this.B(this.u(w)),this.t.set(w.id,P);const a=this.B(P.onDidChangeStorage(t=>this.b.fire({...t,storage:P,profile:w})));this.B(C.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${w.name})`),this.t.delete(w.id),a.dispose()}))}return P}u(w){return this.a===2?new b.$Ubc(this.c,this.j):new b.$Rbc(w,this.n(),this.c,this.j)}workspaceStorage(w){let P=this.w.get(w.id);return P||(this.c.trace(`StorageMainService: creating workspace storage (${w.id})`),P=this.B(this.y(w)),this.w.set(w.id,P),this.B(C.Event.once(P.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${w.id})`),this.w.delete(w.id)}))),P}y(w){return this.a===2?new b.$Ubc(this.c,this.j):new b.$Tbc(w,this.n(),this.c,this.f,this.j)}isUsed(w){const P=n.URI.file(w);for(const a of[this.applicationStorage,...this.t.values(),...this.w.values()])if(a.path&&this.m.extUri.isEqualOrParent(n.URI.file(a.path),P))return!0;return!1}};e.$Wbc=p,e.$Wbc=p=Ee([ie(0,l.$2j),ie(1,R.$Ci),ie(2,m.$zbc),ie(3,h.$Pbc),ie(4,j.$2k),ie(5,f.$zl)],p),e.$Xbc=(0,k.$vi)("applicationStorageMainService");let $=class extends d.$2p{constructor(w,P){super(),this.s=w,this.U=P,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(w){if(w===-1)return this.U.applicationStorage.storage}Q(w){if(w===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:y.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$Ybc=$,e.$Ybc=$=Ee([ie(0,v.$Bl),ie(1,e.$Vbc)],$)}),define(re[291],oe([0,1,88,26,107,100,8,2,4,18,5,27,245,246,96,130,17]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ndc=e.$mdc=e.$ldc=e.$kdc=void 0;async function $(t,r,s,i,o){let u;for(let g=3;g&&(u?.dispose(),u=await new c(t,r,s,i,o).waitForReady(),!(o&&E.$Ug[o]||!E.$Ug[u.tunnelLocalPort]));g--);return u}class c extends k.$Vc{constructor(r,s,i,o,u){super(),this.m=s,this.n=u,this.privacy=y.TunnelPrivacyId.Private,this.j=new Map,this.a=r,this.b=n.createServer(),this.c=new j.$uh,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=g=>this.r(g),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=o,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const r=this.n??this.tunnelRemotePort,s=(0,y.$jw)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,E.$Vg)(r,2,1e3,s),o=null;return this.b.listen(i,this.m),await this.c.wait(),o=this.b.address(),o||(i=0,this.b.listen(i,this.m),await this.c.wait(),o=this.b.address()),this.tunnelLocalPort=o.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${o.port}`,this}async r(r){r.pause();const s=(0,y.$hw)(this.tunnelRemoteHost)||(0,y.$jw)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$Rl)(this.a,s,this.tunnelRemotePort),o=i.getSocket(),u=i.readEntireBuffer();i.dispose(),u.byteLength>0&&r.write(u.buffer),r.on("end",()=>{r.localAddress&&this.j.delete(r.localAddress),o.end()}),r.on("close",()=>o.end()),r.on("error",()=>{r.localAddress&&this.j.delete(r.localAddress),o instanceof R.$ki?o.socket.destroy():o.end()}),o instanceof R.$ki?this.t(r,o):this.s(r,o),r.localAddress&&this.j.set(r.localAddress,()=>{r.end(),o.end()})}s(r,s){s.onClose(()=>r.destroy()),s.onEnd(()=>r.end()),s.onData(i=>r.write(i.buffer)),r.on("data",i=>s.write(p.$Fe.wrap(i))),r.resume()}t(r,s){const i=s.socket;i.on("end",()=>r.end()),i.on("close",()=>r.end()),i.on("error",()=>{r.destroy()}),i.pipe(r),r.pipe(i)}}e.$kdc=c;let w=class extends y.$mw{constructor(r,s,i,o,u){super(s,u),this.v=r,this.w=i,this.y=o}isPortPrivileged(r){return(0,y.$kw)(r,this.m,h.OS,C.release())}t(r,s,i,o,u,g,S,D){const I=this.s(s,i);if(I)return++I.refcount,I.value;if((0,y.$dw)(r))return this.u(r,s,i,u,g,S,D);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${i} on local port ${u}.`);const O={commit:this.y.commit,quality:this.y.quality,addressProvider:r,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=$(O,o,s,i,u);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,i,M),M}}};e.$ldc=w,e.$ldc=w=Ee([ie(0,m.$Ll),ie(1,d.$2j),ie(2,f.$Ol),ie(3,b.$ik),ie(4,l.$2i)],w);let P=class extends w{constructor(r,s,i,o,u){super(r,s,i,o,u)}};e.$mdc=P,e.$mdc=P=Ee([ie(0,m.$Ll),ie(1,d.$2j),ie(2,f.$Ol),ie(3,b.$ik),ie(4,l.$2i)],P);let a=class extends k.$Vc{constructor(r,s,i,o,u){super(),this.b=r,this.c=s,this.f=i,this.g=o,this.h=u,this.a=new Map}async openTunnel(r,s,i,o,u,g,S,D,I){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${o} on local port ${g}.`),!this.a.has(r)){const O=new P(this.b,this.c,this.g,this.f,this.h);this.B(O),this.a.set(r,O),O.onTunnelClosed(async()=>{(await O.tunnels).length===0&&(O.dispose(),this.a.delete(r))})}return this.a.get(r).openTunnel(s,i,o,u,g,S,D,I)}};e.$ndc=a,e.$ndc=a=Ee([ie(0,m.$Ll),ie(1,d.$2j),ie(2,b.$ik),ie(3,f.$Ol),ie(4,l.$2i)],a)}),define(re[101],oe([0,1,8,23,3,18,24,20,5,27,53,50]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jcc=void 0,e.$Icc=v;function v(f,y,p){return`${p.updateUrl}/api/update/${f}/${y}/${p.commit}`}let m=class{get state(){return this.b}d(y){this.j.info("update#setState",y.type),this.b=y,this.c.fire(y)}constructor(y,p,$,c,w,P){this.f=y,this.g=p,this.h=$,this.i=c,this.j=w,this.k=P,this.b=b.$MX.Uninitialized,this.c=new E.$ee,this.onStateChange=this.c.event,y.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(b.$MX.Disabled(0));return}if(this.h.disableUpdates){this.d(b.$MX.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(b.$MX.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const y=this.g.getValue("update.mode"),p=this.m(y);if(!p){this.d(b.$MX.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(p),!this.a){this.d(b.$MX.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(b.$MX.Idle(this.q())),y==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}y==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(y){return y==="none"?void 0:this.k.quality}n(y=60*60*1e3){return(0,n.$wh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(y){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(y)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(y){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},C.CancellationToken.None)).res.statusCode===204}catch(p){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(p);return}}async _applySpecificUpdate(y){}q(){return 1}r(){}};e.$Jcc=m,e.$Jcc=m=Ee([ie(0,k.$Pbc),ie(1,R.$2i),ie(2,j.$lbc),ie(3,d.$Mp),ie(4,h.$2j),ie(5,l.$ik)],m)}),define(re[292],oe([0,1,14,51,3,46,2,18,24,20,5,27,53,28,50,101]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kcc=void 0;let p=class extends y.$Jcc{get v(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"error",(c,w)=>w)}get w(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-not-available")}get x(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-available")}get y(){return E.Event.fromNodeEventEmitter(n.autoUpdater,"update-downloaded",(c,w,P,a)=>({version:P,productVersion:P,timestamp:a}))}constructor(c,w,P,a,t,r,s){super(c,w,a,t,r,s),this.z=P,this.u=new j.$Uc,c.setRelaunchHandler(this)}handleRelaunch(c){return c?.addArgs||c?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(c){this.z.publicLog2("update:error",{messageHash:String((0,R.$jj)(String(c)))}),this.j.error("UpdateService error:",c);const w=this.state.type==="checking for updates"&&this.state.explicit?c:void 0;this.d(f.$MX.Idle(1,w))}s(c){let w;this.k.darwinUniversalAssetId?w=this.k.darwinUniversalAssetId:w=process.arch==="x64"?"darwin":"darwin-arm64";const P=(0,y.$Icc)(w,c,this.k);try{n.autoUpdater.setFeedURL({url:P})}catch(a){this.j.error("Failed to set update feed URL",a);return}return P}t(c){this.d(f.$MX.CheckingForUpdates(c)),n.autoUpdater.checkForUpdates()}E(){this.state.type==="checking for updates"&&this.d(f.$MX.Downloading)}F(c){this.state.type==="downloading"&&(this.d(f.$MX.Downloaded(c)),this.z.publicLog2("update:downloaded",{version:c.version}),this.d(f.$MX.Ready(c)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.$MX.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),n.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$Kcc=p,Ee([C.$Zh],p.prototype,"v",null),Ee([C.$Zh],p.prototype,"w",null),Ee([C.$Zh],p.prototype,"x",null),Ee([C.$Zh],p.prototype,"y",null),e.$Kcc=p=Ee([ie(0,l.$Pbc),ie(1,k.$2i),ie(2,m.$1l),ie(3,h.$lbc),ie(4,v.$Mp),ie(5,d.$2j),ie(6,b.$ik)],p)}),define(re[293],oe([0,1,49,43,8,3,9,24,20,5,28,50]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcc=void 0;let v=class{get state(){return this.a}d(y){this.g.info("update#setState",y.type),this.a=y,this.b.fire(y)}constructor(y,p,$){if(this.f=y,this.g=$,this.a=b.$MX.Uninitialized,this.b=new R.$ee,this.onStateChange=this.b.event,p.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(b.$MX.Idle(this.k())),this.h(30*1e3).then(void 0,c=>this.g.error(c))}h(y=60*60*1e3){return(0,E.$wh)(y).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(y){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(y)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(y){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(y=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${y}`),!y&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(y){}};v=Ee([ie(0,h.$Pbc),ie(1,k.$lbc),ie(2,l.$2j)],v);let m=class extends v{constructor(y,p,$,c,w,P){super($,c,w),this.o=y,this.p=p,this.q=P;const a=(0,C.watch)(j.$nc(this.o)),t=R.Event.fromNodeEventEmitter(a,"change",(o,u)=>u),r=R.Event.filter(t,o=>o==="current"),i=R.Event.debounce(r,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),a.close()})}m(){this.d(b.$MX.CheckingForUpdates(!1)),this.u().then(y=>{y?this.d(b.$MX.Ready({version:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$MX.Idle(2)))},y=>{this.g.error(y),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(b.$MX.Idle(2,y.message||y))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,n.spawn)("sleep 3 && "+j.$oc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const y=await new Promise(($,c)=>(0,C.realpath)(`${j.$nc(this.o)}/current`,(w,P)=>w?c(w):$(P))),p=j.$oc(y);return this.p!==p}isLatestVersion(){return this.u().then(void 0,y=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$Mcc=m,e.$Mcc=m=Ee([ie(2,h.$Pbc),ie(3,k.$lbc),ie(4,l.$2j),ie(5,d.$1l)],m)}),define(re[29],oe([0,1,14,4,6,82,55,69,27,18,24,9,138]),function(X,e,n,C,E,R,j,k,h,l,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowStateValidator=e.OpenContext=e.$wbc=void 0,e.$xbc=f,e.$ybc=y,e.$wbc=(0,E.$vi)("windowsMainService");var m;(function($){$[$.CLI=0]="CLI",$[$.DOCK=1]="DOCK",$[$.MENU=2]="MENU",$[$.DIALOG=3]="DIALOG",$[$.DESKTOP=4]="DESKTOP",$[$.API=5]="API"})(m||(e.OpenContext=m={}));function f($,c,w){const P=$.get(k.$ubc),a=$.get(h.$ik),t=$.get(l.$2i),r=$.get(d.$lbc),s=t.getValue("window"),i={backgroundColor:P.getBackgroundColor(),minWidth:j.$tD.WIDTH,minHeight:j.$tD.HEIGHT,title:a.nameLong,show:c.mode!==0&&c.mode!==3,x:c.x,y:c.y,width:c.width,height:c.height,webPreferences:{...w,enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,j.$ED)(c.zoomLevel??s?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",sandbox:!0},experimentalDarkMode:!0};if(C.$k?i.icon=(0,b.$kc)(r.appRoot,"resources/linux/code.png"):C.$i&&!r.isBuilt&&(i.icon=(0,b.$kc)(r.appRoot,"resources/win32/code_150x150.png")),C.$j&&(i.acceptFirstMouse=!0,s?.clickThroughInactive===!1&&(i.acceptFirstMouse=!1)),C.$j&&!(0,j.$DD)(t)&&(i.fullscreenable=!1),C.$j&&s?.nativeTabs===!0&&(i.tabbingIdentifier=a.nameShort),!(0,j.$AD)(t)&&(i.titleBarStyle="hidden",C.$j||(i.frame=!1),(0,j.$CD)(t))){const g=P.getWindowSplash()?.colorInfo.titleBarBackground??P.getBackgroundColor(),S=v.$Ot.fromHex(g).isDarker()?"#FFFFFF":"#000000";i.titleBarOverlay={height:29,color:g,symbolColor:S}}return i}function y($){let c,w=Number.MIN_VALUE;for(const P of $)P.lastFocusTime>w&&(w=P.lastFocusTime,c=P);return c}var p;(function($){function c(P,a,t=n.screen.getAllDisplays()){if(P.trace(`window#validateWindowState: validating window state on ${t.length} display(s)`,a),typeof a.x!="number"||typeof a.y!="number"||typeof a.width!="number"||typeof a.height!="number"){P.trace("window#validateWindowState: unexpected type of state values");return}if(a.width<=0||a.height<=0){P.trace("window#validateWindowState: unexpected negative values");return}if(t.length===1){const i=w(t[0]);if(P.trace("window#validateWindowState: single monitor working area",i),i){let o=function(){!a||typeof a.x!="number"||typeof a.y!="number"||!i||(a.x<i.x&&(a.x=i.x),a.y<i.y&&(a.y=i.y))};o(),a.width>i.width&&(a.width=i.width),a.height>i.height&&(a.height=i.height),a.x>i.x+i.width-128&&(a.x=i.x+i.width-a.width),a.y>i.y+i.height-128&&(a.y=i.y+i.height-a.height),o()}return a}if(a.display&&a.mode===3){const i=t.find(o=>o.id===a.display);if(i&&typeof i.bounds?.x=="number"&&typeof i.bounds?.y=="number"){P.trace("window#validateWindowState: restoring fullscreen to previous display");const o=(0,R.$jbc)(3);return o.x=i.bounds.x,o.y=i.bounds.y,o}}let r,s;try{r=n.screen.getDisplayMatching({x:a.x,y:a.y,width:a.width,height:a.height}),s=w(r),P.trace("window#validateWindowState: multi-monitor working area",s)}catch(i){P.error("window#validateWindowState: error finding display for window state",i)}if(r&&s&&a.x+a.width>s.x&&a.y+a.height>s.y&&a.x<s.x+s.width&&a.y<s.y+s.height)return a;P.trace("window#validateWindowState: state is outside of the multi-monitor working area")}$.validateWindowState=c;function w(P){if(P.workArea.width>0&&P.workArea.height>0)return P.workArea;if(P.bounds.width>0&&P.bounds.height>0)return P.bounds}})(p||(e.WindowStateValidator=p={}))}),define(re[294],oe([0,1,14,23,3,46,2,33,120,5,84,29]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zbc=void 0;var v;(function(f){f[f.Initial=1]="Initial",f[f.StoredCredentialsUsed=2]="StoredCredentialsUsed",f[f.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let m=class extends j.$Vc{constructor(y,p,$,c){super(),this.g=y,this.h=p,this.j=$,this.m=c,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const y=E.Event.fromNodeEventEmitter(n.app,"login",(p,$,c,w,P)=>({event:p,webContents:$,req:c,authInfo:w,callback:P}));this.B(y(this.r,this))}async r({event:y,authInfo:p,req:$,callback:c}){if(!p.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}y.preventDefault();let w;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),w=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(p);try{w=await this.b}finally{this.b=void 0}}c(w?.username,w?.password)}async s(y){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const p=await this.t(y);if(p)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),p;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(y){this.g.trace("auth#doResolveProxyCredentials - enter",y);const p=String((0,R.$jj)({scheme:y.scheme,host:y.host,port:y.port}));let $,c;try{const t=this.m.get(this.a+p,-1);if(t){const r=JSON.parse(await this.j.decrypt(t));$=r.username,c=r.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof $=="string"&&typeof c=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:$,password:c};const w=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!w){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${w.id} to handle proxy login`);const P={authInfo:y,username:this.f?.username??$,password:this.f?.password??c,replyChannel:`vscode:proxyAuthResponse:${(0,k.$Rg)()}`};w.sendWhenReady("vscode:openProxyAuthenticationDialog",C.CancellationToken.None,P),this.c=v.LoginDialogShown;const a=await new Promise(t=>{const r=async(s,i,o)=>{if(i===P.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${w.id}`),w.win?.webContents.off("ipc-message",r),o){const u={username:o.username,password:o.password};try{if(o.remember){const g=await this.j.encrypt(JSON.stringify(u));this.m.store(this.a+p,g,-1,1)}else this.m.remove(this.a+p,-1)}catch(g){this.g.error(g)}t({username:u.username,password:u.password})}else t(void 0)};w.win?.webContents.on("ipc-message",r)});return this.f=a,a}};e.$Zbc=m,e.$Zbc=m=Ee([ie(0,l.$2j),ie(1,b.$wbc),ie(2,h.$xX),ie(3,d.$Xbc)],m)}),define(re[295],oe([0,1,14,22,4,7,21,18,64,6,5,131,29]),function(X,e,n,C,E,R,j,k,h,l,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pcc=e.$occ=e.ID=void 0,e.ID="launchMainService",e.$occ=(0,l.$vi)(e.ID);let m=class{constructor(y,p,$,c){this.a=y,this.b=p,this.c=$,this.d=c}async start(y,p){this.a.trace("Received data from other instance: ",y,p),E.$j&&n.app.focus({steal:!0});const $=this.e(y);if($.length){let c=Promise.resolve();if(this.b.getWindowCount()===0){const w=(0,C.$Ob)(await this.b.openEmptyWindow({context:4}));w&&(c=w.ready())}c.then(()=>{for(const{uri:w,originalUrl:P}of $)this.c.open(w,{originalUrl:P})})}else return this.f(y,p)}e(y){return y["open-url"]&&y._urls&&y._urls.length>0?(0,C.$Hb)(y._urls.map(p=>{try{return{uri:R.URI.parse(p),originalUrl:p}}catch{return null}})):[]}async f(y,p){const $=(0,h.$zm)(p)?0:4;let c=[];const w=y.wait&&y.waitMarkerFilePath?R.URI.file(y.waitMarkerFilePath):void 0,P=y.remote||void 0,a={context:$,cli:y,userEnv:y["preserve-env"]||$===0?p:void 0,waitMarkerFileURI:w,remoteAuthority:P,forceProfile:y.profile,forceTempProfile:y["profile-temp"]};if(y.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(y.extensionDevelopmentPath,a);else if(!y._.length&&!y["folder-uri"]&&!y["file-uri"]){let t=!1;if(y["new-window"]||a.forceProfile||a.forceTempProfile)t=!0;else if(y["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!E.$j}if(t)c=await this.b.open({...a,forceNewWindow:!0,forceEmpty:!0});else{const r=this.b.getLastActiveWindow();r?(this.b.openExistingWindow(r,a),c=[r]):c=await this.b.open({...a,forceEmpty:!0})}}else c=await this.b.open({...a,forceNewWindow:y["new-window"],preferNewWindow:!y["reuse-window"]&&!y.wait,forceReuseWindow:y["reuse-window"],diffMode:y.diff,mergeMode:y.merge,addMode:y.add,noRecentEntry:!!y["skip-add-to-recently-opened"],gotoLineMode:y.goto});if(w&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,j.whenDeleted)(w.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$pcc=m,e.$pcc=m=Ee([ie(0,d.$2j),ie(1,v.$wbc),ie(2,b.$DX),ie(3,k.$2i)],m)}),define(re[296],oe([0,1,2,20,57,30,8,29]),function(X,e,n,C,E,R,j,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5cc=void 0;let h=class extends n.$Vc{constructor(d,b,v){super(),this.a=b,this.b=v,this.B(d.onWillLoadWindow(m=>{m.reason===2&&this.c(m.window)})),this.B(d.onBeforeCloseWindow(m=>this.c(m))),this.B(new j.$Hh(()=>this.g(),30*1e3)).schedule()}async c(d){const b=this.f(d),v=this.a.getProfileForWorkspace(b);v?.isTransient&&(this.a.unsetWorkspace(b,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(d){return d.openedWorkspace??(0,R.$Ji)(d.backupPath,d.isExtensionDevelopmentHost)}g(){const d=this.a.getAssociatedEmptyWindows();if(d.length===0)return;const b=this.b.getWindows().map(v=>this.f(v));for(const v of d)b.some(m=>m.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$5cc=h,e.$5cc=h=Ee([ie(0,C.$Pbc),ie(1,E.$zbc),ie(2,k.$wbc)],h)}),define(re[61],oe([0,1,14,2,3,5,316,8,13,29,74,28,20,76,35,4,102]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$4bc=e.$3bc=void 0;function c(a){return typeof a.responseWindowId=="number"}let w=class extends C.$Vc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,r,s){super(),this.u=t,this.w=r,this.y=s,this.c=String(++$.a),this.f=this.B(new E.$ee),this.onStdout=this.f.event,this.g=this.B(new E.$ee),this.onStderr=this.g.event,this.h=this.B(new E.$ee),this.onMessage=this.h.event,this.j=this.B(new E.$ee),this.onSpawn=this.j.event,this.m=this.B(new E.$ee),this.onExit=this.m.event,this.n=this.B(new E.$ee),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,r){let s;switch(this.t?.correlationId?s=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:s=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,r){case d.default.Error:this.u.error(s);break;case d.default.Warning:this.u.warn(s);break;case d.default.Info:this.u.trace(s);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",d.default.Error),!1):!0}start(t){const r=this.D(t);return r&&t.payload&&this.postMessage(t.payload)&&this.z("payload sent via postMessage()",d.default.Info),r}D(t){if(!this.C())return!1;this.t=t;const r=`${this.t.type}-${this.c}`,s=h.$Pg.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],o=this.t.execArgv??[],u=this.t.allowLoadingUnsignedLibraries,g=this.t.forceAllocationsToV8Sandbox,S="pipe",D=this.F(t);return this.z("creating new...",d.default.Info),this.r=n.utilityProcess.fork(s,i,{serviceName:r,env:D,execArgv:o,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:g,stdio:S}),this.G(this.r,this.t,r),!0}F(t){const r=t.env?{...t.env}:{...(0,f.$2n)(process.env)};r.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(r.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),r.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,y.$i&&((0,p.isUNCAccessRestrictionsDisabled)()?r.NODE_DISABLE_UNC_ACCESS_CHECKS="1":r.NODE_UNC_HOST_ALLOWLIST=(0,p.getUNCHostAllowlist)().join("\\")),(0,m.$mm)(r);for(const s of Object.keys(r))r[s]=String(r[s]);return r}G(t,r,s){if(t.stdout){const i=new j.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:i.write(o))))}if(t.stderr){const i=new j.StringDecoder("utf-8");this.B(E.Event.fromNodeEventEmitter(t.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:i.write(o))))}this.B(E.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(E.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:c(r)?`${r.type} [${r.responseWindowId}]`:r.type}),this.z("successfully created",d.default.Info),this.j.fire(t.pid)})),this.B(E.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,d.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(E.Event.fromNodeEventEmitter(n.app,"child-process-gone",(i,o)=>({event:i,details:o}))(({details:i})=>{i.type==="Utility"&&i.name===s&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,d.default.Error),this.w.publicLog2("utilityprocesscrash",{type:r.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,r){const s=this.B(this.h.event(i=>{i===t&&(s.dispose(),r())}))}postMessage(t,r){return this.r?(this.r.postMessage(t,r),!0):!1}connect(t){const{port1:r,port2:s}=new n.MessageChannelMain;return this.postMessage(t,[s]),r}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",d.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",d.default.Info),this.r.kill()?(this.z("successfully killed the process",d.default.Info),this.H()):this.z("unable to kill the process",d.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",d.default.Info),await Promise.race([E.Event.toPromise(this.onExit),(0,k.$wh)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,d.default.Info),this.kill()))}};e.$3bc=w,e.$3bc=w=$=Ee([ie(0,R.$2j),ie(1,b.$1l),ie(2,v.$Pbc)],w);let P=class extends w{constructor(t,r,s,i){super(t,s,i),this.I=r}start(t){const r=this.I.getWindowById(t.responseWindowId);if(!r?.win||r.win.isDestroyed()||r.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",d.default.Error),!0;if(!super.D(t))return!1;this.J(r.win,t);const i=this.connect(t.payload);return r.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,r){r.windowLifecycleBound&&(this.B(E.Event.filter(this.y.onWillLoadWindow,s=>s.window.win===t)(()=>this.kill())),this.B(E.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$4bc=P,e.$4bc=P=Ee([ie(0,R.$2j),ie(1,l.$wbc),ie(2,b.$1l),ie(3,v.$Pbc)],P)}),define(re[297],oe([0,1,15,3,5,20,8,61,29,28]),function(X,e,n,C,E,R,j,k,h,l){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$$bc=void 0;let b=class{static{d=this}static{this.a=0}constructor(m,f,y,p){this.d=m,this.f=f,this.g=y,this.h=p,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const f=this.b.get(m);if(!f)throw new Error("Unknown extension host!");return f}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,n.$6)();const m=String(++d.a),f=new k.$4bc(this.d,this.g,this.h,this.f);return this.b.set(m,f),f.onExit(({pid:y,code:p,signal:$})=>{this.d.info(`Extension host with pid ${y} exited with code: ${p}, signal: ${$}.`),setTimeout(()=>{f.dispose(),this.b.delete(m)}),setTimeout(()=>{try{process.kill(y,0),this.d.error(`Extension host with pid ${y} still exists, forcefully killing it...`),process.kill(y)}catch{}},1e3)}),{id:m}}async start(m,f){if(this.c)throw(0,n.$6)();const y=this.i(m);return y.start({...f,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:f.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m}),{pid:await C.Event.toPromise(y.onSpawn)}}async enableInspectPort(m){if(this.c)throw(0,n.$6)();const f=this.b.get(m);return f?f.enableInspectPort():!1}async kill(m){if(this.c)throw(0,n.$6)();const f=this.b.get(m);f&&f.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const f=[];for(const[,y]of this.b)f.push(y.waitForExit(m));return j.Promises.settled(f).then(()=>{})}};e.$$bc=b,e.$$bc=b=d=Ee([ie(0,E.$2j),ie(1,R.$Pbc),ie(2,h.$wbc),ie(3,l.$1l)],b)}),define(re[298],oe([0,1,37,8,2,24,20,5,41,39,67,61,54,91,12,251]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccc=void 0;let p=class extends E.$Vc{constructor(c,w,P,a,t,r,s,i){super(),this.f=c,this.g=w,this.h=P,this.j=a,this.m=t,this.n=r,this.r=s,this.s=i,this.a=new C.$uh,this.b=void 0,this.c=void 0,this.y=void 0,this.z=void 0,this.t()}t(){n.$OW.on(y.$Acc.request,(c,w)=>this.u(c,w,y.$Acc.response)),n.$OW.on(y.$Bcc.request,(c,w)=>this.u(c,w,y.$Bcc.response)),this.B(this.m.onWillShutdown(()=>this.w()))}async u(c,w,P){this.n.trace(`[SharedProcess] onWindowConnection for: ${P}`),this.a.isOpen()||this.a.open(),await this.whenReady();const a=await this.connect(P);if(c.sender.isDestroyed())return a.close();c.sender.postMessage(P,w,[a])}w(){this.n.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(y.$zcc.exit),this.b=void 0}whenReady(){return this.y||(this.y=(async()=>{await this.C;const c=new C.$Sh;this.b?.once(y.$zcc.initDone,()=>c.complete()),await c.p,this.c?.dispose(),this.n.trace("[SharedProcess] Overall ready")})()),this.y}get C(){return this.z||(this.z=(async()=>{await this.a.wait(),this.D();const c=new C.$Sh;this.b?.once(y.$zcc.ipcReady,()=>c.complete()),await c.p,this.n.trace("[SharedProcess] IPC ready")})()),this.z}D(){this.b=this.B(new b.$3bc(this.n,v.$gp,this.m)),this.c=this.b.onMessage(P=>{typeof P.warning=="string"?this.n.warn(P.warning):typeof P.error=="string"&&this.n.error(P.error)});const c=(0,m.$0m)(this.h.args,this.h.isBuilt);let w;c.port&&(w=["--nolazy"],c.break?w.push(`--inspect-brk=${c.port}`):w.push(`--inspect=${c.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.F(),execArgv:w})}F(){return{machineId:this.f,sqmId:this.g,codeCachePath:this.h.codeCachePath,profiles:{home:this.j.profilesHome,all:this.j.profiles},args:this.h.args,logLevel:this.r.getLogLevel(),loggers:this.r.getRegisteredLoggers(),policiesData:this.s.serialize()}}async connect(c){return await this.C,(0,f.$gg)(this.b).connect(c)}};e.$Ccc=p,e.$Ccc=p=Ee([ie(2,R.$lbc),ie(3,h.$Bl),ie(4,j.$Pbc),ie(5,k.$2j),ie(6,d.$Kbc),ie(7,l.$do)],p)}),define(re[299],oe([0,1,24,91,20,5,54,61,114,37,2,3,35,18,13]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cdc=void 0;let y=class extends d.$Vc{constructor($,c,w,P,a){super(),this.f=$,this.g=c,this.h=w,this.j=P,this.m=a,this.a=void 0,this.b=new b.$ee,this.onRequestConnection=this.b.event,this.c=new b.$ee,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$OW.on("vscode:createPtyHostMessageChannel",(t,r)=>this.r(t,r)),this.B((0,d.$Tc)(()=>{l.$OW.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new k.$3bc(this.m,j.$gp,this.j);const $=(0,C.$9m)(this.h.args,this.h.isBuilt),c=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:c,args:["--logsPath",this.h.logsHome.with({scheme:f.Schemas.file}).fsPath],env:this.n()});const w=this.a.connect(),P=new h.$WW(w,"ptyHost"),a=new d.$Uc;return a.add(P),a.add((0,d.$Tc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:P,store:a,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,v.$2n)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},c=this.g.getValue("terminal.integrated.developer.ptyHost.latency");c&&typeof c=="number"&&($.VSCODE_LATENCY=String(c));const w=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return w&&typeof w=="number"&&($.VSCODE_STARTUP_DELAY=String(w)),this.h.restoreSnapExportedVariables(),$}r($,c){this.b.fire();const w=this.a.connect();if($.sender.isDestroyed()){w.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",c,[w])}};e.$cdc=y,e.$cdc=y=Ee([ie(1,m.$2i),ie(2,n.$lbc),ie(3,E.$Pbc),ie(4,R.$2j)],y)}),define(re[300],oe([0,1,2,6,5,29,61,28,46,3,8,20]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bdc=e.$adc=void 0,e.$adc=(0,C.$vi)("utilityProcessWorker");let v=class extends n.$Vc{constructor(y,p,$,c){super(),this.b=y,this.c=p,this.f=$,this.g=c,this.a=new Map}async createWorker(y){const p=`window: ${y.reply.windowId}, moduleId: ${y.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${p})`);const $=this.h(y);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${p})`),this.disposeWorker(y));const c=new m(this.b,this.c,this.f,this.g,y);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,c);const w=new d.$Sh;return l.Event.once(c.onDidTerminate)(P=>{P.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${P.code}, signal: ${P.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${P.code}, signal: ${P.signal}`),this.a.delete($),w.complete({reason:P})}),w.p}h(y){return(0,h.$jj)({moduleId:y.process.moduleId,windowId:y.reply.windowId})}async disposeWorker(y){const p=this.h(y),$=this.a.get(p);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${y.reply.windowId}, moduleId: ${y.process.moduleId})`),$.kill(),this.a.delete(p))}};e.$bdc=v,e.$bdc=v=Ee([ie(0,E.$2j),ie(1,R.$wbc),ie(2,k.$1l),ie(3,b.$Pbc)],v);let m=class extends n.$Vc{constructor(y,p,$,c,w){super(),this.c=y,this.f=p,this.g=$,this.h=c,this.j=w,this.a=this.B(new l.$ee),this.onDidTerminate=this.a.event,this.b=new j.$4bc(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(y=>this.a.fire({code:y.code,signal:y.signal}))),this.B(this.b.onCrash(y=>this.a.fire({code:y.code,signal:"ECRASH"})))}spawn(){const p=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:p,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};m=Ee([ie(0,E.$2j),ie(1,R.$wbc),ie(2,k.$1l),ie(3,b.$Pbc)],m)}),define(re[301],oe([0,1,14,3,2,277,29]),function(X,e,n,C,E,R,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ucc=void 0;let k=class extends E.$Vc{constructor(l){super(),this.b=l,this.a=this.B(new C.$ee),this.onFoundInFrame=this.a.event,this.B(new R.$Tcc)}async setIgnoreMenuShortcuts(l,d){let b;if(typeof l.windowId=="number"){const{windowId:v}=l,m=this.b.getWindowById(v);if(!m?.win)throw new Error(`Invalid windowId: ${v}`);b=m.win.webContents}else{const{webContentsId:v}=l;if(b=n.webContents.fromId(v),!b)throw new Error(`Invalid webContentsId: ${v}`)}b.isDestroyed()||b.setIgnoreMenuShortcuts(d)}async findInFrame(l,d,b,v){const f=this.c(l,d);if(typeof f.findInFrame=="function"){f.findInFrame(b,{findNext:v.findNext,forward:v.forward});const y=(p,$)=>{$.finalUpdate&&(this.a.fire($),f.removeListener("found-in-frame",y))};f.on("found-in-frame",y)}}async stopFindInFrame(l,d,b){const m=this.c(l,d);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(b.keepSelection?"keepSelection":"clearSelection")}c(l,d){const b=this.b.getWindowById(l.windowId);if(!b?.win)throw new Error(`Invalid windowId: ${l}`);const v=b.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===d);if(!v)throw new Error(`Unknown frame: ${d}`);return v}};e.$Ucc=k,e.$Ucc=k=Ee([ie(0,j.$wbc)],k)}),define(re[302],oe([0,1,14,2,4,19,7,18,20,5,34,29,82,30]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vcc=void 0,e.$Wcc=p,e.$Xcc=c;let y=class extends C.$Vc{static{f=this}static{this.a="windowsState"}get state(){return this.b}constructor(a,t,r,s,i){super(),this.g=a,this.h=t,this.j=r,this.m=s,this.n=i,this.b=p(this.h.getItem(f.a)),this.c=void 0,this.f=!1,this.r()}r(){n.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(a=>this.u(a)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(a=>{a.newCount-a.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(a=>this.u(a))}s(){this.f=!0,this.t()}t(){const a=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(o=>!o.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&a.add(t.lastActiveWindow.uiState.display))}const r=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);r&&(t.lastPluginDevelopmentHostWindow=this.w(r),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(a.has(t.lastPluginDevelopmentHostWindow.uiState.display)?E.$j&&!r.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):a.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const o=this.w(i);return o.uiState.mode===3&&(a.has(o.uiState.display)?E.$j&&o.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(o.uiState.mode=1):a.add(o.uiState.display)),o}));const s=c(t);this.h.setItem(f.a,s),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",s)}u(a){if(this.j.quitRequested)return;const t=this.w(a);a.isExtensionDevelopmentHost&&!a.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!a.isExtensionDevelopmentHost&&a.openedWorkspace&&this.b.openedWindows.forEach(r=>{const s=(0,m.$Ki)(a.openedWorkspace)&&r.workspace?.id===a.openedWorkspace.id,i=(0,m.$Fi)(a.openedWorkspace)&&r.folderUri&&R.$Zg.isEqual(r.folderUri,a.openedWorkspace.uri);(s||i)&&(r.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(a){return{windowId:a.id,workspace:(0,m.$Ki)(a.openedWorkspace)?a.openedWorkspace:void 0,folderUri:(0,m.$Fi)(a.openedWorkspace)?a.openedWorkspace.uri:void 0,backupPath:a.backupPath,remoteAuthority:a.remoteAuthority,uiState:a.serializeWindowState()}}getNewWindowState(a){const t=this.z(a),r=this.n.getValue("window");if(t.mode===3){let s;t.hasDefaultState?s=!!(r?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(r.newWindowDimensions)>=0):s=!!(this.j.wasRestarted||r?.restoreFullscreen),s||(t.mode=1)}return t}z(a){const t=this.g.getLastActiveWindow();if(!a.extensionTestsPath){if(a.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const g=a.workspace;if((0,m.$Ki)(g)){const D=this.state.openedWindows.filter(I=>I.workspace&&I.workspace.id===g.id).map(I=>I.uiState);if(D.length)return D[0]}if((0,m.$Fi)(g)){const D=this.state.openedWindows.filter(I=>I.folderUri&&R.$Zg.isEqual(I.folderUri,g.uri)).map(I=>I.uiState);if(D.length)return D[0]}else if(a.backupPath){const D=this.state.openedWindows.filter(I=>I.backupPath===a.backupPath).map(I=>I.uiState);if(D.length)return D[0]}const S=this.c||this.state.lastActiveWindow;if(!t&&S)return S.uiState}let r;const s=n.screen.getAllDisplays();if(s.length===1)r=s[0];else{if(E.$j){const g=n.screen.getCursorScreenPoint();r=n.screen.getDisplayNearestPoint(g)}!r&&t&&(r=n.screen.getDisplayMatching(t.getBounds())),r||(r=n.screen.getPrimaryDisplay()||s[0])}let i=(0,v.$jbc)();i.x=Math.round(r.bounds.x+r.bounds.width/2-i.width/2),i.y=Math.round(r.bounds.y+r.bounds.height/2-i.height/2);const o=this.n.getValue("window");let u=!0;if(o?.newWindowDimensions){if(o.newWindowDimensions==="maximized")i.mode=0,u=!1;else if(o.newWindowDimensions==="fullscreen")i.mode=3,u=!1;else if((o.newWindowDimensions==="inherit"||o.newWindowDimensions==="offset")&&t){const g=t.serializeWindowState();g.mode===3?i.mode=3:i={...g,zoomLevel:void 0},u=i.mode!==3&&o.newWindowDimensions==="offset"}}return u&&(i=this.C(i)),i.hasDefaultState=!0,i}C(a){if(this.g.getWindows().length===0)return a;a.x=typeof a.x=="number"?a.x:0,a.y=typeof a.y=="number"?a.y:0;const t=this.g.getWindows().map(r=>r.getBounds());for(;t.some(r=>r.x===a.x||r.y===a.y);)a.x+=30,a.y+=30;return a}};e.$Vcc=y,e.$Vcc=y=f=Ee([ie(0,b.$wbc),ie(1,d.$BQ),ie(2,h.$Pbc),ie(3,l.$2j),ie(4,k.$2i)],y);function p(P){const a={openedWindows:[]},t=P||{openedWindows:[]};return t.lastActiveWindow&&(a.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(a.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(a.openedWindows=t.openedWindows.map(r=>$(r))),a}function $(P){const a={uiState:P.uiState};return P.backupPath&&(a.backupPath=P.backupPath),P.remoteAuthority&&(a.remoteAuthority=P.remoteAuthority),P.folder&&(a.folderUri=j.URI.parse(P.folder)),P.workspaceIdentifier&&(a.workspace={id:P.workspaceIdentifier.id,configPath:j.URI.parse(P.workspaceIdentifier.configURIPath)}),a}function c(P){return{lastActiveWindow:P.lastActiveWindow&&w(P.lastActiveWindow),lastPluginDevelopmentHostWindow:P.lastPluginDevelopmentHostWindow&&w(P.lastPluginDevelopmentHostWindow),openedWindows:P.openedWindows.map(a=>w(a))}}function w(P){return{workspaceIdentifier:P.workspace&&{id:P.workspace.id,configURIPath:P.workspace.configPath.toString()},folder:P.folderUri&&P.folderUri.toString(),backupPath:P.backupPath,remoteAuthority:P.remoteAuthority,uiState:P.uiState}}}),define(re[58],oe([0,1,14,3,42,2,13,9,19,21,197,65,56,24,6,5,57,133,30,98,99]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jbc=e.$Ibc=void 0,e.$Ibc=(0,f.$vi)("workspacesManagementMainService");let a=class extends R.$Vc{constructor(r,s,i,o,u){super(),this.g=r,this.h=s,this.j=i,this.m=o,this.n=u,this.a=this.B(new C.$ee),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new C.$ee),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const r=(await l.Promises.readdir(this.c.with({scheme:j.Schemas.file}).fsPath)).map(s=>(0,h.$9g)(this.c,s,c.$Ui));for(const s of r){const i=(0,P.$Fbc)(s),o=await this.resolveLocalWorkspace(s);o?this.f.push({workspace:i,remoteAuthority:o.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(r){r.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${r}).`)}}resolveLocalWorkspace(r){return this.r(r,s=>l.Promises.readFile(s,"utf8"))}r(r,s){if(this.s(r)&&r.scheme===j.Schemas.file)try{const i=s(r.fsPath);return i instanceof Promise?i.then(o=>this.t(r,o),o=>{}):this.t(r,i)}catch{return}}s(r){return(0,c.$Vi)(r,this.g)||(0,c.$1i)(r)}t(r,s){try{const i=this.u(r,s),o=(0,P.$Fbc)(r);return{id:o.id,configPath:o.configPath,folders:(0,w.$ggb)(i.folders,o.configPath,h.$Zg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(r,s){const i=(0,E.$In)(s);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(o=>(0,w.$egb)(o));else throw new Error(`${r.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(r,s){const{workspace:i,storedWorkspace:o}=this.w(r,s),u=i.configPath.fsPath;return await l.Promises.mkdir((0,k.$nc)(u),{recursive:!0}),await l.Promises.writeFile(u,JSON.stringify(o,null,"	")),this.f.push({workspace:i,remoteAuthority:s}),i}w(r=[],s){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),o=(0,h.$9g)(this.c,i),u=(0,h.$9g)(o,c.$Ui),g=[];for(const S of r)g.push((0,w.$fgb)(S.uri,!0,S.name,o,h.$Zg));return{workspace:(0,P.$Fbc)(u),storedWorkspace:{folders:g,remoteAuthority:s}}}async getWorkspaceIdentifier(r){return(0,P.$Fbc)(r)}isUntitledWorkspace(r){return(0,c.$Vi)(r.configPath,this.g)}async deleteUntitledWorkspace(r){this.isUntitledWorkspace(r)&&(await this.y(r),this.j.isEnabled()&&this.j.unsetWorkspace(r),this.a.fire(r))}async y(r){const s=(0,h.$Wg)(r.configPath);try{await l.Promises.rm((0,k.$nc)(s));const i=(0,k.$kc)(this.g.workspaceStorageHome.with({scheme:j.Schemas.file}).fsPath,r.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,k.$kc)(i,"obsolete"),""),this.f=this.f.filter(o=>o.workspace.id!==r.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${s} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(r,s,i){if(!r||!r.win||!r.isReady||!await this.z(r,s,i))return;const u=await this.C(r,(0,P.$Fbc)(i));if(u)return this.b.fire({window:r,workspace:u.workspace}),u}async z(r,s,i){return i?(0,c.$Ki)(r.openedWorkspace)&&h.$Zg.isEqual(r.openedWorkspace.configPath,i)?!1:(0,$.$Cbc)(s,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,d.localize)(0,null)],message:(0,d.localize)(1,null,(0,h.$6g)(i)),detail:(0,d.localize)(2,null)},n.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(r,s){if(!r.config)return;r.focus();let i;return r.config.extensionDevelopmentPath||(r.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority},r.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:s,remoteAuthority:r.remoteAuthority})),(0,c.$Ki)(r.openedWorkspace)&&this.isUntitledWorkspace(r.openedWorkspace)&&await this.deleteUntitledWorkspace(r.openedWorkspace),r.config.workspace=s,r.config.backupPath=i,{workspace:s,backupPath:i}}};e.$Jbc=a,e.$Jbc=a=Ee([ie(0,m.$lbc),ie(1,y.$2j),ie(2,p.$zbc),ie(3,b.$qbc),ie(4,v.$rbc)],a)}),define(re[134],oe([0,1,14,37,23,6,29,30,58,12,5,61]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7bc=e.$6bc=e.ID=void 0,e.ID="diagnosticsMainService",e.$6bc=(0,R.$vi)(e.ID);let v=class{constructor(f,y,p){this.a=f,this.b=y,this.c=p}async getRemoteDiagnostics(f){const y=this.a.getWindows();return(await Promise.all(y.map(async $=>{const c=$.remoteAuthority;if(!c)return;const w=`vscode:getDiagnosticInfoResponse${$.id}`,P={includeProcesses:f.includeProcesses,folders:f.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(a=>{$.sendWhenReady("vscode:getDiagnosticInfo",E.CancellationToken.None,{replyChannel:w,args:P}),C.$OW.once(w,(t,r)=>{r||a({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),a(r)}),setTimeout(()=>{a({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const f=[];for(const p of n.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(p.id);$?f.push(await this.d($)):f.push(this.e(p))}const y=[];for(const{pid:p,name:$}of b.$3bc.getAll())y.push({pid:p,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:f,pidToNames:y,screenReader:!!n.app.accessibilitySupportEnabled,gpuFeatureStatus:n.app.getGPUFeatureStatus()}}async d(f){const y=await this.f(f),p=(0,l.$gg)(f.win);return this.e(p,y,f.remoteAuthority)}e(f,y=[],p){return{id:f.id,pid:f.webContents.getOSProcessId(),title:f.getTitle(),folderURIs:y,remoteAuthority:p}}async f(f){const y=[],p=f.openedWorkspace;if((0,k.$Fi)(p))y.push(p.uri);else if((0,k.$Ki)(p)){const $=await this.b.resolveLocalWorkspace(p.configPath);$&&$.folders.forEach(w=>{y.push(w.uri)})}return y}};e.$7bc=v,e.$7bc=v=Ee([ie(0,j.$wbc),ie(1,h.$Ibc),ie(2,d.$2j)],v)}),define(re[70],oe([0,1,49,14,26,158,51,3,2,13,9,4,7,109,89,21,107,185,56,24,6,20,5,27,69,29,30,58,17,247,239,79,15]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jcc=e.$icc=void 0,e.$icc=(0,P.$vi)("nativeHostMainService");let M=class extends h.$Vc{constructor(F,T,q,ue,ee,ce,K,Q,B){super(),this.a=F,this.b=T,this.c=q,this.f=ue,this.g=ee,this.h=ce,this.j=K,this.m=Q,this.n=B,this.onDidOpenMainWindow=k.Event.map(this.a.onDidOpenWindow,L=>L.id),this.onDidTriggerWindowSystemContextMenu=k.Event.any(k.Event.map(this.a.onDidTriggerSystemContextMenu,({window:L,x:z,y:U})=>({windowId:L.id,x:z,y:U})),k.Event.map(this.b.onDidTriggerSystemContextMenu,({window:L,x:z,y:U})=>({windowId:L.id,x:z,y:U}))),this.onDidMaximizeWindow=k.Event.any(k.Event.map(this.a.onDidMaximizeWindow,L=>L.id),k.Event.map(this.b.onDidMaximizeWindow,L=>L.id)),this.onDidUnmaximizeWindow=k.Event.any(k.Event.map(this.a.onDidUnmaximizeWindow,L=>L.id),k.Event.map(this.b.onDidUnmaximizeWindow,L=>L.id)),this.onDidChangeWindowFullScreen=k.Event.any(k.Event.map(this.a.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen})),k.Event.map(this.b.onDidChangeFullScreen,L=>({windowId:L.window.id,fullscreen:L.fullscreen}))),this.onDidBlurMainWindow=k.Event.filter(k.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,z)=>z.id),L=>!!this.a.getWindowById(L)),this.onDidFocusMainWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),L=>!!L),L=>L.id),k.Event.filter(k.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,z)=>z.id),L=>!!this.a.getWindowById(L))),this.onDidBlurMainOrAuxiliaryWindow=k.Event.any(this.onDidBlurMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(C.app,"browser-window-blur",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidFocusMainOrAuxiliaryWindow=k.Event.any(this.onDidFocusMainWindow,k.Event.map(k.Event.filter(k.Event.fromNodeEventEmitter(C.app,"browser-window-focus",(L,z)=>this.b.getWindowByWebContents(z.webContents)),L=>!!L),L=>L.id)),this.onDidResumeOS=k.Event.fromNodeEventEmitter(C.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.r=this.B(new k.$ee),this.onDidChangePassword=this.r.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(C.screen,"display-metrics-changed",(L,z,U)=>U),L=>!(Array.isArray(L)&&L.length===1&&L[0]==="workArea")),k.Event.fromNodeEventEmitter(C.screen,"display-added"),k.Event.fromNodeEventEmitter(C.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(F,T){const q=this.a.getWindows().map(ee=>({id:ee.id,workspace:ee.openedWorkspace??(0,o.$Ji)(ee.backupPath,ee.isExtensionDevelopmentHost),title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename(),dirty:ee.isDocumentEdited()})),ue=[];return T.includeAuxiliaryWindows&&ue.push(...this.b.getWindows().map(ee=>({id:ee.id,parentId:ee.parentId,title:ee.win?.getTitle()??"",filename:ee.getRepresentedFilename()}))),[...q,...ue]}async getWindowCount(F){return this.a.getWindowCount()}async getActiveWindowId(F){const T=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(T)return T.id}openWindow(F,T,q){return Array.isArray(T)?this.s(F,T,q):this.t(F,T)}async s(F,T,q=Object.create(null)){T.length>0&&await this.a.open({context:5,contextWindowId:F,urisToOpen:T,cli:this.g.args,forceNewWindow:q.forceNewWindow,forceReuseWindow:q.forceReuseWindow,preferNewWindow:q.preferNewWindow,diffMode:q.diffMode,mergeMode:q.mergeMode,addMode:q.addMode,gotoLineMode:q.gotoLineMode,noRecentEntry:q.noRecentEntry,waitMarkerFileURI:q.waitMarkerFileURI,remoteAuthority:q.remoteAuthority||void 0,forceProfile:q.forceProfile,forceTempProfile:q.forceTempProfile})}async t(F,T){await this.a.openEmptyWindow({context:5,contextWindowId:F},T)}async toggleFullScreen(F,T){this.C(T?.targetWindowId,F)?.toggleFullScreen()}async handleTitleDoubleClick(F,T){this.C(T?.targetWindowId,F)?.handleTitleDoubleClick()}async getCursorScreenPoint(F){const T=C.screen.getCursorScreenPoint(),q=C.screen.getDisplayNearestPoint(T);return{point:T,display:q.bounds}}async isMaximized(F,T){return this.C(T?.targetWindowId,F)?.win?.isMaximized()??!1}async maximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.maximize()}async unmaximizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.unmaximize()}async minimizeWindow(F,T){this.C(T?.targetWindowId,F)?.win?.minimize()}async moveWindowTop(F,T){this.C(T?.targetWindowId,F)?.win?.moveTop()}async positionWindow(F,T,q){const ue=this.C(q?.targetWindowId,F);if(ue?.win){if(ue.win.isFullScreen()){const ee=k.Event.toPromise(k.Event.once(k.Event.fromNodeEventEmitter(ue.win,"leave-full-screen")));ue.win.setFullScreen(!1),await ee}ue.win.setBounds(T)}}async updateWindowControls(F,T){this.C(T?.targetWindowId,F)?.updateWindowControls(T)}async focusWindow(F,T){this.C(T?.targetWindowId,F)?.focus({force:T?.force??!1})}async setMinimumSize(F,T,q){const ue=this.D(F);if(ue?.win){const[ee,ce]=ue.win.getSize(),[K,Q]=ue.win.getMinimumSize(),[B,L]=[T??K,q??Q],[z,U]=[Math.max(ee,B),Math.max(ce,L)];(K!==B||Q!==L)&&ue.win.setMinimumSize(B,L),(ee!==z||ce!==U)&&ue.win.setSize(z,U)}}async saveWindowSplash(F,T){this.m.saveWindowSplash(F,T)}async installShellCommand(F){const{source:T,target:q}=await this.u();try{const{symbolicLink:ue}=await y.SymlinkSupport.stat(T);if(ue&&!ue.dangling){const ee=await(0,m.$5q)(T);if(q===ee)return}await y.Promises.unlink(T)}catch(ue){if(ue.code!=="ENOENT")throw ue}try{await y.Promises.symlink(q,T)}catch(ue){if(ue.code!=="EACCES"&&ue.code!=="ENOENT")throw ue;const{response:ee}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(ee===1)throw new O.$5;try{const ce=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${q}' '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ce)}catch{throw new Error((0,$.localize)(3,null,T))}}}async uninstallShellCommand(F){const{source:T}=await this.u();try{await y.Promises.unlink(T)}catch(q){switch(q.code){case"EACCES":{const{response:ue}=await this.showMessageBox(F,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ue===1)throw new O.$5;try{const ee=`osascript -e "do shell script \\"rm '${T}'\\" with administrator privileges"`;await(0,R.promisify)(n.exec)(ee)}catch{throw new Error((0,$.localize)(7,null,T))}break}case"ENOENT":break;default:throw q}}}async u(){const F=(0,d.$lc)(this.g.appRoot,"bin","code"),T=`/usr/local/bin/${this.j.applicationName}`;if(!await y.Promises.exists(F))throw new Error((0,$.localize)(8,null,F));return{source:T,target:F}}async showMessageBox(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showMessageBox(T,q?.win??void 0)}async showSaveDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showSaveDialog(T,q?.win??void 0)}async showOpenDialog(F,T){const q=this.C(T?.targetWindowId,F);return this.c.showOpenDialog(T,q?.win??void 0)}async pickFileFolderAndOpen(F,T){const q=await this.c.pickFileFolder(T);q&&await this.w(await Promise.all(q.map(async ue=>await y.SymlinkSupport.existsDirectory(ue)?{folderUri:v.URI.file(ue)}:{fileUri:v.URI.file(ue)})),T,F)}async pickFolderAndOpen(F,T){const q=await this.c.pickFolder(T);q&&await this.w(q.map(ue=>({folderUri:v.URI.file(ue)})),T,F)}async pickFileAndOpen(F,T){const q=await this.c.pickFile(T);q&&await this.w(q.map(ue=>({fileUri:v.URI.file(ue)})),T,F)}async pickWorkspaceAndOpen(F,T){const q=await this.c.pickWorkspace(T);q&&await this.w(q.map(ue=>({workspaceUri:v.URI.file(ue)})),T,F)}async w(F,T,q){await this.a.open({context:3,contextWindowId:q,cli:this.g.args,urisToOpen:F,forceNewWindow:T.forceNewWindow})}async showItemInFolder(F,T){C.shell.showItemInFolder(T)}async setRepresentedFilename(F,T,q){this.C(q?.targetWindowId,F)?.setRepresentedFilename(T)}async setDocumentEdited(F,T,q){this.C(q?.targetWindowId,F)?.setDocumentEdited(T)}async openExternal(F,T){return this.g.unsetSnapExportedVariables(),C.shell.openExternal(T),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(F,T){return C.shell.trashItem(T)}async isAdmin(){let F;return b.$i?F=(await new Promise((T,q)=>{X(["native-is-elevated"],T,q)}))():F=process.getuid?.()===0,F}async writeElevated(F,T,q,ue){const ee=await new Promise((ce,K)=>{X(["@vscode/sudo-prompt"],ce,K)});return new Promise((ce,K)=>{const Q=[`"${this.z}"`];ue?.unlock&&Q.push("--file-chmod"),Q.push("--file-write",`"${T.fsPath}"`,`"${q.fsPath}"`);const B={name:this.j.nameLong.replace("-",""),icns:b.$j&&this.g.isBuilt?(0,d.$kc)((0,d.$nc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};ee.exec(Q.join(" "),B,(L,z,U)=>{z&&this.h.trace(`[sudo-prompt] received stdout: ${z}`),U&&this.h.trace(`[sudo-prompt] received stderr: ${U}`),L?K(L):ce(void 0)})})}async isRunningUnderARM64Translation(){return b.$k||b.$i?!1:C.app.runningUnderARM64Translation}get z(){return b.$i?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.bat"):b.$k?this.g.isBuilt?(0,d.$kc)((0,d.$nc)(process.execPath),"bin",`${this.j.applicationName}`):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,d.$kc)(this.g.appRoot,"bin","code"):(0,d.$kc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,E.totalmem)(),freemem:(0,E.freemem)(),loadavg:(0,E.loadavg)()}}async getOSProperties(){return{arch:(0,E.arch)(),platform:(0,E.platform)(),release:(0,E.release)(),type:(0,E.type)(),cpus:(0,E.cpus)()}}async getOSVirtualMachineHint(){return f.$Dn.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return b.$i&&(0,S.$fcc)()}async killProcess(F,T,q){process.kill(T,q)}async readClipboardText(F,T){return C.clipboard.readText(T)}async writeClipboardText(F,T,q){return C.clipboard.writeText(T,q)}async readClipboardFindText(F){return C.clipboard.readFindText()}async writeClipboardFindText(F,T){return C.clipboard.writeFindText(T)}async writeClipboardBuffer(F,T,q,ue){return C.clipboard.writeBuffer(T,Buffer.from(q.buffer),ue)}async readClipboardBuffer(F,T){return g.$Fe.wrap(C.clipboard.readBuffer(T))}async hasClipboard(F,T,q){return C.clipboard.has(T,q)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){C.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){C.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){C.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){C.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){C.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(F,T){this.D(F)?.updateTouchBar(T)}async notifyReady(F){this.D(F)?.setReady()}async relaunch(F,T){return this.f.relaunch(T)}async reload(F,T){const q=this.D(F);if(q){if((0,o.$Ki)(q.openedWorkspace)){const ue=q.openedWorkspace.configPath;if(ue.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(ue))?.transient)return this.openWindow(q.id,{forceReuseWindow:!0})}return this.f.reload(q,T?.disableExtensions!==void 0?{_:[],"disable-extensions":T.disableExtensions}:void 0)}}async closeWindow(F,T){return this.C(T?.targetWindowId,F)?.win?.close()}async quit(F){const T=this.a.getLastActiveWindow();T?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&T.win?T.win.close():this.f.quit()}async exit(F,T){await this.f.kill(T)}async resolveProxy(F,T){return this.D(F)?.win?.webContents?.session?.resolveProxy(T)}async loadCertificates(F){return(await new Promise((q,ue)=>{X(["@vscode/proxy-agent"],q,ue)})).loadSystemCertificates({log:this.h})}findFreePort(F,T,q,ue,ee=1){return(0,p.$Tg)(T,q,ue,ee)}async openDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.openDevTools(T?.mode?{mode:T.mode,activate:T.activate}:void 0)}async toggleDevTools(F,T){this.C(T?.targetWindowId,F)?.win?.webContents.toggleDevTools()}async profileRenderer(F,T,q){const ue=this.D(F);if(!ue||!ue.win)throw new Error;return await new D.$gcc(ue.win,T,this.h).inspect(q)}async windowsGetStringRegKey(F,T,q,ue){if(!b.$i)return;const ee=await new Promise((ce,K)=>{X(["@vscode/windows-registry"],ce,K)});try{return ee.GetStringRegKey(T,q,ue)}catch{return}}C(F,T){return this.D(F)??this.F(F)??this.D(T)}D(F){if(typeof F=="number")return this.a.getWindowById(F)}F(F){if(typeof F!="number")return;const T=C.webContents.fromId(F);if(T)return this.b.getWindowByWebContents(T)}};e.$jcc=M,Ee([j.$Zh],M.prototype,"z",null),e.$jcc=M=Ee([ie(0,i.$wbc),ie(1,I.$hcc),ie(2,c.$rbc),ie(3,a.$Pbc),ie(4,w.$lbc),ie(5,t.$2j),ie(6,r.$ik),ie(7,s.$ubc),ie(8,u.$Ibc)],M)}),define(re[303],oe([0,1,14,26,8,23,31,2,13,4,111,37,182,92,134,56,24,5,70,80,27,81,34,61,55,29]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$kcc=void 0;const u="issue.processExplorerWindowState";let g=class{static{o=this}static{this.a="#1E1E1E"}constructor(I,O,M,W,F,T,q,ue,ee,ce,K){this.g=I,this.h=O,this.i=M,this.j=W,this.k=F,this.l=T,this.m=q,this.n=ue,this.o=ee,this.p=ce,this.q=K,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){b.$OW.on("vscode:listProcesses",async I=>{const O=[];try{O.push({name:(0,v.localize)(0,null),rootProcess:await(0,d.$Cs)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,m.$dn)(W)?O.push({name:W.hostName,rootProcess:W}):W.processes&&O.push({name:W.hostName,rootProcess:W.processes})})}catch(M){this.i.error(`Listing processes failed: ${M}`)}this.t(I,"vscode:listProcessesResponse",O)}),b.$OW.on("vscode:workbenchCommand",(I,O)=>{const{id:M,from:W,args:F}=O;let T;switch(W){case"processExplorer":T=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}T?.webContents.send("vscode:runAction",{id:M,from:W,args:F})}),b.$OW.on("vscode:closeProcessExplorer",I=>{this.d?.close()}),b.$OW.on("vscode:pidToNameRequest",async I=>{const O=await this.k.getMainDiagnostics(),M=[];for(const W of O.windows)M.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:F}of r.$3bc.getAll())M.push([W,F]);this.t(I,"vscode:pidToNameResponse",M)})}async openReporter(I){if(this.b)this.b&&this.s(this.b);else if(this.c=n.BrowserWindow.getFocusedWindow(),this.c){const O=new k.$Uc,M=O.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(1,null),zoomLevel:I.zoomLevel,alwaysOnTop:!1},"issue-reporter"),M.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:I,disableExtensions:!!this.h.disableExtensions,os:{type:(0,C.type)(),arch:(0,C.arch)(),release:(0,C.release)()},product:w.default}),this.b.loadURL(h.$Pg.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,O.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,O.dispose())})}}async openProcessExplorer(I){if(!this.d&&(this.f=n.BrowserWindow.getFocusedWindow(),this.f)){const O=new k.$Uc,M=O.add(this.n.createIPCObjectUrl()),W=this.p.getItem(u,void 0),F=S(W)?W:this.v(this.f,800,500);this.d=this.u(F,M,{backgroundColor:I.styles.backgroundColor,title:(0,v.localize)(2,null),zoomLevel:I.zoomLevel,alwaysOnTop:!0},"process-explorer"),M.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:I,product:w.default}),this.d.loadURL(h.$Pg.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,O.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,O.dispose())});const T=()=>{if(!this.d)return;const q=this.d.getSize(),ue=this.d.getPosition();if(!q||!ue)return;const ee={width:q[0],height:q[1],x:ue[0],y:ue[1]};this.p.setItem(u,ee)};this.d.on("moved",T),this.d.on("resized",T)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const I=await n.contentTracing.stopRecording(`${(0,j.$Dg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null,I),buttons:[(0,v.localize)(5,null)]},n.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,I)}async getSystemStatus(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(I,O)}async $getSystemInfo(){const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(I,O)}async $getPerformanceInfo(){try{const[I,O]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(I,O)}catch(I){throw this.i.warn("issueService#getPerformanceInfo ",I.message),I}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(I){this.i.error(I)}}async $showConfirmCloseDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(6,null),buttons:[(0,v.localize)(7,null),(0,v.localize)(8,null)]},this.b);I===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:I}=await this.l.showMessageBox({type:"warning",message:(0,v.localize)(9,null),buttons:[(0,v.localize)(10,null),(0,v.localize)(11,null)]},this.b);return I===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const I=this.q.getWindowById(this.c.id);if(!I)throw new Error("Window not found");return I}async $sendReporterMenu(I,O){const M=this.issueReporterWindowCheck(),W="vscode:triggerReporterMenu",F=new R.$pe;return M.sendWhenReady(W,F.token,{replyChannel:W,extensionId:I,extensionName:O}),await(0,E.$mh)(new Promise(q=>b.$OW.once(`vscode:triggerReporterMenuResponse:${I}`,(ue,ee)=>q(ee))),5e3,()=>{this.i.error(`Error: Extension ${I} timed out waiting for menu response`),F.cancel()})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(I){I.isMinimized()&&I.restore(),I.focus()}t(I,O,...M){I.sender.isDestroyed()||I.sender.send(O,...M)}u(I,O,M,W){const F=new n.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:I.width,height:I.height,minWidth:300,minHeight:200,x:I.x,y:I.y,title:M.title,backgroundColor:M.backgroundColor||o.a,webPreferences:{preload:h.$Pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${O.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$ED)(M.zoomLevel),sandbox:!0},alwaysOnTop:M.alwaysOnTop,experimentalDarkMode:!0});return F.setMenuBarVisibility(!1),F}v(I,O,M){let W;const F=n.screen.getAllDisplays();if(F.length===1)W=F[0];else{if(l.$j){const ue=n.screen.getCursorScreenPoint();W=n.screen.getDisplayNearestPoint(ue)}!W&&I&&(W=n.screen.getDisplayMatching(I.getBounds())),W||(W=n.screen.getPrimaryDisplay()||F[0])}const T=W.bounds,q={width:O,height:M,x:T.x+T.width/2-O/2,y:T.y+T.height/2-M/2};return T.width>0&&T.height>0&&(q.x<T.x&&(q.x=T.x),q.y<T.y&&(q.y=T.y),q.x>T.x+T.width&&(q.x=T.x),q.y>T.y+T.height&&(q.y=T.y),q.width>T.width&&(q.width=T.width),q.height>T.height&&(q.height=T.height)),q}};e.$kcc=g,e.$kcc=g=o=Ee([ie(1,p.$lbc),ie(2,$.$2j),ie(3,m.$cn),ie(4,f.$6bc),ie(5,y.$rbc),ie(6,c.$icc),ie(7,a.$tbc),ie(8,P.$ik),ie(9,t.$BQ),ie(10,i.$wbc)],g);function S(D){return typeof D!="object"||D===null?!1:"x"in D&&"y"in D&&"width"in D&&"height"in D}}),define(re[304],oe([0,1,23,18,24,20,5,70,27,53,28,50,101]),function(X,e,n,C,E,R,j,k,h,l,d,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lcc=void 0;let m=class extends v.$Jcc{constructor(y,p,$,c,w,P,a,t){super(y,p,c,w,P,t),this.e=$,this.u=a}s(y){return(0,v.$Icc)(`linux-${process.arch}`,y,this.k)}t(y){this.a&&(this.d(b.$MX.CheckingForUpdates(y)),this.i.request({url:this.a},n.CancellationToken.None).then(l.$Sp).then(p=>{!p||!p.url||!p.version||!p.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!y}),this.d(b.$MX.Idle(1))):this.d(b.$MX.AvailableForDownload(p))}).then(void 0,p=>{this.j.error(p);const $=y?p.message||p:void 0;this.d(b.$MX.Idle(1,$))}))}async o(y){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):y.update.url&&this.u.openExternal(void 0,y.update.url),this.d(b.$MX.Idle(1))}};e.$Lcc=m,e.$Lcc=m=Ee([ie(0,R.$Pbc),ie(1,C.$2i),ie(2,d.$1l),ie(3,E.$lbc),ie(4,l.$Mp),ie(5,j.$2j),ie(6,k.$icc),ie(7,h.$ik)],m)}),define(re[305],oe([0,1,49,43,26,8,23,51,46,9,7,146,21,18,24,16,20,5,70,27,53,28,50,101]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ncc=void 0;async function s(g,S=1e3){for(;!g();)await(0,R.$wh)(S)}let i;function o(){return typeof i>"u"&&(i=C.existsSync(l.$kc(l.$nc(process.execPath),"unins000.exe"))?0:1),i}let u=class extends r.$Jcc{get cachePath(){const S=l.$kc((0,E.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(S,{recursive:!0}).then(()=>S)}constructor(S,D,I,O,M,W,F,T,q){super(S,D,O,M,W,q),this.u=I,this.v=F,this.w=T,S.setRelaunchHandler(this)}handleRelaunch(S){return S?.addArgs||S?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$MX.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(S){let D=`win32-${process.arch}`;return o()===1?D+="-archive":this.k.target==="user"&&(D+="-user"),(0,r.$Icc)(D,S,this.k)}t(S){this.a&&(this.d(t.$MX.CheckingForUpdates(S)),this.i.request({url:this.a},j.CancellationToken.None).then(P.$Sp).then(D=>{const I=o();return!D||!D.url||!D.version||!D.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!S}),this.d(t.$MX.Idle(I)),Promise.resolve(null)):I===1?(this.d(t.$MX.AvailableForDownload(D)),Promise.resolve(null)):(this.d(t.$MX.Downloading),this.C(D.version).then(()=>this.B(D.version).then(O=>v.Promises.exists(O).then(M=>{if(M)return Promise.resolve(O);const W=`${O}.tmp`;return this.i.request({url:D.url},j.CancellationToken.None).then(F=>this.v.writeFile(d.URI.file(W),F.stream)).then(D.sha256hash?()=>(0,b.$HW)(W,D.sha256hash):()=>{}).then(()=>v.Promises.rename(W,O,!1)).then(()=>O)})).then(O=>{this.e={packagePath:O},this.d(t.$MX.Downloaded(D)),this.g.getValue("update.enableWindowsBackgroundUpdates")?this.k.target==="user"&&this.p():this.d(t.$MX.Ready(D))})))}).then(void 0,D=>{this.u.publicLog2("update:error",{messageHash:String((0,h.$jj)(String(D)))}),this.j.error(D);const I=S?D.message||D:void 0;this.d(t.$MX.Idle(o(),I))}))}async o(S){S.update.url&&this.w.openExternal(void 0,S.update.url),this.d(t.$MX.Idle(o()))}async B(S){const D=await this.cachePath;return l.$kc(D,`CodeSetup-${this.k.quality}-${S}.exe`)}async C(S=null){const D=S?W=>!new RegExp(`${this.k.quality}-${S}\\.exe$`).test(W):()=>!0,I=await this.cachePath,M=(await v.Promises.readdir(I)).filter(D).map(async W=>{try{await v.Promises.unlink(l.$kc(I,W))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"||!this.e)return Promise.resolve(void 0);const S=this.state.update;this.d(t.$MX.Updating(S));const D=await this.cachePath;this.e.updateFilePath=l.$kc(D,`CodeSetup-${this.k.quality}-${S.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,n.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$MX.Idle(o()))});const O=`${this.k.win32MutexName}-ready`,M=await new Promise((W,F)=>{X(["@vscode/windows-mutex"],W,F)});s(()=>M.isActive(O)).then(()=>this.d(t.$MX.Ready(S)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?C.unlinkSync(this.e.updateFilePath):(0,n.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return o()}async _applySpecificUpdate(S){if(this.state.type!=="idle")return;const D=this.g.getValue("update.enableWindowsBackgroundUpdates"),I={version:"unknown",productVersion:"unknown"};this.d(t.$MX.Downloading),this.e={packagePath:S},this.d(t.$MX.Downloaded(I)),D?this.k.target==="user"&&this.p():this.d(t.$MX.Ready(I))}};e.$Ncc=u,Ee([k.$Zh],u.prototype,"cachePath",null),e.$Ncc=u=Ee([ie(0,p.$Pbc),ie(1,m.$2i),ie(2,a.$1l),ie(3,f.$lbc),ie(4,P.$Mp),ie(5,$.$2j),ie(6,y.$2k),ie(7,c.$icc),ie(8,w.$ik)],u)}),define(re[135],oe([0,1,14,8,23,47,3,2,13,66,4,7,193,26,65,18,56,24,64,16,20,5,27,81,256,84,28,106,69,55,29,30,58,82,39,34,57,67,22,6]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O,M,W,F,T,q,ue,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nbc=e.$Mbc=void 0;var ce;(function(B){B[B.NONE=0]="NONE",B[B.NAVIGATING=1]="NAVIGATING",B[B.READY=2]="READY"})(ce||(ce={}));class K extends k.$Vc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(j.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(j.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(j.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(j.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(j.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(j.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const z=!(0,S.$AD)(this.r);if(d.$j&&z&&L.setSheetOffset((0,d.$J)((0,m.release)())?28:22),z&&(d.$i&&(0,S.$CD)(this.r)||d.$j)){const U=this.s.getItem(K.D);U&&this.updateWindowControls({height:U})}d.$i&&z&&L.hookWindowMessage(278,()=>{const[ae,G]=L.getPosition(),le=n.screen.getCursorScreenPoint(),Y=le.x-ae,A=le.y-G;return!(Y>30&&A>=0&&A<=Math.max(L.getBounds().height*.15,35))||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:Y,y:A})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools(),d.$j&&(this.B(this.onDidEnterFullScreen(()=>{this.H?.complete(!0)})),this.B(this.onDidLeaveFullScreen(()=>{this.H?.complete(!0)})))}constructor(L,z,U,ae){super(),this.r=L,this.s=z,this.t=U,this.u=ae,this.a=this.B(new j.$ee),this.onDidClose=this.a.event,this.b=this.B(new j.$ee),this.onDidMaximize=this.b.event,this.c=this.B(new j.$ee),this.onDidUnmaximize=this.c.event,this.f=this.B(new j.$ee),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new j.$ee),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new j.$ee),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.F=(0,S.$CD)(this.r),this.G=void 0,this.H=void 0}w(L,z=n.screen.getAllDisplays().length>0){const U=this.r.getValue("window"),ae=d.$j&&U?.nativeTabs===!0;(d.$j||d.$i)&&z&&(!ae||n.BrowserWindow.getAllWindows().length===1)&&[L.width,L.height,L.x,L.y].every(G=>typeof G=="number")&&this.m?.setBounds({width:L.width,height:L.height,x:L.x,y:L.y}),(L.mode===0||L.mode===3)&&(this.m?.maximize(),L.mode===3&&this.I(!0,!0),this.m?.show())}setRepresentedFilename(L){d.$j?this.win?.setRepresentedFilename(L):this.z=L}getRepresentedFilename(){return d.$j?this.win?.getRepresentedFilename():this.z}setDocumentEdited(L){d.$j&&this.win?.setDocumentEdited(L),this.C=L}isDocumentEdited(){return d.$j?!!this.win?.isDocumentEdited():!!this.C}focus(L){d.$j&&L?.force&&n.app.focus({steal:!0});const z=this.win;z&&(z.isMinimized()&&z.restore(),z.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(d.$j)switch(n.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.D="windowControlHeight"}updateWindowControls(L){const z=this.win;if(z){if(L.height&&this.s.setItem(Q.D,L.height),d.$i&&this.F)z.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(d.$j&&L.height!==void 0){const U=(L.height-15)/2;U?z.setWindowButtonPosition({x:U,y:U}):z.setWindowButtonPosition(null)}}}toggleFullScreen(){this.I(!this.isFullScreen,!1)}I(L,z){(0,S.$DD)(this.r)?this.J(L,z):this.M(L)}get isFullScreen(){if(d.$j&&typeof this.G=="boolean")return this.G;const L=this.win,z=L?.isFullScreen(),U=L?.isSimpleFullScreen();return!!(z||U)}J(L,z){const U=this.win;U?.isSimpleFullScreen()&&U?.setSimpleFullScreen(!1),this.L(L,z)}L(L,z){if(d.$j){this.G=L;const ae=this.H=new C.$Sh;(async()=>{const G=await Promise.race([ae.p,(0,C.$wh)(1e4).then(()=>!1)]);this.H===ae&&(this.G=void 0,this.H=void 0,!G&&L&&z&&this.win&&!this.win.isFullScreen()&&(this.u.warn("window: native macOS fullscreen transition did not happen within 10s from restoring"),this.h.fire()))})()}this.win?.setFullScreen(L)}M(L){const z=this.win;z?.isFullScreen()&&this.L(!1,!1),z?.setSimpleFullScreen(L),z?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$Mbc=K;let Q=class extends K{get id(){return this.Q}get backupPath(){return this.S?.backupPath}get openedWorkspace(){return this.S?.workspace}get profile(){if(!this.config)return;const L=this.hb.profiles.find(z=>z.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.hb.getProfileForWorkspace(this.config.workspace??(0,I.$Ji)(this.backupPath,this.isExtensionDevelopmentHost))??this.hb.defaultProfile}get remoteAuthority(){return this.S?.remoteAuthority}get config(){return this.S}get isExtensionDevelopmentHost(){return!!this.S?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.S?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.S?.debugId}constructor(L,z,U,ae,G,le,Y,A,N,_,ne,J,V,x,H,se,he,me,$e,ye,Pe){super(_,ye,ae,z),this.fb=U,this.gb=G,this.hb=le,this.ib=Y,this.jb=A,this.kb=N,this.lb=ne,this.mb=J,this.nb=V,this.ob=x,this.pb=H,this.qb=se,this.rb=he,this.sb=me,this.tb=$e,this.N=this.B(new j.$ee),this.onWillLoad=this.N.event,this.O=this.B(new j.$ee),this.onDidSignalReady=this.O.event,this.P=this.B(new j.$ee),this.onDidDestroy=this.P.event,this.X=[],this.Y=[],this.Z=void 0,this.$=void 0,this.ab=void 0,this.bb=this.B(this.sb.createIPCObjectUrl()),this.eb=!1,this.ub=0;{const[ke,Oe]=this.Eb(L.state);this.U=ke,this.u.trace("window#ctor: using window state",ke);const we=Pe.invokeFunction(D.$xbc,this.U,{preload:h.$Pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.bb.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new n.BrowserWindow(we),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.Q=this.m.id,this.n(this.m),this.w(this.U,Oe),this.j=Date.now()}this.Bb(),this.Kb(),this.vb()}setReady(){for(this.u.trace(`window#load: window reported ready (id: ${this.Q})`),this.ub=2;this.X.length;)this.X.pop()(this);this.O.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.X.push(L)})}get isReady(){return this.ub===2}get whenClosedOrLoaded(){return new Promise(L=>{function z(){U.dispose(),ae.dispose(),L()}const U=this.onDidClose(()=>z()),ae=this.onWillLoad(()=>z())})}vb(){this.B(j.Event.fromNodeEventEmitter(this.m,"unresponsive")(()=>this.yb(1))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"render-process-gone",(z,U)=>U)(z=>this.yb(2,{...z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-fail-load",(z,U,ae)=>({exitCode:U,reason:ae}))(({exitCode:z,reason:U})=>this.yb(3,{reason:U,exitCode:z}))),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"will-prevent-unload")(z=>z.preventDefault())),this.B(j.Event.fromNodeEventEmitter(this.m.webContents,"did-finish-load")(()=>{this.db&&(this.S=this.db,this.db=void 0)})),this.B(this.onDidMaximize(()=>{this.S&&(this.S.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.S&&(this.S.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",E.CancellationToken.None)})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",E.CancellationToken.None)})),this.B(this.r.onDidChangeConfiguration(z=>this.Bb(z))),this.B(this.mb.onDidDeleteUntitledWorkspace(z=>this.Ab(z)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(z,U)=>{const ae=await this.xb();U({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,ae)})})}xb(){return this.wb||(this.wb=(0,s.$7p)(this.rb.version,this.rb,this.t,this.r,this.ib,this.jb,this.ob)),this.wb}async yb(L,z){switch(L){case 2:this.u.error(`CodeWindow: renderer process gone (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break;case 1:this.u.error("CodeWindow: detected unresponsive");break;case 3:this.u.error(`CodeWindow: failed to load (reason: ${z?.reason||"<unknown>"}, code: ${z?.exitCode||"<unknown>"})`);break}switch(this.ob.publicLog2("windowerror",{type:L,reason:z?.reason,code:z?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.qb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.zb(!1,!1),this.qb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:U,checkboxChecked:ae}=await this.pb.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.S?.workspace?(0,v.localize)(5,null):void 0},this.m);if(U!==2){const G=U===0;await this.zb(G,ae)}}else if(L===2){let U;z?U=(0,v.localize)(7,null,z.reason,z.exitCode??"<unknown>"):U=(0,v.localize)(6,null);const{response:ae,checkboxChecked:G}=await this.pb.showMessageBox({type:"warning",buttons:[this.S?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:U,detail:this.S?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.S?.workspace?(0,v.localize)(13,null):void 0},this.m),le=ae===0;await this.zb(le,G)}break}}async zb(L,z){const U=this.S?.workspace;if(z&&U)try{const ae=this.kb.workspaceStorage(U);await ae.init(),ae.delete("memento/workbench.parts.editor"),await ae.close()}catch(ae){this.u.error(ae)}this.P.fire();try{if(L&&this.S){let ae,G;(0,I.$Fi)(U)?ae={folderUri:U.uri}:(0,I.$Ki)(U)?ae={workspaceUri:U.configPath}:G=!0,(0,ue.$Ob)(await this.tb.open({context:5,userEnv:this.S.userEnv,cli:{...this.t.args,_:[]},urisToOpen:ae?[ae]:void 0,forceEmpty:G,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}Ab(L){this.S?.workspace?.id===L.id&&(this.S.workspace=void 0)}Bb(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const z=this.Gb();z!==this.W&&(this.W=z,this.Hb(z))}if(!L||L.affectsConfiguration("http.proxy")){let z=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;z?.endsWith("/")&&(z=z.substr(0,z.length-1));const U=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((z||"").indexOf("@")===-1&&(z!==this.Z||U!==this.$)){this.Z=z,this.$=U;const ae=z||"",G=U?`${U},<local>`:"<local>";this.u.trace(`Setting proxy to '${ae}', bypassing '${G}'`),this.m.webContents.session.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""}),typeof n.app.setProxy=="function"&&n.app.setProxy({proxyRules:ae,proxyBypassRules:G,pacScript:""})}}}addTabbedWindow(L){d.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,z=Object.create(null)){this.u.trace(`window#load: attempt to load window (id: ${this.Q})`),this.isDocumentEdited()&&(!z.isReload||!this.nb.isHotExitEnabled())&&this.setDocumentEdited(!1),z.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.rb.nameLong)),this.Cb(L,z),this.ub===0?this.S=L:this.db=L,this.ub=1,this.m.loadURL(h.$Pg.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const U=this.eb;this.eb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new C.$Hh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.N.fire({workspace:L.workspace,reason:z.isReload?3:U?2:1})}Cb(L,z){const U=(this.S??this.db)?.userEnv;if(U){const ae=(0,c.$zm)(U)&&!(0,c.$zm)(L.userEnv),G=this.isExtensionDevelopmentHost;(ae||G)&&(L.userEnv={...U,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),z.disableExtensions!==void 0&&(L["disable-extensions"]=z.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.lb.getWindowSplash(),L.zoomLevel=this.Jb(),L.isCustomZoomLevel=typeof this.ab=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.bb.update(L)}async reload(L){const z=Object.assign({},this.S);z.workspace=await this.Db(z),delete z.filesToOpenOrCreate,delete z.filesToDiff,delete z.filesToMerge,delete z.filesToWait,this.isExtensionDevelopmentHost&&L&&(z.verbose=L.verbose,z.debugId=L.debugId,z.extensionEnvironment=L.extensionEnvironment,z["inspect-extensions"]=L["inspect-extensions"],z["inspect-brk-extensions"]=L["inspect-brk-extensions"],z["extensions-dir"]=L["extensions-dir"]),z.accessibilitySupport=n.app.isAccessibilitySupportEnabled(),z.isInitialStartup=!1,z.policiesData=this.gb.serialize(),z.continueOn=this.t.continueOn,z.profiles={all:this.hb.profiles,profile:this.profile||this.hb.defaultProfile,home:this.hb.profilesHome},z.logLevel=this.fb.getLogLevel(),z.loggers={window:this.fb.getRegisteredLoggers(this.id),global:this.fb.getRegisteredLoggers()},this.load(z,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Db(L){if((0,I.$Ki)(L.workspace)){const z=L.workspace.configPath;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}else if((0,I.$Fi)(L.workspace)){const z=L.workspace.uri;if(z.scheme===h.Schemas.file&&!await this.ib.exists(z))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$jbc)();if(this.isFullScreen){let U;try{U=n.screen.getDisplayMatching(this.getBounds())}catch{}const ae=(0,M.$jbc)();return{mode:3,display:U?U.id:void 0,width:this.U.width||ae.width,height:this.U.height||ae.height,x:this.U.x||0,y:this.U.y||0,zoomLevel:this.ab}}const L=Object.create(null);let z;if(!d.$j&&this.m.isMaximized()?z=0:z=1,z===0?L.mode=0:L.mode=1,z===1||z===0){let U;z===1?U=this.getBounds():U=this.m.getNormalBounds(),L.x=U.x,L.y=U.y,L.width=U.width,L.height=U.height}return L.zoomLevel=this.ab,L}Eb(L){(0,l.mark)("code/willRestoreCodeWindowState");let z=!1;if(L){this.ab=L.zoomLevel;try{const U=n.screen.getAllDisplays();z=U.length>1,L=D.WindowStateValidator.validateWindowState(this.u,L,U)}catch(U){this.u.warn(`Unexpected error validating window state: ${U}
${U.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$jbc)(),z]}getBounds(){const[L,z]=this.m.getPosition(),[U,ae]=this.m.getSize();return{x:L,y:z,width:U,height:ae}}I(L,z){super.I(L,z),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",E.CancellationToken.None),this.W&&this.Hb(this.W,!1)}Gb(){let L=(0,S.$yD)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Hb(L,z=!0){d.$j||(L==="toggle"&&z&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Ib(L)}):this.Ib(L))}Ib(L){const z=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!z),this.m.autoHideMenuBar=z;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.ab=L}Jb(){return typeof this.ab=="number"?this.ab:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,z,...U){this.isReady?this.send(L,...U):this.ready().then(()=>{z.isCancellationRequested||this.send(L,...U)})}send(L,...z){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.u.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...z)}catch(U){this.u.warn(`Error sending IPC message to channel '${L}' of window ${this.Q}: ${(0,R.$gj)(U)}`)}}}updateTouchBar(L){d.$j&&this.Y.forEach((z,U)=>{const ae=L[U];z.segments=this.Mb(ae)})}Kb(){if(d.$j){for(let L=0;L<10;L++){const z=this.Lb();this.Y.push(z)}this.m.setTouchBar(new n.TouchBar({items:this.Y}))}}Lb(L=[]){const z=this.Mb(L),U=new n.TouchBar.TouchBarSegmentedControl({segments:z,mode:"buttons",segmentStyle:"automatic",change:ae=>{this.sendWhenReady("vscode:runAction",E.CancellationToken.None,{id:U.segments[ae].id,from:"touchbar"})}});return U}Mb(L=[]){return L.map(U=>{let ae;U.icon&&!u.ThemeIcon.isThemeIcon(U.icon)&&U.icon?.dark?.scheme===h.Schemas.file&&(ae=n.nativeImage.createFromPath(b.URI.revive(U.icon.dark).fsPath),ae.isEmpty()&&(ae=void 0));let G;return typeof U.title=="string"?G=U.title:G=U.title.value,{id:U.id,label:ae?void 0:G,icon:ae}})}matches(L){return this.m?.webContents.id===L.id}dispose(){super.dispose(),this.fb.deregisterLoggers(this.id)}};e.$Nbc=Q,e.$Nbc=Q=Ee([ie(1,a.$2j),ie(2,q.$Kbc),ie(3,$.$lbc),ie(4,W.$do),ie(5,T.$zbc),ie(6,w.$2k),ie(7,i.$Xbc),ie(8,i.$Vbc),ie(9,y.$2i),ie(10,g.$ubc),ie(11,O.$Ibc),ie(12,f.$qbc),ie(13,o.$1l),ie(14,p.$rbc),ie(15,P.$Pbc),ie(16,t.$ik),ie(17,r.$tbc),ie(18,D.$wbc),ie(19,F.$BQ),ie(20,ee.$ui)],Q)}),define(re[306],oe([0,1,14,4,18,24,20,5,34,55,135]),function(X,e,n,C,E,R,j,k,h,l,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Obc=void 0;let b=class extends d.$Mbc{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(m,f,y,p,$,c){super(p,$,f,y),this.O=m,this.P=c,this.id=this.O.id,this.parentId=-1,this.N=!1,this.tryClaimWindow()}tryClaimWindow(m){this.q.isDisposed||this.O.isDestroyed()||(this.Q(),m&&!this.N&&(this.N=!0,this.w({x:m.x,y:m.y,width:m.width,height:m.height,mode:m.show===!1?0:1})))}Q(){if(this.m)return;const m=n.BrowserWindow.fromWebContents(this.O);m&&(this.u.trace("[aux window] Claimed browser window instance"),this.n(m),m.setMenu(null),(C.$i||C.$k)&&(0,l.$AD)(this.r)&&m.setAutoHideMenuBar(!0),this.P.registerAuxWindow(this))}matches(m){return this.O.id===m.id}};e.$Obc=b,e.$Obc=b=Ee([ie(1,R.$lbc),ie(2,k.$2j),ie(3,E.$2i),ie(4,h.$BQ),ie(5,j.$Pbc)],b)}),define(re[307],oe([0,1,14,3,2,13,37,306,6,5,82,29]),function(X,e,n,C,E,R,j,k,h,l,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gdc=void 0;let v=class extends E.$Vc{constructor(f,y){super(),this.h=f,this.j=y,this.a=this.B(new C.$ee),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new C.$ee),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new C.$ee),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new C.$ee),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){n.app.on("browser-window-created",(f,y)=>{const p=this.getWindowByWebContents(y.webContents);if(p)this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),p.tryClaimWindow();else{const $=new E.$Uc;$.add(C.Event.fromNodeEventEmitter(y.webContents,"did-create-window",(c,w)=>({browserWindow:c,details:w}))(({browserWindow:c,details:w})=>{const P=this.getWindowByWebContents(c.webContents);P&&(this.j.trace('[aux window] window.on("did-create-window"): Trying to claim auxiliary window'),P.tryClaimWindow(w.options))})),$.add(C.Event.fromNodeEventEmitter(y,"closed")(()=>$.dispose()))}}),j.$OW.handle("vscode:registerAuxiliaryWindow",async(f,y)=>{const p=this.getWindowByWebContents(f.sender);return p&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),p.parentId=y),f.sender.id})}createWindow(f){return this.h.invokeFunction(b.$xbc,this.n(f),{preload:R.$Pg.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath})}n(f){const y={},p=f.features.split(",");for(const c of p){const[w,P]=c.split("=");switch(w){case"width":y.width=parseInt(P,10);break;case"height":y.height=parseInt(P,10);break;case"left":y.x=parseInt(P,10);break;case"top":y.y=parseInt(P,10);break;case"window-maximized":y.mode=0;break;case"window-fullscreen":y.mode=3;break}}const $=b.WindowStateValidator.validateWindowState(this.j,y)??(0,d.$kbc)();return this.j.trace("[aux window] using window state",$),$}registerWindow(f){const y=new E.$Uc,p=this.h.createInstance(k.$Obc,f);this.g.set(p.id,p),y.add((0,E.$Tc)(()=>this.g.delete(p.id))),y.add(p.onDidMaximize(()=>this.a.fire(p))),y.add(p.onDidUnmaximize(()=>this.b.fire(p))),y.add(p.onDidEnterFullScreen(()=>this.c.fire({window:p,fullscreen:!0}))),y.add(p.onDidLeaveFullScreen(()=>this.c.fire({window:p,fullscreen:!1}))),y.add(p.onDidTriggerSystemContextMenu(({x:$,y:c})=>this.f.fire({window:p,x:$,y:c}))),C.Event.once(p.onDidClose)(()=>y.dispose())}getWindowByWebContents(f){const y=this.g.get(f.id);return y?.matches(f)?y:void 0}getFocusedWindow(){const f=n.BrowserWindow.getFocusedWindow();if(f)return this.getWindowByWebContents(f.webContents)}getLastActiveWindow(){return(0,b.$ybc)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$gdc=v,e.$gdc=v=Ee([ie(0,h.$ui),ie(1,l.$2j)],v)}),define(re[85],oe([0,1,14,22,8,3,48,2,13,4,19,7,21,196,6,20,5,84,98,30,58,32,56]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$vcc=e.$ucc=void 0,e.$ucc=(0,f.$vi)("workspacesHistoryMainService");let s=class extends k.$Vc{static{r=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(o,u,g,S,D){super(),this.f=o,this.g=u,this.h=g,this.j=S,this.m=D,this.c=this.B(new R.$ee),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new E.$th(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(o=>this.addRecentlyOpened([{workspace:o.workspace,remoteAuthority:o.window.remoteAuthority}])))}async addRecentlyOpened(o){let u=[],g=[];for(const D of o)if((0,c.$bgb)(D))!this.g.isUntitledWorkspace(D.workspace)&&!this.w(u,D.workspace)&&u.push(D);else if((0,c.$cgb)(D))this.y(u,D.folderUri)||u.push(D);else{const I=this.z(g,D.fileUri),O=D.fileUri.scheme===h.Schemas.file&&r.G.indexOf((0,d.$6g)(D.fileUri))>=0;!I&&!O&&(g.push(D),l.$i&&D.fileUri.scheme===h.Schemas.file&&n.app.addRecentDocument(D.fileUri.fsPath))}const S=await this.r({workspaces:u,files:g});u=S.workspaces,g=S.files,u.length>r.a&&(u.length=r.a),g.length>r.a&&(g.length=r.a),await this.t({workspaces:u,files:g}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(o){const u=I=>{const O=this.u(I);for(const M of o)if(d.$Zg.isEqual(M,O))return!1;return!0},g=await this.getRecentlyOpened(),S=g.workspaces.filter(u),D=g.files.filter(u);(S.length!==g.workspaces.length||D.length!==g.files.length)&&(await this.t({files:D,workspaces:S}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(o){if(o?.confirm){const{response:u}=await this.m.showMessageBox({type:"warning",buttons:[(0,m.localize)(0,null),(0,m.localize)(1,null)],message:(0,m.localize)(2,null),detail:(0,m.localize)(3,null),cancelId:1});if(u!==0)return}await this.t({workspaces:[],files:[]}),n.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(o){const u=new a.$Bc(D=>d.$Zg.getComparisonKey(D));if(o?.workspaces)for(const D of o.workspaces)u.set(this.u(D),D);const g=new a.$Bc(D=>d.$Zg.getComparisonKey(D));if(o?.files)for(const D of o.files)g.set(this.u(D),D);const S=await this.s();for(const D of S.workspaces){const I=u.get(this.u(D));I?I.label=I.label??D.label:u.set(this.u(D),D)}for(const D of S.files){const I=g.get(this.u(D));I?I.label=I.label??D.label:g.set(this.u(D),D)}return{workspaces:[...u.values()],files:[...g.values()]}}async s(){await this.j.whenReady;let o;const u=this.j.get(r.b,-1);if(typeof u=="string")try{o=JSON.parse(u)}catch(g){this.f.error("Unexpected error parsing opened paths list",g)}return(0,c.$igb)(o,this.f)}async t(o){await this.j.whenReady,this.j.store(r.b,JSON.stringify((0,c.$jgb)(o)),-1,1)}u(o){return(0,c.$cgb)(o)?o.folderUri:(0,c.$dgb)(o)?o.fileUri:o.workspace.configPath}w(o,u){return!!o.find(g=>(0,c.$bgb)(g)&&g.workspace.id===u.id)}y(o,u){return!!o.find(g=>(0,c.$cgb)(g)&&d.$Zg.isEqual(g.folderUri,u))}z(o,u){return!!o.find(g=>d.$Zg.isEqual(g.fileUri,u))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const o=[];if(o.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(4,null),description:(0,m.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const u=[];for(const D of n.app.getJumpListSettings().removedItems){const I=D.args;if(I){const O=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);O&&u.push(b.URI.parse(O[2]))}}await this.removeRecentlyOpened(u);let g=!1;const S=(0,C.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,r.F).map(D=>{const I=(0,c.$bgb)(D)?D.workspace:D.folderUri,{title:O,description:M}=this.L(I,D.label);let W;return b.URI.isUri(I)?W=`--folder-uri "${I.toString()}"`:(g=!0,W=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:O.substr(0,255),description:M.substr(0,255),program:process.execPath,args:W,iconPath:"explorer.exe",iconIndex:0}}));S.length>0&&o.push({type:"custom",name:g?(0,m.localize)(6,null):(0,m.localize)(7,null),items:S})}o.push({type:"recent"});try{const u=n.app.setJumpList(o);u&&u!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${u}`)}catch(u){this.f.warn("updateWindowsJumpList#setJumpList",u)}}L(o,u){if(u)return{title:(0,j.$Fw)(u).name,description:u};if(b.URI.isUri(o))return{title:(0,d.$6g)(o),description:this.M(o)};if(this.g.isUntitledWorkspace(o))return{title:(0,m.localize)(8,null),description:""};let g=(0,d.$6g)(o.configPath);return g.endsWith(w.$Ri)&&(g=g.substr(0,g.length-w.$Ri.length-1)),{title:(0,m.localize)(9,null,g),description:this.M(o.configPath)}}M(o){return o.scheme==="file"?(0,j.$xw)(o.fsPath):o.toString()}async N(){if(!l.$j)return;n.app.clearRecentDocuments();const o=await this.getRecentlyOpened(),u=[];let g=0;for(let D=0;D<o.workspaces.length&&g<r.C;D++){const I=this.u(o.workspaces[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Wg)(I);await v.Promises.exists(O)&&(u.push(O),g++)}}const S=[];for(let D=0;D<o.files.length&&g<r.D;D++){const I=this.u(o.files[D]);if(I.scheme===h.Schemas.file){const O=(0,d.$Wg)(I);if(r.G.includes((0,d.$6g)(I))||u.includes(O))continue;await v.Promises.exists(O)&&(S.push(O),g++)}}S.reverse().forEach(D=>n.app.addRecentDocument(D)),u.reverse().forEach(D=>n.app.addRecentDocument(D))}};e.$vcc=s,e.$vcc=s=r=Ee([ie(0,p.$2j),ie(1,P.$Ibc),ie(2,y.$Pbc),ie(3,$.$Xbc),ie(4,t.$rbc)],s)}),define(re[308],oe([0,1,14,8,23,48,4,7,184,79,18,24,20,5,235,70,27,34,28,50,55,29,85]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$wcc=void 0;const s="menu";let i=class{static{r=this}static{this.a="lastKnownMenubarData"}constructor(g,S,D,I,O,M,W,F,T,q,ue,ee){this.n=g,this.o=S,this.p=D,this.q=I,this.r=O,this.s=M,this.t=W,this.u=F,this.v=T,this.w=q,this.x=ue,this.y=ee,this.m=Object.create(null),this.g=new C.$Hh(()=>this.F(),0),this.h=new C.$Hh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(j.$j||(0,P.$AD)(S))&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const g=this.t.getItem(r.a);g&&(g.menus&&(this.k=g.menus),g.keybindings&&(this.l=g.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,W,F)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:W?.id})},this.m["workbench.action.newWindow"]=(M,W,F)=>this.p.openEmptyWindow({context:2,contextWindowId:W?.id}),this.m["workbench.action.files.openFileFolder"]=(M,W,F)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.files.openFolder"]=(M,W,F)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.openWorkspace"]=(M,W,F)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(F),telemetryExtraData:{from:s}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const g=this.x.youTubeUrl;g&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(g,"openYouTubeUrl"));const S=this.x.requestFeatureUrl;S&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(S,"openUserVoiceUrl"));const D=this.x.reportIssueUrl;D&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(D,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(j.$w){const M=I.indexOf("?")>0?"&":"?";this.ab(`${I}${M}lang=${j.$w}`,"openLicenseUrl")}else this.ab(I,"openLicenseUrl")});const O=this.x.privacyStatementUrl;O&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(O,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(g=>this.G(g)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const g=this.o.getValue("window.enableMenuBarMnemonics");return typeof g!="boolean"?!0:g}get D(){if(!j.$j)return!1;const g=this.o.getValue("window.nativeTabs");return typeof g!="boolean"?!1:g}updateMenu(g,S){this.k=g.menus,this.l=g.keybindings,this.t.setItem(r.a,g),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(g){j.$j&&(g.oldCount===0&&g.newCount>0||g.oldCount>0&&g.newCount===0)&&(this.d=g.newCount===0,this.E())}H(){if(!j.$j)return;const g=n.BrowserWindow.getFocusedWindow();this.f=!g||!!this.y.getWindowByWebContents(g.webContents),this.E()}I(){const g=n.Menu.getApplicationMenu();if(g&&this.j.push(g),Object.keys(this.k).length===0){this.J(j.$j?new n.Menu:null);return}const S=new n.Menu;let D;if(j.$j){const O=new n.Menu;D=new n.MenuItem({label:this.x.nameShort,submenu:O}),this.K(O),S.append(D)}if(j.$j&&!this.c){this.c=!0;const O=new n.Menu;O.append(new n.MenuItem({label:this.cb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),n.app.dock.setMenu(O)}if(this.M("File")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(1,null)),submenu:O});this.O(O,"File"),S.append(M)}if(this.M("Edit")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(2,null)),submenu:O});this.O(O,"Edit"),S.append(M)}if(this.M("Selection")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(3,null)),submenu:O});this.O(O,"Selection"),S.append(M)}if(this.M("View")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(4,null)),submenu:O});this.O(O,"View"),S.append(M)}if(this.M("Go")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(5,null)),submenu:O});this.O(O,"Go"),S.append(M)}if(this.M("Run")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(6,null)),submenu:O});this.O(O,"Run"),S.append(M)}if(this.M("Terminal")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(7,null)),submenu:O});this.O(O,"Terminal"),S.append(M)}let I;if(this.M("Window")){const O=new n.Menu;I=new n.MenuItem({label:this.cb(h.localize(8,null)),submenu:O,role:"window"}),this.U(O)}if(I&&S.append(I),this.M("Help")){const O=new n.Menu,M=new n.MenuItem({label:this.cb(h.localize(9,null)),submenu:O,role:"help"});this.O(O,"Help"),S.append(M)}S.items&&S.items.length>0?this.J(S):this.J(null),this.h.schedule()}J(g){if(n.Menu.setApplicationMenu(g),g)for(const S of this.y.getWindows())S.win?.setMenu(null)}K(g){const S=this.W(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),D=this.V();let I;if(this.M("Preferences")){const ee=new n.Menu;this.O(ee,"Preferences"),I=new n.MenuItem({label:this.cb(h.localize(11,null)),submenu:ee})}const O=new n.Menu,M=new n.MenuItem({label:h.localize(12,null),role:"services",submenu:O}),W=new n.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),F=new n.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),T=new n.MenuItem({label:h.localize(15,null),role:"unhide"}),q=new n.MenuItem(this.$("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ee,ce,K)=>{const Q=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||n.BrowserWindow.getFocusedWindow()||Q?.win?.isMinimized())&&await this.L(K)&&this.w.quit(void 0)}})),ue=[S];ue.push(...D),I&&ue.push(o(),I),ue.push(o(),M,o(),W,F,T,o(),q),ue.forEach(ee=>g.append(ee))}async L(g){if(this.p.getWindowCount()===0)return!0;const S=this.o.getValue("window.confirmBeforeClose");if(S==="always"||S==="keyboardOnly"&&this.S(g)){const{response:D}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return D===0}return!0}M(g){if(!j.$j&&!(0,P.$AD)(this.o))return!1;switch(g){case"File":case"Help":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[g];case"Window":if(j.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[g]}}N(g,S){S.forEach(D=>{if((0,f.$rcc)(D))g.append(o());else if((0,f.$qcc)(D)){const I=new n.Menu,O=new n.MenuItem({label:this.cb(D.label),submenu:I});this.N(I,D.submenu.items),g.append(O)}else(0,f.$scc)(D)?g.append(this.Q(D)):(0,f.$tcc)(D)&&(D.id==="workbench.action.showAboutDialog"&&this.P(g),j.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[D.id]?g.append(new n.MenuItem(this.$(D.id,{label:this.cb(D.label),click:this.m[D.id]}))):g.append(this.W(D.label,D.id,!1,D.checked)):g.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)):g.append(this.W(D.label,D.id,D.enabled!==!1,!!D.checked)))})}O(g,S){this.k&&this.k[S]&&this.N(g,this.k[S].items)}P(g){const S=this.V();S.length&&(S.forEach(D=>g.append(D)),g.append(o()))}Q(g){const S=k.URI.revive(g.uri),D=g.id,I=D==="openRecentFile"?{fileUri:S}:D==="openRecentWorkspace"?{workspaceUri:S}:{folderUri:S};return new n.MenuItem(this.$(D,{label:g.label,click:async(O,M,W)=>{const F=this.R(W);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:F,gotoLineMode:!1,remoteAuthority:g.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([S])}},!1))}R(g){return!!(g&&(!j.$j&&(g.ctrlKey||g.shiftKey)||j.$j&&(g.metaKey||g.altKey)))}S(g){return!!(g.triggeredByAccelerator||g.altKey||g.ctrlKey||g.metaKey||g.shiftKey)}T(g,S,D){const I={label:this.cb(g),role:D,enabled:!0};return new n.MenuItem(this.Z(S,I))}U(g){const S=new n.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),D=new n.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new n.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),O=this.W(h.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(o()),M.push(this.W(h.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[S,D,o(),O,...M,o(),I].forEach(W=>g.append(W))}V(){switch(this.n.state.type){case"idle":return[new n.MenuItem({label:this.cb(h.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new n.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new n.MenuItem({label:this.cb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new n.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return j.$j?[]:[new n.MenuItem({label:this.cb(h.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new n.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new n.MenuItem({label:this.cb(h.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(g,S,D,I){const O=this.cb(g),M=typeof S=="function"?S:(ue,ee,ce)=>{const K=ue?ue.userSettingsLabel:null;let Q=S;Array.isArray(S)&&(Q=this.R(ce)?S[1]:S[0]),K&&ce.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:K}):this.Y({type:"commandId",commandId:Q})},W=typeof D=="boolean"?D:this.p.getWindowCount()>0,F=typeof I=="boolean"?I:!1,T={label:O,click:M,enabled:W};F&&(T.type="checkbox",T.checked=F);let q;return typeof S=="string"?q=S:Array.isArray(S)&&(q=S[0]),j.$j&&(q==="editor.action.clipboardCutAction"?T.role="cut":q==="editor.action.clipboardCopyAction"?T.role="copy":q==="editor.action.clipboardPasteAction"&&(T.role="paste"),q==="undo"?T.click=this.X(M,{inDevTools:ue=>ue.undo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("undo:")}):q==="redo"?T.click=this.X(M,{inDevTools:ue=>ue.redo(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("redo:")}):q==="editor.action.selectAll"&&(T.click=this.X(M,{inDevTools:ue=>ue.selectAll(),inNoWindow:()=>n.Menu.sendActionToFirstResponder("selectAll:")}))),new n.MenuItem(this.Z(q,T))}X(g,S){return(D,I,O)=>{const M=n.BrowserWindow.getFocusedWindow();if(!M)return S.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return S.inDevTools(M.webContents.devToolsWebContents);g(D,I||M,O)}}Y(g){let S=n.BrowserWindow.getFocusedWindow();if(S){const I=this.y.getWindowByWebContents(S.webContents);I&&(S=this.p.getWindowById(I.parentId)?.win??null)}if(!S){const I=this.p.getLastActiveWindow();I?.win?.isMinimized()&&(S=I.win)}const D=S?this.p.getWindowById(S.id):void 0;if(D){if(this.v.trace("menubar#runActionInRenderer",g),j.$j&&!this.q.isBuilt&&!D.isReady&&(g.type==="commandId"&&g.commandId==="workbench.action.toggleDevTools"||g.type!=="commandId"&&g.userSettingsLabel==="alt+cmd+i"))return!1;if(g.type==="commandId"){const I={id:g.commandId,from:"menu"};D.sendWhenReady("vscode:runAction",E.CancellationToken.None,I)}else{const I={userSettingsLabel:g.userSettingsLabel};D.sendWhenReady("vscode:runKeybinding",E.CancellationToken.None,I)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",g),!1}Z(g,S){const D=typeof g=="string"?this.l[g]:void 0;if(D?.label){if(D.isNative!==!1)S.accelerator=D.label,S.userSettingsLabel=D.userSettingsLabel;else if(typeof S.label=="string"){const I=S.label.indexOf("[");I>=0?S.label=`${S.label.substr(0,I)} [${D.label}]`:S.label=`${S.label} [${D.label}]`}}else S.accelerator=void 0;return S}$(g,S,D=!S.accelerator){D&&(S=this.Z(g,S));const I=S.click;return S.click=(O,M,W)=>{this.bb(g),I?.(O,M,W)},S}ab(g,S){this.w.openExternal(void 0,g),this.bb(S)}bb(g){this.r.publicLog2("workbenchActionExecuted",{id:g,from:s})}cb(g){return(0,R.$Cw)(g,!this.C)}};e.$wcc=i,e.$wcc=i=r=Ee([ie(0,w.$NX),ie(1,d.$2i),ie(2,a.$wbc),ie(3,b.$lbc),ie(4,c.$1l),ie(5,t.$ucc),ie(6,$.$BQ),ie(7,v.$Pbc),ie(8,m.$2j),ie(9,y.$icc),ie(10,p.$ik),ie(11,l.$hcc)],i);function o(){return new n.MenuItem({type:"separator"})}}),define(re[309],oe([0,1,6,20,5,308]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ycc=e.$xcc=void 0,e.$xcc=(0,n.$vi)("menubarMainService");let j=class{constructor(h,l,d){this.b=h,this.c=l,this.d=d,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(R.$wcc)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.$ycc=j,e.$ycc=j=Ee([ie(0,n.$ui),ie(1,C.$Pbc),ie(2,E.$2j)],j)}),define(re[310],oe([0,1,14,21,102,26,22,23,3,31,48,2,13,9,66,4,36,19,12,7,194,65,18,56,24,16,6,20,5,80,81,68,34,55,135,29,133,302,30,99,85,58,69,39,57,67,79]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O,M,W,F,T,q,ue,ee,ce,K,Q,B,L,z,U){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ycc=void 0;function ae(Y){return(0,ue.$Ki)(Y?.workspace)}function G(Y){return(0,ue.$Fi)(Y?.workspace)}let le=class extends b.$Vc{constructor(A,N,_,ne,J,V,x,H,se,he,me,$e,ye,Pe,ke,Oe,we,Z,fe,ge){super(),this.s=A,this.t=N,this.u=_,this.w=ne,this.z=J,this.C=V,this.D=x,this.F=H,this.G=se,this.H=he,this.I=me,this.J=$e,this.L=ye,this.M=Pe,this.N=ke,this.O=Oe,this.P=we,this.Q=Z,this.R=fe,this.S=ge,this.a=this.B(new h.$ee),this.onDidOpenWindow=this.a.event,this.b=this.B(new h.$ee),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new h.$ee),this.onDidDestroyWindow=this.c.event,this.f=this.B(new h.$ee),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new h.$ee),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new h.$ee),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new h.$ee),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new h.$ee),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new q.$Vcc(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(A=>this.b.fire(A.window))),this.B(this.onDidSignalReadyWindow(A=>{if(A.config?.extensionDevelopmentPath||A.config?.extensionTestsPath){const N=new b.$Uc;if(N.add(h.Event.any(A.onDidClose,A.onDidDestroy)(()=>N.dispose())),A.config.extensionDevelopmentPath)for(const _ of A.config.extensionDevelopmentPath)N.add(this.Q.addValidFileRoot(_));A.config.extensionTestsPath&&N.add(this.Q.addValidFileRoot(A.config.extensionTestsPath))}}))}openEmptyWindow(A,N){const _=this.F.args,ne=N?.remoteAuthority||void 0,J=!0,V=N?.forceReuseWindow,x=!V;return this.open({...A,cli:_,forceEmpty:J,forceNewWindow:x,forceReuseWindow:V,remoteAuthority:ne})}openExistingWindow(A,N){A.focus(),this.W(N,[A])}async open(A){this.w.trace("windowsManager#open"),A.addMode&&(A.initialStartup||!this.getLastActiveWindow())&&(A.addMode=!1);const N=[],_=[],ne=[],J=[],V=[];let x,H=0;const se=await this.cb(A);this.w.trace("windowsManager#open pathsToOpen",se);for(const Pe of se)G(Pe)?A.addMode?N.push(Pe):_.push(Pe):ae(Pe)?ne.push(Pe):Pe.fileUri?(x||(x={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Pe.remoteAuthority}),x.filesToOpenOrCreate.push(Pe)):Pe.backupPath?V.push({backupFolder:(0,m.$oc)(Pe.backupPath),remoteAuthority:Pe.remoteAuthority}):H++;A.diffMode&&x&&x.filesToOpenOrCreate.length>=2&&(x.filesToDiff=x.filesToOpenOrCreate.slice(0,2),x.filesToOpenOrCreate=[]),A.mergeMode&&x&&x.filesToOpenOrCreate.length===4&&(x.filesToMerge=x.filesToOpenOrCreate.slice(0,4),x.filesToOpenOrCreate=[],x.filesToDiff=[]),x&&A.waitMarkerFileURI&&(x.filesToWait={paths:(0,j.$Hb)([...x.filesToDiff,x.filesToMerge[3],...x.filesToOpenOrCreate]),waitMarkerFileUri:A.waitMarkerFileURI}),A.initialStartup?(J.push(...this.M.getUntitledWorkspaces()),ne.push(...J),V.push(...this.I.getEmptyWindowBackups())):V.length=0;const{windows:he,filesOpenedInWindow:me}=await this.X(A,ne,_,V,H,x,N);if(this.w.trace(`windowsManager#open used window count ${he.length} (workspacesToOpen: ${ne.length}, foldersToOpen: ${_.length}, emptyToRestore: ${V.length}, emptyToOpen: ${H})`),he.length>1)if(me)me.focus();else{const Pe=this.r.state.lastActiveWindow&&!A.forceEmpty&&!A.cli._.length&&!A.cli["file-uri"]&&!A.cli["folder-uri"]&&!(A.urisToOpen&&A.urisToOpen.length);let ke=!0,Oe=!0;if(Pe){const we=he.filter(Z=>this.r.state.lastActiveWindow&&Z.backupPath===this.r.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),ke=!1,Oe=!1)}if(ke)for(let we=he.length-1;we>=0;we--){const Z=he[we];if(!(Z.openedWorkspace&&J.some(fe=>Z.openedWorkspace&&fe.workspace.id===Z.openedWorkspace.id)||Z.backupPath&&V.some(fe=>Z.backupPath&&fe.backupFolder===(0,m.$oc)(Z.backupPath)))){Z.focus(),Oe=!1;break}}Oe&&he[he.length-1].focus()}const $e=x&&x.filesToDiff.length>0,ye=x&&x.filesToMerge.length>0;if(!he.some(Pe=>Pe.isExtensionDevelopmentHost)&&!$e&&!ye&&!A.noRecentEntry){const Pe=[];for(const ke of se)ae(ke)&&!ke.transient?Pe.push({label:ke.label,workspace:ke.workspace,remoteAuthority:ke.remoteAuthority}):G(ke)?Pe.push({label:ke.label,folderUri:ke.workspace.uri,remoteAuthority:ke.remoteAuthority}):ke.fileUri&&Pe.push({label:ke.label,fileUri:ke.fileUri,remoteAuthority:ke.remoteAuthority});this.L.addRecentlyOpened(Pe)}return this.W(A,he),he}W(A,N){const _=A.waitMarkerFileURI;A.context===0&&_&&N.length===1&&N[0]&&(async()=>{await N[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(A,N,_,ne,J,V,x){const H=[];let se;function he(we,Z){H.push(we),Z&&(se=we,V=void 0)}let{openFolderInNewWindow:me,openFilesInNewWindow:$e}=this.ob(A);if(!A.initialStartup&&x.length>0){const we=x[0].remoteAuthority,Z=this.ub(we);Z&&he(this.$(Z,x.map(fe=>fe.workspace.uri)))}const ye=_.length+N.length+ne.length;if(V&&ye===0){const we=V.filesToOpenOrCreate[0]||V.filesToDiff[0]||V.filesToMerge[3],Z=this.getWindows().filter(ge=>V&&(0,$.$bh)(ge.remoteAuthority,V.remoteAuthority));let fe;we?.fileUri&&!$e&&((A.context===4||A.context===0||A.context===1)&&(fe=await(0,T.$Bbc)(Z,we.fileUri,async ge=>ge.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace(ge.configPath):void 0)),fe||(fe=this.vb(Z))),fe?(0,ue.$Ki)(fe.openedWorkspace)?N.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ue.$Fi)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):he(this.Y(A,fe,V),!0):he(await this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,filesToOpen:V,forceNewWindow:!0,remoteAuthority:V.remoteAuthority,forceNewTabbedWindow:A.forceNewTabbedWindow,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile}),!0)}const Pe=(0,j.$Mb)(N,we=>we.workspace.id);if(Pe.length>0){const we=(0,j.$Hb)(Pe.map(Z=>(0,T.$Cbc)(this.getWindows(),Z.workspace.configPath)));if(we.length>0){const Z=we[0],fe=(0,$.$bh)(V?.remoteAuthority,Z.remoteAuthority)?V:void 0;he(this.Y(A,Z,fe),!!fe),me=!0}for(const Z of Pe){if(we.some(je=>je.openedWorkspace&&je.openedWorkspace.id===Z.workspace.id))continue;const fe=Z.remoteAuthority,ge=(0,$.$bh)(V?.remoteAuthority,fe)?V:void 0;he(await this.bb(A,Z,me,ge),!!ge),me=!0}}const ke=(0,j.$Mb)(_,we=>$.$Zg.getComparisonKey(we.workspace.uri));if(ke.length>0){const we=(0,j.$Hb)(ke.map(Z=>(0,T.$Cbc)(this.getWindows(),Z.workspace.uri)));if(we.length>0){const Z=we[0],fe=(0,$.$bh)(V?.remoteAuthority,Z.remoteAuthority)?V:void 0;he(this.Y(A,Z,fe),!!fe),me=!0}for(const Z of ke){if(we.some(je=>(0,ue.$Fi)(je.openedWorkspace)&&$.$Zg.isEqual(je.openedWorkspace.uri,Z.workspace.uri)))continue;const fe=Z.remoteAuthority,ge=(0,$.$bh)(V?.remoteAuthority,fe)?V:void 0;he(await this.bb(A,Z,me,ge),!!ge),me=!0}}const Oe=(0,j.$Mb)(ne,we=>we.backupFolder);if(Oe.length>0)for(const we of Oe){const Z=we.remoteAuthority,fe=(0,$.$bh)(V?.remoteAuthority,Z)?V:void 0;he(await this.ab(A,!0,Z,fe,we),!!fe),me=!0}if(H.length===0||V){V&&!J&&J++;const we=V?V.remoteAuthority:A.remoteAuthority;for(let Z=0;Z<J;Z++)he(await this.ab(A,me,we,V),!!V),me=!0}return{windows:(0,j.$Mb)(H),filesOpenedInWindow:se}}Y(A,N,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(N);const ne={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:A?.userEnv?.TERM_PROGRAM};return N.sendWhenReady("vscode:openFiles",k.CancellationToken.None,ne),N}Z(A){let N=A;const _=n.BrowserWindow.getFocusedWindow();if(_&&_.id!==A.id){const ne=this.S.getWindowByWebContents(_.webContents);ne&&ne.parentId===A.id&&(N=ne)}N.focus()}$(A,N){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:N}),A.focus();const _={foldersToAdd:N};return A.sendWhenReady("vscode:addFolders",k.CancellationToken.None,_),A}ab(A,N,_,ne,J){this.w.trace("windowsManager#doOpenEmpty",{restore:!!J,remoteAuthority:_,filesToOpen:ne,forceNewWindow:N});let V;return!N&&typeof A.contextWindowId=="number"&&(V=this.getWindowById(A.contextWindowId)),this.pb({userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:_,forceNewWindow:N,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:V,emptyWindowBackupInfo:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}bb(A,N,_,ne,J){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:N,filesToOpen:ne}),!_&&!J&&typeof A.contextWindowId=="number"&&(J=this.getWindowById(A.contextWindowId)),this.pb({workspace:N.workspace,userEnv:A.userEnv,cli:A.cli,initialStartup:A.initialStartup,remoteAuthority:N.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:A.forceNewTabbedWindow,filesToOpen:ne,windowToUse:J,forceProfile:A.forceProfile,forceTempProfile:A.forceTempProfile})}async cb(A){let N,_=!1,ne=!1;if(A.urisToOpen&&A.urisToOpen.length>0?(N=await this.db(A),_=!0):A.forceEmpty?N=[Object.create(null)]:A.cli._.length||A.cli["folder-uri"]||A.cli["file-uri"]?(N=await this.eb(A.cli),N.length===0&&N.push(Object.create(null)),_=!0):(N=await this.gb(),N.length===0&&N.push(Object.create(null)),ne=!0),!A.addMode&&_){const J=N.filter(V=>G(V));if(J.length>1){const V=J[0].remoteAuthority;if(J.every(x=>(0,$.$bh)(x.remoteAuthority,V))){const x=await this.M.createUntitledWorkspace(J.map(H=>({uri:H.workspace.uri})));N.push({workspace:x,remoteAuthority:V}),N=N.filter(H=>!G(H))}}}if(A.initialStartup&&!ne&&this.J.getValue("window")?.restoreWindows==="preserve"){const J=await this.gb();N.unshift(...J.filter(V=>ae(V)||G(V)||V.backupPath))}return N}async db(A){const N={gotoLineMode:A.gotoLineMode,remoteAuthority:A.remoteAuthority},_=await Promise.all((0,j.$Hb)(A.urisToOpen||[]).map(async ne=>{const J=await this.ib(ne,N);if(J)return J.label=ne.label,J;const V=this.kb(ne);this.O.showMessageBox({type:"info",buttons:[(0,P.localize)(0,null)],message:V.scheme===v.Schemas.file?(0,P.localize)(1,null):(0,P.localize)(2,null),detail:V.scheme===v.Schemas.file?(0,P.localize)(3,null,(0,d.$ww)(V,{os:y.OS,tildify:this.F})):(0,P.localize)(4,null,V.toString(!0))},n.BrowserWindow.getFocusedWindow()??void 0)}));return(0,j.$Hb)(_)}async eb(A){const N=[],_={ignoreFileNotFound:!0,gotoLineMode:A.goto,remoteAuthority:A.remote||void 0,forceOpenWorkspaceAsFile:A.diff&&A._.length===2||A.merge&&A._.length===4},ne=A["folder-uri"];if(ne){const x=await Promise.all(ne.map(H=>{const se=this.fb(H);if(se)return this.ib({folderUri:se},_)}));N.push(...(0,j.$Hb)(x))}const J=A["file-uri"];if(J){const x=await Promise.all(J.map(H=>{const se=this.fb(H);if(se)return this.ib((0,ue.$1i)(H)?{workspaceUri:se}:{fileUri:se},_)}));N.push(...(0,j.$Hb)(x))}const V=await Promise.all(A._.map(x=>_.remoteAuthority?this.nb(x,_):this.lb(x,_)));return N.push(...(0,j.$Hb)(V)),N}fb(A){try{const N=w.URI.parse(A);if(!N.scheme){this.w.error(`Invalid URI input string, scheme missing: ${A}`);return}return N.path?N:N.with({path:"/"})}catch(N){this.w.error(`Invalid URI input string: ${A}, ${N.message}`)}}async gb(){const A=this.hb();switch(A){case"none":return[];case"one":case"all":case"preserve":case"folders":{const N=[];A!=="one"&&N.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&N.push(this.r.state.lastActiveWindow);const _=await Promise.all(N.map(async ne=>{if(ne.workspace){const J=await this.ib({workspaceUri:ne.workspace.configPath},{remoteAuthority:ne.remoteAuthority,rejectTransientWorkspaces:!0});if(ae(J))return J}else if(ne.folderUri){const J=await this.ib({folderUri:ne.folderUri},{remoteAuthority:ne.remoteAuthority});if(G(J))return J}else if(A!=="folders"&&ne.backupPath)return{backupPath:ne.backupPath,remoteAuthority:ne.remoteAuthority}}));return(0,j.$Hb)(_)}}}hb(){let A;return this.H.wasRestarted?A="all":(A=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(A)||(A="all")),A}async ib(A,N=Object.create(null)){const _=this.kb(A);return _.scheme===v.Schemas.file?((0,M.$xD)(A)&&(N={...N,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,N)):this.jb(A,N)}jb(A,N){let _=this.kb(A);const ne=(0,I.$Gm)(_)||N.remoteAuthority;if(_=(0,$.$dh)((0,$.$0g)(_)),(0,M.$xD)(A)){if(N.gotoLineMode){const{path:J,line:V,column:x}=(0,l.$Cg)(_.path);return{fileUri:_.with({path:J}),options:{selection:V?{startLineNumber:V,startColumn:x||1}:void 0},remoteAuthority:ne}}return{fileUri:_,remoteAuthority:ne}}else if((0,M.$vD)(A))return{workspace:(0,ee.$Fbc)(_),remoteAuthority:ne};return{workspace:(0,ee.$Gbc)(_),remoteAuthority:ne}}kb(A){return(0,M.$vD)(A)?A.workspaceUri:(0,M.$wD)(A)?A.folderUri:A.fileUri}async lb(A,N,_){let ne,J;N.gotoLineMode&&({path:A,line:ne,column:J}=(0,l.$Cg)(A)),A=(0,l.$wg)((0,m.$ic)(A),(0,p.cwd)());try{const V=await C.Promises.stat(A);if(V.isFile()){if(!N.forceOpenWorkspaceAsFile){const x=await this.M.resolveLocalWorkspace(w.URI.file(A));if(x)return x.transient&&N.rejectTransientWorkspaces?void 0:{workspace:{id:x.id,configPath:x.configPath},type:i.FileType.File,exists:!0,remoteAuthority:x.remoteAuthority,transient:x.transient}}return{fileUri:w.URI.file(A),type:i.FileType.File,exists:!0,options:{selection:ne?{startLineNumber:ne,startColumn:J||1}:void 0}}}else{if(V.isDirectory())return{workspace:(0,ee.$Gbc)(w.URI.file(A),V),type:i.FileType.Directory,exists:!0};if(!y.$i&&A==="/dev/null")return{fileUri:w.URI.file(A),type:i.FileType.File,exists:!0}}}catch(V){if(V.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(A,N);const x=w.URI.file(A);if(this.L.removeRecentlyOpened([x]),N.ignoreFileNotFound)return{fileUri:x,type:i.FileType.File,exists:!1}}}async mb(A,N){const _=w.URI.file(A),{response:ne,checkboxChecked:J}=await this.O.showMessageBox({type:"warning",buttons:[(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],message:(0,P.localize)(8,null,_.authority),detail:(0,P.localize)(9,null,(0,d.$ww)(_,{os:y.OS,tildify:this.F})),checkboxLabel:(0,P.localize)(10,null,_.authority),cancelId:1});if(ne===0){if((0,E.addUNCHostToAllowlist)(_.authority),J){const V={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(V.channel,V.args),this.sendToOpeningWindow(V.channel,V.args)}return this.lb(A,N,!0)}if(ne===2)return n.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(A,N)}nb(A,N){const _=A.charCodeAt(0),ne=N.remoteAuthority;let J,V;N.gotoLineMode&&({path:A,line:J,column:V}=(0,l.$Cg)(A)),_!==47&&((0,l.$vg)(_)&&A.charCodeAt(A.charCodeAt(1))===58&&(A=(0,l.$og)(A)),A=`/${A}`);const x=w.URI.from({scheme:v.Schemas.vscodeRemote,authority:ne,path:A});if(A.charCodeAt(A.length-1)!==47){if((0,ue.$1i)(A))return N.forceOpenWorkspaceAsFile?{fileUri:x,options:{selection:J?{startLineNumber:J,startColumn:V||1}:void 0},remoteAuthority:N.remoteAuthority}:{workspace:(0,ee.$Fbc)(x),remoteAuthority:ne};if(N.gotoLineMode||m.$hc.basename(A).indexOf(".")!==-1)return{fileUri:x,options:{selection:J?{startLineNumber:J,startColumn:V||1}:void 0},remoteAuthority:ne}}return{workspace:(0,ee.$Gbc)(x),remoteAuthority:ne}}ob(A){const N=this.J.getValue("window"),_=N?.openFoldersInNewWindow||"default",ne=N?.openFilesInNewWindow||"off";let J=(A.preferNewWindow||A.forceNewWindow)&&!A.forceReuseWindow;!A.forceNewWindow&&!A.forceReuseWindow&&(_==="on"||_==="off")&&(J=_==="on");let V=!1;return A.forceNewWindow||A.forceReuseWindow?V=!!A.forceNewWindow&&!A.forceReuseWindow:(y.$j?A.context===1&&(V=!0):A.context!==3&&A.context!==2&&!(A.userEnv&&A.userEnv.TERM_PROGRAM==="vscode")&&(V=!0),!A.cli.extensionDevelopmentPath&&(ne==="on"||ne==="off")&&(V=ne==="on")),{openFolderInNewWindow:!!J,openFilesInNewWindow:V}}async openExtensionDevelopmentHostWindow(A,N){const _=(0,T.$Dbc)(this.getWindows(),A);if(_)return this.H.reload(_,N.cli),_.focus(),[_];let ne=N.cli["folder-uri"]||[],J=N.cli["file-uri"]||[],V=N.cli._;if(!V.length&&!ne.length&&!J.length&&!N.cli.extensionTestsPath){const se=this.r.state.lastPluginDevelopmentHostWindow,he=se?.workspace??se?.folderUri;he&&(w.URI.isUri(he)?he.scheme===v.Schemas.file?V=[he.fsPath]:ne=[he.toString()]:he.configPath.scheme===v.Schemas.file?V=[(0,$.$Wg)(he.configPath)]:J=[he.configPath.toString()])}let x=N.remoteAuthority;for(const se of A)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const he=w.URI.parse(se),me=(0,I.$Gm)(he);me&&(x?(0,$.$bh)(me,x)||this.w.error("more than one extension development path authority"):x=me)}V=V.filter(se=>{const he=w.URI.file(se);return(0,T.$Cbc)(this.getWindows(),he)?!1:(0,$.$bh)((0,I.$Gm)(he),x)}),ne=ne.filter(se=>{const he=this.fb(se);return he&&(0,T.$Cbc)(this.getWindows(),he)?!1:he?(0,$.$bh)((0,I.$Gm)(he),x):!1}),J=J.filter(se=>{const he=this.fb(se);return he&&(0,T.$Cbc)(this.getWindows(),he)?!1:he?(0,$.$bh)((0,I.$Gm)(he),x):!1}),N.cli._=V,N.cli["folder-uri"]=ne,N.cli["file-uri"]=J;const H={context:N.context,cli:N.cli,forceNewWindow:!0,forceEmpty:!V.length&&!ne.length&&!J.length,userEnv:N.userEnv,noRecentEntry:!0,waitMarkerFileURI:N.waitMarkerFileURI,remoteAuthority:x,forceProfile:N.forceProfile,forceTempProfile:N.forceTempProfile};return this.open(H)}async pb(A){const N=this.J.getValue("window"),_=this.getLastActiveWindow(),ne=_?.profile??this.G.defaultProfile;let J;!A.forceNewWindow&&!A.forceNewTabbedWindow&&(J=A.windowToUse||_,J&&J.focus());const V={...this.F.args,...A.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:A.emptyWindowBackupInfo?(0,m.$kc)(this.F.backupHome,A.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:ne},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:A.remoteAuthority,workspace:A.workspace,userEnv:{...this.u,...A.userEnv},filesToOpenOrCreate:A.filesToOpen?.filesToOpenOrCreate,filesToDiff:A.filesToOpen?.filesToDiff,filesToMerge:A.filesToOpen?.filesToMerge,filesToWait:A.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:S.default,isInitialStartup:A.initialStartup,perfMarks:(0,f.getMarks)(),os:{release:(0,R.release)(),hostname:(0,R.hostname)(),arch:(0,R.arch)()},autoDetectHighContrast:N?.autoDetectHighContrast??!0,autoDetectColorScheme:N?.autoDetectColorScheme??!1,accessibilitySupport:n.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(J){const x=J.config;!V.extensionDevelopmentPath&&x?.extensionDevelopmentPath&&(V.extensionDevelopmentPath=x.extensionDevelopmentPath,V.extensionDevelopmentKind=x.extensionDevelopmentKind,V["enable-proposed-api"]=x["enable-proposed-api"],V.verbose=x.verbose,V["inspect-extensions"]=x["inspect-extensions"],V["inspect-brk-extensions"]=x["inspect-brk-extensions"],V.debugId=x.debugId,V.extensionEnvironment=x.extensionEnvironment,V["extensions-dir"]=x["extensions-dir"],V["disable-extensions"]=x["disable-extensions"]),V.loggers={global:V.loggers.global,window:x?.loggers.window??V.loggers.window}}else{const x=this.r.getNewWindowState(V);(0,f.mark)("code/willCreateCodeWindow");const H=J=this.N.createInstance(W.$Nbc,{state:x,extensionDevelopmentPath:V.extensionDevelopmentPath,isExtensionTestHost:!!V.extensionTestsPath});(0,f.mark)("code/didCreateCodeWindow"),A.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(H),this.n.set(H.id,H),this.a.fire(H),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new b.$Uc;se.add(H.onDidSignalReady(()=>this.b.fire(H))),se.add(h.Event.once(H.onDidClose)(()=>this.sb(H,se))),se.add(h.Event.once(H.onDidDestroy)(()=>this.tb(H))),se.add(H.onDidMaximize(()=>this.g.fire(H))),se.add(H.onDidUnmaximize(()=>this.h.fire(H))),se.add(H.onDidEnterFullScreen(()=>this.j.fire({window:H,fullscreen:!0}))),se.add(H.onDidLeaveFullScreen(()=>this.j.fire({window:H,fullscreen:!1}))),se.add(H.onDidTriggerSystemContextMenu(({x:me,y:$e})=>this.m.fire({window:H,x:me,y:$e})));const he=(0,c.$gg)(H.win?.webContents);he.removeAllListeners("devtools-reload-page"),se.add(h.Event.fromNodeEventEmitter(he,"devtools-reload-page")(()=>this.H.reload(H))),this.H.registerWindow(H)}return V.windowId=J.id,J.isReady?this.H.unload(J,4).then(async x=>{x||await this.qb(J,V,A,ne)}):await this.qb(J,V,A,ne),J}async qb(A,N,_,ne){if(N.extensionDevelopmentPath||((0,ue.$Ki)(N.workspace)?N.backupPath=this.I.registerWorkspaceBackup({workspace:N.workspace,remoteAuthority:N.remoteAuthority}):(0,ue.$Fi)(N.workspace)?N.backupPath=this.I.registerFolderBackup({folderUri:N.workspace.uri,remoteAuthority:N.remoteAuthority}):N.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,ee.$Hbc)().id,remoteAuthority:N.remoteAuthority})),this.G.isEnabled()){const J=N.workspace??(0,ue.$Ji)(N.backupPath,!1),V=this.rb(_,J,ne),x=V instanceof Promise?await V:V;N.profiles.profile=x,N.extensionDevelopmentPath||await this.G.setProfileForWorkspace(J,x)}A.load(N)}rb(A,N,_){return A.forceProfile?this.G.profiles.find(ne=>ne.name===A.forceProfile)??this.G.createNamedProfile(A.forceProfile):A.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(N)??_}sb(A,N){this.n.delete(A.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),N.dispose()}tb(A){this.n.delete(A.id),this.c.fire(A)}getFocusedWindow(){const A=n.BrowserWindow.getFocusedWindow();if(A)return this.getWindowById(A.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(A){return this.vb(this.getWindows().filter(N=>(0,$.$bh)(N.remoteAuthority,A)))}vb(A){return(0,F.$ybc)(A)}sendToFocused(A,...N){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(A,k.CancellationToken.None,...N)}sendToOpeningWindow(A,...N){this.B(h.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(A,k.CancellationToken.None,...N)}))}sendToAll(A,N,_){for(const ne of this.getWindows())_&&_.indexOf(ne.id)>=0||ne.sendWhenReady(A,k.CancellationToken.None,N)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(A){return this.n.get(A)}getWindowByWebContents(A){const N=n.BrowserWindow.fromWebContents(A);if(!N)return;const _=this.getWindowById(N.id);return _?.matches(A)?_:void 0}};e.$Ycc=le,e.$Ycc=le=Ee([ie(3,g.$2j),ie(4,z.$Kbc),ie(5,O.$BQ),ie(6,B.$do),ie(7,s.$lbc),ie(8,L.$zbc),ie(9,u.$Pbc),ie(10,a.$qbc),ie(11,t.$2i),ie(12,ce.$ucc),ie(13,K.$Ibc),ie(14,o.$ui),ie(15,r.$rbc),ie(16,i.$2k),ie(17,D.$tbc),ie(18,Q.$ubc),ie(19,U.$hcc)],le)}),define(re[311],oe([0,1,65,29,85,58]),function(X,e,n,C,E,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1cc=void 0;let j=class{constructor(h,l,d,b){this.a=h,this.b=l,this.c=d,this.d=b,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const d=this.b.getWindowById(h);if(d)return this.a.enterWorkspace(d,this.b.getWindows(),l)}createUntitledWorkspace(h,l,d){return this.a.createUntitledWorkspace(l,d)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$1cc=j,e.$1cc=j=Ee([ie(0,R.$Ibc),ie(1,C.$wbc),ie(2,E.$ucc),ie(3,n.$qbc)],j)}),define(re[312],oe([0,1,14,102,37,26,17,47,15,31,3,42,48,2,13,9,4,12,7,33,160,44,161,114,294,164,65,287,18,203,92,134,56,120,224,24,64,95,212,297,214,215,216,16,228,94,78,6,93,223,303,288,295,20,5,309,70,27,68,298,96,34,279,84,126,28,255,257,54,50,269,292,304,293,305,131,271,272,273,276,301,55,29,310,278,30,98,85,311,58,39,237,57,248,53,83,132,281,296,284,8,259,280,232,67,300,275,22,129,299,267,243,62,79,307,72]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O,M,W,F,T,q,ue,ee,ce,K,Q,B,L,z,U,ae,G,le,Y,A,N,_,ne,J,V,x,H,se,he,me,$e,ye,Pe,ke,Oe,we,Z,fe,ge,je,Re,Be,Le,Fe,Ue,Ve,Je,Te,te,de,pe,ve,Se,Me,ze,Qe,Ze,Ye,Ke,st,it,ot,at,vt,Pt,kt,Et,St,ct,gt,jt,It,Dt,lt,Ct,mt,ut,At,Rt,ht,Ot,$t,Mt,wt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$hdc=void 0;let dt=class extends m.$Vc{static{ft=this}static{this.a={[f.Schemas.file]:"security.promptForLocalFileProtocolHandling",[f.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,De,Ae,be,Ce,qe,He,Ge,We,Ne,xe,Xe){super(),this.g=Ie,this.h=De,this.j=Ae,this.m=be,this.n=Ce,this.s=qe,this.t=He,this.u=Ge,this.w=We,this.y=Ne,this.z=xe,this.C=Xe,this.D(),this.F()}D(){const Ie=We=>We?.startsWith(`${f.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);n.session.defaultSession.setPermissionRequestHandler((We,Ne,xe,Xe)=>Ie(Xe.requestingUrl)?xe(De.has(Ne)):xe(!1)),n.session.defaultSession.setPermissionCheckHandler((We,Ne,xe,Xe)=>Ie(Xe.requestingUrl)?De.has(Ne):!1);const Ae=new Set([f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemoteResource,f.Schemas.vscodeManagedRemoteResource,"devtools"]),be=We=>{for(let Ne=We;Ne;Ne=Ne.parent)if(Ne.url.startsWith(`${f.Schemas.vscodeWebview}://`))return!0;return!1},Ce=We=>We.resourceType==="xhr"||be(We.frame),qe=We=>{const Ne=We.frame;if(!Ne||!this.b)return!1;const xe=n.BrowserWindow.getAllWindows();for(const Xe of xe)if(Ne.processId===Xe.webContents.mainFrame.processId)return!0;return!1},He=(We,Ne)=>{if(We.path!=="/index.html")return!0;const xe=Ne.frame;if(!xe||!this.b)return!1;for(const Xe of this.b.getWindows())if(Xe.win&&xe.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};n.session.defaultSession.webRequest.onBeforeRequest((We,Ne)=>{const xe=c.URI.parse(We.url);return xe.scheme===f.Schemas.vscodeWebview&&!He(xe,We)?(this.m.error("Blocked vscode-webview request",We.url),Ne({cancel:!0})):xe.scheme===f.Schemas.vscodeFileResource&&!qe(We)?(this.m.error("Blocked vscode-file request",We.url),Ne({cancel:!0})):xe.path.endsWith(".svg")&&!Ae.has(xe.scheme)?Ne({cancel:!Ce(We)}):Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{const xe=We.responseHeaders,Xe=xe["content-type"]||xe["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=c.URI.parse(We.url);if(_e.path.endsWith(".svg")&&Ae.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ne({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(f.Schemas.vscodeRemoteResource)&&Xe.some(nt=>nt.toLowerCase().includes("image/svg")))return Ne({cancel:!Ce(We)})}return Ne({cancel:!1})}),n.session.defaultSession.webRequest.onHeadersReceived((We,Ne)=>{if(We.url.startsWith("https://vscode.download.prss.microsoft.com/")){const xe=We.responseHeaders??Object.create(null);if(xe["Access-Control-Allow-Origin"]===void 0)return xe["Access-Control-Allow-Origin"]=["*"],Ne({cancel:!1,responseHeaders:xe})}return Ne({cancel:!1})});const Ge=n.session.defaultSession;typeof Ge.setCodeCachePath=="function"&&this.s.codeCachePath&&Ge.setCodeCachePath((0,y.$kc)(this.s.codeCachePath,"chrome")),p.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,C.disableUNCAccessRestrictions)():(0,C.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,h.setUnexpectedErrorHandler)(Ae=>this.H(Ae)),process.on("uncaughtException",Ae=>{(0,h.$Z)(Ae)||(0,h.$1)(Ae)}),process.on("unhandledRejection",Ae=>(0,h.$1)(Ae)),this.t.onWillShutdown(()=>this.dispose()),(0,P.$PW)(),n.app.on("accessibility-support-changed",(Ae,be)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",be)}),n.app.on("activate",async(Ae,be)=>{this.m.trace("app#activate"),be||await this.b?.openEmptyWindow({context:1})}),n.app.on("web-contents-created",(Ae,be)=>{be?.opener?.url.startsWith(`${f.Schemas.vscodeFileResource}://${f.$Og}/`)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(be)),be.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),be.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow(Ce)}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let Ie=[],De;n.app.on("open-file",(Ae,be)=>{be=(0,wt.$am)(be),this.m.trace("app#open-file: ",be),Ae.preventDefault(),Ie.push((0,Me.$1i)(be)?{workspaceUri:c.URI.file(be)}:{fileUri:c.URI.file(be)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],De=void 0},100)}),n.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),E.$OW.handle("vscode:fetchShellEnv",Ae=>{const be=this.b?.getWindowByWebContents(Ae.sender);let Ce,qe;return be?.config?(Ce=be.config,qe={...process.env,...be.config.userEnv}):(Ce=this.s.args,qe=process.env),this.X(Ce,qe,!1)}),E.$OW.handle("vscode:writeNlsFile",(Ae,be,Ce)=>{const qe=this.G([be]);if(!qe||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(qe,j.$Fe.fromString(Ce))}),E.$OW.handle("vscode:readNlsFile",async(Ae,...be)=>{const Ce=this.G(be);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),E.$OW.on("vscode:toggleDevTools",Ae=>Ae.sender.toggleDevTools()),E.$OW.on("vscode:openDevTools",Ae=>Ae.sender.openDevTools()),E.$OW.on("vscode:reloadWindow",Ae=>Ae.sender.reload()),E.$OW.handle("vscode:notifyZoomLevel",async(Ae,be)=>{const Ce=this.b?.getWindowByWebContents(Ae.sender);Ce&&Ce.notifyZoomLevel(be)})}G(Ie){let De;for(const Ae of Ie)typeof Ae=="string"&&(typeof De!="string"?De=Ae:De=(0,y.$kc)(De,Ae));if(!(typeof De!="string"||!(0,y.$jc)(De)||!(0,l.$ug)(De,this.s.cachedLanguagesPath,!p.$k)))return c.URI.file(De)}H(Ie){if(Ie){const De={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;p.$i&&Ie&&n.app.setAppUserModelId(Ie);try{p.$j&&this.u.getValue("window.nativeTabs")===!0&&!n.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&n.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ne){this.m.error(Ne)}const De=new t.$VW;this.t.onWillShutdown(Ne=>{Ne.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Ae,be]=await Promise.all([(0,gt.$9cc)(this.w,this.m),(0,gt.$0cc)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Ae}`);const{sharedProcessReady:Ce,sharedProcessClient:qe}=this.P(Ae,be),He=await this.Q(Ae,be,Ce);this.B(He.createInstance(s.$Zbc)),this.B(He.createInstance(Et.$5cc)),He.invokeFunction(Ne=>this.R(Ne,De,qe));const Ge=await He.invokeFunction(Ne=>this.I(Ne,De));this.J(De),this.t.phase=2,await He.invokeFunction(Ne=>this.S(Ne,Ge)),this.t.phase=3,this.U(),this.B(new ct.$Hh(()=>{this.B((0,ct.$Lh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,De){const Ae=this.b=Ie.get(pe.$wbc),be=Ie.get(Fe.$DX),Ce=this.f=Ie.get(V.$icc),qe=Ie.get(O.$rbc),He=this;be.registerHandler({async handleURL(_e,nt){return He.O(Ae,qe,be,_e,nt)}});const Ge=this.B(new Se.$Zcc({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),We=new a.$di(_e=>Ge.getActiveClientId().then(nt=>_e===nt)),Ne=new Ue.$Qcc(We,this.m),xe=De.getChannel("urlHandler",Ne);be.registerHandler(new Ue.$Pcc(xe));const Xe=await this.L(Ae,qe);return this.B(new Je.$Rcc(Xe?.urls,be,Ae,this.s,this.z,this.m)),Xe}J(Ie){const De=()=>({statusCode:404,data:"Not found"}),Ae=new Ot.$V(()=>Ie.getChannel(ht.$edc,new ht.$fdc));n.protocol.registerBufferProtocol(f.Schemas.vscodeManagedRemoteResource,(be,Ce)=>{const qe=c.URI.parse(be.url);if(!qe.authority.startsWith("window:"))return Ce(De());Ae.value.call(ht.$ddc,[qe]).then(He=>Ce({...He,data:Buffer.from(He.body,"base64")}),He=>{this.m.warn("error dispatching remote resource call",He),Ce({statusCode:500,data:String(He)})})})}async L(Ie,De){const Ae=this.s.args["open-url"]?this.s.args._urls||[]:[];Ae.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Ae);const be=global.getOpenUrls()||[];if(be.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",be),Ae.length+be.length===0)return;const Ce=[...Ae,...be].map(Ge=>{try{return{uri:c.URI.parse(Ge),originalUrl:Ge}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ge);return}}),qe=[],He=[];for(const Ge of Ce){if(!Ge)continue;const We=this.N(Ge.uri);if(We)if(await this.M(We,Ie,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ge.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ge.uri.toString(!0),We),qe.push(We);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ge.uri.toString(!0)),He.push(Ge)}return{urls:He,openables:qe}}async M(Ie,De,Ae){let be,Ce;if((0,de.$vD)(Ie)?(be=Ie.workspaceUri,Ce=(0,i.localize)(0,null,be.scheme===f.Schemas.file?(0,v.$ww)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(0,de.$wD)(Ie)?(be=Ie.folderUri,Ce=(0,i.localize)(1,null,be.scheme===f.Schemas.file?(0,v.$ww)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)):(be=Ie.fileUri,Ce=(0,i.localize)(2,null,be.scheme===f.Schemas.file?(0,v.$ww)(be,{os:p.OS,tildify:this.s}):be.toString(!0),this.z.nameShort)),be.scheme!==f.Schemas.file&&be.scheme!==f.Schemas.vscodeRemote||this.u.getValue(ft.a[be.scheme])===!1)return!1;const{response:He,checkboxChecked:Ge}=await Ae.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:be.scheme===f.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(He!==0)return!0;if(Ge){const We={channel:"vscode:disablePromptForProtocolHandling",args:be.scheme===f.Schemas.file?"local":"remote"};De.sendToFocused(We.channel,We.args),De.sendToOpeningWindow(We.channel,We.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===f.Schemas.file){const De=c.URI.file(Ie.fsPath);return(0,Me.$1i)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ie.authority===f.Schemas.vscodeRemote){const De=Ie.path.indexOf(y.$hc.sep,1);if(De!==-1){const Ae=Ie.path.substring(1,De),be=Ie.path.substring(De);let Ce=Ie.query;const qe=new URLSearchParams(Ie.query);qe.get("windowId")==="_blank"&&(qe.delete("windowId"),Ce=qe.toString());const He=c.URI.from({scheme:f.Schemas.vscodeRemote,authority:Ae,path:be,query:Ce,fragment:Ie.fragment});return(0,Me.$1i)(be)?{workspaceUri:He}:/:[\d]+$/.test(be)?{fileUri:He}:{folderUri:He}}}}}async O(Ie,De,Ae,be,Ce){this.m.trace("app#handleProtocolUrl():",be.toString(!0),Ce),be.scheme===this.z.urlProtocol&&be.path==="workspace"&&(be=be.with({authority:"file",path:c.URI.parse(be.query).path,query:""}));let qe=!1;const He=new URLSearchParams(be.query);He.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",be.toString(!0)),He.delete("windowId"),be=be.with({query:He.toString()}),qe=!0):p.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",be.toString(!0)),qe=!0);const Ge=He.get("continueOn");Ge!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",be.toString(!0)),He.delete("continueOn"),be=be.with({query:He.toString()}),this.s.continueOn=Ge??void 0);const We=this.N(be);return We?await this.M(We,Ie,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",be.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",We,be.toString(!0)),(0,mt.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[We],forceNewWindow:qe,gotoLineMode:!0}))?.focus(),!0):qe?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",be.toString(!0)),await(0,mt.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,H.$Gm)(be)}))?.ready(),Ae.open(be,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",be.toString(!0),Ce),!1)}P(Ie,De){const Ae=this.B(this.j.createInstance(se.$Ccc,Ie,De)),be=(async()=>{this.m.trace("Main->SharedProcess#connect");const qe=await Ae.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new r.$WW(qe,"main")})();return{sharedProcessReady:(async()=>(await Ae.whenReady(),be))(),sharedProcessClient:be}}async Q(Ie,De,Ae){const be=new G.$ti;switch(process.platform){case"win32":be.set(fe.$NX,new U.$si(Le.$Ncc));break;case"linux":p.$l?be.set(fe.$NX,new U.$si(Be.$Mcc,[process.env.SNAP,process.env.SNAP_REVISION])):be.set(fe.$NX,new U.$si(Re.$Lcc));break;case"darwin":be.set(fe.$NX,new U.$si(je.$Kcc));break}be.set(pe.$wbc,new U.$si(ve.$Ycc,[Ie,De,this.h],!1)),be.set($t.$hcc,new U.$si(Mt.$gdc,void 0,!1));const Ce=new O.$sbc(this.m,this.z);be.set(O.$rbc,Ce),be.set(N.$occ,new U.$si(N.$pcc,void 0,!1)),be.set(I.$6bc,new U.$si(I.$7bc,void 0,!1)),be.set(D.$cn,a.ProxyChannel.toService((0,a.$bi)(Ae.then(Ne=>Ne.getChannel("diagnostics"))))),be.set(le.$QJb,new U.$si(Y.$kcc,[this.h])),be.set(M.$xX,new U.$si(W.$8bc)),be.set(A.$lcc,new U.$si(A.$mcc)),be.set(V.$icc,new U.$si(V.$jcc,void 0,!1)),be.set(Te.$Scc,new U.$si(te.$Ucc)),be.set(J.$xcc,new U.$si(J.$ycc)),be.set(ue.$9bc,new U.$si(ee.$$bc)),be.set(ye.$Vbc,new U.$si(ye.$Wbc)),be.set(ye.$Xbc,new U.$si(ye.$Ybc));const qe=new At.$cdc({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),He=new Rt.$vs(qe,this.u,this.m,this.n);be.set(ut.$9r,He),p.$i?be.set(ce.$_bc,new U.$si(K.$acc)):p.$j?be.set(ce.$_bc,new U.$si(K.$bcc)):p.$k&&be.set(ce.$_bc,new U.$si(K.$ccc));const Ge=new u.$1bc(this.s,this.u,this.m,this.w);be.set(o.$qbc,Ge);const We=new Ye.$Jbc(this.s,this.m,this.C,Ge,Ce);if(be.set(Ye.$Ibc,We),be.set(ze.$agb,new U.$si(Ze.$1cc,void 0,!1)),be.set(Qe.$ucc,new U.$si(Qe.$vcc,void 0,!1)),be.set(Fe.$DX,new U.$si(Ve.$FX,void 0,!1)),(0,Z.$lp)(this.z,this.s)){const Ne=(0,Z.$qp)(this.z,this.u),xe=(0,a.$bi)(Ae.then(rt=>rt.getChannel("telemetryAppender"))),Xe=new Oe.$Fcc(xe),_e=(0,Pe.$cp)((0,R.release)(),(0,R.hostname)(),process.arch,this.z.commit,this.z.version,Ie,De,Ne),nt=(0,Z.$rp)(this.s),et={appenders:[Xe],commonProperties:_e,piiPaths:nt,sendErrorTelemetry:!0};be.set(ke.$1l,new U.$si(we.$Yr,[et],!1))}else be.set(ke.$1l,Z.$gp);return be.set(vt.$oq,new U.$si(jt.$IQ,void 0,!0)),be.set(Pt.$sq,new U.$si(kt.$4cc,void 0,!0)),be.set(lt.$adc,new U.$si(lt.$bdc,void 0,!0)),await ct.Promises.settled([Ge.initialize(),We.initialize()]),this.j.createChild(be)}R(Ie,De,Ae){const be=this.B(new m.$Uc),Ce=a.ProxyChannel.fromService(Ie.get(N.$occ),be,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const qe=a.ProxyChannel.fromService(Ie.get(I.$6bc),be,{disableMarshalling:!0});this.g.registerChannel("diagnostics",qe);const He=new st.$2cc(Ie.get(Ke.$do));De.registerChannel("policy",He),Ae.then(tt=>tt.registerChannel("policy",He));const Ge=this.y.getProvider(f.Schemas.file);(0,$.$fg)(Ge instanceof z.$$q);const We=new L.$dcc(Ge,this.m,this.s);De.registerChannel(Q.$rQ,We),Ae.then(tt=>tt.registerChannel(Q.$rQ,We));const Ne=a.ProxyChannel.fromService(Ie.get(it.$zbc),be);De.registerChannel("userDataProfiles",Ne),Ae.then(tt=>tt.registerChannel("userDataProfiles",Ne));const xe=new ot.$Tr(Ie.get(at.$Mp));Ae.then(tt=>tt.registerChannel("request",xe));const Xe=new ge.$Gcc(Ie.get(fe.$NX));De.registerChannel("update",Xe);const _e=a.ProxyChannel.fromService(Ie.get(le.$QJb),be);De.registerChannel("issue",_e);const nt=a.ProxyChannel.fromService(Ie.get(M.$xX),be);De.registerChannel("encryption",nt);const et=a.ProxyChannel.fromService(Ie.get(he.$Ol),be);De.registerChannel("sign",et);const rt=a.ProxyChannel.fromService(Ie.get(A.$lcc),be);De.registerChannel("keyboardLayout",rt),this.f=Ie.get(V.$icc);const pt=a.ProxyChannel.fromService(this.f,be);De.registerChannel("nativeHost",pt),Ae.then(tt=>tt.registerChannel("nativeHost",pt));const Lt=a.ProxyChannel.fromService(Ie.get(ze.$agb),be);De.registerChannel("workspaces",Lt);const Ft=a.ProxyChannel.fromService(Ie.get(J.$xcc),be);De.registerChannel("menubar",Ft);const Wt=a.ProxyChannel.fromService(Ie.get(Fe.$DX),be);De.registerChannel("url",Wt);const Nt=a.ProxyChannel.fromService(Ie.get(Te.$Scc),be);De.registerChannel("webview",Nt);const bt=this.B(new $e.$Dcc(this.m,Ie.get(ye.$Vbc)));De.registerChannel("storage",bt),Ae.then(tt=>tt.registerChannel("storage",bt));const Tt=this.B(new St.$6cc(Ie.get(ye.$Vbc),Ie.get(it.$zbc),this.m));Ae.then(tt=>tt.registerChannel("profileStorageListener",Tt));const zt=a.ProxyChannel.fromService(Ie.get(ut.$9r),be);De.registerChannel(ut.TerminalIpcChannels.LocalPty,zt);const Bt=a.ProxyChannel.fromService(Ie.get(ce.$_bc),be);De.registerChannel("externalTerminal",Bt);const yt=new It.$$cc(Ie.get(Dt.$Kbc));De.registerChannel("logger",yt),Ae.then(tt=>tt.registerChannel("logger",yt));const qt=new S.$2bc(Ie.get(pe.$wbc));De.registerChannel("extensionhostdebugservice",qt);const Ut=a.ProxyChannel.fromService(Ie.get(ue.$9bc),be);De.registerChannel(ue.$0bc,Ut);const Ht=a.ProxyChannel.fromService(Ie.get(lt.$adc),be);De.registerChannel(Ct.$_cc,Ht)}async S(Ie,De){const Ae=this.b=Ie.get(pe.$wbc);this.c=Ie.get($t.$hcc);const be=(0,T.$zm)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Ae.open({context:be,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const et of De.urls){const rt=new URLSearchParams(et.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),et.originalUrl=et.uri.toString(!0),et.uri=et.uri.with({query:rt.toString()}),Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const qe=global.macOpenFiles,He=Ce._.length,Ge=!!Ce["folder-uri"],We=!!Ce["file-uri"],Ne=Ce["skip-add-to-recently-opened"]===!0,xe=Ce.wait&&Ce.waitMarkerFilePath?c.URI.file(Ce.waitMarkerFilePath):void 0,Xe=Ce.remote||void 0,_e=Ce.profile,nt=Ce["profile-temp"];if(!He&&!Ge&&!We){if(Ce["new-window"]||_e||nt)return Ae.open({context:be,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:nt});if(qe.length)return Ae.open({context:1,cli:Ce,urisToOpen:qe.map(et=>(et=(0,wt.$am)(et),(0,Me.$1i)(et)?{workspaceUri:c.URI.file(et)}:{fileUri:c.URI.file(et)})),noRecentEntry:Ne,waitMarkerFileURI:xe,initialStartup:!0})}return Ae.open({context:be,cli:Ce,forceNewWindow:Ce["new-window"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ne,waitMarkerFileURI:xe,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:nt})}U(){this.W(),n.protocol.registerHttpProtocol(f.Schemas.vscodeRemoteResource,(Ie,De)=>{De({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),p.$j&&n.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(p.$i&&Ie)try{const De=await new Promise((be,Ce)=>{X(["@vscode/windows-mutex"],be,Ce)}),Ae=new De.Mutex(Ie);d.Event.once(this.t.onWillShutdown)(()=>Ae.release())}catch(De){this.m.error(De)}}async X(Ie,De,Ae){try{return await(0,q.$Fm)(this.u,this.m,Ie,De)}catch(be){const Ce=(0,k.$gj)(be);Ae?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Ae=JSON.parse((0,b.$Qn)(De)),Ce=(0,Z.$np)(this.u)>=1;if(Ae["enable-crash-reporter"]===void 0){const qe=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,w.$Rg)()}"`,"}"],He=De.substring(0,De.length-2).concat(`,
`,qe.join(`
`));await this.y.writeFile(this.s.argvResource,j.$Fe.fromString(He))}else{const qe=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);qe!==De&&await this.y.writeFile(this.s.argvResource,j.$Fe.fromString(qe))}}catch(Ie){this.m.error(Ie)}}};e.$hdc=dt,e.$hdc=dt=ft=Ee([ie(2,ae.$ui),ie(3,ne.$2j),ie(4,ne.$3j),ie(5,F.$lbc),ie(6,_.$Pbc),ie(7,g.$2i),ie(8,me.$BQ),ie(9,B.$2k),ie(10,x.$ik),ie(11,it.$zbc)],dt)}),define(re[317],oe([0,1,14,43,7,22,8,47,15,31,3,48,13,9,66,4,36,25,21,44,100,312,10,18,242,254,24,64,205,16,226,94,78,222,93,20,229,5,80,27,81,282,130,291,53,290,96,253,34,54,69,57,39,238,236,2,40,270,67,231,119,125,274,102,268]),function(X,e,n,C,E,R,j,k,h,l,d,b,v,m,f,y,p,$,c,w,P,a,t,r,s,i,o,u,g,S,D,I,O,M,W,F,T,q,ue,ee,ce,K,Q,B,L,z,U,ae,G,le,Y,A,N,_,ne,J,V,x,H,se,he,me,$e,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Pe{main(){try{this.a()}catch(we){console.error(we.message),n.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Fe=>console.error(Fe));const[we,Z,fe,ge,je,Re,Be,Le]=this.b();try{try{await this.d(fe,Le,ge,je,Be)}catch(Fe){throw this.g(fe,Be,Fe),Fe}await we.invokeFunction(async Fe=>{const Ue=Fe.get(q.$2j),Ve=Fe.get(F.$Pbc),Je=Fe.get(S.$2k),Te=Fe.get(q.$3j),te=await this.f(Ue,fe,Ve,we,Be,!0);return c.Promises.writeFile(fe.mainLockfile,String(process.pid)).catch(de=>{Ue.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Re.logger=Te.createLogger("main",{name:(0,t.localize)(0,null)}),d.Event.once(Ve.onWillShutdown)(de=>{Je.dispose(),ge.dispose(),de.join("instanceLockfile",c.Promises.unlink(fe.mainLockfile).catch(()=>{}))}),we.createInstance(a.$hdc,te,Z).startup()})}catch(Fe){we.invokeFunction(this.j,Fe)}}b(){const we=new W.$ti,Z=new J.$Uc;process.once("exit",()=>Z.dispose());const fe={_serviceBrand:void 0,...ue.default};we.set(ee.$ik,fe);const ge=new o.$mbc(this.k(),fe),je=this.c(ge);we.set(o.$lbc,ge);const Re=new H.$Lbc((0,q.$dk)(ge),ge.logsHome);we.set(H.$Kbc,Re);const Be=new T.$4$b(Re.getLogLevel()),Le=Z.add(new se.$JQ(Be,[new q.$9j(Re.getLogLevel())]));we.set(q.$2j,Le);const Fe=new D.$Hq(Le);we.set(S.$2k,Fe);const Ue=new I.$$q(Le);Fe.registerProvider(v.Schemas.file,Ue);const Ve=new x.$zs(Fe);we.set(V.$zl,Ve);const Je=new me.$EQ(1,ge,Le,Fe);we.set(G.$AQ,Je),we.set(G.$BQ,Je);const Te=new A.$Abc(Je,Ve,ge,Fe,Le);we.set(A.$zbc,Te),Fe.registerProvider(v.Schemas.vscodeUserData,new $e.$sdc(v.Schemas.file,Ue,v.Schemas.vscodeUserData,Te,Ve,Le));const te=y.$i&&fe.win32RegValueName?Z.add(new _.$qdc(Le,fe.win32RegValueName)):ge.policyFile?Z.add(new ne.$rdc(ge.policyFile,Fe,Le)):new N.$fo;we.set(N.$do,te);const de=new s.$Fo(Te.defaultProfile.settingsResource,Fe,te,Le);return we.set(r.$2i,de),we.set(F.$Pbc,new O.$si(F.$Qbc,void 0,!1)),we.set(L.$Mp,new O.$si(z.$odc,void 0,!0)),we.set(Y.$ubc,new O.$si(Y.$vbc)),we.set(U.$Ol,new O.$si(ae.$pdc,void 0,!1)),we.set(Q.$bw,new O.$si(B.$mdc)),we.set(ce.$tbc,new K.$jdc(ge,Te,Le)),[new M.$br(we,!0),je,ge,de,Je,Be,fe,Te]}c(we){const Z={VSCODE_IPC_HOOK:we.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(fe=>{const ge=process.env[fe];typeof ge=="string"&&(Z[fe]=ge)}),Object.assign(process.env,Z),Z}async d(we,Z,fe,ge,je){await j.Promises.settled([Promise.all([this.e(we.extensionsPath),we.codeCachePath,we.logsHome.with({scheme:v.Schemas.file}).fsPath,Z.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,we.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,we.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,we.backupHome].map(Re=>Re?c.Promises.mkdir(Re,{recursive:!0}):void 0)),ge.init(),fe.initialize()]),Z.init()}e(we){if(y.$i){const Z=(0,ye.getUNCHost)(we);Z&&(0,ye.addUNCHostToAllowlist)(Z)}return we}async f(we,Z,fe,ge,je,Re){let Be;try{(0,f.mark)("code/willStartMainServer"),Be=await(0,P.$qi)(Z.mainIPCHandle),(0,f.mark)("code/didStartMainServer"),d.Event.once(fe.onWillShutdown)(()=>Be.dispose())}catch(Le){if(Le.code!=="EADDRINUSE")throw this.g(Z,je,Le),Le;let Fe;try{Fe=await(0,P.$ri)(Z.mainIPCHandle,"main")}catch(Te){if(!Re||y.$i||Te.code!=="ECONNREFUSED")throw Te.code==="EPERM"&&this.h((0,t.localize)(1,null,je.nameShort),(0,t.localize)(2,null),je),Te;try{(0,C.unlinkSync)(Z.mainIPCHandle)}catch(te){throw we.warn("Could not delete obsolete instance handle",te),te}return this.f(we,Z,fe,ge,je,!1)}if(Z.extensionTestsLocationURI&&!Z.debugExtensionHost.break){const Te=`Running extension tests from the command line is currently only supported if no other instance of ${je.nameShort} is running.`;throw we.error(Te),Fe.dispose(),new Error(Te)}let Ue;!Z.args.wait&&!Z.args.status&&(Ue=setTimeout(()=>{this.h((0,t.localize)(3,null,je.nameShort),(0,t.localize)(4,null),je)},1e4));const Ve=w.ProxyChannel.toService(Fe.getChannel("launch"),{disableMarshalling:!0}),Je=w.ProxyChannel.toService(Fe.getChannel("diagnostics"),{disableMarshalling:!0});if(Z.args.status)return ge.invokeFunction(async()=>{const Te=new i.$Gs(le.$gp,je),te=await Je.getMainDiagnostics(),de=await Je.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),pe=await Te.getDiagnostics(te,de);throw console.log(pe),new h.$ab});throw y.$i&&await this.i(Ve,we),we.trace("Sending env to running instance..."),await Ve.start(Z.args,process.env),Fe.dispose(),Ue&&clearTimeout(Ue),new h.$ab("Sent env to running instance. Terminating...")}if(Z.args.status)throw console.log((0,t.localize)(5,null,je.nameShort)),new h.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),Be}g(we,Z,fe){if(fe.code==="EACCES"||fe.code==="EPERM"){const ge=(0,R.$Hb)([we.userDataPath,we.extensionsPath,P.$mi]).map(je=>(0,b.$ww)(E.URI.file(je),{os:y.OS,tildify:we}));this.h((0,t.localize)(6,null),(0,t.localize)(7,null,(0,k.$gj)(fe),ge.join(`
`)),Z)}}h(we,Z,fe){n.dialog.showMessageBoxSync((0,he.$Kw)({type:"warning",buttons:[(0,t.localize)(8,null)],message:we,detail:Z},fe).options)}async i(we,Z){if(y.$i){const fe=await we.getMainProcessId();Z.trace("Sending some foreground love to the running instance:",fe);try{(await new Promise((ge,je)=>{X(["windows-foreground-love"],ge,je)})).allowSetForegroundWindow(fe)}catch(ge){Z.error(ge)}}}j(we,Z){const fe=we.get(q.$2j),ge=we.get(F.$Pbc);let je=0;Z&&(Z.isExpected?Z.message&&fe.trace(Z.message):(je=1,Z.stack?fe.error(Z.stack):fe.error(`Startup error: ${Z.toString()}`))),ge.kill(je)}k(){const we=this.l((0,u.$wm)(process.argv));if(we.wait&&!we.waitMarkerFilePath){const Z=(0,g.$idc)(we.verbose);Z&&((0,u.$ym)(process.argv,"--waitMarkerFilePath",Z),we.waitMarkerFilePath=Z)}return we}l(we){if(we["open-url"]&&(we._urls=we._,we._=[]),!we.remote){const Z=this.m(we._,we.goto);we._=Z}return we}m(we,Z){const fe=(0,p.cwd)(),ge=we.map(Be=>{let Le=String(Be),Fe;Z&&(Fe=(0,l.$Cg)(Le),Le=Fe.path),Le&&(Le=this.n(fe,Le));const Ue=(0,l.$wg)(Le,fe),Ve=(0,m.$oc)(Ue);return Ve&&!(0,l.$sg)(Ve)?null:Z&&Fe?(Fe.path=Ue,this.o(Fe)):Ue}),je=y.$i||y.$j,Re=(0,R.$Mb)(ge,Be=>Be&&je?Be.toLowerCase():Be||"");return(0,R.$Hb)(Re)}n(we,Z){return y.$i&&(Z=(0,$.$ff)(Z,'"')),Z=(0,$.$df)((0,$.$df)(Z," "),"	"),y.$i&&(Z=(0,m.$lc)(we,Z),Z=(0,$.$ff)(Z,".")),Z}o(we){const Z=[we.path];return typeof we.line=="number"&&Z.push(String(we.line)),typeof we.column=="number"&&Z.push(String(we.column)),Z.join(":")}}new Pe().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/063d715c4504380317f9ca8eefc602d71e56adb5/core/vs/code/electron-main/main.js.map
