/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/arrays","vs/base/common/strings","vs/base/common/types","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/nls","vs/base/browser/ui/hover/hoverDelegateFactory","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/browser/browser","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/mouseEvent","vs/base/browser/ui/widget","vs/base/browser/window","vs/base/common/lazy","vs/base/browser/event","vs/base/common/path","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/browser/touch","vs/base/browser/ui/hover/hoverDelegate2","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/observableInternal/base","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/network","vs/base/common/assert","vs/base/common/equals","vs/base/common/map","vs/base/common/numbers","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/buffer","vs/base/common/filters","vs/base/common/codiconsUtil","vs/base/common/actions","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/linkedList","vs/base/common/range","vs/base/common/observable","vs/base/common/scrollable","vs/base/common/hash","vs/base/common/symbols","vs/base/common/objects","vs/base/common/iconLabels","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/observableInternal/promise","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/common/codiconsLibrary","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/browser/canIUse","vs/base/common/process","vs/base/common/extpath","vs/base/common/mime","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/common/htmlContent","vs/base/browser/markdownRenderer","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/common/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(se){for(var t=[],n=0,C=se.length;n<C;n++)t[n]=me[se[n]];return t};/*! @license DOMPurify 3.0.5 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/3.0.5/LICENSE */const{entries:Bt,setPrototypeOf:xt,isFrozen:ii,getPrototypeOf:ni,getOwnPropertyDescriptor:si}=Object;let{freeze:ot,seal:ft,create:ri}=Object,{apply:Ft,construct:Nt}=typeof Reflect<"u"&&Reflect;Ft||(Ft=function(t,n,C){return t.apply(n,C)}),ot||(ot=function(t){return t}),ft||(ft=function(t){return t}),Nt||(Nt=function(t,n){return new t(...n)});const oi=ct(Array.prototype.forEach),zt=ct(Array.prototype.pop),wt=ct(Array.prototype.push),Dt=ct(String.prototype.toLowerCase),Rt=ct(String.prototype.toString),ai=ct(String.prototype.match),dt=ct(String.prototype.replace),li=ct(String.prototype.indexOf),hi=ct(String.prototype.trim),ht=ct(RegExp.prototype.test),vt=ui(TypeError);function ct(se){return function(t){for(var n=arguments.length,C=new Array(n>1?n-1:0),B=1;B<n;B++)C[B-1]=arguments[B];return Ft(se,t,C)}}function ui(se){return function(){for(var t=arguments.length,n=new Array(t),C=0;C<t;C++)n[C]=arguments[C];return Nt(se,n)}}function He(se,t,n){var C;n=(C=n)!==null&&C!==void 0?C:Dt,xt&&xt(se,null);let B=t.length;for(;B--;){let H=t[B];if(typeof H=="string"){const A=n(H);A!==H&&(ii(t)||(t[B]=A),H=A)}se[H]=!0}return se}function bt(se){const t=ri(null);for(const[n,C]of Bt(se))t[n]=C;return t}function Et(se,t){for(;se!==null;){const C=si(se,t);if(C){if(C.get)return ct(C.get);if(typeof C.value=="function")return ct(C.value)}se=ni(se)}function n(C){return console.warn("fallback value for",C),null}return n}const Ht=ot(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),Lt=ot(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),It=ot(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feDropShadow","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feImage","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),ci=ot(["animate","color-profile","cursor","discard","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ot=ot(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover","mprescripts"]),fi=ot(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Wt=ot(["#text"]),Vt=ot(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","nonce","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),jt=ot(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","transform-origin","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),qt=ot(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),St=ot(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),di=ft(/\{\{[\w\W]*|[\w\W]*\}\}/gm),gi=ft(/<%[\w\W]*|[\w\W]*%>/gm),mi=ft(/\${[\w\W]*}/gm),bi=ft(/^data-[\-\w.\u00B7-\uFFFF]/),$i=ft(/^aria-[\-\w]+$/),Kt=ft(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|sms|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),pi=ft(/^(?:\w+script|data):/i),wi=ft(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),Gt=ft(/^html$/i);var Yt=Object.freeze({__proto__:null,MUSTACHE_EXPR:di,ERB_EXPR:gi,TMPLIT_EXPR:mi,DATA_ATTR:bi,ARIA_ATTR:$i,IS_ALLOWED_URI:Kt,IS_SCRIPT_OR_DATA:pi,ATTR_WHITESPACE:wi,DOCTYPE_NAME:Gt});const vi=()=>typeof window>"u"?null:window,yi=function(t,n){if(typeof t!="object"||typeof t.createPolicy!="function")return null;let C=null;const B="data-tt-policy-suffix";n&&n.hasAttribute(B)&&(C=n.getAttribute(B));const H="dompurify"+(C?"#"+C:"");try{return t.createPolicy(H,{createHTML(A){return A},createScriptURL(A){return A}})}catch{return console.warn("TrustedTypes policy "+H+" could not be created."),null}};function Ut(){let se=arguments.length>0&&arguments[0]!==void 0?arguments[0]:vi();const t=Be=>Ut(Be);if(t.version="3.0.5",t.removed=[],!se||!se.document||se.document.nodeType!==9)return t.isSupported=!1,t;const n=se.document,C=n.currentScript;let{document:B}=se;const{DocumentFragment:H,HTMLTemplateElement:A,Node:P,Element:d,NodeFilter:g,NamedNodeMap:w=se.NamedNodeMap||se.MozNamedAttrMap,HTMLFormElement:M,DOMParser:c,trustedTypes:h}=se,e=d.prototype,i=Et(e,"cloneNode"),o=Et(e,"nextSibling"),l=Et(e,"childNodes"),f=Et(e,"parentNode");if(typeof A=="function"){const Be=B.createElement("template");Be.content&&Be.content.ownerDocument&&(B=Be.content.ownerDocument)}let S,m="";const{implementation:b,createNodeIterator:r,createDocumentFragment:D,getElementsByTagName:k}=B,{importNode:T}=n;let L={};t.isSupported=typeof Bt=="function"&&typeof f=="function"&&b&&b.createHTMLDocument!==void 0;const{MUSTACHE_EXPR:q,ERB_EXPR:$,TMPLIT_EXPR:I,DATA_ATTR:V,ARIA_ATTR:N,IS_SCRIPT_OR_DATA:x,ATTR_WHITESPACE:j}=Yt;let{IS_ALLOWED_URI:Y}=Yt,K=null;const ae=He({},[...Ht,...Lt,...It,...Ot,...Wt]);let ie=null;const ee=He({},[...Vt,...jt,...qt,...St]);let ce=Object.seal(Object.create(null,{tagNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},attributeNameCheck:{writable:!0,configurable:!1,enumerable:!0,value:null},allowCustomizedBuiltInElements:{writable:!0,configurable:!1,enumerable:!0,value:!1}})),De=null,Ee=null,Le=!0,le=!0,_=!1,ue=!0,re=!1,ye=!1,W=!1,Q=!1,ge=!1,we=!1,ke=!1,Te=!0,Ie=!1;const z="user-content-";let u=!0,y=!1,a={},v=null;const F=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]);let s=null;const E=He({},["audio","video","img","source","image","track"]);let p=null;const R=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),O="http://www.w3.org/1998/Math/MathML",U="http://www.w3.org/2000/svg",Z="http://www.w3.org/1999/xhtml";let oe=Z,pe=!1,fe=null;const Re=He({},[O,U,Z],Rt);let Pe;const je=["application/xhtml+xml","text/html"],Se="text/html";let Ce,We=null;const Xe=B.createElement("form"),Ue=function(he){return he instanceof RegExp||he instanceof Function},_e=function(he){if(!(We&&We===he)){if((!he||typeof he!="object")&&(he={}),he=bt(he),Pe=je.indexOf(he.PARSER_MEDIA_TYPE)===-1?Pe=Se:Pe=he.PARSER_MEDIA_TYPE,Ce=Pe==="application/xhtml+xml"?Rt:Dt,K="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS,Ce):ae,ie="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR,Ce):ee,fe="ALLOWED_NAMESPACES"in he?He({},he.ALLOWED_NAMESPACES,Rt):Re,p="ADD_URI_SAFE_ATTR"in he?He(bt(R),he.ADD_URI_SAFE_ATTR,Ce):R,s="ADD_DATA_URI_TAGS"in he?He(bt(E),he.ADD_DATA_URI_TAGS,Ce):E,v="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS,Ce):F,De="FORBID_TAGS"in he?He({},he.FORBID_TAGS,Ce):{},Ee="FORBID_ATTR"in he?He({},he.FORBID_ATTR,Ce):{},a="USE_PROFILES"in he?he.USE_PROFILES:!1,Le=he.ALLOW_ARIA_ATTR!==!1,le=he.ALLOW_DATA_ATTR!==!1,_=he.ALLOW_UNKNOWN_PROTOCOLS||!1,ue=he.ALLOW_SELF_CLOSE_IN_ATTR!==!1,re=he.SAFE_FOR_TEMPLATES||!1,ye=he.WHOLE_DOCUMENT||!1,ge=he.RETURN_DOM||!1,we=he.RETURN_DOM_FRAGMENT||!1,ke=he.RETURN_TRUSTED_TYPE||!1,Q=he.FORCE_BODY||!1,Te=he.SANITIZE_DOM!==!1,Ie=he.SANITIZE_NAMED_PROPS||!1,u=he.KEEP_CONTENT!==!1,y=he.IN_PLACE||!1,Y=he.ALLOWED_URI_REGEXP||Kt,oe=he.NAMESPACE||Z,ce=he.CUSTOM_ELEMENT_HANDLING||{},he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.tagNameCheck)&&(ce.tagNameCheck=he.CUSTOM_ELEMENT_HANDLING.tagNameCheck),he.CUSTOM_ELEMENT_HANDLING&&Ue(he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck)&&(ce.attributeNameCheck=he.CUSTOM_ELEMENT_HANDLING.attributeNameCheck),he.CUSTOM_ELEMENT_HANDLING&&typeof he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements=="boolean"&&(ce.allowCustomizedBuiltInElements=he.CUSTOM_ELEMENT_HANDLING.allowCustomizedBuiltInElements),re&&(le=!1),we&&(ge=!0),a&&(K=He({},[...Wt]),ie=[],a.html===!0&&(He(K,Ht),He(ie,Vt)),a.svg===!0&&(He(K,Lt),He(ie,jt),He(ie,St)),a.svgFilters===!0&&(He(K,It),He(ie,jt),He(ie,St)),a.mathMl===!0&&(He(K,Ot),He(ie,qt),He(ie,St))),he.ADD_TAGS&&(K===ae&&(K=bt(K)),He(K,he.ADD_TAGS,Ce)),he.ADD_ATTR&&(ie===ee&&(ie=bt(ie)),He(ie,he.ADD_ATTR,Ce)),he.ADD_URI_SAFE_ATTR&&He(p,he.ADD_URI_SAFE_ATTR,Ce),he.FORBID_CONTENTS&&(v===F&&(v=bt(v)),He(v,he.FORBID_CONTENTS,Ce)),u&&(K["#text"]=!0),ye&&He(K,["html","head","body"]),K.table&&(He(K,["tbody"]),delete De.tbody),he.TRUSTED_TYPES_POLICY){if(typeof he.TRUSTED_TYPES_POLICY.createHTML!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createHTML" hook.');if(typeof he.TRUSTED_TYPES_POLICY.createScriptURL!="function")throw vt('TRUSTED_TYPES_POLICY configuration option must provide a "createScriptURL" hook.');S=he.TRUSTED_TYPES_POLICY,m=S.createHTML("")}else S===void 0&&(S=yi(h,C)),S!==null&&typeof m=="string"&&(m=S.createHTML(""));ot&&ot(he),We=he}},J=He({},["mi","mo","mn","ms","mtext"]),ne=He({},["foreignobject","desc","title","annotation-xml"]),$e=He({},["title","style","font","a","script"]),ve=He({},Lt);He(ve,It),He(ve,ci);const Ne=He({},Ot);He(Ne,fi);const ze=function(he){let Fe=f(he);(!Fe||!Fe.tagName)&&(Fe={namespaceURI:oe,tagName:"template"});const Oe=Dt(he.tagName),Ge=Dt(Fe.tagName);return fe[he.namespaceURI]?he.namespaceURI===U?Fe.namespaceURI===Z?Oe==="svg":Fe.namespaceURI===O?Oe==="svg"&&(Ge==="annotation-xml"||J[Ge]):!!ve[Oe]:he.namespaceURI===O?Fe.namespaceURI===Z?Oe==="math":Fe.namespaceURI===U?Oe==="math"&&ne[Ge]:!!Ne[Oe]:he.namespaceURI===Z?Fe.namespaceURI===U&&!ne[Ge]||Fe.namespaceURI===O&&!J[Ge]?!1:!Ne[Oe]&&($e[Oe]||!ve[Oe]):!!(Pe==="application/xhtml+xml"&&fe[he.namespaceURI]):!1},Ve=function(he){wt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{he.remove()}},et=function(he,Fe){try{wt(t.removed,{attribute:Fe.getAttributeNode(he),from:Fe})}catch{wt(t.removed,{attribute:null,from:Fe})}if(Fe.removeAttribute(he),he==="is"&&!ie[he])if(ge||we)try{Ve(Fe)}catch{}else try{Fe.setAttribute(he,"")}catch{}},it=function(he){let Fe,Oe;if(Q)he="<remove></remove>"+he;else{const lt=ai(he,/^[\r\n\t ]+/);Oe=lt&&lt[0]}Pe==="application/xhtml+xml"&&oe===Z&&(he='<html xmlns="http://www.w3.org/1999/xhtml"><head></head><body>'+he+"</body></html>");const Ge=S?S.createHTML(he):he;if(oe===Z)try{Fe=new c().parseFromString(Ge,Pe)}catch{}if(!Fe||!Fe.documentElement){Fe=b.createDocument(oe,"template",null);try{Fe.documentElement.innerHTML=pe?m:Ge}catch{}}const nt=Fe.body||Fe.documentElement;return he&&Oe&&nt.insertBefore(B.createTextNode(Oe),nt.childNodes[0]||null),oe===Z?k.call(Fe,ye?"html":"body")[0]:ye?Fe.documentElement:nt},st=function(he){return r.call(he.ownerDocument||he,he,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Qe=function(he){return he instanceof M&&(typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof w)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"||typeof he.hasChildNodes!="function")},rt=function(he){return typeof P=="object"?he instanceof P:he&&typeof he=="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},tt=function(he,Fe,Oe){L[he]&&oi(L[he],Ge=>{Ge.call(t,Fe,Oe,We)})},mt=function(he){let Fe;if(tt("beforeSanitizeElements",he,null),Qe(he))return Ve(he),!0;const Oe=Ce(he.nodeName);if(tt("uponSanitizeElement",he,{tagName:Oe,allowedTags:K}),he.hasChildNodes()&&!rt(he.firstElementChild)&&(!rt(he.content)||!rt(he.content.firstElementChild))&&ht(/<[/\w]/g,he.innerHTML)&&ht(/<[/\w]/g,he.textContent))return Ve(he),!0;if(!K[Oe]||De[Oe]){if(!De[Oe]&&At(Oe)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,Oe)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Oe)))return!1;if(u&&!v[Oe]){const Ge=f(he)||he.parentNode,nt=l(he)||he.childNodes;if(nt&&Ge){const lt=nt.length;for(let Je=lt-1;Je>=0;--Je)Ge.insertBefore(i(nt[Je],!0),o(he))}}return Ve(he),!0}return he instanceof d&&!ze(he)||(Oe==="noscript"||Oe==="noembed"||Oe==="noframes")&&ht(/<\/no(script|embed|frames)/i,he.innerHTML)?(Ve(he),!0):(re&&he.nodeType===3&&(Fe=he.textContent,Fe=dt(Fe,q," "),Fe=dt(Fe,$," "),Fe=dt(Fe,I," "),he.textContent!==Fe&&(wt(t.removed,{element:he.cloneNode()}),he.textContent=Fe)),tt("afterSanitizeElements",he,null),!1)},gt=function(he,Fe,Oe){if(Te&&(Fe==="id"||Fe==="name")&&(Oe in B||Oe in Xe))return!1;if(!(le&&!Ee[Fe]&&ht(V,Fe))){if(!(Le&&ht(N,Fe))){if(!ie[Fe]||Ee[Fe]){if(!(At(he)&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,he)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(he))&&(ce.attributeNameCheck instanceof RegExp&&ht(ce.attributeNameCheck,Fe)||ce.attributeNameCheck instanceof Function&&ce.attributeNameCheck(Fe))||Fe==="is"&&ce.allowCustomizedBuiltInElements&&(ce.tagNameCheck instanceof RegExp&&ht(ce.tagNameCheck,Oe)||ce.tagNameCheck instanceof Function&&ce.tagNameCheck(Oe))))return!1}else if(!p[Fe]){if(!ht(Y,dt(Oe,j,""))){if(!((Fe==="src"||Fe==="xlink:href"||Fe==="href")&&he!=="script"&&li(Oe,"data:")===0&&s[he])){if(!(_&&!ht(x,dt(Oe,j,"")))){if(Oe)return!1}}}}}}return!0},At=function(he){return he.indexOf("-")>0},kt=function(he){let Fe,Oe,Ge,nt;tt("beforeSanitizeAttributes",he,null);const{attributes:lt}=he;if(!lt)return;const Je={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ie};for(nt=lt.length;nt--;){Fe=lt[nt];const{name:ut,namespaceURI:$t}=Fe;if(Oe=ut==="value"?Fe.value:hi(Fe.value),Ge=Ce(ut),Je.attrName=Ge,Je.attrValue=Oe,Je.keepAttr=!0,Je.forceKeepAttr=void 0,tt("uponSanitizeAttribute",he,Je),Oe=Je.attrValue,Je.forceKeepAttr||(et(ut,he),!Je.keepAttr))continue;if(!ue&&ht(/\/>/i,Oe)){et(ut,he);continue}re&&(Oe=dt(Oe,q," "),Oe=dt(Oe,$," "),Oe=dt(Oe,I," "));const Tt=Ce(he.nodeName);if(gt(Tt,Ge,Oe)){if(Ie&&(Ge==="id"||Ge==="name")&&(et(ut,he),Oe=z+Oe),S&&typeof h=="object"&&typeof h.getAttributeType=="function"&&!$t)switch(h.getAttributeType(Tt,Ge)){case"TrustedHTML":{Oe=S.createHTML(Oe);break}case"TrustedScriptURL":{Oe=S.createScriptURL(Oe);break}}try{$t?he.setAttributeNS($t,ut,Oe):he.setAttribute(ut,Oe),zt(t.removed)}catch{}}}tt("afterSanitizeAttributes",he,null)},Pt=function Be(he){let Fe;const Oe=st(he);for(tt("beforeSanitizeShadowDOM",he,null);Fe=Oe.nextNode();)tt("uponSanitizeShadowNode",Fe,null),!mt(Fe)&&(Fe.content instanceof H&&Be(Fe.content),kt(Fe));tt("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Be){let he=arguments.length>1&&arguments[1]!==void 0?arguments[1]:{},Fe,Oe,Ge,nt;if(pe=!Be,pe&&(Be="<!-->"),typeof Be!="string"&&!rt(Be))if(typeof Be.toString=="function"){if(Be=Be.toString(),typeof Be!="string")throw vt("dirty is not a string, aborting")}else throw vt("toString is not a function");if(!t.isSupported)return Be;if(W||_e(he),t.removed=[],typeof Be=="string"&&(y=!1),y){if(Be.nodeName){const ut=Ce(Be.nodeName);if(!K[ut]||De[ut])throw vt("root node is forbidden and cannot be sanitized in-place")}}else if(Be instanceof P)Fe=it("<!---->"),Oe=Fe.ownerDocument.importNode(Be,!0),Oe.nodeType===1&&Oe.nodeName==="BODY"||Oe.nodeName==="HTML"?Fe=Oe:Fe.appendChild(Oe);else{if(!ge&&!re&&!ye&&Be.indexOf("<")===-1)return S&&ke?S.createHTML(Be):Be;if(Fe=it(Be),!Fe)return ge?null:ke?m:""}Fe&&Q&&Ve(Fe.firstChild);const lt=st(y?Be:Fe);for(;Ge=lt.nextNode();)mt(Ge)||(Ge.content instanceof H&&Pt(Ge.content),kt(Ge));if(y)return Be;if(ge){if(we)for(nt=D.call(Fe.ownerDocument);Fe.firstChild;)nt.appendChild(Fe.firstChild);else nt=Fe;return(ie.shadowroot||ie.shadowrootmode)&&(nt=T.call(n,nt,!0)),nt}let Je=ye?Fe.outerHTML:Fe.innerHTML;return ye&&K["!doctype"]&&Fe.ownerDocument&&Fe.ownerDocument.doctype&&Fe.ownerDocument.doctype.name&&ht(Gt,Fe.ownerDocument.doctype.name)&&(Je="<!DOCTYPE "+Fe.ownerDocument.doctype.name+`>
`+Je),re&&(Je=dt(Je,q," "),Je=dt(Je,$," "),Je=dt(Je,I," ")),S&&ke?S.createHTML(Je):Je},t.setConfig=function(Be){_e(Be),W=!0},t.clearConfig=function(){We=null,W=!1},t.isValidAttribute=function(Be,he,Fe){We||_e({});const Oe=Ce(Be),Ge=Ce(he);return gt(Oe,Ge,Fe)},t.addHook=function(Be,he){typeof he=="function"&&(L[Be]=L[Be]||[],wt(L[Be],he))},t.removeHook=function(Be){if(L[Be])return zt(L[Be])},t.removeHooks=function(Be){L[Be]&&(L[Be]=[])},t.removeAllHooks=function(){L={}},t}var Di=Ut();define("vs/base/browser/dompurify/dompurify",function(){return Di}),define(me[51],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mT=void 0,t.$nT=B;class n{constructor(A){this.domNode=A,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(A){const P=C(A);this.a!==P&&(this.a=P,this.domNode.style.maxWidth=this.a)}setWidth(A){const P=C(A);this.b!==P&&(this.b=P,this.domNode.style.width=this.b)}setHeight(A){const P=C(A);this.c!==P&&(this.c=P,this.domNode.style.height=this.c)}setTop(A){const P=C(A);this.d!==P&&(this.d=P,this.domNode.style.top=this.d)}setLeft(A){const P=C(A);this.e!==P&&(this.e=P,this.domNode.style.left=this.e)}setBottom(A){const P=C(A);this.f!==P&&(this.f=P,this.domNode.style.bottom=this.f)}setRight(A){const P=C(A);this.g!==P&&(this.g=P,this.domNode.style.right=this.g)}setPaddingTop(A){const P=C(A);this.h!==P&&(this.h=P,this.domNode.style.paddingTop=this.h)}setPaddingLeft(A){const P=C(A);this.i!==P&&(this.i=P,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(A){const P=C(A);this.j!==P&&(this.j=P,this.domNode.style.paddingBottom=this.j)}setPaddingRight(A){const P=C(A);this.k!==P&&(this.k=P,this.domNode.style.paddingRight=this.k)}setFontFamily(A){this.l!==A&&(this.l=A,this.domNode.style.fontFamily=this.l)}setFontWeight(A){this.m!==A&&(this.m=A,this.domNode.style.fontWeight=this.m)}setFontSize(A){const P=C(A);this.n!==P&&(this.n=P,this.domNode.style.fontSize=this.n)}setFontStyle(A){this.o!==A&&(this.o=A,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(A){this.p!==A&&(this.p=A,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(A){this.q!==A&&(this.q=A,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(A){this.r!==A&&(this.r=A,this.domNode.style.textDecoration=this.r)}setLineHeight(A){const P=C(A);this.s!==P&&(this.s=P,this.domNode.style.lineHeight=this.s)}setLetterSpacing(A){const P=C(A);this.t!==P&&(this.t=P,this.domNode.style.letterSpacing=this.t)}setClassName(A){this.u!==A&&(this.u=A,this.domNode.className=this.u)}toggleClassName(A,P){this.domNode.classList.toggle(A,P),this.u=this.domNode.className}setDisplay(A){this.v!==A&&(this.v=A,this.domNode.style.display=this.v)}setPosition(A){this.w!==A&&(this.w=A,this.domNode.style.position=this.w)}setVisibility(A){this.x!==A&&(this.x=A,this.domNode.style.visibility=this.x)}setColor(A){this.y!==A&&(this.y=A,this.domNode.style.color=this.y)}setBackgroundColor(A){this.z!==A&&(this.z=A,this.domNode.style.backgroundColor=this.z)}setLayerHinting(A){this.A!==A&&(this.A=A,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(A){this.C!==A&&(this.C=A,this.domNode.style.boxShadow=A)}setContain(A){this.B!==A&&(this.B=A,this.domNode.style.contain=this.B)}setAttribute(A,P){this.domNode.setAttribute(A,P)}removeAttribute(A){this.domNode.removeAttribute(A)}appendChild(A){this.domNode.appendChild(A.domNode)}removeChild(A){this.domNode.removeChild(A.domNode)}}t.$mT=n;function C(H){return typeof H=="number"?`${H}px`:H}function B(H){return new n(H)}}),define(me[79],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ER=void 0,t.$FR=H;const n=new WeakMap;function C(P){if(!P.parent||P.parent===P)return null;try{const d=P.location,g=P.parent.location;if(d.origin!=="null"&&g.origin!=="null"&&d.origin!==g.origin)return null}catch{return null}return P.parent}class B{static a(d){let g=n.get(d);if(!g){g=[],n.set(d,g);let w=d,M;do M=C(w),M?g.push({window:new WeakRef(w),iframeElement:w.frameElement||null}):g.push({window:new WeakRef(w),iframeElement:null}),w=M;while(w)}return g.slice(0)}static getPositionOfChildWindowRelativeToAncestorWindow(d,g){if(!g||d===g)return{top:0,left:0};let w=0,M=0;const c=this.a(d);for(const h of c){const e=h.window.deref();if(w+=e?.scrollY??0,M+=e?.scrollX??0,e===g||!h.iframeElement)break;const i=h.iframeElement.getBoundingClientRect();w+=i.top,M+=i.left}return{top:w,left:M}}}t.$ER=B;async function H(P,d){if(!crypto.subtle)throw new Error("'crypto.subtle' is not available so webviews will not work. This is likely because the editor is not running in a secure context (https://developer.mozilla.org/en-US/docs/Web/Security/Secure_Contexts).");const g=JSON.stringify({parentOrigin:P,salt:d}),M=new TextEncoder().encode(g),c=await crypto.subtle.digest("sha-256",M);return A(c)}function A(P){const g=Array.from(new Uint8Array(P)).map(w=>w.toString(16).padStart(2,"0")).join("");return BigInt(`0x${g}`).toString(32).padStart(52,"0")}}),define(me[29],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rU=C,t.$sU=B;let n={showHover:()=>{},hideHover:()=>{},showAndFocusLastHover:()=>{},setupUpdatableHover:()=>null};function C(H){n=H}function B(){return n}}),define(me[80],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7T=t.$6T=t.$5T=t.ListDragOverEffectPosition=t.ListDragOverEffectType=void 0;var n;(function(A){A[A.Copy=0]="Copy",A[A.Move=1]="Move"})(n||(t.ListDragOverEffectType=n={}));var C;(function(A){A.Over="drop-target",A.Before="drop-target-before",A.After="drop-target-after"})(C||(t.ListDragOverEffectPosition=C={})),t.$5T={reject(){return{accept:!1}},accept(){return{accept:!0}}};class B extends Error{constructor(P,d){super(`ListError [${P}] ${d}`)}}t.$6T=B;class H{constructor(){this.c=new WeakMap}getHeight(P){return this.c.get(P)??this.d(P)}setDynamicHeight(P,d){d>0&&this.c.set(P,d)}}t.$7T=H}),define(me[81],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UT=void 0;class n{constructor(B){this.a=B}splice(B,H,A){this.a.forEach(P=>P.splice(B,H,A))}}t.$UT=n}),define(me[52],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$sT=void 0;const n=20;class C{constructor(H,A,P,d,g,w){this.a=Math.round(A),this.b=Math.round(P),this.c=Math.round(H),this.d=d,this.e=g,this.f=w,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new C(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(H){const A=Math.round(H);return this.d!==A?(this.d=A,this.m(),!0):!1}setScrollSize(H){const A=Math.round(H);return this.e!==A?(this.e=A,this.m(),!0):!1}setScrollPosition(H){const A=Math.round(H);return this.f!==A?(this.f=A,this.m(),!0):!1}setScrollbarSize(H){this.a=Math.round(H)}setOppositeScrollbarSize(H){this.b=Math.round(H)}static l(H,A,P,d,g){const w=Math.max(0,P-H),M=Math.max(0,w-2*A),c=d>0&&d>P;if(!c)return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(M),computedSliderRatio:0,computedSliderPosition:0};const h=Math.round(Math.max(n,Math.floor(P*M/d))),e=(M-h)/(d-P),i=g*e;return{computedAvailableSize:Math.round(w),computedIsNeeded:c,computedSliderSize:Math.round(h),computedSliderRatio:e,computedSliderPosition:Math.round(i)}}m(){const H=C.l(this.b,this.c,this.d,this.e,this.f);this.g=H.computedAvailableSize,this.h=H.computedIsNeeded,this.i=H.computedSliderSize,this.j=H.computedSliderRatio,this.k=H.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(H){if(!this.h)return 0;const A=H-this.c-this.i/2;return Math.round(A/this.j)}getDesiredScrollPositionFromOffsetPaged(H){if(!this.h)return 0;const A=H-this.c;let P=this.f;return A<this.k?P-=this.d:P+=this.d,P}getDesiredScrollPositionFromDelta(H){if(!this.h)return 0;const A=this.k+H;return Math.round(A/this.j)}}t.$sT=C}),define(me[30],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4V=t.$3V=t.$2V=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var n;(function(d){d[d.Hidden=0]="Hidden",d[d.Visible=1]="Visible",d[d.Recurse=2]="Recurse"})(n||(t.TreeVisibility=n={}));var C;(function(d){d[d.Expanded=0]="Expanded",d[d.Collapsed=1]="Collapsed",d[d.PreserveOrExpanded=2]="PreserveOrExpanded",d[d.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(C||(t.ObjectTreeElementCollapseState=C={}));var B;(function(d){d[d.Unknown=0]="Unknown",d[d.Twistie=1]="Twistie",d[d.Element=2]="Element",d[d.Filter=3]="Filter"})(B||(t.TreeMouseEventTarget=B={}));var H;(function(d){d[d.Down=0]="Down",d[d.Up=1]="Up"})(H||(t.TreeDragOverBubble=H={})),t.$2V={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(d=!1){return{accept:!0,bubble:0,autoExpand:d}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:{type:0,position:"drop-target"}}},acceptCopyBubbleDown(d=!1){return{accept:!0,bubble:0,effect:{type:0,position:"drop-target"},autoExpand:d}}};class A extends Error{constructor(g,w){super(`TreeError [${g}] ${w}`)}}t.$3V=A;class P{constructor(g){this.a=g,this.b=new WeakMap}map(g){let w=this.b.get(g);return w||(w=this.a(g),this.b.set(g,w)),w}}t.$4V=P}),define(me[22],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iR=void 0,t.$hR=n,t.$jR=C;function n(B,H){const A=B;typeof A.vscodeWindowId!="number"&&Object.defineProperty(A,"vscodeWindowId",{get:()=>H})}t.$iR=window;function C(B){return B===t.$iR?!1:typeof B?.vscodeWindowId=="number"}}),define(me[82],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$mb=void 0,t.$fb=n,t.$gb=C,t.$hb=B,t.$ib=H,t.$jb=A,t.$kb=P,t.$lb=d,t.$nb=w,t.$ob=M,t.$pb=c,t.$qb=h,t.$rb=e;function n(i,o){const l=C(i,o);if(l!==-1)return i[l]}function C(i,o,l=i.length-1){for(let f=l;f>=0;f--){const S=i[f];if(o(S))return f}return-1}function B(i,o){const l=H(i,o);return l===-1?void 0:i[l]}function H(i,o,l=0,f=i.length){let S=l,m=f;for(;S<m;){const b=Math.floor((S+m)/2);o(i[b])?S=b+1:m=b}return S-1}function A(i,o){const l=P(i,o);return l===i.length?void 0:i[l]}function P(i,o,l=0,f=i.length){let S=l,m=f;for(;S<m;){const b=Math.floor((S+m)/2);o(i[b])?m=b:S=b+1}return S}function d(i,o,l=0,f=i.length){const S=P(i,o,l,f);return S===i.length?-1:S}class g{static{this.assertInvariants=!1}constructor(o){this.e=o,this.c=0}findLastMonotonous(o){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!o(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=o}const l=H(this.e,o,this.c);return this.c=l+1,l===-1?void 0:this.e[l]}}t.$mb=g;function w(i,o){if(i.length===0)return;let l=i[0];for(let f=1;f<i.length;f++){const S=i[f];o(S,l)>0&&(l=S)}return l}function M(i,o){if(i.length===0)return;let l=i[0];for(let f=1;f<i.length;f++){const S=i[f];o(S,l)>=0&&(l=S)}return l}function c(i,o){return w(i,(l,f)=>-o(l,f))}function h(i,o){if(i.length===0)return-1;let l=0;for(let f=1;f<i.length;f++){const S=i[f];o(S,i[l])>0&&(l=f)}return l}function e(i,o){for(const l of i){const f=o(l);if(f!==void 0)return f}}}),define(me[83],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$K=n,t.$L=C,t.$M=B,t.$N=H;function n(A,P){const d=Object.create(null);for(const g of A){const w=P(g);let M=d[w];M||(M=d[w]=[]),M.push(g)}return d}function C(A,P){const d=[],g=[];for(const w of A)P.has(w)||d.push(w);for(const w of P)A.has(w)||g.push(w);return{removed:d,added:g}}function B(A,P){const d=[],g=[];for(const[w,M]of A)P.has(w)||d.push(M);for(const[w,M]of P)A.has(w)||g.push(M);return{removed:d,added:g}}function H(A,P){const d=new Set;for(const g of P)A.has(g)&&d.add(g);return d}}),define(me[84],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ot=t.$Nt=t.$Mt=t.$Lt=void 0;function n(P,d){const g=Math.pow(10,d);return Math.round(P*g)/g}class C{constructor(d,g,w,M=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,d))|0,this.g=Math.min(255,Math.max(0,g))|0,this.b=Math.min(255,Math.max(0,w))|0,this.a=n(Math.max(Math.min(1,M),0),3)}static equals(d,g){return d.r===g.r&&d.g===g.g&&d.b===g.b&&d.a===g.a}}t.$Lt=C;class B{constructor(d,g,w,M){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,g),0),3),this.l=n(Math.max(Math.min(1,w),0),3),this.a=n(Math.max(Math.min(1,M),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.l===g.l&&d.a===g.a}static fromRGBA(d){const g=d.r/255,w=d.g/255,M=d.b/255,c=d.a,h=Math.max(g,w,M),e=Math.min(g,w,M);let i=0,o=0;const l=(e+h)/2,f=h-e;if(f>0){switch(o=Math.min(l<=.5?f/(2*l):f/(2-2*l),1),h){case g:i=(w-M)/f+(w<M?6:0);break;case w:i=(M-g)/f+2;break;case M:i=(g-w)/f+4;break}i*=60,i=Math.round(i)}return new B(i,o,l,c)}static i(d,g,w){return w<0&&(w+=1),w>1&&(w-=1),w<1/6?d+(g-d)*6*w:w<1/2?g:w<2/3?d+(g-d)*(2/3-w)*6:d}static toRGBA(d){const g=d.h/360,{s:w,l:M,a:c}=d;let h,e,i;if(w===0)h=e=i=M;else{const o=M<.5?M*(1+w):M+w-M*w,l=2*M-o;h=B.i(l,o,g+1/3),e=B.i(l,o,g),i=B.i(l,o,g-1/3)}return new C(Math.round(h*255),Math.round(e*255),Math.round(i*255),c)}}t.$Mt=B;class H{constructor(d,g,w,M){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,d),0)|0,this.s=n(Math.max(Math.min(1,g),0),3),this.v=n(Math.max(Math.min(1,w),0),3),this.a=n(Math.max(Math.min(1,M),0),3)}static equals(d,g){return d.h===g.h&&d.s===g.s&&d.v===g.v&&d.a===g.a}static fromRGBA(d){const g=d.r/255,w=d.g/255,M=d.b/255,c=Math.max(g,w,M),h=Math.min(g,w,M),e=c-h,i=c===0?0:e/c;let o;return e===0?o=0:c===g?o=((w-M)/e%6+6)%6:c===w?o=(M-g)/e+2:o=(g-w)/e+4,new H(Math.round(o*60),i,c,d.a)}static toRGBA(d){const{h:g,s:w,v:M,a:c}=d,h=M*w,e=h*(1-Math.abs(g/60%2-1)),i=M-h;let[o,l,f]=[0,0,0];return g<60?(o=h,l=e):g<120?(o=e,l=h):g<180?(l=h,f=e):g<240?(l=e,f=h):g<300?(o=e,f=h):g<=360&&(o=h,f=e),o=Math.round((o+i)*255),l=Math.round((l+i)*255),f=Math.round((f+i)*255),new C(o,l,f,c)}}t.$Nt=H;class A{static fromHex(d){return A.Format.CSS.parseHex(d)||A.red}static equals(d,g){return!d&&!g?!0:!d||!g?!1:d.equals(g)}get hsla(){return this.i?this.i:B.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:H.fromRGBA(this.rgba)}constructor(d){if(d)if(d instanceof C)this.rgba=d;else if(d instanceof B)this.i=d,this.rgba=B.toRGBA(d);else if(d instanceof H)this.j=d,this.rgba=H.toRGBA(d);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(d){return!!d&&C.equals(this.rgba,d.rgba)&&B.equals(this.hsla,d.hsla)&&H.equals(this.hsva,d.hsva)}getRelativeLuminance(){const d=A.k(this.rgba.r),g=A.k(this.rgba.g),w=A.k(this.rgba.b),M=.2126*d+.7152*g+.0722*w;return n(M,4)}static k(d){const g=d/255;return g<=.03928?g/12.92:Math.pow((g+.055)/1.055,2.4)}getContrastRatio(d){const g=this.getRelativeLuminance(),w=d.getRelativeLuminance();return g>w?(g+.05)/(w+.05):(w+.05)/(g+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(d){const g=this.getRelativeLuminance(),w=d.getRelativeLuminance();return g>w}isDarkerThan(d){const g=this.getRelativeLuminance(),w=d.getRelativeLuminance();return g<w}lighten(d){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*d,this.hsla.a))}darken(d){return new A(new B(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*d,this.hsla.a))}transparent(d){const{r:g,g:w,b:M,a:c}=this.rgba;return new A(new C(g,w,M,c*d))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new A(new C(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(d){const g=d.rgba,w=this.rgba.a,M=g.a,c=w+M*(1-w);if(c<1e-6)return A.transparent;const h=this.rgba.r*w/c+g.r*M*(1-w)/c,e=this.rgba.g*w/c+g.g*M*(1-w)/c,i=this.rgba.b*w/c+g.b*M*(1-w)/c;return new A(new C(h,e,i,c))}makeOpaque(d){if(this.isOpaque()||d.rgba.a!==1)return this;const{r:g,g:w,b:M,a:c}=this.rgba;return new A(new C(d.rgba.r-c*(d.rgba.r-g),d.rgba.g-c*(d.rgba.g-w),d.rgba.b-c*(d.rgba.b-M),1))}flatten(...d){const g=d.reduceRight((w,M)=>A.o(M,w));return A.o(this,g)}static o(d,g){const w=1-d.rgba.a;return new A(new C(w*g.rgba.r+d.rgba.a*d.rgba.r,w*g.rgba.g+d.rgba.a*d.rgba.g,w*g.rgba.b+d.rgba.a*d.rgba.b))}toString(){return this.u||(this.u=A.Format.CSS.format(this)),this.u}static getLighterColor(d,g,w){if(d.isLighterThan(g))return d;w=w||.5;const M=d.getRelativeLuminance(),c=g.getRelativeLuminance();return w=w*(c-M)/c,d.lighten(w)}static getDarkerColor(d,g,w){if(d.isDarkerThan(g))return d;w=w||.5;const M=d.getRelativeLuminance(),c=g.getRelativeLuminance();return w=w*(M-c)/M,d.darken(w)}static{this.white=new A(new C(255,255,255,1))}static{this.black=new A(new C(0,0,0,1))}static{this.red=new A(new C(255,0,0,1))}static{this.blue=new A(new C(0,0,255,1))}static{this.green=new A(new C(0,255,0,1))}static{this.cyan=new A(new C(0,255,255,1))}static{this.lightgrey=new A(new C(211,211,211,1))}static{this.transparent=new A(new C(0,0,0,0))}}t.$Ot=A,function(P){let d;(function(g){let w;(function(M){function c(r){return r.rgba.a===1?`rgb(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b})`:P.Format.CSS.formatRGBA(r)}M.formatRGB=c;function h(r){return`rgba(${r.rgba.r}, ${r.rgba.g}, ${r.rgba.b}, ${+r.rgba.a.toFixed(2)})`}M.formatRGBA=h;function e(r){return r.hsla.a===1?`hsl(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%)`:P.Format.CSS.formatHSLA(r)}M.formatHSL=e;function i(r){return`hsla(${r.hsla.h}, ${(r.hsla.s*100).toFixed(2)}%, ${(r.hsla.l*100).toFixed(2)}%, ${r.hsla.a.toFixed(2)})`}M.formatHSLA=i;function o(r){const D=r.toString(16);return D.length!==2?"0"+D:D}function l(r){return`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}`}M.formatHex=l;function f(r,D=!1){return D&&r.rgba.a===1?P.Format.CSS.formatHex(r):`#${o(r.rgba.r)}${o(r.rgba.g)}${o(r.rgba.b)}${o(Math.round(r.rgba.a*255))}`}M.formatHexA=f;function S(r){return r.isOpaque()?P.Format.CSS.formatHex(r):P.Format.CSS.formatRGBA(r)}M.format=S;function m(r){const D=r.length;if(D===0||r.charCodeAt(0)!==35)return null;if(D===7){const k=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),T=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),L=16*b(r.charCodeAt(5))+b(r.charCodeAt(6));return new P(new C(k,T,L,1))}if(D===9){const k=16*b(r.charCodeAt(1))+b(r.charCodeAt(2)),T=16*b(r.charCodeAt(3))+b(r.charCodeAt(4)),L=16*b(r.charCodeAt(5))+b(r.charCodeAt(6)),q=16*b(r.charCodeAt(7))+b(r.charCodeAt(8));return new P(new C(k,T,L,q/255))}if(D===4){const k=b(r.charCodeAt(1)),T=b(r.charCodeAt(2)),L=b(r.charCodeAt(3));return new P(new C(16*k+k,16*T+T,16*L+L))}if(D===5){const k=b(r.charCodeAt(1)),T=b(r.charCodeAt(2)),L=b(r.charCodeAt(3)),q=b(r.charCodeAt(4));return new P(new C(16*k+k,16*T+T,16*L+L,(16*q+q)/255))}return null}M.parseHex=m;function b(r){switch(r){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(w=g.CSS||(g.CSS={}))})(d=P.Format||(P.Format={}))}(A||(t.$Ot=A={}))}),define(me[31],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Zh=C,t.$1h=B,t.$2h=H;function n(A){return(P,d,g)=>{let w=null,M=null;if(typeof g.value=="function"?(w="value",M=g.value):typeof g.get=="function"&&(w="get",M=g.get),!M)throw new Error("not supported");g[w]=A(M,d)}}function C(A,P,d){let g=null,w=null;if(typeof d.value=="function"?(g="value",w=d.value,w.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",w=d.get),!w)throw new Error("not supported");const M=`$memoize$${P}`;d[g]=function(...c){return this.hasOwnProperty(M)||Object.defineProperty(this,M,{configurable:!1,enumerable:!1,writable:!1,value:w.apply(this,c)}),this[M]}}function B(A,P,d){return n((g,w)=>{const M=`$debounce$${w}`,c=`$debounce$result$${w}`;return function(...h){this[c]||(this[c]=d?d():void 0),clearTimeout(this[M]),P&&(this[c]=P(this[c],...h),h=[this[c]]),this[M]=setTimeout(()=>{g.apply(this,h),this[c]=d?d():void 0},A)}})}function H(A,P,d){return n((g,w)=>{const M=`$throttle$timer$${w}`,c=`$throttle$result$${w}`,h=`$throttle$lastRun$${w}`,e=`$throttle$pending$${w}`;return function(...i){if(this[c]||(this[c]=d?d():void 0),(this[h]===null||this[h]===void 0)&&(this[h]=-Number.MAX_VALUE),P&&(this[c]=P(this[c],...i)),this[e])return;const o=this[h]+A;o<=Date.now()?(this[h]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0):(this[e]=!0,this[M]=setTimeout(()=>{this[e]=!1,this[h]=Date.now(),g.apply(this,[this[c]]),this[c]=d?d():void 0},o-Date.now()))}})}}),define(me[85],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wt=void 0;class n{constructor(B,H,A,P){this.originalStart=B,this.originalLength=H,this.modifiedStart=A,this.modifiedLength=P}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.$wt=n}),define(me[6],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$cb=t.$bb=t.$ab=t.$_=t.$$=t.$9=t.$5=t.$X=t.$W=void 0,t.setUnexpectedErrorHandler=C,t.$Z=B,t.$1=H,t.$2=A,t.$3=P,t.$4=g,t.$6=M,t.$7=c,t.$8=h,t.$0=i;class n{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?S.isErrorNoTelemetry(r)?new S(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(D=>{D(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}t.$W=n,t.$X=new n;function C(b){t.$X.setUnexpectedErrorHandler(b)}function B(b){if(!b||typeof b!="object")return!1;const r=b;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}function H(b){g(b)||t.$X.onUnexpectedError(b)}function A(b){g(b)||t.$X.onUnexpectedExternalError(b)}function P(b){if(b instanceof Error){const{name:r,message:D}=b,k=b.stacktrace||b.stack;return{$isError:!0,name:r,message:D,stack:k,noTelemetry:S.isErrorNoTelemetry(b)}}return b}const d="Canceled";function g(b){return b instanceof w?!0:b instanceof Error&&b.name===d&&b.message===d}class w extends Error{constructor(){super(d),this.name=this.message}}t.$5=w;function M(){const b=new Error(d);return b.name=b.message,b}function c(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}function h(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}class e extends TypeError{constructor(r){super(r?`${r} is read-only and cannot be changed`:"Cannot change read-only property")}}t.$9=e;function i(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}class o extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}t.$$=o;class l extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}t.$_=l;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.$ab=f;class S extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof S)return r;const D=new S;return D.message=r.message,D.stack=r.stack,D}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}t.$bb=S;class m extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}t.$cb=m}),define(me[8],be([1,0,6,82]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bc=t.$ac=t.$_b=t.$0b=t.$9b=t.CompareResult=void 0,t.$sb=B,t.$tb=H,t.$ub=A,t.$vb=P,t.$wb=d,t.$xb=g,t.$yb=w,t.$zb=M,t.$Ab=c,t.$Bb=h,t.$Cb=e,t.$Db=i,t.$Eb=o,t.top=l,t.$Gb=f,t.$Hb=m,t.$Ib=b,t.$Jb=r,t.$Kb=D,t.$Lb=k,t.$Mb=T,t.$Nb=L,t.$Ob=q,t.$Pb=$,t.$Qb=I,t.$Rb=V,t.$Sb=N,t.$Tb=x,t.$Ub=j,t.$Vb=Y,t.$Wb=K,t.$Xb=ae,t.$Yb=ie,t.$Zb=ee,t.$1b=ce,t.$2b=De,t.$3b=Ee,t.$4b=Le,t.$5b=le,t.$6b=_,t.$7b=ye,t.$8b=W,t.$$b=we;function B(z,u=0){return z[z.length-(1+u)]}function H(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}function A(z,u,y=(a,v)=>a===v){if(z===u)return!0;if(!z||!u||z.length!==u.length)return!1;for(let a=0,v=z.length;a<v;a++)if(!y(z[a],u[a]))return!1;return!0}function P(z,u){const y=z.length-1;u<y&&(z[u]=z[y]),z.pop()}function d(z,u,y){return g(z.length,a=>y(z[a],u))}function g(z,u){let y=0,a=z-1;for(;y<=a;){const v=(y+a)/2|0,F=u(v);if(F<0)y=v+1;else if(F>0)a=v-1;else return v}return-(y+1)}function w(z,u,y){if(z=z|0,z>=u.length)throw new TypeError("invalid index");const a=u[Math.floor(u.length*Math.random())],v=[],F=[],s=[];for(const E of u){const p=y(E,a);p<0?v.push(E):p>0?F.push(E):s.push(E)}return z<v.length?w(z,v,y):z<v.length+s.length?s[0]:w(z-(v.length+s.length),F,y)}function M(z,u){const y=[];let a;for(const v of z.slice(0).sort(u))!a||u(a[0],v)!==0?(a=[v],y.push(a)):a.push(v);return y}function*c(z,u){let y,a;for(const v of z)a!==void 0&&u(a,v)?y.push(v):(y&&(yield y),y=[v]),a=v;y&&(yield y)}function h(z,u){for(let y=0;y<=z.length;y++)u(y===0?void 0:z[y-1],y===z.length?void 0:z[y])}function e(z,u){for(let y=0;y<z.length;y++)u(y===0?void 0:z[y-1],z[y],y+1===z.length?void 0:z[y+1])}function i(z,u,y){const a=[];function v(E,p,R){if(p===0&&R.length===0)return;const O=a[a.length-1];O&&O.start+O.deleteCount===E?(O.deleteCount+=p,O.toInsert.push(...R)):a.push({start:E,deleteCount:p,toInsert:R})}let F=0,s=0;for(;;){if(F===z.length){v(F,0,u.slice(s));break}if(s===u.length){v(F,z.length-F,[]);break}const E=z[F],p=u[s],R=y(E,p);R===0?(F+=1,s+=1):R<0?(v(F,1,[]),F+=1):R>0&&(v(F,0,[p]),s+=1)}return a}function o(z,u,y){const a=i(z,u,y),v=[],F=[];for(const s of a)v.push(...z.slice(s.start,s.start+s.deleteCount)),F.push(...s.toInsert);return{removed:v,added:F}}function l(z,u,y){if(y===0)return[];const a=z.slice(0,y).sort(u);return S(z,u,a,y,z.length),a}function f(z,u,y,a,v){return y===0?Promise.resolve([]):new Promise((F,s)=>{(async()=>{const E=z.length,p=z.slice(0,y).sort(u);for(let R=y,O=Math.min(y+a,E);R<E;R=O,O=Math.min(O+a,E)){if(R>y&&await new Promise(U=>setTimeout(U)),v&&v.isCancellationRequested)throw new n.$5;S(z,u,p,R,O)}return p})().then(F,s)})}function S(z,u,y,a,v){for(const F=y.length;a<v;a++){const s=z[a];if(u(s,y[F-1])<0){y.pop();const E=(0,C.$kb)(y,p=>u(s,p)<0);y.splice(E,0,s)}}}function m(z){return z.filter(u=>!!u)}function b(z){let u=0;for(let y=0;y<z.length;y++)z[y]&&(z[u]=z[y],u+=1);z.length=u}function r(z,u,y){z.splice(y,0,z.splice(u,1)[0])}function D(z){return!Array.isArray(z)||z.length===0}function k(z){return Array.isArray(z)&&z.length>0}function T(z,u=y=>y){const y=new Set;return z.filter(a=>{const v=u(a);return y.has(v)?!1:(y.add(v),!0)})}function L(z){const u=new Set;return y=>{const a=z(y);return u.has(a)?!1:(u.add(a),!0)}}function q(z,u){return z.length>0?z[0]:u}function $(z,u){return z.length>0?z[z.length-1]:u}function I(z,u,y=(a,v)=>a===v){let a=0;for(let v=0,F=Math.min(z.length,u.length);v<F&&y(z[v],u[v]);v++)a++;return a}function V(z){return[].concat(...z)}function N(z,u){let y=typeof u=="number"?z:0;typeof u=="number"?y=z:(y=0,u=z);const a=[];if(y<=u)for(let v=y;v<u;v++)a.push(v);else for(let v=y;v>u;v--)a.push(v);return a}function x(z,u,y){return z.reduce((a,v)=>(a[u(v)]=y?y(v):v,a),Object.create(null))}function j(z,u){return z.push(u),()=>Y(z,u)}function Y(z,u){const y=z.indexOf(u);if(y>-1)return z.splice(y,1),u}function K(z,u,y){const a=z.slice(0,u),v=z.slice(u);return a.concat(y,v)}function ae(z,u){let y;if(typeof u=="number"){let a=u;y=()=>{const v=Math.sin(a++)*179426549;return v-Math.floor(v)}}else y=Math.random;for(let a=z.length-1;a>0;a-=1){const v=Math.floor(y()*(a+1)),F=z[a];z[a]=z[v],z[v]=F}}function ie(z,u){const y=z.indexOf(u);y>-1&&(z.splice(y,1),z.unshift(u))}function ee(z,u){const y=z.indexOf(u);y>-1&&(z.splice(y,1),z.push(u))}function ce(z,u){for(const y of u)z.push(y)}function De(z,u){return Array.isArray(z)?z.map(u):u(z)}function Ee(z){return Array.isArray(z)?z:[z]}function Le(z){return z[Math.floor(Math.random()*z.length)]}function le(z,u,y){const a=ue(z,u),v=z.length,F=y.length;z.length=v+F;for(let s=v-1;s>=a;s--)z[s+F]=z[s];for(let s=0;s<F;s++)z[s+a]=y[s]}function _(z,u,y,a){const v=ue(z,u);let F=z.splice(v,y);return F===void 0&&(F=[]),le(z,v,a),F}function ue(z,u){return u<0?Math.max(u+z.length,0):Math.min(u,z.length)}var re;(function(z){function u(F){return F<0}z.isLessThan=u;function y(F){return F<=0}z.isLessThanOrEqual=y;function a(F){return F>0}z.isGreaterThan=a;function v(F){return F===0}z.isNeitherLessOrGreaterThan=v,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re||(t.CompareResult=re={}));function ye(z,u){return(y,a)=>u(z(y),z(a))}function W(...z){return(u,y)=>{for(const a of z){const v=a(u,y);if(!re.isNeitherLessOrGreaterThan(v))return v}return re.neitherLessOrGreaterThan}}const Q=(z,u)=>z-u;t.$9b=Q;const ge=(z,u)=>(0,t.$9b)(z?1:0,u?1:0);t.$0b=ge;function we(z){return(u,y)=>-z(u,y)}class ke{constructor(u){this.g=u,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(u){let y=this.c;for(;y<this.g.length&&u(this.g[y]);)y++;const a=y===this.c?null:this.g.slice(this.c,y);return this.c=y,a}takeFromEndWhile(u){let y=this.d;for(;y>=0&&u(this.g[y]);)y--;const a=y===this.d?null:this.g.slice(y+1,this.d+1);return this.d=y,a}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const u=this.g[this.c];return this.c++,u}removeLast(){const u=this.g[this.d];return this.d--,u}takeCount(u){const y=this.g.slice(this.c,this.c+u);return this.c+=u,y}}t.$_b=ke;class Te{static{this.empty=new Te(u=>{})}constructor(u){this.iterate=u}forEach(u){this.iterate(y=>(u(y),!0))}toArray(){const u=[];return this.iterate(y=>(u.push(y),!0)),u}filter(u){return new Te(y=>this.iterate(a=>u(a)?y(a):!0))}map(u){return new Te(y=>this.iterate(a=>y(u(a))))}some(u){let y=!1;return this.iterate(a=>(y=u(a),!y)),y}findFirst(u){let y;return this.iterate(a=>u(a)?(y=a,!1):!0),y}findLast(u){let y;return this.iterate(a=>(u(a)&&(y=a),!0)),y}findLastMaxBy(u){let y,a=!0;return this.iterate(v=>((a||re.isGreaterThan(u(v,y)))&&(a=!1,y=v),!0)),y}}t.$ac=Te;class Ie{constructor(u){this.c=u}static createSortPermutation(u,y){const a=Array.from(u.keys()).sort((v,F)=>y(u[v],u[F]));return new Ie(a)}apply(u){return u.map((y,a)=>u[this.c[a]])}inverse(){const u=this.c.slice();for(let y=0;y<this.c.length;y++)u[this.c[y]]=y;return new Ie(u)}}t.$bc=Ie}),define(me[37],be([1,0,6]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=C,t.$fd=B,t.$gd=H,t.$hd=A,t.$id=P,t.$jd=d;function C(g,w){if(!g)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}function B(g,w="Unreachable"){throw new Error(w)}function H(g){if(!g)throw new n.$cb("Assertion Failed")}function A(g){g||(0,n.$1)(new n.$cb("Soft Assertion Failed"))}function P(g){if(!g()){debugger;g(),(0,n.$1)(new n.$cb("Assertion Failed"))}}function d(g,w){let M=0;for(;M<g.length-1;){const c=g[M],h=g[M+1];if(!w(c,h))return!1;M++}return!0}}),define(me[38],be([1,0,8]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7c=void 0,t.$8c=B,t.$9c=H,t.$0c=A,t.$$c=P,t.$_c=d,t.$ad=g;const C=(h,e)=>h===e;t.$7c=C;function B(h=t.$7c){return(e,i)=>n.$ub(e,i,h)}function H(){return(h,e)=>JSON.stringify(h)===JSON.stringify(e)}function A(){return(h,e)=>h.equals(e)}function P(h,e,i){return!h||!e?h===e:i(h,e)}function d(h,e){if(h===e)return!0;if(Array.isArray(h)&&Array.isArray(e)){if(h.length!==e.length)return!1;for(let i=0;i<h.length;i++)if(!d(h[i],e[i]))return!1;return!0}if(Object.getPrototypeOf(h)===Object.prototype&&Object.getPrototypeOf(e)===Object.prototype){const i=h,o=e,l=Object.keys(i),f=Object.keys(o),S=new Set(f);if(l.length!==f.length)return!1;for(const m of l)if(!S.has(m)||!d(i[m],o[m]))return!1;return!0}return!1}function g(h){return JSON.stringify(c(h))}let w=0;const M=new WeakMap;function c(h){if(Array.isArray(h))return h.map(c);if(h&&typeof h=="object")if(Object.getPrototypeOf(h)===Object.prototype){const e=h,i=Object.create(null);for(const o of Object.keys(e).sort())i[o]=c(e[o]);return i}else{let e=M.get(h);return e===void 0&&(e=w++,M.set(h,e)),e+"----2b76a038c20c4bcc"}return h}}),define(me[53],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$db=n;function n(C,B){const H=this;let A=!1,P;return function(){if(A)return P;if(A=!0,B)try{P=C.apply(H,arguments)}finally{B()}else P=C.apply(H,arguments);return P}}}),define(me[86],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rP=t.$qP=void 0;class n{constructor(B){this.a=B,this.b=0}nextId(){return this.a+ ++this.b}}t.$qP=n,t.$rP=new n("id#")}),define(me[32],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var n;(function(C){function B(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}C.is=B;const H=Object.freeze([]);function A(){return H}C.empty=A;function*P(r){yield r}C.single=P;function d(r){return B(r)?r:P(r)}C.wrap=d;function g(r){return r||H}C.from=g;function*w(r){for(let D=r.length-1;D>=0;D--)yield r[D]}C.reverse=w;function M(r){return!r||r[Symbol.iterator]().next().done===!0}C.isEmpty=M;function c(r){return r[Symbol.iterator]().next().value}C.first=c;function h(r,D){for(const k of r)if(D(k))return!0;return!1}C.some=h;function e(r,D){for(const k of r)if(D(k))return k}C.find=e;function*i(r,D){for(const k of r)D(k)&&(yield k)}C.filter=i;function*o(r,D){let k=0;for(const T of r)yield D(T,k++)}C.map=o;function*l(...r){for(const D of r)yield*D}C.concat=l;function f(r,D,k){let T=k;for(const L of r)T=D(T,L);return T}C.reduce=f;function*S(r,D,k=r.length){for(D<0&&(D+=r.length),k<0?k+=r.length:k>r.length&&(k=r.length);D<k;D++)yield r[D]}C.slice=S;function m(r,D=Number.POSITIVE_INFINITY){const k=[];if(D===0)return[k,r];const T=r[Symbol.iterator]();for(let L=0;L<D;L++){const q=T.next();if(q.done)return[k,C.empty()];k.push(q.value)}return[k,{[Symbol.iterator](){return T}}]}C.consume=m;async function b(r){const D=[];for await(const k of r)D.push(k);return Promise.resolve(D)}C.asyncToArray=b})(n||(t.Iterable=n={}))}),define(me[54],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyMod=t.KeyCodeUtils=t.$Cr=t.$Br=t.$Ar=t.$zr=t.$yr=t.ScanCode=t.KeyCode=void 0,t.$Dr=h;var n;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(n||(t.KeyCode=n={}));var C;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(C||(t.ScanCode=C={}));class B{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(i,o){this._keyCodeToStr[i]=o,this._strToKeyCode[o.toLowerCase()]=i}keyCodeToStr(i){return this._keyCodeToStr[i]}strToKeyCode(i){return this._strToKeyCode[i.toLowerCase()]||0}}const H=new B,A=new B,P=new B;t.$yr=new Array(230),t.$zr={};const d=[],g=Object.create(null),w=Object.create(null);t.$Ar={lowerCaseToEnum:e=>w[e]||0,toEnum:e=>g[e]||0,toString:e=>d[e]||"None"},t.$Br=[],t.$Cr=[];for(let e=0;e<=193;e++)t.$Br[e]=-1;for(let e=0;e<=132;e++)t.$Cr[e]=-1;(function(){const e="",i=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",131,"VK_F20",e,e],[1,118,"F21",79,"F21",132,"VK_F21",e,e],[1,119,"F22",80,"F22",133,"VK_F22",e,e],[1,120,"F23",81,"F23",134,"VK_F23",e,e],[1,121,"F24",82,"F24",135,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],o=[],l=[];for(const f of i){const[S,m,b,r,D,k,T,L,q]=f;if(l[m]||(l[m]=!0,d[m]=b,g[b]=m,w[b.toLowerCase()]=m,S&&(t.$Br[m]=r,r!==0&&r!==3&&r!==5&&r!==4&&r!==6&&r!==57&&(t.$Cr[r]=m))),!o[r]){if(o[r]=!0,!D)throw new Error(`String representation missing for key code ${r} around scan code ${b}`);H.define(r,D),A.define(r,L||D),P.define(r,q||L||D)}k&&(t.$yr[k]=r),T&&(t.$zr[T]=r)}t.$Cr[3]=46})();var M;(function(e){function i(b){return H.keyCodeToStr(b)}e.toString=i;function o(b){return H.strToKeyCode(b)}e.fromString=o;function l(b){return A.keyCodeToStr(b)}e.toUserSettingsUS=l;function f(b){return P.keyCodeToStr(b)}e.toUserSettingsGeneral=f;function S(b){return A.strToKeyCode(b)||P.strToKeyCode(b)}e.fromUserSettings=S;function m(b){if(b>=98&&b<=113)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return H.keyCodeToStr(b)}e.toElectronAccelerator=m})(M||(t.KeyCodeUtils=M={}));var c;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(c||(t.KeyMod=c={}));function h(e,i){const o=(i&65535)<<16>>>0;return(e|o)>>>0}}),define(me[87],be([1,0,6]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kr=t.$Jr=t.$Ir=t.$Hr=t.$Gr=void 0,t.$Er=B,t.$Fr=H;var C;(function(M){M[M.CtrlCmd=2048]="CtrlCmd",M[M.Shift=1024]="Shift",M[M.Alt=512]="Alt",M[M.WinCtrl=256]="WinCtrl",M[M.KeyCode=255]="KeyCode"})(C||(C={}));function B(M,c){if(typeof M=="number"){if(M===0)return null;const h=(M&65535)>>>0,e=(M&4294901760)>>>16;return e!==0?new d([H(h,c),H(e,c)]):new d([H(h,c)])}else{const h=[];for(let e=0;e<M.length;e++)h.push(H(M[e],c));return new d(h)}}function H(M,c){const h=!!(M&2048),e=!!(M&256),i=c===2?e:h,o=!!(M&1024),l=!!(M&512),f=c===2?h:e,S=M&255;return new A(i,o,l,f,S)}class A{constructor(c,h,e,i,o){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=i,this.keyCode=o}equals(c){return c instanceof A&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.keyCode===c.keyCode}getHashCode(){const c=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`K${c}${h}${e}${i}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new d([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.$Gr=A;class P{constructor(c,h,e,i,o){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=i,this.scanCode=o}equals(c){return c instanceof P&&this.ctrlKey===c.ctrlKey&&this.shiftKey===c.shiftKey&&this.altKey===c.altKey&&this.metaKey===c.metaKey&&this.scanCode===c.scanCode}getHashCode(){const c=this.ctrlKey?"1":"0",h=this.shiftKey?"1":"0",e=this.altKey?"1":"0",i=this.metaKey?"1":"0";return`S${c}${h}${e}${i}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.$Hr=P;class d{constructor(c){if(c.length===0)throw(0,n.$7)("chords");this.chords=c}getHashCode(){let c="";for(let h=0,e=this.chords.length;h<e;h++)h!==0&&(c+=";"),c+=this.chords[h].getHashCode();return c}equals(c){if(c===null||this.chords.length!==c.chords.length)return!1;for(let h=0;h<this.chords.length;h++)if(!this.chords[h].equals(c.chords[h]))return!1;return!0}}t.$Ir=d;class g{constructor(c,h,e,i,o,l){this.ctrlKey=c,this.shiftKey=h,this.altKey=e,this.metaKey=i,this.keyLabel=o,this.keyAriaLabel=l}}t.$Jr=g;class w{}t.$Kr=w}),define(me[23],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$V=void 0;class n{constructor(B){this.d=B,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(B){this.c=B}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.$V=n}),define(me[14],be([1,0,23]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$FT=P,t.$GT=d,t.$HT=g;let B=()=>({get delay(){return-1},dispose:()=>{},showHover:()=>{}});const H=new n.$V(()=>B("mouse",!1)),A=new n.$V(()=>B("element",!1));function P(w){B=w}function d(w){return w==="element"?A.value:H.value}function g(){return B("element",!0)}}),define(me[55],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6c=void 0;class n{static{this.Undefined=new n(void 0)}constructor(H){this.element=H,this.next=n.Undefined,this.prev=n.Undefined}}class C{constructor(){this.a=n.Undefined,this.b=n.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===n.Undefined}clear(){let H=this.a;for(;H!==n.Undefined;){const A=H.next;H.prev=n.Undefined,H.next=n.Undefined,H=A}this.a=n.Undefined,this.b=n.Undefined,this.c=0}unshift(H){return this.d(H,!1)}push(H){return this.d(H,!0)}d(H,A){const P=new n(H);if(this.a===n.Undefined)this.a=P,this.b=P;else if(A){const g=this.b;this.b=P,P.prev=g,g.next=P}else{const g=this.a;this.a=P,P.next=g,g.prev=P}this.c+=1;let d=!1;return()=>{d||(d=!0,this.e(P))}}shift(){if(this.a!==n.Undefined){const H=this.a.element;return this.e(this.a),H}}pop(){if(this.b!==n.Undefined){const H=this.b.element;return this.e(this.b),H}}e(H){if(H.prev!==n.Undefined&&H.next!==n.Undefined){const A=H.prev;A.next=H.next,H.next.prev=A}else H.prev===n.Undefined&&H.next===n.Undefined?(this.a=n.Undefined,this.b=n.Undefined):H.next===n.Undefined?(this.b=this.b.prev,this.b.next=n.Undefined):H.prev===n.Undefined&&(this.a=this.a.next,this.a.prev=n.Undefined);this.c-=1}*[Symbol.iterator](){let H=this.a;for(;H!==n.Undefined;)yield H.element,H=H.next}}t.$6c=C}),define(me[39],be([1,0]),function(se,t){"use strict";var n,C,B;Object.defineProperty(t,"__esModule",{value:!0}),t.$Ic=t.$Hc=t.$Gc=t.$Fc=t.$Ec=t.$Dc=t.Touch=t.$Cc=t.$Bc=void 0,t.$yc=H,t.$zc=A,t.$Ac=P,t.$Jc=m;function H(b,r,D){let k=b.get(r);return k===void 0&&(k=D,b.set(r,k)),k}function A(b){const r=[];return b.forEach((D,k)=>{r.push(`${k} => ${D}`)}),`Map(${b.size}) {${r.join(", ")}}`}function P(b){const r=[];return b.forEach(D=>{r.push(D)}),`Set(${b.size}) {${r.join(", ")}}`}class d{constructor(r,D){this.uri=r,this.value=D}}function g(b){return Array.isArray(b)}class w{static{this.c=r=>r.toString()}constructor(r,D){if(this[n]="ResourceMap",r instanceof w)this.d=new Map(r.d),this.e=D??w.c;else if(g(r)){this.d=new Map,this.e=D??w.c;for(const[k,T]of r)this.set(k,T)}else this.d=new Map,this.e=r??w.c}set(r,D){return this.d.set(this.e(r),new d(r,D)),this}get(r){return this.d.get(this.e(r))?.value}has(r){return this.d.has(this.e(r))}get size(){return this.d.size}clear(){this.d.clear()}delete(r){return this.d.delete(this.e(r))}forEach(r,D){typeof D<"u"&&(r=r.bind(D));for(const[k,T]of this.d)r(T.value,T.uri,this)}*values(){for(const r of this.d.values())yield r.value}*keys(){for(const r of this.d.values())yield r.uri}*entries(){for(const r of this.d.values())yield[r.uri,r.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.d)yield[r.uri,r.value]}}t.$Bc=w;class M{constructor(r,D){this[C]="ResourceSet",!r||typeof r=="function"?this.c=new w(r):(this.c=new w(D),r.forEach(this.add,this))}get size(){return this.c.size}add(r){return this.c.set(r,r),this}clear(){this.c.clear()}delete(r){return this.c.delete(r)}forEach(r,D){this.c.forEach((k,T)=>r.call(D,T,T,this))}has(r){return this.c.has(r)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(C=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.$Cc=M;var c;(function(b){b[b.None=0]="None",b[b.AsOld=1]="AsOld",b[b.AsNew=2]="AsNew"})(c||(t.Touch=c={}));class h{constructor(){this[B]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(r){return this.c.has(r)}get(r,D=0){const k=this.c.get(r);if(k)return D!==0&&this.m(k,D),k.value}set(r,D,k=0){let T=this.c.get(r);if(T)T.value=D,k!==0&&this.m(T,k);else{switch(T={key:r,value:D,next:void 0,previous:void 0},k){case 0:this.k(T);break;case 1:this.j(T);break;case 2:this.k(T);break;default:this.k(T);break}this.c.set(r,T),this.f++}return this}delete(r){return!!this.remove(r)}remove(r){const D=this.c.get(r);if(D)return this.c.delete(r),this.l(D),this.f--,D.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const r=this.d;return this.c.delete(r.key),this.l(r),this.f--,r.value}forEach(r,D){const k=this.g;let T=this.d;for(;T;){if(D?r.bind(D)(T.value,T.key,this):r(T.value,T.key,this),this.g!==k)throw new Error("LinkedMap got modified during iteration.");T=T.next}}keys(){const r=this,D=this.g;let k=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==D)throw new Error("LinkedMap got modified during iteration.");if(k){const L={value:k.key,done:!1};return k=k.next,L}else return{value:void 0,done:!0}}};return T}values(){const r=this,D=this.g;let k=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==D)throw new Error("LinkedMap got modified during iteration.");if(k){const L={value:k.value,done:!1};return k=k.next,L}else return{value:void 0,done:!0}}};return T}entries(){const r=this,D=this.g;let k=this.d;const T={[Symbol.iterator](){return T},next(){if(r.g!==D)throw new Error("LinkedMap got modified during iteration.");if(k){const L={value:[k.key,k.value],done:!1};return k=k.next,L}else return{value:void 0,done:!0}}};return T}[(B=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(r){if(r>=this.size)return;if(r===0){this.clear();return}let D=this.d,k=this.size;for(;D&&k>r;)this.c.delete(D.key),D=D.next,k--;this.d=D,this.f=k,D&&(D.previous=void 0),this.g++}i(r){if(r>=this.size)return;if(r===0){this.clear();return}let D=this.e,k=this.size;for(;D&&k>r;)this.c.delete(D.key),D=D.previous,k--;this.e=D,this.f=k,D&&(D.next=void 0),this.g++}j(r){if(!this.d&&!this.e)this.e=r;else if(this.d)r.next=this.d,this.d.previous=r;else throw new Error("Invalid list");this.d=r,this.g++}k(r){if(!this.d&&!this.e)this.d=r;else if(this.e)r.previous=this.e,this.e.next=r;else throw new Error("Invalid list");this.e=r,this.g++}l(r){if(r===this.d&&r===this.e)this.d=void 0,this.e=void 0;else if(r===this.d){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.d=r.next}else if(r===this.e){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.e=r.previous}else{const D=r.next,k=r.previous;if(!D||!k)throw new Error("Invalid list");D.previous=k,k.next=D}r.next=void 0,r.previous=void 0,this.g++}m(r,D){if(!this.d||!this.e)throw new Error("Invalid list");if(!(D!==1&&D!==2)){if(D===1){if(r===this.d)return;const k=r.next,T=r.previous;r===this.e?(T.next=void 0,this.e=T):(k.previous=T,T.next=k),r.previous=void 0,r.next=this.d,this.d.previous=r,this.d=r,this.g++}else if(D===2){if(r===this.e)return;const k=r.next,T=r.previous;r===this.d?(k.previous=void 0,this.d=k):(k.previous=T,T.next=k),r.next=void 0,r.previous=this.e,this.e.next=r,this.e=r,this.g++}}}toJSON(){const r=[];return this.forEach((D,k)=>{r.push([k,D])}),r}fromJSON(r){this.clear();for(const[D,k]of r)this.set(D,k)}}t.$Dc=h;class e extends h{constructor(r,D=1){super(),this.n=r,this.o=Math.min(Math.max(0,D),1)}get limit(){return this.n}set limit(r){this.n=r,this.p()}get ratio(){return this.o}set ratio(r){this.o=Math.min(Math.max(0,r),1),this.p()}get(r,D=2){return super.get(r,D)}peek(r){return super.get(r,0)}set(r,D){return super.set(r,D,2),this}p(){this.size>this.n&&this.q(Math.round(this.n*this.o))}}class i extends e{constructor(r,D=1){super(r,D)}q(r){this.h(r)}set(r,D){return super.set(r,D),this.p(),this}}t.$Ec=i;class o extends e{constructor(r,D=1){super(r,D)}q(r){this.i(r)}set(r,D){return this.n<=this.size&&!this.has(r)&&this.q(Math.round(this.n*this.o)-1),super.set(r,D),this}}t.$Fc=o;class l{constructor(){this.c=new Map}add(r){return this.c.set(r,(this.c.get(r)||0)+1),this}delete(r){let D=this.c.get(r)||0;return D===0?!1:(D--,D===0?this.c.delete(r):this.c.set(r,D),!0)}has(r){return this.c.has(r)}}t.$Gc=l;class f{constructor(r){if(this.c=new Map,this.d=new Map,r)for(const[D,k]of r)this.set(D,k)}clear(){this.c.clear(),this.d.clear()}set(r,D){this.c.set(r,D),this.d.set(D,r)}get(r){return this.c.get(r)}getKey(r){return this.d.get(r)}delete(r){const D=this.c.get(r);return D===void 0?!1:(this.c.delete(r),this.d.delete(D),!0)}forEach(r,D){this.c.forEach((k,T)=>{r.call(D,k,T,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}t.$Hc=f;class S{constructor(){this.c=new Map}add(r,D){let k=this.c.get(r);k||(k=new Set,this.c.set(r,k)),k.add(D)}delete(r,D){const k=this.c.get(r);k&&(k.delete(D),k.size===0&&this.c.delete(r))}forEach(r,D){const k=this.c.get(r);k&&k.forEach(D)}get(r){const D=this.c.get(r);return D||new Set}}t.$Ic=S;function m(b,r){if(b===r)return!0;if(b.size!==r.size)return!1;for(const[D,k]of b)if(!r.has(D)||r.get(D)!==k)return!1;for(const[D]of r)if(!b.has(D))return!1;return!0}}),define(me[2],be([1,0,8,83,39,53,32]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$5c=t.$3c=t.$2c=t.$1c=t.$Zc=t.$Yc=t.$Xc=t.$Wc=t.$Vc=t.$Uc=t.$Kc=void 0,t.$Lc=w,t.$Mc=M,t.$Nc=c,t.$Oc=i,t.$Pc=o,t.$Qc=l,t.$Rc=f,t.$Sc=S,t.$Tc=m,t.$4c=V;const P=!1;let d=null;class g{constructor(){this.b=new Map}static{this.a=0}c(j){let Y=this.b.get(j);return Y||(Y={parent:null,source:null,isSingleton:!1,value:j,idx:g.a++},this.b.set(j,Y)),Y}trackDisposable(j){const Y=this.c(j);Y.source||(Y.source=new Error().stack)}setParent(j,Y){const K=this.c(j);K.parent=Y}markAsDisposed(j){this.b.delete(j)}markAsSingleton(j){this.c(j).isSingleton=!0}f(j,Y){const K=Y.get(j);if(K)return K;const ae=j.parent?this.f(this.c(j.parent),Y):j;return Y.set(j,ae),ae}getTrackedDisposables(){const j=new Map;return[...this.b.entries()].filter(([,K])=>K.source!==null&&!this.f(K,j).isSingleton).flatMap(([K])=>K)}computeLeakingDisposables(j=10,Y){let K;if(Y)K=Y;else{const De=new Map,Ee=[...this.b.values()].filter(le=>le.source!==null&&!this.f(le,De).isSingleton);if(Ee.length===0)return;const Le=new Set(Ee.map(le=>le.value));if(K=Ee.filter(le=>!(le.parent&&Le.has(le.parent))),K.length===0)throw new Error("There are cyclic diposable chains!")}if(!K)return;function ae(De){function Ee(le,_){for(;le.length>0&&_.some(ue=>typeof ue=="string"?ue===le[0]:le[0].match(ue));)le.shift()}const Le=De.source.split(`
`).map(le=>le.trim().replace("at ","")).filter(le=>le!=="");return Ee(Le,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Le.reverse()}const ie=new B.$Ic;for(const De of K){const Ee=ae(De);for(let Le=0;Le<=Ee.length;Le++)ie.add(Ee.slice(0,Le).join(`
`),De)}K.sort((0,n.$7b)(De=>De.idx,n.$9b));let ee="",ce=0;for(const De of K.slice(0,j)){ce++;const Ee=ae(De),Le=[];for(let le=0;le<Ee.length;le++){let _=Ee[le];_=`(shared with ${ie.get(Ee.slice(0,le+1).join(`
`)).size}/${K.length} leaks) at ${_}`;const re=ie.get(Ee.slice(0,le).join(`
`)),ye=(0,C.$K)([...re].map(W=>ae(W)[le]),W=>W);delete ye[Ee[le]];for(const[W,Q]of Object.entries(ye))Le.unshift(`    - stacktraces of ${Q.length} other leaks continue with ${W}`);Le.unshift(_)}ee+=`


==================== Leaking disposable ${ce}/${K.length}: ${De.value.constructor.name} ====================
${Le.join(`
`)}
============================================================

`}return K.length>j&&(ee+=`


... and ${K.length-j} more leaking disposables

`),{leaks:K,details:ee}}}t.$Kc=g;function w(x){d=x}if(P){const x="__is_disposable_tracked__";w(new class{trackDisposable(j){const Y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{j[x]||console.log(Y)},3e3)}setParent(j,Y){if(j&&j!==r.None)try{j[x]=!0}catch{}}markAsDisposed(j){if(j&&j!==r.None)try{j[x]=!0}catch{}}markAsSingleton(j){}})}function M(x){return d?.trackDisposable(x),x}function c(x){d?.markAsDisposed(x)}function h(x,j){d?.setParent(x,j)}function e(x,j){if(d)for(const Y of x)d.setParent(Y,j)}function i(x){return d?.markAsSingleton(x),x}function o(x){return typeof x=="object"&&x!==null&&typeof x.dispose=="function"&&x.dispose.length===0}function l(x){if(A.Iterable.is(x)){const j=[];for(const Y of x)if(Y)try{Y.dispose()}catch(K){j.push(K)}if(j.length===1)throw j[0];if(j.length>1)throw new AggregateError(j,"Encountered errors while disposing of store");return Array.isArray(x)?[]:x}else if(x)return x.dispose(),x}function f(x){for(const j of x)o(j)&&j.dispose();return[]}function S(...x){const j=m(()=>l(x));return e(x,j),j}function m(x){const j=M({dispose:(0,H.$db)(()=>{c(j),x()})});return j}class b{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,M(this)}dispose(){this.g||(c(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(j){if(!j)return j;if(j===this)throw new Error("Cannot register a disposable on itself!");return h(j,this),this.g?b.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(j),j}delete(j){if(j){if(j===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(j),j.dispose()}}deleteAndLeak(j){j&&this.f.has(j)&&(this.f.delete(j),h(j,null))}}t.$Uc=b;class r{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new b,M(this),h(this.q,this)}dispose(){c(this),this.q.dispose()}B(j){if(j===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(j)}}t.$Vc=r;class D{constructor(){this.b=!1,M(this)}get value(){return this.b?void 0:this.a}set value(j){this.b||j===this.a||(this.a?.dispose(),j&&h(j,this),this.a=j)}clear(){this.value=void 0}dispose(){this.b=!0,c(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const j=this.a;return this.a=void 0,j&&h(j,null),j}}t.$Wc=D;class k{constructor(j){this.a=new D,this.b=!1,this.a.value=j}get value(){return this.a.value}set value(j){this.b||j===this.a.value||(this.a.value=j)}dispose(){this.b=!0,this.a.dispose()}}t.$Xc=k;class T{constructor(j){this.b=j,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.$Yc=T;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,M(this)}set(j){let Y=j;return this.unset=()=>Y=void 0,this.isset=()=>Y!==void 0,this.dispose=()=>{Y&&(Y(),Y=void 0,c(this))},this}}t.$Zc=L;class q{constructor(){this.a=new Map}acquire(j,...Y){let K=this.a.get(j);K||(K={counter:0,object:this.b(j,...Y)},this.a.set(j,K));const{object:ae}=K,ie=(0,H.$db)(()=>{--K.counter===0&&(this.c(j,K.object),this.a.delete(j))});return K.counter++,{object:ae,dispose:ie}}}t.$1c=q;class ${constructor(j){this.a=j}async acquire(j,...Y){const K=this.a.acquire(j,...Y);try{return{object:await K.object,dispose:()=>K.dispose()}}catch(ae){throw K.dispose(),ae}}}t.$2c=$;class I{constructor(j){this.object=j}dispose(){}}t.$3c=I;function V(x){const j=new b;try{x(j)}finally{j.dispose()}}class N{constructor(){this.a=new Map,this.b=!1,M(this)}dispose(){c(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(j){return this.a.has(j)}get size(){return this.a.size}get(j){return this.a.get(j)}set(j,Y,K=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),K||this.a.get(j)?.dispose(),this.a.set(j,Y)}deleteAndDispose(j){this.a.get(j)?.dispose(),this.a.delete(j)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.$5c=N}),function(se,t){typeof define=="function"&&define.amd?define(me[88],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(se=typeof globalThis<"u"?globalThis:se||self,t(se.marked={}))}(this,function(se){"use strict";function t(z,u){for(var y=0;y<u.length;y++){var a=u[y];a.enumerable=a.enumerable||!1,a.configurable=!0,"value"in a&&(a.writable=!0),Object.defineProperty(z,a.key,a)}}function n(z,u,y){return u&&t(z.prototype,u),y&&t(z,y),Object.defineProperty(z,"prototype",{writable:!1}),z}function C(z,u){if(z){if(typeof z=="string")return B(z,u);var y=Object.prototype.toString.call(z).slice(8,-1);if(y==="Object"&&z.constructor&&(y=z.constructor.name),y==="Map"||y==="Set")return Array.from(z);if(y==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(y))return B(z,u)}}function B(z,u){(u==null||u>z.length)&&(u=z.length);for(var y=0,a=new Array(u);y<u;y++)a[y]=z[y];return a}function H(z,u){var y=typeof Symbol<"u"&&z[Symbol.iterator]||z["@@iterator"];if(y)return(y=y.call(z)).next.bind(y);if(Array.isArray(z)||(y=C(z))||u&&z&&typeof z.length=="number"){y&&(z=y);var a=0;return function(){return a>=z.length?{done:!0}:{done:!1,value:z[a++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}se.defaults=A();function P(z){se.defaults=z}var d=/[&<>"']/,g=/[&<>"']/g,w=/[<>"']|&(?!#?\w+;)/,M=/[<>"']|&(?!#?\w+;)/g,c={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},h=function(u){return c[u]};function e(z,u){if(u){if(d.test(z))return z.replace(g,h)}else if(w.test(z))return z.replace(M,h);return z}var i=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(z){return z.replace(i,function(u,y){return y=y.toLowerCase(),y==="colon"?":":y.charAt(0)==="#"?y.charAt(1)==="x"?String.fromCharCode(parseInt(y.substring(2),16)):String.fromCharCode(+y.substring(1)):""})}var l=/(^|[^\[])\^/g;function f(z,u){z=typeof z=="string"?z:z.source,u=u||"";var y={replace:function(v,F){return F=F.source||F,F=F.replace(l,"$1"),z=z.replace(v,F),y},getRegex:function(){return new RegExp(z,u)}};return y}var S=/[^\w:]/g,m=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(z,u,y){if(z){var a;try{a=decodeURIComponent(o(y)).replace(S,"").toLowerCase()}catch{return null}if(a.indexOf("javascript:")===0||a.indexOf("vbscript:")===0||a.indexOf("data:")===0)return null}u&&!m.test(y)&&(y=L(u,y));try{y=encodeURI(y).replace(/%25/g,"%")}catch{return null}return y}var r={},D=/^[^:]+:\/*[^/]*$/,k=/^([^:]+:)[\s\S]*$/,T=/^([^:]+:\/*[^/]*)[\s\S]*$/;function L(z,u){r[" "+z]||(D.test(z)?r[" "+z]=z+"/":r[" "+z]=V(z,"/",!0)),z=r[" "+z];var y=z.indexOf(":")===-1;return u.substring(0,2)==="//"?y?u:z.replace(k,"$1")+u:u.charAt(0)==="/"?y?u:z.replace(T,"$1")+u:z+u}var q={exec:function(){}};function $(z){for(var u=1,y,a;u<arguments.length;u++){y=arguments[u];for(a in y)Object.prototype.hasOwnProperty.call(y,a)&&(z[a]=y[a])}return z}function I(z,u){var y=z.replace(/\|/g,function(F,s,E){for(var p=!1,R=s;--R>=0&&E[R]==="\\";)p=!p;return p?"|":" |"}),a=y.split(/ \|/),v=0;if(a[0].trim()||a.shift(),a.length>0&&!a[a.length-1].trim()&&a.pop(),a.length>u)a.splice(u);else for(;a.length<u;)a.push("");for(;v<a.length;v++)a[v]=a[v].trim().replace(/\\\|/g,"|");return a}function V(z,u,y){var a=z.length;if(a===0)return"";for(var v=0;v<a;){var F=z.charAt(a-v-1);if(F===u&&!y)v++;else if(F!==u&&y)v++;else break}return z.slice(0,a-v)}function N(z,u){if(z.indexOf(u[1])===-1)return-1;for(var y=z.length,a=0,v=0;v<y;v++)if(z[v]==="\\")v++;else if(z[v]===u[0])a++;else if(z[v]===u[1]&&(a--,a<0))return v;return-1}function x(z){z&&z.sanitize&&!z.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function j(z,u){if(u<1)return"";for(var y="";u>1;)u&1&&(y+=z),u>>=1,z+=z;return y+z}function Y(z,u,y,a){var v=u.href,F=u.title?e(u.title):null,s=z[1].replace(/\\([\[\]])/g,"$1");if(z[0].charAt(0)!=="!"){a.state.inLink=!0;var E={type:"link",raw:y,href:v,title:F,text:s,tokens:a.inlineTokens(s)};return a.state.inLink=!1,E}return{type:"image",raw:y,href:v,title:F,text:e(s)}}function K(z,u){var y=z.match(/^(\s+)(?:```)/);if(y===null)return u;var a=y[1];return u.split(`
`).map(function(v){var F=v.match(/^\s+/);if(F===null)return v;var s=F[0];return s.length>=a.length?v.slice(a.length):v}).join(`
`)}var ae=function(){function z(y){this.options=y||se.defaults}var u=z.prototype;return u.space=function(a){var v=this.rules.block.newline.exec(a);if(v&&v[0].length>0)return{type:"space",raw:v[0]}},u.code=function(a){var v=this.rules.block.code.exec(a);if(v){var F=v[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:v[0],codeBlockStyle:"indented",text:this.options.pedantic?F:V(F,`
`)}}},u.fences=function(a){var v=this.rules.block.fences.exec(a);if(v){var F=v[0],s=K(F,v[3]||"");return{type:"code",raw:F,lang:v[2]?v[2].trim():v[2],text:s}}},u.heading=function(a){var v=this.rules.block.heading.exec(a);if(v){var F=v[2].trim();if(/#$/.test(F)){var s=V(F,"#");(this.options.pedantic||!s||/ $/.test(s))&&(F=s.trim())}return{type:"heading",raw:v[0],depth:v[1].length,text:F,tokens:this.lexer.inline(F)}}},u.hr=function(a){var v=this.rules.block.hr.exec(a);if(v)return{type:"hr",raw:v[0]}},u.blockquote=function(a){var v=this.rules.block.blockquote.exec(a);if(v){var F=v[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:v[0],tokens:this.lexer.blockTokens(F,[]),text:F}}},u.list=function(a){var v=this.rules.block.list.exec(a);if(v){var F,s,E,p,R,O,U,Z,oe,pe,fe,Re,Pe=v[1].trim(),je=Pe.length>1,Se={type:"list",raw:"",ordered:je,start:je?+Pe.slice(0,-1):"",loose:!1,items:[]};Pe=je?"\\d{1,9}\\"+Pe.slice(-1):"\\"+Pe,this.options.pedantic&&(Pe=je?Pe:"[*+-]");for(var Ce=new RegExp("^( {0,3}"+Pe+")((?:[	 ][^\\n]*)?(?:\\n|$))");a&&(Re=!1,!(!(v=Ce.exec(a))||this.rules.block.hr.test(a)));){if(F=v[0],a=a.substring(F.length),Z=v[2].split(`
`,1)[0],oe=a.split(`
`,1)[0],this.options.pedantic?(p=2,fe=Z.trimLeft()):(p=v[2].search(/[^ ]/),p=p>4?1:p,fe=Z.slice(p),p+=v[1].length),O=!1,!Z&&/^ *$/.test(oe)&&(F+=oe+`
`,a=a.substring(oe.length+1),Re=!0),!Re)for(var We=new RegExp("^ {0,"+Math.min(3,p-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Xe=new RegExp("^ {0,"+Math.min(3,p-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ue=new RegExp("^ {0,"+Math.min(3,p-1)+"}(?:```|~~~)"),_e=new RegExp("^ {0,"+Math.min(3,p-1)+"}#");a&&(pe=a.split(`
`,1)[0],Z=pe,this.options.pedantic&&(Z=Z.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ue.test(Z)||_e.test(Z)||We.test(Z)||Xe.test(a)));){if(Z.search(/[^ ]/)>=p||!Z.trim())fe+=`
`+Z.slice(p);else if(!O)fe+=`
`+Z;else break;!O&&!Z.trim()&&(O=!0),F+=pe+`
`,a=a.substring(pe.length+1)}Se.loose||(U?Se.loose=!0:/\n *\n *$/.test(F)&&(U=!0)),this.options.gfm&&(s=/^\[[ xX]\] /.exec(fe),s&&(E=s[0]!=="[ ] ",fe=fe.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:F,task:!!s,checked:E,loose:!1,text:fe}),Se.raw+=F}Se.items[Se.items.length-1].raw=F.trimRight(),Se.items[Se.items.length-1].text=fe.trimRight(),Se.raw=Se.raw.trimRight();var J=Se.items.length;for(R=0;R<J;R++){this.lexer.state.top=!1,Se.items[R].tokens=this.lexer.blockTokens(Se.items[R].text,[]);var ne=Se.items[R].tokens.filter(function(ve){return ve.type==="space"}),$e=ne.every(function(ve){for(var Ne=ve.raw.split(""),ze=0,Ve=H(Ne),et;!(et=Ve()).done;){var it=et.value;if(it===`
`&&(ze+=1),ze>1)return!0}return!1});!Se.loose&&ne.length&&$e&&(Se.loose=!0,Se.items[R].loose=!0)}return Se}},u.html=function(a){var v=this.rules.block.html.exec(a);if(v){var F={type:"html",raw:v[0],pre:!this.options.sanitizer&&(v[1]==="pre"||v[1]==="script"||v[1]==="style"),text:v[0]};if(this.options.sanitize){var s=this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]);F.type="paragraph",F.text=s,F.tokens=this.lexer.inline(s)}return F}},u.def=function(a){var v=this.rules.block.def.exec(a);if(v){v[3]&&(v[3]=v[3].substring(1,v[3].length-1));var F=v[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:F,raw:v[0],href:v[2],title:v[3]}}},u.table=function(a){var v=this.rules.block.table.exec(a);if(v){var F={type:"table",header:I(v[1]).map(function(U){return{text:U}}),align:v[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:v[3]&&v[3].trim()?v[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(F.header.length===F.align.length){F.raw=v[0];var s=F.align.length,E,p,R,O;for(E=0;E<s;E++)/^ *-+: *$/.test(F.align[E])?F.align[E]="right":/^ *:-+: *$/.test(F.align[E])?F.align[E]="center":/^ *:-+ *$/.test(F.align[E])?F.align[E]="left":F.align[E]=null;for(s=F.rows.length,E=0;E<s;E++)F.rows[E]=I(F.rows[E],F.header.length).map(function(U){return{text:U}});for(s=F.header.length,p=0;p<s;p++)F.header[p].tokens=this.lexer.inline(F.header[p].text);for(s=F.rows.length,p=0;p<s;p++)for(O=F.rows[p],R=0;R<O.length;R++)O[R].tokens=this.lexer.inline(O[R].text);return F}}},u.lheading=function(a){var v=this.rules.block.lheading.exec(a);if(v)return{type:"heading",raw:v[0],depth:v[2].charAt(0)==="="?1:2,text:v[1],tokens:this.lexer.inline(v[1])}},u.paragraph=function(a){var v=this.rules.block.paragraph.exec(a);if(v){var F=v[1].charAt(v[1].length-1)===`
`?v[1].slice(0,-1):v[1];return{type:"paragraph",raw:v[0],text:F,tokens:this.lexer.inline(F)}}},u.text=function(a){var v=this.rules.block.text.exec(a);if(v)return{type:"text",raw:v[0],text:v[0],tokens:this.lexer.inline(v[0])}},u.escape=function(a){var v=this.rules.inline.escape.exec(a);if(v)return{type:"escape",raw:v[0],text:e(v[1])}},u.tag=function(a){var v=this.rules.inline.tag.exec(a);if(v)return!this.lexer.state.inLink&&/^<a /i.test(v[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(v[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(v[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(v[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:v[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(v[0]):e(v[0]):v[0]}},u.link=function(a){var v=this.rules.inline.link.exec(a);if(v){var F=v[2].trim();if(!this.options.pedantic&&/^</.test(F)){if(!/>$/.test(F))return;var s=V(F.slice(0,-1),"\\");if((F.length-s.length)%2===0)return}else{var E=N(v[2],"()");if(E>-1){var p=v[0].indexOf("!")===0?5:4,R=p+v[1].length+E;v[2]=v[2].substring(0,E),v[0]=v[0].substring(0,R).trim(),v[3]=""}}var O=v[2],U="";if(this.options.pedantic){var Z=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(O);Z&&(O=Z[1],U=Z[3])}else U=v[3]?v[3].slice(1,-1):"";return O=O.trim(),/^</.test(O)&&(this.options.pedantic&&!/>$/.test(F)?O=O.slice(1):O=O.slice(1,-1)),Y(v,{href:O&&O.replace(this.rules.inline._escapes,"$1"),title:U&&U.replace(this.rules.inline._escapes,"$1")},v[0],this.lexer)}},u.reflink=function(a,v){var F;if((F=this.rules.inline.reflink.exec(a))||(F=this.rules.inline.nolink.exec(a))){var s=(F[2]||F[1]).replace(/\s+/g," ");if(s=v[s.toLowerCase()],!s||!s.href){var E=F[0].charAt(0);return{type:"text",raw:E,text:E}}return Y(F,s,F[0],this.lexer)}},u.emStrong=function(a,v,F){F===void 0&&(F="");var s=this.rules.inline.emStrong.lDelim.exec(a);if(s&&!(s[3]&&F.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var E=s[1]||s[2]||"";if(!E||E&&(F===""||this.rules.inline.punctuation.exec(F))){var p=s[0].length-1,R,O,U=p,Z=0,oe=s[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(oe.lastIndex=0,v=v.slice(-1*a.length+p);(s=oe.exec(v))!=null;)if(R=s[1]||s[2]||s[3]||s[4]||s[5]||s[6],!!R){if(O=R.length,s[3]||s[4]){U+=O;continue}else if((s[5]||s[6])&&p%3&&!((p+O)%3)){Z+=O;continue}if(U-=O,!(U>0)){if(O=Math.min(O,O+U+Z),Math.min(p,O)%2){var pe=a.slice(1,p+s.index+O);return{type:"em",raw:a.slice(0,p+s.index+O+1),text:pe,tokens:this.lexer.inlineTokens(pe)}}var fe=a.slice(2,p+s.index+O-1);return{type:"strong",raw:a.slice(0,p+s.index+O+1),text:fe,tokens:this.lexer.inlineTokens(fe)}}}}}},u.codespan=function(a){var v=this.rules.inline.code.exec(a);if(v){var F=v[2].replace(/\n/g," "),s=/[^ ]/.test(F),E=/^ /.test(F)&&/ $/.test(F);return s&&E&&(F=F.substring(1,F.length-1)),F=e(F,!0),{type:"codespan",raw:v[0],text:F}}},u.br=function(a){var v=this.rules.inline.br.exec(a);if(v)return{type:"br",raw:v[0]}},u.del=function(a){var v=this.rules.inline.del.exec(a);if(v)return{type:"del",raw:v[0],text:v[2],tokens:this.lexer.inlineTokens(v[2])}},u.autolink=function(a,v){var F=this.rules.inline.autolink.exec(a);if(F){var s,E;return F[2]==="@"?(s=e(this.options.mangle?v(F[1]):F[1]),E="mailto:"+s):(s=e(F[1]),E=s),{type:"link",raw:F[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},u.url=function(a,v){var F;if(F=this.rules.inline.url.exec(a)){var s,E;if(F[2]==="@")s=e(this.options.mangle?v(F[0]):F[0]),E="mailto:"+s;else{var p;do p=F[0],F[0]=this.rules.inline._backpedal.exec(F[0])[0];while(p!==F[0]);s=e(F[0]),F[1]==="www."?E="http://"+s:E=s}return{type:"link",raw:F[0],text:s,href:E,tokens:[{type:"text",raw:s,text:s}]}}},u.inlineText=function(a,v){var F=this.rules.inline.text.exec(a);if(F){var s;return this.lexer.state.inRawBlock?s=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(F[0]):e(F[0]):F[0]:s=e(this.options.smartypants?v(F[0]):F[0]),{type:"text",raw:F[0],text:s}}},z}(),ie={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:q,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ie._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ie._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ie.def=f(ie.def).replace("label",ie._label).replace("title",ie._title).getRegex(),ie.bullet=/(?:[*+-]|\d{1,9}[.)])/,ie.listItemStart=f(/^( *)(bull) */).replace("bull",ie.bullet).getRegex(),ie.list=f(ie.list).replace(/bull/g,ie.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ie.def.source+")").getRegex(),ie._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ie._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ie.html=f(ie.html,"i").replace("comment",ie._comment).replace("tag",ie._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ie.paragraph=f(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.blockquote=f(ie.blockquote).replace("paragraph",ie.paragraph).getRegex(),ie.normal=$({},ie),ie.gfm=$({},ie.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ie.gfm.table=f(ie.gfm.table).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.gfm.paragraph=f(ie._paragraph).replace("hr",ie.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ie.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ie._tag).getRegex(),ie.pedantic=$({},ie.normal,{html:f(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ie._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:q,paragraph:f(ie.normal._paragraph).replace("hr",ie.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ie.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ee={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:q,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:q,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ee._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ee.punctuation=f(ee.punctuation).replace(/punctuation/g,ee._punctuation).getRegex(),ee.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ee.escapedEmSt=/\\\*|\\_/g,ee._comment=f(ie._comment).replace("(?:-->|$)","-->").getRegex(),ee.emStrong.lDelim=f(ee.emStrong.lDelim).replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimAst=f(ee.emStrong.rDelimAst,"g").replace(/punct/g,ee._punctuation).getRegex(),ee.emStrong.rDelimUnd=f(ee.emStrong.rDelimUnd,"g").replace(/punct/g,ee._punctuation).getRegex(),ee._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ee._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ee._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ee.autolink=f(ee.autolink).replace("scheme",ee._scheme).replace("email",ee._email).getRegex(),ee._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ee.tag=f(ee.tag).replace("comment",ee._comment).replace("attribute",ee._attribute).getRegex(),ee._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ee._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ee._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ee.link=f(ee.link).replace("label",ee._label).replace("href",ee._href).replace("title",ee._title).getRegex(),ee.reflink=f(ee.reflink).replace("label",ee._label).replace("ref",ie._label).getRegex(),ee.nolink=f(ee.nolink).replace("ref",ie._label).getRegex(),ee.reflinkSearch=f(ee.reflinkSearch,"g").replace("reflink",ee.reflink).replace("nolink",ee.nolink).getRegex(),ee.normal=$({},ee),ee.pedantic=$({},ee.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:f(/^!?\[(label)\]\((.*?)\)/).replace("label",ee._label).getRegex(),reflink:f(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ee._label).getRegex()}),ee.gfm=$({},ee.normal,{escape:f(ee.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ee.gfm.url=f(ee.gfm.url,"i").replace("email",ee.gfm._extended_email).getRegex(),ee.breaks=$({},ee.gfm,{br:f(ee.br).replace("{2,}","*").getRegex(),text:f(ee.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ce(z){return z.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function De(z){var u="",y,a,v=z.length;for(y=0;y<v;y++)a=z.charCodeAt(y),Math.random()>.5&&(a="x"+a.toString(16)),u+="&#"+a+";";return u}var Ee=function(){function z(y){this.tokens=[],this.tokens.links=Object.create(null),this.options=y||se.defaults,this.options.tokenizer=this.options.tokenizer||new ae,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var a={block:ie.normal,inline:ee.normal};this.options.pedantic?(a.block=ie.pedantic,a.inline=ee.pedantic):this.options.gfm&&(a.block=ie.gfm,this.options.breaks?a.inline=ee.breaks:a.inline=ee.gfm),this.tokenizer.rules=a}z.lex=function(a,v){var F=new z(v);return F.lex(a)},z.lexInline=function(a,v){var F=new z(v);return F.inlineTokens(a)};var u=z.prototype;return u.lex=function(a){a=a.replace(/\r\n|\r/g,`
`),this.blockTokens(a,this.tokens);for(var v;v=this.inlineQueue.shift();)this.inlineTokens(v.src,v.tokens);return this.tokens},u.blockTokens=function(a,v){var F=this;v===void 0&&(v=[]),this.options.pedantic?a=a.replace(/\t/g,"    ").replace(/^ +$/gm,""):a=a.replace(/^( *)(\t+)/gm,function(U,Z,oe){return Z+"    ".repeat(oe.length)});for(var s,E,p,R;a;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(U){return(s=U.call({lexer:F},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.space(a)){a=a.substring(s.raw.length),s.raw.length===1&&v.length>0?v[v.length-1].raw+=`
`:v.push(s);continue}if(s=this.tokenizer.code(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s);continue}if(s=this.tokenizer.fences(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.heading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.hr(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.blockquote(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.list(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.html(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.def(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&(E.type==="paragraph"||E.type==="text")?(E.raw+=`
`+s.raw,E.text+=`
`+s.raw,this.inlineQueue[this.inlineQueue.length-1].src=E.text):this.tokens.links[s.tag]||(this.tokens.links[s.tag]={href:s.href,title:s.title});continue}if(s=this.tokenizer.table(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.lheading(a)){a=a.substring(s.raw.length),v.push(s);continue}if(p=a,this.options.extensions&&this.options.extensions.startBlock&&function(){var U=1/0,Z=a.slice(1),oe=void 0;F.options.extensions.startBlock.forEach(function(pe){oe=pe.call({lexer:this},Z),typeof oe=="number"&&oe>=0&&(U=Math.min(U,oe))}),U<1/0&&U>=0&&(p=a.substring(0,U+1))}(),this.state.top&&(s=this.tokenizer.paragraph(p))){E=v[v.length-1],R&&E.type==="paragraph"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s),R=p.length!==a.length,a=a.substring(s.raw.length);continue}if(s=this.tokenizer.text(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&E.type==="text"?(E.raw+=`
`+s.raw,E.text+=`
`+s.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=E.text):v.push(s);continue}if(a){var O="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(O);break}else throw new Error(O)}}return this.state.top=!0,v},u.inline=function(a,v){return v===void 0&&(v=[]),this.inlineQueue.push({src:a,tokens:v}),v},u.inlineTokens=function(a,v){var F=this;v===void 0&&(v=[]);var s,E,p,R=a,O,U,Z;if(this.tokens.links){var oe=Object.keys(this.tokens.links);if(oe.length>0)for(;(O=this.tokenizer.rules.inline.reflinkSearch.exec(R))!=null;)oe.includes(O[0].slice(O[0].lastIndexOf("[")+1,-1))&&(R=R.slice(0,O.index)+"["+j("a",O[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(O=this.tokenizer.rules.inline.blockSkip.exec(R))!=null;)R=R.slice(0,O.index)+"["+j("a",O[0].length-2)+"]"+R.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(O=this.tokenizer.rules.inline.escapedEmSt.exec(R))!=null;)R=R.slice(0,O.index)+"++"+R.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;a;)if(U||(Z=""),U=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(fe){return(s=fe.call({lexer:F},a,v))?(a=a.substring(s.raw.length),v.push(s),!0):!1}))){if(s=this.tokenizer.escape(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.tag(a)){a=a.substring(s.raw.length),E=v[v.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(s=this.tokenizer.link(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.reflink(a,this.tokens.links)){a=a.substring(s.raw.length),E=v[v.length-1],E&&s.type==="text"&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(s=this.tokenizer.emStrong(a,R,Z)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.codespan(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.br(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.del(a)){a=a.substring(s.raw.length),v.push(s);continue}if(s=this.tokenizer.autolink(a,De)){a=a.substring(s.raw.length),v.push(s);continue}if(!this.state.inLink&&(s=this.tokenizer.url(a,De))){a=a.substring(s.raw.length),v.push(s);continue}if(p=a,this.options.extensions&&this.options.extensions.startInline&&function(){var fe=1/0,Re=a.slice(1),Pe=void 0;F.options.extensions.startInline.forEach(function(je){Pe=je.call({lexer:this},Re),typeof Pe=="number"&&Pe>=0&&(fe=Math.min(fe,Pe))}),fe<1/0&&fe>=0&&(p=a.substring(0,fe+1))}(),s=this.tokenizer.inlineText(p,ce)){a=a.substring(s.raw.length),s.raw.slice(-1)!=="_"&&(Z=s.raw.slice(-1)),U=!0,E=v[v.length-1],E&&E.type==="text"?(E.raw+=s.raw,E.text+=s.text):v.push(s);continue}if(a){var pe="Infinite loop on byte: "+a.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return v},n(z,null,[{key:"rules",get:function(){return{block:ie,inline:ee}}}]),z}(),Le=function(){function z(y){this.options=y||se.defaults}var u=z.prototype;return u.code=function(a,v,F){var s=(v||"").match(/\S*/)[0];if(this.options.highlight){var E=this.options.highlight(a,s);E!=null&&E!==a&&(F=!0,a=E)}return a=a.replace(/\n$/,"")+`
`,s?'<pre><code class="'+this.options.langPrefix+e(s,!0)+'">'+(F?a:e(a,!0))+`</code></pre>
`:"<pre><code>"+(F?a:e(a,!0))+`</code></pre>
`},u.blockquote=function(a){return`<blockquote>
`+a+`</blockquote>
`},u.html=function(a){return a},u.heading=function(a,v,F,s){if(this.options.headerIds){var E=this.options.headerPrefix+s.slug(F);return"<h"+v+' id="'+E+'">'+a+"</h"+v+`>
`}return"<h"+v+">"+a+"</h"+v+`>
`},u.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},u.list=function(a,v,F){var s=v?"ol":"ul",E=v&&F!==1?' start="'+F+'"':"";return"<"+s+E+`>
`+a+"</"+s+`>
`},u.listitem=function(a){return"<li>"+a+`</li>
`},u.checkbox=function(a){return"<input "+(a?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},u.paragraph=function(a){return"<p>"+a+`</p>
`},u.table=function(a,v){return v&&(v="<tbody>"+v+"</tbody>"),`<table>
<thead>
`+a+`</thead>
`+v+`</table>
`},u.tablerow=function(a){return`<tr>
`+a+`</tr>
`},u.tablecell=function(a,v){var F=v.header?"th":"td",s=v.align?"<"+F+' align="'+v.align+'">':"<"+F+">";return s+a+("</"+F+`>
`)},u.strong=function(a){return"<strong>"+a+"</strong>"},u.em=function(a){return"<em>"+a+"</em>"},u.codespan=function(a){return"<code>"+a+"</code>"},u.br=function(){return this.options.xhtml?"<br/>":"<br>"},u.del=function(a){return"<del>"+a+"</del>"},u.link=function(a,v,F){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return F;var s='<a href="'+e(a)+'"';return v&&(s+=' title="'+v+'"'),s+=">"+F+"</a>",s},u.image=function(a,v,F){if(a=b(this.options.sanitize,this.options.baseUrl,a),a===null)return F;var s='<img src="'+a+'" alt="'+F+'"';return v&&(s+=' title="'+v+'"'),s+=this.options.xhtml?"/>":">",s},u.text=function(a){return a},z}(),le=function(){function z(){}var u=z.prototype;return u.strong=function(a){return a},u.em=function(a){return a},u.codespan=function(a){return a},u.del=function(a){return a},u.html=function(a){return a},u.text=function(a){return a},u.link=function(a,v,F){return""+F},u.image=function(a,v,F){return""+F},u.br=function(){return""},z}(),_=function(){function z(){this.seen={}}var u=z.prototype;return u.serialize=function(a){return a.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},u.getNextSafeSlug=function(a,v){var F=a,s=0;if(this.seen.hasOwnProperty(F)){s=this.seen[a];do s++,F=a+"-"+s;while(this.seen.hasOwnProperty(F))}return v||(this.seen[a]=s,this.seen[F]=0),F},u.slug=function(a,v){v===void 0&&(v={});var F=this.serialize(a);return this.getNextSafeSlug(F,v.dryrun)},z}(),ue=function(){function z(y){this.options=y||se.defaults,this.options.renderer=this.options.renderer||new Le,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new le,this.slugger=new _}z.parse=function(a,v){var F=new z(v);return F.parse(a)},z.parseInline=function(a,v){var F=new z(v);return F.parseInline(a)};var u=z.prototype;return u.parse=function(a,v){v===void 0&&(v=!0);var F="",s,E,p,R,O,U,Z,oe,pe,fe,Re,Pe,je,Se,Ce,We,Xe,Ue,_e,J=a.length;for(s=0;s<J;s++){if(fe=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[fe.type]&&(_e=this.options.extensions.renderers[fe.type].call({parser:this},fe),_e!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(fe.type))){F+=_e||"";continue}switch(fe.type){case"space":continue;case"hr":{F+=this.renderer.hr();continue}case"heading":{F+=this.renderer.heading(this.parseInline(fe.tokens),fe.depth,o(this.parseInline(fe.tokens,this.textRenderer)),this.slugger);continue}case"code":{F+=this.renderer.code(fe.text,fe.lang,fe.escaped);continue}case"table":{for(oe="",Z="",R=fe.header.length,E=0;E<R;E++)Z+=this.renderer.tablecell(this.parseInline(fe.header[E].tokens),{header:!0,align:fe.align[E]});for(oe+=this.renderer.tablerow(Z),pe="",R=fe.rows.length,E=0;E<R;E++){for(U=fe.rows[E],Z="",O=U.length,p=0;p<O;p++)Z+=this.renderer.tablecell(this.parseInline(U[p].tokens),{header:!1,align:fe.align[p]});pe+=this.renderer.tablerow(Z)}F+=this.renderer.table(oe,pe);continue}case"blockquote":{pe=this.parse(fe.tokens),F+=this.renderer.blockquote(pe);continue}case"list":{for(Re=fe.ordered,Pe=fe.start,je=fe.loose,R=fe.items.length,pe="",E=0;E<R;E++)Ce=fe.items[E],We=Ce.checked,Xe=Ce.task,Se="",Ce.task&&(Ue=this.renderer.checkbox(We),je?Ce.tokens.length>0&&Ce.tokens[0].type==="paragraph"?(Ce.tokens[0].text=Ue+" "+Ce.tokens[0].text,Ce.tokens[0].tokens&&Ce.tokens[0].tokens.length>0&&Ce.tokens[0].tokens[0].type==="text"&&(Ce.tokens[0].tokens[0].text=Ue+" "+Ce.tokens[0].tokens[0].text)):Ce.tokens.unshift({type:"text",text:Ue}):Se+=Ue),Se+=this.parse(Ce.tokens,je),pe+=this.renderer.listitem(Se,Xe,We);F+=this.renderer.list(pe,Re,Pe);continue}case"html":{F+=this.renderer.html(fe.text);continue}case"paragraph":{F+=this.renderer.paragraph(this.parseInline(fe.tokens));continue}case"text":{for(pe=fe.tokens?this.parseInline(fe.tokens):fe.text;s+1<J&&a[s+1].type==="text";)fe=a[++s],pe+=`
`+(fe.tokens?this.parseInline(fe.tokens):fe.text);F+=v?this.renderer.paragraph(pe):pe;continue}default:{var ne='Token with "'+fe.type+'" type was not found.';if(this.options.silent){console.error(ne);return}else throw new Error(ne)}}}return F},u.parseInline=function(a,v){v=v||this.renderer;var F="",s,E,p,R=a.length;for(s=0;s<R;s++){if(E=a[s],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[E.type]&&(p=this.options.extensions.renderers[E.type].call({parser:this},E),p!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(E.type))){F+=p||"";continue}switch(E.type){case"escape":{F+=v.text(E.text);break}case"html":{F+=v.html(E.text);break}case"link":{F+=v.link(E.href,E.title,this.parseInline(E.tokens,v));break}case"image":{F+=v.image(E.href,E.title,E.text);break}case"strong":{F+=v.strong(this.parseInline(E.tokens,v));break}case"em":{F+=v.em(this.parseInline(E.tokens,v));break}case"codespan":{F+=v.codespan(E.text);break}case"br":{F+=v.br();break}case"del":{F+=v.del(this.parseInline(E.tokens,v));break}case"text":{F+=v.text(E.text);break}default:{var O='Token with "'+E.type+'" type was not found.';if(this.options.silent){console.error(O);return}else throw new Error(O)}}}return F},z}();function re(z,u,y){if(typeof z>"u"||z===null)throw new Error("marked(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");if(typeof u=="function"&&(y=u,u=null),u=$({},re.defaults,u||{}),x(u),y){var a=u.highlight,v;try{v=Ee.lex(z,u)}catch(R){return y(R)}var F=function(O){var U;if(!O)try{u.walkTokens&&re.walkTokens(v,u.walkTokens),U=ue.parse(v,u)}catch(Z){O=Z}return u.highlight=a,O?y(O):y(null,U)};if(!a||a.length<3||(delete u.highlight,!v.length))return F();var s=0;re.walkTokens(v,function(R){R.type==="code"&&(s++,setTimeout(function(){a(R.text,R.lang,function(O,U){if(O)return F(O);U!=null&&U!==R.text&&(R.text=U,R.escaped=!0),s--,s===0&&F()})},0))}),s===0&&F();return}function E(R){if(R.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(R.message+"",!0)+"</pre>";throw R}try{var p=Ee.lex(z,u);if(u.walkTokens){if(u.async)return Promise.all(re.walkTokens(p,u.walkTokens)).then(function(){return ue.parse(p,u)}).catch(E);re.walkTokens(p,u.walkTokens)}return ue.parse(p,u)}catch(R){E(R)}}re.options=re.setOptions=function(z){return $(re.defaults,z),P(re.defaults),re},re.getDefaults=A,re.defaults=se.defaults,re.use=function(){for(var z=arguments.length,u=new Array(z),y=0;y<z;y++)u[y]=arguments[y];var a=$.apply(void 0,[{}].concat(u)),v=re.defaults.extensions||{renderers:{},childTokens:{}},F;u.forEach(function(s){if(s.extensions&&(F=!0,s.extensions.forEach(function(p){if(!p.name)throw new Error("extension name required");if(p.renderer){var R=v.renderers?v.renderers[p.name]:null;R?v.renderers[p.name]=function(){for(var O=arguments.length,U=new Array(O),Z=0;Z<O;Z++)U[Z]=arguments[Z];var oe=p.renderer.apply(this,U);return oe===!1&&(oe=R.apply(this,U)),oe}:v.renderers[p.name]=p.renderer}if(p.tokenizer){if(!p.level||p.level!=="block"&&p.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");v[p.level]?v[p.level].unshift(p.tokenizer):v[p.level]=[p.tokenizer],p.start&&(p.level==="block"?v.startBlock?v.startBlock.push(p.start):v.startBlock=[p.start]:p.level==="inline"&&(v.startInline?v.startInline.push(p.start):v.startInline=[p.start]))}p.childTokens&&(v.childTokens[p.name]=p.childTokens)})),s.renderer&&function(){var p=re.defaults.renderer||new Le,R=function(Z){var oe=p[Z];p[Z]=function(){for(var pe=arguments.length,fe=new Array(pe),Re=0;Re<pe;Re++)fe[Re]=arguments[Re];var Pe=s.renderer[Z].apply(p,fe);return Pe===!1&&(Pe=oe.apply(p,fe)),Pe}};for(var O in s.renderer)R(O);a.renderer=p}(),s.tokenizer&&function(){var p=re.defaults.tokenizer||new ae,R=function(Z){var oe=p[Z];p[Z]=function(){for(var pe=arguments.length,fe=new Array(pe),Re=0;Re<pe;Re++)fe[Re]=arguments[Re];var Pe=s.tokenizer[Z].apply(p,fe);return Pe===!1&&(Pe=oe.apply(p,fe)),Pe}};for(var O in s.tokenizer)R(O);a.tokenizer=p}(),s.walkTokens){var E=re.defaults.walkTokens;a.walkTokens=function(p){var R=[];return R.push(s.walkTokens.call(this,p)),E&&(R=R.concat(E.call(this,p))),R}}F&&(a.extensions=v),re.setOptions(a)})},re.walkTokens=function(z,u){for(var y=[],a=function(){var E=F.value;switch(y=y.concat(u.call(re,E)),E.type){case"table":{for(var p=H(E.header),R;!(R=p()).done;){var O=R.value;y=y.concat(re.walkTokens(O.tokens,u))}for(var U=H(E.rows),Z;!(Z=U()).done;)for(var oe=Z.value,pe=H(oe),fe;!(fe=pe()).done;){var Re=fe.value;y=y.concat(re.walkTokens(Re.tokens,u))}break}case"list":{y=y.concat(re.walkTokens(E.items,u));break}default:re.defaults.extensions&&re.defaults.extensions.childTokens&&re.defaults.extensions.childTokens[E.type]?re.defaults.extensions.childTokens[E.type].forEach(function(Pe){y=y.concat(re.walkTokens(E[Pe],u))}):E.tokens&&(y=y.concat(re.walkTokens(E.tokens,u)))}},v=H(z),F;!(F=v()).done;)a();return y},re.parseInline=function(z,u){if(typeof z>"u"||z===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof z!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(z)+", string expected");u=$({},re.defaults,u||{}),x(u);try{var y=Ee.lexInline(z,u);return u.walkTokens&&re.walkTokens(y,u.walkTokens),ue.parseInline(y,u)}catch(a){if(a.message+=`
Please report this to https://github.com/markedjs/marked.`,u.silent)return"<p>An error occurred:</p><pre>"+e(a.message+"",!0)+"</pre>";throw a}},re.Parser=ue,re.parser=ue.parse,re.Renderer=Le,re.TextRenderer=le,re.Lexer=Ee,re.lexer=Ee.lex,re.Tokenizer=ae,re.Slugger=_,re.parse=re;var ye=re.options,W=re.setOptions,Q=re.use,ge=re.walkTokens,we=re.parseInline,ke=re,Te=ue.parse,Ie=Ee.lex;se.Lexer=Ee,se.Parser=ue,se.Renderer=Le,se.Slugger=_,se.TextRenderer=le,se.Tokenizer=ae,se.getDefaults=A,se.lexer=Ie,se.marked=re,se.options=ye,se.parse=ke,se.parseInline=we,se.parser=Te,se.setOptions=W,se.use=Q,se.walkTokens=ge,Object.defineProperty(se,"__esModule",{value:!0})}),define(me[89],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uk=n;function n(i){const o=H(i);if(o&&o.length>0)return new Uint32Array(o)}let C=0;const B=new Uint32Array(10);function H(i){if(C=0,A(i,M,4352),C>0||(A(i,c,4449),C>0)||(A(i,h,4520),C>0)||(A(i,e,12593),C))return B.subarray(0,C);if(i>=44032&&i<=55203){const o=i-44032,l=o%588,f=Math.floor(o/588),S=Math.floor(l/28),m=l%28-1;if(f<M.length?A(f,M,0):4352+f-12593<e.length&&A(4352+f,e,12593),S<c.length?A(S,c,0):4449+S-12593<e.length&&A(4449+S-12593,e,12593),m>=0&&(m<h.length?A(m,h,0):4520+m-12593<e.length&&A(4520+m-12593,e,12593)),C>0)return B.subarray(0,C)}}function A(i,o,l){i>=l&&i<l+o.length&&P(o[i-l])}function P(i){i!==0&&(B[C++]=i&255,i>>8&&(B[C++]=i>>8&255),i>>16&&(B[C++]=i>>16&255))}var d;(function(i){i[i.InitialConsonant=4352]="InitialConsonant",i[i.Vowel=4449]="Vowel",i[i.FinalConsonant=4520]="FinalConsonant",i[i.CompatibilityJamo=12593]="CompatibilityJamo"})(d||(d={}));var g;(function(i){i[i.NUL=0]="NUL",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z"})(g||(g={}));var w;(function(i){i[i.fa=24934]="fa",i[i.fg=26470]="fg",i[i.fq=29030]="fq",i[i.fr=29286]="fr",i[i.ft=29798]="ft",i[i.fv=30310]="fv",i[i.fx=30822]="fx",i[i.hk=27496]="hk",i[i.hl=27752]="hl",i[i.ho=28520]="ho",i[i.ml=27757]="ml",i[i.nj=27246]="nj",i[i.nl=27758]="nl",i[i.np=28782]="np",i[i.qt=29809]="qt",i[i.rt=29810]="rt",i[i.sg=26483]="sg",i[i.sw=30579]="sw"})(w||(w={}));const M=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),c=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),h=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),e=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(me[90],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$gV=void 0;class n{constructor(B,H=0,A=B.length,P=H-1){this.a=B,this.b=H,this.c=A,this.d=P}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.$gV=n}),define(me[91],be([1,0,90]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$iV=t.$hV=void 0;class C{constructor(A=[],P=10){this.h(A),this.b=P,this.d()}getHistory(){return this.j}add(A){this.a.delete(A),this.a.add(A),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(A){return this.a.has(A)}clear(){this.h([]),this.d()}d(){this.f();const A=this.j;this.c=new n.$gV(A,0,A.length,A.length)}f(){const A=this.j;A.length>this.b&&this.h(A.slice(A.length-this.b))}g(){const A=this.c.current();return A?this.j.indexOf(A):-1}h(A){this.a=new Set;for(const P of A)this.a.add(P)}get j(){const A=[];return this.a.forEach(P=>A.push(P)),A}}t.$hV=C;class B{get size(){return this.f}constructor(A,P=10){if(this.g=P,A.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:A[0],previous:void 0,next:void 0},this.a=new Set([A[0]]);for(let d=1;d<A.length;d++)this.add(A[d])}add(A){const P={value:A,previous:this.c,next:void 0};for(this.c.next=P,this.c=P,this.d=this.c,this.f++,this.a.has(A)?this.h(A):this.a.add(A);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(A){if(this.c.value===A)return A;const P=this.c.value;return this.a.delete(P),this.c.value=A,this.a.has(A)?this.h(A):this.a.add(A),P}prepend(A){if(this.f===this.g||this.a.has(A))return;const P={value:A,previous:void 0,next:this.b};this.b.previous=P,this.b=P,this.f++,this.a.add(A)}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(A){return this.a.has(A)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let A=this.b;for(;A;)yield A.value,A=A.next}h(A){let P=this.b;for(;P!==this.c;)P.value===A&&(P===this.b?(this.b=this.b.next,this.b.previous=void 0):(P.previous.next=P.next,P.next.previous=P.previous),this.f--),P=P.next}}t.$iV=B}),define(me[40],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Em=t.$Dm=t.$Cm=void 0,t.$Am=n,t.rot=C;function n(P,d,g){return Math.min(Math.max(P,d),g)}function C(P,d){return(d+P%d)%d}class B{constructor(){this.a=0}getNext(){return this.a++}}t.$Cm=B;class H{constructor(){this.a=1,this.b=0}update(d){return this.b=this.b+(d-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.$Dm=H;class A{constructor(d){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(d),this.c.fill(0,0,d)}update(d){const g=this.c[this.d];return this.c[this.d]=d,this.d=(this.d+1)%this.c.length,this.e-=g,this.e+=d,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.$Em=A}),define(me[26],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bd=void 0,t.$cd=H,t.$dd=c;class n{constructor(e,i,o){this.owner=e,this.debugNameSource=i,this.referenceFn=o}getDebugName(e){return H(e,this)}}t.$bd=n;const C=new Map,B=new WeakMap;function H(h,e){const i=B.get(h);if(i)return i;const o=A(h,e);if(o){let l=C.get(o)??0;l++,C.set(o,l);const f=l===1?o:`${o}#${l}`;return B.set(h,f),f}}function A(h,e){const i=B.get(h);if(i)return i;const o=e.owner?w(e.owner)+".":"";let l;const f=e.debugNameSource;if(f!==void 0)if(typeof f=="function"){if(l=f(),l!==void 0)return o+l}else return o+f;const S=e.referenceFn;if(S!==void 0&&(l=c(S),l!==void 0))return o+l;if(e.owner!==void 0){const m=P(e.owner,h);if(m!==void 0)return o+m}}function P(h,e){for(const i in h)if(h[i]===e)return i}const d=new Map,g=new WeakMap;function w(h){const e=g.get(h);if(e)return e;const i=M(h);let o=d.get(i)??0;o++,d.set(i,o);const l=o===1?i:`${i}#${o}`;return g.set(h,l),l}function M(h){const e=h.constructor;return e?e.name:"Object"}function c(h){const e=h.toString(),o=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(e);return(o?o[1]:void 0)?.trim()}}),define(me[27],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Kd=void 0,t.$Id=C,t.$Jd=B;let n;function C(i){n=i}function B(){return n}class H{constructor(){this.a=0,this.d=new WeakMap}b(o){return A([P(h("|  ",this.a)),o])}c(o){return o.hadValue?o.didChange?[P(" "),g(w(o.oldValue,70),{color:"red",strikeThrough:!0}),P(" "),g(w(o.newValue,60),{color:"green"})]:[P(" (unchanged)")]:[P(" "),g(w(o.newValue,60),{color:"green"}),P(" (initial)")]}handleObservableChanged(o,l){console.log(...this.b([d("observable value changed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l)]))}formatChanges(o){if(o.size!==0)return g(" (changed deps: "+[...o].map(l=>l.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,S)=>(this.d.get(o).add(f),l.apply(o,[f,S]))}handleDerivedRecomputed(o,l){const f=this.d.get(o);console.log(...this.b([d("derived recomputed"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),this.formatChanges(f),{data:[{fn:o._computeFn}]}])),f.clear()}handleFromEventObservableTriggered(o,l){console.log(...this.b([d("observable from event triggered"),g(o.debugName,{color:"BlueViolet"}),...this.c(l),{data:[{fn:o._getValue}]}]))}handleAutorunCreated(o){const l=o.handleChange;this.d.set(o,new Set),o.handleChange=(f,S)=>(this.d.get(o).add(f),l.apply(o,[f,S]))}handleAutorunTriggered(o){const l=this.d.get(o);console.log(...this.b([d("autorun"),g(o.debugName,{color:"BlueViolet"}),this.formatChanges(l),{data:[{fn:o._runFn}]}])),l.clear(),this.a++}handleAutorunFinished(o){this.a--}handleBeginTransaction(o){let l=o.getDebugName();l===void 0&&(l=""),console.log(...this.b([d("transaction"),g(l,{color:"BlueViolet"}),{data:[{fn:o._fn}]}])),this.a++}handleEndTransaction(){this.a--}}t.$Kd=H;function A(i){const o=new Array,l=[];let f="";function S(b){if("length"in b)for(const r of b)r&&S(r);else"text"in b?(f+=`%c${b.text}`,o.push(b.style),b.data&&l.push(...b.data)):"data"in b&&l.push(...b.data)}S(i);const m=[f,...o];return m.push(...l),m}function P(i){return g(i,{color:"black"})}function d(i){return g(e(`${i}: `,10),{color:"black",bold:!0})}function g(i,o={color:"black"}){function l(S){return Object.entries(S).reduce((m,[b,r])=>`${m}${b}:${r};`,"")}const f={color:o.color};return o.strikeThrough&&(f["text-decoration"]="line-through"),o.bold&&(f["font-weight"]="bold"),{text:i,style:l(f)}}function w(i,o){switch(typeof i){case"number":return""+i;case"string":return i.length+2<=o?`"${i}"`:`"${i.substr(0,o-7)}"+...`;case"boolean":return i?"true":"false";case"undefined":return"undefined";case"object":return i===null?"null":Array.isArray(i)?M(i,o):c(i,o);case"symbol":return i.toString();case"function":return`[[Function${i.name?" "+i.name:""}]]`;default:return""+i}}function M(i,o){let l="[ ",f=!0;for(const S of i){if(f||(l+=", "),l.length-5>o){l+="...";break}f=!1,l+=`${w(S,o-l.length)}`}return l+=" ]",l}function c(i,o){let l="{ ",f=!0;for(const[S,m]of Object.entries(i)){if(f||(l+=", "),l.length-5>o){l+="...";break}f=!1,l+=`${S}: ${w(m,o-l.length)}`}return l+=" }",l}function h(i,o){let l="";for(let f=1;f<=o;f++)l+=i;return l}function e(i,o){for(;i.length<o;)i+=" ";return i}}),define(me[41],be([1,0,37,2,26,27]),function(se,t,n,C,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qd=void 0,t.$kd=A,t.$ld=P,t.$md=d,t.$nd=g,t.$od=w,t.$pd=M;function A(e){return new h(new B.$bd(void 0,void 0,e),e,void 0,void 0)}function P(e,i){return new h(new B.$bd(e.owner,e.debugName,e.debugReferenceFn??i),i,void 0,void 0)}function d(e,i){return new h(new B.$bd(e.owner,e.debugName,e.debugReferenceFn??i),i,e.createEmptyChangeSummary,e.handleChange)}function g(e,i){const o=new C.$Uc,l=d({owner:e.owner,debugName:e.debugName,debugReferenceFn:e.debugReferenceFn,createEmptyChangeSummary:e.createEmptyChangeSummary,handleChange:e.handleChange},(f,S)=>{o.clear(),i(f,S,o)});return(0,C.$Tc)(()=>{l.dispose(),o.dispose()})}function w(e){const i=new C.$Uc,o=P({owner:void 0,debugName:void 0,debugReferenceFn:e},l=>{i.clear(),e(l,i)});return(0,C.$Tc)(()=>{o.dispose(),i.dispose()})}function M(e,i){let o;return P({debugReferenceFn:i},l=>{const f=e.read(l),S=o;o=f,i({lastValue:S,newValue:f})})}var c;(function(e){e[e.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",e[e.stale=2]="stale",e[e.upToDate=3]="upToDate"})(c||(c={}));class h{get debugName(){return this.h.getDebugName(this)??"(anonymous)"}constructor(i,o,l,f){this.h=i,this._runFn=o,this.i=l,this.j=f,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,H.$Jd)()?.handleAutorunCreated(this),this.k(),(0,C.$Mc)(this)}dispose(){this.c=!0;for(const i of this.e)i.removeObserver(this);this.e.clear(),(0,C.$Nc)(this)}k(){if(this.a===3)return;const i=this.f;this.f=this.e,this.e=i,this.a=3;const o=this.c;try{if(!o){(0,H.$Jd)()?.handleAutorunTriggered(this);const l=this.g;this.g=this.i?.(),this._runFn(this,l)}}finally{o||(0,H.$Jd)()?.handleAutorunFinished(this);for(const l of this.f)l.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const i of this.e)if(i.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,n.$id)(()=>this.b>=0)}handlePossibleChange(i){this.a===3&&this.e.has(i)&&!this.f.has(i)&&(this.a=1)}handleChange(i,o){this.e.has(i)&&!this.f.has(i)&&(!this.j||this.j({changedObservable:i,change:o,didChange:f=>f===i},this.g))&&(this.a=2)}readObservable(i){if(this.c)return i.get();i.addObserver(this);const o=i.get();return this.e.add(i),this.f.delete(i),o}}t.$qd=h,function(e){e.Observer=h}(A||(t.$kd=A={}))}),define(me[33],be([1,0,38,26,27]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$6d=t.$4d=t.$1d=t.$Vd=t.$Ud=void 0,t.$Rd=A,t.$Sd=d,t.$Td=w,t.$Wd=h,t.$Xd=i,t.$Yd=o,t.$Zd=l,t.$2d=S,t.$3d=m,t.$5d=r;let H;function A(k){H=k}let P;function d(k){P=k}let g;function w(k){g=k}class M{get TChange(){return null}reportChanges(){this.get()}read(T){return T?T.readObservable(this):this.get()}map(T,L){const q=L===void 0?void 0:T,$=L===void 0?T:L;return g({owner:q,debugName:()=>{const I=(0,C.$dd)($);if(I!==void 0)return I;const N=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec($.toString());if(N)return`${this.debugName}.${N[2]}`;if(!q)return`${this.debugName} (mapped)`},debugReferenceFn:$},I=>$(this.read(I),I))}recomputeInitiallyAndOnChange(T,L){return T.add(H(this,L)),this}keepObserved(T){return T.add(P(this)),this}get a(){return this.get()}}t.$Ud=M;class c extends M{constructor(){super(...arguments),this.b=new Set}addObserver(T){const L=this.b.size;this.b.add(T),L===0&&this.c()}removeObserver(T){this.b.delete(T)&&this.b.size===0&&this.f()}c(){}f(){}}t.$Vd=c;function h(k,T){const L=new f(k,T);try{k(L)}finally{L.finish()}}let e;function i(k){if(e)k(e);else{const T=new f(k,void 0);e=T;try{k(T)}finally{T.finish(),e=void 0}}}async function o(k,T){const L=new f(k,T);try{await k(L)}finally{L.finish()}}function l(k,T,L){k?T(k):h(T,L)}class f{constructor(T,L){this._fn=T,this.b=L,this.a=[],(0,B.$Jd)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,C.$dd)(this._fn)}updateObserver(T,L){this.a.push({observer:T,observable:L}),T.beginUpdate(L)}finish(){const T=this.a;for(let L=0;L<T.length;L++){const{observer:q,observable:$}=T[L];q.endUpdate($)}this.a=null,(0,B.$Jd)()?.handleEndTransaction()}}t.$1d=f;function S(k,T){let L;return typeof k=="string"?L=new C.$bd(void 0,k,void 0):L=new C.$bd(k,void 0,void 0),new b(L,T,n.$7c)}function m(k,T){return new b(new C.$bd(k.owner,k.debugName,void 0),T,k.equalsFn??n.$7c)}class b extends c{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(T,L,q){super(),this.e=T,this.g=q,this.d=L}get(){return this.d}set(T,L,q){if(this.g(this.d,T))return;let $;L||(L=$=new f(()=>{},()=>`Setting ${this.debugName}`));try{const I=this.d;this.h(T),(0,B.$Jd)()?.handleObservableChanged(this,{oldValue:I,newValue:T,change:q,didChange:!0,hadValue:!0});for(const V of this.b)L.updateObserver(V,this),V.handleChange(this,q)}finally{$&&$.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(T){this.d=T}}t.$4d=b;function r(k,T){let L;return typeof k=="string"?L=new C.$bd(void 0,k,void 0):L=new C.$bd(k,void 0,void 0),new D(L,T,n.$7c)}class D extends b{h(T){this.d!==T&&(this.d&&this.d.dispose(),this.d=T)}dispose(){this.d?.dispose()}}t.$6d=D}),define(me[42],be([1,0,37,38,2,33,26,27]),function(se,t,n,C,B,H,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Qd=void 0,t.$Ld=d,t.$Md=g,t.$Nd=w,t.$Od=M,t.$Pd=c;function d(i,o){return o!==void 0?new e(new A.$bd(i,void 0,o),o,void 0,void 0,void 0,C.$7c):new e(new A.$bd(void 0,void 0,i),i,void 0,void 0,void 0,C.$7c)}function g(i,o){return new e(new A.$bd(i.owner,i.debugName,i.debugReferenceFn),o,void 0,void 0,i.onLastObserverRemoved,i.equalsFn??C.$7c)}(0,H.$Td)(g);function w(i,o){return new e(new A.$bd(i.owner,i.debugName,void 0),o,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??C.$7c)}function M(i,o){let l,f;o===void 0?(l=i,f=void 0):(f=i,l=o);const S=new B.$Uc;return new e(new A.$bd(f,void 0,l),m=>(S.clear(),l(m,S)),void 0,void 0,()=>S.dispose(),C.$7c)}function c(i,o){let l,f;o===void 0?(l=i,f=void 0):(f=i,l=o);const S=new B.$Uc;return new e(new A.$bd(f,void 0,l),m=>{S.clear();const b=l(m);return b&&S.add(b),b},void 0,void 0,()=>S.dispose(),C.$7c)}var h;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(h||(h={}));class e extends H.$Vd{get debugName(){return this.m.getDebugName(this)??"(anonymous)"}constructor(o,l,f,S,m=void 0,b){super(),this.m=o,this._computeFn=l,this.n=f,this.p=S,this.q=m,this.s=b,this.e=0,this.g=void 0,this.h=0,this.j=new Set,this.k=new Set,this.l=void 0,this.l=this.n?.(),(0,P.$Jd)()?.handleDerivedCreated(this)}f(){this.e=0,this.g=void 0;for(const o of this.j)o.removeObserver(this);this.j.clear(),this.q?.()}get(){if(this.b.size===0){const o=this._computeFn(this,this.n?.());return this.f(),o}else{do{if(this.e===1){for(const o of this.j)if(o.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.u()}while(this.e!==3);return this.g}}u(){if(this.e===3)return;const o=this.k;this.k=this.j,this.j=o;const l=this.e!==0,f=this.g;this.e=3;const S=this.l;this.l=this.n?.();try{this.g=this._computeFn(this,S)}finally{for(const b of this.k)b.removeObserver(this);this.k.clear()}const m=l&&!this.s(f,this.g);if((0,P.$Jd)()?.handleDerivedRecomputed(this,{oldValue:f,newValue:this.g,change:void 0,didChange:m,hadValue:l}),m)for(const b of this.b)b.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(o){this.h++;const l=this.h===1;if(this.e===3&&(this.e=1,!l))for(const f of this.b)f.handlePossibleChange(this);if(l)for(const f of this.b)f.beginUpdate(this)}endUpdate(o){if(this.h--,this.h===0){const l=[...this.b];for(const f of l)f.endUpdate(this)}(0,n.$id)(()=>this.h>=0)}handlePossibleChange(o){if(this.e===3&&this.j.has(o)&&!this.k.has(o)){this.e=1;for(const l of this.b)l.handlePossibleChange(this)}}handleChange(o,l){if(this.j.has(o)&&!this.k.has(o)){const f=this.p?this.p({changedObservable:o,change:l,didChange:m=>m===o},this.l):!0,S=this.e===3;if(f&&(this.e===1||S)&&(this.e=2,S))for(const m of this.b)m.handlePossibleChange(this)}}readObservable(o){o.addObserver(this);const l=o.get();return this.j.add(o),this.k.delete(o),l}addObserver(o){const l=!this.b.has(o)&&this.h>0;super.addObserver(o),l&&o.beginUpdate(this)}removeObserver(o){const l=this.b.has(o)&&this.h>0;super.removeObserver(o),l&&o.endUpdate(this)}}t.$Qd=e}),define(me[56],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var n;(function(C){function B(d,g){if(d.start>=g.end||g.start>=d.end)return{start:0,end:0};const w=Math.max(d.start,g.start),M=Math.min(d.end,g.end);return M-w<=0?{start:0,end:0}:{start:w,end:M}}C.intersect=B;function H(d){return d.end-d.start<=0}C.isEmpty=H;function A(d,g){return!H(B(d,g))}C.intersects=A;function P(d,g){const w=[],M={start:d.start,end:Math.min(g.start,d.end)},c={start:Math.max(g.end,d.start),end:d.end};return H(M)||w.push(M),H(c)||w.push(c),w}C.relativeComplement=P})(n||(t.Range=n={}))}),define(me[92],be([1,0,56]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YT=void 0,t.$VT=C,t.$WT=B,t.$XT=H;function C(d,g){const w=[];for(const M of g){if(d.start>=M.range.end)continue;if(d.end<M.range.start)break;const c=n.Range.intersect(d,M.range);n.Range.isEmpty(c)||w.push({range:c,size:M.size})}return w}function B({start:d,end:g},w){return{start:d+w,end:g+w}}function H(d){const g=[];let w=null;for(const M of d){const c=M.range.start,h=M.range.end,e=M.size;if(w&&e===w.size){w.range.end=h;continue}w={range:{start:c,end:h},size:e},g.push(w)}return g}function A(...d){return H(d.reduce((g,w)=>g.concat(w),[]))}class P{get paddingTop(){return this.c}set paddingTop(g){this.b=this.b+g-this.c,this.c=g}constructor(g){this.a=[],this.b=0,this.c=0,this.c=g??0,this.b=this.c}splice(g,w,M=[]){const c=M.length-w,h=C({start:0,end:g},this.a),e=C({start:g+w,end:Number.POSITIVE_INFINITY},this.a).map(o=>({range:B(o.range,c),size:o.size})),i=M.map((o,l)=>({range:{start:g+l,end:g+l+1},size:o.size}));this.a=A(h,i,e),this.b=this.c+this.a.reduce((o,l)=>o+l.size*(l.range.end-l.range.start),0)}get count(){const g=this.a.length;return g?this.a[g-1].range.end:0}get size(){return this.b}indexAt(g){if(g<0)return-1;if(g<this.c)return 0;let w=0,M=this.c;for(const c of this.a){const h=c.range.end-c.range.start,e=M+h*c.size;if(g<e)return w+Math.floor((g-M)/c.size);w+=h,M=e}return w}indexAfter(g){return Math.min(this.indexAt(g)+1,this.count)}positionAt(g){if(g<0)return-1;let w=0,M=0;for(const c of this.a){const h=c.range.end-c.range.start,e=M+h;if(g<e)return this.c+w+(g-M)*c.size;w+=h*c.size,M=e}return-1}}t.$YT=P}),define(me[93],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ae=void 0;const n=globalThis.performance&&typeof globalThis.performance.now=="function";class C{static create(H){return new C(H)}constructor(H){this.c=n&&H===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}t.$ae=C}),define(me[3],be([1,0,6,53,2,55,93]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oe=t.$ne=t.$me=t.$le=t.$ke=t.$je=t.$ie=t.$he=t.$ge=t.$fe=t.$ee=t.$ce=t.Event=void 0,t.$de=h;const P=!1,d=!1,g=!1;var w;(function(Y){Y.None=()=>B.$Vc.None;function K(E){if(g){const{onDidAddListener:p}=E,R=i.create();let O=0;E.onDidAddListener=()=>{++O===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),R.print()),p?.()}}}function ae(E,p){return re(E,()=>{},0,void 0,!0,void 0,p)}Y.defer=ae;function ie(E){return(p,R=null,O)=>{let U=!1,Z;return Z=E(oe=>{if(!U)return Z?Z.dispose():U=!0,p.call(R,oe)},null,O),U&&Z.dispose(),Z}}Y.once=ie;function ee(E,p,R){return _((O,U=null,Z)=>E(oe=>O.call(U,p(oe)),null,Z),R)}Y.map=ee;function ce(E,p,R){return _((O,U=null,Z)=>E(oe=>{p(oe),O.call(U,oe)},null,Z),R)}Y.forEach=ce;function De(E,p,R){return _((O,U=null,Z)=>E(oe=>p(oe)&&O.call(U,oe),null,Z),R)}Y.filter=De;function Ee(E){return E}Y.signal=Ee;function Le(...E){return(p,R=null,O)=>{const U=(0,B.$Sc)(...E.map(Z=>Z(oe=>p.call(R,oe))));return ue(U,O)}}Y.any=Le;function le(E,p,R,O){let U=R;return ee(E,Z=>(U=p(U,Z),U),O)}Y.reduce=le;function _(E,p){let R;const O={onWillAddFirstListener(){R=E(U.fire,U)},onDidRemoveLastListener(){R?.dispose()}};p||K(O);const U=new b(O);return p?.add(U),U.event}function ue(E,p){return p instanceof Array?p.push(E):p&&p.add(E),E}function re(E,p,R=100,O=!1,U=!1,Z,oe){let pe,fe,Re,Pe=0,je;const Se={leakWarningThreshold:Z,onWillAddFirstListener(){pe=E(We=>{Pe++,fe=p(fe,We),O&&!Re&&(Ce.fire(fe),fe=void 0),je=()=>{const Xe=fe;fe=void 0,Re=void 0,(!O||Pe>1)&&Ce.fire(Xe),Pe=0},typeof R=="number"?(clearTimeout(Re),Re=setTimeout(je,R)):Re===void 0&&(Re=0,queueMicrotask(je))})},onWillRemoveListener(){U&&Pe>0&&je?.()},onDidRemoveLastListener(){je=void 0,pe.dispose()}};oe||K(Se);const Ce=new b(Se);return oe?.add(Ce),Ce.event}Y.debounce=re;function ye(E,p=0,R){return Y.debounce(E,(O,U)=>O?(O.push(U),O):[U],p,void 0,!0,void 0,R)}Y.accumulate=ye;function W(E,p=(O,U)=>O===U,R){let O=!0,U;return De(E,Z=>{const oe=O||!p(Z,U);return O=!1,U=Z,oe},R)}Y.latch=W;function Q(E,p,R){return[Y.filter(E,p,R),Y.filter(E,O=>!p(O),R)]}Y.split=Q;function ge(E,p=!1,R=[],O){let U=R.slice(),Z=E(fe=>{U?U.push(fe):pe.fire(fe)});O&&O.add(Z);const oe=()=>{U?.forEach(fe=>pe.fire(fe)),U=null},pe=new b({onWillAddFirstListener(){Z||(Z=E(fe=>pe.fire(fe)),O&&O.add(Z))},onDidAddFirstListener(){U&&(p?setTimeout(oe):oe())},onDidRemoveLastListener(){Z&&Z.dispose(),Z=null}});return O&&O.add(pe),pe.event}Y.buffer=ge;function we(E,p){return(O,U,Z)=>{const oe=p(new Te);return E(function(pe){const fe=oe.evaluate(pe);fe!==ke&&O.call(U,fe)},void 0,Z)}}Y.chain=we;const ke=Symbol("HaltChainable");class Te{constructor(){this.f=[]}map(p){return this.f.push(p),this}forEach(p){return this.f.push(R=>(p(R),R)),this}filter(p){return this.f.push(R=>p(R)?R:ke),this}reduce(p,R){let O=R;return this.f.push(U=>(O=p(O,U),O)),this}latch(p=(R,O)=>R===O){let R=!0,O;return this.f.push(U=>{const Z=R||!p(U,O);return R=!1,O=U,Z?U:ke}),this}evaluate(p){for(const R of this.f)if(p=R(p),p===ke)break;return p}}function Ie(E,p,R=O=>O){const O=(...pe)=>oe.fire(R(...pe)),U=()=>E.on(p,O),Z=()=>E.removeListener(p,O),oe=new b({onWillAddFirstListener:U,onDidRemoveLastListener:Z});return oe.event}Y.fromNodeEventEmitter=Ie;function z(E,p,R=O=>O){const O=(...pe)=>oe.fire(R(...pe)),U=()=>E.addEventListener(p,O),Z=()=>E.removeEventListener(p,O),oe=new b({onWillAddFirstListener:U,onDidRemoveLastListener:Z});return oe.event}Y.fromDOMEventEmitter=z;function u(E){return new Promise(p=>ie(E)(p))}Y.toPromise=u;function y(E){const p=new b;return E.then(R=>{p.fire(R)},()=>{p.fire(void 0)}).finally(()=>{p.dispose()}),p.event}Y.fromPromise=y;function a(E,p,R){return p(R),E(O=>p(O))}Y.runAndSubscribe=a;class v{constructor(p,R){this._observable=p,this.f=0,this.g=!1;const O={onWillAddFirstListener:()=>{p.addObserver(this)},onDidRemoveLastListener:()=>{p.removeObserver(this)}};R||K(O),this.emitter=new b(O),R&&R.add(this.emitter)}beginUpdate(p){this.f++}handlePossibleChange(p){}handleChange(p,R){this.g=!0}endUpdate(p){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function F(E,p){return new v(E,p).emitter.event}Y.fromObservable=F;function s(E){return(p,R,O)=>{let U=0,Z=!1;const oe={beginUpdate(){U++},endUpdate(){U--,U===0&&(E.reportChanges(),Z&&(Z=!1,p.call(R)))},handlePossibleChange(){},handleChange(){Z=!0}};E.addObserver(oe),E.reportChanges();const pe={dispose(){E.removeObserver(oe)}};return O instanceof B.$Uc?O.add(pe):Array.isArray(O)&&O.push(pe),pe}}Y.fromObservableLight=s})(w||(t.Event=w={}));class M{static{this.all=new Set}static{this.f=0}constructor(K){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${K}_${M.f++}`,M.all.add(this)}start(K){this.g=new A.$ae,this.listenerCount=K}stop(){if(this.g){const K=this.g.elapsed();this.durations.push(K),this.elapsedOverall+=K,this.invocationCount+=1,this.g=void 0}}}t.$ce=M;let c=-1;function h(Y){const K=c;return c=Y,{dispose(){c=K}}}class e{constructor(K,ae=Math.random().toString(18).slice(2,5)){this.threshold=K,this.name=ae,this.g=0}dispose(){this.f?.clear()}check(K,ae){const ie=this.threshold;if(ie<=0||ae<ie)return;this.f||(this.f=new Map);const ee=this.f.get(K.value)||0;if(this.f.set(K.value,ee+1),this.g-=1,this.g<=0){this.g=ie*.5;let ce,De=0;for(const[Ee,Le]of this.f)(!ce||De<Le)&&(ce=Ee,De=Le);console.warn(`[${this.name}] potential listener LEAK detected, having ${ae} listeners already. MOST frequent listener (${De}):`),console.warn(ce)}return()=>{const ce=this.f.get(K.value)||0;this.f.set(K.value,ce-1)}}}class i{static create(){return new i(new Error().stack??"")}constructor(K){this.value=K}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let o=0;class l{constructor(K){this.value=K,this.id=o++}}const f=2,S=(Y,K)=>{if(Y instanceof l)K(Y);else for(let ae=0;ae<Y.length;ae++){const ie=Y[ae];ie&&K(ie)}},m=P?new FinalizationRegistry(Y=>{typeof Y=="string"&&(console.warn("[LEAKING LISTENER] GC'ed a listener that was NOT yet disposed. This is where is was created:"),console.warn(Y))}):void 0;class b{constructor(K){this.w=0,this.f=K,this.g=c>0||this.f?.leakWarningThreshold?new e(this.f?.leakWarningThreshold??c):void 0,this.j=this.f?._profName?new M(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(d){const K=this.t;queueMicrotask(()=>{S(K,ae=>ae.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(K,ae,ie)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),B.$Vc.None;if(this.m)return B.$Vc.None;ae&&(K=K.bind(ae));const ee=new l(K);let ce,De;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(ee.stack=i.create(),ce=this.g.check(ee.stack,this.w+1)),d&&(ee.stack=De??i.create()),this.t?this.t instanceof l?(this.u??=new D,this.t=[this.t,ee]):this.t.push(ee):(this.f?.onWillAddFirstListener?.(this),this.t=ee,this.f?.onDidAddFirstListener?.(this)),this.w++;const Ee=(0,B.$Tc)(()=>{m?.unregister(Ee),ce?.(),this.x(ee)});if(ie instanceof B.$Uc?ie.add(Ee):Array.isArray(ie)&&ie.push(Ee),m){const Le=new Error().stack.split(`
`).slice(2).join(`
`).trim();m.register(Ee,Le,Ee)}return Ee},this.q}x(K){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const ae=this.t,ie=ae.indexOf(K);if(ie===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,ae[ie]=void 0;const ee=this.u.current===this;if(this.w*f<=ae.length){let ce=0;for(let De=0;De<ae.length;De++)ae[De]?ae[ce++]=ae[De]:ee&&(this.u.end--,ce<this.u.i&&this.u.i--);ae.length=ce}}y(K,ae){if(!K)return;const ie=this.f?.onListenerError||n.$1;if(!ie){K.value(ae);return}try{K.value(ae)}catch(ee){ie(ee)}}z(K){const ae=K.current.t;for(;K.i<K.end;)this.y(ae[K.i++],K.value);K.reset()}fire(K){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof l)this.y(this.t,K);else{const ae=this.u;ae.enqueue(this,K,this.t.length),this.z(ae)}this.j?.stop()}hasListeners(){return this.w>0}}t.$ee=b;const r=()=>new D;t.$fe=r;class D{constructor(){this.i=-1,this.end=0}enqueue(K,ae,ie){this.i=0,this.end=ie,this.current=K,this.value=ae}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class k extends b{async fireAsync(K,ae,ie){if(this.t)for(this.h||(this.h=new H.$6c),S(this.t,ee=>this.h.push([ee.value,K]));this.h.size>0&&!ae.isCancellationRequested;){const[ee,ce]=this.h.shift(),De=[],Ee={...ce,token:ae,waitUntil:Le=>{if(Object.isFrozen(De))throw new Error("waitUntil can NOT be called asynchronous");ie&&(Le=ie(Le,ee)),De.push(Le)}};try{ee(Ee)}catch(Le){(0,n.$1)(Le);continue}Object.freeze(De),await Promise.allSettled(De).then(Le=>{for(const le of Le)le.status==="rejected"&&(0,n.$1)(le.reason)})}}}t.$ge=k;class T extends b{get isPaused(){return this.h!==0}constructor(K){super(K),this.h=0,this.s=new H.$6c,this.A=K?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const K=Array.from(this.s);this.s.clear(),super.fire(this.A(K))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(K){this.w&&(this.h!==0?this.s.push(K):super.fire(K))}}t.$he=T;class L extends T{constructor(K){super(K),this.k=K.delay??100}fire(K){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(K)}}t.$ie=L;class q extends b{constructor(K){super(K),this.h=[],this.k=K?.merge}fire(K){this.hasListeners()&&(this.h.push(K),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(ae=>super.fire(ae)),this.h=[]}))}}t.$je=q;class ${constructor(){this.g=!1,this.h=[],this.f=new b({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(K){const ae={event:K,listener:null};this.h.push(ae),this.g&&this.m(ae);const ie=()=>{this.g&&this.o(ae);const ee=this.h.indexOf(ae);this.h.splice(ee,1)};return(0,B.$Tc)((0,C.$db)(ie))}j(){this.g=!0,this.h.forEach(K=>this.m(K))}k(){this.g=!1,this.h.forEach(K=>this.o(K))}m(K){K.listener=K.event(ae=>this.f.fire(ae))}o(K){K.listener?.dispose(),K.listener=null}dispose(){this.f.dispose();for(const K of this.h)K.listener?.dispose();this.h=[]}}t.$ke=$;class I{constructor(K,ae,ie,ee){this.f=new B.$Uc;const ce=this.f.add(new $),De=this.f.add(new B.$5c);function Ee(Le){De.set(Le,ce.add(ee(Le)))}for(const Le of K)Ee(Le);this.f.add(ae(Le=>{Ee(Le)})),this.f.add(ie(Le=>{De.deleteAndDispose(Le)})),this.event=ce.event}dispose(){this.f.dispose()}}t.$le=I;class V{constructor(){this.f=[]}wrapEvent(K){return(ae,ie,ee)=>K(ce=>{const De=this.f[this.f.length-1];De?De.push(()=>ae.call(ie,ce)):ae.call(ie,ce)},void 0,ee)}bufferEvents(K){const ae=[];this.f.push(ae);const ie=K();return this.f.pop(),ae.forEach(ee=>ee()),ie}}t.$me=V;class N{constructor(){this.f=!1,this.g=w.None,this.h=B.$Vc.None,this.j=new b({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(K){this.g=K,this.f&&(this.h.dispose(),this.h=K(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}t.$ne=N;class x{static const(K){return new j(K)}constructor(K){this.g=K,this.f=new b,this.onDidChange=this.f.event}get value(){return this.g}set value(K){K!==this.g&&(this.g=K,this.f.fire(void 0))}}t.$oe=x;class j{constructor(K){this.value=K,this.onDidChange=w.None}}}),define(me[17],be([1,0,22,3]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$AR=t.$zR=t.$yR=t.$xR=t.$wR=t.$vR=t.$uR=t.$tR=t.$oR=void 0,t.$lR=H,t.$mR=A,t.$nR=P,t.$pR=d,t.$qR=g,t.$rR=w,t.$sR=M,t.$BR=e,t.$CR=i;class B{constructor(){this.a=new Map,this.b=new C.$ee,this.onDidChangeZoomLevel=this.b.event,this.c=new Map,this.d=new C.$ee,this.onDidChangeFullscreen=this.d.event,this.e=new Map}static{this.INSTANCE=new B}getZoomLevel(l){return this.a.get(this.f(l))??0}setZoomLevel(l,f){if(this.getZoomLevel(f)===l)return;const S=this.f(f);this.a.set(S,l),this.b.fire(S)}getZoomFactor(l){return this.c.get(this.f(l))??1}setZoomFactor(l,f){this.c.set(this.f(f),l)}setFullscreen(l,f){if(this.isFullscreen(f)===l)return;const S=this.f(f);this.e.set(S,l),this.d.fire(S)}isFullscreen(l){return!!this.e.get(this.f(l))}f(l){return l.vscodeWindowId}}function H(o,l,f){typeof l=="string"&&(l=o.matchMedia(l)),l.addEventListener("change",f)}function A(o,l){B.INSTANCE.setZoomLevel(o,l)}function P(o){return B.INSTANCE.getZoomLevel(o)}t.$oR=B.INSTANCE.onDidChangeZoomLevel;function d(o){return B.INSTANCE.getZoomFactor(o)}function g(o,l){B.INSTANCE.setZoomFactor(o,l)}function w(o,l){B.INSTANCE.setFullscreen(o,l)}function M(o){return B.INSTANCE.isFullscreen(o)}t.$tR=B.INSTANCE.onDidChangeFullscreen;const c=navigator.userAgent;t.$uR=c.indexOf("Firefox")>=0,t.$vR=c.indexOf("AppleWebKit")>=0,t.$wR=c.indexOf("Chrome")>=0,t.$xR=!t.$wR&&c.indexOf("Safari")>=0,t.$yR=!t.$wR&&!t.$xR&&t.$vR,t.$zR=c.indexOf("Electron/")>=0,t.$AR=c.indexOf("Android")>=0;let h=!1;if(typeof n.$iR.matchMedia=="function"){const o=n.$iR.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),l=n.$iR.matchMedia("(display-mode: fullscreen)");h=o.matches,H(n.$iR,o,({matches:f})=>{h&&l.matches||(h=f)})}function e(){return h}function i(){return navigator?.windowControlsOverlay?.visible}}),define(me[24],be([1,0,3]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QT=void 0;class C{get event(){return this.a.event}constructor(H,A,P){const d=g=>this.a.fire(g);this.a=new n.$ee({onWillAddFirstListener:()=>H.addEventListener(A,d,P),onDidRemoveLastListener:()=>H.removeEventListener(A,d,P)})}dispose(){this.a.dispose()}}t.$QT=C}),define(me[34],be([1,0,3]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pe=t.CancellationToken=void 0;const C=Object.freeze(function(P,d){const g=setTimeout(P.bind(d),0);return{dispose(){clearTimeout(g)}}});var B;(function(P){function d(g){return g===P.None||g===P.Cancelled||g instanceof H?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=d,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:n.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:C})})(B||(t.CancellationToken=B={}));class H{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?C:(this.b||(this.b=new n.$ee),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(d){this.f=void 0,this.g=void 0,this.g=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new H),this.f}cancel(){this.f?this.f instanceof H&&this.f.cancel():this.f=B.Cancelled}dispose(d=!1){d&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof H&&this.f.dispose():this.f=B.None}}t.$pe=A}),define(me[94],be([1,0,34]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4e=t.$3e=t.$1e=void 0,t.$2e=B;class C{constructor(d){this.b=d,this.a=null}get(){if(this.a)return this.a;const d=new n.$pe,g=this.b(d.token);return this.a={promise:g,dispose:()=>{this.a=null,d.cancel(),d.dispose()}},this.a}}t.$1e=C;function B(P){return P}class H{constructor(d,g){this.a=void 0,this.b=void 0,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);return this.b!==g&&(this.b=g,this.a=this.c(d)),this.a}}t.$3e=H;class A{get cachedValues(){return this.a}constructor(d,g){this.a=new Map,this.b=new Map,typeof d=="function"?(this.c=d,this.d=B):(this.c=g,this.d=d.getCacheKey)}get(d){const g=this.d(d);if(this.b.has(g))return this.b.get(g);const w=this.c(d);return this.a.set(d,w),this.b.set(g,w),w}}t.$4e=A}),define(me[95],be([1,0,41,33,42,34,26,38]),function(se,t,n,C,B,H,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$0d=t.$9d=t.$8d=t.$7d=void 0,t.$$d=c,t.$_d=h;class d{get cachedValue(){return this.a}constructor(i){this.b=i,this.a=(0,C.$2d)(this,void 0)}getValue(){let i=this.a.get();return i||(i=this.b(),this.a.set(i,void 0)),i}}t.$7d=d;class g{constructor(i){this.a=(0,C.$2d)(this,void 0),this.promiseResult=this.a,this.promise=i.then(o=>((0,C.$Wd)(l=>{this.a.set(new w(o,void 0),l)}),o),o=>{throw(0,C.$Wd)(l=>{this.a.set(new w(void 0,o),l)}),o})}}t.$8d=g;class w{constructor(i,o){this.data=i,this.error=o}getDataOrThrow(){if(this.error)throw this.error;return this.data}}t.$9d=w;class M{constructor(i){this.b=i,this.a=new d(()=>new g(this.b())),this.cachedPromiseResult=(0,B.$Ld)(this,o=>this.a.cachedValue.read(o)?.promiseResult.read(o))}getPromise(){return this.a.getValue().promise}}t.$0d=M;function c(e,i,o){return i||(i=l=>l!=null),new Promise((l,f)=>{let S=!0,m=!1;const b=e.map(D=>({isFinished:i(D),error:o?o(D):!1,state:D})),r=(0,n.$kd)(D=>{const{isFinished:k,error:T,state:L}=b.read(D);(k||T)&&(S?m=!0:r.dispose(),T?f(T===!0?L:T):l(L))});S=!1,m&&r.dispose()})}function h(e,i){let o,l;i===void 0?(o=e,l=void 0):(l=e,o=i);let f;return new B.$Qd(new A.$bd(l,void 0,o),S=>(f&&f.dispose(!0),f=new H.$pe,o(S,f.token)),void 0,void 0,()=>f?.dispose(),P.$7c)}}),define(me[96],be([1,0,3,2,41,33,26,42,27]),function(se,t,n,C,B,H,A,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Gd=t.$Cd=t.$ud=void 0,t.$rd=g,t.$sd=M,t.$td=c,t.$vd=e,t.$wd=o,t.$xd=f,t.$yd=S,t.$zd=m,t.$Ad=b,t.$Bd=r,t.$Dd=k,t.$Ed=T,t.$Fd=L,t.$Hd=I;function g(V){return new w(V)}class w extends H.$Ud{constructor(N){super(),this.b=N}get debugName(){return this.toString()}get(){return this.b}addObserver(N){}removeObserver(N){}toString(){return`Const: ${this.b}`}}function M(V){const N=(0,H.$2d)("promiseValue",{});return V.then(x=>{N.set({value:x},void 0)}),N}function c(V,N){return new h(V,N)}class h extends H.$Vd{constructor(N,x){super(),this.j=N,this._getValue=x,this.g=!1,this.n=j=>{const Y=this._getValue(j),K=this.e,ae=!this.g||K!==Y;let ie=!1;ae&&(this.e=Y,this.g&&(ie=!0,(0,H.$Zd)(h.globalTransaction,ee=>{(0,d.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:Y,change:void 0,didChange:ae,hadValue:this.g});for(const ce of this.b)ee.updateObserver(ce,this),ce.handleChange(this,void 0)},()=>{const ee=this.k();return"Event fired"+(ee?`: ${ee}`:"")})),this.g=!0),ie||(0,d.$Jd)()?.handleFromEventObservableTriggered(this,{oldValue:K,newValue:Y,change:void 0,didChange:ae,hadValue:this.g})}}k(){return(0,A.$dd)(this._getValue)}get debugName(){const N=this.k();return"From Event"+(N?`: ${N}`:"")}c(){this.h=this.j(this.n)}f(){this.h.dispose(),this.h=void 0,this.g=!1,this.e=void 0}get(){return this.h?(this.g||this.n(void 0),this.e):this._getValue(void 0)}}t.$ud=h,function(V){V.Observer=h;function N(x,j){let Y=!1;h.globalTransaction===void 0&&(h.globalTransaction=x,Y=!0);try{j()}finally{Y&&(h.globalTransaction=void 0)}}V.batchEventsGlobally=N}(c||(t.$td=c={}));function e(V,N){return new i(V,N)}class i extends H.$Vd{constructor(N,x){super(),this.debugName=N,this.g=x,this.j=()=>{(0,H.$Wd)(j=>{for(const Y of this.b)j.updateObserver(Y,this),Y.handleChange(this,void 0)},()=>this.debugName)}}c(){this.e=this.g(this.j)}f(){this.e.dispose(),this.e=void 0}get(){}}function o(V){return typeof V=="string"?new l(V):new l(void 0,V)}class l extends H.$Vd{get debugName(){return new A.$bd(this.g,this.e,void 0).getDebugName(this)??"Observable Signal"}constructor(N,x){super(),this.e=N,this.g=x}trigger(N,x){if(!N){(0,H.$Wd)(j=>{this.trigger(j,x)},()=>`Trigger signal ${this.debugName}`);return}for(const j of this.b)N.updateObserver(j,this),j.handleChange(this,x)}get(){}}function f(V,N,x){const j=(0,H.$2d)("debounced",void 0);let Y;return x.add((0,B.$kd)(K=>{const ae=V.read(K);Y&&clearTimeout(Y),Y=setTimeout(()=>{(0,H.$Wd)(ie=>{j.set(ae,ie)})},N)})),j}function S(V,N){let x=!1,j,Y;return c(K=>{const ae=(0,B.$kd)(ie=>{const ee=V.read(ie);x?(Y&&clearTimeout(Y),Y=setTimeout(()=>{j=ee,K()},N)):(x=!0,j=ee)});return{dispose(){ae.dispose(),x=!1,j=void 0}}},()=>x?j:V.get())}function m(V,N,x){const j=(0,H.$2d)("triggeredRecently",!1);let Y;return x.add(V(()=>{j.set(!0,void 0),Y&&clearTimeout(Y),Y=setTimeout(()=>{j.set(!1,void 0)},N)})),j}function b(V){const N=new D(!1,void 0);return V.addObserver(N),(0,C.$Tc)(()=>{V.removeObserver(N)})}(0,H.$Sd)(b);function r(V,N){const x=new D(!0,N);return V.addObserver(x),N?N(V.get()):V.reportChanges(),(0,C.$Tc)(()=>{V.removeObserver(x)})}(0,H.$Rd)(r);class D{constructor(N,x){this.b=N,this.c=x,this.a=0}beginUpdate(N){this.a++}endUpdate(N){this.a--,this.a===0&&this.b&&(this.c?this.c(N.get()):N.reportChanges())}handlePossibleChange(N){}handleChange(N,x){}}t.$Cd=D;function k(V,N){let x;return(0,P.$Ld)(V,Y=>(x=N(Y,x),x))}function T(V,N){let x;const j=o("derivedObservableWithWritableCache"),Y=(0,P.$Ld)(V,K=>(j.read(K),x=N(K,x),x));return Object.assign(Y,{clearCache:K=>{x=void 0,j.trigger(K)},setCache:(K,ae)=>{x=K,j.trigger(ae)}})}function L(V,N,x,j){let Y=new q(x,j);return(0,P.$Md)({debugReferenceFn:x,owner:V,onLastObserverRemoved:()=>{Y.dispose(),Y=new q(x)}},ae=>(Y.setItems(N.read(ae)),Y.getItems()))}class q{constructor(N,x){this.c=N,this.e=x,this.a=new Map,this.b=[]}dispose(){this.a.forEach(N=>N.store.dispose()),this.a.clear()}setItems(N){const x=[],j=new Set(this.a.keys());for(const Y of N){const K=this.e?this.e(Y):Y;let ae=this.a.get(K);if(ae)j.delete(K);else{const ie=new C.$Uc;ae={out:this.c(Y,ie),store:ie},this.a.set(K,ae)}x.push(ae.out)}for(const Y of j)this.a.get(Y).store.dispose(),this.a.delete(Y);this.b=x}getItems(){return this.b}}class ${constructor(N){this.observable=N}get onDidChange(){return n.Event.fromObservableLight(this.observable)}get value(){return this.observable.get()}}t.$Gd=$;function I(V,N){return N instanceof $?N.observable:c(N.onDidChange,()=>N.value)}}),define(me[57],be([1,0,33,42,41,96,95,27]),function(se,t,n,C,B,H,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.derivedWithCancellationToken=t.waitForState=t.PromiseResult=t.ObservablePromise=t.ObservableLazyPromise=t.ObservableLazy=t.wasEventTriggeredRecently=t.observableSignalFromEvent=t.observableSignal=t.observableFromPromise=t.observableFromEvent=t.recomputeInitiallyAndOnChange=t.keepObserved=t.derivedObservableWithWritableCache=t.derivedObservableWithCache=t.debouncedObservable=t.constObservable=t.autorunWithStoreHandleChanges=t.autorunOpts=t.autorunWithStore=t.autorunHandleChanges=t.autorunDelta=t.autorun=t.derivedWithStore=t.derivedHandleChanges=t.derivedOpts=t.derived=t.subtransaction=t.transaction=t.disposableObservableValue=t.observableValue=void 0,Object.defineProperty(t,"observableValue",{enumerable:!0,get:function(){return n.$2d}}),Object.defineProperty(t,"disposableObservableValue",{enumerable:!0,get:function(){return n.$5d}}),Object.defineProperty(t,"transaction",{enumerable:!0,get:function(){return n.$Wd}}),Object.defineProperty(t,"subtransaction",{enumerable:!0,get:function(){return n.$Zd}}),Object.defineProperty(t,"derived",{enumerable:!0,get:function(){return C.$Ld}}),Object.defineProperty(t,"derivedOpts",{enumerable:!0,get:function(){return C.$Md}}),Object.defineProperty(t,"derivedHandleChanges",{enumerable:!0,get:function(){return C.$Nd}}),Object.defineProperty(t,"derivedWithStore",{enumerable:!0,get:function(){return C.$Od}}),Object.defineProperty(t,"autorun",{enumerable:!0,get:function(){return B.$kd}}),Object.defineProperty(t,"autorunDelta",{enumerable:!0,get:function(){return B.$pd}}),Object.defineProperty(t,"autorunHandleChanges",{enumerable:!0,get:function(){return B.$md}}),Object.defineProperty(t,"autorunWithStore",{enumerable:!0,get:function(){return B.$od}}),Object.defineProperty(t,"autorunOpts",{enumerable:!0,get:function(){return B.$ld}}),Object.defineProperty(t,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return B.$nd}}),Object.defineProperty(t,"constObservable",{enumerable:!0,get:function(){return H.$rd}}),Object.defineProperty(t,"debouncedObservable",{enumerable:!0,get:function(){return H.$xd}}),Object.defineProperty(t,"derivedObservableWithCache",{enumerable:!0,get:function(){return H.$Dd}}),Object.defineProperty(t,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return H.$Ed}}),Object.defineProperty(t,"keepObserved",{enumerable:!0,get:function(){return H.$Ad}}),Object.defineProperty(t,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return H.$Bd}}),Object.defineProperty(t,"observableFromEvent",{enumerable:!0,get:function(){return H.$td}}),Object.defineProperty(t,"observableFromPromise",{enumerable:!0,get:function(){return H.$sd}}),Object.defineProperty(t,"observableSignal",{enumerable:!0,get:function(){return H.$wd}}),Object.defineProperty(t,"observableSignalFromEvent",{enumerable:!0,get:function(){return H.$vd}}),Object.defineProperty(t,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return H.$zd}}),Object.defineProperty(t,"ObservableLazy",{enumerable:!0,get:function(){return A.$7d}}),Object.defineProperty(t,"ObservableLazyPromise",{enumerable:!0,get:function(){return A.$0d}}),Object.defineProperty(t,"ObservablePromise",{enumerable:!0,get:function(){return A.$8d}}),Object.defineProperty(t,"PromiseResult",{enumerable:!0,get:function(){return A.$9d}}),Object.defineProperty(t,"waitForState",{enumerable:!0,get:function(){return A.$$d}}),Object.defineProperty(t,"derivedWithCancellationToken",{enumerable:!0,get:function(){return A.$_d}}),!1&&(0,P.$Id)(new P.$Kd)}),define(me[58],be([1,0,3,2]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Xs=t.$Ws=t.$Vs=t.$Us=t.ScrollbarVisibility=void 0;var B;(function(h){h[h.Auto=1]="Auto",h[h.Hidden=2]="Hidden",h[h.Visible=3]="Visible"})(B||(t.ScrollbarVisibility=B={}));class H{constructor(e,i,o,l,f,S,m){this.c=e,this._scrollStateBrand=void 0,this.c&&(i=i|0,o=o|0,l=l|0,f=f|0,S=S|0,m=m|0),this.rawScrollLeft=l,this.rawScrollTop=m,i<0&&(i=0),l+i>o&&(l=o-i),l<0&&(l=0),f<0&&(f=0),m+f>S&&(m=S-f),m<0&&(m=0),this.width=i,this.scrollWidth=o,this.scrollLeft=l,this.height=f,this.scrollHeight=S,this.scrollTop=m}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,i){return new H(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,i?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,i?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new H(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,i){const o=this.width!==e.width,l=this.scrollWidth!==e.scrollWidth,f=this.scrollLeft!==e.scrollLeft,S=this.height!==e.height,m=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:i,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:o,scrollWidthChanged:l,scrollLeftChanged:f,heightChanged:S,scrollHeightChanged:m,scrollTopChanged:b}}}t.$Us=H;class A extends C.$Vc{constructor(e){super(),this._scrollableBrand=void 0,this.j=this.B(new n.$ee),this.onScroll=this.j.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new H(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,i){const o=this.g.withScrollDimensions(e,i);this.n(o,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const i=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.n(i,!1)}setScrollPositionSmooth(e,i){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const o=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===o.scrollLeft&&this.h.to.scrollTop===o.scrollTop)return;let l;i?l=new w(this.h.from,o,this.h.startTime,this.h.duration):l=this.h.combine(this.g,o,this.c),this.h.dispose(),this.h=l}else{const o=this.g.withScrollPosition(e);this.h=w.start(this.g,o,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}hasPendingScrollAnimation(){return!!this.h}m(){if(!this.h)return;const e=this.h.tick(),i=this.g.withScrollPosition(e);if(this.n(i,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.m())})}}n(e,i){const o=this.g;o.equals(e)||(this.g=e,this.j.fire(this.g.createScrollEvent(o,i)))}}t.$Vs=A;class P{constructor(e,i,o){this.scrollLeft=e,this.scrollTop=i,this.isDone=o}}t.$Ws=P;function d(h,e){const i=e-h;return function(o){return h+i*c(o)}}function g(h,e,i){return function(o){return o<i?h(o/i):e((o-i)/(1-i))}}class w{constructor(e,i,o,l){this.from=e,this.to=i,this.duration=l,this.startTime=o,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,i,o){if(Math.abs(e-i)>2.5*o){let f,S;return e<i?(f=e+.75*o,S=i-.75*o):(f=e-.75*o,S=i+.75*o),g(d(e,f),d(S,i),.33)}return d(e,i)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const i=(e-this.startTime)/this.duration;if(i<1){const o=this.c(i),l=this.d(i);return new P(o,l,!1)}return new P(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,i,o){return w.start(e,i,o)}static start(e,i,o){o=o+10;const l=Date.now()-10;return new w(e,i,l,o)}}t.$Xs=w;function M(h){return Math.pow(h,3)}function c(h){return 1-M(1-h)}}),define(me[97],be([1,0,6,2]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$qe=B,t.$re=H,t.$se=A,t.$te=P,t.$ue=g,t.$ve=w,t.$we=M,t.$xe=c,t.$ye=h,t.$ze=e,t.$Ae=i,t.$Be=o,t.$Ce=l,t.$De=f,t.$Ee=S;function B(m){const b=m;return b?typeof b.read=="function":!1}function H(m){const b=m;return b?[b.on,b.pause,b.resume,b.destroy].every(r=>typeof r=="function"):!1}function A(m){const b=m;return b?H(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}function P(m,b){return new d(m,b)}class d{constructor(b,r){this.e=b,this.f=r,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(b){if(!this.a.destroyed){if(this.a.flowing)this.g(b);else if(this.b.data.push(b),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(r=>this.d.push(r))}}error(b){this.a.destroyed||(this.a.flowing?this.h(b):this.b.error.push(b))}end(b){this.a.destroyed||(typeof b<"u"&&this.write(b),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(b){this.c.data.slice(0).forEach(r=>r(b))}h(b){this.c.error.length===0?(0,n.$1)(b):this.c.error.slice(0).forEach(r=>r(b))}i(){this.c.end.slice(0).forEach(b=>b())}on(b,r){if(!this.a.destroyed)switch(b){case"data":this.c.data.push(r),this.resume();break;case"end":this.c.end.push(r),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(r),this.a.flowing&&this.k();break}}removeListener(b,r){if(this.a.destroyed)return;let D;switch(b){case"data":D=this.c.data;break;case"end":D=this.c.end;break;case"error":D=this.c.error;break}if(D){const k=D.indexOf(r);k>=0&&D.splice(k,1)}}j(){if(this.b.data.length>0){const b=this.e(this.b.data);this.g(b),this.b.data.length=0;const r=[...this.d];this.d.length=0,r.forEach(D=>D())}}k(){if(this.c.error.length>0){for(const b of this.b.error)this.h(b);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(m,b){const r=[];let D;for(;(D=m.read())!==null;)r.push(D);return b(r)}function w(m,b,r){const D=[];let k;for(;(k=m.read())!==null&&D.length<r;)D.push(k);return k===null&&D.length>0?b(D):{read:()=>{if(D.length>0)return D.shift();if(typeof k<"u"){const T=k;return k=void 0,T}return m.read()}}}function M(m,b){return new Promise((r,D)=>{const k=[];c(m,{onData:T=>{b&&k.push(T)},onError:T=>{b?D(T):r(void 0)},onEnd:()=>{r(b?b(k):void 0)}})})}function c(m,b,r){m.on("error",D=>{r?.isCancellationRequested||b.onError(D)}),m.on("end",()=>{r?.isCancellationRequested||b.onEnd()}),m.on("data",D=>{r?.isCancellationRequested||b.onData(D)})}function h(m,b){return new Promise((r,D)=>{const k=new C.$Uc,T=[],L=I=>{if(T.push(I),T.length>b)return k.dispose(),m.pause(),r({stream:m,buffer:T,ended:!1})},q=I=>(k.dispose(),D(I)),$=()=>(k.dispose(),r({stream:m,buffer:T,ended:!0}));k.add((0,C.$Tc)(()=>m.removeListener("error",q))),m.on("error",q),k.add((0,C.$Tc)(()=>m.removeListener("end",$))),m.on("end",$),k.add((0,C.$Tc)(()=>m.removeListener("data",L))),m.on("data",L)})}function e(m,b){const r=P(b);return r.end(m),r}function i(){const m=P(()=>{throw new Error("not supported")});return m.end(),m}function o(m){let b=!1;return{read:()=>b?null:(b=!0,m)}}function l(m,b,r){const D=P(r);return c(m,{onData:k=>D.write(b.data(k)),onError:k=>D.error(b.error?b.error(k):k),onEnd:()=>D.end()}),D}function f(m,b,r){let D=!1;return{read:()=>{const k=b.read();return D?k:(D=!0,k!==null?r([m,k]):m)}}}function S(m,b,r){let D=!1;const k=P(r);return c(b,{onData:T=>D?k.write(T):(D=!0,k.write(r([m,T]))),onError:T=>k.error(T),onEnd:()=>{D||(D=!0,k.write(m)),k.end()}}),k}}),define(me[43],be([1,0,23,97]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Fe=void 0,t.$Ge=g,t.$He=w,t.$Ie=M,t.$Je=c,t.$Ke=h,t.$Le=e,t.$Me=i,t.$Ne=o,t.$Oe=l,t.$Pe=f,t.$Qe=S,t.$Re=m,t.$Se=b,t.$Te=r,t.$Ue=D,t.$Ve=k,t.$We=T,t.$Xe=L,t.$Ye=q,t.$Ze=V;const B=typeof Buffer<"u",H=new n.$V(()=>new Uint8Array(256));let A,P;class d{static alloc(x){return B?new d(Buffer.allocUnsafe(x)):new d(new Uint8Array(x))}static wrap(x){return B&&!Buffer.isBuffer(x)&&(x=Buffer.from(x.buffer,x.byteOffset,x.byteLength)),new d(x)}static fromString(x,j){return!(j?.dontUseNodeBuffer||!1)&&B?new d(Buffer.from(x)):(A||(A=new TextEncoder),new d(A.encode(x)))}static fromByteArray(x){const j=d.alloc(x.length);for(let Y=0,K=x.length;Y<K;Y++)j.buffer[Y]=x[Y];return j}static concat(x,j){if(typeof j>"u"){j=0;for(let ae=0,ie=x.length;ae<ie;ae++)j+=x[ae].byteLength}const Y=d.alloc(j);let K=0;for(let ae=0,ie=x.length;ae<ie;ae++){const ee=x[ae];Y.set(ee,K),K+=ee.byteLength}return Y}constructor(x){this.buffer=x,this.byteLength=this.buffer.byteLength}clone(){const x=d.alloc(this.byteLength);return x.set(this),x}toString(){return B?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(x,j){return new d(this.buffer.subarray(x,j))}set(x,j){if(x instanceof d)this.buffer.set(x.buffer,j);else if(x instanceof Uint8Array)this.buffer.set(x,j);else if(x instanceof ArrayBuffer)this.buffer.set(new Uint8Array(x),j);else if(ArrayBuffer.isView(x))this.buffer.set(new Uint8Array(x.buffer,x.byteOffset,x.byteLength),j);else throw new Error("Unknown argument 'array'")}readUInt32BE(x){return c(this.buffer,x)}writeUInt32BE(x,j){h(this.buffer,x,j)}readUInt32LE(x){return e(this.buffer,x)}writeUInt32LE(x,j){i(this.buffer,x,j)}readUInt8(x){return o(this.buffer,x)}writeUInt8(x,j){l(this.buffer,x,j)}indexOf(x,j=0){return g(this.buffer,x instanceof d?x.buffer:x,j)}}t.$Fe=d;function g(N,x,j=0){const Y=x.byteLength,K=N.byteLength;if(Y===0)return 0;if(Y===1)return N.indexOf(x[0]);if(Y>K-j)return-1;const ae=H.value;ae.fill(x.length);for(let De=0;De<x.length;De++)ae[x[De]]=x.length-De-1;let ie=j+x.length-1,ee=ie,ce=-1;for(;ie<K;)if(N[ie]===x[ee]){if(ee===0){ce=ie;break}ie--,ee--}else ie+=Math.max(x.length-ee,ae[N[ie]]),ee=x.length-1;return ce}function w(N,x){return N[x+0]<<0>>>0|N[x+1]<<8>>>0}function M(N,x,j){N[j+0]=x&255,x=x>>>8,N[j+1]=x&255}function c(N,x){return N[x]*2**24+N[x+1]*2**16+N[x+2]*2**8+N[x+3]}function h(N,x,j){N[j+3]=x,x=x>>>8,N[j+2]=x,x=x>>>8,N[j+1]=x,x=x>>>8,N[j]=x}function e(N,x){return N[x+0]<<0>>>0|N[x+1]<<8>>>0|N[x+2]<<16>>>0|N[x+3]<<24>>>0}function i(N,x,j){N[j+0]=x&255,x=x>>>8,N[j+1]=x&255,x=x>>>8,N[j+2]=x&255,x=x>>>8,N[j+3]=x&255}function o(N,x){return N[x]}function l(N,x,j){N[j]=x}function f(N){return C.$ue(N,x=>d.concat(x))}function S(N){return C.$Be(N)}function m(N){return C.$we(N,x=>d.concat(x))}async function b(N){return N.ended?d.concat(N.buffer):d.concat([...N.buffer,await m(N.stream)])}function r(N){return C.$ze(N,x=>d.concat(x))}function D(N){return C.$Ce(N,{data:x=>typeof x=="string"?d.fromString(x):d.wrap(x)},x=>d.concat(x))}function k(N){return C.$te(x=>d.concat(x),N)}function T(N,x){return C.$De(N,x,j=>d.concat(j))}function L(N,x){return C.$Ee(N,x,j=>d.concat(j))}function q(N){let x=0,j=0,Y=0;const K=new Uint8Array(Math.floor(N.length/4*3)),ae=ee=>{switch(j){case 3:K[Y++]=x|ee,j=0;break;case 2:K[Y++]=x|ee>>>2,x=ee<<6,j=3;break;case 1:K[Y++]=x|ee>>>4,x=ee<<4,j=2;break;default:x=ee<<2,j=1}};for(let ee=0;ee<N.length;ee++){const ce=N.charCodeAt(ee);if(ce>=65&&ce<=90)ae(ce-65);else if(ce>=97&&ce<=122)ae(ce-97+26);else if(ce>=48&&ce<=57)ae(ce-48+52);else if(ce===43||ce===45)ae(62);else if(ce===47||ce===95)ae(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${N[ee]}`)}}const ie=Y;for(;j>0;)ae(0);return d.wrap(K).slice(0,ie)}const $="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function V({buffer:N},x=!0,j=!1){const Y=j?I:$;let K="";const ae=N.byteLength%3;let ie=0;for(;ie<N.byteLength-ae;ie+=3){const ee=N[ie+0],ce=N[ie+1],De=N[ie+2];K+=Y[ee>>>2],K+=Y[(ee<<4|ce>>>4)&63],K+=Y[(ce<<2|De>>>6)&63],K+=Y[De&63]}if(ae===1){const ee=N[ie+0];K+=Y[ee>>>2],K+=Y[ee<<4&63],x&&(K+="==")}else if(ae===2){const ee=N[ie+0],ce=N[ie+1];K+=Y[ee>>>2],K+=Y[(ee<<4|ce>>>4)&63],K+=Y[ce<<2&63],x&&(K+="=")}return K}}),define(me[9],be([1,0,94,23]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7f=t.$6f=t.$5f=t.GraphemeBreakType=t.$Uf=t.$Nf=t.$Gf=t.$Ff=void 0,t.$7e=B,t.$8e=A,t.$9e=d,t.$0e=g,t.$$e=w,t.$_e=M,t.$af=c,t.$bf=h,t.$cf=e,t.$df=i,t.$ef=o,t.$ff=l,t.$gf=f,t.$hf=S,t.$if=m,t.$jf=b,t.$kf=r,t.$lf=D,t.$mf=k,t.$nf=T,t.$of=L,t.$pf=q,t.$qf=$,t.$rf=I,t.$sf=V,t.$tf=N,t.$uf=x,t.$vf=j,t.$wf=Y,t.$xf=K,t.$yf=ae,t.$zf=ie,t.$Af=ee,t.$Bf=ce,t.$Cf=De,t.$Df=Ee,t.$Ef=Le,t.$Hf=re,t.$If=ye,t.$Jf=W,t.$Kf=Q,t.$Lf=ke,t.$Mf=Ie,t.$Of=z,t.$Pf=u,t.$Qf=y,t.$Rf=a,t.$Sf=F,t.$Tf=s,t.$Vf=E,t.$Wf=p,t.$Xf=R,t.$Yf=O,t.$Zf=U,t.$1f=Z,t.$2f=oe,t.$3f=pe,t.$4f=Se;function B(J){return!J||typeof J!="string"?!0:J.trim().length===0}const H=/{(\d+)}/g;function A(J,...ne){return ne.length===0?J:J.replace(H,function($e,ve){const Ne=parseInt(ve,10);return isNaN(Ne)||Ne<0||Ne>=ne.length?$e:ne[Ne]})}const P=/{([^}]+)}/g;function d(J,ne){return Object.keys(ne).length===0?J:J.replace(P,($e,ve)=>ne[ve]??$e)}function g(J){return J.replace(/[<>"'&]/g,ne=>{switch(ne){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ne})}function w(J){return J.replace(/[<>&]/g,function(ne){switch(ne){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ne}})}function M(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function c(J,ne){let $e=0;const ve=ne.charCodeAt(0);for(let Ne=J.length-1;Ne>=0;Ne--)J.charCodeAt(Ne)===ve&&$e++;return $e}function h(J,ne,$e="\u2026"){return J.length<=ne?J:`${J.substr(0,ne)}${$e}`}function e(J,ne,$e="\u2026"){if(J.length<=ne)return J;const ve=Math.ceil(ne/2)-$e.length/2,Ne=Math.floor(ne/2)-$e.length/2;return`${J.substr(0,ve)}${$e}${J.substr(J.length-Ne)}`}function i(J,ne=" "){const $e=o(J,ne);return l($e,ne)}function o(J,ne){if(!J||!ne)return J;const $e=ne.length;if($e===0||J.length===0)return J;let ve=0;for(;J.indexOf(ne,ve)===ve;)ve=ve+$e;return J.substring(ve)}function l(J,ne){if(!J||!ne)return J;const $e=ne.length,ve=J.length;if($e===0||ve===0)return J;let Ne=ve,ze=-1;for(;ze=J.lastIndexOf(ne,Ne-1),!(ze===-1||ze+$e!==Ne);){if(ze===0)return"";Ne=ze}return J.substring(0,Ne)}function f(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}function S(J){return J.replace(/\*/g,"")}function m(J,ne,$e={}){if(!J)throw new Error("Cannot create regex from empty string");ne||(J=M(J)),$e.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let ve="";return $e.global&&(ve+="g"),$e.matchCase||(ve+="i"),$e.multiline&&(ve+="m"),$e.unicode&&(ve+="u"),new RegExp(J,ve)}function b(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}function r(J){return J.split(/\r\n|\r|\n/)}function D(J){const ne=[],$e=J.split(/(\r\n|\r|\n)/);for(let ve=0;ve<Math.ceil($e.length/2);ve++)ne.push($e[2*ve]+($e[2*ve+1]??""));return ne}function k(J){for(let ne=0,$e=J.length;ne<$e;ne++){const ve=J.charCodeAt(ne);if(ve!==32&&ve!==9)return ne}return-1}function T(J,ne=0,$e=J.length){for(let ve=ne;ve<$e;ve++){const Ne=J.charCodeAt(ve);if(Ne!==32&&Ne!==9)return J.substring(ne,ve)}return J.substring(ne,$e)}function L(J,ne=J.length-1){for(let $e=ne;$e>=0;$e--){const ve=J.charCodeAt($e);if(ve!==32&&ve!==9)return $e}return-1}function q(J,ne,$e){const ve=[];let Ne=0;for(const ze of J.matchAll(ne)){if(ve.push(J.slice(Ne,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Ne=ze.index+ze[0].length,ve.push($e(ze[0],...ze.slice(1),ze.index,J,ze.groups))}return ve.push(J.slice(Ne)),Promise.all(ve).then(ze=>ze.join(""))}function $(J,ne){return J<ne?-1:J>ne?1:0}function I(J,ne,$e=0,ve=J.length,Ne=0,ze=ne.length){for(;$e<ve&&Ne<ze;$e++,Ne++){const it=J.charCodeAt($e),st=ne.charCodeAt(Ne);if(it<st)return-1;if(it>st)return 1}const Ve=ve-$e,et=ze-Ne;return Ve<et?-1:Ve>et?1:0}function V(J,ne){return N(J,ne,0,J.length,0,ne.length)}function N(J,ne,$e=0,ve=J.length,Ne=0,ze=ne.length){for(;$e<ve&&Ne<ze;$e++,Ne++){let it=J.charCodeAt($e),st=ne.charCodeAt(Ne);if(it===st)continue;if(it>=128||st>=128)return I(J.toLowerCase(),ne.toLowerCase(),$e,ve,Ne,ze);j(it)&&(it-=32),j(st)&&(st-=32);const Qe=it-st;if(Qe!==0)return Qe}const Ve=ve-$e,et=ze-Ne;return Ve<et?-1:Ve>et?1:0}function x(J){return J>=48&&J<=57}function j(J){return J>=97&&J<=122}function Y(J){return J>=65&&J<=90}function K(J,ne){return J.length===ne.length&&N(J,ne)===0}function ae(J,ne){const $e=ne.length;return ne.length>J.length?!1:N(J,ne,0,$e)===0}function ie(J,ne){const $e=Math.min(J.length,ne.length);let ve;for(ve=0;ve<$e;ve++)if(J.charCodeAt(ve)!==ne.charCodeAt(ve))return ve;return $e}function ee(J,ne){const $e=Math.min(J.length,ne.length);let ve;const Ne=J.length-1,ze=ne.length-1;for(ve=0;ve<$e;ve++)if(J.charCodeAt(Ne-ve)!==ne.charCodeAt(ze-ve))return ve;return $e}function ce(J){return 55296<=J&&J<=56319}function De(J){return 56320<=J&&J<=57343}function Ee(J,ne){return(J-55296<<10)+(ne-56320)+65536}function Le(J,ne,$e){const ve=J.charCodeAt($e);if(ce(ve)&&$e+1<ne){const Ne=J.charCodeAt($e+1);if(De(Ne))return Ee(ve,Ne)}return ve}function le(J,ne){const $e=J.charCodeAt(ne-1);if(De($e)&&ne>1){const ve=J.charCodeAt(ne-2);if(ce(ve))return Ee(ve,$e)}return $e}class _{get offset(){return this.e}constructor(ne,$e=0){this.c=ne,this.d=ne.length,this.e=$e}setOffset(ne){this.e=ne}prevCodePoint(){const ne=le(this.c,this.e);return this.e-=ne>=65536?2:1,ne}nextCodePoint(){const ne=Le(this.c,this.d,this.e);return this.e+=ne>=65536?2:1,ne}eol(){return this.e>=this.d}}t.$Ff=_;class ue{get offset(){return this.c.offset}constructor(ne,$e=0){this.c=new _(ne,$e)}nextGraphemeLength(){const ne=Pe.getInstance(),$e=this.c,ve=$e.offset;let Ne=ne.getGraphemeBreakType($e.nextCodePoint());for(;!$e.eol();){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.nextCodePoint());if(fe(Ne,Ve)){$e.setOffset(ze);break}Ne=Ve}return $e.offset-ve}prevGraphemeLength(){const ne=Pe.getInstance(),$e=this.c,ve=$e.offset;let Ne=ne.getGraphemeBreakType($e.prevCodePoint());for(;$e.offset>0;){const ze=$e.offset,Ve=ne.getGraphemeBreakType($e.prevCodePoint());if(fe(Ve,Ne)){$e.setOffset(ze);break}Ne=Ve}return ve-$e.offset}eol(){return this.c.eol()}}t.$Gf=ue;function re(J,ne){return new ue(J,ne).nextGraphemeLength()}function ye(J,ne){return new ue(J,ne).prevGraphemeLength()}function W(J,ne){ne>0&&De(J.charCodeAt(ne))&&ne--;const $e=ne+re(J,ne);return[$e-ye(J,$e),$e]}function Q(J){const ne=new ue(J);let $e=0;for(;!ne.eol();)$e++,ne.nextGraphemeLength();return $e}let ge;function we(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ke(J){return ge||(ge=we()),ge.test(J)}const Te=/^[\t\n\r\x20-\x7E]*$/;function Ie(J){return Te.test(J)}t.$Nf=/[\u2028\u2029]/;function z(J){return t.$Nf.test(J)}function u(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}function y(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}function a(J,ne,$e=""){const ve=J.trimStart();if(ve.length<ne)return ve;const Ne=/\b/g;let ze=0;for(;Ne.test(ve)&&!(ve.length-Ne.lastIndex<ne);)ze=Ne.lastIndex,Ne.lastIndex+=1;return ze===0?ve:$e+ve.substring(ze).trimStart()}const v=/(:?(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~])|(:?\x1b\].*?\x07)/g;function*F(J){let ne=0;for(const $e of J.matchAll(v))ne!==$e.index&&(yield{isCode:!1,str:J.substring(ne,$e.index)}),yield{isCode:!0,str:$e[0]},ne=$e.index+$e[0].length;ne!==J.length&&(yield{isCode:!1,str:J.substring(ne)})}function s(J){return J&&(J=J.replace(v,"")),J}t.$Uf="\uFEFF";function E(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}function p(J){return E(J)?J.substr(1):J}function R(J,ne){if(!J||!ne||J.length<ne.length)return!1;const $e=ne.length,ve=J.toLowerCase();let Ne=0,ze=-1;for(;Ne<$e;){const Ve=ve.indexOf(ne[Ne],ze+1);if(Ve<0)return!1;ze=Ve,Ne++}return!0}function O(J,ne=!1){return J?(ne&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}function U(J){return J.charAt(0).toUpperCase()+J.slice(1)}function Z(J,ne=1){if(ne===0)return"";let $e=-1;do $e=J.indexOf(`
`,$e+1),ne--;while(ne>0&&$e>=0);return $e===-1?J:(J[$e-1]==="\r"&&$e--,J.substr(0,$e))}function oe(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}function pe(J){return Pe.getInstance().getGraphemeBreakType(J)}function fe(J,ne){return J===0?ne!==5&&ne!==7:J===2&&ne===3?!1:J===4||J===2||J===3||ne===4||ne===2||ne===3?!0:!(J===8&&(ne===8||ne===9||ne===11||ne===12)||(J===11||J===9)&&(ne===9||ne===10)||(J===12||J===10)&&ne===10||ne===5||ne===13||ne===7||J===1||J===13&&ne===14||J===6&&ne===6)}var Re;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Re||(t.GraphemeBreakType=Re={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=je()}getGraphemeBreakType(ne){if(ne<32)return ne===10?3:ne===13?2:4;if(ne<127)return 0;const $e=this.d,ve=$e.length/3;let Ne=1;for(;Ne<=ve;)if(ne<$e[3*Ne])Ne=2*Ne;else if(ne>$e[3*Ne+1])Ne=2*Ne+1;else return $e[3*Ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Se(J,ne){if(J===0)return 0;const $e=Ce(J,ne);if($e!==void 0)return $e;const ve=new _(ne,J);return ve.prevCodePoint(),ve.offset}function Ce(J,ne){const $e=new _(ne,J);let ve=$e.prevCodePoint();for(;We(ve)||ve===65039||ve===8419;){if($e.offset===0)return;ve=$e.prevCodePoint()}if(!y(ve))return;let Ne=$e.offset;return Ne>0&&$e.prevCodePoint()===8205&&(Ne=$e.offset),Ne}function We(J){return 127995<=J&&J<=127999}var Xe;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),t.$5f="\xA0";class Ue{static{this.c=new C.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new n.$3e({getCacheKey:JSON.stringify},ne=>{function $e(Qe){const rt=new Map;for(let tt=0;tt<Qe.length;tt+=2)rt.set(Qe[tt],Qe[tt+1]);return rt}function ve(Qe,rt){const tt=new Map(Qe);for(const[mt,gt]of rt)tt.set(mt,gt);return tt}function Ne(Qe,rt){if(!Qe)return rt;const tt=new Map;for(const[mt,gt]of Qe)rt.has(mt)&&tt.set(mt,gt);return tt}const ze=this.c.value;let Ve=ne.filter(Qe=>!Qe.startsWith("_")&&Qe in ze);Ve.length===0&&(Ve=["_default"]);let et;for(const Qe of Ve){const rt=$e(ze[Qe]);et=Ne(et,rt)}const it=$e(ze._common),st=ve(it,et);return new Ue(st)})}static getInstance(ne){return Ue.d.get(Array.from(ne))}static{this.e=new C.$V(()=>Object.keys(Ue.c.value).filter(ne=>!ne.startsWith("_")))}static getLocales(){return Ue.e.value}constructor(ne){this.f=ne}isAmbiguous(ne){return this.f.has(ne)}getPrimaryConfusable(ne){return this.f.get(ne)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.$6f=Ue;class _e{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(_e.c())),this.d}static isInvisibleCharacter(ne){return _e.e().has(ne)}static get codePoints(){return _e.e()}}t.$7f=_e}),define(me[44],be([1,0,39,89,9]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ik=t.FuzzyScore=t.$xk=t.$wk=void 0,t.or=H,t.$yk=P,t.$zk=d,t.$Ak=M,t.$Bk=q,t.$Ck=$,t.$Dk=Y,t.$Ek=K,t.$Fk=ae,t.$Gk=ie,t.$Hk=ke,t.$Jk=u,t.$Kk=v,t.$Lk=F;function H(...p){return function(R,O){for(let U=0,Z=p.length;U<Z;U++){const oe=p[U](R,O);if(oe)return oe}return null}}t.$wk=A.bind(void 0,!1),t.$xk=A.bind(void 0,!0);function A(p,R,O){if(!O||O.length<R.length)return null;let U;return p?U=B.$yf(O,R):U=O.indexOf(R)===0,U?R.length>0?[{start:0,end:R.length}]:[]:null}function P(p,R){const O=R.toLowerCase().indexOf(p.toLowerCase());return O===-1?null:[{start:O,end:O+p.length}]}function d(p,R){return g(p.toLowerCase(),R.toLowerCase(),0,0)}function g(p,R,O,U){if(O===p.length)return[];if(U===R.length)return null;if(p[O]===R[U]){let Z=null;return(Z=g(p,R,O+1,U+1))?m({start:U,end:U+1},Z):null}return g(p,R,O,U+1)}function w(p){return 97<=p&&p<=122}function M(p){return 65<=p&&p<=90}function c(p){return 48<=p&&p<=57}function h(p){return p===32||p===9||p===10||p===13}const e=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(p=>e.add(p.charCodeAt(0)));function i(p){return h(p)||e.has(p)}function o(p,R){return p===R||i(p)&&i(R)}const l=new Map;function f(p){if(l.has(p))return l.get(p);let R;const O=(0,C.$uk)(p);return O&&(R=O),l.set(p,R),R}function S(p){return w(p)||M(p)||c(p)}function m(p,R){return R.length===0?R=[p]:p.end===R[0].start?R[0].start=p.start:R.unshift(p),R}function b(p,R){for(let O=R;O<p.length;O++){const U=p.charCodeAt(O);if(M(U)||c(U)||O>0&&!S(p.charCodeAt(O-1)))return O}return p.length}function r(p,R,O,U){if(O===p.length)return[];if(U===R.length)return null;if(p[O]!==R[U].toLowerCase())return null;{let Z=null,oe=U+1;for(Z=r(p,R,O+1,U+1);!Z&&(oe=b(R,oe))<R.length;)Z=r(p,R,O+1,oe),oe++;return Z===null?null:m({start:U,end:U+1},Z)}}function D(p){let R=0,O=0,U=0,Z=0,oe=0;for(let je=0;je<p.length;je++)oe=p.charCodeAt(je),M(oe)&&R++,w(oe)&&O++,S(oe)&&U++,c(oe)&&Z++;const pe=R/p.length,fe=O/p.length,Re=U/p.length,Pe=Z/p.length;return{upperPercent:pe,lowerPercent:fe,alphaPercent:Re,numericPercent:Pe}}function k(p){const{upperPercent:R,lowerPercent:O}=p;return O===0&&R>.6}function T(p){const{upperPercent:R,lowerPercent:O,alphaPercent:U,numericPercent:Z}=p;return O>.2&&R<.8&&U>.6&&Z<.2}function L(p){let R=0,O=0,U=0,Z=0;for(let oe=0;oe<p.length;oe++)U=p.charCodeAt(oe),M(U)&&R++,w(U)&&O++,h(U)&&Z++;return(R===0||O===0)&&Z===0?p.length<=30:R<=5}function q(p,R){if(!R||(R=R.trim(),R.length===0)||!L(p))return null;R.length>60&&(R=R.substring(0,60));const O=D(R);if(!T(O)){if(!k(O))return null;R=R.toLowerCase()}let U=null,Z=0;for(p=p.toLowerCase();Z<R.length&&(U=r(p,R,0,Z))===null;)Z=b(R,Z+1);return U}function $(p,R,O=!1){if(!R||R.length===0)return null;let U=null,Z=0;for(p=p.toLowerCase(),R=R.toLowerCase();Z<R.length&&(U=I(p,R,0,Z,O),U===null);)Z=V(R,Z+1);return U}function I(p,R,O,U,Z){let oe=0;if(O===p.length)return[];if(U===R.length)return null;if(!o(p.charCodeAt(O),R.charCodeAt(U))){const Re=f(p.charCodeAt(O));if(!Re)return null;for(let Pe=0;Pe<Re.length;Pe++)if(!o(Re[Pe],R.charCodeAt(U+Pe)))return null;oe+=Re.length-1}let pe=null,fe=U+oe+1;if(pe=I(p,R,O+1,fe,Z),!Z)for(;!pe&&(fe=V(R,fe))<R.length;)pe=I(p,R,O+1,fe,Z),fe++;if(!pe)return null;if(p.charCodeAt(O)!==R.charCodeAt(U)){const Re=f(p.charCodeAt(O));if(!Re)return pe;for(let Pe=0;Pe<Re.length;Pe++)if(Re[Pe]!==R.charCodeAt(U+Pe))return pe}return m({start:U,end:U+oe+1},pe)}function V(p,R){for(let O=R;O<p.length;O++)if(i(p.charCodeAt(O))||O>0&&i(p.charCodeAt(O-1)))return O;return p.length}const N=H(t.$xk,q,P),x=H(t.$xk,q,d),j=new n.$Ec(1e4);function Y(p,R,O=!1){if(typeof p!="string"||typeof R!="string")return null;let U=j.get(p);U||(U=new RegExp(B.$gf(p),"i"),j.set(p,U));const Z=U.exec(R);return Z?[{start:Z.index,end:Z.index+Z[0].length}]:O?x(p,R):N(p,R)}function K(p,R){const O=u(p,p.toLowerCase(),0,R,R.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return O?ie(O):null}function ae(p,R,O,U,Z,oe){const pe=Math.min(13,p.length);for(;O<pe;O++){const fe=u(p,R,O,U,Z,oe,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(fe)return fe}return[0,oe]}function ie(p){if(typeof p>"u")return[];const R=[],O=p[1];for(let U=p.length-1;U>1;U--){const Z=p[U]+O,oe=R[R.length-1];oe&&oe.end===Z?oe.end=Z+1:R.push({start:Z,end:Z+1})}return R}const ee=128;function ce(){const p=[],R=[];for(let O=0;O<=ee;O++)R[O]=0;for(let O=0;O<=ee;O++)p.push(R.slice(0));return p}function De(p){const R=[];for(let O=0;O<=p;O++)R[O]=0;return R}const Ee=De(2*ee),Le=De(2*ee),le=ce(),_=ce(),ue=ce(),re=!1;function ye(p,R,O,U,Z){function oe(fe,Re,Pe=" "){for(;fe.length<Re;)fe=Pe+fe;return fe}let pe=` |   |${U.split("").map(fe=>oe(fe,3)).join("|")}
`;for(let fe=0;fe<=O;fe++)fe===0?pe+=" |":pe+=`${R[fe-1]}|`,pe+=p[fe].slice(0,Z+1).map(Re=>oe(Re.toString(),3)).join("|")+`
`;return pe}function W(p,R,O,U){p=p.substr(R),O=O.substr(U),console.log(ye(_,p,p.length,O,O.length)),console.log(ye(ue,p,p.length,O,O.length)),console.log(ye(le,p,p.length,O,O.length))}function Q(p,R){if(R<0||R>=p.length)return!1;const O=p.codePointAt(R);switch(O){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!B.$Qf(O)}}function ge(p,R){if(R<0||R>=p.length)return!1;switch(p.charCodeAt(R)){case 32:case 9:return!0;default:return!1}}function we(p,R,O){return R[p]!==O[p]}function ke(p,R,O,U,Z,oe,pe=!1){for(;R<O&&Z<oe;)p[R]===U[Z]&&(pe&&(Ee[R]=Z),R+=1),Z+=1;return R===O}var Te;(function(p){p[p.Diag=1]="Diag",p[p.Left=2]="Left",p[p.LeftLeft=3]="LeftLeft"})(Te||(Te={}));var Ie;(function(p){p.Default=[-100,0];function R(O){return!O||O.length===2&&O[0]===-100&&O[1]===0}p.isDefault=R})(Ie||(t.FuzzyScore=Ie={}));class z{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(R,O){this.firstMatchCanBeWeak=R,this.boostFullMatch=O}}t.$Ik=z;function u(p,R,O,U,Z,oe,pe=z.default){const fe=p.length>ee?ee:p.length,Re=U.length>ee?ee:U.length;if(O>=fe||oe>=Re||fe-O>Re-oe||!ke(R,O,fe,Z,oe,Re,!0))return;y(fe,Re,O,oe,R,Z);let Pe=1,je=1,Se=O,Ce=oe;const We=[!1];for(Pe=1,Se=O;Se<fe;Pe++,Se++){const ne=Ee[Se],$e=Le[Se],ve=Se+1<fe?Le[Se+1]:Re;for(je=ne-oe+1,Ce=ne;Ce<ve;je++,Ce++){let Ne=Number.MIN_SAFE_INTEGER,ze=!1;Ce<=$e&&(Ne=a(p,R,Se,O,U,Z,Ce,Re,oe,le[Pe-1][je-1]===0,We));let Ve=0;Ne!==Number.MAX_SAFE_INTEGER&&(ze=!0,Ve=Ne+_[Pe-1][je-1]);const et=Ce>ne,it=et?_[Pe][je-1]+(le[Pe][je-1]>0?-5:0):0,st=Ce>ne+1&&le[Pe][je-1]>0,Qe=st?_[Pe][je-2]+(le[Pe][je-2]>0?-5:0):0;if(st&&(!et||Qe>=it)&&(!ze||Qe>=Ve))_[Pe][je]=Qe,ue[Pe][je]=3,le[Pe][je]=0;else if(et&&(!ze||it>=Ve))_[Pe][je]=it,ue[Pe][je]=2,le[Pe][je]=0;else if(ze)_[Pe][je]=Ve,ue[Pe][je]=1,le[Pe][je]=le[Pe-1][je-1]+1;else throw new Error("not possible")}}if(re&&W(p,O,U,oe),!We[0]&&!pe.firstMatchCanBeWeak)return;Pe--,je--;const Xe=[_[Pe][je],oe];let Ue=0,_e=0;for(;Pe>=1;){let ne=je;do{const $e=ue[Pe][ne];if($e===3)ne=ne-2;else if($e===2)ne=ne-1;else break}while(ne>=1);Ue>1&&R[O+Pe-1]===Z[oe+je-1]&&!we(ne+oe-1,U,Z)&&Ue+1>le[Pe][ne]&&(ne=je),ne===je?Ue++:Ue=1,_e||(_e=ne),Pe--,je=ne-1,Xe.push(je)}Re===fe&&pe.boostFullMatch&&(Xe[0]+=2);const J=_e-fe;return Xe[0]-=J,Xe}function y(p,R,O,U,Z,oe){let pe=p-1,fe=R-1;for(;pe>=O&&fe>=U;)Z[pe]===oe[fe]&&(Le[pe]=fe,pe--),fe--}function a(p,R,O,U,Z,oe,pe,fe,Re,Pe,je){if(R[O]!==oe[pe])return Number.MIN_SAFE_INTEGER;let Se=1,Ce=!1;return pe===O-U?Se=p[O]===Z[pe]?7:5:we(pe,Z,oe)&&(pe===0||!we(pe-1,Z,oe))?(Se=p[O]===Z[pe]?7:5,Ce=!0):Q(oe,pe)&&(pe===0||!Q(oe,pe-1))?Se=5:(Q(oe,pe-1)||ge(oe,pe-1))&&(Se=5,Ce=!0),Se>1&&O===U&&(je[0]=!0),Ce||(Ce=we(pe,Z,oe)||Q(oe,pe-1)||ge(oe,pe-1)),O===U?pe>Re&&(Se-=Ce?3:5):Pe?Se+=Ce?2:0:Se+=Ce?0:1,pe+1===fe&&(Se-=Ce?3:5),Se}function v(p,R,O,U,Z,oe,pe){return s(p,R,O,U,Z,oe,!0,pe)}function F(p,R,O,U,Z,oe,pe){return s(p,R,O,U,Z,oe,!1,pe)}function s(p,R,O,U,Z,oe,pe,fe){let Re=u(p,R,O,U,Z,oe,fe);if(Re&&!pe)return Re;if(p.length>=3){const Pe=Math.min(7,p.length-1);for(let je=O+1;je<Pe;je++){const Se=E(p,je);if(Se){const Ce=u(Se,Se.toLowerCase(),O,U,Z,oe,fe);Ce&&(Ce[0]-=3,(!Re||Ce[0]>Re[0])&&(Re=Ce))}}}return Re}function E(p,R){if(R+1>=p.length)return;const O=p[R],U=p[R+1];if(O!==U)return p.slice(0,R)+U+O+p.slice(R+2)}}),define(me[59],be([1,0,9]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pj=t.$nj=void 0,t.$jj=C,t.$kj=B,t.$lj=H,t.$mj=P,t.$oj=i;function C(l){return B(l,0)}function B(l,f){switch(typeof l){case"object":return l===null?H(349,f):Array.isArray(l)?d(l,f):g(l,f);case"string":return P(l,f);case"boolean":return A(l,f);case"number":return H(l,f);case"undefined":return H(937,f);default:return H(617,f)}}function H(l,f){return(f<<5)-f+l|0}function A(l,f){return H(l?433:863,f)}function P(l,f){f=H(149417,f);for(let S=0,m=l.length;S<m;S++)f=H(l.charCodeAt(S),f);return f}function d(l,f){return f=H(104579,f),l.reduce((S,m)=>B(m,S),f)}function g(l,f){return f=H(181387,f),Object.keys(l).sort().reduce((S,m)=>(S=P(m,S),B(l[m],S)),f)}class w{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=B(f,this.g),this.g}}t.$nj=w;var M;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(M||(M={}));function c(l,f,S=32){const m=S-f,b=~((1<<m)-1);return(l<<f|(b&l)>>>m)>>>0}function h(l,f=0,S=l.byteLength,m=0){for(let b=0;b<S;b++)l[f+b]=m}function e(l,f,S="0"){for(;l.length<f;)l=S+l;return l}function i(l,f=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(S=>S.toString(16).padStart(2,"0")).join(""):e((l>>>0).toString(16),f/4)}class o{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const S=f.length;if(S===0)return;const m=this.p;let b=this.r,r=this.u,D,k;for(r!==0?(D=r,k=-1,r=0):(D=f.charCodeAt(0),k=0);;){let T=D;if(n.$Bf(D))if(k+1<S){const L=f.charCodeAt(k+1);n.$Cf(L)?(k++,T=n.$Df(D,L)):T=65533}else{r=D;break}else n.$Cf(D)&&(T=65533);if(b=this.w(m,b,T),k++,k<S)D=f.charCodeAt(k);else break}this.r=b,this.u=r}w(f,S,m){return m<128?f[S++]=m:m<2048?(f[S++]=192|(m&1984)>>>6,f[S++]=128|(m&63)>>>0):m<65536?(f[S++]=224|(m&61440)>>>12,f[S++]=128|(m&4032)>>>6,f[S++]=128|(m&63)>>>0):(f[S++]=240|(m&1835008)>>>18,f[S++]=128|(m&258048)>>>12,f[S++]=128|(m&4032)>>>6,f[S++]=128|(m&63)>>>0),S>=64&&(this.y(),S-=64,this.t+=64,f[0]=f[64],f[1]=f[65],f[2]=f[66]),S}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),i(this.h)+i(this.l)+i(this.m)+i(this.n)+i(this.o)}x(){this.p[this.r++]=128,h(this.p,this.r),this.r>56&&(this.y(),h(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=o.g,S=this.q;for(let $=0;$<64;$+=4)f.setUint32($,S.getUint32($,!1),!1);for(let $=64;$<320;$+=4)f.setUint32($,c(f.getUint32($-12,!1)^f.getUint32($-32,!1)^f.getUint32($-56,!1)^f.getUint32($-64,!1),1),!1);let m=this.h,b=this.l,r=this.m,D=this.n,k=this.o,T,L,q;for(let $=0;$<80;$++)$<20?(T=b&r|~b&D,L=1518500249):$<40?(T=b^r^D,L=1859775393):$<60?(T=b&r|b&D|r&D,L=2400959708):(T=b^r^D,L=3395469782),q=c(m,5)+T+k+L+f.getUint32($*4,!1)&4294967295,k=D,D=r,r=c(b,30),b=m,m=q;this.h=this.h+m&4294967295,this.l=this.l+b&4294967295,this.m=this.m+r&4294967295,this.n=this.n+D&4294967295,this.o=this.o+k&4294967295}}t.$pj=o}),define(me[98],be([1,0,85,59]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zt=t.$xt=void 0,t.$yt=H;class B{constructor(c){this.a=c}getElements(){const c=this.a,h=new Int32Array(c.length);for(let e=0,i=c.length;e<i;e++)h[e]=c.charCodeAt(e);return h}}t.$xt=B;function H(M,c,h){return new w(new B(M),new B(c)).ComputeDiff(h).changes}class A{static Assert(c,h){if(!c)throw new Error(h)}}class P{static Copy(c,h,e,i,o){for(let l=0;l<o;l++)e[i+l]=c[h+l]}static Copy2(c,h,e,i,o){for(let l=0;l<o;l++)e[i+l]=c[h+l]}}var d;(function(M){M[M.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(d||(d={}));class g{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new n.$wt(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(c,h){this.b=Math.min(this.b,c),this.c=Math.min(this.c,h),this.d++}AddModifiedElement(c,h){this.b=Math.min(this.b,c),this.c=Math.min(this.c,h),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class w{constructor(c,h,e=null){this.a=e,this.b=c,this.c=h;const[i,o,l]=w.o(c),[f,S,m]=w.o(h);this.d=l&&m,this.e=i,this.f=o,this.g=f,this.h=S,this.k=[],this.m=[]}static n(c){return c.length>0&&typeof c[0]=="string"}static o(c){const h=c.getElements();if(w.n(h)){const e=new Int32Array(h.length);for(let i=0,o=h.length;i<o;i++)e[i]=(0,C.$mj)(h[i],0);return[h,e,!0]}return h instanceof Int32Array?[[],h,!1]:[[],new Int32Array(h),!1]}p(c,h){return this.f[c]!==this.h[h]?!1:this.d?this.e[c]===this.g[h]:!0}q(c,h){if(!this.p(c,h))return!1;const e=w.r(this.b,c),i=w.r(this.c,h);return e===i}static r(c,h){return typeof c.getStrictElement=="function"?c.getStrictElement(h):null}s(c,h){return this.f[c]!==this.f[h]?!1:this.d?this.e[c]===this.e[h]:!0}u(c,h){return this.h[c]!==this.h[h]?!1:this.d?this.g[c]===this.g[h]:!0}ComputeDiff(c){return this.v(0,this.f.length-1,0,this.h.length-1,c)}v(c,h,e,i,o){const l=[!1];let f=this.w(c,h,e,i,l);return o&&(f=this.z(f)),{quitEarly:l[0],changes:f}}w(c,h,e,i,o){for(o[0]=!1;c<=h&&e<=i&&this.p(c,e);)c++,e++;for(;h>=c&&i>=e&&this.p(h,i);)h--,i--;if(c>h||e>i){let r;return e<=i?(A.Assert(c===h+1,"originalStart should only be one more than originalEnd"),r=[new n.$wt(c,0,e,i-e+1)]):c<=h?(A.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),r=[new n.$wt(c,h-c+1,e,0)]):(A.Assert(c===h+1,"originalStart should only be one more than originalEnd"),A.Assert(e===i+1,"modifiedStart should only be one more than modifiedEnd"),r=[]),r}const l=[0],f=[0],S=this.y(c,h,e,i,l,f,o),m=l[0],b=f[0];if(S!==null)return S;if(!o[0]){const r=this.w(c,m,e,b,o);let D=[];return o[0]?D=[new n.$wt(m+1,h-(m+1)+1,b+1,i-(b+1)+1)]:D=this.w(m+1,h,b+1,i,o),this.H(r,D)}return[new n.$wt(c,h-c+1,e,i-e+1)]}x(c,h,e,i,o,l,f,S,m,b,r,D,k,T,L,q,$,I){let V=null,N=null,x=new g,j=h,Y=e,K=k[0]-q[0]-i,ae=-1073741824,ie=this.k.length-1;do{const ee=K+c;ee===j||ee<Y&&m[ee-1]<m[ee+1]?(r=m[ee+1],T=r-K-i,r<ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,T),K=ee+1-c):(r=m[ee-1]+1,T=r-K-i,r<ae&&x.MarkNextChange(),ae=r-1,x.AddOriginalElement(r,T+1),K=ee-1-c),ie>=0&&(m=this.k[ie],c=m[0],j=1,Y=m.length-1)}while(--ie>=-1);if(V=x.getReverseChanges(),I[0]){let ee=k[0]+1,ce=q[0]+1;if(V!==null&&V.length>0){const De=V[V.length-1];ee=Math.max(ee,De.getOriginalEnd()),ce=Math.max(ce,De.getModifiedEnd())}N=[new n.$wt(ee,D-ee+1,ce,L-ce+1)]}else{x=new g,j=l,Y=f,K=k[0]-q[0]-S,ae=1073741824,ie=$?this.m.length-1:this.m.length-2;do{const ee=K+o;ee===j||ee<Y&&b[ee-1]>=b[ee+1]?(r=b[ee+1]-1,T=r-K-S,r>ae&&x.MarkNextChange(),ae=r+1,x.AddOriginalElement(r+1,T+1),K=ee+1-o):(r=b[ee-1],T=r-K-S,r>ae&&x.MarkNextChange(),ae=r,x.AddModifiedElement(r+1,T+1),K=ee-1-o),ie>=0&&(b=this.m[ie],o=b[0],j=1,Y=b.length-1)}while(--ie>=-1);N=x.getChanges()}return this.H(V,N)}y(c,h,e,i,o,l,f){let S=0,m=0,b=0,r=0,D=0,k=0;c--,e--,o[0]=0,l[0]=0,this.k=[],this.m=[];const T=h-c+(i-e),L=T+1,q=new Int32Array(L),$=new Int32Array(L),I=i-e,V=h-c,N=c-e,x=h-i,Y=(V-I)%2===0;q[I]=c,$[V]=h,f[0]=!1;for(let K=1;K<=T/2+1;K++){let ae=0,ie=0;b=this.J(I-K,K,I,L),r=this.J(I+K,K,I,L);for(let ce=b;ce<=r;ce+=2){ce===b||ce<r&&q[ce-1]<q[ce+1]?S=q[ce+1]:S=q[ce-1]+1,m=S-(ce-I)-N;const De=S;for(;S<h&&m<i&&this.p(S+1,m+1);)S++,m++;if(q[ce]=S,S+m>ae+ie&&(ae=S,ie=m),!Y&&Math.abs(ce-V)<=K-1&&S>=$[ce])return o[0]=S,l[0]=m,De<=$[ce]&&1447>0&&K<=1448?this.x(I,b,r,N,V,D,k,x,q,$,S,h,o,m,i,l,Y,f):null}const ee=(ae-c+(ie-e)-K)/2;if(this.a!==null&&!this.a(ae,ee))return f[0]=!0,o[0]=ae,l[0]=ie,ee>0&&1447>0&&K<=1448?this.x(I,b,r,N,V,D,k,x,q,$,S,h,o,m,i,l,Y,f):(c++,e++,[new n.$wt(c,h-c+1,e,i-e+1)]);D=this.J(V-K,K,V,L),k=this.J(V+K,K,V,L);for(let ce=D;ce<=k;ce+=2){ce===D||ce<k&&$[ce-1]>=$[ce+1]?S=$[ce+1]-1:S=$[ce-1],m=S-(ce-V)-x;const De=S;for(;S>c&&m>e&&this.p(S,m);)S--,m--;if($[ce]=S,Y&&Math.abs(ce-I)<=K&&S<=q[ce])return o[0]=S,l[0]=m,De>=q[ce]&&1447>0&&K<=1448?this.x(I,b,r,N,V,D,k,x,q,$,S,h,o,m,i,l,Y,f):null}if(K<=1447){let ce=new Int32Array(r-b+2);ce[0]=I-b+1,P.Copy2(q,b,ce,1,r-b+1),this.k.push(ce),ce=new Int32Array(k-D+2),ce[0]=V-D+1,P.Copy2($,D,ce,1,k-D+1),this.m.push(ce)}}return this.x(I,b,r,N,V,D,k,x,q,$,S,h,o,m,i,l,Y,f)}z(c){for(let h=0;h<c.length;h++){const e=c[h],i=h<c.length-1?c[h+1].originalStart:this.f.length,o=h<c.length-1?c[h+1].modifiedStart:this.h.length,l=e.originalLength>0,f=e.modifiedLength>0;for(;e.originalStart+e.originalLength<i&&e.modifiedStart+e.modifiedLength<o&&(!l||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!f||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const m=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!m)break;e.originalStart++,e.modifiedStart++}const S=[null];if(h<c.length-1&&this.I(c[h],c[h+1],S)){c[h]=S[0],c.splice(h+1,1),h--;continue}}for(let h=c.length-1;h>=0;h--){const e=c[h];let i=0,o=0;if(h>0){const r=c[h-1];i=r.originalStart+r.originalLength,o=r.modifiedStart+r.modifiedLength}const l=e.originalLength>0,f=e.modifiedLength>0;let S=0,m=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let r=1;;r++){const D=e.originalStart-r,k=e.modifiedStart-r;if(D<i||k<o||l&&!this.s(D,D+e.originalLength)||f&&!this.u(k,k+e.modifiedLength))break;const L=(D===i&&k===o?5:0)+this.G(D,e.originalLength,k,e.modifiedLength);L>m&&(m=L,S=r)}e.originalStart-=S,e.modifiedStart-=S;const b=[null];if(h>0&&this.I(c[h-1],c[h],b)){c[h-1]=b[0],c.splice(h,1),h++;continue}}if(this.d)for(let h=1,e=c.length;h<e;h++){const i=c[h-1],o=c[h],l=o.originalStart-i.originalStart-i.originalLength,f=i.originalStart,S=o.originalStart+o.originalLength,m=S-f,b=i.modifiedStart,r=o.modifiedStart+o.modifiedLength,D=r-b;if(l<5&&m<20&&D<20){const k=this.A(f,m,b,D,l);if(k){const[T,L]=k;(T!==i.originalStart+i.originalLength||L!==i.modifiedStart+i.modifiedLength)&&(i.originalLength=T-i.originalStart,i.modifiedLength=L-i.modifiedStart,o.originalStart=T+l,o.modifiedStart=L+l,o.originalLength=S-o.originalStart,o.modifiedLength=r-o.modifiedStart)}}}return c}A(c,h,e,i,o){if(h<o||i<o)return null;const l=c+h-o+1,f=e+i-o+1;let S=0,m=0,b=0;for(let r=c;r<l;r++)for(let D=e;D<f;D++){const k=this.B(r,D,o);k>0&&k>S&&(S=k,m=r,b=D)}return S>0?[m,b]:null}B(c,h,e){let i=0;for(let o=0;o<e;o++){if(!this.p(c+o,h+o))return 0;i+=this.e[c+o].length}return i}C(c){return c<=0||c>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[c])}D(c,h){if(this.C(c)||this.C(c-1))return!0;if(h>0){const e=c+h;if(this.C(e-1)||this.C(e))return!0}return!1}E(c){return c<=0||c>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[c])}F(c,h){if(this.E(c)||this.E(c-1))return!0;if(h>0){const e=c+h;if(this.E(e-1)||this.E(e))return!0}return!1}G(c,h,e,i){const o=this.D(c,h)?1:0,l=this.F(e,i)?1:0;return o+l}H(c,h){const e=[];if(c.length===0||h.length===0)return h.length>0?h:c;if(this.I(c[c.length-1],h[0],e)){const i=new Array(c.length+h.length-1);return P.Copy(c,0,i,0,c.length-1),i[c.length-1]=e[0],P.Copy(h,1,i,c.length,h.length-1),i}else{const i=new Array(c.length+h.length);return P.Copy(c,0,i,0,c.length),P.Copy(h,0,i,c.length,h.length),i}}I(c,h,e){if(A.Assert(c.originalStart<=h.originalStart,"Left change is not less than or equal to right change"),A.Assert(c.modifiedStart<=h.modifiedStart,"Left change is not less than or equal to right change"),c.originalStart+c.originalLength>=h.originalStart||c.modifiedStart+c.modifiedLength>=h.modifiedStart){const i=c.originalStart;let o=c.originalLength;const l=c.modifiedStart;let f=c.modifiedLength;return c.originalStart+c.originalLength>=h.originalStart&&(o=h.originalStart+h.originalLength-c.originalStart),c.modifiedStart+c.modifiedLength>=h.modifiedStart&&(f=h.modifiedStart+h.modifiedLength-c.modifiedStart),e[0]=new n.$wt(i,o,l,f),!0}else return e[0]=null,!1}J(c,h,e,i){if(c>=0&&c<i)return c;const o=e,l=i-e-1,f=h%2===0;if(c<0){const S=o%2===0;return f===S?0:1}else{const S=l%2===0;return f===S?i-1:i-2}}}t.$zt=w}),define(me[60],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$be=void 0,t.$be=Symbol("MicrotaskDelay")}),define(me[99],be([1,0,8,9]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Bi=t.$Ai=t.$zi=t.$yi=t.$xi=void 0;class B{constructor(){this.b="",this.c=0}reset(h){return this.b=h,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(h){const e=h.charCodeAt(0),i=this.b.charCodeAt(this.c);return e-i}value(){return this.b[this.c]}}t.$xi=B;class H{constructor(h=!0){this.e=h}reset(h){return this.b=h,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let h=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(h)this.c++;else break;else h=!1;return this}cmp(h){return this.e?(0,C.$rf)(h,this.b,0,h.length,this.c,this.d):(0,C.$tf)(h,this.b,0,h.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.$yi=H;class A{constructor(h=!0,e=!0){this.f=h,this.g=e}reset(h){this.d=0,this.e=0,this.b=h,this.c=h.length;for(let e=h.length-1;e>=0;e--,this.c--){const i=this.b.charCodeAt(e);if(!(i===47||this.f&&i===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let h=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(h)this.d++;else break;else h=!1}return this}cmp(h){return this.g?(0,C.$rf)(h,this.b,0,h.length,this.d,this.e):(0,C.$tf)(h,this.b,0,h.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.$zi=A;var P;(function(c){c[c.Scheme=1]="Scheme",c[c.Authority=2]="Authority",c[c.Path=3]="Path",c[c.Query=4]="Query",c[c.Fragment=5]="Fragment"})(P||(P={}));class d{constructor(h,e){this.f=h,this.g=e,this.d=[],this.e=0}reset(h){return this.c=h,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(h)),this.b.reset(h.path),this.b.value()&&this.d.push(3)),this.g(h)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(h){if(this.d[this.e]===1)return(0,C.$sf)(h,this.c.scheme);if(this.d[this.e]===2)return(0,C.$sf)(h,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(h);if(this.d[this.e]===4)return(0,C.$qf)(h,this.c.query);if(this.d[this.e]===5)return(0,C.$qf)(h,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.$Ai=d;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const h=this.right;return this.right=h.left,h.left=this,this.updateHeight(),h.updateHeight(),h}rotateRight(){const h=this.left;return this.left=h.right,h.right=this,this.updateHeight(),h.updateHeight(),h}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var w;(function(c){c[c.Left=-1]="Left",c[c.Mid=0]="Mid",c[c.Right=1]="Right"})(w||(w={}));class M{static forUris(h=()=>!1,e=()=>!1){return new M(new d(h,e))}static forPaths(h=!1){return new M(new A(void 0,!h))}static forStrings(){return new M(new B)}static forConfigKeys(){return new M(new H)}constructor(h){this.b=h}clear(){this.c=void 0}fill(h,e){if(e){const i=e.slice(0);(0,n.$Xb)(i);for(const o of i)this.set(o,h)}else{const i=h.slice(0);(0,n.$Xb)(i);for(const o of i)this.set(o[0],o[1])}}set(h,e){const i=this.b.reset(h);let o;this.c||(this.c=new g,this.c.segment=i.value());const l=[];for(o=this.c;;){const S=i.cmp(o.segment);if(S>0)o.left||(o.left=new g,o.left.segment=i.value()),l.push([-1,o]),o=o.left;else if(S<0)o.right||(o.right=new g,o.right.segment=i.value()),l.push([1,o]),o=o.right;else if(i.hasNext())i.next(),o.mid||(o.mid=new g,o.mid.segment=i.value()),l.push([0,o]),o=o.mid;else break}const f=o.value;o.value=e,o.key=h;for(let S=l.length-1;S>=0;S--){const m=l[S][1];m.updateHeight();const b=m.balanceFactor();if(b<-1||b>1){const r=l[S][0],D=l[S+1][0];if(r===1&&D===1)l[S][1]=m.rotateLeft();else if(r===-1&&D===-1)l[S][1]=m.rotateRight();else if(r===1&&D===-1)m.right=l[S+1][1]=l[S+1][1].rotateRight(),l[S][1]=m.rotateLeft();else if(r===-1&&D===1)m.left=l[S+1][1]=l[S+1][1].rotateLeft(),l[S][1]=m.rotateRight();else throw new Error;if(S>0)switch(l[S-1][0]){case-1:l[S-1][1].left=l[S][1];break;case 1:l[S-1][1].right=l[S][1];break;case 0:l[S-1][1].mid=l[S][1];break}else this.c=l[0][1]}}return f}get(h){return this.d(h)?.value}d(h){const e=this.b.reset(h);let i=this.c;for(;i;){const o=e.cmp(i.segment);if(o>0)i=i.left;else if(o<0)i=i.right;else if(e.hasNext())e.next(),i=i.mid;else break}return i}has(h){const e=this.d(h);return!(e?.value===void 0&&e?.mid===void 0)}delete(h){return this.e(h,!1)}deleteSuperstr(h){return this.e(h,!0)}e(h,e){const i=this.b.reset(h),o=[];let l=this.c;for(;l;){const f=i.cmp(l.segment);if(f>0)o.push([-1,l]),l=l.left;else if(f<0)o.push([1,l]),l=l.right;else if(i.hasNext())i.next(),o.push([0,l]),l=l.mid;else break}if(l){if(e?(l.left=void 0,l.mid=void 0,l.right=void 0,l.height=1):(l.key=void 0,l.value=void 0),!l.mid&&!l.value)if(l.left&&l.right){const f=this.f(l.right);if(f.key){const{key:S,value:m,segment:b}=f;this.e(f.key,!1),l.key=S,l.value=m,l.segment=b}}else{const f=l.left??l.right;if(o.length>0){const[S,m]=o[o.length-1];switch(S){case-1:m.left=f;break;case 0:m.mid=f;break;case 1:m.right=f;break}}else this.c=f}for(let f=o.length-1;f>=0;f--){const S=o[f][1];S.updateHeight();const m=S.balanceFactor();if(m>1?(S.right.balanceFactor()>=0||(S.right=S.right.rotateRight()),o[f][1]=S.rotateLeft()):m<-1&&(S.left.balanceFactor()<=0||(S.left=S.left.rotateLeft()),o[f][1]=S.rotateRight()),f>0)switch(o[f-1][0]){case-1:o[f-1][1].left=o[f][1];break;case 1:o[f-1][1].right=o[f][1];break;case 0:o[f-1][1].mid=o[f][1];break}else this.c=o[0][1]}}}f(h){for(;h.left;)h=h.left;return h}findSubstr(h){const e=this.b.reset(h);let i=this.c,o;for(;i;){const l=e.cmp(i.segment);if(l>0)i=i.left;else if(l<0)i=i.right;else if(e.hasNext())e.next(),o=i.value||o,i=i.mid;else break}return i&&i.value||o}findSuperstr(h){return this.g(h,!1)}g(h,e){const i=this.b.reset(h);let o=this.c;for(;o;){const l=i.cmp(o.segment);if(l>0)o=o.left;else if(l<0)o=o.right;else if(i.hasNext())i.next(),o=o.mid;else return o.mid?this.h(o.mid):e?o.value:void 0}}hasElementOrSubtree(h){return this.g(h,!0)!==void 0}forEach(h){for(const[e,i]of this)h(i,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(h){const e=[];return this.j(h,e),e[Symbol.iterator]()}j(h,e){h&&(h.left&&this.j(h.left,e),h.value&&e.push([h.key,h.value]),h.mid&&this.j(h.mid,e),h.right&&this.j(h.right,e))}_isBalanced(){const h=e=>{if(!e)return!0;const i=e.balanceFactor();return i<-1||i>1?!1:h(e.left)&&h(e.right)};return h(this.c)}}t.$Bi=M}),define(me[10],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$8f=n,t.$9f=C,t.$0f=B,t.$$f=H,t.$_f=A,t.$ag=P,t.$bg=d,t.$cg=g,t.$dg=w,t.$eg=M,t.$fg=c,t.$gg=h,t.$hg=e,t.$ig=o,t.$jg=l,t.$kg=f,t.$lg=S,t.$mg=m;function n(b){return typeof b=="string"}function C(b){return Array.isArray(b)&&b.every(r=>n(r))}function B(b){return typeof b=="object"&&b!==null&&!Array.isArray(b)&&!(b instanceof RegExp)&&!(b instanceof Date)}function H(b){const r=Object.getPrototypeOf(Uint8Array);return typeof b=="object"&&b instanceof r}function A(b){return typeof b=="number"&&!isNaN(b)}function P(b){return!!b&&typeof b[Symbol.iterator]=="function"}function d(b){return b===!0||b===!1}function g(b){return typeof b>"u"}function w(b){return!M(b)}function M(b){return g(b)||b===null}function c(b,r){if(!b)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}function h(b){if(M(b))throw new Error("Assertion Failed: argument is undefined or null");return b}function e(...b){const r=[];for(let D=0;D<b.length;D++){const k=b[D];if(M(k))throw new Error(`Assertion Failed: argument at index ${D} is undefined or null`);r.push(k)}return r}const i=Object.prototype.hasOwnProperty;function o(b){if(!B(b))return!1;for(const r in b)if(i.call(b,r))return!1;return!0}function l(b){return typeof b=="function"}function f(...b){return b.length>0&&b.every(l)}function S(b,r){const D=Math.min(b.length,r.length);for(let k=0;k<D;k++)m(b[k],r[k])}function m(b,r){if(n(r)){if(typeof b!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(l(r)){try{if(b instanceof r)return}catch{}if(!M(b)&&b.constructor===r||r.length===1&&r.call(void 0,b)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}}),define(me[45],be([1,0,10]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Pj=B,t.$Qj=H;const C=Object.create(null);function B(A,P){if((0,n.$8f)(P)){const d=C[P];if(d===void 0)throw new Error(`${A} references an unknown codicon: ${P}`);P=d}return C[A]=P,{id:A}}function H(){return C}}),define(me[100],be([1,0,45]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Rj=void 0,t.$Rj={add:(0,n.$Pj)("add",6e4),plus:(0,n.$Pj)("plus",6e4),gistNew:(0,n.$Pj)("gist-new",6e4),repoCreate:(0,n.$Pj)("repo-create",6e4),lightbulb:(0,n.$Pj)("lightbulb",60001),lightBulb:(0,n.$Pj)("light-bulb",60001),repo:(0,n.$Pj)("repo",60002),repoDelete:(0,n.$Pj)("repo-delete",60002),gistFork:(0,n.$Pj)("gist-fork",60003),repoForked:(0,n.$Pj)("repo-forked",60003),gitPullRequest:(0,n.$Pj)("git-pull-request",60004),gitPullRequestAbandoned:(0,n.$Pj)("git-pull-request-abandoned",60004),recordKeys:(0,n.$Pj)("record-keys",60005),keyboard:(0,n.$Pj)("keyboard",60005),tag:(0,n.$Pj)("tag",60006),gitPullRequestLabel:(0,n.$Pj)("git-pull-request-label",60006),tagAdd:(0,n.$Pj)("tag-add",60006),tagRemove:(0,n.$Pj)("tag-remove",60006),person:(0,n.$Pj)("person",60007),personFollow:(0,n.$Pj)("person-follow",60007),personOutline:(0,n.$Pj)("person-outline",60007),personFilled:(0,n.$Pj)("person-filled",60007),gitBranch:(0,n.$Pj)("git-branch",60008),gitBranchCreate:(0,n.$Pj)("git-branch-create",60008),gitBranchDelete:(0,n.$Pj)("git-branch-delete",60008),sourceControl:(0,n.$Pj)("source-control",60008),mirror:(0,n.$Pj)("mirror",60009),mirrorPublic:(0,n.$Pj)("mirror-public",60009),star:(0,n.$Pj)("star",60010),starAdd:(0,n.$Pj)("star-add",60010),starDelete:(0,n.$Pj)("star-delete",60010),starEmpty:(0,n.$Pj)("star-empty",60010),comment:(0,n.$Pj)("comment",60011),commentAdd:(0,n.$Pj)("comment-add",60011),alert:(0,n.$Pj)("alert",60012),warning:(0,n.$Pj)("warning",60012),search:(0,n.$Pj)("search",60013),searchSave:(0,n.$Pj)("search-save",60013),logOut:(0,n.$Pj)("log-out",60014),signOut:(0,n.$Pj)("sign-out",60014),logIn:(0,n.$Pj)("log-in",60015),signIn:(0,n.$Pj)("sign-in",60015),eye:(0,n.$Pj)("eye",60016),eyeUnwatch:(0,n.$Pj)("eye-unwatch",60016),eyeWatch:(0,n.$Pj)("eye-watch",60016),circleFilled:(0,n.$Pj)("circle-filled",60017),primitiveDot:(0,n.$Pj)("primitive-dot",60017),closeDirty:(0,n.$Pj)("close-dirty",60017),debugBreakpoint:(0,n.$Pj)("debug-breakpoint",60017),debugBreakpointDisabled:(0,n.$Pj)("debug-breakpoint-disabled",60017),debugHint:(0,n.$Pj)("debug-hint",60017),terminalDecorationSuccess:(0,n.$Pj)("terminal-decoration-success",60017),primitiveSquare:(0,n.$Pj)("primitive-square",60018),edit:(0,n.$Pj)("edit",60019),pencil:(0,n.$Pj)("pencil",60019),info:(0,n.$Pj)("info",60020),issueOpened:(0,n.$Pj)("issue-opened",60020),gistPrivate:(0,n.$Pj)("gist-private",60021),gitForkPrivate:(0,n.$Pj)("git-fork-private",60021),lock:(0,n.$Pj)("lock",60021),mirrorPrivate:(0,n.$Pj)("mirror-private",60021),close:(0,n.$Pj)("close",60022),removeClose:(0,n.$Pj)("remove-close",60022),x:(0,n.$Pj)("x",60022),repoSync:(0,n.$Pj)("repo-sync",60023),sync:(0,n.$Pj)("sync",60023),clone:(0,n.$Pj)("clone",60024),desktopDownload:(0,n.$Pj)("desktop-download",60024),beaker:(0,n.$Pj)("beaker",60025),microscope:(0,n.$Pj)("microscope",60025),vm:(0,n.$Pj)("vm",60026),deviceDesktop:(0,n.$Pj)("device-desktop",60026),file:(0,n.$Pj)("file",60027),fileText:(0,n.$Pj)("file-text",60027),more:(0,n.$Pj)("more",60028),ellipsis:(0,n.$Pj)("ellipsis",60028),kebabHorizontal:(0,n.$Pj)("kebab-horizontal",60028),mailReply:(0,n.$Pj)("mail-reply",60029),reply:(0,n.$Pj)("reply",60029),organization:(0,n.$Pj)("organization",60030),organizationFilled:(0,n.$Pj)("organization-filled",60030),organizationOutline:(0,n.$Pj)("organization-outline",60030),newFile:(0,n.$Pj)("new-file",60031),fileAdd:(0,n.$Pj)("file-add",60031),newFolder:(0,n.$Pj)("new-folder",60032),fileDirectoryCreate:(0,n.$Pj)("file-directory-create",60032),trash:(0,n.$Pj)("trash",60033),trashcan:(0,n.$Pj)("trashcan",60033),history:(0,n.$Pj)("history",60034),clock:(0,n.$Pj)("clock",60034),folder:(0,n.$Pj)("folder",60035),fileDirectory:(0,n.$Pj)("file-directory",60035),symbolFolder:(0,n.$Pj)("symbol-folder",60035),logoGithub:(0,n.$Pj)("logo-github",60036),markGithub:(0,n.$Pj)("mark-github",60036),github:(0,n.$Pj)("github",60036),terminal:(0,n.$Pj)("terminal",60037),console:(0,n.$Pj)("console",60037),repl:(0,n.$Pj)("repl",60037),zap:(0,n.$Pj)("zap",60038),symbolEvent:(0,n.$Pj)("symbol-event",60038),error:(0,n.$Pj)("error",60039),stop:(0,n.$Pj)("stop",60039),variable:(0,n.$Pj)("variable",60040),symbolVariable:(0,n.$Pj)("symbol-variable",60040),array:(0,n.$Pj)("array",60042),symbolArray:(0,n.$Pj)("symbol-array",60042),symbolModule:(0,n.$Pj)("symbol-module",60043),symbolPackage:(0,n.$Pj)("symbol-package",60043),symbolNamespace:(0,n.$Pj)("symbol-namespace",60043),symbolObject:(0,n.$Pj)("symbol-object",60043),symbolMethod:(0,n.$Pj)("symbol-method",60044),symbolFunction:(0,n.$Pj)("symbol-function",60044),symbolConstructor:(0,n.$Pj)("symbol-constructor",60044),symbolBoolean:(0,n.$Pj)("symbol-boolean",60047),symbolNull:(0,n.$Pj)("symbol-null",60047),symbolNumeric:(0,n.$Pj)("symbol-numeric",60048),symbolNumber:(0,n.$Pj)("symbol-number",60048),symbolStructure:(0,n.$Pj)("symbol-structure",60049),symbolStruct:(0,n.$Pj)("symbol-struct",60049),symbolParameter:(0,n.$Pj)("symbol-parameter",60050),symbolTypeParameter:(0,n.$Pj)("symbol-type-parameter",60050),symbolKey:(0,n.$Pj)("symbol-key",60051),symbolText:(0,n.$Pj)("symbol-text",60051),symbolReference:(0,n.$Pj)("symbol-reference",60052),goToFile:(0,n.$Pj)("go-to-file",60052),symbolEnum:(0,n.$Pj)("symbol-enum",60053),symbolValue:(0,n.$Pj)("symbol-value",60053),symbolRuler:(0,n.$Pj)("symbol-ruler",60054),symbolUnit:(0,n.$Pj)("symbol-unit",60054),activateBreakpoints:(0,n.$Pj)("activate-breakpoints",60055),archive:(0,n.$Pj)("archive",60056),arrowBoth:(0,n.$Pj)("arrow-both",60057),arrowDown:(0,n.$Pj)("arrow-down",60058),arrowLeft:(0,n.$Pj)("arrow-left",60059),arrowRight:(0,n.$Pj)("arrow-right",60060),arrowSmallDown:(0,n.$Pj)("arrow-small-down",60061),arrowSmallLeft:(0,n.$Pj)("arrow-small-left",60062),arrowSmallRight:(0,n.$Pj)("arrow-small-right",60063),arrowSmallUp:(0,n.$Pj)("arrow-small-up",60064),arrowUp:(0,n.$Pj)("arrow-up",60065),bell:(0,n.$Pj)("bell",60066),bold:(0,n.$Pj)("bold",60067),book:(0,n.$Pj)("book",60068),bookmark:(0,n.$Pj)("bookmark",60069),debugBreakpointConditionalUnverified:(0,n.$Pj)("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:(0,n.$Pj)("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:(0,n.$Pj)("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:(0,n.$Pj)("debug-breakpoint-data-unverified",60072),debugBreakpointData:(0,n.$Pj)("debug-breakpoint-data",60073),debugBreakpointDataDisabled:(0,n.$Pj)("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:(0,n.$Pj)("debug-breakpoint-log-unverified",60074),debugBreakpointLog:(0,n.$Pj)("debug-breakpoint-log",60075),debugBreakpointLogDisabled:(0,n.$Pj)("debug-breakpoint-log-disabled",60075),briefcase:(0,n.$Pj)("briefcase",60076),broadcast:(0,n.$Pj)("broadcast",60077),browser:(0,n.$Pj)("browser",60078),bug:(0,n.$Pj)("bug",60079),calendar:(0,n.$Pj)("calendar",60080),caseSensitive:(0,n.$Pj)("case-sensitive",60081),check:(0,n.$Pj)("check",60082),checklist:(0,n.$Pj)("checklist",60083),chevronDown:(0,n.$Pj)("chevron-down",60084),chevronLeft:(0,n.$Pj)("chevron-left",60085),chevronRight:(0,n.$Pj)("chevron-right",60086),chevronUp:(0,n.$Pj)("chevron-up",60087),chromeClose:(0,n.$Pj)("chrome-close",60088),chromeMaximize:(0,n.$Pj)("chrome-maximize",60089),chromeMinimize:(0,n.$Pj)("chrome-minimize",60090),chromeRestore:(0,n.$Pj)("chrome-restore",60091),circleOutline:(0,n.$Pj)("circle-outline",60092),circle:(0,n.$Pj)("circle",60092),debugBreakpointUnverified:(0,n.$Pj)("debug-breakpoint-unverified",60092),terminalDecorationIncomplete:(0,n.$Pj)("terminal-decoration-incomplete",60092),circleSlash:(0,n.$Pj)("circle-slash",60093),circuitBoard:(0,n.$Pj)("circuit-board",60094),clearAll:(0,n.$Pj)("clear-all",60095),clippy:(0,n.$Pj)("clippy",60096),closeAll:(0,n.$Pj)("close-all",60097),cloudDownload:(0,n.$Pj)("cloud-download",60098),cloudUpload:(0,n.$Pj)("cloud-upload",60099),code:(0,n.$Pj)("code",60100),collapseAll:(0,n.$Pj)("collapse-all",60101),colorMode:(0,n.$Pj)("color-mode",60102),commentDiscussion:(0,n.$Pj)("comment-discussion",60103),creditCard:(0,n.$Pj)("credit-card",60105),dash:(0,n.$Pj)("dash",60108),dashboard:(0,n.$Pj)("dashboard",60109),database:(0,n.$Pj)("database",60110),debugContinue:(0,n.$Pj)("debug-continue",60111),debugDisconnect:(0,n.$Pj)("debug-disconnect",60112),debugPause:(0,n.$Pj)("debug-pause",60113),debugRestart:(0,n.$Pj)("debug-restart",60114),debugStart:(0,n.$Pj)("debug-start",60115),debugStepInto:(0,n.$Pj)("debug-step-into",60116),debugStepOut:(0,n.$Pj)("debug-step-out",60117),debugStepOver:(0,n.$Pj)("debug-step-over",60118),debugStop:(0,n.$Pj)("debug-stop",60119),debug:(0,n.$Pj)("debug",60120),deviceCameraVideo:(0,n.$Pj)("device-camera-video",60121),deviceCamera:(0,n.$Pj)("device-camera",60122),deviceMobile:(0,n.$Pj)("device-mobile",60123),diffAdded:(0,n.$Pj)("diff-added",60124),diffIgnored:(0,n.$Pj)("diff-ignored",60125),diffModified:(0,n.$Pj)("diff-modified",60126),diffRemoved:(0,n.$Pj)("diff-removed",60127),diffRenamed:(0,n.$Pj)("diff-renamed",60128),diff:(0,n.$Pj)("diff",60129),diffSidebyside:(0,n.$Pj)("diff-sidebyside",60129),discard:(0,n.$Pj)("discard",60130),editorLayout:(0,n.$Pj)("editor-layout",60131),emptyWindow:(0,n.$Pj)("empty-window",60132),exclude:(0,n.$Pj)("exclude",60133),extensions:(0,n.$Pj)("extensions",60134),eyeClosed:(0,n.$Pj)("eye-closed",60135),fileBinary:(0,n.$Pj)("file-binary",60136),fileCode:(0,n.$Pj)("file-code",60137),fileMedia:(0,n.$Pj)("file-media",60138),filePdf:(0,n.$Pj)("file-pdf",60139),fileSubmodule:(0,n.$Pj)("file-submodule",60140),fileSymlinkDirectory:(0,n.$Pj)("file-symlink-directory",60141),fileSymlinkFile:(0,n.$Pj)("file-symlink-file",60142),fileZip:(0,n.$Pj)("file-zip",60143),files:(0,n.$Pj)("files",60144),filter:(0,n.$Pj)("filter",60145),flame:(0,n.$Pj)("flame",60146),foldDown:(0,n.$Pj)("fold-down",60147),foldUp:(0,n.$Pj)("fold-up",60148),fold:(0,n.$Pj)("fold",60149),folderActive:(0,n.$Pj)("folder-active",60150),folderOpened:(0,n.$Pj)("folder-opened",60151),gear:(0,n.$Pj)("gear",60152),gift:(0,n.$Pj)("gift",60153),gistSecret:(0,n.$Pj)("gist-secret",60154),gist:(0,n.$Pj)("gist",60155),gitCommit:(0,n.$Pj)("git-commit",60156),gitCompare:(0,n.$Pj)("git-compare",60157),compareChanges:(0,n.$Pj)("compare-changes",60157),gitMerge:(0,n.$Pj)("git-merge",60158),githubAction:(0,n.$Pj)("github-action",60159),githubAlt:(0,n.$Pj)("github-alt",60160),globe:(0,n.$Pj)("globe",60161),grabber:(0,n.$Pj)("grabber",60162),graph:(0,n.$Pj)("graph",60163),gripper:(0,n.$Pj)("gripper",60164),heart:(0,n.$Pj)("heart",60165),home:(0,n.$Pj)("home",60166),horizontalRule:(0,n.$Pj)("horizontal-rule",60167),hubot:(0,n.$Pj)("hubot",60168),inbox:(0,n.$Pj)("inbox",60169),issueReopened:(0,n.$Pj)("issue-reopened",60171),issues:(0,n.$Pj)("issues",60172),italic:(0,n.$Pj)("italic",60173),jersey:(0,n.$Pj)("jersey",60174),json:(0,n.$Pj)("json",60175),kebabVertical:(0,n.$Pj)("kebab-vertical",60176),key:(0,n.$Pj)("key",60177),law:(0,n.$Pj)("law",60178),lightbulbAutofix:(0,n.$Pj)("lightbulb-autofix",60179),linkExternal:(0,n.$Pj)("link-external",60180),link:(0,n.$Pj)("link",60181),listOrdered:(0,n.$Pj)("list-ordered",60182),listUnordered:(0,n.$Pj)("list-unordered",60183),liveShare:(0,n.$Pj)("live-share",60184),loading:(0,n.$Pj)("loading",60185),location:(0,n.$Pj)("location",60186),mailRead:(0,n.$Pj)("mail-read",60187),mail:(0,n.$Pj)("mail",60188),markdown:(0,n.$Pj)("markdown",60189),megaphone:(0,n.$Pj)("megaphone",60190),mention:(0,n.$Pj)("mention",60191),milestone:(0,n.$Pj)("milestone",60192),gitPullRequestMilestone:(0,n.$Pj)("git-pull-request-milestone",60192),mortarBoard:(0,n.$Pj)("mortar-board",60193),move:(0,n.$Pj)("move",60194),multipleWindows:(0,n.$Pj)("multiple-windows",60195),mute:(0,n.$Pj)("mute",60196),noNewline:(0,n.$Pj)("no-newline",60197),note:(0,n.$Pj)("note",60198),octoface:(0,n.$Pj)("octoface",60199),openPreview:(0,n.$Pj)("open-preview",60200),package:(0,n.$Pj)("package",60201),paintcan:(0,n.$Pj)("paintcan",60202),pin:(0,n.$Pj)("pin",60203),play:(0,n.$Pj)("play",60204),run:(0,n.$Pj)("run",60204),plug:(0,n.$Pj)("plug",60205),preserveCase:(0,n.$Pj)("preserve-case",60206),preview:(0,n.$Pj)("preview",60207),project:(0,n.$Pj)("project",60208),pulse:(0,n.$Pj)("pulse",60209),question:(0,n.$Pj)("question",60210),quote:(0,n.$Pj)("quote",60211),radioTower:(0,n.$Pj)("radio-tower",60212),reactions:(0,n.$Pj)("reactions",60213),references:(0,n.$Pj)("references",60214),refresh:(0,n.$Pj)("refresh",60215),regex:(0,n.$Pj)("regex",60216),remoteExplorer:(0,n.$Pj)("remote-explorer",60217),remote:(0,n.$Pj)("remote",60218),remove:(0,n.$Pj)("remove",60219),replaceAll:(0,n.$Pj)("replace-all",60220),replace:(0,n.$Pj)("replace",60221),repoClone:(0,n.$Pj)("repo-clone",60222),repoForcePush:(0,n.$Pj)("repo-force-push",60223),repoPull:(0,n.$Pj)("repo-pull",60224),repoPush:(0,n.$Pj)("repo-push",60225),report:(0,n.$Pj)("report",60226),requestChanges:(0,n.$Pj)("request-changes",60227),rocket:(0,n.$Pj)("rocket",60228),rootFolderOpened:(0,n.$Pj)("root-folder-opened",60229),rootFolder:(0,n.$Pj)("root-folder",60230),rss:(0,n.$Pj)("rss",60231),ruby:(0,n.$Pj)("ruby",60232),saveAll:(0,n.$Pj)("save-all",60233),saveAs:(0,n.$Pj)("save-as",60234),save:(0,n.$Pj)("save",60235),screenFull:(0,n.$Pj)("screen-full",60236),screenNormal:(0,n.$Pj)("screen-normal",60237),searchStop:(0,n.$Pj)("search-stop",60238),server:(0,n.$Pj)("server",60240),settingsGear:(0,n.$Pj)("settings-gear",60241),settings:(0,n.$Pj)("settings",60242),shield:(0,n.$Pj)("shield",60243),smiley:(0,n.$Pj)("smiley",60244),sortPrecedence:(0,n.$Pj)("sort-precedence",60245),splitHorizontal:(0,n.$Pj)("split-horizontal",60246),splitVertical:(0,n.$Pj)("split-vertical",60247),squirrel:(0,n.$Pj)("squirrel",60248),starFull:(0,n.$Pj)("star-full",60249),starHalf:(0,n.$Pj)("star-half",60250),symbolClass:(0,n.$Pj)("symbol-class",60251),symbolColor:(0,n.$Pj)("symbol-color",60252),symbolConstant:(0,n.$Pj)("symbol-constant",60253),symbolEnumMember:(0,n.$Pj)("symbol-enum-member",60254),symbolField:(0,n.$Pj)("symbol-field",60255),symbolFile:(0,n.$Pj)("symbol-file",60256),symbolInterface:(0,n.$Pj)("symbol-interface",60257),symbolKeyword:(0,n.$Pj)("symbol-keyword",60258),symbolMisc:(0,n.$Pj)("symbol-misc",60259),symbolOperator:(0,n.$Pj)("symbol-operator",60260),symbolProperty:(0,n.$Pj)("symbol-property",60261),wrench:(0,n.$Pj)("wrench",60261),wrenchSubaction:(0,n.$Pj)("wrench-subaction",60261),symbolSnippet:(0,n.$Pj)("symbol-snippet",60262),tasklist:(0,n.$Pj)("tasklist",60263),telescope:(0,n.$Pj)("telescope",60264),textSize:(0,n.$Pj)("text-size",60265),threeBars:(0,n.$Pj)("three-bars",60266),thumbsdown:(0,n.$Pj)("thumbsdown",60267),thumbsup:(0,n.$Pj)("thumbsup",60268),tools:(0,n.$Pj)("tools",60269),triangleDown:(0,n.$Pj)("triangle-down",60270),triangleLeft:(0,n.$Pj)("triangle-left",60271),triangleRight:(0,n.$Pj)("triangle-right",60272),triangleUp:(0,n.$Pj)("triangle-up",60273),twitter:(0,n.$Pj)("twitter",60274),unfold:(0,n.$Pj)("unfold",60275),unlock:(0,n.$Pj)("unlock",60276),unmute:(0,n.$Pj)("unmute",60277),unverified:(0,n.$Pj)("unverified",60278),verified:(0,n.$Pj)("verified",60279),versions:(0,n.$Pj)("versions",60280),vmActive:(0,n.$Pj)("vm-active",60281),vmOutline:(0,n.$Pj)("vm-outline",60282),vmRunning:(0,n.$Pj)("vm-running",60283),watch:(0,n.$Pj)("watch",60284),whitespace:(0,n.$Pj)("whitespace",60285),wholeWord:(0,n.$Pj)("whole-word",60286),window:(0,n.$Pj)("window",60287),wordWrap:(0,n.$Pj)("word-wrap",60288),zoomIn:(0,n.$Pj)("zoom-in",60289),zoomOut:(0,n.$Pj)("zoom-out",60290),listFilter:(0,n.$Pj)("list-filter",60291),listFlat:(0,n.$Pj)("list-flat",60292),listSelection:(0,n.$Pj)("list-selection",60293),selection:(0,n.$Pj)("selection",60293),listTree:(0,n.$Pj)("list-tree",60294),debugBreakpointFunctionUnverified:(0,n.$Pj)("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:(0,n.$Pj)("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:(0,n.$Pj)("debug-breakpoint-function-disabled",60296),debugStackframeActive:(0,n.$Pj)("debug-stackframe-active",60297),circleSmallFilled:(0,n.$Pj)("circle-small-filled",60298),debugStackframeDot:(0,n.$Pj)("debug-stackframe-dot",60298),terminalDecorationMark:(0,n.$Pj)("terminal-decoration-mark",60298),debugStackframe:(0,n.$Pj)("debug-stackframe",60299),debugStackframeFocused:(0,n.$Pj)("debug-stackframe-focused",60299),debugBreakpointUnsupported:(0,n.$Pj)("debug-breakpoint-unsupported",60300),symbolString:(0,n.$Pj)("symbol-string",60301),debugReverseContinue:(0,n.$Pj)("debug-reverse-continue",60302),debugStepBack:(0,n.$Pj)("debug-step-back",60303),debugRestartFrame:(0,n.$Pj)("debug-restart-frame",60304),debugAlt:(0,n.$Pj)("debug-alt",60305),callIncoming:(0,n.$Pj)("call-incoming",60306),callOutgoing:(0,n.$Pj)("call-outgoing",60307),menu:(0,n.$Pj)("menu",60308),expandAll:(0,n.$Pj)("expand-all",60309),feedback:(0,n.$Pj)("feedback",60310),gitPullRequestReviewer:(0,n.$Pj)("git-pull-request-reviewer",60310),groupByRefType:(0,n.$Pj)("group-by-ref-type",60311),ungroupByRefType:(0,n.$Pj)("ungroup-by-ref-type",60312),account:(0,n.$Pj)("account",60313),gitPullRequestAssignee:(0,n.$Pj)("git-pull-request-assignee",60313),bellDot:(0,n.$Pj)("bell-dot",60314),debugConsole:(0,n.$Pj)("debug-console",60315),library:(0,n.$Pj)("library",60316),output:(0,n.$Pj)("output",60317),runAll:(0,n.$Pj)("run-all",60318),syncIgnored:(0,n.$Pj)("sync-ignored",60319),pinned:(0,n.$Pj)("pinned",60320),githubInverted:(0,n.$Pj)("github-inverted",60321),serverProcess:(0,n.$Pj)("server-process",60322),serverEnvironment:(0,n.$Pj)("server-environment",60323),pass:(0,n.$Pj)("pass",60324),issueClosed:(0,n.$Pj)("issue-closed",60324),stopCircle:(0,n.$Pj)("stop-circle",60325),playCircle:(0,n.$Pj)("play-circle",60326),record:(0,n.$Pj)("record",60327),debugAltSmall:(0,n.$Pj)("debug-alt-small",60328),vmConnect:(0,n.$Pj)("vm-connect",60329),cloud:(0,n.$Pj)("cloud",60330),merge:(0,n.$Pj)("merge",60331),export:(0,n.$Pj)("export",60332),graphLeft:(0,n.$Pj)("graph-left",60333),magnet:(0,n.$Pj)("magnet",60334),notebook:(0,n.$Pj)("notebook",60335),redo:(0,n.$Pj)("redo",60336),checkAll:(0,n.$Pj)("check-all",60337),pinnedDirty:(0,n.$Pj)("pinned-dirty",60338),passFilled:(0,n.$Pj)("pass-filled",60339),circleLargeFilled:(0,n.$Pj)("circle-large-filled",60340),circleLarge:(0,n.$Pj)("circle-large",60341),circleLargeOutline:(0,n.$Pj)("circle-large-outline",60341),combine:(0,n.$Pj)("combine",60342),gather:(0,n.$Pj)("gather",60342),table:(0,n.$Pj)("table",60343),variableGroup:(0,n.$Pj)("variable-group",60344),typeHierarchy:(0,n.$Pj)("type-hierarchy",60345),typeHierarchySub:(0,n.$Pj)("type-hierarchy-sub",60346),typeHierarchySuper:(0,n.$Pj)("type-hierarchy-super",60347),gitPullRequestCreate:(0,n.$Pj)("git-pull-request-create",60348),runAbove:(0,n.$Pj)("run-above",60349),runBelow:(0,n.$Pj)("run-below",60350),notebookTemplate:(0,n.$Pj)("notebook-template",60351),debugRerun:(0,n.$Pj)("debug-rerun",60352),workspaceTrusted:(0,n.$Pj)("workspace-trusted",60353),workspaceUntrusted:(0,n.$Pj)("workspace-untrusted",60354),workspaceUnknown:(0,n.$Pj)("workspace-unknown",60355),terminalCmd:(0,n.$Pj)("terminal-cmd",60356),terminalDebian:(0,n.$Pj)("terminal-debian",60357),terminalLinux:(0,n.$Pj)("terminal-linux",60358),terminalPowershell:(0,n.$Pj)("terminal-powershell",60359),terminalTmux:(0,n.$Pj)("terminal-tmux",60360),terminalUbuntu:(0,n.$Pj)("terminal-ubuntu",60361),terminalBash:(0,n.$Pj)("terminal-bash",60362),arrowSwap:(0,n.$Pj)("arrow-swap",60363),copy:(0,n.$Pj)("copy",60364),personAdd:(0,n.$Pj)("person-add",60365),filterFilled:(0,n.$Pj)("filter-filled",60366),wand:(0,n.$Pj)("wand",60367),debugLineByLine:(0,n.$Pj)("debug-line-by-line",60368),inspect:(0,n.$Pj)("inspect",60369),layers:(0,n.$Pj)("layers",60370),layersDot:(0,n.$Pj)("layers-dot",60371),layersActive:(0,n.$Pj)("layers-active",60372),compass:(0,n.$Pj)("compass",60373),compassDot:(0,n.$Pj)("compass-dot",60374),compassActive:(0,n.$Pj)("compass-active",60375),azure:(0,n.$Pj)("azure",60376),issueDraft:(0,n.$Pj)("issue-draft",60377),gitPullRequestClosed:(0,n.$Pj)("git-pull-request-closed",60378),gitPullRequestDraft:(0,n.$Pj)("git-pull-request-draft",60379),debugAll:(0,n.$Pj)("debug-all",60380),debugCoverage:(0,n.$Pj)("debug-coverage",60381),runErrors:(0,n.$Pj)("run-errors",60382),folderLibrary:(0,n.$Pj)("folder-library",60383),debugContinueSmall:(0,n.$Pj)("debug-continue-small",60384),beakerStop:(0,n.$Pj)("beaker-stop",60385),graphLine:(0,n.$Pj)("graph-line",60386),graphScatter:(0,n.$Pj)("graph-scatter",60387),pieChart:(0,n.$Pj)("pie-chart",60388),bracket:(0,n.$Pj)("bracket",60175),bracketDot:(0,n.$Pj)("bracket-dot",60389),bracketError:(0,n.$Pj)("bracket-error",60390),lockSmall:(0,n.$Pj)("lock-small",60391),azureDevops:(0,n.$Pj)("azure-devops",60392),verifiedFilled:(0,n.$Pj)("verified-filled",60393),newline:(0,n.$Pj)("newline",60394),layout:(0,n.$Pj)("layout",60395),layoutActivitybarLeft:(0,n.$Pj)("layout-activitybar-left",60396),layoutActivitybarRight:(0,n.$Pj)("layout-activitybar-right",60397),layoutPanelLeft:(0,n.$Pj)("layout-panel-left",60398),layoutPanelCenter:(0,n.$Pj)("layout-panel-center",60399),layoutPanelJustify:(0,n.$Pj)("layout-panel-justify",60400),layoutPanelRight:(0,n.$Pj)("layout-panel-right",60401),layoutPanel:(0,n.$Pj)("layout-panel",60402),layoutSidebarLeft:(0,n.$Pj)("layout-sidebar-left",60403),layoutSidebarRight:(0,n.$Pj)("layout-sidebar-right",60404),layoutStatusbar:(0,n.$Pj)("layout-statusbar",60405),layoutMenubar:(0,n.$Pj)("layout-menubar",60406),layoutCentered:(0,n.$Pj)("layout-centered",60407),target:(0,n.$Pj)("target",60408),indent:(0,n.$Pj)("indent",60409),recordSmall:(0,n.$Pj)("record-small",60410),errorSmall:(0,n.$Pj)("error-small",60411),terminalDecorationError:(0,n.$Pj)("terminal-decoration-error",60411),arrowCircleDown:(0,n.$Pj)("arrow-circle-down",60412),arrowCircleLeft:(0,n.$Pj)("arrow-circle-left",60413),arrowCircleRight:(0,n.$Pj)("arrow-circle-right",60414),arrowCircleUp:(0,n.$Pj)("arrow-circle-up",60415),layoutSidebarRightOff:(0,n.$Pj)("layout-sidebar-right-off",60416),layoutPanelOff:(0,n.$Pj)("layout-panel-off",60417),layoutSidebarLeftOff:(0,n.$Pj)("layout-sidebar-left-off",60418),blank:(0,n.$Pj)("blank",60419),heartFilled:(0,n.$Pj)("heart-filled",60420),map:(0,n.$Pj)("map",60421),mapHorizontal:(0,n.$Pj)("map-horizontal",60421),foldHorizontal:(0,n.$Pj)("fold-horizontal",60421),mapFilled:(0,n.$Pj)("map-filled",60422),mapHorizontalFilled:(0,n.$Pj)("map-horizontal-filled",60422),foldHorizontalFilled:(0,n.$Pj)("fold-horizontal-filled",60422),circleSmall:(0,n.$Pj)("circle-small",60423),bellSlash:(0,n.$Pj)("bell-slash",60424),bellSlashDot:(0,n.$Pj)("bell-slash-dot",60425),commentUnresolved:(0,n.$Pj)("comment-unresolved",60426),gitPullRequestGoToChanges:(0,n.$Pj)("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:(0,n.$Pj)("git-pull-request-new-changes",60428),searchFuzzy:(0,n.$Pj)("search-fuzzy",60429),commentDraft:(0,n.$Pj)("comment-draft",60430),send:(0,n.$Pj)("send",60431),sparkle:(0,n.$Pj)("sparkle",60432),insert:(0,n.$Pj)("insert",60433),mic:(0,n.$Pj)("mic",60434),thumbsdownFilled:(0,n.$Pj)("thumbsdown-filled",60435),thumbsupFilled:(0,n.$Pj)("thumbsup-filled",60436),coffee:(0,n.$Pj)("coffee",60437),snake:(0,n.$Pj)("snake",60438),game:(0,n.$Pj)("game",60439),vr:(0,n.$Pj)("vr",60440),chip:(0,n.$Pj)("chip",60441),piano:(0,n.$Pj)("piano",60442),music:(0,n.$Pj)("music",60443),micFilled:(0,n.$Pj)("mic-filled",60444),repoFetch:(0,n.$Pj)("repo-fetch",60445),copilot:(0,n.$Pj)("copilot",60446),lightbulbSparkle:(0,n.$Pj)("lightbulb-sparkle",60447),robot:(0,n.$Pj)("robot",60448),sparkleFilled:(0,n.$Pj)("sparkle-filled",60449),diffSingle:(0,n.$Pj)("diff-single",60450),diffMultiple:(0,n.$Pj)("diff-multiple",60451),surroundWith:(0,n.$Pj)("surround-with",60452),share:(0,n.$Pj)("share",60453),gitStash:(0,n.$Pj)("git-stash",60454),gitStashApply:(0,n.$Pj)("git-stash-apply",60455),gitStashPop:(0,n.$Pj)("git-stash-pop",60456),vscode:(0,n.$Pj)("vscode",60457),vscodeInsiders:(0,n.$Pj)("vscode-insiders",60458),codeOss:(0,n.$Pj)("code-oss",60459),runCoverage:(0,n.$Pj)("run-coverage",60460),runAllCoverage:(0,n.$Pj)("run-all-coverage",60461),coverage:(0,n.$Pj)("coverage",60462),githubProject:(0,n.$Pj)("github-project",60463),mapVertical:(0,n.$Pj)("map-vertical",60464),foldVertical:(0,n.$Pj)("fold-vertical",60464),mapVerticalFilled:(0,n.$Pj)("map-vertical-filled",60465),foldVerticalFilled:(0,n.$Pj)("fold-vertical-filled",60465),goToSearch:(0,n.$Pj)("go-to-search",60466),percentage:(0,n.$Pj)("percentage",60467),sortPercentage:(0,n.$Pj)("sort-percentage",60467)}}),define(me[18],be([1,0,45,100]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Uj=t.$Tj=void 0,t.$Sj=B;function B(){return Object.values(t.$Uj)}t.$Tj={dialogError:(0,n.$Pj)("dialog-error","error"),dialogWarning:(0,n.$Pj)("dialog-warning","warning"),dialogInfo:(0,n.$Pj)("dialog-info","info"),dialogClose:(0,n.$Pj)("dialog-close","close"),treeItemExpanded:(0,n.$Pj)("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:(0,n.$Pj)("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:(0,n.$Pj)("tree-filter-on-type-off","list-selection"),treeFilterClear:(0,n.$Pj)("tree-filter-clear","close"),treeItemLoading:(0,n.$Pj)("tree-item-loading","loading"),menuSelection:(0,n.$Pj)("menu-selection","check"),menuSubmenu:(0,n.$Pj)("menu-submenu","chevron-right"),menuBarMore:(0,n.$Pj)("menubar-more","more"),scrollbarButtonLeft:(0,n.$Pj)("scrollbar-button-left","triangle-left"),scrollbarButtonRight:(0,n.$Pj)("scrollbar-button-right","triangle-right"),scrollbarButtonUp:(0,n.$Pj)("scrollbar-button-up","triangle-up"),scrollbarButtonDown:(0,n.$Pj)("scrollbar-button-down","triangle-down"),toolBarMore:(0,n.$Pj)("toolbar-more","more"),quickInputBack:(0,n.$Pj)("quick-input-back","arrow-left"),dropDownButton:(0,n.$Pj)("drop-down-button",60084),symbolCustomColor:(0,n.$Pj)("symbol-customcolor",60252),exportIcon:(0,n.$Pj)("export",60332),workspaceUnspecified:(0,n.$Pj)("workspace-unspecified",60355),newLine:(0,n.$Pj)("newline",60394),thumbsDownFilled:(0,n.$Pj)("thumbsdown-filled",60435),thumbsUpFilled:(0,n.$Pj)("thumbsup-filled",60436),gitFetch:(0,n.$Pj)("git-fetch",60445),lightbulbSparkleAutofix:(0,n.$Pj)("lightbulb-sparkle-autofix",60447),debugBreakpointPending:(0,n.$Pj)("debug-breakpoint-pending",60377)},t.$Uj={...C.$Rj,...t.$Tj}}),define(me[61],be([1,0,10]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$2n=C,t.$3n=B,t.$4n=A,t.$5n=d,t.$6n=g,t.$7n=w,t.$8n=M,t.$9n=c,t.$0n=h,t.$$n=e,t.$_n=i,t.$ao=o;function C(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const f=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([S,m])=>{f[S]=m&&typeof m=="object"?C(m):m}),f}function B(l){if(!l||typeof l!="object")return l;const f=[l];for(;f.length>0;){const S=f.shift();Object.freeze(S);for(const m in S)if(H.call(S,m)){const b=S[m];typeof b=="object"&&!Object.isFrozen(b)&&!(0,n.$$f)(b)&&f.push(b)}}return l}const H=Object.prototype.hasOwnProperty;function A(l,f){return P(l,f,new Set)}function P(l,f,S){if((0,n.$eg)(l))return l;const m=f(l);if(typeof m<"u")return m;if(Array.isArray(l)){const b=[];for(const r of l)b.push(P(r,f,S));return b}if((0,n.$0f)(l)){if(S.has(l))throw new Error("Cannot clone recursive data-structure");S.add(l);const b={};for(const r in l)H.call(l,r)&&(b[r]=P(l[r],f,S));return S.delete(l),b}return l}function d(l,f,S=!0){return(0,n.$0f)(l)?((0,n.$0f)(f)&&Object.keys(f).forEach(m=>{m in l?S&&((0,n.$0f)(l[m])&&(0,n.$0f)(f[m])?d(l[m],f[m],S):l[m]=f[m]):l[m]=f[m]}),l):f}function g(l,f){if(l===f)return!0;if(l==null||f===null||f===void 0||typeof l!=typeof f||typeof l!="object"||Array.isArray(l)!==Array.isArray(f))return!1;let S,m;if(Array.isArray(l)){if(l.length!==f.length)return!1;for(S=0;S<l.length;S++)if(!g(l[S],f[S]))return!1}else{const b=[];for(m in l)b.push(m);b.sort();const r=[];for(m in f)r.push(m);if(r.sort(),!g(b,r))return!1;for(S=0;S<b.length;S++)if(!g(l[b[S]],f[b[S]]))return!1}return!0}function w(l){const f=new Set;return JSON.stringify(l,(S,m)=>{if((0,n.$0f)(m)||Array.isArray(m)){if(f.has(m))return"[Circular]";f.add(m)}return typeof m=="bigint"?`[BigInt ${m.toString()}]`:m})}function M(l,f){const S=Object.create(null);return!l||!f||Object.keys(f).forEach(b=>{const r=l[b],D=f[b];g(r,D)||(S[b]=D)}),S}function c(l,f){const S=f.toLowerCase(),m=Object.keys(l).find(b=>b.toLowerCase()===S);return m?l[m]:l[f]}function h(l,f){const S=Object.create(null);for(const[m,b]of Object.entries(l))f(m,b)&&(S[m]=b);return S}function e(l){let f=[];for(;Object.prototype!==l;)f=f.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return f}function i(l){const f=[];for(const S of e(l))typeof l[S]=="function"&&f.push(S);return f}function o(l,f){const S=b=>function(){const r=Array.prototype.slice.call(arguments,0);return f(b,r)},m={};for(const b of l)m[b]=S(b);return m}}),define(me[19],be([1,0,18]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.ThemeColor=void 0,t.$Vj=B;var C;(function(A){function P(d){return d&&typeof d=="object"&&typeof d.id=="string"}A.isThemeColor=P})(C||(t.ThemeColor=C={}));function B(A){return{id:A}}var H;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function d(f){const S=P.exec(f.id);if(!S)return d(n.$Uj.error);const[,m,b]=S,r=["codicon","codicon-"+m];return b&&r.push("codicon-modifier-"+b.substring(1)),r}A.asClassNameArray=d;function g(f){return d(f).join(" ")}A.asClassName=g;function w(f){return"."+d(f).join(".")}A.asCSSSelector=w;function M(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(typeof f.color>"u"||C.isThemeColor(f.color))}A.isThemeIcon=M;const c=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function h(f){const S=c.exec(f);if(!S)return;const[,m]=S;return{id:m}}A.fromString=h;function e(f){return{id:f}}A.fromId=e;function i(f,S){let m=f.id;const b=m.lastIndexOf("~");return b!==-1&&(m=m.substring(0,b)),S&&(m=`${m}~${S}`),{id:m}}A.modify=i;function o(f){const S=f.id.lastIndexOf("~");if(S!==-1)return f.id.substring(S+1)}A.getModifier=o;function l(f,S){return f.id===S.id&&f.color?.id===S.color?.id}A.isEqual=l})(H||(t.ThemeIcon=H={}))}),define(me[62],be([1,0,44,9,19]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Mk=d,t.$Nk=w,t.$Ok=c,t.$Pk=h,t.$Qk=i,t.$Rk=o;const H="$(",A=new RegExp(`\\$\\(${B.ThemeIcon.iconNameExpression}(?:${B.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${A.source}`,"g");function d(l){return l.replace(P,(f,S)=>S?f:`\\${f}`)}const g=new RegExp(`\\\\${A.source}`,"g");function w(l){return l.replace(g,f=>`\\${f}`)}const M=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function c(l){return l.indexOf(H)===-1?l:l.replace(M,(f,S,m,b)=>m?f:S||b||"")}function h(l){return l?l.replace(/\$\((.*?)\)/g,(f,S)=>` ${S} `).trim():""}const e=new RegExp(`\\$\\(${B.ThemeIcon.iconNameCharacter}+\\)`,"g");function i(l){e.lastIndex=0;let f="";const S=[];let m=0;for(;;){const b=e.lastIndex,r=e.exec(l),D=l.substring(b,r?.index);if(D.length>0){f+=D;for(let k=0;k<D.length;k++)S.push(m)}if(!r)break;m+=r[0].length}return{text:f,iconOffsets:S}}function o(l,f,S=!1){const{text:m,iconOffsets:b}=f;if(!b||b.length===0)return(0,n.$Dk)(l,m,S);const r=(0,C.$ef)(m," "),D=m.length-r.length,k=(0,n.$Dk)(l,r,S);if(k)for(const T of k){const L=b[T.start+D]+D;T.start+=L,T.end+=L}return k}}),define(me[101],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NW=t.$MW=void 0,t.$MW="vscode:contextmenu",t.$NW="vscode:onCloseContextMenu"}),define(me[102],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$UW=void 0;class n{constructor(B,H){this.a=B,this.onMessage=H}send(B){try{this.a.send("vscode:message",B.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.$UW=n}),define(me[35],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$S=t.$R=t.$Q=t.$P=t.$O=void 0;const n=globalThis.vscode;t.$O=n.ipcRenderer,t.$P=n.ipcMessagePort,t.$Q=n.webFrame,t.$R=n.process,t.$S=n.context}),define(me[103],be([1,0,101,35]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$QW=H;let B=0;function H(P,d,g){const w=[],M=B++,c=`vscode:onContextMenu${M}`,h=(e,i,o)=>{w[i].click?.(o)};C.$O.once(c,h),C.$O.once(n.$NW,(e,i)=>{i===M&&(C.$O.removeListener(c,h),g?.())}),C.$O.send(n.$MW,M,P.map(e=>A(e,w)),c,d)}function A(P,d){const g={id:d.length,label:P.label,type:P.type,accelerator:P.accelerator,checked:P.checked,enabled:typeof P.enabled=="boolean"?P.enabled:!0,visible:typeof P.visible=="boolean"?P.visible:!0};return d.push(P),Array.isArray(P.submenu)&&(g.submenu=P.submenu.map(w=>A(w,d))),g}}),define(me[63],be([7]),{}),define(me[104],be([7]),{}),define(me[105],be([7]),{}),define(me[106],be([7]),{}),define(me[107],be([1,0,105,106]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[108],be([7]),{}),define(me[109],be([7]),{}),define(me[110],be([7]),{}),define(me[111],be([7]),{}),define(me[112],be([7]),{}),define(me[113],be([7]),{}),define(me[114],be([7]),{}),define(me[115],be([7]),{}),define(me[116],be([7]),{}),define(me[117],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[118],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[119],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[120],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[121],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[122],be([13,12]),function(se,t){return se.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[123],be([13,12]),function(se,t){return se.create("vs/base/common/actions",t)}),define(me[46],be([1,0,3,2,123]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ej=t.$dj=t.$cj=t.$bj=t.$aj=void 0,t.$fj=w;class H extends C.$Vc{constructor(c,h="",e="",i=!0,o){super(),this.h=this.B(new n.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=c,this.m=h,this.u=e,this.w=i,this.C=o}get id(){return this.j}get label(){return this.m}set label(c){this.D(c)}D(c){this.m!==c&&(this.m=c,this.h.fire({label:c}))}get tooltip(){return this.n||""}set tooltip(c){this.F(c)}F(c){this.n!==c&&(this.n=c,this.h.fire({tooltip:c}))}get class(){return this.u}set class(c){this.G(c)}G(c){this.u!==c&&(this.u=c,this.h.fire({class:c}))}get enabled(){return this.w}set enabled(c){this.H(c)}H(c){this.w!==c&&(this.w=c,this.h.fire({enabled:c}))}get checked(){return this.z}set checked(c){this.I(c)}I(c){this.z!==c&&(this.z=c,this.h.fire({checked:c}))}async run(c,h){this.C&&await this.C(c)}}t.$aj=H;class A extends C.$Vc{constructor(){super(...arguments),this.f=this.B(new n.$ee),this.onWillRun=this.f.event,this.m=this.B(new n.$ee),this.onDidRun=this.m.event}async run(c,h){if(!c.enabled)return;this.f.fire({action:c});let e;try{await this.u(c,h)}catch(i){e=i}this.m.fire({action:c,error:e})}async u(c,h){await c.run(h)}}t.$bj=A;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...c){let h=[];for(const e of c)e.length&&(h.length?h=[...h,new P,...e]:h=e);return h}static{this.ID="vs.actions.separator"}async run(){}}t.$cj=P;class d{get actions(){return this.a}constructor(c,h,e,i){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=c,this.label=h,this.class=i,this.a=e}async run(){}}t.$dj=d;class g extends H{static{this.ID="vs.actions.empty"}constructor(){super(g.ID,B.localize(0,null),void 0,!1)}}t.$ej=g;function w(M){return{id:M.id,label:M.label,class:M.class,enabled:M.enabled??!0,checked:M.checked,run:async(...c)=>M.run(...c),tooltip:M.label}}}),define(me[124],be([13,12]),function(se,t){return se.create("vs/base/common/platform",t)}),define(me[5],be([1,0,124]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$I=t.$H=t.$G=t.$F=t.$E=t.OS=t.OperatingSystem=t.$B=t.$A=t.$z=t.$y=t.$x=t.Language=t.$w=t.$v=t.$u=t.$t=t.$s=t.$r=t.$q=t.$p=t.$o=t.$n=t.$m=t.$l=t.$k=t.$j=t.$i=t.Platform=t.$g=void 0,t.$h=D,t.$D=I,t.$J=V,t.$g="en";let C=!1,B=!1,H=!1,A=!1,P=!1,d=!1,g=!1,w=!1,M=!1,c=!1,h,e=t.$g,i=t.$g,o,l;const f=globalThis;let S;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?S=f.vscode.process:typeof process<"u"&&typeof process?.versions?.node=="string"&&(S=process);const m=typeof S?.versions?.electron=="string",b=m&&S?.type==="renderer";if(typeof S=="object"){C=S.platform==="win32",B=S.platform==="darwin",H=S.platform==="linux",A=H&&!!S.env.SNAP&&!!S.env.SNAP_REVISION,g=m,M=!!S.env.CI||!!S.env.BUILD_ARTIFACTSTAGINGDIRECTORY,h=t.$g,e=t.$g;const N=S.env.VSCODE_NLS_CONFIG;if(N)try{const x=JSON.parse(N),j=x.availableLanguages["*"];h=x.locale,i=x.osLocale,e=j||t.$g,o=x._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!b?(l=navigator.userAgent,C=l.indexOf("Windows")>=0,B=l.indexOf("Macintosh")>=0,w=(l.indexOf("Macintosh")>=0||l.indexOf("iPad")>=0||l.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,H=l.indexOf("Linux")>=0,c=l?.indexOf("Mobi")>=0,d=!0,h=n.getConfiguredDefaultLocale(n.localize(0,null))||t.$g,e=h,i=navigator.language):console.error("Unable to resolve platform.");var r;(function(N){N[N.Web=0]="Web",N[N.Mac=1]="Mac",N[N.Linux=2]="Linux",N[N.Windows=3]="Windows"})(r||(t.Platform=r={}));function D(N){switch(N){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}let k=0;B?k=1:C?k=3:H&&(k=2),t.$i=C,t.$j=B,t.$k=H,t.$l=A,t.$m=P,t.$n=g,t.$o=d,t.$p=d&&typeof f.importScripts=="function",t.$q=t.$p?f.origin:void 0,t.$r=w,t.$s=c,t.$t=M,t.$u=k,t.$v=l,t.$w=e;var T;(function(N){function x(){return t.$w}N.value=x;function j(){return t.$w.length===2?t.$w==="en":t.$w.length>=3?t.$w[0]==="e"&&t.$w[1]==="n"&&t.$w[2]==="-":!1}N.isDefaultVariant=j;function Y(){return t.$w==="en"}N.isDefault=Y})(T||(t.Language=T={})),t.$x=h,t.$y=i,t.$z=o,t.$A=typeof f.postMessage=="function"&&!f.importScripts,t.$B=(()=>{if(t.$A){const N=[];f.addEventListener("message",j=>{if(j.data&&j.data.vscodeScheduleAsyncWork)for(let Y=0,K=N.length;Y<K;Y++){const ae=N[Y];if(ae.id===j.data.vscodeScheduleAsyncWork){N.splice(Y,1),ae.callback();return}}});let x=0;return j=>{const Y=++x;N.push({id:Y,callback:j}),f.postMessage({vscodeScheduleAsyncWork:Y},"*")}}return N=>setTimeout(N)})();var L;(function(N){N[N.Windows=1]="Windows",N[N.Macintosh=2]="Macintosh",N[N.Linux=3]="Linux"})(L||(t.OperatingSystem=L={})),t.OS=B||w?2:C?1:3;let q=!0,$=!1;function I(){if(!$){$=!0;const N=new Uint8Array(2);N[0]=1,N[1]=2,q=new Uint16Array(N.buffer)[0]===513}return q}t.$E=!!(t.$v&&t.$v.indexOf("Chrome")>=0),t.$F=!!(t.$v&&t.$v.indexOf("Firefox")>=0),t.$G=!!(!t.$E&&t.$v&&t.$v.indexOf("Safari")>=0),t.$H=!!(t.$v&&t.$v.indexOf("Edg/")>=0),t.$I=!!(t.$v&&t.$v.indexOf("Android")>=0);function V(N){return parseFloat(N)>=20}}),define(me[125],be([1,0,17,22,5]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$DR=t.KeyboardSupport=void 0;var H;(function(A){A[A.Always=0]="Always",A[A.FullScreen=1]="FullScreen",A[A.None=2]="None"})(H||(t.KeyboardSupport=H={})),t.$DR={clipboard:{writeText:B.$m||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:B.$m||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:B.$m||n.$BR()?0:navigator.keyboard||n.$xR?1:2,touch:"ontouchstart"in C.$iR||navigator.maxTouchPoints>0,pointerEvents:C.$iR.PointerEvent&&("ontouchstart"in C.$iR||navigator.maxTouchPoints>0)}}),define(me[15],be([1,0,17,54,87,5]),function(se,t,n,C,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$LR=void 0,t.$JR=M,t.$KR=c;function A(e){if(e.charCode){const o=String.fromCharCode(e.charCode).toUpperCase();return C.KeyCodeUtils.fromString(o)}const i=e.keyCode;if(i===3)return 7;if(n.$uR)switch(i){case 59:return 85;case 60:if(H.$k)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(H.$j)return 57;break}else if(n.$vR){if(H.$j&&i===93)return 57;if(!H.$j&&i===92)return 57}return C.$yr[i]||0}const P=H.$j?256:2048,d=512,g=1024,w=H.$j?2048:256;function M(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}function c(e){const i=[];return e.ctrlKey&&i.push("ctrl"),e.shiftKey&&i.push("shift"),e.altKey&&i.push("alt"),e.metaKey&&i.push("meta"),`modifiers: [${i.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${C.KeyCodeUtils.toString(e.keyCode)}')`}class h{constructor(i){this._standardKeyboardEventBrand=!0;const o=i;this.browserEvent=o,this.target=o.target,this.ctrlKey=o.ctrlKey,this.shiftKey=o.shiftKey,this.altKey=o.altKey,this.metaKey=o.metaKey,this.altGraphKey=o.getModifierState?.("AltGraph"),this.keyCode=A(o),this.code=o.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(i){return this.a===i}c(){let i=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode);let o=0;return this.ctrlKey&&(o|=P),this.altKey&&(o|=d),this.shiftKey&&(o|=g),this.metaKey&&(o|=w),o|=i,o}d(){let i=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(i=this.keyCode),new B.$Gr(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,i)}}t.$LR=h}),define(me[20],be([1,0,17,79,5]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IR=t.$HR=t.$GR=void 0;class H{constructor(g,w){this.timestamp=Date.now(),this.browserEvent=w,this.leftButton=w.button===0,this.middleButton=w.button===1,this.rightButton=w.button===2,this.buttons=w.buttons,this.target=w.target,this.detail=w.detail||1,w.type==="dblclick"&&(this.detail=2),this.ctrlKey=w.ctrlKey,this.shiftKey=w.shiftKey,this.altKey=w.altKey,this.metaKey=w.metaKey,typeof w.pageX=="number"?(this.posx=w.pageX,this.posy=w.pageY):(this.posx=w.clientX+this.target.ownerDocument.body.scrollLeft+this.target.ownerDocument.documentElement.scrollLeft,this.posy=w.clientY+this.target.ownerDocument.body.scrollTop+this.target.ownerDocument.documentElement.scrollTop);const M=C.$ER.getPositionOfChildWindowRelativeToAncestorWindow(g,w.view);this.posx-=M.left,this.posy-=M.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.$GR=H;class A extends H{constructor(g,w){super(g,w),this.dataTransfer=w.dataTransfer}}t.$HR=A;class P{constructor(g,w=0,M=0){this.browserEvent=g||null,this.target=g?g.target||g.targetNode||g.srcElement:null,this.deltaY=M,this.deltaX=w;let c=!1;if(n.$wR){const h=navigator.userAgent.match(/Chrome\/(\d+)/);c=(h?parseInt(h[1]):123)<=122}if(g){const h=g,e=g,i=g.view?.devicePixelRatio||1;if(typeof h.wheelDeltaY<"u")c?this.deltaY=h.wheelDeltaY/(120*i):this.deltaY=h.wheelDeltaY/120;else if(typeof e.VERTICAL_AXIS<"u"&&e.axis===e.VERTICAL_AXIS)this.deltaY=-e.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?n.$uR&&!B.$j?this.deltaY=-g.deltaY/3:this.deltaY=-g.deltaY:this.deltaY=-g.deltaY/40}if(typeof h.wheelDeltaX<"u")n.$xR&&B.$i?this.deltaX=-(h.wheelDeltaX/120):c?this.deltaX=h.wheelDeltaX/(120*i):this.deltaX=h.wheelDeltaX/120;else if(typeof e.HORIZONTAL_AXIS<"u"&&e.axis===e.HORIZONTAL_AXIS)this.deltaX=-g.detail/3;else if(g.type==="wheel"){const o=g;o.deltaMode===o.DOM_DELTA_LINE?n.$uR&&!B.$j?this.deltaX=-g.deltaX/3:this.deltaX=-g.deltaX:this.deltaX=-g.deltaX/40}this.deltaY===0&&this.deltaX===0&&g.wheelDelta&&(c?this.deltaY=g.wheelDelta/(120*i):this.deltaY=g.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.$IR=P}),define(me[126],be([1,0,5]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fc=t.$ec=t.env=t.cwd=void 0;let C;const B=globalThis.vscode;if(typeof B<"u"&&typeof B.process<"u"){const H=B.process;C={get platform(){return H.platform},get arch(){return H.arch},get env(){return H.env},cwd(){return H.cwd()}}}else typeof process<"u"?C={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:C={get platform(){return n.$i?"win32":n.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=C.cwd,t.env=C.env,t.$ec=C.platform,t.$fc=C.arch}),define(me[25],be([1,0,126]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uc=t.sep=t.$sc=t.$rc=t.$qc=t.$pc=t.$oc=t.$nc=t.$mc=t.$lc=t.$kc=t.$jc=t.$ic=t.$hc=t.$gc=void 0;const C=65,B=97,H=90,A=122,P=46,d=47,g=92,w=58,M=63;class c extends Error{constructor(D,k,T){let L;typeof k=="string"&&k.indexOf("not ")===0?(L="must not be",k=k.replace(/^not /,"")):L="must be";const q=D.indexOf(".")!==-1?"property":"argument";let $=`The "${D}" ${q} ${L} of type ${k}`;$+=`. Received type ${typeof T}`,super($),this.code="ERR_INVALID_ARG_TYPE"}}function h(r,D){if(r===null||typeof r!="object")throw new c(D,"Object",r)}function e(r,D){if(typeof r!="string")throw new c(D,"string",r)}const i=n.$ec==="win32";function o(r){return r===d||r===g}function l(r){return r===d}function f(r){return r>=C&&r<=H||r>=B&&r<=A}function S(r,D,k,T){let L="",q=0,$=-1,I=0,V=0;for(let N=0;N<=r.length;++N){if(N<r.length)V=r.charCodeAt(N);else{if(T(V))break;V=d}if(T(V)){if(!($===N-1||I===1))if(I===2){if(L.length<2||q!==2||L.charCodeAt(L.length-1)!==P||L.charCodeAt(L.length-2)!==P){if(L.length>2){const x=L.lastIndexOf(k);x===-1?(L="",q=0):(L=L.slice(0,x),q=L.length-1-L.lastIndexOf(k)),$=N,I=0;continue}else if(L.length!==0){L="",q=0,$=N,I=0;continue}}D&&(L+=L.length>0?`${k}..`:"..",q=2)}else L.length>0?L+=`${k}${r.slice($+1,N)}`:L=r.slice($+1,N),q=N-$-1;$=N,I=0}else V===P&&I!==-1?++I:I=-1}return L}function m(r,D){h(D,"pathObject");const k=D.dir||D.root,T=D.base||`${D.name||""}${D.ext||""}`;return k?k===D.root?`${k}${T}`:`${k}${r}${T}`:T}t.$gc={resolve(...r){let D="",k="",T=!1;for(let L=r.length-1;L>=-1;L--){let q;if(L>=0){if(q=r[L],e(q,"path"),q.length===0)continue}else D.length===0?q=n.cwd():(q=n.env[`=${D}`]||n.cwd(),(q===void 0||q.slice(0,2).toLowerCase()!==D.toLowerCase()&&q.charCodeAt(2)===g)&&(q=`${D}\\`));const $=q.length;let I=0,V="",N=!1;const x=q.charCodeAt(0);if($===1)o(x)&&(I=1,N=!0);else if(o(x))if(N=!0,o(q.charCodeAt(1))){let j=2,Y=j;for(;j<$&&!o(q.charCodeAt(j));)j++;if(j<$&&j!==Y){const K=q.slice(Y,j);for(Y=j;j<$&&o(q.charCodeAt(j));)j++;if(j<$&&j!==Y){for(Y=j;j<$&&!o(q.charCodeAt(j));)j++;(j===$||j!==Y)&&(V=`\\\\${K}\\${q.slice(Y,j)}`,I=j)}}}else I=1;else f(x)&&q.charCodeAt(1)===w&&(V=q.slice(0,2),I=2,$>2&&o(q.charCodeAt(2))&&(N=!0,I=3));if(V.length>0)if(D.length>0){if(V.toLowerCase()!==D.toLowerCase())continue}else D=V;if(T){if(D.length>0)break}else if(k=`${q.slice(I)}\\${k}`,T=N,N&&D.length>0)break}return k=S(k,!T,"\\",o),T?`${D}\\${k}`:`${D}${k}`||"."},normalize(r){e(r,"path");const D=r.length;if(D===0)return".";let k=0,T,L=!1;const q=r.charCodeAt(0);if(D===1)return l(q)?"\\":r;if(o(q))if(L=!0,o(r.charCodeAt(1))){let I=2,V=I;for(;I<D&&!o(r.charCodeAt(I));)I++;if(I<D&&I!==V){const N=r.slice(V,I);for(V=I;I<D&&o(r.charCodeAt(I));)I++;if(I<D&&I!==V){for(V=I;I<D&&!o(r.charCodeAt(I));)I++;if(I===D)return`\\\\${N}\\${r.slice(V)}\\`;I!==V&&(T=`\\\\${N}\\${r.slice(V,I)}`,k=I)}}}else k=1;else f(q)&&r.charCodeAt(1)===w&&(T=r.slice(0,2),k=2,D>2&&o(r.charCodeAt(2))&&(L=!0,k=3));let $=k<D?S(r.slice(k),!L,"\\",o):"";return $.length===0&&!L&&($="."),$.length>0&&o(r.charCodeAt(D-1))&&($+="\\"),T===void 0?L?`\\${$}`:$:L?`${T}\\${$}`:`${T}${$}`},isAbsolute(r){e(r,"path");const D=r.length;if(D===0)return!1;const k=r.charCodeAt(0);return o(k)||D>2&&f(k)&&r.charCodeAt(1)===w&&o(r.charCodeAt(2))},join(...r){if(r.length===0)return".";let D,k;for(let q=0;q<r.length;++q){const $=r[q];e($,"path"),$.length>0&&(D===void 0?D=k=$:D+=`\\${$}`)}if(D===void 0)return".";let T=!0,L=0;if(typeof k=="string"&&o(k.charCodeAt(0))){++L;const q=k.length;q>1&&o(k.charCodeAt(1))&&(++L,q>2&&(o(k.charCodeAt(2))?++L:T=!1))}if(T){for(;L<D.length&&o(D.charCodeAt(L));)L++;L>=2&&(D=`\\${D.slice(L)}`)}return t.$gc.normalize(D)},relative(r,D){if(e(r,"from"),e(D,"to"),r===D)return"";const k=t.$gc.resolve(r),T=t.$gc.resolve(D);if(k===T||(r=k.toLowerCase(),D=T.toLowerCase(),r===D))return"";let L=0;for(;L<r.length&&r.charCodeAt(L)===g;)L++;let q=r.length;for(;q-1>L&&r.charCodeAt(q-1)===g;)q--;const $=q-L;let I=0;for(;I<D.length&&D.charCodeAt(I)===g;)I++;let V=D.length;for(;V-1>I&&D.charCodeAt(V-1)===g;)V--;const N=V-I,x=$<N?$:N;let j=-1,Y=0;for(;Y<x;Y++){const ae=r.charCodeAt(L+Y);if(ae!==D.charCodeAt(I+Y))break;ae===g&&(j=Y)}if(Y!==x){if(j===-1)return T}else{if(N>x){if(D.charCodeAt(I+Y)===g)return T.slice(I+Y+1);if(Y===2)return T.slice(I+Y)}$>x&&(r.charCodeAt(L+Y)===g?j=Y:Y===2&&(j=3)),j===-1&&(j=0)}let K="";for(Y=L+j+1;Y<=q;++Y)(Y===q||r.charCodeAt(Y)===g)&&(K+=K.length===0?"..":"\\..");return I+=j,K.length>0?`${K}${T.slice(I,V)}`:(T.charCodeAt(I)===g&&++I,T.slice(I,V))},toNamespacedPath(r){if(typeof r!="string"||r.length===0)return r;const D=t.$gc.resolve(r);if(D.length<=2)return r;if(D.charCodeAt(0)===g){if(D.charCodeAt(1)===g){const k=D.charCodeAt(2);if(k!==M&&k!==P)return`\\\\?\\UNC\\${D.slice(2)}`}}else if(f(D.charCodeAt(0))&&D.charCodeAt(1)===w&&D.charCodeAt(2)===g)return`\\\\?\\${D}`;return r},dirname(r){e(r,"path");const D=r.length;if(D===0)return".";let k=-1,T=0;const L=r.charCodeAt(0);if(D===1)return o(L)?r:".";if(o(L)){if(k=T=1,o(r.charCodeAt(1))){let I=2,V=I;for(;I<D&&!o(r.charCodeAt(I));)I++;if(I<D&&I!==V){for(V=I;I<D&&o(r.charCodeAt(I));)I++;if(I<D&&I!==V){for(V=I;I<D&&!o(r.charCodeAt(I));)I++;if(I===D)return r;I!==V&&(k=T=I+1)}}}}else f(L)&&r.charCodeAt(1)===w&&(k=D>2&&o(r.charCodeAt(2))?3:2,T=k);let q=-1,$=!0;for(let I=D-1;I>=T;--I)if(o(r.charCodeAt(I))){if(!$){q=I;break}}else $=!1;if(q===-1){if(k===-1)return".";q=k}return r.slice(0,q)},basename(r,D){D!==void 0&&e(D,"ext"),e(r,"path");let k=0,T=-1,L=!0,q;if(r.length>=2&&f(r.charCodeAt(0))&&r.charCodeAt(1)===w&&(k=2),D!==void 0&&D.length>0&&D.length<=r.length){if(D===r)return"";let $=D.length-1,I=-1;for(q=r.length-1;q>=k;--q){const V=r.charCodeAt(q);if(o(V)){if(!L){k=q+1;break}}else I===-1&&(L=!1,I=q+1),$>=0&&(V===D.charCodeAt($)?--$===-1&&(T=q):($=-1,T=I))}return k===T?T=I:T===-1&&(T=r.length),r.slice(k,T)}for(q=r.length-1;q>=k;--q)if(o(r.charCodeAt(q))){if(!L){k=q+1;break}}else T===-1&&(L=!1,T=q+1);return T===-1?"":r.slice(k,T)},extname(r){e(r,"path");let D=0,k=-1,T=0,L=-1,q=!0,$=0;r.length>=2&&r.charCodeAt(1)===w&&f(r.charCodeAt(0))&&(D=T=2);for(let I=r.length-1;I>=D;--I){const V=r.charCodeAt(I);if(o(V)){if(!q){T=I+1;break}continue}L===-1&&(q=!1,L=I+1),V===P?k===-1?k=I:$!==1&&($=1):k!==-1&&($=-1)}return k===-1||L===-1||$===0||$===1&&k===L-1&&k===T+1?"":r.slice(k,L)},format:m.bind(null,"\\"),parse(r){e(r,"path");const D={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return D;const k=r.length;let T=0,L=r.charCodeAt(0);if(k===1)return o(L)?(D.root=D.dir=r,D):(D.base=D.name=r,D);if(o(L)){if(T=1,o(r.charCodeAt(1))){let j=2,Y=j;for(;j<k&&!o(r.charCodeAt(j));)j++;if(j<k&&j!==Y){for(Y=j;j<k&&o(r.charCodeAt(j));)j++;if(j<k&&j!==Y){for(Y=j;j<k&&!o(r.charCodeAt(j));)j++;j===k?T=j:j!==Y&&(T=j+1)}}}}else if(f(L)&&r.charCodeAt(1)===w){if(k<=2)return D.root=D.dir=r,D;if(T=2,o(r.charCodeAt(2))){if(k===3)return D.root=D.dir=r,D;T=3}}T>0&&(D.root=r.slice(0,T));let q=-1,$=T,I=-1,V=!0,N=r.length-1,x=0;for(;N>=T;--N){if(L=r.charCodeAt(N),o(L)){if(!V){$=N+1;break}continue}I===-1&&(V=!1,I=N+1),L===P?q===-1?q=N:x!==1&&(x=1):q!==-1&&(x=-1)}return I!==-1&&(q===-1||x===0||x===1&&q===I-1&&q===$+1?D.base=D.name=r.slice($,I):(D.name=r.slice($,q),D.base=r.slice($,I),D.ext=r.slice(q,I))),$>0&&$!==T?D.dir=r.slice(0,$-1):D.dir=D.root,D},sep:"\\",delimiter:";",win32:null,posix:null};const b=(()=>{if(i){const r=/\\/g;return()=>{const D=n.cwd().replace(r,"/");return D.slice(D.indexOf("/"))}}return()=>n.cwd()})();t.$hc={resolve(...r){let D="",k=!1;for(let T=r.length-1;T>=-1&&!k;T--){const L=T>=0?r[T]:b();e(L,"path"),L.length!==0&&(D=`${L}/${D}`,k=L.charCodeAt(0)===d)}return D=S(D,!k,"/",l),k?`/${D}`:D.length>0?D:"."},normalize(r){if(e(r,"path"),r.length===0)return".";const D=r.charCodeAt(0)===d,k=r.charCodeAt(r.length-1)===d;return r=S(r,!D,"/",l),r.length===0?D?"/":k?"./":".":(k&&(r+="/"),D?`/${r}`:r)},isAbsolute(r){return e(r,"path"),r.length>0&&r.charCodeAt(0)===d},join(...r){if(r.length===0)return".";let D;for(let k=0;k<r.length;++k){const T=r[k];e(T,"path"),T.length>0&&(D===void 0?D=T:D+=`/${T}`)}return D===void 0?".":t.$hc.normalize(D)},relative(r,D){if(e(r,"from"),e(D,"to"),r===D||(r=t.$hc.resolve(r),D=t.$hc.resolve(D),r===D))return"";const k=1,T=r.length,L=T-k,q=1,$=D.length-q,I=L<$?L:$;let V=-1,N=0;for(;N<I;N++){const j=r.charCodeAt(k+N);if(j!==D.charCodeAt(q+N))break;j===d&&(V=N)}if(N===I)if($>I){if(D.charCodeAt(q+N)===d)return D.slice(q+N+1);if(N===0)return D.slice(q+N)}else L>I&&(r.charCodeAt(k+N)===d?V=N:N===0&&(V=0));let x="";for(N=k+V+1;N<=T;++N)(N===T||r.charCodeAt(N)===d)&&(x+=x.length===0?"..":"/..");return`${x}${D.slice(q+V)}`},toNamespacedPath(r){return r},dirname(r){if(e(r,"path"),r.length===0)return".";const D=r.charCodeAt(0)===d;let k=-1,T=!0;for(let L=r.length-1;L>=1;--L)if(r.charCodeAt(L)===d){if(!T){k=L;break}}else T=!1;return k===-1?D?"/":".":D&&k===1?"//":r.slice(0,k)},basename(r,D){D!==void 0&&e(D,"ext"),e(r,"path");let k=0,T=-1,L=!0,q;if(D!==void 0&&D.length>0&&D.length<=r.length){if(D===r)return"";let $=D.length-1,I=-1;for(q=r.length-1;q>=0;--q){const V=r.charCodeAt(q);if(V===d){if(!L){k=q+1;break}}else I===-1&&(L=!1,I=q+1),$>=0&&(V===D.charCodeAt($)?--$===-1&&(T=q):($=-1,T=I))}return k===T?T=I:T===-1&&(T=r.length),r.slice(k,T)}for(q=r.length-1;q>=0;--q)if(r.charCodeAt(q)===d){if(!L){k=q+1;break}}else T===-1&&(L=!1,T=q+1);return T===-1?"":r.slice(k,T)},extname(r){e(r,"path");let D=-1,k=0,T=-1,L=!0,q=0;for(let $=r.length-1;$>=0;--$){const I=r.charCodeAt($);if(I===d){if(!L){k=$+1;break}continue}T===-1&&(L=!1,T=$+1),I===P?D===-1?D=$:q!==1&&(q=1):D!==-1&&(q=-1)}return D===-1||T===-1||q===0||q===1&&D===T-1&&D===k+1?"":r.slice(D,T)},format:m.bind(null,"/"),parse(r){e(r,"path");const D={root:"",dir:"",base:"",ext:"",name:""};if(r.length===0)return D;const k=r.charCodeAt(0)===d;let T;k?(D.root="/",T=1):T=0;let L=-1,q=0,$=-1,I=!0,V=r.length-1,N=0;for(;V>=T;--V){const x=r.charCodeAt(V);if(x===d){if(!I){q=V+1;break}continue}$===-1&&(I=!1,$=V+1),x===P?L===-1?L=V:N!==1&&(N=1):L!==-1&&(N=-1)}if($!==-1){const x=q===0&&k?1:q;L===-1||N===0||N===1&&L===$-1&&L===q+1?D.base=D.name=r.slice(x,$):(D.name=r.slice(x,L),D.base=r.slice(x,$),D.ext=r.slice(L,$))}return q>0?D.dir=r.slice(0,q-1):k&&(D.dir="/"),D},sep:"/",delimiter:":",win32:null,posix:null},t.$hc.win32=t.$gc.win32=t.$gc,t.$hc.posix=t.$gc.posix=t.$hc,t.$ic=i?t.$gc.normalize:t.$hc.normalize,t.$jc=i?t.$gc.isAbsolute:t.$hc.isAbsolute,t.$kc=i?t.$gc.join:t.$hc.join,t.$lc=i?t.$gc.resolve:t.$hc.resolve,t.$mc=i?t.$gc.relative:t.$hc.relative,t.$nc=i?t.$gc.dirname:t.$hc.dirname,t.$oc=i?t.$gc.basename:t.$hc.basename,t.$pc=i?t.$gc.extname:t.$hc.extname,t.$qc=i?t.$gc.format:t.$hc.format,t.$rc=i?t.$gc.parse:t.$hc.parse,t.$sc=i?t.$gc.toNamespacedPath:t.$hc.toNamespacedPath,t.sep=i?t.$gc.sep:t.$hc.sep,t.$uc=i?t.$gc.delimiter:t.$hc.delimiter}),define(me[127],be([1,0,25,5,9,10]),function(se,t,n,C,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ng=A,t.$og=P,t.$pg=d,t.$qg=g,t.$rg=w,t.$sg=e,t.$tg=i,t.$ug=o,t.$vg=l,t.$wg=f,t.$xg=S,t.$yg=m,t.$zg=b,t.$Ag=r,t.$Bg=D,t.$Cg=k,t.$Dg=q;function A($){return $===47||$===92}function P($){return $.replace(/[\\/]/g,n.$hc.sep)}function d($){return $.indexOf("/")===-1&&($=P($)),/^[a-zA-Z]:(\/|$)/.test($)&&($="/"+$),$}function g($,I=n.$hc.sep){if(!$)return"";const V=$.length,N=$.charCodeAt(0);if(A(N)){if(A($.charCodeAt(1))&&!A($.charCodeAt(2))){let j=3;const Y=j;for(;j<V&&!A($.charCodeAt(j));j++);if(Y!==j&&!A($.charCodeAt(j+1))){for(j+=1;j<V;j++)if(A($.charCodeAt(j)))return $.slice(0,j+1).replace(/[\\/]/g,I)}}return I}else if(l(N)&&$.charCodeAt(1)===58)return A($.charCodeAt(2))?$.slice(0,2)+I:$.slice(0,2);let x=$.indexOf("://");if(x!==-1){for(x+=3;x<V;x++)if(A($.charCodeAt(x)))return $.slice(0,x+1)}return""}function w($){if(!C.$i||!$||$.length<5)return!1;let I=$.charCodeAt(0);if(I!==92||(I=$.charCodeAt(1),I!==92))return!1;let V=2;const N=V;for(;V<$.length&&(I=$.charCodeAt(V),I!==92);V++);return!(N===V||(I=$.charCodeAt(V+1),isNaN(I)||I===92))}const M=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e($,I=C.$i){const V=I?M:c;return!(!$||$.length===0||/^\s+$/.test($)||(V.lastIndex=0,V.test($))||I&&h.test($)||$==="."||$===".."||I&&$[$.length-1]==="."||I&&$.length!==$.trim().length||$.length>255)}function i($,I,V){const N=$===I;return!V||N?N:!$||!I?!1:(0,B.$xf)($,I)}function o($,I,V,N=n.sep){if($===I)return!0;if(!$||!I||I.length>$.length)return!1;if(V){if(!(0,B.$yf)($,I))return!1;if(I.length===$.length)return!0;let j=I.length;return I.charAt(I.length-1)===N&&j--,$.charAt(j)===N}return I.charAt(I.length-1)!==N&&(I+=N),$.indexOf(I)===0}function l($){return $>=65&&$<=90||$>=97&&$<=122}function f($,I){return C.$i&&$.endsWith(":")&&($+=n.sep),(0,n.$jc)($)||($=(0,n.$kc)(I,$)),$=(0,n.$ic)($),S($)}function S($){return C.$i?($=(0,B.$ff)($,n.sep),$.endsWith(":")&&($+=n.sep)):($=(0,B.$ff)($,n.sep),$||($=n.sep)),$}function m($){const I=(0,n.$ic)($);return C.$i?$.length>3?!1:b(I)&&($.length===2||I.charCodeAt(2)===92):I===n.$hc.sep}function b($,I=C.$i){return I?l($.charCodeAt(0))&&$.charCodeAt(1)===58:!1}function r($,I=C.$i){return b($,I)?$[0]:void 0}function D($,I,V){return I.length>$.length?-1:$===I?0:(V&&($=$.toLowerCase(),I=I.toLowerCase()),$.indexOf(I))}function k($){const I=$.split(":");let V,N,x;for(const j of I){const Y=Number(j);(0,H.$_f)(Y)?N===void 0?N=Y:x===void 0&&(x=Y):V=V?[V,j].join(":"):j}if(!V)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:V,line:N!==void 0?N:void 0,column:x!==void 0?x:N!==void 0?1:void 0}}const T="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function q($,I,V=8){let N="";for(let j=0;j<V;j++){let Y;j===0&&C.$i&&!I&&(V===3||V===4)?Y=L:Y=T,N+=Y.charAt(Math.floor(Math.random()*Y.length))}let x;return I?x=`${I}-${N}`:x=N,$?(0,n.$kc)($,x):x}}),define(me[128],be([1,0,25]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Ps=void 0,t.$Qs=H,t.$Rs=A,t.$Ss=P,t.$Ts=g,t.$Ps=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const C={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},B={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function H(w){const M=(0,n.$pc)(w),c=C[M.toLowerCase()];return c!==void 0?c:A(w)}function A(w){const M=(0,n.$pc)(w);return B[M.toLowerCase()]}function P(w){for(const M in B)if(B[M]===w)return M}const d=/^(.+)\/(.+?)(;.+)?$/;function g(w,M){const c=d.exec(w);return c?`${c[1].toLowerCase()}/${c[2].toLowerCase()}${c[3]??""}`:M?void 0:w}}),define(me[16],be([1,0,25,5]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URI=void 0,t.$wc=e,t.$xc=m;const B=/^\w[\w\d+.-]*$/,H=/^\//,A=/^\/\//;function P(T,L){if(!T.scheme&&L)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${T.authority}", path: "${T.path}", query: "${T.query}", fragment: "${T.fragment}"}`);if(T.scheme&&!B.test(T.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(T.path){if(T.authority){if(!H.test(T.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(T.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(T,L){return!T&&!L?"file":T}function g(T,L){switch(T){case"https":case"http":case"file":L?L[0]!==M&&(L=M+L):L=M;break}return L}const w="",M="/",c=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class h{static isUri(L){return L instanceof h?!0:L?typeof L.authority=="string"&&typeof L.fragment=="string"&&typeof L.path=="string"&&typeof L.query=="string"&&typeof L.scheme=="string"&&typeof L.fsPath=="string"&&typeof L.with=="function"&&typeof L.toString=="function":!1}constructor(L,q,$,I,V,N=!1){typeof L=="object"?(this.scheme=L.scheme||w,this.authority=L.authority||w,this.path=L.path||w,this.query=L.query||w,this.fragment=L.fragment||w):(this.scheme=d(L,N),this.authority=q||w,this.path=g(this.scheme,$||w),this.query=I||w,this.fragment=V||w,P(this,N))}get fsPath(){return m(this,!1)}with(L){if(!L)return this;let{scheme:q,authority:$,path:I,query:V,fragment:N}=L;return q===void 0?q=this.scheme:q===null&&(q=w),$===void 0?$=this.authority:$===null&&($=w),I===void 0?I=this.path:I===null&&(I=w),V===void 0?V=this.query:V===null&&(V=w),N===void 0?N=this.fragment:N===null&&(N=w),q===this.scheme&&$===this.authority&&I===this.path&&V===this.query&&N===this.fragment?this:new o(q,$,I,V,N)}static parse(L,q=!1){const $=c.exec(L);return $?new o($[2]||w,k($[4]||w),k($[5]||w),k($[7]||w),k($[9]||w),q):new o(w,w,w,w,w)}static file(L){let q=w;if(C.$i&&(L=L.replace(/\\/g,M)),L[0]===M&&L[1]===M){const $=L.indexOf(M,2);$===-1?(q=L.substring(2),L=M):(q=L.substring(2,$),L=L.substring($)||M)}return new o("file",q,L,w,w)}static from(L,q){return new o(L.scheme,L.authority,L.path,L.query,L.fragment,q)}static joinPath(L,...q){if(!L.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let $;return C.$i&&L.scheme==="file"?$=h.file(n.$gc.join(m(L,!0),...q)).path:$=n.$hc.join(L.path,...q),L.with({path:$})}toString(L=!1){return b(this,L)}toJSON(){return this}static revive(L){if(L){if(L instanceof h)return L;{const q=new o(L);return q._formatted=L.external??null,q._fsPath=L._sep===i?L.fsPath??null:null,q}}else return L}}t.URI=h;function e(T){return!T||typeof T!="object"?!1:typeof T.scheme=="string"&&(typeof T.authority=="string"||typeof T.authority>"u")&&(typeof T.path=="string"||typeof T.path>"u")&&(typeof T.query=="string"||typeof T.query>"u")&&(typeof T.fragment=="string"||typeof T.fragment>"u")}const i=C.$i?1:void 0;class o extends h{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(L=!1){return L?b(this,!0):(this._formatted||(this._formatted=b(this,!1)),this._formatted)}toJSON(){const L={$mid:1};return this._fsPath&&(L.fsPath=this._fsPath,L._sep=i),this._formatted&&(L.external=this._formatted),this.path&&(L.path=this.path),this.scheme&&(L.scheme=this.scheme),this.authority&&(L.authority=this.authority),this.query&&(L.query=this.query),this.fragment&&(L.fragment=this.fragment),L}}const l={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function f(T,L,q){let $,I=-1;for(let V=0;V<T.length;V++){const N=T.charCodeAt(V);if(N>=97&&N<=122||N>=65&&N<=90||N>=48&&N<=57||N===45||N===46||N===95||N===126||L&&N===47||q&&N===91||q&&N===93||q&&N===58)I!==-1&&($+=encodeURIComponent(T.substring(I,V)),I=-1),$!==void 0&&($+=T.charAt(V));else{$===void 0&&($=T.substr(0,V));const x=l[N];x!==void 0?(I!==-1&&($+=encodeURIComponent(T.substring(I,V)),I=-1),$+=x):I===-1&&(I=V)}}return I!==-1&&($+=encodeURIComponent(T.substring(I))),$!==void 0?$:T}function S(T){let L;for(let q=0;q<T.length;q++){const $=T.charCodeAt(q);$===35||$===63?(L===void 0&&(L=T.substr(0,q)),L+=l[$]):L!==void 0&&(L+=T[q])}return L!==void 0?L:T}function m(T,L){let q;return T.authority&&T.path.length>1&&T.scheme==="file"?q=`//${T.authority}${T.path}`:T.path.charCodeAt(0)===47&&(T.path.charCodeAt(1)>=65&&T.path.charCodeAt(1)<=90||T.path.charCodeAt(1)>=97&&T.path.charCodeAt(1)<=122)&&T.path.charCodeAt(2)===58?L?q=T.path.substr(1):q=T.path[1].toLowerCase()+T.path.substr(2):q=T.path,C.$i&&(q=q.replace(/\//g,"\\")),q}function b(T,L){const q=L?S:f;let $="",{scheme:I,authority:V,path:N,query:x,fragment:j}=T;if(I&&($+=I,$+=":"),(V||I==="file")&&($+=M,$+=M),V){let Y=V.indexOf("@");if(Y!==-1){const K=V.substr(0,Y);V=V.substr(Y+1),Y=K.lastIndexOf(":"),Y===-1?$+=q(K,!1,!1):($+=q(K.substr(0,Y),!1,!1),$+=":",$+=q(K.substr(Y+1),!1,!0)),$+="@"}V=V.toLowerCase(),Y=V.lastIndexOf(":"),Y===-1?$+=q(V,!1,!0):($+=q(V.substr(0,Y),!1,!0),$+=V.substr(Y))}if(N){if(N.length>=3&&N.charCodeAt(0)===47&&N.charCodeAt(2)===58){const Y=N.charCodeAt(1);Y>=65&&Y<=90&&(N=`/${String.fromCharCode(Y+32)}:${N.substr(3)}`)}else if(N.length>=2&&N.charCodeAt(1)===58){const Y=N.charCodeAt(0);Y>=65&&Y<=90&&(N=`${String.fromCharCode(Y+32)}:${N.substr(2)}`)}$+=q(N,!0,!1)}return x&&($+="?",$+=q(x,!1,!1)),j&&($+="#",$+=L?j:f(j,!1,!1)),$}function r(T){try{return decodeURIComponent(T)}catch{return T.length>3?T.substr(0,3)+r(T.substr(3)):T}}const D=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function k(T){return T.match(D)?T.replace(D,L=>r(L)):T}}),define(me[64],be([1,0,43,16]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$3h=B,t.$4h=H,t.$5h=P;function B(d){return JSON.stringify(d,A)}function H(d){let g=JSON.parse(d);return g=P(g),g}function A(d,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function P(d,g=0){if(!d||g>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return C.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 17:return new Date(d.source)}if(d instanceof n.$Fe||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let w=0;w<d.length;++w)d[w]=P(d[w],g+1);else for(const w in d)Object.hasOwnProperty.call(d,w)&&(d[w]=P(d[w],g+1))}return d}}),define(me[36],be([1,0,6,5,9,16,25]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.$Pg=t.$Og=t.$Ng=t.$Mg=t.$Lg=t.$Kg=t.$Ig=t.$Hg=t.$Gg=t.Schemas=void 0,t.$Eg=d,t.$Fg=g,t.$Jg=M;var P;(function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.vscodeManagedRemoteResource="vscode-managed-remote-resource",e.vscodeUserData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeNotebookCell="vscode-notebook-cell",e.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",e.vscodeNotebookCellOutput="vscode-notebook-cell-output",e.vscodeInteractiveInput="vscode-interactive-input",e.vscodeSettings="vscode-settings",e.vscodeWorkspaceTrust="vscode-workspace-trust",e.vscodeTerminal="vscode-terminal",e.vscodeChatCodeBlock="vscode-chat-code-block",e.vscodeChatSesssion="vscode-chat-editor",e.webviewPanel="webview-panel",e.vscodeWebview="vscode-webview",e.extension="extension",e.vscodeFileResource="vscode-file",e.tmp="tmp",e.vsls="vsls",e.vscodeSourceControl="vscode-scm",e.commentsInput="comment",e.codeSetting="code-setting"})(P||(t.Schemas=P={}));function d(e,i){return H.URI.isUri(e)?(0,B.$xf)(e.scheme,i):(0,B.$yf)(e,i+":")}function g(e,...i){return i.some(o=>d(e,o))}t.$Gg="vscode-tkn",t.$Hg="tkn";class w{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(i){this.d=i}setDelegate(i){this.e=i}setServerRootPath(i,o){this.f=M(i,o)}getServerRootPath(){return this.f}get g(){return A.$hc.join(this.f,P.vscodeRemoteResource)}set(i,o,l){this.a[i]=o,this.b[i]=l}setConnectionToken(i,o){this.c[i]=o}getPreferredWebSchema(){return this.d}rewrite(i){if(this.e)try{return this.e(i)}catch(b){return n.$1(b),i}const o=i.authority;let l=this.a[o];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const f=this.b[o],S=this.c[o];let m=`path=${encodeURIComponent(i.path)}`;return typeof S=="string"&&(m+=`&${t.$Hg}=${encodeURIComponent(S)}`),H.URI.from({scheme:C.$o?this.d:P.vscodeRemoteResource,authority:`${l}:${f}`,path:this.g,query:m})}}t.$Ig=new w;function M(e,i){return A.$hc.join(i??"/",`${e.quality??"oss"}-${e.commit??"dev"}`)}t.$Kg="vs/../../extensions",t.$Lg="vs/../../node_modules",t.$Mg="vs/../../node_modules.asar",t.$Ng="vs/../../node_modules.asar.unpacked",t.$Og="vscode-app";class c{static{this.a=t.$Og}asBrowserUri(i){const o=this.b(i,se);return this.uriToBrowserUri(o)}uriToBrowserUri(i){return i.scheme===P.vscodeRemote?t.$Ig.rewrite(i):i.scheme===P.file&&(C.$m||C.$q===`${P.vscodeFileResource}://${c.a}`)?i.with({scheme:P.vscodeFileResource,authority:i.authority||c.a,query:null,fragment:null}):i}asFileUri(i){const o=this.b(i,se);return this.uriToFileUri(o)}uriToFileUri(i){return i.scheme===P.vscodeFileResource?i.with({scheme:P.file,authority:i.authority!==c.a?i.authority:null,query:null,fragment:null}):i}b(i,o){return H.URI.isUri(i)?i:H.URI.parse(o.toUrl(i))}}t.$Pg=new c;var h;(function(e){const i=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);e.CoopAndCoep=Object.freeze(i.get("3"));const o="vscode-coi";function l(S){let m;typeof S=="string"?m=new URL(S).searchParams:S instanceof URL?m=S.searchParams:H.URI.isUri(S)&&(m=new URL(S.toString(!0)).searchParams);const b=m?.get(o);if(b)return i.get(b)}e.getHeadersFromQuery=l;function f(S,m,b){if(!globalThis.crossOriginIsolated)return;const r=m&&b?"3":b?"2":"1";S instanceof URLSearchParams?S.set(o,r):S[o]=r}e.addSearchParam=f})(h||(t.COI=h={}))}),define(me[47],be([1,0,127,36,25,5,9,16]),function(se,t,n,C,B,H,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataUri=t.$eh=t.$dh=t.$ch=t.$bh=t.$ah=t.$_g=t.$$g=t.$0g=t.$9g=t.$8g=t.$7g=t.$6g=t.$5g=t.$4g=t.$3g=t.$2g=t.$1g=t.$Zg=t.$Yg=t.$Xg=void 0,t.$Wg=d,t.$fh=w,t.$gh=c;function d(h){return(0,P.$xc)(h,!0)}class g{constructor(e){this.a=e}compare(e,i,o=!1){return e===i?0:(0,A.$qf)(this.getComparisonKey(e,o),this.getComparisonKey(i,o))}isEqual(e,i,o=!1){return e===i?!0:!e||!i?!1:this.getComparisonKey(e,o)===this.getComparisonKey(i,o)}getComparisonKey(e,i=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:i?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,i,o=!1){if(e.scheme===i.scheme){if(e.scheme===C.Schemas.file)return n.$ug(d(e),d(i),this.a(e))&&e.query===i.query&&(o||e.fragment===i.fragment);if((0,t.$bh)(e.authority,i.authority))return n.$ug(e.path,i.path,this.a(e),"/")&&e.query===i.query&&(o||e.fragment===i.fragment)}return!1}joinPath(e,...i){return P.URI.joinPath(e,...i)}basenameOrAuthority(e){return(0,t.$6g)(e)||e.authority}basename(e){return B.$hc.basename(e.path)}extname(e){return B.$hc.extname(e.path)}dirname(e){if(e.path.length===0)return e;let i;return e.scheme===C.Schemas.file?i=P.URI.file(B.$nc(d(e))).path:(i=B.$hc.dirname(e.path),e.authority&&i.length&&i.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),i="/")),e.with({path:i})}normalizePath(e){if(!e.path.length)return e;let i;return e.scheme===C.Schemas.file?i=P.URI.file(B.$ic(d(e))).path:i=B.$hc.normalize(e.path),e.with({path:i})}relativePath(e,i){if(e.scheme!==i.scheme||!(0,t.$bh)(e.authority,i.authority))return;if(e.scheme===C.Schemas.file){const f=B.$mc(d(e),d(i));return H.$i?n.$og(f):f}let o=e.path||"/";const l=i.path||"/";if(this.a(e)){let f=0;for(const S=Math.min(o.length,l.length);f<S&&!(o.charCodeAt(f)!==l.charCodeAt(f)&&o.charAt(f).toLowerCase()!==l.charAt(f).toLowerCase());f++);o=l.substr(0,f)+o.substr(f)}return B.$hc.relative(o,l)}resolvePath(e,i){if(e.scheme===C.Schemas.file){const o=P.URI.file(B.$lc(d(e),i));return e.with({authority:o.authority,path:o.path})}return i=n.$pg(i),e.with({path:B.$hc.resolve(e.path,i)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,i){return e===i||e!==void 0&&i!==void 0&&(0,A.$xf)(e,i)}hasTrailingPathSeparator(e,i=B.sep){if(e.scheme===C.Schemas.file){const o=d(e);return o.length>n.$qg(o).length&&o[o.length-1]===i}else{const o=e.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=B.sep){return(0,t.$ch)(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,i=B.sep){let o=!1;if(e.scheme===C.Schemas.file){const l=d(e);o=l!==void 0&&l.length===n.$qg(l).length&&l[l.length-1]===i}else{i="/";const l=e.path;o=l.length===1&&l.charCodeAt(l.length-1)===47}return!o&&!(0,t.$ch)(e,i)?e.with({path:e.path+"/"}):e}}t.$Xg=g,t.$Yg=new g(()=>!1),t.$Zg=new g(h=>h.scheme===C.Schemas.file?!H.$k:!0),t.$1g=new g(h=>!0),t.$2g=t.$Yg.isEqual.bind(t.$Yg),t.$3g=t.$Yg.isEqualOrParent.bind(t.$Yg),t.$4g=t.$Yg.getComparisonKey.bind(t.$Yg),t.$5g=t.$Yg.basenameOrAuthority.bind(t.$Yg),t.$6g=t.$Yg.basename.bind(t.$Yg),t.$7g=t.$Yg.extname.bind(t.$Yg),t.$8g=t.$Yg.dirname.bind(t.$Yg),t.$9g=t.$Yg.joinPath.bind(t.$Yg),t.$0g=t.$Yg.normalizePath.bind(t.$Yg),t.$$g=t.$Yg.relativePath.bind(t.$Yg),t.$_g=t.$Yg.resolvePath.bind(t.$Yg),t.$ah=t.$Yg.isAbsolutePath.bind(t.$Yg),t.$bh=t.$Yg.isEqualAuthority.bind(t.$Yg),t.$ch=t.$Yg.hasTrailingPathSeparator.bind(t.$Yg),t.$dh=t.$Yg.removeTrailingPathSeparator.bind(t.$Yg),t.$eh=t.$Yg.addTrailingPathSeparator.bind(t.$Yg);function w(h,e){const i=[];for(let o=0;o<h.length;o++){const l=e(h[o]);h.some((f,S)=>S===o?!1:(0,t.$3g)(l,e(f)))||i.push(h[o])}return i}var M;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function e(i){const o=new Map;i.path.substring(i.path.indexOf(";")+1,i.path.lastIndexOf(";")).split(";").forEach(S=>{const[m,b]=S.split(":");m&&b&&o.set(m,b)});const f=i.path.substring(0,i.path.indexOf(";"));return f&&o.set(h.META_DATA_MIME,f),o}h.parseMetaData=e})(M||(t.DataUri=M={}));function c(h,e,i){if(e){let o=h.path;return o&&o[0]!==B.$hc.sep&&(o=B.$hc.sep+o),h.with({scheme:i,authority:e,path:o})}return h.with({scheme:i})}}),define(me[11],be([1,0,34,6,3,2,47,5,60,23]),function(se,t,n,C,B,H,A,P,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Yh=t.$Wh=t.$Vh=t.$Uh=t.$Th=t.Promises=t.$Sh=t.$Rh=t.$Qh=t.$Oh=t.$Nh=t.$Mh=t.$Lh=t.$Kh=t.$Jh=t.$Ih=t.$Hh=t.$Gh=t.$Fh=t.$Eh=t.$Dh=t.$Ch=t.$Bh=t.$vh=t.$uh=t.$th=t.$sh=t.$rh=t.$qh=t.$ph=void 0,t.$hh=w,t.$ih=M,t.$jh=c,t.$kh=h,t.$lh=e,t.$mh=i,t.$nh=o,t.$oh=l,t.$wh=q,t.$xh=$,t.$yh=I,t.$zh=V,t.$Ah=N,t.$Ph=_,t.$Xh=z;function w(y){return!!y&&typeof y.then=="function"}function M(y){const a=new n.$pe,v=y(a.token),F=new Promise((s,E)=>{const p=a.token.onCancellationRequested(()=>{p.dispose(),E(new C.$5)});Promise.resolve(v).then(R=>{p.dispose(),a.dispose(),s(R)},R=>{p.dispose(),a.dispose(),E(R)})});return new class{cancel(){a.cancel(),a.dispose()}then(s,E){return F.then(s,E)}catch(s){return this.then(void 0,s)}finally(s){return F.finally(s)}}}function c(y,a,v){return new Promise((F,s)=>{const E=a.onCancellationRequested(()=>{E.dispose(),F(v)});y.then(F,s).finally(()=>E.dispose())})}function h(y,a){return new Promise((v,F)=>{const s=a.onCancellationRequested(()=>{s.dispose(),F(new C.$5)});y.then(v,F).finally(()=>s.dispose())})}async function e(y){let a=-1;const v=y.map((F,s)=>F.then(E=>(a=s,E)));try{return await Promise.race(v)}finally{y.forEach((F,s)=>{s!==a&&F.cancel()})}}function i(y,a,v){let F;const s=setTimeout(()=>{F?.(void 0),v?.()},a);return Promise.race([y.finally(()=>clearTimeout(s)),new Promise(E=>F=E)])}function o(y){return new Promise((a,v)=>{const F=y();w(F)?F.then(a,v):a(F)})}function l(){let y,a;return{promise:new Promise((F,s)=>{y=F,a=s}),resolve:y,reject:a}}class f{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(a){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=a,!this.b){const v=()=>{if(this.b=null,this.f)return;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(v,v).then(F)})}return new Promise((v,F)=>{this.b.then(v,F)})}return this.a=a(),new Promise((v,F)=>{this.a.then(s=>{this.a=null,v(s)},s=>{this.a=null,F(s)})})}dispose(){this.f=!0}}t.$ph=f;class S{constructor(){this.a=Promise.resolve(null)}queue(a){return this.a=this.a.then(()=>a(),()=>a())}}t.$qh=S;class m{constructor(){this.a=new Map}queue(a,v){const s=(this.a.get(a)??Promise.resolve()).catch(()=>{}).then(v).finally(()=>{this.a.get(a)===s&&this.a.delete(a)});return this.a.set(a,s),s}}t.$rh=m;const b=(y,a)=>{let v=!0;const F=setTimeout(()=>{v=!1,a()},y);return{isTriggered:()=>v,dispose:()=>{clearTimeout(F),v=!1}}},r=y=>{let a=!0;return queueMicrotask(()=>{a&&(a=!1,y())}),{isTriggered:()=>a,dispose:()=>{a=!1}}};class D{constructor(a){this.defaultDelay=a,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(a,v=this.defaultDelay){this.g=a,this.h(),this.b||(this.b=new Promise((s,E)=>{this.d=s,this.f=E}).then(()=>{if(this.b=null,this.d=null,this.g){const s=this.g;return this.g=null,s()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=v===d.$be?r(F):b(v,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new C.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.$sh=D;class k{constructor(a){this.a=new D(a),this.b=new f}trigger(a,v){return this.a.trigger(()=>this.b.queue(a),v)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}t.$th=k;class T{constructor(){this.a=!1,this.b=new Promise((a,v)=>{this.d=a})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.$uh=T;class L extends T{constructor(a){super(),this.f=setTimeout(()=>this.open(),a)}open(){clearTimeout(this.f),super.open()}}t.$vh=L;function q(y,a){return a?new Promise((v,F)=>{const s=setTimeout(()=>{E.dispose(),v()},y),E=a.onCancellationRequested(()=>{clearTimeout(s),E.dispose(),F(new C.$5)})}):M(v=>q(y,v))}function $(y,a=0,v){const F=setTimeout(()=>{y(),v&&s.dispose()},a),s=(0,H.$Tc)(()=>{clearTimeout(F),v?.deleteAndLeak(s)});return v?.add(s),s}function I(y){const a=[];let v=0;const F=y.length;function s(){return v<F?y[v++]():null}function E(p){p!=null&&a.push(p);const R=s();return R?R.then(E):Promise.resolve(a)}return Promise.resolve(null).then(E)}function V(y,a=F=>!!F,v=null){let F=0;const s=y.length,E=()=>{if(F>=s)return Promise.resolve(v);const p=y[F++];return Promise.resolve(p()).then(O=>a(O)?Promise.resolve(O):E())};return E()}function N(y,a=F=>!!F,v=null){if(y.length===0)return Promise.resolve(v);let F=y.length;const s=()=>{F=-1;for(const E of y)E.cancel?.()};return new Promise((E,p)=>{for(const R of y)R.then(O=>{--F>=0&&a(O)?(s(),E(O)):F===0&&E(v)}).catch(O=>{--F>=0&&(s(),p(O))})})}class x{constructor(a){this.a=0,this.b=!1,this.f=a,this.g=[],this.d=0,this.h=new B.$ee}whenIdle(){return this.size>0?B.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(a){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((v,F)=>{this.g.push({factory:a,c:v,e:F}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const a=this.g.shift();this.d++;const v=a.factory();v.then(a.c,a.e),v.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}t.$Bh=x;class j extends x{constructor(){super(1)}}t.$Ch=j;class Y{constructor(){this.a=new ue,this.b=0}queue(a){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,a())):this.a.run(this.b++,a())}}t.$Dh=Y;class K{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const a=new W;return this.b.add(a),a.p}g(){for(const[,a]of this.a)if(a.size>0)return!1;return!0}queueSize(a,v=A.$Yg){const F=v.getComparisonKey(a);return this.a.get(F)?.size??0}queueFor(a,v,F=A.$Yg){const s=F.getComparisonKey(a);let E=this.a.get(s);if(!E){E=new j;const p=this.f++,R=B.Event.once(E.onDrained)(()=>{E?.dispose(),this.a.delete(s),this.h(),this.d?.deleteAndDispose(p),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new H.$5c),this.d.set(p,R),this.a.set(s,E)}return E.queue(v)}h(){this.g()&&this.j()}j(){for(const a of this.b)a.complete();this.b.clear()}dispose(){for(const[,a]of this.a)a.dispose();this.a.clear(),this.j(),this.d?.dispose()}}t.$Eh=K;class ae{constructor(a,v){this.a=-1,typeof a=="function"&&typeof v=="number"&&this.setIfNotSet(a,v)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(a,v){this.cancel(),this.a=setTimeout(()=>{this.a=-1,a()},v)}setIfNotSet(a,v){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,a()},v))}}t.$Fh=ae;class ie{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(a,v,F=globalThis){this.cancel();const s=F.setInterval(()=>{a()},v);this.d=(0,H.$Tc)(()=>{F.clearInterval(s),this.d=void 0})}dispose(){this.cancel()}}t.$Gh=ie;class ee{constructor(a,v){this.b=-1,this.a=a,this.d=v,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(a=this.d){this.cancel(),this.b=setTimeout(this.f,a)}get delay(){return this.d}set delay(a){this.d=a}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.$Hh=ee;class ce{constructor(a,v){v%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${v}ms is not a multiple of 1000ms.`),this.a=a,this.b=v,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(a=this.b){a%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${a}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(a/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.$Ih=ce;class De extends ee{constructor(a,v){super(a,v),this.j=[]}work(a){this.j.push(a),this.isScheduled()||this.schedule()}h(){const a=this.j;this.j=[],this.a?.(a)}dispose(){this.j=[],super.dispose()}}t.$Jh=De;class Ee extends H.$Vc{constructor(a,v){super(),this.g=a,this.h=v,this.a=[],this.b=this.B(new H.$Wc),this.f=!1}get pending(){return this.a.length}work(a){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+a.length>this.g.maxBufferedWork)return!1}else if(this.pending+a.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const v of a)this.a.push(v);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.$Kh=Ee,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?t.$Mh=(y,a)=>{(0,P.$B)(()=>{if(v)return;const F=Date.now()+15;a(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let v=!1;return{dispose(){v||(v=!0)}}}:t.$Mh=(y,a,v)=>{const F=y.requestIdleCallback(a,typeof v=="number"?{timeout:v}:void 0);let s=!1;return{dispose(){s||(s=!0,y.cancelIdleCallback(F))}}},t.$Lh=y=>(0,t.$Mh)(globalThis,y)}();class Le{constructor(a,v){this.g=!1,this.d=()=>{try{this.j=v()}catch(F){this.l=F}finally{this.g=!0}},this.f=(0,t.$Mh)(a,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}t.$Nh=Le;class le extends Le{constructor(a){super(globalThis,a)}}t.$Oh=le;async function _(y,a,v){let F;for(let s=0;s<v;s++)try{return await y()}catch(E){F=E,await q(a)}throw F}class ue{isRunning(a){return typeof a=="number"?this.a?.taskId===a:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(a,v,F){return this.a={taskId:a,cancel:()=>F?.(),promise:v},v.then(()=>this.d(a),()=>this.d(a)),v}d(a){this.a&&a===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const a=this.b;this.b=void 0,a.run().then(a.promiseResolve,a.promiseReject)}}queue(a){if(this.b)this.b.run=a;else{const{promise:v,resolve:F,reject:s}=l();this.b={run:a,promise:v,promiseResolve:F,promiseReject:s}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.$Qh=ue;class re{constructor(a,v=()=>Date.now()){this.d=a,this.f=v,this.a=0,this.b=0}increment(){const a=this.f();return a-this.a>this.d&&(this.a=a,this.b=0),this.b++,this.b}}t.$Rh=re;var ye;(function(y){y[y.Resolved=0]="Resolved",y[y.Rejected=1]="Rejected"})(ye||(ye={}));class W{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((a,v)=>{this.a=a,this.b=v})}complete(a){return new Promise(v=>{this.a(a),this.d={outcome:0,value:a},v()})}error(a){return new Promise(v=>{this.b(a),this.d={outcome:1,value:a},v()})}cancel(){return this.error(new C.$5)}}t.$Sh=W;var Q;(function(y){async function a(F){let s;const E=await Promise.all(F.map(p=>p.then(R=>R,R=>{s||(s=R)})));if(typeof s<"u")throw s;return E}y.settled=a;function v(F){return new Promise(async(s,E)=>{try{await F(s,E)}catch(p){E(p)}})}y.withAsyncBody=v})(Q||(t.Promises=Q={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(a){this.a=void 0,this.b=void 0,this.d=!1,this.promise=a.then(v=>(this.a=v,this.d=!0,v),v=>{throw this.b=v,this.d=!0,v})}requireValue(){if(!this.d)throw new C.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}t.$Th=ge;class we{constructor(a){this.b=a,this.a=new g.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}t.$Uh=we;var ke;(function(y){y[y.Initial=0]="Initial",y[y.DoneOK=1]="DoneOK",y[y.DoneError=2]="DoneError"})(ke||(ke={}));class Te{static fromArray(a){return new Te(v=>{v.emitMany(a)})}static fromPromise(a){return new Te(async v=>{v.emitMany(await a)})}static fromPromises(a){return new Te(async v=>{await Promise.all(a.map(async F=>v.emitOne(await F)))})}static merge(a){return new Te(async v=>{await Promise.all(a.map(async F=>{for await(const s of F)v.emitOne(s)}))})}static{this.EMPTY=Te.fromArray([])}constructor(a,v){this.a=0,this.b=[],this.d=null,this.f=v,this.g=new B.$ee,queueMicrotask(async()=>{const F={emitOne:s=>this.h(s),emitMany:s=>this.j(s),reject:s=>this.l(s)};try{await Promise.resolve(a(F)),this.k()}catch(s){this.l(s)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let a=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(a<this.b.length)return{done:!1,value:this.b[a++]};if(this.a===1)return{done:!0,value:void 0};await B.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(a,v){return new Te(async F=>{for await(const s of a)F.emitOne(v(s))})}map(a){return Te.map(this,a)}static filter(a,v){return new Te(async F=>{for await(const s of a)v(s)&&F.emitOne(s)})}filter(a){return Te.filter(this,a)}static coalesce(a){return Te.filter(a,v=>!!v)}coalesce(){return Te.coalesce(this)}static async toPromise(a){const v=[];for await(const F of a)v.push(F);return v}toPromise(){return Te.toPromise(this)}h(a){this.a===0&&(this.b.push(a),this.g.fire())}j(a){this.a===0&&(this.b=this.b.concat(a),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(a){this.a===0&&(this.a=2,this.d=a,this.g.fire())}}t.$Vh=Te;class Ie extends Te{constructor(a,v){super(v),this.m=a}cancel(){this.m.cancel()}}t.$Wh=Ie;function z(y){const a=new n.$pe,v=y(a.token);return new Ie(a,async F=>{const s=a.token.onCancellationRequested(()=>{s.dispose(),a.dispose(),F.reject(new C.$5)});try{for await(const E of v){if(a.token.isCancellationRequested)return;F.emitOne(E)}s.dispose(),a.dispose()}catch(E){s.dispose(),a.dispose(),F.reject(E)}})}class u{constructor(a){this.a=new W,this.b=new Te(s=>{if(v){s.reject(v);return}return F&&s.emitMany(F),this.d=E=>s.reject(E),this.f=E=>s.emitOne(E),this.a.p},a);let v,F;this.f=s=>{F||(F=[]),F.push(s)},this.d=s=>{v||(v=s)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(a){this.d(a),this.a.complete()}emitOne(a){this.f(a)}}t.$Yh=u}),define(me[4],be([1,0,17,125,15,20,11,6,3,129,2,36,5,16,59,22]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.$eT=t.$cT=t.$_S=t.DetectedFullscreenMode=t.Namespace=t.$JS=t.$HS=t.$yS=t.$7R=t.$1R=t.$YR=t.$XR=t.$WR=t.$RR=t.$QR=t.$PR=t.onDidUnregisterWindow=t.onWillUnregisterWindow=t.onDidRegisterWindow=t.hasWindow=t.getWindowById=t.getWindowId=t.getWindowsCount=t.getWindows=t.getDocument=t.getWindow=t.registerWindow=void 0,t.$NR=l,t.$OR=S,t.$SR=T,t.$TR=L,t.$UR=q,t.$VR=$,t.$ZR=V,t.$2R=j,t.$3R=Y,t.$4R=ee,t.$5R=ce,t.$6R=De,t.$8R=le,t.$9R=_,t.$0R=ue,t.$$R=re,t.$_R=ye,t.$aS=W,t.$bS=Q,t.$cS=ge,t.$dS=we,t.$eS=ke,t.$fS=Ie,t.$gS=z,t.$hS=y,t.$iS=v,t.$jS=F,t.$kS=s,t.$lS=E,t.$mS=p,t.$nS=R,t.$oS=O,t.$pS=U,t.$qS=Z,t.$rS=oe,t.$sS=pe,t.$tS=fe,t.$uS=Pe,t.$vS=je,t.$wS=Ce,t.$xS=We,t.$zS=Ue,t.$AS=_e,t.$BS=Ne,t.$CS=ze,t.$DS=et,t.$ES=it,t.$FS=st,t.$GS=Qe,t.$IS=rt,t.$KS=tt,t.$LS=mt,t.$MS=At,t.$NS=kt,t.$OS=Pt,t.$PS=Be,t.$QS=he,t.$=nt,t.$SS=lt,t.$TS=Je,t.$US=ut,t.$VS=$t,t.$WS=Xt,t.$XS=Si,t.$YS=Ai,t.$ZS=ki,t.$1S=Pi,t.$2S=Ti,t.$3S=Ci,t.$4S=Fi,t.$5S=Ni,t.$6S=Ri,t.$7S=Qt,t.$8S=Li,t.$9S=Ii,t.$0S=Oi,t.$$S=_t,t.$aT=Bi,t.$bT=zi,t.$dT=Hi,t.h=qi,t.$gT=ti,t.$hT=Gi,o=function(){const G=new Map;(0,i.$hR)(i.$iR,1);const X={window:i.$iR,disposables:new w.$Uc};G.set(i.$iR.vscodeWindowId,X);const te=new d.$ee,de=new d.$ee,Ae=new d.$ee;function xe(Me,qe){return(typeof Me=="number"?G.get(Me):void 0)??(qe?X:void 0)}return{onDidRegisterWindow:te.event,onWillUnregisterWindow:Ae.event,onDidUnregisterWindow:de.event,registerWindow(Me){if(G.has(Me.vscodeWindowId))return w.$Vc.None;const qe=new w.$Uc,Ke={window:Me,disposables:qe.add(new w.$Uc)};return G.set(Me.vscodeWindowId,Ke),qe.add((0,w.$Tc)(()=>{G.delete(Me.vscodeWindowId),de.fire(Me)})),qe.add(S(Me,t.$HS.BEFORE_UNLOAD,()=>{Ae.fire(Me)})),te.fire(Ke),qe},getWindows(){return G.values()},getWindowsCount(){return G.size},getWindowId(Me){return Me.vscodeWindowId},hasWindow(Me){return G.has(Me)},getWindowById:xe,getWindow(Me){const qe=Me;if(qe?.ownerDocument?.defaultView)return qe.ownerDocument.defaultView.window;const Ke=Me;return Ke?.view?Ke.view.window:i.$iR},getDocument(Me){const qe=Me;return(0,t.getWindow)(qe).document}}}(),t.registerWindow=o.registerWindow,t.getWindow=o.getWindow,t.getDocument=o.getDocument,t.getWindows=o.getWindows,t.getWindowsCount=o.getWindowsCount,t.getWindowId=o.getWindowId,t.getWindowById=o.getWindowById,t.hasWindow=o.hasWindow,t.onDidRegisterWindow=o.onDidRegisterWindow,t.onWillUnregisterWindow=o.onWillUnregisterWindow,t.onDidUnregisterWindow=o.onDidUnregisterWindow;function l(G){for(;G.firstChild;)G.firstChild.remove()}class f{constructor(X,te,de,Ae){this.f=X,this.g=te,this.d=de,this.j=Ae||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function S(G,X,te,de){return new f(G,X,te,de)}function m(G,X){return function(te){return X(new H.$GR(G,te))}}function b(G){return function(X){return G(new B.$LR(X))}}const r=function(X,te,de,Ae){let xe=de;return te==="click"||te==="mousedown"?xe=m((0,t.getWindow)(X),de):(te==="keydown"||te==="keypress"||te==="keyup")&&(xe=b(de)),S(X,te,xe,Ae)};t.$PR=r;const D=function(X,te,de){const Ae=m((0,t.getWindow)(X),te);return T(X,Ae,de)};t.$QR=D;const k=function(X,te,de){const Ae=m((0,t.getWindow)(X),te);return q(X,Ae,de)};t.$RR=k;function T(G,X,te){return S(G,c.$r&&C.$DR.pointerEvents?t.$HS.POINTER_DOWN:t.$HS.MOUSE_DOWN,X,te)}function L(G,X,te){return S(G,c.$r&&C.$DR.pointerEvents?t.$HS.POINTER_MOVE:t.$HS.MOUSE_MOVE,X,te)}function q(G,X,te){return S(G,c.$r&&C.$DR.pointerEvents?t.$HS.POINTER_UP:t.$HS.MOUSE_UP,X,te)}function $(G,X,te){return(0,A.$Mh)(G,X,te)}class I extends A.$Nh{constructor(X,te){super(X,te)}}t.$WR=I;function V(G,X,te,de){let Ae=0;const xe=G.setInterval(()=>{Ae++,(typeof de=="number"&&Ae>=de||X()===!0)&&Me.dispose()},te),Me=(0,w.$Tc)(()=>{G.clearInterval(xe)});return Me}class N extends A.$Gh{constructor(X){super(),this.f=X&&(0,t.getWindow)(X)}cancelAndSet(X,te,de){return super.cancelAndSet(X,te,de??this.f)}}t.$1R=N;class x{constructor(X,te=0){this.d=X,this.priority=te,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(X){(0,P.$1)(X)}}static sort(X,te){return te.priority-X.priority}}(function(){const G=new Map,X=new Map,te=new Map,de=new Map,Ae=xe=>{te.set(xe,!1);const Me=G.get(xe)??[];for(X.set(xe,Me),G.set(xe,[]),de.set(xe,!0);Me.length>0;)Me.sort(x.sort),Me.shift().execute();de.set(xe,!1)};t.$YR=(xe,Me,qe=0)=>{const Ke=(0,t.getWindowId)(xe),Ye=new x(Me,qe);let at=G.get(Ke);return at||(at=[],G.set(Ke,at)),at.push(Ye),te.get(Ke)||(te.set(Ke,!0),xe.requestAnimationFrame(()=>Ae(Ke))),Ye},t.$XR=(xe,Me,qe)=>{const Ke=(0,t.getWindowId)(xe);if(de.get(Ke)){const Ye=new x(Me,qe);let at=X.get(Ke);return at||(at=[],X.set(Ke,at)),at.push(Ye),Ye}else return(0,t.$YR)(xe,Me,qe)}})();function j(G,X){return(0,t.$YR)(G,X,1e4)}function Y(G,X){return(0,t.$YR)(G,X,-1e4)}const K=8,ae=function(G,X){return X};class ie extends w.$Vc{constructor(X,te,de,Ae=ae,xe=K){super();let Me=null,qe=0;const Ke=this.B(new A.$Fh),Ye=()=>{qe=new Date().getTime(),de(Me),Me=null};this.B(S(X,te,at=>{Me=Ae(Me,at);const Ct=new Date().getTime()-qe;Ct>=xe?(Ke.cancel(),Ye()):Ke.setIfNotSet(Ye,xe-Ct)}))}}function ee(G,X,te,de,Ae){return new ie(G,X,te,de,Ae)}function ce(G){return(0,t.getWindow)(G).getComputedStyle(G,null)}function De(G,X){const te=(0,t.getWindow)(G),de=te.document;if(G!==de.body)return new Le(G.clientWidth,G.clientHeight);if(c.$r&&te?.visualViewport)return new Le(te.visualViewport.width,te.visualViewport.height);if(te?.innerWidth&&te.innerHeight)return new Le(te.innerWidth,te.innerHeight);if(de.body&&de.body.clientWidth&&de.body.clientHeight)return new Le(de.body.clientWidth,de.body.clientHeight);if(de.documentElement&&de.documentElement.clientWidth&&de.documentElement.clientHeight)return new Le(de.documentElement.clientWidth,de.documentElement.clientHeight);if(X)return De(X);throw new Error("Unable to figure out browser width and height")}class Ee{static d(X,te){return parseFloat(te)||0}static f(X,te,de){const Ae=ce(X),xe=Ae?Ae.getPropertyValue(te):"0";return Ee.d(X,xe)}static getBorderLeftWidth(X){return Ee.f(X,"border-left-width","borderLeftWidth")}static getBorderRightWidth(X){return Ee.f(X,"border-right-width","borderRightWidth")}static getBorderTopWidth(X){return Ee.f(X,"border-top-width","borderTopWidth")}static getBorderBottomWidth(X){return Ee.f(X,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(X){return Ee.f(X,"padding-left","paddingLeft")}static getPaddingRight(X){return Ee.f(X,"padding-right","paddingRight")}static getPaddingTop(X){return Ee.f(X,"padding-top","paddingTop")}static getPaddingBottom(X){return Ee.f(X,"padding-bottom","paddingBottom")}static getMarginLeft(X){return Ee.f(X,"margin-left","marginLeft")}static getMarginTop(X){return Ee.f(X,"margin-top","marginTop")}static getMarginRight(X){return Ee.f(X,"margin-right","marginRight")}static getMarginBottom(X){return Ee.f(X,"margin-bottom","marginBottom")}}class Le{static{this.None=new Le(0,0)}constructor(X,te){this.width=X,this.height=te}with(X=this.width,te=this.height){return X!==this.width||te!==this.height?new Le(X,te):this}static is(X){return typeof X=="object"&&typeof X.height=="number"&&typeof X.width=="number"}static lift(X){return X instanceof Le?X:new Le(X.width,X.height)}static equals(X,te){return X===te?!0:!X||!te?!1:X.width===te.width&&X.height===te.height}}t.$7R=Le;function le(G){let X=G.offsetParent,te=G.offsetTop,de=G.offsetLeft;for(;(G=G.parentNode)!==null&&G!==G.ownerDocument.body&&G!==G.ownerDocument.documentElement;){te-=G.scrollTop;const Ae=E(G)?null:ce(G);Ae&&(de-=Ae.direction!=="rtl"?G.scrollLeft:-G.scrollLeft),G===X&&(de+=Ee.getBorderLeftWidth(G),te+=Ee.getBorderTopWidth(G),te+=G.offsetTop,de+=G.offsetLeft,X=G.offsetParent)}return{left:de,top:te}}function _(G,X,te){typeof X=="number"&&(G.style.width=`${X}px`),typeof te=="number"&&(G.style.height=`${te}px`)}function ue(G,X,te,de,Ae,xe="absolute"){typeof X=="number"&&(G.style.top=`${X}px`),typeof te=="number"&&(G.style.right=`${te}px`),typeof de=="number"&&(G.style.bottom=`${de}px`),typeof Ae=="number"&&(G.style.left=`${Ae}px`),G.style.position=xe}function re(G){const X=G.getBoundingClientRect(),te=(0,t.getWindow)(G);return{left:X.left+te.scrollX,top:X.top+te.scrollY,width:X.width,height:X.height}}function ye(G){let X=G,te=1;do{const de=ce(X).zoom;de!=null&&de!=="1"&&(te*=de),X=X.parentElement}while(X!==null&&X!==X.ownerDocument.documentElement);return te}function W(G){const X=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.offsetWidth+X}function Q(G){const X=Ee.getBorderLeftWidth(G)+Ee.getBorderRightWidth(G),te=Ee.getPaddingLeft(G)+Ee.getPaddingRight(G);return G.offsetWidth-X-te}function ge(G){const X=Ee.getMarginLeft(G)+Ee.getMarginRight(G);return G.scrollWidth+X}function we(G){const X=Ee.getBorderTopWidth(G)+Ee.getBorderBottomWidth(G),te=Ee.getPaddingTop(G)+Ee.getPaddingBottom(G);return G.offsetHeight-X-te}function ke(G){const X=Ee.getMarginTop(G)+Ee.getMarginBottom(G);return G.offsetHeight+X}function Te(G,X){if(G===null)return 0;const te=le(G),de=le(X);return te.left-de.left}function Ie(G,X){const te=X.map(Ae=>Math.max(ge(Ae),W(Ae))+Te(Ae,G)||0);return Math.max(...te)}function z(G,X){return!!X?.contains(G)}const u="parentFlowToElementId";function y(G,X){G.dataset[u]=X.id}function a(G){const X=G.dataset[u];return typeof X=="string"?G.ownerDocument.getElementById(X):null}function v(G,X){let te=G;for(;te;){if(te===X)return!0;if(te instanceof HTMLElement){const de=a(te);if(de){te=de;continue}}te=te.parentNode}return!1}function F(G,X,te){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G.classList.contains(X))return G;if(te){if(typeof te=="string"){if(G.classList.contains(te))return null}else if(G===te)return null}G=G.parentNode}return null}function s(G,X,te){return!!F(G,X,te)}function E(G){return G&&!!G.host&&!!G.mode}function p(G){return!!R(G)}function R(G){for(;G.parentNode;){if(G===G.ownerDocument?.body)return null;G=G.parentNode}return E(G)?G:null}function O(){let G=pe().activeElement;for(;G?.shadowRoot;)G=G.shadowRoot.activeElement;return G}function U(G){return O()===G}function Z(G){return z(O(),G)}function oe(G){return G.ownerDocument===pe()}function pe(){return(0,t.getWindowsCount)()<=1?i.$iR.document:Array.from((0,t.getWindows)()).map(({window:X})=>X.document).find(X=>X.hasFocus())??i.$iR.document}function fe(){return pe().defaultView?.window??i.$iR}const Re=new Map;function Pe(G){return Re.has(G)}function je(){return new Se}class Se{constructor(){this.d="",this.f=void 0}setStyle(X){X!==this.d&&(this.d=X,this.f?this.f.innerText=X:this.f=Ce(i.$iR.document.head,te=>te.innerText=X))}dispose(){this.f&&(this.f.remove(),this.f=void 0)}}function Ce(G=i.$iR.document.head,X,te){const de=document.createElement("style");if(de.type="text/css",de.media="screen",X?.(de),G.appendChild(de),te&&te.add((0,w.$Tc)(()=>G.removeChild(de))),G===i.$iR.document.head){const Ae=new Set;Re.set(de,Ae);for(const{window:xe,disposables:Me}of(0,t.getWindows)()){if(xe===i.$iR)continue;const qe=Me.add(Xe(de,Ae,xe));te?.add(qe)}}return de}function We(G){const X=new w.$Uc;for(const[te,de]of Re)X.add(Xe(te,de,G));return X}function Xe(G,X,te){const de=new w.$Uc,Ae=G.cloneNode(!0);te.document.head.appendChild(Ae),de.add((0,w.$Tc)(()=>te.document.head.removeChild(Ae)));for(const xe of ve(G))Ae.sheet?.insertRule(xe.cssText,Ae.sheet?.cssRules.length);return de.add(t.$yS.observe(G,de,{childList:!0})(()=>{Ae.textContent=G.textContent})),X.add(Ae),de.add((0,w.$Tc)(()=>X.delete(Ae))),de}t.$yS=new class{constructor(){this.mutationObservers=new Map}observe(G,X,te){let de=this.mutationObservers.get(G);de||(de=new Map,this.mutationObservers.set(G,de));const Ae=(0,e.$jj)(te);let xe=de.get(Ae);if(xe)xe.users+=1;else{const Me=new d.$ee,qe=new MutationObserver(Ye=>Me.fire(Ye));qe.observe(G,te);const Ke=xe={users:1,observer:qe,onDidMutate:Me.event};X.add((0,w.$Tc)(()=>{Ke.users-=1,Ke.users===0&&(Me.dispose(),qe.disconnect(),de?.delete(Ae),de?.size===0&&this.mutationObservers.delete(G))})),de.set(Ae,xe)}return xe.onDidMutate}};function Ue(G=i.$iR.document.head){return J("meta",G)}function _e(G=i.$iR.document.head){return J("link",G)}function J(G,X=i.$iR.document.head){const te=document.createElement(G);return X.appendChild(te),te}let ne=null;function $e(){return ne||(ne=Ce()),ne}function ve(G){return G?.sheet?.rules?G.sheet.rules:G?.sheet?.cssRules?G.sheet.cssRules:[]}function Ne(G,X,te=$e()){if(!(!te||!X)){te.sheet?.insertRule(`${G} {${X}}`,0);for(const de of Re.get(te)??[])Ne(G,X,de)}}function ze(G,X=$e()){if(!X)return;const te=ve(X),de=[];for(let Ae=0;Ae<te.length;Ae++){const xe=te[Ae];Ve(xe)&&xe.selectorText.indexOf(G)!==-1&&de.push(Ae)}for(let Ae=de.length-1;Ae>=0;Ae--)X.sheet?.deleteRule(de[Ae]);for(const Ae of Re.get(X)??[])ze(G,Ae)}function Ve(G){return typeof G.selectorText=="string"}function et(G){return G instanceof MouseEvent||G instanceof(0,t.getWindow)(G).MouseEvent}function it(G){return G instanceof KeyboardEvent||G instanceof(0,t.getWindow)(G).KeyboardEvent}function st(G){return G instanceof PointerEvent||G instanceof(0,t.getWindow)(G).PointerEvent}function Qe(G){return G instanceof DragEvent||G instanceof(0,t.getWindow)(G).DragEvent}t.$HS={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",PASTE:"paste",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:n.$vR?"webkitAnimationStart":"animationstart",ANIMATION_END:n.$vR?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:n.$vR?"webkitAnimationIteration":"animationiteration"};function rt(G){const X=G;return!!(X&&typeof X.preventDefault=="function"&&typeof X.stopPropagation=="function")}t.$JS={stop:(G,X)=>(G.preventDefault(),X&&G.stopPropagation(),G)};function tt(G){const X=[];for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)X[te]=G.scrollTop,G=G.parentNode;return X}function mt(G,X){for(let te=0;G&&G.nodeType===G.ELEMENT_NODE;te++)G.scrollTop!==X[te]&&(G.scrollTop=X[te]),G=G.parentNode}class gt extends w.$Vc{static m(X){if(X instanceof HTMLElement){const te=R(X),de=te?te.activeElement:X.ownerDocument.activeElement;return z(de,X)}else{const te=X;return z(te.document.activeElement,te.document)}}constructor(X){super(),this.f=this.B(new d.$ee),this.onDidFocus=this.f.event,this.g=this.B(new d.$ee),this.onDidBlur=this.g.event;let te=gt.m(X),de=!1;const Ae=()=>{de=!1,te||(te=!0,this.f.fire())},xe=()=>{te&&(de=!0,(X instanceof HTMLElement?(0,t.getWindow)(X):X).setTimeout(()=>{de&&(de=!1,te=!1,this.g.fire())},0))};this.j=()=>{gt.m(X)!==te&&(te?xe():Ae())},this.B(S(X,t.$HS.FOCUS,Ae,!0)),this.B(S(X,t.$HS.BLUR,xe,!0)),X instanceof HTMLElement&&(this.B(S(X,t.$HS.FOCUS_IN,()=>this.j())),this.B(S(X,t.$HS.FOCUS_OUT,()=>this.j())))}refreshState(){this.j()}}function At(G){return new gt(G)}function kt(G,X){return G.after(X),X}function Pt(G,...X){if(G.append(...X),X.length===1&&typeof X[0]!="string")return X[0]}function Be(G,X){return G.insertBefore(X,G.firstChild),X}function he(G,...X){G.innerText="",Pt(G,...X)}const Fe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var Oe;(function(G){G.HTML="http://www.w3.org/1999/xhtml",G.SVG="http://www.w3.org/2000/svg"})(Oe||(t.Namespace=Oe={}));function Ge(G,X,te,...de){const Ae=Fe.exec(X);if(!Ae)throw new Error("Bad use of emmet");const xe=Ae[1]||"div";let Me;return G!==Oe.HTML?Me=document.createElementNS(G,xe):Me=document.createElement(xe),Ae[3]&&(Me.id=Ae[3]),Ae[4]&&(Me.className=Ae[4].replace(/\./g," ").trim()),te&&Object.entries(te).forEach(([qe,Ke])=>{typeof Ke>"u"||(/^on\w+$/.test(qe)?Me[qe]=Ke:qe==="selected"?Ke&&Me.setAttribute(qe,"true"):Me.setAttribute(qe,Ke))}),Me.append(...de),Me}function nt(G,X,...te){return Ge(Oe.HTML,G,X,...te)}nt.SVG=function(G,X,...te){return Ge(Oe.SVG,G,X,...te)};function lt(G,X){const te=[];return G.forEach((de,Ae)=>{Ae>0&&(X instanceof Node?te.push(X.cloneNode()):te.push(document.createTextNode(X))),te.push(de)}),te}function Je(G,...X){G?ut(...X):$t(...X)}function ut(...G){for(const X of G)X.style.display="",X.removeAttribute("aria-hidden")}function $t(...G){for(const X of G)X.style.display="none",X.setAttribute("aria-hidden","true")}function Tt(G,X){for(;G&&G.nodeType===G.ELEMENT_NODE;){if(G instanceof HTMLElement&&G.hasAttribute(X))return G;G=G.parentNode}return null}function Xt(G){!G||!G.hasAttribute("tabIndex")||(G.ownerDocument.activeElement===G&&Tt(G.parentElement,"tabIndex")?.focus(),G.removeAttribute("tabindex"))}function Si(G){return X=>{X.preventDefault(),X.stopPropagation(),G(X)}}function Ai(G){return new Promise(X=>{if(G.document.readyState==="complete"||G.document&&G.document.body!==null)X(void 0);else{const de=()=>{G.window.removeEventListener("DOMContentLoaded",de,!1),X()};G.window.addEventListener("DOMContentLoaded",de,!1)}})}function ki(G,X){const te=G.devicePixelRatio*X;return Math.max(1,Math.floor(te))/G.devicePixelRatio}function Pi(G){i.$iR.open(G,"_blank","noopener")}const Jt=780,Zt=640;function Ti(G){const X=Math.floor(i.$iR.screenLeft+i.$iR.innerWidth/2-Jt/2),te=Math.floor(i.$iR.screenTop+i.$iR.innerHeight/2-Zt/2);i.$iR.open(G,"_blank",`width=${Jt},height=${Zt},top=${te},left=${X}`)}function Ci(G,X=!0){const te=i.$iR.open();return te?(X&&(te.opener=null),te.location.href=G,!0):!1}function Fi(G,X){const te=()=>{X(),de=(0,t.$YR)(G,te)};let de=(0,t.$YR)(G,te);return(0,w.$Tc)(()=>de.dispose())}M.$Ig.setPreferredWebSchema(/^https:/.test(i.$iR.location.href)?"https":"http");function Ni(G){return G?`url('${M.$Pg.uriToBrowserUri(G).toString(!0).replace(/'/g,"%27")}')`:"url('')"}function Ri(G){return`'${G.replace(/'/g,"%27")}'`}function Qt(G,X){if(G!==void 0){const te=G.match(/^\s*var\((.+)\)$/);if(te){const de=te[1].split(",",2);return de.length===2&&(X=Qt(de[1].trim(),X)),`var(${de[0]}, ${X})`}return G}return X}function Li(G,X){let te;if(h.URI.isUri(G))te=G.toString(!0);else{const xe=new Blob([G]);te=URL.createObjectURL(xe),setTimeout(()=>URL.revokeObjectURL(te))}const de=fe(),Ae=document.createElement("a");de.document.body.appendChild(Ae),Ae.download=X,Ae.href=te,Ae.click(),setTimeout(()=>de.document.body.removeChild(Ae))}function Ii(){return new Promise(G=>{const X=fe(),te=document.createElement("input");X.document.body.appendChild(te),te.type="file",te.multiple=!0,d.Event.once(d.Event.fromDOMEventEmitter(te,"input"))(()=>{G(te.files??void 0)}),te.click(),setTimeout(()=>X.document.body.removeChild(te))})}var yt;(function(G){G[G.DOCUMENT=1]="DOCUMENT",G[G.BROWSER=2]="BROWSER"})(yt||(t.DetectedFullscreenMode=yt={}));function Oi(G){return G.document.fullscreenElement||G.document.webkitFullscreenElement||G.document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:G.innerHeight===G.screen.height?{mode:yt.BROWSER,guess:!1}:(c.$j||c.$k)&&G.outerHeight===G.screen.height&&G.outerWidth===G.screen.width?{mode:yt.BROWSER,guess:!0}:null}function _t(G,X=!1){const te=document.createElement("a");return g.addHook("afterSanitizeAttributes",de=>{for(const Ae of["href","src"])if(de.hasAttribute(Ae)){const xe=de.getAttribute(Ae);if(Ae==="href"&&xe.startsWith("#"))continue;if(te.href=xe,!G.includes(te.protocol.replace(/:$/,""))){if(X&&Ae==="src"&&te.href.startsWith("data:"))continue;de.removeAttribute(Ae)}}}),(0,w.$Tc)(()=>{g.removeHook("afterSanitizeAttributes")})}const ji=[M.Schemas.http,M.Schemas.https,M.Schemas.command];t.$_S=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","input","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const Mi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function Bi(G,X){const te=_t(ji);try{const de=g.sanitize(X,Mi);G.innerHTML=de}finally{te.dispose()}}function xi(G){const X=new Uint16Array(G.length);for(let Ae=0;Ae<X.length;Ae++)X[Ae]=G.charCodeAt(Ae);let te="";const de=new Uint8Array(X.buffer);for(let Ae=0;Ae<de.length;Ae++)te+=String.fromCharCode(de[Ae]);return te}function zi(G){return btoa(xi(G))}class pt extends d.$ee{constructor(){super(),this.o=new w.$Uc,this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.o.add(d.Event.runAndSubscribe(t.onDidRegisterWindow,({window:X,disposables:te})=>this.C(X,te),{window:i.$iR,disposables:this.o}))}C(X,te){te.add(S(X,"keydown",de=>{if(de.defaultPrevented)return;const Ae=new B.$LR(de);if(!(Ae.keyCode===6&&de.repeat)){if(de.altKey&&!this.A.altKey)this.A.lastKeyPressed="alt";else if(de.ctrlKey&&!this.A.ctrlKey)this.A.lastKeyPressed="ctrl";else if(de.metaKey&&!this.A.metaKey)this.A.lastKeyPressed="meta";else if(de.shiftKey&&!this.A.shiftKey)this.A.lastKeyPressed="shift";else if(Ae.keyCode!==6)this.A.lastKeyPressed=void 0;else return;this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyPressed&&(this.A.event=de,this.fire(this.A))}},!0)),te.add(S(X,"keyup",de=>{de.defaultPrevented||(!de.altKey&&this.A.altKey?this.A.lastKeyReleased="alt":!de.ctrlKey&&this.A.ctrlKey?this.A.lastKeyReleased="ctrl":!de.metaKey&&this.A.metaKey?this.A.lastKeyReleased="meta":!de.shiftKey&&this.A.shiftKey?this.A.lastKeyReleased="shift":this.A.lastKeyReleased=void 0,this.A.lastKeyPressed!==this.A.lastKeyReleased&&(this.A.lastKeyPressed=void 0),this.A.altKey=de.altKey,this.A.ctrlKey=de.ctrlKey,this.A.metaKey=de.metaKey,this.A.shiftKey=de.shiftKey,this.A.lastKeyReleased&&(this.A.event=de,this.fire(this.A)))},!0)),te.add(S(X.document.body,"mousedown",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(S(X.document.body,"mouseup",()=>{this.A.lastKeyPressed=void 0},!0)),te.add(S(X.document.body,"mousemove",de=>{de.buttons&&(this.A.lastKeyPressed=void 0)},!0)),te.add(S(X,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.A}get isModifierPressed(){return this.A.altKey||this.A.ctrlKey||this.A.metaKey||this.A.shiftKey}resetKeyStatus(){this.D(),this.fire(this.A)}D(){this.A={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return pt.B||(pt.B=new pt),pt.B}dispose(){super.dispose(),this.o.dispose()}}t.$cT=pt;function Hi(G){const X=document.cookie.match("(^|[^;]+)\\s*"+G+"\\s*=\\s*([^;]+)");return X?X.pop():void 0}class Wi extends w.$Vc{constructor(X,te){super(),this.j=X,this.m=te,this.f=0,this.g=0,this.n()}n(){this.m.onDragStart&&this.B(S(this.j,t.$HS.DRAG_START,X=>{this.m.onDragStart?.(X)})),this.m.onDrag&&this.B(S(this.j,t.$HS.DRAG,X=>{this.m.onDrag?.(X)})),this.B(S(this.j,t.$HS.DRAG_ENTER,X=>{this.f++,this.g=X.timeStamp,this.m.onDragEnter?.(X)})),this.B(S(this.j,t.$HS.DRAG_OVER,X=>{X.preventDefault(),this.m.onDragOver?.(X,X.timeStamp-this.g)})),this.B(S(this.j,t.$HS.DRAG_LEAVE,X=>{this.f--,this.f===0&&(this.g=0,this.m.onDragLeave?.(X))})),this.B(S(this.j,t.$HS.DRAG_END,X=>{this.f=0,this.g=0,this.m.onDragEnd?.(X)})),this.B(S(this.j,t.$HS.DROP,X=>{this.f=0,this.g=0,this.m.onDrop?.(X)}))}}t.$eT=Wi;const Vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function qi(G,...X){let te,de;Array.isArray(X[0])?(te={},de=X[0]):(te=X[0]||{},de=X[1]);const Ae=Vi.exec(G);if(!Ae||!Ae.groups)throw new Error("Bad use of h");const xe=Ae.groups.tag||"div",Me=document.createElement(xe);Ae.groups.id&&(Me.id=Ae.groups.id);const qe=[];if(Ae.groups.class)for(const Ye of Ae.groups.class.split("."))Ye!==""&&qe.push(Ye);if(te.className!==void 0)for(const Ye of te.className.split("."))Ye!==""&&qe.push(Ye);qe.length>0&&(Me.className=qe.join(" "));const Ke={};if(Ae.groups.name&&(Ke[Ae.groups.name]=Me),de)for(const Ye of de)Ye instanceof HTMLElement?Me.appendChild(Ye):typeof Ye=="string"?Me.append(Ye):"root"in Ye&&(Object.assign(Ke,Ye),Me.appendChild(Ye.root));for(const[Ye,at]of Object.entries(te))if(Ye!=="className")if(Ye==="style")for(const[Ct,Mt]of Object.entries(at))Me.style.setProperty(ei(Ct),typeof Mt=="number"?Mt+"px":""+Mt);else Ye==="tabIndex"?Me.tabIndex=at:Me.setAttribute(ei(Ye),at.toString());return Ke.root=Me,Ke}function ei(G){return G.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}function ti(G,X,te){for(const{name:de,value:Ae}of G.attributes)(!te||te.includes(de))&&X.setAttribute(de,Ae)}function Ki(G,X,te){const de=G.getAttribute(te);de?X.setAttribute(te,de):X.removeAttribute(te)}function Gi(G,X,te){ti(G,X,te);const de=new w.$Uc;return de.add(t.$yS.observe(G,de,{attributes:!0,attributeFilter:te})(Ae=>{for(const xe of Ae)xe.type==="attributes"&&xe.attributeName&&Ki(G,X,xe.attributeName)})),de}}),define(me[65],be([1,0,4,2,128]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jT=t.$iT=void 0,t.$kT=A;class H extends C.$Vc{constructor(d,g){super(),this.B((0,n.$OR)(d,"dragover",w=>{w.preventDefault(),this.a||(this.a=setTimeout(()=>{g(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(w=>{this.B((0,n.$OR)(d,w,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.$iT=H,t.$jT={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:B.$Ps.text,INTERNAL_URI_LIST:"application/vnd.code.uri-list"};function A(P,d,g,w,M){const c=document.createElement("div");if(c.className=g,c.textContent=d,M&&(c.style.color=M),w&&(c.style.background=w),P.dataTransfer){const h=(0,n.getWindow)(P).document;h.body.appendChild(c),P.dataTransfer.setDragImage(c,-10,-10),setTimeout(()=>h.body.removeChild(c),0)}}}),define(me[66],be([1,0,4]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$NT=C,t.$OT=B,t.$PT=H;function C(c,h={}){const e=H(h);return e.textContent=c,e}function B(c,h={}){const e=H(h);return d(e,g(c,!!h.renderCodeSegments),h.actionHandler,h.renderCodeSegments),e}function H(c){const h=c.inline?"span":"div",e=document.createElement(h);return c.className&&(e.className=c.className),e}class A{constructor(h){this.b=h,this.c=0}eos(){return this.c>=this.b.length}next(){const h=this.peek();return this.advance(),h}peek(){return this.b[this.c]}advance(){this.c++}}var P;(function(c){c[c.Invalid=0]="Invalid",c[c.Root=1]="Root",c[c.Text=2]="Text",c[c.Bold=3]="Bold",c[c.Italics=4]="Italics",c[c.Action=5]="Action",c[c.ActionClose=6]="ActionClose",c[c.Code=7]="Code",c[c.NewLine=8]="NewLine"})(P||(P={}));function d(c,h,e,i){let o;if(h.type===2)o=document.createTextNode(h.content||"");else if(h.type===3)o=document.createElement("b");else if(h.type===4)o=document.createElement("i");else if(h.type===7&&i)o=document.createElement("code");else if(h.type===5&&e){const l=document.createElement("a");e.disposables.add(n.$PR(l,"click",f=>{e.callback(String(h.index),f)})),o=l}else h.type===8?o=document.createElement("br"):h.type===1&&(o=c);o&&c!==o&&c.appendChild(o),o&&Array.isArray(h.children)&&h.children.forEach(l=>{d(o,l,e,i)})}function g(c,h){const e={type:1,children:[]};let i=0,o=e;const l=[],f=new A(c);for(;!f.eos();){let S=f.next();const m=S==="\\"&&M(f.peek(),h)!==0;if(m&&(S=f.next()),!m&&w(S,h)&&S===f.peek()){f.advance(),o.type===2&&(o=l.pop());const b=M(S,h);if(o.type===b||o.type===5&&b===6)o=l.pop();else{const r={type:b,children:[]};b===5&&(r.index=i,i++),o.children.push(r),l.push(o),o=r}}else if(S===`
`)o.type===2&&(o=l.pop()),o.children.push({type:8});else if(o.type!==2){const b={type:2,content:S};o.children.push(b),l.push(o),o=b}else o.content+=S}return o.type===2&&(o=l.pop()),l.length,e}function w(c,h){return M(c,h)!==0}function M(c,h){switch(c){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return h?7:0;default:return 0}}}),define(me[67],be([1,0,4,2]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$oT=void 0;class B{constructor(){this.a=new C.$Uc,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(A,P){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const d=this.c;this.c=null,A&&d&&d(P)}isMonitoring(){return!!this.b}startMonitoring(A,P,d,g,w){this.isMonitoring()&&this.stopMonitoring(!1),this.b=g,this.c=w;let M=A;try{A.setPointerCapture(P),this.a.add((0,C.$Tc)(()=>{try{A.releasePointerCapture(P)}catch{}}))}catch{M=n.getWindow(A)}this.a.add(n.$OR(M,n.$HS.POINTER_MOVE,c=>{if(c.buttons!==d){this.stopMonitoring(!0);return}c.preventDefault(),this.b(c)})),this.a.add(n.$OR(M,n.$HS.POINTER_UP,c=>this.stopMonitoring(!0)))}}t.$oT=B});var Ze=this&&this.__decorate||function(se,t,n,C){var B=arguments.length,H=B<3?t:C===null?C=Object.getOwnPropertyDescriptor(t,n):C,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")H=Reflect.decorate(se,t,n,C);else for(var P=se.length-1;P>=0;P--)(A=se[P])&&(H=(B<3?A(H):B>3?A(t,n,H):A(t,n))||H);return B>3&&H&&Object.defineProperty(t,n,H),H};define(me[28],be([1,0,4,22,8,31,3,2,55]),function(se,t,n,C,B,H,A,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lT=t.EventType=void 0;var g;(function(M){M.Tap="-monaco-gesturetap",M.Change="-monaco-gesturechange",M.Start="-monaco-gesturestart",M.End="-monaco-gesturesend",M.Contextmenu="-monaco-gesturecontextmenu"})(g||(t.EventType=g={}));class w extends P.$Vc{static{this.c=-.005}static{this.g=700}static{this.u=400}constructor(){super(),this.h=!1,this.j=new d.$6c,this.m=new d.$6c,this.r={},this.n=null,this.s=0,this.B(A.Event.runAndSubscribe(n.onDidRegisterWindow,({window:c,disposables:h})=>{h.add(n.$OR(c.document,"touchstart",e=>this.w(e),{passive:!1})),h.add(n.$OR(c.document,"touchend",e=>this.z(c,e))),h.add(n.$OR(c.document,"touchmove",e=>this.G(e),{passive:!1}))},{window:C.$iR,disposables:this.q}))}static addTarget(c){if(!w.isTouchDevice())return P.$Vc.None;w.f||(w.f=(0,P.$Oc)(new w));const h=w.f.j.push(c);return(0,P.$Tc)(h)}static ignoreTarget(c){if(!w.isTouchDevice())return P.$Vc.None;w.f||(w.f=(0,P.$Oc)(new w));const h=w.f.m.push(c);return(0,P.$Tc)(h)}static isTouchDevice(){return"ontouchstart"in C.$iR||navigator.maxTouchPoints>0}dispose(){this.n&&(this.n.dispose(),this.n=null),super.dispose()}w(c){const h=Date.now();this.n&&(this.n.dispose(),this.n=null);for(let e=0,i=c.targetTouches.length;e<i;e++){const o=c.targetTouches.item(e);this.r[o.identifier]={id:o.identifier,initialTarget:o.target,initialTimeStamp:h,initialPageX:o.pageX,initialPageY:o.pageY,rollingTimestamps:[h],rollingPageX:[o.pageX],rollingPageY:[o.pageY]};const l=this.C(g.Start,o.target);l.pageX=o.pageX,l.pageY=o.pageY,this.D(l)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}z(c,h){const e=Date.now(),i=Object.keys(this.r).length;for(let o=0,l=h.changedTouches.length;o<l;o++){const f=h.changedTouches.item(o);if(!this.r.hasOwnProperty(String(f.identifier))){console.warn("move of an UNKNOWN touch",f);continue}const S=this.r[f.identifier],m=Date.now()-S.initialTimeStamp;if(m<w.g&&Math.abs(S.initialPageX-B.$sb(S.rollingPageX))<30&&Math.abs(S.initialPageY-B.$sb(S.rollingPageY))<30){const b=this.C(g.Tap,S.initialTarget);b.pageX=B.$sb(S.rollingPageX),b.pageY=B.$sb(S.rollingPageY),this.D(b)}else if(m>=w.g&&Math.abs(S.initialPageX-B.$sb(S.rollingPageX))<30&&Math.abs(S.initialPageY-B.$sb(S.rollingPageY))<30){const b=this.C(g.Contextmenu,S.initialTarget);b.pageX=B.$sb(S.rollingPageX),b.pageY=B.$sb(S.rollingPageY),this.D(b)}else if(i===1){const b=B.$sb(S.rollingPageX),r=B.$sb(S.rollingPageY),D=B.$sb(S.rollingTimestamps)-S.rollingTimestamps[0],k=b-S.rollingPageX[0],T=r-S.rollingPageY[0],L=[...this.j].filter(q=>S.initialTarget instanceof Node&&q.contains(S.initialTarget));this.F(c,L,e,Math.abs(k)/D,k>0?1:-1,b,Math.abs(T)/D,T>0?1:-1,r)}this.D(this.C(g.End,S.initialTarget)),delete this.r[f.identifier]}this.h&&(h.preventDefault(),h.stopPropagation(),this.h=!1)}C(c,h){const e=document.createEvent("CustomEvent");return e.initEvent(c,!1,!0),e.initialTarget=h,e.tapCount=0,e}D(c){if(c.type===g.Tap){const h=new Date().getTime();let e=0;h-this.s>w.u?e=1:e=2,this.s=h,c.tapCount=e}else(c.type===g.Change||c.type===g.Contextmenu)&&(this.s=0);if(c.initialTarget instanceof Node){for(const e of this.m)if(e.contains(c.initialTarget))return;const h=[];for(const e of this.j)if(e.contains(c.initialTarget)){let i=0,o=c.initialTarget;for(;o&&o!==e;)i++,o=o.parentElement;h.push([i,e])}h.sort((e,i)=>e[0]-i[0]);for(const[e,i]of h)i.dispatchEvent(c),this.h=!0}}F(c,h,e,i,o,l,f,S,m){this.n=n.$YR(c,()=>{const b=Date.now(),r=b-e;let D=0,k=0,T=!0;i+=w.c*r,f+=w.c*r,i>0&&(T=!1,D=o*i*r),f>0&&(T=!1,k=S*f*r);const L=this.C(g.Change);L.translationX=D,L.translationY=k,h.forEach(q=>q.dispatchEvent(L)),T||this.F(c,h,b,i,o,l+D,f,S,m+k)})}G(c){const h=Date.now();for(let e=0,i=c.changedTouches.length;e<i;e++){const o=c.changedTouches.item(e);if(!this.r.hasOwnProperty(String(o.identifier))){console.warn("end of an UNKNOWN touch",o);continue}const l=this.r[o.identifier],f=this.C(g.Change,l.initialTarget);f.translationX=o.pageX-B.$sb(l.rollingPageX),f.translationY=o.pageY-B.$sb(l.rollingPageY),f.pageX=o.pageX,f.pageY=o.pageY,this.D(f),l.rollingPageX.length>3&&(l.rollingPageX.shift(),l.rollingPageY.shift(),l.rollingTimestamps.shift()),l.rollingPageX.push(o.pageX),l.rollingPageY.push(o.pageY),l.rollingTimestamps.push(h)}this.h&&(c.preventDefault(),c.stopPropagation(),this.h=!1)}}t.$lT=w,Ze([H.$Zh],w,"isTouchDevice",null)}),define(me[68],be([1,0,4,104]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$RT=g,t.$ST=w,t.$TT=M;const C=2e4;let B,H,A,P,d;function g(h){B=document.createElement("div"),B.className="monaco-aria-container";const e=()=>{const o=document.createElement("div");return o.className="monaco-alert",o.setAttribute("role","alert"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};H=e(),A=e();const i=()=>{const o=document.createElement("div");return o.className="monaco-status",o.setAttribute("aria-live","polite"),o.setAttribute("aria-atomic","true"),B.appendChild(o),o};P=i(),d=i(),h.appendChild(B)}function w(h){B&&(H.textContent!==h?(n.$NR(A),c(H,h)):(n.$NR(H),c(A,h)))}function M(h){B&&(P.textContent!==h?(n.$NR(d),c(P,h)):(n.$NR(P),c(d,h)))}function c(h,e){n.$NR(h),e.length>C&&(e=e.substr(0,C)),h.textContent=e,h.style.visibility="hidden",h.style.visibility="visible"}}),define(me[130],be([1,0,4,19]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$kU=H,t.$lU=A;const B=new RegExp(`(\\\\)?\\$\\((${C.ThemeIcon.iconNameExpression}(?:${C.ThemeIcon.iconModifierExpression})?)\\)`,"g");function H(P){const d=new Array;let g,w=0,M=0;for(;(g=B.exec(P))!==null;){M=g.index||0,w<M&&d.push(P.substring(w,M)),w=(g.index||0)+g[0].length;const[,c,h]=g;d.push(c?`$(${h})`:A({id:h}))}return w<P.length&&d.push(P.substring(w)),d}function A(P){const d=n.$("span");return d.classList.add(...C.ThemeIcon.asClassNameArray(P)),d}}),define(me[131],be([1,0,4]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ZT=void 0;function C(H){try{H.parentElement?.removeChild(H)}catch{}}class B{constructor(A){this.d=A,this.a=new Map,this.b=new Set,this.c=!1}alloc(A){let P=this.h(A).pop(),d=!1;if(P)d=this.b.has(P.domNode),d&&this.b.delete(P.domNode);else{const g=(0,n.$)(".monaco-list-row"),M=this.i(A).renderTemplate(g);P={domNode:g,templateId:A,templateData:M}}return{row:P,isReusingConnectedDomNode:d}}release(A){A&&this.f(A)}transact(A){if(this.c)throw new Error("Already in transaction");this.c=!0;try{A()}finally{for(const P of this.b)this.g(P);this.b.clear(),this.c=!1}}f(A){const{domNode:P,templateId:d}=A;P&&(this.c?this.b.add(P):this.g(P)),this.h(d).push(A)}g(A){A.classList.remove("scrolling"),C(A)}h(A){let P=this.a.get(A);return P||(P=[],this.a.set(A,P)),P}dispose(){this.a.forEach((A,P)=>{for(const d of A)this.i(P).disposeTemplate(d.templateData),d.templateData=null}),this.a.clear(),this.b.clear()}i(A){const P=this.d.get(A);if(!P)throw new Error(`No renderer found for ${A}`);return P}}t.$ZT=B}),define(me[132],be([1,0,11,2]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tT=void 0;class B extends C.$Vc{constructor(A,P,d){super(),this.a=A,this.b=P,this.c=d,this.f=null,this.m=!1,this.j=!1,this.g=!1,this.h=!1,this.n=this.B(new n.$Fh)}setVisibility(A){this.a!==A&&(this.a=A,this.s())}setShouldBeVisible(A){this.g=A,this.s()}r(){return this.a===2?!1:this.a===3?!0:this.g}s(){const A=this.r();this.h!==A&&(this.h=A,this.ensureVisibility())}setIsNeeded(A){this.j!==A&&(this.j=A,this.ensureVisibility())}setDomNode(A){this.f=A,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.j){this.u(!1);return}this.h?this.t():this.u(!0)}t(){this.m||(this.m=!0,this.n.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}u(A){this.n.cancel(),this.m&&(this.m=!1,this.f?.setClassName(this.c+(A?" fade":"")))}}t.$tT=B}),define(me[133],be([1,0,4,28,8,3,2,5]),function(se,t,n,C,B,H,A,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uU=void 0;class d extends A.$Vc{constructor(w,M,c,h){super(),this.f=0,this.b=h||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new H.$ee),this.h=c,this.j(),this.setOptions(w,M)}j(){this.B(C.$lT.addTarget(this.a)),[C.EventType.Tap].forEach(w=>{this.B(n.$OR(this.a,w,M=>{this.a.focus()}))}),this.B(n.$PR(this.a,"click",w=>{n.$JS.stop(w,!0)})),this.B(n.$PR(this.a,"change",w=>{this.a.title=w.target.value,this.g.fire({index:w.target.selectedIndex,selected:w.target.value})})),this.B(n.$PR(this.a,"keydown",w=>{let M=!1;P.$j?(w.keyCode===18||w.keyCode===16||w.keyCode===10)&&(M=!0):(w.keyCode===18&&w.altKey||w.keyCode===10||w.keyCode===3)&&(M=!0),M&&w.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(w,M){(!this.c||!B.$ub(this.c,w))&&(this.c=w,this.a.options.length=0,this.c.forEach((c,h)=>{this.a.add(this.m(c.text,h,c.isDisabled))})),M!==void 0&&this.select(M)}select(w){this.c.length===0?this.f=0:w>=0&&w<this.c.length?this.f=w:w>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(w){this.b.ariaLabel=w,this.a.setAttribute("aria-label",w)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(w){this.a.tabIndex=w?0:-1}render(w){w.classList.add("select-container"),w.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(w){this.h=w,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}m(w,M,c){const h=document.createElement("option");return h.value=w,h.text=w,h.disabled=!!c,h}}t.$uU=d}),define(me[69],be([1,0,30,8,11,60,98,3,32]),function(se,t,n,C,B,H,A,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$7V=void 0,t.$5V=g,t.$6V=w;function g(h){return typeof h=="object"&&"visibility"in h&&"data"in h}function w(h){switch(h){case!0:return 1;case!1:return 0;default:return h}}function M(h){return typeof h.collapsible=="boolean"}class c{constructor(e,i,o,l={}){this.p=e,this.q=i,this.rootRef=[],this.d=new P.$me,this.f=new P.$ee,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new P.$ee,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.m=new P.$ee,this.onDidSplice=this.m.event,this.o=new B.$sh(H.$be),this.h=typeof l.collapseByDefault>"u"?!1:l.collapseByDefault,this.j=l.allowNonCollapsibleParents??!1,this.k=l.filter,this.l=typeof l.autoExpandSingleChildren>"u"?!1:l.autoExpandSingleChildren,this.c={parent:void 0,element:o,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,i,o=d.Iterable.empty(),l={}){if(e.length===0)throw new n.$3V(this.p,"Invalid tree location");l.diffIdentityProvider?this.s(l.diffIdentityProvider,e,i,o,l):this.t(e,i,o,l)}s(e,i,o,l=d.Iterable.empty(),f,S=f.diffDepth??0){const{parentNode:m}=this.H(i);if(!m.lastDiffIds)return this.t(i,o,l,f);const b=[...l],r=i[i.length-1],D=new A.$zt({getElements:()=>m.lastDiffIds},{getElements:()=>[...m.children.slice(0,r),...b,...m.children.slice(r+o)].map($=>e.getId($.element).toString())}).ComputeDiff(!1);if(D.quitEarly)return m.lastDiffIds=void 0,this.t(i,o,b,f);const k=i.slice(0,-1),T=($,I,V)=>{if(S>0)for(let N=0;N<V;N++)$--,I--,this.s(e,[...k,$,0],Number.MAX_SAFE_INTEGER,b[I].children,f,S-1)};let L=Math.min(m.children.length,r+o),q=b.length;for(const $ of D.changes.sort((I,V)=>V.originalStart-I.originalStart))T(L,q,L-($.originalStart+$.originalLength)),L=$.originalStart,q=$.modifiedStart-r,this.t([...k,L],$.originalLength,d.Iterable.slice(b,q,q+$.modifiedLength),f);T(L,q,L)}t(e,i,o=d.Iterable.empty(),{onDidCreateNode:l,onDidDeleteNode:f,diffIdentityProvider:S}){const{parentNode:m,listIndex:b,revealed:r,visible:D}=this.H(e),k=[],T=d.Iterable.map(o,Y=>this.x(Y,m,m.visible?1:0,r,k,l)),L=e[e.length-1];let q=0;for(let Y=L;Y>=0&&Y<m.children.length;Y--){const K=m.children[Y];if(K.visible){q=K.visibleChildIndex;break}}const $=[];let I=0,V=0;for(const Y of T)$.push(Y),V+=Y.renderNodeCount,Y.visible&&(Y.visibleChildIndex=q+I++);const N=(0,C.$6b)(m.children,L,i,$);S?m.lastDiffIds?(0,C.$6b)(m.lastDiffIds,L,i,$.map(Y=>S.getId(Y.element).toString())):m.lastDiffIds=m.children.map(Y=>S.getId(Y.element).toString()):m.lastDiffIds=void 0;let x=0;for(const Y of N)Y.visible&&x++;if(x!==0)for(let Y=L+$.length;Y<m.children.length;Y++){const K=m.children[Y];K.visible&&(K.visibleChildIndex-=x)}if(m.visibleChildrenCount+=I-x,r&&D){const Y=N.reduce((K,ae)=>K+(ae.visible?ae.renderNodeCount:0),0);this.C(m,V-Y),this.q.splice(b,Y,k)}if(N.length>0&&f){const Y=K=>{f(K),K.children.forEach(Y)};N.forEach(Y)}this.m.fire({insertedNodes:$,deletedNodes:N});let j=m;for(;j;){if(j.visibility===2){this.o.trigger(()=>this.refilter());break}j=j.parent}}rerender(e){if(e.length===0)throw new n.$3V(this.p,"Invalid tree location");const{node:i,listIndex:o,revealed:l}=this.G(e);i.visible&&l&&this.q.splice(o,1,[i])}updateElementHeight(e,i){if(e.length===0)throw new n.$3V(this.p,"Invalid tree location");const{listIndex:o}=this.G(e);this.q.updateElementHeight(o,i)}has(e){return this.E(e)}getListIndex(e){const{listIndex:i,visible:o,revealed:l}=this.G(e);return o&&l?i:-1}getListRenderCount(e){return this.F(e).renderNodeCount}isCollapsible(e){return this.F(e).collapsible}setCollapsible(e,i){const o=this.F(e);typeof i>"u"&&(i=!o.collapsible);const l={collapsible:i};return this.d.bufferEvents(()=>this.u(e,l))}isCollapsed(e){return this.F(e).collapsed}setCollapsed(e,i,o){const l=this.F(e);typeof i>"u"&&(i=!l.collapsed);const f={collapsed:i,recursive:o||!1};return this.d.bufferEvents(()=>this.u(e,f))}u(e,i){const{node:o,listIndex:l,revealed:f}=this.G(e),S=this.v(o,l,f,i);if(o!==this.c&&this.l&&S&&!M(i)&&o.collapsible&&!o.collapsed&&!i.recursive){let m=-1;for(let b=0;b<o.children.length;b++)if(o.children[b].visible)if(m>-1){m=-1;break}else m=b;m>-1&&this.u([...e,m],i)}return S}v(e,i,o,l){const f=this.w(e,l,!1);if(!o||!e.visible||!f)return f;const S=e.renderNodeCount,m=this.y(e),b=S-(i===-1?0:1);return this.q.splice(i+1,b,m.slice(1)),f}w(e,i,o){let l;if(e===this.c?l=!1:(M(i)?(l=e.collapsible!==i.collapsible,e.collapsible=i.collapsible):e.collapsible?(l=e.collapsed!==i.collapsed,e.collapsed=i.collapsed):l=!1,l&&this.f.fire({node:e,deep:o})),!M(i)&&i.recursive)for(const f of e.children)l=this.w(f,i,!0)||l;return l}expandTo(e){this.d.bufferEvents(()=>{let i=this.F(e);for(;i.parent;)i=i.parent,e=e.slice(0,e.length-1),i.collapsed&&this.u(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,i=this.A(this.c);this.q.splice(0,e,i),this.o.cancel()}x(e,i,o,l,f,S){const m={parent:i,element:e.element,children:[],depth:i.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},b=this.D(m,o);m.visibility=b,l&&f.push(m);const r=e.children||d.Iterable.empty(),D=l&&b!==0&&!m.collapsed;let k=0,T=1;for(const L of r){const q=this.x(L,m,b,D,f,S);m.children.push(q),T+=q.renderNodeCount,q.visible&&(q.visibleChildIndex=k++)}return this.j||(m.collapsible=m.collapsible||m.children.length>0),m.visibleChildrenCount=k,m.visible=b===2?k>0:b===1,m.visible?m.collapsed||(m.renderNodeCount=T):(m.renderNodeCount=0,l&&f.pop()),S?.(m),m}y(e){const i=e.renderNodeCount,o=[];return this.z(e,o),this.C(e.parent,o.length-i),o}z(e,i){if(e.visible===!1)return 0;if(i.push(e),e.renderNodeCount=1,!e.collapsed)for(const o of e.children)e.renderNodeCount+=this.z(o,i);return this.g.fire(e),e.renderNodeCount}A(e){const i=e.renderNodeCount,o=[];return this.B(e,e.visible?1:0,o),this.C(e.parent,o.length-i),o}B(e,i,o,l=!0){let f;if(e!==this.c){if(f=this.D(e,i),f===0)return e.visible=!1,e.renderNodeCount=0,!1;l&&o.push(e)}const S=o.length;e.renderNodeCount=e===this.c?0:1;let m=!1;if(!e.collapsed||f!==0){let b=0;for(const r of e.children)m=this.B(r,f,o,l&&!e.collapsed)||m,r.visible&&(r.visibleChildIndex=b++);e.visibleChildrenCount=b}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=f===2?m:f===1,e.visibility=f),e.visible?e.collapsed||(e.renderNodeCount+=o.length-S):(e.renderNodeCount=0,l&&o.pop()),this.g.fire(e),e.visible}C(e,i){if(i!==0)for(;e;)e.renderNodeCount+=i,this.g.fire(e),e=e.parent}D(e,i){const o=this.k?this.k.filter(e.element,i):1;return typeof o=="boolean"?(e.filterData=void 0,o?1:0):g(o)?(e.filterData=o.data,w(o.visibility)):(e.filterData=void 0,w(o))}E(e,i=this.c){if(!e||e.length===0)return!0;const[o,...l]=e;return o<0||o>i.children.length?!1:this.E(l,i.children[o])}F(e,i=this.c){if(!e||e.length===0)return i;const[o,...l]=e;if(o<0||o>i.children.length)throw new n.$3V(this.p,"Invalid tree location");return this.F(l,i.children[o])}G(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:i,listIndex:o,revealed:l,visible:f}=this.H(e),S=e[e.length-1];if(S<0||S>i.children.length)throw new n.$3V(this.p,"Invalid tree location");const m=i.children[S];return{node:m,listIndex:o,revealed:l,visible:f&&m.visible}}H(e,i=this.c,o=0,l=!0,f=!0){const[S,...m]=e;if(S<0||S>i.children.length)throw new n.$3V(this.p,"Invalid tree location");for(let b=0;b<S;b++)o+=i.children[b].renderNodeCount;return l=l&&!i.collapsed,f=f&&i.visible,m.length===0?{parentNode:i,listIndex:o,revealed:l,visible:f}:this.H(m,i.children[S],o+1,l,f)}getNode(e=[]){return this.F(e)}getNodeLocation(e){const i=[];let o=e;for(;o.parent;)i.push(o.parent.children.indexOf(o)),o=o.parent;return i.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,C.$tb)(e)[0]}getFirstElementChild(e){const i=this.F(e);if(i.children.length!==0)return i.children[0].element}getLastElementAncestor(e=[]){const i=this.F(e);if(i.children.length!==0)return this.I(i)}I(e){return e.children.length===0?e.element:this.I(e.children[e.children.length-1])}}t.$7V=c}),define(me[134],be([1,0,69,30,32]),function(se,t,n,C,B){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bW=void 0;class H{get size(){return this.d.size}constructor(P,d,g={}){this.k=P,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new n.$7V(P,d,null,g),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,g.sorter&&(this.j={compare(w,M){return g.sorter.compare(w.element,M.element)}}),this.h=g.identityProvider}setChildren(P,d=B.Iterable.empty(),g={}){const w=this.o(P);this.l(w,this.m(d),g)}l(P,d=B.Iterable.empty(),g){const w=new Set,M=new Set,c=e=>{if(e.element===null)return;const i=e;if(w.add(i.element),this.d.set(i.element,i),this.h){const o=this.h.getId(i.element).toString();M.add(o),this.f.set(o,i)}g.onDidCreateNode?.(i)},h=e=>{if(e.element===null)return;const i=e;if(w.has(i.element)||this.d.delete(i.element),this.h){const o=this.h.getId(i.element).toString();M.has(o)||this.f.delete(o)}g.onDidDeleteNode?.(i)};this.c.splice([...P,0],Number.MAX_VALUE,d,{...g,onDidCreateNode:c,onDidDeleteNode:h})}m(P=B.Iterable.empty()){return this.j&&(P=[...P].sort(this.j.compare.bind(this.j))),B.Iterable.map(P,d=>{let g=this.d.get(d.element);if(!g&&this.h){const c=this.h.getId(d.element).toString();g=this.f.get(c)}if(!g){let c;return typeof d.collapsed>"u"?c=void 0:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed?c=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?c=!1:c=!!d.collapsed,{...d,children:this.m(d.children),collapsed:c}}const w=typeof d.collapsible=="boolean"?d.collapsible:g.collapsible;let M;return typeof d.collapsed>"u"||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrCollapsed||d.collapsed===C.ObjectTreeElementCollapseState.PreserveOrExpanded?M=g.collapsed:d.collapsed===C.ObjectTreeElementCollapseState.Collapsed?M=!0:d.collapsed===C.ObjectTreeElementCollapseState.Expanded?M=!1:M=!!d.collapsed,{...d,collapsible:w,collapsed:M,children:this.m(d.children)}})}rerender(P){const d=this.o(P);this.c.rerender(d)}updateElementHeight(P,d){const g=this.o(P);this.c.updateElementHeight(g,d)}resort(P=null,d=!0){if(!this.j)return;const g=this.o(P),w=this.c.getNode(g);this.l(g,this.n(w,d),{})}n(P,d,g=!0){let w=[...P.children];return(d||g)&&(w=w.sort(this.j.compare.bind(this.j))),B.Iterable.map(w,M=>({element:M.element,collapsible:M.collapsible,collapsed:M.collapsed,children:this.n(M,d,!1)}))}getFirstElementChild(P=null){const d=this.o(P);return this.c.getFirstElementChild(d)}getLastElementAncestor(P=null){const d=this.o(P);return this.c.getLastElementAncestor(d)}has(P){return this.d.has(P)}getListIndex(P){const d=this.o(P);return this.c.getListIndex(d)}getListRenderCount(P){const d=this.o(P);return this.c.getListRenderCount(d)}isCollapsible(P){const d=this.o(P);return this.c.isCollapsible(d)}setCollapsible(P,d){const g=this.o(P);return this.c.setCollapsible(g,d)}isCollapsed(P){const d=this.o(P);return this.c.isCollapsed(d)}setCollapsed(P,d,g){const w=this.o(P);return this.c.setCollapsed(w,d,g)}expandTo(P){const d=this.o(P);this.c.expandTo(d)}refilter(){this.c.refilter()}getNode(P=null){if(P===null)return this.c.getNode(this.c.rootRef);const d=this.d.get(P);if(!d)throw new C.$3V(this.k,`Tree element not found: ${P}`);return d}getNodeLocation(P){return P.element}getParentNodeLocation(P){if(P===null)throw new C.$3V(this.k,"Invalid getParentNodeLocation call");const d=this.d.get(P);if(!d)throw new C.$3V(this.k,`Tree element not found: ${P}`);const g=this.c.getNodeLocation(d),w=this.c.getParentNodeLocation(g);return this.c.getNode(w).element}o(P){if(P===null)return[];const d=this.d.get(P);if(!d)throw new C.$3V(this.k,`Tree element not found: ${P}`);return this.c.getNodeLocation(d)}}t.$bW=H}),define(me[21],be([1,0,4,15,20,28,2]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$pT=void 0;class P extends A.$Vc{f(g,w){this.B(n.$OR(g,n.$HS.CLICK,M=>w(new B.$GR(n.getWindow(g),M))))}j(g,w){this.B(n.$OR(g,n.$HS.MOUSE_DOWN,M=>w(new B.$GR(n.getWindow(g),M))))}m(g,w){this.B(n.$OR(g,n.$HS.MOUSE_OVER,M=>w(new B.$GR(n.getWindow(g),M))))}u(g,w){this.B(n.$OR(g,n.$HS.MOUSE_LEAVE,M=>w(new B.$GR(n.getWindow(g),M))))}z(g,w){this.B(n.$OR(g,n.$HS.KEY_DOWN,M=>w(new C.$LR(M))))}C(g,w){this.B(n.$OR(g,n.$HS.KEY_UP,M=>w(new C.$LR(M))))}D(g,w){this.B(n.$OR(g,n.$HS.INPUT,w))}F(g,w){this.B(n.$OR(g,n.$HS.BLUR,w))}G(g,w){this.B(n.$OR(g,n.$HS.FOCUS,w))}H(g,w){this.B(n.$OR(g,n.$HS.CHANGE,w))}I(g){return H.$lT.ignoreTarget(g)}}t.$pT=P}),define(me[48],be([1,0,67,21,11,19,4]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$rT=t.$qT=void 0,t.$qT=11;class P extends C.$pT{constructor(g){super(),this.a=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top<"u"&&(this.bgDomNode.style.top="0px"),typeof g.left<"u"&&(this.bgDomNode.style.left="0px"),typeof g.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof g.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(g.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.$qT+"px",this.domNode.style.height=t.$qT+"px",typeof g.top<"u"&&(this.domNode.style.top=g.top+"px"),typeof g.left<"u"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom<"u"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right<"u"&&(this.domNode.style.right=g.right+"px"),this.g=this.B(new n.$oT),this.B(A.$PR(this.bgDomNode,A.$HS.POINTER_DOWN,w=>this.h(w))),this.B(A.$PR(this.domNode,A.$HS.POINTER_DOWN,w=>this.h(w))),this.b=this.B(new A.$1R),this.c=this.B(new B.$Fh)}h(g){if(!g.target||!(g.target instanceof Element))return;const w=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24,A.getWindow(g))};this.a(),this.b.cancel(),this.c.cancelAndSet(w,200),this.g.startMonitoring(g.target,g.pointerId,g.buttons,M=>{},()=>{this.b.cancel(),this.c.cancel()}),g.preventDefault()}}t.$rT=P}),define(me[70],be([1,0,4,51,67,48,132,21,5]),function(se,t,n,C,B,H,A,P,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$uT=void 0;const g=140;class w extends P.$pT{constructor(c){super(),this.g=c.lazyRender,this.a=c.host,this.b=c.scrollable,this.c=c.scrollByPage,this.h=c.scrollbarState,this.n=this.B(new A.$tT(c.visibility,"visible scrollbar "+c.extraScrollbarClassName,"invisible scrollbar "+c.extraScrollbarClassName)),this.n.setIsNeeded(this.h.isNeeded()),this.r=this.B(new B.$oT),this.s=!0,this.domNode=(0,C.$nT)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.n.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(n.$OR(this.domNode.domNode,n.$HS.POINTER_DOWN,h=>this.M(h)))}t(c){const h=this.B(new H.$rT(c));this.domNode.domNode.appendChild(h.bgDomNode),this.domNode.domNode.appendChild(h.domNode)}w(c,h,e,i){this.slider=(0,C.$nT)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(c),this.slider.setLeft(h),typeof e=="number"&&this.slider.setWidth(e),typeof i=="number"&&this.slider.setHeight(i),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(n.$OR(this.slider.domNode,n.$HS.POINTER_DOWN,o=>{o.button===0&&(o.preventDefault(),this.O(o))})),this.f(this.slider.domNode,o=>{o.leftButton&&o.stopPropagation()})}y(c){return this.h.setVisibleSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}J(c){return this.h.setScrollSize(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}L(c){return this.h.setScrollPosition(c)&&(this.n.setIsNeeded(this.h.isNeeded()),this.s=!0,this.g||this.render()),this.s}beginReveal(){this.n.setShouldBeVisible(!0)}beginHide(){this.n.setShouldBeVisible(!1)}render(){this.s&&(this.s=!1,this.Q(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.R(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}M(c){c.target===this.domNode.domNode&&this.N(c)}delegatePointerDown(c){const h=this.domNode.domNode.getClientRects()[0].top,e=h+this.h.getSliderPosition(),i=h+this.h.getSliderPosition()+this.h.getSliderSize(),o=this.U(c);e<=o&&o<=i?c.button===0&&(c.preventDefault(),this.O(c)):this.N(c)}N(c){let h,e;if(c.target===this.domNode.domNode&&typeof c.offsetX=="number"&&typeof c.offsetY=="number")h=c.offsetX,e=c.offsetY;else{const o=n.$$R(this.domNode.domNode);h=c.pageX-o.left,e=c.pageY-o.top}const i=this.S(h,e);this.P(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(i):this.h.getDesiredScrollPositionFromOffset(i)),c.button===0&&(c.preventDefault(),this.O(c))}O(c){if(!c.target||!(c.target instanceof Element))return;const h=this.U(c),e=this.W(c),i=this.h.clone();this.slider.toggleClassName("active",!0),this.r.startMonitoring(c.target,c.pointerId,c.buttons,o=>{const l=this.W(o),f=Math.abs(l-e);if(d.$i&&f>g){this.P(i.getScrollPosition());return}const m=this.U(o)-h;this.P(i.getDesiredScrollPositionFromDelta(m))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}P(c){const h={};this.writeScrollPosition(h,c),this.b.setScrollPositionNow(h)}updateScrollbarSize(c){this.X(c),this.h.setScrollbarSize(c),this.s=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.$uT=w}),define(me[135],be([1,0,20,70,48,52,18]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vT=void 0;class P extends C.$uT{constructor(g,w,M){const c=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:M,scrollbarState:new H.$sT(w.horizontalHasArrows?w.arrowSize:0,w.horizontal===2?0:w.horizontalScrollbarSize,w.vertical===2?0:w.verticalScrollbarSize,c.width,c.scrollWidth,h.scrollLeft),visibility:w.horizontal,extraScrollbarClassName:"horizontal",scrollable:g,scrollByPage:w.scrollByPage}),w.horizontalHasArrows){const e=(w.arrowSize-B.$qT)/2,i=(w.horizontalScrollbarSize-B.$qT)/2;this.t({className:"scra",icon:A.$Uj.scrollbarButtonLeft,top:i,left:e,bottom:void 0,right:void 0,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new n.$IR(null,1,0))}),this.t({className:"scra",icon:A.$Uj.scrollbarButtonRight,top:i,left:void 0,bottom:void 0,right:e,bgWidth:w.arrowSize,bgHeight:w.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new n.$IR(null,-1,0))})}this.w(Math.floor((w.horizontalScrollbarSize-w.horizontalSliderSize)/2),0,void 0,w.horizontalSliderSize)}R(g,w){this.slider.setWidth(g),this.slider.setLeft(w)}Q(g,w){this.domNode.setWidth(g),this.domNode.setHeight(w),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(g){return this.s=this.J(g.scrollWidth)||this.s,this.s=this.L(g.scrollLeft)||this.s,this.s=this.y(g.width)||this.s,this.s}S(g,w){return g}U(g){return g.pageX}W(g){return g.pageY}X(g){this.slider.setHeight(g)}writeScrollPosition(g,w){g.scrollLeft=w}updateOptions(g){this.updateScrollbarSize(g.horizontal===2?0:g.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.n.setVisibility(g.horizontal),this.c=g.scrollByPage}}t.$vT=P}),define(me[136],be([1,0,20,70,48,52,18]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wT=void 0;class P extends C.$uT{constructor(g,w,M){const c=g.getScrollDimensions(),h=g.getCurrentScrollPosition();if(super({lazyRender:w.lazyRender,host:M,scrollbarState:new H.$sT(w.verticalHasArrows?w.arrowSize:0,w.vertical===2?0:w.verticalScrollbarSize,0,c.height,c.scrollHeight,h.scrollTop),visibility:w.vertical,extraScrollbarClassName:"vertical",scrollable:g,scrollByPage:w.scrollByPage}),w.verticalHasArrows){const e=(w.arrowSize-B.$qT)/2,i=(w.verticalScrollbarSize-B.$qT)/2;this.t({className:"scra",icon:A.$Uj.scrollbarButtonUp,top:e,left:i,bottom:void 0,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new n.$IR(null,0,1))}),this.t({className:"scra",icon:A.$Uj.scrollbarButtonDown,top:void 0,left:i,bottom:e,right:void 0,bgWidth:w.verticalScrollbarSize,bgHeight:w.arrowSize,onActivate:()=>this.a.onMouseWheel(new n.$IR(null,0,-1))})}this.w(0,Math.floor((w.verticalScrollbarSize-w.verticalSliderSize)/2),w.verticalSliderSize,void 0)}R(g,w){this.slider.setHeight(g),this.slider.setTop(w)}Q(g,w){this.domNode.setWidth(w),this.domNode.setHeight(g),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(g){return this.s=this.J(g.scrollHeight)||this.s,this.s=this.L(g.scrollTop)||this.s,this.s=this.y(g.height)||this.s,this.s}S(g,w){return w}U(g){return g.pageY}W(g){return g.pageX}X(g){this.slider.setWidth(g)}writeScrollPosition(g,w){g.scrollTop=w}updateOptions(g){this.updateScrollbarSize(g.vertical===2?0:g.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.n.setVisibility(g.vertical),this.c=g.scrollByPage}}t.$wT=P}),define(me[71],be([1,0,17,4,51,20,135,136,21,11,3,2,5,58,111]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BT=t.$AT=t.$zT=t.$yT=t.$xT=void 0;const e=500,i=50,o=!0;class l{constructor(T,L,q){this.timestamp=T,this.deltaX=L,this.deltaY=q,this.score=0}}class f{static{this.INSTANCE=new f}constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let T=1,L=0,q=1,$=this.d;do{const I=$===this.c?T:Math.pow(2,-q);if(T-=I,L+=this.b[$].score*I,$===this.c)break;$=(this.a+$-1)%this.a,q++}while(!0);return L<=.5}acceptStandardWheelEvent(T){if(n.$wR){const L=C.getWindow(T.browserEvent),q=(0,n.$pR)(L);this.accept(Date.now(),T.deltaX*q,T.deltaY*q)}else this.accept(Date.now(),T.deltaX,T.deltaY)}accept(T,L,q){let $=null;const I=new l(T,L,q);this.c===-1&&this.d===-1?(this.b[0]=I,this.c=0,this.d=0):($=this.b[this.d],this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=I),I.score=this.f(I,$)}f(T,L){if(Math.abs(T.deltaX)>0&&Math.abs(T.deltaY)>0)return 1;let q=.5;if((!this.g(T.deltaX)||!this.g(T.deltaY))&&(q+=.25),L){const $=Math.abs(T.deltaX),I=Math.abs(T.deltaY),V=Math.abs(L.deltaX),N=Math.abs(L.deltaY),x=Math.max(Math.min($,V),1),j=Math.max(Math.min(I,N),1),Y=Math.max($,V),K=Math.max(I,N);Y%x===0&&K%j===0&&(q-=.5)}return Math.min(Math.max(q,0),1)}g(T){return Math.abs(Math.round(T)-T)<.01}}t.$xT=f;class S extends d.$pT{get options(){return this.a}constructor(T,L,q){super(),this.O=this.B(new w.$ee),this.onScroll=this.O.event,this.P=this.B(new w.$ee),this.onWillScroll=this.P.event,T.style.overflow="hidden",this.a=D(L),this.b=q,this.B(this.b.onScroll(I=>{this.P.fire(I),this.S(I),this.O.fire(I)}));const $={onMouseWheel:I=>this.R(I),onDragStart:()=>this.W(),onDragEnd:()=>this.X()};this.c=this.B(new P.$wT(this.b,this.a,$)),this.g=this.B(new A.$vT(this.b,this.a,$)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(T),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.n=(0,B.$nT)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode),this.r=(0,B.$nT)(document.createElement("div")),this.r.setClassName("shadow"),this.h.appendChild(this.r.domNode),this.s=(0,B.$nT)(document.createElement("div")),this.s.setClassName("shadow"),this.h.appendChild(this.s.domNode)):(this.n=null,this.r=null,this.s=null),this.t=this.a.listenOnDomNode||this.h,this.w=[],this.Q(this.a.handleMouseWheel),this.m(this.t,I=>this.Z(I)),this.u(this.t,I=>this.Y(I)),this.L=this.B(new g.$Fh),this.y=!1,this.J=!1,this.M=!0,this.N=!0}dispose(){this.w=(0,M.$Qc)(this.w),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(T){this.c.delegatePointerDown(T)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(T){this.b.setScrollDimensions(T,!1)}updateClassName(T){this.a.className=T,c.$j&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(T){typeof T.handleMouseWheel<"u"&&(this.a.handleMouseWheel=T.handleMouseWheel,this.Q(this.a.handleMouseWheel)),typeof T.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=T.mouseWheelScrollSensitivity),typeof T.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=T.fastScrollSensitivity),typeof T.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=T.scrollPredominantAxis),typeof T.horizontal<"u"&&(this.a.horizontal=T.horizontal),typeof T.vertical<"u"&&(this.a.vertical=T.vertical),typeof T.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=T.horizontalScrollbarSize),typeof T.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=T.verticalScrollbarSize),typeof T.scrollByPage<"u"&&(this.a.scrollByPage=T.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.U()}setRevealOnScroll(T){this.N=T}delegateScrollFromMouseWheelEvent(T){this.R(new H.$IR(T))}Q(T){if(this.w.length>0!==T&&(this.w=(0,M.$Qc)(this.w),T)){const q=$=>{this.R(new H.$IR($))};this.w.push(C.$OR(this.t,C.$HS.MOUSE_WHEEL,q,{passive:!1}))}}R(T){if(T.browserEvent?.defaultPrevented)return;const L=f.INSTANCE;o&&L.acceptStandardWheelEvent(T);let q=!1;if(T.deltaY||T.deltaX){let I=T.deltaY*this.a.mouseWheelScrollSensitivity,V=T.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(this.a.scrollYToX&&V+I===0?V=I=0:Math.abs(I)>=Math.abs(V)?V=0:I=0),this.a.flipAxes&&([I,V]=[V,I]);const N=!c.$j&&T.browserEvent&&T.browserEvent.shiftKey;(this.a.scrollYToX||N)&&!V&&(V=I,I=0),T.browserEvent&&T.browserEvent.altKey&&(V=V*this.a.fastScrollSensitivity,I=I*this.a.fastScrollSensitivity);const x=this.b.getFutureScrollPosition();let j={};if(I){const Y=i*I,K=x.scrollTop-(Y<0?Math.floor(Y):Math.ceil(Y));this.c.writeScrollPosition(j,K)}if(V){const Y=i*V,K=x.scrollLeft-(Y<0?Math.floor(Y):Math.ceil(Y));this.g.writeScrollPosition(j,K)}j=this.b.validateScrollPosition(j),(x.scrollLeft!==j.scrollLeft||x.scrollTop!==j.scrollTop)&&(o&&this.a.mouseWheelSmoothScroll&&L.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(j):this.b.setScrollPositionNow(j),q=!0)}let $=q;!$&&this.a.alwaysConsumeMouseWheel&&($=!0),!$&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&($=!0),$&&(T.preventDefault(),T.stopPropagation())}S(T){this.M=this.g.onDidScroll(T)||this.M,this.M=this.c.onDidScroll(T)||this.M,this.a.useShadows&&(this.M=!0),this.N&&this.$(),this.a.lazyRender||this.U()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.U()}U(){if(this.M&&(this.M=!1,this.g.render(),this.c.render(),this.a.useShadows)){const T=this.b.getCurrentScrollPosition(),L=T.scrollTop>0,q=T.scrollLeft>0,$=q?" left":"",I=L?" top":"",V=q||L?" top-left-corner":"";this.n.setClassName(`shadow${$}`),this.r.setClassName(`shadow${I}`),this.s.setClassName(`shadow${V}${I}${$}`)}}W(){this.y=!0,this.$()}X(){this.y=!1,this.ab()}Y(T){this.J=!1,this.ab()}Z(T){this.J=!0,this.$()}$(){this.c.beginReveal(),this.g.beginReveal(),this.bb()}ab(){!this.J&&!this.y&&(this.c.beginHide(),this.g.beginHide())}bb(){!this.J&&!this.y&&this.L.cancelAndSet(()=>this.ab(),e)}}t.$yT=S;class m extends S{constructor(T,L){L=L||{},L.mouseWheelSmoothScroll=!1;const q=new h.$Vs({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>C.$YR(C.getWindow(T),$)});super(T,L,q),this.B(q)}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$zT=m;class b extends S{constructor(T,L,q){super(T,L,q)}setScrollPosition(T){T.reuseAnimation?this.b.setScrollPositionSmooth(T,T.reuseAnimation):this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.$AT=b;class r extends S{constructor(T,L){L=L||{},L.mouseWheelSmoothScroll=!1;const q=new h.$Vs({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:$=>C.$YR(C.getWindow(T),$)});super(T,L,q),this.B(q),this.cb=T,this.B(this.onScroll($=>{$.scrollTopChanged&&(this.cb.scrollTop=$.scrollTop),$.scrollLeftChanged&&(this.cb.scrollLeft=$.scrollLeft)})),this.scanDomNode()}setScrollPosition(T){this.b.setScrollPositionNow(T)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.cb.clientWidth,scrollWidth:this.cb.scrollWidth,height:this.cb.clientHeight,scrollHeight:this.cb.scrollHeight}),this.setScrollPosition({scrollLeft:this.cb.scrollLeft,scrollTop:this.cb.scrollTop})}}t.$BT=r;function D(k){const T={lazyRender:typeof k.lazyRender<"u"?k.lazyRender:!1,className:typeof k.className<"u"?k.className:"",useShadows:typeof k.useShadows<"u"?k.useShadows:!0,handleMouseWheel:typeof k.handleMouseWheel<"u"?k.handleMouseWheel:!0,flipAxes:typeof k.flipAxes<"u"?k.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof k.consumeMouseWheelIfScrollbarIsNeeded<"u"?k.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof k.alwaysConsumeMouseWheel<"u"?k.alwaysConsumeMouseWheel:!1,scrollYToX:typeof k.scrollYToX<"u"?k.scrollYToX:!1,mouseWheelScrollSensitivity:typeof k.mouseWheelScrollSensitivity<"u"?k.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof k.fastScrollSensitivity<"u"?k.fastScrollSensitivity:5,scrollPredominantAxis:typeof k.scrollPredominantAxis<"u"?k.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof k.mouseWheelSmoothScroll<"u"?k.mouseWheelSmoothScroll:!0,arrowSize:typeof k.arrowSize<"u"?k.arrowSize:11,listenOnDomNode:typeof k.listenOnDomNode<"u"?k.listenOnDomNode:null,horizontal:typeof k.horizontal<"u"?k.horizontal:1,horizontalScrollbarSize:typeof k.horizontalScrollbarSize<"u"?k.horizontalScrollbarSize:10,horizontalSliderSize:typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:0,horizontalHasArrows:typeof k.horizontalHasArrows<"u"?k.horizontalHasArrows:!1,vertical:typeof k.vertical<"u"?k.vertical:1,verticalScrollbarSize:typeof k.verticalScrollbarSize<"u"?k.verticalScrollbarSize:10,verticalHasArrows:typeof k.verticalHasArrows<"u"?k.verticalHasArrows:!1,verticalSliderSize:typeof k.verticalSliderSize<"u"?k.verticalSliderSize:0,scrollByPage:typeof k.scrollByPage<"u"?k.scrollByPage:!1};return T.horizontalSliderSize=typeof k.horizontalSliderSize<"u"?k.horizontalSliderSize:T.horizontalScrollbarSize,T.verticalSliderSize=typeof k.verticalSliderSize<"u"?k.verticalSliderSize:T.verticalScrollbarSize,c.$j&&(T.className+=" mac"),T}}),define(me[72],be([1,0,65,4,24,28,71,8,11,31,3,2,56,58,92,131,6,40]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i,o,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$4T=t.$3T=t.$2T=t.$1T=t.ListViewTargetSector=void 0;const f={CurrentDragAndDropData:void 0};var S;(function(q){q[q.TOP=0]="TOP",q[q.CENTER_TOP=1]="CENTER_TOP",q[q.CENTER_BOTTOM=2]="CENTER_BOTTOM",q[q.BOTTOM=3]="BOTTOM"})(S||(t.ListViewTargetSector=S={}));const m={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(q){return[q]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class b{get context(){return this.d}set context($){this.d=$}constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$1T=b;class r{constructor($){this.elements=$}update(){}getData(){return this.elements}}t.$2T=r;class D{constructor(){this.types=[],this.files=[]}update($){if($.types&&this.types.splice(0,this.types.length,...$.types),$.files){this.files.splice(0,this.files.length);for(let I=0;I<$.files.length;I++){const V=$.files.item(I);V&&(V.size||V.type)&&this.files.push(V)}}}getData(){return{types:this.types,files:this.files}}}t.$3T=D;function k(q,$){return Array.isArray(q)&&Array.isArray($)?(0,P.$ub)(q,$):q===$}class T{constructor($){$?.getSetSize?this.getSetSize=$.getSetSize.bind($):this.getSetSize=(I,V,N)=>N,$?.getPosInSet?this.getPosInSet=$.getPosInSet.bind($):this.getPosInSet=(I,V)=>V+1,$?.getRole?this.getRole=$.getRole.bind($):this.getRole=I=>"listitem",$?.isChecked?this.isChecked=$.isChecked.bind($):this.isChecked=I=>{}}}class L{static{this.c=0}get contentHeight(){return this.g.size}get contentWidth(){return this.E??0}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get Q(){return this.P}set Q($){if($!==this.P){if($&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.P=$,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.P){for(const I of this.d)this.ab(I);this.X(),this.q.setScrollDimensions({width:(0,C.$bS)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor($,I,V,N=m){if(this.R=I,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new d.$sh(50),this.v=!1,this.x=M.$Vc.None,this.y=0,this.G=!1,this.K=M.$Vc.None,this.L=M.$Vc.None,this.M=new M.$Uc,this.N=new w.$ee,this.O=new w.$ee,this.onDidChangeContentHeight=w.Event.latch(this.N.event,void 0,this.M),this.onDidChangeContentWidth=w.Event.latch(this.O.event,void 0,this.M),this.P=!1,N.horizontalScrolling&&N.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=this.S(N.paddingTop??0);for(const j of V)this.j.set(j.templateId,j);this.h=this.M.add(new i.$ZT(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof N.mouseSupport=="boolean"?N.mouseSupport:!0),this.P=N.horizontalScrolling??m.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.P),this.C=typeof N.paddingBottom>"u"?0:N.paddingBottom,this.D=new T(N.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(N.transformOptimization??m.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.M.add(H.$lT.addTarget(this.o)),this.p=this.M.add(new h.$Vs({forceIntegerValues:!0,smoothScrollDuration:N.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:j=>(0,C.$YR)((0,C.getWindow)(this.domNode),j)})),this.q=this.M.add(new A.$AT(this.o,{alwaysConsumeMouseWheel:N.alwaysConsumeMouseWheel??m.alwaysConsumeMouseWheel,horizontal:1,vertical:N.verticalScrollMode??m.verticalScrollMode,useShadows:N.useShadows??m.useShadows,mouseWheelScrollSensitivity:N.mouseWheelScrollSensitivity,fastScrollSensitivity:N.fastScrollSensitivity,scrollByPage:N.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),$.appendChild(this.domNode),this.q.onScroll(this.ib,this,this.M),this.M.add((0,C.$OR)(this.o,H.EventType.Change,j=>this.jb(j))),this.M.add((0,C.$OR)(this.q.getDomNode(),"scroll",j=>j.target.scrollTop=0)),this.M.add((0,C.$OR)(this.domNode,"dragover",j=>this.lb(this.hb(j)))),this.M.add((0,C.$OR)(this.domNode,"drop",j=>this.nb(this.hb(j)))),this.M.add((0,C.$OR)(this.domNode,"dragleave",j=>this.mb(this.hb(j)))),this.M.add((0,C.$OR)(this.domNode,"dragend",j=>this.ob(j))),this.z=N.setRowLineHeight??m.setRowLineHeight,this.A=N.setRowHeight??m.setRowHeight,this.B=N.supportDynamicHeights??m.supportDynamicHeights,this.F=N.dnd??this.M.add(m.dnd),this.layout(N.initialSize?.height,N.initialSize?.width)}updateOptions($){$.paddingBottom!==void 0&&(this.C=$.paddingBottom,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),$.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration($.smoothScrolling?125:0),$.horizontalScrolling!==void 0&&(this.Q=$.horizontalScrolling);let I;if($.scrollByPage!==void 0&&(I={...I??{},scrollByPage:$.scrollByPage}),$.mouseWheelScrollSensitivity!==void 0&&(I={...I??{},mouseWheelScrollSensitivity:$.mouseWheelScrollSensitivity}),$.fastScrollSensitivity!==void 0&&(I={...I??{},fastScrollSensitivity:$.fastScrollSensitivity}),I&&this.q.updateOptions(I),$.paddingTop!==void 0&&$.paddingTop!==this.g.paddingTop){const V=this.vb(this.k,this.m),N=$.paddingTop-this.g.paddingTop;this.g.paddingTop=$.paddingTop,this.Y(V,Math.max(0,this.k+N),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}}delegateScrollFromMouseWheelEvent($){this.q.delegateScrollFromMouseWheelEvent($)}delegateVerticalScrollbarPointerDown($){this.q.delegateVerticalScrollbarPointerDown($)}updateElementHeight($,I,V){if($<0||$>=this.d.length)return;const N=this.d[$].size;if(typeof I>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[$].lastDynamicHeightWidth=void 0,I=N+this.xb($)}if(N===I)return;const x=this.vb(this.k,this.m);let j=0;$<x.start||V!==null&&V>$&&V<x.end?j=I-N:j=0,this.g.splice($,1,[{size:I}]),this.d[$].size=I,this.Y(x,Math.max(0,this.k+j),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.V(),this.B&&this.wb(this.k,this.m)}S($){return new e.$YT($)}splice($,I,V=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.U($,I,V)}finally{this.v=!1,this.N.fire(this.contentHeight)}}U($,I,V=[]){const N=this.vb(this.k,this.m),x={start:$,end:$+I},j=c.Range.intersect(N,x),Y=new Map;for(let W=j.end-1;W>=j.start;W--){const Q=this.d[W];if(Q.dragStartDisposable.dispose(),Q.checkedDisposable.dispose(),Q.row){let ge=Y.get(Q.templateId);ge||(ge=[],Y.set(Q.templateId,ge));const we=this.j.get(Q.templateId);we&&we.disposeElement&&we.disposeElement(Q.element,W,Q.row.templateData,Q.size),ge.unshift(Q.row)}Q.row=null,Q.stale=!0}const K={start:$+I,end:this.d.length},ae=c.Range.intersect(K,N),ie=c.Range.relativeComplement(K,N),ee=V.map(W=>({id:String(this.f++),element:W,templateId:this.R.getTemplateId(W),size:this.R.getHeight(W),width:void 0,hasDynamicHeight:!!this.R.hasDynamicHeight&&this.R.hasDynamicHeight(W),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:M.$Vc.None,checkedDisposable:M.$Vc.None,stale:!1}));let ce;$===0&&I>=this.d.length?(this.g=this.S(this.g.paddingTop),this.g.splice(0,0,ee),ce=this.d,this.d=ee):(this.g.splice($,I,ee),ce=this.d.splice($,I,...ee));const De=V.length-I,Ee=this.vb(this.k,this.m),Le=(0,e.$WT)(ae,De),le=c.Range.intersect(Ee,Le);for(let W=le.start;W<le.end;W++)this.bb(this.d[W],W);const _=c.Range.relativeComplement(Le,Ee);for(const W of _)for(let Q=W.start;Q<W.end;Q++)this.db(Q);const ue=ie.map(W=>(0,e.$WT)(W,De)),ye=[{start:$,end:$+V.length},...ue].map(W=>c.Range.intersect(Ee,W)).reverse();for(const W of ye)for(let Q=W.end-1;Q>=W.start;Q--){const ge=this.d[Q],ke=Y.get(ge.templateId)?.pop();this.Z(Q,ke)}for(const W of Y.values())for(const Q of W)this.h.release(Q);return this.V(),this.B&&this.wb(this.scrollTop,this.renderHeight),ce.map(W=>W.element)}V(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,C.$YR)((0,C.getWindow)(this.domNode),()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.X(),this.t=null}))}W(){if(!this.Q){this.u.cancel();return}this.u.trigger(()=>this.X())}X(){if(!this.Q)return;let $=0;for(const I of this.d)typeof I.width<"u"&&($=Math.max($,I.width));this.E=$,this.q.setScrollDimensions({scrollWidth:$===0?0:$+10}),this.O.fire(this.E)}updateWidth($){if(!this.Q||typeof this.E>"u")return;const I=this.d[$];this.ab(I),typeof I.width<"u"&&I.width>this.E&&(this.E=I.width,this.q.setScrollDimensions({scrollWidth:this.E+10}),this.O.fire(this.E))}rerender(){if(this.B){for(const $ of this.d)$.lastDynamicHeightWidth=void 0;this.wb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){return this.vb(this.k,this.m).start}get firstMostlyVisibleIndex(){const $=this.firstVisibleIndex,I=this.g.positionAt($),V=this.g.positionAt($+1);return V!==-1&&(V-I)/2+I<this.scrollTop?$+1:$}get lastVisibleIndex(){return this.vb(this.k,this.m).end-1}element($){return this.d[$].element}indexOf($){return this.d.findIndex(I=>I.element===$)}domElement($){const I=this.d[$].row;return I&&I.domNode}elementHeight($){return this.d[$].size}elementTop($){return this.g.positionAt($)}indexAt($){return this.g.indexAt($)}indexAfter($){return this.g.indexAfter($)}layout($,I){const V={height:typeof $=="number"?$:(0,C.$dS)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,V.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(V),typeof I<"u"&&(this.n=I,this.B&&this.wb(this.scrollTop,this.renderHeight)),this.Q&&this.q.setScrollDimensions({width:typeof I=="number"?I:(0,C.$bS)(this.domNode)})}Y($,I,V,N,x,j=!1){const Y=this.vb(I,V),K=c.Range.relativeComplement(Y,$).reverse(),ae=c.Range.relativeComplement($,Y);if(j){const ie=c.Range.intersect($,Y);for(let ee=ie.start;ee<ie.end;ee++)this.bb(this.d[ee],ee)}this.h.transact(()=>{for(const ie of ae)for(let ee=ie.start;ee<ie.end;ee++)this.db(ee);for(const ie of K)for(let ee=ie.end-1;ee>=ie.start;ee--)this.Z(ee)}),N!==void 0&&(this.o.style.left=`-${N}px`),this.o.style.top=`-${I}px`,this.Q&&x!==void 0&&(this.o.style.width=`${Math.max(x,this.n)}px`),this.k=I,this.m=V}Z($,I){const V=this.d[$];if(!V.row)if(I)V.row=I,V.stale=!0;else{const K=this.h.alloc(V.templateId);V.row=K.row,V.stale||=K.isReusingConnectedDomNode}const N=this.D.getRole(V.element)||"listitem";V.row.domNode.setAttribute("role",N);const x=this.D.isChecked(V.element);if(typeof x=="boolean")V.row.domNode.setAttribute("aria-checked",String(!!x));else if(x){const K=ae=>V.row.domNode.setAttribute("aria-checked",String(!!ae));K(x.value),V.checkedDisposable=x.onDidChange(()=>K(x.value))}if(V.stale||!V.row.domNode.parentElement){const K=this.d.at($+1)?.row?.domNode??null;(V.row.domNode.parentElement!==this.o||V.row.domNode.nextElementSibling!==K)&&this.o.insertBefore(V.row.domNode,K),V.stale=!1}this.bb(V,$);const j=this.j.get(V.templateId);if(!j)throw new Error(`No renderer found for template id ${V.templateId}`);j?.renderElement(V.element,$,V.row.templateData,V.size);const Y=this.F.getDragURI(V.element);V.dragStartDisposable.dispose(),V.row.domNode.draggable=!!Y,Y&&(V.dragStartDisposable=(0,C.$OR)(V.row.domNode,"dragstart",K=>this.kb(V.element,Y,K))),this.Q&&(this.ab(V),this.W())}ab($){if(!$.row||!$.row.domNode)return;$.row.domNode.style.width="fit-content",$.width=(0,C.$bS)($.row.domNode);const I=(0,C.getWindow)($.row.domNode).getComputedStyle($.row.domNode);I.paddingLeft&&($.width+=parseFloat(I.paddingLeft)),I.paddingRight&&($.width+=parseFloat(I.paddingRight)),$.row.domNode.style.width=""}bb($,I){$.row.domNode.style.top=`${this.elementTop(I)}px`,this.A&&($.row.domNode.style.height=`${$.size}px`),this.z&&($.row.domNode.style.lineHeight=`${$.size}px`),$.row.domNode.setAttribute("data-index",`${I}`),$.row.domNode.setAttribute("data-last-element",I===this.length-1?"true":"false"),$.row.domNode.setAttribute("data-parity",I%2===0?"even":"odd"),$.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize($.element,I,this.length))),$.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet($.element,I))),$.row.domNode.setAttribute("id",this.getElementDomId(I)),$.row.domNode.classList.toggle("drop-target",$.dropTarget)}db($){const I=this.d[$];if(I.dragStartDisposable.dispose(),I.checkedDisposable.dispose(),I.row){const V=this.j.get(I.templateId);V&&V.disposeElement&&V.disposeElement(I.element,$,I.row.templateData,I.size),this.h.release(I.row),I.row=null}this.Q&&this.W()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop($,I){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:$,reuseAnimation:I})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft($){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:$})}get scrollTop(){return this.getScrollTop()}set scrollTop($){this.setScrollTop($)}get scrollHeight(){return this.s+(this.Q?10:0)+this.C}get onMouseClick(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"click")).event,$=>this.eb($),this.M)}get onMouseDblClick(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"dblclick")).event,$=>this.eb($),this.M)}get onMouseMiddleClick(){return w.Event.filter(w.Event.map(this.M.add(new B.$QT(this.domNode,"auxclick")).event,$=>this.eb($),this.M),$=>$.browserEvent.button===1,this.M)}get onMouseUp(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"mouseup")).event,$=>this.eb($),this.M)}get onMouseDown(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"mousedown")).event,$=>this.eb($),this.M)}get onMouseOver(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"mouseover")).event,$=>this.eb($),this.M)}get onMouseMove(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"mousemove")).event,$=>this.eb($),this.M)}get onMouseOut(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"mouseout")).event,$=>this.eb($),this.M)}get onContextMenu(){return w.Event.any(w.Event.map(this.M.add(new B.$QT(this.domNode,"contextmenu")).event,$=>this.eb($),this.M),w.Event.map(this.M.add(new B.$QT(this.domNode,H.EventType.Contextmenu)).event,$=>this.gb($),this.M))}get onTouchStart(){return w.Event.map(this.M.add(new B.$QT(this.domNode,"touchstart")).event,$=>this.fb($),this.M)}get onTap(){return w.Event.map(this.M.add(new B.$QT(this.o,H.EventType.Tap)).event,$=>this.gb($),this.M)}eb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],N=V&&V.element;return{browserEvent:$,index:I,element:N}}fb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],N=V&&V.element;return{browserEvent:$,index:I,element:N}}gb($){const I=this.ub($.initialTarget||null),V=typeof I>"u"?void 0:this.d[I],N=V&&V.element;return{browserEvent:$,index:I,element:N}}hb($){const I=this.ub($.target||null),V=typeof I>"u"?void 0:this.d[I],N=V&&V.element,x=this.tb($,I);return{browserEvent:$,index:I,element:N,sector:x}}ib($){try{const I=this.vb(this.k,this.m);this.Y(I,$.scrollTop,$.height,$.scrollLeft,$.scrollWidth),this.B&&this.wb($.scrollTop,$.height,$.inSmoothScrolling)}catch(I){throw console.error("Got bad scroll event:",$),I}}jb($){$.preventDefault(),$.stopPropagation(),this.scrollTop-=$.translationY}kb($,I,V){if(!V.dataTransfer)return;const N=this.F.getDragElements($);if(V.dataTransfer.effectAllowed="copyMove",V.dataTransfer.setData(n.$jT.TEXT,I),V.dataTransfer.setDragImage){let x;this.F.getDragLabel&&(x=this.F.getDragLabel(N,V)),typeof x>"u"&&(x=String(N.length));const j=(0,C.$)(".monaco-drag-image");j.textContent=x;const K=(ae=>{for(;ae&&!ae.classList.contains("monaco-workbench");)ae=ae.parentElement;return ae||this.domNode.ownerDocument})(this.domNode);K.appendChild(j),V.dataTransfer.setDragImage(j,-10,-10),setTimeout(()=>K.removeChild(j),0)}this.domNode.classList.add("dragging"),this.H=new b(N),f.CurrentDragAndDropData=new r(N),this.F.onDragStart?.(this.H,V)}lb($){if($.browserEvent.preventDefault(),this.L.dispose(),f.CurrentDragAndDropData&&f.CurrentDragAndDropData.getData()==="vscode-ui"||(this.qb($.browserEvent),!$.browserEvent.dataTransfer))return!1;if(!this.H)if(f.CurrentDragAndDropData)this.H=f.CurrentDragAndDropData;else{if(!$.browserEvent.dataTransfer.types)return!1;this.H=new D}const I=this.F.onDragOver(this.H,$.element,$.index,$.sector,$.browserEvent);if(this.G=typeof I=="boolean"?I:I.accept,!this.G)return this.I=void 0,this.K.dispose(),!1;$.browserEvent.dataTransfer.dropEffect=typeof I!="boolean"&&I.effect?.type===0?"copy":"move";let V;typeof I!="boolean"&&I.feedback?V=I.feedback:typeof $.index>"u"?V=[-1]:V=[$.index],V=(0,P.$Mb)(V).filter(x=>x>=-1&&x<this.length).sort((x,j)=>x-j),V=V[0]===-1?[-1]:V;let N=typeof I!="boolean"&&I.effect&&I.effect.position?I.effect.position:"drop-target";if(k(this.I,V)&&this.J===N)return!0;if(this.I=V,this.J=N,this.K.dispose(),V[0]===-1)this.domNode.classList.add(N),this.o.classList.add(N),this.K=(0,M.$Tc)(()=>{this.domNode.classList.remove(N),this.o.classList.remove(N)});else{if(V.length>1&&N!=="drop-target")throw new Error("Can't use multiple feedbacks with position different than 'over'");N==="drop-target-after"&&V[0]<this.length-1&&(V[0]+=1,N="drop-target-before");for(const x of V){const j=this.d[x];j.dropTarget=!0,j.row?.domNode.classList.add(N)}this.K=(0,M.$Tc)(()=>{for(const x of V){const j=this.d[x];j.dropTarget=!1,j.row?.domNode.classList.remove(N)}})}return!0}mb($){this.L.dispose(),this.L=(0,d.$xh)(()=>this.pb(),100,this.M),this.H&&this.F.onDragLeave?.(this.H,$.element,$.index,$.browserEvent)}nb($){if(!this.G)return;const I=this.H;this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,!(!I||!$.browserEvent.dataTransfer)&&($.browserEvent.preventDefault(),I.update($.browserEvent.dataTransfer),this.F.drop(I,$.element,$.index,$.sector,$.browserEvent))}ob($){this.G=!1,this.sb(),this.pb(),this.domNode.classList.remove("dragging"),this.H=void 0,f.CurrentDragAndDropData=void 0,this.F.onDragEnd?.($)}pb(){this.I=void 0,this.J=void 0,this.K.dispose(),this.K=M.$Vc.None}qb($){if(!this.w){const I=(0,C.$8R)(this.domNode).top;this.w=(0,C.$4S)((0,C.getWindow)(this.domNode),this.rb.bind(this,I))}this.x.dispose(),this.x=(0,d.$xh)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3,this.M),this.y=$.pageY}rb($){if(this.y===void 0)return;const I=this.y-$,V=this.renderHeight-35;I<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(I-35))):I>V&&(this.scrollTop+=Math.min(14,Math.floor(.3*(I-V))))}sb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}tb($,I){if(I===void 0)return;const V=$.offsetY/this.d[I].size,N=Math.floor(V/.25);return(0,l.$Am)(N,0,3)}ub($){const I=this.q.getDomNode();let V=$;for(;V instanceof HTMLElement&&V!==this.o&&I.contains(V);){const N=V.getAttribute("data-index");if(N){const x=Number(N);if(!isNaN(x))return x}V=V.parentElement}}vb($,I){return{start:this.g.indexAt($),end:this.g.indexAfter($+I-1)}}wb($,I,V){const N=this.vb($,I);let x,j;$===this.elementTop(N.start)?(x=N.start,j=0):N.end-N.start>1&&(x=N.start+1,j=this.elementTop(x)-$);let Y=0;for(;;){const K=this.vb($,I);let ae=!1;for(let ie=K.start;ie<K.end;ie++){const ee=this.xb(ie);ee!==0&&this.g.splice(ie,1,[this.d[ie]]),Y+=ee,ae=ae||ee!==0}if(!ae){Y!==0&&this.V();const ie=c.Range.relativeComplement(N,K);for(const ce of ie)for(let De=ce.start;De<ce.end;De++)this.d[De].row&&this.db(De);const ee=c.Range.relativeComplement(K,N).reverse();for(const ce of ee)for(let De=ce.end-1;De>=ce.start;De--)this.Z(De);for(let ce=K.start;ce<K.end;ce++)this.d[ce].row&&this.bb(this.d[ce],ce);if(typeof x=="number"){const ce=this.p.getFutureScrollPosition().scrollTop-$,De=this.elementTop(x)-j+ce;this.setScrollTop(De,V)}this.N.fire(this.contentHeight);return}}}xb($){const I=this.d[$];if(this.R.getDynamicHeight){const j=this.R.getDynamicHeight(I.element);if(j!==null){const Y=I.size;return I.size=j,I.lastDynamicHeightWidth=this.n,j-Y}}if(!I.hasDynamicHeight||I.lastDynamicHeightWidth===this.n||this.R.hasDynamicHeight&&!this.R.hasDynamicHeight(I.element))return 0;const V=I.size;if(I.row)return I.row.domNode.style.height="",I.size=I.row.domNode.offsetHeight,I.size===0&&!(0,C.$gS)(I.row.domNode,(0,C.getWindow)(I.row.domNode).document.body)&&console.warn("Measuring item node that is not in DOM! Add ListView to the DOM before measuring row height!"),I.lastDynamicHeightWidth=this.n,I.size-V;const{row:N}=this.h.alloc(I.templateId);N.domNode.style.height="",this.o.appendChild(N.domNode);const x=this.j.get(I.templateId);if(!x)throw new o.$cb("Missing renderer for templateId: "+I.templateId);return x.renderElement(I.element,$,N.templateData,void 0),I.size=N.domNode.offsetHeight,x.disposeElement?.(I.element,$,N.templateData,void 0),this.R.setDynamicHeight?.(I.element,I.size),I.lastDynamicHeightWidth=this.n,this.o.removeChild(N.domNode),this.h.release(N),I.size-V}getElementDomId($){return`${this.domId}_${$}`}dispose(){for(const $ of this.d)if($.dragStartDisposable.dispose(),$.checkedDisposable.dispose(),$.row){const I=this.j.get($.row.templateId);I&&(I.disposeElement?.($.element,-1,$.row.templateData,void 0),I.disposeTemplate($.row.templateData))}this.d=[],this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),this.w?.dispose(),this.M.dispose()}}t.$4T=L,Ze([g.$Zh],L.prototype,"onMouseClick",null),Ze([g.$Zh],L.prototype,"onMouseDblClick",null),Ze([g.$Zh],L.prototype,"onMouseMiddleClick",null),Ze([g.$Zh],L.prototype,"onMouseUp",null),Ze([g.$Zh],L.prototype,"onMouseDown",null),Ze([g.$Zh],L.prototype,"onMouseOver",null),Ze([g.$Zh],L.prototype,"onMouseMove",null),Ze([g.$Zh],L.prototype,"onMouseOut",null),Ze([g.$Zh],L.prototype,"onContextMenu",null),Ze([g.$Zh],L.prototype,"onTouchStart",null),Ze([g.$Zh],L.prototype,"onTap",null)}),define(me[49],be([1,0,4,24,15,28,68,81,8,11,84,31,3,44,2,40,5,10,80,72,20,57,110]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i,o,l,f,S,m,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$jU=t.$iU=t.$hU=t.$gU=t.$dU=t.TypeNavigationMode=void 0,t.$8T=L,t.$9T=$,t.$0T=I,t.$$T=V,t.$_T=N,t.$aU=x,t.$bU=j,t.$cU=Y,t.$eU=De,t.$fU=Ee;class r{constructor(u){this.d=u,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(u){return u}renderElement(u,y,a){const v=this.c.findIndex(F=>F.templateData===a);if(v>=0){const F=this.c[v];this.d.unrender(a),F.index=y}else{const F={index:y,templateData:a};this.c.push(F)}this.d.renderIndex(y,a)}splice(u,y,a){const v=[];for(const F of this.c)F.index<u?v.push(F):F.index>=u+y&&v.push({index:F.index+a-y,templateData:F.templateData});this.c=v}renderIndexes(u){for(const{index:y,templateData:a}of this.c)u.indexOf(y)>-1&&this.d.renderIndex(y,a)}disposeTemplate(u){const y=this.c.findIndex(a=>a.templateData===u);y<0||this.c.splice(y,1)}}class D{get name(){return this.g}get renderer(){return new r(this)}constructor(u){this.g=u,this.c=[],this.d=[],this.f=new c.$ee,this.onChange=this.f.event}splice(u,y,a){const v=a.length-y,F=u+y,s=[];let E=0;for(;E<this.d.length&&this.d[E]<u;)s.push(this.d[E++]);for(let p=0;p<a.length;p++)a[p]&&s.push(p+u);for(;E<this.d.length&&this.d[E]>=F;)s.push(this.d[E++]+v);this.renderer.splice(u,y,a.length),this.h(s,s)}renderIndex(u,y){y.classList.toggle(this.g,this.contains(u))}unrender(u){u.classList.remove(this.g)}set(u,y){return this.h(u,[...u].sort(ge),y)}h(u,y,a){const v=this.c,F=this.d;this.c=u,this.d=y;const s=W(F,u);return this.renderer.renderIndexes(s),this.f.fire({indexes:u,browserEvent:a}),v}get(){return this.c}contains(u){return(0,d.$wb)(this.d,u,ge)>=0}dispose(){(0,e.$Qc)(this.f)}}Ze([M.$Zh],D.prototype,"renderer",null);class k extends D{constructor(u){super("selected"),this.k=u}renderIndex(u,y){super.renderIndex(u,y),this.k&&(this.contains(u)?y.setAttribute("aria-selected","true"):y.setAttribute("aria-selected","false"))}}class T{constructor(u,y,a){this.c=u,this.d=y,this.f=a}splice(u,y,a){if(!this.f)return this.c.splice(u,y,new Array(a.length).fill(!1));const v=this.c.get().map(E=>this.f.getId(this.d.element(E)).toString());if(v.length===0)return this.c.splice(u,y,new Array(a.length).fill(!1));const F=new Set(v),s=a.map(E=>F.has(this.f.getId(E).toString()));this.c.splice(u,y,s)}}function L(z){return z.tagName==="INPUT"||z.tagName==="TEXTAREA"}function q(z,u){return z.classList.contains(u)?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:q(z.parentElement,u)}function $(z){return q(z,"monaco-editor")}function I(z){return q(z,"monaco-custom-toggle")}function V(z){return q(z,"action-item")}function N(z){return q(z,"monaco-tl-twistie")}function x(z){return q(z,"monaco-tree-sticky-row")}function j(z){return z.classList.contains("monaco-tree-sticky-container")}function Y(z){return z.tagName==="A"&&z.classList.contains("monaco-button")||z.tagName==="DIV"&&z.classList.contains("monaco-button-dropdown")?!0:z.classList.contains("monaco-list")||!z.parentElement?!1:Y(z.parentElement)}class K{get g(){return c.Event.chain(this.c.add(new C.$QT(this.k.domNode,"keydown")).event,u=>u.filter(y=>!L(y.target)).map(y=>new B.$LR(y)))}constructor(u,y,a){this.h=u,this.k=y,this.c=new e.$Uc,this.d=new e.$Uc,this.f=a.multipleSelectionSupport,this.c.add(this.g(v=>{switch(v.keyCode){case 3:return this.l(v);case 16:return this.o(v);case 18:return this.p(v);case 11:return this.q(v);case 12:return this.s(v);case 9:return this.u(v);case 31:this.f&&(o.$j?v.metaKey:v.ctrlKey)&&this.t(v)}}))}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.f=u.multipleSelectionSupport)}l(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection(this.h.getFocus(),u.browserEvent)}o(u){u.preventDefault(),u.stopPropagation(),this.h.focusPrevious(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}p(u){u.preventDefault(),u.stopPropagation(),this.h.focusNext(1,!1,u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}q(u){u.preventDefault(),u.stopPropagation(),this.h.focusPreviousPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}s(u){u.preventDefault(),u.stopPropagation(),this.h.focusNextPage(u.browserEvent);const y=this.h.getFocus()[0];this.h.setAnchor(y),this.h.reveal(y),this.k.domNode.focus()}t(u){u.preventDefault(),u.stopPropagation(),this.h.setSelection((0,d.$Sb)(this.h.length),u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus()}u(u){this.h.getSelection().length&&(u.preventDefault(),u.stopPropagation(),this.h.setSelection([],u.browserEvent),this.h.setAnchor(void 0),this.k.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}Ze([M.$Zh],K.prototype,"g",null);var ae;(function(z){z[z.Automatic=0]="Automatic",z[z.Trigger=1]="Trigger"})(ae||(t.TypeNavigationMode=ae={}));var ie;(function(z){z[z.Idle=0]="Idle",z[z.Typing=1]="Typing"})(ie||(ie={})),t.$dU=new class{mightProducePrintableCharacter(z){return z.ctrlKey||z.metaKey||z.altKey?!1:z.keyCode>=31&&z.keyCode<=56||z.keyCode>=21&&z.keyCode<=30||z.keyCode>=98&&z.keyCode<=107||z.keyCode>=85&&z.keyCode<=95}};class ee{constructor(u,y,a,v,F){this.o=u,this.p=y,this.q=a,this.s=v,this.t=F,this.c=!1,this.d=ie.Idle,this.f=ae.Automatic,this.g=!1,this.h=-1,this.k=new e.$Uc,this.l=new e.$Uc,this.updateOptions(u.options)}updateOptions(u){u.typeNavigationEnabled??!0?this.u():this.v(),this.f=u.typeNavigationMode??ae.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let u=!1;const y=c.Event.chain(this.k.add(new C.$QT(this.p.domNode,"keydown")).event,F=>F.filter(s=>!L(s.target)).filter(()=>this.f===ae.Automatic||this.g).map(s=>new B.$LR(s)).filter(s=>u||this.s(s)).filter(s=>this.t.mightProducePrintableCharacter(s)).forEach(s=>n.$JS.stop(s,!0)).map(s=>s.browserEvent.key)),a=c.Event.debounce(y,()=>null,800,void 0,void 0,void 0,this.k);c.Event.reduce(c.Event.any(y,a),(F,s)=>s===null?null:(F||"")+s,void 0,this.k)(this.x,this,this.k),a(this.w,this,this.k),y(()=>u=!0,void 0,this.k),a(()=>u=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const u=this.o.getFocus();if(u.length>0&&u[0]===this.h){const y=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(u[0]));typeof y=="string"?(0,A.$ST)(y):y&&(0,A.$ST)(y.get())}this.h=-1}x(u){if(!u){this.d=ie.Idle,this.g=!1;return}const y=this.o.getFocus(),a=y.length>0?y[0]:0,v=this.d===ie.Idle?1:0;this.d=ie.Typing;for(let F=0;F<this.o.length;F++){const s=(a+F+v)%this.o.length,E=this.q.getKeyboardNavigationLabel(this.p.element(s)),p=E&&E.toString();if(this.o.options.typeNavigationEnabled){if(typeof p<"u"){if((0,h.$xk)(u,p)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}const R=(0,h.$Ek)(u,p);if(R&&R[0].end-R[0].start>1&&R.length===1){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}else if(typeof p>"u"||(0,h.$xk)(u,p)){this.h=a,this.o.setFocus([s]),this.o.reveal(s);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class ce{constructor(u,y){this.d=u,this.f=y,this.c=new e.$Uc;const a=c.Event.chain(this.c.add(new C.$QT(y.domNode,"keydown")).event,F=>F.filter(s=>!L(s.target)).map(s=>new B.$LR(s)));c.Event.chain(a,F=>F.filter(s=>s.keyCode===2&&!s.ctrlKey&&!s.metaKey&&!s.shiftKey&&!s.altKey))(this.g,this,this.c)}g(u){if(u.target!==this.f.domNode)return;const y=this.d.getFocus();if(y.length===0)return;const a=this.f.domElement(y[0]);if(!a)return;const v=a.querySelector("[tabIndex]");if(!v||!(v instanceof HTMLElement)||v.tabIndex===-1)return;const F=(0,n.getWindow)(v).getComputedStyle(v);F.visibility==="hidden"||F.display==="none"||(u.preventDefault(),u.stopPropagation(),v.focus())}dispose(){this.c.dispose()}}function De(z){return o.$j?z.browserEvent.metaKey:z.browserEvent.ctrlKey}function Ee(z){return z.browserEvent.shiftKey}function Le(z){return(0,n.$DS)(z)&&z.button===2}const le={isSelectionSingleChangeEvent:De,isSelectionRangeChangeEvent:Ee};class _{constructor(u){this.k=u,this.f=new e.$Uc,this.g=new c.$ee,this.onPointer=this.g.event,u.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||le),this.d=typeof u.options.mouseSupport>"u"||!!u.options.mouseSupport,this.d&&(u.onMouseDown(this.s,this,this.f),u.onContextMenu(this.t,this,this.f),u.onMouseDblClick(this.v,this,this.f),u.onTouchStart(this.s,this,this.f),this.f.add(H.$lT.addTarget(u.getHTMLElement()))),c.Event.any(u.onMouseClick,u.onMouseMiddleClick,u.onTap)(this.u,this,this.f)}updateOptions(u){u.multipleSelectionSupport!==void 0&&(this.c=void 0,u.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||le))}o(u){return this.c?this.c.isSelectionSingleChangeEvent(u):!1}p(u){return this.c?this.c.isSelectionRangeChangeEvent(u):!1}q(u){return this.o(u)||this.p(u)}s(u){$(u.browserEvent.target)||(0,n.$oS)()!==u.browserEvent.target&&this.k.domFocus()}t(u){if(L(u.browserEvent.target)||$(u.browserEvent.target))return;const y=typeof u.index>"u"?[]:[u.index];this.k.setFocus(y,u.browserEvent)}u(u){if(!this.d||L(u.browserEvent.target)||$(u.browserEvent.target)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=u.index;if(typeof y>"u"){this.k.setFocus([],u.browserEvent),this.k.setSelection([],u.browserEvent),this.k.setAnchor(void 0);return}if(this.q(u))return this.w(u);this.k.setFocus([y],u.browserEvent),this.k.setAnchor(y),Le(u.browserEvent)||this.k.setSelection([y],u.browserEvent),this.g.fire(u)}v(u){if(L(u.browserEvent.target)||$(u.browserEvent.target)||this.q(u)||u.browserEvent.isHandledByList)return;u.browserEvent.isHandledByList=!0;const y=this.k.getFocus();this.k.setSelection(y,u.browserEvent)}w(u){const y=u.index;let a=this.k.getAnchor();if(this.p(u)){typeof a>"u"&&(a=this.k.getFocus()[0]??y,this.k.setAnchor(a));const v=Math.min(a,y),F=Math.max(a,y),s=(0,d.$Sb)(v,F+1),E=this.k.getSelection(),p=ye(W(E,[a]),a);if(p.length===0)return;const R=W(s,Q(E,p));this.k.setSelection(R,u.browserEvent),this.k.setFocus([y],u.browserEvent)}else if(this.o(u)){const v=this.k.getSelection(),F=v.filter(s=>s!==y);this.k.setFocus([y]),this.k.setAnchor(y),v.length===F.length?this.k.setSelection([...F,y],u.browserEvent):this.k.setSelection(F,u.browserEvent)}}dispose(){this.f.dispose()}}t.$gU=_;class ue{constructor(u,y){this.c=u,this.d=y}style(u){const y=this.d&&`.${this.d}`,a=[];u.listBackground&&a.push(`.monaco-list${y} .monaco-list-rows { background: ${u.listBackground}; }`),u.listFocusBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.focused { background-color: ${u.listFocusBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.focused:hover { background-color: ${u.listFocusBackground}; }`)),u.listFocusForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused { color: ${u.listFocusForeground}; }`),u.listActiveSelectionBackground&&(a.push(`.monaco-list${y}:focus .monaco-list-row.selected { background-color: ${u.listActiveSelectionBackground}; }`),a.push(`.monaco-list${y}:focus .monaco-list-row.selected:hover { background-color: ${u.listActiveSelectionBackground}; }`)),u.listActiveSelectionForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected { color: ${u.listActiveSelectionForeground}; }`),u.listActiveSelectionIconForeground&&a.push(`.monaco-list${y}:focus .monaco-list-row.selected .codicon { color: ${u.listActiveSelectionIconForeground}; }`),u.listFocusAndSelectionBackground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { background-color: ${u.listFocusAndSelectionBackground}; }
			`),u.listFocusAndSelectionForeground&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.selected.focused { color: ${u.listFocusAndSelectionForeground}; }
			`),u.listInactiveFocusForeground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { color:  ${u.listInactiveFocusForeground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { color:  ${u.listInactiveFocusForeground}; }`)),u.listInactiveSelectionIconForeground&&a.push(`.monaco-list${y} .monaco-list-row.focused .codicon { color:  ${u.listInactiveSelectionIconForeground}; }`),u.listInactiveFocusBackground&&(a.push(`.monaco-list${y} .monaco-list-row.focused { background-color:  ${u.listInactiveFocusBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.focused:hover { background-color:  ${u.listInactiveFocusBackground}; }`)),u.listInactiveSelectionBackground&&(a.push(`.monaco-list${y} .monaco-list-row.selected { background-color:  ${u.listInactiveSelectionBackground}; }`),a.push(`.monaco-list${y} .monaco-list-row.selected:hover { background-color:  ${u.listInactiveSelectionBackground}; }`)),u.listInactiveSelectionForeground&&a.push(`.monaco-list${y} .monaco-list-row.selected { color: ${u.listInactiveSelectionForeground}; }`),u.listHoverBackground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${u.listHoverBackground}; }`),u.listHoverForeground&&a.push(`.monaco-list${y}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${u.listHoverForeground}; }`);const v=(0,n.$7S)(u.listFocusAndSelectionOutline,(0,n.$7S)(u.listSelectionOutline,u.listFocusOutline??""));v&&a.push(`.monaco-list${y}:focus .monaco-list-row.focused.selected { outline: 1px solid ${v}; outline-offset: -1px;}`),u.listFocusOutline&&a.push(`
				.monaco-drag-image,
				.monaco-list${y}:focus .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${y}.last-focused .monaco-list-row.focused { outline: 1px solid ${u.listFocusOutline}; outline-offset: -1px; }
			`);const F=(0,n.$7S)(u.listSelectionOutline,u.listInactiveFocusOutline??"");F&&a.push(`.monaco-list${y} .monaco-list-row.focused.selected { outline: 1px dotted ${F}; outline-offset: -1px; }`),u.listSelectionOutline&&a.push(`.monaco-list${y} .monaco-list-row.selected { outline: 1px dotted ${u.listSelectionOutline}; outline-offset: -1px; }`),u.listInactiveFocusOutline&&a.push(`.monaco-list${y} .monaco-list-row.focused { outline: 1px dotted ${u.listInactiveFocusOutline}; outline-offset: -1px; }`),u.listHoverOutline&&a.push(`.monaco-list${y} .monaco-list-row:hover { outline: 1px dashed ${u.listHoverOutline}; outline-offset: -1px; }`),u.listDropOverBackground&&a.push(`
				.monaco-list${y}.drop-target,
				.monaco-list${y} .monaco-list-rows.drop-target,
				.monaco-list${y} .monaco-list-row.drop-target { background-color: ${u.listDropOverBackground} !important; color: inherit !important; }
			`),u.listDropBetweenBackground&&(a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-before .monaco-list-row:first-child::before,
			.monaco-list${y} .monaco-list-row.drop-target-before::before {
				content: ""; position: absolute; top: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`),a.push(`
			.monaco-list${y} .monaco-list-rows.drop-target-after .monaco-list-row:last-child::after,
			.monaco-list${y} .monaco-list-row.drop-target-after::after {
				content: ""; position: absolute; bottom: 0px; left: 0px; width: 100%; height: 1px;
				background-color: ${u.listDropBetweenBackground};
			}`)),u.tableColumnsBorder&&a.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${u.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),u.tableOddRowsBackgroundColor&&a.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${u.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=a.join(`
`)}}t.$hU=ue,t.$iU={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropOverBackground:"#383B3D",listDropBetweenBackground:"#EEEEEE",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:w.$Ot.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:w.$Ot.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:w.$Ot.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0,treeStickyScrollBackground:void 0,treeStickyScrollBorder:void 0,treeStickyScrollShadow:void 0};const re={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){},dispose(){}}};function ye(z,u){const y=z.indexOf(u);if(y===-1)return[];const a=[];let v=y-1;for(;v>=0&&z[v]===u-(y-v);)a.push(z[v--]);for(a.reverse(),v=y;v<z.length&&z[v]===u+(v-y);)a.push(z[v++]);return a}function W(z,u){const y=[];let a=0,v=0;for(;a<z.length||v<u.length;)if(a>=z.length)y.push(u[v++]);else if(v>=u.length)y.push(z[a++]);else if(z[a]===u[v]){y.push(z[a]),a++,v++;continue}else z[a]<u[v]?y.push(z[a++]):y.push(u[v++]);return y}function Q(z,u){const y=[];let a=0,v=0;for(;a<z.length||v<u.length;)if(a>=z.length)y.push(u[v++]);else if(v>=u.length)y.push(z[a++]);else if(z[a]===u[v]){a++,v++;continue}else z[a]<u[v]?y.push(z[a++]):v++;return y}const ge=(z,u)=>z-u;class we{constructor(u,y){this.c=u,this.d=y}get templateId(){return this.c}renderTemplate(u){return this.d.map(y=>y.renderTemplate(u))}renderElement(u,y,a,v){let F=0;for(const s of this.d)s.renderElement(u,y,a[F++],v)}disposeElement(u,y,a,v){let F=0;for(const s of this.d)s.disposeElement?.(u,y,a[F],v),F+=1}disposeTemplate(u){let y=0;for(const a of this.d)a.disposeTemplate(u[y++])}}class ke{constructor(u){this.c=u,this.templateId="a18n"}renderTemplate(u){return{container:u,disposables:new e.$Uc}}renderElement(u,y,a){const v=this.c.getAriaLabel(u),F=v&&typeof v!="string"?v:(0,b.constObservable)(v);a.disposables.add((0,b.autorun)(E=>{this.d(E.readObservable(F),a.container)}));const s=this.c.getAriaLevel&&this.c.getAriaLevel(u);typeof s=="number"?a.container.setAttribute("aria-level",`${s}`):a.container.removeAttribute("aria-level")}d(u,y){u?y.setAttribute("aria-label",u):y.removeAttribute("aria-label")}disposeElement(u,y,a,v){a.disposables.clear()}disposeTemplate(u){u.disposables.dispose()}}class Te{constructor(u,y){this.c=u,this.d=y}getDragElements(u){const y=this.c.getSelectedElements();return y.indexOf(u)>-1?y:[u]}getDragURI(u){return this.d.getDragURI(u)}getDragLabel(u,y){if(this.d.getDragLabel)return this.d.getDragLabel(u,y)}onDragStart(u,y){this.d.onDragStart?.(u,y)}onDragOver(u,y,a,v,F){return this.d.onDragOver(u,y,a,v,F)}onDragLeave(u,y,a,v){this.d.onDragLeave?.(u,y,a,v)}onDragEnd(u){this.d.onDragEnd?.(u)}drop(u,y,a,v,F){this.d.drop(u,y,a,v,F)}dispose(){this.d.dispose()}}class Ie{get onDidChangeFocus(){return c.Event.map(this.g.wrapEvent(this.c.onChange),u=>this.G(u),this.y)}get onDidChangeSelection(){return c.Event.map(this.g.wrapEvent(this.d.onChange),u=>this.G(u),this.y)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let u=!1;const y=c.Event.chain(this.y.add(new C.$QT(this.k.domNode,"keydown")).event,F=>F.map(s=>new B.$LR(s)).filter(s=>u=s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>n.$JS.stop(s,!0)).filter(()=>!1)),a=c.Event.chain(this.y.add(new C.$QT(this.k.domNode,"keyup")).event,F=>F.forEach(()=>u=!1).map(s=>new B.$LR(s)).filter(s=>s.keyCode===58||s.shiftKey&&s.keyCode===68).map(s=>n.$JS.stop(s,!0)).map(({browserEvent:s})=>{const E=this.getFocus(),p=E.length?E[0]:void 0,R=typeof p<"u"?this.k.element(p):void 0,O=typeof p<"u"?this.k.domElement(p):this.k.domNode;return{index:p,element:R,anchor:O,browserEvent:s}})),v=c.Event.chain(this.k.onContextMenu,F=>F.filter(s=>!u).map(({element:s,index:E,browserEvent:p})=>({element:s,index:E,anchor:new m.$GR((0,n.getWindow)(this.k.domNode),p),browserEvent:p})));return c.Event.any(y,a,v)}get onKeyDown(){return this.y.add(new C.$QT(this.k.domNode,"keydown")).event}get onKeyUp(){return this.y.add(new C.$QT(this.k.domNode,"keyup")).event}get onKeyPress(){return this.y.add(new C.$QT(this.k.domNode,"keypress")).event}get onDidFocus(){return c.Event.signal(this.y.add(new C.$QT(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return c.Event.signal(this.y.add(new C.$QT(this.k.domNode,"blur",!0)).event)}constructor(u,y,a,v,F=re){this.A=u,this.B=F,this.c=new D("focused"),this.f=new D("anchor"),this.g=new c.$me,this.x="",this.y=new e.$Uc,this.z=new c.$ee,this.onDidDispose=this.z.event;const s=this.B.accessibilityProvider&&this.B.accessibilityProvider.getWidgetRole?this.B.accessibilityProvider?.getWidgetRole():"list";this.d=new k(s!=="listbox");const E=[this.c.renderer,this.d.renderer];this.u=F.accessibilityProvider,this.u&&(E.push(new ke(this.u)),this.u.onDidChangeActiveDescendant?.(this.I,this,this.y)),v=v.map(R=>new we(R.templateId,[...E,R]));const p={...F,dnd:F.dnd&&new Te(this,F.dnd)};if(this.k=this.C(y,a,v,p),this.k.domNode.setAttribute("role",s),F.styleController)this.q=F.styleController(this.k.domId);else{const R=(0,n.$wS)(this.k.domNode);this.q=new ue(R,this.k.domId)}if(this.o=new P.$UT([new T(this.c,this.k,F.identityProvider),new T(this.d,this.k,F.identityProvider),new T(this.f,this.k,F.identityProvider),this.k]),this.y.add(this.c),this.y.add(this.d),this.y.add(this.f),this.y.add(this.k),this.y.add(this.z),this.y.add(new ce(this,this.k)),(typeof F.keyboardSupport!="boolean"||F.keyboardSupport)&&(this.v=new K(this,this.k,F),this.y.add(this.v)),F.keyboardNavigationLabelProvider){const R=F.keyboardNavigationDelegate||t.$dU;this.t=new ee(this,this.k,F.keyboardNavigationLabelProvider,F.keyboardNavigationEventFilter??(()=>!0),R),this.y.add(this.t)}this.w=this.D(F),this.y.add(this.w),this.onDidChangeFocus(this.H,this,this.y),this.onDidChangeSelection(this.J,this,this.y),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.B.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}C(u,y,a,v){return new S.$4T(u,y,a,v)}D(u){return new _(this)}updateOptions(u={}){this.B={...this.B,...u},this.t?.updateOptions(this.B),this.B.multipleSelectionController!==void 0&&(this.B.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(u),this.v?.updateOptions(u),this.k.updateOptions(u)}get options(){return this.B}splice(u,y,a=[]){if(u<0||u>this.k.length)throw new f.$6T(this.A,`Invalid start index: ${u}`);if(y<0)throw new f.$6T(this.A,`Invalid delete count: ${y}`);y===0&&a.length===0||this.g.bufferEvents(()=>this.o.splice(u,y,a))}updateWidth(u){this.k.updateWidth(u)}updateElementHeight(u,y){this.k.updateElementHeight(u,y,null)}rerender(){this.k.rerender()}element(u){return this.k.element(u)}indexOf(u){return this.k.indexOf(u)}indexAt(u){return this.k.indexAt(u)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get contentWidth(){return this.k.contentWidth}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.k.onDidChangeContentWidth}get scrollTop(){return this.k.getScrollTop()}set scrollTop(u){this.k.setScrollTop(u)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(u){this.k.setScrollLeft(u)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get firstMostlyVisibleIndex(){return this.k.firstMostlyVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.x}set ariaLabel(u){this.x=u,this.k.domNode.setAttribute("aria-label",u)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(u,y){this.k.layout(u,y)}triggerTypeNavigation(){this.t?.trigger()}setSelection(u,y){for(const a of u)if(a<0||a>=this.length)throw new f.$6T(this.A,`Invalid index ${a}`);this.d.set(u,y)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(u=>this.k.element(u))}setAnchor(u){if(typeof u>"u"){this.f.set([]);return}if(u<0||u>=this.length)throw new f.$6T(this.A,`Invalid index ${u}`);this.f.set([u])}getAnchor(){return(0,d.$Ob)(this.f.get(),void 0)}getAnchorElement(){const u=this.getAnchor();return typeof u>"u"?void 0:this.element(u)}setFocus(u,y){for(const a of u)if(a<0||a>=this.length)throw new f.$6T(this.A,`Invalid index ${a}`);this.c.set(u,y)}focusNext(u=1,y=!1,a,v){if(this.length===0)return;const F=this.c.get(),s=this.E(F.length>0?F[0]+u:0,y,v);s>-1&&this.setFocus([s],a)}focusPrevious(u=1,y=!1,a,v){if(this.length===0)return;const F=this.c.get(),s=this.F(F.length>0?F[0]-u:0,y,v);s>-1&&this.setFocus([s],a)}async focusNextPage(u,y){let a=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);a=a===0?0:a-1;const v=this.getFocus()[0];if(v!==a&&(v===void 0||a>v)){const F=this.F(a,!1,y);F>-1&&v!==F?this.setFocus([F],u):this.setFocus([a],u)}else{const F=this.k.getScrollTop();let s=F+this.k.renderHeight;a>v&&(s-=this.k.elementHeight(a)),this.k.setScrollTop(s),this.k.getScrollTop()!==F&&(this.setFocus([]),await(0,g.$wh)(0),await this.focusNextPage(u,y))}}async focusPreviousPage(u,y,a=()=>0){let v;const F=a(),s=this.k.getScrollTop()+F;s===0?v=this.k.indexAt(s):v=this.k.indexAfter(s-1);const E=this.getFocus()[0];if(E!==v&&(E===void 0||E>=v)){const p=this.E(v,!1,y);p>-1&&E!==p?this.setFocus([p],u):this.setFocus([v],u)}else{const p=s;this.k.setScrollTop(s-this.k.renderHeight-F),this.k.getScrollTop()+a()!==p&&(this.setFocus([]),await(0,g.$wh)(0),await this.focusPreviousPage(u,y,a))}}focusLast(u,y){if(this.length===0)return;const a=this.F(this.length-1,!1,y);a>-1&&this.setFocus([a],u)}focusFirst(u,y){this.focusNth(0,u,y)}focusNth(u,y,a){if(this.length===0)return;const v=this.E(u,!1,a);v>-1&&this.setFocus([v],y)}E(u,y=!1,a){for(let v=0;v<this.length;v++){if(u>=this.length&&!y)return-1;if(u=u%this.length,!a||a(this.element(u)))return u;u++}return-1}F(u,y=!1,a){for(let v=0;v<this.length;v++){if(u<0&&!y)return-1;if(u=(this.length+u%this.length)%this.length,!a||a(this.element(u)))return u;u--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(u=>this.k.element(u))}reveal(u,y,a=0){if(u<0||u>=this.length)throw new f.$6T(this.A,`Invalid index ${u}`);const v=this.k.getScrollTop(),F=this.k.elementTop(u),s=this.k.elementHeight(u);if((0,l.$_f)(y)){const E=s-this.k.renderHeight+a;this.k.setScrollTop(E*(0,i.$Am)(y,0,1)+F-a)}else{const E=F+s,p=v+this.k.renderHeight;F<v+a&&E>=p||(F<v+a||E>=p&&s>=this.k.renderHeight?this.k.setScrollTop(F-a):E>=p&&this.k.setScrollTop(E-this.k.renderHeight))}}getRelativeTop(u,y=0){if(u<0||u>=this.length)throw new f.$6T(this.A,`Invalid index ${u}`);const a=this.k.getScrollTop(),v=this.k.elementTop(u),F=this.k.elementHeight(u);if(v<a+y||v+F>a+this.k.renderHeight)return null;const s=F-this.k.renderHeight+y;return Math.abs((a+y-v)/s)}isDOMFocused(){return(0,n.$pS)(this.k.domNode)}getHTMLElement(){return this.k.domNode}getScrollableElement(){return this.k.scrollableElementDomNode}getElementID(u){return this.k.getElementDomId(u)}getElementTop(u){return this.k.elementTop(u)}style(u){this.q.style(u)}G({indexes:u,browserEvent:y}){return{indexes:u,elements:u.map(a=>this.k.element(a)),browserEvent:y}}H(){const u=this.c.get();this.k.domNode.classList.toggle("element-focused",u.length>0),this.I()}I(){const u=this.c.get();if(u.length>0){let y;this.u?.getActiveDescendantId&&(y=this.u.getActiveDescendantId(this.k.element(u[0]))),this.k.domNode.setAttribute("aria-activedescendant",y||this.k.getElementDomId(u[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}J(){const u=this.d.get();this.k.domNode.classList.toggle("selection-none",u.length===0),this.k.domNode.classList.toggle("selection-single",u.length===1),this.k.domNode.classList.toggle("selection-multiple",u.length>1)}dispose(){this.z.fire(),this.y.dispose(),this.z.dispose()}}t.$jU=Ie,Ze([M.$Zh],Ie.prototype,"onDidChangeFocus",null),Ze([M.$Zh],Ie.prototype,"onDidChangeSelection",null),Ze([M.$Zh],Ie.prototype,"onContextMenu",null),Ze([M.$Zh],Ie.prototype,"onKeyDown",null),Ze([M.$Zh],Ie.prototype,"onKeyUp",null),Ze([M.$Zh],Ie.prototype,"onKeyPress",null),Ze([M.$Zh],Ie.prototype,"onDidFocus",null),Ze([M.$Zh],Ie.prototype,"onDidBlur",null)}),define(me[137],be([1,0,6,62,47,9,16]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Sk=t.MarkdownStringTextNewlineStyle=void 0,t.$Tk=g,t.$Uk=w,t.$Vk=M,t.$Wk=c,t.$Xk=h,t.$Yk=e,t.$Zk=i,t.$1k=o;var P;(function(l){l[l.Paragraph=0]="Paragraph",l[l.Break=1]="Break"})(P||(t.MarkdownStringTextNewlineStyle=P={}));class d{constructor(f="",S=!1){if(this.value=f,typeof this.value!="string")throw(0,n.$7)("value");typeof S=="boolean"?(this.isTrusted=S,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=S.isTrusted??void 0,this.supportThemeIcons=S.supportThemeIcons??!1,this.supportHtml=S.supportHtml??!1)}appendText(f,S=0){return this.value+=c(this.supportThemeIcons?(0,C.$Mk)(f):f).replace(/([ \t]+)/g,(m,b)=>"&nbsp;".repeat(b.length)).replace(/\>/gm,"\\>").replace(/\n/g,S===1?`\\
`:`

`),this}appendMarkdown(f){return this.value+=f,this}appendCodeblock(f,S){return this.value+=`
${h(S,f)}
`,this}appendLink(f,S,m){return this.value+="[",this.value+=this.c(S,"]"),this.value+="](",this.value+=this.c(String(f),")"),m&&(this.value+=` "${this.c(this.c(m,'"'),")")}"`),this.value+=")",this}c(f,S){const m=new RegExp((0,H.$_e)(S),"g");return f.replace(m,(b,r)=>f.charAt(r-1)!=="\\"?`\\${b}`:b)}}t.$Sk=d;function g(l){return w(l)?!l.value:Array.isArray(l)?l.every(g):!0}function w(l){return l instanceof d?!0:l&&typeof l=="object"?typeof l.value=="string"&&(typeof l.isTrusted=="boolean"||typeof l.isTrusted=="object"||l.isTrusted===void 0)&&(typeof l.supportThemeIcons=="boolean"||l.supportThemeIcons===void 0):!1}function M(l,f){return l===f?!0:!l||!f?!1:l.value===f.value&&l.isTrusted===f.isTrusted&&l.supportThemeIcons===f.supportThemeIcons&&l.supportHtml===f.supportHtml&&(l.baseUri===f.baseUri||!!l.baseUri&&!!f.baseUri&&(0,B.$2g)(A.URI.from(l.baseUri),A.URI.from(f.baseUri)))}function c(l){return l.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function h(l,f){const S=l.match(/^`+/gm)?.reduce((b,r)=>b.length>r.length?b:r).length??0,m=S>=3?S+1:3;return[`${"`".repeat(m)}${f}`,l,`${"`".repeat(m)}`].join(`
`)}function e(l){return l.replace(/"/g,"&quot;")}function i(l){return l&&l.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(l){const f=[],S=l.split("|").map(b=>b.trim());l=S[0];const m=S[1];if(m){const b=/height=(\d+)/.exec(m),r=/width=(\d+)/.exec(m),D=b?b[1]:"",k=r?r[1]:"",T=isFinite(parseInt(k)),L=isFinite(parseInt(D));T&&f.push(`width="${k}"`),L&&f.push(`height="${D}"`)}return{href:l,dimensions:f}}}),define(me[138],be([1,0,4,129,24,66,15,20,130,6,3,137,62,86,23,2,88,64,36,61,47,9,16]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i,o,l,f,S,m,b,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$nU=void 0,t.$mU=k,t.$oU=I,t.$pU=V,t.$qU=ae;const D=Object.freeze({image:(W,Q,ge)=>{let we=[],ke=[];return W&&({href:W,dimensions:we}=(0,M.$1k)(W),ke.push(`src="${(0,M.$Yk)(W)}"`)),ge&&ke.push(`alt="${(0,M.$Yk)(ge)}"`),Q&&ke.push(`title="${(0,M.$Yk)(Q)}"`),we.length&&(ke=ke.concat(we)),"<img "+ke.join(" ")+">"},paragraph:W=>`<p>${W}</p>`,link:(W,Q,ge)=>typeof W!="string"?"":(W===ge&&(ge=(0,M.$Zk)(ge)),Q=typeof Q=="string"?(0,M.$Yk)((0,M.$Zk)(Q)):"",W=(0,M.$Zk)(W),W=W.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${W}" title="${Q||W}" draggable="false">${ge}</a>`)});function k(W,Q={},ge={}){const we=new i.$Uc;let ke=!1;const Te=(0,H.$PT)(Q),Ie=function(p){let R;try{R=(0,l.$4h)(decodeURIComponent(p))}catch{}return R?(R=(0,S.$4n)(R,O=>{if(W.uris&&W.uris[O])return r.URI.revive(W.uris[O])}),encodeURIComponent(JSON.stringify(R))):p},z=function(p,R){const O=W.uris&&W.uris[p];let U=r.URI.revive(O);return R?p.startsWith(f.Schemas.data+":")?p:(U||(U=r.URI.parse(p)),f.$Pg.uriToBrowserUri(U).toString(!0)):!U||r.URI.parse(p).toString()===U.toString()?p:(U.query&&(U=U.with({query:Ie(U.query)})),U.toString())},u=new o.marked.Renderer;u.image=D.image,u.link=D.link,u.paragraph=D.paragraph;const y=[],a=[];if(Q.codeBlockRendererSync?u.code=(p,R)=>{const O=h.$rP.nextId(),U=Q.codeBlockRendererSync(T(R),p);return a.push([O,U]),`<div class="code" data-code="${O}">${(0,b.$$e)(p)}</div>`}:Q.codeBlockRenderer&&(u.code=(p,R)=>{const O=h.$rP.nextId(),U=Q.codeBlockRenderer(T(R),p);return y.push(U.then(Z=>[O,Z])),`<div class="code" data-code="${O}">${(0,b.$$e)(p)}</div>`}),Q.actionHandler){const p=function(U){let Z=U.target;if(!(Z.tagName!=="A"&&(Z=Z.parentElement,!Z||Z.tagName!=="A")))try{let oe=Z.dataset.href;oe&&(W.baseUri&&(oe=L(r.URI.from(W.baseUri),oe)),Q.actionHandler.callback(oe,U))}catch(oe){(0,g.$1)(oe)}finally{U.preventDefault()}},R=Q.actionHandler.disposables.add(new B.$QT(Te,"click")),O=Q.actionHandler.disposables.add(new B.$QT(Te,"auxclick"));Q.actionHandler.disposables.add(w.Event.any(R.event,O.event)(U=>{const Z=new P.$GR(n.getWindow(Te),U);!Z.leftButton&&!Z.middleButton||p(Z)})),Q.actionHandler.disposables.add(n.$OR(Te,"keydown",U=>{const Z=new A.$LR(U);!Z.equals(10)&&!Z.equals(3)||p(Z)}))}W.supportHtml||(ge.sanitizer=p=>(W.isTrusted?p.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?p:"",ge.sanitize=!0,ge.silent=!0),ge.renderer=u;let v=W.value??"";v.length>1e5&&(v=`${v.substr(0,1e5)}\u2026`),W.supportThemeIcons&&(v=(0,c.$Nk)(v));let F;if(Q.fillInIncompleteTokens){const p={...o.marked.defaults,...ge},R=o.marked.lexer(v,p),O=ae(R);F=o.marked.parser(O,p)}else F=o.marked.parse(v,ge);W.supportThemeIcons&&(F=(0,d.$kU)(F).map(R=>typeof R=="string"?R:R.outerHTML).join(""));const E=new DOMParser().parseFromString(q(W,F),"text/html");if(E.body.querySelectorAll("img, audio, video, source").forEach(p=>{const R=p.getAttribute("src");if(R){let O=R;try{W.baseUri&&(O=L(r.URI.from(W.baseUri),O))}catch{}if(p.setAttribute("src",z(O,!0)),Q.disallowRemoteImages){const U=r.URI.parse(O).scheme;U!==f.Schemas.file&&U!==f.Schemas.data&&p.replaceWith(n.$("",void 0,p.outerHTML))}}}),E.body.querySelectorAll("a").forEach(p=>{const R=p.getAttribute("href");if(p.setAttribute("href",""),!R||/^data:|javascript:/i.test(R)||/^command:/i.test(R)&&!W.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(R))p.replaceWith(...p.childNodes);else{let O=z(R,!1);W.baseUri&&(O=L(r.URI.from(W.baseUri),R)),p.dataset.href=O}}),Te.innerHTML=q(W,E.body.innerHTML),y.length>0)Promise.all(y).then(p=>{if(ke)return;const R=new Map(p),O=Te.querySelectorAll("div[data-code]");for(const U of O){const Z=R.get(U.dataset.code??"");Z&&n.$QS(U,Z)}Q.asyncRenderCallback?.()});else if(a.length>0){const p=new Map(a),R=Te.querySelectorAll("div[data-code]");for(const O of R){const U=p.get(O.dataset.code??"");U&&n.$QS(O,U)}}if(Q.asyncRenderCallback)for(const p of Te.getElementsByTagName("img")){const R=we.add(n.$OR(p,"load",()=>{R.dispose(),Q.asyncRenderCallback()}))}return{element:Te,dispose:()=>{ke=!0,we.dispose()}}}function T(W){if(!W)return"";const Q=W.split(/[\s+|:|,|\{|\?]/,1);return Q.length?Q[0]:W}function L(W,Q){return/^\w[\w\d+.-]*:/.test(Q)?Q:W.path.endsWith("/")?(0,m.$_g)(W,Q).toString():(0,m.$_g)((0,m.$8g)(W),Q).toString()}function q(W,Q){const{config:ge,allowedSchemes:we}=$(W);C.addHook("uponSanitizeAttribute",(Te,Ie)=>{if(Ie.attrName==="style"||Ie.attrName==="class"){if(Te.tagName==="SPAN"){if(Ie.attrName==="style"){Ie.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(Ie.attrValue);return}else if(Ie.attrName==="class"){Ie.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(Ie.attrValue);return}}Ie.keepAttr=!1;return}else if(Te.tagName==="INPUT"&&Te.attributes.getNamedItem("type")?.value==="checkbox"){if(Ie.attrName==="type"&&Ie.attrValue==="checkbox"||Ie.attrName==="disabled"||Ie.attrName==="checked"){Ie.keepAttr=!0;return}Ie.keepAttr=!1}}),C.addHook("uponSanitizeElement",(Te,Ie)=>{Ie.tagName==="input"&&(Te.attributes.getNamedItem("type")?.value==="checkbox"?Te.setAttribute("disabled",""):Te.parentElement?.removeChild(Te))});const ke=n.$$S(we);try{return C.sanitize(Q,{...ge,RETURN_TRUSTED_TYPE:!0})}finally{C.removeHook("uponSanitizeAttribute"),ke.dispose()}}t.$nU=["align","autoplay","alt","checked","class","controls","data-code","data-href","disabled","draggable","height","href","loop","muted","playsinline","poster","src","style","target","title","type","width","start"];function $(W){const Q=[f.Schemas.http,f.Schemas.https,f.Schemas.mailto,f.Schemas.data,f.Schemas.file,f.Schemas.vscodeFileResource,f.Schemas.vscodeRemote,f.Schemas.vscodeRemoteResource];return W.isTrusted&&Q.push(f.Schemas.command),{config:{ALLOWED_TAGS:[...n.$_S],ALLOWED_ATTR:t.$nU,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:Q}}function I(W){return typeof W=="string"?W:V(W)}function V(W){let Q=W.value??"";Q.length>1e5&&(Q=`${Q.substr(0,1e5)}\u2026`);const ge=o.marked.parse(Q,{renderer:x.value}).replace(/&(#\d+|[a-zA-Z]+);/g,we=>N.get(we)??we);return q({isTrusted:!1},ge).toString()}const N=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),x=new e.$V(()=>{const W=new o.marked.Renderer;return W.code=Q=>Q,W.blockquote=Q=>Q,W.html=Q=>"",W.heading=(Q,ge,we)=>Q+`
`,W.hr=()=>"",W.list=(Q,ge)=>Q,W.listitem=Q=>Q+`
`,W.paragraph=Q=>Q+`
`,W.table=(Q,ge)=>Q+ge+`
`,W.tablerow=Q=>Q,W.tablecell=(Q,ge)=>Q+" ",W.strong=Q=>Q,W.em=Q=>Q,W.codespan=Q=>Q,W.br=()=>`
`,W.del=Q=>Q,W.image=(Q,ge,we)=>"",W.text=Q=>Q,W.link=(Q,ge,we)=>we,W});function j(W){let Q="";return W.forEach(ge=>{Q+=ge.raw}),Q}function Y(W){for(let Q=0;Q<W.tokens.length;Q++){const ge=W.tokens[Q];if(ge.type==="text"){const we=ge.raw.split(`
`),ke=we[we.length-1];if(ke.includes("`"))return ee(W);if(ke.includes("**"))return _(W);if(ke.match(/\*\w/))return ce(W);if(ke.match(/(^|\s)__\w/))return ue(W);if(ke.match(/(^|\s)_\w/))return De(W);if(ke.match(/(^|\s)\[.*\]\(\w*/)){const Te=W.tokens.slice(Q+1);return Te[0]?.type==="link"&&Te[1]?.type==="text"&&Te[1].raw.match(/^ *"[^"]*$/)?Le(W):Ee(W)}else{if(K(ke))return Ee(W);if(ke.match(/(^|\s)\[\w/)&&!W.tokens.slice(Q+1).some(Te=>K(Te.raw)))return le(W)}}}}function K(W){return!!W.match(/^[^\[]*\]\([^\)]*$/)}function ae(W){let Q,ge;for(Q=0;Q<W.length;Q++){const we=W[Q];let ke;if(we.type==="paragraph"&&(ke=we.raw.match(/(\n|^)(````*)/))){const Te=ke[2];ge=ie(W.slice(Q),Te);break}if(we.type==="paragraph"&&we.raw.match(/(\n|^)\|/)){ge=ye(W.slice(Q));break}if(Q===W.length-1&&we.type==="paragraph"){const Te=Y(we);if(Te){ge=[Te];break}}}if(ge){const we=[...W.slice(0,Q),...ge];return we.links=W.links,we}return W}function ie(W,Q){const ge=j(W);return o.marked.lexer(ge+`
${Q}`)}function ee(W){return re(W,"`")}function ce(W){return re(W,"*")}function De(W){return re(W,"_")}function Ee(W){return re(W,")")}function Le(W){return re(W,'")')}function le(W){return re(W,"](about:blank)")}function _(W){return re(W,"**")}function ue(W){return re(W,"__")}function re(W,Q){const ge=j(Array.isArray(W)?W:[W]);return o.marked.lexer(ge+Q)[0]}function ye(W){const Q=j(W),ge=Q.split(`
`);let we,ke=!1;for(let Te=0;Te<ge.length;Te++){const Ie=ge[Te].trim();if(typeof we>"u"&&Ie.match(/^\s*\|/)){const z=Ie.match(/(\|[^\|]+)(?=\||$)/g);z&&(we=z.length)}else if(typeof we=="number")if(Ie.match(/^\s*\|/)){if(Te!==ge.length-1)return;ke=!0}else return}if(typeof we=="number"&&we>0){const Te=ke?ge.slice(0,-1).join(`
`):Q,Ie=!!Te.match(/\|\s*$/),z=Te+(Ie?"":"|")+`
|${" --- |".repeat(we)}`;return o.marked.lexer(z)}}}),define(me[139],be([1,0,4,24,15,138,29,14,49,8,3,54,2,5,121,113]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$tU=void 0;const i=n.$,o="selectOption.entry.template";class l{get templateId(){return o}renderTemplate(m){const b=Object.create(null);return b.root=m,b.text=n.$OS(m,i(".option-text")),b.detail=n.$OS(m,i(".option-detail")),b.decoratorRight=n.$OS(m,i(".option-decorator-right")),b}renderElement(m,b,r){const D=r,k=m.text,T=m.detail,L=m.decoratorRight,q=m.isDisabled;D.text.textContent=k,D.detail.textContent=T||"",D.decoratorRight.innerText=L||"",q?D.root.classList.add("option-disabled"):D.root.classList.remove("option-disabled")}disposeTemplate(m){}}class f extends c.$Vc{static{this.a=32}static{this.b=2}static{this.c=3}constructor(m,b,r,D,k){super(),this.m=[],this.F=0,this.H=!1,this.J=!1,this.N=!1,this.f=!1,this.s=D,this.g=k||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=f.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.r=new w.$ee,this.B(this.r),this.Q(),this.P(r),this.n=b||0,m&&this.setOptions(m,b),this.S()}O(m){!this.M&&m?this.M=this.B((0,A.$sU)().setupUpdatableHover((0,P.$GT)("mouse"),this.h,m)):this.M&&this.M.update(m)}getHeight(){return 22}getTemplateId(){return o}P(m){this.u=m,this.w=n.$(".monaco-select-box-dropdown-container"),this.w.classList.add("monaco-select-box-dropdown-padding"),this.I=n.$OS(this.w,i(".select-box-details-pane"));const b=n.$OS(this.w,i(".select-box-dropdown-container-width-control")),r=n.$OS(b,i(".width-control-div"));this.D=document.createElement("span"),this.D.className="option-text-width-control",n.$OS(r,this.D),this.G=0,this.y=n.$wS(this.w),this.w.setAttribute("draggable","true"),this.B(n.$OR(this.w,n.$HS.DRAG_START,D=>{n.$JS.stop(D,!0)}))}Q(){this.B(n.$PR(this.h,"change",b=>{this.n=b.target.selectedIndex,this.r.fire({index:b.target.selectedIndex,selected:b.target.value}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)})),this.B(n.$OR(this.h,n.$HS.CLICK,b=>{n.$JS.stop(b),this.f?this.Z(!0):this.Y()})),this.B(n.$OR(this.h,n.$HS.MOUSE_DOWN,b=>{n.$JS.stop(b)}));let m;this.B(n.$OR(this.h,"touchstart",b=>{m=this.f})),this.B(n.$OR(this.h,"touchend",b=>{n.$JS.stop(b),m?this.Z(!0):this.Y()})),this.B(n.$OR(this.h,n.$HS.KEY_DOWN,b=>{const r=new B.$LR(b);let D=!1;h.$j?(r.keyCode===18||r.keyCode===16||r.keyCode===10||r.keyCode===3)&&(D=!0):(r.keyCode===18&&r.altKey||r.keyCode===16&&r.altKey||r.keyCode===10||r.keyCode===3)&&(D=!0),D&&(this.Y(),n.$JS.stop(b,!0))}))}get onDidSelect(){return this.r.event}setOptions(m,b){g.$ub(this.m,m)||(this.m=m,this.h.options.length=0,this.H=!1,this.L=void 0,this.m.forEach((r,D)=>{this.h.add(this.X(r.text,D,r.isDisabled)),typeof r.description=="string"&&(this.H=!0)})),b!==void 0&&(this.select(b),this.F=this.n)}R(){this.z?.splice(0,this.z.length,this.m)}select(m){m>=0&&m<this.m.length?this.n=m:m>this.m.length-1?this.select(this.m.length-1):this.n<0&&(this.n=0),this.h.selectedIndex=this.n,this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)}setAriaLabel(m){this.g.ariaLabel=m,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(m){this.h.tabIndex=m?0:-1}render(m){this.j=m,m.classList.add("select-container"),m.appendChild(this.h),this.U()}S(){const m=[];this.s.listFocusBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.s.listFocusBackground} !important; }`),this.s.listFocusForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.s.listFocusForeground} !important; }`),this.s.decoratorRightForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.s.decoratorRightForeground}; }`),this.s.selectBackground&&this.s.selectBorder&&this.s.selectBorder!==this.s.selectBackground?(m.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectBorder} } `)):this.s.selectListBorder&&(m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.s.selectListBorder} } `),m.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.s.selectListBorder} } `)),this.s.listHoverForeground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.s.listHoverForeground} !important; }`),this.s.listHoverBackground&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.s.listHoverBackground} !important; }`),this.s.listFocusOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.s.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.s.listHoverOutline&&m.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.s.listHoverOutline} !important; outline-offset: -1.6px !important; }`),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),m.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.y.textContent=m.join(`
`)}U(){const m=this.s.selectBackground??"",b=this.s.selectForeground??"",r=this.s.selectBorder??"";this.h.style.backgroundColor=m,this.h.style.color=b,this.h.style.borderColor=r}W(){const m=this.s.selectBackground??"",b=n.$7S(this.s.selectListBackground,m);this.C.style.backgroundColor=b,this.I.style.backgroundColor=b;const r=this.s.focusBorder??"";this.w.style.outlineColor=r,this.w.style.outlineOffset="-1px",this.z.style(this.s)}X(m,b,r){const D=document.createElement("option");return D.value=m,D.text=m,D.disabled=!!r,D}Y(){this.I.innerText="",!(!this.u||this.f)&&(this.eb(this.w),this.R(),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m,!0),layout:()=>{this.cb()},onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.Z(!1),this.u.showContextView({getAnchor:()=>this.h,render:m=>this.ab(m),layout:()=>this.cb(),onHide:()=>{this.w.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.G},this.g.optionsAsChildren?this.j:void 0),this.F=this.n,this.f=!0,this.h.setAttribute("aria-expanded","true"))}Z(m){!this.u||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),m&&this.h.focus(),this.u.hideContextView())}ab(m,b){return m.appendChild(this.w),this.cb(b),{dispose:()=>{try{m.removeChild(this.w)}catch{}}}}bb(){let m=0;return this.m.forEach((b,r)=>{this.jb(r),this.I.offsetHeight>m&&(m=this.I.offsetHeight)}),m}cb(m){if(this.J)return!1;if(this.z){this.w.classList.add("visible");const b=n.getWindow(this.h),r=n.$$R(this.h),D=n.getWindow(this.h).getComputedStyle(this.h),k=parseFloat(D.getPropertyValue("--dropdown-padding-top"))+parseFloat(D.getPropertyValue("--dropdown-padding-bottom")),T=b.innerHeight-r.top-r.height-(this.g.minBottomMargin||0),L=r.top-f.b,q=this.h.offsetWidth,$=this.db(this.D),I=Math.max($,Math.round(q)).toString()+"px";this.w.style.width=I,this.z.getHTMLElement().style.height="",this.z.layout();let V=this.z.contentHeight;this.H&&this.L===void 0&&(this.L=this.bb());const N=this.H?this.L:0,x=V+k+N,j=Math.floor((T-k-N)/this.getHeight()),Y=Math.floor((L-k-N)/this.getHeight());if(m)return r.top+r.height>b.innerHeight-22||r.top<f.b||j<1&&Y<1?!1:(j<f.c&&Y>j&&this.m.length>j?(this.G=1,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.I),this.w.appendChild(this.C),this.I.classList.remove("border-top"),this.I.classList.add("border-bottom")):(this.G=0,this.w.removeChild(this.C),this.w.removeChild(this.I),this.w.appendChild(this.C),this.w.appendChild(this.I),this.I.classList.remove("border-bottom"),this.I.classList.add("border-top")),!0);if(r.top+r.height>b.innerHeight-22||r.top<f.b||this.G===0&&j<1||this.G===1&&Y<1)return this.Z(!0),!1;if(this.G===0){if(this.f&&j+Y<1)return this.Z(!0),!1;x>T&&(V=j*this.getHeight())}else x>L&&(V=Y*this.getHeight());return this.z.layout(V),this.z.domFocus(),this.z.length>0&&(this.z.setFocus([this.n||0]),this.z.reveal(this.z.getFocus()[0]||0)),this.H?(this.z.getHTMLElement().style.height=V+k+"px",this.w.style.height=""):this.w.style.height=V+k+"px",this.jb(this.n),this.w.style.width=I,this.C.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.w.classList.add("synthetic-focus"),!0}else return!1}db(m){let b=0;if(m){let r=0,D=0;this.m.forEach((k,T)=>{const L=k.detail?k.detail.length:0,q=k.decoratorRight?k.decoratorRight.length:0,$=k.text.length+L+q;$>D&&(r=T,D=$)}),m.textContent=this.m[r].text+(this.m[r].decoratorRight?this.m[r].decoratorRight+" ":""),b=n.$aS(m)}return b}eb(m){if(this.z)return;this.C=n.$OS(m,i(".select-box-dropdown-list-container")),this.t=new l,this.z=new d.$jU("SelectBoxCustom",this.C,this,[this.t],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:D=>{let k=D.text;return D.detail&&(k+=`. ${D.detail}`),D.decoratorRight&&(k+=`. ${D.decoratorRight}`),D.description&&(k+=`. ${D.description}`),k},getWidgetAriaLabel:()=>(0,e.localize)(0,null),getRole:()=>h.$j?"":"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.z.ariaLabel=this.g.ariaLabel);const b=this.B(new C.$QT(this.C,"keydown")),r=w.Event.chain(b.event,D=>D.filter(()=>this.z.length>0).map(k=>new B.$LR(k)));this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===3))(this.lb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===2))(this.lb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===9))(this.kb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===16))(this.nb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===18))(this.mb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===12))(this.pb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===11))(this.ob,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===14))(this.qb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode===13))(this.rb,this)),this.B(w.Event.chain(r,D=>D.filter(k=>k.keyCode>=21&&k.keyCode<=56||k.keyCode>=85&&k.keyCode<=113))(this.sb,this)),this.B(n.$OR(this.z.getHTMLElement(),n.$HS.POINTER_UP,D=>this.fb(D))),this.B(this.z.onMouseOver(D=>typeof D.index<"u"&&this.z.setFocus([D.index]))),this.B(this.z.onDidChangeFocus(D=>this.ib(D))),this.B(n.$OR(this.w,n.$HS.FOCUS_OUT,D=>{!this.f||n.$gS(D.relatedTarget,this.w)||this.gb()})),this.z.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.z.getHTMLElement().setAttribute("aria-expanded","true"),this.W()}fb(m){if(!this.z.length)return;n.$JS.stop(m);const b=m.target;if(!b||b.classList.contains("slider"))return;const r=b.closest(".monaco-list-row");if(!r)return;const D=Number(r.getAttribute("data-index")),k=r.classList.contains("option-disabled");D>=0&&D<this.m.length&&!k&&(this.n=D,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0))}gb(){this.N||(this.n!==this.F&&this.select(this.F),this.Z(!1))}hb(m,b){const r=k=>{for(let T=0;T<k.childNodes.length;T++){const L=k.childNodes.item(T);(L.tagName&&L.tagName.toLowerCase())==="img"?k.removeChild(L):r(L)}},D=(0,H.$mU)({value:m,supportThemeIcons:!0},{actionHandler:b});return D.element.classList.add("select-box-description-markdown"),r(D.element),D.element}ib(m){!this.f||!this.H||this.jb(m.indexes[0])}jb(m){this.I.innerText="";const b=this.m[m],r=b?.description??"",D=b?.descriptionIsMarkdown??!1;if(r){if(D){const k=b.descriptionMarkdownActionHandler;this.I.appendChild(this.hb(r,k))}else this.I.innerText=r;this.I.style.display="block"}else this.I.style.display="none";this.J=!0,this.u.layout(),this.J=!1}kb(m){n.$JS.stop(m),this.select(this.F),this.Z(!0)}lb(m){n.$JS.stop(m),this.n!==this.F&&(this.F=this.n,this.r.fire({index:this.h.selectedIndex,selected:this.m[this.n].text}),this.m[this.n]&&this.m[this.n].text&&this.O(this.m[this.n].text)),this.Z(!0)}mb(m){if(this.n<this.m.length-1){n.$JS.stop(m,!0);const b=this.m[this.n+1].isDisabled;if(b&&this.m.length>this.n+2)this.n+=2;else{if(b)return;this.n++}this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0])}}nb(m){this.n>0&&(n.$JS.stop(m,!0),this.m[this.n-1].isDisabled&&this.n>1?this.n-=2:this.n--,this.select(this.n),this.z.setFocus([this.n]),this.z.reveal(this.z.getFocus()[0]))}ob(m){n.$JS.stop(m),this.z.focusPreviousPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n<this.m.length-1&&(this.n++,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}pb(m){n.$JS.stop(m),this.z.focusNextPage(),setTimeout(()=>{this.n=this.z.getFocus()[0],this.m[this.n].isDisabled&&this.n>0&&(this.n--,this.z.setFocus([this.n])),this.z.reveal(this.n),this.select(this.n)},1)}qb(m){n.$JS.stop(m),!(this.m.length<2)&&(this.n=0,this.m[this.n].isDisabled&&this.n>1&&this.n++,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}rb(m){n.$JS.stop(m),!(this.m.length<2)&&(this.n=this.m.length-1,this.m[this.n].isDisabled&&this.n>1&&this.n--,this.z.setFocus([this.n]),this.z.reveal(this.n),this.select(this.n))}sb(m){const b=M.KeyCodeUtils.toString(m.keyCode);let r=-1;for(let D=0;D<this.m.length-1;D++)if(r=(D+this.n+1)%this.m.length,this.m[r].text.charAt(0).toUpperCase()===b&&!this.m[r].isDisabled){this.select(r),this.z.setFocus([r]),this.z.reveal(this.z.getFocus()[0]),n.$JS.stop(m);break}}dispose(){this.Z(!1),super.dispose()}}t.$tU=f}),define(me[140],be([1,0,49,139,133,21,5,112]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$wU=t.$vU=void 0,t.$vU={...n.$iU,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class P extends H.$pT{constructor(g,w,M,c,h){super(),A.$j&&!h?.useCustomDrawn?this.a=new B.$uU(g,w,c,h):this.a=new C.$tU(g,w,M,c,h),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(g,w){this.a.setOptions(g,w)}select(g){this.a.select(g)}setAriaLabel(g){this.a.setAriaLabel(g)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(g){this.a.setFocusable(g)}render(g){this.a.render(g)}}t.$wU=P}),define(me[73],be([1,0,17,65,4,28,14,140,46,2,5,10,117,29,63]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$EU=t.$DU=t.$CU=void 0;class e extends g.$Vc{get action(){return this._action}constructor(f,S,m={}){super(),this.m=m,this._context=f||this,this._action=S,S instanceof d.$aj&&this.B(S.onDidChange(b=>{this.element&&this.t(b)}))}t(f){f.enabled!==void 0&&this.u(),f.checked!==void 0&&this.H(),f.class!==void 0&&this.G(),f.label!==void 0&&(this.w(),this.D()),f.tooltip!==void 0&&this.D()}get actionRunner(){return this.j||(this.j=this.B(new d.$bj)),this.j}set actionRunner(f){this.j=f}isEnabled(){return this._action.enabled}setActionContext(f){this._context=f}render(f){const S=this.element=f;this.B(H.$lT.addTarget(f));const m=this.m&&this.m.draggable;m&&(f.draggable=!0,n.$uR&&this.B((0,B.$OR)(f,B.$HS.DRAG_START,b=>b.dataTransfer?.setData(C.$jT.TEXT,this._action.label)))),this.B((0,B.$OR)(S,H.EventType.Tap,b=>this.onClick(b,!0))),this.B((0,B.$OR)(S,B.$HS.MOUSE_DOWN,b=>{m||B.$JS.stop(b,!0),this._action.enabled&&b.button===0&&S.classList.add("active")})),w.$j&&this.B((0,B.$OR)(S,B.$HS.CONTEXT_MENU,b=>{b.button===0&&b.ctrlKey===!0&&this.onClick(b)})),this.B((0,B.$OR)(S,B.$HS.CLICK,b=>{B.$JS.stop(b,!0),this.m&&this.m.isMenu||this.onClick(b)})),this.B((0,B.$OR)(S,B.$HS.DBLCLICK,b=>{B.$JS.stop(b,!0)})),[B.$HS.MOUSE_UP,B.$HS.MOUSE_OUT].forEach(b=>{this.B((0,B.$OR)(S,b,r=>{B.$JS.stop(r),S.classList.remove("active")}))})}onClick(f,S=!1){B.$JS.stop(f,!0);const m=M.$eg(this._context)?this.m?.useEventAsContext?f:{preserveFocus:S}:this._context;this.actionRunner.run(this._action,m)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(f){this.element&&(this.element.tabIndex=f?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.class}C(){return this.action.tooltip}D(){if(!this.element)return;const f=this.C()??"";if(this.F(),this.m.hoverDelegate?.showNativeHover)this.element.title=f;else if(!this.f&&f!==""){const S=this.m.hoverDelegate??(0,A.$GT)("element");this.f=this.q.add((0,h.$sU)().setupUpdatableHover(S,this.element,f))}else this.f&&this.f.update(f)}F(){if(this.element){const f=this.C()??"";this.element.setAttribute("aria-label",f)}}G(){}H(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.$CU=e;class i extends e{constructor(f,S,m){super(f,S,m),this.m=m,this.m.icon=m.icon!==void 0?m.icon:!1,this.m.label=m.label!==void 0?m.label:!0,this.L=""}render(f){super.render(f),M.$fg(this.element);const S=document.createElement("a");if(S.classList.add("action-label"),S.setAttribute("role",this.M()),this.I=S,this.element.appendChild(S),this.m.label&&this.m.keybinding){const m=document.createElement("span");m.classList.add("keybinding"),m.textContent=this.m.keybinding,this.element.appendChild(m)}this.G(),this.w(),this.D(),this.u(),this.H()}M(){return this._action.id===d.$cj.ID?"presentation":this.m.isMenu?"menuitem":"button"}focus(){this.I&&(this.I.tabIndex=0,this.I.focus())}isFocused(){return!!this.I&&this.I?.tabIndex===0}blur(){this.I&&(this.I.tabIndex=-1)}setFocusable(f){this.I&&(this.I.tabIndex=f?0:-1)}w(){this.m.label&&this.I&&(this.I.textContent=this.action.label)}C(){let f=null;return this.action.tooltip?f=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(f=this.action.label,this.m.keybinding&&(f=c.localize(0,null,f,this.m.keybinding))),f??void 0}G(){this.L&&this.I&&this.I.classList.remove(...this.L.split(" ")),this.m.icon?(this.L=this.z(),this.I&&(this.I.classList.add("codicon"),this.L&&this.I.classList.add(...this.L.split(" "))),this.u()):this.I?.classList.remove("codicon")}u(){this.action.enabled?(this.I&&(this.I.removeAttribute("aria-disabled"),this.I.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.I&&(this.I.setAttribute("aria-disabled","true"),this.I.classList.add("disabled")),this.element?.classList.add("disabled"))}F(){if(this.I){const f=this.C()??"";this.I.setAttribute("aria-label",f)}}H(){this.I&&(this.action.checked!==void 0?(this.I.classList.toggle("checked",this.action.checked),this.I.setAttribute("aria-checked",this.action.checked?"true":"false"),this.I.setAttribute("role","checkbox")):(this.I.classList.remove("checked"),this.I.removeAttribute("aria-checked"),this.I.setAttribute("role",this.M())))}}t.$DU=i;class o extends e{constructor(f,S,m,b,r,D,k){super(f,S),this.b=new P.$wU(m,b,r,D,k),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(f,S){this.b.setOptions(f,S)}select(f){this.b.select(f)}g(){this.B(this.b.onDidSelect(f=>this.n(f.selected,f.index)))}n(f,S){this.actionRunner.run(this._action,this.r(f,S))}r(f,S){return f}setFocusable(f){this.b.setFocusable(f)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(f){this.b.render(f)}}t.$EU=o}),define(me[74],be([1,0,4,15,73,14,46,3,2,10,63]),function(se,t,n,C,B,H,A,P,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$IT=t.ActionsOrientation=void 0,t.$JT=c;var w;(function(h){h[h.HORIZONTAL=0]="HORIZONTAL",h[h.VERTICAL=1]="VERTICAL"})(w||(t.ActionsOrientation=w={}));class M extends d.$Vc{constructor(e,i={}){super(),this.j=this.B(new d.$Uc),this.s=this.B(new d.$5c),this.y=!1,this.z=!0,this.D=this.B(new P.$ee),this.onDidBlur=this.D.event,this.F=this.B(new P.$ee({onWillAddFirstListener:()=>this.G=!0})),this.onDidCancel=this.F.event,this.G=!1,this.H=this.B(new P.$ee),this.onDidRun=this.H.event,this.I=this.B(new P.$ee),this.onWillRun=this.I.event,this.b=i,this.m=i.context??null,this.n=this.b.orientation??0,this.r={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.f=i.hoverDelegate??this.B((0,H.$HT)()),this.b.actionRunner?this.g=this.b.actionRunner:(this.g=new A.$bj,this.j.add(this.g)),this.j.add(this.g.onDidRun(f=>this.H.fire(f))),this.j.add(this.g.onWillRun(f=>this.I.fire(f))),this.viewItems=[],this.u=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar";let o,l;switch(this.n){case 0:o=[15],l=[17];break;case 1:o=[16],l=[18],this.domNode.className+=" vertical";break}this.B(n.$OR(this.domNode,n.$HS.KEY_DOWN,f=>{const S=new C.$LR(f);let m=!0;const b=typeof this.u=="number"?this.viewItems[this.u]:void 0;o&&(S.equals(o[0])||S.equals(o[1]))?m=this.Q():l&&(S.equals(l[0])||S.equals(l[1]))?m=this.P():S.equals(9)&&this.G?this.F.fire():S.equals(14)?m=this.N():S.equals(13)?m=this.O():S.equals(2)&&b instanceof B.$CU&&b.trapsArrowNavigation?m=this.P():this.L(S)?this.r.keyDown?this.S(S):this.y=!0:m=!1,m&&(S.preventDefault(),S.stopPropagation())})),this.B(n.$OR(this.domNode,n.$HS.KEY_UP,f=>{const S=new C.$LR(f);this.L(S)?(!this.r.keyDown&&this.y&&(this.y=!1,this.S(S)),S.preventDefault(),S.stopPropagation()):(S.equals(2)||S.equals(1026)||S.equals(16)||S.equals(18)||S.equals(15)||S.equals(17))&&this.M()})),this.w=this.B(n.$MS(this.domNode)),this.B(this.w.onDidBlur(()=>{(n.$oS()===this.domNode||!n.$gS(n.$oS(),this.domNode))&&(this.D.fire(),this.t=this.u,this.u=void 0,this.y=!1)})),this.B(this.w.onDidFocus(()=>this.M())),this.C=document.createElement("ul"),this.C.className="actions-container",this.b.highlightToggledItems&&this.C.classList.add("highlight-toggled"),this.C.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.C.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.C),e.appendChild(this.domNode)}J(){this.length()>=1?this.C.setAttribute("role",this.b.ariaRole||"toolbar"):this.C.setAttribute("role","presentation")}setAriaLabel(e){e?this.C.setAttribute("aria-label",e):this.C.removeAttribute("aria-label")}setFocusable(e){if(this.z=e,this.z){const i=this.viewItems.find(o=>o instanceof B.$CU&&o.isEnabled());i instanceof B.$CU&&i.setFocusable(!0)}else this.viewItems.forEach(i=>{i instanceof B.$CU&&i.setFocusable(!1)})}L(e){let i=!1;return this.r.keys.forEach(o=>{i=i||e.equals(o)}),i}M(){for(let e=0;e<this.C.children.length;e++){const i=this.C.children[e];if(n.$gS(n.$oS(),i)){this.u=e,this.viewItems[this.u]?.showHover?.();break}}}get context(){return this.m}set context(e){this.m=e,this.viewItems.forEach(i=>i.setActionContext(e))}get actionRunner(){return this.g}set actionRunner(e){this.g=e,this.j.clear(),this.j.add(this.g.onDidRun(i=>this.H.fire(i))),this.j.add(this.g.onWillRun(i=>this.I.fire(i))),this.viewItems.forEach(i=>i.actionRunner=e)}getContainer(){return this.domNode}hasAction(e){return this.viewItems.findIndex(i=>i.action.id===e.id)!==-1}getAction(e){if(typeof e=="number")return this.viewItems[e]?.action;if(e instanceof HTMLElement){for(;e.parentElement!==this.C;){if(!e.parentElement)return;e=e.parentElement}for(let i=0;i<this.C.childNodes.length;i++)if(this.C.childNodes[i]===e)return this.viewItems[i].action}}push(e,i={}){const o=Array.isArray(e)?e:[e];let l=g.$_f(i.index)?i.index:null;o.forEach(f=>{const S=document.createElement("li");S.className="action-item",S.setAttribute("role","presentation");let m;const b={hoverDelegate:this.f,...i};this.b.actionViewItemProvider&&(m=this.b.actionViewItemProvider(f,b)),m||(m=new B.$DU(this.context,f,b)),this.b.allowContextMenu||this.s.set(m,n.$OR(S,n.$HS.CONTEXT_MENU,r=>{n.$JS.stop(r,!0)})),m.actionRunner=this.g,m.setActionContext(this.context),m.render(S),this.z&&m instanceof B.$CU&&this.viewItems.length===0&&m.setFocusable(!0),l===null||l<0||l>=this.C.children.length?(this.C.appendChild(S),this.viewItems.push(m)):(this.C.insertBefore(S,this.C.children[l]),this.viewItems.splice(l,0,m),l++)}),typeof this.u=="number"&&this.focus(this.u),this.J()}getWidth(e){if(e>=0&&e<this.C.children.length){const i=this.C.children.item(e);if(i)return i.clientWidth}return 0}getHeight(e){if(e>=0&&e<this.C.children.length){const i=this.C.children.item(e);if(i)return i.clientHeight}return 0}pull(e){e>=0&&e<this.viewItems.length&&(this.C.removeChild(this.C.childNodes[e]),this.s.deleteAndDispose(this.viewItems[e]),(0,d.$Qc)(this.viewItems.splice(e,1)),this.J())}clear(){this.isEmpty()||(this.viewItems=(0,d.$Qc)(this.viewItems),this.s.clearAndDisposeAll(),n.$NR(this.C),this.J())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(e){let i=!1,o;if(e===void 0?i=!0:typeof e=="number"?o=e:typeof e=="boolean"&&(i=e),i&&typeof this.u>"u"){const l=this.viewItems.findIndex(f=>f.isEnabled());this.u=l===-1?void 0:l,this.R(void 0,void 0,!0)}else o!==void 0&&(this.u=o),this.R(void 0,void 0,!0)}N(){return this.u=this.length()-1,this.P(!0)}O(){return this.u=0,this.Q(!0)}P(e){if(typeof this.u>"u")this.u=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const i=this.u;let o;do{if(!e&&this.b.preventLoopNavigation&&this.u+1>=this.viewItems.length)return this.u=i,!1;this.u=(this.u+1)%this.viewItems.length,o=this.viewItems[this.u]}while(this.u!==i&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===A.$cj.ID));return this.R(),!0}Q(e){if(typeof this.u>"u")this.u=0;else if(this.viewItems.length<=1)return!1;const i=this.u;let o;do{if(this.u=this.u-1,this.u<0){if(!e&&this.b.preventLoopNavigation)return this.u=i,!1;this.u=this.viewItems.length-1}o=this.viewItems[this.u]}while(this.u!==i&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===A.$cj.ID));return this.R(!0),!0}R(e,i,o=!1){typeof this.u>"u"&&this.C.focus({preventScroll:i}),this.t!==void 0&&this.t!==this.u&&this.viewItems[this.t]?.blur();const l=this.u!==void 0?this.viewItems[this.u]:void 0;if(l){let f=!0;g.$jg(l.focus)||(f=!1),this.b.focusOnlyEnabledItems&&g.$jg(l.isEnabled)&&!l.isEnabled()&&(f=!1),l.action.id===A.$cj.ID&&(f=!1),f?(o||this.t!==this.u)&&(l.focus(e),this.t=this.u):(this.C.focus({preventScroll:i}),this.t=void 0),f&&l.showHover?.()}}S(e){if(typeof this.u>"u")return;const i=this.viewItems[this.u];if(i instanceof B.$CU){const o=i._context===null||i._context===void 0?e:i._context;this.run(i._action,o)}}async run(e,i){await this.g.run(e,i)}dispose(){this.m=void 0,this.viewItems=(0,d.$Qc)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.$IT=M;function c(h){if(!h.length)return h;let e=-1;for(let o=0;o<h.length;o++)if(h[o].id!==A.$cj.ID){e=o;break}if(e===-1)return[];h=h.slice(e);for(let o=h.length-1;o>=0&&h[o].id===A.$cj.ID;o--)h.splice(o,1);let i=!1;for(let o=h.length-1;o>=0;o--){const l=h[o].id===A.$cj.ID;l&&!i?h.splice(o,1):l?l&&(i=!1):i=!0}return h}}),define(me[75],be([1,0,4,24,66,74,68,29,14,71,21,3,91,61,120,109]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lV=t.$kV=t.$jV=t.MessageType=void 0;const i=n.$;var o;(function(S){S[S.INFO=1]="INFO",S[S.WARNING=2]="WARNING",S[S.ERROR=3]="ERROR"})(o||(t.MessageType=o={})),t.$jV={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class l extends w.$pT{constructor(m,b,r){super(),this.w="idle",this.M=Number.POSITIVE_INFINITY,this.P=this.B(new M.$ee),this.onDidChange=this.P.event,this.Q=this.B(new M.$ee),this.onDidHeightChange=this.Q.event,this.a=b,this.g=r,this.h=null,this.n=this.g.placeholder||"",this.r=this.g.tooltip??(this.n||""),this.s=this.g.ariaLabel||"",this.g.validationOptions&&(this.t=this.g.validationOptions.validation),this.element=n.$OS(m,i(".monaco-inputbox.idle"));const D=this.g.flexibleHeight?"textarea":"input",k=n.$OS(this.element,i(".ibwrapper"));if(this.b=n.$OS(k,i(D+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.G(this.b,()=>this.element.classList.add("synthetic-focus")),this.F(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.M=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.y=n.$OS(k,i("div.mirror")),this.y.innerText="\xA0",this.N=new g.$zT(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.y.style.whiteSpace="pre",this.y.style.wordWrap="initial"),n.$OS(m,this.N.getDomNode()),this.B(this.N),this.B(this.N.onScroll(q=>this.b.scrollTop=q.scrollTop));const T=this.B(new C.$QT(m.ownerDocument,"selectionchange")),L=M.Event.filter(T.event,()=>m.ownerDocument.getSelection()?.anchorNode===k);this.B(L(this.U,this)),this.B(this.onDidHeightChange(this.U,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.s&&this.b.setAttribute("aria-label",this.s),this.n&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.n),this.r&&this.setTooltip(this.r),this.D(this.b,()=>this.Z()),this.F(this.b,()=>this.R()),this.G(this.b,()=>this.S()),this.B(this.I(this.b)),setTimeout(()=>this.ab(),0),this.g.actions&&(this.c=this.B(new H.$IT(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.bb()}R(){this.Y(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}S(){this.X(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.n||"")}setPlaceHolder(m){this.n=m,this.b.setAttribute("placeholder",m)}setTooltip(m){this.r=m,this.O?this.O.update(m):this.O=this.B((0,P.$sU)().setupUpdatableHover((0,d.$GT)("mouse"),this.b,m))}setAriaLabel(m){this.s=m,m?this.b.setAttribute("aria-label",this.s):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.s}get mirrorElement(){return this.y}get inputElement(){return this.b}get value(){return this.b.value}set value(m){this.b.value!==m&&(this.b.value=m,this.Z())}get step(){return this.b.step}set step(m){this.b.step=m}get height(){return typeof this.J=="number"?this.J:n.$eS(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return n.$pS(this.b)}select(m=null){this.b.select(),m&&(this.b.setSelectionRange(m.start,m.end),m.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}getSelection(){const m=this.b.selectionStart;if(m===null)return null;const b=this.b.selectionEnd??m;return{start:m,end:b}}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Y()}setEnabled(m){m?this.enable():this.disable()}get width(){return n.$aS(this.b)}set width(m){if(this.g.flexibleHeight&&this.g.flexibleWidth){let b=0;if(this.y){const r=parseFloat(this.y.style.paddingLeft||"")||0,D=parseFloat(this.y.style.paddingRight||"")||0;b=r+D}this.b.style.width=m-b+"px"}else this.b.style.width=m+"px";this.y&&(this.y.style.width=m+"px")}set paddingRight(m){this.b.style.width=`calc(100% - ${m}px)`,this.y&&(this.y.style.paddingRight=m+"px")}U(){if(typeof this.L!="number"||typeof this.J!="number"||!this.N)return;const m=this.L,b=this.J,r=this.b.scrollTop;this.N.setScrollDimensions({scrollHeight:m,height:b}),this.N.setScrollPosition({scrollTop:r})}showMessage(m,b){if(this.w==="open"&&(0,h.$6n)(this.h,m))return;this.h=m,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.W(m.type));const r=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${n.$7S(r.border,"transparent")}`,this.h.content&&(this.hasFocus()||b)&&this.X()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Y(),this.bb()}isInputValid(){return!!this.t&&!this.t(this.value)}validate(){let m=null;return this.t&&(m=this.t(this.value),m?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(m)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),m?.type}stylesForType(m){const b=this.g.inputBoxStyles;switch(m){case 1:return{border:b.inputValidationInfoBorder,background:b.inputValidationInfoBackground,foreground:b.inputValidationInfoForeground};case 2:return{border:b.inputValidationWarningBorder,background:b.inputValidationWarningBackground,foreground:b.inputValidationWarningForeground};default:return{border:b.inputValidationErrorBorder,background:b.inputValidationErrorBackground,foreground:b.inputValidationErrorForeground}}}W(m){switch(m){case 1:return"info";case 2:return"warning";default:return"error"}}X(){if(!this.a||!this.h)return;let m;const b=()=>m.style.width=n.$aS(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:D=>{if(!this.h)return null;m=n.$OS(D,i(".monaco-inputbox-container")),b();const k={inline:!0,className:"monaco-inputbox-message"},T=this.h.formatContent?(0,B.$OT)(this.h.content,k):(0,B.$NT)(this.h.content,k);T.classList.add(this.W(this.h.type));const L=this.stylesForType(this.h.type);return T.style.backgroundColor=L.background??"",T.style.color=L.foreground??"",T.style.border=L.border?`1px solid ${L.border}`:"",n.$OS(m,T),null},onHide:()=>{this.w="closed"},layout:b});let r;this.h.type===3?r=e.localize(0,null,this.h.content):this.h.type===2?r=e.localize(1,null,this.h.content):r=e.localize(2,null,this.h.content),A.$ST(r),this.w="open"}Y(){this.a&&(this.w==="open"&&this.a.hideContextView(),this.w="idle")}Z(){this.P.fire(this.value),this.validate(),this.ab(),this.b.classList.toggle("empty",!this.value),this.w==="open"&&this.a&&this.a.layout()}ab(){if(!this.y)return;const m=this.value,r=m.charCodeAt(m.length-1)===10?" ":"";(m+r).replace(/\u000c/g,"")?this.y.textContent=m+r:this.y.innerText="\xA0",this.layout()}bb(){const m=this.g.inputBoxStyles,b=m.inputBackground??"",r=m.inputForeground??"",D=m.inputBorder??"";this.element.style.backgroundColor=b,this.element.style.color=r,this.b.style.backgroundColor="inherit",this.b.style.color=r,this.element.style.border=`1px solid ${n.$7S(D,"transparent")}`}layout(){if(!this.y)return;const m=this.L;this.L=n.$eS(this.y),m!==this.L&&(this.J=Math.min(this.L,this.M),this.b.style.height=this.J+"px",this.Q.fire(this.L))}insertAtCursor(m){const b=this.inputElement,r=b.selectionStart,D=b.selectionEnd,k=b.value;r!==null&&D!==null&&(this.value=k.substr(0,r)+m+k.substr(D),b.setSelectionRange(r+1,r+1),this.layout())}dispose(){this.Y(),this.h=null,this.c?.dispose(),super.dispose()}}t.$kV=l;class f extends l{constructor(m,b,r){const D=e.localize(3,null,"\u21C5"),k=e.localize(4,null,"\u21C5");super(m,b,r),this.eb=this.B(new M.$ee),this.onDidFocus=this.eb.event,this.fb=this.B(new M.$ee),this.onDidBlur=this.fb.event,this.cb=new c.$hV(r.history,100);const T=()=>{if(r.showHistoryHint&&r.showHistoryHint()&&!this.n.endsWith(D)&&!this.n.endsWith(k)&&this.cb.getHistory().length){const L=this.n.endsWith(")")?D:k,q=this.n+L;r.showPlaceholderOnFocus&&!n.$pS(this.b)?this.n=q:this.setPlaceHolder(q)}};this.db=new MutationObserver((L,q)=>{L.forEach($=>{$.target.textContent||T()})}),this.db.observe(this.b,{attributeFilter:["class"]}),this.G(this.b,()=>T()),this.F(this.b,()=>{const L=q=>{if(this.n.endsWith(q)){const $=this.n.slice(0,this.n.length-q.length);return r.showPlaceholderOnFocus?this.n=$:this.setPlaceHolder($),!0}else return!1};L(k)||L(D)})}dispose(){super.dispose(),this.db&&(this.db.disconnect(),this.db=void 0)}addToHistory(m){this.value&&(m||this.value!==this.ib())&&this.cb.add(this.value)}prependHistory(m){const b=this.getHistory();this.clearHistory(),m.forEach(r=>{this.cb.add(r)}),b.forEach(r=>{this.cb.add(r)})}getHistory(){return this.cb.getHistory()}isAtFirstInHistory(){return this.cb.isFirst()}isAtLastInHistory(){return this.cb.isLast()}isNowhereInHistory(){return this.cb.isNowhere()}showNextValue(){this.cb.has(this.value)||this.addToHistory();let m=this.kb();m&&(m=m===this.value?this.kb():m),this.value=m??"",A.$TT(this.value?this.value:e.localize(5,null))}showPreviousValue(){this.cb.has(this.value)||this.addToHistory();let m=this.jb();m&&(m=m===this.value?this.jb():m),m&&(this.value=m,A.$TT(this.value))}clearHistory(){this.cb.clear()}setPlaceHolder(m){super.setPlaceHolder(m),this.setTooltip(m)}R(){super.R(),this.fb.fire()}S(){super.S(),this.eb.fire()}ib(){let m=this.cb.current();return m||(m=this.cb.last(),this.cb.next()),m}jb(){return this.cb.previous()||this.cb.first()}kb(){return this.cb.next()}}t.$lV=f}),define(me[76],be([1,0,73,21,18,19,3,4,14,29,114]),function(se,t,n,C,B,H,A,P,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$BU=t.$AU=t.$zU=t.$yU=t.$xU=void 0,t.$xU={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class w extends n.$CU{constructor(i,o,l){super(i,o,l),this.a=this.B(new M({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground,hoverDelegate:l.hoverDelegate})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(i){this.element=i,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}H(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(i){this.a.domNode.tabIndex=i?0:-1}}t.$yU=w;class M extends C.$pT{constructor(i){super(),this.a=this.B(new A.$ee),this.onChange=this.a.event,this.b=this.B(new A.$ee),this.onKeyDown=this.b.event,this.c=i,this.s=this.c.isChecked;const o=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,o.push(...H.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&o.push(...this.c.actionClassName.split(" ")),this.s&&o.push("checked"),this.domNode=document.createElement("div"),this.t=this.B((0,g.$sU)().setupUpdatableHover(i.hoverDelegate??(0,d.$GT)("mouse"),this.domNode,this.c.title)),this.domNode.classList.add(...o),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.w(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.I(this.domNode)),this.z(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(i){this.s=i,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.w()}setIcon(i){this.g&&this.domNode.classList.remove(...H.ThemeIcon.asClassNameArray(this.g)),this.g=i,this.g&&this.domNode.classList.add(...H.ThemeIcon.asClassNameArray(this.g))}width(){return 22}w(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(i){this.t.update(i),this.domNode.setAttribute("aria-label",i)}set visible(i){this.domNode.style.display=i?"":"none"}get visible(){return this.domNode.style.display!=="none"}}t.$zU=M;class c extends C.$pT{constructor(i,o,l){super(),this.g=i,this.h=o,this.a=this.B(new A.$ee),this.onChange=this.a.event,this.b=this.B(new M({title:this.g,isChecked:this.h,icon:B.$Uj.check,actionClassName:"monaco-checkbox",...t.$xU})),this.domNode=this.b.domNode,this.c=l,this.n(),this.B(this.b.onChange(f=>{this.n(),this.a.fire(f)}))}get checked(){return this.b.checked}set checked(i){this.b.checked=i,this.n()}focus(){this.domNode.focus()}hasFocus(){return(0,P.$pS)(this.domNode)}enable(){this.b.enable()}disable(){this.b.disable()}n(){this.domNode.style.color=this.c.checkboxForeground||"",this.domNode.style.backgroundColor=this.c.checkboxBackground||"",this.domNode.style.borderColor=this.c.checkboxBorder||""}}t.$AU=c;class h extends n.$CU{constructor(i,o,l){super(i,o,l),this.a=this.B(new c(this._action.label,!!this._action.checked,l.checkboxStyles)),this.B(this.a.onChange(()=>this.c()))}render(i){if(this.element=i,this.element.classList.add("checkbox-action-item"),this.element.appendChild(this.a.domNode),this.m.label&&this._action.label){const o=this.element.appendChild((0,P.$)("span.checkbox-label",void 0,this._action.label));this.B((0,P.$OR)(o,P.$HS.CLICK,l=>{this.a.checked=!this.a.checked,l.stopPropagation(),l.preventDefault(),this.c()}))}this.u(),this.G(),this.H()}c(){this._action.checked=!!this.a&&this.a.checked,this.actionRunner.run(this._action,this._context)}u(){this.isEnabled()?this.a.enable():this.a.disable(),this.action.enabled?this.element?.classList.remove("disabled"):this.element?.classList.add("disabled")}H(){this.a.checked=!!this._action.checked}G(){this.b&&this.a.domNode.classList.remove(...this.b.split(" ")),this.b=this.z(),this.b&&this.a.domNode.classList.add(...this.b.split(" "))}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(i){this.a.domNode.tabIndex=i?0:-1}}t.$BU=h}),define(me[141],be([1,0,14,76,18,119]),function(se,t,n,C,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$yV=t.$xV=t.$wV=void 0;const A=H.localize(0,null),P=H.localize(1,null),d=H.localize(2,null);class g extends C.$zU{constructor(h){super({icon:B.$Uj.caseSensitive,title:A+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,n.$GT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$wV=g;class w extends C.$zU{constructor(h){super({icon:B.$Uj.wholeWord,title:P+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,n.$GT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$xV=w;class M extends C.$zU{constructor(h){super({icon:B.$Uj.regex,title:d+h.appendTitle,isChecked:h.isChecked,hoverDelegate:h.hoverDelegate??(0,n.$GT)("element"),inputActiveOptionBorder:h.inputActiveOptionBorder,inputActiveOptionForeground:h.inputActiveOptionForeground,inputActiveOptionBackground:h.inputActiveOptionBackground})}}t.$yV=M}),define(me[142],be([1,0,4,141,75,21,3,118,2,14,108]),function(se,t,n,C,B,H,A,P,d,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zV=void 0;const w=P.localize(0,null);class M extends H.$pT{static{this.OPTION_CHANGE="optionChange"}constructor(h,e,i){super(),this.n=!0,this.s=!1,this.w=this.B(new d.$Wc),this.N=[],this.O=this.B(new A.$ee),this.onDidOptionChange=this.O.event,this.P=this.B(new A.$ee),this.onKeyDown=this.P.event,this.Q=this.B(new A.$ee),this.onMouseDown=this.Q.event,this.R=this.B(new A.$ee),this.onInput=this.R.event,this.S=this.B(new A.$ee),this.onKeyUp=this.S.event,this.U=this.B(new A.$ee),this.onCaseSensitiveKeyDown=this.U.event,this.W=this.B(new A.$ee),this.onRegexKeyDown=this.W.event,this.Y=0,this.a=i.placeholder||"",this.b=i.validation,this.c=i.label||w,this.h=!!i.showCommonFindToggles;const o=i.appendCaseSensitiveLabel||"",l=i.appendWholeWordsLabel||"",f=i.appendRegexLabel||"",S=i.history||[],m=!!i.flexibleHeight,b=!!i.flexibleWidth,r=i.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new B.$lV(this.domNode,e,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:S,showHistoryHint:i.showHistoryHint,flexibleHeight:m,flexibleWidth:b,flexibleMaxHeight:r,inputBoxStyles:i.inputBoxStyles}));const D=this.B((0,g.$HT)());if(this.h){this.J=this.B(new C.$yV({appendTitle:f,isChecked:!1,hoverDelegate:D,...i.toggleStyles})),this.B(this.J.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.J.onKeyDown(T=>{this.W.fire(T)})),this.L=this.B(new C.$xV({appendTitle:l,isChecked:!1,hoverDelegate:D,...i.toggleStyles})),this.B(this.L.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.M=this.B(new C.$wV({appendTitle:o,isChecked:!1,hoverDelegate:D,...i.toggleStyles})),this.B(this.M.onChange(T=>{this.O.fire(T),!T&&this.n&&this.inputBox.focus(),this.validate()})),this.B(this.M.onKeyDown(T=>{this.U.fire(T)}));const k=[this.M.domNode,this.L.domNode,this.J.domNode];this.z(this.domNode,T=>{if(T.equals(15)||T.equals(17)||T.equals(9)){const L=k.indexOf(this.domNode.ownerDocument.activeElement);if(L>=0){let q=-1;T.equals(17)?q=(L+1)%k.length:T.equals(15)&&(L===0?q=k.length-1:q=L-1),T.equals(9)?(k[L].blur(),this.inputBox.focus()):q>=0&&k[q].focus(),n.$JS.stop(T,!0)}}})}this.y=document.createElement("div"),this.y.className="controls",this.y.style.display=this.h?"":"none",this.M&&this.y.append(this.M.domNode),this.L&&this.y.appendChild(this.L.domNode),this.J&&this.y.appendChild(this.J.domNode),this.setAdditionalToggles(i?.additionalToggles),this.y&&this.domNode.appendChild(this.y),h?.appendChild(this.domNode),this.B(n.$OR(this.inputBox.inputElement,"compositionstart",k=>{this.s=!0})),this.B(n.$OR(this.inputBox.inputElement,"compositionend",k=>{this.s=!1,this.R.fire()})),this.z(this.inputBox.inputElement,k=>this.P.fire(k)),this.C(this.inputBox.inputElement,k=>this.S.fire(k)),this.D(this.inputBox.inputElement,k=>this.R.fire()),this.j(this.inputBox.inputElement,k=>this.Q.fire(k))}get isImeSessionInProgress(){return this.s}get onDidChange(){return this.inputBox.onDidChange}layout(h){this.inputBox.layout(),this.X(h.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.J?.enable(),this.L?.enable(),this.M?.enable();for(const h of this.N)h.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.J?.disable(),this.L?.disable(),this.M?.disable();for(const h of this.N)h.disable()}setFocusInputOnOptionClick(h){this.n=h}setEnabled(h){h?this.enable():this.disable()}setAdditionalToggles(h){for(const e of this.N)e.domNode.remove();this.N=[],this.w.value=new d.$Uc;for(const e of h??[])this.w.value.add(e),this.y.appendChild(e.domNode),this.w.value.add(e.onChange(i=>{this.O.fire(i),!i&&this.n&&this.inputBox.focus()})),this.N.push(e);this.N.length>0&&(this.y.style.display=""),this.X()}X(h=!1){h?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.M?.width()??0)+(this.L?.width()??0)+(this.J?.width()??0)+this.N.reduce((e,i)=>e+i.width(),0)}clear(){this.Z(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(h){this.inputBox.value!==h&&(this.inputBox.value=h)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.M?.checked??!1}setCaseSensitive(h){this.M&&(this.M.checked=h)}getWholeWords(){return this.L?.checked??!1}setWholeWords(h){this.L&&(this.L.checked=h)}getRegex(){return this.J?.checked??!1}setRegex(h){this.J&&(this.J.checked=h,this.validate())}focusOnCaseSensitive(){this.M?.focus()}focusOnRegex(){this.J?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.Y),this.Y=1-this.Y,this.domNode.classList.add("highlight-"+this.Y)}validate(){this.inputBox.validate()}showMessage(h){this.inputBox.showMessage(h)}clearMessage(){this.inputBox.hideMessage()}Z(){this.inputBox.hideMessage()}}t.$zV=M}),define(me[143],be([1,0,4,24,15,74,142,75,72,49,76,69,30,46,8,11,18,19,39,3,44,2,40,10,122,14,57,115]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i,o,l,f,S,m,b,r,D,k,T,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$aW=t.AbstractTreePart=t.TreeFindMatchType=t.TreeFindMode=t.$_V=t.$$V=t.$0V=t.RenderIndentGuides=t.$9V=t.$8V=void 0;class q extends d.$1T{set context(s){this.c.context=s}get context(){return this.c.context}constructor(s){super(s.elements.map(E=>E.element)),this.c=s}}function $(F){return F instanceof d.$1T?new q(F):F}class I{constructor(s,E){this.d=s,this.f=E,this.b=b.$Vc.None,this.c=new b.$Uc}getDragURI(s){return this.f.getDragURI(s.element)}getDragLabel(s,E){if(this.f.getDragLabel)return this.f.getDragLabel(s.map(p=>p.element),E)}onDragStart(s,E){this.f.onDragStart?.($(s),E)}onDragOver(s,E,p,R,O,U=!0){const Z=this.f.onDragOver($(s),E&&E.element,p,R,O),oe=this.a!==E;if(oe&&(this.b.dispose(),this.a=E),typeof E>"u")return Z;if(oe&&typeof Z!="boolean"&&Z.autoExpand&&(this.b=(0,i.$xh)(()=>{const je=this.d(),Se=je.getNodeLocation(E);je.isCollapsed(Se)&&je.setCollapsed(Se,!1),this.a=void 0},500,this.c)),typeof Z=="boolean"||!Z.accept||typeof Z.bubble>"u"||Z.feedback){if(!U){const je=typeof Z=="boolean"?Z:Z.accept,Se=typeof Z=="boolean"?void 0:Z.effect;return{accept:je,effect:Se,feedback:[p]}}return Z}if(Z.bubble===1){const je=this.d(),Se=je.getNodeLocation(E),Ce=je.getParentNodeLocation(Se),We=je.getNode(Ce),Xe=Ce&&je.getListIndex(Ce);return this.onDragOver(s,We,Xe,R,O,!1)}const pe=this.d(),fe=pe.getNodeLocation(E),Re=pe.getListIndex(fe),Pe=pe.getListRenderCount(fe);return{...Z,feedback:(0,e.$Sb)(Re,Re+Pe)}}drop(s,E,p,R,O){this.b.dispose(),this.a=void 0,this.f.drop($(s),E&&E.element,p,R,O)}onDragEnd(s){this.f.onDragEnd?.(s)}dispose(){this.c.dispose(),this.f.dispose()}}function V(F,s){return s&&{...s,identityProvider:s.identityProvider&&{getId(E){return s.identityProvider.getId(E.element)}},dnd:s.dnd&&new I(F,s.dnd),multipleSelectionController:s.multipleSelectionController&&{isSelectionSingleChangeEvent(E){return s.multipleSelectionController.isSelectionSingleChangeEvent({...E,element:E.element})},isSelectionRangeChangeEvent(E){return s.multipleSelectionController.isSelectionRangeChangeEvent({...E,element:E.element})}},accessibilityProvider:s.accessibilityProvider&&{...s.accessibilityProvider,getSetSize(E){const p=F(),R=p.getNodeLocation(E),O=p.getParentNodeLocation(R);return p.getNode(O).visibleChildrenCount},getPosInSet(E){return E.visibleChildIndex+1},isChecked:s.accessibilityProvider&&s.accessibilityProvider.isChecked?E=>s.accessibilityProvider.isChecked(E.element):void 0,getRole:s.accessibilityProvider&&s.accessibilityProvider.getRole?E=>s.accessibilityProvider.getRole(E.element):()=>"treeitem",getAriaLabel(E){return s.accessibilityProvider.getAriaLabel(E.element)},getWidgetAriaLabel(){return s.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:s.accessibilityProvider&&s.accessibilityProvider.getWidgetRole?()=>s.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:s.accessibilityProvider&&s.accessibilityProvider.getAriaLevel?E=>s.accessibilityProvider.getAriaLevel(E.element):E=>E.depth,getActiveDescendantId:s.accessibilityProvider.getActiveDescendantId&&(E=>s.accessibilityProvider.getActiveDescendantId(E.element))},keyboardNavigationLabelProvider:s.keyboardNavigationLabelProvider&&{...s.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(E){return s.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(E.element)}}}}class N{constructor(s){this.a=s}getHeight(s){return this.a.getHeight(s.element)}getTemplateId(s){return this.a.getTemplateId(s.element)}hasDynamicHeight(s){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(s.element)}setDynamicHeight(s,E){this.a.setDynamicHeight?.(s.element,E)}}t.$8V=N;class x{static lift(s){return s instanceof x?s:new x(s)}static empty(s=0){return new x({focus:[],selection:[],expanded:Object.create(null),scrollTop:s})}constructor(s){if(this.focus=new Set(s.focus),this.selection=new Set(s.selection),s.expanded instanceof Array){this.expanded=Object.create(null);for(const E of s.expanded)this.expanded[E]=1}else this.expanded=s.expanded;this.expanded=s.expanded,this.scrollTop=s.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.$9V=x;var j;(function(F){F.None="none",F.OnHover="onHover",F.Always="always"})(j||(t.RenderIndentGuides=j={}));class Y{get elements(){return this.b}constructor(s,E=[]){this.b=E,this.a=new b.$Uc,this.onDidChange=S.Event.forEach(s,p=>this.b=p,this.a)}dispose(){this.a.dispose()}}class K{static{this.a=8}constructor(s,E,p,R,O,U={}){this.o=s,this.p=E,this.q=R,this.s=O,this.b=new Map,this.c=new Map,this.d=K.a,this.f=!1,this.g=!1,this.j=new Set,this.k=b.$Vc.None,this.m=new b.$Uc,this.templateId=s.templateId,this.updateOptions(U),S.Event.map(p,Z=>Z.node)(this.u,this,this.m),s.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(s={}){if(typeof s.indent<"u"){const E=(0,r.$Am)(s.indent,0,40);if(E!==this.d){this.d=E;for(const[p,R]of this.c)this.v(p,R)}}if(typeof s.renderIndentGuides<"u"){const E=s.renderIndentGuides!==j.None;if(E!==this.g){this.g=E;for(const[p,R]of this.c)this.w(p,R);if(this.k.dispose(),E){const p=new b.$Uc;this.q.onDidChange(this.x,this,p),this.k=p,this.x(this.q.elements)}}}typeof s.hideTwistiesOfChildlessElements<"u"&&(this.f=s.hideTwistiesOfChildlessElements)}renderTemplate(s){const E=(0,n.$OS)(s,(0,n.$)(".monaco-tl-row")),p=(0,n.$OS)(E,(0,n.$)(".monaco-tl-indent")),R=(0,n.$OS)(E,(0,n.$)(".monaco-tl-twistie")),O=(0,n.$OS)(E,(0,n.$)(".monaco-tl-contents")),U=this.o.renderTemplate(O);return{container:s,indent:p,twistie:R,indentGuidesDisposable:b.$Vc.None,templateData:U}}renderElement(s,E,p,R){this.c.set(s,p),this.b.set(s.element,s),this.v(s,p),this.o.renderElement(s,E,p.templateData,R)}disposeElement(s,E,p,R){p.indentGuidesDisposable.dispose(),this.o.disposeElement?.(s,E,p.templateData,R),typeof R=="number"&&(this.c.delete(s),this.b.delete(s.element))}disposeTemplate(s){this.o.disposeTemplate(s.templateData)}t(s){const E=this.b.get(s);E&&this.u(E)}u(s){const E=this.c.get(s);E&&(this.x(this.q.elements),this.v(s,E))}v(s,E){const p=K.a+(s.depth-1)*this.d;E.twistie.style.paddingLeft=`${p}px`,E.indent.style.width=`${p+this.d-16}px`,s.collapsible?E.container.setAttribute("aria-expanded",String(!s.collapsed)):E.container.removeAttribute("aria-expanded"),E.twistie.classList.remove(...l.ThemeIcon.asClassNameArray(o.$Uj.treeItemExpanded));let R=!1;this.o.renderTwistie&&(R=this.o.renderTwistie(s.element,E.twistie)),s.collapsible&&(!this.f||s.visibleChildrenCount>0)?(R||E.twistie.classList.add(...l.ThemeIcon.asClassNameArray(o.$Uj.treeItemExpanded)),E.twistie.classList.add("collapsible"),E.twistie.classList.toggle("collapsed",s.collapsed)):E.twistie.classList.remove("collapsible","collapsed"),this.w(s,E)}w(s,E){if((0,n.$NR)(E.indent),E.indentGuidesDisposable.dispose(),!this.g)return;const p=new b.$Uc,R=this.p();for(;;){const O=R.getNodeLocation(s),U=R.getParentNodeLocation(O);if(!U)break;const Z=R.getNode(U),oe=(0,n.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(Z)&&oe.classList.add("active"),E.indent.childElementCount===0?E.indent.appendChild(oe):E.indent.insertBefore(oe,E.indent.firstElementChild),this.s.add(Z,oe),p.add((0,b.$Tc)(()=>this.s.delete(Z,oe))),s=Z}E.indentGuidesDisposable=p}x(s){if(!this.g)return;const E=new Set,p=this.p();s.forEach(R=>{const O=p.getNodeLocation(R);try{const U=p.getParentNodeLocation(O);R.collapsible&&R.children.length>0&&!R.collapsed?E.add(R):U&&E.add(p.getNode(U))}catch{}}),this.j.forEach(R=>{E.has(R)||this.s.forEach(R,O=>O.classList.remove("active"))}),E.forEach(R=>{this.j.has(R)||this.s.forEach(R,O=>O.classList.add("active"))}),this.j=E}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,b.$Qc)(this.m)}}t.$0V=K;class ae{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(s){this.c=s,this.d=s.toLowerCase()}constructor(s,E,p){this.g=s,this.j=E,this.k=p,this.a=0,this.b=0,this.c="",this.d="",this.f=new b.$Uc,s.onWillRefilter(this.m,this,this.f)}filter(s,E){let p=1;if(this.k){const U=this.k.filter(s,E);if(typeof U=="boolean"?p=U?1:0:(0,M.$5V)(U)?p=(0,M.$6V)(U.visibility):p=U,p===0)return!1}if(this.a++,!this.c)return this.b++,{data:m.FuzzyScore.Default,visibility:p};const R=this.j.getKeyboardNavigationLabel(s),O=Array.isArray(R)?R:[R];for(const U of O){const Z=U&&U.toString();if(typeof Z>"u")return{data:m.FuzzyScore.Default,visibility:p};let oe;if(this.g.findMatchType===Ee.Contiguous){const pe=Z.toLowerCase().indexOf(this.d);if(pe>-1){oe=[Number.MAX_SAFE_INTEGER,0];for(let fe=this.d.length;fe>0;fe--)oe.push(pe+fe-1)}}else oe=(0,m.$Jk)(this.c,this.d,0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(oe)return this.b++,O.length===1?{data:oe,visibility:p}:{data:{label:Z,score:oe},visibility:p}}return this.g.findMode===De.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(s):2:{data:m.FuzzyScore.Default,visibility:p}}m(){this.a=0,this.b=0}dispose(){(0,b.$Qc)(this.f)}}class ie extends w.$zU{constructor(s){super({icon:o.$Uj.listFilter,title:(0,k.localize)(0,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,T.$GT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$$V=ie;class ee extends w.$zU{constructor(s){super({icon:o.$Uj.searchFuzzy,title:(0,k.localize)(1,null),isChecked:s.isChecked??!1,hoverDelegate:s.hoverDelegate??(0,T.$GT)("element"),inputActiveOptionBorder:s.inputActiveOptionBorder,inputActiveOptionForeground:s.inputActiveOptionForeground,inputActiveOptionBackground:s.inputActiveOptionBackground})}}t.$_V=ee;const ce={inputBoxStyles:P.$jV,toggleStyles:w.$xU,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var De;(function(F){F[F.Highlight=0]="Highlight",F[F.Filter=1]="Filter"})(De||(t.TreeFindMode=De={}));var Ee;(function(F){F[F.Fuzzy=0]="Fuzzy",F[F.Contiguous=1]="Contiguous"})(Ee||(t.TreeFindMatchType=Ee={}));class Le extends b.$Vc{set mode(s){this.b.checked=s===De.Filter,this.f.inputBox.setPlaceHolder(s===De.Filter?(0,k.localize)(2,null):(0,k.localize)(3,null))}set matchType(s){this.c.checked=s===Ee.Fuzzy}get value(){return this.f.inputBox.value}set value(s){this.f.inputBox.value=s}constructor(s,E,p,R,O,U){super(),this.t=E,this.a=(0,n.h)(".monaco-tree-type-filter",[(0,n.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,n.h)(".monaco-tree-type-filter-input@findInput"),(0,n.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.m=0,this.s=0,this._onDidDisable=new S.$ee,this.onDidDisable=this._onDidDisable.event,s.appendChild(this.a.root),this.B((0,b.$Tc)(()=>s.removeChild(this.a.root)));const Z=U?.styles??ce;Z.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=Z.listFilterWidgetBackground),Z.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${Z.listFilterWidgetShadow}`);const oe=this.B((0,T.$HT)());this.b=this.B(new ie({...Z.toggleStyles,isChecked:R===De.Filter,hoverDelegate:oe})),this.c=this.B(new ee({...Z.toggleStyles,isChecked:O===Ee.Fuzzy,hoverDelegate:oe})),this.onDidChangeMode=S.Event.map(this.b.onChange,()=>this.b.checked?De.Filter:De.Highlight,this.q),this.onDidChangeMatchType=S.Event.map(this.c.onChange,()=>this.c.checked?Ee.Fuzzy:Ee.Contiguous,this.q),this.f=this.B(new A.$zV(this.a.findInput,p,{label:(0,k.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:Z.inputBoxStyles,toggleStyles:Z.toggleStyles,history:U?.history})),this.g=this.B(new H.$IT(this.a.actionbar)),this.mode=R;const pe=this.B(new C.$QT(this.f.inputBox.inputElement,"keydown")),fe=S.Event.chain(pe.event,Se=>Se.map(Ce=>new B.$LR(Ce)));this.B(fe(Se=>{if(Se.equals(3)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.addToHistory(),this.t.domFocus();return}if(Se.equals(18)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.t.domFocus()):this.f.inputBox.showNextValue();return}if(Se.equals(16)){Se.preventDefault(),Se.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const Re=this.B(new h.$aj("close",(0,k.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(Re,{icon:!0,label:!1});const Pe=this.B(new C.$QT(this.a.grab,"mousedown"));this.B(Pe.event(Se=>{const Ce=new b.$Uc,We=Ce.add(new C.$QT((0,n.getWindow)(Se),"mousemove")),Xe=Ce.add(new C.$QT((0,n.getWindow)(Se),"mouseup")),Ue=this.m,_e=Se.pageX,J=this.s,ne=Se.pageY;this.a.grab.classList.add("grabbing");const $e=this.a.root.style.transition;this.a.root.style.transition="unset";const ve=Ne=>{const ze=Ne.pageX-_e;this.m=Ue-ze;const Ve=Ne.pageY-ne;this.s=J+Ve,this.layout()};Ce.add(We.event(ve)),Ce.add(Xe.event(Ne=>{ve(Ne),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=$e,Ce.dispose()}))}));const je=S.Event.chain(this.B(new C.$QT(this.a.grab,"keydown")).event,Se=>Se.map(Ce=>new B.$LR(Ce)));this.B(je(Se=>{let Ce,We;if(Se.keyCode===15?Ce=Number.POSITIVE_INFINITY:Se.keyCode===17?Ce=0:Se.keyCode===10&&(Ce=this.m===0?Number.POSITIVE_INFINITY:0),Se.keyCode===16?We=0:Se.keyCode===18&&(We=Number.POSITIVE_INFINITY),Ce!==void 0&&(Se.preventDefault(),Se.stopPropagation(),this.m=Ce,this.layout()),We!==void 0){Se.preventDefault(),Se.stopPropagation(),this.s=We;const Xe=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=Xe},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(s=this.j){this.j=s,this.m=(0,r.$Am)(this.m,0,Math.max(0,s-212)),this.a.root.style.right=`${this.m}px`,this.s=(0,r.$Am)(this.s,0,24),this.a.root.style.top=`${this.s}px`}showMessage(s){this.f.showMessage(s)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,i.$wh)(300),super.dispose()}}class le{get pattern(){return this.b}get mode(){return this.d}set mode(s){s!==this.d&&(this.d=s,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(s))}get matchType(){return this.f}set matchType(s){s!==this.f&&(this.f=s,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(s))}constructor(s,E,p,R,O,U={}){this.t=s,this.u=p,this.v=R,this.w=O,this.x=U,this.b="",this.c="",this.j=0,this.k=new S.$ee,this.onDidChangeMode=this.k.event,this.m=new S.$ee,this.onDidChangeMatchType=this.m.event,this.o=new S.$ee,this.onDidChangePattern=this.o.event,this.p=new S.$ee,this.onDidChangeOpenState=this.p.event,this.q=new b.$Uc,this.s=new b.$Uc,this.d=s.options.defaultFindMode??De.Highlight,this.f=s.options.defaultFindMatchType??Ee.Fuzzy,E.onDidSplice(this.z,this,this.s)}updateOptions(s={}){s.defaultFindMode!==void 0&&(this.mode=s.defaultFindMode),s.defaultFindMatchType!==void 0&&(this.matchType=s.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Le(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(s=>this.mode=s,void 0,this.q),this.g.onDidChangeMatchType(s=>this.matchType=s,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.clear(),this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(s){this.b=s,this.o.fire(s),this.v.pattern=s,this.t.refilter(),s&&this.t.focusNext(0,!0,void 0,p=>!m.FuzzyScore.isDefault(p.filterData));const E=this.t.getFocus();if(E.length>0){const p=E[0];this.t.getRelativeTop(p)===null&&this.t.reveal(p,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const s=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&s?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,k.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(s){return!this.g||!this.pattern||this.v.totalCount>0&&this.v.matchCount<=1?!0:!m.FuzzyScore.isDefault(s.filterData)}layout(s){this.j=s,this.g?.layout(s)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function _(F,s){return F.position===s.position&&ue(F,s)}function ue(F,s){return F.node.element===s.node.element&&F.startIndex===s.startIndex&&F.height===s.height&&F.endIndex===s.endIndex}class re{constructor(s=[]){this.stickyNodes=s}get count(){return this.stickyNodes.length}equal(s){return(0,e.$ub)(this.stickyNodes,s.stickyNodes,_)}lastNodePartiallyVisible(){if(this.count===0)return!1;const s=this.stickyNodes[this.count-1];if(this.count===1)return s.position!==0;const E=this.stickyNodes[this.count-2];return E.position+E.height!==s.position}animationStateChanged(s){if(!(0,e.$ub)(this.stickyNodes,s.stickyNodes,ue)||this.count===0)return!1;const E=this.stickyNodes[this.count-1],p=s.stickyNodes[s.count-1];return E.position!==p.position}}class ye{constrainStickyScrollNodes(s,E,p){for(let R=0;R<s.length;R++){const O=s[R];if(O.position+O.height>p||R>=E)return s.slice(0,R)}return s}}class W extends b.$Vc{constructor(s,E,p,R,O,U={}){super(),this.g=s,this.j=E,this.m=p,this.s=O,this.c=.4;const Z=this.validateStickySettings(U);this.b=Z.stickyScrollMaxItemCount,this.a=U.stickyScrollDelegate??new ye,this.f=this.B(new Q(p.getScrollableElement(),p,s,R,O,U.accessibilityProvider)),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu,this.B(p.onDidScroll(()=>this.u())),this.B(p.onDidChangeContentHeight(()=>this.u())),this.B(s.onDidChangeCollapseState(()=>this.u())),this.u()}get height(){return this.f.height}get count(){return this.f.count}getNode(s){return this.f.getNode(s)}t(s){let E;if(s===0?E=this.m.firstVisibleIndex:E=this.m.indexAt(s+this.m.scrollTop),!(E<0||E>=this.m.length))return this.m.element(E)}u(){const s=this.t(0);if(!s||this.g.scrollTop===0){this.f.setState(void 0);return}const E=this.w(s);this.f.setState(E)}w(s){const E=[];let p=s,R=0,O=this.z(p,void 0,R);for(;O&&(E.push(O),R+=O.height,!(E.length<=this.b&&(p=this.y(O),!p)));)O=this.z(p,O.node,R);const U=this.H(E);return U.length?new re(U):void 0}y(s){return this.t(s.position+s.height)}z(s,E,p){const R=this.F(s,E);if(R&&!(R===s&&(!this.J(s)||this.C(s,p))))return this.D(R,p)}C(s,E){const p=this.L(s),R=this.m.getElementTop(p),O=E;return this.m.scrollTop===R-O}D(s,E){const p=this.s.getHeight(s),{startIndex:R,endIndex:O}=this.M(s),U=this.G(O,E,p);return{node:s,position:U,height:p,startIndex:R,endIndex:O}}F(s,E=void 0){let p=s,R=this.I(p);for(;R;){if(R===E)return p;p=R,R=this.I(p)}if(E===void 0)return p}G(s,E,p){let R=this.m.getRelativeTop(s);if(R===null&&this.m.firstVisibleIndex===s&&s+1<this.m.length){const pe=this.s.getHeight(this.m.element(s)),fe=this.m.getRelativeTop(s+1);R=fe?fe-pe/this.m.renderHeight:null}if(R===null)return E;const O=this.m.element(s),U=this.s.getHeight(O),oe=R*this.m.renderHeight+U;return E+p>oe&&E<=oe?oe-p:E}H(s){if(s.length===0)return[];const E=this.m.renderHeight*this.c,p=s[s.length-1];if(s.length<=this.b&&p.position+p.height<=E)return s;const R=this.a.constrainStickyScrollNodes(s,this.b,E);if(!R.length)return[];const O=R[R.length-1];if(R.length>this.b||O.position+O.height>E)throw new Error("stickyScrollDelegate violates constraints");return R}I(s){const E=this.j.getNodeLocation(s),p=this.j.getParentNodeLocation(E);return p?this.j.getNode(p):void 0}J(s){const E=this.j.getNodeLocation(s);return this.j.getListRenderCount(E)>1}L(s){const E=this.j.getNodeLocation(s);return this.j.getListIndex(E)}M(s){const E=this.j.getNodeLocation(s),p=this.j.getListIndex(E);if(p<0)throw new Error("Node not found in tree");const R=this.j.getListRenderCount(E),O=p+R-1;return{startIndex:p,endIndex:O}}nodePositionTopBelowWidget(s){const E=[];let p=this.I(s);for(;p;)E.push(p),p=this.I(p);let R=0;for(let O=0;O<E.length&&O<this.b;O++)R+=this.s.getHeight(E[O]);return R}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}updateOptions(s={}){if(!s.stickyScrollMaxItemCount)return;const E=this.validateStickySettings(s);this.b!==E.stickyScrollMaxItemCount&&(this.b=E.stickyScrollMaxItemCount,this.u())}validateStickySettings(s){let E=7;return typeof s.stickyScrollMaxItemCount=="number"&&(E=Math.max(s.stickyScrollMaxItemCount,1)),{stickyScrollMaxItemCount:E}}}class Q{constructor(s,E,p,R,O,U){this.g=E,this.j=p,this.k=R,this.m=O,this.o=U,this.c=[],this.d=new b.$Uc,this.a=(0,n.$)(".monaco-tree-sticky-container.empty"),s.appendChild(this.a);const Z=(0,n.$)(".monaco-tree-sticky-container-shadow");this.a.appendChild(Z),this.f=new ge(this.a,E),this.onDidChangeHasFocus=this.f.onDidChangeHasFocus,this.onContextMenu=this.f.onContextMenu}get height(){if(!this.b)return 0;const s=this.b.stickyNodes[this.b.count-1];return s.position+s.height}get count(){return this.b?.count??0}getNode(s){return this.b?.stickyNodes.find(E=>E.node===s)}setState(s){const E=!!this.b&&this.b.count>0,p=!!s&&s.count>0;if(!E&&!p||E&&p&&this.b.equal(s))return;if(E!==p&&this.s(p),!p){this.b=void 0,this.c=[],this.d.clear();return}const R=s.stickyNodes[s.count-1];if(this.b&&s.animationStateChanged(this.b))this.c[this.b.count-1].style.top=`${R.position}px`;else{this.d.clear();const O=Array(s.count);for(let U=s.count-1;U>=0;U--){const Z=s.stickyNodes[U],{element:oe,disposable:pe}=this.p(Z,U,s.count);O[U]=oe,this.a.appendChild(oe),this.d.add(pe)}this.f.updateElements(O,s),this.c=O}this.b=s,this.a.style.height=`${R.position+R.height}px`}p(s,E,p){const R=s.startIndex,O=document.createElement("div");O.style.top=`${s.position}px`,this.j.options.setRowHeight!==!1&&(O.style.height=`${s.height}px`),this.j.options.setRowLineHeight!==!1&&(O.style.lineHeight=`${s.height}px`),O.classList.add("monaco-tree-sticky-row"),O.classList.add("monaco-list-row"),O.setAttribute("data-index",`${R}`),O.setAttribute("data-parity",R%2===0?"even":"odd"),O.setAttribute("id",this.g.getElementID(R));const U=this.q(O,s.node.element,E,p),Z=this.m.getTemplateId(s.node),oe=this.k.find(Pe=>Pe.templateId===Z);if(!oe)throw new Error(`No renderer found for template id ${Z}`);let pe=s.node;pe===this.j.getNode(this.j.getNodeLocation(s.node))&&(pe=new Proxy(s.node,{}));const fe=oe.renderTemplate(O);oe.renderElement(pe,s.startIndex,fe,s.height);const Re=(0,b.$Tc)(()=>{U.dispose(),oe.disposeElement(pe,s.startIndex,fe,s.height),oe.disposeTemplate(fe),O.remove()});return{element:O,disposable:Re}}q(s,E,p,R){if(!this.o)return b.$Vc.None;this.o.getSetSize&&s.setAttribute("aria-setsize",String(this.o.getSetSize(E,p,R))),this.o.getPosInSet&&s.setAttribute("aria-posinset",String(this.o.getPosInSet(E,p))),this.o.getRole&&s.setAttribute("role",this.o.getRole(E)??"treeitem");const O=this.o.getAriaLabel(E),U=O&&typeof O!="string"?O:(0,L.constObservable)(O),Z=(0,L.autorun)(pe=>{const fe=pe.readObservable(U);fe?s.setAttribute("aria-label",fe):s.removeAttribute("aria-label")});typeof O=="string"||O&&s.setAttribute("aria-label",O.get());const oe=this.o.getAriaLevel&&this.o.getAriaLevel(E);return typeof oe=="number"&&s.setAttribute("aria-level",`${oe}`),s.setAttribute("aria-selected",String(!1)),Z}s(s){this.a.classList.toggle("empty",!s),s||this.f.updateElements([],void 0)}getFocus(){return this.f.getFocus()}domFocus(){this.f.domFocus()}focusedLast(){return this.f.focusedLast()}dispose(){this.f.dispose(),this.d.dispose(),this.a.remove()}}class ge extends b.$Vc{get m(){return this.j}set m(s){s!==this.j&&(this.f.fire(s),this.j=s)}constructor(s,E){super(),this.s=s,this.t=E,this.a=-1,this.b=[],this.f=new S.$ee,this.onDidChangeHasFocus=this.f.event,this.g=new S.$ee,this.onContextMenu=this.g.event,this.j=!1,this.s.addEventListener("focus",()=>this.M()),this.s.addEventListener("blur",()=>this.O()),this.B(this.t.onDidFocus(()=>this.L(!1))),this.B(this.t.onKeyDown(p=>this.w(p))),this.B(this.t.onMouseDown(p=>this.y(p))),this.B(this.t.onContextMenu(p=>this.u(p)))}u(s){const E=s.browserEvent.target;if(!(0,g.$bU)(E)&&!(0,g.$aU)(E)){this.focusedLast()&&this.t.domFocus();return}if(!(0,n.$ES)(s.browserEvent)){if(!this.c)throw new Error("Context menu should not be triggered when state is undefined");const U=this.c.stickyNodes.findIndex(Z=>Z.node.element===s.element?.element);if(U===-1)throw new Error("Context menu should not be triggered when element is not in sticky scroll widget");this.s.focus(),this.F(U);return}if(!this.c||this.a<0)throw new Error("Context menu key should not be triggered when focus is not in sticky scroll widget");const R=this.c.stickyNodes[this.a].node.element,O=this.b[this.a];this.g.fire({element:R,anchor:O,browserEvent:s.browserEvent,isStickyScroll:!0})}w(s){if(this.m&&this.c){if(s.key==="ArrowUp")this.z(Math.max(0,this.a-1)),s.preventDefault(),s.stopPropagation();else if(s.key==="ArrowDown"||s.key==="ArrowRight"){if(this.a>=this.c.count-1){const E=this.c.stickyNodes[this.c.count-1].startIndex+1;this.t.domFocus(),this.t.setFocus([E]),this.C(E,this.c)}else this.z(this.a+1);s.preventDefault(),s.stopPropagation()}}}y(s){const E=s.browserEvent.target;!(0,g.$bU)(E)&&!(0,g.$aU)(E)||(s.browserEvent.preventDefault(),s.browserEvent.stopPropagation())}updateElements(s,E){if(E&&E.count===0)throw new Error("Sticky scroll state must be undefined when there are no sticky nodes");if(E&&E.count!==s.length)throw new Error("Sticky scroll focus received illigel state");const p=this.a;if(this.D(),this.b=s,this.c=E,E){const R=(0,r.$Am)(p,0,E.count-1);this.F(R)}else this.m&&this.t.domFocus();this.s.tabIndex=E?0:-1}z(s){const E=this.c;if(!E)throw new Error("Cannot set focus when state is undefined");if(this.F(s),!(s<E.count-1)&&E.lastNodePartiallyVisible()){const p=E.stickyNodes[s];this.C(p.endIndex+1,E)}}C(s,E){const p=E.stickyNodes[E.count-1],R=E.count>1?E.stickyNodes[E.count-2]:void 0,O=this.t.getElementTop(s),U=R?R.position+R.height+p.height:p.height;this.t.scrollTop=O-U}getFocus(){if(!(!this.c||this.a===-1))return this.c.stickyNodes[this.a].node.element}domFocus(){if(!this.c)throw new Error("Cannot focus when state is undefined");this.s.focus()}focusedLast(){return this.c?this.t.getHTMLElement().classList.contains("sticky-scroll-focused"):!1}D(){this.a!==-1&&(this.G(this.b[this.a],!1),this.a=-1)}F(s){if(0>s)throw new Error("addFocus() can not remove focus");if(!this.c&&s>=0)throw new Error("Cannot set focus index when state is undefined");if(this.c&&s>=this.c.count)throw new Error("Cannot set focus index to an index that does not exist");const E=this.a;E>=0&&this.G(this.b[E],!1),s>=0&&this.G(this.b[s],!0),this.a=s}G(s,E){this.I(s,E&&this.m),this.J(s,E)}H(s){this.a!==-1&&this.I(this.b[this.a],s)}I(s,E){s.classList.toggle("focused",E)}J(s,E){s.classList.toggle("passive-focused",E)}L(s){this.t.getHTMLElement().classList.toggle("sticky-scroll-focused",s)}M(){if(!this.c||this.b.length===0)throw new Error("Cannot focus when state is undefined or elements are empty");this.m=!0,this.L(!0),this.H(!0),this.a===-1&&this.F(0)}O(){this.m=!1,this.H(!1)}dispose(){this.L(!1),this.f.fire(!1),super.dispose()}}function we(F){let s=c.TreeMouseEventTarget.Unknown;return(0,n.$kS)(F.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?s=c.TreeMouseEventTarget.Twistie:(0,n.$kS)(F.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?s=c.TreeMouseEventTarget.Element:(0,n.$kS)(F.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(s=c.TreeMouseEventTarget.Filter),{browserEvent:F.browserEvent,element:F.element?F.element.element:null,target:s}}function ke(F){const s=(0,g.$bU)(F.browserEvent.target);return{element:F.element?F.element.element:null,browserEvent:F.browserEvent,anchor:F.anchor,isStickyScroll:s}}function Te(F,s){s(F),F.children.forEach(E=>Te(E,s))}class Ie{get f(){return this.d||(this.d=this.m()),this.d}constructor(s,E){this.g=s,this.j=E,this.a=[],this.c=new S.$ee,this.onDidChange=this.c.event}set(s,E){!E?.__forceEvent&&(0,e.$ub)(this.a,s)||this.k(s,!1,E)}k(s,E,p){if(this.a=[...s],this.b=void 0,this.d=void 0,!E){const R=this;this.c.fire({get elements(){return R.get()},browserEvent:p})}}get(){return this.b||(this.b=this.a.map(s=>s.element)),[...this.b]}getNodes(){return this.a}has(s){return this.f.has(s)}onDidModelSplice({insertedNodes:s,deletedNodes:E}){if(!this.j){const oe=this.m(),pe=fe=>oe.delete(fe);E.forEach(fe=>Te(fe,pe)),this.set([...oe.values()]);return}const p=new Set,R=oe=>p.add(this.j.getId(oe.element).toString());E.forEach(oe=>Te(oe,R));const O=new Map,U=oe=>O.set(this.j.getId(oe.element).toString(),oe);s.forEach(oe=>Te(oe,U));const Z=[];for(const oe of this.a){const pe=this.j.getId(oe.element).toString();if(!p.has(pe))Z.push(oe);else{const Re=O.get(pe);Re&&Re.visible&&Z.push(Re)}}if(this.a.length>0&&Z.length===0){const oe=this.g();oe&&Z.push(oe)}this.k(Z,!0)}m(){const s=new Set;for(const E of this.a)s.add(E);return s}}class z extends g.$gU{constructor(s,E,p){super(s),this.x=E,this.y=p}u(s){if((0,g.$cU)(s.browserEvent.target)||(0,g.$8T)(s.browserEvent.target)||(0,g.$9T)(s.browserEvent.target)||s.browserEvent.isHandledByList)return;const E=s.element;if(!E)return super.u(s);if(this.p(s)||this.o(s))return super.u(s);const p=s.browserEvent.target,R=p.classList.contains("monaco-tl-twistie")||p.classList.contains("monaco-icon-label")&&p.classList.contains("folder-icon")&&s.browserEvent.offsetX<16,O=(0,g.$aU)(s.browserEvent.target);let U=!1;if(O?U=!0:typeof this.x.expandOnlyOnTwistieClick=="function"?U=this.x.expandOnlyOnTwistieClick(E.element):U=!!this.x.expandOnlyOnTwistieClick,O)this.A(s,E);else{if(U&&!R&&s.browserEvent.detail!==2)return super.u(s);if(!this.x.expandOnDoubleClick&&s.browserEvent.detail===2)return super.u(s)}if(E.collapsible&&(!O||R)){const Z=this.x.getNodeLocation(E),oe=s.browserEvent.altKey;if(this.x.setFocus([Z]),this.x.toggleCollapsed(Z,oe),R){s.browserEvent.isHandledByList=!0;return}}O||super.u(s)}A(s,E){if((0,g.$0T)(s.browserEvent.target)||(0,g.$$T)(s.browserEvent.target))return;const p=this.y();if(!p)throw new Error("Sticky scroll controller not found");const R=this.k.indexOf(E),O=this.k.getElementTop(R),U=p.nodePositionTopBelowWidget(E);this.x.scrollTop=O-U,this.k.domFocus(),this.k.setFocus([R]),this.k.setSelection([R])}v(s){s.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.x.expandOnDoubleClick||s.browserEvent.isHandledByList||super.v(s)}s(s){const E=s.browserEvent.target;if(!(0,g.$bU)(E)&&!(0,g.$aU)(E)){super.s(s);return}}t(s){const E=s.browserEvent.target;if(!(0,g.$bU)(E)&&!(0,g.$aU)(E)){super.t(s);return}}}class u extends g.$jU{constructor(s,E,p,R,O,U,Z,oe){super(s,E,p,R,oe),this.p=O,this.s=U,this.K=Z}D(s){return new z(this,s.tree,s.stickyScrollProvider)}splice(s,E,p=[]){if(super.splice(s,E,p),p.length===0)return;const R=[],O=[];let U;p.forEach((Z,oe)=>{this.p.has(Z)&&R.push(s+oe),this.s.has(Z)&&O.push(s+oe),this.K.has(Z)&&(U=s+oe)}),R.length>0&&super.setFocus((0,e.$Mb)([...super.getFocus(),...R])),O.length>0&&super.setSelection((0,e.$Mb)([...super.getSelection(),...O])),typeof U=="number"&&super.setAnchor(U)}setFocus(s,E,p=!1){super.setFocus(s,E),p||this.p.set(s.map(R=>this.element(R)),E)}setSelection(s,E,p=!1){super.setSelection(s,E),p||this.s.set(s.map(R=>this.element(R)),E)}setAnchor(s,E=!1){super.setAnchor(s),E||(typeof s>"u"?this.K.set([]):this.K.set([this.element(s)]))}}var y;(function(F){F[F.Tree=0]="Tree",F[F.StickyScroll=1]="StickyScroll"})(y||(t.AbstractTreePart=y={}));class a{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.y.wrapEvent(this.q.onDidChange)}get onDidChangeSelection(){return this.y.wrapEvent(this.w.onDidChange)}get onMouseClick(){return S.Event.map(this.j.onMouseClick,we)}get onMouseDblClick(){return S.Event.filter(S.Event.map(this.j.onMouseDblClick,we),s=>s.target!==c.TreeMouseEventTarget.Filter)}get onMouseOver(){return S.Event.map(this.j.onMouseOver,we)}get onMouseOut(){return S.Event.map(this.j.onMouseOut,we)}get onContextMenu(){return S.Event.any(S.Event.filter(S.Event.map(this.j.onContextMenu,ke),s=>!s.isStickyScroll),this.B?.onContextMenu??S.Event.None)}get onTap(){return S.Event.map(this.j.onTap,we)}get onPointer(){return S.Event.map(this.j.onPointer,we)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return S.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.z?.mode??De.Highlight}set findMode(s){this.z&&(this.z.mode=s)}get findMatchType(){return this.z?.matchType??Ee.Fuzzy}set findMatchType(s){this.z&&(this.z.matchType=s)}get onDidChangeFindPattern(){return this.z?this.z.onDidChangePattern:S.Event.None}get expandOnDoubleClick(){return typeof this.H.expandOnDoubleClick>"u"?!0:this.H.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.H.expandOnlyOnTwistieClick>"u"?!0:this.H.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(s,E,p,R,O={}){this.G=s,this.H=O,this.y=new S.$me,this.onDidChangeFindOpenState=S.Event.None,this.onDidChangeStickyScrollFocused=S.Event.None,this.D=new b.$Uc,this.E=new S.$ee,this.onWillRefilter=this.E.event,this.F=new S.$ee,this.onDidUpdateOptions=this.F.event,this.p=new N(p);const U=new S.$ne,Z=new S.$ne,oe=this.D.add(new Y(Z.event)),pe=new f.$Ic;this.k=R.map(Se=>new K(Se,()=>this.o,U.event,oe,pe,O));for(const Se of this.k)this.D.add(Se);let fe;O.keyboardNavigationLabelProvider&&(fe=new ae(this,O.keyboardNavigationLabelProvider,O.filter),O={...O,filter:fe},this.D.add(fe)),this.q=new Ie(()=>this.j.getFocusedElements()[0],O.identityProvider),this.w=new Ie(()=>this.j.getSelectedElements()[0],O.identityProvider),this.x=new Ie(()=>this.j.getAnchorElement(),O.identityProvider),this.j=new u(s,E,this.p,this.k,this.q,this.w,this.x,{...V(()=>this.o,O),tree:this,stickyScrollProvider:()=>this.B}),this.o=this.M(s,this.j,O),U.input=this.o.onDidChangeCollapseState;const Re=S.Event.forEach(this.o.onDidSplice,Se=>{this.y.bufferEvents(()=>{this.q.onDidModelSplice(Se),this.w.onDidModelSplice(Se)})},this.D);Re(()=>null,null,this.D);const Pe=this.D.add(new S.$ee),je=this.D.add(new i.$sh(0));if(this.D.add(S.Event.any(Re,this.q.onDidChange,this.w.onDidChange)(()=>{je.trigger(()=>{const Se=new Set;for(const Ce of this.q.getNodes())Se.add(Ce);for(const Ce of this.w.getNodes())Se.add(Ce);Pe.fire([...Se.values()])})})),Z.input=Pe.event,O.keyboardSupport!==!1){const Se=S.Event.chain(this.j.onKeyDown,Ce=>Ce.filter(We=>!(0,g.$8T)(We.target)).map(We=>new B.$LR(We)));S.Event.chain(Se,Ce=>Ce.filter(We=>We.keyCode===15))(this.J,this,this.D),S.Event.chain(Se,Ce=>Ce.filter(We=>We.keyCode===17))(this.K,this,this.D),S.Event.chain(Se,Ce=>Ce.filter(We=>We.keyCode===10))(this.L,this,this.D)}if((O.findWidgetEnabled??!0)&&O.keyboardNavigationLabelProvider&&O.contextViewProvider){const Se=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.z=new le(this,this.o,this.j,fe,O.contextViewProvider,Se),this.A=Ce=>this.z.shouldAllowFocus(Ce),this.onDidChangeFindOpenState=this.z.onDidChangeOpenState,this.D.add(this.z),this.onDidChangeFindMode=this.z.onDidChangeMode,this.onDidChangeFindMatchType=this.z.onDidChangeMatchType}else this.onDidChangeFindMode=S.Event.None,this.onDidChangeFindMatchType=S.Event.None;O.enableStickyScroll&&(this.B=new W(this,this.o,this.j,this.k,this.p,O),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus),this.C=(0,n.$wS)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===j.Always)}updateOptions(s={}){this.H={...this.H,...s};for(const E of this.k)E.updateOptions(s);this.j.updateOptions(this.H),this.z?.updateOptions(s),this.I(s),this.F.fire(this.H),this.getHTMLElement().classList.toggle("always",this.H.renderIndentGuides===j.Always)}get options(){return this.H}I(s){!this.B&&this.H.enableStickyScroll?(this.B=new W(this,this.o,this.j,this.k,this.p,this.H),this.onDidChangeStickyScrollFocused=this.B.onDidChangeHasFocus):this.B&&!this.H.enableStickyScroll&&(this.onDidChangeStickyScrollFocused=S.Event.None,this.B.dispose(),this.B=void 0),this.B?.updateOptions(s)}updateWidth(s){const E=this.o.getListIndex(s);E!==-1&&this.j.updateWidth(E)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get contentWidth(){return this.j.contentWidth}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get onDidChangeContentWidth(){return this.j.onDidChangeContentWidth}get scrollTop(){return this.j.scrollTop}set scrollTop(s){this.j.scrollTop=s}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(s){this.j.scrollLeft=s}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){let s=this.j.firstVisibleIndex;return this.B&&(s+=this.B.count),s<0||s>=this.j.length?void 0:this.j.element(s).element}get lastVisibleElement(){const s=this.j.lastVisibleIndex;return this.j.element(s).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(s){this.j.ariaLabel=s}get selectionSize(){return this.w.getNodes().length}domFocus(){this.B?.focusedLast()?this.B.domFocus():this.j.domFocus()}isDOMFocused(){return(0,n.$pS)(this.getHTMLElement())}layout(s,E){this.j.layout(s,E),(0,D.$_f)(E)&&this.z?.layout(E)}style(s){const E=`.${this.j.domId}`,p=[];s.treeIndentGuidesStroke&&(p.push(`.monaco-list${E}:hover .monaco-tl-indent > .indent-guide, .monaco-list${E}.always .monaco-tl-indent > .indent-guide  { border-color: ${s.treeInactiveIndentGuidesStroke}; }`),p.push(`.monaco-list${E} .monaco-tl-indent > .indent-guide.active { border-color: ${s.treeIndentGuidesStroke}; }`));const R=s.treeStickyScrollBackground??s.listBackground;R&&(p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { background-color: ${R}; }`),p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-row { background-color: ${R}; }`)),s.treeStickyScrollBorder&&p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container { border-bottom: 1px solid ${s.treeStickyScrollBorder}; }`),s.treeStickyScrollShadow&&p.push(`.monaco-list${E} .monaco-scrollable-element .monaco-tree-sticky-container .monaco-tree-sticky-container-shadow { box-shadow: ${s.treeStickyScrollShadow} 0 6px 6px -6px inset; height: 3px; }`),s.listFocusForeground&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { color: ${s.listFocusForeground}; }`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { color: inherit; }`));const O=(0,n.$7S)(s.listFocusAndSelectionOutline,(0,n.$7S)(s.listSelectionOutline,s.listFocusOutline??""));O&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused.selected { outline: 1px solid ${O}; outline-offset: -1px;}`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused.selected { outline: inherit;}`)),s.listFocusOutline&&(p.push(`.monaco-list${E}.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container:focus .monaco-list-row.focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),p.push(`.monaco-list${E}:not(.sticky-scroll-focused) .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.focused { outline: inherit; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-scrollable-element .monaco-tree-sticky-container .monaco-list-row.passive-focused { outline: 1px solid ${s.listFocusOutline}; outline-offset: -1px; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused.sticky-scroll-focused .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`),p.push(`.monaco-workbench.context-menu-visible .monaco-list${E}.last-focused:not(.sticky-scroll-focused) .monaco-tree-sticky-container .monaco-list-rows .monaco-list-row.focused { outline: inherit; }`)),this.C.textContent=p.join(`
`),this.j.style(s)}getParentElement(s){const E=this.o.getParentNodeLocation(s);return this.o.getNode(E).element}getFirstElementChild(s){return this.o.getFirstElementChild(s)}getNode(s){return this.o.getNode(s)}getNodeLocation(s){return this.o.getNodeLocation(s)}collapse(s,E=!1){return this.o.setCollapsed(s,!0,E)}expand(s,E=!1){return this.o.setCollapsed(s,!1,E)}toggleCollapsed(s,E=!1){return this.o.setCollapsed(s,void 0,E)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(s){return this.o.isCollapsible(s)}setCollapsible(s,E){return this.o.setCollapsible(s,E)}isCollapsed(s){return this.o.isCollapsed(s)}expandTo(s){this.o.expandTo(s)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.z?.open()}closeFind(){this.z?.close()}refilter(){this.E.fire(void 0),this.o.refilter()}setAnchor(s){if(typeof s>"u")return this.j.setAnchor(void 0);this.y.bufferEvents(()=>{const E=this.o.getNode(s);this.x.set([E]);const p=this.o.getListIndex(s);p>-1&&this.j.setAnchor(p,!0)})}getAnchor(){return(0,e.$Ob)(this.x.get(),void 0)}setSelection(s,E){this.y.bufferEvents(()=>{const p=s.map(O=>this.o.getNode(O));this.w.set(p,E);const R=s.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setSelection(R,E,!0)})}getSelection(){return this.w.get()}setFocus(s,E){this.y.bufferEvents(()=>{const p=s.map(O=>this.o.getNode(O));this.q.set(p,E);const R=s.map(O=>this.o.getListIndex(O)).filter(O=>O>-1);this.j.setFocus(R,E,!0)})}focusNext(s=1,E=!1,p,R=(0,n.$ES)(p)&&p.altKey?void 0:this.A){this.j.focusNext(s,E,p,R)}focusPrevious(s=1,E=!1,p,R=(0,n.$ES)(p)&&p.altKey?void 0:this.A){this.j.focusPrevious(s,E,p,R)}focusNextPage(s,E=(0,n.$ES)(s)&&s.altKey?void 0:this.A){return this.j.focusNextPage(s,E)}focusPreviousPage(s,E=(0,n.$ES)(s)&&s.altKey?void 0:this.A){return this.j.focusPreviousPage(s,E,()=>this.B?.height??0)}focusLast(s,E=(0,n.$ES)(s)&&s.altKey?void 0:this.A){this.j.focusLast(s,E)}focusFirst(s,E=(0,n.$ES)(s)&&s.altKey?void 0:this.A){this.j.focusFirst(s,E)}getFocus(){return this.q.get()}getStickyScrollFocus(){const s=this.B?.getFocus();return s!==void 0?[s]:[]}getFocusedPart(){return this.B?.focusedLast()?1:0}reveal(s,E){this.o.expandTo(s);const p=this.o.getListIndex(s);if(p!==-1)if(!this.B)this.j.reveal(p,E);else{const R=this.B.nodePositionTopBelowWidget(this.getNode(s));this.j.reveal(p,E,R)}}getRelativeTop(s){const E=this.o.getListIndex(s);if(E===-1)return null;const p=this.B?.getNode(this.getNode(s));return this.j.getRelativeTop(E,p?.position??this.B?.height)}getViewState(s=this.options.identityProvider){if(!s)throw new c.$3V(this.G,"Can't get tree view state without an identity provider");const E=U=>s.getId(U).toString(),p=x.empty(this.scrollTop);for(const U of this.getFocus())p.focus.add(E(U));for(const U of this.getSelection())p.selection.add(E(U));const R=this.o.getNode(),O=[R];for(;O.length>0;){const U=O.shift();U!==R&&U.collapsible&&(p.expanded[E(U.element)]=U.collapsed?0:1),O.push(...U.children)}return p}J(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],R=this.o.getNodeLocation(p);if(!this.o.setCollapsed(R,!0)){const U=this.o.getParentNodeLocation(R);if(!U)return;const Z=this.o.getListIndex(U);this.j.reveal(Z),this.j.setFocus([Z])}}K(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],R=this.o.getNodeLocation(p);if(!this.o.setCollapsed(R,!1)){if(!p.children.some(oe=>oe.visible))return;const[U]=this.j.getFocus(),Z=U+1;this.j.reveal(Z),this.j.setFocus([Z])}}L(s){s.preventDefault(),s.stopPropagation();const E=this.j.getFocusedElements();if(E.length===0)return;const p=E[0],R=this.o.getNodeLocation(p),O=s.browserEvent.altKey;this.o.setCollapsed(R,void 0,O)}navigate(s){return new v(this.j,this.o,s)}dispose(){(0,b.$Qc)(this.D),this.B?.dispose(),this.j.dispose()}}t.$aW=a;class v{constructor(s,E,p){this.b=s,this.c=E,p?this.a=this.c.getListIndex(p):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[144],be([1,0,143,134,30,32]),function(se,t,n,C,B,H){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$lW=void 0;class A extends n.$aW{constructor(d,g,w,M,c,h={}){super(d,g,w,M,h),this.f=d,this.g=c,this.d=new Map,this.c=h.identityProvider}getInput(){return this.b}setInput(d,g){if(g&&!this.c)throw new B.$3V(this.f,"Can't restore tree view state without an identity provider");if(this.b=d,!d){this.d.clear(),this.o.setChildren(null,H.Iterable.empty());return}if(!g){this.m(d);return}const w=[],M=[],c=e=>{const i=this.c.getId(e).toString();return!g.expanded[i]},h=e=>{const i=this.c.getId(e.element).toString();g.focus.has(i)&&w.push(e.element),g.selection.has(i)&&M.push(e.element)};this.m(d,c,h),this.setFocus(w),this.setSelection(M),g&&typeof g.scrollTop=="number"&&(this.scrollTop=g.scrollTop)}updateChildren(d=this.b){if(typeof this.b>"u")throw new B.$3V(this.f,"Tree input not set");let g;this.c&&(g=w=>{const M=this.c.getId(w).toString(),c=this.d.get(M);if(c)return c.collapsed}),this.m(d,g)}resort(d=this.b,g=!0){this.o.resort(d===this.b?null:d,g)}refresh(d){if(d===void 0){this.j.rerender();return}this.o.rerender(d)}m(d,g,w){let M;if(this.c){const c=new Set,h=w;w=e=>{const i=this.c.getId(e.element).toString();c.add(i),this.d.set(i,e),h?.(e)},M=e=>{const i=this.c.getId(e.element).toString();c.has(i)||this.d.delete(i)}}this.o.setChildren(d===this.b?null:d,this.s(d,g).elements,{onDidCreateNode:w,onDidDeleteNode:M})}s(d,g){const w=[...this.g.getChildren(d)];return{elements:H.Iterable.map(w,c=>{const{elements:h,size:e}=this.s(c,g),i=this.g.hasChildren?this.g.hasChildren(c):void 0,o=e===0?void 0:g&&g(c);return{element:c,children:h,collapsible:i,collapsed:o}}),size:w.length}}M(d,g,w){return new C.$bW(d,g,w)}}t.$lW=A}),define(me[77],be([1,0,8,11,43,34,31,6,3,2,64,9,10]),function(se,t,n,C,B,H,A,P,d,g,w,M,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ei=t.ProxyChannel=t.$di=t.$ai=t.$_h=t.$$h=t.RequestInitiator=t.$0h=t.$7h=t.$6h=void 0,t.$8h=q,t.$9h=$,t.$bi=Y,t.$ci=K;var h;(function(le){le[le.Promise=100]="Promise",le[le.PromiseCancel=101]="PromiseCancel",le[le.EventListen=102]="EventListen",le[le.EventDispose=103]="EventDispose"})(h||(h={}));function e(le){switch(le){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var i;(function(le){le[le.Initialize=200]="Initialize",le[le.PromiseSuccess=201]="PromiseSuccess",le[le.PromiseError=202]="PromiseError",le[le.PromiseErrorObj=203]="PromiseErrorObj",le[le.EventFire=204]="EventFire"})(i||(i={}));function o(le){switch(le){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(le){le[le.Uninitialized=0]="Uninitialized",le[le.Idle=1]="Idle"})(l||(l={}));function f(le){let _=0;for(let ue=0;;ue+=7){const re=le.read(1);if(_|=(re.buffer[0]&127)<<ue,!(re.buffer[0]&128))return _}}const S=k(0);function m(le,_){if(_===0){le.write(S);return}let ue=0;for(let ye=_;ye!==0;ye=ye>>>7)ue++;const re=B.$Fe.alloc(ue);for(let ye=0;_!==0;ye++)re.buffer[ye]=_&127,_=_>>>7,_>0&&(re.buffer[ye]|=128);le.write(re)}class b{constructor(_){this.b=_,this.a=0}read(_){const ue=this.b.slice(this.a,this.a+_);return this.a+=ue.byteLength,ue}}t.$6h=b;class r{constructor(){this.a=[]}get buffer(){return B.$Fe.concat(this.a)}write(_){this.a.push(_)}}t.$7h=r;var D;(function(le){le[le.Undefined=0]="Undefined",le[le.String=1]="String",le[le.Buffer=2]="Buffer",le[le.VSBuffer=3]="VSBuffer",le[le.Array=4]="Array",le[le.Object=5]="Object",le[le.Int=6]="Int"})(D||(D={}));function k(le){const _=B.$Fe.alloc(1);return _.writeUInt8(le,0),_}const T={Undefined:k(D.Undefined),String:k(D.String),Buffer:k(D.Buffer),VSBuffer:k(D.VSBuffer),Array:k(D.Array),Object:k(D.Object),Uint:k(D.Int)},L=typeof Buffer<"u";function q(le,_){if(typeof _>"u")le.write(T.Undefined);else if(typeof _=="string"){const ue=B.$Fe.fromString(_);le.write(T.String),m(le,ue.byteLength),le.write(ue)}else if(L&&Buffer.isBuffer(_)){const ue=B.$Fe.wrap(_);le.write(T.Buffer),m(le,ue.byteLength),le.write(ue)}else if(_ instanceof B.$Fe)le.write(T.VSBuffer),m(le,_.byteLength),le.write(_);else if(Array.isArray(_)){le.write(T.Array),m(le,_.length);for(const ue of _)q(le,ue)}else if(typeof _=="number"&&(_|0)===_)le.write(T.Uint),m(le,_);else{const ue=B.$Fe.fromString(JSON.stringify(_));le.write(T.Object),m(le,ue.byteLength),le.write(ue)}}function $(le){switch(le.read(1).readUInt8(0)){case D.Undefined:return;case D.String:return le.read(f(le)).toString();case D.Buffer:return le.read(f(le)).buffer;case D.VSBuffer:return le.read(f(le));case D.Array:{const ue=f(le),re=[];for(let ye=0;ye<ue;ye++)re.push($(le));return re}case D.Object:return JSON.parse(le.read(f(le)).toString());case D.Int:return f(le)}}class I{constructor(_,ue,re=null,ye=1e3){this.h=_,this.j=ue,this.k=re,this.l=ye,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(W=>this.q(W)),this.m({type:200})}registerChannel(_,ue){this.b.set(_,ue),setTimeout(()=>this.w(_),0)}m(_){switch(_.type){case 200:{const ue=this.o([_.type]);this.k?.logOutgoing(ue,0,1,o(_.type));return}case 201:case 202:case 204:case 203:{const ue=this.o([_.type,_.id],_.data);this.k?.logOutgoing(ue,_.id,1,o(_.type),_.data);return}}}o(_,ue=void 0){const re=new r;return q(re,_),q(re,ue),this.p(re.buffer)}p(_){try{return this.h.send(_),_.byteLength}catch{return 0}}q(_){const ue=new b(_),re=$(ue),ye=$(ue),W=re[0];switch(W){case 100:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}: ${re[2]}.${re[3]}`,ye),this.s({type:W,id:re[1],channelName:re[2],name:re[3],arg:ye});case 102:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}: ${re[2]}.${re[3]}`,ye),this.t({type:W,id:re[1],channelName:re[2],name:re[3],arg:ye});case 101:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}`),this.u({type:W,id:re[1]});case 103:return this.k?.logIncoming(_.byteLength,re[1],1,`${e(W)}`),this.u({type:W,id:re[1]})}}s(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=new H.$pe;let ye;try{ye=ue.call(this.j,_.name,_.arg,re.token)}catch(ge){ye=Promise.reject(ge)}const W=_.id;ye.then(ge=>{this.m({id:W,data:ge,type:201})},ge=>{ge instanceof Error?this.m({id:W,data:{message:ge.message,name:ge.name,stack:ge.stack?ge.stack.split?ge.stack.split(`
`):ge.stack:void 0},type:202}):this.m({id:W,data:ge,type:203})}).finally(()=>{Q.dispose(),this.d.delete(_.id)});const Q=(0,g.$Tc)(()=>re.cancel());this.d.set(_.id,Q)}t(_){const ue=this.b.get(_.channelName);if(!ue){this.v(_);return}const re=_.id,W=ue.listen(this.j,_.name,_.arg)(Q=>this.m({id:re,data:Q,type:204}));this.d.set(_.id,W)}u(_){const ue=this.d.get(_.id);ue&&(ue.dispose(),this.d.delete(_.id))}v(_){let ue=this.g.get(_.channelName);ue||(ue=[],this.g.set(_.channelName,ue));const re=setTimeout(()=>{console.error(`Unknown channel: ${_.channelName}`),_.type===100&&this.m({id:_.id,data:{name:"Unknown channel",message:`Channel name '${_.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ue.push({request:_,timeoutTimer:re})}w(_){const ue=this.g.get(_);if(ue){for(const re of ue)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(_)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$0h=I;var V;(function(le){le[le.LocalSide=0]="LocalSide",le[le.OtherSide=1]="OtherSide"})(V||(t.RequestInitiator=V={}));class N{constructor(_,ue=null){this.l=_,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new d.$ee,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ue}getChannel(_){const ue=this;return{call(re,ye,W){return ue.a?Promise.reject(new P.$5):ue.m(_,re,ye,W)},listen(re,ye){return ue.a?d.Event.None:ue.o(_,re,ye)}}}m(_,ue,re,ye=H.CancellationToken.None){const W=this.g++,ge={id:W,type:100,channelName:_,name:ue,arg:re};if(ye.isCancellationRequested)return Promise.reject(new P.$5);let we;return new Promise((Te,Ie)=>{if(ye.isCancellationRequested)return Ie(new P.$5);const z=()=>{const v=F=>{switch(F.type){case 201:this.f.delete(W),Te(F.data);break;case 202:{this.f.delete(W);const s=new Error(F.data.message);s.stack=Array.isArray(F.data.stack)?F.data.stack.join(`
`):F.data.stack,s.name=F.data.name,Ie(s);break}case 203:this.f.delete(W),Ie(F.data);break}};this.f.set(W,v),this.p(ge)};let u=null;this.b===l.Idle?z():(u=(0,C.$ih)(v=>this.u()),u.then(()=>{u=null,z()}));const y=()=>{u?(u.cancel(),u=null):this.p({id:W,type:101}),Ie(new P.$5)},a=ye.onCancellationRequested(y);we=(0,g.$Sc)((0,g.$Tc)(y),a),this.d.add(we)}).finally(()=>{we.dispose(),this.d.delete(we)})}o(_,ue,re){const ye=this.g++,Q={id:ye,type:102,channelName:_,name:ue,arg:re};let ge=null;const we=new d.$ee({onWillAddFirstListener:()=>{ge=(0,C.$ih)(Te=>this.u()),ge.then(()=>{ge=null,this.d.add(we),this.p(Q)})},onDidRemoveLastListener:()=>{ge?(ge.cancel(),ge=null):(this.d.delete(we),this.p({id:ye,type:103}))}}),ke=Te=>we.fire(Te.data);return this.f.set(ye,ke),we.event}p(_){switch(_.type){case 100:case 102:{const ue=this.q([_.type,_.id,_.channelName,_.name],_.arg);this.j?.logOutgoing(ue,_.id,0,`${e(_.type)}: ${_.channelName}.${_.name}`,_.arg);return}case 101:case 103:{const ue=this.q([_.type,_.id]);this.j?.logOutgoing(ue,_.id,0,e(_.type));return}}}q(_,ue=void 0){const re=new r;return q(re,_),q(re,ue),this.r(re.buffer)}r(_){try{return this.l.send(_),_.byteLength}catch{return 0}}s(_){const ue=new b(_),re=$(ue),ye=$(ue),W=re[0];switch(W){case 200:return this.j?.logIncoming(_.byteLength,0,0,o(W)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(_.byteLength,re[1],0,o(W),ye),this.t({type:re[0],id:re[1],data:ye})}}t(_){if(_.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(_.id)?.(_)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Qc)(this.d.values()),this.d.clear()}}t.$$h=N,Ze([A.$Zh],N.prototype,"onDidInitializePromise",null);class x{get connections(){const _=[];return this.f.forEach(ue=>_.push(ue)),_}constructor(_,ue,re){this.a=new Map,this.f=new Set,this.g=new d.$ee,this.onDidAddConnection=this.g.event,this.h=new d.$ee,this.onDidRemoveConnection=this.h.event,this.j=new g.$Uc,this.j.add(_(({protocol:ye,onDidClientDisconnect:W})=>{const Q=d.Event.once(ye.onMessage);this.j.add(Q(ge=>{const we=new b(ge),ke=$(we),Te=new I(ye,ke,ue,re),Ie=new N(ye,ue);this.a.forEach((u,y)=>Te.registerChannel(y,u));const z={channelServer:Te,channelClient:Ie,ctx:ke};this.f.add(z),this.g.fire(z),this.j.add(W(()=>{Te.dispose(),Ie.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(_,ue){const re=this;return{call(ye,W,Q){let ge;if((0,c.$jg)(ue)){const ke=(0,n.$4b)(re.connections.filter(ue));ge=ke?Promise.resolve(ke):d.Event.toPromise(d.Event.filter(re.onDidAddConnection,ue))}else ge=ue.routeCall(re,ye,W);const we=ge.then(ke=>ke.channelClient.getChannel(_));return Y(we).call(ye,W,Q)},listen(ye,W){if((0,c.$jg)(ue))return re.k(_,ue,ye,W);const Q=ue.routeEvent(re,ye,W).then(ge=>ge.channelClient.getChannel(_));return Y(Q).listen(ye,W)}}}k(_,ue,re,ye){const W=this;let Q;const ge=new d.$ee({onWillAddFirstListener:()=>{Q=new g.$Uc;const we=new d.$ke,ke=new Map,Te=z=>{const y=z.channelClient.getChannel(_).listen(re,ye),a=we.add(y);ke.set(z,a)},Ie=z=>{const u=ke.get(z);u&&(u.dispose(),ke.delete(z))};W.connections.filter(ue).forEach(Te),d.Event.filter(W.onDidAddConnection,ue)(Te,void 0,Q),W.onDidRemoveConnection(Ie,void 0,Q),we.event(ge.fire,ge,Q),Q.add(we)},onDidRemoveLastListener:()=>{Q?.dispose(),Q=void 0}});return ge.event}registerChannel(_,ue){this.a.set(_,ue);for(const re of this.f)re.channelServer.registerChannel(_,ue)}dispose(){this.j.dispose();for(const _ of this.f)_.channelClient.dispose(),_.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}t.$_h=x;class j{constructor(_,ue,re=null){const ye=new r;q(ye,ue),_.send(ye.buffer),this.a=new N(_,re),this.d=new I(_,ue,re)}getChannel(_){return this.a.getChannel(_)}registerChannel(_,ue){this.d.registerChannel(_,ue)}dispose(){this.a.dispose(),this.d.dispose()}}t.$ai=j;function Y(le){return{call(_,ue,re){return le.then(ye=>ye.call(_,ue,re))},listen(_,ue){const re=new d.$ne;return le.then(ye=>re.input=ye.listen(_,ue)),re.event}}}function K(le){let _=!1;return{call(ue,re,ye){return _?le.call(ue,re,ye):(0,C.$wh)(0).then(()=>_=!0).then(()=>le.call(ue,re,ye))},listen(ue,re){if(_)return le.listen(ue,re);const ye=new d.$ne;return(0,C.$wh)(0).then(()=>_=!0).then(()=>ye.input=le.listen(ue,re)),ye.event}}}class ae{constructor(_){this.a=_}routeCall(_){return this.b(_)}routeEvent(_){return this.b(_)}async b(_){for(const ue of _.connections)if(await Promise.resolve(this.a(ue.ctx)))return Promise.resolve(ue);return await d.Event.toPromise(_.onDidAddConnection),await this.b(_)}}t.$di=ae;var ie;(function(le){function _(W,Q,ge){const we=W,ke=ge&&ge.disableMarshalling,Te=new Map;for(const Ie in we)re(Ie)&&Te.set(Ie,d.Event.buffer(we[Ie],!0,void 0,Q));return new class{listen(Ie,z,u){const y=Te.get(z);if(y)return y;const a=we[z];if(typeof a=="function"){if(ye(z))return a.call(we,u);if(re(z))return Te.set(z,d.Event.buffer(we[z],!0,void 0,Q)),Te.get(z)}throw new P.$bb(`Event not found: ${z}`)}call(Ie,z,u){const y=we[z];if(typeof y=="function"){if(!ke&&Array.isArray(u))for(let v=0;v<u.length;v++)u[v]=(0,w.$5h)(u[v]);let a=y.apply(we,u);return a instanceof Promise||(a=Promise.resolve(a)),a}throw new P.$bb(`Method not found: ${z}`)}}}le.fromService=_;function ue(W,Q){const ge=Q&&Q.disableMarshalling;return new Proxy({},{get(we,ke){if(typeof ke=="string")return Q?.properties?.has(ke)?Q.properties.get(ke):ye(ke)?function(Te){return W.listen(ke,Te)}:re(ke)?W.listen(ke):async function(...Te){let Ie;Q&&!(0,c.$eg)(Q.context)?Ie=[Q.context,...Te]:Ie=Te;const z=await W.call(ke,Ie);return ge?z:(0,w.$5h)(z)};throw new P.$bb(`Property not found: ${String(ke)}`)}})}le.toService=ue;function re(W){return W[0]==="o"&&W[1]==="n"&&M.$wf(W.charCodeAt(2))}function ye(W){return/^onDynamic/.test(W)&&M.$wf(W.charCodeAt(9))}})(ie||(t.ProxyChannel=ie={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(le){if(Array.isArray(le))return le;if(le&&typeof le=="object"&&typeof le.toString=="function"){const _=le.toString();if(_!=="[object Object]")return _}return le}function De(le){return Array.isArray(le)?le.map(ce):ce(le)}function Ee(le,_,ue,re,ye,W,Q){Q=De(Q);const ge=ee[ye],we=ge[re%ge.length];let ke=[`%c[${le}]%c[${String(_).padStart(7," ")}]%c[len: ${String(ue).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${W}`,"color: darkgreen","color: grey","color: grey",`color: ${we}`];/\($/.test(W)?(ke=ke.concat(Q),ke.push(")")):ke.push(Q),console.log.apply(console,ke)}class Le{constructor(_,ue){this.d=_,this.f=ue,this.a=0,this.b=0}logOutgoing(_,ue,re,ye,W){this.b+=_,Ee(this.d,this.b,_,ue,re,ye,W)}logIncoming(_,ue,re,ye,W){this.a+=_,Ee(this.f,this.a,_,ue,re,ye,W)}}t.$ei=Le}),define(me[145],be([1,0,43,3,77,102,35]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$YW=void 0;class P extends B.$ai{static f(){const g=C.Event.fromNodeEventEmitter(A.$O,"vscode:message",(w,M)=>n.$Fe.wrap(M));return A.$O.send("vscode:hello"),new H.$UW(A.$O,g)}constructor(g){const w=P.f();super(w,g),this.b=w}dispose(){this.b.disconnect(),super.dispose()}}t.$YW=P}),define(me[146],be([13,12]),function(se,t){return se.create("vs/platform/files/common/files",t)}),define(me[147],be([13,12]),function(se,t){return se.create("vs/platform/theme/common/iconRegistry",t)}),define(me[50],be([1,0]),function(se,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$ui=t._util=void 0,t.$vi=B,t.$wi=H;var n;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(d){return d[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(n||(t._util=n={})),t.$ui=B("instantiationService");function C(A,P,d){P[n.DI_TARGET]===P?P[n.DI_DEPENDENCIES].push({id:A,index:d}):(P[n.DI_DEPENDENCIES]=[{id:A,index:d}],P[n.DI_TARGET]=P)}function B(A){if(n.serviceIds.has(A))return n.serviceIds.get(A);const P=function(d,g,w){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");C(P,d,w)};return P.toString=()=>A,n.serviceIds.set(A,P),P}function H(A){return A}}),define(me[148],be([1,0,50]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$en=t.$cn=t.ID=void 0,t.$dn=C,t.ID="diagnosticsService",t.$cn=(0,n.$vi)(t.ID);function C(H){return!!H.hostName&&!!H.errorMessage}class B{async getPerformanceInfo(A,P){return{}}async getSystemInfo(A,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,P){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}t.$en=B}),define(me[149],be([1,0,99,25,9,10,16,146,50,5,36,23]),function(se,t,n,C,B,H,A,P,d,g,w,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$xl=t.$ul=t.FileKind=t.$tl=t.$sl=t.$rl=t.$ql=t.$pl=t.$ol=t.$nl=t.FileOperationResult=t.$ml=t.$ll=t.$kl=t.$il=t.FileChangeType=t.$hl=t.FileOperation=t.$bl=t.FileSystemProviderErrorCode=t.FileSystemProviderCapabilities=t.FileChangeFilter=t.FilePermission=t.FileType=t.$2k=void 0,t.$3k=c,t.$4k=o,t.$5k=f,t.$6k=S,t.$7k=m,t.$8k=b,t.$9k=r,t.$0k=D,t.$$k=k,t.$_k=T,t.$al=L,t.$cl=I,t.$dl=V,t.$el=N,t.$fl=x,t.$gl=j,t.$jl=ee,t.$vl=_,t.$wl=ue,t.$yl=ye,t.$2k=(0,d.$vi)("fileService");function c(W){return W.create===!0}var h;(function(W){W[W.Unknown=0]="Unknown",W[W.File=1]="File",W[W.Directory=2]="Directory",W[W.SymbolicLink=64]="SymbolicLink"})(h||(t.FileType=h={}));var e;(function(W){W[W.Readonly=1]="Readonly",W[W.Locked=2]="Locked"})(e||(t.FilePermission=e={}));var i;(function(W){W[W.UPDATED=2]="UPDATED",W[W.ADDED=4]="ADDED",W[W.DELETED=8]="DELETED"})(i||(t.FileChangeFilter=i={}));function o(W){const Q=W;return!!Q&&typeof Q.onDidChange=="function"}var l;(function(W){W[W.None=0]="None",W[W.FileReadWrite=2]="FileReadWrite",W[W.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",W[W.FileReadStream=16]="FileReadStream",W[W.FileFolderCopy=8]="FileFolderCopy",W[W.PathCaseSensitive=1024]="PathCaseSensitive",W[W.Readonly=2048]="Readonly",W[W.Trash=4096]="Trash",W[W.FileWriteUnlock=8192]="FileWriteUnlock",W[W.FileAtomicRead=16384]="FileAtomicRead",W[W.FileAtomicWrite=32768]="FileAtomicWrite",W[W.FileAtomicDelete=65536]="FileAtomicDelete",W[W.FileClone=131072]="FileClone"})(l||(t.FileSystemProviderCapabilities=l={}));function f(W){return!!(W.capabilities&2)}function S(W){return!!(W.capabilities&8)}function m(W){return!!(W.capabilities&131072)}function b(W){return!!(W.capabilities&4)}function r(W){return!!(W.capabilities&16)}function D(W){return f(W)?!!(W.capabilities&16384):!1}function k(W){return f(W)?!!(W.capabilities&32768):!1}function T(W){return!!(W.capabilities&65536)}function L(W){return!!(W.capabilities&2048)}var q;(function(W){W.FileExists="EntryExists",W.FileNotFound="EntryNotFound",W.FileNotADirectory="EntryNotADirectory",W.FileIsADirectory="EntryIsADirectory",W.FileExceedsStorageQuota="EntryExceedsStorageQuota",W.FileTooLarge="EntryTooLarge",W.FileWriteLocked="EntryWriteLocked",W.NoPermissions="NoPermissions",W.Unavailable="Unavailable",W.Unknown="Unknown"})(q||(t.FileSystemProviderErrorCode=q={}));class $ extends Error{static create(Q,ge){const we=new $(Q.toString(),ge);return N(we,ge),we}constructor(Q,ge){super(Q),this.code=ge}}t.$bl=$;function I(W,Q){return $.create(W,Q)}function V(W){return W||I((0,P.localize)(0,null),q.Unknown)}function N(W,Q){return W.name=Q?`${Q} (FileSystemError)`:"FileSystemError",W}function x(W){if(!W)return q.Unknown;if(W instanceof $)return W.code;const Q=/^(.+) \(FileSystemError\)$/.exec(W.name);if(!Q)return q.Unknown;switch(Q[1]){case q.FileExists:return q.FileExists;case q.FileIsADirectory:return q.FileIsADirectory;case q.FileNotADirectory:return q.FileNotADirectory;case q.FileNotFound:return q.FileNotFound;case q.FileTooLarge:return q.FileTooLarge;case q.FileWriteLocked:return q.FileWriteLocked;case q.NoPermissions:return q.NoPermissions;case q.Unavailable:return q.Unavailable}return q.Unknown}function j(W){if(W instanceof ce)return W.fileOperationResult;switch(x(W)){case q.FileNotFound:return 1;case q.FileIsADirectory:return 0;case q.FileNotADirectory:return 9;case q.FileWriteLocked:return 5;case q.NoPermissions:return 6;case q.FileExists:return 4;case q.FileTooLarge:return 7;default:return 10}}var Y;(function(W){W[W.CREATE=0]="CREATE",W[W.DELETE=1]="DELETE",W[W.MOVE=2]="MOVE",W[W.COPY=3]="COPY",W[W.WRITE=4]="WRITE"})(Y||(t.FileOperation=Y={}));class K{constructor(Q,ge,we){this.resource=Q,this.operation=ge,this.target=we}isOperation(Q){return this.operation===Q}}t.$hl=K;var ae;(function(W){W[W.UPDATED=0]="UPDATED",W[W.ADDED=1]="ADDED",W[W.DELETED=2]="DELETED"})(ae||(t.FileChangeType=ae={}));class ie{static{this.a=null}constructor(Q,ge){this.c=ge,this.b=void 0,this.d=new M.$V(()=>{const we=n.$Bi.forUris(()=>this.c);return we.fill(this.rawAdded.map(ke=>[ke,!0])),we}),this.f=new M.$V(()=>{const we=n.$Bi.forUris(()=>this.c);return we.fill(this.rawUpdated.map(ke=>[ke,!0])),we}),this.g=new M.$V(()=>{const we=n.$Bi.forUris(()=>this.c);return we.fill(this.rawDeleted.map(ke=>[ke,!0])),we}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const we of Q){switch(we.type){case 1:this.rawAdded.push(we.resource);break;case 0:this.rawUpdated.push(we.resource);break;case 2:this.rawDeleted.push(we.resource);break}this.b!==ie.a&&(typeof we.cId=="number"?this.b===void 0?this.b=we.cId:this.b!==we.cId&&(this.b=ie.a):this.b!==void 0&&(this.b=ie.a))}}contains(Q,...ge){return this.h(Q,{includeChildren:!1},...ge)}affects(Q,...ge){return this.h(Q,{includeChildren:!0},...ge)}h(Q,ge,...we){if(!Q)return!1;const ke=we.length>0;return!!((!ke||we.includes(1))&&(this.d.value.get(Q)||ge.includeChildren&&this.d.value.findSuperstr(Q))||(!ke||we.includes(0))&&(this.f.value.get(Q)||ge.includeChildren&&this.f.value.findSuperstr(Q))||(!ke||we.includes(2))&&(this.g.value.findSubstr(Q)||ge.includeChildren&&this.g.value.findSuperstr(Q)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Q){return this.b===Q}hasCorrelation(){return typeof this.b=="number"}}t.$il=ie;function ee(W,Q,ge){return!W||!Q||W===Q||Q.length>W.length?!1:(Q.charAt(Q.length-1)!==C.sep&&(Q+=C.sep),ge?(0,B.$yf)(W,Q):W.indexOf(Q)===0)}class ce extends Error{constructor(Q,ge,we){super(Q),this.fileOperationResult=ge,this.options=we}}t.$kl=ce;class De extends ce{constructor(Q,ge,we,ke){super(Q,ge,ke),this.fileOperationResult=ge,this.size=we}}t.$ll=De;class Ee extends ce{constructor(Q,ge,we){super(Q,2,we),this.stat=ge}}t.$ml=Ee;var Le;(function(W){W[W.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",W[W.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",W[W.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",W[W.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",W[W.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",W[W.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",W[W.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",W[W.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",W[W.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",W[W.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",W[W.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Le||(t.FileOperationResult=Le={})),t.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.$pl="files.associations",t.$ql="files.exclude",t.$rl="files.readonlyInclude",t.$sl="files.readonlyExclude",t.$tl="files.readonlyFromPermissions";var le;(function(W){W[W.FILE=0]="FILE",W[W.FOLDER=1]="FOLDER",W[W.ROOT_FOLDER=2]="ROOT_FOLDER"})(le||(t.FileKind=le={})),t.$ul="";function _(W){if(!(typeof W.size!="number"||typeof W.mtime!="number"))return W.mtime.toString(29)+W.size.toString(31)}async function ue(W,Q){if(!Q.hasProvider(A.URI.from({scheme:W.scheme})))return new Promise(ge=>{const we=Q.onDidChangeFileSystemProviderRegistrations(ke=>{ke.scheme===W.scheme&&ke.added&&(we.dispose(),ge())})})}class re{static{this.KB=1024}static{this.MB=re.KB*re.KB}static{this.GB=re.MB*re.KB}static{this.TB=re.GB*re.KB}static formatSize(Q){return(0,H.$_f)(Q)||(Q=0),Q<re.KB?(0,P.localize)(1,null,Q.toFixed(0)):Q<re.MB?(0,P.localize)(2,null,(Q/re.KB).toFixed(2)):Q<re.GB?(0,P.localize)(3,null,(Q/re.MB).toFixed(2)):Q<re.TB?(0,P.localize)(4,null,(Q/re.GB).toFixed(2)):(0,P.localize)(5,null,(Q/re.TB).toFixed(2))}}t.$xl=re;function ye(W){const Q=typeof W=="string"||W?.scheme===w.Schemas.vscodeRemote;return typeof W!="string"&&W?.scheme===w.Schemas.file?1024*re.MB:Q?10*re.MB:g.$o?50*re.MB:1024*re.MB}}),define(me[150],be([1,0,50]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$udc=t.$tdc=void 0,t.$tdc=(0,n.$vi)("mainProcessService");class C{constructor(H,A){this.a=H,this.b=A}getChannel(H){return this.a.getChannel(H,this.b)}registerChannel(H,A){this.a.registerChannel(H,A)}}t.$udc=C}),define(me[151],be([1,0,2,145]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$vdc=void 0;class B extends n.$Vc{constructor(A){super(),this.a=this.B(new C.$YW(`window:${A}`))}getChannel(A){return this.a.getChannel(A)}registerChannel(A,P){this.a.registerChannel(A,P)}}t.$vdc=B});var Ei=this&&this.__param||function(se,t){return function(n,C){t(n,C,se)}};define(me[152],be([1,0,77,150]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$zdc=void 0;let B=class{constructor(A,P){return this.windowId=A,n.ProxyChannel.toService(P.getChannel("nativeHost"),{context:A,properties:(()=>{const d=new Map;return d.set("windowId",A),d})()})}};t.$zdc=B,t.$zdc=B=Ze([Ei(1,C.$tdc)],B)}),define(me[78],be([1,0,37,10]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$bo=void 0;class B{constructor(){this.a=new Map}add(A,P){n.ok(C.$8f(A)),n.ok(C.$0f(P)),n.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}t.$bo=new B}),define(me[153],be([1,0,3,78]),function(se,t,n,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$co=void 0,t.$co={JSONContribution:"base.contributions.json"};function B(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class H{constructor(){this.b=new n.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(d,g){this.a[B(d)]=g,this.b.fire(d)}notifySchemaChanged(d){this.b.fire(d)}getSchemaContributions(){return{schemas:this.a}}}const A=new H;C.$bo.add(t.$co.JSONContribution,A)}),define(me[154],be([1,0,11,18,45,19,3,10,16,147,153,78]),function(se,t,n,C,B,H,A,P,d,g,w,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$fx=t.$ex=t.$dx=t.$cx=t.$bx=t.$ax=t.IconFontDefinition=t.IconContribution=t.$0w=void 0,t.$$w=o,t.$_w=l,t.$0w={IconContribution:"base.contributions.icons"};var c;(function(b){function r(D,k){let T=D.defaults;for(;H.ThemeIcon.isThemeIcon(T);){const L=i.getIcon(T.id);if(!L)return;T=L.defaults}return T}b.getDefinition=r})(c||(t.IconContribution=c={}));var h;(function(b){function r(k){return{weight:k.weight,style:k.style,src:k.src.map(T=>({format:T.format,location:T.location.toString()}))}}b.toJSONObject=r;function D(k){const T=L=>(0,P.$8f)(L)?L:void 0;if(k&&Array.isArray(k.src)&&k.src.every(L=>(0,P.$8f)(L.format)&&(0,P.$8f)(L.location)))return{weight:T(k.weight),style:T(k.style),src:k.src.map(L=>({format:L.format,location:d.URI.parse(L.location)}))}}b.fromJSONObject=D})(h||(t.IconFontDefinition=h={}));class e{constructor(){this.a=new A.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,g.localize)(0,null)},fontCharacter:{type:"string",description:(0,g.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${H.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(r,D,k,T){const L=this.b[r];if(L){if(k&&!L.description){L.description=k,this.d.properties[r].markdownDescription=`${k} $(${r})`;const I=this.e.enum.indexOf(r);I!==-1&&(this.e.enumDescriptions[I]=k),this.a.fire()}return L}const q={id:r,description:k,defaults:D,deprecationMessage:T};this.b[r]=q;const $={$ref:"#/definitions/icons"};return T&&($.deprecationMessage=T),k&&($.markdownDescription=`${k}: $(${r})`),this.d.properties[r]=$,this.e.enum.push(r),this.e.enumDescriptions.push(k||""),this.a.fire(),{id:r}}deregisterIcon(r){delete this.b[r],delete this.d.properties[r];const D=this.e.enum.indexOf(r);D!==-1&&(this.e.enum.splice(D,1),this.e.enumDescriptions.splice(D,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(r=>this.b[r])}getIcon(r){return this.b[r]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(r,D){const k=this.f[r];return k||(this.f[r]=D,this.a.fire(),D)}deregisterIconFont(r){delete this.f[r]}getIconFont(r){return this.f[r]}toString(){const r=(L,q)=>L.id.localeCompare(q.id),D=L=>{for(;H.ThemeIcon.isThemeIcon(L.defaults);)L=this.b[L.defaults.id];return`codicon codicon-${L?L.id:""}`},k=[];k.push("| preview     | identifier                        | default codicon ID                | description"),k.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const T=Object.keys(this.b).map(L=>this.b[L]);for(const L of T.filter(q=>!!q.description).sort(r))k.push(`|<i class="${D(L)}"></i>|${L.id}|${H.ThemeIcon.isThemeIcon(L.defaults)?L.defaults.id:L.id}|${L.description||""}|`);k.push("| preview     | identifier                        "),k.push("| ----------- | --------------------------------- |");for(const L of T.filter(q=>!H.ThemeIcon.isThemeIcon(q.defaults)).sort(r))k.push(`|<i class="${D(L)}"></i>|${L.id}|`);return k.join(`
`)}}const i=new e;M.$bo.add(t.$0w.IconContribution,i);function o(b,r,D,k){return i.registerIcon(b,r,D,k)}function l(){return i}function f(){const b=(0,B.$Qj)();for(const r in b){const D="\\"+b[r].toString(16);i.registerIcon(r,{fontCharacter:D})}}f(),t.$ax="vscode://schemas/icons";const S=M.$bo.as(w.$co.JSONContribution);S.registerSchema(t.$ax,i.getIconSchema());const m=new n.$Hh(()=>S.notifySchemaChanged(t.$ax),200);i.onDidChange(()=>{m.isScheduled()||m.schedule()}),t.$bx=o("widget-close",C.$Uj.close,(0,g.localize)(2,null)),t.$cx=o("goto-previous-location",C.$Uj.arrowUp,(0,g.localize)(3,null)),t.$dx=o("goto-next-location",C.$Uj.arrowDown,(0,g.localize)(4,null)),t.$ex=H.ThemeIcon.modify(C.$Uj.sync,"spin"),t.$fx=H.ThemeIcon.modify(C.$Uj.loading,"spin")}),define(me[155],be([1,0,4,3,2,19,154]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$JJb=void 0,t.$IJb=P;function P(g){const w=new B.$Uc,M=w.add(new C.$ee),c=(0,A.$_w)();return w.add(c.onDidChange(()=>M.fire())),g&&w.add(g.onDidProductIconThemeChange(()=>M.fire())),{dispose:()=>w.dispose(),onDidChange:M.event,getCSS(){const h=g?g.getProductIconTheme():new d,e={},i=[],o=[];for(const l of c.getIcons()){const f=h.getIcon(l);if(!f)continue;const S=f.font,m=`--vscode-icon-${l.id}-font-family`,b=`--vscode-icon-${l.id}-content`;S?(e[S.id]=S.definition,o.push(`${m}: ${(0,n.$6S)(S.id)};`,`${b}: '${f.fontCharacter}';`),i.push(`.codicon-${l.id}:before { content: '${f.fontCharacter}'; font-family: ${(0,n.$6S)(S.id)}; }`)):(o.push(`${b}: '${f.fontCharacter}'; ${m}: 'codicon';`),i.push(`.codicon-${l.id}:before { content: '${f.fontCharacter}'; }`))}for(const l in e){const f=e[l],S=f.weight?`font-weight: ${f.weight};`:"",m=f.style?`font-style: ${f.style};`:"",b=f.src.map(r=>`${(0,n.$5S)(r.location)} format('${r.format}')`).join(", ");i.push(`@font-face { src: ${b}; font-family: ${(0,n.$6S)(l)};${S}${m} font-display: block; }`)}return i.push(`:root { ${o.join(" ")} }`),i.join(`
`)}}}class d{getIcon(w){const M=(0,A.$_w)();let c=w.defaults;for(;H.ThemeIcon.isThemeIcon(c);){const h=M.getIcon(c.id);if(!h)return;c=h.defaults}return c}}t.$JJb=d}),define(me[156],be([1,0,5]),function(se,t,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CustomTitleBarVisibility=t.TitlebarStyle=t.TitleBarSetting=t.$tD=void 0,t.$uD=C,t.$vD=B,t.$wD=H,t.$xD=A,t.$yD=P,t.$zD=M,t.$AD=c,t.$BD=h,t.$CD=e,t.$DD=i,t.$ED=o,t.$tD={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function C(l){return typeof l.parentId=="number"}function B(l){return!!l.workspaceUri}function H(l){return!!l.folderUri}function A(l){return!!l.fileUri}function P(l){const f=c(l),S=l.getValue("window.menuBarVisibility");return S==="default"||f&&S==="compact"||n.$j&&n.$m?"classic":S}var d;(function(l){l.TITLE_BAR_STYLE="window.titleBarStyle",l.CUSTOM_TITLE_BAR_VISIBILITY="window.customTitleBarVisibility"})(d||(t.TitleBarSetting=d={}));var g;(function(l){l.NATIVE="native",l.CUSTOM="custom"})(g||(t.TitlebarStyle=g={}));var w;(function(l){l.AUTO="auto",l.WINDOWED="windowed",l.NEVER="never"})(w||(t.CustomTitleBarVisibility=w={}));function M(l,f){return!0}function c(l,f){return f||(f=h(l)),f==="native"}function h(l){if(n.$o)return"custom";const f=l.getValue("window");if(f){if(n.$j&&f.nativeTabs===!0||n.$j&&f.nativeFullScreen===!1)return"native";const b=f.titleBarStyle;if(b==="native"||b==="custom")return b}return n.$k?"native":"custom"}function e(l){return!(!n.$i||n.$o||c(l))}function i(l){const f=l.getValue("window");return!f||typeof f.nativeFullScreen!="boolean"||f.nativeTabs?!0:f.nativeFullScreen!==!1}function o(l=0){return Math.pow(1.2,l)}}),define(me[157],be([1,0,17,4,22,35,156]),function(se,t,n,C,B,H,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.$Cdc=t.$Bdc=t.ApplyZoomTarget=void 0,t.$Ddc=d,t.$Edc=w,t.$Fdc=M;var P;(function(c){c[c.ACTIVE_WINDOW=1]="ACTIVE_WINDOW",c[c.ALL_WINDOWS=2]="ALL_WINDOWS"})(P||(t.ApplyZoomTarget=P={})),t.$Bdc=8,t.$Cdc=-8;function d(c,h){c=Math.min(Math.max(c,t.$Cdc),t.$Bdc);const e=[];h===P.ACTIVE_WINDOW?e.push((0,C.$tS)()):h===P.ALL_WINDOWS?e.push(...Array.from((0,C.getWindows)()).map(({window:i})=>i)):e.push(h);for(const i of e)g(i)?.webFrame?.setZoomLevel(c),(0,n.$qR)((0,A.$ED)(c),i),(0,n.$mR)(c,i)}function g(c){if(c===B.$iR)return{ipcRenderer:H.$O,webFrame:H.$Q};{const h=c;if(h?.vscode?.ipcRenderer&&h?.vscode?.webFrame)return h.vscode}}function w(c){d((0,n.$nR)(typeof c=="number"?(0,C.$tS)():c)+1,c)}function M(c){d((0,n.$nR)(typeof c=="number"?(0,C.$tS)():c)-1,c)}}),define(me[158],be([1,0,12,4,144,11,103,35,148,149,151,152,155,157,15,22,116,107]),function(se,t,n,C,B,H,A,P,d,g,w,M,c,h,e,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=I;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,l=/\s--inspect-port=(?<port>\d+)/;class f{getHeight(N){return 22}getTemplateId(N){return L(N)?"process":k(N)?"machine":(0,d.$dn)(N)?"error":T(N)?"header":""}}class S{hasChildren(N){return(0,d.$dn)(N)?!1:L(N)?!!N.children?.length:!0}getChildren(N){return L(N)?N.children?N.children:[]:(0,d.$dn)(N)?[]:T(N)?N.processRoots.length>1?N.processRoots:[N.processRoots[0].rootProcess]:k(N)?[N.rootProcess]:[N.processes]}}class m{constructor(){this.templateId="header"}renderTemplate(N){const x=(0,C.$OS)(N,(0,C.$)(".row")),j=(0,C.$OS)(x,(0,C.$)(".nameLabel")),Y=(0,C.$OS)(x,(0,C.$)(".cpu")),K=(0,C.$OS)(x,(0,C.$)(".memory")),ae=(0,C.$OS)(x,(0,C.$)(".pid"));return{name:j,CPU:Y,memory:K,PID:ae}}renderElement(N,x,j,Y){j.name.textContent=(0,n.localize)(0,null),j.CPU.textContent=(0,n.localize)(1,null),j.PID.textContent=(0,n.localize)(2,null),j.memory.textContent=(0,n.localize)(3,null)}disposeTemplate(N){}}class b{constructor(){this.templateId="machine"}renderTemplate(N){const x=Object.create(null),j=(0,C.$OS)(N,(0,C.$)(".row"));return x.name=(0,C.$OS)(j,(0,C.$)(".nameLabel")),x}renderElement(N,x,j,Y){j.name.textContent=N.element.name}disposeTemplate(N){}}class r{constructor(){this.templateId="error"}renderTemplate(N){const x=Object.create(null),j=(0,C.$OS)(N,(0,C.$)(".row"));return x.name=(0,C.$OS)(j,(0,C.$)(".nameLabel")),x}renderElement(N,x,j,Y){j.name.textContent=N.element.errorMessage}disposeTemplate(N){}}class D{constructor(N,x,j){this.a=N,this.b=x,this.c=j,this.templateId="process"}renderTemplate(N){const x=(0,C.$OS)(N,(0,C.$)(".row")),j=(0,C.$OS)(x,(0,C.$)(".nameLabel")),Y=(0,C.$OS)(x,(0,C.$)(".cpu")),K=(0,C.$OS)(x,(0,C.$)(".memory")),ae=(0,C.$OS)(x,(0,C.$)(".pid"));return{name:j,CPU:Y,PID:ae,memory:K}}renderElement(N,x,j,Y){const{element:K}=N,ae=K.pid.toFixed(0);let ie=K.name;this.c.has(K.pid)&&(ie=this.c.get(K.pid)),j.name.textContent=ie,j.name.title=K.cmd,j.CPU.textContent=K.load.toFixed(0),j.PID.textContent=ae,j.PID.parentElement.id=`pid-${ae}`;const ee=this.a==="win32"?K.mem:this.b*(K.mem/100);j.memory.textContent=(ee/g.$xl.MB).toFixed(0)}disposeTemplate(N){}}function k(V){return!!V.name&&!!V.rootProcess}function T(V){return!!V.processRoots}function L(V){return!!V.pid}class q{constructor(N,x){this.f=x,this.b=new Map;const j=new w.$vdc(N);this.c=new M.$zdc(N,j),this.k(x.styles),this.g(x),P.$O.on("vscode:pidToNameResponse",(Y,K)=>{this.b.clear();for(const[ae,ie]of K)this.b.set(ae,ie)}),P.$O.on("vscode:listProcessesResponse",async(Y,K)=>{K.forEach((ae,ie)=>{L(ae.rootProcess)&&(ae.rootProcess.name=ie===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:K}}),this.d.layout(i.$iR.innerHeight,i.$iR.innerWidth)):await this.h(K),this.m(0)}),this.a=Date.now(),P.$O.send("vscode:pidToNameRequest"),P.$O.send("vscode:listProcesses")}g(N){i.$iR.document.onkeydown=x=>{const j=N.platform==="darwin"?x.metaKey:x.ctrlKey;j&&x.keyCode===87&&(x.stopPropagation(),x.preventDefault(),P.$O.send("vscode:closeProcessExplorer")),j&&x.keyCode===187&&(0,h.$Edc)(i.$iR),j&&x.keyCode===189&&(0,h.$Fdc)(i.$iR)}}async h(N){const x=i.$iR.document.getElementById("process-list");if(!x)return;const{totalmem:j}=await this.c.getOSStatistics(),Y=[new D(this.f.platform,j,this.b),new m,new b,new r];this.d=new B.$lW("processExplorer",x,new f,Y,new S,{identityProvider:{getId:K=>L(K)?K.pid.toString():(0,d.$dn)(K)?K.hostName:T(K)?"processes":k(K)?K.name:"header"}}),this.d.setInput({processes:{processRoots:N}}),this.d.layout(i.$iR.innerHeight,i.$iR.innerWidth),this.d.onKeyDown(K=>{const ae=new e.$LR(K);if(ae.keyCode===35&&ae.altKey){const ie=this.n();Promise.all(ie.map(ee=>this.c.killProcess(ee,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(K=>{L(K.element)&&this.l(K.element,!0)}),x.style.height=`${i.$iR.innerHeight}px`,i.$iR.addEventListener("resize",()=>{x.style.height=`${i.$iR.innerHeight}px`,this.d?.layout(i.$iR.innerHeight,i.$iR.innerWidth)})}i(N){const x=o.exec(N);return x&&x.groups.port!=="0"||N.indexOf("node ")>=0||N.indexOf("node.exe")>=0}j(N){const x={type:"node",request:"attach",name:`process ${N.pid}`};let j=o.exec(N.cmd);j?x.port=Number(j.groups.port):x.processId=String(N.pid),j=l.exec(N.cmd),j&&(x.port=Number(j.groups.port)),P.$O.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[x]})}k(N){const x=(0,C.$wS)(),j=[];N.listFocusBackground&&(j.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${N.listFocusBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${N.listFocusBackground}; }`)),N.listFocusForeground&&j.push(`.monaco-list:focus .monaco-list-row.focused { color: ${N.listFocusForeground}; }`),N.listActiveSelectionBackground&&(j.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${N.listActiveSelectionBackground}; }`),j.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${N.listActiveSelectionBackground}; }`)),N.listActiveSelectionForeground&&j.push(`.monaco-list:focus .monaco-list-row.selected { color: ${N.listActiveSelectionForeground}; }`),N.listHoverBackground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${N.listHoverBackground}; }`),N.listHoverForeground&&j.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${N.listHoverForeground}; }`),N.listFocusOutline&&j.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${N.listFocusOutline}; outline-offset: -1px; }`),N.listHoverOutline&&j.push(`.monaco-list-row:hover { outline: 1px dashed ${N.listHoverOutline}; outline-offset: -1px; }`),N.scrollbarShadowColor&&j.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${N.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${N.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),N.scrollbarSliderBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${N.scrollbarSliderBackgroundColor};
				}
			`),N.scrollbarSliderHoverBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${N.scrollbarSliderHoverBackgroundColor};
				}
			`),N.scrollbarSliderActiveBackgroundColor&&j.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${N.scrollbarSliderActiveBackgroundColor};
				}
			`),x.textContent=j.join(`
`),N.color&&(i.$iR.document.body.style.color=N.color)}l(N,x){const j=[],Y=Number(N.pid);x&&(j.push({accelerator:"Alt+E",label:(0,n.localize)(4,null),click:()=>{this.c.killProcess(Y,"SIGTERM")}}),j.push({label:(0,n.localize)(5,null),click:()=>{this.c.killProcess(Y,"SIGKILL")}}),j.push({type:"separator"})),j.push({label:(0,n.localize)(6,null),click:()=>{const K=this.n();K?.includes(Y)||(K.length=0,K.push(Y));const ae=K?.map(ie=>i.$iR.document.getElementById(`pid-${ie}`)).filter(ie=>!!ie);if(ae){const ie=ae.map(ee=>ee.innerText).filter(ee=>!!ee);this.c.writeClipboardText(ie.join(`
`))}}}),j.push({label:(0,n.localize)(7,null),click:()=>{const K=i.$iR.document.getElementById("process-list");K&&this.c.writeClipboardText(K.innerText)}}),N&&x&&this.i(N.cmd)&&(j.push({type:"separator"}),j.push({label:(0,n.localize)(8,null),click:()=>{this.j(N)}})),(0,A.$QW)(j)}m(N){setTimeout(()=>{const x=Date.now(),j=N+x-this.a;this.a=x,j>1e3?(P.$O.send("vscode:pidToNameRequest"),P.$O.send("vscode:listProcesses")):this.m(j)},200)}n(){return this.d?.getSelection()?.map(N=>{if(!(!N||!("pid"in N)))return N.pid}).filter(N=>!!N)}}function $(){const V=(0,C.$wS)();V.id="codiconStyles";const N=(0,c.$IJb)(void 0);function x(){V.textContent=N.getCSS()}const j=new H.$Hh(x,0);N.onDidChange(()=>j.schedule()),j.schedule()}function I(V){const N=V.data.platform==="win32"?"windows":V.data.platform==="linux"?"linux":"mac";i.$iR.document.body.classList.add(N),$(),(0,h.$Ddc)(V.data.zoomLevel,i.$iR),new q(V.windowId,V.data)}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/063d715c4504380317f9ca8eefc602d71e56adb5/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
