/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/base/common/network","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/strings","vs/workbench/api/common/extHostRpcService","vs/base/common/types","vs/base/common/arrays","vs/base/common/path","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/buffer","vs/base/common/resources","vs/base/common/cancellation","vs/base/common/objects","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostCommands","vs/base/common/severity","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/themables","vs/base/common/errorMessage","vs/platform/files/common/files","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ae=function(ge){for(var e=[],S=0,N=ge.length;S<N;S++)e[S]=Ce[ge[S]];return e};define(Ce[68],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zh=N,e.$1h=R,e.$2h=O;function S(M){return(p,g,E)=>{let T=null,y=null;if(typeof E.value=="function"?(T="value",y=E.value):typeof E.get=="function"&&(T="get",y=E.get),!y)throw new Error("not supported");E[T]=M(y,g)}}function N(M,p,g){let E=null,T=null;if(typeof g.value=="function"?(E="value",T=g.value,T.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(E="get",T=g.get),!T)throw new Error("not supported");const y=`$memoize$${p}`;g[E]=function(...l){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:T.apply(this,l)}),this[y]}}function R(M,p,g){return S((E,T)=>{const y=`$debounce$${T}`,l=`$debounce$result$${T}`;return function(...w){this[l]||(this[l]=g?g():void 0),clearTimeout(this[y]),p&&(this[l]=p(this[l],...w),w=[this[l]]),this[y]=setTimeout(()=>{E.apply(this,w),this[l]=g?g():void 0},M)}})}function O(M,p,g){return S((E,T)=>{const y=`$throttle$timer$${T}`,l=`$throttle$result$${T}`,w=`$throttle$lastRun$${T}`,m=`$throttle$pending$${T}`;return function(...s){if(this[l]||(this[l]=g?g():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[l]=p(this[l],...s)),this[m])return;const o=this[w]+M;o<=Date.now()?(this[w]=Date.now(),E.apply(this,[this[l]]),this[l]=g?g():void 0):(this[m]=!0,this[y]=setTimeout(()=>{this[m]=!1,this[w]=Date.now(),E.apply(this,[this[l]]),this[l]=g?g():void 0},o-Date.now()))}})}}),define(Ce[90],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rP=e.$qP=void 0;class S{constructor(R){this.a=R,this.b=0}nextId(){return this.a+ ++this.b}}e.$qP=S,e.$rP=new S("id#")}),define(Ce[123],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Gn=M,e.$Hn=y,e.$In=l,e.$Jn=w,e.$Kn=m,e.$Ln=s,e.$Mn=o,e.$Nn=r,e.$On=t,e.$Pn=n,e.$Qn=c,e.$Rn=h;var S;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(S||(e.ScanError=S={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function M(i,$=!1){let a=0;const v=i.length;let d="",C=0,u=16,D=0;function f(q){let A=0,j=0;for(;A<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)j=j*16+K-48;else if(K>=65&&K<=70)j=j*16+K-65+10;else if(K>=97&&K<=102)j=j*16+K-97+10;else break;a++,A++}return A<q&&(j=-1),j}function k(q){a=q,d="",C=0,u=16,D=0}function b(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&E(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&E(i.charCodeAt(a)))for(a++;a<i.length&&E(i.charCodeAt(a));)a++;else return D=3,i.substring(q,a);let A=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&E(i.charCodeAt(a))){for(a++;a<i.length&&E(i.charCodeAt(a));)a++;A=a}else D=3;return i.substring(q,A)}function P(){let q="",A=a;for(;;){if(a>=v){q+=i.substring(A,a),D=2;break}const j=i.charCodeAt(a);if(j===34){q+=i.substring(A,a),a++;break}if(j===92){if(q+=i.substring(A,a),a++,a>=v){D=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const re=f(4);re>=0?q+=String.fromCharCode(re):D=4;break}default:D=5}A=a;continue}if(j>=0&&j<=31)if(g(j)){q+=i.substring(A,a),D=2;break}else D=6;a++}return q}function I(){if(d="",D=0,C=a,a>=v)return C=v,u=17;let q=i.charCodeAt(a);if(p(q)){do a++,d+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return u=15}if(g(q))return a++,d+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,d+=`
`),u=14;switch(q){case 123:return a++,u=1;case 125:return a++,u=2;case 91:return a++,u=3;case 93:return a++,u=4;case 58:return a++,u=6;case 44:return a++,u=5;case 34:return a++,d=P(),u=10;case 47:{const A=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<v&&!g(i.charCodeAt(a));)a++;return d=i.substring(A,a),u=12}if(i.charCodeAt(a+1)===42){a+=2;const j=v-1;let K=!1;for(;a<j;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,D=1),d=i.substring(A,a),u=13}return d+=String.fromCharCode(q),a++,u=16}case 45:if(d+=String.fromCharCode(q),a++,a===v||!E(i.charCodeAt(a)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return d+=b(),u=11;default:for(;a<v&&W(q);)a++,q=i.charCodeAt(a);if(C!==a){switch(d=i.substring(C,a),d){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return d+=String.fromCharCode(q),a++,u=16}}function W(q){if(p(q)||g(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let q;do q=I();while(q>=12&&q<=15);return q}return{setPosition:k,getPosition:()=>a,scan:$?V:I,getToken:()=>u,getTokenValue:()=>d,getTokenOffset:()=>C,getTokenLength:()=>a-C,getTokenError:()=>D}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function g(i){return i===10||i===13||i===8232||i===8233}function E(i){return i>=48&&i<=57}var T;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(T||(T={}));function y(i,$){const a=[],v=new Object;let d;const C={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function D(f,k,b,P){C.value=f,C.offset=k,C.length=b,C.type=P,C.colonOffset=void 0,d=C}try{n(i,{onObjectBegin:(f,k)=>{if($<=f)throw v;d=void 0,u=$>f,a.push("")},onObjectProperty:(f,k,b)=>{if($<k||(D(f,k,b,"property"),a[a.length-1]=f,$<=k+b))throw v},onObjectEnd:(f,k)=>{if($<=f)throw v;d=void 0,a.pop()},onArrayBegin:(f,k)=>{if($<=f)throw v;d=void 0,a.push(0)},onArrayEnd:(f,k)=>{if($<=f)throw v;d=void 0,a.pop()},onLiteralValue:(f,k,b)=>{if($<k||(D(f,k,b,h(f)),$<=k+b))throw v},onSeparator:(f,k,b)=>{if($<=k)throw v;if(f===":"&&d&&d.type==="property")d.colonOffset=k,u=!1,d=void 0;else if(f===","){const P=a[a.length-1];typeof P=="number"?a[a.length-1]=P+1:(u=!0,a[a.length-1]=""),d=void 0}}})}catch(f){if(f!==v)throw f}return{path:a,previousNode:d,isAtPropertyKey:u,matches:f=>{let k=0;for(let b=0;k<f.length&&b<a.length;b++)if(f[k]===a[b]||f[k]==="*")k++;else if(f[k]!=="**")return!1;return k===f.length}}}function l(i,$=[],a=O.DEFAULT){let v=null,d=[];const C=[];function u(f){Array.isArray(d)?d.push(f):v!==null&&(d[v]=f)}return n(i,{onObjectBegin:()=>{const f={};u(f),C.push(d),d=f,v=null},onObjectProperty:f=>{v=f},onObjectEnd:()=>{d=C.pop()},onArrayBegin:()=>{const f=[];u(f),C.push(d),d=f,v=null},onArrayEnd:()=>{d=C.pop()},onLiteralValue:u,onError:(f,k,b)=>{$.push({error:f,offset:k,length:b})}},a),d[0]}function w(i,$=[],a=O.DEFAULT){let v={type:"array",offset:-1,length:-1,children:[],parent:void 0};function d(f){v.type==="property"&&(v.length=f-v.offset,v=v.parent)}function C(f){return v.children.push(f),f}n(i,{onObjectBegin:f=>{v=C({type:"object",offset:f,length:-1,parent:v,children:[]})},onObjectProperty:(f,k,b)=>{v=C({type:"property",offset:k,length:-1,parent:v,children:[]}),v.children.push({type:"string",value:f,offset:k,length:b,parent:v})},onObjectEnd:(f,k)=>{v.length=f+k-v.offset,v=v.parent,d(f+k)},onArrayBegin:(f,k)=>{v=C({type:"array",offset:f,length:-1,parent:v,children:[]})},onArrayEnd:(f,k)=>{v.length=f+k-v.offset,v=v.parent,d(f+k)},onLiteralValue:(f,k,b)=>{C({type:h(f),offset:k,length:b,parent:v,value:f}),d(k+b)},onSeparator:(f,k,b)=>{v.type==="property"&&(f===":"?v.colonOffset=k:f===","&&d(k))},onError:(f,k,b)=>{$.push({error:f,offset:k,length:b})}},a);const D=v.children[0];return D&&delete D.parent,D}function m(i,$){if(!i)return;let a=i;for(const v of $)if(typeof v=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let d=!1;for(const C of a.children)if(Array.isArray(C.children)&&C.children[0].value===v){a=C.children[1],d=!0;break}if(!d)return}else{const d=v;if(a.type!=="array"||d<0||!Array.isArray(a.children)||d>=a.children.length)return;a=a.children[d]}return a}function s(i){if(!i.parent||!i.parent.children)return[];const $=s(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;$.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&$.push(a)}return $}function o(i){switch(i.type){case"array":return i.children.map(o);case"object":{const $=Object.create(null);for(const a of i.children){const v=a.children[1];v&&($[a.children[0].value]=o(v))}return $}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function r(i,$,a=!1){return $>=i.offset&&$<i.offset+i.length||a&&$===i.offset+i.length}function t(i,$,a=!1){if(r(i,$,a)){const v=i.children;if(Array.isArray(v))for(let d=0;d<v.length&&v[d].offset<=$;d++){const C=t(v[d],$,a);if(C)return C}return i}}function n(i,$,a=O.DEFAULT){const v=M(i,!1);function d(Me){return Me?()=>Me(v.getTokenOffset(),v.getTokenLength()):()=>!0}function C(Me){return Me?ce=>Me(ce,v.getTokenOffset(),v.getTokenLength()):()=>!0}const u=d($.onObjectBegin),D=C($.onObjectProperty),f=d($.onObjectEnd),k=d($.onArrayBegin),b=d($.onArrayEnd),P=C($.onLiteralValue),I=C($.onSeparator),W=d($.onComment),V=C($.onError),q=a&&a.disallowComments,A=a&&a.allowTrailingComma;function j(){for(;;){const Me=v.scan();switch(v.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Me){case 12:case 13:q?K(10):W();break;case 16:K(1);break;case 15:case 14:break;default:return Me}}}function K(Me,ce=[],Re=[]){if(V(Me),ce.length+Re.length>0){let ie=v.getToken();for(;ie!==17;){if(ce.indexOf(ie)!==-1){j();break}else if(Re.indexOf(ie)!==-1)break;ie=j()}}}function re(Me){const ce=v.getTokenValue();return Me?P(ce):D(ce),j(),!0}function ae(){switch(v.getToken()){case 11:{let Me=0;try{Me=JSON.parse(v.getTokenValue()),typeof Me!="number"&&(K(2),Me=0)}catch{K(2)}P(Me);break}case 7:P(null);break;case 8:P(!0);break;case 9:P(!1);break;default:return!1}return j(),!0}function we(){return v.getToken()!==10?(K(3,[],[2,5]),!1):(re(!1),v.getToken()===6?(I(":"),j(),me()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function Ie(){u(),j();let Me=!1;for(;v.getToken()!==2&&v.getToken()!==17;){if(v.getToken()===5){if(Me||K(4,[],[]),I(","),j(),v.getToken()===2&&A)break}else Me&&K(6,[],[]);we()||K(4,[],[2,5]),Me=!0}return f(),v.getToken()!==2?K(7,[2],[]):j(),!0}function de(){k(),j();let Me=!1;for(;v.getToken()!==4&&v.getToken()!==17;){if(v.getToken()===5){if(Me||K(4,[],[]),I(","),j(),v.getToken()===4&&A)break}else Me&&K(6,[],[]);me()||K(4,[],[4,5]),Me=!0}return b(),v.getToken()!==4?K(8,[4],[]):j(),!0}function me(){switch(v.getToken()){case 3:return de();case 1:return Ie();case 10:return re(!0);default:return ae()}}return j(),v.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):me()?(v.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,$){const a=M(i),v=[];let d,C=0,u;do switch(u=a.getPosition(),d=a.scan(),d){case 12:case 13:case 17:C!==u&&v.push(i.substring(C,u)),$!==void 0&&v.push(a.getTokenValue().replace(/[^\r\n]/g,$)),C=a.getPosition();break}while(d!==17);return v.join("")}function h(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(ge,e){typeof define=="function"&&define.amd?define(Ce[124],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(Ee,pe){for(var fe=0;fe<pe.length;fe++){var Y=pe[fe];Y.enumerable=Y.enumerable||!1,Y.configurable=!0,"value"in Y&&(Y.writable=!0),Object.defineProperty(Ee,Y.key,Y)}}function S(Ee,pe,fe){return pe&&e(Ee.prototype,pe),fe&&e(Ee,fe),Object.defineProperty(Ee,"prototype",{writable:!1}),Ee}function N(Ee,pe){if(Ee){if(typeof Ee=="string")return R(Ee,pe);var fe=Object.prototype.toString.call(Ee).slice(8,-1);if(fe==="Object"&&Ee.constructor&&(fe=Ee.constructor.name),fe==="Map"||fe==="Set")return Array.from(Ee);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return R(Ee,pe)}}function R(Ee,pe){(pe==null||pe>Ee.length)&&(pe=Ee.length);for(var fe=0,Y=new Array(pe);fe<pe;fe++)Y[fe]=Ee[fe];return Y}function O(Ee,pe){var fe=typeof Symbol<"u"&&Ee[Symbol.iterator]||Ee["@@iterator"];if(fe)return(fe=fe.call(Ee)).next.bind(fe);if(Array.isArray(Ee)||(fe=N(Ee))||pe&&Ee&&typeof Ee.length=="number"){fe&&(Ee=fe);var Y=0;return function(){return Y>=Ee.length?{done:!0}:{done:!1,value:Ee[Y++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function M(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=M();function p(Ee){ge.defaults=Ee}var g=/[&<>"']/,E=/[&<>"']/g,T=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(pe){return l[pe]};function m(Ee,pe){if(pe){if(g.test(Ee))return Ee.replace(E,w)}else if(T.test(Ee))return Ee.replace(y,w);return Ee}var s=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function o(Ee){return Ee.replace(s,function(pe,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var r=/(^|[^\[])\^/g;function t(Ee,pe){Ee=typeof Ee=="string"?Ee:Ee.source,pe=pe||"";var fe={replace:function(X,le){return le=le.source||le,le=le.replace(r,"$1"),Ee=Ee.replace(X,le),fe},getRegex:function(){return new RegExp(Ee,pe)}};return fe}var n=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function h(Ee,pe,fe){if(Ee){var Y;try{Y=decodeURIComponent(o(fe)).replace(n,"").toLowerCase()}catch{return null}if(Y.indexOf("javascript:")===0||Y.indexOf("vbscript:")===0||Y.indexOf("data:")===0)return null}pe&&!c.test(fe)&&(fe=d(pe,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch{return null}return fe}var i={},$=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,v=/^([^:]+:\/*[^/]*)[\s\S]*$/;function d(Ee,pe){i[" "+Ee]||($.test(Ee)?i[" "+Ee]=Ee+"/":i[" "+Ee]=f(Ee,"/",!0)),Ee=i[" "+Ee];var fe=Ee.indexOf(":")===-1;return pe.substring(0,2)==="//"?fe?pe:Ee.replace(a,"$1")+pe:pe.charAt(0)==="/"?fe?pe:Ee.replace(v,"$1")+pe:Ee+pe}var C={exec:function(){}};function u(Ee){for(var pe=1,fe,Y;pe<arguments.length;pe++){fe=arguments[pe];for(Y in fe)Object.prototype.hasOwnProperty.call(fe,Y)&&(Ee[Y]=fe[Y])}return Ee}function D(Ee,pe){var fe=Ee.replace(/\|/g,function(le,ue,Te){for(var he=!1,Pe=ue;--Pe>=0&&Te[Pe]==="\\";)he=!he;return he?"|":" |"}),Y=fe.split(/ \|/),X=0;if(Y[0].trim()||Y.shift(),Y.length>0&&!Y[Y.length-1].trim()&&Y.pop(),Y.length>pe)Y.splice(pe);else for(;Y.length<pe;)Y.push("");for(;X<Y.length;X++)Y[X]=Y[X].trim().replace(/\\\|/g,"|");return Y}function f(Ee,pe,fe){var Y=Ee.length;if(Y===0)return"";for(var X=0;X<Y;){var le=Ee.charAt(Y-X-1);if(le===pe&&!fe)X++;else if(le!==pe&&fe)X++;else break}return Ee.slice(0,Y-X)}function k(Ee,pe){if(Ee.indexOf(pe[1])===-1)return-1;for(var fe=Ee.length,Y=0,X=0;X<fe;X++)if(Ee[X]==="\\")X++;else if(Ee[X]===pe[0])Y++;else if(Ee[X]===pe[1]&&(Y--,Y<0))return X;return-1}function b(Ee){Ee&&Ee.sanitize&&!Ee.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function P(Ee,pe){if(pe<1)return"";for(var fe="";pe>1;)pe&1&&(fe+=Ee),pe>>=1,Ee+=Ee;return fe+Ee}function I(Ee,pe,fe,Y){var X=pe.href,le=pe.title?m(pe.title):null,ue=Ee[1].replace(/\\([\[\]])/g,"$1");if(Ee[0].charAt(0)!=="!"){Y.state.inLink=!0;var Te={type:"link",raw:fe,href:X,title:le,text:ue,tokens:Y.inlineTokens(ue)};return Y.state.inLink=!1,Te}return{type:"image",raw:fe,href:X,title:le,text:m(ue)}}function W(Ee,pe){var fe=Ee.match(/^(\s+)(?:```)/);if(fe===null)return pe;var Y=fe[1];return pe.split(`
`).map(function(X){var le=X.match(/^\s+/);if(le===null)return X;var ue=le[0];return ue.length>=Y.length?X.slice(Y.length):X}).join(`
`)}var V=function(){function Ee(fe){this.options=fe||ge.defaults}var pe=Ee.prototype;return pe.space=function(Y){var X=this.rules.block.newline.exec(Y);if(X&&X[0].length>0)return{type:"space",raw:X[0]}},pe.code=function(Y){var X=this.rules.block.code.exec(Y);if(X){var le=X[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:X[0],codeBlockStyle:"indented",text:this.options.pedantic?le:f(le,`
`)}}},pe.fences=function(Y){var X=this.rules.block.fences.exec(Y);if(X){var le=X[0],ue=W(le,X[3]||"");return{type:"code",raw:le,lang:X[2]?X[2].trim():X[2],text:ue}}},pe.heading=function(Y){var X=this.rules.block.heading.exec(Y);if(X){var le=X[2].trim();if(/#$/.test(le)){var ue=f(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:X[0],depth:X[1].length,text:le,tokens:this.lexer.inline(le)}}},pe.hr=function(Y){var X=this.rules.block.hr.exec(Y);if(X)return{type:"hr",raw:X[0]}},pe.blockquote=function(Y){var X=this.rules.block.blockquote.exec(Y);if(X){var le=X[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:X[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},pe.list=function(Y){var X=this.rules.block.list.exec(Y);if(X){var le,ue,Te,he,Pe,Ne,ze,U,z,H,G,ee,ne=X[1].trim(),Oe=ne.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+ne.slice(0,-1):"",loose:!1,items:[]};ne=Oe?"\\d{1,9}\\"+ne.slice(-1):"\\"+ne,this.options.pedantic&&(ne=Oe?ne:"[*+-]");for(var Ye=new RegExp("^( {0,3}"+ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");Y&&(ee=!1,!(!(X=Ye.exec(Y))||this.rules.block.hr.test(Y)));){if(le=X[0],Y=Y.substring(le.length),U=X[2].split(`
`,1)[0],z=Y.split(`
`,1)[0],this.options.pedantic?(he=2,G=U.trimLeft()):(he=X[2].search(/[^ ]/),he=he>4?1:he,G=U.slice(he),he+=X[1].length),Ne=!1,!U&&/^ *$/.test(z)&&(le+=z+`
`,Y=Y.substring(z.length+1),ee=!0),!ee)for(var _e=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),et=new RegExp("^ {0,"+Math.min(3,he-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),tt=new RegExp("^ {0,"+Math.min(3,he-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,he-1)+"}#");Y&&(H=Y.split(`
`,1)[0],U=H,this.options.pedantic&&(U=U.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(tt.test(U)||it.test(U)||_e.test(U)||et.test(Y)));){if(U.search(/[^ ]/)>=he||!U.trim())G+=`
`+U.slice(he);else if(!Ne)G+=`
`+U;else break;!Ne&&!U.trim()&&(Ne=!0),le+=H+`
`,Y=Y.substring(H.length+1)}Be.loose||(ze?Be.loose=!0:/\n *\n *$/.test(le)&&(ze=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(G),ue&&(Te=ue[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:le,task:!!ue,checked:Te,loose:!1,text:G}),Be.raw+=le}Be.items[Be.items.length-1].raw=le.trimRight(),Be.items[Be.items.length-1].text=G.trimRight(),Be.raw=Be.raw.trimRight();var nt=Be.items.length;for(Pe=0;Pe<nt;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(je){return je.type==="space"}),mt=at.every(function(je){for(var st=je.raw.split(""),Z=0,Q=O(st),$e;!($e=Q()).done;){var Ge=$e.value;if(Ge===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&at.length&&mt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},pe.html=function(Y){var X=this.rules.block.html.exec(Y);if(X){var le={type:"html",raw:X[0],pre:!this.options.sanitizer&&(X[1]==="pre"||X[1]==="script"||X[1]==="style"),text:X[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},pe.def=function(Y){var X=this.rules.block.def.exec(Y);if(X){X[3]&&(X[3]=X[3].substring(1,X[3].length-1));var le=X[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:X[0],href:X[2],title:X[3]}}},pe.table=function(Y){var X=this.rules.block.table.exec(Y);if(X){var le={type:"table",header:D(X[1]).map(function(ze){return{text:ze}}),align:X[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:X[3]&&X[3].trim()?X[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=X[0];var ue=le.align.length,Te,he,Pe,Ne;for(Te=0;Te<ue;Te++)/^ *-+: *$/.test(le.align[Te])?le.align[Te]="right":/^ *:-+: *$/.test(le.align[Te])?le.align[Te]="center":/^ *:-+ *$/.test(le.align[Te])?le.align[Te]="left":le.align[Te]=null;for(ue=le.rows.length,Te=0;Te<ue;Te++)le.rows[Te]=D(le.rows[Te],le.header.length).map(function(ze){return{text:ze}});for(ue=le.header.length,he=0;he<ue;he++)le.header[he].tokens=this.lexer.inline(le.header[he].text);for(ue=le.rows.length,he=0;he<ue;he++)for(Ne=le.rows[he],Pe=0;Pe<Ne.length;Pe++)Ne[Pe].tokens=this.lexer.inline(Ne[Pe].text);return le}}},pe.lheading=function(Y){var X=this.rules.block.lheading.exec(Y);if(X)return{type:"heading",raw:X[0],depth:X[2].charAt(0)==="="?1:2,text:X[1],tokens:this.lexer.inline(X[1])}},pe.paragraph=function(Y){var X=this.rules.block.paragraph.exec(Y);if(X){var le=X[1].charAt(X[1].length-1)===`
`?X[1].slice(0,-1):X[1];return{type:"paragraph",raw:X[0],text:le,tokens:this.lexer.inline(le)}}},pe.text=function(Y){var X=this.rules.block.text.exec(Y);if(X)return{type:"text",raw:X[0],text:X[0],tokens:this.lexer.inline(X[0])}},pe.escape=function(Y){var X=this.rules.inline.escape.exec(Y);if(X)return{type:"escape",raw:X[0],text:m(X[1])}},pe.tag=function(Y){var X=this.rules.inline.tag.exec(Y);if(X)return!this.lexer.state.inLink&&/^<a /i.test(X[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(X[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(X[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(X[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:X[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):m(X[0]):X[0]}},pe.link=function(Y){var X=this.rules.inline.link.exec(Y);if(X){var le=X[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=f(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var Te=k(X[2],"()");if(Te>-1){var he=X[0].indexOf("!")===0?5:4,Pe=he+X[1].length+Te;X[2]=X[2].substring(0,Te),X[0]=X[0].substring(0,Pe).trim(),X[3]=""}}var Ne=X[2],ze="";if(this.options.pedantic){var U=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ne);U&&(Ne=U[1],ze=U[3])}else ze=X[3]?X[3].slice(1,-1):"";return Ne=Ne.trim(),/^</.test(Ne)&&(this.options.pedantic&&!/>$/.test(le)?Ne=Ne.slice(1):Ne=Ne.slice(1,-1)),I(X,{href:Ne&&Ne.replace(this.rules.inline._escapes,"$1"),title:ze&&ze.replace(this.rules.inline._escapes,"$1")},X[0],this.lexer)}},pe.reflink=function(Y,X){var le;if((le=this.rules.inline.reflink.exec(Y))||(le=this.rules.inline.nolink.exec(Y))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=X[ue.toLowerCase()],!ue||!ue.href){var Te=le[0].charAt(0);return{type:"text",raw:Te,text:Te}}return I(le,ue,le[0],this.lexer)}},pe.emStrong=function(Y,X,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(Y);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ue[1]||ue[2]||"";if(!Te||Te&&(le===""||this.rules.inline.punctuation.exec(le))){var he=ue[0].length-1,Pe,Ne,ze=he,U=0,z=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(z.lastIndex=0,X=X.slice(-1*Y.length+he);(ue=z.exec(X))!=null;)if(Pe=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!Pe){if(Ne=Pe.length,ue[3]||ue[4]){ze+=Ne;continue}else if((ue[5]||ue[6])&&he%3&&!((he+Ne)%3)){U+=Ne;continue}if(ze-=Ne,!(ze>0)){if(Ne=Math.min(Ne,Ne+ze+U),Math.min(he,Ne)%2){var H=Y.slice(1,he+ue.index+Ne);return{type:"em",raw:Y.slice(0,he+ue.index+Ne+1),text:H,tokens:this.lexer.inlineTokens(H)}}var G=Y.slice(2,he+ue.index+Ne-1);return{type:"strong",raw:Y.slice(0,he+ue.index+Ne+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},pe.codespan=function(Y){var X=this.rules.inline.code.exec(Y);if(X){var le=X[2].replace(/\n/g," "),ue=/[^ ]/.test(le),Te=/^ /.test(le)&&/ $/.test(le);return ue&&Te&&(le=le.substring(1,le.length-1)),le=m(le,!0),{type:"codespan",raw:X[0],text:le}}},pe.br=function(Y){var X=this.rules.inline.br.exec(Y);if(X)return{type:"br",raw:X[0]}},pe.del=function(Y){var X=this.rules.inline.del.exec(Y);if(X)return{type:"del",raw:X[0],text:X[2],tokens:this.lexer.inlineTokens(X[2])}},pe.autolink=function(Y,X){var le=this.rules.inline.autolink.exec(Y);if(le){var ue,Te;return le[2]==="@"?(ue=m(this.options.mangle?X(le[1]):le[1]),Te="mailto:"+ue):(ue=m(le[1]),Te=ue),{type:"link",raw:le[0],text:ue,href:Te,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.url=function(Y,X){var le;if(le=this.rules.inline.url.exec(Y)){var ue,Te;if(le[2]==="@")ue=m(this.options.mangle?X(le[0]):le[0]),Te="mailto:"+ue;else{var he;do he=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(he!==le[0]);ue=m(le[0]),le[1]==="www."?Te="http://"+ue:Te=ue}return{type:"link",raw:le[0],text:ue,href:Te,tokens:[{type:"text",raw:ue,text:ue}]}}},pe.inlineText=function(Y,X){var le=this.rules.inline.text.exec(Y);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):m(le[0]):le[0]:ue=m(this.options.smartypants?X(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},Ee}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:C,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=t(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=t(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=t(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=t(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=t(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=t(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=u({},q),q.gfm=u({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=t(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=t(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=u({},q.normal,{html:t(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:C,paragraph:t(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var A={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:C,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:C,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};A._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",A.punctuation=t(A.punctuation).replace(/punctuation/g,A._punctuation).getRegex(),A.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,A.escapedEmSt=/\\\*|\\_/g,A._comment=t(q._comment).replace("(?:-->|$)","-->").getRegex(),A.emStrong.lDelim=t(A.emStrong.lDelim).replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimAst=t(A.emStrong.rDelimAst,"g").replace(/punct/g,A._punctuation).getRegex(),A.emStrong.rDelimUnd=t(A.emStrong.rDelimUnd,"g").replace(/punct/g,A._punctuation).getRegex(),A._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,A._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,A._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,A.autolink=t(A.autolink).replace("scheme",A._scheme).replace("email",A._email).getRegex(),A._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,A.tag=t(A.tag).replace("comment",A._comment).replace("attribute",A._attribute).getRegex(),A._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,A._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,A._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,A.link=t(A.link).replace("label",A._label).replace("href",A._href).replace("title",A._title).getRegex(),A.reflink=t(A.reflink).replace("label",A._label).replace("ref",q._label).getRegex(),A.nolink=t(A.nolink).replace("ref",q._label).getRegex(),A.reflinkSearch=t(A.reflinkSearch,"g").replace("reflink",A.reflink).replace("nolink",A.nolink).getRegex(),A.normal=u({},A),A.pedantic=u({},A.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:t(/^!?\[(label)\]\((.*?)\)/).replace("label",A._label).getRegex(),reflink:t(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",A._label).getRegex()}),A.gfm=u({},A.normal,{escape:t(A.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),A.gfm.url=t(A.gfm.url,"i").replace("email",A.gfm._extended_email).getRegex(),A.breaks=u({},A.gfm,{br:t(A.br).replace("{2,}","*").getRegex(),text:t(A.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(Ee){return Ee.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(Ee){var pe="",fe,Y,X=Ee.length;for(fe=0;fe<X;fe++)Y=Ee.charCodeAt(fe),Math.random()>.5&&(Y="x"+Y.toString(16)),pe+="&#"+Y+";";return pe}var re=function(){function Ee(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ge.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Y={block:q.normal,inline:A.normal};this.options.pedantic?(Y.block=q.pedantic,Y.inline=A.pedantic):this.options.gfm&&(Y.block=q.gfm,this.options.breaks?Y.inline=A.breaks:Y.inline=A.gfm),this.tokenizer.rules=Y}Ee.lex=function(Y,X){var le=new Ee(X);return le.lex(Y)},Ee.lexInline=function(Y,X){var le=new Ee(X);return le.inlineTokens(Y)};var pe=Ee.prototype;return pe.lex=function(Y){Y=Y.replace(/\r\n|\r/g,`
`),this.blockTokens(Y,this.tokens);for(var X;X=this.inlineQueue.shift();)this.inlineTokens(X.src,X.tokens);return this.tokens},pe.blockTokens=function(Y,X){var le=this;X===void 0&&(X=[]),this.options.pedantic?Y=Y.replace(/\t/g,"    ").replace(/^ +$/gm,""):Y=Y.replace(/^( *)(\t+)/gm,function(ze,U,z){return U+"    ".repeat(z.length)});for(var ue,Te,he,Pe;Y;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ze){return(ue=ze.call({lexer:le},Y,X))?(Y=Y.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.space(Y)){Y=Y.substring(ue.raw.length),ue.raw.length===1&&X.length>0?X[X.length-1].raw+=`
`:X.push(ue);continue}if(ue=this.tokenizer.code(Y)){Y=Y.substring(ue.raw.length),Te=X[X.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(ue);continue}if(ue=this.tokenizer.fences(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.heading(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.hr(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.blockquote(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.list(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.html(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.def(Y)){Y=Y.substring(ue.raw.length),Te=X[X.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.lheading(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(he=Y,this.options.extensions&&this.options.extensions.startBlock&&function(){var ze=1/0,U=Y.slice(1),z=void 0;le.options.extensions.startBlock.forEach(function(H){z=H.call({lexer:this},U),typeof z=="number"&&z>=0&&(ze=Math.min(ze,z))}),ze<1/0&&ze>=0&&(he=Y.substring(0,ze+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(he))){Te=X[X.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(ue),Pe=he.length!==Y.length,Y=Y.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(Y)){Y=Y.substring(ue.raw.length),Te=X[X.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ue.raw,Te.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):X.push(ue);continue}if(Y){var Ne="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(Ne);break}else throw new Error(Ne)}}return this.state.top=!0,X},pe.inline=function(Y,X){return X===void 0&&(X=[]),this.inlineQueue.push({src:Y,tokens:X}),X},pe.inlineTokens=function(Y,X){var le=this;X===void 0&&(X=[]);var ue,Te,he,Pe=Y,Ne,ze,U;if(this.tokens.links){var z=Object.keys(this.tokens.links);if(z.length>0)for(;(Ne=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)z.includes(Ne[0].slice(Ne[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Ne.index)+"["+P("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ne=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"["+P("a",Ne[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ne=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Ne.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Y;)if(ze||(U=""),ze=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(ue=G.call({lexer:le},Y,X))?(Y=Y.substring(ue.raw.length),X.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.tag(Y)){Y=Y.substring(ue.raw.length),Te=X[X.length-1],Te&&ue.type==="text"&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.link(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.reflink(Y,this.tokens.links)){Y=Y.substring(ue.raw.length),Te=X[X.length-1],Te&&ue.type==="text"&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):X.push(ue);continue}if(ue=this.tokenizer.emStrong(Y,Pe,U)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.codespan(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.br(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.del(Y)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(ue=this.tokenizer.autolink(Y,K)){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(Y,K))){Y=Y.substring(ue.raw.length),X.push(ue);continue}if(he=Y,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,ee=Y.slice(1),ne=void 0;le.options.extensions.startInline.forEach(function(Oe){ne=Oe.call({lexer:this},ee),typeof ne=="number"&&ne>=0&&(G=Math.min(G,ne))}),G<1/0&&G>=0&&(he=Y.substring(0,G+1))}(),ue=this.tokenizer.inlineText(he,j)){Y=Y.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(U=ue.raw.slice(-1)),ze=!0,Te=X[X.length-1],Te&&Te.type==="text"?(Te.raw+=ue.raw,Te.text+=ue.text):X.push(ue);continue}if(Y){var H="Infinite loop on byte: "+Y.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return X},S(Ee,null,[{key:"rules",get:function(){return{block:q,inline:A}}}]),Ee}(),ae=function(){function Ee(fe){this.options=fe||ge.defaults}var pe=Ee.prototype;return pe.code=function(Y,X,le){var ue=(X||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Y,ue);Te!=null&&Te!==Y&&(le=!0,Y=Te)}return Y=Y.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+m(ue,!0)+'">'+(le?Y:m(Y,!0))+`</code></pre>
`:"<pre><code>"+(le?Y:m(Y,!0))+`</code></pre>
`},pe.blockquote=function(Y){return`<blockquote>
`+Y+`</blockquote>
`},pe.html=function(Y){return Y},pe.heading=function(Y,X,le,ue){if(this.options.headerIds){var Te=this.options.headerPrefix+ue.slug(le);return"<h"+X+' id="'+Te+'">'+Y+"</h"+X+`>
`}return"<h"+X+">"+Y+"</h"+X+`>
`},pe.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},pe.list=function(Y,X,le){var ue=X?"ol":"ul",Te=X&&le!==1?' start="'+le+'"':"";return"<"+ue+Te+`>
`+Y+"</"+ue+`>
`},pe.listitem=function(Y){return"<li>"+Y+`</li>
`},pe.checkbox=function(Y){return"<input "+(Y?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},pe.paragraph=function(Y){return"<p>"+Y+`</p>
`},pe.table=function(Y,X){return X&&(X="<tbody>"+X+"</tbody>"),`<table>
<thead>
`+Y+`</thead>
`+X+`</table>
`},pe.tablerow=function(Y){return`<tr>
`+Y+`</tr>
`},pe.tablecell=function(Y,X){var le=X.header?"th":"td",ue=X.align?"<"+le+' align="'+X.align+'">':"<"+le+">";return ue+Y+("</"+le+`>
`)},pe.strong=function(Y){return"<strong>"+Y+"</strong>"},pe.em=function(Y){return"<em>"+Y+"</em>"},pe.codespan=function(Y){return"<code>"+Y+"</code>"},pe.br=function(){return this.options.xhtml?"<br/>":"<br>"},pe.del=function(Y){return"<del>"+Y+"</del>"},pe.link=function(Y,X,le){if(Y=h(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var ue='<a href="'+m(Y)+'"';return X&&(ue+=' title="'+X+'"'),ue+=">"+le+"</a>",ue},pe.image=function(Y,X,le){if(Y=h(this.options.sanitize,this.options.baseUrl,Y),Y===null)return le;var ue='<img src="'+Y+'" alt="'+le+'"';return X&&(ue+=' title="'+X+'"'),ue+=this.options.xhtml?"/>":">",ue},pe.text=function(Y){return Y},Ee}(),we=function(){function Ee(){}var pe=Ee.prototype;return pe.strong=function(Y){return Y},pe.em=function(Y){return Y},pe.codespan=function(Y){return Y},pe.del=function(Y){return Y},pe.html=function(Y){return Y},pe.text=function(Y){return Y},pe.link=function(Y,X,le){return""+le},pe.image=function(Y,X,le){return""+le},pe.br=function(){return""},Ee}(),Ie=function(){function Ee(){this.seen={}}var pe=Ee.prototype;return pe.serialize=function(Y){return Y.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},pe.getNextSafeSlug=function(Y,X){var le=Y,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[Y];do ue++,le=Y+"-"+ue;while(this.seen.hasOwnProperty(le))}return X||(this.seen[Y]=ue,this.seen[le]=0),le},pe.slug=function(Y,X){X===void 0&&(X={});var le=this.serialize(Y);return this.getNextSafeSlug(le,X.dryrun)},Ee}(),de=function(){function Ee(fe){this.options=fe||ge.defaults,this.options.renderer=this.options.renderer||new ae,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new we,this.slugger=new Ie}Ee.parse=function(Y,X){var le=new Ee(X);return le.parse(Y)},Ee.parseInline=function(Y,X){var le=new Ee(X);return le.parseInline(Y)};var pe=Ee.prototype;return pe.parse=function(Y,X){X===void 0&&(X=!0);var le="",ue,Te,he,Pe,Ne,ze,U,z,H,G,ee,ne,Oe,Be,Ye,_e,et,tt,it,nt=Y.length;for(ue=0;ue<nt;ue++){if(G=Y[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(it=this.options.extensions.renderers[G.type].call({parser:this},G),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){le+=it||"";continue}switch(G.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(G.tokens),G.depth,o(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(z="",U="",Pe=G.header.length,Te=0;Te<Pe;Te++)U+=this.renderer.tablecell(this.parseInline(G.header[Te].tokens),{header:!0,align:G.align[Te]});for(z+=this.renderer.tablerow(U),H="",Pe=G.rows.length,Te=0;Te<Pe;Te++){for(ze=G.rows[Te],U="",Ne=ze.length,he=0;he<Ne;he++)U+=this.renderer.tablecell(this.parseInline(ze[he].tokens),{header:!1,align:G.align[he]});H+=this.renderer.tablerow(U)}le+=this.renderer.table(z,H);continue}case"blockquote":{H=this.parse(G.tokens),le+=this.renderer.blockquote(H);continue}case"list":{for(ee=G.ordered,ne=G.start,Oe=G.loose,Pe=G.items.length,H="",Te=0;Te<Pe;Te++)Ye=G.items[Te],_e=Ye.checked,et=Ye.task,Be="",Ye.task&&(tt=this.renderer.checkbox(_e),Oe?Ye.tokens.length>0&&Ye.tokens[0].type==="paragraph"?(Ye.tokens[0].text=tt+" "+Ye.tokens[0].text,Ye.tokens[0].tokens&&Ye.tokens[0].tokens.length>0&&Ye.tokens[0].tokens[0].type==="text"&&(Ye.tokens[0].tokens[0].text=tt+" "+Ye.tokens[0].tokens[0].text)):Ye.tokens.unshift({type:"text",text:tt}):Be+=tt),Be+=this.parse(Ye.tokens,Oe),H+=this.renderer.listitem(Be,et,_e);le+=this.renderer.list(H,ee,ne);continue}case"html":{le+=this.renderer.html(G.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(H=G.tokens?this.parseInline(G.tokens):G.text;ue+1<nt&&Y[ue+1].type==="text";)G=Y[++ue],H+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);le+=X?this.renderer.paragraph(H):H;continue}default:{var at='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return le},pe.parseInline=function(Y,X){X=X||this.renderer;var le="",ue,Te,he,Pe=Y.length;for(ue=0;ue<Pe;ue++){if(Te=Y[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(he=this.options.extensions.renderers[Te.type].call({parser:this},Te),he!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){le+=he||"";continue}switch(Te.type){case"escape":{le+=X.text(Te.text);break}case"html":{le+=X.html(Te.text);break}case"link":{le+=X.link(Te.href,Te.title,this.parseInline(Te.tokens,X));break}case"image":{le+=X.image(Te.href,Te.title,Te.text);break}case"strong":{le+=X.strong(this.parseInline(Te.tokens,X));break}case"em":{le+=X.em(this.parseInline(Te.tokens,X));break}case"codespan":{le+=X.codespan(Te.text);break}case"br":{le+=X.br();break}case"del":{le+=X.del(this.parseInline(Te.tokens,X));break}case"text":{le+=X.text(Te.text);break}default:{var Ne='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Ne);return}else throw new Error(Ne)}}}return le},Ee}();function me(Ee,pe,fe){if(typeof Ee>"u"||Ee===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");if(typeof pe=="function"&&(fe=pe,pe=null),pe=u({},me.defaults,pe||{}),b(pe),fe){var Y=pe.highlight,X;try{X=re.lex(Ee,pe)}catch(Pe){return fe(Pe)}var le=function(Ne){var ze;if(!Ne)try{pe.walkTokens&&me.walkTokens(X,pe.walkTokens),ze=de.parse(X,pe)}catch(U){Ne=U}return pe.highlight=Y,Ne?fe(Ne):fe(null,ze)};if(!Y||Y.length<3||(delete pe.highlight,!X.length))return le();var ue=0;me.walkTokens(X,function(Pe){Pe.type==="code"&&(ue++,setTimeout(function(){Y(Pe.text,Pe.lang,function(Ne,ze){if(Ne)return le(Ne);ze!=null&&ze!==Pe.text&&(Pe.text=ze,Pe.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Pe.message+"",!0)+"</pre>";throw Pe}try{var he=re.lex(Ee,pe);if(pe.walkTokens){if(pe.async)return Promise.all(me.walkTokens(he,pe.walkTokens)).then(function(){return de.parse(he,pe)}).catch(Te);me.walkTokens(he,pe.walkTokens)}return de.parse(he,pe)}catch(Pe){Te(Pe)}}me.options=me.setOptions=function(Ee){return u(me.defaults,Ee),p(me.defaults),me},me.getDefaults=M,me.defaults=ge.defaults,me.use=function(){for(var Ee=arguments.length,pe=new Array(Ee),fe=0;fe<Ee;fe++)pe[fe]=arguments[fe];var Y=u.apply(void 0,[{}].concat(pe)),X=me.defaults.extensions||{renderers:{},childTokens:{}},le;pe.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(he){if(!he.name)throw new Error("extension name required");if(he.renderer){var Pe=X.renderers?X.renderers[he.name]:null;Pe?X.renderers[he.name]=function(){for(var Ne=arguments.length,ze=new Array(Ne),U=0;U<Ne;U++)ze[U]=arguments[U];var z=he.renderer.apply(this,ze);return z===!1&&(z=Pe.apply(this,ze)),z}:X.renderers[he.name]=he.renderer}if(he.tokenizer){if(!he.level||he.level!=="block"&&he.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");X[he.level]?X[he.level].unshift(he.tokenizer):X[he.level]=[he.tokenizer],he.start&&(he.level==="block"?X.startBlock?X.startBlock.push(he.start):X.startBlock=[he.start]:he.level==="inline"&&(X.startInline?X.startInline.push(he.start):X.startInline=[he.start]))}he.childTokens&&(X.childTokens[he.name]=he.childTokens)})),ue.renderer&&function(){var he=me.defaults.renderer||new ae,Pe=function(U){var z=he[U];he[U]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var ne=ue.renderer[U].apply(he,G);return ne===!1&&(ne=z.apply(he,G)),ne}};for(var Ne in ue.renderer)Pe(Ne);Y.renderer=he}(),ue.tokenizer&&function(){var he=me.defaults.tokenizer||new V,Pe=function(U){var z=he[U];he[U]=function(){for(var H=arguments.length,G=new Array(H),ee=0;ee<H;ee++)G[ee]=arguments[ee];var ne=ue.tokenizer[U].apply(he,G);return ne===!1&&(ne=z.apply(he,G)),ne}};for(var Ne in ue.tokenizer)Pe(Ne);Y.tokenizer=he}(),ue.walkTokens){var Te=me.defaults.walkTokens;Y.walkTokens=function(he){var Pe=[];return Pe.push(ue.walkTokens.call(this,he)),Te&&(Pe=Pe.concat(Te.call(this,he))),Pe}}le&&(Y.extensions=X),me.setOptions(Y)})},me.walkTokens=function(Ee,pe){for(var fe=[],Y=function(){var Te=le.value;switch(fe=fe.concat(pe.call(me,Te)),Te.type){case"table":{for(var he=O(Te.header),Pe;!(Pe=he()).done;){var Ne=Pe.value;fe=fe.concat(me.walkTokens(Ne.tokens,pe))}for(var ze=O(Te.rows),U;!(U=ze()).done;)for(var z=U.value,H=O(z),G;!(G=H()).done;){var ee=G.value;fe=fe.concat(me.walkTokens(ee.tokens,pe))}break}case"list":{fe=fe.concat(me.walkTokens(Te.items,pe));break}default:me.defaults.extensions&&me.defaults.extensions.childTokens&&me.defaults.extensions.childTokens[Te.type]?me.defaults.extensions.childTokens[Te.type].forEach(function(ne){fe=fe.concat(me.walkTokens(Te[ne],pe))}):Te.tokens&&(fe=fe.concat(me.walkTokens(Te.tokens,pe)))}},X=O(Ee),le;!(le=X()).done;)Y();return fe},me.parseInline=function(Ee,pe){if(typeof Ee>"u"||Ee===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ee!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ee)+", string expected");pe=u({},me.defaults,pe||{}),b(pe);try{var fe=re.lexInline(Ee,pe);return pe.walkTokens&&me.walkTokens(fe,pe.walkTokens),de.parseInline(fe,pe)}catch(Y){if(Y.message+=`
Please report this to https://github.com/markedjs/marked.`,pe.silent)return"<p>An error occurred:</p><pre>"+m(Y.message+"",!0)+"</pre>";throw Y}},me.Parser=de,me.parser=de.parse,me.Renderer=ae,me.TextRenderer=we,me.Lexer=re,me.lexer=re.lex,me.Tokenizer=V,me.Slugger=Ie,me.parse=me;var Me=me.options,ce=me.setOptions,Re=me.use,ie=me.walkTokens,L=me.parseInline,x=me,ve=de.parse,Fe=re.lex;ge.Lexer=re,ge.Parser=de,ge.Renderer=ae,ge.Slugger=Ie,ge.TextRenderer=we,ge.Tokenizer=V,ge.getDefaults=M,ge.lexer=Fe,ge.marked=me,ge.options=Me,ge.parse=x,ge.parseInline=L,ge.parser=ve,ge.setOptions=ce,ge.use=Re,ge.walkTokens=ie,Object.defineProperty(ge,"__esModule",{value:!0})}),define(Ce[125],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uk=S;function S(s){const o=O(s);if(o&&o.length>0)return new Uint32Array(o)}let N=0;const R=new Uint32Array(10);function O(s){if(N=0,M(s,y,4352),N>0||(M(s,l,4449),N>0)||(M(s,w,4520),N>0)||(M(s,m,12593),N))return R.subarray(0,N);if(s>=44032&&s<=55203){const o=s-44032,r=o%588,t=Math.floor(o/588),n=Math.floor(r/28),c=r%28-1;if(t<y.length?M(t,y,0):4352+t-12593<m.length&&M(4352+t,m,12593),n<l.length?M(n,l,0):4449+n-12593<m.length&&M(4449+n-12593,m,12593),c>=0&&(c<w.length?M(c,w,0):4520+c-12593<m.length&&M(4520+c-12593,m,12593)),N>0)return R.subarray(0,N)}}function M(s,o,r){s>=r&&s<r+o.length&&p(o[s-r])}function p(s){s!==0&&(R[N++]=s&255,s>>8&&(R[N++]=s>>8&255),s>>16&&(R[N++]=s>>16&255))}var g;(function(s){s[s.InitialConsonant=4352]="InitialConsonant",s[s.Vowel=4449]="Vowel",s[s.FinalConsonant=4520]="FinalConsonant",s[s.CompatibilityJamo=12593]="CompatibilityJamo"})(g||(g={}));var E;(function(s){s[s.NUL=0]="NUL",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z"})(E||(E={}));var T;(function(s){s[s.fa=24934]="fa",s[s.fg=26470]="fg",s[s.fq=29030]="fq",s[s.fr=29286]="fr",s[s.ft=29798]="ft",s[s.fv=30310]="fv",s[s.fx=30822]="fx",s[s.hk=27496]="hk",s[s.hl=27752]="hl",s[s.ho=28520]="ho",s[s.ml=27757]="ml",s[s.nj=27246]="nj",s[s.nl=27758]="nl",s[s.np=28782]="np",s[s.qt=29809]="qt",s[s.rt=29810]="rt",s[s.sg=26483]="sg",s[s.sw=30579]="sw"})(T||(T={}));const y=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),l=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),m=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Ce[126],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Em=e.$Dm=e.$Cm=void 0,e.$Am=S,e.rot=N;function S(p,g,E){return Math.min(Math.max(p,g),E)}function N(p,g){return(g+p%g)%g}class R{constructor(){this.a=0}getNext(){return this.a++}}e.$Cm=R;class O{constructor(){this.a=1,this.b=0}update(g){return this.b=this.b+(g-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Dm=O;class M{constructor(g){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(g),this.c.fill(0,0,g)}update(g){const E=this.c[this.d];return this.c[this.d]=g,this.d=(this.d+1)%this.c.length,this.e-=E,this.e+=g,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Em=M}),function(){function ge(R){const O=[];typeof R=="number"&&O.push("code/timeOrigin",R);function M(g){O.push(g,Date.now())}function p(){const g=[];for(let E=0;E<O.length;E+=2)g.push({name:O[E],startTime:O[E+1]});return g}return{mark:M,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const M of performance.getEntriesByType("mark"))O.push({name:M.name,startTime:Math.round(R+M.startTime)});return O}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function S(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return S(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=S(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=S(N))}(),define(Ce[127],Ae([1,0,40]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aP=void 0;const N=Symbol("unset");class R{constructor(){this.a=new M,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||S.Iterable.empty()}insert(g,E,T){this.d(g,y=>y._value=E,T)}mutate(g,E){this.d(g,T=>T._value=E(T._value===N?void 0:T._value))}delete(g){const E=this.c(g);if(!E)return;let T=E.length-1;const y=E[T].node._value;if(y!==N){for(this.b--,E[T].node._value=N;T>0;T--){const{node:l,part:w}=E[T];if(l.children?.size||l._value!==N)break;E[T-1].node.children.delete(w)}return y}}*deleteRecursive(g){const E=this.c(g);if(!E)return;const T=E[E.length-1].node;for(let y=E.length-1;y>0;y--){const l=E[y-1];if(l.node.children.delete(E[y].part),l.node.children.size>0||l.node._value!==N)break}for(const y of O(T))y._value!==N&&(this.b--,yield y._value)}find(g){let E=this.a;for(const T of g){const y=E.children?.get(T);if(!y)return;E=y}return E._value===N?void 0:E._value}hasKeyOrParent(g){let E=this.a;for(const T of g){const y=E.children?.get(T);if(!y)return!1;if(y._value!==N)return!0;E=y}return!1}hasKeyOrChildren(g){let E=this.a;for(const T of g){const y=E.children?.get(T);if(!y)return!1;E=y}return!0}hasKey(g){let E=this.a;for(const T of g){const y=E.children?.get(T);if(!y)return!1;E=y}return E._value!==N}c(g){const E=[{part:"",node:this.a}];let T=0;for(const y of g){const l=E[T].node.children?.get(y);if(!l)return;E.push({part:y,node:l}),T++}return E}d(g,E,T){let y=this.a;for(const m of g){if(y.children)if(y.children.has(m))y=y.children.get(m);else{const s=new M;y.children.set(m,s),y=s}else{const s=new M;y.children=new Map([[m,s]]),y=s}T?.(y)}const l=y._value===N?0:1;E(y);const w=y._value===N?0:1;this.b+=w-l}*values(){for(const{_value:g}of O(this.a))g!==N&&(yield g)}}e.$aP=R;function*O(p){const g=[p];for(;g.length>0;){const E=g.pop();if(yield E,E.children)for(const T of E.children.values())g.push(T)}}class M{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(g){this._value=g===void 0?N:g}}}),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var S=e();for(var N in S)(typeof exports=="object"?exports:ge)[N]=S[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function S(N){if(e[N])return e[N].exports;var R=e[N]={i:N,l:!1,exports:{}};return ge[N].call(R.exports,R,R.exports,S),R.l=!0,R.exports}return S.m=ge,S.c=e,S.d=function(N,R,O){S.o(N,R)||Object.defineProperty(N,R,{enumerable:!0,get:O})},S.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},S.t=function(N,R){if(1&R&&(N=S(N)),8&R||4&R&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(S.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&R&&typeof N!="string")for(var M in N)S.d(O,M,function(p){return N[p]}.bind(null,M));return O},S.n=function(N){var R=N&&N.__esModule?function(){return N.default}:function(){return N};return S.d(R,"a",R),R},S.o=function(N,R){return Object.prototype.hasOwnProperty.call(N,R)},S.p="",S(S.s=0)}([function(ge,e,S){(function(N){var R;e=ge.exports=Re,R=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,M=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],g=e.src=[],E=0,T=E++;g[T]="0|[1-9]\\d*";var y=E++;g[y]="[0-9]+";var l=E++;g[l]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=E++;g[w]="("+g[T]+")\\.("+g[T]+")\\.("+g[T]+")";var m=E++;g[m]="("+g[y]+")\\.("+g[y]+")\\.("+g[y]+")";var s=E++;g[s]="(?:"+g[T]+"|"+g[l]+")";var o=E++;g[o]="(?:"+g[y]+"|"+g[l]+")";var r=E++;g[r]="(?:-("+g[s]+"(?:\\."+g[s]+")*))";var t=E++;g[t]="(?:-?("+g[o]+"(?:\\."+g[o]+")*))";var n=E++;g[n]="[0-9A-Za-z-]+";var c=E++;g[c]="(?:\\+("+g[n]+"(?:\\."+g[n]+")*))";var h=E++,i="v?"+g[w]+g[r]+"?"+g[c]+"?";g[h]="^"+i+"$";var $="[v=\\s]*"+g[m]+g[t]+"?"+g[c]+"?",a=E++;g[a]="^"+$+"$";var v=E++;g[v]="((?:<|>)?=?)";var d=E++;g[d]=g[y]+"|x|X|\\*";var C=E++;g[C]=g[T]+"|x|X|\\*";var u=E++;g[u]="[v=\\s]*("+g[C]+")(?:\\.("+g[C]+")(?:\\.("+g[C]+")(?:"+g[r]+")?"+g[c]+"?)?)?";var D=E++;g[D]="[v=\\s]*("+g[d]+")(?:\\.("+g[d]+")(?:\\.("+g[d]+")(?:"+g[t]+")?"+g[c]+"?)?)?";var f=E++;g[f]="^"+g[v]+"\\s*"+g[u]+"$";var k=E++;g[k]="^"+g[v]+"\\s*"+g[D]+"$";var b=E++;g[b]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var P=E++;g[P]="(?:~>?)";var I=E++;g[I]="(\\s*)"+g[P]+"\\s+",p[I]=new RegExp(g[I],"g");var W=E++;g[W]="^"+g[P]+g[u]+"$";var V=E++;g[V]="^"+g[P]+g[D]+"$";var q=E++;g[q]="(?:\\^)";var A=E++;g[A]="(\\s*)"+g[q]+"\\s+",p[A]=new RegExp(g[A],"g");var j=E++;g[j]="^"+g[q]+g[u]+"$";var K=E++;g[K]="^"+g[q]+g[D]+"$";var re=E++;g[re]="^"+g[v]+"\\s*("+$+")$|^$";var ae=E++;g[ae]="^"+g[v]+"\\s*("+i+")$|^$";var we=E++;g[we]="(\\s*)"+g[v]+"\\s*("+$+"|"+g[u]+")",p[we]=new RegExp(g[we],"g");var Ie=E++;g[Ie]="^\\s*("+g[u]+")\\s+-\\s+("+g[u]+")\\s*$";var de=E++;g[de]="^\\s*("+g[D]+")\\s+-\\s+("+g[D]+")\\s*$";var me=E++;g[me]="(<|>)?=?\\s*\\*";for(var Me=0;Me<35;Me++)R(Me,g[Me]),p[Me]||(p[Me]=new RegExp(g[Me]));function ce(z,H){if(z instanceof Re)return z;if(typeof z!="string"||z.length>O||!(H?p[a]:p[h]).test(z))return null;try{return new Re(z,H)}catch{return null}}function Re(z,H){if(z instanceof Re){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof Re))return new Re(z,H);R("SemVer",z,H),this.loose=H;var G=z.trim().match(H?p[a]:p[h]);if(!G)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>M||this.major<0)throw new TypeError("Invalid major version");if(this.minor>M||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>M||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(ee){if(/^[0-9]+$/.test(ee)){var ne=+ee;if(ne>=0&&ne<M)return ne}return ee}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=ce,e.valid=function(z,H){var G=ce(z,H);return G?G.version:null},e.clean=function(z,H){var G=ce(z.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=Re,Re.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Re.prototype.toString=function(){return this.version},Re.prototype.compare=function(z){return R("SemVer.compare",this.version,this.loose,z),z instanceof Re||(z=new Re(z,this.loose)),this.compareMain(z)||this.comparePre(z)},Re.prototype.compareMain=function(z){return z instanceof Re||(z=new Re(z,this.loose)),L(this.major,z.major)||L(this.minor,z.minor)||L(this.patch,z.patch)},Re.prototype.comparePre=function(z){if(z instanceof Re||(z=new Re(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],ee=z.prerelease[H];if(R("prerelease compare",H,G,ee),G===void 0&&ee===void 0)return 0;if(ee===void 0)return 1;if(G===void 0)return-1;if(G!==ee)return L(G,ee)}while(++H)},Re.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},e.inc=function(z,H,G,ee){typeof G=="string"&&(ee=G,G=void 0);try{return new Re(z,G).inc(H,ee).version}catch{return null}},e.diff=function(z,H){if(Ee(z,H))return null;var G=ce(z),ee=ce(H);if(G.prerelease.length||ee.prerelease.length){for(var ne in G)if((ne==="major"||ne==="minor"||ne==="patch")&&G[ne]!==ee[ne])return"pre"+ne;return"prerelease"}for(var ne in G)if((ne==="major"||ne==="minor"||ne==="patch")&&G[ne]!==ee[ne])return ne},e.compareIdentifiers=L;var ie=/^[0-9]+$/;function L(z,H){var G=ie.test(z),ee=ie.test(H);return G&&ee&&(z=+z,H=+H),G&&!ee?-1:ee&&!G?1:z<H?-1:z>H?1:0}function x(z,H,G){return new Re(z,G).compare(new Re(H,G))}function ve(z,H,G){return x(z,H,G)>0}function Fe(z,H,G){return x(z,H,G)<0}function Ee(z,H,G){return x(z,H,G)===0}function pe(z,H,G){return x(z,H,G)!==0}function fe(z,H,G){return x(z,H,G)>=0}function Y(z,H,G){return x(z,H,G)<=0}function X(z,H,G,ee){var ne;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),ne=z===G;break;case"!==":typeof z=="object"&&(z=z.version),typeof G=="object"&&(G=G.version),ne=z!==G;break;case"":case"=":case"==":ne=Ee(z,G,ee);break;case"!=":ne=pe(z,G,ee);break;case">":ne=ve(z,G,ee);break;case">=":ne=fe(z,G,ee);break;case"<":ne=Fe(z,G,ee);break;case"<=":ne=Y(z,G,ee);break;default:throw new TypeError("Invalid operator: "+H)}return ne}function le(z,H){if(z instanceof le){if(z.loose===H)return z;z=z.value}if(!(this instanceof le))return new le(z,H);R("comparator",z,H),this.loose=H,this.parse(z),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(z,H){return L(H,z)},e.major=function(z,H){return new Re(z,H).major},e.minor=function(z,H){return new Re(z,H).minor},e.patch=function(z,H){return new Re(z,H).patch},e.compare=x,e.compareLoose=function(z,H){return x(z,H,!0)},e.rcompare=function(z,H,G){return x(H,z,G)},e.sort=function(z,H){return z.sort(function(G,ee){return e.compare(G,ee,H)})},e.rsort=function(z,H){return z.sort(function(G,ee){return e.rcompare(G,ee,H)})},e.gt=ve,e.lt=Fe,e.eq=Ee,e.neq=pe,e.gte=fe,e.lte=Y,e.cmp=X,e.Comparator=le;var ue={};function Te(z,H){if(z instanceof Te)return z.loose===H?z:new Te(z.raw,H);if(z instanceof le)return new Te(z.value,H);if(!(this instanceof Te))return new Te(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function he(z){return!z||z.toLowerCase()==="x"||z==="*"}function Pe(z,H,G,ee,ne,Oe,Be,Ye,_e,et,tt,it,nt){return((H=he(G)?"":he(ee)?">="+G+".0.0":he(ne)?">="+G+"."+ee+".0":">="+H)+" "+(Ye=he(_e)?"":he(et)?"<"+(+_e+1)+".0.0":he(tt)?"<"+_e+"."+(+et+1)+".0":it?"<="+_e+"."+et+"."+tt+"-"+it:"<="+Ye)).trim()}function Ne(z,H){for(var G=0;G<z.length;G++)if(!z[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<z.length;G++)if(R(z[G].semver),z[G].semver!==ue&&z[G].semver.prerelease.length>0){var ee=z[G].semver;if(ee.major===H.major&&ee.minor===H.minor&&ee.patch===H.patch)return!0}return!1}return!0}function ze(z,H,G){try{H=new Te(H,G)}catch{return!1}return H.test(z)}function U(z,H,G,ee){var ne,Oe,Be,Ye,_e;switch(z=new Re(z,ee),H=new Te(H,ee),G){case">":ne=ve,Oe=Y,Be=Fe,Ye=">",_e=">=";break;case"<":ne=Fe,Oe=fe,Be=ve,Ye="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ze(z,H,ee))return!1;for(var et=0;et<H.set.length;++et){var tt=H.set[et],it=null,nt=null;if(tt.forEach(function(at){at.semver===ue&&(at=new le(">=0.0.0")),it=it||at,nt=nt||at,ne(at.semver,it.semver,ee)?it=at:Be(at.semver,nt.semver,ee)&&(nt=at)}),it.operator===Ye||it.operator===_e||(!nt.operator||nt.operator===Ye)&&Oe(z,nt.semver)||nt.operator===_e&&Be(z,nt.semver))return!1}return!0}le.prototype.parse=function(z){var H=this.loose?p[re]:p[ae],G=z.match(H);if(!G)throw new TypeError("Invalid comparator: "+z);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Re(G[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(z){return R("Comparator.test",z,this.loose),this.semver===ue||(typeof z=="string"&&(z=new Re(z,this.loose)),X(z,this.operator,this.semver,this.loose))},le.prototype.intersects=function(z,H){if(!(z instanceof le))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Te(z.value,H),ze(this.value,G,H);if(z.operator==="")return G=new Te(this.value,H),ze(z.semver,G,H);var ee=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ne=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Oe=this.semver.version===z.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Ye=X(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),_e=X(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ee||ne||Oe&&Be||Ye||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),R("range",z,H);var G=H?p[de]:p[Ie];z=z.replace(G,Pe),R("hyphen replace",z),z=z.replace(p[we],"$1$2$3"),R("comparator trim",z,p[we]),z=(z=(z=z.replace(p[I],"$1~")).replace(p[A],"$1^")).split(/\s+/).join(" ");var ee=H?p[re]:p[ae],ne=z.split(" ").map(function(Oe){return function(Be,Ye){return R("comp",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){R("caret",it,nt);var at=nt?p[K]:p[j];return it.replace(at,function(mt,je,st,Z,Q){var $e;return R("caret",it,mt,je,st,Z,Q),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Z)?$e=je==="0"?">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":">="+je+"."+st+".0 <"+(+je+1)+".0.0":Q?(R("replaceCaret pr",Q),Q.charAt(0)!=="-"&&(Q="-"+Q),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Z+Q+" <"+je+"."+st+"."+(+Z+1):">="+je+"."+st+"."+Z+Q+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Z+Q+" <"+(+je+1)+".0.0"):(R("no pr"),$e=je==="0"?st==="0"?">="+je+"."+st+"."+Z+" <"+je+"."+st+"."+(+Z+1):">="+je+"."+st+"."+Z+" <"+je+"."+(+st+1)+".0":">="+je+"."+st+"."+Z+" <"+(+je+1)+".0.0"),R("caret return",$e),$e})}(tt,et)}).join(" ")}(Be,Ye),R("caret",Be),Be=function(_e,et){return _e.trim().split(/\s+/).map(function(tt){return function(it,nt){var at=nt?p[V]:p[W];return it.replace(at,function(mt,je,st,Z,Q){var $e;return R("tilde",it,mt,je,st,Z,Q),he(je)?$e="":he(st)?$e=">="+je+".0.0 <"+(+je+1)+".0.0":he(Z)?$e=">="+je+"."+st+".0 <"+je+"."+(+st+1)+".0":Q?(R("replaceTilde pr",Q),Q.charAt(0)!=="-"&&(Q="-"+Q),$e=">="+je+"."+st+"."+Z+Q+" <"+je+"."+(+st+1)+".0"):$e=">="+je+"."+st+"."+Z+" <"+je+"."+(+st+1)+".0",R("tilde return",$e),$e})}(tt,et)}).join(" ")}(Be,Ye),R("tildes",Be),Be=function(_e,et){return R("replaceXRanges",_e,et),_e.split(/\s+/).map(function(tt){return function(it,nt){it=it.trim();var at=nt?p[k]:p[f];return it.replace(at,function(mt,je,st,Z,Q,$e){R("xRange",it,mt,je,st,Z,Q,$e);var Ge=he(st),ye=Ge||he(Z),ot=ye||he(Q);return je==="="&&ot&&(je=""),Ge?mt=je===">"||je==="<"?"<0.0.0":"*":je&&ot?(ye&&(Z=0),ot&&(Q=0),je===">"?(je=">=",ye?(st=+st+1,Z=0,Q=0):ot&&(Z=+Z+1,Q=0)):je==="<="&&(je="<",ye?st=+st+1:Z=+Z+1),mt=je+st+"."+Z+"."+Q):ye?mt=">="+st+".0.0 <"+(+st+1)+".0.0":ot&&(mt=">="+st+"."+Z+".0 <"+st+"."+(+Z+1)+".0"),R("xRange return",mt),mt})}(tt,et)}).join(" ")}(Be,Ye),R("xrange",Be),Be=function(_e,et){return R("replaceStars",_e,et),_e.trim().replace(p[me],"")}(Be,Ye),R("stars",Be),Be}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(ne=ne.filter(function(Oe){return!!Oe.match(ee)})),ne=ne.map(function(Oe){return new le(Oe,H)})},Te.prototype.intersects=function(z,H){if(!(z instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(ee){return z.set.some(function(ne){return ne.every(function(Oe){return ee.intersects(Oe,H)})})})})},e.toComparators=function(z,H){return new Te(z,H).set.map(function(G){return G.map(function(ee){return ee.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new Re(z,this.loose));for(var H=0;H<this.set.length;H++)if(Ne(this.set[H],z))return!0;return!1},e.satisfies=ze,e.maxSatisfying=function(z,H,G){var ee=null,ne=null;try{var Oe=new Te(H,G)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==-1||(ne=new Re(ee=Be,G)))}),ee},e.minSatisfying=function(z,H,G){var ee=null,ne=null;try{var Oe=new Te(H,G)}catch{return null}return z.forEach(function(Be){Oe.test(Be)&&(ee&&ne.compare(Be)!==1||(ne=new Re(ee=Be,G)))}),ee},e.validRange=function(z,H){try{return new Te(z,H).range||"*"}catch{return null}},e.ltr=function(z,H,G){return U(z,H,"<",G)},e.gtr=function(z,H,G){return U(z,H,">",G)},e.outside=U,e.prerelease=function(z,H){var G=ce(z,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(z,H,G){return z=new Te(z,G),H=new Te(H,G),z.intersects(H)},e.coerce=function(z){if(z instanceof Re)return z;if(typeof z!="string")return null;var H=z.match(p[b]);return H==null?null:ce((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,S(1))},function(ge,e){var S,N,R=ge.exports={};function O(){throw new Error("setTimeout has not been defined")}function M(){throw new Error("clearTimeout has not been defined")}function p(o){if(S===setTimeout)return setTimeout(o,0);if((S===O||!S)&&setTimeout)return S=setTimeout,setTimeout(o,0);try{return S(o,0)}catch{try{return S.call(null,o,0)}catch{return S.call(this,o,0)}}}(function(){try{S=typeof setTimeout=="function"?setTimeout:O}catch{S=O}try{N=typeof clearTimeout=="function"?clearTimeout:M}catch{N=M}})();var g,E=[],T=!1,y=-1;function l(){T&&g&&(T=!1,g.length?E=g.concat(E):y=-1,E.length&&w())}function w(){if(!T){var o=p(l);T=!0;for(var r=E.length;r;){for(g=E,E=[];++y<r;)g&&g[y].run();y=-1,r=E.length}g=null,T=!1,function(t){if(N===clearTimeout)return clearTimeout(t);if((N===M||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(t);try{N(t)}catch{try{return N.call(null,t)}catch{return N.call(this,t)}}}(o)}}function m(o,r){this.fun=o,this.array=r}function s(){}R.nextTick=function(o){var r=new Array(arguments.length-1);if(arguments.length>1)for(var t=1;t<arguments.length;t++)r[t-1]=arguments[t];E.push(new m(o,r)),E.length!==1||T||p(w)},m.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=s,R.addListener=s,R.once=s,R.off=s,R.removeListener=s,R.removeAllListeners=s,R.emit=s,R.prependListener=s,R.prependOnceListener=s,R.listeners=function(o){return[]},R.binding=function(o){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function(o){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(Ce[128],Ae([1,0,14,6]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qe=R,e.$re=O,e.$se=M,e.$te=p,e.$ue=E,e.$ve=T,e.$we=y,e.$xe=l,e.$ye=w,e.$ze=m,e.$Ae=s,e.$Be=o,e.$Ce=r,e.$De=t,e.$Ee=n;function R(c){const h=c;return h?typeof h.read=="function":!1}function O(c){const h=c;return h?[h.on,h.pause,h.resume,h.destroy].every(i=>typeof i=="function"):!1}function M(c){const h=c;return h?O(h.stream)&&Array.isArray(h.buffer)&&typeof h.ended=="boolean":!1}function p(c,h){return new g(c,h)}class g{constructor(h,i){this.e=h,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(h){if(!this.a.destroyed){if(this.a.flowing)this.g(h);else if(this.b.data.push(h),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(h){this.a.destroyed||(this.a.flowing?this.h(h):this.b.error.push(h))}end(h){this.a.destroyed||(typeof h<"u"&&this.write(h),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(h){this.c.data.slice(0).forEach(i=>i(h))}h(h){this.c.error.length===0?(0,S.$1)(h):this.c.error.slice(0).forEach(i=>i(h))}i(){this.c.end.slice(0).forEach(h=>h())}on(h,i){if(!this.a.destroyed)switch(h){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(h,i){if(this.a.destroyed)return;let $;switch(h){case"data":$=this.c.data;break;case"end":$=this.c.end;break;case"error":$=this.c.error;break}if($){const a=$.indexOf(i);a>=0&&$.splice(a,1)}}j(){if(this.b.data.length>0){const h=this.e(this.b.data);this.g(h),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach($=>$())}}k(){if(this.c.error.length>0){for(const h of this.b.error)this.h(h);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function E(c,h){const i=[];let $;for(;($=c.read())!==null;)i.push($);return h(i)}function T(c,h,i){const $=[];let a;for(;(a=c.read())!==null&&$.length<i;)$.push(a);return a===null&&$.length>0?h($):{read:()=>{if($.length>0)return $.shift();if(typeof a<"u"){const v=a;return a=void 0,v}return c.read()}}}function y(c,h){return new Promise((i,$)=>{const a=[];l(c,{onData:v=>{h&&a.push(v)},onError:v=>{h?$(v):i(void 0)},onEnd:()=>{i(h?h(a):void 0)}})})}function l(c,h,i){c.on("error",$=>{i?.isCancellationRequested||h.onError($)}),c.on("end",()=>{i?.isCancellationRequested||h.onEnd()}),c.on("data",$=>{i?.isCancellationRequested||h.onData($)})}function w(c,h){return new Promise((i,$)=>{const a=new N.$Uc,v=[],d=D=>{if(v.push(D),v.length>h)return a.dispose(),c.pause(),i({stream:c,buffer:v,ended:!1})},C=D=>(a.dispose(),$(D)),u=()=>(a.dispose(),i({stream:c,buffer:v,ended:!0}));a.add((0,N.$Tc)(()=>c.removeListener("error",C))),c.on("error",C),a.add((0,N.$Tc)(()=>c.removeListener("end",u))),c.on("end",u),a.add((0,N.$Tc)(()=>c.removeListener("data",d))),c.on("data",d)})}function m(c,h){const i=p(h);return i.end(c),i}function s(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function o(c){let h=!1;return{read:()=>h?null:(h=!0,c)}}function r(c,h,i){const $=p(i);return l(c,{onData:a=>$.write(h.data(a)),onError:a=>$.error(h.error?h.error(a):a),onEnd:()=>$.end()}),$}function t(c,h,i){let $=!1;return{read:()=>{const a=h.read();return $?a:($=!0,a!==null?i([c,a]):c)}}}function n(c,h,i){let $=!1;const a=p(i);return l(h,{onData:v=>$?a.write(v):($=!0,a.write(i([c,v]))),onError:v=>a.error(v),onEnd:()=>{$||($=!0,a.write(c)),a.end()}}),a}}),define(Ce[22],Ae([1,0,41,128]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fe=void 0,e.$Ge=E,e.$He=T,e.$Ie=y,e.$Je=l,e.$Ke=w,e.$Le=m,e.$Me=s,e.$Ne=o,e.$Oe=r,e.$Pe=t,e.$Qe=n,e.$Re=c,e.$Se=h,e.$Te=i,e.$Ue=$,e.$Ve=a,e.$We=v,e.$Xe=d,e.$Ye=C,e.$Ze=f;const R=typeof Buffer<"u",O=new S.$V(()=>new Uint8Array(256));let M,p;class g{static alloc(b){return R?new g(Buffer.allocUnsafe(b)):new g(new Uint8Array(b))}static wrap(b){return R&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new g(b)}static fromString(b,P){return!(P?.dontUseNodeBuffer||!1)&&R?new g(Buffer.from(b)):(M||(M=new TextEncoder),new g(M.encode(b)))}static fromByteArray(b){const P=g.alloc(b.length);for(let I=0,W=b.length;I<W;I++)P.buffer[I]=b[I];return P}static concat(b,P){if(typeof P>"u"){P=0;for(let V=0,q=b.length;V<q;V++)P+=b[V].byteLength}const I=g.alloc(P);let W=0;for(let V=0,q=b.length;V<q;V++){const A=b[V];I.set(A,W),W+=A.byteLength}return I}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=g.alloc(this.byteLength);return b.set(this),b}toString(){return R?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(b,P){return new g(this.buffer.subarray(b,P))}set(b,P){if(b instanceof g)this.buffer.set(b.buffer,P);else if(b instanceof Uint8Array)this.buffer.set(b,P);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),P);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),P);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return l(this.buffer,b)}writeUInt32BE(b,P){w(this.buffer,b,P)}readUInt32LE(b){return m(this.buffer,b)}writeUInt32LE(b,P){s(this.buffer,b,P)}readUInt8(b){return o(this.buffer,b)}writeUInt8(b,P){r(this.buffer,b,P)}indexOf(b,P=0){return E(this.buffer,b instanceof g?b.buffer:b,P)}}e.$Fe=g;function E(k,b,P=0){const I=b.byteLength,W=k.byteLength;if(I===0)return 0;if(I===1)return k.indexOf(b[0]);if(I>W-P)return-1;const V=O.value;V.fill(b.length);for(let K=0;K<b.length;K++)V[b[K]]=b.length-K-1;let q=P+b.length-1,A=q,j=-1;for(;q<W;)if(k[q]===b[A]){if(A===0){j=q;break}q--,A--}else q+=Math.max(b.length-A,V[k[q]]),A=b.length-1;return j}function T(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0}function y(k,b,P){k[P+0]=b&255,b=b>>>8,k[P+1]=b&255}function l(k,b){return k[b]*2**24+k[b+1]*2**16+k[b+2]*2**8+k[b+3]}function w(k,b,P){k[P+3]=b,b=b>>>8,k[P+2]=b,b=b>>>8,k[P+1]=b,b=b>>>8,k[P]=b}function m(k,b){return k[b+0]<<0>>>0|k[b+1]<<8>>>0|k[b+2]<<16>>>0|k[b+3]<<24>>>0}function s(k,b,P){k[P+0]=b&255,b=b>>>8,k[P+1]=b&255,b=b>>>8,k[P+2]=b&255,b=b>>>8,k[P+3]=b&255}function o(k,b){return k[b]}function r(k,b,P){k[P]=b}function t(k){return N.$ue(k,b=>g.concat(b))}function n(k){return N.$Be(k)}function c(k){return N.$we(k,b=>g.concat(b))}async function h(k){return k.ended?g.concat(k.buffer):g.concat([...k.buffer,await c(k.stream)])}function i(k){return N.$ze(k,b=>g.concat(b))}function $(k){return N.$Ce(k,{data:b=>typeof b=="string"?g.fromString(b):g.wrap(b)},b=>g.concat(b))}function a(k){return N.$te(b=>g.concat(b),k)}function v(k,b){return N.$De(k,b,P=>g.concat(P))}function d(k,b){return N.$Ee(k,b,P=>g.concat(P))}function C(k){let b=0,P=0,I=0;const W=new Uint8Array(Math.floor(k.length/4*3)),V=A=>{switch(P){case 3:W[I++]=b|A,P=0;break;case 2:W[I++]=b|A>>>2,b=A<<6,P=3;break;case 1:W[I++]=b|A>>>4,b=A<<4,P=2;break;default:b=A<<2,P=1}};for(let A=0;A<k.length;A++){const j=k.charCodeAt(A);if(j>=65&&j<=90)V(j-65);else if(j>=97&&j<=122)V(j-97+26);else if(j>=48&&j<=57)V(j-48+52);else if(j===43||j===45)V(62);else if(j===47||j===95)V(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${k[A]}`)}}const q=I;for(;P>0;)V(0);return g.wrap(W).slice(0,q)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function f({buffer:k},b=!0,P=!1){const I=P?D:u;let W="";const V=k.byteLength%3;let q=0;for(;q<k.byteLength-V;q+=3){const A=k[q+0],j=k[q+1],K=k[q+2];W+=I[A>>>2],W+=I[(A<<4|j>>>4)&63],W+=I[(j<<2|K>>>6)&63],W+=I[K&63]}if(V===1){const A=k[q+0];W+=I[A>>>2],W+=I[A<<4&63],b&&(W+="==")}else if(V===2){const A=k[q+0],j=k[q+1];W+=I[A>>>2],W+=I[(A<<4|j>>>4)&63],W+=I[j<<2&63],b&&(W+="=")}return W}}),define(Ce[129],Ae([1,0,28,125,15]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ik=e.FuzzyScore=e.$xk=e.$wk=void 0,e.or=O,e.$yk=p,e.$zk=g,e.$Ak=y,e.$Bk=C,e.$Ck=u,e.$Dk=I,e.$Ek=W,e.$Fk=V,e.$Gk=q,e.$Hk=x,e.$Jk=pe,e.$Kk=X,e.$Lk=le;function O(...he){return function(Pe,Ne){for(let ze=0,U=he.length;ze<U;ze++){const z=he[ze](Pe,Ne);if(z)return z}return null}}e.$wk=M.bind(void 0,!1),e.$xk=M.bind(void 0,!0);function M(he,Pe,Ne){if(!Ne||Ne.length<Pe.length)return null;let ze;return he?ze=R.$yf(Ne,Pe):ze=Ne.indexOf(Pe)===0,ze?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(he,Pe){const Ne=Pe.toLowerCase().indexOf(he.toLowerCase());return Ne===-1?null:[{start:Ne,end:Ne+he.length}]}function g(he,Pe){return E(he.toLowerCase(),Pe.toLowerCase(),0,0)}function E(he,Pe,Ne,ze){if(Ne===he.length)return[];if(ze===Pe.length)return null;if(he[Ne]===Pe[ze]){let U=null;return(U=E(he,Pe,Ne+1,ze+1))?c({start:ze,end:ze+1},U):null}return E(he,Pe,Ne,ze+1)}function T(he){return 97<=he&&he<=122}function y(he){return 65<=he&&he<=90}function l(he){return 48<=he&&he<=57}function w(he){return he===32||he===9||he===10||he===13}const m=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(he=>m.add(he.charCodeAt(0)));function s(he){return w(he)||m.has(he)}function o(he,Pe){return he===Pe||s(he)&&s(Pe)}const r=new Map;function t(he){if(r.has(he))return r.get(he);let Pe;const Ne=(0,N.$uk)(he);return Ne&&(Pe=Ne),r.set(he,Pe),Pe}function n(he){return T(he)||y(he)||l(he)}function c(he,Pe){return Pe.length===0?Pe=[he]:he.end===Pe[0].start?Pe[0].start=he.start:Pe.unshift(he),Pe}function h(he,Pe){for(let Ne=Pe;Ne<he.length;Ne++){const ze=he.charCodeAt(Ne);if(y(ze)||l(ze)||Ne>0&&!n(he.charCodeAt(Ne-1)))return Ne}return he.length}function i(he,Pe,Ne,ze){if(Ne===he.length)return[];if(ze===Pe.length)return null;if(he[Ne]!==Pe[ze].toLowerCase())return null;{let U=null,z=ze+1;for(U=i(he,Pe,Ne+1,ze+1);!U&&(z=h(Pe,z))<Pe.length;)U=i(he,Pe,Ne+1,z),z++;return U===null?null:c({start:ze,end:ze+1},U)}}function $(he){let Pe=0,Ne=0,ze=0,U=0,z=0;for(let Oe=0;Oe<he.length;Oe++)z=he.charCodeAt(Oe),y(z)&&Pe++,T(z)&&Ne++,n(z)&&ze++,l(z)&&U++;const H=Pe/he.length,G=Ne/he.length,ee=ze/he.length,ne=U/he.length;return{upperPercent:H,lowerPercent:G,alphaPercent:ee,numericPercent:ne}}function a(he){const{upperPercent:Pe,lowerPercent:Ne}=he;return Ne===0&&Pe>.6}function v(he){const{upperPercent:Pe,lowerPercent:Ne,alphaPercent:ze,numericPercent:U}=he;return Ne>.2&&Pe<.8&&ze>.6&&U<.2}function d(he){let Pe=0,Ne=0,ze=0,U=0;for(let z=0;z<he.length;z++)ze=he.charCodeAt(z),y(ze)&&Pe++,T(ze)&&Ne++,w(ze)&&U++;return(Pe===0||Ne===0)&&U===0?he.length<=30:Pe<=5}function C(he,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!d(he))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Ne=$(Pe);if(!v(Ne)){if(!a(Ne))return null;Pe=Pe.toLowerCase()}let ze=null,U=0;for(he=he.toLowerCase();U<Pe.length&&(ze=i(he,Pe,0,U))===null;)U=h(Pe,U+1);return ze}function u(he,Pe,Ne=!1){if(!Pe||Pe.length===0)return null;let ze=null,U=0;for(he=he.toLowerCase(),Pe=Pe.toLowerCase();U<Pe.length&&(ze=D(he,Pe,0,U,Ne),ze===null);)U=f(Pe,U+1);return ze}function D(he,Pe,Ne,ze,U){let z=0;if(Ne===he.length)return[];if(ze===Pe.length)return null;if(!o(he.charCodeAt(Ne),Pe.charCodeAt(ze))){const ee=t(he.charCodeAt(Ne));if(!ee)return null;for(let ne=0;ne<ee.length;ne++)if(!o(ee[ne],Pe.charCodeAt(ze+ne)))return null;z+=ee.length-1}let H=null,G=ze+z+1;if(H=D(he,Pe,Ne+1,G,U),!U)for(;!H&&(G=f(Pe,G))<Pe.length;)H=D(he,Pe,Ne+1,G,U),G++;if(!H)return null;if(he.charCodeAt(Ne)!==Pe.charCodeAt(ze)){const ee=t(he.charCodeAt(Ne));if(!ee)return H;for(let ne=0;ne<ee.length;ne++)if(ee[ne]!==Pe.charCodeAt(ze+ne))return H}return c({start:ze,end:ze+z+1},H)}function f(he,Pe){for(let Ne=Pe;Ne<he.length;Ne++)if(s(he.charCodeAt(Ne))||Ne>0&&s(he.charCodeAt(Ne-1)))return Ne;return he.length}const k=O(e.$xk,C,p),b=O(e.$xk,C,g),P=new S.$Ec(1e4);function I(he,Pe,Ne=!1){if(typeof he!="string"||typeof Pe!="string")return null;let ze=P.get(he);ze||(ze=new RegExp(R.$gf(he),"i"),P.set(he,ze));const U=ze.exec(Pe);return U?[{start:U.index,end:U.index+U[0].length}]:Ne?b(he,Pe):k(he,Pe)}function W(he,Pe){const Ne=pe(he,he.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Ne?q(Ne):null}function V(he,Pe,Ne,ze,U,z){const H=Math.min(13,he.length);for(;Ne<H;Ne++){const G=pe(he,Pe,Ne,ze,U,z,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,z]}function q(he){if(typeof he>"u")return[];const Pe=[],Ne=he[1];for(let ze=he.length-1;ze>1;ze--){const U=he[ze]+Ne,z=Pe[Pe.length-1];z&&z.end===U?z.end=U+1:Pe.push({start:U,end:U+1})}return Pe}const A=128;function j(){const he=[],Pe=[];for(let Ne=0;Ne<=A;Ne++)Pe[Ne]=0;for(let Ne=0;Ne<=A;Ne++)he.push(Pe.slice(0));return he}function K(he){const Pe=[];for(let Ne=0;Ne<=he;Ne++)Pe[Ne]=0;return Pe}const re=K(2*A),ae=K(2*A),we=j(),Ie=j(),de=j(),me=!1;function Me(he,Pe,Ne,ze,U){function z(G,ee,ne=" "){for(;G.length<ee;)G=ne+G;return G}let H=` |   |${ze.split("").map(G=>z(G,3)).join("|")}
`;for(let G=0;G<=Ne;G++)G===0?H+=" |":H+=`${Pe[G-1]}|`,H+=he[G].slice(0,U+1).map(ee=>z(ee.toString(),3)).join("|")+`
`;return H}function ce(he,Pe,Ne,ze){he=he.substr(Pe),Ne=Ne.substr(ze),console.log(Me(Ie,he,he.length,Ne,Ne.length)),console.log(Me(de,he,he.length,Ne,Ne.length)),console.log(Me(we,he,he.length,Ne,Ne.length))}function Re(he,Pe){if(Pe<0||Pe>=he.length)return!1;const Ne=he.codePointAt(Pe);switch(Ne){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.$Qf(Ne)}}function ie(he,Pe){if(Pe<0||Pe>=he.length)return!1;switch(he.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function L(he,Pe,Ne){return Pe[he]!==Ne[he]}function x(he,Pe,Ne,ze,U,z,H=!1){for(;Pe<Ne&&U<z;)he[Pe]===ze[U]&&(H&&(re[Pe]=U),Pe+=1),U+=1;return Pe===Ne}var ve;(function(he){he[he.Diag=1]="Diag",he[he.Left=2]="Left",he[he.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Fe;(function(he){he.Default=[-100,0];function Pe(Ne){return!Ne||Ne.length===2&&Ne[0]===-100&&Ne[1]===0}he.isDefault=Pe})(Fe||(e.FuzzyScore=Fe={}));class Ee{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Ne){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Ne}}e.$Ik=Ee;function pe(he,Pe,Ne,ze,U,z,H=Ee.default){const G=he.length>A?A:he.length,ee=ze.length>A?A:ze.length;if(Ne>=G||z>=ee||G-Ne>ee-z||!x(Pe,Ne,G,U,z,ee,!0))return;fe(G,ee,Ne,z,Pe,U);let ne=1,Oe=1,Be=Ne,Ye=z;const _e=[!1];for(ne=1,Be=Ne;Be<G;ne++,Be++){const at=re[Be],mt=ae[Be],je=Be+1<G?ae[Be+1]:ee;for(Oe=at-z+1,Ye=at;Ye<je;Oe++,Ye++){let st=Number.MIN_SAFE_INTEGER,Z=!1;Ye<=mt&&(st=Y(he,Pe,Be,Ne,ze,U,Ye,ee,z,we[ne-1][Oe-1]===0,_e));let Q=0;st!==Number.MAX_SAFE_INTEGER&&(Z=!0,Q=st+Ie[ne-1][Oe-1]);const $e=Ye>at,Ge=$e?Ie[ne][Oe-1]+(we[ne][Oe-1]>0?-5:0):0,ye=Ye>at+1&&we[ne][Oe-1]>0,ot=ye?Ie[ne][Oe-2]+(we[ne][Oe-2]>0?-5:0):0;if(ye&&(!$e||ot>=Ge)&&(!Z||ot>=Q))Ie[ne][Oe]=ot,de[ne][Oe]=3,we[ne][Oe]=0;else if($e&&(!Z||Ge>=Q))Ie[ne][Oe]=Ge,de[ne][Oe]=2,we[ne][Oe]=0;else if(Z)Ie[ne][Oe]=Q,de[ne][Oe]=1,we[ne][Oe]=we[ne-1][Oe-1]+1;else throw new Error("not possible")}}if(me&&ce(he,Ne,ze,z),!_e[0]&&!H.firstMatchCanBeWeak)return;ne--,Oe--;const et=[Ie[ne][Oe],z];let tt=0,it=0;for(;ne>=1;){let at=Oe;do{const mt=de[ne][at];if(mt===3)at=at-2;else if(mt===2)at=at-1;else break}while(at>=1);tt>1&&Pe[Ne+ne-1]===U[z+Oe-1]&&!L(at+z-1,ze,U)&&tt+1>we[ne][at]&&(at=Oe),at===Oe?tt++:tt=1,it||(it=at),ne--,Oe=at-1,et.push(Oe)}ee===G&&H.boostFullMatch&&(et[0]+=2);const nt=it-G;return et[0]-=nt,et}function fe(he,Pe,Ne,ze,U,z){let H=he-1,G=Pe-1;for(;H>=Ne&&G>=ze;)U[H]===z[G]&&(ae[H]=G,H--),G--}function Y(he,Pe,Ne,ze,U,z,H,G,ee,ne,Oe){if(Pe[Ne]!==z[H])return Number.MIN_SAFE_INTEGER;let Be=1,Ye=!1;return H===Ne-ze?Be=he[Ne]===U[H]?7:5:L(H,U,z)&&(H===0||!L(H-1,U,z))?(Be=he[Ne]===U[H]?7:5,Ye=!0):Re(z,H)&&(H===0||!Re(z,H-1))?Be=5:(Re(z,H-1)||ie(z,H-1))&&(Be=5,Ye=!0),Be>1&&Ne===ze&&(Oe[0]=!0),Ye||(Ye=L(H,U,z)||Re(z,H-1)||ie(z,H-1)),Ne===ze?H>ee&&(Be-=Ye?3:5):ne?Be+=Ye?2:0:Be+=Ye?0:1,H+1===G&&(Be-=Ye?3:5),Be}function X(he,Pe,Ne,ze,U,z,H){return ue(he,Pe,Ne,ze,U,z,!0,H)}function le(he,Pe,Ne,ze,U,z,H){return ue(he,Pe,Ne,ze,U,z,!1,H)}function ue(he,Pe,Ne,ze,U,z,H,G){let ee=pe(he,Pe,Ne,ze,U,z,G);if(ee&&!H)return ee;if(he.length>=3){const ne=Math.min(7,he.length-1);for(let Oe=Ne+1;Oe<ne;Oe++){const Be=Te(he,Oe);if(Be){const Ye=pe(Be,Be.toLowerCase(),Ne,ze,U,z,G);Ye&&(Ye[0]-=3,(!ee||Ye[0]>ee[0])&&(ee=Ye))}}}return ee}function Te(he,Pe){if(Pe+1>=he.length)return;const Ne=he[Pe],ze=he[Pe+1];if(Ne!==ze)return he.slice(0,Pe)+ze+Ne+he.slice(Pe+2)}}),define(Ce[33],Ae([1,0,15]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(N||(N={})),function(R){const O="error",M="warning",p="warn",g="info",E="ignore";function T(l){return l?S.$xf(O,l)?R.Error:S.$xf(M,l)||S.$xf(p,l)?R.Warning:S.$xf(g,l)?R.Info:R.Ignore:R.Ignore}R.fromValue=T;function y(l){switch(l){case R.Error:return O;case R.Warning:return M;case R.Info:return g;default:return E}}R.toString=y}(N||(N={})),e.default=N}),define(Ce[130],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$be=void 0,e.$be=Symbol("MicrotaskDelay")}),define(Ce[52],Ae([1,0,18,15]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bi=e.$Ai=e.$zi=e.$yi=e.$xi=void 0;class R{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const m=w.charCodeAt(0),s=this.b.charCodeAt(this.c);return m-s}value(){return this.b[this.c]}}e.$xi=R;class O{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,N.$rf)(w,this.b,0,w.length,this.c,this.d):(0,N.$tf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$yi=O;class M{constructor(w=!0,m=!0){this.f=w,this.g=m}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let m=w.length-1;m>=0;m--,this.c--){const s=this.b.charCodeAt(m);if(!(s===47||this.f&&s===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,N.$rf)(w,this.b,0,w.length,this.d,this.e):(0,N.$tf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$zi=M;var p;(function(l){l[l.Scheme=1]="Scheme",l[l.Authority=2]="Authority",l[l.Path=3]="Path",l[l.Query=4]="Query",l[l.Fragment=5]="Fragment"})(p||(p={}));class g{constructor(w,m){this.f=w,this.g=m,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new M(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,N.$sf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,N.$sf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,N.$qf)(w,this.c.query);if(this.d[this.e]===5)return(0,N.$qf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Ai=g;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var T;(function(l){l[l.Left=-1]="Left",l[l.Mid=0]="Mid",l[l.Right=1]="Right"})(T||(T={}));class y{static forUris(w=()=>!1,m=()=>!1){return new y(new g(w,m))}static forPaths(w=!1){return new y(new M(void 0,!w))}static forStrings(){return new y(new R)}static forConfigKeys(){return new y(new O)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,m){if(m){const s=m.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o,w)}else{const s=w.slice(0);(0,S.$Xb)(s);for(const o of s)this.set(o[0],o[1])}}set(w,m){const s=this.b.reset(w);let o;this.c||(this.c=new E,this.c.segment=s.value());const r=[];for(o=this.c;;){const n=s.cmp(o.segment);if(n>0)o.left||(o.left=new E,o.left.segment=s.value()),r.push([-1,o]),o=o.left;else if(n<0)o.right||(o.right=new E,o.right.segment=s.value()),r.push([1,o]),o=o.right;else if(s.hasNext())s.next(),o.mid||(o.mid=new E,o.mid.segment=s.value()),r.push([0,o]),o=o.mid;else break}const t=o.value;o.value=m,o.key=w;for(let n=r.length-1;n>=0;n--){const c=r[n][1];c.updateHeight();const h=c.balanceFactor();if(h<-1||h>1){const i=r[n][0],$=r[n+1][0];if(i===1&&$===1)r[n][1]=c.rotateLeft();else if(i===-1&&$===-1)r[n][1]=c.rotateRight();else if(i===1&&$===-1)c.right=r[n+1][1]=r[n+1][1].rotateRight(),r[n][1]=c.rotateLeft();else if(i===-1&&$===1)c.left=r[n+1][1]=r[n+1][1].rotateLeft(),r[n][1]=c.rotateRight();else throw new Error;if(n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}return t}get(w){return this.d(w)?.value}d(w){const m=this.b.reset(w);let s=this.c;for(;s;){const o=m.cmp(s.segment);if(o>0)s=s.left;else if(o<0)s=s.right;else if(m.hasNext())m.next(),s=s.mid;else break}return s}has(w){const m=this.d(w);return!(m?.value===void 0&&m?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,m){const s=this.b.reset(w),o=[];let r=this.c;for(;r;){const t=s.cmp(r.segment);if(t>0)o.push([-1,r]),r=r.left;else if(t<0)o.push([1,r]),r=r.right;else if(s.hasNext())s.next(),o.push([0,r]),r=r.mid;else break}if(r){if(m?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const t=this.f(r.right);if(t.key){const{key:n,value:c,segment:h}=t;this.e(t.key,!1),r.key=n,r.value=c,r.segment=h}}else{const t=r.left??r.right;if(o.length>0){const[n,c]=o[o.length-1];switch(n){case-1:c.left=t;break;case 0:c.mid=t;break;case 1:c.right=t;break}}else this.c=t}for(let t=o.length-1;t>=0;t--){const n=o[t][1];n.updateHeight();const c=n.balanceFactor();if(c>1?(n.right.balanceFactor()>=0||(n.right=n.right.rotateRight()),o[t][1]=n.rotateLeft()):c<-1&&(n.left.balanceFactor()<=0||(n.left=n.left.rotateLeft()),o[t][1]=n.rotateRight()),t>0)switch(o[t-1][0]){case-1:o[t-1][1].left=o[t][1];break;case 1:o[t-1][1].right=o[t][1];break;case 0:o[t-1][1].mid=o[t][1];break}else this.c=o[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const m=this.b.reset(w);let s=this.c,o;for(;s;){const r=m.cmp(s.segment);if(r>0)s=s.left;else if(r<0)s=s.right;else if(m.hasNext())m.next(),o=s.value||o,s=s.mid;else break}return s&&s.value||o}findSuperstr(w){return this.g(w,!1)}g(w,m){const s=this.b.reset(w);let o=this.c;for(;o;){const r=s.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(s.hasNext())s.next(),o=o.mid;else return o.mid?this.h(o.mid):m?o.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[m,s]of this)w(s,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const m=[];return this.j(w,m),m[Symbol.iterator]()}j(w,m){w&&(w.left&&this.j(w.left,m),w.value&&m.push([w.key,w.value]),w.mid&&this.j(w.mid,m),w.right&&this.j(w.right,m))}_isBalanced(){const w=m=>{if(!m)return!0;const s=m.balanceFactor();return s<-1||s>1?!1:w(m.left)&&w(m.right)};return w(this.c)}}e.$Bi=y}),define(Ce[42],Ae([1,0,91]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Vj=R;var N;(function(M){function p(g){return g&&typeof g=="object"&&typeof g.id=="string"}M.isThemeColor=p})(N||(e.ThemeColor=N={}));function R(M){return{id:M}}var O;(function(M){M.iconNameSegment="[A-Za-z0-9]+",M.iconNameExpression="[A-Za-z0-9-]+",M.iconModifierExpression="~[A-Za-z]+",M.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${M.iconNameExpression})(${M.iconModifierExpression})?$`);function g(t){const n=p.exec(t.id);if(!n)return g(S.$Uj.error);const[,c,h]=n,i=["codicon","codicon-"+c];return h&&i.push("codicon-modifier-"+h.substring(1)),i}M.asClassNameArray=g;function E(t){return g(t).join(" ")}M.asClassName=E;function T(t){return"."+g(t).join(".")}M.asCSSSelector=T;function y(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(typeof t.color>"u"||N.isThemeColor(t.color))}M.isThemeIcon=y;const l=new RegExp(`^\\$\\((${M.iconNameExpression}(?:${M.iconModifierExpression})?)\\)$`);function w(t){const n=l.exec(t);if(!n)return;const[,c]=n;return{id:c}}M.fromString=w;function m(t){return{id:t}}M.fromId=m;function s(t,n){let c=t.id;const h=c.lastIndexOf("~");return h!==-1&&(c=c.substring(0,h)),n&&(c=`${c}~${n}`),{id:c}}M.modify=s;function o(t){const n=t.id.lastIndexOf("~");if(n!==-1)return t.id.substring(n+1)}M.getModifier=o;function r(t,n){return t.id===n.id&&t.color?.id===n.color?.id}M.isEqual=r})(O||(e.ThemeIcon=O={}))}),define(Ce[131],Ae([1,0,129,15,42]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mk=g,e.$Nk=T,e.$Ok=l,e.$Pk=w,e.$Qk=s,e.$Rk=o;const O="$(",M=new RegExp(`\\$\\(${R.ThemeIcon.iconNameExpression}(?:${R.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${M.source}`,"g");function g(r){return r.replace(p,(t,n)=>n?t:`\\${t}`)}const E=new RegExp(`\\\\${M.source}`,"g");function T(r){return r.replace(E,t=>`\\${t}`)}const y=new RegExp(`(\\s)?(\\\\)?${M.source}(\\s)?`,"g");function l(r){return r.indexOf(O)===-1?r:r.replace(y,(t,n,c,h)=>c?t:n||h||"")}function w(r){return r?r.replace(/\$\((.*?)\)/g,(t,n)=>` ${n} `).trim():""}const m=new RegExp(`\\$\\(${R.ThemeIcon.iconNameCharacter}+\\)`,"g");function s(r){m.lastIndex=0;let t="";const n=[];let c=0;for(;;){const h=m.lastIndex,i=m.exec(r),$=r.substring(h,i?.index);if($.length>0){t+=$;for(let a=0;a<$.length;a++)n.push(c)}if(!i)break;c+=i[0].length}return{text:t,iconOffsets:n}}function o(r,t,n=!1){const{text:c,iconOffsets:h}=t;if(!h||h.length===0)return(0,S.$Dk)(r,c,n);const i=(0,N.$ef)(c," "),$=c.length-i.length,a=(0,S.$Dk)(r,i,n);if(a)for(const v of a){const d=h[v.start+$]+$;v.start+=d,v.end+=d}return a}}),define(Ce[35],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=void 0,e.$Qg=N;const S=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(R){return S.test(R)}e.$Rg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(p){for(let g=0;g<p.length;g++)p[g]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),M=[];for(let p=0;p<256;p++)M.push(p.toString(16).padStart(2,"0"));return function(){R(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let g=0,E="";return E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+="-",E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E+=M[O[g++]],E}}()}),define(Ce[132],Ae([1,0,18,40,35]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tt=e.$Rt=void 0,e.$Pt=O,e.$Qt=M,e.$St=E;function O(y){return{asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}function M(y,l,w){const m={id:(0,R.$Rg)(),name:y,uri:l,data:w};return{asString:async()=>"",asFile:()=>m,value:void 0}}class p{constructor(){this.a=new Map}get size(){let l=0;for(const w of this.a)l++;return l}has(l){return this.a.has(this.b(l))}matches(l){const w=[...this.a.keys()];return N.Iterable.some(this,([m,s])=>s.asFile())&&w.push("files"),T(g(l),w)}get(l){return this.a.get(this.b(l))?.[0]}append(l,w){const m=this.a.get(l);m?m.push(w):this.a.set(this.b(l),[w])}replace(l,w){this.a.set(this.b(l),[w])}delete(l){this.a.delete(this.b(l))}*[Symbol.iterator](){for(const[l,w]of this.a)for(const m of w)yield[l,m]}b(l){return g(l)}}e.$Rt=p;function g(y){return y.toLowerCase()}function E(y,l){return T(g(y),l.map(g))}function T(y,l){if(y==="*/*")return l.length>0;if(l.includes(y))return!0;const w=y.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[m,s,o]=w;return o==="*"?l.some(r=>r.startsWith(s+"/")):!1}e.$Tt=Object.freeze({create:y=>(0,S.$Mb)(y.map(l=>l.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.$Tt.split(y).filter(l=>!l.startsWith("#"))})}),define(Ce[133],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$Wt=N;var S;(function(R){R[R.Unknown=0]="Unknown",R[R.Invalid=3]="Invalid",R[R.LF=1]="LF",R[R.CRLF=2]="CRLF"})(S||(e.StringEOL=S={}));function N(R){let O=0,M=0,p=0,g=0;for(let E=0,T=R.length;E<T;E++){const y=R.charCodeAt(E);y===13?(O===0&&(M=E),O++,E+1<T&&R.charCodeAt(E+1)===10?(g|=2,E++):g|=3,p=E+1):y===10&&(g|=1,O===0&&(M=E),O++,p=E+1)}return O===0&&(M=R.length),[O,M,R.length-p,g]}}),define(Ce[134],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3s=void 0,e.$3s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[135],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ku=e.$ju=e.IndentAction=void 0;var S;(function(M){M[M.None=0]="None",M[M.Indent=1]="Indent",M[M.IndentOutdent=2]="IndentOutdent",M[M.Outdent=3]="Outdent"})(S||(e.IndentAction=S={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let g=0,E=p.notIn.length;g<E;g++)switch(p.notIn[g]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,g){if(p.getTokenCount()===0)return!0;const E=p.findTokenIndexAtOffset(g-2),T=p.getStandardTokenType(E);return this.isOK(T)}g(p,g){for(let E=p;E<=g;E++){const T=String.fromCharCode(E);if(!this.open.includes(T)&&!this.close.includes(T))return T}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$ju=N;class R{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const g of p)O(this.autoClosingPairsOpenByStart,g.open.charAt(0),g),O(this.autoClosingPairsOpenByEnd,g.open.charAt(g.open.length-1),g),O(this.autoClosingPairsCloseByStart,g.close.charAt(0),g),O(this.autoClosingPairsCloseByEnd,g.close.charAt(g.close.length-1),g),g.close.length===1&&g.open.length===1&&O(this.autoClosingPairsCloseSingleChar,g.close,g)}}e.$ku=R;function O(M,p,g){M.has(p)?M.get(p).push(g):M.set(p,[g])}}),define(Ce[136],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zC=e.NodeColor=e.$yC=void 0,e.$AC=R,e.$BC=O,e.$CC=E,e.$DC=T,e.$EC=y,e.$FC=l,e.$GC=w,e.$HC=m;class S{constructor(o,r){this.piece=o,this.color=r,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$zC)return R(this.right);let o=this;for(;o.parent!==e.$zC&&o.parent.left!==o;)o=o.parent;return o.parent===e.$zC?e.$zC:o.parent}prev(){if(this.left!==e.$zC)return O(this.left);let o=this;for(;o.parent!==e.$zC&&o.parent.right!==o;)o=o.parent;return o.parent===e.$zC?e.$zC:o.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$yC=S;var N;(function(s){s[s.Black=0]="Black",s[s.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$zC=new S(null,0),e.$zC.parent=e.$zC,e.$zC.left=e.$zC,e.$zC.right=e.$zC,e.$zC.color=0;function R(s){for(;s.left!==e.$zC;)s=s.left;return s}function O(s){for(;s.right!==e.$zC;)s=s.right;return s}function M(s){return s===e.$zC?0:s.size_left+s.piece.length+M(s.right)}function p(s){return s===e.$zC?0:s.lf_left+s.piece.lineFeedCnt+p(s.right)}function g(){e.$zC.parent=e.$zC}function E(s,o){const r=o.right;r.size_left+=o.size_left+(o.piece?o.piece.length:0),r.lf_left+=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),o.right=r.left,r.left!==e.$zC&&(r.left.parent=o),r.parent=o.parent,o.parent===e.$zC?s.root=r:o.parent.left===o?o.parent.left=r:o.parent.right=r,r.left=o,o.parent=r}function T(s,o){const r=o.left;o.left=r.right,r.right!==e.$zC&&(r.right.parent=o),r.parent=o.parent,o.size_left-=r.size_left+(r.piece?r.piece.length:0),o.lf_left-=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),o.parent===e.$zC?s.root=r:o===o.parent.right?o.parent.right=r:o.parent.left=r,r.right=o,o.parent=r}function y(s,o){let r,t;if(o.left===e.$zC?(t=o,r=t.right):o.right===e.$zC?(t=o,r=t.left):(t=R(o.right),r=t.right),t===s.root){s.root=r,r.color=0,o.detach(),g(),s.root.parent=e.$zC;return}const n=t.color===1;if(t===t.parent.left?t.parent.left=r:t.parent.right=r,t===o?(r.parent=t.parent,m(s,r)):(t.parent===o?r.parent=t:r.parent=t.parent,m(s,r),t.left=o.left,t.right=o.right,t.parent=o.parent,t.color=o.color,o===s.root?s.root=t:o===o.parent.left?o.parent.left=t:o.parent.right=t,t.left!==e.$zC&&(t.left.parent=t),t.right!==e.$zC&&(t.right.parent=t),t.size_left=o.size_left,t.lf_left=o.lf_left,m(s,t)),o.detach(),r.parent.left===r){const h=M(r),i=p(r);if(h!==r.parent.size_left||i!==r.parent.lf_left){const $=h-r.parent.size_left,a=i-r.parent.lf_left;r.parent.size_left=h,r.parent.lf_left=i,w(s,r.parent,$,a)}}if(m(s,r.parent),n){g();return}let c;for(;r!==s.root&&r.color===0;)r===r.parent.left?(c=r.parent.right,c.color===1&&(c.color=0,r.parent.color=1,E(s,r.parent),c=r.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.right.color===0&&(c.left.color=0,c.color=1,T(s,c),c=r.parent.right),c.color=r.parent.color,r.parent.color=0,c.right.color=0,E(s,r.parent),r=s.root)):(c=r.parent.left,c.color===1&&(c.color=0,r.parent.color=1,T(s,r.parent),c=r.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,r=r.parent):(c.left.color===0&&(c.right.color=0,c.color=1,E(s,c),c=r.parent.left),c.color=r.parent.color,r.parent.color=0,c.left.color=0,T(s,r.parent),r=s.root));r.color=0,g()}function l(s,o){for(m(s,o);o!==s.root&&o.parent.color===1;)if(o.parent===o.parent.parent.left){const r=o.parent.parent.right;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.right&&(o=o.parent,E(s,o)),o.parent.color=0,o.parent.parent.color=1,T(s,o.parent.parent))}else{const r=o.parent.parent.left;r.color===1?(o.parent.color=0,r.color=0,o.parent.parent.color=1,o=o.parent.parent):(o===o.parent.left&&(o=o.parent,T(s,o)),o.parent.color=0,o.parent.parent.color=1,E(s,o.parent.parent))}s.root.color=0}function w(s,o,r,t){for(;o!==s.root&&o!==e.$zC;)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=t),o=o.parent}function m(s,o){let r=0,t=0;if(o!==s.root){for(;o!==s.root&&o===o.parent.right;)o=o.parent;if(o!==s.root)for(o=o.parent,r=M(o.left)-o.size_left,t=p(o.left)-o.lf_left,o.size_left+=r,o.lf_left+=t;o!==s.root&&(r!==0||t!==0);)o.parent.left===o&&(o.parent.size_left+=r,o.parent.lf_left+=t),o=o.parent}}}),define(Ce[92],Ae([1,0,93,29,94,136,95]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SC=e.$RC=e.$QC=void 0,e.$OC=T,e.$PC=y;const p=65535;function g(r){let t;return r[r.length-1]<65536?t=new Uint16Array(r.length):t=new Uint32Array(r.length),t.set(r,0),t}class E{constructor(t,n,c,h,i){this.lineStarts=t,this.cr=n,this.lf=c,this.crlf=h,this.isBasicASCII=i}}function T(r,t=!0){const n=[0];let c=1;for(let h=0,i=r.length;h<i;h++){const $=r.charCodeAt(h);$===13?h+1<i&&r.charCodeAt(h+1)===10?(n[c++]=h+2,h++):n[c++]=h+1:$===10&&(n[c++]=h+1)}return t?g(n):n}function y(r,t){r.length=0,r[0]=0;let n=1,c=0,h=0,i=0,$=!0;for(let v=0,d=t.length;v<d;v++){const C=t.charCodeAt(v);C===13?v+1<d&&t.charCodeAt(v+1)===10?(i++,r[n++]=v+2,v++):(c++,r[n++]=v+1):C===10?(h++,r[n++]=v+1):$&&C!==9&&(C<32||C>126)&&($=!1)}const a=new E(g(r),c,h,i,$);return r.length=0,a}class l{constructor(t,n,c,h,i){this.bufferIndex=t,this.start=n,this.end=c,this.lineFeedCnt=h,this.length=i}}e.$QC=l;class w{constructor(t,n){this.buffer=t,this.lineStarts=n}}e.$RC=w;class m{constructor(t,n){this.a=[],this.c=t,this.d=n,this.b=0,t.root!==O.$zC&&t.iterate(t.root,c=>(c!==O.$zC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class s{constructor(t){this.a=t,this.b=[]}get(t){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartOffset<=t&&c.nodeStartOffset+c.node.piece.length>=t)return c}return null}get2(t){for(let n=this.b.length-1;n>=0;n--){const c=this.b[n];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<t&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=t)return c}return null}set(t){this.b.length>=this.a&&this.b.shift(),this.b.push(t)}validate(t){let n=!1;const c=this.b;for(let h=0;h<c.length;h++){const i=c[h];if(i.node.parent===null||i.nodeStartOffset>=t){c[h]=null,n=!0;continue}}if(n){const h=[];for(const i of c)i!==null&&h.push(i);this.b=h}}}class o{constructor(t,n,c){this.create(t,n,c)}create(t,n,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=O.$zC,this.b=1,this.c=0,this.d=n,this.e=n.length,this.f=c;let h=null;for(let i=0,$=t.length;i<$;i++)if(t[i].buffer.length>0){t[i].lineStarts||(t[i].lineStarts=T(t[i].buffer));const a=new l(i+1,{line:0,column:0},{line:t[i].lineStarts.length-1,column:t[i].buffer.length-t[i].lineStarts[t[i].lineStarts.length-1]},t[i].lineStarts.length-1,t[i].buffer.length);this.a.push(t[i]),h=this.S(h,a)}this.h=new s(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(t){const n=p,c=n-Math.floor(n/3),h=c*2;let i="",$=0;const a=[];if(this.iterate(this.root,v=>{const d=this.R(v),C=d.length;if($<=c||$+C<h)return i+=d,$+=C,!0;const u=i.replace(/\r\n|\r|\n/g,t);return a.push(new w(u,T(u))),i=d,$=C,!0}),$>0){const v=i.replace(/\r\n|\r|\n/g,t);a.push(new w(v,T(v)))}this.create(a,t,!0)}getEOL(){return this.d}setEOL(t){this.d=t,this.e=this.d.length,this.normalizeEOL(t)}createSnapshot(t){return new m(this,t)}equal(t){if(this.getLength()!==t.getLength()||this.getLineCount()!==t.getLineCount())return!1;let n=0;return this.iterate(this.root,h=>{if(h===O.$zC)return!0;const i=this.R(h),$=i.length,a=t.G(n),v=t.G(n+$),d=t.getValueInRange2(a,v);return n+=$,i===d})}getOffsetAt(t,n){let c=0,h=this.root;for(;h!==O.$zC;)if(h.left!==O.$zC&&h.lf_left+1>=t)h=h.left;else if(h.lf_left+h.piece.lineFeedCnt+1>=t){c+=h.size_left;const i=this.B(h,t-h.lf_left-2);return c+=i+n-1}else t-=h.lf_left+h.piece.lineFeedCnt,c+=h.size_left+h.piece.length,h=h.right;return c}getPositionAt(t){t=Math.floor(t),t=Math.max(0,t);let n=this.root,c=0;const h=t;for(;n!==O.$zC;)if(n.size_left!==0&&n.size_left>=t)n=n.left;else if(n.size_left+n.piece.length>=t){const i=this.A(n,t-n.size_left);if(c+=n.lf_left+i.index,i.index===0){const $=this.getOffsetAt(c+1,1),a=h-$;return new S.$st(c+1,a+1)}return new S.$st(c+1,i.remainder+1)}else if(t-=n.size_left+n.piece.length,c+=n.lf_left+n.piece.lineFeedCnt,n.right===O.$zC){const i=this.getOffsetAt(c+1,1),$=h-t-i;return new S.$st(c+1,$+1)}else n=n.right;return new S.$st(1,1)}getValueInRange(t,n){if(t.startLineNumber===t.endLineNumber&&t.startColumn===t.endColumn)return"";const c=this.H(t.startLineNumber,t.startColumn),h=this.H(t.endLineNumber,t.endColumn),i=this.getValueInRange2(c,h);return n?n!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,n):n===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,n):i}getValueInRange2(t,n){if(t.node===n.node){const a=t.node,v=this.a[a.piece.bufferIndex].buffer,d=this.u(a.piece.bufferIndex,a.piece.start);return v.substring(d+t.remainder,d+n.remainder)}let c=t.node;const h=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let $=h.substring(i+t.remainder,i+c.piece.length);for(c=c.next();c!==O.$zC;){const a=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);if(c===n.node){$+=a.substring(v,v+n.remainder);break}else $+=a.substr(v,c.piece.length);c=c.next()}return $}getLinesContent(){const t=[];let n=0,c="",h=!1;return this.iterate(this.root,i=>{if(i===O.$zC)return!0;const $=i.piece;let a=$.length;if(a===0)return!0;const v=this.a[$.bufferIndex].buffer,d=this.a[$.bufferIndex].lineStarts,C=$.start.line,u=$.end.line;let D=d[C]+$.start.column;if(h&&(v.charCodeAt(D)===10&&(D++,a--),t[n++]=c,c="",h=!1,a===0))return!0;if(C===u)return!this.f&&v.charCodeAt(D+a-1)===13?(h=!0,c+=v.substr(D,a-1)):c+=v.substr(D,a),!0;c+=this.f?v.substring(D,Math.max(D,d[C+1]-this.e)):v.substring(D,d[C+1]).replace(/(\r\n|\r|\n)$/,""),t[n++]=c;for(let f=C+1;f<u;f++)c=this.f?v.substring(d[f],d[f+1]-this.e):v.substring(d[f],d[f+1]).replace(/(\r\n|\r|\n)$/,""),t[n++]=c;return!this.f&&v.charCodeAt(d[u]+$.end.column-1)===13?(h=!0,$.end.column===0?n--:c=v.substr(d[u],$.end.column-1)):c=v.substr(d[u],$.end.column),!0}),h&&(t[n++]=c,c=""),t[n++]=c,t}getLength(){return this.c}getLineCount(){return this.b}getLineContent(t){return this.j.lineNumber===t?this.j.value:(this.j.lineNumber=t,t===this.b?this.j.value=this.getLineRawContent(t):this.f?this.j.value=this.getLineRawContent(t,this.e):this.j.value=this.getLineRawContent(t).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(t){if(t.remainder===t.node.piece.length){const n=t.node.next();if(!n)return 0;const c=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start);return c.buffer.charCodeAt(h)}else{const n=this.a[t.node.piece.bufferIndex],h=this.u(t.node.piece.bufferIndex,t.node.piece.start)+t.remainder;return n.buffer.charCodeAt(h)}}getLineCharCode(t,n){const c=this.H(t,n+1);return this.l(c)}getLineLength(t){if(t===this.getLineCount()){const n=this.getOffsetAt(t,1);return this.getLength()-n}return this.getOffsetAt(t+1,1)-this.getOffsetAt(t,1)-this.e}getCharCode(t){const n=this.G(t);return this.l(n)}findMatchesInNode(t,n,c,h,i,$,a,v,d,C,u){const D=this.a[t.piece.bufferIndex],f=this.u(t.piece.bufferIndex,t.piece.start),k=this.u(t.piece.bufferIndex,i),b=this.u(t.piece.bufferIndex,$);let P;const I={line:0,column:0};let W,V;n._wordSeparators?(W=D.buffer.substring(k,b),V=q=>q+k,n.reset(0)):(W=D.buffer,V=q=>q,n.reset(k));do if(P=n.next(W),P){if(V(P.index)>=b)return C;this.s(t,V(P.index)-f,I);const q=this.t(t.piece.bufferIndex,i,I),A=I.line===i.line?I.column-i.column+h:I.column+1,j=A+P[0].length;if(u[C++]=(0,M.$KC)(new N.$tt(c+q,A,c+q,j),P,v),V(P.index)+P[0].length>=b||C>=d)return C}while(P);return C}findMatchesLineByLine(t,n,c,h){const i=[];let $=0;const a=new M.$NC(n.wordSeparators,n.regex);let v=this.H(t.startLineNumber,t.startColumn);if(v===null)return[];const d=this.H(t.endLineNumber,t.endColumn);if(d===null)return[];let C=this.s(v.node,v.remainder);const u=this.s(d.node,d.remainder);if(v.node===d.node)return this.findMatchesInNode(v.node,a,t.startLineNumber,t.startColumn,C,u,n,c,h,$,i),i;let D=t.startLineNumber,f=v.node;for(;f!==d.node;){const b=this.t(f.piece.bufferIndex,C,f.piece.end);if(b>=1){const I=this.a[f.piece.bufferIndex].lineStarts,W=this.u(f.piece.bufferIndex,f.piece.start),V=I[C.line+b],q=D===t.startLineNumber?t.startColumn:1;if($=this.findMatchesInNode(f,a,D,q,C,this.s(f,V-W),n,c,h,$,i),$>=h)return i;D+=b}const P=D===t.startLineNumber?t.startColumn-1:0;if(D===t.endLineNumber){const I=this.getLineContent(D).substring(P,t.endColumn-1);return $=this.n(n,a,I,t.endLineNumber,P,$,i,c,h),i}if($=this.n(n,a,this.getLineContent(D).substr(P),D,P,$,i,c,h),$>=h)return i;D++,v=this.H(D,1),f=v.node,C=this.s(v.node,v.remainder)}if(D===t.endLineNumber){const b=D===t.startLineNumber?t.startColumn-1:0,P=this.getLineContent(D).substring(b,t.endColumn-1);return $=this.n(n,a,P,t.endLineNumber,b,$,i,c,h),i}const k=D===t.startLineNumber?t.startColumn:1;return $=this.findMatchesInNode(d.node,a,D,k,C,u,n,c,h,$,i),i}n(t,n,c,h,i,$,a,v,d){const C=t.wordSeparators;if(!v&&t.simpleSearch){const D=t.simpleSearch,f=D.length,k=c.length;let b=-f;for(;(b=c.indexOf(D,b+f))!==-1;)if((!C||(0,M.$MC)(C,c,k,b,f))&&(a[$++]=new R.$Ev(new N.$tt(h,b+1+i,h,b+1+f+i),null),$>=d))return $;return $}let u;n.reset(0);do if(u=n.next(c),u&&(a[$++]=(0,M.$KC)(new N.$tt(h,u.index+1+i,h,u.index+1+u[0].length+i),u,v),$>=d))return $;while(u);return $}insert(t,n,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==O.$zC){const{node:h,remainder:i,nodeStartOffset:$}=this.G(t),a=h.piece,v=a.bufferIndex,d=this.s(h,i);if(h.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&$+a.length===t&&n.length<p){this.F(h,n),this.y();return}if($===t)this.o(n,h),this.h.validate(t);else if($+h.piece.length>t){const C=[];let u=new l(a.bufferIndex,d,a.end,this.t(a.bufferIndex,d,a.end),this.u(v,a.end)-this.u(v,d));if(this.K()&&this.M(n)&&this.I(h,i)===10){const b={line:u.start.line+1,column:0};u=new l(u.bufferIndex,b,u.end,this.t(u.bufferIndex,b,u.end),u.length-1),n+=`
`}if(this.K()&&this.L(n))if(this.I(h,i-1)===13){const b=this.s(h,i-1);this.C(h,b),n="\r"+n,h.piece.length===0&&C.push(h)}else this.C(h,d);else this.C(h,d);const D=this.w(n);u.length>0&&this.S(h,u);let f=h;for(let k=0;k<D.length;k++)f=this.S(f,D[k]);this.v(C)}else this.q(n,h)}else{const h=this.w(n);let i=this.T(null,h[0]);for(let $=1;$<h.length;$++)i=this.S(i,h[$])}this.y()}delete(t,n){if(this.j.lineNumber=0,this.j.value="",n<=0||this.root===O.$zC)return;const c=this.G(t),h=this.G(t+n),i=c.node,$=h.node;if(i===$){const D=this.s(i,c.remainder),f=this.s(i,h.remainder);if(c.nodeStartOffset===t){if(n===i.piece.length){const k=i.next();(0,O.$EC)(this,i),this.N(k),this.y();return}this.D(i,f),this.h.validate(t),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===t+n){this.C(i,D),this.O(i),this.y();return}this.E(i,D,f),this.y();return}const a=[],v=this.s(i,c.remainder);this.C(i,v),this.h.validate(t),i.piece.length===0&&a.push(i);const d=this.s($,h.remainder);this.D($,d),$.piece.length===0&&a.push($);const C=i.next();for(let D=C;D!==O.$zC&&D!==$;D=D.next())a.push(D);const u=i.piece.length===0?i.prev():i;this.v(a),this.O(u),this.y()}o(t,n){const c=[];if(this.K()&&this.M(t)&&this.L(n)){const $=n.piece,a={line:$.start.line+1,column:0},v=new l($.bufferIndex,a,$.end,this.t($.bufferIndex,a,$.end),$.length-1);n.piece=v,t+=`
`,(0,O.$GC)(this,n,-1,-1),n.piece.length===0&&c.push(n)}const h=this.w(t);let i=this.T(n,h[h.length-1]);for(let $=h.length-2;$>=0;$--)i=this.T(i,h[$]);this.N(i),this.v(c)}q(t,n){this.Q(t,n)&&(t+=`
`);const c=this.w(t),h=this.S(n,c[0]);let i=h;for(let $=1;$<c.length;$++)i=this.S(i,c[$]);this.N(h)}s(t,n,c){const h=t.piece,i=t.piece.bufferIndex,$=this.a[i].lineStarts,v=$[h.start.line]+h.start.column+n;let d=h.start.line,C=h.end.line,u=0,D=0,f=0;for(;d<=C&&(u=d+(C-d)/2|0,f=$[u],u!==C);)if(D=$[u+1],v<f)C=u-1;else if(v>=D)d=u+1;else break;return c?(c.line=u,c.column=v-f,null):{line:u,column:v-f}}t(t,n,c){if(c.column===0)return c.line-n.line;const h=this.a[t].lineStarts;if(c.line===h.length-1)return c.line-n.line;const i=h[c.line+1],$=h[c.line]+c.column;if(i>$+1)return c.line-n.line;const a=$-1;return this.a[t].buffer.charCodeAt(a)===13?c.line-n.line+1:c.line-n.line}u(t,n){return this.a[t].lineStarts[n.line]+n.column}v(t){for(let n=0;n<t.length;n++)(0,O.$EC)(this,t[n])}w(t){if(t.length>p){const C=[];for(;t.length>p;){const D=t.charCodeAt(p-1);let f;D===13||D>=55296&&D<=56319?(f=t.substring(0,p-1),t=t.substring(p-1)):(f=t.substring(0,p),t=t.substring(p));const k=T(f);C.push(new l(this.a.length,{line:0,column:0},{line:k.length-1,column:f.length-k[k.length-1]},k.length-1,f.length)),this.a.push(new w(f,k))}const u=T(t);return C.push(new l(this.a.length,{line:0,column:0},{line:u.length-1,column:t.length-u[u.length-1]},u.length-1,t.length)),this.a.push(new w(t,u)),C}let n=this.a[0].buffer.length;const c=T(t,!1);let h=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===n&&n!==0&&this.L(t)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},h=this.g;for(let C=0;C<c.length;C++)c[C]+=n+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+t,n+=1}else{if(n!==0)for(let C=0;C<c.length;C++)c[C]+=n;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=t}const i=this.a[0].buffer.length,$=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[$],v={line:$,column:a},d=new l(0,h,v,this.t(0,h,v),i-n);return this.g=v,[d]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(t,n=0){let c=this.root,h="";const i=this.h.get2(t);if(i){c=i.node;const $=this.B(c,t-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===t)h=a.substring(v+$,v+c.piece.length);else{const d=this.B(c,t-i.nodeStartLineNumber);return a.substring(v+$,v+d-n)}}else{let $=0;const a=t;for(;c!==O.$zC;)if(c.left!==O.$zC&&c.lf_left>=t-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>t-1){const v=this.B(c,t-c.lf_left-2),d=this.B(c,t-c.lf_left-1),C=this.a[c.piece.bufferIndex].buffer,u=this.u(c.piece.bufferIndex,c.piece.start);return $+=c.size_left,this.h.set({node:c,nodeStartOffset:$,nodeStartLineNumber:a-(t-1-c.lf_left)}),C.substring(u+v,u+d-n)}else if(c.lf_left+c.piece.lineFeedCnt===t-1){const v=this.B(c,t-c.lf_left-2),d=this.a[c.piece.bufferIndex].buffer,C=this.u(c.piece.bufferIndex,c.piece.start);h=d.substring(C+v,C+c.piece.length);break}else t-=c.lf_left+c.piece.lineFeedCnt,$+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==O.$zC;){const $=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),v=this.u(c.piece.bufferIndex,c.piece.start);return h+=$.substring(v,v+a-n),h}else{const a=this.u(c.piece.bufferIndex,c.piece.start);h+=$.substr(a,c.piece.length)}c=c.next()}return h}y(){let t=this.root,n=1,c=0;for(;t!==O.$zC;)n+=t.lf_left+t.piece.lineFeedCnt,c+=t.size_left+t.piece.length,t=t.right;this.b=n,this.c=c,this.h.validate(this.c)}A(t,n){const c=t.piece,h=this.s(t,n),i=h.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===n){const $=this.t(t.piece.bufferIndex,c.start,h);if($!==i)return{index:$,remainder:0}}return{index:i,remainder:h.column}}B(t,n){if(n<0)return 0;const c=t.piece,h=this.a[c.bufferIndex].lineStarts,i=c.start.line+n+1;return i>c.end.line?h[c.end.line]+c.end.column-h[c.start.line]-c.start.column:h[i]-h[c.start.line]-c.start.column}C(t,n){const c=t.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),$=n,a=this.u(c.bufferIndex,$),v=this.t(c.bufferIndex,c.start,$),d=v-h,C=a-i,u=c.length+C;t.piece=new l(c.bufferIndex,c.start,$,v,u),(0,O.$GC)(this,t,C,d)}D(t,n){const c=t.piece,h=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),$=n,a=this.t(c.bufferIndex,$,c.end),v=this.u(c.bufferIndex,$),d=a-h,C=i-v,u=c.length+C;t.piece=new l(c.bufferIndex,$,c.end,a,u),(0,O.$GC)(this,t,C,d)}E(t,n,c){const h=t.piece,i=h.start,$=h.end,a=h.length,v=h.lineFeedCnt,d=n,C=this.t(h.bufferIndex,h.start,d),u=this.u(h.bufferIndex,n)-this.u(h.bufferIndex,i);t.piece=new l(h.bufferIndex,h.start,d,C,u),(0,O.$GC)(this,t,u-a,C-v);const D=new l(h.bufferIndex,c,$,this.t(h.bufferIndex,c,$),this.u(h.bufferIndex,$)-this.u(h.bufferIndex,c)),f=this.S(t,D);this.N(f)}F(t,n){this.Q(n,t)&&(n+=`
`);const c=this.K()&&this.L(n)&&this.M(t),h=this.a[0].buffer.length;this.a[0].buffer+=n;const i=T(n,!1);for(let f=0;f<i.length;f++)i[f]+=h;if(c){const f=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:h-f}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const $=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[$],v={line:$,column:a},d=t.piece.length+n.length,C=t.piece.lineFeedCnt,u=this.t(0,t.piece.start,v),D=u-C;t.piece=new l(t.piece.bufferIndex,t.piece.start,v,u,d),this.g=v,(0,O.$GC)(this,t,n.length,D)}G(t){let n=this.root;const c=this.h.get(t);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:t-c.nodeStartOffset};let h=0;for(;n!==O.$zC;)if(n.size_left>t)n=n.left;else if(n.size_left+n.piece.length>=t){h+=n.size_left;const i={node:n,remainder:t-n.size_left,nodeStartOffset:h};return this.h.set(i),i}else t-=n.size_left+n.piece.length,h+=n.size_left+n.piece.length,n=n.right;return null}H(t,n){let c=this.root,h=0;for(;c!==O.$zC;)if(c.left!==O.$zC&&c.lf_left>=t-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>t-1){const i=this.B(c,t-c.lf_left-2),$=this.B(c,t-c.lf_left-1);return h+=c.size_left,{node:c,remainder:Math.min(i+n-1,$),nodeStartOffset:h}}else if(c.lf_left+c.piece.lineFeedCnt===t-1){const i=this.B(c,t-c.lf_left-2);if(i+n-1<=c.piece.length)return{node:c,remainder:i+n-1,nodeStartOffset:h};n-=c.piece.length-i;break}else t-=c.lf_left+c.piece.lineFeedCnt,h+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==O.$zC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),$=this.J(c);return{node:c,remainder:Math.min(n-1,i),nodeStartOffset:$}}else if(c.piece.length>=n-1){const i=this.J(c);return{node:c,remainder:n-1,nodeStartOffset:i}}else n-=c.piece.length;c=c.next()}return null}I(t,n){if(t.piece.lineFeedCnt<1)return-1;const c=this.a[t.piece.bufferIndex],h=this.u(t.piece.bufferIndex,t.piece.start)+n;return c.buffer.charCodeAt(h)}J(t){if(!t)return 0;let n=t.size_left;for(;t!==this.root;)t.parent.right===t&&(n+=t.parent.size_left+t.parent.piece.length),t=t.parent;return n}K(){return!(this.f&&this.d===`
`)}L(t){if(typeof t=="string")return t.charCodeAt(0)===10;if(t===O.$zC||t.piece.lineFeedCnt===0)return!1;const n=t.piece,c=this.a[n.bufferIndex].lineStarts,h=n.start.line,i=c[h]+n.start.column;return h===c.length-1||c[h+1]>i+1?!1:this.a[n.bufferIndex].buffer.charCodeAt(i)===10}M(t){return typeof t=="string"?t.charCodeAt(t.length-1)===13:t===O.$zC||t.piece.lineFeedCnt===0?!1:this.I(t,t.piece.length-1)===13}N(t){if(this.K()&&this.L(t)){const n=t.prev();this.M(n)&&this.P(n,t)}}O(t){if(this.K()&&this.M(t)){const n=t.next();this.L(n)&&this.P(t,n)}}P(t,n){const c=[],h=this.a[t.piece.bufferIndex].lineStarts;let i;t.piece.end.column===0?i={line:t.piece.end.line-1,column:h[t.piece.end.line]-h[t.piece.end.line-1]-1}:i={line:t.piece.end.line,column:t.piece.end.column-1};const $=t.piece.length-1,a=t.piece.lineFeedCnt-1;t.piece=new l(t.piece.bufferIndex,t.piece.start,i,a,$),(0,O.$GC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const v={line:n.piece.start.line+1,column:0},d=n.piece.length-1,C=this.t(n.piece.bufferIndex,v,n.piece.end);n.piece=new l(n.piece.bufferIndex,v,n.piece.end,C,d),(0,O.$GC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const u=this.w(`\r
`);this.S(t,u[0]);for(let D=0;D<c.length;D++)(0,O.$EC)(this,c[D])}Q(t,n){if(this.K()&&this.M(t)){const c=n.next();if(this.L(c)){if(t+=`
`,c.piece.length===1)(0,O.$EC)(this,c);else{const h=c.piece,i={line:h.start.line+1,column:0},$=h.length-1,a=this.t(h.bufferIndex,i,h.end);c.piece=new l(h.bufferIndex,i,h.end,a,$),(0,O.$GC)(this,c,-1,-1)}return!0}}return!1}iterate(t,n){if(t===O.$zC)return n(O.$zC);const c=this.iterate(t.left,n);return c&&n(t)&&this.iterate(t.right,n)}R(t){if(t===O.$zC)return"";const n=this.a[t.piece.bufferIndex],c=t.piece,h=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return n.buffer.substring(h,i)}getPieceContent(t){const n=this.a[t.bufferIndex],c=this.u(t.bufferIndex,t.start),h=this.u(t.bufferIndex,t.end);return n.buffer.substring(c,h)}S(t,n){const c=new O.$yC(n,1);if(c.left=O.$zC,c.right=O.$zC,c.parent=O.$zC,c.size_left=0,c.lf_left=0,this.root===O.$zC)this.root=c,c.color=0;else if(t.right===O.$zC)t.right=c,c.parent=t;else{const i=(0,O.$AC)(t.right);i.left=c,c.parent=i}return(0,O.$FC)(this,c),c}T(t,n){const c=new O.$yC(n,1);if(c.left=O.$zC,c.right=O.$zC,c.parent=O.$zC,c.size_left=0,c.lf_left=0,this.root===O.$zC)this.root=c,c.color=0;else if(t.left===O.$zC)t.left=c,c.parent=t;else{const h=(0,O.$BC)(t.left);h.right=c,c.parent=h}return(0,O.$FC)(this,c),c}U(t){let n="";return this.iterate(t,c=>(n+=this.R(c),!0)),n}}e.$SC=o}),define(Ce[137],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G9=e.$F9=void 0;class S{constructor(){this.a=new Map}removeDragOperationTransfer(O){if(O&&this.a.has(O)){const M=this.a.get(O);return this.a.delete(O),M}}addDragOperationTransfer(O,M){this.a.set(O,M)}}e.$F9=S;class N{constructor(O){this.identifier=O}}e.$G9=N}),define(Ce[138],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(Ce[139],Ae([1,0,5,6,138]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=void 0,e.$fj=T;class O extends N.$Vc{constructor(l,w="",m="",s=!0,o){super(),this.h=this.B(new S.$ee),this.onDidChange=this.h.event,this.w=!0,this.j=l,this.m=w,this.u=m,this.w=s,this.C=o}get id(){return this.j}get label(){return this.m}set label(l){this.D(l)}D(l){this.m!==l&&(this.m=l,this.h.fire({label:l}))}get tooltip(){return this.n||""}set tooltip(l){this.F(l)}F(l){this.n!==l&&(this.n=l,this.h.fire({tooltip:l}))}get class(){return this.u}set class(l){this.G(l)}G(l){this.u!==l&&(this.u=l,this.h.fire({class:l}))}get enabled(){return this.w}set enabled(l){this.H(l)}H(l){this.w!==l&&(this.w=l,this.h.fire({enabled:l}))}get checked(){return this.z}set checked(l){this.I(l)}I(l){this.z!==l&&(this.z=l,this.h.fire({checked:l}))}async run(l,w){this.C&&await this.C(l)}}e.$aj=O;class M extends N.$Vc{constructor(){super(...arguments),this.f=this.B(new S.$ee),this.onWillRun=this.f.event,this.m=this.B(new S.$ee),this.onDidRun=this.m.event}async run(l,w){if(!l.enabled)return;this.f.fire({action:l});let m;try{await this.u(l,w)}catch(s){m=s}this.m.fire({action:l,error:m})}async u(l,w){await l.run(w)}}e.$bj=M;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...l){let w=[];for(const m of l)m.length&&(w.length?w=[...w,new p,...m]:w=m);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$cj=p;class g{get actions(){return this.a}constructor(l,w,m,s){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=w,this.class=s,this.a=m}async run(){}}e.$dj=g;class E extends O{static{this.ID="vs.actions.empty"}constructor(){super(E.ID,R.localize(0,null),void 0,!1)}}e.$ej=E;function T(y){return{id:y.id,label:y.label,class:y.class,enabled:y.enabled??!0,checked:y.checked,run:async(...l)=>y.run(...l),tooltip:y.label}}}),define(Ce[140],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(Ce[141],Ae([1,0,140]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=E,e.$2m=T,e.$3m=y;const N=60,R=N*60,O=R*24,M=O*7,p=O*30,g=O*365;function E(l,w,m,s){typeof l!="number"&&(l=l.getTime());const o=Math.round((new Date().getTime()-l)/1e3);if(o<-30)return(0,S.localize)(0,null,E(new Date().getTime()+o*1e3,!1));if(!s&&o<30)return(0,S.localize)(1,null);let r;return o<N?(r=o,w?r===1?m?(0,S.localize)(2,null,r):(0,S.localize)(3,null,r):m?(0,S.localize)(4,null,r):(0,S.localize)(5,null,r):r===1?m?(0,S.localize)(6,null,r):(0,S.localize)(7,null,r):m?(0,S.localize)(8,null,r):(0,S.localize)(9,null,r)):o<R?(r=Math.floor(o/N),w?r===1?m?(0,S.localize)(10,null,r):(0,S.localize)(11,null,r):m?(0,S.localize)(12,null,r):(0,S.localize)(13,null,r):r===1?m?(0,S.localize)(14,null,r):(0,S.localize)(15,null,r):m?(0,S.localize)(16,null,r):(0,S.localize)(17,null,r)):o<O?(r=Math.floor(o/R),w?r===1?m?(0,S.localize)(18,null,r):(0,S.localize)(19,null,r):m?(0,S.localize)(20,null,r):(0,S.localize)(21,null,r):r===1?m?(0,S.localize)(22,null,r):(0,S.localize)(23,null,r):m?(0,S.localize)(24,null,r):(0,S.localize)(25,null,r)):o<M?(r=Math.floor(o/O),w?r===1?(0,S.localize)(26,null,r):(0,S.localize)(27,null,r):r===1?(0,S.localize)(28,null,r):(0,S.localize)(29,null,r)):o<p?(r=Math.floor(o/M),w?r===1?m?(0,S.localize)(30,null,r):(0,S.localize)(31,null,r):m?(0,S.localize)(32,null,r):(0,S.localize)(33,null,r):r===1?m?(0,S.localize)(34,null,r):(0,S.localize)(35,null,r):m?(0,S.localize)(36,null,r):(0,S.localize)(37,null,r)):o<g?(r=Math.floor(o/p),w?r===1?m?(0,S.localize)(38,null,r):(0,S.localize)(39,null,r):m?(0,S.localize)(40,null,r):(0,S.localize)(41,null,r):r===1?m?(0,S.localize)(42,null,r):(0,S.localize)(43,null,r):m?(0,S.localize)(44,null,r):(0,S.localize)(45,null,r)):(r=Math.floor(o/g),w?r===1?m?(0,S.localize)(46,null,r):(0,S.localize)(47,null,r):m?(0,S.localize)(48,null,r):(0,S.localize)(49,null,r):r===1?m?(0,S.localize)(50,null,r):(0,S.localize)(51,null,r):m?(0,S.localize)(52,null,r):(0,S.localize)(53,null,r))}function T(l,w){const m=Math.abs(l/1e3);return m<1?w?(0,S.localize)(54,null,l):(0,S.localize)(55,null,l):m<N?w?(0,S.localize)(56,null,Math.round(l)/1e3):(0,S.localize)(57,null,Math.round(l)/1e3):m<R?w?(0,S.localize)(58,null,Math.round(l/(1e3*N))):(0,S.localize)(59,null,Math.round(l/(1e3*N))):m<O?w?(0,S.localize)(60,null,Math.round(l/(1e3*R))):(0,S.localize)(61,null,Math.round(l/(1e3*R))):(0,S.localize)(62,null,Math.round(l/(1e3*O)))}function y(l){return l.getFullYear()+"-"+String(l.getMonth()+1).padStart(2,"0")+"-"+String(l.getDate()).padStart(2,"0")+"T"+String(l.getHours()).padStart(2,"0")+":"+String(l.getMinutes()).padStart(2,"0")+":"+String(l.getSeconds()).padStart(2,"0")+"."+(l.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Ce[142],Ae([9,10]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(Ce[43],Ae([1,0,18,17,142]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gj=g,e.$hj=E,e.$ij=T;function O(y,l){return l&&(y.stack||y.stacktrace)?R.localize(0,null,p(y),M(y.stack)||M(y.stacktrace)):p(y)}function M(y){return Array.isArray(y)?y.join(`
`):y}function p(y){return y.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${y.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?R.localize(1,null,y.message):y.message||R.localize(2,null)}function g(y=null,l=!1){if(!y)return R.localize(3,null);if(Array.isArray(y)){const w=S.$Hb(y),m=g(w[0],l);return w.length>1?R.localize(4,null,m,w.length):m}if(N.$8f(y))return y;if(y.detail){const w=y.detail;if(w.error)return O(w.error,l);if(w.exception)return O(w.exception,l)}return y.stack?O(y,l):y.message?y.message:R.localize(5,null)}function E(y){const l=y;return l instanceof Error&&Array.isArray(l.actions)}function T(y,l){let w;return typeof y=="string"?w=new Error(y):w=y,w.actions=l,w}}),define(Ce[143],Ae([1,0,41,19]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fr=p,e.$gr=g,e.$hr=E,e.$ir=T,e.$jr=y,e.$kr=l,e.$lr=w,e.$mr=m,e.$nr=s,e.$or=o,e.$pr=d,e.$qr=C,e.$rr=u;const R=new S.$V(()=>{const D=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:D,collatorIsNumeric:D.resolvedOptions().numeric}}),O=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),M=new S.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(D,f,k=!1){const b=D||"",P=f||"",I=R.value.collator.compare(b,P);return R.value.collatorIsNumeric&&I===0&&b!==P?b<P?-1:1:I}function g(D,f){const k=O.value.collator;return D=D||"",f=f||"",c(k,D,f)}function E(D,f){const k=O.value.collator;return D=D||"",f=f||"",a(D,f)||c(k,D,f)}function T(D,f){const k=O.value.collator;return D=D||"",f=f||"",$(D,f)||c(k,D,f)}function y(D,f){return D=D||"",f=f||"",D===f?0:D<f?-1:1}function l(D,f){const[k,b]=t(D),[P,I]=t(f);let W=R.value.collator.compare(b,I);if(W===0){if(R.value.collatorIsNumeric&&b!==I)return b<I?-1:1;if(W=R.value.collator.compare(k,P),R.value.collatorIsNumeric&&W===0&&k!==P)return k<P?-1:1}return W}function w(D,f){D=D||"",f=f||"";const k=n(D),b=n(f),P=O.value.collator,I=M.value.collator;return c(I,k,b)||c(P,D,f)}function m(D,f){D=D||"",f=f||"";const k=n(D),b=n(f),P=O.value.collator,I=M.value.collator;return c(I,k,b)||a(D,f)||c(P,D,f)}function s(D,f){D=D||"",f=f||"";const k=n(D),b=n(f),P=O.value.collator,I=M.value.collator;return c(I,k,b)||$(D,f)||c(P,D,f)}function o(D,f){D=D||"",f=f||"";const k=n(D).toLowerCase(),b=n(f).toLowerCase();return k!==b?k<b?-1:1:D!==f?D<f?-1:1:0}const r=/^(.*?)(\.([^.]*))?$/;function t(D,f=!1){const k=D?r.exec(D):[];let b=[k&&k[1]||"",k&&k[3]||""];return f&&(!b[0]&&b[1]||b[0]&&b[0].charAt(0)===".")&&(b=[b[0]+"."+b[1],""]),b}function n(D){const f=D?r.exec(D):[];return f&&f[1]&&f[1].charAt(0)!=="."&&f[3]||""}function c(D,f,k){const b=D.compare(f,k);return b!==0?b:f.length!==k.length?f.length<k.length?-1:1:0}function h(D){const f=D.charAt(0);return f.toLocaleUpperCase()!==f}function i(D){const f=D.charAt(0);return f.toLocaleLowerCase()!==f}function $(D,f){return h(D)&&i(f)?-1:i(D)&&h(f)?1:0}function a(D,f){return i(D)&&h(f)?-1:h(D)&&i(f)?1:0}function v(D,f,k=!1){return k||(D=D&&D.toLowerCase(),f=f&&f.toLowerCase()),D===f?0:D<f?-1:1}function d(D,f,k=!1){const b=D.split(N.sep),P=f.split(N.sep),I=b.length-1,W=P.length-1;let V,q;for(let A=0;;A++){if(V=I===A,q=W===A,V&&q)return p(b[A],P[A],k);if(V)return-1;if(q)return 1;const j=v(b[A],P[A],k);if(j!==0)return j}}function C(D,f,k){const b=D.toLowerCase(),P=f.toLowerCase(),I=u(D,f,k);if(I)return I;const W=b.endsWith(k),V=P.endsWith(k);if(W!==V)return W?-1:1;const q=p(b,P);return q!==0?q:b.localeCompare(P)}function u(D,f,k){const b=D.toLowerCase(),P=f.toLowerCase(),I=b.startsWith(k),W=P.startsWith(k);if(I!==W)return I?-1:1;if(I&&W){if(b.length<P.length)return-1;if(b.length>P.length)return 1}return 0}}),define(Ce[47],Ae([1,0,19,21,15,17]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ng=M,e.$og=p,e.$pg=g,e.$qg=E,e.$rg=T,e.$sg=m,e.$tg=s,e.$ug=o,e.$vg=r,e.$wg=t,e.$xg=n,e.$yg=c,e.$zg=h,e.$Ag=i,e.$Bg=$,e.$Cg=a,e.$Dg=C;function M(u){return u===47||u===92}function p(u){return u.replace(/[\\/]/g,S.$hc.sep)}function g(u){return u.indexOf("/")===-1&&(u=p(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}function E(u,D=S.$hc.sep){if(!u)return"";const f=u.length,k=u.charCodeAt(0);if(M(k)){if(M(u.charCodeAt(1))&&!M(u.charCodeAt(2))){let P=3;const I=P;for(;P<f&&!M(u.charCodeAt(P));P++);if(I!==P&&!M(u.charCodeAt(P+1))){for(P+=1;P<f;P++)if(M(u.charCodeAt(P)))return u.slice(0,P+1).replace(/[\\/]/g,D)}}return D}else if(r(k)&&u.charCodeAt(1)===58)return M(u.charCodeAt(2))?u.slice(0,2)+D:u.slice(0,2);let b=u.indexOf("://");if(b!==-1){for(b+=3;b<f;b++)if(M(u.charCodeAt(b)))return u.slice(0,b+1)}return""}function T(u){if(!N.$i||!u||u.length<5)return!1;let D=u.charCodeAt(0);if(D!==92||(D=u.charCodeAt(1),D!==92))return!1;let f=2;const k=f;for(;f<u.length&&(D=u.charCodeAt(f),D!==92);f++);return!(k===f||(D=u.charCodeAt(f+1),isNaN(D)||D===92))}const y=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(u,D=N.$i){const f=D?y:l;return!(!u||u.length===0||/^\s+$/.test(u)||(f.lastIndex=0,f.test(u))||D&&w.test(u)||u==="."||u===".."||D&&u[u.length-1]==="."||D&&u.length!==u.trim().length||u.length>255)}function s(u,D,f){const k=u===D;return!f||k?k:!u||!D?!1:(0,R.$xf)(u,D)}function o(u,D,f,k=S.sep){if(u===D)return!0;if(!u||!D||D.length>u.length)return!1;if(f){if(!(0,R.$yf)(u,D))return!1;if(D.length===u.length)return!0;let P=D.length;return D.charAt(D.length-1)===k&&P--,u.charAt(P)===k}return D.charAt(D.length-1)!==k&&(D+=k),u.indexOf(D)===0}function r(u){return u>=65&&u<=90||u>=97&&u<=122}function t(u,D){return N.$i&&u.endsWith(":")&&(u+=S.sep),(0,S.$jc)(u)||(u=(0,S.$kc)(D,u)),u=(0,S.$ic)(u),n(u)}function n(u){return N.$i?(u=(0,R.$ff)(u,S.sep),u.endsWith(":")&&(u+=S.sep)):(u=(0,R.$ff)(u,S.sep),u||(u=S.sep)),u}function c(u){const D=(0,S.$ic)(u);return N.$i?u.length>3?!1:h(D)&&(u.length===2||D.charCodeAt(2)===92):D===S.$hc.sep}function h(u,D=N.$i){return D?r(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}function i(u,D=N.$i){return h(u,D)?u[0]:void 0}function $(u,D,f){return D.length>u.length?-1:u===D?0:(f&&(u=u.toLowerCase(),D=D.toLowerCase()),u.indexOf(D))}function a(u){const D=u.split(":");let f,k,b;for(const P of D){const I=Number(P);(0,O.$_f)(I)?k===void 0?k=I:b===void 0&&(b=I):f=f?[f,P].join(":"):P}if(!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:k!==void 0?k:void 0,column:b!==void 0?b:k!==void 0?1:void 0}}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(u,D,f=8){let k="";for(let P=0;P<f;P++){let I;P===0&&N.$i&&!D&&(f===3||f===4)?I=d:I=v,k+=I.charAt(Math.floor(Math.random()*I.length))}let b;return D?b=`${D}-${k}`:b=k,u?(0,S.$kc)(u,b):b}}),define(Ce[69],Ae([1,0,19]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ps=void 0,e.$Qs=O,e.$Rs=M,e.$Ss=p,e.$Ts=E,e.$Ps=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},R={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(T){const y=(0,S.$pc)(T),l=N[y.toLowerCase()];return l!==void 0?l:M(T)}function M(T){const y=(0,S.$pc)(T);return R[y.toLowerCase()]}function p(T){for(const y in R)if(R[y]===T)return y}const g=/^(.+)\/(.+?)(;.+)?$/;function E(T,y){const l=g.exec(T);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:y?void 0:T}}),define(Ce[53],Ae([1,0,22,2]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=R,e.$4h=O,e.$5h=p;function R(g){return JSON.stringify(g,M)}function O(g){let E=JSON.parse(g);return E=p(E),E}function M(g,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:E.flags}:E}function p(g,E=0){if(!g||E>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return N.URI.revive(g);case 2:return new RegExp(g.source,g.flags);case 17:return new Date(g.source)}if(g instanceof S.$Fe||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let T=0;T<g.length;++T)g[T]=p(g[T],E+1);else for(const T in g)Object.hasOwnProperty.call(g,T)&&(g[T]=p(g[T],E+1))}return g}}),define(Ce[12],Ae([1,0,14,21,15,2,19]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Ig=e.$Hg=e.$Gg=e.Schemas=void 0,e.$Eg=g,e.$Fg=E,e.$Jg=y;var p;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatCodeBlock="vscode-chat-code-block",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm",m.commentsInput="comment",m.codeSetting="code-setting"})(p||(e.Schemas=p={}));function g(m,s){return O.URI.isUri(m)?(0,R.$xf)(m.scheme,s):(0,R.$yf)(m,s+":")}function E(m,...s){return s.some(o=>g(m,o))}e.$Gg="vscode-tkn",e.$Hg="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s,o){this.f=y(s,o)}getServerRootPath(){return this.f}get g(){return M.$hc.join(this.f,p.vscodeRemoteResource)}set(s,o,r){this.a[s]=o,this.b[s]=r}setConnectionToken(s,o){this.c[s]=o}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(h){return S.$1(h),s}const o=s.authority;let r=this.a[o];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const t=this.b[o],n=this.c[o];let c=`path=${encodeURIComponent(s.path)}`;return typeof n=="string"&&(c+=`&${e.$Hg}=${encodeURIComponent(n)}`),O.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${r}:${t}`,path:this.g,query:c})}}e.$Ig=new T;function y(m,s){return M.$hc.join(s??"/",`${m.quality??"oss"}-${m.commit??"dev"}`)}e.$Kg="vs/../../extensions",e.$Lg="vs/../../node_modules",e.$Mg="vs/../../node_modules.asar",e.$Ng="vs/../../node_modules.asar.unpacked",e.$Og="vscode-app";class l{static{this.a=e.$Og}asBrowserUri(s){const o=this.b(s,ge);return this.uriToBrowserUri(o)}uriToBrowserUri(s){return s.scheme===p.vscodeRemote?e.$Ig.rewrite(s):s.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${l.a}`)?s.with({scheme:p.vscodeFileResource,authority:s.authority||l.a,query:null,fragment:null}):s}asFileUri(s){const o=this.b(s,ge);return this.uriToFileUri(o)}uriToFileUri(s){return s.scheme===p.vscodeFileResource?s.with({scheme:p.file,authority:s.authority!==l.a?s.authority:null,query:null,fragment:null}):s}b(s,o){return O.URI.isUri(s)?s:O.URI.parse(o.toUrl(s))}}e.$Pg=new l;var w;(function(m){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(s.get("3"));const o="vscode-coi";function r(n){let c;typeof n=="string"?c=new URL(n).searchParams:n instanceof URL?c=n.searchParams:O.URI.isUri(n)&&(c=new URL(n.toString(!0)).searchParams);const h=c?.get(o);if(h)return s.get(h)}m.getHeadersFromQuery=r;function t(n,c,h){if(!globalThis.crossOriginIsolated)return;const i=c&&h?"3":h?"2":"1";n instanceof URLSearchParams?n.set(o,i):n[o]=i}m.addSearchParam=t})(w||(e.COI=w={}))}),define(Ce[23],Ae([1,0,47,12,19,21,15,2]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=void 0,e.$Wg=g,e.$fh=T,e.$gh=l;function g(w){return(0,p.$xc)(w,!0)}class E{constructor(m){this.a=m}compare(m,s,o=!1){return m===s?0:(0,M.$qf)(this.getComparisonKey(m,o),this.getComparisonKey(s,o))}isEqual(m,s,o=!1){return m===s?!0:!m||!s?!1:this.getComparisonKey(m,o)===this.getComparisonKey(s,o)}getComparisonKey(m,s=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:s?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,s,o=!1){if(m.scheme===s.scheme){if(m.scheme===N.Schemas.file)return S.$ug(g(m),g(s),this.a(m))&&m.query===s.query&&(o||m.fragment===s.fragment);if((0,e.$bh)(m.authority,s.authority))return S.$ug(m.path,s.path,this.a(m),"/")&&m.query===s.query&&(o||m.fragment===s.fragment)}return!1}joinPath(m,...s){return p.URI.joinPath(m,...s)}basenameOrAuthority(m){return(0,e.$6g)(m)||m.authority}basename(m){return R.$hc.basename(m.path)}extname(m){return R.$hc.extname(m.path)}dirname(m){if(m.path.length===0)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(R.$nc(g(m))).path:(s=R.$hc.dirname(m.path),m.authority&&s.length&&s.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),s="/")),m.with({path:s})}normalizePath(m){if(!m.path.length)return m;let s;return m.scheme===N.Schemas.file?s=p.URI.file(R.$ic(g(m))).path:s=R.$hc.normalize(m.path),m.with({path:s})}relativePath(m,s){if(m.scheme!==s.scheme||!(0,e.$bh)(m.authority,s.authority))return;if(m.scheme===N.Schemas.file){const t=R.$mc(g(m),g(s));return O.$i?S.$og(t):t}let o=m.path||"/";const r=s.path||"/";if(this.a(m)){let t=0;for(const n=Math.min(o.length,r.length);t<n&&!(o.charCodeAt(t)!==r.charCodeAt(t)&&o.charAt(t).toLowerCase()!==r.charAt(t).toLowerCase());t++);o=r.substr(0,t)+o.substr(t)}return R.$hc.relative(o,r)}resolvePath(m,s){if(m.scheme===N.Schemas.file){const o=p.URI.file(R.$lc(g(m),s));return m.with({authority:o.authority,path:o.path})}return s=S.$pg(s),m.with({path:R.$hc.resolve(m.path,s)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,s){return m===s||m!==void 0&&s!==void 0&&(0,M.$xf)(m,s)}hasTrailingPathSeparator(m,s=R.sep){if(m.scheme===N.Schemas.file){const o=g(m);return o.length>S.$qg(o).length&&o[o.length-1]===s}else{const o=m.path;return o.length>1&&o.charCodeAt(o.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,s=R.sep){return(0,e.$ch)(m,s)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,s=R.sep){let o=!1;if(m.scheme===N.Schemas.file){const r=g(m);o=r!==void 0&&r.length===S.$qg(r).length&&r[r.length-1]===s}else{s="/";const r=m.path;o=r.length===1&&r.charCodeAt(r.length-1)===47}return!o&&!(0,e.$ch)(m,s)?m.with({path:m.path+"/"}):m}}e.$Xg=E,e.$Yg=new E(()=>!1),e.$Zg=new E(w=>w.scheme===N.Schemas.file?!O.$k:!0),e.$1g=new E(w=>!0),e.$2g=e.$Yg.isEqual.bind(e.$Yg),e.$3g=e.$Yg.isEqualOrParent.bind(e.$Yg),e.$4g=e.$Yg.getComparisonKey.bind(e.$Yg),e.$5g=e.$Yg.basenameOrAuthority.bind(e.$Yg),e.$6g=e.$Yg.basename.bind(e.$Yg),e.$7g=e.$Yg.extname.bind(e.$Yg),e.$8g=e.$Yg.dirname.bind(e.$Yg),e.$9g=e.$Yg.joinPath.bind(e.$Yg),e.$0g=e.$Yg.normalizePath.bind(e.$Yg),e.$$g=e.$Yg.relativePath.bind(e.$Yg),e.$_g=e.$Yg.resolvePath.bind(e.$Yg),e.$ah=e.$Yg.isAbsolutePath.bind(e.$Yg),e.$bh=e.$Yg.isEqualAuthority.bind(e.$Yg),e.$ch=e.$Yg.hasTrailingPathSeparator.bind(e.$Yg),e.$dh=e.$Yg.removeTrailingPathSeparator.bind(e.$Yg),e.$eh=e.$Yg.addTrailingPathSeparator.bind(e.$Yg);function T(w,m){const s=[];for(let o=0;o<w.length;o++){const r=m(w[o]);w.some((t,n)=>n===o?!1:(0,e.$3g)(r,m(t)))||s.push(w[o])}return s}var y;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function m(s){const o=new Map;s.path.substring(s.path.indexOf(";")+1,s.path.lastIndexOf(";")).split(";").forEach(n=>{const[c,h]=n.split(":");c&&h&&o.set(c,h)});const t=s.path.substring(0,s.path.indexOf(";"));return t&&o.set(w.META_DATA_MIME,t),o}w.parseMetaData=m})(y||(e.DataUri=y={}));function l(w,m,s){if(m){let o=w.path;return o&&o[0]!==R.$hc.sep&&(o=R.$hc.sep+o),w.with({scheme:s,authority:m,path:o})}return w.with({scheme:s})}}),define(Ce[11],Ae([1,0,24,14,5,6,23,21,130,41]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yh=e.$Wh=e.$Vh=e.$Uh=e.$Th=e.Promises=e.$Sh=e.$Rh=e.$Qh=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=e.$Ch=e.$Bh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.$qh=e.$ph=void 0,e.$hh=T,e.$ih=y,e.$jh=l,e.$kh=w,e.$lh=m,e.$mh=s,e.$nh=o,e.$oh=r,e.$wh=C,e.$xh=u,e.$yh=D,e.$zh=f,e.$Ah=k,e.$Ph=Ie,e.$Xh=Ee;function T(fe){return!!fe&&typeof fe.then=="function"}function y(fe){const Y=new S.$pe,X=fe(Y.token),le=new Promise((ue,Te)=>{const he=Y.token.onCancellationRequested(()=>{he.dispose(),Te(new N.$5)});Promise.resolve(X).then(Pe=>{he.dispose(),Y.dispose(),ue(Pe)},Pe=>{he.dispose(),Y.dispose(),Te(Pe)})});return new class{cancel(){Y.cancel(),Y.dispose()}then(ue,Te){return le.then(ue,Te)}catch(ue){return this.then(void 0,ue)}finally(ue){return le.finally(ue)}}}function l(fe,Y,X){return new Promise((le,ue)=>{const Te=Y.onCancellationRequested(()=>{Te.dispose(),le(X)});fe.then(le,ue).finally(()=>Te.dispose())})}function w(fe,Y){return new Promise((X,le)=>{const ue=Y.onCancellationRequested(()=>{ue.dispose(),le(new N.$5)});fe.then(X,le).finally(()=>ue.dispose())})}async function m(fe){let Y=-1;const X=fe.map((le,ue)=>le.then(Te=>(Y=ue,Te)));try{return await Promise.race(X)}finally{fe.forEach((le,ue)=>{ue!==Y&&le.cancel()})}}function s(fe,Y,X){let le;const ue=setTimeout(()=>{le?.(void 0),X?.()},Y);return Promise.race([fe.finally(()=>clearTimeout(ue)),new Promise(Te=>le=Te)])}function o(fe){return new Promise((Y,X)=>{const le=fe();T(le)?le.then(Y,X):Y(le)})}function r(){let fe,Y;return{promise:new Promise((le,ue)=>{fe=le,Y=ue}),resolve:fe,reject:Y}}class t{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Y){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Y,!this.b){const X=()=>{if(this.b=null,this.f)return;const le=this.queue(this.d);return this.d=null,le};this.b=new Promise(le=>{this.a.then(X,X).then(le)})}return new Promise((X,le)=>{this.b.then(X,le)})}return this.a=Y(),new Promise((X,le)=>{this.a.then(ue=>{this.a=null,X(ue)},ue=>{this.a=null,le(ue)})})}dispose(){this.f=!0}}e.$ph=t;class n{constructor(){this.a=Promise.resolve(null)}queue(Y){return this.a=this.a.then(()=>Y(),()=>Y())}}e.$qh=n;class c{constructor(){this.a=new Map}queue(Y,X){const ue=(this.a.get(Y)??Promise.resolve()).catch(()=>{}).then(X).finally(()=>{this.a.get(Y)===ue&&this.a.delete(Y)});return this.a.set(Y,ue),ue}}e.$rh=c;const h=(fe,Y)=>{let X=!0;const le=setTimeout(()=>{X=!1,Y()},fe);return{isTriggered:()=>X,dispose:()=>{clearTimeout(le),X=!1}}},i=fe=>{let Y=!0;return queueMicrotask(()=>{Y&&(Y=!1,fe())}),{isTriggered:()=>Y,dispose:()=>{Y=!1}}};class ${constructor(Y){this.defaultDelay=Y,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Y,X=this.defaultDelay){this.g=Y,this.h(),this.b||(this.b=new Promise((ue,Te)=>{this.d=ue,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ue=this.g;return this.g=null,ue()}}));const le=()=>{this.a=null,this.d?.(null)};return this.a=X===g.$be?i(le):h(X,le),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$sh=$;class a{constructor(Y){this.a=new $(Y),this.b=new t}trigger(Y,X){return this.a.trigger(()=>this.b.queue(Y),X)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$th=a;class v{constructor(){this.a=!1,this.b=new Promise((Y,X)=>{this.d=Y})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$uh=v;class d extends v{constructor(Y){super(),this.f=setTimeout(()=>this.open(),Y)}open(){clearTimeout(this.f),super.open()}}e.$vh=d;function C(fe,Y){return Y?new Promise((X,le)=>{const ue=setTimeout(()=>{Te.dispose(),X()},fe),Te=Y.onCancellationRequested(()=>{clearTimeout(ue),Te.dispose(),le(new N.$5)})}):y(X=>C(fe,X))}function u(fe,Y=0,X){const le=setTimeout(()=>{fe(),X&&ue.dispose()},Y),ue=(0,O.$Tc)(()=>{clearTimeout(le),X?.deleteAndLeak(ue)});return X?.add(ue),ue}function D(fe){const Y=[];let X=0;const le=fe.length;function ue(){return X<le?fe[X++]():null}function Te(he){he!=null&&Y.push(he);const Pe=ue();return Pe?Pe.then(Te):Promise.resolve(Y)}return Promise.resolve(null).then(Te)}function f(fe,Y=le=>!!le,X=null){let le=0;const ue=fe.length,Te=()=>{if(le>=ue)return Promise.resolve(X);const he=fe[le++];return Promise.resolve(he()).then(Ne=>Y(Ne)?Promise.resolve(Ne):Te())};return Te()}function k(fe,Y=le=>!!le,X=null){if(fe.length===0)return Promise.resolve(X);let le=fe.length;const ue=()=>{le=-1;for(const Te of fe)Te.cancel?.()};return new Promise((Te,he)=>{for(const Pe of fe)Pe.then(Ne=>{--le>=0&&Y(Ne)?(ue(),Te(Ne)):le===0&&Te(X)}).catch(Ne=>{--le>=0&&(ue(),he(Ne))})})}class b{constructor(Y){this.a=0,this.b=!1,this.f=Y,this.g=[],this.d=0,this.h=new R.$ee}whenIdle(){return this.size>0?R.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Y){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((X,le)=>{this.g.push({factory:Y,c:X,e:le}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Y=this.g.shift();this.d++;const X=Y.factory();X.then(Y.c,Y.e),X.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Bh=b;class P extends b{constructor(){super(1)}}e.$Ch=P;class I{constructor(){this.a=new de,this.b=0}queue(Y){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Y())):this.a.run(this.b++,Y())}}e.$Dh=I;class W{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Y=new ce;return this.b.add(Y),Y.p}g(){for(const[,Y]of this.a)if(Y.size>0)return!1;return!0}queueSize(Y,X=M.$Yg){const le=X.getComparisonKey(Y);return this.a.get(le)?.size??0}queueFor(Y,X,le=M.$Yg){const ue=le.getComparisonKey(Y);let Te=this.a.get(ue);if(!Te){Te=new P;const he=this.f++,Pe=R.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ue),this.h(),this.d?.deleteAndDispose(he),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new O.$5c),this.d.set(he,Pe),this.a.set(ue,Te)}return Te.queue(X)}h(){this.g()&&this.j()}j(){for(const Y of this.b)Y.complete();this.b.clear()}dispose(){for(const[,Y]of this.a)Y.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Eh=W;class V{constructor(Y,X){this.a=-1,typeof Y=="function"&&typeof X=="number"&&this.setIfNotSet(Y,X)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Y,X){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Y()},X)}setIfNotSet(Y,X){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Y()},X))}}e.$Fh=V;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Y,X,le=globalThis){this.cancel();const ue=le.setInterval(()=>{Y()},X);this.d=(0,O.$Tc)(()=>{le.clearInterval(ue),this.d=void 0})}dispose(){this.cancel()}}e.$Gh=q;class A{constructor(Y,X){this.b=-1,this.a=Y,this.d=X,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Y=this.d){this.cancel(),this.b=setTimeout(this.f,Y)}get delay(){return this.d}set delay(Y){this.d=Y}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Hh=A;class j{constructor(Y,X){X%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${X}ms is not a multiple of 1000ms.`),this.a=Y,this.b=X,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Y=this.b){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Y/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Ih=j;class K extends A{constructor(Y,X){super(Y,X),this.j=[]}work(Y){this.j.push(Y),this.isScheduled()||this.schedule()}h(){const Y=this.j;this.j=[],this.a?.(Y)}dispose(){this.j=[],super.dispose()}}e.$Jh=K;class re extends O.$Vc{constructor(Y,X){super(),this.g=Y,this.h=X,this.a=[],this.b=this.B(new O.$Wc),this.f=!1}get pending(){return this.a.length}work(Y){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Y.length>this.g.maxBufferedWork)return!1}else if(this.pending+Y.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const X of Y)this.a.push(X);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new A(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Kh=re,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Mh=(fe,Y)=>{(0,p.$B)(()=>{if(X)return;const le=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,le-Date.now())}}))});let X=!1;return{dispose(){X||(X=!0)}}}:e.$Mh=(fe,Y,X)=>{const le=fe.requestIdleCallback(Y,typeof X=="number"?{timeout:X}:void 0);let ue=!1;return{dispose(){ue||(ue=!0,fe.cancelIdleCallback(le))}}},e.$Lh=fe=>(0,e.$Mh)(globalThis,fe)}();class ae{constructor(Y,X){this.g=!1,this.d=()=>{try{this.j=X()}catch(le){this.l=le}finally{this.g=!0}},this.f=(0,e.$Mh)(Y,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Nh=ae;class we extends ae{constructor(Y){super(globalThis,Y)}}e.$Oh=we;async function Ie(fe,Y,X){let le;for(let ue=0;ue<X;ue++)try{return await fe()}catch(Te){le=Te,await C(Y)}throw le}class de{isRunning(Y){return typeof Y=="number"?this.a?.taskId===Y:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Y,X,le){return this.a={taskId:Y,cancel:()=>le?.(),promise:X},X.then(()=>this.d(Y),()=>this.d(Y)),X}d(Y){this.a&&Y===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Y=this.b;this.b=void 0,Y.run().then(Y.promiseResolve,Y.promiseReject)}}queue(Y){if(this.b)this.b.run=Y;else{const{promise:X,resolve:le,reject:ue}=r();this.b={run:Y,promise:X,promiseResolve:le,promiseReject:ue}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Qh=de;class me{constructor(Y,X=()=>Date.now()){this.d=Y,this.f=X,this.a=0,this.b=0}increment(){const Y=this.f();return Y-this.a>this.d&&(this.a=Y,this.b=0),this.b++,this.b}}e.$Rh=me;var Me;(function(fe){fe[fe.Resolved=0]="Resolved",fe[fe.Rejected=1]="Rejected"})(Me||(Me={}));class ce{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Y,X)=>{this.a=Y,this.b=X})}complete(Y){return new Promise(X=>{this.a(Y),this.d={outcome:0,value:Y},X()})}error(Y){return new Promise(X=>{this.b(Y),this.d={outcome:1,value:Y},X()})}cancel(){return this.error(new N.$5)}}e.$Sh=ce;var Re;(function(fe){async function Y(le){let ue;const Te=await Promise.all(le.map(he=>he.then(Pe=>Pe,Pe=>{ue||(ue=Pe)})));if(typeof ue<"u")throw ue;return Te}fe.settled=Y;function X(le){return new Promise(async(ue,Te)=>{try{await le(ue,Te)}catch(he){Te(he)}})}fe.withAsyncBody=X})(Re||(e.Promises=Re={}));class ie{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Y){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Y.then(X=>(this.a=X,this.d=!0,X),X=>{throw this.b=X,this.d=!0,X})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Th=ie;class L{constructor(Y){this.b=Y,this.a=new E.$V(()=>new ie(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Uh=L;var x;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Y){return new ve(X=>{X.emitMany(Y)})}static fromPromise(Y){return new ve(async X=>{X.emitMany(await Y)})}static fromPromises(Y){return new ve(async X=>{await Promise.all(Y.map(async le=>X.emitOne(await le)))})}static merge(Y){return new ve(async X=>{await Promise.all(Y.map(async le=>{for await(const ue of le)X.emitOne(ue)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Y,X){this.a=0,this.b=[],this.d=null,this.f=X,this.g=new R.$ee,queueMicrotask(async()=>{const le={emitOne:ue=>this.h(ue),emitMany:ue=>this.j(ue),reject:ue=>this.l(ue)};try{await Promise.resolve(Y(le)),this.k()}catch(ue){this.l(ue)}finally{le.emitOne=void 0,le.emitMany=void 0,le.reject=void 0}})}[Symbol.asyncIterator](){let Y=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Y<this.b.length)return{done:!1,value:this.b[Y++]};if(this.a===1)return{done:!0,value:void 0};await R.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Y,X){return new ve(async le=>{for await(const ue of Y)le.emitOne(X(ue))})}map(Y){return ve.map(this,Y)}static filter(Y,X){return new ve(async le=>{for await(const ue of Y)X(ue)&&le.emitOne(ue)})}filter(Y){return ve.filter(this,Y)}static coalesce(Y){return ve.filter(Y,X=>!!X)}coalesce(){return ve.coalesce(this)}static async toPromise(Y){const X=[];for await(const le of Y)X.push(le);return X}toPromise(){return ve.toPromise(this)}h(Y){this.a===0&&(this.b.push(Y),this.g.fire())}j(Y){this.a===0&&(this.b=this.b.concat(Y),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Y){this.a===0&&(this.a=2,this.d=Y,this.g.fire())}}e.$Vh=ve;class Fe extends ve{constructor(Y,X){super(X),this.m=Y}cancel(){this.m.cancel()}}e.$Wh=Fe;function Ee(fe){const Y=new S.$pe,X=fe(Y.token);return new Fe(Y,async le=>{const ue=Y.token.onCancellationRequested(()=>{ue.dispose(),Y.dispose(),le.reject(new N.$5)});try{for await(const Te of X){if(Y.token.isCancellationRequested)return;le.emitOne(Te)}ue.dispose(),Y.dispose()}catch(Te){ue.dispose(),Y.dispose(),le.reject(Te)}})}class pe{constructor(Y){this.a=new ce,this.b=new ve(ue=>{if(X){ue.reject(X);return}return le&&ue.emitMany(le),this.d=Te=>ue.reject(Te),this.f=Te=>ue.emitOne(Te),this.a.p},Y);let X,le;this.f=ue=>{le||(le=[]),le.push(ue)},this.d=ue=>{X||(X=ue)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Y){this.d(Y),this.a.complete()}emitOne(Y){this.f(Y)}}e.$Yh=pe}),define(Ce[36],Ae([1,0,18,11,47,28,19,21,15]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$kk=E,e.$nk=m,e.$ok=P,e.$pk=I,e.$qk=W,e.$rk=V,e.$sk=q,e.$tk=re;function E(){return Object.create(null)}e.$lk="**",e.$mk="/";const T="[/\\\\]",y="[^/\\\\]",l=/\//g;function w(ae,we){switch(ae){case 0:return"";case 1:return`${y}*?`;default:return`(?:${T}|${y}+${T}${we?`|${T}${y}+`:""})*?`}}function m(ae,we){if(!ae)return[];const Ie=[];let de=!1,me=!1,Me="";for(const ce of ae){switch(ce){case we:if(!de&&!me){Ie.push(Me),Me="";continue}break;case"{":de=!0;break;case"}":de=!1;break;case"[":me=!0;break;case"]":me=!1;break}Me+=ce}return Me&&Ie.push(Me),Ie}function s(ae){if(!ae)return"";let we="";const Ie=m(ae,e.$mk);if(Ie.every(de=>de===e.$lk))we=".*";else{let de=!1;Ie.forEach((me,Me)=>{if(me===e.$lk){if(de)return;we+=w(2,Me===Ie.length-1)}else{let ce=!1,Re="",ie=!1,L="";for(const x of me){if(x!=="}"&&ce){Re+=x;continue}if(ie&&(x!=="]"||!L)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!L?ve="^":x===e.$mk?ve="":ve=(0,g.$_e)(x),L+=ve;continue}switch(x){case"{":ce=!0;continue;case"[":ie=!0;continue;case"}":{const Fe=`(?:${m(Re,",").map(Ee=>s(Ee)).join("|")})`;we+=Fe,ce=!1,Re="";break}case"]":{we+="["+L+"]",ie=!1,L="";break}case"?":we+=y;continue;case"*":we+=w(1);continue;default:we+=(0,g.$_e)(x)}}Me<Ie.length-1&&(Ie[Me+1]!==e.$lk||Me+2<Ie.length)&&(we+=T)}de=me===e.$lk})}return we}const o=/^\*\*\/\*\.[\w\.-]+$/,r=/^\*\*\/([\w\.-]+)\/?$/,t=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,n=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,h=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new O.$Ec(1e4),$=function(){return!1},a=function(){return null};function v(ae,we){if(!ae)return a;let Ie;typeof ae!="string"?Ie=ae.pattern:Ie=ae,Ie=Ie.trim();const de=`${Ie}_${!!we.trimForExclusions}`;let me=i.get(de);if(me)return d(me,ae);let Me;return o.test(Ie)?me=u(Ie.substr(4),Ie):(Me=r.exec(C(Ie,we)))?me=D(Me[1],Ie):(we.trimForExclusions?n:t).test(Ie)?me=f(Ie,we):(Me=c.exec(C(Ie,we)))?me=k(Me[1].substr(1),Ie,!0):(Me=h.exec(C(Ie,we)))?me=k(Me[1],Ie,!1):me=b(Ie),i.set(de,me),d(me,ae)}function d(ae,we){if(typeof we=="string")return ae;const Ie=function(de,me){return(0,R.$ug)(de,we.base,!p.$k)?ae((0,g.$ef)(de.substr(we.base.length),M.sep),me):null};return Ie.allBasenames=ae.allBasenames,Ie.allPaths=ae.allPaths,Ie.basenames=ae.basenames,Ie.patterns=ae.patterns,Ie}function C(ae,we){return we.trimForExclusions&&ae.endsWith("/**")?ae.substr(0,ae.length-2):ae}function u(ae,we){return function(Ie,de){return typeof Ie=="string"&&Ie.endsWith(ae)?we:null}}function D(ae,we){const Ie=`/${ae}`,de=`\\${ae}`,me=function(ce,Re){return typeof ce!="string"?null:Re?Re===ae?we:null:ce===ae||ce.endsWith(Ie)||ce.endsWith(de)?we:null},Me=[ae];return me.basenames=Me,me.patterns=[we],me.allBasenames=Me,me}function f(ae,we){const Ie=K(ae.slice(1,-1).split(",").map(Re=>v(Re,we)).filter(Re=>Re!==a),ae),de=Ie.length;if(!de)return a;if(de===1)return Ie[0];const me=function(Re,ie){for(let L=0,x=Ie.length;L<x;L++)if(Ie[L](Re,ie))return ae;return null},Me=Ie.find(Re=>!!Re.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Re,ie)=>ie.allPaths?Re.concat(ie.allPaths):Re,[]);return ce.length&&(me.allPaths=ce),me}function k(ae,we,Ie){const de=M.sep===M.$hc.sep,me=de?ae:ae.replace(l,M.sep),Me=M.sep+me,ce=M.$hc.sep+ae;let Re;return Ie?Re=function(ie,L){return typeof ie=="string"&&(ie===me||ie.endsWith(Me)||!de&&(ie===ae||ie.endsWith(ce)))?we:null}:Re=function(ie,L){return typeof ie=="string"&&(ie===me||!de&&ie===ae)?we:null},Re.allPaths=[(Ie?"*/":"./")+ae],Re}function b(ae){try{const we=new RegExp(`^${s(ae)}$`);return function(Ie){return we.lastIndex=0,typeof Ie=="string"&&we.test(Ie)?ae:null}}catch{return a}}function P(ae,we,Ie){return!ae||typeof we!="string"?!1:I(ae)(we,void 0,Ie)}function I(ae,we={}){if(!ae)return $;if(typeof ae=="string"||W(ae)){const Ie=v(ae,we);if(Ie===a)return $;const de=function(me,Me){return!!Ie(me,Me)};return Ie.allBasenames&&(de.allBasenames=Ie.allBasenames),Ie.allPaths&&(de.allPaths=Ie.allPaths),de}return A(ae,we)}function W(ae){const we=ae;return we?typeof we.base=="string"&&typeof we.pattern=="string":!1}function V(ae){return ae.allBasenames||[]}function q(ae){return ae.allPaths||[]}function A(ae,we){const Ie=K(Object.getOwnPropertyNames(ae).map(Re=>j(Re,ae[Re],we)).filter(Re=>Re!==a)),de=Ie.length;if(!de)return a;if(!Ie.some(Re=>!!Re.requiresSiblings)){if(de===1)return Ie[0];const Re=function(x,ve){let Fe;for(let Ee=0,pe=Ie.length;Ee<pe;Ee++){const fe=Ie[Ee](x,ve);if(typeof fe=="string")return fe;(0,N.$hh)(fe)&&(Fe||(Fe=[]),Fe.push(fe))}return Fe?(async()=>{for(const Ee of Fe){const pe=await Ee;if(typeof pe=="string")return pe}return null})():null},ie=Ie.find(x=>!!x.allBasenames);ie&&(Re.allBasenames=ie.allBasenames);const L=Ie.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return L.length&&(Re.allPaths=L),Re}const me=function(Re,ie,L){let x,ve;for(let Fe=0,Ee=Ie.length;Fe<Ee;Fe++){const pe=Ie[Fe];pe.requiresSiblings&&L&&(ie||(ie=(0,M.$oc)(Re)),x||(x=ie.substr(0,ie.length-(0,M.$pc)(Re).length)));const fe=pe(Re,ie,x,L);if(typeof fe=="string")return fe;(0,N.$hh)(fe)&&(ve||(ve=[]),ve.push(fe))}return ve?(async()=>{for(const Fe of ve){const Ee=await Fe;if(typeof Ee=="string")return Ee}return null})():null},Me=Ie.find(Re=>!!Re.allBasenames);Me&&(me.allBasenames=Me.allBasenames);const ce=Ie.reduce((Re,ie)=>ie.allPaths?Re.concat(ie.allPaths):Re,[]);return ce.length&&(me.allPaths=ce),me}function j(ae,we,Ie){if(we===!1)return a;const de=v(ae,Ie);if(de===a)return a;if(typeof we=="boolean")return de;if(we){const me=we.when;if(typeof me=="string"){const Me=(ce,Re,ie,L)=>{if(!L||!de(ce,Re))return null;const x=me.replace("$(basename)",()=>ie),ve=L(x);return(0,N.$hh)(ve)?ve.then(Fe=>Fe?ae:null):ve?ae:null};return Me.requiresSiblings=!0,Me}}return de}function K(ae,we){const Ie=ae.filter(Re=>!!Re.basenames);if(Ie.length<2)return ae;const de=Ie.reduce((Re,ie)=>{const L=ie.basenames;return L?Re.concat(L):Re},[]);let me;if(we){me=[];for(let Re=0,ie=de.length;Re<ie;Re++)me.push(we)}else me=Ie.reduce((Re,ie)=>{const L=ie.patterns;return L?Re.concat(L):Re},[]);const Me=function(Re,ie){if(typeof Re!="string")return null;if(!ie){let x;for(x=Re.length;x>0;x--){const ve=Re.charCodeAt(x-1);if(ve===47||ve===92)break}ie=Re.substr(x)}const L=de.indexOf(ie);return L!==-1?me[L]:null};Me.basenames=de,Me.patterns=me,Me.allBasenames=de;const ce=ae.filter(Re=>!Re.basenames);return ce.push(Me),ce}function re(ae,we){return(0,S.$ub)(ae,we,(Ie,de)=>typeof Ie=="string"&&typeof de=="string"?Ie===de:typeof Ie!="string"&&typeof de!="string"?Ie.base===de.base&&Ie.pattern===de.pattern:!1)}}),define(Ce[54],Ae([1,0,14,131,23,15,2]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sk=e.MarkdownStringTextNewlineStyle=void 0,e.$Tk=E,e.$Uk=T,e.$Vk=y,e.$Wk=l,e.$Xk=w,e.$Yk=m,e.$Zk=s,e.$1k=o;var p;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class g{constructor(t="",n=!1){if(this.value=t,typeof this.value!="string")throw(0,S.$7)("value");typeof n=="boolean"?(this.isTrusted=n,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=n.isTrusted??void 0,this.supportThemeIcons=n.supportThemeIcons??!1,this.supportHtml=n.supportHtml??!1)}appendText(t,n=0){return this.value+=l(this.supportThemeIcons?(0,N.$Mk)(t):t).replace(/([ \t]+)/g,(c,h)=>"&nbsp;".repeat(h.length)).replace(/\>/gm,"\\>").replace(/\n/g,n===1?`\\
`:`

`),this}appendMarkdown(t){return this.value+=t,this}appendCodeblock(t,n){return this.value+=`
${w(n,t)}
`,this}appendLink(t,n,c){return this.value+="[",this.value+=this.c(n,"]"),this.value+="](",this.value+=this.c(String(t),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(t,n){const c=new RegExp((0,O.$_e)(n),"g");return t.replace(c,(h,i)=>t.charAt(i-1)!=="\\"?`\\${h}`:h)}}e.$Sk=g;function E(r){return T(r)?!r.value:Array.isArray(r)?r.every(E):!0}function T(r){return r instanceof g?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||typeof r.isTrusted=="object"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}function y(r,t){return r===t?!0:!r||!t?!1:r.value===t.value&&r.isTrusted===t.isTrusted&&r.supportThemeIcons===t.supportThemeIcons&&r.supportHtml===t.supportHtml&&(r.baseUri===t.baseUri||!!r.baseUri&&!!t.baseUri&&(0,R.$2g)(M.URI.from(r.baseUri),M.URI.from(t.baseUri)))}function l(r){return r.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(r,t){const n=r.match(/^`+/gm)?.reduce((h,i)=>h.length>i.length?h:i).length??0,c=n>=3?n+1:3;return[`${"`".repeat(c)}${t}`,r,`${"`".repeat(c)}`].join(`
`)}function m(r){return r.replace(/"/g,"&quot;")}function s(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function o(r){const t=[],n=r.split("|").map(h=>h.trim());r=n[0];const c=n[1];if(c){const h=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),$=h?h[1]:"",a=i?i[1]:"",v=isFinite(parseInt(a)),d=isFinite(parseInt($));v&&t.push(`width="${a}"`),d&&t.push(`height="${$}"`)}return{href:r,dimensions:t}}}),define(Ce[96],Ae([1,0,18,47,19,21,23,15]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ww=g,e.$xw=T,e.$yw=l,e.$zw=w,e.$Aw=r,e.$Bw=n,e.$Cw=c,e.$Dw=h,e.$Ew=i,e.$Fw=$;function g(v,d){const{os:C,tildify:u,relative:D}=d;if(D){const b=E(v,D,C);if(typeof b=="string")return b}let f=v.fsPath;if(C===1&&!O.$i?f=f.replace(/\//g,"\\"):C!==1&&O.$i&&(f=f.replace(/\\/g,"/")),C!==1&&u?.userHome){const b=u.userHome.fsPath;let P;v.scheme!==u.userHome.scheme&&v.path[0]===R.$hc.sep&&v.path[1]!==R.$hc.sep?P=u.userHome.with({path:v.path}).fsPath:P=f,f=l(P,b,C)}return(C===1?R.$gc:R.$hc).normalize(T(f,C===1))}function E(v,d,C){const u=C===1?R.$gc:R.$hc,D=C===3?M.$Yg:M.$1g,f=d.getWorkspace(),k=(0,S.$Ob)(f.folders);if(!k)return;v.scheme!==k.uri.scheme&&v.path[0]===R.$hc.sep&&v.path[1]!==R.$hc.sep&&(v=k.uri.with({path:v.path}));const b=d.getWorkspaceFolder(v);if(!b)return;let P;if(D.isEqual(b.uri,v)?P="":P=D.relativePath(b.uri,v)??"",P&&(P=u.normalize(P)),f.folders.length>1&&!d.noPrefix){const I=b.name?b.name:D.basenameOrAuthority(b.uri);P=P?`${I} \u2022 ${P}`:I}return P}function T(v,d=O.$i){return(0,N.$zg)(v,d)?v.charAt(0).toUpperCase()+v.slice(1):v}let y=Object.create(null);function l(v,d,C=O.OS){if(C===1||!v||!d)return v;let u=y.original===d?y.normalized:void 0;u||(u=d,O.$i&&(u=(0,N.$og)(u)),u=`${(0,p.$ff)(u,R.$hc.sep)}${R.$hc.sep}`,y={original:d,normalized:u});let D=v;return O.$i&&(D=(0,N.$og)(D)),(C===3?D.startsWith(u):(0,p.$yf)(D,u))?`~/${D.substr(u.length)}`:v}function w(v,d){return v.replace(/^~($|\/|\\)/,`${d}$1`)}const m="\u2026",s="\\\\",o="~";function r(v,d=R.sep){const C=new Array(v.length);let u=!1;for(let D=0;D<v.length;D++){const f=v[D];if(f===""){C[D]=`.${d}`;continue}if(!f){C[D]=f;continue}u=!0;let k="",b=f;b.indexOf(s)===0?(k=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(d)===0?(k=b.substr(0,b.indexOf(d)+d.length),b=b.substr(b.indexOf(d)+d.length)):b.indexOf(o)===0&&(k=b.substr(0,b.indexOf(o)+o.length),b=b.substr(b.indexOf(o)+o.length));const P=b.split(d);for(let I=1;u&&I<=P.length;I++)for(let W=P.length-I;u&&W>=0;W--){u=!1;let V=P.slice(W,W+I).join(d);for(let q=0;!u&&q<v.length;q++)if(q!==D&&v[q]&&v[q].indexOf(V)>-1){const A=W+I===P.length,j=W>0&&v[q].indexOf(d)>-1?d+V:V,K=v[q].endsWith(j);u=!A||K}if(!u){let q="";(P[0].endsWith(":")||k!=="")&&(W===1&&(W=0,I++,V=P[0]+d+V),W>0&&(q=P[0]+d),q=k+q),W>0&&(q=q+m+d),q=q+V,W+I<P.length&&(q=q+d+m),C[D]=q}}u&&(C[D]=f)}return C}var t;(function(v){v[v.TEXT=0]="TEXT",v[v.VARIABLE=1]="VARIABLE",v[v.SEPARATOR=2]="SEPARATOR"})(t||(t={}));function n(v,d=Object.create(null)){const C=[];let u=!1,D="";for(const f of v)if(f==="$"||u&&f==="{")D&&C.push({value:D,type:t.TEXT}),D="",u=!0;else if(f==="}"&&u){const k=d[D];if(typeof k=="string")k.length&&C.push({value:k,type:t.VARIABLE});else if(k){const b=C[C.length-1];(!b||b.type!==t.SEPARATOR)&&C.push({value:k.label,type:t.SEPARATOR})}D="",u=!1}else D+=f;return D&&!u&&C.push({value:D,type:t.TEXT}),C.filter((f,k)=>{if(f.type===t.SEPARATOR){const b=C[k-1],P=C[k+1];return[b,P].every(I=>I&&(I.type===t.VARIABLE||I.type===t.TEXT)&&I.value.length>0)}return!0}).map(f=>f.value).join("")}function c(v,d){return O.$j||d?v.replace(/\(&&\w\)|&&/g,"").replace(/&/g,O.$j?"&":"&&"):v.replace(/&&|&/g,C=>C==="&"?"&&":"&")}function h(v,d){return O.$j||d?v.replace(/\(&&\w\)|&&/g,""):O.$i?v.replace(/&&|&/g,C=>C==="&"?"&&":"&"):v.replace(/&&/g,"_")}function i(v){return v.replace(/&/g,"&&")}function $(v){if(v.endsWith("]")){const d=v.lastIndexOf(" [",v.length-2);if(d!==-1){const C=a(v.substring(0,d)),u=v.substring(d);return{name:C.name+u,parentPath:C.parentPath}}}return a(v)}function a(v){const d=v.indexOf("/")!==-1?R.$hc:R.$gc,C=d.basename(v),u=d.dirname(v);return C.length?{name:C,parentPath:u}:{name:u,parentPath:""}}}),define(Ce[144],Ae([1,0,22,2]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yn=e.$xn=void 0,e.$zn=p,e.$An=E,e.$Bn=T;function R(y){return y.toJSON()}class O{constructor(l){this.a=l}transformIncoming(l){const w=this.a.transformIncoming(l);return w===l?l:R(N.URI.from(w))}transformOutgoing(l){const w=this.a.transformOutgoing(l);return w===l?l:R(N.URI.from(w))}transformOutgoingURI(l){const w=this.a.transformOutgoing(l);return w===l?l:N.URI.from(w)}transformOutgoingScheme(l){return this.a.transformOutgoingScheme(l)}}e.$xn=O,e.$yn=new class{transformIncoming(y){return y}transformOutgoing(y){return y}transformOutgoingURI(y){return y}transformOutgoingScheme(y){return y}};function M(y,l,w){if(!y||w>200)return null;if(typeof y=="object"){if(y instanceof N.URI)return l.transformOutgoing(y);for(const m in y)if(Object.hasOwnProperty.call(y,m)){const s=M(y[m],l,w+1);s!==null&&(y[m]=s)}}return null}function p(y,l){const w=M(y,l,0);return w===null?y:w}function g(y,l,w,m){if(!y||m>200)return null;if(typeof y=="object"){if(y.$mid===1)return w?N.URI.revive(l.transformIncoming(y)):l.transformIncoming(y);if(y instanceof S.$Fe)return null;for(const s in y)if(Object.hasOwnProperty.call(y,s)){const o=g(y[s],l,w,m+1);o!==null&&(y[s]=o)}}return null}function E(y,l){const w=g(y,l,!1,0);return w===null?y:w}function T(y,l){const w=g(y,l,!0,0);return w===null?y:w}}),define(Ce[145],Ae([1,0,15,21,22]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Et=void 0,e.$Ct=T,e.$Dt=y;let O;function M(){return O||(O=new TextDecoder("UTF-16LE")),O}let p;function g(){return p||(p=new TextDecoder("UTF-16BE")),p}let E;function T(){return E||(E=N.$D()?M():g()),E}function y(m,s,o){const r=new Uint16Array(m.buffer,s,o);return o>0&&(r[0]===65279||r[0]===65534)?l(m,s,o):M().decode(r)}function l(m,s,o){const r=[];let t=0;for(let n=0;n<o;n++){const c=R.$He(m,s);s+=2,r[t++]=String.fromCharCode(c)}return r.join("")}class w{constructor(s){this.a=s|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const s=new Uint16Array(this.b.buffer,0,this.d);return T().decode(s)}f(){const s=this.e();this.d=0,this.c===null?this.c=[s]:this.c[this.c.length]=s}appendCharCode(s){const o=this.a-this.d;o<=1&&(o===0||S.$Bf(s))&&this.f(),this.b[this.d++]=s}appendASCIICharCode(s){this.d===this.a&&this.f(),this.b[this.d++]=s}appendString(s){const o=s.length;if(this.d+o>=this.a){this.f(),this.c[this.c.length]=s;return}for(let r=0;r<o;r++)this.b[this.d++]=s.charCodeAt(r)}}e.$Et=w}),define(Ce[146],Ae([1,0,22,145]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ft=void 0,e.$Gt=M;function R(g){return g.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class O{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(E,T,y,l){this.oldPosition=E,this.oldText=T,this.newPosition=y,this.newText=l}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${R(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${R(this.oldText)}")`:`(replace@${this.oldPosition} "${R(this.oldText)}" with "${R(this.newText)}")`}static a(E){return 4+2*E.length}static c(E,T,y){const l=T.length;S.$Ke(E,l,y),y+=4;for(let w=0;w<l;w++)S.$Ie(E,T.charCodeAt(w),y),y+=2;return y}static d(E,T){const y=S.$Je(E,T);return T+=4,(0,N.$Dt)(E,T,y)}writeSize(){return 8+O.a(this.oldText)+O.a(this.newText)}write(E,T){return S.$Ke(E,this.oldPosition,T),T+=4,S.$Ke(E,this.newPosition,T),T+=4,T=O.c(E,this.oldText,T),T=O.c(E,this.newText,T),T}static read(E,T,y){const l=S.$Je(E,T);T+=4;const w=S.$Je(E,T);T+=4;const m=O.d(E,T);T+=O.a(m);const s=O.d(E,T);return T+=O.a(s),y.push(new O(l,m,w,s)),T}}e.$Ft=O;function M(g,E){return g===null||g.length===0?E:new p(g,E).compress()}class p{constructor(E,T){this.a=E,this.c=T,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let E=0,T=0,y=this.n(E),l=this.l(T);for(;E<this.f||T<this.h;){if(y===null){this.k(l),l=this.l(++T);continue}if(l===null){this.m(y),y=this.n(++E);continue}if(l.oldEnd<=y.newPosition){this.k(l),l=this.l(++T);continue}if(y.newEnd<=l.oldPosition){this.m(y),y=this.n(++E);continue}if(l.oldPosition<y.newPosition){const[r,t]=p.r(l,y.newPosition-l.oldPosition);this.k(r),l=t;continue}if(y.newPosition<l.oldPosition){const[r,t]=p.q(y,l.oldPosition-y.newPosition);this.m(r),y=t;continue}let s,o;if(l.oldEnd===y.newEnd)s=y,o=l,y=this.n(++E),l=this.l(++T);else if(l.oldEnd<y.newEnd){const[r,t]=p.q(y,l.oldLength);s=r,o=l,y=t,l=this.l(++T)}else{const[r,t]=p.r(l,y.newLength);s=y,o=r,y=this.n(++E),l=t}this.d[this.e++]=new O(s.oldPosition,s.oldText,o.newPosition,o.newText),this.g+=s.newLength-s.oldLength,this.j+=o.newLength-o.oldLength}const w=p.s(this.d);return p.t(w)}k(E){this.d[this.e++]=p.o(this.g,E),this.j+=E.newLength-E.oldLength}l(E){return E<this.h?this.c[E]:null}m(E){this.d[this.e++]=p.p(this.j,E),this.g+=E.newLength-E.oldLength}n(E){return E<this.f?this.a[E]:null}static o(E,T){return new O(T.oldPosition-E,T.oldText,T.newPosition,T.newText)}static p(E,T){return new O(T.oldPosition,T.oldText,T.newPosition+E,T.newText)}static q(E,T){const y=E.newText.substr(0,T),l=E.newText.substr(T);return[new O(E.oldPosition,E.oldText,E.newPosition,y),new O(E.oldEnd,"",E.newPosition+T,l)]}static r(E,T){const y=E.oldText.substr(0,T),l=E.oldText.substr(T);return[new O(E.oldPosition,y,E.newPosition,E.newText),new O(E.oldPosition+T,l,E.newEnd,"")]}static s(E){if(E.length===0)return E;const T=[];let y=0,l=E[0];for(let w=1;w<E.length;w++){const m=E[w];l.oldEnd===m.oldPosition?l=new O(l.oldPosition,l.oldText+m.oldText,l.newPosition,l.newText+m.newText):(T[y++]=l,l=m)}return T[y++]=l,T}static t(E){if(E.length===0)return E;const T=[];let y=0;for(let l=0;l<E.length;l++){const w=E[l];w.oldText!==w.newText&&(T[y++]=w)}return T}}}),define(Ce[147],Ae([1,0,36,19]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4t=R,e.$5t=O;function R(M,p,g,E,T,y){if(Array.isArray(M)){let l=0;for(const w of M){const m=R(w,p,g,E,T,y);if(m===10)return m;m>l&&(l=m)}return l}else{if(typeof M=="string")return E?M==="*"?5:M===g?10:0:0;if(M){const{language:l,pattern:w,scheme:m,hasAccessToAllModels:s,notebookType:o}=M;if(!E&&!s)return 0;o&&T&&(p=T);let r=0;if(m)if(m===p.scheme)r=10;else if(m==="*")r=5;else return 0;if(l)if(l===g)r=10;else if(l==="*")r=Math.max(r,5);else return 0;if(o)if(o===y)r=10;else if(o==="*"&&y!==void 0)r=Math.max(r,5);else return 0;if(w){let t;if(typeof w=="string"?t=w:t={...w,base:(0,N.$ic)(w.base)},t===p.fsPath||(0,S.$ok)(t,p.fsPath))r=10;else return 0}return r}else return 0}}function O(M){return typeof M=="string"?!1:Array.isArray(M)?M.some(O):!!M.notebookType}}),define(Ce[148],Ae([1,0,5,15,29,94,92,133,146,6]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TC=void 0;class T extends E.$Vc{constructor(l,w,m,s,o,r,t){super(),this.m=this.B(new S.$ee),this.onDidChangeContent=this.m.event,this.f=w,this.j=!r,this.g=s,this.h=o,this.c=new M.$SC(l,m,t)}equals(l){return!(l instanceof T)||this.f!==l.f||this.getEOL()!==l.getEOL()?!1:this.c.equal(l.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(l){return this.c.createSnapshot(l?this.f:"")}getOffsetAt(l,w){return this.c.getOffsetAt(l,w)}getPositionAt(l){return this.c.getPositionAt(l)}getRangeAt(l,w){const m=l+w,s=this.getPositionAt(l),o=this.getPositionAt(m);return new R.$tt(s.lineNumber,s.column,o.lineNumber,o.column)}getValueInRange(l,w=0){if(l.isEmpty())return"";const m=this.n(w);return this.c.getValueInRange(l,m)}getValueLengthInRange(l,w=0){if(l.isEmpty())return 0;if(l.startLineNumber===l.endLineNumber)return l.endColumn-l.startColumn;const m=this.getOffsetAt(l.startLineNumber,l.startColumn),s=this.getOffsetAt(l.endLineNumber,l.endColumn);let o=0;const r=this.n(w),t=this.getEOL();if(r.length!==t.length){const n=r.length-t.length,c=l.endLineNumber-l.startLineNumber;o=n*c}return s-m+o}getCharacterCountInRange(l,w=0){if(this.j){let m=0;const s=l.startLineNumber,o=l.endLineNumber;for(let r=s;r<=o;r++){const t=this.getLineContent(r),n=r===s?l.startColumn-1:0,c=r===o?l.endColumn-1:t.length;for(let h=n;h<c;h++)N.$Bf(t.charCodeAt(h))?(m=m+1,h=h+1):m=m+1}return m+=this.n(w).length*(o-s),m}return this.getValueLengthInRange(l,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(l){return this.c.getLineContent(l)}getLineCharCode(l,w){return this.c.getLineCharCode(l,w)}getCharCode(l){return this.c.getCharCode(l)}getLineLength(l){return this.c.getLineLength(l)}getLineMinColumn(l){return 1}getLineMaxColumn(l){return this.getLineLength(l)+1}getLineFirstNonWhitespaceColumn(l){const w=N.$mf(this.getLineContent(l));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(l){const w=N.$of(this.getLineContent(l));return w===-1?0:w+2}n(l){switch(l){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(l){this.c.setEOL(l)}applyEdits(l,w,m){let s=this.g,o=this.h,r=this.j,t=!0,n=[];for(let d=0;d<l.length;d++){const C=l[d];t&&C._isTracked&&(t=!1);const u=C.range;if(C.text){let P=!0;r||(P=!N.$Mf(C.text),r=P),!s&&P&&(s=N.$Lf(C.text)),!o&&P&&(o=N.$Of(C.text))}let D="",f=0,k=0,b=0;if(C.text){let P;[f,k,b,P]=(0,p.$Wt)(C.text);const I=this.getEOL();P===0||P===(I===`\r
`?2:1)?D=C.text:D=C.text.replace(/\r\n|\r|\n/g,I)}n[d]={sortIndex:d,identifier:C.identifier||null,range:u,rangeOffset:this.getOffsetAt(u.startLineNumber,u.startColumn),rangeLength:this.getValueLengthInRange(u),text:D,eolCount:f,firstLineLength:k,lastLineLength:b,forceMoveMarkers:!!C.forceMoveMarkers,isAutoWhitespaceEdit:C.isAutoWhitespaceEdit||!1}}n.sort(T.u);let c=!1;for(let d=0,C=n.length-1;d<C;d++){const u=n[d].range.getEndPosition(),D=n[d+1].range.getStartPosition();if(D.isBeforeOrEqual(u)){if(D.isBefore(u))throw new Error("Overlapping ranges are not allowed!");c=!0}}t&&(n=this.s(n));const h=m||w?T._getInverseEditRanges(n):[],i=[];if(w)for(let d=0;d<n.length;d++){const C=n[d],u=h[d];if(C.isAutoWhitespaceEdit&&C.range.isEmpty())for(let D=u.startLineNumber;D<=u.endLineNumber;D++){let f="";D===u.startLineNumber&&(f=this.getLineContent(C.range.startLineNumber),N.$mf(f)!==-1)||i.push({lineNumber:D,oldContent:f})}}let $=null;if(m){let d=0;$=[];for(let C=0;C<n.length;C++){const u=n[C],D=h[C],f=this.getValueInRange(u.range),k=u.rangeOffset+d;d+=u.text.length-f.length,$[C]={sortIndex:u.sortIndex,identifier:u.identifier,range:D,text:f,textChange:new g.$Ft(u.rangeOffset,f,k,u.text)}}c||$.sort((C,u)=>C.sortIndex-u.sortIndex)}this.g=s,this.h=o,this.j=r;const a=this.t(n);let v=null;if(w&&i.length>0){i.sort((d,C)=>C.lineNumber-d.lineNumber),v=[];for(let d=0,C=i.length;d<C;d++){const u=i[d].lineNumber;if(d>0&&i[d-1].lineNumber===u)continue;const D=i[d].oldContent,f=this.getLineContent(u);f.length===0||f===D||N.$mf(f)!==-1||v.push(u)}}return this.m.fire(),new O.$Iv($,a,v)}s(l){return l.length<1e3?l:[this._toSingleEditOperation(l)]}_toSingleEditOperation(l){let w=!1;const m=l[0].range,s=l[l.length-1].range,o=new R.$tt(m.startLineNumber,m.startColumn,s.endLineNumber,s.endColumn);let r=m.startLineNumber,t=m.startColumn;const n=[];for(let a=0,v=l.length;a<v;a++){const d=l[a],C=d.range;w=w||d.forceMoveMarkers,n.push(this.getValueInRange(new R.$tt(r,t,C.startLineNumber,C.startColumn))),d.text.length>0&&n.push(d.text),r=C.endLineNumber,t=C.endColumn}const c=n.join(""),[h,i,$]=(0,p.$Wt)(c);return{sortIndex:0,identifier:l[0].identifier,range:o,rangeOffset:this.getOffsetAt(o.startLineNumber,o.startColumn),rangeLength:this.getValueLengthInRange(o,0),text:c,eolCount:h,firstLineLength:i,lastLineLength:$,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(l){l.sort(T.w);const w=[];for(let m=0;m<l.length;m++){const s=l[m],o=s.range.startLineNumber,r=s.range.startColumn,t=s.range.endLineNumber,n=s.range.endColumn;if(o===t&&r===n&&s.text.length===0)continue;s.text?(this.c.delete(s.rangeOffset,s.rangeLength),this.c.insert(s.rangeOffset,s.text,!0)):this.c.delete(s.rangeOffset,s.rangeLength);const c=new R.$tt(o,r,t,n);w.push({range:c,rangeLength:s.rangeLength,text:s.text,rangeOffset:s.rangeOffset,forceMoveMarkers:s.forceMoveMarkers})}return w}findMatchesLineByLine(l,w,m,s){return this.c.findMatchesLineByLine(l,w,m,s)}getPieceTree(){return this.c}static _getInverseEditRange(l,w){const m=l.startLineNumber,s=l.startColumn,[o,r,t]=(0,p.$Wt)(w);let n;if(w.length>0){const c=o+1;c===1?n=new R.$tt(m,s,m,s+r):n=new R.$tt(m,s,m+c-1,t+1)}else n=new R.$tt(m,s,m,s);return n}static _getInverseEditRanges(l){const w=[];let m=0,s=0,o=null;for(let r=0,t=l.length;r<t;r++){const n=l[r];let c,h;o?o.range.endLineNumber===n.range.startLineNumber?(c=m,h=s+(n.range.startColumn-o.range.endColumn)):(c=m+(n.range.startLineNumber-o.range.endLineNumber),h=n.range.startColumn):(c=n.range.startLineNumber,h=n.range.startColumn);let i;if(n.text.length>0){const $=n.eolCount+1;$===1?i=new R.$tt(c,h,c,h+n.firstLineLength):i=new R.$tt(c,h,c+$-1,n.lastLineLength+1)}else i=new R.$tt(c,h,c,h);m=i.endLineNumber,s=i.endColumn,w.push(i),o=n}return w}static u(l,w){const m=R.$tt.compareRangesUsingEnds(l.range,w.range);return m===0?l.sortIndex-w.sortIndex:m}static w(l,w){const m=R.$tt.compareRangesUsingEnds(l.range,w.range);return m===0?w.sortIndex-l.sortIndex:-m}}e.$TC=T}),define(Ce[149],Ae([1,0,15,92,148]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UC=void 0;class O{constructor(g,E,T,y,l,w,m,s,o){this.a=g,this.b=E,this.c=T,this.d=y,this.e=l,this.f=w,this.g=m,this.h=s,this.j=o}k(g){const E=this.c+this.d+this.e,T=this.c+this.e;return E===0?g===1?`
`:`\r
`:T>E/2?`\r
`:`
`}create(g){const E=this.k(g),T=this.a;if(this.j&&(E===`\r
`&&(this.c>0||this.d>0)||E===`
`&&(this.c>0||this.e>0)))for(let l=0,w=T.length;l<w;l++){const m=T[l].buffer.replace(/\r\n|\r|\n/g,E),s=(0,N.$OC)(m);T[l]=new N.$RC(m,s)}const y=new R.$TC(T,this.b,E,this.f,this.g,this.h,this.j);return{textBuffer:y,disposable:y}}getFirstLineText(g){return this.a[0].buffer.substr(0,g).split(/\r\n|\r|\n/)[0]}}class M{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(g){if(g.length===0)return;this.a.length===0&&S.$Vf(g)&&(this.b=S.$Uf,g=g.substr(1));const E=g.charCodeAt(g.length-1);E===13||E>=55296&&E<=56319?(this.m(g.substr(0,g.length-1),!1),this.c=!0,this.d=E):(this.m(g,!1),this.c=!1,this.d=E)}m(g,E){!E&&g.length===0||(this.c?this.n(String.fromCharCode(this.d)+g):this.n(g))}n(g){const E=(0,N.$PC)(this.e,g);this.a.push(new N.$RC(g,E.lineStarts)),this.f+=E.cr,this.g+=E.lf,this.h+=E.crlf,E.isBasicASCII||(this.l=!1,this.j||(this.j=S.$Lf(g)),this.k||(this.k=S.$Of(g)))}finish(g=!0){return this.o(),new O(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,g)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const g=this.a[this.a.length-1];g.buffer+=String.fromCharCode(this.d);const E=(0,N.$OC)(g.buffer);g.lineStarts=E,this.d===13&&this.f++}}}e.$UC=M}),define(Ce[97],Ae([1,0,22,21]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xbb=g,e.$Ybb=T;var R;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(R||(R={}));function O(y){for(let l=0,w=y.length;l<w;l+=4){const m=y[l+0],s=y[l+1],o=y[l+2],r=y[l+3];y[l+0]=r,y[l+1]=o,y[l+2]=s,y[l+3]=m}}function M(y){const l=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return N.$D()||O(l),S.$Fe.wrap(l)}function p(y){const l=y.buffer;if(N.$D()||O(l),l.byteOffset%4===0)return new Uint32Array(l.buffer,l.byteOffset,l.length/4);{const w=new Uint8Array(l.byteLength);return w.set(l),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function g(y){const l=new Uint32Array(E(y));let w=0;if(l[w++]=y.id,y.type==="full")l[w++]=1,l[w++]=y.data.length,l.set(y.data,w),w+=y.data.length;else{l[w++]=2,l[w++]=y.deltas.length;for(const m of y.deltas)l[w++]=m.start,l[w++]=m.deleteCount,m.data?(l[w++]=m.data.length,l.set(m.data,w),w+=m.data.length):l[w++]=0}return M(l)}function E(y){let l=0;if(l+=2,y.type==="full")l+=1+y.data.length;else{l+=1,l+=3*y.deltas.length;for(const w of y.deltas)w.data&&(l+=w.data.length)}return l}function T(y){const l=p(y);let w=0;const m=l[w++];if(l[w++]===1){const t=l[w++],n=l.subarray(w,w+t);return w+=t,{id:m,type:"full",data:n}}const o=l[w++],r=[];for(let t=0;t<o;t++){const n=l[w++],c=l[w++],h=l[w++];let i;h>0&&(i=l.subarray(w,w+h),w+=h),r[t]={start:n,deleteCount:c,data:i}}return{id:m,type:"delta",deltas:r}}}),define(Ce[150],Ae([9,10]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(Ce[151],Ae([1,0,18,25,21,134,152,150]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=o,e.clampedInt=t,e.clampedFloat=c,e.stringSet=$,e.cursorStyleToString=b,e.filterValidationDecorations=ue;var g;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(g||(e.EditorAutoIndentStrategy=g={})),e.MINIMAP_GUTTER_WIDTH=8;class E{constructor(Q){this.c=Q}hasChanged(Q){return this.c[Q]}}e.ConfigurationChangedEvent=E;class T{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=T;class y{constructor(Q,$e,Ge,ye){this.id=Q,this.name=$e,this.defaultValue=Ge,this.schema=ye}applyUpdate(Q,$e){return w(Q,$e)}compute(Q,$e,Ge){return Ge}}class l{constructor(Q,$e){this.newValue=Q,this.didChange=$e}}e.ApplyUpdateResult=l;function w(Z,Q){if(typeof Z!="object"||typeof Q!="object"||!Z||!Q)return new l(Q,Z!==Q);if(Array.isArray(Z)||Array.isArray(Q)){const Ge=Array.isArray(Z)&&Array.isArray(Q)&&S.$ub(Z,Q);return new l(Q,!Ge)}let $e=!1;for(const Ge in Q)if(Q.hasOwnProperty(Ge)){const ye=w(Z[Ge],Q[Ge]);ye.didChange&&(Z[Ge]=ye.newValue,$e=!0)}return new l(Z,$e)}class m{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,$e){return w(Q,$e)}validate(Q){return this.defaultValue}}class s{constructor(Q,$e,Ge,ye){this.id=Q,this.name=$e,this.defaultValue=Ge,this.schema=ye}applyUpdate(Q,$e){return w(Q,$e)}validate(Q){return typeof Q>"u"?this.defaultValue:Q}compute(Q,$e,Ge){return Ge}}function o(Z,Q){return typeof Z>"u"?Q:Z==="false"?!1:!!Z}class r extends s{constructor(Q,$e,Ge,ye=void 0){typeof ye<"u"&&(ye.type="boolean",ye.default=Ge),super(Q,$e,Ge,ye)}validate(Q){return o(Q,this.defaultValue)}}function t(Z,Q,$e,Ge){if(typeof Z>"u")return Q;let ye=parseInt(Z,10);return isNaN(ye)?Q:(ye=Math.max($e,ye),ye=Math.min(Ge,ye),ye|0)}class n extends s{static clampedInt(Q,$e,Ge,ye){return t(Q,$e,Ge,ye)}constructor(Q,$e,Ge,ye,ot,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=Ge,dt.minimum=ye,dt.maximum=ot),super(Q,$e,Ge,dt),this.minimum=ye,this.maximum=ot}validate(Q){return n.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}function c(Z,Q,$e,Ge){if(typeof Z>"u")return Q;const ye=h.float(Z,Q);return h.clamp(ye,$e,Ge)}class h extends s{static clamp(Q,$e,Ge){return Q<$e?$e:Q>Ge?Ge:Q}static float(Q,$e){if(typeof Q=="number")return Q;if(typeof Q>"u")return $e;const Ge=parseFloat(Q);return isNaN(Ge)?$e:Ge}constructor(Q,$e,Ge,ye,ot){typeof ot<"u"&&(ot.type="number",ot.default=Ge),super(Q,$e,Ge,ot),this.validationFn=ye}validate(Q){return this.validationFn(h.float(Q,this.defaultValue))}}class i extends s{static string(Q,$e){return typeof Q!="string"?$e:Q}constructor(Q,$e,Ge,ye=void 0){typeof ye<"u"&&(ye.type="string",ye.default=Ge),super(Q,$e,Ge,ye)}validate(Q){return i.string(Q,this.defaultValue)}}function $(Z,Q,$e,Ge){return typeof Z!="string"?Q:Ge&&Z in Ge?Ge[Z]:$e.indexOf(Z)===-1?Q:Z}class a extends s{constructor(Q,$e,Ge,ye,ot=void 0){typeof ot<"u"&&(ot.type="string",ot.enum=ye,ot.default=Ge),super(Q,$e,Ge,ot),this.c=ye}validate(Q){return $(Q,this.defaultValue,this.c)}}class v extends y{constructor(Q,$e,Ge,ye,ot,dt,It=void 0){typeof It<"u"&&(It.type="string",It.enum=ot,It.default=ye),super(Q,$e,Ge,It),this.c=ot,this.d=dt}validate(Q){return typeof Q!="string"?this.defaultValue:this.c.indexOf(Q)===-1?this.defaultValue:this.d(Q)}}function d(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class C extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,$e,Ge){return Ge===0?Q.accessibilitySupport:Ge}}class u extends y{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:p.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertSpace:o($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:o($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var D;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(D||(e.TextEditorCursorBlinkingStyle=D={}));function f(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var k;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(k||(e.TextEditorCursorStyle=k={}));function b(Z){switch(Z){case k.Line:return"line";case k.Block:return"block";case k.Underline:return"underline";case k.LineThin:return"line-thin";case k.BlockOutline:return"block-outline";case k.UnderlineThin:return"underline-thin"}}function P(Z){switch(Z){case"line":return k.Line;case"block":return k.Block;case"underline":return k.Underline;case"line-thin":return k.LineThin;case"block-outline":return k.BlockOutline;case"underline-thin":return k.UnderlineThin}}class I extends m{constructor(){super(142)}compute(Q,$e,Ge){const ye=["monaco-editor"];return $e.get(39)&&ye.push($e.get(39)),Q.extraEditorClassName&&ye.push(Q.extraEditorClassName),$e.get(74)==="default"?ye.push("mouse-default"):$e.get(74)==="copy"&&ye.push("mouse-copy"),$e.get(111)&&ye.push("showUnused"),$e.get(140)&&ye.push("showDeprecated"),ye.join(" ")}}class W extends r{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(Q,$e,Ge){return Ge&&Q.emptySelectionClipboard}}class V extends y{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:p.localize(16,null),included:R.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:p.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{cursorMoveOnType:o($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":$($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":$($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:o($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:o($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:o($e.loop,this.defaultValue.loop)}}}class q extends y{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"||Q.length===0?q.OFF:Q==="true"?q.ON:Q:Q?q.ON:q.OFF}}e.EditorFontLigatures=q;class A extends y{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",A.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(Q){return typeof Q>"u"?this.defaultValue:typeof Q=="string"?Q==="false"?A.OFF:Q==="true"?A.TRANSLATE:Q:Q?A.TRANSLATE:A.OFF}compute(Q,$e,Ge){return Q.fontInfo.fontVariationSettings}}e.EditorFontVariations=A;class j extends m{constructor(){super(50)}compute(Q,$e,Ge){return Q.fontInfo}}class K extends s{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(Q){const $e=h.float(Q,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:h.clamp($e,6,100)}compute(Q,$e,Ge){return Q.fontInfo.fontSize}}class re extends y{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:re.d,maximum:re.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:re.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(n.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,re.d,re.e))}}class ae extends y{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},Ge=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ge,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ge,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ge,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ge,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ge,description:p.localize(41,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{multiple:$($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??$($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??$($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??$($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??$($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??$($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class we extends y{constructor(){const Q={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:Q.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:p.localize(46,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),delay:n.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:o($e.sticky,this.defaultValue.sticky),hidingDelay:n.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:o($e.above,this.defaultValue.above)}}}var Ie;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ie||(e.RenderMinimap=Ie={}));class de extends m{constructor(){super(145)}compute(Q,$e,Ge){return de.computeLayout($e,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio,glyphMarginDecorationLaneCount:Q.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(Q){const $e=Q.height/Q.lineHeight,Ge=Math.floor(Q.paddingTop/Q.lineHeight);let ye=Math.floor(Q.paddingBottom/Q.lineHeight);Q.scrollBeyondLastLine&&(ye=Math.max(ye,$e-1));const ot=(Ge+Q.viewLineCount+ye)/(Q.pixelRatio*Q.height),dt=Math.floor(Q.viewLineCount/ot);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:Ge,extraLinesBeyondLastLine:ye,desiredRatio:ot,minimapLineCount:dt}}static c(Q,$e){const Ge=Q.outerWidth,ye=Q.outerHeight,ot=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(ot*ye),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:ye};const dt=$e.stableMinimapLayoutInput,It=dt&&Q.outerHeight===dt.outerHeight&&Q.lineHeight===dt.lineHeight&&Q.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&Q.pixelRatio===dt.pixelRatio&&Q.scrollBeyondLastLine===dt.scrollBeyondLastLine&&Q.paddingTop===dt.paddingTop&&Q.paddingBottom===dt.paddingBottom&&Q.minimap.enabled===dt.minimap.enabled&&Q.minimap.side===dt.minimap.side&&Q.minimap.size===dt.minimap.size&&Q.minimap.showSlider===dt.minimap.showSlider&&Q.minimap.renderCharacters===dt.minimap.renderCharacters&&Q.minimap.maxColumn===dt.minimap.maxColumn&&Q.minimap.scale===dt.minimap.scale&&Q.verticalScrollbarWidth===dt.verticalScrollbarWidth&&Q.isViewportWrapping===dt.isViewportWrapping,Yt=Q.lineHeight,Ut=Q.typicalHalfwidthCharacterWidth,xt=Q.scrollBeyondLastLine,_t=Q.minimap.renderCharacters;let Pt=ot>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const Wt=Q.minimap.maxColumn,Qt=Q.minimap.size,Ze=Q.minimap.side,si=Q.verticalScrollbarWidth,Zt=Q.viewLineCount,lt=Q.remainingWidth,wt=Q.isViewportWrapping,ti=_t?2:3;let Xt=Math.floor(ot*ye);const Lt=Xt/ot;let ft=!1,jt=!1,Bt=ti*Pt,qt=Pt/ot,He=1;if(Qt==="fill"||Qt==="fit"){const{typicalViewportLineCount:Ot,extraLinesBeforeFirstLine:ii,extraLinesBeyondLastLine:Ht,desiredRatio:ni,minimapLineCount:Nt}=de.computeContainedMinimapLineCount({viewLineCount:Zt,scrollBeyondLastLine:xt,paddingTop:Q.paddingTop,paddingBottom:Q.paddingBottom,height:ye,lineHeight:Yt,pixelRatio:ot});if(Zt/Nt>1)ft=!0,jt=!0,Pt=1,Bt=1,qt=Pt/ot;else{let Ct=!1,Dt=Pt+1;if(Qt==="fit"){const pt=Math.ceil((ii+Zt+Ht)*Bt);wt&&It&&lt<=$e.stableFitRemainingWidth?(Ct=!0,Dt=$e.stableFitMaxMinimapScale):Ct=pt>Xt}if(Qt==="fill"||Ct){ft=!0;const pt=Pt;Bt=Math.min(Yt*ot,Math.max(1,Math.floor(1/ni))),wt&&It&&lt<=$e.stableFitRemainingWidth&&(Dt=$e.stableFitMaxMinimapScale),Pt=Math.min(Dt,Math.max(1,Math.floor(Bt/ti))),Pt>pt&&(He=Math.min(2,Pt/pt)),qt=Pt/ot/He,Xt=Math.ceil(Math.max(Ot,ii+Zt+Ht)*Bt),wt?($e.stableMinimapLayoutInput=Q,$e.stableFitRemainingWidth=lt,$e.stableFitMaxMinimapScale=Pt):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Wt*qt),Gt=Math.min(ui,Math.max(0,Math.floor((lt-si-2)*qt/(Ut+qt)))+e.MINIMAP_GUTTER_WIDTH);let zt=Math.floor(ot*Gt);const gt=zt/ot;zt=Math.floor(zt*He);const Tt=_t?1:2,At=Ze==="left"?0:Ge-Gt-si;return{renderMinimap:Tt,minimapLeft:At,minimapWidth:Gt,minimapHeightIsEditorHeight:ft,minimapIsSampling:jt,minimapScale:Pt,minimapLineHeight:Bt,minimapCanvasInnerWidth:zt,minimapCanvasInnerHeight:Xt,minimapCanvasOuterWidth:gt,minimapCanvasOuterHeight:Lt}}static computeLayout(Q,$e){const Ge=$e.outerWidth|0,ye=$e.outerHeight|0,ot=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,It=$e.typicalHalfwidthCharacterWidth,Yt=$e.maxDigitWidth,Ut=$e.pixelRatio,xt=$e.viewLineCount,_t=Q.get(137),Pt=_t==="inherit"?Q.get(136):_t,Wt=Pt==="inherit"?Q.get(132):Pt,Qt=Q.get(135),Ze=$e.isDominatedByLongLines,si=Q.get(57),Zt=Q.get(68).renderType!==0,lt=Q.get(69),wt=Q.get(105),ti=Q.get(84),Xt=Q.get(73),Lt=Q.get(103),ft=Lt.verticalScrollbarSize,jt=Lt.verticalHasArrows,Bt=Lt.arrowSize,qt=Lt.horizontalScrollbarSize,He=Q.get(43),ui=Q.get(110)!=="never";let Gt=Q.get(66);He&&ui&&(Gt+=16);let zt=0;if(Zt){const li=Math.max(dt,lt);zt=Math.round(li*Yt)}let gt=0;si&&(gt=ot*$e.glyphMarginDecorationLaneCount);let Tt=0,At=Tt+gt,Ot=At+zt,ii=Ot+Gt;const Ht=Ge-gt-zt-Gt;let ni=!1,Nt=!1,Rt=-1;Pt==="inherit"&&Ze?(ni=!0,Nt=!0):Wt==="on"||Wt==="bounded"?Nt=!0:Wt==="wordWrapColumn"&&(Rt=Qt);const Ct=de.c({outerWidth:Ge,outerHeight:ye,lineHeight:ot,typicalHalfwidthCharacterWidth:It,pixelRatio:Ut,scrollBeyondLastLine:wt,paddingTop:ti.top,paddingBottom:ti.bottom,minimap:Xt,verticalScrollbarWidth:ft,viewLineCount:xt,remainingWidth:Ht,isViewportWrapping:Nt},$e.memory||new T);Ct.renderMinimap!==0&&Ct.minimapLeft===0&&(Tt+=Ct.minimapWidth,At+=Ct.minimapWidth,Ot+=Ct.minimapWidth,ii+=Ct.minimapWidth);const Dt=Ht-Ct.minimapWidth,pt=Math.max(1,Math.floor((Dt-ft-2)/It)),St=jt?Bt:0;return Nt&&(Rt=Math.max(1,pt),Wt==="bounded"&&(Rt=Math.min(Rt,Qt))),{width:Ge,height:ye,glyphMarginLeft:Tt,glyphMarginWidth:gt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:At,lineNumbersWidth:zt,decorationsLeft:Ot,decorationsWidth:Gt,contentLeft:ii,contentWidth:Dt,minimap:Ct,viewportColumn:pt,isWordWrapMinified:ni,isViewportWrapping:Nt,wrappingColumn:Rt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:qt,overviewRuler:{top:St,width:ft,height:ye-2*St,right:0}}}}e.EditorLayoutInfoComputer=de;class me extends y{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(Q){return $(Q,"simple",["simple","advanced"])}compute(Q,$e,Ge){return $e.get(2)===2?"advanced":Ge}}var Me;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Me||(e.ShowLightbulbIconMode=Me={}));class ce extends y{constructor(){const Q={enabled:Me.On};super(65,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Me.Off,Me.OnCode,Me.On],default:Q.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:$(Q.enabled,this.defaultValue.enabled,[Me.Off,Me.OnCode,Me.On])}}}class Re extends y{constructor(){const Q={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",Q,{"editor.stickyScroll.enabled":{type:"boolean",default:Q.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:Q.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:Q.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:Q.scrollWithEditor,description:p.localize(57,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),maxLineCount:n.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:$($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:o($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ie extends y{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,R.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:p.localize(65,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:$($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:n.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:o($e.padding,this.defaultValue.padding)}}}class L extends y{constructor(){super(66,"lineDecorationsWidth",10)}validate(Q){return typeof Q=="string"&&/^\d+(\.\d+)?ch$/.test(Q)?-parseFloat(Q.substring(0,Q.length-2)):n.clampedInt(Q,this.defaultValue,0,1e3)}compute(Q,$e,Ge){return Ge<0?n.clampedInt(-Ge*Q.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ge}}class x extends h{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>h.clamp(Q,0,150),{markdownDescription:p.localize(66,null)})}compute(Q,$e,Ge){return Q.fontInfo.lineHeight}}class ve extends y{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:Q.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:Q.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:Q.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:Q.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),autohide:o($e.autohide,this.defaultValue.autohide),size:$($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:$($e.side,this.defaultValue.side,["right","left"]),showSlider:$($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:o($e.renderCharacters,this.defaultValue.renderCharacters),scale:n.clampedInt($e.scale,1,1,3),maxColumn:n.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:o($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:o($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:h.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Fe(Z){return Z==="ctrlCmd"?R.$j?"metaKey":"ctrlKey":"altKey"}class Ee extends y{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{top:n.clampedInt($e.top,0,0,1e3),bottom:n.clampedInt($e.bottom,0,0,1e3)}}}class pe extends y{constructor(){const Q={enabled:!0,cycle:!0};super(86,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:p.localize(84,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),cycle:o($e.cycle,this.defaultValue.cycle)}}}class fe extends m{constructor(){super(143)}compute(Q,$e,Ge){return Q.pixelRatio}}class Y extends y{constructor(){const Q={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:Q.strings,description:p.localize(88,null)},comments:{anyOf:$e,default:Q.comments,description:p.localize(89,null)},other:{anyOf:$e,default:Q.other,description:p.localize(90,null)}},default:Q,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const Ut=Q?"on":"off";return{comments:Ut,strings:Ut,other:Ut}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:$e,comments:Ge,strings:ye}=Q,ot=["on","inline","off"];let dt,It,Yt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=$($e,this.defaultValue.other,ot),typeof Ge=="boolean"?It=Ge?"on":"off":It=$(Ge,this.defaultValue.comments,ot),typeof ye=="boolean"?Yt=ye?"on":"off":Yt=$(ye,this.defaultValue.strings,ot),{other:dt,comments:It,strings:Yt}}}var X;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(X||(e.RenderLineNumbersType=X={}));class le extends y{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(Q){let $e=this.defaultValue.renderType,Ge=this.defaultValue.renderFn;return typeof Q<"u"&&(typeof Q=="function"?($e=4,Ge=Q):Q==="interval"?$e=3:Q==="relative"?$e=2:Q==="on"?$e=1:$e=0),{renderType:$e,renderFn:Ge}}}function ue(Z){const Q=Z.get(98);return Q==="editable"?Z.get(91):Q!=="on"}class Te extends y{constructor(){const Q=[],$e={type:"number",description:p.localize(97,null)};super(102,"rulers",Q,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:Q,description:p.localize(99,null)})}validate(Q){if(Array.isArray(Q)){const $e=[];for(const Ge of Q)if(typeof Ge=="number")$e.push({column:n.clampedInt(Ge,0,0,1e4),color:null});else if(Ge&&typeof Ge=="object"){const ye=Ge;$e.push({column:n.clampedInt(ye.column,0,0,1e4),color:ye.color})}return $e.sort((Ge,ye)=>Ge.column-ye.column),$e}return this.defaultValue}}class he extends y{constructor(){super(92,"readOnlyMessage",void 0)}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:Q}}function Pe(Z,Q){if(typeof Z!="string")return Q;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Ne extends y{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:Q.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q,Ge=n.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),ye=n.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:n.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:o($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:o($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:o($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:o($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:o($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ge,horizontalSliderSize:n.clampedInt($e.horizontalSliderSize,Ge,0,1e3),verticalScrollbarSize:ye,verticalSliderSize:n.clampedInt($e.verticalSliderSize,ye,0,1e3),scrollByPage:o($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:o($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class ze extends y{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:p.localize(118,null)}})}applyUpdate(Q,$e){let Ge=!1;$e.allowedCharacters&&Q&&(N.$6n(Q.allowedCharacters,$e.allowedCharacters)||(Q={...Q,allowedCharacters:$e.allowedCharacters},Ge=!0)),$e.allowedLocales&&Q&&(N.$6n(Q.allowedLocales,$e.allowedLocales)||(Q={...Q,allowedLocales:$e.allowedLocales},Ge=!0));const ye=super.applyUpdate(Q,$e);return Ge?new l(ye.newValue,!0):ye}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{nonBasicASCII:ee($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:o($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:o($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(Q.allowedLocales,this.defaultValue.allowedLocales)}}c(Q,$e){if(typeof Q!="object"||!Q)return $e;const Ge={};for(const[ye,ot]of Object.entries(Q))ot===!0&&(Ge[ye]=!0);return Ge}}class U extends y{constructor(){const Q={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:Q.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:Q.fontFamily,description:p.localize(125,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),mode:$($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:o($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily)}}}class z extends y{constructor(){const Q={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",Q,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:Q.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:Q.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:Q.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:Q.backgroundColoring,description:p.localize(132,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showToolbar:$($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:o($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:o($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends y{constructor(){const Q={enabled:O.$3s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:O.$3s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:o($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends y{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:Q.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:Q.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:Q.highlightActiveIndentation,description:p.localize(148,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{bracketPairs:ee($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:o($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:o($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,Q,$e){const Ge=$e.indexOf(Z);return Ge===-1?Q:$e[Ge]}class ne extends y{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:Q.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:Q.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{insertMode:$($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:o($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:o($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:o($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:o($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:$($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:o($e.showIcons,this.defaultValue.showIcons),showStatusBar:o($e.showStatusBar,this.defaultValue.showStatusBar),preview:o($e.preview,this.defaultValue.preview),previewMode:$($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:o($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:o($e.showMethods,this.defaultValue.showMethods),showFunctions:o($e.showFunctions,this.defaultValue.showFunctions),showConstructors:o($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:o($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:o($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:o($e.showFields,this.defaultValue.showFields),showVariables:o($e.showVariables,this.defaultValue.showVariables),showClasses:o($e.showClasses,this.defaultValue.showClasses),showStructs:o($e.showStructs,this.defaultValue.showStructs),showInterfaces:o($e.showInterfaces,this.defaultValue.showInterfaces),showModules:o($e.showModules,this.defaultValue.showModules),showProperties:o($e.showProperties,this.defaultValue.showProperties),showEvents:o($e.showEvents,this.defaultValue.showEvents),showOperators:o($e.showOperators,this.defaultValue.showOperators),showUnits:o($e.showUnits,this.defaultValue.showUnits),showValues:o($e.showValues,this.defaultValue.showValues),showConstants:o($e.showConstants,this.defaultValue.showConstants),showEnums:o($e.showEnums,this.defaultValue.showEnums),showEnumMembers:o($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:o($e.showKeywords,this.defaultValue.showKeywords),showWords:o($e.showWords,this.defaultValue.showWords),showColors:o($e.showColors,this.defaultValue.showColors),showFiles:o($e.showFiles,this.defaultValue.showFiles),showReferences:o($e.showReferences,this.defaultValue.showReferences),showFolders:o($e.showFolders,this.defaultValue.showFolders),showTypeParameters:o($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:o($e.showSnippets,this.defaultValue.showSnippets),showUsers:o($e.showUsers,this.defaultValue.showUsers),showIssues:o($e.showIssues,this.defaultValue.showIssues)}}}class Oe extends y{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:o(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:o(Q.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends y{constructor(){const Q=[];super(130,"wordSegmenterLocales",Q,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(Q){if(typeof Q=="string"&&(Q=[Q]),Array.isArray(Q)){const $e=[];for(const Ge of Q)if(typeof Ge=="string")try{Intl.Segmenter.supportedLocalesOf(Ge).length>0&&$e.push(Ge)}catch{}return $e}return this.defaultValue}}var Ye;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ye||(e.WrappingIndent=Ye={}));class _e extends y{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(Q){switch(Q){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(Q,$e,Ge){return $e.get(2)===2?0:Ge}}class et extends m{constructor(){super(146)}compute(Q,$e,Ge){const ye=$e.get(145);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:ye.isWordWrapMinified,isViewportWrapping:ye.isViewportWrapping,wrappingColumn:ye.wrappingColumn}}}class tt extends y{constructor(){const Q={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showDropSelector:$($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class it extends y{constructor(){const Q={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",Q,{"editor.pasteAs.enabled":{type:"boolean",default:Q.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const $e=Q;return{enabled:o($e.enabled,this.defaultValue.enabled),showPasteSelector:$($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const nt="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",mt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.$j?at:R.$k?mt:nt,fontWeight:"normal",fontSize:R.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function je(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:je(new r(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:je(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:je(new C),accessibilityPageSize:je(new n(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:je(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:je(new r(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:je(new r(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:je(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:je(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:je(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:je(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:je(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:je(new v(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],d,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:je(new r(13,"automaticLayout",!1)),autoSurround:je(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:je(new H),bracketPairGuides:je(new G),stickyTabStops:je(new r(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:je(new r(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:je(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:je(new n(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:je(new r(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:je(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:je(new n(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:je(new r(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:je(new u),contextmenu:je(new r(24,"contextmenu",!0)),copyWithSyntaxHighlighting:je(new r(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:je(new v(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],f,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:je(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:je(new v(28,"cursorStyle",k.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],P,{description:p.localize(260,null)})),cursorSurroundingLines:je(new n(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:je(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:je(new n(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:je(new r(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:je(new r(33,"disableMonospaceOptimizations",!1)),domReadOnly:je(new r(34,"domReadOnly",!1)),dragAndDrop:je(new r(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:je(new W),dropIntoEditor:je(new tt),stickyScroll:je(new Re),experimentalWhitespaceRendering:je(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:je(new i(39,"extraEditorClassName","")),fastScrollSensitivity:je(new h(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:p.localize(271,null)})),find:je(new V),fixedOverflowWidgets:je(new r(42,"fixedOverflowWidgets",!1)),folding:je(new r(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:je(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:je(new r(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:je(new r(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:je(new n(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:je(new r(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:je(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:je(new j),fontLigatures2:je(new q),fontSize:je(new K),fontWeight:je(new re),fontVariations:je(new A),formatOnPaste:je(new r(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:je(new r(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:je(new r(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:je(new ae),hideCursorInOverviewRuler:je(new r(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:je(new we),inDiffEditor:je(new r(61,"inDiffEditor",!1)),letterSpacing:je(new h(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>h.clamp(Z,-5,20),{description:p.localize(285,null)})),lightbulb:je(new ce),lineDecorationsWidth:je(new L),lineHeight:je(new x),lineNumbers:je(new le),lineNumbersMinChars:je(new n(69,"lineNumbersMinChars",5,1,300)),linkedEditing:je(new r(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:je(new r(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:je(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:je(new ve),mouseStyle:je(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:je(new h(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:je(new r(76,"mouseWheelZoom",!1,{markdownDescription:R.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:je(new r(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:je(new v(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Fe,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:je(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:je(new n(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:je(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:je(new r(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:je(new n(83,"overviewRulerLanes",3,0,3)),padding:je(new Ee),pasteAs:je(new it),parameterHints:je(new pe),peekWidgetDefaultFocus:je(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:je(new r(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:je(new Y),quickSuggestionsDelay:je(new n(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:je(new r(91,"readOnly",!1)),readOnlyMessage:je(new he),renameOnType:je(new r(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:je(new r(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:je(new a(95,"renderFinalNewline",R.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:je(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:je(new r(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:je(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:je(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:je(new n(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:je(new r(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:je(new Te),scrollbar:je(new Ne),scrollBeyondLastColumn:je(new n(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:je(new r(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:je(new r(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:je(new r(107,"selectionClipboard",!0,{description:p.localize(325,null),included:R.$k})),selectionHighlight:je(new r(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:je(new r(109,"selectOnLineNumbers",!0)),showFoldingControls:je(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:je(new r(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:je(new r(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:je(new ie),snippetSuggestions:je(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:je(new Oe),smoothScrolling:je(new r(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:je(new n(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:je(new ne),inlineSuggest:je(new U),inlineEdit:je(new z),inlineCompletionsAccessibilityVerbose:je(new r(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:je(new n(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:je(new n(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:je(new r(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:je(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:je(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:je(new n(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:je(new ze),unusualLineTerminators:je(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:je(new r(127,"useShadowDOM",!0)),useTabStops:je(new r(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:je(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:je(new Be),wordSeparators:je(new i(131,"wordSeparators",M.$4s,{description:p.localize(359,null)})),wordWrap:je(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:je(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:je(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:je(new n(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:je(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:je(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:je(new I),defaultColorDecorators:je(new r(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:je(new fe),tabFocusMode:je(new r(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:je(new de),wrappingInfo:je(new et),wrappingIndent:je(new _e),wrappingStrategy:je(new me)}}),define(Ce[153],Ae([9,10]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[154],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[155],Ae([9,10]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[156],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[157],Ae([9,10]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[158],Ae([9,10]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(Ce[159],Ae([9,10]),function(ge,e){return ge.create("vs/platform/log/common/log",e)}),define(Ce[160],Ae([9,10]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(Ce[161],Ae([9,10]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[162],Ae([9,10]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(Ce[163],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[164],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[165],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[166],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Ce[167],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[168],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(Ce[169],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[170],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[171],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[172],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[173],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Ce[174],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[175],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(Ce[176],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(Ce[177],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(Ce[178],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Ce[179],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[180],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[181],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[182],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[183],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[184],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Ce[185],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[186],Ae([9,10]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[187],Ae([1,0,14,155]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qj=e.TokenType=void 0;var R;(function(E){E[E.LParen=0]="LParen",E[E.RParen=1]="RParen",E[E.Neg=2]="Neg",E[E.Eq=3]="Eq",E[E.NotEq=4]="NotEq",E[E.Lt=5]="Lt",E[E.LtEq=6]="LtEq",E[E.Gt=7]="Gt",E[E.GtEq=8]="GtEq",E[E.RegexOp=9]="RegexOp",E[E.RegexStr=10]="RegexStr",E[E.True=11]="True",E[E.False=12]="False",E[E.In=13]="In",E[E.Not=14]="Not",E[E.And=15]="And",E[E.Or=16]="Or",E[E.Str=17]="Str",E[E.QuotedStr=18]="QuotedStr",E[E.Error=19]="Error",E[E.EOF=20]="EOF"})(R||(e.TokenType=R={}));function O(...E){switch(E.length){case 1:return(0,N.localize)(0,null,E[0]);case 2:return(0,N.localize)(1,null,E[0],E[1]);case 3:return(0,N.localize)(2,null,E[0],E[1],E[2]);default:return}}const M=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class g{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(T){switch(T.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return T.isTripleEq?"===":"==";case 4:return T.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return T.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return T.lexeme;case 18:return T.lexeme;case 19:return T.lexeme;case 20:return"EOF";default:throw(0,S.$8)(`unhandled token type: ${JSON.stringify(T)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(T=>T.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(T){return this.c=T,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const y=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:y})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const y=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:y})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(T){return this.r()||this.c.charCodeAt(this.e)!==T?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(T){this.f.push({type:T,offset:this.d})}l(T){const y=this.d,l=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:l};this.g.push({offset:y,lexeme:l,additionalInfo:T}),this.f.push(w)}n(){this.m.lastIndex=this.d;const T=this.m.exec(this.c);if(T){this.e=this.d+T[0].length;const y=this.c.substring(this.d,this.e),l=g.b.get(y);l?this.k(l):this.f.push({type:17,lexeme:y,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(M);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let T=this.e,y=!1,l=!1;for(;;){if(T>=this.c.length){this.e=T,this.l(p);return}const m=this.c.charCodeAt(T);if(y)y=!1;else if(m===47&&!l){T++;break}else m===91?l=!0:m===92?y=!0:m===93&&(l=!1);T++}for(;T<this.c.length&&g.a.has(this.c.charCodeAt(T));)T++;this.e=T;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$qj=g}),define(Ce[188],Ae([1,0,23,33,157,300]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fp=g,e.$Gp=E,e.$Hp=T,e.$Ip=y,e.$Jp=l,e.$Kp=w,e.$Lp=m;const M=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function g(r){return r=r.trim(),r==="*"||M.test(r)}function E(r){if(!g(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const t=r.match(M);return t?{hasCaret:t[1]==="^",hasGreaterEquals:t[1]===">=",majorBase:t[2]==="x"?0:parseInt(t[2],10),majorMustEqual:t[2]!=="x",minorBase:t[4]==="x"?0:parseInt(t[4],10),minorMustEqual:t[4]!=="x",patchBase:t[6]==="x"?0:parseInt(t[6],10),patchMustEqual:t[6]!=="x",preRelease:t[8]||null}:null}function T(r){if(!r)return null;const t=r.majorBase,n=r.majorMustEqual,c=r.minorBase;let h=r.minorMustEqual;const i=r.patchBase;let $=r.patchMustEqual;r.hasCaret&&(t===0||(h=!1),$=!1);let a=0;if(r.preRelease){const v=p.exec(r.preRelease);if(v){const[,d,C,u]=v;a=Date.UTC(Number(d),Number(C)-1,Number(u))}}return{majorBase:t,majorMustEqual:n,minorBase:c,minorMustEqual:h,patchBase:i,patchMustEqual:$,isMinimum:r.hasGreaterEquals,notBefore:a}}function y(r,t,n){let c;typeof r=="string"?c=T(E(r)):c=r;let h;t instanceof Date?h=t.getTime():typeof t=="string"&&(h=new Date(t).getTime());let i;if(typeof n=="string"?i=T(E(n)):i=n,!c||!i)return!1;const $=c.majorBase,a=c.minorBase,v=c.patchBase;let d=i.majorBase,C=i.minorBase,u=i.patchBase;const D=i.notBefore;let f=i.majorMustEqual,k=i.minorMustEqual,b=i.patchMustEqual;return i.isMinimum?$>d?!0:$<d?!1:a>C?!0:a<C||h&&h<D?!1:v>=u:($===1&&d===0&&(!f||!k||!b)&&(d=1,C=0,u=0,f=!0,k=!1,b=!1),$<d?!1:$>d?!f:a<C?!1:a>C?!k:v<u?!1:v>u?!b:!(h&&h<D))}function l(r,t,n,c,h){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,R.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,R.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,R.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,R.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!o(c.extensionDependencies))return i.push([N.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!o(c.activationEvents))return i.push([N.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,R.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,R.localize(9,null,"main")]),i;{const v=(0,S.$9g)(n,c.main);(0,S.$3g)(v,n)||i.push([N.default.Warning,R.localize(10,null,v.path,n.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,R.localize(11,null,"browser")]),i;{const v=(0,S.$9g)(n,c.browser);(0,S.$3g)(v,n)||i.push([N.default.Warning,R.localize(12,null,v.path,n.path)])}}if(!O.valid(c.version))return i.push([N.default.Error,R.localize(13,null)]),i;const $=[];if(!w(r,t,c,h,$))for(const v of $)i.push([N.default.Error,v]);return i}function w(r,t,n,c,h){return c||typeof n.main>"u"&&typeof n.browser>"u"?!0:s(r,t,n.engines.vscode,h)}function m(r,t,n){return r==="*"||s(t,n,r)}function s(r,t,n,c=[]){const h=T(E(n));if(!h)return c.push(R.localize(14,null,n)),!1;if(h.majorBase===0){if(!h.majorMustEqual||!h.minorMustEqual)return c.push(R.localize(15,null,n)),!1}else if(!h.majorMustEqual)return c.push(R.localize(16,null,n)),!1;return y(r,t,h)?!0:(c.push(R.localize(17,null,r,n)),!1)}function o(r){if(!Array.isArray(r))return!1;for(let t=0,n=r.length;t<n;t++)if(typeof r[t]!="string")return!1;return!0}}),define(Ce[70],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$si=void 0;class S{constructor(R,O=[],M=!1){this.ctor=R,this.staticArguments=O,this.supportsDelayedInstantiation=M}}e.$si=S}),define(Ce[55],Ae([1,0,70]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$ws=O,e.$xs=M;const N=[];var R;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function O(p,g,E){g instanceof S.$si||(g=new S.$si(g,[],!!E)),N.push([p,g])}function M(){return N}}),define(Ce[189],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ar=e.$_q=void 0;class S{constructor(O,M){this.key=O,this.data=M,this.incoming=new Map,this.outgoing=new Map}}e.$_q=S;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const M of this.a.values())M.outgoing.size===0&&O.push(M);return O}insertEdge(O,M){const p=this.lookupOrInsertNode(O),g=this.lookupOrInsertNode(M);p.outgoing.set(g.key,g),g.incoming.set(p.key,p)}removeNode(O){const M=this.b(O);this.a.delete(M);for(const p of this.a.values())p.outgoing.delete(M),p.incoming.delete(M)}lookupOrInsertNode(O){const M=this.b(O);let p=this.a.get(M);return p||(p=new S(M,O),this.a.set(M,p)),p}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[M,p]of this.a)O.push(`${M}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,M]of this.a){const p=new Set([O]),g=this.c(M,p);if(g)return g}}c(O,M){for(const[p,g]of O.outgoing){if(M.has(p))return[...M,p].join(" -> ");M.add(p);const E=this.c(g,M);if(E)return E;M.delete(p)}}}e.$ar=N}),define(Ce[3],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ui=e._util=void 0,e.$vi=R,e.$wi=O;var S;(function(M){M.serviceIds=new Map,M.DI_TARGET="$di$target",M.DI_DEPENDENCIES="$di$dependencies";function p(g){return g[M.DI_DEPENDENCIES]||[]}M.getServiceDependencies=p})(S||(e._util=S={})),e.$ui=R("instantiationService");function N(M,p,g){p[S.DI_TARGET]===p?p[S.DI_DEPENDENCIES].push({id:M,index:g}):(p[S.DI_DEPENDENCIES]=[{id:M,index:g}],p[S.DI_TARGET]=p)}function R(M){if(S.serviceIds.has(M))return S.serviceIds.get(M);const p=function(g,E,T){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,g,T)};return p.toString=()=>M,S.serviceIds.set(M,p),p}function O(M){return M}}),define(Ce[48],Ae([1,0,17,2,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$2i=void 0,e.$3i=O,e.$4i=M,e.$5i=g,e.$6i=E,e.$7i=T,e.$8i=y,e.$9i=l,e.$0i=m,e.$$i=s,e.$_i=o,e.$2i=(0,R.$vi)("configurationService");function O(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof N.URI)}function M(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof N.URI)}var p;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function g(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function E(r){return r.applicationValue!==void 0||r.userValue!==void 0||r.userLocalValue!==void 0||r.userRemoteValue!==void 0||r.workspaceValue!==void 0||r.workspaceFolderValue!==void 0}function T(r,t){const n=Object.create(null);for(const c in r)y(n,c,r[c],t);return n}function y(r,t,n,c){const h=t.split("."),i=h.pop();let $=r;for(let a=0;a<h.length;a++){const v=h[a];let d=$[v];switch(typeof d){case"undefined":d=$[v]=Object.create(null);break;case"object":if(d===null){c(`Ignoring ${t} as ${h.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${t} as ${h.slice(0,a+1).join(".")} is ${JSON.stringify(d)}`);return}$=d}if(typeof $=="object"&&$!==null)try{$[i]=n}catch{c(`Ignoring ${t} as ${h.join(".")} is ${JSON.stringify($)}`)}else c(`Ignoring ${t} as ${h.join(".")} is ${JSON.stringify($)}`)}function l(r,t){const n=t.split(".");w(r,n)}function w(r,t){const n=t.shift();if(t.length===0){delete r[n];return}if(Object.keys(r).indexOf(n)!==-1){const c=r[n];typeof c=="object"&&!Array.isArray(c)&&(w(c,t),Object.keys(c).length===0&&delete r[n])}}function m(r,t,n){function c($,a){let v=$;for(const d of a){if(typeof v!="object"||v===null)return;v=v[d]}return v}const h=t.split("."),i=c(r,h);return typeof i>"u"?n:i}function s(r,t,n){Object.keys(t).forEach(c=>{c!=="__proto__"&&(c in r?S.$0f(r[c])&&S.$0f(t[c])?s(r[c],t[c],n):n&&(r[c]=t[c]):r[c]=t[c])})}function o(r){return r.replace(/[\[\]]/g,"")}}),define(Ce[31],Ae([1,0,21,15,187,3,154,14]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$tj=e.$sj=e.ContextKeyExprType=void 0,e.$rj=E,e.$uj=$,e.$vj=a,e.$Oj=Me;const g=new Map;g.set("false",!1),g.set("true",!0),g.set("isMac",S.$j),g.set("isLinux",S.$k),g.set("isWindows",S.$i),g.set("isWeb",S.$o),g.set("isMacNative",S.$j&&!S.$o),g.set("isEdge",S.$H),g.set("isFirefox",S.$F),g.set("isChrome",S.$E),g.set("isSafari",S.$G);function E(ie,L){if(g.get(ie)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");g.set(ie,L)}const T=Object.prototype.hasOwnProperty;var y;(function(ie){ie[ie.False=0]="False",ie[ie.True=1]="True",ie[ie.Defined=2]="Defined",ie[ie.Not=3]="Not",ie[ie.Equals=4]="Equals",ie[ie.NotEquals=5]="NotEquals",ie[ie.And=6]="And",ie[ie.Regex=7]="Regex",ie[ie.NotRegex=8]="NotRegex",ie[ie.Or=9]="Or",ie[ie.In=10]="In",ie[ie.NotIn=11]="NotIn",ie[ie.Greater=12]="Greater",ie[ie.GreaterEquals=13]="GreaterEquals",ie[ie.Smaller=14]="Smaller",ie[ie.SmallerEquals=15]="SmallerEquals"})(y||(e.ContextKeyExprType=y={}));const l={regexParsingWithErrorRecovery:!0},w=(0,M.localize)(0,null),m=(0,M.localize)(1,null),s=(0,M.localize)(2,null),o=(0,M.localize)(3,null),r=(0,M.localize)(4,null),t=(0,M.localize)(5,null),n=(0,M.localize)(6,null),c=(0,M.localize)(7,null);class h{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(L=l){this.k=L,this.d=new R.$qj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(L){if(L===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:m});return}this.f=this.d.reset(L).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Fe=ve.type===17?t:void 0;throw this.h.push({message:r,offset:ve.offset,lexeme:R.$qj.getLexeme(ve),additionalInfo:Fe}),h.c}return x}catch(x){if(x!==h.c)throw x;return}}l(){return this.m()}m(){const L=[this.o()];for(;this.y(16);){const x=this.o();L.push(x)}return L.length===1?L[0]:i.or(...L)}o(){const L=[this.s()];for(;this.y(15);){const x=this.s();L.push(x)}return L.length===1?L[0]:i.and(...L)}s(){if(this.y(2)){const L=this.D();switch(L.type){case 11:return this.z(),d.INSTANCE;case 12:return this.z(),C.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,o),x?.negate()}case 17:return this.z(),P.create(L.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",L)}}return this.t()}t(){const L=this.D();switch(L.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,o),x}case 17:{const x=L.lexeme;if(this.z(),this.y(9)){const Fe=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Fe.type!==10)throw this.B("REGEX",Fe);const Ee=Fe.lexeme,pe=Ee.lastIndexOf("/"),fe=pe===Ee.length-1?void 0:this.w(Ee.substring(pe+1));let Y;try{Y=new RegExp(Ee.substring(1,pe),fe)}catch{throw this.B("REGEX",Fe)}return j.create(x,Y)}switch(Fe.type){case 10:case 19:{const Ee=[Fe.lexeme];this.z();let pe=this.D(),fe=0;for(let Te=0;Te<Fe.lexeme.length;Te++)Fe.lexeme.charCodeAt(Te)===40?fe++:Fe.lexeme.charCodeAt(Te)===41&&fe--;for(;!this.E()&&pe.type!==15&&pe.type!==16;){switch(pe.type){case 0:fe++;break;case 1:fe--;break;case 10:case 18:for(let Te=0;Te<pe.lexeme.length;Te++)pe.lexeme.charCodeAt(Te)===40?fe++:Fe.lexeme.charCodeAt(Te)===41&&fe--}if(fe<0)break;Ee.push(R.$qj.getLexeme(pe)),this.z(),pe=this.D()}const Y=Ee.join(""),X=Y.lastIndexOf("/"),le=X===Y.length-1?void 0:this.w(Y.substring(X+1));let ue;try{ue=new RegExp(Y.substring(1,X),le)}catch{throw this.B("REGEX",Fe)}return i.regex(x,ue)}case 18:{const Ee=Fe.lexeme;this.z();let pe=null;if(!(0,N.$7e)(Ee)){const fe=Ee.indexOf("/"),Y=Ee.lastIndexOf("/");if(fe!==Y&&fe>=0){const X=Ee.slice(fe+1,Y),le=Ee[Y+1]==="i"?"i":"";try{pe=new RegExp(X,le)}catch{throw this.B("REGEX",Fe)}}}if(pe===null)throw this.B("REGEX",Fe);return j.create(x,pe)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,s);const Fe=this.u();return i.notIn(x,Fe)}switch(this.D().type){case 3:{this.z();const Fe=this.u();if(this.x().type===18)return i.equals(x,Fe);switch(Fe){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Fe)}}case 4:{this.z();const Fe=this.u();if(this.x().type===18)return i.notEquals(x,Fe);switch(Fe){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Fe)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),A.create(x,this.u());case 7:return this.z(),W.create(x,this.u());case 8:return this.z(),V.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:n,offset:L.offset,lexeme:"",additionalInfo:c}),h.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const L=this.D();switch(L.type){case 17:case 18:return this.z(),L.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(L){return L.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(L){return this.C(L)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(L,x){if(this.C(L))return this.z();throw this.B(x,this.D())}B(L,x,ve){const Fe=(0,M.localize)(8,null,L,R.$qj.getLexeme(x)),Ee=x.offset,pe=R.$qj.getLexeme(x);return this.h.push({message:Fe,offset:Ee,lexeme:pe,additionalInfo:ve}),h.c}C(L){return this.D().type===L}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$sj=h;class i{static false(){return d.INSTANCE}static true(){return C.INSTANCE}static has(L){return u.create(L)}static equals(L,x){return D.create(L,x)}static notEquals(L,x){return b.create(L,x)}static regex(L,x){return j.create(L,x)}static in(L,x){return f.create(L,x)}static notIn(L,x){return k.create(L,x)}static not(L){return P.create(L)}static and(...L){return ae.create(L,null,!0)}static or(...L){return we.create(L,null,!0)}static greater(L,x){return W.create(L,x)}static greaterEquals(L,x){return V.create(L,x)}static smaller(L,x){return q.create(L,x)}static smallerEquals(L,x){return A.create(L,x)}static{this.c=new h({regexParsingWithErrorRecovery:!1})}static deserialize(L){return L==null?void 0:this.c.parse(L)}}e.$tj=i;function $(ie){const L=new h({regexParsingWithErrorRecovery:!1});return ie.map(x=>(L.parse(x),L.lexingErrors.length>0?L.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,M.localize)(9,null,ve.additionalInfo):(0,M.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):L.parsingErrors.length>0?L.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ie,L){const x=ie?ie.substituteConstants():void 0,ve=L?L.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function v(ie,L){return ie.cmp(L)}class d{static{this.INSTANCE=new d}constructor(){this.type=0}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!1}serialize(){return"false"}keys(){return[]}map(L){return this}negate(){return C.INSTANCE}}e.$wj=d;class C{static{this.INSTANCE=new C}constructor(){this.type=1}cmp(L){return this.type-L.type}equals(L){return L.type===this.type}substituteConstants(){return this}evaluate(L){return!0}serialize(){return"true"}keys(){return[]}map(L){return this}negate(){return d.INSTANCE}}e.$xj=C;class u{static create(L,x=null){const ve=g.get(L);return typeof ve=="boolean"?ve?C.INSTANCE:d.INSTANCE:new u(L,x)}constructor(L,x){this.key=L,this.c=x,this.type=2}cmp(L){return L.type!==this.type?this.type-L.type:de(this.key,L.key)}equals(L){return L.type===this.type?this.key===L.key:!1}substituteConstants(){const L=g.get(this.key);return typeof L=="boolean"?L?C.INSTANCE:d.INSTANCE:this}evaluate(L){return!!L.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(L){return L.mapDefined(this.key)}negate(){return this.c||(this.c=P.create(this.key,this)),this.c}}e.$yj=u;class D{static create(L,x,ve=null){if(typeof x=="boolean")return x?u.create(L,ve):P.create(L,ve);const Fe=g.get(L);return typeof Fe=="boolean"?x===(Fe?"true":"false")?C.INSTANCE:d.INSTANCE:new D(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=4}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=g.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?C.INSTANCE:d.INSTANCE}return this}evaluate(L){return L.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(L){return L.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$zj=D;class f{static create(L,x){return new f(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=10,this.c=null}cmp(L){return L.type!==this.type?this.type-L.type:me(this.d,this.f,L.d,L.f)}equals(L){return L.type===this.type?this.d===L.d&&this.f===L.f:!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.f),ve=L.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?T.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(L){return L.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Aj=f;class k{static create(L,x){return new k(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=11,this.c=f.create(L,x)}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(L){return L.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Bj=k;class b{static create(L,x,ve=null){if(typeof x=="boolean")return x?P.create(L,ve):u.create(L,ve);const Fe=g.get(L);return typeof Fe=="boolean"?x===(Fe?"true":"false")?d.INSTANCE:C.INSTANCE:new b(L,x,ve)}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=5}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){const L=g.get(this.c);if(typeof L=="boolean"){const x=L?"true":"false";return this.d===x?d.INSTANCE:C.INSTANCE}return this}evaluate(L){return L.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(L){return L.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Cj=b;class P{static create(L,x=null){const ve=g.get(L);return typeof ve=="boolean"?ve?d.INSTANCE:C.INSTANCE:new P(L,x)}constructor(L,x){this.c=L,this.d=x,this.type=3}cmp(L){return L.type!==this.type?this.type-L.type:de(this.c,L.c)}equals(L){return L.type===this.type?this.c===L.c:!1}substituteConstants(){const L=g.get(this.c);return typeof L=="boolean"?L?d.INSTANCE:C.INSTANCE:this}evaluate(L){return!L.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(L){return L.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Dj=P;function I(ie,L){if(typeof ie=="string"){const x=parseFloat(ie);isNaN(x)||(ie=x)}return typeof ie=="string"||typeof ie=="number"?L(ie):d.INSTANCE}class W{static create(L,x,ve=null){return I(x,Fe=>new W(L,Fe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=12}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$Ej=W;class V{static create(L,x,ve=null){return I(x,Fe=>new V(L,Fe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=13}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(L){return L.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Fj=V;class q{static create(L,x,ve=null){return I(x,Fe=>new q(L,Fe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=14}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Gj=q;class A{static create(L,x,ve=null){return I(x,Fe=>new A(L,Fe,ve))}constructor(L,x,ve){this.c=L,this.d=x,this.f=ve,this.type=15}cmp(L){return L.type!==this.type?this.type-L.type:me(this.c,this.d,L.c,L.d)}equals(L){return L.type===this.type?this.c===L.c&&this.d===L.d:!1}substituteConstants(){return this}evaluate(L){return typeof this.d=="string"?!1:parseFloat(L.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(L){return L.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Hj=A;class j{static create(L,x){return new j(L,x)}constructor(L,x){this.d=L,this.f=x,this.type=7,this.c=null}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.d<L.d)return-1;if(this.d>L.d)return 1;const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return x<ve?-1:x>ve?1:0}equals(L){if(L.type===this.type){const x=this.f?this.f.source:"",ve=L.f?L.f.source:"";return this.d===L.d&&x===ve}return!1}substituteConstants(){return this}evaluate(L){const x=L.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const L=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${L}`}keys(){return[this.d]}map(L){return L.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Ij=j;class K{static create(L){return new K(L)}constructor(L){this.c=L,this.type=8}cmp(L){return L.type!==this.type?this.type-L.type:this.c.cmp(L.c)}equals(L){return L.type===this.type?this.c.equals(L.c):!1}substituteConstants(){return this}evaluate(L){return!this.c.evaluate(L)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(L){return new K(this.c.map(L))}negate(){return this.c}}e.$Jj=K;function re(ie){let L=null;for(let x=0,ve=ie.length;x<ve;x++){const Fe=ie[x].substituteConstants();if(ie[x]!==Fe&&L===null){L=[];for(let Ee=0;Ee<x;Ee++)L[Ee]=ie[Ee]}L!==null&&(L[x]=Fe)}return L===null?ie:L}class ae{static create(L,x,ve){return ae.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=6}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=v(this.expr[x],L.expr[x]);if(Fe!==0)return Fe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:ae.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(L))return!1;return!0}static d(L,x,ve){const Fe=[];let Ee=!1;for(const pe of L)if(pe){if(pe.type===1){Ee=!0;continue}if(pe.type===0)return d.INSTANCE;if(pe.type===6){Fe.push(...pe.expr);continue}Fe.push(pe)}if(Fe.length===0&&Ee)return C.INSTANCE;if(Fe.length!==0){if(Fe.length===1)return Fe[0];Fe.sort(v);for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];for(;Fe.length>1;){const pe=Fe[Fe.length-1];if(pe.type!==9)break;Fe.pop();const fe=Fe.pop(),Y=Fe.length===0,X=we.create(pe.expr.map(le=>ae.create([le,fe],null,ve)),null,Y);X&&(Fe.push(X),Fe.sort(v))}if(Fe.length===1)return Fe[0];if(ve){for(let pe=0;pe<Fe.length;pe++)for(let fe=pe+1;fe<Fe.length;fe++)if(Fe[pe].negate().equals(Fe[fe]))return d.INSTANCE;if(Fe.length===1)return Fe[0]}return new ae(Fe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" && ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new ae(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());this.c=we.create(L,this,!0)}return this.c}}e.$Kj=ae;class we{static create(L,x,ve){return we.d(L,x,ve)}constructor(L,x){this.expr=L,this.c=x,this.type=9}cmp(L){if(L.type!==this.type)return this.type-L.type;if(this.expr.length<L.expr.length)return-1;if(this.expr.length>L.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Fe=v(this.expr[x],L.expr[x]);if(Fe!==0)return Fe}return 0}equals(L){if(L.type===this.type){if(this.expr.length!==L.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(L.expr[x]))return!1;return!0}return!1}substituteConstants(){const L=re(this.expr);return L===this.expr?this:we.create(L,this.c,!1)}evaluate(L){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(L))return!0;return!1}static d(L,x,ve){let Fe=[],Ee=!1;if(L){for(let pe=0,fe=L.length;pe<fe;pe++){const Y=L[pe];if(Y){if(Y.type===0){Ee=!0;continue}if(Y.type===1)return C.INSTANCE;if(Y.type===9){Fe=Fe.concat(Y.expr);continue}Fe.push(Y)}}if(Fe.length===0&&Ee)return d.INSTANCE;Fe.sort(v)}if(Fe.length!==0){if(Fe.length===1)return Fe[0];for(let pe=1;pe<Fe.length;pe++)Fe[pe-1].equals(Fe[pe])&&(Fe.splice(pe,1),pe--);if(Fe.length===1)return Fe[0];if(ve){for(let pe=0;pe<Fe.length;pe++)for(let fe=pe+1;fe<Fe.length;fe++)if(Fe[pe].negate().equals(Fe[fe]))return C.INSTANCE;if(Fe.length===1)return Fe[0]}return new we(Fe,x)}}serialize(){return this.expr.map(L=>L.serialize()).join(" || ")}keys(){const L=[];for(const x of this.expr)L.push(...x.keys());return L}map(L){return new we(this.expr.map(x=>x.map(L)),null)}negate(){if(!this.c){const L=[];for(const x of this.expr)L.push(x.negate());for(;L.length>1;){const x=L.shift(),ve=L.shift(),Fe=[];for(const Ee of Re(x))for(const pe of Re(ve))Fe.push(ae.create([Ee,pe],null,!1));L.unshift(we.create(Fe,null,!1))}this.c=we.create(L,this,!0)}return this.c}}e.$Lj=we;class Ie extends u{static{this.d=[]}static all(){return Ie.d.values()}constructor(L,x,ve){super(L,null),this.f=x,typeof ve=="object"?Ie.d.push({...ve,key:L}):ve!==!0&&Ie.d.push({key:L,description:ve,type:x!=null?typeof x:void 0})}bindTo(L){return L.createKey(this.key,this.f)}getValue(L){return L.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(L){return D.create(this.key,L)}notEqualsTo(L){return b.create(this.key,L)}}e.$Mj=Ie,e.$Nj=(0,O.$vi)("contextKeyService");function de(ie,L){return ie<L?-1:ie>L?1:0}function me(ie,L,x,ve){return ie<x?-1:ie>x?1:L<ve?-1:L>ve?1:0}function Me(ie,L){if(ie.type===0||L.type===1)return!0;if(ie.type===9)return L.type===9?ce(ie.expr,L.expr):!1;if(L.type===9){for(const x of L.expr)if(Me(ie,x))return!0;return!1}if(ie.type===6){if(L.type===6)return ce(L.expr,ie.expr);for(const x of ie.expr)if(Me(x,L))return!0;return!1}return ie.equals(L)}function ce(ie,L){let x=0,ve=0;for(;x<ie.length&&ve<L.length;){const Fe=ie[x].cmp(L[ve]);if(Fe<0)return!1;Fe===0&&x++,ve++}return x===ie.length}function Re(ie){return ie.type===9?ie.expr:[ie]}}),define(Ce[190],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Di=e.$Ci=void 0,e.$Ci=(0,S.$vi)("environmentService"),e.$Di=(0,S.$wi)(e.$Ci)}),define(Ce[98],Ae([1,0,156,3]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bp=e.$ap=e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.ExtensionGalleryErrorCode=e.$6o=e.ExtensionManagementErrorCode=e.$5o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=void 0,e.$Yo=R,e.$Zo=O,e.$1o=M,e.$2o=p,e.$3o=g,e.$4o=E,e.$So="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$To=new RegExp(e.$So),e.$Uo="__web_extension",e.$Vo="skipWalkthrough",e.$Wo="extensionsSync",e.$Xo="dependecyOrPackExtensionInstall";function R(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function O(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function M(t,n){switch(t){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function p(t,n){return n==="web"&&!t.includes("web")}function g(t,n,c){return p(n,c)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===c}function E(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var T;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(T||(e.SortBy=T={}));var y;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(y||(e.SortOrder=y={}));var l;(function(t){t.Install="install",t.Uninstall="uninstall"})(l||(e.StatisticType=l={}));var w;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(w||(e.InstallOperation=w={})),e.$5o=(0,N.$vi)("extensionGalleryService");var m;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.Delete="Delete",t.Rename="Rename",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(m||(e.ExtensionManagementErrorCode=m={}));class s extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$6o=s;var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class r extends Error{constructor(n,c){super(n),this.code=c,this.name=c}}e.$7o=r,e.$8o=(0,N.$vi)("extensionManagementService"),e.$9o="extensionsIdentifiers/disabled",e.$0o="extensionsIdentifiers/enabled",e.$$o=(0,N.$vi)("IGlobalExtensionEnablementService"),e.$_o=(0,N.$vi)("IExtensionTipsService"),e.$ap=(0,S.localize2)(0,"Extensions"),e.$bp=(0,S.localize2)(1,"Preferences")}),define(Ce[44],Ae([1,0,52,19,15,17,2,158,3,21,12,41]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xl=e.$ul=e.FileKind=e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.FileOperationResult=e.$ml=e.$ll=e.$kl=e.$il=e.FileChangeType=e.$hl=e.FileOperation=e.$bl=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$2k=void 0,e.$3k=l,e.$4k=o,e.$5k=t,e.$6k=n,e.$7k=c,e.$8k=h,e.$9k=i,e.$0k=$,e.$$k=a,e.$_k=v,e.$al=d,e.$cl=D,e.$dl=f,e.$el=k,e.$fl=b,e.$gl=P,e.$jl=A,e.$vl=Ie,e.$wl=de,e.$yl=Me,e.$2k=(0,g.$vi)("fileService");function l(ce){return ce.create===!0}var w;(function(ce){ce[ce.Unknown=0]="Unknown",ce[ce.File=1]="File",ce[ce.Directory=2]="Directory",ce[ce.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var m;(function(ce){ce[ce.Readonly=1]="Readonly",ce[ce.Locked=2]="Locked"})(m||(e.FilePermission=m={}));var s;(function(ce){ce[ce.UPDATED=2]="UPDATED",ce[ce.ADDED=4]="ADDED",ce[ce.DELETED=8]="DELETED"})(s||(e.FileChangeFilter=s={}));function o(ce){const Re=ce;return!!Re&&typeof Re.onDidChange=="function"}var r;(function(ce){ce[ce.None=0]="None",ce[ce.FileReadWrite=2]="FileReadWrite",ce[ce.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ce[ce.FileReadStream=16]="FileReadStream",ce[ce.FileFolderCopy=8]="FileFolderCopy",ce[ce.PathCaseSensitive=1024]="PathCaseSensitive",ce[ce.Readonly=2048]="Readonly",ce[ce.Trash=4096]="Trash",ce[ce.FileWriteUnlock=8192]="FileWriteUnlock",ce[ce.FileAtomicRead=16384]="FileAtomicRead",ce[ce.FileAtomicWrite=32768]="FileAtomicWrite",ce[ce.FileAtomicDelete=65536]="FileAtomicDelete",ce[ce.FileClone=131072]="FileClone"})(r||(e.FileSystemProviderCapabilities=r={}));function t(ce){return!!(ce.capabilities&2)}function n(ce){return!!(ce.capabilities&8)}function c(ce){return!!(ce.capabilities&131072)}function h(ce){return!!(ce.capabilities&4)}function i(ce){return!!(ce.capabilities&16)}function $(ce){return t(ce)?!!(ce.capabilities&16384):!1}function a(ce){return t(ce)?!!(ce.capabilities&32768):!1}function v(ce){return!!(ce.capabilities&65536)}function d(ce){return!!(ce.capabilities&2048)}var C;(function(ce){ce.FileExists="EntryExists",ce.FileNotFound="EntryNotFound",ce.FileNotADirectory="EntryNotADirectory",ce.FileIsADirectory="EntryIsADirectory",ce.FileExceedsStorageQuota="EntryExceedsStorageQuota",ce.FileTooLarge="EntryTooLarge",ce.FileWriteLocked="EntryWriteLocked",ce.NoPermissions="NoPermissions",ce.Unavailable="Unavailable",ce.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class u extends Error{static create(Re,ie){const L=new u(Re.toString(),ie);return k(L,ie),L}constructor(Re,ie){super(Re),this.code=ie}}e.$bl=u;function D(ce,Re){return u.create(ce,Re)}function f(ce){return ce||D((0,p.localize)(0,null),C.Unknown)}function k(ce,Re){return ce.name=Re?`${Re} (FileSystemError)`:"FileSystemError",ce}function b(ce){if(!ce)return C.Unknown;if(ce instanceof u)return ce.code;const Re=/^(.+) \(FileSystemError\)$/.exec(ce.name);if(!Re)return C.Unknown;switch(Re[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}function P(ce){if(ce instanceof j)return ce.fileOperationResult;switch(b(ce)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}var I;(function(ce){ce[ce.CREATE=0]="CREATE",ce[ce.DELETE=1]="DELETE",ce[ce.MOVE=2]="MOVE",ce[ce.COPY=3]="COPY",ce[ce.WRITE=4]="WRITE"})(I||(e.FileOperation=I={}));class W{constructor(Re,ie,L){this.resource=Re,this.operation=ie,this.target=L}isOperation(Re){return this.operation===Re}}e.$hl=W;var V;(function(ce){ce[ce.UPDATED=0]="UPDATED",ce[ce.ADDED=1]="ADDED",ce[ce.DELETED=2]="DELETED"})(V||(e.FileChangeType=V={}));class q{static{this.a=null}constructor(Re,ie){this.c=ie,this.b=void 0,this.d=new y.$V(()=>{const L=S.$Bi.forUris(()=>this.c);return L.fill(this.rawAdded.map(x=>[x,!0])),L}),this.f=new y.$V(()=>{const L=S.$Bi.forUris(()=>this.c);return L.fill(this.rawUpdated.map(x=>[x,!0])),L}),this.g=new y.$V(()=>{const L=S.$Bi.forUris(()=>this.c);return L.fill(this.rawDeleted.map(x=>[x,!0])),L}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const L of Re){switch(L.type){case 1:this.rawAdded.push(L.resource);break;case 0:this.rawUpdated.push(L.resource);break;case 2:this.rawDeleted.push(L.resource);break}this.b!==q.a&&(typeof L.cId=="number"?this.b===void 0?this.b=L.cId:this.b!==L.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Re,...ie){return this.h(Re,{includeChildren:!1},...ie)}affects(Re,...ie){return this.h(Re,{includeChildren:!0},...ie)}h(Re,ie,...L){if(!Re)return!1;const x=L.length>0;return!!((!x||L.includes(1))&&(this.d.value.get(Re)||ie.includeChildren&&this.d.value.findSuperstr(Re))||(!x||L.includes(0))&&(this.f.value.get(Re)||ie.includeChildren&&this.f.value.findSuperstr(Re))||(!x||L.includes(2))&&(this.g.value.findSubstr(Re)||ie.includeChildren&&this.g.value.findSuperstr(Re)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Re){return this.b===Re}hasCorrelation(){return typeof this.b=="number"}}e.$il=q;function A(ce,Re,ie){return!ce||!Re||ce===Re||Re.length>ce.length?!1:(Re.charAt(Re.length-1)!==N.sep&&(Re+=N.sep),ie?(0,R.$yf)(ce,Re):ce.indexOf(Re)===0)}class j extends Error{constructor(Re,ie,L){super(Re),this.fileOperationResult=ie,this.options=L}}e.$kl=j;class K extends j{constructor(Re,ie,L,x){super(Re,ie,x),this.fileOperationResult=ie,this.size=L}}e.$ll=K;class re extends j{constructor(Re,ie,L){super(Re,2,L),this.stat=ie}}e.$ml=re;var ae;(function(ce){ce[ce.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ce[ce.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ce[ce.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ce[ce.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ce[ce.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ce[ce.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ce[ce.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ce[ce.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ce[ce.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ce[ce.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ce[ce.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ae||(e.FileOperationResult=ae={})),e.$nl={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$ol={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$pl="files.associations",e.$ql="files.exclude",e.$rl="files.readonlyInclude",e.$sl="files.readonlyExclude",e.$tl="files.readonlyFromPermissions";var we;(function(ce){ce[ce.FILE=0]="FILE",ce[ce.FOLDER=1]="FOLDER",ce[ce.ROOT_FOLDER=2]="ROOT_FOLDER"})(we||(e.FileKind=we={})),e.$ul="";function Ie(ce){if(!(typeof ce.size!="number"||typeof ce.mtime!="number"))return ce.mtime.toString(29)+ce.size.toString(31)}async function de(ce,Re){if(!Re.hasProvider(M.URI.from({scheme:ce.scheme})))return new Promise(ie=>{const L=Re.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===ce.scheme&&x.added&&(L.dispose(),ie())})})}class me{static{this.KB=1024}static{this.MB=me.KB*me.KB}static{this.GB=me.MB*me.KB}static{this.TB=me.GB*me.KB}static formatSize(Re){return(0,O.$_f)(Re)||(Re=0),Re<me.KB?(0,p.localize)(1,null,Re.toFixed(0)):Re<me.MB?(0,p.localize)(2,null,(Re/me.KB).toFixed(2)):Re<me.GB?(0,p.localize)(3,null,(Re/me.MB).toFixed(2)):Re<me.TB?(0,p.localize)(4,null,(Re/me.GB).toFixed(2)):(0,p.localize)(5,null,(Re/me.TB).toFixed(2))}}e.$xl=me;function Me(ce){const Re=typeof ce=="string"||ce?.scheme===T.Schemas.vscodeRemote;return typeof ce!="string"&&ce?.scheme===T.Schemas.file?1024*me.MB:Re?10*me.MB:E.$o?50*me.MB:1024*me.MB}}),define(Ce[71],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ti=void 0;class S{constructor(...R){this.a=new Map;for(const[O,M]of R)this.set(O,M)}set(R,O){const M=this.a.get(R);return this.a.set(R,O),M}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$ti=S}),define(Ce[191],Ae([1,0,11,14,6,70,189,3,71,192]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=e.$br=void 0;const T=!1;class y extends Error{constructor(o){super("cyclic dependency between services"),this.message=o.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${o.toString()}`}}class l{constructor(o=new g.$ti,r=!1,t,n=T){this.i=o,this.j=r,this.k=t,this.l=n,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$ui,this),this._globalGraph=n?t?._globalGraph??new M.$ar(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,R.$Qc)(this.h),this.h.clear();for(const o of this.g)(0,R.$Pc)(o)&&o.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(o){this.m();const r=new class extends l{dispose(){this.h.delete(r),super.dispose()}}(o,this.j,this,this.l);return this.h.add(r),r}invokeFunction(o,...r){this.m();const t=m.traceInvocation(this.l,o);let n=!1;try{return o({get:h=>{if(n)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(h,t);if(!i)throw new Error(`[invokeFunction] unknown service '${h}'`);return i}},...r)}finally{n=!0,t.stop()}}createInstance(o,...r){this.m();let t,n;return o instanceof O.$si?(t=m.traceCreation(this.l,o.ctor),n=this.o(o.ctor,o.staticArguments.concat(r),t)):(t=m.traceCreation(this.l,o),n=this.o(o,r,t)),t.stop(),n}o(o,r=[],t){const n=p._util.getServiceDependencies(o).sort((i,$)=>i.index-$.index),c=[];for(const i of n){const $=this.s(i.id,t);$||this.y(`[createInstance] ${o.name} depends on UNKNOWN service ${i.id}.`,!1),c.push($)}const h=n.length>0?n[0].index:r.length;if(r.length!==h){console.trace(`[createInstance] First service dependency of ${o.name} at position ${h+1} conflicts with ${r.length} static arguments`);const i=h-r.length;i>0?r=r.concat(new Array(i)):r=r.slice(0,h)}return Reflect.construct(o,r.concat(c))}q(o,r){if(this.i.get(o)instanceof O.$si)this.i.set(o,r);else if(this.k)this.k.q(o,r);else throw new Error("illegalState - setting UNKNOWN service instance")}r(o){const r=this.i.get(o);return!r&&this.k?this.k.r(o):r}s(o,r){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(o));const t=this.r(o);return t instanceof O.$si?this.u(o,t,r.branch(o,!0)):(r.branch(o,!1),t)}u(o,r,t){if(this.t.has(o))throw new Error(`illegal state - RECURSIVELY instantiating service '${o}'`);this.t.add(o);try{return this.v(o,r,t)}finally{this.t.delete(o)}}v(o,r,t){const n=new M.$ar(i=>i.id.toString());let c=0;const h=[{id:o,desc:r,_trace:t}];for(;h.length;){const i=h.pop();if(n.lookupOrInsertNode(i),c++>1e3)throw new y(n);for(const $ of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r($.id);if(a||this.y(`[createInstance] ${o} depends on ${$.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String($.id)),a instanceof O.$si){const v={id:$.id,desc:a,_trace:i._trace.branch($.id,!0)};n.insertEdge(i,v),h.push(v)}}}for(;;){const i=n.roots();if(i.length===0){if(!n.isEmpty())throw new y(n);break}for(const{data:$}of i){if(this.r($.id)instanceof O.$si){const v=this.w($.id,$.desc.ctor,$.desc.staticArguments,$.desc.supportsDelayedInstantiation,$._trace);this.q($.id,v)}n.removeNode($)}}return this.r(o)}w(o,r,t=[],n,c){if(this.i.get(o)instanceof O.$si)return this.x(o,r,t,n,c,this.g);if(this.k)return this.k.w(o,r,t,n,c);throw new Error(`illegalState - creating UNKNOWN service instance ${r.name}`)}x(o,r,t=[],n,c,h){if(n){const i=new l(void 0,this.j,this,this.l);i.c=String(o);const $=new Map,a=new S.$Oh(()=>{const v=i.o(r,t,c);for(const[d,C]of $){const u=v[d];if(typeof u=="function")for(const D of C)D.disposable=u.apply(v,D.listener)}return $.clear(),h.add(v),v});return new Proxy(Object.create(null),{get(v,d){if(!a.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let D=$.get(d);return D||(D=new E.$6c,$.set(d,D)),(k,b,P)=>{if(a.isInitialized)return a.value[d](k,b,P);{const I={listener:[k,b,P],disposable:void 0},W=D.push(I);return(0,R.$Tc)(()=>{W(),I.disposable?.dispose()})}}}if(d in v)return v[d];const C=a.value;let u=C[d];return typeof u!="function"||(u=u.bind(C),v[d]=u),u},set(v,d,C){return a.value[d]=C,!0},getPrototypeOf(v){return r.prototype}})}else{const i=this.o(r,t,c);return h.add(i),i}}y(o,r){if(r&&console.warn(o),this.j)throw new Error(o)}}e.$br=l;var w;(function(s){s[s.None=0]="None",s[s.Creation=1]="Creation",s[s.Invocation=2]="Invocation",s[s.Branch=3]="Branch"})(w||(w={}));class m{static{this.all=new Set}static{this.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(o,r){return o?new m(2,r.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(o,r){return o?new m(1,r.name):m.c}static{this.f=0}constructor(o,r){this.type=o,this.name=r,this.g=Date.now(),this.h=[]}branch(o,r){const t=new m(3,o.toString());return this.h.push([o,r,t]),t}stop(){const o=Date.now()-this.g;m.f+=o;let r=!1;function t(c,h){const i=[],$=new Array(c+1).join("	");for(const[a,v,d]of h.h)if(v&&d){r=!0,i.push(`${$}CREATES -> ${a}`);const C=t(c+1,d);C&&i.push(C)}else i.push(`${$}uses -> ${a}`);return i.join(`
`)}const n=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${t(1,this)}`,`DONE, took ${o.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(o>2||r)&&m.all.add(n.join(`
`))}}e.$cr=m}),define(Ce[13],Ae([1,0,159,43,5,99,6,28,21,23,17,2,31,3]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$9j=e.$8j=e.$7j=e.$5j=e.LogLevel=e.$3j=e.$2j=void 0,e.$4j=s,e.log=r,e.$dk=u,e.$ek=D,e.$fk=f,e.$gk=k,e.$2j=(0,w.$vi)("logService"),e.$3j=(0,w.$vi)("loggerService");function m(){return new Date().toISOString()}function s(b){return(0,T.$_f)(b)}var o;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(o||(e.LogLevel=o={})),e.$5j=o.Info;function r(b,P,I){switch(P){case o.Trace:b.trace(I);break;case o.Debug:b.debug(I);break;case o.Info:b.info(I);break;case o.Warning:b.warn(I);break;case o.Error:b.error(I);break;case o.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function t(b,P=!1){let I="";for(let W=0;W<b.length;W++){let V=b[W];if(V instanceof Error&&(V=(0,N.$gj)(V,P)),typeof V=="object")try{V=JSON.stringify(V)}catch{}I+=(W>0?" ":"")+V}return I}class n extends M.$Vc{constructor(){super(...arguments),this.b=e.$5j,this.c=this.B(new R.$ee),this.onDidChangeLogLevel=this.c.event}setLevel(P){this.b!==P&&(this.b=P,this.c.fire(this.b))}getLevel(){return this.b}f(P){return this.b!==o.Off&&this.b<=P}}e.$7j=n;class c extends n{constructor(P){super(),this.h=P}f(P){return this.h||super.f(P)}trace(P,...I){this.f(o.Trace)&&this.g(o.Trace,t([P,...I],!0))}debug(P,...I){this.f(o.Debug)&&this.g(o.Debug,t([P,...I]))}info(P,...I){this.f(o.Info)&&this.g(o.Info,t([P,...I]))}warn(P,...I){this.f(o.Warning)&&this.g(o.Warning,t([P,...I]))}error(P,...I){if(this.f(o.Error))if(P instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=P.stack,this.g(o.Error,t(W))}else this.g(o.Error,t([P,...I]))}flush(){}}e.$8j=c;class h extends n{constructor(P=e.$5j){super(),this.setLevel(P),this.g=!g.$i}trace(P,...I){this.f(o.Trace)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...I):console.log(`[main ${m()}]`,P,...I))}debug(P,...I){this.f(o.Debug)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...I):console.log(`[main ${m()}]`,P,...I))}info(P,...I){this.f(o.Info)&&(this.g?console.log(`\x1B[90m[main ${m()}]\x1B[0m`,P,...I):console.log(`[main ${m()}]`,P,...I))}warn(P,...I){this.f(o.Warning)&&(this.g?console.warn(`\x1B[93m[main ${m()}]\x1B[0m`,P,...I):console.warn(`[main ${m()}]`,P,...I))}error(P,...I){this.f(o.Error)&&(this.g?console.error(`\x1B[91m[main ${m()}]\x1B[0m`,P,...I):console.error(`[main ${m()}]`,P,...I))}flush(){}}e.$9j=h;class i extends n{constructor(P=e.$5j,I=!0){super(),this.g=I,this.setLevel(P)}trace(P,...I){this.f(o.Trace)&&(this.g?console.log("%cTRACE","color: #888",P,...I):console.log(P,...I))}debug(P,...I){this.f(o.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",P,...I):console.log(P,...I))}info(P,...I){this.f(o.Info)&&(this.g?console.log("%c INFO","color: #33f",P,...I):console.log(P,...I))}warn(P,...I){this.f(o.Warning)&&(this.g?console.log("%c WARN","color: #993",P,...I):console.log(P,...I))}error(P,...I){this.f(o.Error)&&(this.g?console.log("%c  ERR","color: #f33",P,...I):console.error(P,...I))}flush(){}}e.$0j=i;class $ extends n{constructor(P,I=e.$5j){super(),this.g=P,this.setLevel(I)}trace(P,...I){this.f(o.Trace)&&this.g.log(o.Trace,[this.h(P),...I])}debug(P,...I){this.f(o.Debug)&&this.g.log(o.Debug,[this.h(P),...I])}info(P,...I){this.f(o.Info)&&this.g.log(o.Info,[this.h(P),...I])}warn(P,...I){this.f(o.Warning)&&this.g.log(o.Warning,[this.h(P),...I])}error(P,...I){this.f(o.Error)&&this.g.log(o.Error,[this.h(P),...I])}h(P){return typeof P=="string"?P:(0,N.$gj)(P,this.f(o.Trace))}flush(){}}e.$$j=$;class a extends n{constructor(P){super(),this.g=P,P.length&&this.setLevel(P[0].getLevel())}setLevel(P){for(const I of this.g)I.setLevel(P);super.setLevel(P)}trace(P,...I){for(const W of this.g)W.trace(P,...I)}debug(P,...I){for(const W of this.g)W.debug(P,...I)}info(P,...I){for(const W of this.g)W.info(P,...I)}warn(P,...I){for(const W of this.g)W.warn(P,...I)}error(P,...I){for(const W of this.g)W.error(P,...I)}flush(){for(const P of this.g)P.flush()}dispose(){for(const P of this.g)P.dispose();super.dispose()}}e.$_j=a;class v extends M.$Vc{constructor(P,I,W){if(super(),this.h=P,this.j=I,this.b=new p.$Bc,this.c=this.B(new R.$ee),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$ee),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$ee),this.onDidChangeVisibility=this.g.event,W)for(const V of W)this.b.set(V.resource,{logger:void 0,info:V})}m(P){return(0,T.$8f)(P)?[...this.b.values()].find(I=>I.info.id===P):this.b.get(P)}getLogger(P){return this.m(P)?.logger}createLogger(P,I){const W=this.n(P),V=(0,T.$8f)(P)?P:I?.id??(0,O.$jj)(W.toString()).toString(16);let q=this.b.get(W)?.logger;const A=I?.logLevel==="always"?o.Trace:I?.logLevel;q||(q=this.s(W,A??this.getLogLevel(W)??this.h,{...I,id:V}));const j={logger:q,info:{resource:W,id:V,logLevel:A,name:I?.name,hidden:I?.hidden,extensionId:I?.extensionId,when:I?.when}};return this.registerLogger(j.info),this.b.set(W,j),q}n(P){return(0,T.$8f)(P)?(0,E.$9g)(this.j,`${P}.log`):P}setLogLevel(P,I){if(y.URI.isUri(P)){const W=P,V=I,q=this.b.get(W);q&&V!==q.info.logLevel&&(q.info.logLevel=V===this.h?void 0:V,q.logger?.setLevel(V),this.b.set(q.info.resource,q),this.f.fire([W,V]))}else{this.h=P;for(const[W,V]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(P,I){const W=this.m(P);W&&I!==!W.info.hidden&&(W.info.hidden=!I,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,I]))}getLogLevel(P){let I;return P&&(I=this.b.get(P)?.info.logLevel),I??this.h}registerLogger(P){const I=this.b.get(P.resource);I?I.info.hidden!==P.hidden&&this.setVisibility(P.resource,!P.hidden):(this.b.set(P.resource,{info:P,logger:void 0}),this.c.fire({added:[P],removed:[]}))}deregisterLogger(P){const I=this.b.get(P);I&&(I.logger&&I.logger.dispose(),this.b.delete(P),this.c.fire({added:[],removed:[I.info]}))}*getRegisteredLoggers(){for(const P of this.b.values())yield P.info}getRegisteredLogger(P){return this.b.get(P)?.info}dispose(){this.b.forEach(P=>P.logger?.dispose()),this.b.clear(),super.dispose()}}e.$ak=v;class d{constructor(){this.onDidChangeLogLevel=new R.$ee().event}setLevel(P){}getLevel(){return o.Info}trace(P,...I){}debug(P,...I){}info(P,...I){}warn(P,...I){}error(P,...I){}critical(P,...I){}dispose(){}flush(){}}e.$bk=d;class C extends d{}e.$ck=C;function u(b){if(b.verbose)return o.Trace;if(typeof b.logLevel=="string"){const P=k(b.logLevel.toLowerCase());if(P!==void 0)return P}return e.$5j}function D(b){switch(b){case o.Trace:return"trace";case o.Debug:return"debug";case o.Info:return"info";case o.Warning:return"warn";case o.Error:return"error";case o.Off:return"off"}}function f(b){switch(b){case o.Trace:return{original:"Trace",value:S.localize(0,null)};case o.Debug:return{original:"Debug",value:S.localize(1,null)};case o.Info:return{original:"Info",value:S.localize(2,null)};case o.Warning:return{original:"Warning",value:S.localize(3,null)};case o.Error:return{original:"Error",value:S.localize(4,null)};case o.Off:return{original:"Off",value:S.localize(5,null)}}}function k(b){switch(b){case"trace":return o.Trace;case"debug":return o.Debug;case"info":return o.Info;case"warn":return o.Warning;case"error":return o.Error;case"critical":return o.Error;case"off":return o.Off}}e.$hk=new l.$Mj("logLevel",D(o.Info))}),define(Ce[193],Ae([1,0,6,13]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JQ=void 0;class R extends S.$Vc{constructor(M,p=[]){super(),this.a=new N.$_j([M,...p]),this.B(M.onDidChangeLogLevel(g=>this.setLevel(g)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(M){this.a.setLevel(M)}getLevel(){return this.a.getLevel()}trace(M,...p){this.a.trace(M,...p)}debug(M,...p){this.a.debug(M,...p)}info(M,...p){this.a.info(M,...p)}warn(M,...p){this.a.warn(M,...p)}error(M,...p){this.a.error(M,...p)}flush(){this.a.flush()}}e.$JQ=R}),define(Ce[100],Ae([1,0,33,160,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3t=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var O;(function(g){g[g.Unnecessary=1]="Unnecessary",g[g.Deprecated=2]="Deprecated"})(O||(e.MarkerTag=O={}));var M;(function(g){g[g.Hint=1]="Hint",g[g.Info=2]="Info",g[g.Warning=4]="Warning",g[g.Error=8]="Error"})(M||(e.MarkerSeverity=M={})),function(g){function E(m,s){return s-m}g.compare=E;const T=Object.create(null);T[g.Error]=(0,N.localize)(0,null),T[g.Warning]=(0,N.localize)(1,null),T[g.Info]=(0,N.localize)(2,null);function y(m){return T[m]||""}g.toString=y;function l(m){switch(m){case S.default.Error:return g.Error;case S.default.Warning:return g.Warning;case S.default.Info:return g.Info;case S.default.Ignore:return g.Hint}}g.fromSeverity=l;function w(m){switch(m){case g.Error:return S.default.Error;case g.Warning:return S.default.Warning;case g.Info:return S.default.Info;case g.Hint:return S.default.Ignore}}g.toSeverity=w}(M||(e.MarkerSeverity=M={}));var p;(function(g){const E="";function T(l){return y(l,!0)}g.makeKey=T;function y(l,w){const m=[E];return l.source?m.push(l.source.replace("\xA6","\\\xA6")):m.push(E),l.code?typeof l.code=="string"?m.push(l.code.replace("\xA6","\\\xA6")):m.push(l.code.value.replace("\xA6","\\\xA6")):m.push(E),l.severity!==void 0&&l.severity!==null?m.push(M.toString(l.severity)):m.push(E),l.message&&w?m.push(l.message.replace("\xA6","\\\xA6")):m.push(E),l.startLineNumber!==void 0&&l.startLineNumber!==null?m.push(l.startLineNumber.toString()):m.push(E),l.startColumn!==void 0&&l.startColumn!==null?m.push(l.startColumn.toString()):m.push(E),l.endLineNumber!==void 0&&l.endLineNumber!==null?m.push(l.endLineNumber.toString()):m.push(E),l.endColumn!==void 0&&l.endColumn!==null?m.push(l.endColumn.toString()):m.push(E),m.push(E),m.join("\xA6")}g.makeKeyOptionalMessage=y})(p||(e.IMarkerData=p={})),e.$3t=(0,R.$vi)("markerService")}),define(Ce[194],Ae([1,0,5,33,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6v=e.$5v=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$3v=e.Severity=void 0,e.$4v=p,e.Severity=N.default,e.$3v=(0,R.$vi)("notificationService");var O;(function(y){y[y.DEFAULT=0]="DEFAULT",y[y.SILENT=1]="SILENT",y[y.URGENT=2]="URGENT"})(O||(e.NotificationPriority=O={}));var M;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.PROFILE=1]="PROFILE",y[y.APPLICATION=2]="APPLICATION"})(M||(e.NeverShowAgainScope=M={}));function p(y){if(y){const l=y;return typeof l.id=="string"&&typeof l.label=="string"}return!1}var g;(function(y){y[y.OFF=0]="OFF",y[y.ERROR=1]="ERROR"})(g||(e.NotificationsFilter=g={}));class E{constructor(){this.progress=new T,this.onDidClose=S.Event.None,this.onDidChangeVisibility=S.Event.None}updateSeverity(l){}updateMessage(l){}updateActions(l){}close(){}}e.$5v=E;class T{infinite(){}done(){}total(l){}worked(l){}}e.$6v=T}),define(Ce[195],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jk=e.$ik=void 0,e.$ik=(0,S.$vi)("productService"),e.$jk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(ge,e,S,N){var R=arguments.length,O=R<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,S):N,M;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ge,e,S,N);else for(var p=ge.length-1;p>=0;p--)(M=ge[p])&&(O=(R<3?M(O):R>3?M(e,S,O):M(e,S))||O);return R>3&&O&&Object.defineProperty(e,S,O),O},We=this&&this.__param||function(ge,e){return function(S,N){e(S,N,ge)}};define(Ce[101],Ae([1,0,11,24,6,3]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aw=e.$_v=e.$$v=e.$0v=e.$9v=e.$8v=e.ProgressLocation=e.$7v=void 0,e.$7v=(0,O.$vi)("progressService");var M;(function(y){y[y.Explorer=1]="Explorer",y[y.Scm=3]="Scm",y[y.Extensions=5]="Extensions",y[y.Window=10]="Window",y[y.Notification=15]="Notification",y[y.Dialog=20]="Dialog"})(M||(e.ProgressLocation=M={})),e.$8v=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(l){this.b=l}report(l){this.a=l,this.b(this.a)}}e.$9v=p;class g{get value(){return this.a}constructor(l){this.e=l}report(l){this.b?this.b.push(l):this.b=[l],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const l=this.b.shift();this.a=l,await this.e(this.a)}}finally{this.c=!1;const l=this.d;this.d=void 0,l?.()}}drain(){return this.c?new Promise(l=>{const w=this.d;this.d=()=>{w?.(),l()}}):Promise.resolve()}}e.$0v=g;let E=class extends R.$Vc{constructor(l,w){super(),this.a=new S.$Sh,w.withProgress(l,m=>(this.b=m,this.c&&m.report(this.c),this.a.p)),this.B((0,R.$Tc)(()=>this.a.complete()))}report(l){this.b?this.b.report(l):this.c=l}};e.$$v=E,e.$$v=E=Je([We(1,e.$7v)],E);class T extends R.$Vc{constructor(l){super(),this.g=l,this.a=0,this.b=this.B(new R.$Uc)}start(l){this.stop();const w=++this.a,m=new N.$pe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},l),this.b.add((0,R.$Tc)(()=>clearTimeout(this.f))),this.b.add((0,R.$Tc)(()=>m.cancel())),this.b.add((0,R.$Tc)(()=>this.c?this.c.done():void 0)),{id:w,token:m.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(l){this.a===l&&this.b.clear()}}e.$_v=T,e.$aw=(0,O.$vi)("editorProgressService")}),define(Ce[30],Ae([1,0,56,17]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bo=void 0;class R{constructor(){this.a=new Map}add(M,p){S.ok(N.$8f(M)),S.ok(N.$0f(p)),S.ok(!this.a.has(M),"There is already an extension with this id"),this.a.set(M,p)}knows(M){return this.a.has(M)}as(M){return this.a.get(M)||null}}e.$bo=new R}),define(Ce[72],Ae([1,0,5,30]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=void 0,e.$co={JSONContribution:"base.contributions.json"};function R(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this.b=new S.$ee,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(g,E){this.a[R(g)]=E,this.b.fire(g)}notifySchemaChanged(g){this.b.fire(g)}getSchemaContributions(){return{schemas:this.a}}}const M=new O;N.$bo.add(e.$co.JSONContribution,M)}),define(Ce[57],Ae([1,0,18,5,17,153,48,72,30]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.$ko=e.$jo=e.$io=e.$ho=e.ConfigurationScope=e.$go=e.EditPresentationTypes=void 0,e.$ro=s,e.$so=o,e.$to=r,e.$uo=n,e.$vo=c;var E;(function(h){h.Multiline="multilineText",h.Singleline="singlelineText"})(E||(e.EditPresentationTypes=E={})),e.$go={Configuration:"base.contributions.configuration"};var T;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.MACHINE=2]="MACHINE",h[h.WINDOW=3]="WINDOW",h[h.RESOURCE=4]="RESOURCE",h[h.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",h[h.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(T||(e.ConfigurationScope=T={})),e.$ho={properties:{},patternProperties:{}},e.$io={properties:{},patternProperties:{}},e.$jo={properties:{},patternProperties:{}},e.$ko={properties:{},patternProperties:{}},e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no="vscode://schemas/settings/resourceLanguage",e.$oo="vscode://schemas/settings/configurationDefaults";const y=g.$bo.as(p.$co.JSONContribution);class l{constructor(){this.h=new Set,this.i=new N.$ee,this.onDidSchemaChange=this.i.event,this.j=new N.$ee,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},y.registerSchema(e.$no,this.g),this.v()}registerConfiguration(i,$=!0){this.registerConfigurations([i],$)}registerConfigurations(i,$=!0){const a=new Set;this.n(i,$,a),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const $=new Set;this.o(i,$),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:$})}updateConfigurations({add:i,remove:$}){const a=new Set;this.o($,a),this.n(i,!1,a),y.registerSchema(e.$no,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const $=new Set;this.k(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}k(i,$){const a=[];for(const{overrides:v,source:d}of i)for(const C in v)if($.add(C),e.$qo.test(C)){const u=this.a.get(C),D=u?.valuesSources??new Map;if(d)for(const P of Object.keys(v[C]))D.set(P,d);const f={...u?.value||{},...v[C]};this.a.set(C,{source:d,value:f,valuesSources:D});const k=(0,M.$_i)(C),b={type:"object",default:f,description:O.localize(1,null,k),$ref:e.$no,defaultDefaultValue:f,source:R.$8f(d)?void 0:d,defaultValueSource:d};a.push(...s(C)),this.d[C]=b,this.b.properties[C]=b}else{this.a.set(C,{value:v[C],source:d});const u=this.d[C];u&&(this.w(C,u),this.r(C,u))}this.m(a)}deregisterDefaultConfigurations(i){const $=new Set;this.l(i,$),this.i.fire(),this.j.fire({properties:$,defaultsOverrides:!0})}l(i,$){for(const{overrides:a,source:v}of i)for(const d in a){const C=this.a.get(d),u=R.$8f(v)?v:v?.id,D=R.$8f(C?.source)?C?.source:C?.source?.id;if(u===D)if($.add(d),this.a.delete(d),e.$qo.test(d))delete this.d[d],delete this.b.properties[d];else{const f=this.d[d];f&&(this.w(d,f),this.r(d,f))}}this.u()}deltaConfiguration(i){let $=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),$=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),$=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:$})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const $ of i)this.h.add($);this.u()}n(i,$,a){i.forEach(v=>{this.p(v,$,v.extensionInfo,v.restrictedProperties,void 0,a),this.c.push(v),this.q(v)})}o(i,$){const a=v=>{if(v.properties)for(const d in v.properties){$.add(d);const C=this.d[d];C?.policy?.name&&this.e.delete(C.policy.name),delete this.d[d],this.s(d,v.properties[d])}v.allOf?.forEach(d=>a(d))};for(const v of i){a(v);const d=this.c.indexOf(v);d!==-1&&this.c.splice(d,1)}}p(i,$=!0,a,v,d=3,C){d=R.$eg(i.scope)?d:i.scope;const u=i.properties;if(u)for(const f in u){const k=u[f];if($&&n(f,k)){delete u[f];continue}if(k.source=a,k.defaultDefaultValue=u[f].default,this.w(f,k),e.$qo.test(f)?k.scope=void 0:(k.scope=R.$eg(k.scope)?d:k.scope,k.restricted=R.$eg(k.restricted)?!!v?.includes(f):k.restricted),u[f].hasOwnProperty("included")&&!u[f].included){this.f[f]=u[f],delete u[f];continue}else this.d[f]=u[f],u[f].policy?.name&&this.e.set(u[f].policy.name,f);!u[f].deprecationMessage&&u[f].markdownDeprecationMessage&&(u[f].deprecationMessage=u[f].markdownDeprecationMessage),C.add(f)}const D=i.allOf;if(D)for(const f of D)this.p(f,$,a,v,d,C)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const $=a=>{const v=a.properties;if(v)for(const C in v)this.r(C,v[C]);a.allOf?.forEach($)};$(i)}r(i,$){switch(e.$ho.properties[i]=$,$.scope){case 1:e.$io.properties[i]=$;break;case 2:e.$jo.properties[i]=$;break;case 6:e.$ko.properties[i]=$;break;case 3:e.$lo.properties[i]=$;break;case 4:e.$mo.properties[i]=$;break;case 5:e.$mo.properties[i]=$,this.g.properties[i]=$;break}}s(i,$){switch(delete e.$ho.properties[i],$.scope){case 1:delete e.$io.properties[i];break;case 2:delete e.$jo.properties[i];break;case 6:delete e.$ko.properties[i];break;case 3:delete e.$lo.properties[i];break;case 4:case 5:delete e.$mo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const $=`[${i}]`,a={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.$no};this.w($,a),e.$ho.properties[$]=a,e.$io.properties[$]=a,e.$jo.properties[$]=a,e.$ko.properties[$]=a,e.$lo.properties[$]=a,e.$mo.properties[$]=a}}v(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.$no};e.$ho.patternProperties[e.$po]=i,e.$io.patternProperties[e.$po]=i,e.$jo.patternProperties[e.$po]=i,e.$ko.patternProperties[e.$po]=i,e.$lo.patternProperties[e.$po]=i,e.$mo.patternProperties[e.$po]=i,this.i.fire()}w(i,$){const a=this.a.get(i);let v=a?.value,d=a?.source;R.$cg(v)&&(v=$.defaultDefaultValue,d=void 0),R.$cg(v)&&(v=r($.type)),$.default=v,$.defaultValueSource=d}}const w="\\[([^\\]]+)\\]",m=new RegExp(w,"g");e.$po=`^(${w})+$`,e.$qo=new RegExp(e.$po);function s(h){const i=[];if(e.$qo.test(h)){let $=m.exec(h);for(;$?.length;){const a=$[1].trim();a&&i.push(a),$=m.exec(h)}}return(0,S.$Mb)(i)}function o(h){return h.reduce((i,$)=>`${i}[${$}]`,"")}function r(h){switch(Array.isArray(h)?h[0]:h){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const t=new l;g.$bo.add(e.$go.Configuration,t);function n(h,i){return h.trim()?e.$qo.test(h)?O.localize(7,null,h):t.getConfigurationProperties()[h]!==void 0?O.localize(8,null,h):i.policy?.name&&t.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,h,i.policy?.name,t.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}function c(){const h=[],i=t.getConfigurationProperties();for(const $ of Object.keys(i))h.push([$,i[$].scope]);return h.push(["launch",4]),h.push(["task",4]),h}}),define(Ce[196],Ae([1,0,18,5,123,6,28,25,17,2,48,57,30]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bo=e.$zo=e.$yo=e.$xo=e.$wo=void 0,e.$Ao=n;function w($){return Object.isFrozen($)?$:p.$3n($)}class m{static createEmptyModel(a){return new m({},[],[],void 0,a)}constructor(a,v,d,C,u){this.b=a,this.c=v,this.d=d,this.raw=C,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(v=>{if(v instanceof m)return v;const d=new s("",this.f);return d.parseRaw(v),d.configurationModel});this.g=a.reduce((v,d)=>d===v?d:v.merge(d),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,T.$0i)(this.contents,a):this.contents}inspect(a,v){const d=this;return{get value(){return w(d.rawConfiguration.getValue(a))},get override(){return v?w(d.rawConfiguration.getOverrideValue(a,v)):void 0},get merged(){return w(v?d.rawConfiguration.override(v).getValue(a):d.rawConfiguration.getValue(a))},get overrides(){const C=[];for(const{contents:u,identifiers:D,keys:f}of d.rawConfiguration.overrides){const k=new m(u,f,[],void 0,d.f).getValue(a);k!==void 0&&C.push({identifiers:D,value:k})}return C.length?w(C):void 0}}}getOverrideValue(a,v){const d=this.j(v);return d?a?(0,T.$0i)(d,a):d:void 0}getKeysForOverrideIdentifier(a){const v=[];for(const d of this.overrides)d.identifiers.includes(a)&&v.push(...d.keys);return S.$Mb(v)}getAllOverrideIdentifiers(){const a=[];for(const v of this.overrides)a.push(...v.identifiers);return S.$Mb(a)}override(a){let v=this.a.get(a);return v||(v=this.h(a),this.a.set(a,v)),v}merge(...a){const v=p.$2n(this.contents),d=p.$2n(this.overrides),C=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const D of a)if(u.push(...D.raw?.length?D.raw:[D]),!D.isEmpty()){this.i(v,D.contents);for(const f of D.overrides){const[k]=d.filter(b=>S.$ub(b.identifiers,f.identifiers));k?(this.i(k.contents,f.contents),k.keys.push(...f.keys),k.keys=S.$Mb(k.keys)):d.push(p.$2n(f))}for(const f of D.keys)C.indexOf(f)===-1&&C.push(f)}return new m(v,C,d,u.every(D=>D instanceof m)?void 0:u,this.f)}h(a){const v=this.j(a);if(!v||typeof v!="object"||!Object.keys(v).length)return this;const d={};for(const C of S.$Mb([...Object.keys(this.contents),...Object.keys(v)])){let u=this.contents[C];const D=v[C];D&&(typeof u=="object"&&typeof D=="object"?(u=p.$2n(u),this.i(u,D)):u=D),d[C]=u}return new m(d,this.keys,this.overrides,void 0,this.f)}i(a,v){for(const d of Object.keys(v)){if(d in a&&g.$0f(a[d])&&g.$0f(v[d])){this.i(a[d],v[d]);continue}a[d]=p.$2n(v[d])}}j(a){let v=null,d=null;const C=u=>{u&&(d?this.i(d,u):d=p.$2n(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===a?v=u.contents:u.identifiers.includes(a)&&C(u.contents);return C(v),d}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,v){this.k(a,v,!0)}setValue(a,v){this.k(a,v,!1)}removeValue(a){const v=this.keys.indexOf(a);v!==-1&&(this.keys.splice(v,1),(0,T.$9i)(this.contents,a),y.$qo.test(a)&&this.overrides.splice(this.overrides.findIndex(d=>S.$ub(d.identifiers,(0,y.$ro)(a))),1))}k(a,v,d){(0,T.$8i)(this.contents,a,v,C=>this.f.error(C)),d=d||this.keys.indexOf(a)===-1,d&&this.keys.push(a),y.$qo.test(a)&&this.overrides.push({identifiers:(0,y.$ro)(a),keys:Object.keys(this.contents[a]),contents:(0,T.$7i)(this.contents[a],C=>this.f.error(C))})}}e.$wo=m;class s{constructor(a,v){this.f=a,this.g=v,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||m.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,v){if(!g.$eg(a)){const d=this.h(a);this.parseRaw(d,v)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,v){this.a=a;const{contents:d,keys:C,overrides:u,restricted:D,hasExcludedProperties:f}=this.i(a,v);this.b=new m(d,C,u,f?[a]:void 0,this.g),this.c=D||[]}h(a){let v={},d=null,C=[];const u=[],D=[];function f(b){Array.isArray(C)?C.push(b):d!==null&&(C[d]=b)}const k={onObjectBegin:()=>{const b={};f(b),u.push(C),C=b,d=null},onObjectProperty:b=>{d=b},onObjectEnd:()=>{C=u.pop()},onArrayBegin:()=>{const b=[];f(b),u.push(C),C=b,d=null},onArrayEnd:()=>{C=u.pop()},onLiteralValue:f,onError:(b,P,I)=>{D.push({error:b,offset:P,length:I})}};if(a)try{R.$Pn(a,k),v=C[0]||{}}catch(b){this.g.error(`Error while parsing settings file ${this.f}: ${b}`),this.d=[b]}return v}i(a,v){const d=l.$bo.as(y.$go.Configuration).getConfigurationProperties(),C=this.j(a,d,!0,v);a=C.raw;const u=(0,T.$7i)(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),D=Object.keys(a),f=this.l(a,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:u,keys:D,overrides:f,restricted:C.restricted,hasExcludedProperties:C.hasExcludedProperties}}j(a,v,d,C){let u=!1;if(!C?.scopes&&!C?.skipRestricted&&!C?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:u};const D={},f=[];for(const k in a)if(y.$qo.test(k)&&d){const b=this.j(a[k],v,!1,C);D[k]=b.raw,u=u||b.hasExcludedProperties,f.push(...b.restricted)}else{const b=v[k],P=b?typeof b.scope<"u"?b.scope:3:void 0;b?.restricted&&f.push(k),!C.exclude?.includes(k)&&(C.include?.includes(k)||(P===void 0||C.scopes===void 0||C.scopes.includes(P))&&!(C.skipRestricted&&b?.restricted))?D[k]=a[k]:u=!0}return{raw:D,restricted:f,hasExcludedProperties:u}}l(a,v){const d=[];for(const C of Object.keys(a))if(y.$qo.test(C)){const u={};for(const D in a[C])u[D]=a[C][D];d.push({identifiers:(0,y.$ro)(C),keys:Object.keys(u),contents:(0,T.$7i)(u,v)})}return d}}e.$xo=s;class o extends O.$Vc{constructor(a,v,d,C,u){super(),this.c=a,this.f=v,this.g=C,this.h=u,this.b=this.B(new N.$ee),this.onDidChange=this.b.event,this.a=new s(this.c.toString(),u),this.B(this.g.watch(d.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,D=>D.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,D=>(D.isOperation(0)||D.isOperation(3)||D.isOperation(1)||D.isOperation(4))&&d.isEqual(D.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return m.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$yo=o;class r{constructor(a,v,d,C,u,D,f,k,b,P,I,W,V){this.a=a,this.b=v,this.c=d,this.overrideIdentifiers=C,this.d=u,this.f=D,this.g=f,this.h=k,this.i=b,this.j=P,this.k=I,this.l=W,this.m=V}get value(){return w(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class t{constructor(a,v,d,C,u,D,f,k,b,P){this.j=a,this.l=v,this.m=d,this.n=C,this.p=u,this.q=D,this.r=f,this.s=k,this.t=b,this.u=P,this.h=null,this.i=new M.$Bc,this.v=null}getValue(a,v,d){return this.w(a,v,d).getValue(a)}updateValue(a,v,d={}){let C;d.resource?(C=this.t.get(d.resource),C||(C=m.createEmptyModel(this.u),this.t.set(d.resource,C))):C=this.s,v===void 0?C.removeValue(a):C.setValue(a,v),d.resource||(this.h=null)}inspect(a,v,d){const C=this.w(a,v,d),u=this.A(v.resource,d),D=v.resource?this.t.get(v.resource)||this.s:this.s,f=new Set;for(const k of C.overrides)for(const b of k.identifiers)C.getOverrideValue(a,b)!==void 0&&f.add(b);return new r(a,v,C.getValue(a),f.size?[...f]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,d?this.q:void 0,u||void 0,D)}keys(a){const v=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:v?v.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,v){this.r.set(a,v),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,v){const d=[];if(!v){const{added:C,updated:u,removed:D}=h(this.j,a);v=[...C,...u,...D]}for(const C of v)for(const u of(0,y.$ro)(C)){const D=this.j.getKeysForOverrideIdentifier(u),f=a.getKeysForOverrideIdentifier(u),k=[...f.filter(b=>D.indexOf(b)===-1),...D.filter(b=>f.indexOf(b)===-1),...D.filter(b=>!p.$6n(this.j.override(u).getValue(b),a.override(u).getValue(b)))];d.push([u,k])}return this.updateDefaultConfiguration(a),{keys:v,overrides:d}}compareAndUpdatePolicyConfiguration(a){const{added:v,updated:d,removed:C}=h(this.l,a),u=[...v,...d,...C];return u.length&&this.updatePolicyConfiguration(a),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:v,updated:d,removed:C,overrides:u}=h(this.applicationConfiguration,a),D=[...v,...d,...C];return D.length&&this.updateApplicationConfiguration(a),{keys:D,overrides:u}}compareAndUpdateLocalUserConfiguration(a){const{added:v,updated:d,removed:C,overrides:u}=h(this.localUserConfiguration,a),D=[...v,...d,...C];return D.length&&this.updateLocalUserConfiguration(a),{keys:D,overrides:u}}compareAndUpdateRemoteUserConfiguration(a){const{added:v,updated:d,removed:C,overrides:u}=h(this.remoteUserConfiguration,a),D=[...v,...d,...C];return D.length&&this.updateRemoteUserConfiguration(a),{keys:D,overrides:u}}compareAndUpdateWorkspaceConfiguration(a){const{added:v,updated:d,removed:C,overrides:u}=h(this.workspaceConfiguration,a),D=[...v,...d,...C];return D.length&&this.updateWorkspaceConfiguration(a),{keys:D,overrides:u}}compareAndUpdateFolderConfiguration(a,v){const d=this.folderConfigurations.get(a),{added:C,updated:u,removed:D,overrides:f}=h(d,v),k=[...C,...u,...D];return(k.length||!d)&&this.updateFolderConfiguration(a,v),{keys:k,overrides:f}}compareAndDeleteFolderConfiguration(a){const v=this.folderConfigurations.get(a);if(!v)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:d,updated:C,removed:u,overrides:D}=h(v,void 0);return{keys:[...d,...C,...u],overrides:D}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,v,d){let C=this.x(v,d);return v.overrideIdentifier&&(C=C.override(v.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&(C=C.merge(this.l)),C}x({resource:a},v){let d=this.y();if(v&&a){const C=v.getFolder(a);C&&(d=this.z(C.uri)||d);const u=this.t.get(a);u&&(d=d.merge(u))}return d}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let v=this.i.get(a);if(!v){const d=this.y(),C=this.r.get(a);C?(v=d.merge(C),this.i.set(a,v)):v=d}return v}A(a,v){if(v&&a){const d=v.getFolder(a);if(d)return this.r.get(d.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,v)=>{const{contents:d,overrides:C,keys:u}=this.r.get(v);return a.push([v,{contents:d,overrides:C,keys:u}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(v=>a.add(v)),this.userConfiguration.keys.forEach(v=>a.add(v)),this.q.keys.forEach(v=>a.add(v)),this.r.forEach(v=>v.keys.forEach(d=>a.add(d))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.userConfiguration.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.q.getAllOverrideIdentifiers().forEach(v=>a.add(v)),this.r.forEach(v=>v.getAllOverrideIdentifiers().forEach(d=>a.add(d))),[...a.values()]}D(a){const v=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.q.getKeysForOverrideIdentifier(a).forEach(d=>v.add(d)),this.r.forEach(d=>d.getKeysForOverrideIdentifier(a).forEach(C=>v.add(C))),[...v.values()]}static parse(a,v){const d=this.E(a.defaults,v),C=this.E(a.policy,v),u=this.E(a.application,v),D=this.E(a.user,v),f=this.E(a.workspace,v),k=a.folders.reduce((b,P)=>(b.set(E.URI.revive(P[0]),this.E(P[1],v)),b),new M.$Bc);return new t(d,C,u,D,m.createEmptyModel(v),f,k,m.createEmptyModel(v),new M.$Bc,v)}static E(a,v){return new m(a.contents,a.keys,a.overrides,void 0,v)}}e.$zo=t;function n(...$){if($.length===0)return{keys:[],overrides:[]};if($.length===1)return $[0];const a=new Set,v=new Map;for(const C of $)C.keys.forEach(u=>a.add(u)),C.overrides.forEach(([u,D])=>{const f=(0,M.$yc)(v,u,new Set);D.forEach(k=>f.add(k))});const d=[];return v.forEach((C,u)=>d.push([u,[...C.values()]])),{keys:[...a.values()],overrides:d}}class c{constructor(a,v,d,C,u){this.change=a,this.f=v,this.g=d,this.h=C,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const D of a.keys)this.affectedKeys.add(D);for(const[,D]of a.overrides)for(const f of D)this.affectedKeys.add(f);this.d=this.a;for(const D of this.affectedKeys)this.d+=D+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=t.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,v){const d=this.a+a,C=this.d.indexOf(d);if(C<0)return!1;const u=C+d.length;if(u>=this.d.length)return!1;const D=this.d.charCodeAt(u);if(D!==this.b&&D!==this.c)return!1;if(v){const f=this.previousConfiguration?this.previousConfiguration.getValue(a,v,this.f?.workspace):void 0,k=this.g.getValue(a,v,this.h);return!p.$6n(f,k)}return!0}}e.$Bo=c;function h($,a){const{added:v,removed:d,updated:C}=i(a?.rawConfiguration,$?.rawConfiguration),u=[],D=$?.getAllOverrideIdentifiers()||[],f=a?.getAllOverrideIdentifiers()||[];if(a){const k=f.filter(b=>!D.includes(b));for(const b of k)u.push([b,a.getKeysForOverrideIdentifier(b)])}if($){const k=D.filter(b=>!f.includes(b));for(const b of k)u.push([b,$.getKeysForOverrideIdentifier(b)])}if(a&&$){for(const k of D)if(f.includes(k)){const b=i({contents:$.getOverrideValue(void 0,k)||{},keys:$.getKeysForOverrideIdentifier(k)},{contents:a.getOverrideValue(void 0,k)||{},keys:a.getKeysForOverrideIdentifier(k)});u.push([k,[...b.added,...b.removed,...b.updated]])}}return{added:v,removed:d,updated:C,overrides:u}}function i($,a){const v=$?a?$.keys.filter(u=>a.keys.indexOf(u)===-1):[...$.keys]:[],d=a?$?a.keys.filter(u=>$.keys.indexOf(u)===-1):[...a.keys]:[],C=[];if($&&a){for(const u of a.keys)if($.keys.indexOf(u)!==-1){const D=(0,T.$0i)(a.contents,u),f=(0,T.$0i)($.contents,u);p.$6n(D,f)||C.push(u)}}return{added:v,removed:d,updated:C}}}),define(Ce[102],Ae([1,0,14,3]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jl=e.RemoteAuthorityResolverErrorCode=e.$Il=e.$Hl=e.RemoteConnectionType=e.$Gl=void 0,e.$Kl=E,e.$Gl=(0,N.$vi)("remoteAuthorityResolverService");var R;(function(T){T[T.WebSocket=0]="WebSocket",T[T.Managed=1]="Managed"})(R||(e.RemoteConnectionType=R={}));class O{constructor(y){this.id=y,this.type=1}toString(){return`Managed(${this.id})`}}e.$Hl=O;class M{constructor(y,l){this.host=y,this.port=l,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Il=M;var p;(function(T){T.Unknown="Unknown",T.NotAvailable="NotAvailable",T.TemporarilyNotAvailable="TemporarilyNotAvailable",T.NoResolverFound="NoResolverFound",T.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class g extends S.$bb{static isNotAvailable(y){return y instanceof g&&y._code===p.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof g&&y._code===p.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof g&&y._code===p.NoResolverFound}static isInvalidAuthority(y){return y instanceof g&&y._code===p.InvalidAuthority}static isHandled(y){return y instanceof g&&y.isHandled}constructor(y,l=p.Unknown,w){super(y),this._message=y,this._code=l,this._detail=w,this.isHandled=l===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,g.prototype)}}e.$Jl=g;function E(T){const y=T.indexOf("+");return y===-1?T:T.substring(0,y)}}),define(Ce[58],Ae([1,0,12]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gm=N,e.$Hm=R,e.$Im=O,e.$Jm=M;function N(g){return g.scheme===S.Schemas.vscodeRemote?g.authority:void 0}function R(g){if(!g)return;const E=g.indexOf("+");return E<0?g:g.substr(0,E)}function O(g){const{host:E,port:T}=p(g);if(typeof T>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:E,port:T}}function M(g,E){let{host:T,port:y}=p(g);return typeof y>"u"&&(y=E),{host:T,port:y}}function p(g){const E=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const T=g.match(/^(\[[0-9a-z:]+\])$/);if(T)return{host:T[1],port:void 0};const y=g.match(/(.*):(\d+)$/);return y?{host:y[1],port:parseInt(y[2],10)}:{host:g,port:void 0}}}),define(Ce[20],Ae([1,0,15,3,58]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xm=e.$Sm=e.$Rm=e.$Qm=e.TargetPlatform=e.ExtensionType=e.$Pm=e.$Nm=e.$Mm=e.$Lm=e.$Km=void 0,e.$Om=O,e.$Tm=y,e.$Um=l,e.$Vm=w,e.$Wm=m,e.$Km="extensions.user.cache",e.$Lm="extensions.builtin.cache",e.$Mm="undefined_publisher",e.$Nm=["ui","workspace","web"];function O(s){if(typeof s=="object"&&s!==null&&s.supported!==!0)return s.description}e.$Pm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var M;(function(s){s[s.System=0]="System",s[s.User=1]="User"})(M||(e.ExtensionType=M={}));var p;(function(s){s.WIN32_X64="win32-x64",s.WIN32_ARM64="win32-arm64",s.LINUX_X64="linux-x64",s.LINUX_ARM64="linux-arm64",s.LINUX_ARMHF="linux-armhf",s.ALPINE_X64="alpine-x64",s.ALPINE_ARM64="alpine-arm64",s.DARWIN_X64="darwin-x64",s.DARWIN_ARM64="darwin-arm64",s.WEB="web",s.UNIVERSAL="universal",s.UNKNOWN="unknown",s.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class g{constructor(o){this.value=o,this._lower=o.toLowerCase()}static equals(o,r){if(typeof o>"u"||o===null)return typeof r>"u"||r===null;if(typeof r>"u"||r===null)return!1;if(typeof o=="string"||typeof r=="string"){const t=typeof o=="string"?o:o.value,n=typeof r=="string"?r:r.value;return S.$xf(t,n)}return o._lower===r._lower}static toKey(o){return typeof o=="string"?o.toLowerCase():o._lower}}e.$Qm=g;class E{get size(){return this.c.size}constructor(o){if(this.c=new Set,o)for(const r of o)this.add(r)}add(o){this.c.add(g.toKey(o))}delete(o){return this.c.delete(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}}e.$Rm=E;class T{constructor(){this.c=new Map}clear(){this.c.clear()}delete(o){this.c.delete(g.toKey(o))}get(o){return this.c.get(g.toKey(o))}has(o){return this.c.has(g.toKey(o))}set(o,r){this.c.set(g.toKey(o),r)}values(){return this.c.values()}forEach(o){this.c.forEach(o)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Sm=T;function y(s){return l(s)}function l(s){return s.contributes&&s.contributes.localizations?s.contributes.localizations.length>0:!1}function w(s){return s.contributes&&s.contributes.authentication?s.contributes.authentication.length>0:!1}function m(s,o){if(o){const r=`onResolveRemoteAuthority:${(0,R.$Hm)(o)}`;return!!s.activationEvents?.includes(r)}return!1}e.$Xm=(0,N.$vi)("IBuiltinExtensionsScannerService")}),define(Ce[103],Ae([1,0,14,20]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lG=e.$kG=void 0;class R{constructor(){this.a=new Map,this.b=new WeakMap}register(M,p){this.a.set(M,p)}readActivationEvents(M){return this.b.has(M)||this.b.set(M,this.c(M)),this.b.get(M)}createActivationEventsMap(M){const p=Object.create(null);for(const g of M){const E=this.readActivationEvents(g);E.length>0&&(p[N.$Qm.toKey(g.identifier)]=E)}return p}c(M){if(typeof M.main>"u"&&typeof M.browser>"u")return[];const p=Array.isArray(M.activationEvents)?M.activationEvents.slice(0):[];for(let g=0;g<p.length;g++)p[g]==="onUri"&&(p[g]=`onUri:${N.$Qm.toKey(M.identifier)}`);if(!M.contributes)return p;for(const g in M.contributes){const E=this.a.get(g);if(!E)continue;const T=M.contributes[g],y=Array.isArray(T)?T:[T];try{E(y,p)}catch(l){(0,S.$1)(l)}}return p}}e.$kG=R,e.$lG=new R}),define(Ce[197],Ae([1,0,21,73,35]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cp=M,e.$dp=p;function O(g){if(S.$u===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}function M(g,E,T,y,l,w,m,s,o){const r=Object.create(null);r["common.machineId"]=w,r["common.sqmId"]=m,r.sessionID=(0,R.$Rg)()+Date.now(),r.commitHash=y,r.version=l,r["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,S.$h)(S.$u),r["common.nodePlatform"]=N.$ec,r["common.nodeArch"]=T,r["common.product"]=o||"desktop",s&&(r["common.msftInternal"]=s);let t=0;const n=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>t++,enumerable:!0}}),S.$l&&(r["common.snap"]="true");const c=O(E);return c&&(r["common.platformDetail"]=c),r}function p(g){const E=N.env.USERDNSDOMAIN;if(!E)return!1;const T=E.toLowerCase();return g.some(y=>T===y)}}),define(Ce[198],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=e.$3l=e.$2l=e.$1l=void 0,e.$1l=(0,S.$vi)("telemetryService"),e.$2l=(0,S.$vi)("customEndpointTelemetryService"),e.$3l="telemetry.currentSessionDate",e.$4l="telemetry.firstSessionDate",e.$5l="telemetry.lastSessionDate",e.$6l="telemetry.machineId",e.$7l="telemetry.sqmId",e.$8l="telemetry",e.$9l="telemetry.telemetryLevel",e.$0l="telemetry.enableCrashReporter",e.$$l="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var R;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(Ce[59],Ae([1,0,25,17,58,197,198]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kp=e.$jp=e.$ip=e.$hp=e.$gp=e.$fp=e.$ep=void 0,e.$lp=T,e.$mp=y,e.$np=l,e.$op=w,e.$pp=s,e.$qp=r,e.$rp=t,e.$sp=h;class p{constructor($){this.value=$,this.isTrustedTelemetryValue=!0}}e.$ep=p;class g{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$fp=g,e.$gp=new g;class E{async publicLog($,a,v){}async publicLogError($,a,v){}}e.$hp=E,e.$ip="telemetry",e.$jp="extensionTelemetryLog",e.$kp={log:()=>null,flush:()=>Promise.resolve(null)};function T(i,$){return!$.isBuilt&&!$.disableTelemetry?!0:!($.disableTelemetry||!i.enableTelemetry)}function y(i,$){return $.extensionTestsLocationURI?!0:!($.isBuilt||$.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function l(i){const $=i.getValue(M.$9l),a=i.getValue(M.$0l);if(i.getValue(M.$$l)===!1||a===!1)return 0;switch($??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(i){const $={},a={},v={};o(i,v);for(let d in v){d=d.length>150?d.substr(d.length-149):d;const C=v[d];typeof C=="number"?a[d]=C:typeof C=="boolean"?a[d]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${d} has been trimmed to 8192, the original length is ${C.length}`),$[d]=C.substring(0,8191)):typeof C<"u"&&C!==null&&($[d]=C)}return{properties:$,measurements:a}}const m=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function s(i){if(!i)return"none";const $=(0,R.$Hm)(i);return m.has($)?$:"other"}function o(i,$,a=0,v){if(i)for(const d of Object.getOwnPropertyNames(i)){const C=i[d],u=v?v+d:d;Array.isArray(C)?$[u]=(0,S.$7n)(C):C instanceof Date?$[u]=C.toISOString():(0,N.$0f)(C)?a<2?o(C,$,a+1,u+"."):$[u]=(0,S.$7n)(C):$[u]=C}}function r(i,$){const a=i.msftInternalDomains||[],v=$.getValue("telemetry.internalTesting");return(0,O.$dp)(a)||v}function t(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function n(i,$){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const v=[];for(const D of $)for(;;){const f=D.exec(i);if(!f)break;v.push([f.index,D.lastIndex])}const d=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(a="";;){const D=C.exec(i);if(!D)break;const f=v.some(([k,b])=>D.index<b&&k<C.lastIndex);!d.test(D[0])&&!f&&(a+=i.substring(u,D.index)+"<REDACTED: user-file-path>",u=C.lastIndex)}return u<i.length&&(a+=i.substr(u)),a}function c(i){if(!i)return i;const $=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of $)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function h(i,$){return(0,S.$4n)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let v=a.replaceAll("%20"," ");v=n(v,$);for(const d of $)v=v.replace(d,"");return v=c(v),v}})}}),define(Ce[199],Ae([1,0,15,98,20,21,2,14,73,59]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cp=e.$up=void 0,e.$tp=T,e.$vp=m,e.$wp=s,e.$xp=o,e.$yp=r,e.$zp=t,e.$Ap=n,e.$Bp=c,e.$Dp=h,e.$Ep=$;function T(a,v){return a.uuid&&v.uuid?a.uuid===v.uuid:a.id===v.id?!0:(0,S.$sf)(a.id,v.id)===0}const y=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class l{static create(v){const d=v.manifest?v.manifest.version:v.version,C=v.manifest?v.targetPlatform:v.properties.targetPlatform;return new l(v.identifier,d,C)}static parse(v){const d=y.exec(v);return d&&d[1]&&d[2]?new l({id:d[1]},d[2],d[4]||void 0):null}constructor(v,d,C="undefined"){this.version=d,this.targetPlatform=C,this.id=v.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(v){return v instanceof l?T(this,v)&&this.version===v.version&&this.targetPlatform===v.targetPlatform:!1}}e.$up=l;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(a){const v=w.exec(a);return v&&v[1]?[o(v[1]),v[2]]:[o(a),void 0]}function s(a,v){return`${a}.${v}`}function o(a){return a.toLowerCase()}function r(a,v){return o(s(a??R.$Mm,v))}function t(a,v){const d=[],C=u=>{for(const D of d)if(D.some(f=>T(v(f),v(u))))return D;return null};for(const u of a){const D=C(u);D?D.push(u):d.push([u])}return d}function n(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new E.$ep(a.identifier.id),name:new E.$ep(a.name),galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Cp=new R.$Qm("pprice.better-merge");function h(a,v){const d=[],C=v.manifest.extensionDependencies?.slice(0)??[];for(;C.length;){const u=C.shift();if(u&&d.every(D=>!T(D.identifier,{id:u}))){const D=a.filter(f=>T(f.identifier,{id:u}));D.length===1&&(d.push(D[0]),C.push(...D[0].manifest.extensionDependencies?.slice(0)??[]))}}return d}async function i(a,v){if(!O.$k)return!1;let d;try{d=(await a.readFile(M.URI.file("/etc/os-release"))).value.toString()}catch{try{d=(await a.readFile(M.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){v.debug("Error while getting the os-release file.",(0,p.$0)(u))}}return!!d&&(d.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function $(a,v){const d=await i(a,v),C=(0,N.$1o)(d?"alpine":O.$u,g.$fc);return v.debug("ComputeTargetPlatform:",C),C}}),define(Ce[200],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ks=S,e.$ls=N,e.$ms=R,e.$ns=O,e.$os=M,e.$ps=p;function S(g){return[...g.entries()]}function N(g){return g?[...g.entries()]:[]}function R(g){return new Map(g)}function O(g){return new Map(g??[])}function M(g){return Array.from(g.entries()).map(E=>[E[0],S(E[1].map),N(E[1].descriptionMap)])}function p(g){return new Map(g.map(E=>[E[0],{map:R(E[1]),descriptionMap:O(E[2])}]))}}),define(Ce[201],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ntb=void 0;class S{constructor(R){this.b=R,this.a=new Map}dispose(){for(const R of this.a.values())R.dispose()}startBuffering(R,O,M=5){const p=O(g=>{const E=typeof g=="string"?g:g.data;let T=this.a.get(R);if(T){T.data.push(E);return}const y=setTimeout(()=>this.flushBuffer(R),M);T={data:[E],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(R),p.dispose()}},this.a.set(R,T)});return p}stopBuffering(R){this.a.get(R)?.dispose()}flushBuffer(R){const O=this.a.get(R);O&&(this.a.delete(R),this.b(R,O.data.join("")))}}e.$ntb=S}),define(Ce[202],Ae([1,0,11,91,301,42,5,17,2,161,72,30]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fx=e.$ex=e.$dx=e.$cx=e.$bx=e.$ax=e.IconFontDefinition=e.IconContribution=e.$0w=void 0,e.$$w=o,e.$_w=r,e.$0w={IconContribution:"base.contributions.icons"};var l;(function(h){function i($,a){let v=$.defaults;for(;O.ThemeIcon.isThemeIcon(v);){const d=s.getIcon(v.id);if(!d)return;v=d.defaults}return v}h.getDefinition=i})(l||(e.IconContribution=l={}));var w;(function(h){function i(a){return{weight:a.weight,style:a.style,src:a.src.map(v=>({format:v.format,location:v.location.toString()}))}}h.toJSONObject=i;function $(a){const v=d=>(0,p.$8f)(d)?d:void 0;if(a&&Array.isArray(a.src)&&a.src.every(d=>(0,p.$8f)(d.format)&&(0,p.$8f)(d.location)))return{weight:v(a.weight),style:v(a.style),src:a.src.map(d=>({format:d.format,location:g.URI.parse(d.location)}))}}h.fromJSONObject=$})(w||(e.IconFontDefinition=w={}));class m{constructor(){this.a=new M.$ee,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,E.localize)(0,null)},fontCharacter:{type:"string",description:(0,E.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${O.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,$,a,v){const d=this.b[i];if(d){if(a&&!d.description){d.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const D=this.e.enum.indexOf(i);D!==-1&&(this.e.enumDescriptions[D]=a),this.a.fire()}return d}const C={id:i,description:a,defaults:$,deprecationMessage:v};this.b[i]=C;const u={$ref:"#/definitions/icons"};return v&&(u.deprecationMessage=v),a&&(u.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=u,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const $=this.e.enum.indexOf(i);$!==-1&&(this.e.enum.splice($,1),this.e.enumDescriptions.splice($,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,$){const a=this.f[i];return a||(this.f[i]=$,this.a.fire(),$)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(d,C)=>d.id.localeCompare(C.id),$=d=>{for(;O.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const v=Object.keys(this.b).map(d=>this.b[d]);for(const d of v.filter(C=>!!C.description).sort(i))a.push(`|<i class="${$(d)}"></i>|${d.id}|${O.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const d of v.filter(C=>!O.ThemeIcon.isThemeIcon(C.defaults)).sort(i))a.push(`|<i class="${$(d)}"></i>|${d.id}|`);return a.join(`
`)}}const s=new m;y.$bo.add(e.$0w.IconContribution,s);function o(h,i,$,a){return s.registerIcon(h,i,$,a)}function r(){return s}function t(){const h=(0,R.$Qj)();for(const i in h){const $="\\"+h[i].toString(16);s.registerIcon(i,{fontCharacter:$})}}t(),e.$ax="vscode://schemas/icons";const n=y.$bo.as(T.$co.JSONContribution);n.registerSchema(e.$ax,s.getIconSchema());const c=new S.$Hh(()=>n.notifySchemaChanged(e.$ax),200);s.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$bx=o("widget-close",N.$Uj.close,(0,E.localize)(2,null)),e.$cx=o("goto-previous-location",N.$Uj.arrowUp,(0,E.localize)(3,null)),e.$dx=o("goto-next-location",N.$Uj.arrowDown,(0,E.localize)(4,null)),e.$ex=O.ThemeIcon.modify(N.$Uj.sync,"spin"),e.$fx=O.ThemeIcon.modify(N.$Uj.loading,"spin")}),define(Ce[203],Ae([1,0,5,2,48,3,13]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$iw=e.$gw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$cw=e.$bw=void 0,e.$dw=E,e.$ew=y,e.$fw=l,e.$hw=w,e.$jw=m,e.$kw=s,e.$bw=(0,O.$vi)("tunnelService"),e.$cw=(0,O.$vi)("sharedTunnelsService");var p;(function(t){t.Http="http",t.Https="https"})(p||(e.TunnelProtocol=p={}));var g;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(g||(e.TunnelPrivacyId=g={}));function E(t){return!!t.forwardPort}var T;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(T||(e.ProvidedOnAutoForward=T={}));function y(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const n=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(n)return{address:n[1],port:+n[2]}}function l(t){if(t.scheme!=="http"&&t.scheme!=="https"||!t.query)return;const n=t.query.split("&");for(const c of n){const h=c.split("=")[1];if(/^https?:/.exec(h)){const i=y(N.URI.parse(h));if(i)return i}}}e.$gw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(t){return e.$gw.indexOf(t)>=0}e.$iw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(t){return e.$iw.indexOf(t)>=0}function s(t,n,c,h){if(c===1)return!1;if(c===2&&m(n)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(i?.length===4&&parseInt(i[1])>=18)return!1}return t<1024}class o{constructor(n,c,h){this.remoteAddress=n,this.localAddress=c,this.b=h,this.a=new S.$ee,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$lw=o;let r=class{constructor(n,c){this.k=n,this.l=c,this.a=new S.$ee,this.onTunnelOpened=this.a.event,this.b=new S.$ee,this.onTunnelClosed=this.b.event,this.c=new S.$ee,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const n=this.l.getValue("remote.localPortHost");return!n||n==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(n){return this.f=n,n?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(n){this.g=n.elevation,this.i=n.privacyOptions,this.h=n.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const n=[],c=Array.from(this.e.values());for(const h of c){const i=Array.from(h.values());for(const $ of i){const a=await $.value;a&&typeof a!="string"&&n.push(a)}}return n}async dispose(){for(const n of this.e.values()){for(const{value:c}of n.values())await c.then(h=>typeof h!="string"?h?.dispose():void 0);n.clear()}this.e.clear()}setEnvironmentTunnel(n,c,h,i,$){this.q(n,c,Promise.resolve({tunnelRemoteHost:n,tunnelRemotePort:c,localAddress:h,privacy:i,protocol:$,dispose:()=>Promise.resolve()}))}async getExistingTunnel(n,c){(m(n)||w(n))&&(n=e.$gw[0]);const h=this.s(n,c);if(h)return++h.refcount,h.value}openTunnel(n,c,h,i,$,a=!1,v,d){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${h} on local port ${$}.`);const C=this.f??n;if(!C)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(C,c,h,i,$,a,v,d);return u?u.then(D=>{if(D){if(typeof D=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,h),D}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const f=this.o(D);return(D.tunnelRemoteHost!==c||D.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),v&&D.privacy!==v&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(f),f}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(n){return{tunnelRemotePort:n.tunnelRemotePort,tunnelRemoteHost:n.tunnelRemoteHost,tunnelLocalPort:n.tunnelLocalPort,localAddress:n.localAddress,privacy:n.privacy,protocol:n.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${n.tunnelRemoteHost}:${n.tunnelRemotePort} `);const c=this.e.get(n.tunnelRemoteHost);if(c){const h=c.get(n.tunnelRemotePort);h&&(h.refcount--,await this.p(n.tunnelRemoteHost,n.tunnelRemotePort,h))}}}}async p(n,c,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${n}:${c}.`);const i=h.value.then(async $=>{$&&typeof $!="string"&&(await $.dispose(!0),this.b.fire({host:$.tunnelRemoteHost,port:$.tunnelRemotePort}))});return this.e.has(n)&&this.e.get(n).delete(c),i}}async closeTunnel(n,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${n}:${c} `);const h=this.e.get(n);if(h&&h.has(c)){const i=h.get(c);i.refcount=0,await this.p(n,c,i)}}q(n,c,h){this.e.has(n)||this.e.set(n,new Map),this.e.get(n).set(c,{refcount:1,value:h})}async r(n,c){const h=this.e.get(n);if(h){const i=h.get(c),$=i?await i.value:void 0;(!$||typeof $=="string")&&h.delete(c),h.size===0&&this.e.delete(n)}}s(n,c){const h=[n];w(n)?(h.push(...e.$gw),h.push(...e.$iw)):m(n)&&h.push(...e.$iw);const i=h.map($=>this.e.get($));for(const $ of i){const a=$?.get(c);if(a)return a}}canTunnel(n){return!!y(n)}u(n,c,h,i,$,a,v){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${h} on local port ${i}.`);const d=h;this.j.add(d);const C=i===void 0?h:i,u={elevationRequired:$?this.isPortPrivileged(C):!1},D={remoteAddress:{host:c,port:h},localAddressPort:i,privacy:a,public:a?a!==g.Private:void 0,protocol:v},f=n.forwardPort(D,u);return f?(this.q(c,h,f),f.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(d)})):this.j.delete(d),f}};e.$mw=r,e.$mw=r=Je([We(0,M.$2j),We(1,R.$2i)],r)}),define(Ce[204],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$nw=void 0,e.$nw=(0,S.$vi)("editSessionIdentityService");var N;(function(R){R[R.Complete=100]="Complete",R[R.Partial=50]="Partial",R[R.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Ce[205],Ae([1,0,12]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vM=N,e.$wM=R,e.$xM=O,e.$yM=M,e.$zM=p;function N(g){return g.scheme!==S.Schemas.file&&g.scheme!==S.Schemas.vscodeRemote}function R(g){if(g.folders.length)return g.folders.every(E=>N(E.uri))?g.folders[0].uri:void 0;if(g.configuration&&N(g.configuration))return g.configuration}function O(g){return R(g)?.scheme}function M(g){return R(g)?.authority}function p(g){return R(g)!==void 0}}),define(Ce[49],Ae([1,0,162,19,52,23,2,3,12]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xi=e.$Ui=e.$Ti=e.$Si=e.$Ri=e.$Pi=e.$Oi=e.WorkbenchState=e.$Ii=e.$Hi=e.$Ei=void 0,e.$Fi=E,e.$Gi=T,e.$Ji=y,e.$Ki=l,e.$Li=w,e.$Mi=s,e.$Ni=o,e.$Qi=n,e.$Vi=c,e.$Wi=h,e.$Yi=i,e.$Zi=$,e.$1i=a,e.$Ei=(0,p.$vi)("contextService");function E(v){const d=v;return typeof d?.id=="string"&&M.URI.isUri(d.uri)}function T(v){return typeof v?.id=="string"&&!E(v)&&!l(v)}e.$Hi={id:"ext-dev"},e.$Ii={id:"empty-window"};function y(v,d){if(typeof v=="string"||typeof v>"u")return typeof v=="string"?{id:(0,N.$oc)(v)}:d?e.$Hi:e.$Ii;const C=v;return C.configuration?{id:C.id,configPath:C.configuration}:C.folders.length===1?{id:C.id,uri:C.folders[0].uri}:{id:C.id}}function l(v){const d=v;return typeof d?.id=="string"&&M.URI.isUri(d.configPath)}function w(v){const d=v;if(d?.uri)return{id:d.id,uri:M.URI.revive(d.uri)};const C=v;if(C?.configPath)return{id:C.id,configPath:M.URI.revive(C.configPath)};if(v?.id)return{id:v.id}}var m;(function(v){v[v.EMPTY=1]="EMPTY",v[v.FOLDER=2]="FOLDER",v[v.WORKSPACE=3]="WORKSPACE"})(m||(e.WorkbenchState=m={}));function s(v){const d=v;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}function o(v){const d=v;return!!(d&&typeof d=="object"&&M.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}class r{constructor(d,C,u,D,f){this.h=d,this.j=u,this.k=D,this.l=f,this.c=R.$Bi.forUris(this.l,()=>!0),this.folders=C}update(d){this.h=d.id,this.k=d.configuration,this.j=d.transient,this.l=d.l,this.folders=d.folders}get folders(){return this.g}set folders(d){this.g=d,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(d){this.k=d}getFolder(d){return d&&this.c.findSubstr(d)||null}n(){this.c=R.$Bi.forUris(this.l,()=>!0);for(const d of this.folders)this.c.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Oi=r;class t{constructor(d,C){this.raw=C,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,O.$9g)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Pi=t;function n(v){return new t({uri:v,index:0,name:(0,O.$5g)(v)},{uri:v.toString()})}e.$Ri="code-workspace",e.$Si=`.${e.$Ri}`,e.$Ti=[{name:(0,S.localize)(0,null),extensions:[e.$Ri]}],e.$Ui="workspace.json";function c(v,d){return O.$Zg.isEqualOrParent(v,d.untitledWorkspacesHome)}function h(v){let d;return M.URI.isUri(v)?d=v:d=v.configuration,d?.scheme===g.Schemas.tmp}e.$Xi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(v){return v.id===e.$Xi}function $(v,d){return!c(v,d)&&!h(v)}function a(v){return(typeof v=="string"?(0,N.$pc)(v):(0,O.$7g)(v))===e.$Si}}),define(Ce[74],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rkc=void 0;class S{static{this.a=!1}constructor(R){this.d=R,this.b=new Map,this.c=1}add(R){const O=this.c++;return this.b.set(O,R),this.e(),O}get(R,O){return this.b.has(R)?this.b.get(R)[O]:void 0}delete(R){this.b.delete(R),this.e()}e(){S.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Rkc=S}),define(Ce[45],Ae([1,0,12,23,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xkc=e.$Wkc=void 0;class O{constructor(){this.a=new Set(Object.keys(S.Schemas)),this.b=new Map,this.extUri=new N.$Xg(p=>{const g=this.b.get(p.scheme);return!(g===void 0||g&1024)})}$acceptProviderInfos(p,g){g===null?this.b.delete(p.scheme):this.b.set(p.scheme,g)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$Wkc=O,e.$Xkc=(0,R.$vi)("IExtHostFileSystemInfo")}),define(Ce[27],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BP=void 0,e.$BP=(0,S.$vi)("IExtHostInitDataService")}),define(Ce[206],Ae([1,0,167,13,193,27]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4mc=void 0;let M=class extends R.$JQ{constructor(g,E,T){const y=T.remote.isRemote?"remoteexthost":g?"workerexthost":"exthost",l=T.remote.isRemote?(0,S.localize)(0,null):g?(0,S.localize)(1,null):(0,S.localize)(2,null);super(E.createLogger(y,{name:l}))}};e.$4mc=M,e.$4mc=M=Je([We(1,N.$3j),We(2,O.$BP)],M)}),define(Ce[207],Ae([1,0,11]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dlc=e.$Clc=void 0;class N{constructor(M,p,g){this.h=new Map,this.a=M,this.b=p,this.c=g,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(E=>(this.f=E,this)),this.g=this.c.onDidChangeStorage(E=>{E.shared===this.b&&E.key===this.a&&(this.f=E.value)}),this.i=new S.$Hh(()=>{const E=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const T of E.values())T.complete()}catch(T){for(const y of E.values())y.error(T)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,M])=>M!==void 0).map(([M])=>M)}get whenReady(){return this.d}get(M,p){let g=this.f[M];return typeof g>"u"&&(g=p),g}update(M,p){this.f[M]=p;const g=this.h.get(M);if(g!==void 0)return g.p;const E=new S.$Sh;return this.h.set(M,E),this.i.isScheduled()||this.i.schedule(),E.p}dispose(){this.g.dispose()}}e.$Clc=N;class R extends N{setKeysForSync(M){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},M)}constructor(M,p){super(M.identifier.value,!0,p),this.j=M}}e.$Dlc=R}),define(Ce[208],Ae([1,0,5,2]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=void 0;class R{constructor(M){this.c=M,this.a=new S.$ee,this.onDidSaveNotebookDocument=this.a.event,this.b=new S.$ee,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(M,p,g,E){const y=this.c.getNotebookDocument(N.URI.revive(M)).acceptModelChanged(p.value,g,E);this.b.fire(y)}$acceptDirtyStateChanged(M,p){this.c.getNotebookDocument(N.URI.revive(M)).acceptDirty(p)}$acceptModelSaved(M){const p=this.c.getNotebookDocument(N.URI.revive(M));this.a.fire(p.apiNotebook)}}e.$rmc=R}),define(Ce[16],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mP=e.$lP=void 0,e.$lP=(0,S.$vi)("IExtHostRpcService");class N{constructor(O){this.getProxy=O.getProxy.bind(O),this.set=O.set.bind(O),this.dispose=O.dispose.bind(O),this.assertRegistered=O.assertRegistered.bind(O),this.drain=O.drain.bind(O)}}e.$mP=N}),define(Ce[209],Ae([1,0,20,5]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mlc=void 0;class R{#e;constructor(M,p){this.b=new N.$ee,this.onDidChange=this.b.event,this.a=S.$Qm.toKey(M.identifier),this.#e=p,this.#e.onDidChangePassword(g=>{g.extensionId===this.a&&this.b.fire({key:g.key})})}get(M){return this.#e.get(this.a,M)}store(M,p){return this.#e.store(this.a,M,p)}delete(M){return this.#e.delete(this.a,M)}}e.$Mlc=R}),define(Ce[60],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$blc=e.$alc=void 0,e.$alc=(0,S.$vi)("IURITransformerService");class N{constructor(O){O?(this.transformIncoming=O.transformIncoming.bind(O),this.transformOutgoing=O.transformOutgoing.bind(O),this.transformOutgoingURI=O.transformOutgoingURI.bind(O),this.transformOutgoingScheme=O.transformOutgoingScheme.bind(O)):(this.transformIncoming=M=>M,this.transformOutgoing=M=>M,this.transformOutgoingURI=M=>M,this.transformOutgoingScheme=M=>M)}}e.$blc=N}),define(Ce[210],Ae([1,0,22]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fob=R,e.$Gob=M;class N{constructor(){this.buffers=[]}add(g){let E=this.buffers.indexOf(g);return E<0&&(E=this.buffers.length,this.buffers.push(g)),E}}function R(p,g){if(g.serializeBuffersForPostMessage){const E=new N,y=JSON.stringify(p,(w,m)=>{if(m instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m)};if(ArrayBuffer.isView(m)){const s=O(m);if(s)return{$$vscode_array_buffer_reference$$:!0,index:E.add(m.buffer),view:{type:s,byteLength:m.byteLength,byteOffset:m.byteOffset}}}return m}),l=E.buffers.map(w=>{const m=new Uint8Array(w);return S.$Fe.wrap(m)});return{message:y,buffers:l}}else return{message:JSON.stringify(p),buffers:[]}}function O(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function M(p,g){const E=g.map(l=>{const w=new ArrayBuffer(l.byteLength);return new Uint8Array(w).set(l.buffer),w}),T=g.length?(l,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const m=w,{index:s}=m,o=E[s];if(m.view)switch(m.view.type){case 1:return new Int8Array(o,m.view.byteOffset,m.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(o,m.view.byteOffset,m.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(o,m.view.byteOffset,m.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(o,m.view.byteOffset,m.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(o,m.view.byteOffset,m.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(o,m.view.byteOffset,m.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(o,m.view.byteOffset,m.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(o,m.view.byteOffset,m.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(o,m.view.byteOffset,m.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(o,m.view.byteOffset,m.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(o,m.view.byteOffset,m.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return o}return w}:void 0;return{message:JSON.parse(p,T),arrayBuffers:E}}}),define(Ce[104],Ae([1,0,176,17,2,6,3,30,44,12,43,139,33]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$JF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$AF=e.EditorInputCapabilities=e.$zF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$pF=e.$oF=e.$nF=e.$mF=e.$lF=void 0,e.$qF=s,e.$rF=o,e.$sF=r,e.$tF=t,e.$uF=n,e.$vF=c,e.$wF=h,e.$xF=i,e.$yF=$,e.$BF=D,e.$CF=k,e.$DF=b,e.$EF=P,e.$FF=I,e.$GF=W,e.$HF=V,e.$IF=ae,e.$KF=de,e.$LF=Me,e.$MF=ce,e.$NF=Re,e.$lF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$mF={id:"default",displayName:(0,S.localize)(0,null),providerDisplayName:(0,S.localize)(1,null)},e.$nF="workbench.editor.sidebysideEditor",e.$oF="workbench.editors.textDiffEditor",e.$pF="workbench.editors.binaryResourceDiffEditor";var w;(function(ie){ie[ie.PROGRAMMATIC=1]="PROGRAMMATIC",ie[ie.USER=2]="USER",ie[ie.EDIT=3]="EDIT",ie[ie.NAVIGATION=4]="NAVIGATION",ie[ie.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var m;(function(ie){ie[ie.IDENTICAL=1]="IDENTICAL",ie[ie.SIMILAR=2]="SIMILAR",ie[ie.DIFFERENT=3]="DIFFERENT"})(m||(e.EditorPaneSelectionCompareResult=m={}));function s(ie){const L=ie;return!!L&&typeof L.getSelection=="function"&&!!L.onDidChangeSelection}function o(ie){const L=ie;return!!L&&typeof L.getScrollPosition=="function"&&typeof L.setScrollPosition=="function"&&!!L.onDidChangeScroll}function r(ie,L,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===L&&ie.matches(ve.input))return ve.getViewState()}function t(ie){if(D(ie))return!1;const L=ie;return R.URI.isUri(L?.resource)}function n(ie){if(D(ie))return!1;const L=ie;return L?.original!==void 0&&L.modified!==void 0}function c(ie){if(D(ie))return!1;const L=ie;return!L||L.resources&&!Array.isArray(L.resources)?!1:!!L.resources||!!L.multiDiffSource}function h(ie){if(D(ie)||n(ie))return!1;const L=ie;return L?.primary!==void 0&&L.secondary!==void 0}function i(ie){if(D(ie))return!1;const L=ie;return L?L.resource===void 0||L.resource.scheme===E.Schemas.untitled||L.forceUntitled===!0:!1}function $(ie){if(D(ie))return!1;const L=ie;return R.URI.isUri(L?.base?.resource)&&R.URI.isUri(L?.input1?.resource)&&R.URI.isUri(L?.input2?.resource)&&R.URI.isUri(L?.result?.resource)}var a;(function(ie){ie[ie.SHORT=0]="SHORT",ie[ie.MEDIUM=1]="MEDIUM",ie[ie.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var v;(function(ie){ie[ie.EXPLICIT=1]="EXPLICIT",ie[ie.AUTO=2]="AUTO",ie[ie.FOCUS_CHANGE=3]="FOCUS_CHANGE",ie[ie.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v||(e.SaveReason=v={}));class d{constructor(){this.a=new Map}registerSource(L,x){let ve=this.a.get(L);return ve||(ve={source:L,label:x},this.a.set(L,ve)),ve.source}getSourceLabel(L){return this.a.get(L)?.label??L}}e.$zF=new d;var C;(function(ie){ie[ie.None=0]="None",ie[ie.Readonly=2]="Readonly",ie[ie.Untitled=4]="Untitled",ie[ie.Singleton=8]="Singleton",ie[ie.RequiresTrust=16]="RequiresTrust",ie[ie.CanSplitInGroup=32]="CanSplitInGroup",ie[ie.ForceDescription=64]="ForceDescription",ie[ie.CanDropIntoEditor=128]="CanDropIntoEditor",ie[ie.MultipleEditors=256]="MultipleEditors",ie[ie.Scratchpad=512]="Scratchpad"})(C||(e.EditorInputCapabilities=C={}));class u extends O.$Vc{}e.$AF=u;function D(ie){return ie instanceof u}function f(ie){const L=ie;return R.URI.isUri(L?.preferredResource)}function k(ie){const L=ie;return D(L?.primary)&&D(L?.secondary)}function b(ie){const L=ie;return D(L?.modified)&&D(L?.original)}function P(ie,L,x,ve,Fe){return Re(ve,[(0,y.$fj)({id:"workbench.action.openLargeFile",label:(0,S.localize)(2,null),run:()=>{const Ee={...x,limits:{size:Number.MAX_VALUE}};ie.openEditor(L,Ee)}}),(0,y.$fj)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,S.localize)(3,null),run:()=>Fe.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:l.default.Warning})}function I(ie){return D(ie?.editor)}function W(ie){const L=ie;return I(ie)&&L?.group!==void 0}function V(ie){const L=ie;return typeof L?.groupId=="number"&&D(L.editor)}var q;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.REPLACE=1]="REPLACE",ie[ie.MOVE=2]="MOVE",ie[ie.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var A;(function(ie){ie[ie.GROUP_ACTIVE=0]="GROUP_ACTIVE",ie[ie.GROUP_INDEX=1]="GROUP_INDEX",ie[ie.GROUP_LABEL=2]="GROUP_LABEL",ie[ie.GROUP_LOCKED=3]="GROUP_LOCKED",ie[ie.EDITOR_OPEN=4]="EDITOR_OPEN",ie[ie.EDITOR_CLOSE=5]="EDITOR_CLOSE",ie[ie.EDITOR_MOVE=6]="EDITOR_MOVE",ie[ie.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ie[ie.EDITOR_LABEL=8]="EDITOR_LABEL",ie[ie.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ie[ie.EDITOR_PIN=10]="EDITOR_PIN",ie[ie.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ie[ie.EDITOR_STICKY=12]="EDITOR_STICKY",ie[ie.EDITOR_DIRTY=13]="EDITOR_DIRTY",ie[ie.EDITOR_WILL_DISPOSE=14]="EDITOR_WILL_DISPOSE"})(A||(e.GroupModelChangeKind=A={}));var j;(function(ie){ie[ie.PRIMARY=1]="PRIMARY",ie[ie.SECONDARY=2]="SECONDARY",ie[ie.BOTH=3]="BOTH",ie[ie.ANY=4]="ANY"})(j||(e.SideBySideEditor=j={}));class K{getOriginalUri(L,x){if(!L)return;if($(L))return e.$JF.getOriginalUri(L.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:Ee}=this.a(L);if(Fe&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getOriginalUri(Fe,{filterByScheme:x.filterByScheme})??this.getOriginalUri(Ee,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Fe:Ee}}if(n(L)||c(L)||h(L)||$(L))return;const ve=f(L)?L.preferredResource:L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(L){return k(L)||h(L)?{primary:L.primary,secondary:L.secondary}:b(L)||n(L)?{primary:L.modified,secondary:L.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(L,x){if(!L)return;if($(L))return e.$JF.getCanonicalUri(L.result,x);if(x?.supportSideBySide){const{primary:Fe,secondary:Ee}=this.a(L);if(Fe&&Ee){if(x?.supportSideBySide===j.BOTH)return{primary:this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===j.ANY)return this.getCanonicalUri(Fe,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(Ee,{filterByScheme:x.filterByScheme});L=x.supportSideBySide===j.PRIMARY?Fe:Ee}}if(n(L)||c(L)||h(L)||$(L))return;const ve=L.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(L,x){if(Array.isArray(x)){if(x.some(ve=>L.scheme===ve))return L}else if(x===L.scheme)return L}}var re;(function(ie){ie[ie.UNKNOWN=0]="UNKNOWN",ie[ie.KEYBOARD=1]="KEYBOARD",ie[ie.MOUSE=2]="MOUSE"})(re||(e.EditorCloseMethod=re={}));function ae(ie,L,x,ve){if(!ie.isSticky(L))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===re.MOUSE||x===re.KEYBOARD;case"mouse":return x===re.MOUSE;case"keyboard":return x===re.KEYBOARD}return!1}e.$JF=new K;var we;(function(ie){ie[ie.LEFT=0]="LEFT",ie[ie.RIGHT=1]="RIGHT"})(we||(e.CloseDirection=we={}));class Ie{constructor(){this.c=new Map,this.d=new Map}start(L){const x=this.a=L.get(M.$ui);for(const[ve,Fe]of this.c)this.e(ve,Fe,x);this.c.clear()}e(L,x,ve){const Fe=ve.createInstance(x);this.d.set(L,Fe)}registerFileEditorFactory(L){if(this.b)throw new Error("Can only register one file editor factory.");this.b=L}getFileEditorFactory(){return(0,N.$gg)(this.b)}registerEditorSerializer(L,x){if(this.c.has(L)||this.d.has(L))throw new Error(`A editor serializer with type ID '${L}' was already registered.`);return this.a?this.e(L,x,this.a):this.c.set(L,x),(0,O.$Tc)(()=>{this.c.delete(L),this.d.delete(L)})}getEditorSerializer(L){return this.d.get(typeof L=="string"?L:L.typeId)}}p.$bo.add(e.$lF.EditorFactory,new Ie);async function de(ie,L,x){return!ie||!ie.length?[]:await Promise.all(ie.map(async ve=>{const Fe=R.URI.revive(ve.fileUri);if(!Fe){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await L.canHandleResource(Fe)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let pe=ve.exists,fe=ve.type;if(typeof pe!="boolean"||typeof fe!="number")try{fe=(await L.stat(Fe)).isDirectory?g.FileType.Directory:g.FileType.Unknown,pe=!0}catch(X){x.error(X),pe=!1}if(!pe&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(fe===g.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Y={...ve.options,pinned:!0};return pe?{resource:Fe,options:Y}:{resource:Fe,options:Y,forceUntitled:!0}}))}var me;(function(ie){ie[ie.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ie[ie.SEQUENTIAL=1]="SEQUENTIAL"})(me||(e.EditorsOrder=me={}));function Me(ie){const L=ie;if(!L)return!1;const x=L;if(x.modified)return Me(x.modified);const ve=L;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function ce(ie){return(0,T.$hj)(ie)}function Re(ie,L,x){const ve=(0,T.$ij)(ie,L);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Ce[211],Ae([1,0,5,177,3,6,28,30,18,25,91,202]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VF=e.$UF=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$TF=e.ViewContentGroups=e.$RF=e.ViewContainerLocation=e.Extensions=e.$QF=e.$PF=e.$OF=void 0,e.$SF=m,e.$OF="views",e.$PF=(0,N.localize)(0,null),e.$QF=(0,y.$$w)("default-view-icon",T.$Uj.window,(0,N.localize)(1,null));var l;(function($){$.ViewContainersRegistry="workbench.registry.view.containers",$.ViewsRegistry="workbench.registry.view"})(l||(e.Extensions=l={}));var w;(function($){$[$.Sidebar=0]="Sidebar",$[$.Panel=1]="Panel",$[$.AuxiliaryBar=2]="AuxiliaryBar"})(w||(e.ViewContainerLocation=w={})),e.$RF=[0,1,2];function m($){switch($){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class s extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new S.$ee),this.onDidRegister=this.c.event,this.f=this.B(new S.$ee),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,g.$Rb)([...this.g.values()])}registerViewContainer(a,v,d){const C=this.get(a.id);if(C)return C;const u=a;return u.openCommandActionDescriptor=d?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,M.$yc)(this.g,v,[]).push(u),d?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:v}),u}deregisterViewContainer(a){for(const v of this.g.keys()){const d=this.g.get(v),C=d?.indexOf(a);if(C!==-1){d?.splice(C,1),d.length===0&&this.g.delete(v),this.f.fire({viewContainer:a,viewContainerLocation:v});return}}}get(a){return this.all.filter(v=>v.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(v=>this.getViewContainers(v).filter(d=>d?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(v=>this.getViewContainerLocation(v)===a)}}p.$bo.add(l.ViewContainersRegistry,new s);var o;(function($){$.Open="2_open",$.Debug="4_debug",$.SCM="5_scm",$.More="9_more"})(o||(e.ViewContentGroups=o={}));function r($,a){const v=$.group??o.More,d=a.group??o.More;return v!==d?v.localeCompare(d):($.order??5)-(a.order??5)}class t extends O.$Vc{constructor(){super(...arguments),this.c=this.B(new S.$ee),this.onViewsRegistered=this.c.event,this.f=this.B(new S.$ee),this.onViewsDeregistered=this.f.event,this.g=this.B(new S.$ee),this.onDidChangeContainer=this.g.event,this.h=this.B(new S.$ee),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new M.$Ic}registerViews(a,v){this.registerViews2([{views:a,viewContainer:v}])}registerViews2(a){a.forEach(({views:v,viewContainer:d})=>this.r(v,d)),this.c.fire(a)}deregisterViews(a,v){const d=this.s(a,v);d.length&&this.f.fire({views:d,viewContainer:v})}moveViews(a,v){for(const d of this.m.keys())if(d!==v){const C=this.s(a,d);C.length&&(this.r(C,v),this.g.fire({views:C,from:d,to:v}))}}getViews(a){return this.m.get(a)||[]}getView(a){for(const v of this.j){const d=(this.m.get(v)||[]).filter(C=>C.id===a)[0];if(d)return d}return null}getViewContainer(a){for(const v of this.j)if((this.m.get(v)||[]).filter(C=>C.id===a)[0])return v;return null}registerViewWelcomeContent(a,v){return this.n.add(a,v),this.h.fire(a),(0,O.$Tc)(()=>{this.n.delete(a,v),this.h.fire(a)})}registerViewWelcomeContent2(a,v){const d=new Map;for(const[C,u]of v)this.n.add(a,u),d.set(C,(0,O.$Tc)(()=>{this.n.delete(a,u),this.h.fire(a)}));return this.h.fire(a),d}getViewWelcomeContent(a){const v=[];return this.n.forEach(a,d=>v.push(d)),v.sort(r)}r(a,v){let d=this.m.get(v);d||(d=[],this.m.set(v,d),this.j.push(v));for(const C of a){if(this.getView(C.id)!==null)throw new Error((0,N.localize)(2,null,C.id));d.push(C)}}s(a,v){const d=this.m.get(v);if(!d)return[];const C=[],u=[];for(const D of d)a.includes(D)?C.push(D):u.push(D);return C.length&&(u.length?this.m.set(v,u):(this.m.delete(v),this.j.splice(this.j.indexOf(v),1))),C}}p.$bo.add(l.ViewsRegistry,new t),e.$TF=(0,R.$vi)("viewDescriptorService");var n;(function($){$[$.Default=0]="Default",$[$.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var c;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(c||(e.TreeItemCollapsibleState=c={}));class h{constructor(a,v){this.c=!1,this.d=!1,(0,E.$5n)(this,a),this.d=!!v,this.resolve=async d=>{if(v&&!this.c){const C=await v(d);C&&(this.tooltip=this.tooltip??C.tooltip,this.command=this.command??C.command)}d.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$UF=h;class i extends Error{constructor(a){super((0,N.localize)(3,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.$VF=i}),define(Ce[212],Ae([1,0,178,31]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=e.$9F=e.$8F=e.$7F=e.$6F=e.$5F=e.$4F=e.$3F=e.$2F=e.$1F=e.$ZF=void 0,e.$ZF=new N.$Mj("chatSessionResponseVote","",{type:"string",description:(0,S.localize)(0,null)}),e.$1F=new N.$Mj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,S.localize)(1,null)}),e.$2F=new N.$Mj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,S.localize)(2,null)}),e.$3F=new N.$Mj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,S.localize)(3,null)}),e.$4F=new N.$Mj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,S.localize)(4,null)}),e.$5F=new N.$Mj("chatResponse",!1,{type:"boolean",description:(0,S.localize)(5,null)}),e.$6F=new N.$Mj("chatRequest",!1,{type:"boolean",description:(0,S.localize)(6,null)}),e.$7F=new N.$Mj("chatInputHasText",!1,{type:"boolean",description:(0,S.localize)(7,null)}),e.$8F=new N.$Mj("chatInputHasFocus",!1,{type:"boolean",description:(0,S.localize)(8,null)}),e.$9F=new N.$Mj("inChatInput",!1,{type:"boolean",description:(0,S.localize)(9,null)}),e.$0F=new N.$Mj("inChat",!1,{type:"boolean",description:(0,S.localize)(10,null)}),e.$$F=new N.$Mj("chatIsEnabled",!1,{type:"boolean",description:(0,S.localize)(11,null)}),e.$_F=new N.$Mj("chatCursorAtTop",!1),e.$aG=new N.$Mj("chatInputHasAgent",!1),e.$bG=new N.$Mj("chatLocation",void 0)}),define(Ce[213],Ae([1,0,5,40,6,31,3,212]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bH=e.$aH=e.$_G=e.ChatAgentLocation=void 0;var g;(function(y){y.Panel="panel",y.Terminal="terminal",y.Notebook="notebook",y.Editor="editor"})(g||(e.ChatAgentLocation=g={})),function(y){function l(w){switch(w){case"panel":return y.Panel;case"terminal":return y.Terminal;case"notebook":return y.Notebook;case"editor":return y.Editor}return y.Panel}y.fromRaw=l}(g||(e.ChatAgentLocation=g={})),e.$_G=(0,M.$vi)("chatAgentService");let E=class{static{this.AGENT_LEADER="@"}constructor(l){this.f=l,this.b=[],this.d=new S.$ee,this.onDidChangeAgents=this.d.event,this.e=p.$$F.bindTo(this.f)}registerAgent(l,w){if(this.getAgent(l))throw new Error(`Agent already registered: ${JSON.stringify(l)}`);const s=this,o=w.slashCommands;w={...w,get slashCommands(){return o.filter(t=>!t.when||s.f.contextMatchesRules(O.$tj.deserialize(t.when)))}};const r={data:w};return this.b.push(r),(0,R.$Tc)(()=>{this.b=this.b.filter(t=>t!==r),this.d.fire(void 0)})}registerAgentImplementation(l,w){const m=this.g(l);if(!m)throw new Error(`Unknown agent: ${JSON.stringify(l)}`);if(m.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(l)}`);return m.data.isDefault&&this.e.set(!0),m.impl=w,this.d.fire(new T(m.data,w)),(0,R.$Tc)(()=>{m.impl=void 0,this.d.fire(void 0),m.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(l,w){const m={data:l,impl:w};return this.b.push(m),this.d.fire(new T(l,w)),(0,R.$Tc)(()=>{this.b=this.b.filter(s=>s!==m),this.d.fire(void 0)})}updateAgent(l,w){const m=this.g(l);if(!m?.impl)throw new Error(`No activated agent with id ${JSON.stringify(l)} registered`);m.data.metadata={...m.data.metadata,...w},this.d.fire(new T(m.data,m.impl))}getDefaultAgent(l){return this.getActivatedAgents().find(w=>!!w.isDefault&&w.locations.includes(l))}getContributedDefaultAgent(l){return this.getAgents().find(w=>!!w.isDefault&&w.locations.includes(l))}getSecondaryAgent(){return N.Iterable.find(this.b.values(),l=>!!l.data.metadata.isSecondary)?.data}g(l){return this.b.find(w=>w.data.id===l)}getAgent(l){return this.g(l)?.data}getAgents(){return this.b.map(l=>l.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(l=>!!l.impl).map(l=>new T(l.data,l.impl))}getAgentsByName(l){return this.getAgents().filter(w=>w.name===l)}async invokeAgent(l,w,m,s,o){const r=this.g(l);if(!r?.impl)throw new Error(`No activated agent with id ${l}`);return await r.impl.invoke(w,m,s,o)}async getFollowups(l,w,m,s,o){const r=this.g(l);if(!r?.impl)throw new Error(`No activated agent with id ${l}`);return r.impl?.provideFollowups?r.impl.provideFollowups(w,m,s,o):[]}};e.$aH=E,e.$aH=E=Je([We(0,O.$Nj)],E);class T{constructor(l,w){this.b=l,this.d=w}get id(){return this.b.id}get name(){return this.b.name??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisher(){return this.b.extensionPublisher}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(l,w,m,s){return this.d.invoke(l,w,m,s)}async provideFollowups(l,w,m,s){return this.d.provideFollowups?this.d.provideFollowups(l,w,m,s):[]}provideWelcomeMessage(l,w){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(l,w)}provideSampleQuestions(l,w){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(l,w)}}e.$bH=T}),define(Ce[214],Ae([1,0,2,29,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.ChatCopyKind=e.InteractiveSessionVoteDirection=void 0,e.$gG=O,e.$hG=M;function O(E){return!!E&&typeof E=="object"&&"uri"in E&&E.uri instanceof S.URI&&"version"in E&&typeof E.version=="number"&&"ranges"in E&&Array.isArray(E.ranges)&&E.ranges.every(N.$tt.isIRange)}function M(E){return!!E&&typeof E=="object"&&"documents"in E&&Array.isArray(E.documents)&&E.documents.every(O)}var p;(function(E){E[E.Down=0]="Down",E[E.Up=1]="Up"})(p||(e.InteractiveSessionVoteDirection=p={}));var g;(function(E){E[E.Action=1]="Action",E[E.Toolbar=2]="Toolbar"})(g||(e.ChatCopyKind=g={})),e.$iG=(0,R.$vi)("IChatService"),e.$jG="accessibility.voice.keywordActivation"}),define(Ce[215],Ae([1,0,5,11,179]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apb=void 0;class O{constructor(){this.f=new Map,this.m=[],this.n=new S.$ee,this.o=new S.$ee,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,g,E,T){const y={command:p};if(g&&Object.keys(g).length>0&&(y.arguments=g),this.u("request",y),typeof T=="number"){const l=setTimeout(()=>{clearTimeout(l);const w=this.f.get(y.seq);if(w){this.f.delete(y.seq);const m={type:"response",seq:0,request_seq:y.seq,success:!1,command:p,message:(0,R.localize)(0,null,T,p)};w(m)}},T)}return E&&this.f.set(y.seq,E),y.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,g){return p.type!=="event"||g.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$wh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const g=p,E=this.f.get(g.request_seq);E&&(this.f.delete(g.request_seq),E(g));break}}}}u(p,g){g.type=p,g.seq=this.d++,this.sendMessage(g)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((g,E)=>p.set(E,g)),await(0,N.$wh)(500),p.forEach((g,E)=>{g({type:"response",seq:0,request_seq:E,success:!1,command:"canceled",message:"canceled"}),this.f.delete(E)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$apb=O}),define(Ce[216],Ae([1,0,2,180,31,3]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$rJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$pJ=e.MemoryRangeType=e.State=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=e.$uI=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.$oI=e.$nI=e.$mI=e.$lI=e.$kI=e.$jI=e.$iI=e.$hI=e.$gI=e.$fI=e.$eI=e.$dI=e.$cI=void 0,e.$oJ=g,e.$qJ=T,e.$cI="workbench.view.debug",e.$dI="workbench.debug.variablesView",e.$eI="workbench.debug.watchExpressionsView",e.$fI="workbench.debug.callStackView",e.$gI="workbench.debug.loadedScriptsView",e.$hI="workbench.debug.breakPointsView",e.$iI="workbench.debug.disassemblyView",e.$jI="workbench.panel.repl",e.$kI="workbench.panel.repl.view",e.$lI=new R.$Mj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$mI=new R.$Mj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$nI=new R.$Mj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$oI="debugUx",e.$pI=new R.$Mj(e.$oI,"default",{type:"string",description:N.localize(3,null)}),e.$qI=new R.$Mj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$rI=new R.$Mj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$sI=new R.$Mj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$tI=new R.$Mj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$uI=new R.$Mj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$vI=new R.$Mj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$wI=new R.$Mj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$xI=new R.$Mj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$yI=new R.$Mj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$zI=new R.$Mj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$AI=new R.$Mj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$BI=new R.$Mj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$CI=new R.$Mj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$DI=new R.$Mj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$EI=new R.$Mj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$FI=new R.$Mj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$GI=new R.$Mj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$HI=new R.$Mj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$II=new R.$Mj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$JI=new R.$Mj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$KI=new R.$Mj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$LI=new R.$Mj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$MI=new R.$Mj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$NI=new R.$Mj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$OI=new R.$Mj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$PI=new R.$Mj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$QI=new R.$Mj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$RI=new R.$Mj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$SI=new R.$Mj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$TI=new R.$Mj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$UI=new R.$Mj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$VI=new R.$Mj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$WI=new R.$Mj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$XI=new R.$Mj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$YI=new R.$Mj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$ZI=new R.$Mj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$1I=new R.$Mj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$2I=new R.$Mj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$3I=new R.$Mj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$4I=new R.$Mj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$5I=new R.$Mj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$6I=new R.$Mj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$7I=new R.$Mj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$8I=new R.$Mj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$9I=new R.$Mj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$0I=new R.$Mj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$$I=new R.$Mj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$_I=new R.$Mj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$aJ=new R.$Mj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$bJ=new R.$Mj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$cJ=new R.$Mj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$dJ=new R.$Mj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$eJ=new R.$Mj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$fJ=new R.$Mj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$gJ=new R.$Mj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$hJ=new R.$Mj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$iJ=new R.$Mj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const M=n=>N.localize(61,null,n);e.$jJ=M,e.$kJ="editor.contrib.debug",e.$lJ="editor.contrib.breakpoint",e.$mJ="debug",e.$nJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(n){n[n.Inactive=0]="Inactive",n[n.Initializing=1]="Initializing",n[n.Stopped=2]="Stopped",n[n.Running=3]="Running"})(p||(e.State=p={}));function g(n){switch(n){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var E;(function(n){n[n.Valid=0]="Valid",n[n.Unreadable=1]="Unreadable",n[n.Error=2]="Error"})(E||(e.MemoryRangeType=E={})),e.$pJ="vscode-debug-memory";function T(n){return n.source.presentationHint==="deemphasize"||n.presentationHint==="deemphasize"||n.presentationHint==="subtle"}var y;(function(n){n[n.Variable=0]="Variable",n[n.Address=1]="Address"})(y||(e.DataBreakpointSetType=y={}));var l;(function(n){n[n.Initial=1]="Initial",n[n.Dynamic=2]="Dynamic"})(l||(e.DebugConfigurationProviderTriggerKind=l={}));var w;(function(n){n.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$rJ=(0,O.$vi)("debugService");var m;(function(n){n[n.CONDITION=0]="CONDITION",n[n.HIT_COUNT=1]="HIT_COUNT",n[n.LOG_MESSAGE=2]="LOG_MESSAGE",n[n.TRIGGER_POINT=3]="TRIGGER_POINT"})(m||(e.BreakpointWidgetContext=m={}));var s;(function(n){n[n.Command=0]="Command",n[n.Tree=1]="Tree"})(s||(e.DebugVisualizationType=s={}));var o;(function(n){n[n.None=0]="None",n[n.Collapsed=1]="Collapsed",n[n.Expanded=2]="Expanded"})(o||(e.DebugTreeItemCollapsibleState=o={}));var r;(function(n){n.deserialize=c=>c,n.serialize=c=>c})(r||(e.IDebugVisualizationTreeItem=r={}));var t;(function(n){n.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:S.URI.revive(c.iconPath.light),dark:S.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),n.serialize=c=>c})(t||(e.IDebugVisualization=t={}))}),define(Ce[217],Ae([1,0,15,2,19,25,12,29,24,18]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qH=void 0,e.$eH=y,e.$fH=l,e.$gH=w,e.$hH=m,e.$iH=s,e.$jH=o,e.$kH=r,e.$lH=n,e.$mH=i,e.$nH=$,e.$oH=v,e.$pH=C;const T=/{([^}]+)}/g;function y(D,f,k){return D.replace(T,function(b,P){return f&&P.length>0&&P[0]!=="_"?b:k&&k.hasOwnProperty(P)?k[P]:b})}function l(D){const f={};for(const k of Object.keys(D))k.startsWith("!")||(f[k]=D[k]);return f}function w(D){return D.configuration.request==="attach"&&!m(D)&&(!D.parentSession||w(D.parentSession))}function m(D){let f=D.configuration.type;if(f)return f==="vslsShare"&&(f=D.configuration.adapterProxy.configuration.type),(0,S.$xf)(f,"extensionhost")||(0,S.$xf)(f,"pwa-extensionhost")?D:D.parentSession?m(D.parentSession):void 0}function s(D){return D.type&&(D.label||D.program||D.runtime)}function o(D,f,k){let b,P=0;const I=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let W=null;for(;W=I.exec(D);){const V=W.index+1,q=V+W[0].length;if(V<=f&&q>=k){b=W[0],P=V;break}}if(b){const V=/\w+/g;let q=null;for(;(q=V.exec(b))&&!(q.index+1+P+q[0].length>=k););q&&(b=b.substring(0,V.lastIndex))}return b?{start:P,end:P+b.length-1}:{start:0,end:0}}async function r(D,f,k,b){if(D.evaluatableExpressionProvider.has(f)){const P=D.evaluatableExpressionProvider.ordered(f),I=(0,E.$Hb)(await Promise.all(P.map(async W=>{try{return await W.provideEvaluatableExpression(f,k,b??g.CancellationToken.None)}catch{return}})));if(I.length>0){let W=I[0].expression;const V=I[0].range;return W||(W=f.getLineContent(k.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:W}}}else{const P=f.getLineContent(k.lineNumber),{start:I,end:W}=o(P,k.column,k.column),V=P.substring(I-1,W);return{matchingExpression:V,range:new p.$tt(k.lineNumber,I,k.lineNumber,I+V.length)}}return null}const t=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function n(D){return!!(D&&D.match(t))}function c(D){if(typeof D.path=="string"&&!(typeof D.sourceReference=="number"&&D.sourceReference>0)){if(n(D.path))return N.URI.parse(D.path);if((0,R.$jc)(D.path))return N.URI.file(D.path)}return D.path}function h(D){if(typeof D.path=="object"){const f=N.URI.revive(D.path);if(f)return f.scheme===M.Schemas.file?f.fsPath:f.toString()}return D.path}function i(D,f){const k=f?c:h,b=(0,O.$2n)(D);return a(b,(P,I)=>{P&&I&&(I.path=k(I))}),b}function $(D,f){const k=f?c:h,b=(0,O.$2n)(D);return a(b,(P,I)=>{!P&&I&&(I.path=k(I))}),b}function a(D,f){switch(D.type){case"event":{const k=D;switch(k.event){case"output":f(!1,k.body.source);break;case"loadedSource":f(!1,k.body.source);break;case"breakpoint":f(!1,k.body.breakpoint.source);break;default:break}break}case"request":{const k=D;switch(k.command){case"setBreakpoints":f(!0,k.arguments.source);break;case"breakpointLocations":f(!0,k.arguments.source);break;case"source":f(!0,k.arguments.source);break;case"gotoTargets":f(!0,k.arguments.source);break;case"launchVSCode":k.arguments.args.forEach(b=>f(!1,b));break;default:break}break}case"response":{const k=D;if(k.success&&k.body)switch(k.command){case"stackTrace":k.body.stackFrames.forEach(b=>f(!1,b.source));break;case"loadedSources":k.body.sources.forEach(b=>f(!1,b));break;case"scopes":k.body.scopes.forEach(b=>f(!1,b.source));break;case"setFunctionBreakpoints":k.body.breakpoints.forEach(b=>f(!1,b.source));break;case"setBreakpoints":k.body.breakpoints.forEach(b=>f(!1,b.source));break;case"disassemble":k.body?.instructions.forEach(P=>f(!1,P.location));break;default:break}break}}}function v(D){return D.filter(f=>!f.presentation?.hidden).sort((f,k)=>f.presentation?k.presentation?f.presentation.group?k.presentation.group?f.presentation.group!==k.presentation.group?f.presentation.group.localeCompare(k.presentation.group):d(f.presentation.order,k.presentation.order):-1:k.presentation.group?1:d(f.presentation.order,k.presentation.order):-1:k.presentation?1:0)}function d(D,f){return typeof D!="number"?typeof f!="number"?0:1:typeof f!="number"?-1:D-f}async function C(D,f){const k=D.getValue("debug.saveBeforeStart",{overrideIdentifier:f.activeTextEditorLanguageId});if(k!=="none"&&(await f.saveAll(),k==="allEditorsInActiveGroup")){const b=f.activeEditorPane;b&&b.input.resource?.scheme===M.Schemas.untitled&&await f.save({editor:b.input,groupId:b.group.id})}await D.reloadConfiguration()}const u=(D,f)=>!D||!f?D===f:D.name===f.name&&D.path===f.path&&D.sourceReference===f.sourceReference;e.$qH=u}),define(Ce[218],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EK=e.CellExecutionUpdateType=void 0;var N;(function(R){R[R.Output=1]="Output",R[R.OutputItems=2]="OutputItems",R[R.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$EK=(0,S.$vi)("INotebookExecutionService")}),define(Ce[219],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ib=e.$4ib=e.ProxyKernelState=e.$3ib=void 0,e.$3ib=100;var N;(function(R){R[R.Disconnected=1]="Disconnected",R[R.Connected=2]="Connected",R[R.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$4ib=(0,S.$vi)("INotebookKernelService"),e.$5ib=(0,S.$vi)("INotebookKernelHistoryService")}),define(Ce[220],Ae([1,0,6,29,149,95]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1Wb=void 0;class M extends S.$Vc{constructor(g,E,T){super(),this._source=g,this.b=E,this.c=T,this.a=void 0}f(g){const E=g.getLineCount();return new N.$tt(1,1,E,this.g(g,E))}g(g,E){if(E<1||E>g.getLineCount())throw new Error("Illegal value for lineNumber");return g.getLineLength(E)+1}get inputTextBuffer(){if(!this.b){const g=new R.$UC;g.acceptChunk(this._source);const E=g.finish(!0),{textBuffer:T,disposable:y}=E.create(1);this.b=T,this.B(y)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(g=>{const E=new R.$UC;E.acceptChunk(g);const T=E.finish(!0),{textBuffer:y,disposable:l}=T.create(1);return this.B(l),y})),this.a}findInInputs(g){const T=new O.$IC(g,!1,!1,null).parseSearchRequest();if(!T)return[];const y=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(y,T,!0,5e3)}findInOutputs(g){const T=new O.$IC(g,!1,!1,null).parseSearchRequest();return T?this.outputTextBuffers.map(y=>{const l=y.findMatchesLineByLine(this.f(y),T,!0,5e3);if(l.length!==0)return{textBuffer:y,matches:l}}).filter(y=>!!y):[]}}e.$1Wb=M}),define(Ce[50],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$KL=e.TestPosition=e.TestIdPathParts=void 0;var S;(function(O){O.Delimiter="\0"})(S||(e.TestIdPathParts=S={}));var N;(function(O){O[O.IsSame=0]="IsSame",O[O.Disconnected=1]="Disconnected",O[O.IsChild=2]="IsChild",O[O.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class R{static fromExtHostTestItem(M,p,g=M.parent){if(M._isRoot)return new R([p]);const E=[M.id];for(let T=g;T&&T.id!==p;T=T.parent)E.push(T.id);return E.push(p),new R(E.reverse())}static isRoot(M){return!M.includes("\0")}static root(M){const p=M.indexOf("\0");return p===-1?M:M.slice(0,p)}static fromString(M){return new R(M.split("\0"))}static join(M,p){return new R([...M.path,p])}static joinToString(M,p){return M.toString()+"\0"+p}static parentId(M){const p=M.lastIndexOf("\0");return p===-1?void 0:M.slice(0,p)}static localId(M){const p=M.lastIndexOf("\0");return p===-1?M:M.slice(p+1)}static isChild(M,p){return p.startsWith(M)&&p[M.length]==="\0"}static compare(M,p){return M===p?0:R.isChild(M,p)?2:R.isChild(p,M)?3:1}constructor(M,p=M.length){if(this.path=M,this.d=p,M.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new R(this.path,1)}get parentId(){return this.d>1?new R(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let M=1;M<=this.d;M++)yield new R(this.path,M)}*idsToRoot(){for(let M=this.d;M>0;M--)yield new R(this.path,M)}compare(M){if(typeof M=="string")return R.compare(this.toString(),M);for(let p=0;p<M.d&&p<this.d;p++)if(M.path[p]!==this.path[p])return 1;return M.d>this.d?2:M.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let M=1;M<this.d;M++)this.c+="\0",this.c+=this.path[M]}return this.c}}e.$KL=R}),define(Ce[61],Ae([1,0,2,93,29,50]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$SL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$RL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$QL=e.$PL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$OL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$NL=e.$ML=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$LL=e.TestResultState=void 0;var M;(function(A){A[A.Unset=0]="Unset",A[A.Queued=1]="Queued",A[A.Running=2]="Running",A[A.Passed=3]="Passed",A[A.Failed=4]="Failed",A[A.Skipped=5]="Skipped",A[A.Errored=6]="Errored"})(M||(e.TestResultState=M={})),e.$LL={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(A){A[A.Run=1]="Run",A[A.Debug=2]="Debug",A[A.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var g;(function(A){A[A.Run=2]="Run",A[A.Debug=4]="Debug",A[A.Coverage=8]="Coverage",A[A.HasNonDefaultProfile=16]="HasNonDefaultProfile",A[A.HasConfigurable=32]="HasConfigurable",A[A.SupportsContinuousRun=64]="SupportsContinuousRun"})(g||(e.TestRunProfileBitset=g={})),e.$ML=[2,4,8,16,32,64];const E=A=>"runId"in A;e.$NL=E;var T;(function(A){A.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({range:R.$tt.lift(K.range),uri:j.asCanonicalUri(S.URI.revive(K.uri))})})(T||(e.IRichLocation=T={}));var y;(function(A){A[A.Error=0]="Error",A[A.Output=1]="Output"})(y||(e.TestMessageType=y={}));var l;(function(A){A.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&T.deserialize(j,K.location)})})(l||(e.ITestErrorMessage=l={}));const w=(A,j)=>`${j?"s":"e"}${A}`;e.$OL=w;var m;(function(A){A.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&T.serialize(j.location)}),A.deserialize=(j,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&T.deserialize(j,K.location)})})(m||(e.ITestOutputMessage=m={}));var s;(function(A){A.serialize=j=>j.type===0?l.serialize(j):m.serialize(j),A.deserialize=(j,K)=>K.type===0?l.deserialize(j,K):m.deserialize(j,K)})(s||(e.ITestMessage=s={}));var o;(function(A){A.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),A.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(s.serialize)}),A.deserialize=(j,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(re=>s.deserialize(j,re))})})(o||(e.ITestTaskState=o={}));const r="\0",t=(A,j)=>A+r+j;e.$PL=t;const n=A=>{const j=A.indexOf(r);return{ctrlId:A.slice(0,j),tagId:A.slice(j+1)}};e.$QL=n;var c;(function(A){A.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),A.deserialize=(j,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?j.asCanonicalUri(S.URI.revive(K.uri)):void 0,range:K.range?R.$tt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var h;(function(A){A[A.NotExpandable=0]="NotExpandable",A[A.Expandable=1]="Expandable",A[A.BusyExpanding=2]="BusyExpanding",A[A.Expanded=3]="Expanded"})(h||(e.TestItemExpandState=h={}));var i;(function(A){A.serialize=j=>({expand:j.expand,item:c.serialize(j.item)}),A.deserialize=(j,K)=>({controllerId:O.$KL.root(K.item.extId),expand:K.expand,item:c.deserialize(j,K.item)})})(i||(e.InternalTestItem=i={}));var $;(function(A){A.serialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.uri!==void 0&&(K.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(K.range=j.item.range?.toJSON()),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}},A.deserialize=j=>{let K;return j.item&&(K={},j.item.label!==void 0&&(K.label=j.item.label),j.item.tags!==void 0&&(K.tags=j.item.tags),j.item.busy!==void 0&&(K.busy=j.item.busy),j.item.range!==void 0&&(K.range=j.item.range?R.$tt.lift(j.item.range):null),j.item.description!==void 0&&(K.description=j.item.description),j.item.error!==void 0&&(K.error=j.item.error),j.item.sortText!==void 0&&(K.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:K}}})($||(e.ITestItemUpdate=$={}));const a=(A,j)=>{j.expand!==void 0&&(A.expand=j.expand),j.item!==void 0&&(A.item=A.item?Object.assign(A.item,j.item):j.item)};e.$RL=a;var v;(function(A){A.serializeWithoutMessages=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serializeWithoutMessages)}),A.serialize=j=>({...i.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(o.serialize)}),A.deserialize=(j,K)=>({...i.deserialize(j,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(re=>o.deserialize(j,re)),retired:!0})})(v||(e.TestResultItem=v={}));var d;(function(A){A.empty=()=>({covered:0,total:0}),A.sum=(j,K)=>{j.covered+=K.covered,j.total+=K.total}})(d||(e.ICoverageCount=d={}));var C;(function(A){A.serialize=j=>({id:j.id,statement:j.statement,branch:j.branch,declaration:j.declaration,uri:j.uri.toJSON()}),A.deserialize=(j,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,uri:j.asCanonicalUri(S.URI.revive(K.uri))})})(C||(e.IFileCoverage=C={}));function u(A){return{...A,location:A.location?.toJSON()}}function D(A){return A.location=A.location?N.$st.isIPosition(A.location)?N.$st.lift(A.location):R.$tt.lift(A.location):void 0,A}e.$SL=3;var f;(function(A){A[A.Declaration=0]="Declaration",A[A.Statement=1]="Statement",A[A.Branch=2]="Branch"})(f||(e.DetailType=f={}));var k;(function(A){A.serialize=j=>j.type===0?P.serialize(j):I.serialize(j),A.deserialize=j=>j.type===0?P.deserialize(j):I.deserialize(j)})(k||(e.CoverageDetails=k={}));var b;(function(A){A.serialize=u,A.deserialize=D})(b||(e.IBranchCoverage=b={}));var P;(function(A){A.serialize=u,A.deserialize=D})(P||(e.IDeclarationCoverage=P={}));var I;(function(A){A.serialize=j=>({...u(j),branches:j.branches?.map(b.serialize)}),A.deserialize=j=>({...D(j),branches:j.branches?.map(b.deserialize)})})(I||(e.IStatementCoverage=I={}));var W;(function(A){A[A.Add=0]="Add",A[A.Update=1]="Update",A[A.DocumentSynced=2]="DocumentSynced",A[A.Remove=3]="Remove",A[A.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",A[A.Retire=5]="Retire",A[A.AddTag=6]="AddTag",A[A.RemoveTag=7]="RemoveTag"})(W||(e.TestDiffOpType=W={}));var V;(function(A){A.deserialize=(j,K)=>K.op===0?{op:K.op,item:i.deserialize(j,K.item)}:K.op===1?{op:K.op,item:$.deserialize(K.item)}:K.op===2?{op:K.op,uri:j.asCanonicalUri(S.URI.revive(K.uri)),docv:K.docv}:K,A.serialize=j=>j.op===0?{op:j.op,item:i.serialize(j.item)}:j.op===1?{op:j.op,item:$.serialize(j.item)}:j})(V||(e.TestsDiffOp=V={}));class q{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const K=this.v();for(const re of j)switch(re.op){case 0:this.l(i.deserialize(this.k,re.item),K);break;case 1:this.o($.deserialize(re.item),K);break;case 3:this.p(re.itemId,K);break;case 5:this.q(re.itemId);break;case 4:this.updatePendingRoots(re.amount);break;case 6:this.c.set(re.tag.id,re.tag);break;case 7:this.c.delete(re.id);break}K.complete?.()}l(j,K){const re=O.$KL.parentId(j.item.extId)?.toString();let ae;if(!re)ae=this.w(j),this.g.add(ae),this.f.set(j.item.extId,ae);else if(this.f.has(re)){const we=this.f.get(re);we.children.add(j.item.extId),ae=this.w(j,we),this.f.set(j.item.extId,ae)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return K.add?.(ae),j.expand===2&&this.h++,ae}o(j,K){const re=this.f.get(j.extId);if(re)return j.expand!==void 0&&(re.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$RL)(re,j),K.update?.(re),re}p(j,K){const re=this.f.get(j);if(!re)return;const ae=O.$KL.parentId(re.item.extId)?.toString();ae?this.f.get(ae).children.delete(re.item.extId):this.g.delete(re);const we=[[j]];for(;we.length;)for(const Ie of we.pop()){const de=this.f.get(Ie);de&&(we.push(de.children),this.f.delete(Ie),K.remove?.(de,de!==re),de.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$TL=q}),define(Ce[75],Ae([1,0,11,5,6,56,61,50]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fP=e.$eP=e.$dP=e.$cP=e.$bP=e.TestItemEventOp=void 0;var g;(function(t){t[t.Upsert=0]="Upsert",t[t.SetTags=1]="SetTags",t[t.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",t[t.RemoveChild=3]="RemoveChild",t[t.SetProp=4]="SetProp",t[t.Bulk=5]="Bulk",t[t.DocumentSynced=6]="DocumentSynced"})(g||(e.TestItemEventOp=g={}));const E=(t,n)=>t===n,y=Object.entries({range:(t,n)=>t===n?!0:!t||!n?!1:t.equalsRange(n),busy:E,label:E,description:E,error:E,sortText:E,tags:(t,n)=>!(t.length!==n.length||t.some(c=>!n.includes(c)))}),l=(t,n)=>{let c;for(const[h,i]of y)i(t[h],n[h])||(c?c[h]=n[h]:c={[h]:n[h]});return c};class w extends R.$Vc{get root(){return this.s.root}constructor(n){super(),this.s=n,this.f=this.B(new S.$Hh(()=>this.flushDiff(),200)),this.g=this.B(new N.$ee),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(n){this.h=n;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const n=this.m;return this.m=[],n}pushDiff(n){switch(n.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===n.uri){c.docv=n.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===n.item.extId){(0,M.$RL)(c.item,n.item);return}if(c.op===0&&c.item.item.extId===n.item.extId){(0,M.$RL)(c.item,n.item);return}}break}}this.m.push(n),this.f.isScheduled()||this.f.schedule()}expand(n,c){const h=this.tree.get(n);if(h){if((h.expandLevels===void 0||c>h.expandLevels)&&(h.expandLevels=c),h.expand===1){const i=this.M(h);return i.isOpen()?this.L(h,c-1):i.wait().then(()=>this.L(h,c-1))}else if(h.expand===3)return h.resolveBarrier?.isOpen()===!1?h.resolveBarrier.wait().then(()=>this.L(h,c-1)):this.L(h,c-1)}}dispose(){for(const n of this.tree.values())this.s.getApiFor(n.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(n,c){switch(c.op){case 3:this.O(p.$KL.joinToString(n.fullId,c.id));break;case 0:this.z(c.item,n);break;case 5:for(const h of c.ops)this.w(n,h);break;case 1:this.C(c.new,c.old,n.fullId.toString());break;case 2:this.J(n);break;case 4:this.pushDiff({op:1,item:{extId:n.fullId.toString(),item:c.update}});break;case 6:this.y(n.actual.uri);break;default:(0,O.$fd)(c)}}y(n){n&&this.pushDiff({op:2,uri:n,docv:this.s.getDocumentVersion(n)})}z(n,c){const h=p.$KL.fromExtHostTestItem(n,this.root.id,c?.actual),i=this.s.getApiFor(n);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(n.id);let $=this.tree.get(h.toString());if(!$){$={fullId:h,actual:n,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},n.tags.forEach(this.D,this),this.tree.set($.fullId.toString(),$),this.G(n,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:$.expand,item:this.s.toITestItem(n)}}),this.I(n,$,c);return}if($.actual===n){this.H(n,$,c);return}if($.actual.uri?.toString()!==n.uri?.toString())return this.O(h.toString()),this.z(n,c);const a=this.s.getChildren($.actual),v=$.actual,d=l(this.s.toITestItem(v),this.s.toITestItem(n));this.s.getApiFor(v).listener=void 0,$.actual=n,$.resolveBarrier=void 0,$.expand=0,d&&(d.hasOwnProperty("tags")&&(this.C(n.tags,v.tags,h.toString()),delete d.tags),this.w($,{op:4,update:d})),this.I(n,$,c);for(const[u,D]of a)this.s.getChildren(n).get(D.id)||this.O(p.$KL.joinToString(h,D.id));const C=$.expandLevels;C!==void 0&&queueMicrotask(()=>{$.expand===1&&($.expandLevels=void 0,this.expand(h.toString(),C))}),this.y($.actual.uri)}C(n,c,h){const i=new Set(c.map($=>$.id));for(const $ of n)i.delete($.id)||this.D($);this.pushDiff({op:1,item:{extId:h,item:{tags:n.map($=>(0,M.$PL)(this.s.controllerId,$.id))}}}),i.forEach(this.F,this)}D(n){const c=this.j.get(n.id);c?c.refCount++:(this.j.set(n.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,M.$PL)(this.s.controllerId,n.id)}}))}F(n){const c=this.j.get(n);c&&!--c.refCount&&(this.j.delete(n),this.pushDiff({op:7,id:(0,M.$PL)(this.s.controllerId,n)}))}G(n,c){this.s.getApiFor(n).parent=c&&c.actual!==this.root?c.actual:void 0}H(n,c,h){this.G(n,h);const i=this.s.getApiFor(n);i.parent=h?.actual,i.listener=$=>this.w(c,$),this.J(c)}I(n,c,h){this.H(n,c,h);for(const[i,$]of this.s.getChildren(n))this.z($,c)}J(n){let c;this.h?n.resolveBarrier?c=n.resolveBarrier.isOpen()?3:2:c=n.actual.canResolveChildren?1:0:c=0,c!==n.expand&&(n.expand=c,this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:c}}),c===1&&n.expandLevels!==void 0&&this.M(n))}L(n,c){if(c<0)return;const h=[];for(const[i,$]of this.s.getChildren(n.actual)){const a=this.expand(p.$KL.joinToString(n.fullId,$.id),c);(0,S.$hh)(a)&&h.push(a)}if(h.length)return Promise.all(h).then(()=>{})}M(n){if(n.resolveBarrier)return n.resolveBarrier;if(!this.h){const $=new S.$uh;return $.open(),$}n.expand=2,this.N(n);const c=n.resolveBarrier=new S.$uh,h=$=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,$)};let i;try{i=this.h(n.actual===this.root?void 0:n.actual)}catch($){h($)}return(0,S.$hh)(i)?i.catch(h).then(()=>{c.open(),this.J(n)}):(c.open(),this.J(n)),n.resolveBarrier}N(n){this.pushDiff({op:1,item:{extId:n.fullId.toString(),expand:n.expand}})}O(n){const c=this.tree.get(n);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:n});const h=[c];for(;h.length;){const i=h.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const $ of i.actual.tags)this.F($.id);this.tree.delete(i.fullId.toString());for(const[$,a]of this.s.getChildren(i.actual))h.push(this.tree.get(p.$KL.joinToString(i.fullId,a.id)))}}}flushDiff(){const n=this.collectDiff();n.length&&this.g.fire(n)}}e.$bP=w;class m extends Error{constructor(n){super(`Attempted to insert a duplicate test item ID ${n}`)}}e.$cP=m;class s extends Error{constructor(n){super(`TestItem with ID "${n}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$dP=s;class o extends Error{constructor(n,c,h){super(`TestItem with ID "${n}" is from controller "${c}" and cannot be added as a child of an item from controller "${h}".`)}}e.$eP=o;const r=(t,n,c)=>{let h=new Map;return{get size(){return h.size},forEach(i,$){for(const a of h.values())i.call($,a,this)},[Symbol.iterator](){return h.entries()},replace(i){const $=new Map,a=new Set(h.keys()),v={op:5,ops:[]};for(const d of i){if(!(d instanceof c))throw new s(d.id);const C=n(d).controllerId;if(C!==t.controllerId)throw new o(d.id,C,t.controllerId);if($.has(d.id))throw new m(d.id);$.set(d.id,d),a.delete(d.id),v.ops.push({op:0,item:d})}for(const d of a.keys())v.ops.push({op:3,id:d});t.listener?.(v),h=$},add(i){if(!(i instanceof c))throw new s(i.id);h.set(i.id,i),t.listener?.({op:0,item:i})},delete(i){h.delete(i)&&t.listener?.({op:3,id:i})},get(i){return h.get(i)},toJSON(){return Array.from(h.values())}}};e.$fP=r}),define(Ce[105],Ae([1,0,75]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hP=e.$gP=void 0;const N=new WeakMap,R=(M,p)=>{const g={controllerId:p};return N.set(M,g),g};e.$gP=R;const O=M=>{const p=N.get(M);if(!p)throw new S.$dP(M?.id||"<unknown>");return p};e.$hP=O}),define(Ce[76],Ae([1,0,12,2]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uyb=e.$tyb=e.$syb=void 0,e.$vyb=R,e.$wyb=M,e.$syb="vscode-cdn.net",e.$tyb=`vscode-resource.${e.$syb}`,e.$uyb=`'self' https://*.${e.$syb}`;function R(p,g){return p.scheme===S.Schemas.http||p.scheme===S.Schemas.https?p:(g&&g.authority&&g.isRemote&&p.scheme===S.Schemas.file&&(p=N.URI.from({scheme:S.Schemas.vscodeRemote,authority:g.authority,path:p.path})),N.URI.from({scheme:S.Schemas.https,authority:`${p.scheme}+${O(p.authority)}.${e.$tyb}`,path:p.path,fragment:p.fragment,query:p.query}))}function O(p){return p.replace(/./g,g=>{const E=g.charCodeAt(0);return E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57?g:"-"+E.toString(16).padStart(4,"0")})}function M(p){return p.replace(/-([0-9a-f]{4})/g,(g,E)=>String.fromCharCode(parseInt(E,16)))}}),define(Ce[221],Ae([1,0,5,6,76]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$kc=void 0;class O{constructor(p,g,E){this.d=p,this.e=g,this.f=E,this.a=0,this.b=new N.$Uc,this.c=new Map,this.b.add(g.onDidChangeVisibleTextEditors(()=>{const T=g.getVisibleTextEditors();for(const y of this.c.values())T.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,g,E,T,y){let l;for(const n of this.e.getVisibleTextEditors(!0))if(n.value===p){l=n;break}if(!l)throw new Error("not a visible editor");const w=this,m=this.a++,s=new S.$ee,o=new S.$ee,r=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(n){return(0,R.$vyb)(n,w.f)}get cspSource(){return R.$uyb}set options(n){this.b=n,w.d.$setOptions(m,n)}get options(){return this.b}set html(n){this.a=n,w.d.$setHtml(m,n)}get html(){return this.a}get onDidReceiveMessage(){return s.event}postMessage(n){return w.d.$postMessage(m,n)}},t=new class{constructor(){this.editor=p,this.line=g,this.height=E,this.webview=r,this.onDidDispose=o.event}dispose(){w.c.has(m)&&(w.c.delete(m),w.d.$disposeEditorInset(m),o.fire(),o.dispose(),s.dispose())}};return this.d.$createEditorInset(m,l.id,l.value.document.uri,g+1,E,T||{},y.identifier,y.extensionLocation),this.c.set(m,{editor:p,inset:t,onDidReceiveMessage:s}),t}$onDidDispose(p){const g=this.c.get(p);g&&g.inset.dispose()}$onDidReceiveMessage(p,g){this.c.get(p)?.onDidReceiveMessage.fire(g)}}e.$$kc=O}),define(Ce[106],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3L=e.$2L=e.$1L=void 0,e.$1L="__",e.$2L=(0,S.$vi)("IAuthenticationService"),e.$3L=(0,S.$vi)("IAuthenticationExtensionsService")}),define(Ce[222],Ae([1,0,3]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.VariableKind=e.$0P=void 0,e.$0P=(0,S.$vi)("configurationResolverService");var N;(function(O){O.Unknown="unknown",O.Env="env",O.Config="config",O.Command="command",O.Input="input",O.ExtensionInstallFolder="extensionInstallFolder",O.WorkspaceFolder="workspaceFolder",O.Cwd="cwd",O.WorkspaceFolderBasename="workspaceFolderBasename",O.UserHome="userHome",O.LineNumber="lineNumber",O.SelectedText="selectedText",O.File="file",O.FileWorkspaceFolder="fileWorkspaceFolder",O.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",O.RelativeFile="relativeFile",O.RelativeFileDirname="relativeFileDirname",O.FileDirname="fileDirname",O.FileExtname="fileExtname",O.FileBasename="fileBasename",O.FileBasenameNoExtension="fileBasenameNoExtension",O.FileDirnameBasename="fileDirnameBasename",O.ExecPath="execPath",O.ExecInstallFolder="execInstallFolder",O.PathSeparator="pathSeparator",O.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class R extends Error{constructor(M,p){super(p),this.variable=M}}e.$$P=R}),define(Ce[223],Ae([1,0,19,73,17,25,21,96,183,222,15]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nQ=void 0;class y{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,m,s,o){this.h=new Map,this.a=w,this.b=m,this.g=s,o&&(this.c=o.then(r=>this.i(r)))}i(w){if(M.$i){const m=Object.create(null);return Object.keys(w).forEach(s=>{m[s.toLowerCase()]=w[s]}),m}return w}resolveWithEnvironment(w,m,s){return this.l({env:this.i(w),userHome:void 0},m?m.uri:void 0,s)}async resolveAsync(w,m){const s={env:await this.c,userHome:await this.g};return this.l(s,w?w.uri:void 0,m)}async j(w,m,s,o){const r=O.$2n(m);M.$i&&r.windows?Object.keys(r.windows).forEach(n=>r[n]=r.windows[n]):M.$j&&r.osx?Object.keys(r.osx).forEach(n=>r[n]=r.osx[n]):M.$k&&r.linux&&Object.keys(r.linux).forEach(n=>r[n]=r.linux[n]),delete r.windows,delete r.osx,delete r.linux;const t={env:await this.c,userHome:await this.g};return this.l(t,w?w.uri:void 0,r,s,o)}async resolveAnyAsync(w,m,s){return this.j(w,m,s)}async resolveAnyMap(w,m,s){const o=new Map;return{newConfig:await this.j(w,m,s,o),resolvedVariables:o}}resolveWithInteractionReplace(w,m,s,o){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,m,s,o){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,m){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,m)}async l(w,m,s,o,r){if(R.$8f(s))return this.m(w,m,s,o,r);if(Array.isArray(s))return Promise.all(s.map(t=>this.l(w,m,t,o,r)));if(R.$0f(s)){const t=Object.create(null),n=await Promise.all(Object.keys(s).map(async c=>[await this.m(w,m,c,o,r),await this.l(w,m,s[c],o,r)]));for(const[c,h]of n)t[c]=h;return t}return s}m(w,m,s,o,r){return(0,T.$pf)(s,y.VARIABLE_REGEXP,async(t,n)=>{if(n.includes(y.VARIABLE_LHS))return t;let c=await this.o(w,t,n,m,o);return r?.set(n,c),c!==t&&R.$8f(c)&&c.match(y.VARIABLE_REGEXP)&&(c=await this.m(w,m,c,o,r)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,m,s,o,r){let t;const n=s.split(":");n.length>1&&(s=n[0],t=n[1]);const c=$=>{const a=this.a.getFilePath();if(a)return(0,p.$xw)(a);throw new E.$$P($,(0,g.localize)(0,null,m))},h=$=>{const a=c($);if(this.a.getWorkspaceFolderPathForFile){const v=this.a.getWorkspaceFolderPathForFile();if(v)return(0,p.$xw)(v)}throw new E.$$P($,(0,g.localize)(1,null,m,S.$oc(a)))},i=$=>{if(t){const a=this.a.getFolderUri(t);if(a)return a;throw new E.$$P($,(0,g.localize)(2,null,m,t))}if(o)return o;throw this.a.getWorkspaceFolderCount()>1?new E.$$P($,(0,g.localize)(3,null,m)):new E.$$P($,(0,g.localize)(4,null,m))};switch(s){case"env":if(t){if(w.env){const $=w.env[M.$i?t.toLowerCase():t];if(R.$8f($))return $}return""}throw new E.$$P(E.VariableKind.Env,(0,g.localize)(5,null,m));case"config":if(t){const $=this.a.getConfigurationValue(o,t);if(R.$eg($))throw new E.$$P(E.VariableKind.Config,(0,g.localize)(6,null,m,t));if(R.$0f($))throw new E.$$P(E.VariableKind.Config,(0,g.localize)(7,null,m,t));return $}throw new E.$$P(E.VariableKind.Config,(0,g.localize)(8,null,m));case"command":return this.p(E.VariableKind.Command,m,t,r,"command");case"input":return this.p(E.VariableKind.Input,m,t,r,"input");case"extensionInstallFolder":if(t){const $=await this.a.getExtension(t);if(!$)throw new E.$$P(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(9,null,m,t));return this.n($.extensionLocation)}throw new E.$$P(E.VariableKind.ExtensionInstallFolder,(0,g.localize)(10,null,m));default:switch(s){case"workspaceRoot":case"workspaceFolder":return(0,p.$xw)(this.n(i(E.VariableKind.WorkspaceFolder)));case"cwd":return o||t?(0,p.$xw)(this.n(i(E.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$xw)(S.$oc(this.n(i(E.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new E.$$P(E.VariableKind.UserHome,(0,g.localize)(11,null,m))}case"lineNumber":{const $=this.a.getLineNumber();if($)return $;throw new E.$$P(E.VariableKind.LineNumber,(0,g.localize)(12,null,m))}case"selectedText":{const $=this.a.getSelectedText();if($)return $;throw new E.$$P(E.VariableKind.SelectedText,(0,g.localize)(13,null,m))}case"file":return c(E.VariableKind.File);case"fileWorkspaceFolder":return h(E.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return S.$oc(h(E.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return o||t?S.$mc(this.n(i(E.VariableKind.RelativeFile)),c(E.VariableKind.RelativeFile)):c(E.VariableKind.RelativeFile);case"relativeFileDirname":{const $=S.$nc(c(E.VariableKind.RelativeFileDirname));if(o||t){const a=S.$mc(this.n(i(E.VariableKind.RelativeFileDirname)),$);return a.length===0?".":a}return $}case"fileDirname":return S.$nc(c(E.VariableKind.FileDirname));case"fileExtname":return S.$pc(c(E.VariableKind.FileExtname));case"fileBasename":return S.$oc(c(E.VariableKind.FileBasename));case"fileBasenameNoExtension":{const $=S.$oc(c(E.VariableKind.FileBasenameNoExtension));return $.slice(0,$.length-S.$pc($).length)}case"fileDirnameBasename":return S.$oc(S.$nc(c(E.VariableKind.FileDirnameBasename)));case"execPath":{const $=this.a.getExecPath();return $||m}case"execInstallFolder":{const $=this.a.getAppRoot();return $||m}case"pathSeparator":case"/":return S.sep;default:try{const $=t?`${s}:${t}`:s;return this.p(E.VariableKind.Unknown,m,$,r,void 0)}catch{return m}}}}p(w,m,s,o,r){if(s&&o){const t=r===void 0?o[s]:o[r+":"+s];if(typeof t=="string")return t;throw new E.$$P(w,(0,g.localize)(14,null,m))}return m}}e.$nQ=y}),define(Ce[107],Ae([1,0,3,104]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$QD=void 0,e.$RD=E,e.$SD=l,e.$TD=w,e.$QD=(0,S.$vi)("editorGroupsService");var R;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(R||(e.GroupDirection=R={}));var O;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(O||(e.GroupOrientation=O={}));var M;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(M||(e.GroupLocation=M={}));var p;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EXPAND=1]="EXPAND",m[m.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var g;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(g||(e.MergeGroupMode=g={}));function E(m){const s=m;return(0,N.$BF)(s?.editor)&&(0,N.$BF)(s?.replacement)}var T;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(T||(e.GroupsOrder=T={}));var y;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(y||(e.OpenEditorContext=y={}));function l(m){const s=m;return!!s&&typeof s.id=="number"&&Array.isArray(s.editors)}function w(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Ce[224],Ae([1,0,3,107]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XD=e.$WD=e.$VD=e.$UD=void 0,e.$YD=R,e.$UD=(0,S.$vi)("editorService"),e.$VD=-1,e.$WD=-2,e.$XD=-3;function R(O){const M=O;return typeof O=="number"||(0,N.$SD)(M)}}),define(Ce[225],Ae([1,0,3,190]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jM=void 0,e.$jM=(0,S.$wi)(N.$Ci)}),define(Ce[108],Ae([1,0,20,5,19,6,11]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=e.$v_b=e.$u_b=e.$t_b=e.$s_b=void 0;class p{constructor(t,n){this.versionId=t,this.removedDueToLooping=n}}e.$s_b=p;class g{static isHostExtension(t,n,c){if(n.getExtensionDescription(t))return!1;const h=c.getExtensionDescription(t);return h?!!((h.main||h.browser)&&h.api==="none"):!1}constructor(t,n){this.j=t,this.c=new N.$ee,this.onDidChange=this.c.event,this.d=0,this.e=n,this.k()}k(){this.e.sort(s),this.f=new S.$Sm,this.g=[],this.h=new Map;for(const t of this.e){if(this.f.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.f.set(t.identifier,t),this.g.push(t);const n=this.j.readActivationEvents(t);for(const c of n)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(t)}}set(t){return this.e=t,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(t,n){this.e=o(this.e,n),this.e=this.e.concat(t);const c=g.l(this.e);return this.e=o(this.e,c.map(h=>h.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(t){const n=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,v){this.addNode(a),this.addNode(v),this.c.has(a)?this.c.get(a).push(v):this.c.set(a,[v])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,v){const d=n.getArcs(a);for(let C=0;C<d.length;C++)if(!v.has(d[C]))return!1;return!0}getNodes(){return this.e}},c=new S.$Sm;for(const a of t)if(c.set(a.identifier,a),a.extensionDependencies)for(const v of a.extensionDependencies)n.addArc(S.$Qm.toKey(a.identifier),S.$Qm.toKey(v));const h=new Set;n.getNodes().filter(a=>n.getArcs(a).length===0).forEach(a=>h.add(a));const i=n.getNodes().filter(a=>!h.has(a));let $;do{$=!1;for(let a=0;a<i.length;a++){const v=i[a];n.hasOnlyGoodArcs(v,h)&&(i.splice(a,1),a--,h.add(v),$=!0)}}while($);return i.map(a=>c.get(a))}containsActivationEvent(t){return this.h.has(t)}containsExtension(t){return this.f.has(t)}getExtensionDescriptionsForActivationEvent(t){const n=this.h.get(t);return n?n.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new E(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(t){const n=this.f.get(t);return n||void 0}getExtensionDescriptionByUUID(t){for(const n of this.g)if(n.uuid===t)return n}getExtensionDescriptionByIdOrUUID(t,n){return this.getExtensionDescription(t)??(n?this.getExtensionDescriptionByUUID(n):void 0)}}e.$t_b=g;class E{constructor(t,n){this.versionId=t,this.extensions=n}}e.$u_b=E;class T{constructor(t){this.d=new w,this.c=new g(t,[])}async acquireLock(t){const n=await this.d.acquire(t);return new y(this,n)}deltaExtensions(t,n,c){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(n,c)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,n){return this.c.getExtensionDescriptionByIdOrUUID(t,n)}}e.$v_b=T;class y extends O.$Vc{constructor(t,n){super(),this.f=t,this.c=!1,this.B(n)}isAcquiredFor(t){return!this.c&&this.f===t}}e.$w_b=y;class l{constructor(t){this.name=t;const n=(0,M.$oh)();this.promise=n.promise,this.c=n.resolve}resolve(t){this.c(t)}}class w{constructor(){this.c=[],this.d=!1}async acquire(t){const n=new l(t);return this.c.push(n),this.e(),n.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let n=!0;const c=setTimeout(()=>{n&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),h=()=>{n&&(clearTimeout(c),n=!1,this.d=!1,this.e())};t.resolve((0,O.$Tc)(h))}}var m;(function(r){r[r.Builtin=0]="Builtin",r[r.User=1]="User",r[r.Dev=2]="Dev"})(m||(m={}));function s(r,t){const n=r.isBuiltin?0:r.isUnderDevelopment?2:1,c=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(n!==c)return n-c;const h=R.$hc.basename(r.extensionLocation.path),i=R.$hc.basename(t.extensionLocation.path);return h<i?-1:h>i?1:0}function o(r,t){const n=new S.$Rm(t);return r.filter(c=>!n.has(c.identifier))}}),define(Ce[77],Ae([1,0,22]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$Ym=M,e.$Zm=p;var N;(function(E){E[E.Desktop=1]="Desktop",E[E.Web=2]="Web"})(N||(e.UIKind=N={}));var R;(function(E){E[E.VersionMismatch=55]="VersionMismatch",E[E.UnexpectedError=81]="UnexpectedError"})(R||(e.ExtensionHostExitCode=R={}));var O;(function(E){E[E.Initialized=0]="Initialized",E[E.Ready=1]="Ready",E[E.Terminate=2]="Terminate"})(O||(e.MessageType=O={}));function M(E){const T=S.$Fe.alloc(1);switch(E){case 0:T.writeUInt8(1,0);break;case 1:T.writeUInt8(2,0);break;case 2:T.writeUInt8(3,0);break}return T}function p(E,T){if(E.byteLength!==1)return!1;switch(E.readUInt8(0)){case 1:return T===0;case 2:return T===1;case 3:return T===2;default:return!1}}var g;(function(E){E.Start="START_NATIVE_LOG",E.End="END_NATIVE_LOG"})(g||(e.NativeLogMarkers=g={}))}),define(Ce[62],Ae([1,0,3,5,13,27,77,58,59,25,2,6,170]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FP=e.$DP=e.$CP=void 0,e.$EP=s;let w=class extends y.$Vc{constructor(r,t){super(),this.s=r,this.t=t,this.a=this.B(new N.$ee),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$ee),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=T.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=t.createLogger(this.m,{id:g.$jp,name:(0,l.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(t.onDidChangeLogLevel(n=>{(0,R.$4j)(n)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===R.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(r,t,n){const c=this.getTelemetryDetails(),h=new m(t,n,r,this.n,this.j,this.getBuiltInCommonProperties(r),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(r.identifier.value)??[];return this.r.set(r.identifier.value,[...i,h]),h.apiTelemetryLogger}$initializeTelemetryLevel(r,t,n){this.f=r,this.g=t,this.c=n??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(r){const t=Object.create(null);switch(t["common.extname"]=`${r.publisher}.${r.name}`,t["common.extversion"]=r.version,t["common.vscodemachineid"]=this.s.telemetryInfo.machineId,t["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,t["common.sqmid"]=this.s.telemetryInfo.sqmId,t["common.vscodeversion"]=this.s.version,t["common.isnewappinstall"]=s(this.s.telemetryInfo.firstSessionDate),t["common.product"]=this.s.environment.appHost,this.s.uiKind){case M.UIKind.Web:t["common.uikind"]="web";break;case M.UIKind.Desktop:t["common.uikind"]="desktop";break;default:t["common.uikind"]="unknown"}return t["common.remotename"]=(0,p.$Hm)((0,g.$pp)(this.s.remote.authority)),t}$onDidChangeTelemetryLevel(r){this.h=this.getTelemetryConfiguration(),this.f=r;const t=this.getTelemetryDetails();this.r.forEach((n,c)=>{const h=n.filter(i=>!i.isDisposed);h.length===0?this.r.delete(c):this.r.set(c,h)}),this.r.forEach(n=>{for(const c of n)c.updateTelemetryEnablements(t.isUsageEnabled,t.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(r,t){const c=this.r.get(r.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(r.value),!1;let h=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(t),h=!0);return h}};e.$CP=w,e.$CP=w=Je([We(0,O.$BP),We(1,R.$3j)],w);class m{static validateSender(r){if(typeof r!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof r.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof r.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof r.flush<"u"&&typeof r.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(r,t,n,c,h,i,$){this.g=n,this.h=c,this.i=h,this.j=i,this.a=new N.$ee,this.ignoreUnhandledExtHostErrors=t?.ignoreUnhandledErrors??!1,this.b=t?.ignoreBuiltInCommonProperties??!1,this.c=t?.additionalCommonProperties,this.f=r,this.d={isUsageEnabled:$.isUsageEnabled,isErrorsEnabled:$.isErrorsEnabled}}updateTelemetryEnablements(r,t){this.e&&(this.d={isUsageEnabled:r,isErrorsEnabled:t},this.a.fire(this.e))}mixInCommonPropsAndCleanData(r){let t="properties"in r?r.properties??{}:r;return t=(0,g.$sp)(t,[]),this.c&&(t=(0,E.$5n)(t,this.c)),this.b||(t=(0,E.$5n)(t,this.j)),"properties"in r?r.properties=t:r=t,r}k(r,t){this.f&&(this.g.publisher==="vscode"?r=this.g.name+"/"+r:r=this.g.identifier.value+"/"+r,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f?.sendEventData(r,t),this.h.trace(r,t))}logUsage(r,t){this.d.isUsageEnabled&&this.k(r,t)}logError(r,t){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof r=="string")this.k(r,t);else{const n={name:r.name,message:r.message,stack:r.stack,cause:r.cause},c=(0,g.$sp)(n,[]),h=new Error(c.message,{cause:c.cause});h.stack=c.stack,h.name=c.name,t=this.mixInCommonPropsAndCleanData(t||{}),this.i||this.f.sendErrorData(h,t),this.h.trace("exception",t)}}get apiTelemetryLogger(){if(!this.e){const r=this,t={logUsage:r.logUsage.bind(r),get isUsageEnabled(){return r.d.isUsageEnabled},get isErrorsEnabled(){return r.d.isErrorsEnabled},logError:r.logError.bind(r),dispose:r.dispose.bind(r),onDidChangeEnableStates:r.a.event.bind(r)};this.e=Object.freeze(t)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let r=this.f;this.f=void 0,Promise.resolve(r.flush()).then(r=void 0),this.e=void 0}else this.f=void 0}}e.$DP=m;function s(o){const r=Date.now()-new Date(o).getTime();return isNaN(r)?!1:r<1e3*60*60*24}e.$FP=(0,S.$vi)("IExtHostTelemetry")}),define(Ce[26],Ae([1,0,5,2,199,103,20,3]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LG=e.ActivationKind=e.$IG=e.$HG=e.$EG=e.ExtensionHostStartup=e.$DG=e.$CG=e.$BG=e.$AG=void 0,e.$FG=l,e.$GG=w,e.$JG=r,e.$KG=t,e.$AG=Object.freeze({identifier:new M.$Qm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BG="extensions.webWorker",e.$CG=(0,p.$vi)("extensionService");class g{constructor(h){this.dependency=h}}e.$DG=g;var E;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(E||(e.ExtensionHostStartup=E={}));class T{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(h,i,$){this.c=h,this.d=i.slice(0),this.e=$.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:O.$lG.createActivationEventsMap(this.d)}}set(h,i,$){if(this.c>h)throw new Error(`ExtensionHostExtensions: invalid versionId ${h} (current: ${this.c})`);const a=[],v=[],d=[],C=[],u=y(this.d),D=y(i),f=(W,V)=>W.extensionLocation.toString()===V.extensionLocation.toString()||W.isBuiltin===V.isBuiltin||W.isUserBuiltin===V.isUserBuiltin||W.isUnderDevelopment===V.isUnderDevelopment;for(const W of this.d){const V=D.get(W.identifier);if(!V){a.push(W.identifier),u.delete(W.identifier);continue}if(!f(W,V)){a.push(W.identifier),u.delete(W.identifier);continue}}for(const W of i){const V=u.get(W.identifier);if(!V){v.push(W);continue}if(!f(V,W)){a.push(V.identifier),u.delete(V.identifier);continue}}const k=new M.$Rm(this.e),b=new M.$Rm($);for(const W of this.e)b.has(W)||d.push(W);for(const W of $)k.has(W)||C.push(W);const P=O.$lG.createActivationEventsMap(v),I={versionId:h,toRemove:a,toAdd:v,addActivationEvents:P,myToRemove:d,myToAdd:C};return this.delta(I),I}delta(h){if(this.c>=h.versionId)return null;const{toRemove:i,toAdd:$,myToRemove:a,myToAdd:v}=h,d=new M.$Rm(i),C=new M.$Rm(a);for(let u=0;u<this.d.length;u++)d.has(this.d[u].identifier)&&(this.d.splice(u,1),u--);for(let u=0;u<this.e.length;u++)C.has(this.e[u])&&(this.e.splice(u,1),u--);for(const u of $)this.d.push(u);for(const u of v)this.e.push(u);return this.f=null,h}containsExtension(h){for(const i of this.e)if(M.$Qm.equals(i,h))return!0;return!1}containsActivationEvent(h){return this.f||(this.f=this.g()),this.f.has(h)}g(){const h=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const $=O.$lG.readActivationEvents(i);for(const a of $)h.add(a)}return h}}e.$EG=T;function y(c){const h=new M.$Sm;for(const i of c)h.set(i.identifier,i);return h}function l(c,h){return c.enabledApiProposals?c.enabledApiProposals.includes(h):!1}function w(c,h){if(!l(c,h))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${h}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${h}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class m{constructor(h,i,$,a){this.codeLoadingTime=h,this.activateCallTime=i,this.activateResolvedTime=$,this.activationReason=a}}e.$HG=m;class s{constructor(h,i){this.description=h,this.value=i}}e.$IG=s;var o;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(o||(e.ActivationKind=o={}));function r(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,R.$yp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function t(c,h){return{identifier:new M.$Qm((0,R.$wp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!h,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class n{constructor(){this.onDidRegisterExtensions=S.Event.None,this.onDidChangeExtensionsStatus=S.Event.None,this.onDidChangeExtensions=S.Event.None,this.onWillActivateByEvent=S.Event.None,this.onDidChangeResponsiveChange=S.Event.None,this.onWillStop=S.Event.None,this.extensions=[]}activateByEvent(h){return Promise.resolve(void 0)}activateById(h,i){return Promise.resolve(void 0)}activationEventIsDone(h){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(h){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(h,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(h){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LG=n}),define(Ce[226],Ae([1,0,14,108,20,26,13,11]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zlc=e.$ylc=e.$xlc=e.$wlc=e.$vlc=e.$ulc=void 0;class g{static{this.NONE=new g(!1,-1,-1,-1)}constructor(r,t,n,c){this.startup=r,this.codeLoadingTime=t,this.activateCallTime=n,this.activateResolvedTime=c}}e.$ulc=g;class E{constructor(r){this.a=r,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(r,t){return r===-1||t===-1?-1:t-r}build(){return new g(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$vlc=E;class T{constructor(r,t,n,c,h,i){this.activationFailed=r,this.activationFailedError=t,this.activationTimes=n,this.module=c,this.exports=h,this.subscriptions=i}}e.$wlc=T;class y extends T{constructor(r){super(!1,null,r,{activate:void 0,deactivate:void 0},void 0,[])}}e.$xlc=y;class l extends T{constructor(){super(!1,null,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$ylc=l;class w extends T{constructor(r){super(!0,r,g.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let m=class{constructor(r,t,n,c){this.g=c,this.a=r,this.b=t,this.c=n,this.d=new R.$Sm,this.f=Object.create(null)}dispose(){for(const[r,t]of this.d)t.dispose()}async waitForActivatingExtensions(){const r=[];for(const[t,n]of this.d)r.push(n.wait());await Promise.all(r)}isActivated(r){const t=this.d.get(r);return!!(t&&t.value)}getActivatedExtension(r){const t=this.d.get(r);if(!t||!t.value)throw new Error(`Extension '${r.value}' is not known or not activated`);return t.value}async activateByEvent(r,t){if(this.f[r])return;const n=this.a.getExtensionDescriptionsForActivationEvent(r);await this.h(n.map(c=>({id:c.identifier,reason:{startup:t,extensionId:c.identifier,activationEvent:r}}))),this.f[r]=!0}activateById(r,t){const n=this.a.getExtensionDescription(r);if(!n)throw new Error(`Extension '${r.value}' is not known`);return this.h([{id:n.identifier,reason:t}])}async h(r){const t=r.filter(n=>!this.isActivated(n.id)).map(n=>this.j(n));await Promise.all(t.map(n=>n.wait()))}j(r){if(this.d.has(r.id))return this.d.get(r.id);if(this.l(r.id))return this.k(r,null,[],null);const t=this.a.getExtensionDescription(r.id);if(!t){const h=new Error(`Cannot activate unknown extension '${r.id.value}'`),i=this.k(r,null,[],new w(h));return this.c.onExtensionActivationError(r.id,h,new O.$DG(r.id.value)),i}const n=[],c=typeof t.extensionDependencies>"u"?[]:t.extensionDependencies;for(const h of c){if(this.m(h))continue;const i=this.d.get(h);if(i){n.push(i);continue}if(this.l(h)){n.push(this.j({id:this.b.getExtensionDescription(h).identifier,reason:r.reason}));continue}const $=this.a.getExtensionDescription(h);if($){if(!$.main&&!$.browser)continue;n.push(this.j({id:$.identifier,reason:r.reason}));continue}const a=t.displayName||t.identifier.value,v=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${h}'`),d=this.k(r,t.displayName,[],new w(v));return this.c.onExtensionActivationError(t.identifier,v,new O.$DG(h)),d}return this.k(r,t.displayName,n,null)}k(r,t,n,c){const h=new s(r.id,t,r.reason,n,c,this.c,this.g);return this.d.set(r.id,h),h}l(r){return N.$t_b.isHostExtension(r,this.a,this.b)}m(r){const t=this.b.getExtensionDescription(r);return t?!t.main&&!t.browser:!1}};e.$zlc=m,e.$zlc=m=Je([We(3,M.$2j)],m);let s=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(r,t,n,c,h,i,$){this.c=r,this.d=t,this.f=n,this.g=c,this.h=h,this.j=i,this.k=$,this.a=new p.$uh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let r=0;r<this.g.length;r++){const t=this.g[r];if(t.value&&!t.value.activationFailed){this.g.splice(r,1),r--;continue}if(t.value&&t.value.activationFailed){const n=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${t.friendlyName}' failed to activate`);n.detail=t.value.activationFailedError,this.h=new w(n),this.j.onExtensionActivationError(this.c,n,null);return}}this.g.length>0&&await Promise.race(this.g.map(r=>r.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(r){const t=new Error;if(r&&r.name&&(t.name=r.name),r&&r.message?t.message=`Activating extension '${this.c.value}' failed: ${r.message}.`:t.message=`Activating extension '${this.c.value}' failed: ${r}.`,r&&r.stack&&(t.stack=r.stack),this.h=new w(t),this.b&&S.$4(r))return;this.j.onExtensionActivationError(this.c,t,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(r)}}};s=Je([We(6,M.$2j)],s)}),define(Ce[227],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[228],Ae([1,0,185,14,33,98,72,30,20,227,195,103]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zG=e.$yG=e.$xG=e.$wG=e.$vG=e.$uG=void 0;const l=p.$bo.as(M.$co.JSONContribution);class w{constructor(h,i,$){this.a=h,this.b=i,this.c=$}d(h,i){this.a({type:h,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(h){this.d(R.default.Error,h)}warn(h){this.d(R.default.Warning,h)}info(h){this.d(R.default.Info,h)}}e.$uG=w;class m{static a(h){const i=new g.$Rm;for(let $=0,a=h.length;$<a;$++)i.add(h[$].description.identifier);return i}static compute(h,i){if(!h||!h.length)return new m(i,[]);if(!i||!i.length)return new m([],h);const $=this.a(h),a=this.a(i),v=i.filter(C=>!$.has(C.description.identifier)),d=h.filter(C=>!a.has(C.description.identifier));return new m(v,d)}constructor(h,i){this.added=h,this.removed=i}}e.$vG=m;class s{constructor(h,i){this.name=h,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(h){if(this.a!==null)throw new Error("Handler already set!");this.a=h,this.d()}acceptUsers(h){this.c=m.compute(this.b,h),this.b=h,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(h){(0,N.$1)(h)}}}e.$wG=s;const o={type:"string",enum:["ui","workspace"],enumDescriptions:[S.localize(0,null),S.localize(1,null)]},r="vscode://schemas/vscode-extensions";e.$xG={properties:{engines:{type:"object",description:S.localize(2,null),properties:{vscode:{type:"string",description:S.localize(3,null),default:"^1.22.0"}}},publisher:{description:S.localize(4,null),type:"string"},displayName:{description:S.localize(5,null),type:"string"},categories:{description:S.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:g.$Pm},{type:"string",const:"Languages",deprecationMessage:S.localize(7,null)}]}},galleryBanner:{type:"object",description:S.localize(8,null),properties:{color:{description:S.localize(9,null),type:"string"},theme:{description:S.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:S.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:S.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:S.localize(13,null)},enabledApiProposals:{markdownDescription:S.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}},api:{markdownDescription:S.localize(15,null),type:"string",enum:["none"],enumDescriptions:[S.localize(16,null)]},activationEvents:{description:S.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:S.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:S.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:S.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:S.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:S.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:S.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:S.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:S.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:S.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:S.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:S.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:S.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:S.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:S.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:S.localize(32,null)},{label:"onUri",body:"onUri",description:S.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:S.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:S.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:S.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:S.localize(37,null)},{label:"onRenderer",description:S.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:S.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:S.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:S.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:S.localize(42,null)},{label:"*",description:S.localize(43,null),body:"*"}]}},badges:{type:"array",description:S.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:S.localize(45,null)},href:{type:"string",description:S.localize(46,null)},description:{type:"string",description:S.localize(47,null)}}}},markdown:{type:"string",description:S.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:S.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:S.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$So}},extensionPack:{description:S.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:O.$So}},extensionKind:{description:S.localize(52,null),type:"array",items:o,default:["workspace"],defaultSnippets:[{body:["ui"],description:S.localize(53,null)},{body:["workspace"],description:S.localize(54,null)},{body:["ui","workspace"],description:S.localize(55,null)},{body:["workspace","ui"],description:S.localize(56,null)},{body:[],description:S.localize(57,null)}]},capabilities:{description:S.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:S.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:S.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(61,null),S.localize(62,null),S.localize(63,null)]},description:{type:"string",markdownDescription:S.localize(64,null)}}},untrustedWorkspaces:{description:S.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:S.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[S.localize(67,null),S.localize(68,null),S.localize(69,null)]},restrictedConfigurations:{description:S.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:S.localize(71,null)}}}}},sponsor:{description:S.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:S.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:S.localize(74,null),type:"string"},"vscode:uninstall":{description:S.localize(75,null),type:"string"}}},icon:{type:"string",description:S.localize(76,null)},l10n:{type:"string",description:S.localize(77,null)},pricing:{type:"string",markdownDescription:S.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class t{constructor(){this.a=new Map}registerExtensionPoint(h){if(this.a.has(h.extensionPoint))throw new Error("Duplicate extension point: "+h.extensionPoint);const i=new s(h.extensionPoint,h.defaultExtensionKind);return this.a.set(h.extensionPoint,i),h.activationEventsGenerator&&y.$lG.register(h.extensionPoint,h.activationEventsGenerator),e.$xG.properties.contributes.properties[h.extensionPoint]=h.jsonSchema,l.registerSchema(r,e.$xG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$yG=t;const n={ExtensionsRegistry:"ExtensionsRegistry"};p.$bo.add(n.ExtensionsRegistry,new t),e.$zG=p.$bo.as(n.ExtensionsRegistry),l.registerSchema(r,e.$xG),l.registerSchema(T.$jk,{properties:{extensionEnabledApiProposals:{description:S.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(E.allApiProposals),markdownEnumDescriptions:Object.values(E.allApiProposals)}}]}}}})}),define(Ce[229],Ae([1,0,181,17,25,228,31,5]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4H=void 0;const g={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:S.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:S.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:S.localize(2,null),default:""}}};var E;(function(l){function w(m,s,o){if(!m)return;const r=N.$8f(m.type)?m.type:void 0;if(!r||r.length===0){o.error(S.localize(3,null));return}const t=[];if(Array.isArray(m.required))for(const n of m.required)N.$8f(n)&&t.push(n);return{extensionId:s.value,taskType:r,required:t,properties:m.properties?R.$2n(m.properties):{},when:m.when?M.$tj.deserialize(m.when):void 0}}l.from=w})(E||(E={}));const T=O.$zG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(l,w)=>{for(const m of l)m.type&&w.push(`onTaskType:${m.type}`)},jsonSchema:{description:S.localize(4,null),type:"array",items:g}});class y{constructor(){this.d=new p.$ee,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,m)=>{T.setHandler((s,o)=>{this.c=void 0;try{for(const r of o.removed){const t=r.value;for(const n of t)this.a&&n.type&&this.a[n.type]&&delete this.a[n.type]}for(const r of o.added){const t=r.value;for(const n of t){const c=E.from(n,r.description.identifier,r.collector);c&&(this.a[c.taskType]=c)}}(o.removed.length>0||o.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const m of this.all()){const s={type:"object",additionalProperties:!1};m.required.length>0&&(s.required=m.required.slice(0)),m.properties!==void 0?s.properties=R.$2n(m.properties):s.properties=Object.create(null),s.properties.type={type:"string",enum:[m.taskType]},w.push(s)}this.c={oneOf:w}}return this.c}}e.$4H=new y}),define(Ce[230],Ae([1,0,182,17,23,25,31,229]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$bI=e.JsonSchemaVersion=e.ExecutionEngine=e.$aI=e.$_H=e.$$H=e.$0H=e.$9H=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$8H=e.ShellQuoting=e.$7H=e.$6H=e.$5H=void 0,e.$5H="settings",e.$6H=new M.$Mj("taskRunning",!1,S.localize(0,null)),e.$7H=S.localize2(2,"Tasks");var g;(function(A){A[A.Escape=1]="Escape",A[A.Strong=2]="Strong",A[A.Weak=3]="Weak"})(g||(e.ShellQuoting=g={})),e.$8H="$customized",function(A){function j(K){if(!K)return A.Strong;switch(K.toLowerCase()){case"escape":return A.Escape;case"strong":return A.Strong;case"weak":return A.Weak;default:return A.Strong}}A.from=j}(g||(e.ShellQuoting=g={}));var E;(function(A){A.defaults={cwd:"${workspaceFolder}"}})(E||(e.CommandOptions=E={}));var T;(function(A){A[A.Always=1]="Always",A[A.Silent=2]="Silent",A[A.Never=3]="Never"})(T||(e.RevealKind=T={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"silent":return A.Silent;case"never":return A.Never;default:return A.Always}}A.fromString=j}(T||(e.RevealKind=T={}));var y;(function(A){A[A.Never=1]="Never",A[A.OnProblem=2]="OnProblem",A[A.Always=3]="Always"})(y||(e.RevealProblemKind=y={})),function(A){function j(K){switch(K.toLowerCase()){case"always":return A.Always;case"never":return A.Never;case"onproblem":return A.OnProblem;default:return A.OnProblem}}A.fromString=j}(y||(e.RevealProblemKind=y={}));var l;(function(A){A[A.Shared=1]="Shared",A[A.Dedicated=2]="Dedicated",A[A.New=3]="New"})(l||(e.PanelKind=l={})),function(A){function j(K){switch(K.toLowerCase()){case"shared":return A.Shared;case"dedicated":return A.Dedicated;case"new":return A.New;default:return A.Shared}}A.fromString=j}(l||(e.PanelKind=l={}));var w;(function(A){A.defaults={echo:!0,reveal:T.Always,revealProblems:y.Never,focus:!1,panel:l.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var m;(function(A){A[A.Shell=1]="Shell",A[A.Process=2]="Process",A[A.CustomExecution=3]="CustomExecution"})(m||(e.RuntimeType=m={})),function(A){function j(re){switch(re.toLowerCase()){case"shell":return A.Shell;case"process":return A.Process;case"customExecution":return A.CustomExecution;default:return A.Process}}A.fromString=j;function K(re){switch(re){case A.Shell:return"shell";case A.Process:return"process";case A.CustomExecution:return"customExecution";default:return"process"}}A.toString=K}(m||(e.RuntimeType=m={}));var s;(function(A){function j(K){return N.$8f(K)?K:K.value}A.value=j})(s||(e.CommandString=s={}));var o;(function(A){A.Clean={_id:"clean",isDefault:!1},A.Build={_id:"build",isDefault:!1},A.Rebuild={_id:"rebuild",isDefault:!1},A.Test={_id:"test",isDefault:!1};function j(re){return re===A.Clean._id||re===A.Build._id||re===A.Rebuild._id||re===A.Test._id}A.is=j;function K(re){if(re!==void 0)return N.$8f(re)?j(re)?{_id:re,isDefault:!1}:void 0:re}A.from=K})(o||(e.TaskGroup=o={}));var r;(function(A){A[A.Global=1]="Global",A[A.Workspace=2]="Workspace",A[A.Folder=3]="Folder"})(r||(e.TaskScope=r={}));var t;(function(A){A.Workspace="workspace",A.Extension="extension",A.InMemory="inMemory",A.WorkspaceFile="workspaceFile",A.User="user";function j(K){switch(K){case A.User:return 2;case A.WorkspaceFile:return 5;default:return 6}}A.toConfigurationTarget=j})(t||(e.TaskSourceKind=t={}));var n;(function(A){A.parallel="parallel",A.sequence="sequence"})(n||(e.DependsOrder=n={}));var c;(function(A){A[A.default=1]="default",A[A.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var h;(function(A){A.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(h||(e.RunOptions=h={}));class i{constructor(j,K,re,ae,we,Ie){this._label="",this._id=j,K&&(this._label=K),re&&(this.type=re),this.runOptions=ae,this.configurationProperties=we,this._source=Ie}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,K=!1){if(j===void 0)return!1;if(N.$8f(j))return j===this._label||j===this.configurationProperties.identifier||K&&j===this._id;const re=this.getDefinition(!0);return re!==void 0&&re._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$9H=i;class $ extends i{constructor(j,K,re,ae,we,Ie,de,me){super(j,re,void 0,de,me,K),this.command={},this._source=K,this.hasDefinedMatchers=Ie,we&&(this.command=we)}clone(){return new $(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case m.Shell:K="shell";break;case m.Process:K="process";break;case m.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(j){return j instanceof $}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===t.User?e.$5H:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(K+=this._source.kind);const re={type:e.$8H,folder:j,id:K};return JSON.stringify(re)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$6g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new $(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$0H=$;class a extends i{constructor(j,K,re,ae,we,Ie,de){super(j,re,ae,Ie,de,K),this._source=K,this.configures=we}static is(j){return j instanceof a}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?R.$6g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===t.User?e.$5H:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let K=this.configurationProperties.identifier;this._source.kind!==t.Workspace&&(K+=this._source.kind);const re={type:e.$8H,folder:j,id:K};return JSON.stringify(re)}}e.$$H=a;class v extends i{constructor(j,K,re,ae,we,Ie,de,me,Me){super(j,re,ae,me,Me,K),this.defines=we,this.hasDefinedMatchers=de,this.command=Ie,this.icon=Me.icon,this.hide=Me.hide}clone(){return new v(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof v}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new v(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$_H=v;class d extends i{constructor(j,K,re,ae,we,Ie){super(j,re,ae,we,Ie,K),this._source=K}clone(){return new d(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof d}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new d(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$aI=d;var C;(function(A){A[A.Process=1]="Process",A[A.Terminal=2]="Terminal"})(C||(e.ExecutionEngine=C={})),function(A){A._default=A.Terminal}(C||(e.ExecutionEngine=C={}));var u;(function(A){A[A.V0_1_0=1]="V0_1_0",A[A.V2_0_0=2]="V2_0_0"})(u||(e.JsonSchemaVersion=u={}));class D{constructor(j){this.c=new Map;for(let K=0;K<j.length;K++)this.c.set(j[K].uri.toString(),K)}compare(j,K){const re=j.getWorkspaceFolder(),ae=K.getWorkspaceFolder();if(re&&ae){let we=this.c.get(re.uri.toString());we=we===void 0?0:we+1;let Ie=this.c.get(ae.uri.toString());return Ie=Ie===void 0?0:Ie+1,we===Ie?j._label.localeCompare(K._label):we-Ie}else return!re&&ae?-1:re&&!ae?1:0}}e.$bI=D;var f;(function(A){A.DependsOnStarted="dependsOnStarted",A.AcquiredInput="acquiredInput",A.Start="start",A.ProcessStarted="processStarted",A.Active="active",A.Inactive="inactive",A.Changed="changed",A.Terminated="terminated",A.ProcessEnded="processEnded",A.End="end"})(f||(e.TaskEventKind=f={}));var k;(function(A){A.SingleRun="singleRun",A.Background="background"})(k||(e.TaskRunType=k={}));var b;(function(A){A[A.System=0]="System",A[A.User=1]="User",A[A.FolderOpen=2]="FolderOpen",A[A.ConfigurationChange=3]="ConfigurationChange",A[A.Reconnect=4]="Reconnect"})(b||(e.TaskRunSource=b={}));var P;(function(A){function j(me){return{taskId:me._id,taskName:me.configurationProperties.name,runType:me.configurationProperties.isBackground?"background":"singleRun",group:me.configurationProperties.group,__task:me}}function K(me,Me,ce){return{...j(me),kind:"start",terminalId:Me,resolvedVariables:ce}}A.start=K;function re(me,Me,ce){return{...j(me),kind:"processStarted",terminalId:Me,processId:ce}}A.processStarted=re;function ae(me,Me,ce){return{...j(me),kind:"processEnded",terminalId:Me,exitCode:ce}}A.processEnded=ae;function we(me,Me,ce){return{...j(me),kind:"terminated",exitReason:ce,terminalId:Me}}A.terminated=we;function Ie(me,Me,ce){return{...j(Me),kind:me,terminalId:ce}}A.general=Ie;function de(){return{kind:"changed"}}A.changed=de})(P||(e.TaskEvent=P={}));var I;(function(A){function j(re){const ae=Object.keys(re).sort();let we="";for(const Ie of ae){let de=re[Ie];de instanceof Object?de=j(de):typeof de=="string"&&(de=de.replace(/,/g,",,")),we+=Ie+","+de+","}return we}function K(re){const we={_key:j(re),type:re.taskType};return Object.assign(we,re),we}A.create=K})(I||(e.KeyedTaskIdentifier=I={}));var W;(function(A){A.AutoDetect="task.autoDetect",A.SaveBeforeRun="task.saveBeforeRun",A.ShowDecorations="task.showDecorations",A.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",A.SlowProviderWarning="task.slowProviderWarning",A.QuickOpenHistory="task.quickOpen.history",A.QuickOpenDetail="task.quickOpen.detail",A.QuickOpenSkip="task.quickOpen.skip",A.QuickOpenShowAll="task.quickOpen.showAll",A.AllowAutomaticTasks="task.allowAutomaticTasks",A.Reconnection="task.reconnection",A.VerboseLogging="task.verboseLogging"})(W||(e.TaskSettingId=W={}));var V;(function(A){A.Tasks="tasks",A.SuppressTaskName="tasks.suppressTaskName",A.Windows="tasks.windows",A.Osx="tasks.osx",A.Linux="tasks.linux",A.ShowOutput="tasks.showOutput",A.IsShellCommand="tasks.isShellCommand",A.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var q;(function(A){function j(K,re){const ae=p.$4H.get(K.type);if(ae===void 0){const me=O.$2n(K);return delete me._key,I.create(me)}const we=Object.create(null);we.type=ae.taskType;const Ie=new Set;ae.required.forEach(me=>Ie.add(me));const de=ae.properties;for(const me of Object.keys(de)){const Me=K[me];if(Me!=null)we[me]=Me;else if(Ie.has(me)){const ce=de[me];if(ce.default!==void 0)we[me]=O.$2n(ce.default);else switch(ce.type){case"boolean":we[me]=!1;break;case"number":case"integer":we[me]=0;break;case"string":we[me]="";break;default:re.error(S.localize(1,null,JSON.stringify(K,void 0,0),me));return}}}return I.create(we)}A.createTaskIdentifier=j})(q||(e.TaskDefinition=q={}))}),define(Ce[231],Ae([1,0,14]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=e.$x_b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((M,p)=>{this.b=M,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(M){this.f||this.h||(this.f=!0,this.g=M,this.a&&this.b(M))}resolveErr(M){this.f||this.h||(this.h=!0,this.i=M,this.a?this.d(M):(0,S.$1)(M))}then(M,p){return this.j().then(M,p)}catch(M){return this.j().then(void 0,M)}finally(M){return this.j().finally(M)}}e.$x_b=N;class R extends N{constructor(){super(),this.h=!0,this.i=new S.$5}}e.$y_b=R}),define(Ce[34],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uw=e.$rw=void 0,e.$sw=R,e.$tw=O;class S{static{this.count=0}constructor(g){this._proxyIdentifierBrand=void 0,this.sid=g,this.nid=++S.count}}e.$rw=S;const N=[];function R(p){const g=new S(p);return N[g.nid]=g,g}function O(p){return N[p].sid}class M{constructor(g){this.value=g}}e.$uw=M}),define(Ce[4],Ae([1,0,34]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ZM=e.$YM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$XM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var R;(function(s){s[s.UnknownInput=0]="UnknownInput",s[s.TextInput=1]="TextInput",s[s.TextDiffInput=2]="TextDiffInput",s[s.TextMergeInput=3]="TextMergeInput",s[s.NotebookInput=4]="NotebookInput",s[s.NotebookDiffInput=5]="NotebookDiffInput",s[s.CustomEditorInput=6]="CustomEditorInput",s[s.WebviewEditorInput=7]="WebviewEditorInput",s[s.TerminalEditorInput=8]="TerminalEditorInput",s[s.InteractiveEditorInput=9]="InteractiveEditorInput",s[s.ChatEditorInput=10]="ChatEditorInput",s[s.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(R||(e.TabInputKind=R={}));var O;(function(s){s[s.TAB_OPEN=0]="TAB_OPEN",s[s.TAB_CLOSE=1]="TAB_CLOSE",s[s.TAB_UPDATE=2]="TAB_UPDATE",s[s.TAB_MOVE=3]="TAB_MOVE"})(O||(e.TabModelOperationKind=O={}));var M;(function(s){s[s.Editable=0]="Editable",s[s.SupportsHotExit=1]="SupportsHotExit"})(M||(e.WebviewEditorCapabilities=M={}));var p;(function(s){s[s.Int8Array=1]="Int8Array",s[s.Uint8Array=2]="Uint8Array",s[s.Uint8ClampedArray=3]="Uint8ClampedArray",s[s.Int16Array=4]="Int16Array",s[s.Uint16Array=5]="Uint16Array",s[s.Int32Array=6]="Int32Array",s[s.Uint32Array=7]="Uint32Array",s[s.Float32Array=8]="Float32Array",s[s.Float64Array=9]="Float64Array",s[s.BigInt64Array=10]="BigInt64Array",s[s.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var g;(function(s){s[s.Text=1]="Text",s[s.Error=2]="Error",s[s.Rich=3]="Rich"})(g||(e.CellOutputKind=g={}));var E;(function(s){s[s.Default=0]="Default",s[s.InCenter=1]="InCenter",s[s.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",s[s.AtTop=3]="AtTop"})(E||(e.NotebookEditorRevealType=E={}));var T;(function(s){s[s.None=0]="None",s[s.Process=1]="Process",s[s.Output=2]="Output"})(T||(e.CandidatePortSource=T={}));class y{static{this.a=0}static mixin(o){return o._id=y.a++,o}}e.$XM=y;var l;(function(s){s.label="a",s.kind="b",s.detail="c",s.documentation="d",s.sortText="e",s.filterText="f",s.preselect="g",s.insertText="h",s.insertTextRules="i",s.range="j",s.commitCharacters="k",s.additionalTextEdits="l",s.kindModifier="m",s.commandIdent="n",s.commandId="o",s.commandArguments="p"})(l||(e.ISuggestDataDtoField=l={}));var w;(function(s){s.defaultRanges="a",s.completions="b",s.isIncomplete="c",s.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var m;(function(s){s[s.Workspace=0]="Workspace",s[s.TextDocument=1]="TextDocument"})(m||(e.ExtHostTestingResource=m={})),e.$YM={MainThreadAuthentication:(0,S.$sw)("MainThreadAuthentication"),MainThreadBulkEdits:(0,S.$sw)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,S.$sw)("MainThreadLanguageModels"),MainThreadChatAgents2:(0,S.$sw)("MainThreadChatAgents2"),MainThreadChatVariables:(0,S.$sw)("MainThreadChatVariables"),MainThreadClipboard:(0,S.$sw)("MainThreadClipboard"),MainThreadCommands:(0,S.$sw)("MainThreadCommands"),MainThreadComments:(0,S.$sw)("MainThreadComments"),MainThreadConfiguration:(0,S.$sw)("MainThreadConfiguration"),MainThreadConsole:(0,S.$sw)("MainThreadConsole"),MainThreadDebugService:(0,S.$sw)("MainThreadDebugService"),MainThreadDecorations:(0,S.$sw)("MainThreadDecorations"),MainThreadDiagnostics:(0,S.$sw)("MainThreadDiagnostics"),MainThreadDialogs:(0,S.$sw)("MainThreadDiaglogs"),MainThreadDocuments:(0,S.$sw)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,S.$sw)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,S.$sw)("MainThreadTextEditors"),MainThreadEditorInsets:(0,S.$sw)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,S.$sw)("MainThreadEditorTabs"),MainThreadErrors:(0,S.$sw)("MainThreadErrors"),MainThreadTreeViews:(0,S.$sw)("MainThreadTreeViews"),MainThreadDownloadService:(0,S.$sw)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,S.$sw)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,S.$sw)("MainThreadLanguages"),MainThreadLogger:(0,S.$sw)("MainThreadLogger"),MainThreadMessageService:(0,S.$sw)("MainThreadMessageService"),MainThreadOutputService:(0,S.$sw)("MainThreadOutputService"),MainThreadProgress:(0,S.$sw)("MainThreadProgress"),MainThreadQuickDiff:(0,S.$sw)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,S.$sw)("MainThreadQuickOpen"),MainThreadStatusBar:(0,S.$sw)("MainThreadStatusBar"),MainThreadSecretState:(0,S.$sw)("MainThreadSecretState"),MainThreadStorage:(0,S.$sw)("MainThreadStorage"),MainThreadSpeech:(0,S.$sw)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,S.$sw)("MainThreadTelemetry"),MainThreadTerminalService:(0,S.$sw)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,S.$sw)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,S.$sw)("MainThreadWebviews"),MainThreadWebviewPanels:(0,S.$sw)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,S.$sw)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,S.$sw)("MainThreadCustomEditors"),MainThreadUrls:(0,S.$sw)("MainThreadUrls"),MainThreadUriOpeners:(0,S.$sw)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,S.$sw)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,S.$sw)("MainThreadWorkspace"),MainThreadFileSystem:(0,S.$sw)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,S.$sw)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,S.$sw)("MainThreadExtensionService"),MainThreadSCM:(0,S.$sw)("MainThreadSCM"),MainThreadSearch:(0,S.$sw)("MainThreadSearch"),MainThreadShare:(0,S.$sw)("MainThreadShare"),MainThreadTask:(0,S.$sw)("MainThreadTask"),MainThreadWindow:(0,S.$sw)("MainThreadWindow"),MainThreadLabelService:(0,S.$sw)("MainThreadLabelService"),MainThreadNotebook:(0,S.$sw)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,S.$sw)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,S.$sw)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,S.$sw)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,S.$sw)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,S.$sw)("MainThreadInteractive"),MainThreadInlineChat:(0,S.$sw)("MainThreadInlineChatShape"),MainThreadTheming:(0,S.$sw)("MainThreadTheming"),MainThreadTunnelService:(0,S.$sw)("MainThreadTunnelService"),MainThreadManagedSockets:(0,S.$sw)("MainThreadManagedSockets"),MainThreadTimeline:(0,S.$sw)("MainThreadTimeline"),MainThreadTesting:(0,S.$sw)("MainThreadTesting"),MainThreadLocalization:(0,S.$sw)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,S.$sw)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,S.$sw)("MainThreadAiEmbeddingVector")},e.$ZM={ExtHostCommands:(0,S.$sw)("ExtHostCommands"),ExtHostConfiguration:(0,S.$sw)("ExtHostConfiguration"),ExtHostDiagnostics:(0,S.$sw)("ExtHostDiagnostics"),ExtHostDebugService:(0,S.$sw)("ExtHostDebugService"),ExtHostDecorations:(0,S.$sw)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,S.$sw)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,S.$sw)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,S.$sw)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,S.$sw)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,S.$sw)("ExtHostEditors"),ExtHostTreeViews:(0,S.$sw)("ExtHostTreeViews"),ExtHostFileSystem:(0,S.$sw)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,S.$sw)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,S.$sw)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,S.$sw)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,S.$sw)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,S.$sw)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,S.$sw)("ExtHostQuickDiff"),ExtHostStatusBar:(0,S.$sw)("ExtHostStatusBar"),ExtHostShare:(0,S.$sw)("ExtHostShare"),ExtHostExtensionService:(0,S.$sw)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,S.$sw)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,S.$sw)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,S.$sw)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,S.$sw)("ExtHostSCM"),ExtHostSearch:(0,S.$sw)("ExtHostSearch"),ExtHostTask:(0,S.$sw)("ExtHostTask"),ExtHostWorkspace:(0,S.$sw)("ExtHostWorkspace"),ExtHostWindow:(0,S.$sw)("ExtHostWindow"),ExtHostWebviews:(0,S.$sw)("ExtHostWebviews"),ExtHostWebviewPanels:(0,S.$sw)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,S.$sw)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,S.$sw)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,S.$sw)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,S.$sw)("ExtHostEditorTabs"),ExtHostProgress:(0,S.$sw)("ExtHostProgress"),ExtHostComments:(0,S.$sw)("ExtHostComments"),ExtHostSecretState:(0,S.$sw)("ExtHostSecretState"),ExtHostStorage:(0,S.$sw)("ExtHostStorage"),ExtHostUrls:(0,S.$sw)("ExtHostUrls"),ExtHostUriOpeners:(0,S.$sw)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,S.$sw)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,S.$sw)("ExtHostOutputService"),ExtHostLabelService:(0,S.$sw)("ExtHostLabelService"),ExtHostNotebook:(0,S.$sw)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,S.$sw)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,S.$sw)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,S.$sw)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,S.$sw)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,S.$sw)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,S.$sw)("ExtHostInteractive"),ExtHostInlineChat:(0,S.$sw)("ExtHostInlineChatShape"),ExtHostChatAgents2:(0,S.$sw)("ExtHostChatAgents"),ExtHostChatVariables:(0,S.$sw)("ExtHostChatVariables"),ExtHostChatProvider:(0,S.$sw)("ExtHostChatProvider"),ExtHostSpeech:(0,S.$sw)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,S.$sw)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,S.$sw)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,S.$sw)("ExtHostTheming"),ExtHostTunnelService:(0,S.$sw)("ExtHostTunnelService"),ExtHostManagedSockets:(0,S.$sw)("ExtHostManagedSockets"),ExtHostAuthentication:(0,S.$sw)("ExtHostAuthentication"),ExtHostTimeline:(0,S.$sw)("ExtHostTimeline"),ExtHostTesting:(0,S.$sw)("ExtHostTesting"),ExtHostTelemetry:(0,S.$sw)("ExtHostTelemetry"),ExtHostLocalization:(0,S.$sw)("ExtHostLocalization")}}),define(Ce[78],Ae([1,0,3,13,4,16]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vkc=e.$Ukc=e.$Tkc=void 0,e.$Tkc=(0,S.$vi)("IExtHostApiDeprecationService");let M=class{constructor(g,E){this.c=E,this.a=new Set,this.b=g.getProxy(R.$YM.MainThreadTelemetry)}report(g,E,T){const y=this.d(g,E);this.a.has(y)||(this.a.add(y),E.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${g}' is deprecated. ${T}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:E.identifier.value,apiId:g}))}d(g,E){return`${g}-${E.identifier.value}`}};e.$Ukc=M,e.$Ukc=M=Je([We(0,O.$lP),We(1,N.$2j)],M),e.$Vkc=Object.freeze(new class{report(p,g,E){}})}),define(Ce[232],Ae([1,0,4]),function(ge,e,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9kc=void 0;class N{constructor(O){const M=O.getProxy(S.$YM.MainThreadClipboard);this.value=Object.freeze({readText(){return M.$readText()},writeText(p){return M.$writeText(p)}})}}e.$9kc=N}),define(Ce[233],Ae([1,0,25,4,27,16]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=void 0;let M=class{constructor(T,y){this.a=T.getProxy(N.$YM.MainThreadConsole),this.b=y.consoleForward.includeStack,this.c=y.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(T,y){const l=this,w=console[T];Object.defineProperty(console,T,{set:()=>{},get:()=>function(){l.e(T,y,w,arguments)}})}e(T,y,l,w){this.a.$logExtensionHostMessage({type:"__$console",severity:y,arguments:g(w,this.b)}),this.c&&this.f(T,l,w)}};e.$3mc=M,e.$3mc=M=Je([We(0,O.$lP),We(1,R.$BP)],M);const p=1e5;function g(E,T){const y=[];if(E.length)for(let l=0;l<E.length;l++){let w=E[l];if(typeof w>"u")w="undefined";else if(w instanceof Error){const m=w;m.stack?w=m.stack:w=m.toString()}y.push(w)}if(T){const l=new Error().stack;l&&y.push({__$stack:l.split(`
`).slice(3).join(`
`)})}try{const l=(0,S.$7n)(y);return l.length>p?"Output omitted for a large object that exceeds the limits":l}catch(l){return`Output omitted for an object that cannot be inspected ('${l.toString()}')`}}}),define(Ce[234],Ae([1,0,2,4,26]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class O{constructor(p){this.a=p.getProxy(N.$YM.MainThreadDialogs)}showOpenDialog(p,g){return g?.allowUIResources&&(0,R.$GG)(p,"showLocal"),this.a.$showOpenDialog(g).then(E=>E?E.map(T=>S.URI.revive(T)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(g=>g?S.URI.revive(g):void 0)}}e.$6lc=O}),define(Ce[235],Ae([1,0,6,4]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=void 0;class R{constructor(M){this.b=0,this.a=M.getProxy(N.$YM.MainThreadLabelService)}$registerResourceLabelFormatter(M){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,M),(0,S.$Tc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$nmc=R}),define(Ce[79],Ae([1,0,21,15,2,3,13,4,27,16]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Olc=e.$Nlc=void 0;let T=class{constructor(l,w,m){this.f=m,this.d=new Map,this.a=w.getProxy(p.$YM.MainThreadLocalization),this.b=l.environment.appLanguage,this.c=this.b===S.$g}getMessage(l,w){const{message:m,args:s,comment:o}=w;if(this.c)return(0,N.$9e)(m,s??{});let r=m;o&&o.length>0&&(r+=`/${Array.isArray(o)?o.join(""):o}`);const t=this.d.get(l)?.contents[r];return t||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${r}`),(0,N.$9e)(t??m,s??{})}getBundle(l){return this.d.get(l)?.contents}getBundleUri(l){return this.d.get(l)?.uri}async initializeLocalizedMessages(l){if(this.c||!l.l10n&&!l.isBuiltin||this.d.has(l.identifier.value))return;let w;const m=await this.g(l);if(!m){this.f.error(`No bundle location found for extension ${l.identifier.value}`);return}try{const s=await this.a.$fetchBundleContents(m),o=JSON.parse(s);w=l.isBuiltin?o.contents?.bundle:o}catch(s){this.f.error(`Failed to load translations for ${l.identifier.value} from ${m}: ${s.message}`);return}w&&this.d.set(l.identifier.value,{contents:w,uri:m})}async g(l){if(l.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(l.identifier.value,this.b);return R.URI.revive(w)}return l.l10n?R.URI.joinPath(l.extensionLocation,l.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$Nlc=T,e.$Nlc=T=Je([We(0,g.$BP),We(1,E.$lP),We(2,M.$2j)],T),e.$Olc=(0,O.$vi)("IExtHostLocalizationService")}),define(Ce[236],Ae([1,0,13,4,27,16,2,53]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2mc=void 0;let g=class extends S.$ak{constructor(y,l){super(l.logLevel,l.logsLocation,l.loggers.map(w=>(0,p.$5h)(w))),this.r=y.getProxy(N.$YM.MainThreadLogger)}$setLogLevel(y,l){l?this.setLogLevel(M.URI.revive(l),y):this.setLogLevel(y)}setVisibility(y,l){super.setVisibility(y,l),this.r.$setVisibility(y,l)}s(y,l,w){return new E(this.r,y,l,w)}};e.$2mc=g,e.$2mc=g=Je([We(0,O.$lP),We(1,R.$BP)],g);class E extends S.$8j{constructor(y,l,w,m){super(m?.logLevel==="always"),this.r=y,this.s=l,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(l,m).then(()=>{this.u(this.n),this.m=!0})}g(y,l){const w=[[y,l]];this.m?this.u(w):this.n.push(...w)}u(y){this.r.$log(this.s,y)}flush(){this.r.$flush(this.s)}}}),define(Ce[80],Ae([1,0,4,3,6,16,22]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qlc=e.$Plc=void 0,e.$Plc=(0,N.$vi)("IExtHostManagedSockets");let p=class{constructor(y){this.b=0,this.c=null,this.d=new Map,this.a=y.getProxy(S.$YM.MainThreadManagedSockets)}setFactory(y,l){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new g(y,l),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(y){if(!this.c||this.c.socketFactoryId!==y)throw new Error(`No socket factory with id ${y}`);const l=++this.b,w=await this.c.makeConnection(),m=new R.$Uc;return this.d.set(l,new E(l,w,m)),m.add((0,R.$Tc)(()=>this.d.delete(l))),m.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(l),m.dispose()})),m.add(w.onDidClose(s=>{this.a.$onDidManagedSocketClose(l,s?.stack??s?.message),m.dispose()})),m.add(w.onDidReceiveMessage(s=>this.a.$onDidManagedSocketHaveData(l,M.$Fe.wrap(s)))),l}$remoteSocketWrite(y,l){this.d.get(y)?.actual.send(l.buffer)}$remoteSocketEnd(y){const l=this.d.get(y);l&&(l.actual.end(),l.dispose())}async $remoteSocketDrain(y){await this.d.get(y)?.actual.drain?.()}};e.$Qlc=p,e.$Qlc=p=Je([We(0,O.$lP)],p);class g{constructor(y,l){this.socketFactoryId=y,this.makeConnection=l}}class E extends R.$Vc{constructor(y,l,w){super(),this.socketId=y,this.actual=l,this.B(w)}}}),define(Ce[237],Ae([1,0,4,13,26]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=void 0;function O(p){return p&&p.title}let M=class{constructor(g,E){this.b=E,this.a=g.getProxy(S.$YM.MainThreadMessageService)}showMessage(g,E,T,y,l){const w={source:{identifier:g.identifier,label:g.displayName||g.name}};let m;typeof y=="string"||O(y)?m=[y,...l]:(w.modal=y?.modal,w.useCustom=y?.useCustom,w.detail=y?.detail,m=l),w.useCustom&&(0,R.$GG)(g,"resolvers");const s=[];let o=!1;for(let r=0;r<m.length;r++){const t=m[r];if(typeof t=="string")s.push({title:t,handle:r,isCloseAffordance:!1});else if(typeof t=="object"){const{title:n,isCloseAffordance:c}=t;s.push({title:n,isCloseAffordance:!!c,handle:r}),c&&(o?this.b.warn(`[${g.identifier}] Only one message item can have 'isCloseAffordance':`,t):o=!0)}else this.b.warn(`[${g.identifier}] Invalid message item:`,t)}return this.a.$showMessage(E,T,w,s).then(r=>{if(typeof r=="number")return m[r]})}};e.$pmc=M,e.$pmc=M=Je([We(1,N.$2j)],M)}),define(Ce[238],Ae([1,0,6,17,2,26,4]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=void 0;class p{constructor(E){this.b=new Map,this.a=E.getProxy(M.$YM.MainThreadProfileContentHandlers)}registerProfileContentHandler(E,T,y){if((0,O.$GG)(E,"profileContentHandlers"),this.b.has(T))throw new Error(`Handler with id '${T}' already registered`);return this.b.set(T,y),this.a.$registerProfileContentHandler(T,y.name,y.description,E.identifier.value),(0,S.$Tc)(()=>{this.b.delete(T),this.a.$unregisterProfileContentHandler(T)})}async $saveProfile(E,T,y,l){const w=this.b.get(E);if(!w)throw new Error(`Unknown handler with id: ${E}`);return w.saveProfile(T,y,l)}async $readProfile(E,T,y){const l=this.b.get(E);if(!l)throw new Error(`Unknown handler with id: ${E}`);return l.readProfile((0,N.$8f)(T)?T:R.URI.revive(T),y)}}e.$ymc=p}),define(Ce[81],Ae([1,0,4,5,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Llc=e.$Klc=void 0;class O{constructor(p){this.b=new N.$ee,this.onDidChangePassword=this.b.event,this.a=p.getProxy(S.$YM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,g){return this.a.$getPassword(p,g)}store(p,g,E){return this.a.$setPassword(p,g,E)}delete(p,g){return this.a.$deletePassword(p,g)}}e.$Klc=O,e.$Llc=(0,R.$vi)("IExtHostSecretState")}),define(Ce[239],Ae([1,0,24,6,4]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class O{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.b=p.getProxy(R.$YM.MainThreadSpeech)}async $createSpeechToTextSession(p,g,E){const T=this.c.get(p);if(!T)return;const y=new N.$Uc,l=new S.$pe;this.d.set(g,l);const w=y.add(T.provideSpeechToTextSession(l.token,E?{language:E}:void 0));y.add(w.onDidChange(m=>{l.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(g,m)})),y.add(l.token.onCancellationRequested(()=>y.dispose()))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createKeywordRecognitionSession(p,g){const E=this.c.get(p);if(!E)return;const T=new N.$Uc,y=new S.$pe;this.d.set(g,y);const l=T.add(E.provideKeywordRecognitionSession(y.token));T.add(l.onDidChange(w=>{y.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(g,w)})),T.add(y.token.onCancellationRequested(()=>T.dispose()))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,g,E){const T=O.a++;return this.c.set(T,E),this.b.$registerProvider(T,g,{extension:p,displayName:p.value}),(0,N.$Tc)(()=>{this.b.$unregisterProvider(T),this.c.delete(T)})}}e.$Fmc=O}),define(Ce[82],Ae([1,0,4,5,3]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Blc=e.$Alc=void 0;class O{constructor(p,g){this.c=g,this.b=new N.$ee,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(S.$YM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,g){this.a.$registerExtensionStorageKeysToSync(p,g)}async initializeExtensionStorage(p,g,E){const T=await this.a.$initializeExtensionStorage(p,g);let y;return T&&(y=this.d(p,g,T)),y||E}setValue(p,g,E){return this.a.$setValue(p,g,E)}$acceptValue(p,g,E){const T=this.d(p,g,E);T&&this.b.fire({shared:p,key:g,value:T})}d(p,g,E){try{return JSON.parse(E)}catch(T){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${g}, global: ${p}): ${T}`)}}}e.$Alc=O,e.$Blc=(0,R.$vi)("IExtHostStorage")}),define(Ce[240],Ae([1,0,6,12,2,4]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=void 0;class M{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(g){this.c=new Map,this.b=g.getProxy(O.$YM.MainThreadUriOpeners)}registerExternalUriOpener(g,E,T,y){if(this.c.has(E))throw new Error(`Opener with id '${E}' already registered`);const l=y.schemes.find(w=>!M.a.has(w));if(l)throw new Error(`Scheme '${l}' is not supported. Only http and https are currently supported.`);return this.c.set(E,T),this.b.$registerUriOpener(E,y.schemes,g,y.label),(0,S.$Tc)(()=>{this.c.delete(E),this.b.$unregisterUriOpener(E)})}async $canOpenUri(g,E,T){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener with id: ${g}`);const l=R.URI.revive(E);return y.canOpenExternalUri(l,T)}async $openUri(g,E,T){const y=this.c.get(g);if(!y)throw new Error(`Unknown opener id: '${g}'`);return y.openExternalUri(R.URI.revive(E.resolvedUri),{sourceUri:R.URI.revive(E.sourceUri)},T)}}e.$Vmc=M}),define(Ce[241],Ae([1,0,4,2,6,14,20]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wmc=void 0;class p{static{this.a=0}constructor(E){this.c=new M.$Rm,this.d=new Map,this.b=E.getProxy(S.$YM.MainThreadUrls)}registerUriHandler(E,T){const y=E.identifier;if(this.c.has(y))throw new Error(`Protocol handler already registered for extension ${y}`);const l=p.a++;return this.c.add(y),this.d.set(l,T),this.b.$registerUriHandler(l,y,E.displayName||E.name),(0,R.$Tc)(()=>{this.c.delete(y),this.d.delete(l),this.b.$unregisterUriHandler(l)})}$handleExternalUri(E,T){const y=this.d.get(E);if(!y)return Promise.resolve(void 0);try{y.handleUri(N.URI.revive(T))}catch(l){(0,O.$1)(l)}return Promise.resolve(void 0)}async createAppUri(E){return N.URI.revive(await this.b.$createAppUri(E))}}e.$Wmc=p}),define(Ce[63],Ae([1,0,5,6,12,25,2,188,210,76,4]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nlc=e.$llc=void 0,e.$mlc=l,e.$olc=s,e.$plc=o;class y{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,h,i,$,a,v,d){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new S.$ee,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new S.$ee,this._onDidDispose=this.#h.event,this.#e=c,this.#t=h,this.#o=i,this.#n=$,this.#s=a,this.#r=v,this.#l=l(v),this.#d=w(v),this.#i=d}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,E.$vyb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===R.Schemas.https||c.scheme===R.Schemas.http){let h=c.toString();return h.endsWith("/")||(h+="/"),h+" "+E.$uyb}return E.$uyb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),O.$6n(this.#o,c)||this.#t.$setOptions(this.#e,o(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const h=(0,g.$Fob)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,h.message,...h.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const h=this.#r.extensionLocation?.scheme===R.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===R.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,v,d,C,u)=>{const D=M.URI.from({scheme:d||"file",path:decodeURIComponent(C)}),f=(0,E.$vyb)(D,{isRemote:h,authority:i}).toString();return`${a}${f}${u}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,($,a,v,d,C,u)=>{const D=M.URI.from({scheme:d||"file",path:decodeURIComponent(C)}),f=(0,E.$vyb)(D,{isRemote:h,authority:i}).toString();return`${a}${f}${u}`})}}e.$llc=y;function l(n){try{const c=(0,p.$Hp)((0,p.$Gp)(n.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(n){try{const c=(0,p.$Hp)((0,p.$Gp)(n.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class m extends N.$Vc{constructor(c,h,i,$,a){super(),this.c=h,this.f=i,this.g=$,this.h=a,this.b=new Map,this.a=c.getProxy(T.$YM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,h,i){const $=this.j(c);if($){const{message:a}=(0,g.$Gob)(h,i.value);$._onMessageEmitter.fire(a)}}$onMissingCsp(c,h){this.g.warn(`${h} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,h,i){const $=new y(c,this.a,r(h),this.c,this.f,i,this.h);this.b.set(c,$);const a=$._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return $}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$nlc=m;function s(n){return{id:n.identifier,location:n.extensionLocation}}function o(n,c,h){return{enableCommandUris:h.enableCommandUris,enableScripts:h.enableScripts,enableForms:h.enableForms,portMapping:h.portMapping,localResourceRoots:h.localResourceRoots||t(n,c)}}function r(n){return{enableCommandUris:n.enableCommandUris,enableScripts:n.enableScripts,enableForms:n.enableForms,portMapping:n.portMapping,localResourceRoots:n.localResourceRoots?.map(c=>M.URI.from(c))}}function t(n,c){return[...(c?.getWorkspaceFolders()||[]).map(h=>h.uri),n.extensionLocation]}}),define(Ce[109],Ae([1,0,5,12,15,2,3,16,4]),function(ge,e,S,N,R,O,M,p,g){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;let T=class{static{E=this}static{this.a={focused:!0,active:!0}}getState(){const l=this.d;return{get focused(){return l.focused},get active(){return l.active}}}constructor(l){this.c=new S.$ee,this.onDidChangeWindowState=this.c.event,this.d=E.a,this.b=l.getProxy(g.$YM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:m})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",m)})}$onDidChangeWindowFocus(l){this.onDidChangeWindowProperty("focused",l)}$onDidChangeWindowActive(l){this.onDidChangeWindowProperty("active",l)}onDidChangeWindowProperty(l,w){w!==this.d[l]&&(this.d={...this.d,[l]:w},this.c.fire(this.d))}openUri(l,w){let m;if(typeof l=="string"){m=l;try{l=O.URI.parse(l)}catch{return Promise.reject(`Invalid uri - '${l}'`)}}return(0,R.$7e)(l.scheme)?Promise.reject("Invalid scheme - cannot be empty"):l.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${l.scheme}'`):this.b.$openUri(l,m,w)}async asExternalUri(l,w){if((0,R.$7e)(l.scheme))return Promise.reject("Invalid scheme - cannot be empty");const m=await this.b.$asExternalUri(l,w);return O.URI.from(m)}};e.$Ymc=T,e.$Ymc=T=E=Je([We(0,p.$lP)],T),e.$Zmc=(0,M.$vi)("IExtHostWindow")}),define(Ce[242],Ae([1,0,233,27,16]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$oc=void 0;let O=class extends S.$3mc{constructor(p,g){super(p,g)}f(p,g,E){g.apply(console,E)}};e.$$oc=O,e.$$oc=O=Je([We(0,R.$lP),We(1,N.$BP)],O)}),define(Ce[243],Ae([1,0,11,22,24,14,5,6,144,231,34]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$B_b=e.ResponsiveState=e.RequestInitiator=void 0,e.$z_b=o,e.$A_b=r;function l(b,P){try{return JSON.stringify(b,P)}catch{return"null"}}const w="$$ref$$",m={[w]:-1};class s{constructor(P,I){this.jsonString=P,this.referencedBuffers=I}}function o(b,P=null,I=!1){const W=[];return{jsonString:(I?l:JSON.stringify)(b,(q,A)=>{if(typeof A>"u")return m;if(typeof A=="object"){if(A instanceof N.$Fe){const j=W.push(A)-1;return{[w]:j}}if(P)return P(q,A)}return A}),referencedBuffers:W}}function r(b,P,I){return JSON.parse(b,(W,V)=>{if(V){const q=V[w];if(typeof q=="number")return P[q];if(I&&V.$mid===1)return I.transformIncoming(V)}return V})}function t(b,P){return JSON.stringify(b,P)}function n(b){return b?(P,I)=>I&&I.$mid===1?b.transformOutgoing(I):I:null}var c;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var h;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(h||(e.ResponsiveState=h={}));const i=()=>{},$=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class v extends p.$Vc{static{y=$}static{this.a=3*1e3}constructor(P,I=null,W=null){super(),this[y]=!0,this.b=this.B(new M.$ee),this.onDidChangeResponsiveState=this.b.event,this.c=P,this.f=I,this.g=W,this.h=n(this.g),this.j=!1,this.m=[],this.s=[];for(let V=0,q=T.$rw.count;V<q;V++)this.m[V]=null,this.s[V]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new S.$Hh(()=>this.H(),1e3)),this.c.onMessage(V=>this.L(V))}dispose(){this.j=!0,Object.keys(this.w).forEach(P=>{const I=this.w[P];delete this.w[P],I.resolveErr(O.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(P){this.z===0&&(this.C=Date.now()+v.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(P){this.C=Date.now()+v.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(P){this.y!==P&&(this.y=P,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(P){return this.g?(0,g.$An)(P,this.g):P}getProxy(P){const{nid:I,sid:W}=P;return this.s[I]||(this.s[I]=this.J(I,W)),this.s[I]}J(P,I){const W={get:(V,q)=>(typeof q=="string"&&!V[q]&&q.charCodeAt(0)===36&&(V[q]=(...A)=>this.U(P,q,A)),q===a?I:V[q])};return new Proxy(Object.create(null),W)}set(P,I){return this.m[P.nid]=I,I}assertRegistered(P){for(let I=0,W=P.length;I<W;I++){const V=P[I];if(!this.m[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}L(P){if(this.j)return;const I=P.byteLength,W=C.read(P,0),V=W.readUInt8(),q=W.readUInt32();switch(V){case 1:case 2:{let{rpcId:A,method:j,args:K}=D.deserializeRequestJSONArgs(W);this.g&&(K=(0,g.$An)(K,this.g)),this.M(I,q,A,j,K,V===2);break}case 3:case 4:{let{rpcId:A,method:j,args:K}=D.deserializeRequestMixedArgs(W);this.g&&(K=(0,g.$An)(K,this.g)),this.M(I,q,A,j,K,V===4);break}case 5:{this.f?.logIncoming(I,q,0,"ack"),this.G(q);break}case 6:{this.N(I,q);break}case 7:{this.O(I,q,void 0);break}case 9:{let A=D.deserializeReplyOKJSON(W);this.g&&(A=(0,g.$An)(A,this.g)),this.O(I,q,A);break}case 10:{const A=D.deserializeReplyOKJSONWithBuffers(W,this.g);this.O(I,q,A);break}case 8:{const A=D.deserializeReplyOKVSBuffer(W);this.O(I,q,A);break}case 11:{let A=D.deserializeReplyErrError(W);this.g&&(A=(0,g.$An)(A,this.g)),this.P(I,q,A);break}case 12:{this.P(I,q,void 0);break}default:console.error("received unexpected message"),console.error(P)}}M(P,I,W,V,q,A){this.f?.logIncoming(P,I,1,`receiveRequest ${(0,T.$tw)(W)}.${V}(`,q);const j=String(I);let K,re;if(A){const we=new R.$pe;q.push(we.token),K=this.Q(W,V,q),re=()=>we.cancel()}else K=this.Q(W,V,q),re=i;this.u[j]=re;const ae=D.serializeAcknowledged(I);this.f?.logOutgoing(ae.byteLength,I,1,"ack"),this.c.send(ae),K.then(we=>{delete this.u[j];const Ie=D.serializeReplyOK(I,we,this.h);this.f?.logOutgoing(Ie.byteLength,I,1,"reply:",we),this.c.send(Ie)},we=>{delete this.u[j];const Ie=D.serializeReplyErr(I,we);this.f?.logOutgoing(Ie.byteLength,I,1,"replyErr:",we),this.c.send(Ie)})}N(P,I){this.f?.logIncoming(P,I,1,"receiveCancel");const W=String(I);this.u[W]?.()}O(P,I,W){this.f?.logIncoming(P,I,0,"receiveReply:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V],q.resolveOk(W)}P(P,I,W){this.f?.logIncoming(P,I,0,"receiveReplyErr:",W);const V=String(I);if(!this.w.hasOwnProperty(V))return;const q=this.w[V];delete this.w[V];let A;W&&(W.$isError?(A=new Error,A.name=W.name,A.message=W.message,A.stack=W.stack):A=W),q.resolveErr(A)}Q(P,I,W){try{return Promise.resolve(this.S(P,I,W))}catch(V){return Promise.reject(V)}}S(P,I,W){const V=this.m[P];if(!V)throw new Error("Unknown actor "+(0,T.$tw)(P));const q=V[I];if(typeof q!="function")throw new Error("Unknown method "+I+" on actor "+(0,T.$tw)(P));return q.apply(V,W)}U(P,I,W){if(this.j)return new E.$y_b;let V=null;if(W.length>0&&R.CancellationToken.isCancellationToken(W[W.length-1])&&(V=W.pop()),V&&V.isCancellationRequested)return Promise.reject(O.$6());const q=D.serializeRequestArguments(W,this.h),A=++this.t,j=String(A),K=new E.$x_b,re=new p.$Uc;V&&re.add(V.onCancellationRequested(()=>{const we=D.serializeCancel(A);this.f?.logOutgoing(we.byteLength,A,0,"cancel"),this.c.send(D.serializeCancel(A))})),this.w[j]=new d(K,re),this.F(A);const ae=D.serializeRequest(A,P,I,q,!!V);return this.f?.logOutgoing(ae.byteLength,A,0,`request: ${(0,T.$tw)(P)}.${I}(`,W),this.c.send(ae),K}}e.$B_b=v;class d{constructor(P,I){this.a=P,this.b=I}resolveOk(P){this.a.resolveOk(P),this.b.dispose()}resolveErr(P){this.a.resolveErr(P),this.b.dispose()}}class C{static alloc(P,I,W){const V=new C(N.$Fe.alloc(W+1+4),0);return V.writeUInt8(P),V.writeUInt32(I),V}static read(P,I){return new C(P,I)}get buffer(){return this.a}constructor(P,I){this.a=P,this.b=I}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(P){this.a.writeUInt8(P,this.b),this.b+=1}readUInt8(){const P=this.a.readUInt8(this.b);return this.b+=1,P}writeUInt32(P){this.a.writeUInt32BE(P,this.b),this.b+=4}readUInt32(){const P=this.a.readUInt32BE(this.b);return this.b+=4,P}static sizeShortString(P){return 1+P.byteLength}writeShortString(P){this.a.writeUInt8(P.byteLength,this.b),this.b+=1,this.a.set(P,this.b),this.b+=P.byteLength}readShortString(){const P=this.a.readUInt8(this.b);this.b+=1;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}static sizeLongString(P){return 4+P.byteLength}writeLongString(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readLongString(){const P=this.a.readUInt32BE(this.b);this.b+=4;const W=this.a.slice(this.b,this.b+P).toString();return this.b+=P,W}writeBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}static sizeVSBuffer(P){return 4+P.byteLength}writeVSBuffer(P){this.a.writeUInt32BE(P.byteLength,this.b),this.b+=4,this.a.set(P,this.b),this.b+=P.byteLength}readVSBuffer(){const P=this.a.readUInt32BE(this.b);this.b+=4;const I=this.a.slice(this.b,this.b+P);return this.b+=P,I}static sizeMixedArray(P){let I=0;I+=1;for(let W=0,V=P.length;W<V;W++){const q=P[W];switch(I+=1,q.type){case 1:I+=this.sizeLongString(q.value);break;case 2:I+=this.sizeVSBuffer(q.value);break;case 3:I+=this.sizeUInt32,I+=this.sizeLongString(q.value);for(let A=0;A<q.buffers.length;++A)I+=this.sizeVSBuffer(q.buffers[A]);break;case 4:break}}return I}writeMixedArray(P){this.a.writeUInt8(P.length,this.b),this.b+=1;for(let I=0,W=P.length;I<W;I++){const V=P[I];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let q=0;q<V.buffers.length;++q)this.writeBuffer(V.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const P=this.a.readUInt8(this.b);this.b+=1;const I=new Array(P);for(let W=0;W<P;W++)switch(this.readUInt8()){case 1:I[W]=this.readLongString();break;case 2:I[W]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),A=this.readLongString(),j=[];for(let K=0;K<q;++K)j.push(this.readVSBuffer());I[W]=new T.$uw(r(A,j,null));break}case 4:I[W]=void 0;break}return I}}var u;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(u||(u={}));class D{static a(P){for(let I=0,W=P.length;I<W;I++)if(P[I]instanceof N.$Fe||P[I]instanceof T.$uw||typeof P[I]>"u")return!0;return!1}static serializeRequestArguments(P,I){if(this.a(P)){const W=[];for(let V=0,q=P.length;V<q;V++){const A=P[V];if(A instanceof N.$Fe)W[V]={type:2,value:A};else if(typeof A>"u")W[V]={type:4};else if(A instanceof T.$uw){const{jsonString:j,referencedBuffers:K}=o(A.value,I);W[V]={type:3,value:N.$Fe.fromString(j),buffers:K}}else W[V]={type:1,value:N.$Fe.fromString(t(A,I))}}return{type:1,args:W}}return{type:0,args:t(P,I)}}static serializeRequest(P,I,W,V,q){switch(V.type){case 0:return this.b(P,I,W,V.args,q);case 1:return this.c(P,I,W,V.args,q)}}static b(P,I,W,V,q){const A=N.$Fe.fromString(W),j=N.$Fe.fromString(V);let K=0;K+=C.sizeUInt8(),K+=C.sizeShortString(A),K+=C.sizeLongString(j);const re=C.alloc(q?2:1,P,K);return re.writeUInt8(I),re.writeShortString(A),re.writeLongString(j),re.buffer}static deserializeRequestJSONArgs(P){const I=P.readUInt8(),W=P.readShortString(),V=P.readLongString();return{rpcId:I,method:W,args:JSON.parse(V)}}static c(P,I,W,V,q){const A=N.$Fe.fromString(W);let j=0;j+=C.sizeUInt8(),j+=C.sizeShortString(A),j+=C.sizeMixedArray(V);const K=C.alloc(q?4:3,P,j);return K.writeUInt8(I),K.writeShortString(A),K.writeMixedArray(V),K.buffer}static deserializeRequestMixedArgs(P){const I=P.readUInt8(),W=P.readShortString(),V=P.readMixedArray(),q=new Array(V.length);for(let A=0,j=V.length;A<j;A++){const K=V[A];typeof K=="string"?q[A]=JSON.parse(K):q[A]=K}return{rpcId:I,method:W,args:q}}static serializeAcknowledged(P){return C.alloc(5,P,0).buffer}static serializeCancel(P){return C.alloc(6,P,0).buffer}static serializeReplyOK(P,I,W){if(typeof I>"u")return this.d(P);if(I instanceof N.$Fe)return this.e(P,I);if(I instanceof T.$uw){const{jsonString:V,referencedBuffers:q}=o(I.value,W,!0);return this.g(P,V,q)}else return this.f(P,l(I,W))}static d(P){return C.alloc(7,P,0).buffer}static e(P,I){let W=0;W+=C.sizeVSBuffer(I);const V=C.alloc(8,P,W);return V.writeVSBuffer(I),V.buffer}static deserializeReplyOKVSBuffer(P){return P.readVSBuffer()}static f(P,I){const W=N.$Fe.fromString(I);let V=0;V+=C.sizeLongString(W);const q=C.alloc(9,P,V);return q.writeLongString(W),q.buffer}static g(P,I,W){const V=N.$Fe.fromString(I);let q=0;q+=C.sizeUInt32,q+=C.sizeLongString(V);for(const j of W)q+=C.sizeVSBuffer(j);const A=C.alloc(10,P,q);A.writeUInt32(W.length),A.writeLongString(V);for(const j of W)A.writeBuffer(j);return A.buffer}static deserializeReplyOKJSON(P){const I=P.readLongString();return JSON.parse(I)}static deserializeReplyOKJSONWithBuffers(P,I){const W=P.readUInt32(),V=P.readLongString(),q=[];for(let A=0;A<W;++A)q.push(P.readVSBuffer());return new T.$uw(r(V,q,I))}static serializeReplyErr(P,I){const W=I?l(O.$3(I),null):void 0;if(typeof W!="string")return this.h(P);const V=N.$Fe.fromString(W);let q=0;q+=C.sizeLongString(V);const A=C.alloc(11,P,q);return A.writeLongString(V),A.buffer}static deserializeReplyErrError(P){const I=P.readLongString();return JSON.parse(I)}static h(P){return C.alloc(12,P,0).buffer}}var f;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(f||(f={}));var k;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(k||(k={}))}),define(Ce[244],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$apc=void 0;const S=function(O){const M=p=>{globalThis.removeEventListener("message",M);const g=p.data;Object.defineProperties(globalThis,{postMessage:{value(E,T){g.postMessage(E,T)}},onmessage:{get(){return g.onmessage},set(E){g.onmessage=E}}}),g.addEventListener("message",E=>{globalThis.dispatchEvent(new MessageEvent("message",{data:E.data,ports:E.ports?[...E.ports]:void 0}))}),g.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(O)};globalThis.addEventListener("message",M)}.toString();class N extends EventTarget{constructor(O,M,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const g=`((${S})('${M}'))`,E=new Blob([g],{type:"application/javascript"}),T=URL.createObjectURL(E),y=new MessageChannel,l=T,w={type:"_newWorker",id:l,port:y.port2,url:T,options:p};O(w,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{O({type:"_terminateWorker",id:l}),URL.revokeObjectURL(T),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(m){y.port1.onmessage=m}},onmessageerror:{get(){return y.port1.onmessageerror},set(m){y.port1.onmessageerror=m}}}),y.port1.addEventListener("messageerror",m=>{const s=new MessageEvent("messageerror",{data:m.data});this.dispatchEvent(s)}),y.port1.addEventListener("message",m=>{const s=new MessageEvent("message",{data:m.data});this.dispatchEvent(s)}),y.port1.start()}}e.$apc=N}),define(Ce[245],Ae([1,0,22,28,12,55,3]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DK=e.$AK=void 0,e.$BK=T,e.$CK=y,e.$AK=(0,M.$vi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],g=new RegExp(`^[${p.join("")}]+`),E=7;function T(w){if(w.scheme!==R.Schemas.vscodeNotebookCell)return;const m=w.fragment.indexOf("s");if(m<0)return;const s=parseInt(w.fragment.substring(0,m).replace(g,""),E),o=(0,S.$Ye)(w.fragment.substring(m+1)).toString();if(!isNaN(s))return{handle:s,notebook:w.with({scheme:o,fragment:null})}}function y(w,m){const s=m.toString(E),r=`${s.length<p.length?p[s.length-1]:"z"}${s}s${(0,S.$Ze)(S.$Fe.fromString(w.scheme),!0,!0)}`;return w.with({scheme:R.Schemas.vscodeNotebookCell,fragment:r})}class l{constructor(){this.a=new N.$Bc}getNotebook(m){if(m.scheme===R.Schemas.vscodeNotebookCell){const s=T(m);if(s){const o=this.a.get(s.notebook);if(o)return o}}return this.a.get(m)}addNotebookDocument(m){this.a.set(m.uri,m)}removeNotebookDocument(m){this.a.delete(m.uri)}}e.$DK=l,(0,O.$ws)(e.$AK,l,1)}),define(Ce[83],Ae([1,0,22,36,40,69,12,19,21,31,245]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XK=e.$UK=e.CellStatusbarAlignment=e.$TK=e.NotebookEditorPriority=e.$QK=e.$PK=e.$NK=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$MK=e.$LK=e.$KK=e.$JK=e.CellKind=e.$IK=e.$HK=e.$GK=void 0,e.$OK=$,e.$RK=v,e.$SK=d,e.$VK=D,e.$WK=k,e.$GK="workbench.editor.notebook",e.$HK="workbench.editor.notebookTextDiffEditor",e.$IK="workbench.editor.interactive";var y;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(y||(e.CellKind=y={})),e.$JK=["application/json","application/javascript","text/html","image/svg+xml",O.$Ps.latex,O.$Ps.markdown,"image/png","image/jpeg",O.$Ps.text],e.$KK=[O.$Ps.latex,O.$Ps.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",O.$Ps.text],e.$LK=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$MK="_notAvailable";var l;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(l||(e.NotebookRunState=l={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var m;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(m||(e.NotebookExecutionState=m={}));var s;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(s||(e.NotebookRendererMatch=s={}));var o;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(o||(e.RendererMessagingSpec=o={}));var r;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(r||(e.NotebookCellsChangeType=r={}));var t;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(t||(e.SelectionStateType=t={}));var n;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(n||(e.CellEditType=n={}));var c;(function(K){K.scheme=M.Schemas.vscodeNotebookCell;function re(Me,ce){return(0,T.$CK)(Me,ce)}K.generate=re;function ae(Me){return(0,T.$BK)(Me)}K.parse=ae;function we(Me,ce){return Me.with({scheme:M.Schemas.vscodeNotebookCellOutput,fragment:`op${ce??""},${Me.scheme!==M.Schemas.file?Me.scheme:""}`})}K.generateCellOutputUri=we;function Ie(Me){if(Me.scheme!==M.Schemas.vscodeNotebookCellOutput)return;const ce=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Me.fragment);if(!ce)return;const Re=ce[1]&&ce[1]!==""?ce[1]:void 0,ie=ce[2];return{outputId:Re,notebook:Me.with({scheme:ie||M.Schemas.file,fragment:null})}}K.parseCellOutputUri=Ie;function de(Me,ce,Re){return K.generate(Me,ce).with({scheme:Re})}K.generateCellPropertyUri=de;function me(Me,ce){if(Me.scheme===ce)return K.parse(Me.with({scheme:K.scheme}))}K.parseCellPropertyUri=me})(c||(e.CellUri=c={}));const h=K=>g.$i?K.replace(/\//g,"\\"):K;class i{constructor(re=[],ae=e.$JK){this.e=ae,this.d=[...new Set(re)].map(we=>({pattern:we,matches:N.$pk(h(we))}))}sort(re){const ae=new Map(R.Iterable.map(re,Ie=>[Ie,h(Ie)]));let we=[];for(const{matches:Ie}of this.d)for(const[de,me]of ae)if(Ie(me)){we.push(de),ae.delete(de);break}return ae.size&&(we=we.concat([...ae.keys()].sort((Ie,de)=>this.e.indexOf(Ie)-this.e.indexOf(de)))),we}prioritize(re,ae){const we=this.f(re);if(we===-1){this.d.unshift({pattern:re,matches:N.$pk(h(re))});return}const Ie=new Set(ae.map(me=>this.f(me,we)));Ie.delete(-1);const de=Array.from(Ie).sort();this.d.splice(we+1,0,...de.map(me=>this.d[me]));for(let me=de.length-1;me>=0;me--)this.d.splice(de[me],1)}toArray(){return this.d.map(re=>re.pattern)}f(re,ae=this.d.length){const we=h(re);for(let Ie=0;Ie<ae;Ie++)if(this.d[Ie].matches(we))return Ie;return-1}}e.$NK=i;function $(K,re,ae,we=(Ie,de)=>Ie===de){const Ie=[];function de(ce,Re,ie){if(Re===0&&ie.length===0)return;const L=Ie[Ie.length-1];L&&L.start+L.deleteCount===ce?(L.deleteCount+=Re,L.toInsert.push(...ie)):Ie.push({start:ce,deleteCount:Re,toInsert:ie})}let me=0,Me=0;for(;;){if(me===K.length){de(me,0,re.slice(Me));break}if(Me===re.length){de(me,K.length-me,[]);break}const ce=K[me],Re=re[Me];if(we(ce,Re)){me+=1,Me+=1;continue}ae(Re)?(de(me,1,[]),me+=1):(de(me,0,[Re]),Me+=1)}return Ie}e.$PK=new E.$Mj("notebookEditorCursorAtBoundary","none"),e.$QK=new E.$Mj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function v(K){const re=K;return!!((typeof re.include=="string"||N.$qk(re.include))&&(typeof re.exclude=="string"||N.$qk(re.exclude)))}function d(K,re,ae){if(Array.isArray(K.viewType)&&K.viewType.indexOf(re)>=0||K.viewType===re)return!0;if(K.filenamePattern){const we=v(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,Ie=v(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$ok(we,(0,p.$oc)(ae.fsPath).toLowerCase()))return!(Ie&&N.$ok(Ie,(0,p.$oc)(ae.fsPath).toLowerCase()))}return!1}e.$TK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var C;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(C||(e.CellStatusbarAlignment=C={}));class u{static{this.d="notebook/"}static create(re){return`${u.d}${re}`}static parse(re){if(re.startsWith(u.d))return re.substring(u.d.length)}}e.$UK=u;function D(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const f=new TextDecoder;function k(K){const re=[];let ae=!1;for(const me of K)(re.length===0||ae)&&(re.push(me),ae=!0);let we=I(re);const Ie=S.$Fe.concat(re.map(me=>S.$Fe.wrap(me))),de=j(Ie);return we=we||de.byteLength!==Ie.byteLength,{data:de,didCompression:we}}e.$XK="\x1B[A";const b=e.$XK.split("").map(K=>K.charCodeAt(0)),P=10;function I(K){let re=!1;return K.forEach((ae,we)=>{if(we===0||ae.length<e.$XK.length)return;const Ie=K[we-1],de=ae.subarray(0,e.$XK.length);if(de[0]===b[0]&&de[1]===b[1]&&de[2]===b[2]){const me=Ie.lastIndexOf(P);if(me===-1)return;re=!0,K[we-1]=Ie.subarray(0,me),K[we]=ae.subarray(e.$XK.length)}}),re}function W(K){let re=K;do K=re,re=K.replace(/[^\n]\x08/gm,"");while(re.length<K.length);return K}function V(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const re=K.match(/^(.*)\r+/m)[1];let ae=K.match(/\r+(.*)$/m)[1];ae=ae+re.slice(ae.length,re.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ae)}return K}const q=8,A=13;function j(K){return!K.buffer.includes(q)&&!K.buffer.includes(A)?K:S.$Fe.fromString(V(W(f.decode(K.buffer))))}}),define(Ce[7],Ae([1,0,18,14,54,28,69,15,17,2,35,20,44,102,83]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m){"use strict";var s,o,r,t,n,c,h,i,$,a,v,d,C,u,D,f,k;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$_O=e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$$O=e.$0O=e.$9O=e.$8O=e.ChatLocation=e.$7O=e.$6O=e.$5O=e.$4O=e.$3O=e.$2O=e.$1O=e.$ZO=e.$YO=e.$XO=e.$WO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$VO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$UO=e.$TO=e.$SO=e.$RO=e.$QO=e.$PO=e.$OO=e.$NO=e.$MO=e.$LO=e.$KO=e.$JO=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$IO=e.$HO=e.$GO=e.$FO=e.$DO=e.$CO=e.$BO=e.$AO=e.TestRunProfileKind=e.TestResultState=e.$zO=e.$yO=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$xO=e.NotebookVariablesRequestKind=e.$wO=e.$vO=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$uO=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.ColorThemeKind=e.$oO=e.$nO=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$mO=e.$lO=e.DebugConsoleMode=e.$kO=e.$jO=e.$iO=e.$hO=e.$gO=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$fO=e.$eO=e.FileChangeType=e.$dO=e.NewSymbolNameTag=e.$cO=e.$bO=e.$aO=e.$_N=e.InlineCompletionTriggerKind=e.$$N=e.$0N=e.$9N=e.$8N=e.$7N=e.$6N=e.$5N=e.$4N=e.$3N=e.$2N=e.$1N=e.$YN=e.ConfigurationTarget=e.$XN=e.$WN=e.$VN=e.$UN=e.DocumentPasteTriggerKind=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.$ON=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$NN=e.ViewBadge=e.ProgressLocation=e.$MN=e.$LN=e.TaskScope=e.ShellQuoting=e.$KN=e.$JN=e.$IN=e.TaskPanelKind=e.TaskRevealKind=e.$HN=e.TerminalLocation=e.$GN=e.$FN=e.$EN=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$DN=e.$CN=e.$BN=e.$AN=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$yN=e.$xN=e.$wN=e.$vN=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$uN=e.$tN=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.LanguageStatusSeverity=e.$nN=e.$mN=e.$lN=e.$kN=e.$jN=e.$iN=e.CodeActionTriggerKind=e.$hN=e.$gN=e.SymbolTag=e.SymbolKind=e.$fN=e.$eN=e.DocumentHighlightKind=e.$dN=e.$cN=e.$bN=e.$aN=e.DiagnosticSeverity=e.DiagnosticTag=e.$_M=e.$$M=e.FileEditType=e.$0M=e.$9M=e.$8M=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$7M=e.$6M=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$zN=dt,e.$ZN=J,e.$EO=Mt;function b(B){return Object.assign(B,{apply:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const De=te.length===1?[]:te[1];return Reflect.construct(B,De,te[0].constructor)}},call:function(...te){if(te.length===0)return Reflect.construct(B,[]);{const[De,...Ke]=te;return Reflect.construct(B,Ke,De.constructor)}}})}var P;(function(B){B[B.Top=0]="Top",B[B.Bottom=1]="Bottom"})(P||(e.TerminalOutputAnchor=P={}));var I;(function(B){B[B.TerminalCommand=0]="TerminalCommand",B[B.Opener=1]="Opener",B[B.Command=3]="Command"})(I||(e.TerminalQuickFixType=I={}));let W=s=class{static from(...F){let te=F;return new s(function(){if(te){for(const De of te)De&&typeof De.dispose=="function"&&De.dispose();te=void 0}})}#e;constructor(F){this.#e=F}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$1M=W,e.$1M=W=s=Je([b],W);let V=o=class{static Min(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isBefore(te)&&(te=Ke)}return te}static Max(...F){if(F.length===0)throw new TypeError;let te=F[0];for(let De=1;De<F.length;De++){const Ke=F[De];Ke.isAfter(te)&&(te=Ke)}return te}static isPosition(F){if(!F)return!1;if(F instanceof o)return!0;const{line:te,character:De}=F;return typeof te=="number"&&typeof De=="number"}static of(F){if(F instanceof o)return F;if(this.isPosition(F))return new o(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,te){if(F<0)throw(0,N.$7)("line must be non-negative");if(te<0)throw(0,N.$7)("character must be non-negative");this.c=F,this.e=te}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,te=0){if(F===null||te===null)throw(0,N.$7)();let De;return typeof F>"u"?De=0:typeof F=="number"?De=F:(De=typeof F.lineDelta=="number"?F.lineDelta:0,te=typeof F.characterDelta=="number"?F.characterDelta:0),De===0&&te===0?this:new o(this.line+De,this.character+te)}with(F,te=this.character){if(F===null||te===null)throw(0,N.$7)();let De;return typeof F>"u"?De=this.line:typeof F=="number"?De=F:(De=typeof F.line=="number"?F.line:this.line,te=typeof F.character=="number"?F.character:this.character),De===this.line&&te===this.character?this:new o(De,te)}toJSON(){return{line:this.line,character:this.character}}};e.$2M=V,e.$2M=V=o=Je([b],V);let q=r=class{static isRange(F){return F instanceof r?!0:F?V.isPosition(F.start)&&V.isPosition(F.end):!1}static of(F){if(F instanceof r)return F;if(this.isRange(F))return new r(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,te,De,Ke){let Xe,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Xe=new V(F,te),ht=new V(De,Ke)):V.isPosition(F)&&V.isPosition(te)&&(Xe=V.of(F),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");Xe.isBefore(ht)?(this.c=Xe,this.e=ht):(this.c=ht,this.e=Xe)}contains(F){return r.isRange(F)?this.contains(F.start)&&this.contains(F.end):V.isPosition(F)?!(V.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const te=V.Max(F.start,this.c),De=V.Min(F.end,this.e);if(!te.isAfter(De))return new r(te,De)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const te=V.Min(F.start,this.c),De=V.Max(F.end,this.end);return new r(te,De)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,te=this.end){if(F===null||te===null)throw(0,N.$7)();let De;return F?V.isPosition(F)?De=F:(De=F.start||this.start,te=F.end||this.end):De=this.start,De.isEqual(this.c)&&te.isEqual(this.end)?this:new r(De,te)}toJSON(){return[this.start,this.end]}};e.$3M=q,e.$3M=q=r=Je([b],q);let A=t=class extends q{static isSelection(F){return F instanceof t?!0:F?q.isRange(F)&&V.isPosition(F.anchor)&&V.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,te,De,Ke){let Xe,ht;if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"?(Xe=new V(F,te),ht=new V(De,Ke)):V.isPosition(F)&&V.isPosition(te)&&(Xe=V.of(F),ht=V.of(te)),!Xe||!ht)throw new Error("Invalid arguments");super(Xe,ht),this.f=Xe,this.g=ht}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$4M=A,e.$4M=A=t=Je([b],A);const j=B=>{if(typeof B!="string"||B.length===0||!/^[0-9A-Za-z_\-]+$/.test(B))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.host=="string"&&typeof F.port=="number"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te,De){if(typeof F!="string"||F.length===0)throw(0,N.$7)("host");if(typeof te!="number"||te===0||Math.round(te)!==te)throw(0,N.$7)("port");typeof De<"u"&&j(De),this.host=F,this.port=Math.round(te),this.connectionToken=De}}e.$5M=K;class re{static isManagedResolvedAuthority(F){return F&&typeof F=="object"&&typeof F.makeConnection=="function"&&(F.connectionToken===void 0||typeof F.connectionToken=="string")}constructor(F,te){this.makeConnection=F,this.connectionToken=te,typeof te<"u"&&j(te)}}e.$6M=re;class ae extends Error{static NotAvailable(F,te){return new ae(F,w.RemoteAuthorityResolverErrorCode.NotAvailable,te)}static TemporarilyNotAvailable(F){return new ae(F,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,te=w.RemoteAuthorityResolverErrorCode.Unknown,De){super(F),this._message=F,this._code=te,this._detail=De,Object.setPrototypeOf(this,ae.prototype)}}e.$7M=ae;var we;(function(B){B[B.LF=1]="LF",B[B.CRLF=2]="CRLF"})(we||(e.EndOfLine=we={}));var Ie;(function(B){B[B.Replace=1]="Replace",B[B.Append=2]="Append",B[B.Prepend=3]="Prepend"})(Ie||(e.EnvironmentVariableMutatorType=Ie={}));let de=n=class{static isTextEdit(F){return F instanceof n?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,te){return new n(F,te)}static insert(F,te){return n.replace(new q(F,F),te)}static delete(F){return n.replace(F,"")}static setEndOfLine(F){const te=new n(new q(new V(0,0),new V(0,0)),"");return te.newEol=F,te}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,N.$7)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,N.$7)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,N.$7)("newEol");this.f=F}constructor(F,te){this.c=F,this.e=te}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$8M=de,e.$8M=de=n=Je([b],de);let me=c=class{static isNotebookCellEdit(F){return F instanceof c?!0:F?xe.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,te){return new c(F,te)}static insertCells(F,te){return new c(new xe(F,F),te)}static deleteCells(F){return new c(F,[])}static updateCellMetadata(F,te){const De=new c(new xe(F,F),[]);return De.newCellMetadata=te,De}static updateNotebookMetadata(F){const te=new c(new xe(0,0),[]);return te.newNotebookMetadata=F,te}constructor(F,te){this.range=F,this.newCells=te}};e.$9M=me,e.$9M=me=c=Je([b],me);class Me{static isSnippetTextEdit(F){return F instanceof Me?!0:F?q.isRange(F.range)&&ie.isSnippetString(F.snippet):!1}static replace(F,te){return new Me(F,te)}static insert(F,te){return Me.replace(new q(F,F),te)}constructor(F,te){this.range=F,this.snippet=te}}e.$0M=Me;var ce;(function(B){B[B.File=1]="File",B[B.Text=2]="Text",B[B.Cell=3]="Cell",B[B.CellReplace=5]="CellReplace",B[B.Snippet=6]="Snippet"})(ce||(e.FileEditType=ce={}));let Re=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,te,De,Ke){this.c.push({_type:1,from:F,to:te,options:De,metadata:Ke})}createFile(F,te,De){this.c.push({_type:1,from:void 0,to:F,options:te,metadata:De})}deleteFile(F,te,De){this.c.push({_type:1,from:F,to:void 0,options:te,metadata:De})}e(F,te,De){this.c.push({_type:3,metadata:De,uri:F,edit:{editType:5,metadata:te},notebookMetadata:te})}f(F,te,De,Ke){const Xe=te.start,ht=te.end;(Xe!==ht||De.length>0)&&this.c.push({_type:5,uri:F,index:Xe,count:ht-Xe,cells:De,metadata:Ke})}g(F,te,De,Ke){this.c.push({_type:3,metadata:Ke,uri:F,edit:{editType:3,index:te,metadata:De}})}replace(F,te,De,Ke){this.c.push({_type:2,uri:F,edit:new de(te,De),metadata:Ke})}insert(F,te,De,Ke){this.replace(F,new q(te,te),De,Ke)}delete(F,te,De){this.replace(F,te,"",De)}has(F){return this.c.some(te=>te._type===2&&te.uri.toString()===F.toString())}set(F,te){if(te)for(const De of te){if(!De)continue;let Ke,Xe;Array.isArray(De)?(Ke=De[0],Xe=De[1]):Ke=De,me.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(F,Ke.range.start,Ke.newCellMetadata,Xe):Ke.newNotebookMetadata?this.e(F,Ke.newNotebookMetadata,Xe):this.f(F,Ke.range,Ke.newCells,Xe):Me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:F,range:Ke.range,edit:Ke.snippet,metadata:Xe}):this.c.push({_type:2,uri:F,edit:Ke,metadata:Xe})}else{for(let De=0;De<this.c.length;De++){const Ke=this.c[De];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===F.toString()&&(this.c[De]=void 0);break}}(0,S.$Ib)(this.c)}}get(F){const te=[];for(const De of this.c)De._type===2&&De.uri.toString()===F.toString()&&te.push(De.edit);return te}entries(){const F=new O.$Bc;for(const te of this.c)if(te._type===2){let De=F.get(te.uri);De||(De=[te.uri,[]],F.set(te.uri,De)),De[1].push(te.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$$M=Re,e.$$M=Re=Je([b],Re);let ie=h=class{static isSnippetString(F){return F instanceof h?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=h.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,te=this.e++){if(typeof F=="function"){const De=new h;De.e=this.e,F(De),this.e=De.e,F=De.value}else F=h.c(F);return this.value+="${",this.value+=te,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,te=this.e++){const De=F.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=te,this.value+="|",this.value+=De,this.value+="|}",this}appendVariable(F,te){if(typeof te=="function"){const De=new h;De.e=this.e,te(De),this.e=De.e,te=De.value}else typeof te=="string"&&(te=te.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,te&&(this.value+=":",this.value+=te),this.value+="}",this}};e.$_M=ie,e.$_M=ie=h=Je([b],ie);var L;(function(B){B[B.Unnecessary=1]="Unnecessary",B[B.Deprecated=2]="Deprecated"})(L||(e.DiagnosticTag=L={}));var x;(function(B){B[B.Hint=3]="Hint",B[B.Information=2]="Information",B[B.Warning=1]="Warning",B[B.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=i=class{static isLocation(F){return F instanceof i?!0:F?q.isRange(F.range)&&E.URI.isUri(F.uri):!1}constructor(F,te){if(this.uri=F,te)if(q.isRange(te))this.range=q.of(te);else if(V.isPosition(te))this.range=new q(te,te);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$aN=ve,e.$aN=ve=i=Je([b],ve);let Fe=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&E.URI.isUri(F.location.uri):!1}constructor(F,te){this.location=F,this.message=te}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.location.range.isEqual(te.location.range)&&F.location.uri.toString()===te.location.uri.toString()}};e.$bN=Fe,e.$bN=Fe=Je([b],Fe);let Ee=class{constructor(F,te,De=x.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!te)throw new TypeError("message must be set");this.range=F,this.message=te,this.severity=De}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,te){return F===te?!0:!F||!te?!1:F.message===te.message&&F.severity===te.severity&&F.code===te.code&&F.severity===te.severity&&F.source===te.source&&F.range.isEqual(te.range)&&(0,S.$ub)(F.tags,te.tags)&&(0,S.$ub)(F.relatedInformation,te.relatedInformation,Fe.isEqual)}};e.$cN=Ee,e.$cN=Ee=Je([b],Ee);let pe=class{constructor(F,te){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=te}};e.$dN=pe,e.$dN=pe=Je([b],pe);var fe;(function(B){B[B.Text=0]="Text",B[B.Read=1]="Read",B[B.Write=2]="Write"})(fe||(e.DocumentHighlightKind=fe={}));let Y=class{constructor(F,te=fe.Text){this.range=F,this.kind=te}toJSON(){return{range:this.range,kind:fe[this.kind]}}};e.$eN=Y,e.$eN=Y=Je([b],Y);let X=class{constructor(F,te){this.uri=F,this.highlights=te}toJSON(){return{uri:this.uri,highlights:this.highlights.map(F=>F.toJSON())}}};e.$fN=X,e.$fN=X=Je([b],X);var le;(function(B){B[B.File=0]="File",B[B.Module=1]="Module",B[B.Namespace=2]="Namespace",B[B.Package=3]="Package",B[B.Class=4]="Class",B[B.Method=5]="Method",B[B.Property=6]="Property",B[B.Field=7]="Field",B[B.Constructor=8]="Constructor",B[B.Enum=9]="Enum",B[B.Interface=10]="Interface",B[B.Function=11]="Function",B[B.Variable=12]="Variable",B[B.Constant=13]="Constant",B[B.String=14]="String",B[B.Number=15]="Number",B[B.Boolean=16]="Boolean",B[B.Array=17]="Array",B[B.Object=18]="Object",B[B.Key=19]="Key",B[B.Null=20]="Null",B[B.EnumMember=21]="EnumMember",B[B.Struct=22]="Struct",B[B.Event=23]="Event",B[B.Operator=24]="Operator",B[B.TypeParameter=25]="TypeParameter"})(le||(e.SymbolKind=le={}));var ue;(function(B){B[B.Deprecated=1]="Deprecated"})(ue||(e.SymbolTag=ue={}));let Te=$=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,te,De,Ke,Xe){this.name=F,this.kind=te,this.containerName=Xe,typeof De=="string"&&(this.containerName=De),Ke instanceof ve?this.location=Ke:De instanceof q&&(this.location=new ve(Ke,De)),$.validate(this)}toJSON(){return{name:this.name,kind:le[this.kind],location:this.location,containerName:this.containerName}}};e.$gN=Te,e.$gN=Te=$=Je([b],Te);let he=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(a.validate)}constructor(F,te,De,Ke,Xe){this.name=F,this.detail=te,this.kind=De,this.range=Ke,this.selectionRange=Xe,this.children=[],a.validate(this)}};e.$hN=he,e.$hN=he=a=Je([b],he);var Pe;(function(B){B[B.Invoke=1]="Invoke",B[B.Automatic=2]="Automatic"})(Pe||(e.CodeActionTriggerKind=Pe={}));let Ne=class{constructor(F,te){this.title=F,this.kind=te}};e.$iN=Ne,e.$iN=Ne=Je([b],Ne);let ze=class{static{v=this}static{this.c="."}constructor(F){this.value=F}append(F){return new v(this.value?this.value+v.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+v.c)}};e.$jN=ze,e.$jN=ze=v=Je([b],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll"),ze.Notebook=ze.Empty.append("notebook");let U=class{constructor(F,te){if(this.range=F,this.parent=te,te&&!te.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$kN=U,e.$kN=U=Je([b],U);class z{constructor(F,te,De,Ke,Xe,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=Xe,this.selectionRange=ht}}e.$lN=z;class H{constructor(F,te){this.fromRanges=te,this.from=F}}e.$mN=H;class G{constructor(F,te){this.fromRanges=te,this.to=F}}e.$nN=G;var ee;(function(B){B[B.Information=0]="Information",B[B.Warning=1]="Warning",B[B.Error=2]="Error"})(ee||(e.LanguageStatusSeverity=ee={}));let ne=class{constructor(F,te){this.range=F,this.command=te}get isResolved(){return!!this.command}};e.$oN=ne,e.$oN=ne=Je([b],ne);let Oe=d=class{#e;static isMarkdownString(F){return F instanceof d?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,te=!1){this.#e=new R.$Sk(F,{supportThemeIcons:te})}get value(){return this.#e.value}set value(F){this.#e.value=F}get isTrusted(){return this.#e.isTrusted}set isTrusted(F){this.#e.isTrusted=F}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(F){this.#e.supportThemeIcons=F}get supportHtml(){return this.#e.supportHtml}set supportHtml(F){this.#e.supportHtml=F}get baseUri(){return this.#e.baseUri}set baseUri(F){this.#e.baseUri=F}appendText(F){return this.#e.appendText(F),this}appendMarkdown(F){return this.#e.appendMarkdown(F),this}appendCodeblock(F,te){return this.#e.appendCodeblock(te??"",F),this}};e.$pN=Oe,e.$pN=Oe=d=Je([b],Oe);let Be=class{constructor(F,te){this.label=F,this.documentation=te}};e.$qN=Be,e.$qN=Be=Je([b],Be);let Ye=class{constructor(F,te){this.label=F,this.documentation=te,this.parameters=[]}};e.$rN=Ye,e.$rN=Ye=Je([b],Ye);let _e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$sN=_e,e.$sN=_e=Je([b],_e);var et;(function(B){B[B.Invoke=1]="Invoke",B[B.TriggerCharacter=2]="TriggerCharacter",B[B.ContentChange=3]="ContentChange"})(et||(e.SignatureHelpTriggerKind=et={}));var tt;(function(B){B[B.Type=1]="Type",B[B.Parameter=2]="Parameter"})(tt||(e.InlayHintKind=tt={}));let it=class{constructor(F){this.value=F}};e.$tN=it,e.$tN=it=Je([b],it);let nt=class{constructor(F,te,De){this.position=F,this.label=te,this.kind=De}};e.$uN=nt,e.$uN=nt=Je([b],nt);var at;(function(B){B[B.Invoke=0]="Invoke",B[B.TriggerCharacter=1]="TriggerCharacter",B[B.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(at||(e.CompletionTriggerKind=at={}));var mt;(function(B){B[B.Text=0]="Text",B[B.Method=1]="Method",B[B.Function=2]="Function",B[B.Constructor=3]="Constructor",B[B.Field=4]="Field",B[B.Variable=5]="Variable",B[B.Class=6]="Class",B[B.Interface=7]="Interface",B[B.Module=8]="Module",B[B.Property=9]="Property",B[B.Unit=10]="Unit",B[B.Value=11]="Value",B[B.Enum=12]="Enum",B[B.Keyword=13]="Keyword",B[B.Snippet=14]="Snippet",B[B.Color=15]="Color",B[B.File=16]="File",B[B.Reference=17]="Reference",B[B.Folder=18]="Folder",B[B.EnumMember=19]="EnumMember",B[B.Constant=20]="Constant",B[B.Struct=21]="Struct",B[B.Event=22]="Event",B[B.Operator=23]="Operator",B[B.TypeParameter=24]="TypeParameter",B[B.User=25]="User",B[B.Issue=26]="Issue"})(mt||(e.CompletionItemKind=mt={}));var je;(function(B){B[B.Deprecated=1]="Deprecated"})(je||(e.CompletionItemTag=je={}));let st=class{constructor(F,te){this.label=F,this.kind=te}toJSON(){return{label:this.label,kind:this.kind&&mt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$vN=st,e.$vN=st=Je([b],st);let Z=class{constructor(F=[],te=!1){this.items=F,this.isIncomplete=te}};e.$wN=Z,e.$wN=Z=Je([b],Z);let Q=class{constructor(F,te,De){this.insertText=F,this.range=te,this.command=De}};e.$xN=Q,e.$xN=Q=Je([b],Q);let $e=class{constructor(F){this.commands=void 0,this.suppressSuggestions=void 0,this.items=F}};e.$yN=$e,e.$yN=$e=Je([b],$e);var Ge;(function(B){B[B.Unknown=0]="Unknown",B[B.Word=1]="Word",B[B.Line=2]="Line",B[B.Suggest=3]="Suggest"})(Ge||(e.PartialAcceptTriggerKind=Ge={}));var ye;(function(B){B[B.Active=-1]="Active",B[B.Beside=-2]="Beside",B[B.One=1]="One",B[B.Two=2]="Two",B[B.Three=3]="Three",B[B.Four=4]="Four",B[B.Five=5]="Five",B[B.Six=6]="Six",B[B.Seven=7]="Seven",B[B.Eight=8]="Eight",B[B.Nine=9]="Nine"})(ye||(e.ViewColumn=ye={}));var ot;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(ot||(e.StatusBarAlignment=ot={}));function dt(B,F){return`${y.$Qm.toKey(B)}.${F}`}var It;(function(B){B[B.Off=0]="Off",B[B.On=1]="On",B[B.Relative=2]="Relative",B[B.Interval=3]="Interval"})(It||(e.TextEditorLineNumbersStyle=It={}));var Yt;(function(B){B[B.Manual=1]="Manual",B[B.AfterDelay=2]="AfterDelay",B[B.FocusOut=3]="FocusOut"})(Yt||(e.TextDocumentSaveReason=Yt={}));var Ut;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(Ut||(e.TextEditorRevealType=Ut={}));var xt;(function(B){B[B.Keyboard=1]="Keyboard",B[B.Mouse=2]="Mouse",B[B.Command=3]="Command"})(xt||(e.TextEditorSelectionChangeKind=xt={}));var _t;(function(B){B[B.Undo=1]="Undo",B[B.Redo=2]="Redo"})(_t||(e.TextDocumentChangeReason=_t={}));var Pt;(function(B){B[B.OpenOpen=0]="OpenOpen",B[B.ClosedClosed=1]="ClosedClosed",B[B.OpenClosed=2]="OpenClosed",B[B.ClosedOpen=3]="ClosedOpen"})(Pt||(e.DecorationRangeBehavior=Pt={})),function(B){function F(te){switch(te){case"keyboard":return B.Keyboard;case"mouse":return B.Mouse;case"api":return B.Command}}B.fromValue=F}(xt||(e.TextEditorSelectionChangeKind=xt={}));var Wt;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(Wt||(e.SyntaxTokenType=Wt={})),function(B){function F(te){switch(te){case B.Other:return"other";case B.Comment:return"comment";case B.String:return"string";case B.RegEx:return"regex"}return"other"}B.toString=F}(Wt||(e.SyntaxTokenType=Wt={}));let Qt=class{constructor(F,te){if(te&&!E.URI.isUri(te))throw(0,N.$7)("target");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.target=te}};e.$AN=Qt,e.$AN=Qt=Je([b],Qt);let Ze=class{constructor(F,te,De,Ke){this.red=F,this.green=te,this.blue=De,this.alpha=Ke}};e.$BN=Ze,e.$BN=Ze=Je([b],Ze);let si=class{constructor(F,te){if(te&&!(te instanceof Ze))throw(0,N.$7)("color");if(!q.isRange(F)||F.isEmpty)throw(0,N.$7)("range");this.range=F,this.color=te}};e.$CN=si,e.$CN=si=Je([b],si);let Zt=class{constructor(F){if(!F||typeof F!="string")throw(0,N.$7)("label");this.label=F}};e.$DN=Zt,e.$DN=Zt=Je([b],Zt);var lt;(function(B){B[B.RGB=0]="RGB",B[B.HEX=1]="HEX",B[B.HSL=2]="HSL"})(lt||(e.ColorFormat=lt={}));var wt;(function(B){B[B.Error=0]="Error",B[B.Warning=1]="Warning",B[B.Information=2]="Information"})(wt||(e.SourceControlInputBoxValidationType=wt={}));var ti;(function(B){B[B.Unknown=0]="Unknown",B[B.Shutdown=1]="Shutdown",B[B.Process=2]="Process",B[B.User=3]="User",B[B.Extension=4]="Extension"})(ti||(e.TerminalExitReason=ti={}));var Xt;(function(B){B[B.Low=0]="Low",B[B.Medium=1]="Medium",B[B.High=2]="High"})(Xt||(e.TerminalShellExecutionCommandLineConfidence=Xt={}));class Lt{constructor(F,te,De){if(this.startIndex=F,this.length=te,this.tooltip=De,typeof F!="number"||F<0)throw(0,N.$7)("startIndex");if(typeof te!="number"||te<1)throw(0,N.$7)("length");if(De!==void 0&&typeof De!="string")throw(0,N.$7)("tooltip")}}e.$EN=Lt;class ft{constructor(F){this.uri=F}}e.$FN=ft;class jt{constructor(F){this.terminalCommand=F}}e.$GN=jt;var Bt;(function(B){B[B.Panel=1]="Panel",B[B.Editor=2]="Editor"})(Bt||(e.TerminalLocation=Bt={}));class qt{constructor(F){if(this.options=F,typeof F!="object")throw(0,N.$7)("options")}}e.$HN=qt;var He;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(He||(e.TaskRevealKind=He={}));var ui;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(ui||(e.TaskPanelKind=ui={}));let Gt=class{static{C=this}static{this.Clean=new C("clean","Clean")}static{this.Build=new C("build","Build")}static{this.Rebuild=new C("rebuild","Rebuild")}static{this.Test=new C("test","Test")}static from(F){switch(F){case"clean":return C.Clean;case"build":return C.Build;case"rebuild":return C.Rebuild;case"test":return C.Test;default:return}}constructor(F,te){if(this.label=te,typeof F!="string"||typeof te!="string")throw(0,N.$7)("name");this.c=F}get id(){return this.c}};e.$IN=Gt,e.$IN=Gt=C=Je([b],Gt);function zt(B){let F="";for(let te=0;te<B.length;te++)F+=B[te].replace(/,/g,",,")+",";return F}let gt=class{constructor(F,te,De){if(typeof F!="string")throw(0,N.$7)("process");this.e=[],this.c=F,te!==void 0&&(Array.isArray(te)?(this.e=te,this.f=De):this.f=te)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,N.$7)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const te of this.e)F.push(te);return zt(F)}};e.$JN=gt,e.$JN=gt=Je([b],gt);let Tt=class{constructor(F,te,De){if(this.f=[],Array.isArray(te)){if(!F)throw(0,N.$7)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F,this.f=te,this.g=De}else{if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F,this.g=te}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,N.$7)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,N.$7)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const te of this.f)F.push(typeof te=="string"?te:te.value);return zt(F)}};e.$KN=Tt,e.$KN=Tt=Je([b],Tt);var At;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(At||(e.ShellQuoting=At={}));var Ot;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace"})(Ot||(e.TaskScope=Ot={}));class ii{constructor(F){this.c=F}computeId(){return"customExecution"+(0,T.$Rg)()}set callback(F){this.c=F}get callback(){return this.c}}e.$LN=ii;let Ht=class{static{u=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(F,te,De,Ke,Xe,ht){this.k=!1,this.l=this.definition=F;let $t;typeof te=="string"?(this.o=this.name=te,this.w=this.source=De,this.execution=Ke,$t=Xe,this.k=!0):te===Ot.Global||te===Ot.Workspace?(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Xe,$t=ht):(this.target=te,this.o=this.name=De,this.w=this.source=Ke,this.execution=Xe,$t=ht),typeof $t=="string"?(this.r=[$t],this.t=!0):Array.isArray($t)?(this.r=$t,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(F){this.j=F}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof gt?this.l={type:u.e,id:this.q.computeId()}:this.q instanceof Tt?this.l={type:u.f,id:this.q.computeId()}:this.q instanceof ii?this.l={type:u.c,id:this.q.computeId()}:this.l={type:u.g,id:(0,T.$Rg)()}}get definition(){return this.l}set definition(F){if(F==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=F}get scope(){return this.m}set target(F){this.B(),this.m=F}get name(){return this.o}set name(F){if(typeof F!="string")throw(0,N.$7)("name");this.B(),this.o=F}get execution(){return this.q}set execution(F){F===null&&(F=void 0),this.B(),this.q=F;const te=this.l.type;(u.g===te||u.e===te||u.f===te||u.c===te)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(F){if(Array.isArray(F))this.B(),this.r=F,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.B(),this.u=F}get source(){return this.w}set source(F){if(typeof F!="string"||F.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=F}get group(){return this.x}set group(F){F===null&&(F=void 0),this.B(),this.x=F}get detail(){return this.A}set detail(F){F===null&&(F=void 0),this.A=F}get presentationOptions(){return this.y}set presentationOptions(F){F==null&&(F=Object.create(null)),this.B(),this.y=F}get runOptions(){return this.z}set runOptions(F){F==null&&(F=Object.create(null)),this.B(),this.z=F}};e.$MN=Ht,e.$MN=Ht=u=Je([b],Ht);var ni;(function(B){B[B.SourceControl=1]="SourceControl",B[B.Window=10]="Window",B[B.Notification=15]="Notification"})(ni||(e.ProgressLocation=ni={}));var Nt;(function(B){function F(te){const De=te;return(0,g.$_f)(De.value)?De.tooltip&&!(0,g.$8f)(De.tooltip)?(console.log("INVALID view badge, invalid tooltip",De.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",De.value),!1)}B.isViewBadge=F})(Nt||(e.ViewBadge=Nt={}));let Rt=D=class{static isTreeItem(F,te){const De=F;if(De.checkboxState!==void 0){const Ke=(0,g.$_f)(De.checkboxState)?De.checkboxState:(0,g.$0f)(De.checkboxState)&&(0,g.$_f)(De.checkboxState.state)?De.checkboxState.state:void 0,Xe=!(0,g.$_f)(De.checkboxState)&&(0,g.$0f)(De.checkboxState)?De.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Xe!==void 0&&!(0,g.$8f)(Xe))return console.log("INVALID tree item, invalid checkboxState",De.checkboxState),!1}if(F instanceof D)return!0;if(De.label!==void 0&&!(0,g.$8f)(De.label)&&!De.label?.label)return console.log("INVALID tree item, invalid label",De.label),!1;if(De.id!==void 0&&!(0,g.$8f)(De.id))return console.log("INVALID tree item, invalid id",De.id),!1;if(De.iconPath!==void 0&&!(0,g.$8f)(De.iconPath)&&!E.URI.isUri(De.iconPath)&&(!De.iconPath||!(0,g.$8f)(De.iconPath.id))){const Ke=De.iconPath;if(!Ke||!(0,g.$8f)(Ke.light)&&!E.URI.isUri(Ke.light)&&!(0,g.$8f)(Ke.dark)&&!E.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",De.iconPath),!1}return De.description!==void 0&&!(0,g.$8f)(De.description)&&typeof De.description!="boolean"?(console.log("INVALID tree item, invalid description",De.description),!1):De.resourceUri!==void 0&&!E.URI.isUri(De.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",De.resourceUri),!1):De.tooltip!==void 0&&!(0,g.$8f)(De.tooltip)&&!(De.tooltip instanceof Oe)?(console.log("INVALID tree item, invalid tooltip",De.tooltip),!1):De.command!==void 0&&!De.command.command?(console.log("INVALID tree item, invalid command",De.command),!1):De.collapsibleState!==void 0&&De.collapsibleState<Ct.None&&De.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",De.collapsibleState),!1):De.contextValue!==void 0&&!(0,g.$8f)(De.contextValue)?(console.log("INVALID tree item, invalid contextValue",De.contextValue),!1):De.accessibilityInformation!==void 0&&!De.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",De.accessibilityInformation),!1):!0}constructor(F,te=Ct.None){this.collapsibleState=te,E.URI.isUri(F)?this.resourceUri=F:this.label=F}};e.$NN=Rt,e.$NN=Rt=D=Je([b],Rt);var Ct;(function(B){B[B.None=0]="None",B[B.Collapsed=1]="Collapsed",B[B.Expanded=2]="Expanded"})(Ct||(e.TreeItemCollapsibleState=Ct={}));var Dt;(function(B){B[B.Unchecked=0]="Unchecked",B[B.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let pt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F){this.value=F}};e.$ON=pt,e.$ON=pt=Je([b],pt);class St extends pt{}e.$PN=St;class li extends St{#e;constructor(F){super(""),this.#e=F}asFile(){return this.#e}}e.$QN=li;class kt{constructor(F,te,De,Ke){this.name=F,this.uri=te,this._itemId=De,this.c=Ke}data(){return this.c()}}e.$RN=kt;let hi=class{#e=new Map;constructor(F){for(const[te,De]of F??[]){const Ke=this.#e.get(this.#t(te));Ke?Ke.push(De):this.#e.set(this.#t(te),[De])}}get(F){return this.#e.get(this.#t(F))?.[0]}set(F,te){this.#e.set(this.#t(F),[te])}forEach(F,te){for(const[De,Ke]of this.#e)for(const Xe of Ke)F.call(te,Xe,De,this)}*[Symbol.iterator](){for(const[F,te]of this.#e)for(const De of te)yield[F,De]}#t(F){return F.toLowerCase()}};e.$SN=hi,e.$SN=hi=Je([b],hi);let Kt=class{constructor(F,te,De){this.insertText=F,this.title=te,this.kind=De}};e.$TN=Kt,e.$TN=Kt=Je([b],Kt);var wi;(function(B){B[B.Automatic=0]="Automatic",B[B.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class ei{static{this.c="."}constructor(F){this.value=F}append(...F){return new ei((this.value?[this.value,...F]:F).join(ei.c))}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+ei.c)}}e.$UN=ei,ei.Empty=new ei("");class bi{constructor(F,te,De){this.title=te,this.insertText=F,this.kind=De}}e.$VN=bi;let yt=class{constructor(F,te){this.id=F,this.color=te}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};e.$WN=yt,e.$WN=yt=Je([b],yt),yt.File=new yt("file"),yt.Folder=new yt("folder");let $i=class{constructor(F){this.id=F}};e.$XN=$i,e.$XN=$i=Je([b],$i);var be;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.WorkspaceFolder=3]="WorkspaceFolder"})(be||(e.ConfigurationTarget=be={}));let Se=class{get base(){return this.c}set base(F){this.c=F,this.e=E.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,te){if(typeof F!="string"&&(!F||!E.URI.isUri(F)&&!E.URI.isUri(F.uri)))throw(0,N.$7)("base");if(typeof te!="string")throw(0,N.$7)("pattern");typeof F=="string"?this.baseUri=E.URI.file(F):E.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=te}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$YN=Se,e.$YN=Se=Je([b],Se);const oe=new WeakMap;function J(B,F){oe.set(B,F)}let ke=class{constructor(F,te,De,Ke,Xe){this.enabled=typeof F=="boolean"?F:!0,typeof te=="string"&&(this.condition=te),typeof De=="string"&&(this.hitCondition=De),typeof Ke=="string"&&(this.logMessage=Ke),typeof Xe=="string"&&(this.mode=Xe)}get id(){return this.c||(this.c=oe.get(this)??(0,T.$Rg)()),this.c}};e.$1N=ke,e.$1N=ke=Je([b],ke);let Ve=class extends ke{constructor(F,te,De,Ke,Xe,ht){if(super(te,De,Ke,Xe,ht),F===null)throw(0,N.$7)("location");this.location=F}};e.$2N=Ve,e.$2N=Ve=Je([b],Ve);let Qe=class extends ke{constructor(F,te,De,Ke,Xe,ht){super(te,De,Ke,Xe,ht),this.functionName=F}};e.$3N=Qe,e.$3N=Qe=Je([b],Qe);let qe=class extends ke{constructor(F,te,De,Ke,Xe,ht,$t,Jt){if(super(Ke,Xe,ht,$t,Jt),!te)throw(0,N.$7)("dataId");this.label=F,this.dataId=te,this.canPersist=De}};e.$4N=qe,e.$4N=qe=Je([b],qe);let ut=class{constructor(F,te,De){this.command=F,this.args=te||[],this.options=De}};e.$5N=ut,e.$5N=ut=Je([b],ut);let Et=class{constructor(F,te){this.port=F,this.host=te}};e.$6N=Et,e.$6N=Et=Je([b],Et);let Ft=class{constructor(F){this.path=F}};e.$7N=Ft,e.$7N=Ft=Je([b],Ft);let Vt=class{constructor(F){this.implementation=F}};e.$8N=Vt,e.$8N=Vt=Je([b],Vt);class ct{constructor(F,te,De){this.session=F,this.threadId=te,this.frameId=De}}e.$9N=ct;class ri{constructor(F,te){this.session=F,this.threadId=te}}e.$0N=ri;let di=class{constructor(F,te){this.range=F,this.expression=te}};e.$$N=di,e.$$N=di=Je([b],di);var pi;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(pi||(e.InlineCompletionTriggerKind=pi={}));let Si=class{constructor(F,te){this.range=F,this.text=te}};e.$_N=Si,e.$_N=Si=Je([b],Si);let Ai=class{constructor(F,te,De=!0){this.range=F,this.variableName=te,this.caseSensitiveLookup=De}};e.$aO=Ai,e.$aO=Ai=Je([b],Ai);let Mi=class{constructor(F,te){this.range=F,this.expression=te}};e.$bO=Mi,e.$bO=Mi=Je([b],Mi);let Ni=class{constructor(F,te){this.frameId=F,this.stoppedLocation=te}};e.$cO=Ni,e.$cO=Ni=Je([b],Ni);var Ti;(function(B){B[B.AIGenerated=1]="AIGenerated"})(Ti||(e.NewSymbolNameTag=Ti={}));class cn{constructor(F,te){this.newSymbolName=F,this.tags=te}}e.$dO=cn;var Oi;(function(B){B[B.Changed=1]="Changed",B[B.Created=2]="Created",B[B.Deleted=3]="Deleted"})(Oi||(e.FileChangeType=Oi={}));let Fi=f=class extends Error{static FileExists(F){return new f(F,l.FileSystemProviderErrorCode.FileExists,f.FileExists)}static FileNotFound(F){return new f(F,l.FileSystemProviderErrorCode.FileNotFound,f.FileNotFound)}static FileNotADirectory(F){return new f(F,l.FileSystemProviderErrorCode.FileNotADirectory,f.FileNotADirectory)}static FileIsADirectory(F){return new f(F,l.FileSystemProviderErrorCode.FileIsADirectory,f.FileIsADirectory)}static NoPermissions(F){return new f(F,l.FileSystemProviderErrorCode.NoPermissions,f.NoPermissions)}static Unavailable(F){return new f(F,l.FileSystemProviderErrorCode.Unavailable,f.Unavailable)}constructor(F,te=l.FileSystemProviderErrorCode.Unknown,De){super(E.URI.isUri(F)?F.toString(!0):F),this.code=De?.name??"Unknown",(0,l.$el)(this,te),Object.setPrototypeOf(this,f.prototype),typeof Error.captureStackTrace=="function"&&typeof De=="function"&&Error.captureStackTrace(this,De)}};e.$eO=Fi,e.$eO=Fi=f=Je([b],Fi);let yi=class{constructor(F,te,De){this.start=F,this.end=te,this.kind=De}};e.$fO=yi,e.$fO=yi=Je([b],yi);var Ii;(function(B){B[B.Comment=1]="Comment",B[B.Imports=2]="Imports",B[B.Region=3]="Region"})(Ii||(e.FoldingRangeKind=Ii={}));var Hi;(function(B){B[B.Collapsed=0]="Collapsed",B[B.Expanded=1]="Expanded"})(Hi||(e.CommentThreadCollapsibleState=Hi={}));var Ki;(function(B){B[B.Editing=0]="Editing",B[B.Preview=1]="Preview"})(Ki||(e.CommentMode=Ki={}));var vi;(function(B){B[B.Published=0]="Published",B[B.Draft=1]="Draft"})(vi||(e.CommentState=vi={}));var Ji;(function(B){B[B.Unresolved=0]="Unresolved",B[B.Resolved=1]="Resolved"})(Ji||(e.CommentThreadState=Ji={}));var Yi;(function(B){B[B.Current=0]="Current",B[B.Outdated=1]="Outdated"})(Yi||(e.CommentThreadApplicability=Yi={}));class un{constructor(F,te=[]){this.tokenTypes=F,this.tokenModifiers=te}}e.$gO=un;function Li(B){return typeof B>"u"||(0,g.$9f)(B)}class zi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,F){this.m=!0;for(let te=0,De=F.tokenTypes.length;te<De;te++)this.k.set(F.tokenTypes[te],te);for(let te=0,De=F.tokenModifiers.length;te<De;te++)this.l.set(F.tokenModifiers[te],te)}}push(F,te,De,Ke,Xe){if(typeof F=="number"&&typeof te=="number"&&typeof De=="number"&&typeof Ke=="number"&&(typeof Xe=="number"||typeof Xe>"u"))return typeof Xe>"u"&&(Xe=0),this.q(F,te,De,Ke,Xe);if(q.isRange(F)&&typeof te=="string"&&Li(De))return this.o(F,te,De);throw(0,N.$7)()}o(F,te,De){if(!this.m)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(te))throw new Error("`tokenType` is not in the provided legend");const Ke=F.start.line,Xe=F.start.character,ht=F.end.character-F.start.character,$t=this.k.get(te);let Jt=0;if(De)for(const ci of De){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const fi=this.l.get(ci);Jt|=1<<fi>>>0}this.q(Ke,Xe,ht,$t,Jt)}q(F,te,De,Ke,Xe){if(this.f&&(F<this.c||F===this.c&&te<this.e)){this.f=!1;const Jt=this.g.length/5|0;let ci=0,fi=0;for(let gi=0;gi<Jt;gi++){let mi=this.g[5*gi],qi=this.g[5*gi+1];mi===0?(mi=ci,qi+=fi):mi+=ci,this.g[5*gi]=mi,this.g[5*gi+1]=qi,ci=mi,fi=qi}}let ht=F,$t=te;this.f&&this.j>0&&(ht-=this.c,ht===0&&($t-=this.e)),this.g[this.j++]=ht,this.g[this.j++]=$t,this.g[this.j++]=De,this.g[this.j++]=Ke,this.g[this.j++]=Xe,this.c=F,this.e=te}static r(F){const te=[],De=F.length/5|0;for(let $t=0;$t<De;$t++)te[$t]=$t;te.sort(($t,Jt)=>{const ci=F[5*$t],fi=F[5*Jt];if(ci===fi){const gi=F[5*$t+1],mi=F[5*Jt+1];return gi-mi}return ci-fi});const Ke=new Uint32Array(F.length);let Xe=0,ht=0;for(let $t=0;$t<De;$t++){const Jt=5*te[$t],ci=F[Jt+0],fi=F[Jt+1],gi=F[Jt+2],mi=F[Jt+3],qi=F[Jt+4],Mn=ci-Xe,ur=Mn===0?fi-ht:fi,Gi=5*$t;Ke[Gi+0]=Mn,Ke[Gi+1]=ur,Ke[Gi+2]=gi,Ke[Gi+3]=mi,Ke[Gi+4]=qi,Xe=ci,ht=fi}return Ke}build(F){return this.f?new Pi(new Uint32Array(this.g),F):new Pi(zi.r(this.g),F)}}e.$hO=zi;class Pi{constructor(F,te){this.resultId=te,this.data=F}}e.$iO=Pi;class ln{constructor(F,te,De){this.start=F,this.deleteCount=te,this.data=De}}e.$jO=ln;class Qi{constructor(F,te){this.resultId=te,this.edits=F}}e.$kO=Qi;var Zi;(function(B){B[B.Separate=0]="Separate",B[B.MergeWithParent=1]="MergeWithParent"})(Zi||(e.DebugConsoleMode=Zi={}));class hn{constructor(F){this.name=F}}e.$lO=hn;let Ui=class{static{this.Back={iconPath:new yt("arrow-left")}}constructor(){}};e.$mO=Ui,e.$mO=Ui=Je([b],Ui);var Xi;(function(B){B[B.Separator=-1]="Separator",B[B.Default=0]="Default"})(Xi||(e.QuickPickItemKind=Xi={}));var Ci;(function(B){B[B.Info=1]="Info",B[B.Warning=2]="Warning",B[B.Error=3]="Error"})(Ci||(e.InputBoxValidationSeverity=Ci={}));var ji;(function(B){B[B.UI=1]="UI",B[B.Workspace=2]="Workspace"})(ji||(e.ExtensionKind=ji={}));class Ue{static validate(F){if(typeof F.badge=="string"){let te=(0,p.$Hf)(F.badge,0);if(te<F.badge.length&&(te+=(0,p.$Hf)(F.badge,te)),F.badge.length>te)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!yt.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,te,De){this.badge=F,this.tooltip=te,this.color=De}}e.$nO=Ue;let oi=class{constructor(F){this.kind=F}};e.$oO=oi,e.$oO=oi=Je([b],oi);var Bi;(function(B){B[B.Light=1]="Light",B[B.Dark=2]="Dark",B[B.HighContrast=3]="HighContrast",B[B.HighContrastLight=4]="HighContrastLight"})(Bi||(e.ColorThemeKind=Bi={}));class xe{static isNotebookRange(F){return F instanceof xe?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,te){if(F<0)throw(0,N.$7)("start must be positive");if(te<0)throw(0,N.$7)("end must be positive");F<=te?(this.c=F,this.e=te):(this.c=te,this.e=F)}with(F){let te=this.c,De=this.e;return F.start!==void 0&&(te=F.start),F.end!==void 0&&(De=F.end),te===this.c&&De===this.e?this:new xe(te,De)}}e.$pO=xe;class vt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(te=>vt.isNotebookCellData(te))}static isNotebookCellData(F){return!0}constructor(F,te,De,Ke,Xe,ht,$t){this.kind=F,this.value=te,this.languageId=De,this.mime=Ke,this.outputs=Xe??[],this.metadata=ht,this.executionSummary=$t,vt.validate(this)}}e.$qO=vt;class dn{constructor(F){this.cells=F}}e.$rO=dn;class ai{static isNotebookCellOutputItem(F){return F instanceof ai?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const te={name:F.name,message:F.message,stack:F.stack};return ai.json(te,"application/vnd.code.notebook.error")}static stdout(F){return ai.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return ai.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,te="application/octet-stream"){return new ai(F,te)}static#e=new TextEncoder;static text(F,te=M.$Ps.text){const De=ai.#e.encode(String(F));return new ai(De,te)}static json(F,te="text/x-json"){const De=JSON.stringify(F,void 0,"	");return ai.text(De,te)}constructor(F,te){this.data=F,this.mime=te;const De=(0,M.$Ts)(te,!0);if(!De)throw new Error(`INVALID mime type: ${te}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=De}}e.$sO=ai;class Ei{static isNotebookCellOutput(F){return F instanceof Ei?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,te=!1){const De=new Set,Ke=new Set;for(let Xe=0;Xe<F.length;Xe++){const ht=F[Xe],$t=(0,M.$Ts)(ht.mime);if(!De.has($t)||(0,m.$VK)($t)){De.add($t);continue}Ke.add(Xe),te&&console.warn(`DUPLICATED mime type '${ht.mime}' will be dropped`)}return Ke.size===0?F:F.filter((Xe,ht)=>!Ke.has(ht))}constructor(F,te,De){this.items=Ei.ensureUniqueMimeTypes(F,!0),typeof te=="string"?(this.id=te,this.metadata=De):(this.id=(0,T.$Rg)(),this.metadata=te??De)}}e.$tO=Ei;var xi;(function(B){B[B.Markup=1]="Markup",B[B.Code=2]="Code"})(xi||(e.NotebookCellKind=xi={}));var Di;(function(B){B[B.Idle=1]="Idle",B[B.Pending=2]="Pending",B[B.Executing=3]="Executing"})(Di||(e.NotebookCellExecutionState=Di={}));var _i;(function(B){B[B.Left=1]="Left",B[B.Right=2]="Right"})(_i||(e.NotebookCellStatusBarAlignment=_i={}));var en;(function(B){B[B.Default=0]="Default",B[B.InCenter=1]="InCenter",B[B.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",B[B.AtTop=3]="AtTop"})(en||(e.NotebookEditorRevealType=en={}));class fn{constructor(F,te){this.text=F,this.alignment=te}}e.$uO=fn;var Vi;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred"})(Vi||(e.NotebookControllerAffinity=Vi={}));var tn;(function(B){B[B.Default=1]="Default",B[B.Preferred=2]="Preferred",B[B.Hidden=-1]="Hidden"})(tn||(e.NotebookControllerAffinity2=tn={}));class gn{constructor(F,te=[]){this.uri=F,this.provides=(0,S.$3b)(te)}}e.$vO=gn;class mn{constructor(F){this.label=F}}e.$wO=mn;var nn;(function(B){B[B.Named=1]="Named",B[B.Indexed=2]="Indexed"})(nn||(e.NotebookVariablesRequestKind=nn={}));let Wi=class{constructor(F,te){this.label=F,this.timestamp=te}};e.$xO=Wi,e.$xO=Wi=Je([b],Wi);var rn;(function(B){B[B.Production=1]="Production",B[B.Development=2]="Development",B[B.Test=3]="Test"})(rn||(e.ExtensionMode=rn={}));var sn;(function(B){B[B.Node=1]="Node",B[B.Webworker=2]="Webworker"})(sn||(e.ExtensionRuntime=sn={}));var on;(function(B){B[B.Other=0]="Other",B[B.Comment=1]="Comment",B[B.String=2]="String",B[B.RegEx=3]="RegEx"})(on||(e.StandardTokenType=on={}));class $n{constructor(F,te){this.ranges=F,this.wordPattern=te}}e.$yO=$n;class pn{constructor(F){this.c=F}get autoForwardAction(){return this.c}}e.$zO=pn;var an;(function(B){B[B.Queued=1]="Queued",B[B.Running=2]="Running",B[B.Passed=3]="Passed",B[B.Failed=4]="Failed",B[B.Skipped=5]="Skipped",B[B.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var _;(function(B){B[B.Run=1]="Run",B[B.Debug=2]="Debug",B[B.Coverage=3]="Coverage"})(_||(e.TestRunProfileKind=_={}));let se=class{constructor(F=void 0,te=void 0,De=void 0,Ke=!1){this.include=F,this.exclude=te,this.profile=De,this.continuous=Ke}};e.$AO=se,e.$AO=se=Je([b],se);let Le=k=class{static diff(F,te,De){const Ke=new k(F);return Ke.expectedOutput=te,Ke.actualOutput=De,Ke}constructor(F){this.message=F}};e.$BO=Le,e.$BO=Le=k=Je([b],Le);let rt=class{constructor(F){this.id=F}};e.$CO=rt,e.$CO=rt=Je([b],rt);class bt{constructor(F,te){this.covered=F,this.total=te,Mt(this)}}e.$DO=bt;function Mt(B){if(B){if(B.covered>B.total)throw new Error(`The total number of covered items (${B.covered}) cannot be greater than the total (${B.total})`);if(B.total<0)throw new Error(`The number of covered items (${B.total}) cannot be negative`)}}class ki{static fromDetails(F,te){const De=new bt(0,0),Ke=new bt(0,0),Xe=new bt(0,0);for(const $t of te)if("branches"in $t){De.total+=1,De.covered+=$t.executed?1:0;for(const Jt of $t.branches)Ke.total+=1,Ke.covered+=Jt.executed?1:0}else Xe.total+=1,Xe.covered+=$t.executed?1:0;const ht=new ki(F,De,Ke.total>0?Ke:void 0,Xe.total>0?Xe:void 0);return ht.detailedCoverage=te,ht}constructor(F,te,De,Ke){this.uri=F,this.statementCoverage=te,this.branchCoverage=De,this.declarationCoverage=Ke}}e.$FO=ki;class Nn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De=[]){this.executed=F,this.location=te,this.branches=De}}e.$GO=Nn;class Tn{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.executed=F,this.location=te,this.label=De}}e.$HO=Tn;class On{get executionCount(){return+this.executed}set executionCount(F){this.executed=F}constructor(F,te,De){this.name=F,this.executed=te,this.location=De}}e.$IO=On;var vn;(function(B){B[B.None=0]="None",B[B.Option=1]="Option",B[B.Default=2]="Default",B[B.Preferred=3]="Preferred"})(vn||(e.ExternalUriOpenerPriority=vn={}));var wn;(function(B){B[B.Untrusted=0]="Untrusted",B[B.Trusted=1]="Trusted",B[B.Unspecified=2]="Unspecified"})(wn||(e.WorkspaceTrustState=wn={}));var bn;(function(B){B[B.Notify=1]="Notify",B[B.OpenBrowser=2]="OpenBrowser",B[B.OpenPreview=3]="OpenPreview",B[B.Silent=4]="Silent",B[B.Ignore=5]="Ignore",B[B.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class Fn{constructor(F,te,De,Ke,Xe,ht){this.kind=F,this.name=te,this.detail=De,this.uri=Ke,this.range=Xe,this.selectionRange=ht}}e.$JO=Fn;class Ln{constructor(F){this.uri=F}}e.$KO=Ln;class zn{constructor(F,te){this.original=F,this.modified=te}}e.$LO=zn;class Un{constructor(F,te,De,Ke){this.base=F,this.input1=te,this.input2=De,this.result=Ke}}e.$MO=Un;class jn{constructor(F,te){this.uri=F,this.viewType=te}}e.$NO=jn;class Bn{constructor(F){this.viewType=F}}e.$OO=Bn;class Vn{constructor(F,te){this.uri=F,this.notebookType=te}}e.$PO=Vn;class Wn{constructor(F,te,De){this.original=F,this.modified=te,this.notebookType=De}}e.$QO=Wn;class qn{constructor(){}}e.$RO=qn;class Gn{constructor(F,te){this.uri=F,this.inputBoxUri=te}}e.$SO=Gn;class Hn{constructor(){}}e.$TO=Hn;class Kn{constructor(F){this.textDiffs=F}}e.$UO=Kn;var yn;(function(B){B[B.Down=0]="Down",B[B.Up=1]="Up"})(yn||(e.InteractiveSessionVoteDirection=yn={}));var En;(function(B){B[B.Action=1]="Action",B[B.Toolbar=2]="Toolbar"})(En||(e.ChatCopyKind=En={}));var Dn;(function(B){B[B.Short=1]="Short",B[B.Medium=2]="Medium",B[B.Full=3]="Full"})(Dn||(e.ChatVariableLevel=Dn={}));class Jn{constructor(F,te){this.label=F,this.values=te}}e.$VO=Jn;var kn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful",B[B.Undone=2]="Undone",B[B.Accepted=3]="Accepted",B[B.Bug=4]="Bug"})(kn||(e.InteractiveEditorResponseFeedbackKind=kn={}));var Sn;(function(B){B[B.Unhelpful=0]="Unhelpful",B[B.Helpful=1]="Helpful"})(Sn||(e.ChatResultFeedbackKind=Sn={}));class Yn{constructor(F){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Oe(F):F}}e.$WO=Yn;class Qn{constructor(F,te){if(typeof F!="string"&&F.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof F=="string"?new Oe(F):F,this.vulnerabilities=te}}e.$XO=Qn;class Zn{constructor(F,te){this.participant=F,this.command=te}}e.$YO=Zn;class Xn{constructor(F,te){this.value=F,this.baseUri=te}}e.$ZO=Xn;class xn{constructor(F,te){this.value=F,this.title=te}}e.$1O=xn;class _n{constructor(F){this.value=F}}e.$2O=_n;class er{constructor(F){this.value=F}}e.$3O=er;class tr{constructor(F){this.value=F}}e.$4O=tr;class ir{constructor(F,te){this.uri=F,this.edits=Array.isArray(te)?te:[te]}}e.$5O=ir;class nr{constructor(F,te,De,Ke){this.prompt=F,this.command=te,this.variables=De,this.participant=Ke}}e.$6O=nr;class rr{constructor(F,te,De,Ke){this.response=F,this.result=te,this.participant=De,this.command=Ke}}e.$7O=rr;var In;(function(B){B[B.Panel=1]="Panel",B[B.Terminal=2]="Terminal",B[B.Notebook=3]="Notebook",B[B.Editor=4]="Editor"})(In||(e.ChatLocation=In={}));class sr{constructor(F){this.content=F}}e.$8O=sr;class or{constructor(F,te){this.content=F,this.name=te}}e.$9O=or;class ar{constructor(F,te){this.content=F,this.name=te}}e.$0O=ar;class Ri extends Error{static NotFound(F){return new Ri(F,Ri.NotFound.name)}static NoPermissions(F){return new Ri(F,Ri.NoPermissions.name)}constructor(F,te,De){super(F,{cause:De}),this.name="LanguageModelError",this.code=te??""}}e.$$O=Ri;var Pn;(function(B){B[B.SymbolInformation=1]="SymbolInformation",B[B.CommandInformation=2]="CommandInformation",B[B.SearchInformation=3]="SearchInformation",B[B.SettingInformation=4]="SettingInformation"})(Pn||(e.RelatedInformationType=Pn={}));var Cn;(function(B){B[B.Started=1]="Started",B[B.Recognizing=2]="Recognizing",B[B.Recognized=3]="Recognized",B[B.Stopped=4]="Stopped",B[B.Error=5]="Error"})(Cn||(e.SpeechToTextStatus=Cn={}));var Rn;(function(B){B[B.Recognized=1]="Recognized",B[B.Stopped=2]="Stopped"})(Rn||(e.KeywordRecognitionStatus=Rn={}));class cr{constructor(F,te){this.text=F,this.range=te}}e.$_O=cr;var An;(function(B){B[B.Invoke=0]="Invoke",B[B.Automatic=1]="Automatic"})(An||(e.InlineEditTriggerKind=An={}))}),define(Ce[246],Ae([1,0,4,7]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Skc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(S.$YM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(M,p,g){if(this.a.size===0)throw new Error("No related information providers registered");const E=this.a.get(M);if(!E)throw new Error("related information provider not found");return await E.provideRelatedInformation(p,g)??[]}getRelatedInformation(M,p,g){return this.c.$getAiRelatedInformation(p,g)}registerRelatedInformationProvider(M,p,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiRelatedInformationProvider(E,p),new N.$1M(()=>{this.c.$unregisterAiRelatedInformationProvider(E),this.a.delete(E)})}}e.$Skc=R}),define(Ce[84],Ae([1,0,5,4,7,20,106,3,16]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5kc=e.$4kc=void 0,e.$4kc=(0,p.$vi)("IExtHostAuthentication");let E=class{constructor(l){this.b=new Map,this.c=new S.$ee,this.onDidChangeSessions=this.c.event,this.d=new T,this.f=new T,this.a=l.getProxy(N.$YM.MainThreadAuthentication)}async getSession(l,w,m,s={}){const o=O.$Qm.toKey(l.identifier),r=[...m].sort().join(" ");return await this.d.getOrCreate(`${o} ${w} ${r}`,async()=>{await this.a.$ensureProvider(w);const t=l.displayName||l.name;return this.a.$getSession(w,m,o,t,s)})}async getSessions(l,w,m){const s=O.$Qm.toKey(l.identifier),o=[...m].sort().join(" ");return await this.f.getOrCreate(`${s} ${o}`,async()=>{await this.a.$ensureProvider(w);const r=l.displayName||l.name;return this.a.$getSessions(w,m,s,r)})}async removeSession(l,w){const m=this.b.get(l);return m?m.provider.removeSession(w):this.a.$removeSession(l,w)}registerAuthenticationProvider(l,w,m,s){if(this.b.get(l))throw new Error(`An authentication provider with id '${l}' is already registered.`);this.b.set(l,{label:w,provider:m,options:s??{supportsMultipleAccounts:!1}});const o=m.onDidChangeSessions(r=>this.a.$sendDidChangeSessions(l,r));return this.a.$registerAuthenticationProvider(l,w,s?.supportsMultipleAccounts??!1),new R.$1M(()=>{o.dispose(),this.b.delete(l),this.a.$unregisterAuthenticationProvider(l)})}$createSession(l,w,m){const s=this.b.get(l);if(s)return Promise.resolve(s.provider.createSession(w,m));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$removeSession(l,w){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.removeSession(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$getSessions(l,w){const m=this.b.get(l);if(m)return Promise.resolve(m.provider.getSessions(w));throw new Error(`Unable to find authentication provider with handle: ${l}`)}$onDidChangeAuthenticationSessions(l,w){return l.startsWith(M.$1L)||this.c.fire({provider:{id:l,label:w}}),Promise.resolve()}};e.$5kc=E,e.$5kc=E=Je([We(0,g.$lP)],E);class T{constructor(){this.a=new Map}getOrCreate(l,w){const m=this.a.get(l);if(m)return m;const s=w().finally(()=>this.a.delete(l));return this.a.set(l,s),s}}}),define(Ce[110],Ae([1,0,2,4,7,3,16,13,18,15,19,26]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$5lc=e.$4lc=void 0;let w=class{static{l=this}static{this.c=0}static{this.d=250}constructor(s,o){this.h=o,this.f=new Map,this.g=s.getProxy(N.$YM.MainThreadDecorations)}registerFileDecorationProvider(s,o){const r=l.c++;this.f.set(r,{provider:s,extensionDescription:o}),this.g.$registerDecorationProvider(r,o.identifier.value);const t=s.onDidChangeFileDecorations&&s.onDidChangeFileDecorations(n=>{if(!n){this.g.$onDidChange(r,null);return}const c=(0,g.$3b)(n);if(c.length<=l.d){this.g.$onDidChange(r,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",o.identifier.value,c.length);const h=c.map(a=>({uri:a,rank:(0,E.$af)(a.path,"/")})),i=(0,g.$zb)(h,(a,v)=>a.rank-v.rank||(0,E.$qf)(a.uri.path,v.uri.path)),$=[];e:for(const a of i){let v;for(const d of a){const C=(0,T.$nc)(d.uri.path);if(v!==C&&(v=C,$.push(d.uri)>=l.d))break e}}this.g.$onDidChange(r,$)});return new R.$1M(()=>{t?.dispose(),this.g.$unregisterDecorationProvider(r),this.f.delete(r)})}async $provideDecorations(s,o,r){if(!this.f.has(s))return Object.create(null);const t=Object.create(null),{provider:n,extensionDescription:c}=this.f.get(s);return await Promise.all(o.map(async h=>{try{const{uri:i,id:$}=h,a=await Promise.resolve(n.provideFileDecoration(S.URI.revive(i),r));if(!a)return;try{R.$nO.validate(a),a.badge&&typeof a.badge!="string"&&(0,y.$GG)(c,"codiconDecoration"),t[$]=[a.propagate,a.tooltip,a.badge,a.color]}catch(v){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${v}`)}}catch(i){this.h.error(i)}})),t}};e.$4lc=w,e.$4lc=w=l=Je([We(0,M.$lP),We(1,p.$2j)],w),e.$5lc=(0,O.$vi)("IExtHostDecorations")}),define(Ce[247],Ae([1,0,14,2,7,4,12,24,15]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class E{static{this.a=0}constructor(y,l,w){this.d=l,this.e=w,this.b=new Map,this.c=y.getProxy(O.$YM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,l){if(Object.keys(M.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const w=E.a++;this.b.set(w,l),this.c.$registerTextContentProvider(w,y);let m;if(typeof l.onDidChange=="function"){let s;m=l.onDidChange(async o=>{if(o.scheme!==y){this.e.warn(`Provider for scheme '${y}' is firing event for schema '${o.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(o))return;s&&await s;const r=this.$provideTextDocumentContent(w,o).then(async t=>{if(!t&&typeof t!="string")return;const n=this.d.getDocument(o);if(!n)return;const c=(0,g.$kf)(t);if(!n.equalLines(c))return this.c.$onVirtualDocumentChange(o,t)}).catch(S.$1).finally(()=>{s===r&&(s=void 0)});s=r})}return new R.$1M(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),m&&(m.dispose(),m=void 0)})}$provideTextDocumentContent(y,l){const w=this.b.get(y);return w?Promise.resolve(w.provideTextDocumentContent(N.URI.revive(l),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${l.scheme}`))}}e.$7lc=E}),define(Ce[111],Ae([1,0,56,12,15,302,152,7,18]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pP=e.$oP=void 0,e.$nP=T;const E=new Map;function T(m,s){s?E.set(m,s):E.delete(m)}function y(m){return E.get(m)}class l extends O.$Yv{constructor(s,o,r,t,n,c,h){super(o,r,t,n),this.c=s,this.m=c,this.q=h,this.b=!1}dispose(){(0,S.ok)(!this.b),this.b=!0,this.q=!1}equalLines(s){return(0,g.$ub)(this.f,s)}get document(){if(!this.a){const s=this;this.a={get uri(){return s.d},get fileName(){return s.d.fsPath},get isUntitled(){return s.d.scheme===N.Schemas.untitled},get languageId(){return s.m},get version(){return s.h},get isClosed(){return s.b},get isDirty(){return s.q},save(){return s.r()},getText(o){return o?s.s(o):s.getText()},get eol(){return s.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return s.f.length},lineAt(o){return s.t(o)},offsetAt(o){return s.u(o)},positionAt(o){return s.v(o)},validateRange(o){return s.w(o)},validatePosition(o){return s.x(o)},getWordRangeAtPosition(o,r){return s.y(o,r)}}}return Object.freeze(this.a)}_acceptLanguageId(s){(0,S.ok)(!this.b),this.m=s}_acceptIsDirty(s){(0,S.ok)(!this.b),this.q=s}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(s){const o=this.w(s);if(o.isEmpty)return"";if(o.isSingleLine)return this.f[o.start.line].substring(o.start.character,o.end.character);const r=this.g,t=o.start.line,n=o.end.line,c=[];c.push(this.f[t].substring(o.start.character));for(let h=t+1;h<n;h++)c.push(this.f[h]);return c.push(this.f[n].substring(0,o.end.character)),c.join(r)}t(s){let o;if(s instanceof p.$2M?o=s.line:typeof s=="number"&&(o=s),typeof o!="number"||o<0||o>=this.f.length||Math.floor(o)!==o)throw new Error("Illegal value for `line`");return new w(o,this.f[o],o===this.f.length-1)}u(s){return s=this.x(s),this.l(),this.j.getPrefixSum(s.line-1)+s.character}v(s){s=Math.floor(s),s=Math.max(0,s),this.l();const o=this.j.getIndexOf(s),r=this.f[o.index].length;return new p.$2M(o.index,Math.min(o.remainder,r))}w(s){if(!(s instanceof p.$3M))throw new Error("Invalid argument");const o=this.x(s.start),r=this.x(s.end);return o===s.start&&r===s.end?s:new p.$3M(o.line,o.character,r.line,r.character)}x(s){if(!(s instanceof p.$2M))throw new Error("Invalid argument");if(this.f.length===0)return s.with(0,0);let{line:o,character:r}=s,t=!1;if(o<0)o=0,r=0,t=!0;else if(o>=this.f.length)o=this.f.length-1,r=this.f[o].length,t=!0;else{const n=this.f[o].length;r<0?(r=0,t=!0):r>n&&(r=n,t=!0)}return t?new p.$2M(o,r):s}y(s,o){const r=this.x(s);if(!o)o=y(this.m);else if((0,R.$jf)(o))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${o.source}' because it matches the empty string.`);const t=(0,M.$8s)(r.character+1,(0,M.$6s)(o),this.f[r.line],0);if(t)return new p.$3M(r.line,t.startColumn-1,r.line,t.endColumn-1)}}e.$oP=l;class w{constructor(s,o,r){this.a=s,this.b=o,this.c=r}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$3M(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$3M(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$pP=w}),define(Ce[248],Ae([1,0,4,7]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9lc=void 0;class R{constructor(M){this.a=new Map,this.b=0,this.c=M.getProxy(S.$YM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(M,p,g){if(this.a.size===0)throw new Error("No embedding vector providers registered");const E=this.a.get(M);if(!E)throw new Error("Embedding vector provider not found");const T=await E.provideEmbeddingVector(p,g);if(!T)throw new Error("Embedding vector provider returned undefined");return T}registerEmbeddingVectorProvider(M,p,g){const E=this.b;return this.b++,this.a.set(E,g),this.c.$registerAiEmbeddingVectorProvider(p,E),new N.$1M(()=>{this.c.$unregisterAiEmbeddingVectorProvider(E),this.a.delete(E)})}}e.$9lc=R}),define(Ce[64],Ae([1,0,4,44,7,22,3,16,45,6,11,23,12]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$ilc=e.$hlc=void 0;let m=w=class{constructor(o,r){this.b=new Map,this.c=new T.$Eh,this.a=o.getProxy(S.$YM.MainThreadFileSystem);const t=this;this.value=Object.freeze({async stat(n){try{let c;const h=t.b.get(n.scheme);return h?(await t.a.$ensureActivation(n.scheme),c=await h.impl.stat(n)):c=await t.a.$stat(n),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===N.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(n){try{const c=t.b.get(n.scheme);return c?(await t.a.$ensureActivation(n.scheme),(await c.impl.readDirectory(n)).slice()):await t.a.$readdir(n)}catch(c){return w.e(c)}},async createDirectory(n){try{const c=t.b.get(n.scheme);return c&&!c.isReadonly?(await t.a.$ensureActivation(n.scheme),await t.d(c.impl,c.extUri,n)):await t.a.$mkdir(n)}catch(c){return w.e(c)}},async readFile(n){try{const c=t.b.get(n.scheme);return c?(await t.a.$ensureActivation(n.scheme),(await c.impl.readFile(n)).slice()):(await t.a.$readFile(n)).buffer}catch(c){return w.e(c)}},async writeFile(n,c){try{const h=t.b.get(n.scheme);return h&&!h.isReadonly?(await t.a.$ensureActivation(n.scheme),await t.d(h.impl,h.extUri,h.extUri.dirname(n)),await t.c.queueFor(n,()=>Promise.resolve(h.impl.writeFile(n,c,{create:!0,overwrite:!0})))):await t.a.$writeFile(n,O.$Fe.wrap(c))}catch(h){return w.e(h)}},async delete(n,c){try{const h=t.b.get(n.scheme);return h&&!h.isReadonly&&!c?.useTrash?(await t.a.$ensureActivation(n.scheme),await h.impl.delete(n,{recursive:!1,...c})):await t.a.$delete(n,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(h){return w.e(h)}},async rename(n,c,h){try{return await t.a.$rename(n,c,{overwrite:!1,...h})}catch(i){return w.e(i)}},async copy(n,c,h){try{return await t.a.$copy(n,c,{overwrite:!1,...h})}catch(i){return w.e(i)}},isWritableFileSystem(n){const c=r.getCapabilities(n);if(typeof c=="number")return!(c&2048)}})}async d(o,r,t){const n=[];for(;!r.isEqual(t,r.dirname(t));)try{if(!((await o.stat(t)).type&N.FileType.Directory))throw R.$eO.FileExists(`Unable to create folder '${t.scheme===l.Schemas.file?t.fsPath:t.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(N.$fl(c)!==N.FileSystemProviderErrorCode.FileNotFound)throw c;n.push(r.basename(t)),t=r.dirname(t)}for(let c=n.length-1;c>=0;c--){t=r.joinPath(t,n[c]);try{await o.createDirectory(t)}catch(h){if(N.$fl(h)!==N.FileSystemProviderErrorCode.FileExists)throw h}}}static e(o){if(o instanceof R.$eO)throw o;if(o instanceof N.$bl)switch(o.code){case N.FileSystemProviderErrorCode.FileExists:throw R.$eO.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$eO.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$eO.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$eO.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$eO.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$eO.Unavailable(o.message);default:throw new R.$eO(o.message,o.name)}if(!(o instanceof Error))throw new R.$eO(String(o));if(o.name==="ENOPRO"||o.message.includes("ENOPRO"))throw R.$eO.Unavailable(o.message);switch(o.name){case N.FileSystemProviderErrorCode.FileExists:throw R.$eO.FileExists(o.message);case N.FileSystemProviderErrorCode.FileNotFound:throw R.$eO.FileNotFound(o.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw R.$eO.FileNotADirectory(o.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw R.$eO.FileIsADirectory(o.message);case N.FileSystemProviderErrorCode.NoPermissions:throw R.$eO.NoPermissions(o.message);case N.FileSystemProviderErrorCode.Unavailable:throw R.$eO.Unavailable(o.message);default:throw new R.$eO(o.message,o.name)}}addFileSystemProvider(o,r,t){return this.b.set(o,{impl:r,extUri:t?.isCaseSensitive?y.$Yg:y.$1g,isReadonly:!!t?.isReadonly}),(0,E.$Tc)(()=>this.b.delete(o))}getFileSystemProviderExtUri(o){return this.b.get(o)?.extUri??y.$Yg}};e.$hlc=m,e.$hlc=m=w=Je([We(0,p.$lP),We(1,g.$Xkc)],m),e.$ilc=(0,M.$vi)("IExtHostConsumerFileSystem")}),define(Ce[85],Ae([1,0,3,27,13,64,2]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$klc=e.$jlc=void 0,e.$jlc=(0,S.$vi)("IExtensionStoragePaths");let p=class{constructor(E,T,y){this.d=T,this.f=y,this.a=E.workspace??void 0,this.b=E.environment,this.whenReady=this.h().then(l=>this.c=l)}async g(E){return M.URI.joinPath(this.b.workspaceStorageHome,E)}async h(){if(!this.a)return Promise.resolve(void 0);const E=this.a.id,T=await this.g(E);try{return await this.f.value.stat(T),this.d.trace("[ExtHostStorage] storage dir already exists",T),T}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",T),await this.f.value.createDirectory(T),await this.f.value.writeFile(M.URI.joinPath(T,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:M.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),T}catch(y){this.d.error("[ExtHostStorage]",y);return}}workspaceValue(E){if(this.c)return M.URI.joinPath(this.c,E.identifier.value)}globalValue(E){return M.URI.joinPath(this.b.globalStorageHome,E.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$klc=p,e.$klc=p=Je([We(0,N.$BP),We(1,R.$2j),We(2,O.$ilc)],p)}),define(Ce[249],Ae([1,0,7,16,5]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=void 0;let O=class{constructor(p){this.a=new S.$oO(S.ColorThemeKind.Dark),this.b=new R.$ee}get activeColorTheme(){return this.a}$onColorThemeChange(p){let g;switch(p){case"light":g=S.ColorThemeKind.Light;break;case"hcDark":g=S.ColorThemeKind.HighContrast;break;case"hcLight":g=S.ColorThemeKind.HighContrastLight;break;default:g=S.ColorThemeKind.Dark}this.a=new S.$oO(g),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Rmc=O,e.$Rmc=O=Je([We(0,N.$lP)],O)}),define(Ce[86],Ae([1,0,24,5,6,173,3,13,203,4,27,16,7]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aDb=e.$_Cb=e.TunnelDtoConverter=void 0;class w extends g.$lw{}var m;(function(o){function r(n){return{remoteAddress:n.remoteAddress,localAddress:n.localAddress,public:!!n.public,privacy:n.privacy??(n.public?g.TunnelPrivacyId.Public:g.TunnelPrivacyId.Private),protocol:n.protocol}}o.fromApiTunnel=r;function t(n){return{remoteAddress:{host:n.tunnelRemoteHost,port:n.tunnelRemotePort},localAddress:n.localAddress,public:n.privacy!==g.TunnelPrivacyId.ConstantPrivate&&n.privacy!==g.TunnelPrivacyId.ConstantPrivate,privacy:n.privacy,protocol:n.protocol}}o.fromServiceTunnel=t})(m||(e.TunnelDtoConverter=m={})),e.$_Cb=(0,M.$vi)("IExtHostTunnelService");let s=class extends R.$Vc{constructor(r,t,n){super(),this.s=n,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$ee,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=r.getProxy(E.$YM.MainThreadTunnelService)}async openTunnel(r,t){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${r.identifier.value} called openTunnel API for ${t.remoteAddress.host}:${t.remoteAddress.port}.`);const n=await this.a.$openTunnel(t,r.displayName);if(n){const c=new w(n.remoteAddress,n.localAddress,()=>this.a.$closeTunnel(n.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(r,t){r.portRange===void 0&&r.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const n=this.u();return this.r.set(n,{selector:r,provider:t}),this.a.$registerPortsAttributesProvider(r,n),new l.$1M(()=>{this.r.delete(n),this.a.$unregisterPortsAttributesProvider(n)})}async $providePortAttributes(r,t,n,c,h){const i=[];for(const a of r){const v=this.r.get(a);if(!v)return[];i.push(...await Promise.all(t.map(async d=>{let C;try{C=await v.provider.providePortAttributes({port:d,pid:n,commandLine:c},h)}catch{C=await v.provider.providePortAttributes(d,n,c,h)}return{providedAttributes:C,port:d}})))}const $=i.filter(a=>!!a.providedAttributes);return $.length>0?$.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(r){}registerTunnelProvider(r,t){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,h)=>await r.provideTunnel(c,h,S.CancellationToken.None)??void 0;const n=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,privacyOptions:t.tunnelFeatures?.privacyOptions,protocol:t.tunnelFeatures.protocol===void 0?!0:t.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(n),Promise.resolve((0,R.$Tc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(r,t){if(r){r.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(r.candidatePortSource),r.showCandidatePort&&(this.f=r.showCandidatePort,this.a.$setCandidateFilter());const n=r.tunnelFactory??(t?this.w(t):void 0);if(n){this.b=n;let c=r.tunnelFeatures?.privacyOptions??[];r.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:O.localize(0,null),themeIcon:"lock"},{id:"public",label:O.localize(1,null),themeIcon:"eye"}]);const h=r.tunnelFeatures?{elevation:!!r.tunnelFeatures?.elevation,public:!!r.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(h)}}else this.b=void 0;return(0,R.$Tc)(()=>{this.b=void 0})}w(r){}async $closeTunnel(r,t){if(this.g.has(r.host)){const n=this.g.get(r.host);n.has(r.port)&&(t&&n.get(r.port).disposeListener.dispose(),await n.get(r.port).tunnel.dispose(),n.delete(r.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(r,t){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const n=this.b(r,t);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),n!==void 0){const c=await n;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(r.remoteAddress.host)||this.g.set(r.remoteAddress.host,new Map);const h=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(r.remoteAddress.host).set(r.remoteAddress.port,{tunnel:c,disposeListener:h}),m.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(n){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),n instanceof Error)return n.message}}async $applyCandidateFilter(r){const t=await Promise.all(r.map(c=>this.f(c.host,c.port,c.detail??""))),n=r.filter((c,h)=>t[h]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${r.map(c=>c.port).join(", ")} to ${n.map(c=>c.port).join(", ")}`),n}};e.$aDb=s,e.$aDb=s=Je([We(0,y.$lP),We(1,T.$BP),We(2,p.$2j)],s)}),define(Ce[8],Ae([1,0,18,22,132,250,54,28,124,53,69,25,127,23,17,2,29,87,100,105,104,213,83,50,61,224,7]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$,a,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentResolvedVariable=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.LanguageModelMessage=e.ChatInlineFollowup=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$iP=j,e.$jP=re,e.$kP=ae;var C;(function(be){function Se(J){const{selectionStartLineNumber:ke,selectionStartColumn:Ve,positionLineNumber:Qe,positionColumn:qe}=J,ut=new d.$2M(ke-1,Ve-1),Et=new d.$2M(Qe-1,qe-1);return new d.$4M(ut,Et)}be.to=Se;function oe(J){const{anchor:ke,active:Ve}=J;return{selectionStartLineNumber:ke.line+1,selectionStartColumn:ke.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}be.from=oe})(C||(e.Selection=C={}));var u;(function(be){function Se(J){if(!J)return;const{start:ke,end:Ve}=J;return{startLineNumber:ke.line+1,startColumn:ke.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}be.from=Se;function oe(J){if(!J)return;const{startLineNumber:ke,startColumn:Ve,endLineNumber:Qe,endColumn:qe}=J;return new d.$3M(ke-1,Ve-1,Qe-1,qe-1)}be.to=oe})(u||(e.Range=u={}));var D;(function(be){function Se(J){return{uri:J.uri,range:u.from(J.range)}}be.from=Se;function oe(J){return new d.$aN(s.URI.revive(J.uri),u.to(J.range))}be.to=oe})(D||(e.Location=D={}));var f;(function(be){function Se(oe){switch(oe){case 1:return d.StandardTokenType.Comment;case 0:return d.StandardTokenType.Other;case 3:return d.StandardTokenType.RegEx;case 2:return d.StandardTokenType.String}}be.to=Se})(f||(e.TokenType=f={}));var k;(function(be){function Se(J){return new d.$2M(J.lineNumber-1,J.column-1)}be.to=Se;function oe(J){return{lineNumber:J.line+1,column:J.character+1}}be.from=oe})(k||(e.Position=k={}));var b;(function(be){function Se(ke,Ve,Qe){return(0,S.$Hb)((0,S.$3b)(ke).map(qe=>oe(qe,Ve,Qe)))}be.from=Se;function oe(ke,Ve,Qe){if(typeof ke=="string")return{$serialized:!0,language:ke,isBuiltin:Qe?.isBuiltin};if(ke)return{$serialized:!0,language:ke.language,scheme:J(ke.scheme,Ve),pattern:Q.from(ke.pattern)??void 0,exclusive:ke.exclusive,notebookType:ke.notebookType,isBuiltin:Qe?.isBuiltin}}function J(ke,Ve){return Ve&&typeof ke=="string"?Ve.transformOutgoingScheme(ke):ke}})(b||(e.DocumentSelector=b={}));var P;(function(be){function Se(J){switch(J){case d.DiagnosticTag.Unnecessary:return 1;case d.DiagnosticTag.Deprecated:return 2}}be.from=Se;function oe(J){switch(J){case 1:return d.DiagnosticTag.Unnecessary;case 2:return d.DiagnosticTag.Deprecated;default:return}}be.to=oe})(P||(e.DiagnosticTag=P={}));var I;(function(be){function Se(J){let ke;return J.code&&((0,m.$8f)(J.code)||(0,m.$_f)(J.code)?ke=String(J.code):ke={value:String(J.code.value),target:J.code.target}),{...u.from(J.range),message:J.message,source:J.source,code:ke,severity:V.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,S.$Hb)(J.tags.map(P.from)):void 0}}be.from=Se;function oe(J){const ke=new d.$cN(u.to(J),J.message,V.to(J.severity));return ke.source=J.source,ke.code=(0,m.$8f)(J.code)?J.code:J.code?.value,ke.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),ke.tags=J.tags&&(0,S.$Hb)(J.tags.map(P.to)),ke}be.to=oe})(I||(e.Diagnostic=I={}));var W;(function(be){function Se(J){return{...u.from(J.location.range),message:J.message,resource:J.location.uri}}be.from=Se;function oe(J){return new d.$bN(new d.$aN(J.resource,u.to(J)),J.message)}be.to=oe})(W||(e.DiagnosticRelatedInformation=W={}));var V;(function(be){function Se(J){switch(J){case d.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case d.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case d.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case d.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}be.from=Se;function oe(J){switch(J){case t.MarkerSeverity.Info:return d.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return d.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return d.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return d.DiagnosticSeverity.Hint;default:return d.DiagnosticSeverity.Error}}be.to=oe})(V||(e.DiagnosticSeverity=V={}));var q;(function(be){function Se(J){return typeof J=="number"&&J>=d.ViewColumn.One?J-1:J===d.ViewColumn.Beside?v.$WD:v.$VD}be.from=Se;function oe(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}be.to=oe})(q||(e.ViewColumn=q={}));function A(be){return typeof be.range<"u"}function j(be){return be.length===0?!0:!!A(be[0])}var K;(function(be){function Se(qe){return qe.map(be.from)}be.fromMany=Se;function oe(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(oe(qe)){const{language:ct,value:ri}=qe;ut={value:"```"+ct+`
`+ri+"\n```\n"}}else d.$pN.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const Et=Object.create(null);ut.uris=Et;const Ft=ct=>{try{let ri=s.URI.parse(ct,!0);ri=ri.with({query:ke(ri.query,Et)}),Et[ct]=ri}catch{}return""},Vt=new g.marked.Renderer;return Vt.link=Ft,Vt.image=ct=>typeof ct=="string"?Ft(M.$1k(ct).href):"",(0,g.marked)(ut.value,{renderer:Vt}),ut}be.from=J;function ke(qe,ut){if(!qe)return qe;let Et;try{Et=(0,E.$4h)(qe)}catch{}if(!Et)return qe;let Ft=!1;return Et=(0,y.$4n)(Et,Vt=>{if(s.URI.isUri(Vt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[ct]=Vt,Ft=!0,ct}else return}),Ft?JSON.stringify(Et):qe}function Ve(qe){const ut=new d.$pN(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?s.URI.from(qe.baseUri):void 0,ut}be.to=Ve;function Qe(qe){if(qe)return typeof qe=="string"?qe:be.from(qe)}be.fromStrict=Qe})(K||(e.MarkdownString=K={}));function re(be){return j(be)?be.map(Se=>({range:u.from(Se.range),hoverMessage:Array.isArray(Se.hoverMessage)?K.fromMany(Se.hoverMessage):Se.hoverMessage?K.from(Se.hoverMessage):void 0,renderOptions:Se.renderOptions})):be.map(Se=>({range:u.from(Se)}))}function ae(be){return typeof be>"u"?be:typeof be=="string"?s.URI.file(be):be}var we;(function(be){function Se(oe){return typeof oe>"u"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?ae(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}be.from=Se})(we||(e.ThemableDecorationAttachmentRenderOptions=we={}));var Ie;(function(be){function Se(oe){return typeof oe>"u"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?we.from(oe.before):void 0,after:oe.after?we.from(oe.after):void 0}}be.from=Se})(Ie||(e.ThemableDecorationRenderOptions=Ie={}));var de;(function(be){function Se(oe){if(typeof oe>"u")return oe;switch(oe){case d.DecorationRangeBehavior.OpenOpen:return 0;case d.DecorationRangeBehavior.ClosedClosed:return 1;case d.DecorationRangeBehavior.OpenClosed:return 2;case d.DecorationRangeBehavior.ClosedOpen:return 3}}be.from=Se})(de||(e.DecorationRangeBehavior=de={}));var me;(function(be){function Se(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?de.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?Ie.from(oe.light):void 0,dark:oe.dark?Ie.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?ae(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?we.from(oe.before):void 0,after:oe.after?we.from(oe.after):void 0}}be.from=Se})(me||(e.DecorationRenderOptions=me={}));var Me;(function(be){function Se(J){return{text:J.newText,eol:J.newEol&&at.from(J.newEol),range:u.from(J.range)}}be.from=Se;function oe(J){const ke=new d.$8M(u.to(J.range),J.text);return ke.newEol=typeof J.eol>"u"?void 0:at.to(J.eol),ke}be.to=oe})(Me||(e.TextEdit=Me={}));var ce;(function(be){function Se(J,ke){const Ve={edits:[]};if(J instanceof d.$$M){const Qe=new p.$Cc;for(const qe of J._allEntries())qe._type===1&&s.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$Ze)(N.$Fe.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:Me.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:u.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:ke?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:ke?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(Ut.from)}})}return Ve}be.from=Se;function oe(J){const ke=new d.$$M,Ve=new p.$Bc;for(const Qe of J.edits)if(Qe.textEdit){const qe=Qe,ut=s.URI.revive(qe.resource),Et=u.to(qe.textEdit.range),Ft=qe.textEdit.text,Vt=qe.textEdit.insertAsSnippet;let ct;Vt?ct=d.$0M.replace(Et,new d.$_M(Ft)):ct=d.$8M.replace(Et,Ft);const ri=Ve.get(ut);ri?ri.push(ct):Ve.set(ut,[ct])}else ke.renameFile(s.URI.revive(Qe.oldResource),s.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of Ve)ke.set(Qe,qe);return ke}be.to=oe})(ce||(e.WorkspaceEdit=ce={}));var Re;(function(be){const Se=Object.create(null);Se[d.SymbolKind.File]=0,Se[d.SymbolKind.Module]=1,Se[d.SymbolKind.Namespace]=2,Se[d.SymbolKind.Package]=3,Se[d.SymbolKind.Class]=4,Se[d.SymbolKind.Method]=5,Se[d.SymbolKind.Property]=6,Se[d.SymbolKind.Field]=7,Se[d.SymbolKind.Constructor]=8,Se[d.SymbolKind.Enum]=9,Se[d.SymbolKind.Interface]=10,Se[d.SymbolKind.Function]=11,Se[d.SymbolKind.Variable]=12,Se[d.SymbolKind.Constant]=13,Se[d.SymbolKind.String]=14,Se[d.SymbolKind.Number]=15,Se[d.SymbolKind.Boolean]=16,Se[d.SymbolKind.Array]=17,Se[d.SymbolKind.Object]=18,Se[d.SymbolKind.Key]=19,Se[d.SymbolKind.Null]=20,Se[d.SymbolKind.EnumMember]=21,Se[d.SymbolKind.Struct]=22,Se[d.SymbolKind.Event]=23,Se[d.SymbolKind.Operator]=24,Se[d.SymbolKind.TypeParameter]=25;function oe(ke){return typeof Se[ke]=="number"?Se[ke]:6}be.from=oe;function J(ke){for(const Ve in Se)if(Se[Ve]===ke)return Number(Ve);return d.SymbolKind.Property}be.to=J})(Re||(e.SymbolKind=Re={}));var ie;(function(be){function Se(J){switch(J){case d.SymbolTag.Deprecated:return 1}}be.from=Se;function oe(J){switch(J){case 1:return d.SymbolTag.Deprecated}}be.to=oe})(ie||(e.SymbolTag=ie={}));var L;(function(be){function Se(J){return{name:J.name,kind:Re.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:pe.from(J.location)}}be.from=Se;function oe(J){const ke=new d.$gN(J.name,Re.to(J.kind),J.containerName,pe.to(J.location));return ke.tags=J.tags&&J.tags.map(ie.to),ke}be.to=oe})(L||(e.WorkspaceSymbol=L={}));var x;(function(be){function Se(J){const ke={name:J.name||"!!MISSING: name!!",detail:J.detail,range:u.from(J.range),selectionRange:u.from(J.selectionRange),kind:Re.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(ke.children=J.children.map(Se)),ke}be.from=Se;function oe(J){const ke=new d.$hN(J.name,J.detail,Re.to(J.kind),u.to(J.range),u.to(J.selectionRange));return(0,S.$Lb)(J.tags)&&(ke.tags=J.tags.map(ie.to)),J.children&&(ke.children=J.children.map(oe)),ke}be.to=oe})(x||(e.DocumentSymbol=x={}));var ve;(function(be){function Se(J){const ke=new d.$lN(Re.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),u.to(J.range),u.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,name:J.name,detail:J.detail,kind:Re.from(J.kind),uri:J.uri,range:u.from(J.range),selectionRange:u.from(J.selectionRange),tags:J.tags?.map(ie.from)}}be.from=oe})(ve||(e.CallHierarchyItem=ve={}));var Fe;(function(be){function Se(oe){return new d.$mN(ve.to(oe.from),oe.fromRanges.map(J=>u.to(J)))}be.to=Se})(Fe||(e.CallHierarchyIncomingCall=Fe={}));var Ee;(function(be){function Se(oe){return new d.$nN(ve.to(oe.to),oe.fromRanges.map(J=>u.to(J)))}be.to=Se})(Ee||(e.CallHierarchyOutgoingCall=Ee={}));var pe;(function(be){function Se(J){return{range:J.range&&u.from(J.range),uri:J.uri}}be.from=Se;function oe(J){return new d.$aN(s.URI.revive(J.uri),u.to(J.range))}be.to=oe})(pe||(e.location=pe={}));var fe;(function(be){function Se(J){const ke=J,Ve=J;return{originSelectionRange:ke.originSelectionRange?u.from(ke.originSelectionRange):void 0,uri:ke.targetUri?ke.targetUri:Ve.uri,range:u.from(ke.targetRange?ke.targetRange:Ve.range),targetSelectionRange:ke.targetSelectionRange?u.from(ke.targetSelectionRange):void 0}}be.from=Se;function oe(J){return{targetUri:s.URI.revive(J.uri),targetRange:u.to(J.range),targetSelectionRange:J.targetSelectionRange?u.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?u.to(J.originSelectionRange):void 0}}be.to=oe})(fe||(e.DefinitionLink=fe={}));var Y;(function(be){function Se(J){return{range:u.from(J.range),contents:K.fromMany(J.contents)}}be.from=Se;function oe(J){return new d.$dN(J.contents.map(K.to),u.to(J.range))}be.to=oe})(Y||(e.Hover=Y={}));var X;(function(be){function Se(J){return{range:u.from(J.range),expression:J.expression}}be.from=Se;function oe(J){return new d.$$N(u.to(J.range),J.expression)}be.to=oe})(X||(e.EvaluatableExpression=X={}));var le;(function(be){function Se(J){if(J instanceof d.$_N)return{type:"text",range:u.from(J.range),text:J.text};if(J instanceof d.$aO)return{type:"variable",range:u.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof d.$bO)return{type:"expression",range:u.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}be.from=Se;function oe(J){switch(J.type){case"text":return{range:u.to(J.range),text:J.text};case"variable":return{range:u.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:u.to(J.range),expression:J.expression}}}be.to=oe})(le||(e.InlineValue=le={}));var ue;(function(be){function Se(J){return{frameId:J.frameId,stoppedLocation:u.from(J.stoppedLocation)}}be.from=Se;function oe(J){return new d.$cO(J.frameId,u.to(J.stoppedLocation))}be.to=oe})(ue||(e.InlineValueContext=ue={}));var Te;(function(be){function Se(J){return{range:u.from(J.range),kind:J.kind}}be.from=Se;function oe(J){return new d.$eN(u.to(J.range),J.kind)}be.to=oe})(Te||(e.DocumentHighlight=Te={}));var he;(function(be){function Se(J){return{uri:J.uri,highlights:J.highlights.map(Te.from)}}be.from=Se;function oe(J){return new d.$fN(s.URI.revive(J.uri),J.highlights.map(Te.to))}be.to=oe})(he||(e.MultiDocumentHighlight=he={}));var Pe;(function(be){function Se(oe){switch(oe){case 1:return d.CompletionTriggerKind.TriggerCharacter;case 2:return d.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return d.CompletionTriggerKind.Invoke}}be.to=Se})(Pe||(e.CompletionTriggerKind=Pe={}));var Ne;(function(be){function Se(oe){return{triggerKind:Pe.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}be.to=Se})(Ne||(e.CompletionContext=Ne={}));var ze;(function(be){function Se(J){switch(J){case d.CompletionItemTag.Deprecated:return 1}}be.from=Se;function oe(J){switch(J){case 1:return d.CompletionItemTag.Deprecated}}be.to=oe})(ze||(e.CompletionItemTag=ze={}));var U;(function(be){const Se=new Map([[d.CompletionItemKind.Method,0],[d.CompletionItemKind.Function,1],[d.CompletionItemKind.Constructor,2],[d.CompletionItemKind.Field,3],[d.CompletionItemKind.Variable,4],[d.CompletionItemKind.Class,5],[d.CompletionItemKind.Interface,7],[d.CompletionItemKind.Struct,6],[d.CompletionItemKind.Module,8],[d.CompletionItemKind.Property,9],[d.CompletionItemKind.Unit,12],[d.CompletionItemKind.Value,13],[d.CompletionItemKind.Constant,14],[d.CompletionItemKind.Enum,15],[d.CompletionItemKind.EnumMember,16],[d.CompletionItemKind.Keyword,17],[d.CompletionItemKind.Snippet,27],[d.CompletionItemKind.Text,18],[d.CompletionItemKind.Color,19],[d.CompletionItemKind.File,20],[d.CompletionItemKind.Reference,21],[d.CompletionItemKind.Folder,23],[d.CompletionItemKind.Event,10],[d.CompletionItemKind.Operator,11],[d.CompletionItemKind.TypeParameter,24],[d.CompletionItemKind.Issue,26],[d.CompletionItemKind.User,25]]);function oe(Ve){return Se.get(Ve)??9}be.from=oe;const J=new Map([[0,d.CompletionItemKind.Method],[1,d.CompletionItemKind.Function],[2,d.CompletionItemKind.Constructor],[3,d.CompletionItemKind.Field],[4,d.CompletionItemKind.Variable],[5,d.CompletionItemKind.Class],[7,d.CompletionItemKind.Interface],[6,d.CompletionItemKind.Struct],[8,d.CompletionItemKind.Module],[9,d.CompletionItemKind.Property],[12,d.CompletionItemKind.Unit],[13,d.CompletionItemKind.Value],[14,d.CompletionItemKind.Constant],[15,d.CompletionItemKind.Enum],[16,d.CompletionItemKind.EnumMember],[17,d.CompletionItemKind.Keyword],[27,d.CompletionItemKind.Snippet],[18,d.CompletionItemKind.Text],[19,d.CompletionItemKind.Color],[20,d.CompletionItemKind.File],[21,d.CompletionItemKind.Reference],[23,d.CompletionItemKind.Folder],[10,d.CompletionItemKind.Event],[11,d.CompletionItemKind.Operator],[24,d.CompletionItemKind.TypeParameter],[25,d.CompletionItemKind.User],[26,d.CompletionItemKind.Issue]]);function ke(Ve){return J.get(Ve)??d.CompletionItemKind.Property}be.to=ke})(U||(e.CompletionItemKind=U={}));var z;(function(be){function Se(oe,J){const ke=new d.$vN(oe.label);return ke.insertText=oe.insertText,ke.kind=U.to(oe.kind),ke.tags=oe.tags?.map(ze.to),ke.detail=oe.detail,ke.documentation=M.$Uk(oe.documentation)?K.to(oe.documentation):oe.documentation,ke.sortText=oe.sortText,ke.filterText=oe.filterText,ke.preselect=oe.preselect,ke.commitCharacters=oe.commitCharacters,o.$tt.isIRange(oe.range)?ke.range=u.to(oe.range):typeof oe.range=="object"&&(ke.range={inserting:u.to(oe.range.insert),replacing:u.to(oe.range.replace)}),ke.keepWhitespace=typeof oe.insertTextRules>"u"?!1:!!(oe.insertTextRules&1),typeof oe.insertTextRules<"u"&&oe.insertTextRules&4?ke.insertText=new d.$_M(oe.insertText):(ke.insertText=oe.insertText,ke.textEdit=ke.range instanceof d.$3M?new d.$8M(ke.range,ke.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(ke.additionalTextEdits=oe.additionalTextEdits.map(Ve=>Me.to(Ve))),ke.command=J&&oe.command?J.fromInternal(oe.command):void 0,ke}be.to=Se})(z||(e.CompletionItem=z={}));var H;(function(be){function Se(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:K.fromStrict(J.documentation)}}be.from=Se;function oe(J){return{label:J.label,documentation:M.$Uk(J.documentation)?K.to(J.documentation):J.documentation}}be.to=oe})(H||(e.ParameterInformation=H={}));var G;(function(be){function Se(J){return{label:J.label,documentation:K.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(H.from):[],activeParameter:J.activeParameter}}be.from=Se;function oe(J){return{label:J.label,documentation:M.$Uk(J.documentation)?K.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(H.to):[],activeParameter:J.activeParameter}}be.to=oe})(G||(e.SignatureInformation=G={}));var ee;(function(be){function Se(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(G.from):[]}}be.from=Se;function oe(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(G.to):[]}}be.to=oe})(ee||(e.SignatureHelp=ee={}));var ne;(function(be){function Se(oe,J){const ke=new d.$uN(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Oe.to.bind(void 0,oe)),J.kind&&Be.to(J.kind));return ke.textEdits=J.textEdits&&J.textEdits.map(Me.to),ke.tooltip=M.$Uk(J.tooltip)?K.to(J.tooltip):J.tooltip,ke.paddingLeft=J.paddingLeft,ke.paddingRight=J.paddingRight,ke}be.to=Se})(ne||(e.InlayHint=ne={}));var Oe;(function(be){function Se(oe,J){const ke=new d.$tN(J.label);return ke.tooltip=M.$Uk(J.tooltip)?K.to(J.tooltip):J.tooltip,r.Command.is(J.command)&&(ke.command=oe.fromInternal(J.command)),J.location&&(ke.location=pe.to(J.location)),ke}be.to=Se})(Oe||(e.InlayHintLabelPart=Oe={}));var Be;(function(be){function Se(J){return J}be.from=Se;function oe(J){return J}be.to=oe})(Be||(e.InlayHintKind=Be={}));var Ye;(function(be){function Se(J){return{range:u.from(J.range),url:J.target,tooltip:J.tooltip}}be.from=Se;function oe(J){let ke;if(J.url)try{ke=typeof J.url=="string"?s.URI.parse(J.url,!0):s.URI.revive(J.url)}catch{}return new d.$AN(u.to(J.range),ke)}be.to=oe})(Ye||(e.DocumentLink=Ye={}));var _e;(function(be){function Se(J){const ke=new d.$DN(J.label);return J.textEdit&&(ke.textEdit=Me.to(J.textEdit)),J.additionalTextEdits&&(ke.additionalTextEdits=J.additionalTextEdits.map(Ve=>Me.to(Ve))),ke}be.to=Se;function oe(J){return{label:J.label,textEdit:J.textEdit?Me.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(ke=>Me.from(ke)):void 0}}be.from=oe})(_e||(e.ColorPresentation=_e={}));var et;(function(be){function Se(J){return new d.$BN(J[0],J[1],J[2],J[3])}be.to=Se;function oe(J){return[J.red,J.green,J.blue,J.alpha]}be.from=oe})(et||(e.Color=et={}));var tt;(function(be){function Se(J){return{range:u.from(J.range)}}be.from=Se;function oe(J){return new d.$kN(u.to(J.range))}be.to=oe})(tt||(e.SelectionRange=tt={}));var it;(function(be){function Se(oe){switch(oe){case 2:return d.TextDocumentSaveReason.AfterDelay;case 1:return d.TextDocumentSaveReason.Manual;case 3:case 4:return d.TextDocumentSaveReason.FocusOut}}be.to=Se})(it||(e.TextDocumentSaveReason=it={}));var nt;(function(be){function Se(J){switch(J){case d.TextEditorLineNumbersStyle.Off:return 0;case d.TextEditorLineNumbersStyle.Relative:return 2;case d.TextEditorLineNumbersStyle.Interval:return 3;case d.TextEditorLineNumbersStyle.On:default:return 1}}be.from=Se;function oe(J){switch(J){case 0:return d.TextEditorLineNumbersStyle.Off;case 2:return d.TextEditorLineNumbersStyle.Relative;case 3:return d.TextEditorLineNumbersStyle.Interval;case 1:default:return d.TextEditorLineNumbersStyle.On}}be.to=oe})(nt||(e.TextEditorLineNumbersStyle=nt={}));var at;(function(be){function Se(J){if(J===d.EndOfLine.CRLF)return 1;if(J===d.EndOfLine.LF)return 0}be.from=Se;function oe(J){if(J===1)return d.EndOfLine.CRLF;if(J===0)return d.EndOfLine.LF}be.to=oe})(at||(e.EndOfLine=at={}));var mt;(function(be){function Se(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case d.ProgressLocation.SourceControl:return 3;case d.ProgressLocation.Window:return 10;case d.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}be.from=Se})(mt||(e.ProgressLocation=mt={}));var je;(function(be){function Se(J){const ke={start:J.start+1,end:J.end+1};return J.kind&&(ke.kind=st.from(J.kind)),ke}be.from=Se;function oe(J){const ke={start:J.start-1,end:J.end-1};return J.kind&&(ke.kind=st.to(J.kind)),ke}be.to=oe})(je||(e.FoldingRange=je={}));var st;(function(be){function Se(J){if(J)switch(J){case d.FoldingRangeKind.Comment:return r.$cu.Comment;case d.FoldingRangeKind.Imports:return r.$cu.Imports;case d.FoldingRangeKind.Region:return r.$cu.Region}}be.from=Se;function oe(J){if(J)switch(J.value){case r.$cu.Comment.value:return d.FoldingRangeKind.Comment;case r.$cu.Imports.value:return d.FoldingRangeKind.Imports;case r.$cu.Region.value:return d.FoldingRangeKind.Region}}be.to=oe})(st||(e.FoldingRangeKind=st={}));var Z;(function(be){function Se(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?u.from(oe.selection):void 0,override:typeof oe.override=="boolean"?c.$mF.id:void 0}}be.from=Se})(Z||(e.TextEditorOpenOptions=Z={}));var Q;(function(be){function Se(Ve){return Ve instanceof d.$YN?Ve.toJSON():typeof Ve=="string"?Ve:oe(Ve)||J(Ve)?new d.$YN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}be.from=Se;function oe(Ve){const Qe=Ve;return Qe?s.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function J(Ve){const Qe=Ve;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function ke(Ve){return typeof Ve=="string"?Ve:new d.$YN(s.URI.revive(Ve.baseUri),Ve.pattern)}be.to=ke})(Q||(e.GlobPattern=Q={}));var $e;(function(be){function Se(oe){if(oe){if(Array.isArray(oe))return oe.map(Se);if(typeof oe=="string")return oe;{const J=oe;return{language:J.language,scheme:J.scheme,pattern:Q.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}be.from=Se})($e||(e.LanguageSelector=$e={}));var Ge;(function(be){function Se(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(ke=>Array.isArray(ke)&&ke.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&s.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Qe=>Qe instanceof d.$3M)))}be.is=Se;function oe(J){return{documents:J.documents.map(ke=>ke.map(Ve=>({uri:s.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Qe=>u.from(Qe))})))}}be.from=oe})(Ge||(e.MappedEditsContext=Ge={}));var ye;(function(be){function Se(J){return{start:J.start,end:J.end}}be.from=Se;function oe(J){return new d.$pO(J.start,J.end)}be.to=oe})(ye||(e.NotebookRange=ye={}));var ot;(function(be){function Se(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}be.to=Se;function oe(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}be.from=oe})(ot||(e.NotebookCellExecutionSummary=ot={}));var dt;(function(be){function Se(oe){if(oe===i.NotebookCellExecutionState.Unconfirmed)return d.NotebookCellExecutionState.Pending;if(oe===i.NotebookCellExecutionState.Pending)return;if(oe===i.NotebookCellExecutionState.Executing)return d.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${oe}`)}be.to=Se})(dt||(e.NotebookCellExecutionState=dt={}));var It;(function(be){function Se(J){switch(J){case d.NotebookCellKind.Markup:return i.CellKind.Markup;case d.NotebookCellKind.Code:default:return i.CellKind.Code}}be.from=Se;function oe(J){switch(J){case i.CellKind.Markup:return d.NotebookCellKind.Markup;case i.CellKind.Code:default:return d.NotebookCellKind.Code}}be.to=oe})(It||(e.NotebookCellKind=It={}));var Yt;(function(be){function Se(J){const ke={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)d.$qO.validate(Ve),ke.cells.push(Ut.from(Ve));return ke}be.from=Se;function oe(J){const ke=new d.$rO(J.cells.map(Ut.to));return(0,m.$ig)(J.metadata)||(ke.metadata=J.metadata),ke}be.to=oe})(Yt||(e.NotebookData=Yt={}));var Ut;(function(be){function Se(J){return{cellKind:It.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ot.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(_t.from):[]}}be.from=Se;function oe(J){return new d.$qO(It.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(_t.to):void 0,J.metadata,J.internalMetadata?ot.to(J.internalMetadata):void 0)}be.to=oe})(Ut||(e.NotebookCellData=Ut={}));var xt;(function(be){function Se(J){return{mime:J.mime,valueBytes:N.$Fe.wrap(J.data)}}be.from=Se;function oe(J){return new d.$sO(J.valueBytes.buffer,J.mime)}be.to=oe})(xt||(e.NotebookCellOutputItem=xt={}));var _t;(function(be){function Se(J){return{outputId:J.id,items:J.items.map(xt.from),metadata:J.metadata}}be.from=Se;function oe(J){const ke=J.items.map(xt.to);return new d.$tO(ke,J.outputId,J.metadata)}be.to=oe})(_t||(e.NotebookCellOutput=_t={}));var Pt;(function(be){function Se(ke){return J(ke)?{include:Q.from(ke.include)??void 0,exclude:Q.from(ke.exclude)??void 0}:Q.from(ke)??void 0}be.from=Se;function oe(ke){return J(ke)?{include:Q.to(ke.include),exclude:Q.to(ke.exclude)}:Q.to(ke)}be.to=oe;function J(ke){const Ve=ke;return Ve?!(0,m.$eg)(Ve.include)&&!(0,m.$eg)(Ve.exclude):!1}})(Pt||(e.NotebookExclusiveDocumentPattern=Pt={}));var Wt;(function(be){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===d.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,ke),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}be.from=Se})(Wt||(e.NotebookStatusBarItem=Wt={}));var Qt;(function(be){function Se(oe,J,ke){const Ve=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{command:J.toInternal(Ve,ke),label:oe.label,description:oe.description,detail:oe.detail,documentation:oe.documentation}}be.from=Se})(Qt||(e.NotebookKernelSourceAction=Qt={}));var Ze;(function(be){function Se(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{},cellContentMetadata:oe?.cellContentMetadata??{}}}be.from=Se})(Ze||(e.NotebookDocumentContentOptions=Ze={}));var si;(function(be){function Se(J){return{uri:J.uri,provides:J.provides}}be.from=Se;function oe(J){return new d.$vO(s.URI.revive(J.uri),J.provides)}be.to=oe})(si||(e.NotebookRendererScript=si={}));var Zt;(function(be){function Se(J){return{message:K.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:u.from(J.location.range),uri:J.location.uri}}}be.from=Se;function oe(J){const ke=new d.$BO(typeof J.message=="string"?J.message:K.to(J.message));return ke.actualOutput=J.actual,ke.expectedOutput=J.expected,ke.contextValue=J.contextValue,ke.location=J.location?pe.to(J.location):void 0,ke}be.to=oe})(Zt||(e.TestMessage=Zt={}));var lt;(function(be){be.namespace=a.$PL,be.denamespace=a.$QL})(lt||(e.TestTag=lt={}));var wt;(function(be){function Se(J){const ke=(0,n.$hP)(J).controllerId;return{extId:$.$KL.fromExtHostTestItem(J,ke).toString(),label:J.label,uri:s.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>lt.namespace(ke,Ve.id)),range:o.$tt.lift(u.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&K.fromStrict(J.error)||null}}be.from=Se;function oe(J){return{parent:void 0,error:void 0,id:$.$KL.fromString(J.extId).localId,label:J.label,uri:s.URI.revive(J.uri),tags:(J.tags||[]).map(ke=>{const{tagId:Ve}=lt.denamespace(ke);return new d.$CO(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}be.toPlain=oe})(wt||(e.TestItem=wt={})),function(be){function Se(J){return{id:J.id}}be.from=Se;function oe(J){return new d.$CO(J.id)}be.to=oe}(lt||(e.TestTag=lt={}));var ti;(function(be){const Se=(J,ke)=>{const Ve=J.value;if(!Ve)return;const Qe={...wt.toPlain(Ve.item),parent:ke,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(Zt.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Se(qe,Qe);ut&&Qe.children.push(ut)}return Qe};function oe(J){const ke=new l.$aP;for(const qe of J.items)ke.insert($.$KL.fromString(qe.item.extId).path,qe);const Ve=[ke.nodes],Qe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Qe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Qe.map(qe=>Se(qe)).filter(m.$dg)}}be.to=oe})(ti||(e.TestResults=ti={}));var Xt;(function(be){function Se(Ve){return{covered:Ve.covered,total:Ve.total}}function oe(Ve){return"line"in Ve?k.from(Ve):u.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:oe(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Qe=>({count:Qe.executed,location:Qe.location&&oe(Qe.location),label:Qe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:oe(Ve.location)}}be.fromDetails=J;function ke(Ve,Qe){return d.$EO(Qe.statementCoverage),d.$EO(Qe.branchCoverage),d.$EO(Qe.declarationCoverage),{id:Ve,uri:Qe.uri,statement:Se(Qe.statementCoverage),branch:Qe.branchCoverage&&Se(Qe.branchCoverage),declaration:Qe.declarationCoverage&&Se(Qe.declarationCoverage)}}be.fromFile=ke})(Xt||(e.TestCoverage=Xt={}));var Lt;(function(be){function Se(oe){switch(oe){case 1:return d.CodeActionTriggerKind.Invoke;case 2:return d.CodeActionTriggerKind.Automatic}}be.to=Se})(Lt||(e.CodeActionTriggerKind=Lt={}));var ft;(function(be){function Se(J){const ke=new d.$JO(Re.to(J.kind),J.name,J.detail||"",s.URI.revive(J.uri),u.to(J.range),u.to(J.selectionRange));return ke._sessionId=J._sessionId,ke._itemId=J._itemId,ke}be.to=Se;function oe(J,ke,Ve){if(ke=ke??J._sessionId,Ve=Ve??J._itemId,ke===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:ke,_itemId:Ve,kind:Re.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:u.from(J.range),selectionRange:u.from(J.selectionRange),tags:J.tags?.map(ie.from)}}be.from=oe})(ft||(e.TypeHierarchyItem=ft={}));var jt;(function(be){function Se(oe){if(oe)return{value:oe.value,tooltip:oe.tooltip}}be.from=Se})(jt||(e.ViewBadge=jt={}));var Bt;(function(be){function Se(Ve,Qe,qe){const ut=Qe.fileData;return ut?new d.$QN(new d.$RN(ut.name,s.URI.revive(ut.uri),ut.id,(0,O.$db)(()=>qe(ut.id)))):Ve===T.$Ps.uriList&&Qe.uriListData?new d.$PN(ke(Qe.uriListData)):new d.$PN(Qe.asString)}be.to=Se;async function oe(Ve,Qe){const qe=await Qe.asString();if(Ve===T.$Ps.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Qe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}be.from=oe;function J(Ve){return R.$Tt.split(Ve).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return s.URI.parse(Qe)}catch{}return Qe})}function ke(Ve){return R.$Tt.create(Ve.map(Qe=>typeof Qe=="string"?Qe:s.URI.revive(Qe)))}})(Bt||(e.DataTransferItem=Bt={}));var qt;(function(be){function Se(J,ke){const Ve=J.items.map(([Qe,qe])=>[Qe,Bt.to(Qe,qe,ke)]);return new d.$SN(Ve)}be.toDataTransfer=Se;async function oe(J){const ke={items:[]},Ve=[];for(const[Qe,qe]of J)Ve.push((async()=>{ke.items.push([Qe,await Bt.from(Qe,qe)])})());return await Promise.all(Ve),ke}be.from=oe})(qt||(e.DataTransfer=qt={}));var He;(function(be){function Se(J,ke){return{kind:"reply",agentId:J.participant??ke?.agentId??"",subCommand:J.command??ke?.command,message:J.prompt,title:J.label}}be.from=Se;function oe(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}be.to=oe})(He||(e.ChatFollowup=He={}));var ui;(function(be){function Se(oe){return"commandId"in oe?{kind:"command",title:oe.title??"",commandId:oe.commandId??"",when:oe.when??"",args:oe.args}:{kind:"reply",message:oe.message,title:oe.title,tooltip:oe.tooltip}}be.from=Se})(ui||(e.ChatInlineFollowup=ui={}));var Gt;(function(be){function Se(J){switch(J.role){case 0:return new d.$8O(J.content);case 1:return new d.$9O(J.content);case 2:return new d.$0O(J.content)}}be.to=Se;function oe(J){if(J instanceof d.$8O)return{role:0,content:J.content};if(J instanceof d.$9O)return{role:1,content:J.content};if(J instanceof d.$0O)return{role:2,content:J.content};throw new Error("Invalid LanguageModelMessage")}be.from=oe})(Gt||(e.LanguageModelMessage=Gt={}));var zt;(function(be){function Se(ke){const Ve={};for(const Qe of Object.keys(ke))Ve[Qe]=ke[Qe].map(be.to);return Ve}be.objectTo=Se;function oe(ke){return{level:gt.to(ke.level),kind:ke.kind,value:(0,s.$wc)(ke.value)?s.URI.revive(ke.value):ke.value,description:ke.description}}be.to=oe;function J(ke){return{level:gt.from(ke.level),kind:ke.kind,value:ke.value,description:ke.description}}be.from=J})(zt||(e.ChatVariable=zt={}));var gt;(function(be){function Se(J){switch(J){case"short":return d.ChatVariableLevel.Short;case"medium":return d.ChatVariableLevel.Medium;case"full":default:return d.ChatVariableLevel.Full}}be.to=Se;function oe(J){switch(J){case d.ChatVariableLevel.Short:return"short";case d.ChatVariableLevel.Medium:return"medium";case d.ChatVariableLevel.Full:default:return"full"}}be.from=oe})(gt||(e.ChatVariableLevel=gt={}));var Tt;(function(be){function Se(oe){switch(oe){case 1:return d.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return d.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return d.InteractiveEditorResponseFeedbackKind.Undone;case 3:return d.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return d.InteractiveEditorResponseFeedbackKind.Bug}}be.to=Se})(Tt||(e.InteractiveEditorResponseFeedbackKind=Tt={}));var At;(function(be){function Se(J){return{kind:"markdownContent",content:K.from(J.value)}}be.from=Se;function oe(J){return new d.$WO(K.to(J.content))}be.to=oe})(At||(e.ChatResponseMarkdownPart=At={}));var Ot;(function(be){function Se(J){return{kind:"markdownVuln",content:K.from(J.value),vulnerabilities:J.vulnerabilities}}be.from=Se;function oe(J){return new d.$XO(K.to(J.content),J.vulnerabilities)}be.to=oe})(Ot||(e.ChatResponseMarkdownWithVulnerabilitiesPart=Ot={}));var ii;(function(be){function Se(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}be.from=Se;function oe(J){return new d.$YO(J.agentId,J.command)}be.to=oe})(ii||(e.ChatResponseDetectedParticipantPart=ii={}));var Ht;(function(be){function Se(J){const{value:ke,baseUri:Ve}=J;function Qe(qe,ut){return qe.map(Et=>{const Ft=s.URI.joinPath(ut,Et.name);return{label:Et.name,uri:Ft,children:Et.children&&Qe(Et.children,Ft)}})}return{kind:"treeData",treeData:{label:(0,w.$6g)(Ve),uri:Ve,children:Qe(ke,Ve)}}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J.treeData);function Ve(ut){return ut.map(Et=>({name:Et.label,children:Et.children&&Ve(Et.children)}))}const Qe=ke.uri,qe=ke.children?Ve(ke.children):[];return new d.$ZO(qe,Qe)}be.to=oe})(Ht||(e.ChatResponseFilesPart=Ht={}));var ni;(function(be){function Se(J){return{kind:"inlineReference",name:J.title,inlineReference:s.URI.isUri(J.value)?J.value:D.from(J.value)}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J);return new d.$1O(s.URI.isUri(ke.inlineReference)?ke.inlineReference:D.to(ke.inlineReference),J.name)}be.to=oe})(ni||(e.ChatResponseAnchorPart=ni={}));var Nt;(function(be){function Se(J){return{kind:"progressMessage",content:K.from(J.value)}}be.from=Se;function oe(J){return new d.$2O(J.content.value)}be.to=oe})(Nt||(e.ChatResponseProgressPart=Nt={}));var Rt;(function(be){function Se(J,ke,Ve){return{kind:"command",command:ke.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}be.from=Se;function oe(J,ke){return new d.$3O(ke.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}be.to=oe})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var Ct;(function(be){function Se(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(ke=>Me.from(ke))}}be.from=Se;function oe(J){return new d.$5O(s.URI.revive(J.uri),J.edits.map(ke=>Me.to(ke)))}be.to=oe})(Ct||(e.ChatResponseTextEditPart=Ct={}));var Dt;(function(be){function Se(J){return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:s.URI.isUri(J.value.value)||!J.value.value?J.value.value:D.from(J.value.value)}}:{kind:"reference",reference:s.URI.isUri(J.value)?J.value:D.from(J.value)}}be.from=Se;function oe(J){const ke=(0,E.$5h)(J),Ve=Qe=>s.URI.isUri(Qe)?Qe:D.to(Qe);return new d.$4O("variableName"in ke.reference?{variableName:ke.reference.variableName,value:ke.reference.value&&Ve(ke.reference.value)}:Ve(ke.reference))}be.to=oe})(Dt||(e.ChatResponseReferencePart=Dt={}));var pt;(function(be){function Se(ke,Ve,Qe){return ke instanceof d.$WO?At.from(ke):ke instanceof d.$1O?ni.from(ke):ke instanceof d.$4O?Dt.from(ke):ke instanceof d.$2O?Nt.from(ke):ke instanceof d.$ZO?Ht.from(ke):ke instanceof d.$3O?Rt.from(ke,Ve,Qe):ke instanceof d.$5O?Ct.from(ke):ke instanceof d.$XO?Ot.from(ke):ke instanceof d.$YO?ii.from(ke):{kind:"markdownContent",content:K.from("")}}be.from=Se;function oe(ke,Ve){switch(ke.kind){case"reference":return Dt.to(ke);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(ke,Ve)}}be.to=oe;function J(ke,Ve){switch(ke.kind){case"markdownContent":return At.to(ke);case"inlineReference":return ni.to(ke);case"progressMessage":return;case"treeData":return Ht.to(ke);case"command":return Rt.to(ke,Ve)}}be.toContent=J})(pt||(e.ChatResponsePart=pt={}));var St;(function(be){function Se(oe){return{prompt:oe.message,command:oe.command,attempt:oe.attempt??0,enableCommandDetection:oe.enableCommandDetection??!0,variables:oe.variables.variables.map(kt.to),location:li.to(oe.location)}}be.to=Se})(St||(e.ChatAgentRequest=St={}));var li;(function(be){function Se(oe){switch(oe){case h.ChatAgentLocation.Notebook:return d.ChatLocation.Notebook;case h.ChatAgentLocation.Terminal:return d.ChatLocation.Terminal;case h.ChatAgentLocation.Panel:return d.ChatLocation.Panel;case h.ChatAgentLocation.Editor:return d.ChatLocation.Editor}}be.to=Se})(li||(e.ChatLocation=li={}));var kt;(function(be){function Se(oe){return{name:oe.name,range:oe.range&&[oe.range.start,oe.range.endExclusive],values:oe.values.map(zt.to)}}be.to=Se})(kt||(e.ChatAgentResolvedVariable=kt={}));var hi;(function(be){function Se(oe,J,ke){return{label:oe.label,values:oe.values.map(zt.from),insertText:oe.insertText,detail:oe.detail,documentation:oe.documentation,command:J.toInternal(oe.command,ke)}}be.from=Se})(hi||(e.ChatAgentCompletionItem=hi={}));var Kt;(function(be){function Se(oe){return{errorDetails:oe.errorDetails,metadata:oe.metadata}}be.to=Se})(Kt||(e.ChatAgentResult=Kt={}));var wi;(function(be){function Se(oe,J,ke){if(J.action.kind==="vote")return;const Ve=Kt.to(oe);if(J.action.kind==="command"){const Qe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:ke.fromInternal(Qe)??{command:Qe.id,title:Qe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:He.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}be.to=Se})(wi||(e.ChatAgentUserActionEvent=wi={}));var ei;(function(be){function Se(oe,J,ke){return"terminalCommand"in oe?{terminalCommand:oe.terminalCommand,shouldExecute:oe.shouldExecute}:"uri"in oe?{uri:oe.uri}:J.toInternal(oe,ke)}be.from=Se})(ei||(e.TerminalQuickFix=ei={}));var bi;(function(be){function Se(oe){return{kind:yt.to(oe.kind)}}be.to=Se})(bi||(e.PartialAcceptInfo=bi={}));var yt;(function(be){function Se(oe){switch(oe){case 0:return d.PartialAcceptTriggerKind.Word;case 1:return d.PartialAcceptTriggerKind.Line;case 2:return d.PartialAcceptTriggerKind.Suggest;default:return d.PartialAcceptTriggerKind.Unknown}}be.to=Se})(yt||(e.PartialAcceptTriggerKind=yt={}));var $i;(function(be){function Se(oe,J){return{id:J,label:oe.label,description:oe.description,canEdit:oe.canEdit,collapsibleState:oe.collapsibleState||0,contextValue:oe.contextValue}}be.from=Se})($i||(e.DebugTreeItem=$i={}))}),define(Ce[251],Ae([1,0,4,16,8,34]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6kc=void 0;let M=class{constructor(g,E){this.a=g.getProxy(S.$YM.MainThreadBulkEdits),this.b={getTextDocumentVersion:T=>E.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(g,E,T){const y=new O.$uw(R.WorkspaceEdit.from(g,this.b));return this.a.$tryApplyWorkspaceEdit(y,void 0,T?.isRefactoring??!1)}};e.$6kc=M,e.$6kc=M=Je([We(0,N.$lP)],M)}),define(Ce[252],Ae([1,0,18,11,43,5,40,6,65,17,2,20,4,8,7,214,26]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7kc=void 0;class r{constructor(h,i,$,a,v){this.j=h,this.k=i,this.l=$,this.m=a,this.n=v,this.b=g.$ae.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(h.c){const v=new Error("Response stream has been closed");throw Error.captureStackTrace(v,a),v}};const h=this;this.b.reset();const $=a=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a)};this.g={markdown(a){i(this.markdown);const v=new m.$WO(a),d=w.ChatResponseMarkdownPart.from(v);return $(d),this},markdownWithVulnerabilities(a,v){i(this.markdown),v&&(0,o.$GG)(h.j,"chatParticipantAdditions");const d=new m.$XO(a,v),C=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(d);return $(C),this},filetree(a,v){i(this.filetree);const d=new m.$ZO(a,v),C=w.ChatResponseFilesPart.from(d);return $(C),this},anchor(a,v){i(this.anchor);const d=new m.$1O(a,v),C=w.ChatResponseAnchorPart.from(d);return $(C),this},button(a){i(this.anchor);const v=new m.$3O(a),d=w.ChatResponseCommandButtonPart.from(v,h.m,h.n);return $(d),this},progress(a){i(this.progress);const v=new m.$2O(a),d=w.ChatResponseProgressPart.from(v);return $(d),this},reference(a){if(i(this.reference),"variableName"in a&&!a.value){const v=h.k.variables.variables.find(d=>d.name===a.variableName);if(v){let d;if(v.references?.length)d=v.references.map(C=>({kind:"reference",reference:{variableName:a.variableName,value:C.reference}}));else{const C=new m.$4O(a);d=[w.ChatResponseReferencePart.from(C)]}return d.forEach(C=>$(C)),this}}else{const v=new m.$4O(a),d=w.ChatResponseReferencePart.from(v);$(d)}return this},textEdit(a,v){i(this.textEdit),(0,o.$GG)(h.j,"chatParticipantAdditions");const d=new m.$5O(a,v),C=w.ChatResponseTextEditPart.from(d);return $(C),this},detectedParticipant(a,v){i(this.detectedParticipant),(0,o.$GG)(h.j,"chatParticipantAdditions");const d=new m.$YO(a,v),C=w.ChatResponseDetectedParticipantPart.from(d);return $(C),this},push(a){if(i(this.push),(a instanceof m.$5O||a instanceof m.$XO||a instanceof m.$YO)&&(0,o.$GG)(h.j,"chatParticipantAdditions"),a instanceof m.$4O)this.reference(a.value);else{const v=w.ChatResponsePart.from(a,h.m,h.n);$(v)}return this}}}return this.g}}class t extends p.$Vc{static{this.b=0}constructor(h,i,$){super(),this.n=i,this.s=$,this.c=new Map,this.j=this.B(new p.$5c),this.m=this.B(new p.$Uc),this.g=h.getProxy(l.$YM.MainThreadChatAgents2)}transferActiveChat(h){this.g.$transferActiveChatSession(h)}createChatAgent(h,i,$){const a=t.b++,v=new n(h,i,this.g,a,$);return this.c.set(a,v),this.g.$registerAgent(a,h.identifier,i,{},void 0),v.apiAgent}createDynamicChatAgent(h,i,$,a,v){const d=t.b++,C=new n(h,i,this.g,d,v);return this.c.set(d,C),this.g.$registerAgent(d,h.identifier,i,{isSticky:!0},{name:$,description:a}),C.apiAgent}async $invokeAgent(h,i,$,a){const v=this.c.get(h);if(!v)throw new Error(`[CHAT](${h}) CANNOT invoke agent because the agent is not registered`);let d=this.j.get(i.sessionId);d||(d=new p.$Uc,this.j.set(i.sessionId,d));const C=new r(v.extension,i,this.g,this.s.converter,d);try{const u=await this.t(i.agentId,$),D=v.invoke(w.ChatAgentRequest.to(i),{history:u},C.apiObject,a);return await(0,N.$jh)(Promise.resolve(D).then(f=>{if(f?.metadata)try{JSON.stringify(f.metadata)}catch(k){const b=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${v.extension.identifier.value}] [@${v.id}] ${b}`,v.extension),{errorDetails:{message:b},timings:C.timings}}return{errorDetails:f?.errorDetails,timings:C.timings,metadata:f?.metadata}}),a)}catch(u){return this.n.error(u,v.extension),{errorDetails:{message:(0,R.$gj)(u),responseIsIncomplete:!0}}}finally{C.close()}}async t(h,i){const $=[];for(const a of i.history){const v=w.ChatAgentResult.to(a.result),d=h===a.request.agentId?v:{...v,metadata:void 0};$.push(new m.$6O(a.request.message,a.request.command,a.request.variables.variables.map(w.ChatAgentResolvedVariable.to),a.request.agentId));const C=(0,S.$Hb)(a.response.map(u=>w.ChatResponsePart.toContent(u,this.s.converter)));$.push(new m.$7O(C,d,a.request.agentId,a.request.command))}return $}$releaseSession(h){this.j.deleteAndDispose(h)}async $provideFollowups(h,i,$,a,v){const d=this.c.get(i);if(!d)return Promise.resolve([]);const C=await this.t(d.id,a),u=w.ChatAgentResult.to($);return(await d.provideFollowups(u,{history:C},v)).filter(D=>{const f=!D.participant||M.Iterable.some(this.c.values(),k=>k.id===D.participant&&y.$Qm.equals(k.extension.identifier,d.extension.identifier));return f||this.n.warn(`[@${d.id}] ChatFollowup refers to an unknown participant: ${D.participant}`),f}).map(D=>w.ChatFollowup.from(D,h))}$acceptFeedback(h,i,$,a){const v=this.c.get(h);if(!v)return;const d=w.ChatAgentResult.to(i);let C;switch($){case s.InteractiveSessionVoteDirection.Down:C=m.ChatResultFeedbackKind.Unhelpful;break;case s.InteractiveSessionVoteDirection.Up:C=m.ChatResultFeedbackKind.Helpful;break}v.acceptFeedback(Object.freeze(a?{result:d,kind:C,reportIssue:a}:{result:d,kind:C}))}$acceptAction(h,i,$){const a=this.c.get(h);if(!a||$.action.kind==="vote")return;const v=w.ChatAgentUserActionEvent.to(i,$,this.s.converter);v&&a.acceptAction(Object.freeze(v))}async $invokeCompletionProvider(h,i,$){const a=this.c.get(h);return a?(await a.invokeCompletionProvider(i,$)).map(d=>w.ChatAgentCompletionItem.from(d,this.s.converter,this.m)):[]}async $provideWelcomeMessage(h,i,$){const a=this.c.get(h);if(a)return await a.provideWelcomeMessage(w.ChatLocation.to(i),$)}async $provideSampleQuestions(h,i,$){const a=this.c.get(h);if(a)return(await a.provideSampleQuestions(w.ChatLocation.to(i),$)).map(v=>w.ChatFollowup.from(v,void 0))}}e.$7kc=t;class n{constructor(h,i,$,a,v){this.extension=h,this.id=i,this.u=$,this.w=a,this.x=v,this.n=new O.$ee,this.o=new O.$ee}acceptFeedback(h){this.n.fire(h)}acceptAction(h){this.o.fire(h)}async invokeCompletionProvider(h,i){return this.q?await this.q.provider.provideCompletionItems(h,i)??[]:[]}async provideFollowups(h,i,$){if(!this.b)return[];const a=await this.b.provideFollowups(h,i,$);return a?a.filter(v=>!(v&&"commandId"in v)).filter(v=>!(v&&"message"in v)):[]}async provideWelcomeMessage(h,i){if(!this.s)return[];const $=await this.s.provideWelcomeMessage(h,i);return $?$.map(a=>typeof a=="string"?a:w.MarkdownString.from(a)):[]}async provideSampleQuestions(h,i){if(!this.s||!this.s.provideSampleQuestions)return[];const $=await this.s.provideSampleQuestions(h,i);return $||[]}get apiAgent(){let h=!1,i=!1;const $=()=>{h||i||(i=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{fullName:this.c,icon:this.d?this.d instanceof T.URI?this.d:"light"in this.d?this.d.light:void 0:void 0,iconDark:this.d&&"dark"in this.d?this.d.dark:void 0,themeIcon:this.d instanceof m.$WN?this.d:void 0,hasFollowups:this.b!==void 0,isSecondary:this.m,helpTextPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextVariablesPrefix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),helpTextPostfix:!this.l||typeof this.l=="string"?this.l:w.MarkdownString.from(this.l),supportIssueReporting:this.p,requester:this.t}),i=!1}))},a=this;return{get id(){return a.id},get fullName(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.c??a.extension.displayName??a.extension.name},set fullName(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.c=v,$()},get iconPath(){return a.d},set iconPath(v){a.d=v,$()},get requestHandler(){return a.x},set requestHandler(v){(0,E.$fg)(typeof v=="function","Invalid request handler"),a.x=v},get followupProvider(){return a.b},set followupProvider(v){a.b=v,$()},get isDefault(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.g},set isDefault(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.g=v,$()},get helpTextPrefix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.j},set helpTextPrefix(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.j=v,$()},get helpTextVariablesPrefix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.k},set helpTextVariablesPrefix(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.k=v,$()},get helpTextPostfix(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.l},set helpTextPostfix(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.l=v,$()},get isSecondary(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.m},set isSecondary(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.m=v,$()},get supportIssueReporting(){return(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.p},set supportIssueReporting(v){(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.p=v,$()},get onDidReceiveFeedback(){return a.n.event},set participantVariableProvider(v){if((0,o.$GG)(a.extension,"chatParticipantAdditions"),a.q=v,v){if(!v.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,v.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,o.$GG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(v){(0,o.$GG)(a.extension,"defaultChatParticipant"),a.s=v,$()},get welcomeMessageProvider(){return(0,o.$GG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,o.$FG)(this.extension,"chatParticipantAdditions")?this.o.event:void 0,set requester(v){a.t=v,$()},get requester(){return a.t},dispose(){h=!0,a.b=void 0,a.n.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(h,i,$,a){return this.x(h,i,$,a)}}}),define(Ce[253],Ae([1,0,14,6,4,8,7,26]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8kc=void 0;class g{static{this.a=0}constructor(y){this.b=new Map,this.c=y.getProxy(R.$YM.MainThreadChatVariables)}async $resolveVariable(y,l,w,m){const s=this.b.get(y);if(s)try{if(s.resolver.resolve2){(0,p.$GG)(s.extension,"chatParticipantAdditions");const o=new E(l,this.c),r=await s.resolver.resolve2(s.data.name,{prompt:w},o.apiObject,m);if(r)return r.map(O.ChatVariable.from)}else{const o=await s.resolver.resolve(s.data.name,{prompt:w},m);if(o)return o.map(O.ChatVariable.from)}}catch(o){(0,S.$2)(o)}}registerVariableResolver(y,l,w,m){const s=g.a++;return this.b.set(s,{extension:y,data:{name:l,description:w},resolver:m}),this.c.$registerVariable(s,{name:l,description:w}),(0,N.$Tc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$8kc=g;class E{constructor(y,l){this.c=y,this.d=l,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let l=function(m){if(y.a){const s=new Error("Response stream has been closed");throw Error.captureStackTrace(s,m),s}};const y=this,w=m=>{this.d.$handleProgressChunk(this.c,m)};this.b={progress(m){l(this.progress);const s=new M.$2O(m),o=O.ChatResponseProgressPart.from(s);return w(o),this},reference(m){l(this.reference);const s=new M.$4O(m),o=O.ChatResponseReferencePart.from(s);return w(o),this},push(m){return l(this.push),m instanceof M.$4O?w(O.ChatResponseReferencePart.from(m)):m instanceof M.$2O&&w(O.ChatResponseProgressPart.from(m)),this}}}return this.b}}}),define(Ce[254],Ae([1,0,11,68,5,6,2,87,20,8,7,4,26]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_kc=w;function w(m,s,o){const r=m.getProxy(y.$YM.MainThreadComments);class t{static{this.a=0}constructor(){this.b=new Map,this.c=new g.$Sm,s.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===6){const D=this.b.get(u.handle);return D?D.value:u}else if(u&&u.$mid===7){const D=u,f=this.b.get(D.commentControlHandle);if(!f)return D;const k=f.getCommentThread(D.commentThreadHandle);return k?k.value:D}else if(u&&(u.$mid===9||u.$mid===8)){const D=this.b.get(u.thread.commentControlHandle);if(!D)return u;const f=D.getCommentThread(u.thread.commentThreadHandle);return f?u.$mid===8?f.value:{thread:f.value,text:u.text}:u}else if(u&&u.$mid===10){const D=this.b.get(u.thread.commentControlHandle);if(!D)return u;const f=D.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const k=u.commentUniqueId,b=f.getCommentByUniqueId(k);return b||u}else if(u&&u.$mid===11){const D=this.b.get(u.thread.commentControlHandle);if(!D)return u;const f=D.getCommentThread(u.thread.commentThreadHandle);if(!f)return u;const k=u.text,b=u.commentUniqueId,P=f.getCommentByUniqueId(b);return P?(typeof P.body=="string"?P.body=k:P.body=new T.$pN(k),P):u}return u}})}createCommentController(u,D,f){const k=t.a++,b=new c(u,k,D,f);this.b.set(b.handle,b);const P=this.c.get(u.identifier)||[];return P.push(b),this.c.set(u.identifier,P),b.value}async $createCommentThreadTemplate(u,D,f){const k=this.b.get(u);k&&k.$createCommentThreadTemplate(D,f)}async $setActiveComment(u,D){const f=this.b.get(u);f&&f.$setActiveComment(D??void 0)}async $updateCommentThreadTemplate(u,D,f){const k=this.b.get(u);k&&k.$updateCommentThreadTemplate(D,f)}$deleteCommentThread(u,D){this.b.get(u)?.$deleteCommentThread(D)}async $provideCommentingRanges(u,D,f){const k=this.b.get(u);if(!k||!k.commentingRangeProvider)return Promise.resolve(void 0);const b=await o.ensureDocumentData(M.URI.revive(D));return(0,S.$nh)(async()=>{const P=await k.commentingRangeProvider.provideCommentingRanges(b.document,f);let I;return Array.isArray(P)?I={ranges:P,fileComments:!1}:P?I={ranges:P.ranges||[],fileComments:P.fileComments||!1}:I=P??void 0,I}).then(P=>{let I;return P&&(I={ranges:P.ranges.map(W=>E.Range.from(W)),fileComments:P.fileComments}),I})}$toggleReaction(u,D,f,k,b){const P=this.b.get(u);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,S.$nh)(()=>{const I=P.getCommentThread(D);if(I){const W=I.getCommentByUniqueId(k.uniqueIdInThread);if(P!==void 0&&W&&P.reactionHandler)return P.reactionHandler(W,$(b))}return Promise.resolve(void 0)})}}class n{static{this.a=0}set threadId(u){this.n=u}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(u){(u===void 0!=(this.p===void 0)||!u||!this.p||!u.isEqual(this.p))&&(this.p=u,this.b.range=u,this.c.fire())}get range(){return this.p}set canReply(u){this.d!==u&&(this.d=u,this.b.canReply=u,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(u){this.e=u,this.b.label=u,this.c.fire()}get contextValue(){return this.f}set contextValue(u){this.f=u,this.b.contextValue=u,this.c.fire()}get comments(){return this.q}set comments(u){this.q=u,this.b.comments=u,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(u){this.g=u,this.b.collapsibleState=u,this.c.fire()}get state(){return this.h}set state(u){this.h=u,typeof u=="object"?((0,l.$GG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=u.resolved,this.b.applicability=u.applicability):this.b.state=u,this.c.fire()}get isDisposed(){return this.j}constructor(u,D,f,k,b,P,I,W){this.m=D,this.n=f,this.o=k,this.p=b,this.q=P,this.extensionDescription=I,this.r=W,this.handle=n.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new R.$ee,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new O.$Wc,this.l.value=new O.$Uc,this.n===void 0&&(this.n=`${u}.${this.handle}`),r.$createCommentThread(D,this.handle,this.n,this.o,E.Range.from(this.p),I.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this.i.push({dispose:()=>{r.$deleteCommentThread(D,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(q){V.range=q},get comments(){return V.comments},set comments(q){V.comments=q},get collapsibleState(){return V.collapsibleState},set collapsibleState(q){V.collapsibleState=q},get canReply(){return V.canReply},set canReply(q){V.canReply=q},get contextValue(){return V.contextValue},set contextValue(q){V.contextValue=q},get label(){return V.label},set label(q){V.label=q},get state(){return V.state},set state(q){V.state=q},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new O.$Uc);const u=f=>Object.prototype.hasOwnProperty.call(this.b,f),D={};u("range")&&(D.range=E.Range.from(this.p)),u("label")&&(D.label=this.label),u("contextValue")&&(D.contextValue=this.contextValue??null),u("comments")&&(D.comments=this.q.map(f=>h(this,f,this.k,this.extensionDescription))),u("collapsibleState")&&(D.collapseState=a(this.g)),u("canReply")&&(D.canReply=this.canReply),u("state")&&(D.state=v(this.h)),u("applicability")&&(D.applicability=d(this.h)),u("isTemplate")&&(D.isTemplate=this.r),this.b={},r.$updateCommentThread(this.m,this.handle,this.n,this.o,D)}getCommentByUniqueId(u){for(const D of this.k){const f=D[0],k=D[1];if(u===k)return f}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(u=>u.dispose())}}Je([(0,N.$1h)(100)],n.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(u){this.b=u,u?.resourceHints&&(0,l.$GG)(this.h,"commentingRangeHint"),r.$updateCommentingRanges(this.handle,u?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(u){this.c=u,r.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!u})}get options(){return this.d}set options(u){this.d=u,r.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,l.$GG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,l.$GG)(this.h,"activeComment"),this.f}constructor(u,D,f,k){this.h=u,this.i=D,this.j=f,this.k=k,this.a=new Map,r.$registerCommentController(this.handle,f,k,this.h.identifier.value);const b=this;this.value=Object.freeze({id:b.id,label:b.label,get options(){return b.options},set options(P){b.options=P},get commentingRangeProvider(){return b.commentingRangeProvider},set commentingRangeProvider(P){b.commentingRangeProvider=P},get reactionHandler(){return b.reactionHandler},set reactionHandler(P){b.reactionHandler=P},get activeCommentThread(){return b.activeCommentThread},createCommentThread(P,I,W){return b.createCommentThread(P,I,W).value},dispose:()=>{b.dispose()}}),this.g=[],this.g.push({dispose:()=>{r.$unregisterCommentController(this.handle)}})}createCommentThread(u,D,f){D===void 0&&(0,l.$GG)(this.h,"fileComments");const k=new n(this.id,this.handle,void 0,u,D,f,this.h,!1);return this.a.set(k.handle,k),k}$setActiveComment(u){if(!u){this.e=void 0,this.f=void 0;return}const D=this.a.get(u.commentThreadHandle);D&&(this.e=u.uniqueIdInThread?D.getCommentByUniqueId(u.uniqueIdInThread):void 0,this.f=D)}$createCommentThreadTemplate(u,D){const f=new n(this.id,this.handle,void 0,M.URI.revive(u),E.Range.to(D),[],this.h,!0);return f.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(f.handle,f),f}$updateCommentThreadTemplate(u,D){const f=this.a.get(u);f&&(f.range=E.Range.to(D))}$deleteCommentThread(u){this.a.get(u)?.dispose(),this.a.delete(u)}getCommentThread(u){return this.a.get(u)}dispose(){this.a.forEach(u=>{u.dispose()}),this.g.forEach(u=>u.dispose())}}function h(C,u,D,f){let k=D.get(u);return k||(k=++C.commentHandle,D.set(u,k)),u.state!==void 0&&(0,l.$GG)(f,"commentsDraftState"),u.reactions?.some(b=>b.reactors!==void 0)&&(0,l.$GG)(f,"commentReactor"),{mode:u.mode,contextValue:u.contextValue,uniqueIdInThread:k,body:typeof u.body=="string"?u.body:E.MarkdownString.from(u.body),userName:u.author.name,userIconPath:u.author.iconPath,label:u.label,commentReactions:u.reactions?u.reactions.map(b=>i(b)):void 0,state:u.state,timestamp:u.timestamp?.toJSON()}}function i(C){return{label:C.label,iconPath:C.iconPath?E.$kP(C.iconPath):void 0,count:C.count,hasReacted:C.authorHasReacted,reactors:C.reactors&&C.reactors.length>0&&typeof C.reactors[0]!="string"?C.reactors.map(u=>u.name):C.reactors}}function $(C){return{label:C.label||"",count:C.count||0,iconPath:C.iconPath?M.URI.revive(C.iconPath):"",authorHasReacted:C.hasReacted||!1,reactors:C.reactors?.map(u=>({name:u}))}}function a(C){if(C!==void 0)switch(C){case T.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case T.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function v(C){let u;if(typeof C=="object"?u=C.resolved:u=C,u!==void 0)switch(u){case T.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case T.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function d(C){let u;if(typeof C=="object"&&(u=C.applicability),u!==void 0)switch(u){case T.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case T.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new t}}),define(Ce[255],Ae([1,0,24,99,6,12,23,2,8,63,74,4,7]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rlc=void 0;class w{constructor($,a){this.document=$,this.b=a,this.a=1,this.c=new T.$Rkc("custom documents")}addEdit($){return this.c.add([$])}async undo($,a){await this.f($).undo(),a||this.disposeBackup()}async redo($,a){await this.f($).redo(),a||this.disposeBackup()}disposeEdits($){for(const a of $)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const $=h(this.document.uri)+this.a++;return(0,M.$9g)(this.b,$)}updateBackup($){this.d?.delete(),this.d=$}disposeBackup(){this.d?.delete(),this.d=void 0}f($){const a=this.c.get($,0);if(!a)throw new Error("No edit found");return a}}class m{constructor(){this.a=new Map}get($,a){return this.a.get(this.b($,a))}add($,a,v){const d=this.b($,a.uri);if(this.a.has(d))throw new Error(`Document already exists for viewType:${$} resource:${a.uri}`);const C=new w(a,v);return this.a.set(d,C),C}delete($,a){const v=this.b($,a.uri);this.a.delete(v)}b($,a){return`${$}@@@${a}`}}var s;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(s||(s={}));class o{constructor(){this.a=new Map}addTextProvider($,a,v){return this.b(0,$,a,v)}addCustomProvider($,a,v){return this.b(1,$,a,v)}get($){return this.a.get($)}b($,a,v,d){if(this.a.has(a))throw new Error(`Provider for viewType:${a} already registered`);return this.a.set(a,{type:$,extension:v,provider:d}),new l.$1M(()=>this.a.delete(a))}}class r{constructor($,a,v,d,C){this.d=a,this.f=v,this.g=d,this.h=C,this.b=new o,this.c=new m,this.a=$.getProxy(y.$YM.MainThreadCustomEditors)}registerCustomEditorProvider($,a,v,d){const C=new R.$Uc;return n(v)?(C.add(this.b.addTextProvider(a,$,v)),this.a.$registerTextEditorProvider((0,E.$olc)($),a,d.webviewOptions||{},{supportsMove:!!v.moveCustomTextEditor},(0,E.$mlc)($))):(C.add(this.b.addCustomProvider(a,$,v)),t(v)&&C.add(v.onDidChangeCustomDocument(u=>{const D=this.i(a,u.document.uri);if(c(u)){const f=D.addEdit(u);this.a.$onDidEdit(u.document.uri,a,f,u.label)}else this.a.$onContentChange(u.document.uri,a)})),this.a.$registerCustomEditorProvider((0,E.$olc)($),a,d.webviewOptions||{},!!d.supportsMultipleEditorsPerDocument,(0,E.$mlc)($))),l.$1M.from(C,new l.$1M(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument($,a,v,d,C){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);if(u.type!==1)throw new Error(`Invalid provide type for '${a}'`);const D=p.URI.revive($),f=await u.provider.openCustomDocument(D,{backupId:v,untitledDocumentData:d?.buffer},C);let k;return t(u.provider)&&this.f&&(k=this.f.workspaceValue(u.extension)??this.f.globalValue(u.extension)),this.c.add(a,f,k),{editable:t(u.provider)}}async $disposeCustomDocument($,a){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provider type for '${a}'`);const d=p.URI.revive($),{document:C}=this.i(a,d);this.c.delete(a,C),C.dispose()}async $resolveCustomEditor($,a,v,d,C,u){const D=this.b.get(v);if(!D)throw new Error(`No provider found for '${v}'`);const f=g.ViewColumn.to(C),k=this.g.createNewWebview(a,d.contentOptions,D.extension),b=this.h.createNewWebviewPanel(a,v,d.title,f,d.options,k,d.active),P=p.URI.revive($);switch(D.type){case 1:{const{document:I}=this.i(v,P);return D.provider.resolveCustomEditor(I,b,u)}case 0:{const I=this.d.getDocument(P);return D.provider.resolveCustomTextEditor(I,b,u)}default:throw new Error("Unknown webview provider type")}}$disposeEdits($,a,v){this.i(a,$).disposeEdits(v)}async $onMoveCustomEditor($,a,v){const d=this.b.get(v);if(!d)throw new Error(`No provider found for '${v}'`);if(!d.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${v}'`);const C=this.h.getWebviewPanel($);if(!C)throw new Error("No webview found");const u=p.URI.revive(a),D=this.d.getDocument(u);await d.provider.moveCustomTextEditor(D,C,S.CancellationToken.None)}async $undo($,a,v,d){return this.i(a,$).undo(v,d)}async $redo($,a,v,d){return this.i(a,$).redo(v,d)}async $revert($,a,v){const d=this.i(a,$);await this.j(a).revertCustomDocument(d.document,v),d.disposeBackup()}async $onSave($,a,v){const d=this.i(a,$);await this.j(a).saveCustomDocument(d.document,v),d.disposeBackup()}async $onSaveAs($,a,v,d){const C=this.i(a,$);return this.j(a).saveCustomDocumentAs(C.document,p.URI.revive(v),d)}async $backup($,a,v){const d=this.i(a,$),u=await this.j(a).backupCustomDocument(d.document,{destination:d.getNewBackupUri()},v);return d.updateBackup(u),u.id}i($,a){const v=this.c.get($,p.URI.revive(a));if(!v)throw new Error("No custom document found");return v}j($){const v=this.b.get($)?.provider;if(!v||!t(v))throw new Error("Custom document is not editable");return v}}e.$rlc=r;function t(i){return!!i.onDidChangeCustomDocument}function n(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function h(i){const $=i.scheme===O.Schemas.file||i.scheme===O.Schemas.untitled?i.fsPath:i.toString();return(0,N.$jj)($)+""}}),define(Ce[256],Ae([1,0,163,100,2,4,7,8,5,13,28,45]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.$Zkc=e.$Ykc=void 0;class w{#e;#t;#i;constructor(o,r,t,n,c,h,i,$){this.d=o,this.e=r,this.f=t,this.g=n,this.h=c,this.c=!1,this.f=Math.max(n,t),this.#i=new T.$Bc(a=>h.getComparisonKey(a)),this.#e=i,this.#t=$}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(o,r){if(!o){this.clear();return}this.j();let t=[];if(R.URI.isUri(o)){if(!r){this.delete(o);return}this.#i.set(o,r.slice()),t=[o]}else if(Array.isArray(o)){t=[];let h;o=[...o].sort(w.k);for(const i of o){const[$,a]=i;if((!h||$.toString()!==h.toString())&&(h&&this.#i.get(h).length===0&&this.#i.delete(h),h=$,t.push($),this.#i.set($,[])),a)this.#i.get($)?.push(...a);else{const v=this.#i.get($);v&&(v.length=0)}}}if(this.#t.fire(t),!this.#e)return;const n=[];let c=0;for(const h of t){let i=[];const $=this.#i.get(h);if($)if($.length>this.g){i=[];const a=[M.DiagnosticSeverity.Error,M.DiagnosticSeverity.Warning,M.DiagnosticSeverity.Information,M.DiagnosticSeverity.Hint];e:for(let v=0;v<4;v++)for(const d of $)if(d.severity===a[v]&&i.push({...p.Diagnostic.from(d),modelVersionId:this.h(h)})===this.g)break e;i.push({severity:N.MarkerSeverity.Info,message:(0,S.localize)(0,null,$.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=$.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(h)}));if(n.push([h,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,n)}delete(o){this.j(),this.#t.fire([o]),this.#i.delete(o),this.#e?.$changeMany(this.e,[[o,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(o,r){this.j();for(const[t,n]of this)o.call(r,t,n,this)}*[Symbol.iterator](){this.j();for(const o of this.#i.keys())yield[o,this.get(o)]}get(o){this.j();const r=this.#i.get(o);return Array.isArray(r)?Object.freeze(r.slice(0)):[]}has(o){return this.j(),Array.isArray(this.#i.get(o))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(o,r){return o[0].toString()<r[0].toString()?-1:o[0].toString()>r[0].toString()?1:0}}e.$Ykc=w;let m=class{static{l=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*l.d}static _mapper(o){const r=new T.$Bc;for(const t of o)r.set(t,t);return{uris:Object.freeze(Array.from(r.values()))}}constructor(o,r,t,n){this.j=r,this.k=t,this.l=n,this.g=new Map,this.h=new g.$ie({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=g.Event.map(this.h.event,l._mapper),this.f=o.getProxy(O.$YM.MainThreadDiagnostics)}createDiagnosticCollection(o,r){const{g:t,f:n,h:c,j:h,k:i,l:$}=this,a=new class{$changeMany(C,u){n.$changeMany(C,u),h.trace("[DiagnosticCollection] change many (extension, owner, uris)",o.value,C,u.length===0?"CLEARING":u)}$clear(C){n.$clear(C),h.trace("[DiagnosticCollection] remove all (extension, owner)",o.value,C)}dispose(){n.dispose()}};let v;if(!r)r="_generated_diagnostic_collection_name_#"+l.c++,v=r;else if(!t.has(r))v=r;else{this.j.warn(`DiagnosticCollection with name '${r}' does already exist.`);do v=r+l.c++;while(t.has(v))}return new class extends w{constructor(){super(r,v,l.e,l.d,C=>$.getDocument(C)?.version,i.extUri,a,c),t.set(v,this)}dispose(){super.dispose(),t.delete(v)}}}getDiagnostics(o){if(o)return this.m(o);{const r=new Map,t=[];for(const n of this.g.values())n.forEach((c,h)=>{let i=r.get(c.toString());typeof i>"u"&&(i=t.length,r.set(c.toString(),i),t.push([c,[]])),t[i][1]=t[i][1].concat(...h)});return t}}m(o){let r=[];for(const t of this.g.values())t.has(o)&&(r=r.concat(t.get(o)));return r}$acceptMarkersChange(o){if(!this.n){const r="_generated_mirror",t=new w(r,r,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,n=>{},this.k.extUri,void 0,this.h);this.g.set(r,t),this.n=t}for(const[r,t]of o)this.n.set(R.URI.revive(r),t.map(p.Diagnostic.to))}};e.$Zkc=m,e.$Zkc=m=l=Je([We(1,E.$2j),We(2,y.$Xkc)],m)}),define(Ce[257],Ae([1,0,2,14,7,8,192,34]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8lc=void 0;class g{constructor(T,y,l,w={timeout:1500,errors:3}){this.c=T,this.d=y,this.f=l,this.g=w,this.a=new M.$6c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(T){return(y,l,w)=>{const s={dispose:this.a.push([y,l,T])};return Array.isArray(w)&&w.push(s),s}}async $participateInSave(T,y){const l=S.URI.revive(T);let w=!1;const m=setTimeout(()=>w=!0,this.g.timeout),s=[];try{for(const o of[...this.a]){if(w)break;const r=this.d.getDocument(l),t=await this.h(o,{document:r,reason:O.TextDocumentSaveReason.to(y)});s.push(t)}}finally{clearTimeout(m)}return s}h([T,y,l],w){const m=this.b.get(T);return typeof m=="number"&&m>this.g.errors?Promise.resolve(!1):this.i(l,T,y,w).then(()=>!0,s=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' threw ERROR`),this.c.error(s),!(s instanceof Error)||s.message!=="concurrent_edits"){const o=this.b.get(T);this.b.set(T,o?o+1:1),typeof o=="number"&&o>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${l.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(T,y,l,w){const m=[],s=Date.now(),{document:o,reason:r}=w,{version:t}=o,n=Object.freeze({document:o,reason:r,waitUntil(c){if(Object.isFrozen(m))throw(0,N.$8)("waitUntil can not be called async");m.push(Promise.resolve(c))}});try{y.apply(l,[n])}catch(c){return Promise.reject(c)}return Object.freeze(m),new Promise((c,h)=>{const i=setTimeout(()=>h(new Error("timeout")),this.g.timeout);return Promise.all(m).then($=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${T.identifier.value}' finished after ${Date.now()-s}ms`),clearTimeout(i),c($)}).catch($=>{clearTimeout(i),h($)})}).then(c=>{const h={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every($=>$ instanceof R.$8M))for(const{newText:$,newEol:a,range:v}of i)h.edits.push({resource:o.uri,versionId:void 0,textEdit:{range:v&&O.Range.from(v),text:$,eol:a&&O.EndOfLine.from(a)}});if(h.edits.length!==0)return t===o.version?this.f.$tryApplyWorkspaceEdit(new p.$uw(h)):Promise.reject(new Error("concurrent_edits"))})}}e.$8lc=g}),define(Ce[258],Ae([1,0,5,6,2,4,111,8,17,25,7]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1kc=void 0;class y{constructor(w,m){this.a=new S.$ee,this.b=new S.$ee,this.c=new S.$ee,this.d=new S.$ee,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Uc,this.h=new Map,this.f=w.getProxy(O.$YM.MainThreadDocuments),this.g=m,this.g.onDidRemoveDocuments(s=>{for(const o of s)this.b.fire(o.document)},void 0,this.e),this.g.onDidAddDocuments(s=>{for(const o of s)this.a.fire(o.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const m=this.g.getDocument(w);if(m)return m}getDocument(w){const m=this.getDocumentData(w);if(!m?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return m.document}ensureDocumentData(w){const m=this.g.getDocument(w);if(m)return Promise.resolve(m);let s=this.h.get(w.toString());return s||(s=this.f.$tryOpenDocument(w).then(o=>{this.h.delete(w.toString());const r=R.URI.revive(o);return(0,g.$gg)(this.g.getDocument(r))},o=>(this.h.delete(w.toString()),Promise.reject(o))),this.h.set(w.toString(),s)),s}createDocumentData(w){return this.f.$tryCreateDocument(w).then(m=>R.URI.revive(m))}$acceptModelLanguageChanged(w,m){const s=R.URI.revive(w),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");this.b.fire(o.document),o._acceptLanguageId(m),this.a.fire(o.document)}$acceptModelSaved(w){const m=R.URI.revive(w),s=this.g.getDocument(m);if(!s)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(s.document)}$acceptDirtyStateChanged(w,m){const s=R.URI.revive(w),o=this.g.getDocument(s);if(!o)throw new Error("unknown document");o._acceptIsDirty(m),this.c.fire({document:o.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,m,s){const o=R.URI.revive(w),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(s),r.onEvents(m);let t;m.isUndoing?t=T.TextDocumentChangeReason.Undo:m.isRedoing&&(t=T.TextDocumentChangeReason.Redo),this.c.fire((0,E.$3n)({document:r.document,contentChanges:m.changes.map(n=>({range:p.Range.to(n.range),rangeOffset:n.rangeOffset,rangeLength:n.rangeLength,text:n.text})),reason:t}))}setWordDefinitionFor(w,m){(0,M.$nP)(w,m)}}e.$1kc=y}),define(Ce[66],Ae([1,0,259,5,17,2,3,4,16,8,7]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tlc=e.$slc=void 0,e.$slc=(0,M.$vi)("IExtHostEditorTabs");class y{constructor(o,r,t){this.e=t,this.d=r,this.acceptDtoUpdate(o)}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.id===o.e()},get label(){return o.b.label},get input(){return o.c},get isDirty(){return o.b.isDirty},get isPinned(){return o.b.isPinned},get isPreview(){return o.b.isPreview},get group(){return o.d.apiObject}};this.a=Object.freeze(r)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(o){this.b=o,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new T.$KO(O.URI.revive(this.b.input.uri));case 2:return new T.$LO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified));case 3:return new T.$MO(O.URI.revive(this.b.input.base),O.URI.revive(this.b.input.input1),O.URI.revive(this.b.input.input2),O.URI.revive(this.b.input.result));case 6:return new T.$NO(O.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new T.$OO(this.b.input.viewType);case 4:return new T.$PO(O.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new T.$QO(O.URI.revive(this.b.input.original),O.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new T.$RO;case 9:return new T.$SO(O.URI.revive(this.b.input.uri),O.URI.revive(this.b.input.inputBoxUri));case 10:return new T.$TO;case 11:return new T.$UO(this.b.input.diffEditors.map(o=>new T.$LO(O.URI.revive(o.original),O.URI.revive(o.modified))));default:return}}}class l{constructor(o,r){this.c=[],this.d="",this.b=o,this.e=r;for(const t of o.tabs)t.isActive&&(this.d=t.id),this.c.push(new y(t,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const o=this,r={get isActive(){return o.b.groupId===o.e()},get viewColumn(){return E.ViewColumn.to(o.b.viewColumn)},get activeTab(){return o.c.find(t=>t.tabId===o.d)?.apiObject},get tabs(){return Object.freeze(o.c.map(t=>t.apiObject))}};this.a=Object.freeze(r)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(o){this.b=o}acceptTabOperation(o){if(o.kind===0){const t=new y(o.tabDto,this,()=>this.activeTabId());return this.c.splice(o.index,0,t),o.tabDto.isActive&&(this.d=t.tabId),t}else if(o.kind===1){const t=this.c.splice(o.index,1)[0];if(!t)throw new Error(`Tab close updated received for index ${o.index} which does not exist`);return t.tabId===this.d&&(this.d=""),t}else if(o.kind===3){if(o.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const t=this.c.splice(o.oldIndex,1)[0];if(!t)throw new Error(`Tab move updated received for index ${o.oldIndex} which does not exist`);return this.c.splice(o.index,0,t),t}const r=this.c.find(t=>t.tabId===o.tabDto.id);if(!r)throw new Error("INVALID tab");return o.tabDto.isActive?this.d=o.tabDto.id:this.d===o.tabDto.id&&!o.tabDto.isActive&&(this.d=""),r.acceptDtoUpdate(o.tabDto),r}activeTabId(){return this.d}}let w=class{constructor(o){this.b=new N.$ee,this.c=new N.$ee,this.e=[],this.a=o.getProxy(p.$YM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const o=this,r={onDidChangeTabGroups:o.c.event,onDidChangeTabs:o.b.event,get all(){return Object.freeze(o.e.map(t=>t.apiObject))},get activeTabGroup(){const t=o.d;return(0,R.$gg)(o.e.find(c=>c.groupId===t)?.apiObject)},close:async(t,n)=>{const c=Array.isArray(t)?t:[t];return c.length?m(c[0])?this.j(c,n):this.i(c,n):!0}};this.f=Object.freeze(r)}return this.f}$acceptEditorTabModel(o){const r=new Set(this.e.map(a=>a.groupId)),t=new Set(o.map(a=>a.groupId)),n=(0,S.$L)(r,t),c=this.e.filter(a=>n.removed.includes(a.groupId)).map(a=>a.apiObject),h=[],i=[];this.e=o.map(a=>{const v=new l(a,()=>this.d);return n.added.includes(v.groupId)?h.push(v.apiObject):i.push(v.apiObject),v});const $=(0,R.$gg)(o.find(a=>a.isActive===!0)?.groupId);$!==void 0&&this.d!==$&&(this.d=$),this.c.fire(Object.freeze({opened:h,closed:c,changed:i}))}$acceptTabGroupUpdate(o){const r=this.e.find(t=>t.groupId===o.groupId);if(!r)throw new Error("Update Group IPC call received before group creation.");r.acceptGroupDtoUpdate(o),o.isActive&&(this.d=o.groupId),this.c.fire(Object.freeze({changed:[r.apiObject],opened:[],closed:[]}))}$acceptTabOperation(o){const r=this.e.find(n=>n.groupId===o.groupId);if(!r)throw new Error("Update Tabs IPC call received before group creation.");const t=r.acceptTabOperation(o);switch(o.kind){case 0:this.b.fire(Object.freeze({opened:[t.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[t.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[t.apiObject]}));return}}g(o){for(const r of this.e)for(const t of r.tabs)if(t.apiObject===o)return t}h(o){return this.e.find(r=>r.apiObject===o)}async i(o,r){const t=[];for(const n of o){const c=this.g(n);if(!c)throw new Error("Tab close: Invalid tab not found!");t.push(c.tabId)}return this.a.$closeTab(t,r)}async j(o,r){const t=[];for(const n of o){const c=this.h(n);if(!c)throw new Error("Group close: Invalid group not found!");t.push(c.groupId)}return this.a.$closeGroup(t,r)}};e.$tlc=w,e.$tlc=w=Je([We(0,g.$lP)],w);function m(s){return s.tabs!==void 0}}),define(Ce[260],Ae([1,0,2,4,6,7,8,303,15,22,26,54]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=void 0;class l{constructor(){this.a=[]}add(s){this.b=void 0,this.a.push(s)}delete(s){const o=this.a.indexOf(s);o>=0&&(this.a.splice(o,1),this.b=void 0)}c(){if(!this.b){const s=this.a.sort(),o=[];let r,t,n=14,c=14;for(const h of s){let i=r?(0,g.$zf)(r,h):0;for(i===0?t=1:t=c;i<h.length;i++)i+1===h.length?(n=c,c=9):c+=1,o.push([t,h.toUpperCase().charCodeAt(i),c]),o.push([t,h.toLowerCase().charCodeAt(i),c]),t=c;r=h,c=n}o.push([9,58,10]),o.push([10,47,12]),this.b=new p.$d3(o)}}provideDocumentLinks(s){this.c();const o=[],r=p.$e3.computeLinks({getLineContent(t){return s.lineAt(t-1).text},getLineCount(){return s.lineCount}},this.b);for(const t of r){const n=M.DocumentLink.to(t);n.target&&o.push(n)}return o}}class w{constructor(s,o){this.i=o,this.b=new l,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=s.getProxy(N.$YM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(s,o,r,t={}){if(w.j(r),this.d.has(o))throw new Error(`a provider for the scheme '${o}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(s,"*",this.b));const n=this.h++;this.b.add(o),this.d.add(o),this.c.set(n,r);let c=2;t.isCaseSensitive&&(c+=1024),t.isReadonly&&(c+=2048),typeof r.copy=="function"&&(c+=8),typeof r.open=="function"&&typeof r.close=="function"&&typeof r.read=="function"&&typeof r.write=="function"&&((0,T.$GG)(s,"fsChunks"),c+=4);let h;t.isReadonly&&(0,y.$Uk)(t.isReadonly)&&t.isReadonly.value!==""&&(h={value:t.isReadonly.value,isTrusted:t.isReadonly.isTrusted,supportThemeIcons:t.isReadonly.supportThemeIcons,supportHtml:t.isReadonly.supportHtml,baseUri:t.isReadonly.baseUri,uris:t.isReadonly.uris}),this.a.$registerFileSystemProvider(n,o,c,h).catch($=>{console.error(`FAILED to register filesystem provider of ${s.identifier.value}-extension for the scheme ${o}`),console.error($)});const i=r.onDidChangeFile($=>{const a=[];for(const v of $){const{uri:d,type:C}=v;if(d.scheme!==o)continue;let u;switch(C){case O.FileChangeType.Changed:u=0;break;case O.FileChangeType.Created:u=1;break;case O.FileChangeType.Deleted:u=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:d,type:u})}this.a.$onFileSystemChange(n,a)});return(0,R.$Tc)(()=>{i.dispose(),this.b.delete(o),this.d.delete(o),this.c.delete(n),this.a.$unregisterProvider(n)})}static j(s){if(!s)throw new Error("MISSING provider");if(typeof s.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof s.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof s.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof s.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof s.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof s.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof s.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof s.rename!="function")throw new Error("Provider does NOT implement rename")}static k(s){const{type:o,ctime:r,mtime:t,size:n,permissions:c}=s;return{type:o,ctime:r,mtime:t,size:n,permissions:c}}$stat(s,o){return Promise.resolve(this.l(s).stat(S.URI.revive(o))).then(r=>w.k(r))}$readdir(s,o){return Promise.resolve(this.l(s).readDirectory(S.URI.revive(o)))}$readFile(s,o){return Promise.resolve(this.l(s).readFile(S.URI.revive(o))).then(r=>E.$Fe.wrap(r))}$writeFile(s,o,r,t){return Promise.resolve(this.l(s).writeFile(S.URI.revive(o),r.buffer,t))}$delete(s,o,r){return Promise.resolve(this.l(s).delete(S.URI.revive(o),r))}$rename(s,o,r,t){return Promise.resolve(this.l(s).rename(S.URI.revive(o),S.URI.revive(r),t))}$copy(s,o,r,t){const n=this.l(s);if(!n.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(n.copy(S.URI.revive(o),S.URI.revive(r),t))}$mkdir(s,o){return Promise.resolve(this.l(s).createDirectory(S.URI.revive(o)))}$watch(s,o,r,t){const n=this.l(s).watch(S.URI.revive(r),t);this.f.set(o,n)}$unwatch(s,o){const r=this.f.get(o);r&&(r.dispose(),this.f.delete(o))}$open(s,o,r){const t=this.l(s);if(!t.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(t.open(S.URI.revive(o),r))}$close(s,o){const r=this.l(s);if(!r.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(r.close(o))}$read(s,o,r,t){const n=this.l(s);if(!n.read)throw new Error('FileSystemProvider does not implement "read"');const c=E.$Fe.alloc(t);return Promise.resolve(n.read(o,r,c.buffer,0,t)).then(h=>c.slice(0,h))}$write(s,o,r,t){const n=this.l(s);if(!n.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(n.write(o,r,t.buffer,0,t.byteLength))}l(s){const o=this.c.get(s);if(!o){const r=new Error;throw r.name="ENOPRO",r.message="no provider",r}return o}}e.$0lc=w}),define(Ce[261],Ae([1,0,5,36,2,4,8,7,41]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$lc=void 0;class E{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,m,s,o,r,t){this.a=Math.random(),this.b=new S.$ee,this.c=new S.$ee,this.d=new S.$ee,this.h=0,t?.ignoreCreateEvents&&(this.h+=1),t?.ignoreChangeEvents&&(this.h+=2),t?.ignoreDeleteEvents&&(this.h+=4);const n=(0,N.$pk)(r),c=typeof r=="string",h=t?.correlate,i=o($=>{if(!(typeof $.session=="number"&&$.session!==this.a)&&!(h&&typeof $.session>"u")){if(!t?.ignoreCreateEvents)for(const a of $.created){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.b.fire(v)}if(!t?.ignoreChangeEvents)for(const a of $.changed){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.c.fire(v)}if(!t?.ignoreDeleteEvents)for(const a of $.deleted){const v=R.URI.revive(a);n(v.fsPath)&&(!c||m.getWorkspaceFolder(v))&&this.d.fire(v)}}});this.g=p.$1M.from(this.i(w,s,r,t,t?.correlate),this.b,this.c,this.d,i)}i(w,m,s,o,r){const t=p.$1M.from();if(typeof s=="string"||o?.ignoreChangeEvents&&o?.ignoreCreateEvents&&o?.ignoreDeleteEvents)return t;const n=w.getProxy(O.$YM.MainThreadFileSystemEventService);let c=!1;(s.pattern.includes(N.$lk)||s.pattern.includes(N.$mk))&&(c=!0);let h;return r&&(o?.ignoreChangeEvents||o?.ignoreCreateEvents||o?.ignoreDeleteEvents)&&(h=14,o?.ignoreChangeEvents&&(h&=-3),o?.ignoreCreateEvents&&(h&=-5),o?.ignoreDeleteEvents&&(h&=-9)),n.$watch(m.identifier.value,this.a,s.baseUri,{recursive:c,excludes:o?.excludes??[],filter:h},!!r),p.$1M.from({dispose:()=>n.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class T{constructor(w){this.a=w,this.session=this.a.session,this.b=new g.$V(()=>this.a.created.map(R.URI.revive)),this.c=new g.$V(()=>this.a.changed.map(R.URI.revive)),this.d=new g.$V(()=>this.a.deleted.map(R.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class y{constructor(w,m,s){this.j=w,this.k=m,this.l=s,this.a=new S.$ee,this.b=new S.$ee,this.c=new S.$ee,this.d=new S.$ee,this.g=new S.$ge,this.h=new S.$ge,this.i=new S.$ge,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,m,s,o){return new E(this.j,w,m,this.a.event,M.GlobPattern.from(s),o)}$onFileEvent(w){this.a.fire(new T(w))}$onDidRunFileOperation(w,m){switch(w){case 2:this.b.fire(Object.freeze({files:m.map(s=>({oldUri:R.URI.revive(s.source),newUri:R.URI.revive(s.target)}))}));break;case 1:this.d.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:m.map(s=>R.URI.revive(s.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,m){return(s,o,r)=>{const t=function(c){s.call(o,c)};return t.extension=w,m.event(t,void 0,r)}}async $onWillRunFileOperation(w,m,s,o){switch(w){case 2:return await this.n(this.g,{files:m.map(r=>({oldUri:R.URI.revive(r.source),newUri:R.URI.revive(r.target)}))},s,o);case 1:return await this.n(this.i,{files:m.map(r=>R.URI.revive(r.target))},s,o);case 0:case 3:return await this.n(this.h,{files:m.map(r=>R.URI.revive(r.target))},s,o)}}async n(w,m,s,o){const r=new Set,t=[];if(await w.fireAsync(m,o,async(c,h)=>{const i=Date.now(),$=await Promise.resolve(c);$ instanceof p.$$M&&(t.push([h.extension,$]),r.add(h.extension.displayName??h.extension.identifier.value)),Date.now()-i>s&&this.k.warn("SLOW file-participant",h.extension.identifier)}),o.isCancellationRequested||t.length===0)return;const n={edits:[]};for(const[,c]of t){const{edits:h}=M.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});n.edits=n.edits.concat(h)}return{edit:n,extensionNames:Array.from(r)}}}e.$$lc=y}),define(Ce[262],Ae([1,0,18,11,24,14,90,6,25,65,15,17,2,29,304,87,97,165,20,8,7,26,74,4]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2kc=void 0;class a{constructor(U,z){this.d=U,this.e=z}async provideDocumentSymbols(U,z){const H=this.d.getDocument(U),G=await this.e.provideDocumentSymbols(H,z);if(!(0,S.$Kb)(G))return G[0]instanceof c.$hN?G.map(n.DocumentSymbol.from):a.f(G)}static f(U){U=U.slice(0).sort((G,ee)=>{let ne=G.location.range.start.compareTo(ee.location.range.start);return ne===0&&(ne=ee.location.range.end.compareTo(G.location.range.end)),ne});const z=[],H=[];for(const G of U){const ee={name:G.name||"!!MISSING: name!!",kind:n.SymbolKind.from(G.kind),tags:G.tags?.map(n.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:n.Range.from(G.location.range),selectionRange:n.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(ee),z.push(ee);break}const ne=H[H.length-1];if(w.$tt.containsRange(ne.range,ee.range)&&!w.$tt.equalsRange(ne.range,ee.range)){ne.children?.push(ee),H.push(ee);break}H.pop()}}return z}}class v{constructor(U,z,H,G,ee,ne){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.l=ne,this.d=new i.$Rkc("CodeLens"),this.e=new Map}async provideCodeLenses(U,z){const H=this.f.getDocument(U),G=await this.h.provideCodeLenses(H,z);if(!G||z.isCancellationRequested)return;const ee=this.d.add(G),ne=new p.$Uc;this.e.set(ee,ne);const Oe={cacheId:ee,lenses:[]};for(let Be=0;Be<G.length;Be++)Oe.lenses.push({cacheId:[ee,Be],range:n.Range.from(G[Be].range),command:this.g.toInternal(G[Be].command,ne)});return Oe}async resolveCodeLens(U,z){const H=U.cacheId&&this.d.get(...U.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,z),G||(G=H),z.isCancellationRequested)return;const ee=U.cacheId&&this.e.get(U.cacheId[0]);if(ee){if(!G.command){const ne=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,ne),this.l.error(ne);return}return U.command=this.g.toInternal(G.command,ee),U}}releaseCodeLenses(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}}function d(ze){return Array.isArray(ze)?ze.map(n.DefinitionLink.from):ze?[n.DefinitionLink.from(ze)]:[]}class C{constructor(U,z){this.d=U,this.e=z}async provideDefinition(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDefinition(G,ee,H);return d(ne)}}class u{constructor(U,z){this.d=U,this.e=z}async provideDeclaration(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDeclaration(G,ee,H);return d(ne)}}class D{constructor(U,z){this.d=U,this.e=z}async provideImplementation(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideImplementation(G,ee,H);return d(ne)}}class f{constructor(U,z){this.d=U,this.e=z}async provideTypeDefinition(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideTypeDefinition(G,ee,H);return d(ne)}}class k{constructor(U,z){this.d=U,this.e=z}async provideHover(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideHover(G,ee,H);if(!(!ne||(0,S.$Kb)(ne.contents)))return ne.range||(ne.range=G.getWordRangeAtPosition(ee)),ne.range||(ne.range=new c.$3M(ee,ee)),n.Hover.from(ne)}}class b{constructor(U,z){this.d=U,this.e=z}async provideEvaluatableExpression(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideEvaluatableExpression(G,ee,H);if(ne)return n.EvaluatableExpression.from(ne)}}class P{constructor(U,z){this.d=U,this.e=z}async provideInlineValues(U,z,H,G){const ee=this.d.getDocument(U),ne=await this.e.provideInlineValues(ee,n.Range.to(z),n.InlineValueContext.to(H),G);if(Array.isArray(ne))return ne.map(Oe=>n.InlineValue.from(Oe))}}class I{constructor(U,z){this.d=U,this.e=z}async provideDocumentHighlights(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideDocumentHighlights(G,ee,H);if(Array.isArray(ne))return ne.map(n.DocumentHighlight.from)}}class W{constructor(U,z){this.d=U,this.e=z}async provideMultiDocumentHighlights(U,z,H,G){const ee=this.d.getDocument(U),ne=H.map(Ye=>this.d.getDocument(Ye)),Oe=n.Position.to(z),Be=await this.e.provideMultiDocumentHighlights(ee,Oe,ne,G);if(Array.isArray(Be))return Be.map(n.MultiDocumentHighlight.from)}}class V{constructor(U,z){this.d=U,this.e=z}async provideLinkedEditingRanges(U,z,H){const G=this.d.getDocument(U),ee=n.Position.to(z),ne=await this.e.provideLinkedEditingRanges(G,ee,H);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,S.$Hb)(ne.ranges.map(n.Range.from)),wordPattern:ne.wordPattern}}}class q{constructor(U,z){this.d=U,this.e=z}async provideReferences(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Position.to(z),Oe=await this.e.provideReferences(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.location.from)}}class A{static{this.d=1e3}constructor(U,z,H,G,ee,ne,Oe){this.g=U,this.h=z,this.j=H,this.k=G,this.l=ee,this.m=ne,this.n=Oe,this.e=new i.$Rkc("CodeAction"),this.f=new Map}async provideCodeActions(U,z,H,G){const ee=this.g.getDocument(U),ne=m.$vt.isISelection(z)?n.Selection.to(z):n.Range.to(z),Oe=[];for(const it of this.j.getDiagnostics(U))if(ne.intersection(it.range)&&Oe.push(it)>A.d)break;const Be={diagnostics:Oe,only:H.only?new c.$jN(H.only):void 0,triggerKind:n.CodeActionTriggerKind.to(H.trigger)},Ye=await this.k.provideCodeActions(ee,ne,Be,G);if(!(0,S.$Lb)(Ye)||G.isCancellationRequested)return;const _e=this.e.add(Ye),et=new p.$Uc;this.f.set(_e,et);const tt=[];for(let it=0;it<Ye.length;it++){const nt=Ye[it];if(nt)if(A.o(nt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),tt.push({_isSynthetic:!0,title:nt.title,command:this.h.toInternal(nt,et)});else{Be.only&&(nt.kind?Be.only.contains(nt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${nt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=nt.ranges??[];tt.push({cacheId:[_e,it],title:nt.title,command:nt.command&&this.h.toInternal(nt.command,et),diagnostics:nt.diagnostics&&nt.diagnostics.map(n.Diagnostic.from),edit:nt.edit&&n.WorkspaceEdit.from(nt.edit,void 0),kind:nt.kind&&nt.kind.value,isPreferred:nt.isPreferred,isAI:(0,h.$FG)(this.m,"codeActionAI")?nt.isAI:!1,ranges:(0,h.$FG)(this.m,"codeActionRanges")?(0,S.$Hb)(at.map(n.Range.from)):void 0,disabled:nt.disabled?.reason})}}return{cacheId:_e,actions:tt}}async resolveCodeAction(U,z){const[H,G]=U,ee=this.e.get(H,G);if(!ee||A.o(ee))return{};if(!this.k.resolveCodeAction)return{};const ne=await this.k.resolveCodeAction(ee,z)??ee;let Oe;ne.edit&&(Oe=n.WorkspaceEdit.from(ne.edit,void 0));let Be;if(ne.command){const Ye=this.f.get(H);Ye&&(Be=this.h.toInternal(ne.command,Ye))}return{edit:Oe,command:Be}}releaseCodeActions(U){this.f.get(U)?.dispose(),this.f.delete(U),this.e.delete(U)}static o(U){return typeof U.command=="string"&&typeof U.title=="string"}}class j{constructor(U,z,H,G,ee){this.e=U,this.f=z,this.g=H,this.h=G,this.j=ee,this.d=new i.$Rkc("DocumentPasteEdit")}async prepareDocumentPaste(U,z,H,G){if(!this.g.prepareDocumentPaste)return;const ee=this.f.getDocument(U),ne=z.map(Ye=>n.Range.to(Ye)),Oe=n.DataTransfer.toDataTransfer(H,()=>{throw new O.$$});if(await this.g.prepareDocumentPaste(ee,ne,Oe,G),G.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Ye])=>!(Ye instanceof c.$PN));return n.DataTransfer.from(Be)}async providePasteEdits(U,z,H,G,ee,ne){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(z),Be=H.map(tt=>n.Range.to(tt)),Ye=n.DataTransfer.toDataTransfer(G,async tt=>(await this.e.$resolvePasteFileData(this.h,U,tt)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,Ye,{only:ee.only?new c.$UN(ee.only):void 0,triggerKind:ee.triggerKind},ne);if(!_e||ne.isCancellationRequested)return[];const et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(0,null,this.j.displayName||this.j.name),kind:tt.kind,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolvePasteEdit(U,z){const[H,G]=U,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentPasteEdit)return{};const ne=await this.g.resolveDocumentPasteEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releasePasteEdits(U){this.d.delete(U)}}class K{constructor(U,z){this.d=U,this.e=z}async provideDocumentFormattingEdits(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideDocumentFormattingEdits(G,z,H);if(Array.isArray(ee))return ee.map(n.TextEdit.from)}}class re{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeFormattingEdits(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Range.to(z),Oe=await this.e.provideDocumentRangeFormattingEdits(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}async provideDocumentRangesFormattingEdits(U,z,H,G){(0,y.$fg)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ee=this.d.getDocument(U),ne=z.map(n.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(ee,ne,H,G);if(Array.isArray(Oe))return Oe.map(n.TextEdit.from)}}class ae{constructor(U,z){this.d=U,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(U,z,H,G,ee){const ne=this.d.getDocument(U),Oe=n.Position.to(z),Be=await this.e.provideOnTypeFormattingEdits(ne,Oe,H,G,ee);if(Array.isArray(Be))return Be.map(n.TextEdit.from)}}class we{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Rkc("WorkspaceSymbols")}async provideWorkspaceSymbols(U,z){const H=await this.e.provideWorkspaceSymbols(U,z);if(!(0,S.$Lb)(H))return{symbols:[]};const G=this.d.add(H),ee={cacheId:G,symbols:[]};for(let ne=0;ne<H.length;ne++){const Oe=H[ne];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}ee.symbols.push({...n.WorkspaceSymbol.from(Oe),cacheId:[G,ne]})}return ee}async resolveWorkspaceSymbol(U,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!U.cacheId)return U;const H=this.d.get(...U.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,z);return G&&(0,g.$5n)(U,n.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(U){this.d.delete(U)}}class Ie{static supportsResolving(U){return typeof U.prepareRename=="function"}constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideRenameEdits(U,z,H,G){const ee=this.d.getDocument(U),ne=n.Position.to(z);try{const Oe=await this.e.provideRenameEdits(ee,ne,H,G);return Oe?n.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=Ie.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(U,z,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(U),ee=n.Position.to(z);try{const ne=await this.e.prepareRename(G,ee,H);let Oe,Be;if(c.$3M.isRange(ne)?(Oe=ne,Be=G.getText(ne)):(0,y.$0f)(ne)&&(Oe=ne.range,Be=ne.placeholder),!Oe||!Be)return;if(Oe.start.line>ee.line||Oe.end.line<ee.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:n.Range.from(Oe),text:Be}}catch(ne){const Oe=Ie.g(ne);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(ne)}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class de{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideNewSymbolNames(U,z,H){const G=this.d.getDocument(U),ee=n.Range.to(z);try{const ne=await this.e.provideNewSymbolNames(G,ee,H);return ne?ne.map(Oe=>typeof Oe=="string"?{newSymbolName:Oe}:{newSymbolName:Oe.newSymbolName,tags:Oe.tags}):void 0}catch(ne){this.f.error(de.g(ne)??JSON.stringify(ne,null,"	"));return}}static g(U){return typeof U=="string"?U:U instanceof Error&&typeof U.message=="string"?U.message:void 0}}class me{constructor(U,z){this.resultId=U,this.tokens=z}}class Me{constructor(U,z){this.f=U,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(U,z,H){const G=this.f.getDocument(U),ee=z!==0?this.d.get(z):null;let ne=typeof ee?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,ee.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return ee&&this.d.delete(z),ne?(ne=Me.h(ne),this.o(Me.n(ee,ne),ne)):null}async releaseDocumentSemanticColoring(U){this.d.delete(U)}static h(U){return Me.j(U)?Me.k(U)?U:new c.$iO(new Uint32Array(U.data),U.resultId):Me.l(U)?Me.m(U)?U:new c.$kO(U.edits.map(z=>new c.$jO(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),U.resultId):U}static j(U){return U&&!!U.data}static k(U){return U.data instanceof Uint32Array}static l(U){return U&&Array.isArray(U.edits)}static m(U){for(const z of U.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(U,z){if(!Me.j(z)||!U||!U.tokens)return z;const H=U.tokens,G=H.length,ee=z.data,ne=ee.length;let Oe=0;const Be=Math.min(G,ne);for(;Oe<Be&&H[Oe]===ee[Oe];)Oe++;if(Oe===G&&Oe===ne)return new c.$kO([],z.resultId);let Ye=0;const _e=Be-Oe;for(;Ye<_e&&H[G-Ye-1]===ee[ne-Ye-1];)Ye++;return new c.$kO([{start:Oe,deleteCount:G-Oe-Ye,data:ee.subarray(Oe,ne-Ye)}],z.resultId)}o(U,z){if(Me.j(U)){const H=this.e++;return this.d.set(H,new me(U.resultId,U.data)),(0,o.$Xbb)({id:H,type:"full",data:U.data})}if(Me.l(U)){const H=this.e++;return Me.j(z)?this.d.set(H,new me(z.resultId,z.data)):this.d.set(H,new me(U.resultId)),(0,o.$Xbb)({id:H,type:"delta",deltas:(U.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class ce{constructor(U,z){this.d=U,this.e=z}async provideDocumentRangeSemanticTokens(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideDocumentRangeSemanticTokens(G,n.Range.to(z),H);return ee?this.f(ee):null}f(U){return(0,o.$Xbb)({id:0,type:"full",data:U.data})}}class Re{static supportsResolving(U){return typeof U.resolveCompletionItem=="function"}constructor(U,z,H,G,ee){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.d=new i.$Rkc("CompletionItem"),this.e=new Map}async provideCompletionItems(U,z,H,G){const ee=this.f.getDocument(U),ne=n.Position.to(z),Oe=ee.getWordRangeAtPosition(ne)||new c.$3M(ne,ne),Be=Oe.with({end:ne}),Ye=new E.$ae,_e=await this.h.provideCompletionItems(ee,ne,G,n.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const et=Array.isArray(_e)?new c.$wN(_e):_e,tt=Re.supportsResolving(this.h)?this.d.add(et.items):this.d.add([]),it=new p.$Uc;this.e.set(tt,it);const nt=[],at={x:tt,b:nt,a:{replace:n.Range.from(Oe),insert:n.Range.from(Be)},c:et.isIncomplete||void 0,d:Ye.elapsed()};for(let mt=0;mt<et.items.length;mt++){const je=et.items[mt],st=this.l(je,[tt,mt],Be,Oe);nt.push(st)}return at}async resolveCompletionItem(U,z){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...U);if(!H)return;const G=this.l(H,U),ee=await this.h.resolveCompletionItem(H,z);if(!ee)return;const ne=this.l(ee,U);return(G.h!==ne.h||G.i!==ne.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==ne.n||G.o!==ne.o||!(0,g.$6n)(G.p,ne.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:ne.d,c:ne.c,l:ne.l,h:ne.h,i:ne.i,n:ne.n,o:ne.o,p:ne.p}}releaseCompletionItems(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z,H,G){const ee=this.e.get(z[0]);if(!ee)throw Error("DisposableStore is missing...");const ne=this.g.toInternal(U.command,ee),Oe={x:z,a:U.label,b:U.kind!==void 0?n.CompletionItemKind.from(U.kind):void 0,m:U.tags&&U.tags.map(n.CompletionItemTag.from),c:U.detail,d:typeof U.documentation>"u"?void 0:n.MarkdownString.fromStrict(U.documentation),e:U.sortText!==U.label?U.sortText:void 0,f:U.filterText!==U.label?U.filterText:void 0,g:U.preselect||void 0,i:U.keepWhitespace?1:0,k:U.commitCharacters?.join(""),l:U.additionalTextEdits&&U.additionalTextEdits.map(n.TextEdit.from),n:ne?.$ident,o:ne?.id,p:ne?.$ident?void 0:ne?.arguments};U.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=U.textEdit.newText):typeof U.insertText=="string"?Oe.h=U.insertText:U.insertText instanceof c.$_M&&(Oe.h=U.insertText.value,Oe.i|=4);let Be;return U.textEdit?Be=U.textEdit.range:U.range&&(Be=U.range),c.$3M.isRange(Be)?Oe.j=n.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!G?.isEqual(Be.replacing))&&(Oe.j={insert:n.Range.from(Be.inserting),replace:n.Range.from(Be.replacing)}),Oe}}class ie{async provideInlineCompletions(U,z,H,G){}disposeCompletions(U){}handleDidShowCompletionItem(U,z,H){}handlePartialAccept(U,z,H,G){}}class L extends ie{constructor(U,z,H,G){super(),this.f=U,this.g=z,this.h=H,this.j=G,this.d=new ve,this.e=(0,h.$FG)(this.f,"inlineCompletionsAdditions"),this.k={[s.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[s.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,h.$FG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(U,z,H,G){const ee=this.g.getDocument(U),ne=n.Position.to(z),Oe=await this.h.provideInlineCompletionItems(ee,ne,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:n.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Oe||G.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Ye=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Be}),items:Be.map((it,nt)=>{let at;it.command&&(et||(et=new p.$Uc),at=this.j.toInternal(it.command,et));const mt=it.insertText;return{insertText:typeof mt=="string"?mt:{snippet:mt.value},filterText:it.filterText,range:it.range?n.Range.from(it.range):void 0,command:at,idx:nt,completeBracketPairs:this.e?it.completeBracketPairs:!1}}),commands:Ye.map(it=>(et||(et=new p.$Uc),this.j.toInternal(it,et))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(U){this.d.disposeReferenceId(U)?.dispose()}handleDidShowCompletionItem(U,z,H){const G=this.d.get(U)?.items[z];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(U,z,H,G){const ee=this.d.get(U)?.items[z];ee&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(ee,H),this.h.handleDidPartiallyAcceptCompletionItem(ee,n.PartialAcceptInfo.to(G)))}}class x{async provideInlineEdits(U,z,H){const G=this.f.getDocument(U),ee=await this.g.provideInlineEdit(G,{triggerKind:this.e[z.triggerKind]},H);if(!ee||H.isCancellationRequested)return;let ne;const Oe=this.d.createReferenceId({dispose(){ne?.dispose()},item:ee});let Be;ee.accepted&&(ne||(ne=new p.$Uc),Be=this.h.toInternal(ee.accepted,ne));let Ye;return ee.rejected&&(ne||(ne=new p.$Uc),Ye=this.h.toInternal(ee.rejected,ne)),{pid:Oe,text:ee.text,range:n.Range.from(ee.range),accepted:Be,rejected:Ye}}disposeEdit(U){this.d.disposeReferenceId(U)?.dispose()}constructor(U,z,H,G){this.f=z,this.g=H,this.h=G,this.d=new ve,this.e={[s.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[s.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(U){const z=this.e++;return this.d.set(z,U),z}disposeReferenceId(U){const z=this.d.get(U);return this.d.delete(U),z}get(U){return this.d.get(U)}}class Fe{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Rkc("SignatureHelp")}async provideSignatureHelp(U,z,H,G){const ee=this.e.getDocument(U),ne=n.Position.to(z),Oe=this.g(H),Be=await this.f.provideSignatureHelp(ee,ne,G,Oe);if(Be){const Ye=this.d.add([Be]);return{...n.SignatureHelp.from(Be),id:Ye}}}g(U){let z;if(U.activeSignatureHelp){const H=n.SignatureHelp.to(U.activeSignatureHelp),G=this.d.get(U.activeSignatureHelp.id,0);G?(z=G,z.activeSignature=H.activeSignature,z.activeParameter=H.activeParameter):z=H}return{...U,activeSignatureHelp:z}}releaseSignatureHelp(U){this.d.delete(U)}}class Ee{constructor(U,z,H,G,ee){this.f=U,this.g=z,this.h=H,this.j=G,this.k=ee,this.d=new i.$Rkc("InlayHints"),this.e=new Map}async provideInlayHints(U,z,H){const G=this.f.getDocument(U),ee=n.Range.to(z),ne=await this.h.provideInlayHints(G,ee,H);if(!Array.isArray(ne)||ne.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`);return}if(H.isCancellationRequested)return;const Oe=this.d.add(ne);this.e.set(Oe,new p.$Uc);const Be={hints:[],cacheId:Oe};for(let Ye=0;Ye<ne.length;Ye++)this.l(ne[Ye],ee)&&Be.hints.push(this.m(ne[Ye],[Oe,Ye]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(z)}`),Be}async resolveInlayHint(U,z){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...U);if(!H)return;const G=await this.h.resolveInlayHint(H,z);if(G&&this.l(G))return this.m(G,U)}releaseHints(U){this.e.get(U)?.dispose(),this.e.delete(U),this.d.delete(U)}l(U,z){return U.label.length===0||Array.isArray(U.label)&&U.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",U),!1):!(z&&!z.contains(U.position))}m(U,z){const H=this.e.get(z[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:z,tooltip:n.MarkdownString.fromStrict(U.tooltip),position:n.Position.from(U.position),textEdits:U.textEdits&&U.textEdits.map(n.TextEdit.from),kind:U.kind&&n.InlayHintKind.from(U.kind),paddingLeft:U.paddingLeft,paddingRight:U.paddingRight};if(typeof U.label=="string")G.label=U.label;else{const ee=[];G.label=ee;for(const ne of U.label){if(!ne.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:ne.value,tooltip:n.MarkdownString.fromStrict(ne.tooltip)};c.$aN.isLocation(ne.location)&&(Oe.location=n.location.from(ne.location)),ne.command&&(Oe.command=this.g.toInternal(ne.command,H)),ee.push(Oe)}}return G}}class pe{constructor(U,z){this.e=U,this.f=z,this.d=new i.$Rkc("DocumentLink")}async provideLinks(U,z){const H=this.e.getDocument(U),G=await this.f.provideDocumentLinks(H,z);if(!(!Array.isArray(G)||G.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(pe.g).map(n.DocumentLink.from)};{const ee=this.d.add(G),ne={links:[],cacheId:ee};for(let Oe=0;Oe<G.length;Oe++){if(!pe.g(G[Oe]))continue;const Be=n.DocumentLink.from(G[Oe]);Be.cacheId=[ee,Oe],ne.links.push(Be)}return ne}}}static g(U){return U.target&&U.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(U,z){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...U);if(!H)return;const G=await this.f.resolveDocumentLink(H,z);if(!(!G||!pe.g(G)))return n.DocumentLink.from(G)}releaseLinks(U){this.d.delete(U)}}class fe{constructor(U,z){this.d=U,this.e=z}async provideColors(U,z){const H=this.d.getDocument(U),G=await this.e.provideDocumentColors(H,z);return Array.isArray(G)?G.map(ne=>({color:n.Color.from(ne.color),range:n.Range.from(ne.range)})):[]}async provideColorPresentations(U,z,H){const G=this.d.getDocument(U),ee=n.Range.to(z.range),ne=n.Color.to(z.color),Oe=await this.e.provideColorPresentations(ne,{document:G,range:ee},H);if(Array.isArray(Oe))return Oe.map(n.ColorPresentation.from)}}class Y{constructor(U,z){this.d=U,this.e=z}async provideFoldingRanges(U,z,H){const G=this.d.getDocument(U),ee=await this.e.provideFoldingRanges(G,z,H);if(Array.isArray(ee))return ee.map(n.FoldingRange.from)}}class X{constructor(U,z,H){this.d=U,this.e=z,this.f=H}async provideSelectionRanges(U,z,H){const G=this.d.getDocument(U),ee=z.map(n.Position.to),ne=await this.e.provideSelectionRanges(G,ee,H);if(!(0,S.$Lb)(ne))return[];if(ne.length!==ee.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<ee.length;Be++){const Ye=[];Oe.push(Ye);let _e=ee[Be],et=ne[Be];for(;;){if(!et.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ye.push(n.SelectionRange.from(et)),!et.parent)break;_e=et.range,et=et.parent}}return Oe}}class le{constructor(U,z){this.f=U,this.g=z,this.d=new M.$qP(""),this.e=new Map}async prepareSession(U,z,H){const G=this.f.getDocument(U),ee=n.Position.to(z),ne=await this.g.prepareCallHierarchy(G,ee,H);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideCallsTo(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyIncomingCalls(G,H);if(ee)return ee.map(ne=>({from:this.h(U,ne.from),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}async provideCallsFrom(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing call hierarchy item");const ee=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(ee)return ee.map(ne=>({to:this.h(U,ne.to),fromRanges:ne.fromRanges.map(Oe=>n.Range.from(Oe))}))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),G=n.CallHierarchyItem.from(z,U,H.size.toString(36));return H.set(G._itemId,z),G}j(U,z){return this.e.get(U)?.get(z)}}class ue{constructor(U,z){this.f=U,this.g=z,this.d=new M.$qP(""),this.e=new Map}async prepareSession(U,z,H){const G=this.f.getDocument(U),ee=n.Position.to(z),ne=await this.g.prepareTypeHierarchy(G,ee,H);if(!ne)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(ne)?ne.map(Be=>this.h(Oe,Be)):[this.h(Oe,ne)]}async provideSupertypes(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySupertypes(G,H);if(ee)return ee.map(ne=>this.h(U,ne))}async provideSubtypes(U,z,H){const G=this.j(U,z);if(!G)throw new Error("missing type hierarchy item");const ee=await this.g.provideTypeHierarchySubtypes(G,H);if(ee)return ee.map(ne=>this.h(U,ne))}releaseSession(U){this.e.delete(U)}h(U,z){const H=this.e.get(U),G=n.TypeHierarchyItem.from(z,U,H.size.toString(36));return H.set(G._itemId,z),G}j(U,z){return this.e.get(U)?.get(z)}}class Te{constructor(U,z,H,G,ee){this.e=U,this.f=z,this.g=H,this.h=G,this.j=ee,this.d=new i.$Rkc("DocumentDropEdit")}async provideDocumentOnDropEdits(U,z,H,G,ee){const ne=this.f.getDocument(z),Oe=n.Position.to(H),Be=n.DataTransfer.toDataTransfer(G,async tt=>(await this.e.$resolveDocumentOnDropFileData(this.h,U,tt)).buffer),Ye=await this.g.provideDocumentDropEdits(ne,Oe,Be,ee);if(!Ye)return;const _e=(0,S.$3b)(Ye),et=this.d.add(_e);return _e.map((tt,it)=>({_cacheId:[et,it],title:tt.title??(0,r.localize)(1,null,this.j.displayName||this.j.name),kind:tt.kind?.value,yieldTo:tt.yieldTo?.map(nt=>nt.value),insertText:typeof tt.insertText=="string"?tt.insertText:{snippet:tt.insertText.value},additionalEdit:tt.additionalEdit?n.WorkspaceEdit.from(tt.additionalEdit,void 0):void 0}))}async resolveDropEdit(U,z){const[H,G]=U,ee=this.d.get(H,G);if(!ee||!this.g.resolveDocumentDropEdit)return{};const ne=await this.g.resolveDocumentDropEdit(ee,z)??ee;return{additionalEdit:ne.additionalEdit?n.WorkspaceEdit.from(ne.additionalEdit,void 0):void 0}}releaseDropEdits(U){this.d.delete(U)}}class he{constructor(U,z){this.d=U,this.e=z}async provideMappedEdits(U,z,H,G){const ee=l.URI.revive(U),ne=this.d.getDocument(ee),Oe=H.documents.map(_e=>_e.map(et=>({uri:l.URI.revive(et.uri),version:et.version,ranges:et.ranges.map(tt=>n.Range.to(tt))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ye=await this.e.provideMappedEdits(ne,z,Be,G);return Ye?n.WorkspaceEdit.from(Ye):null}}class Pe{constructor(U,z){this.adapter=U,this.extension=z}}class Ne{static{this.d=0}constructor(U,z,H,G,ee,ne,Oe,Be){this.g=z,this.h=H,this.j=G,this.k=ee,this.l=ne,this.m=Oe,this.n=Be,this.f=new Map,this.e=U.getProxy($.$YM.MainThreadLanguageFeatures)}o(U,z){return n.DocumentSelector.from(U,this.g,z)}p(U){return new c.$1M(()=>{this.f.delete(U),this.e.$unregister(U)})}q(){return Ne.d++}async s(U,z,H,G,ee,ne=!1){const Oe=this.f.get(U);if(!Oe||!(Oe.adapter instanceof z))return G;const Be=Date.now();ne||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ye=H(Oe.adapter,Oe.extension);return Promise.resolve(Ye).catch(_e=>{(0,O.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{ne||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),R.CancellationToken.isCancellationToken(ee)?(0,N.$kh)(Ye,ee):Ye}t(U,z){const H=this.q();return this.f.set(H,new Pe(U,z)),H}static u(U){return U.displayName||U.name}registerDocumentSymbolProvider(U,z,H,G){const ee=this.t(new a(this.h,H),U),ne=G&&G.label||Ne.u(U);return this.e.$registerDocumentSymbolProvider(ee,this.o(z,U),ne),this.p(ee)}$provideDocumentSymbols(U,z,H){return this.s(U,a,G=>G.provideDocumentSymbols(l.URI.revive(z),H),void 0,H)}registerCodeLensProvider(U,z,H){const G=this.q(),ee=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Pe(new v(this.h,this.j.converter,H,U,this.n,this.l),U)),this.e.$registerCodeLensSupport(G,this.o(z,U),ee);let ne=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(ee));ne=c.$1M.from(ne,Oe)}return ne}$provideCodeLenses(U,z,H){return this.s(U,v,G=>G.provideCodeLenses(l.URI.revive(z),H),void 0,H)}$resolveCodeLens(U,z,H){return this.s(U,v,G=>G.resolveCodeLens(z,H),void 0,void 0)}$releaseCodeLenses(U,z){this.s(U,v,H=>Promise.resolve(H.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(U,z,H){const G=this.t(new C(this.h,H),U);return this.e.$registerDefinitionSupport(G,this.o(z,U)),this.p(G)}$provideDefinition(U,z,H,G){return this.s(U,C,ee=>ee.provideDefinition(l.URI.revive(z),H,G),[],G)}registerDeclarationProvider(U,z,H){const G=this.t(new u(this.h,H),U);return this.e.$registerDeclarationSupport(G,this.o(z,U)),this.p(G)}$provideDeclaration(U,z,H,G){return this.s(U,u,ee=>ee.provideDeclaration(l.URI.revive(z),H,G),[],G)}registerImplementationProvider(U,z,H){const G=this.t(new D(this.h,H),U);return this.e.$registerImplementationSupport(G,this.o(z,U)),this.p(G)}$provideImplementation(U,z,H,G){return this.s(U,D,ee=>ee.provideImplementation(l.URI.revive(z),H,G),[],G)}registerTypeDefinitionProvider(U,z,H){const G=this.t(new f(this.h,H),U);return this.e.$registerTypeDefinitionSupport(G,this.o(z,U)),this.p(G)}$provideTypeDefinition(U,z,H,G){return this.s(U,f,ee=>ee.provideTypeDefinition(l.URI.revive(z),H,G),[],G)}registerHoverProvider(U,z,H,G){const ee=this.t(new k(this.h,H),U);return this.e.$registerHoverProvider(ee,this.o(z,U)),this.p(ee)}$provideHover(U,z,H,G){return this.s(U,k,ee=>ee.provideHover(l.URI.revive(z),H,G),void 0,G)}registerEvaluatableExpressionProvider(U,z,H,G){const ee=this.t(new b(this.h,H),U);return this.e.$registerEvaluatableExpressionProvider(ee,this.o(z,U)),this.p(ee)}$provideEvaluatableExpression(U,z,H,G){return this.s(U,b,ee=>ee.provideEvaluatableExpression(l.URI.revive(z),H,G),void 0,G)}registerInlineValuesProvider(U,z,H,G){const ee=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,ne=this.t(new P(this.h,H),U);this.e.$registerInlineValuesProvider(ne,this.o(z,U),ee);let Oe=this.p(ne);if(ee!==void 0){const Be=H.onDidChangeInlineValues(Ye=>this.e.$emitInlineValuesEvent(ee));Oe=c.$1M.from(Oe,Be)}return Oe}$provideInlineValues(U,z,H,G,ee){return this.s(U,P,ne=>ne.provideInlineValues(l.URI.revive(z),H,G,ee),void 0,ee)}registerDocumentHighlightProvider(U,z,H){const G=this.t(new I(this.h,H),U);return this.e.$registerDocumentHighlightProvider(G,this.o(z,U)),this.p(G)}registerMultiDocumentHighlightProvider(U,z,H){const G=this.t(new W(this.h,H),U);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(z,U)),this.p(G)}$provideDocumentHighlights(U,z,H,G){return this.s(U,I,ee=>ee.provideDocumentHighlights(l.URI.revive(z),H,G),void 0,G)}$provideMultiDocumentHighlights(U,z,H,G,ee){return this.s(U,W,ne=>ne.provideMultiDocumentHighlights(l.URI.revive(z),H,G.map(Oe=>l.URI.revive(Oe)),ee),void 0,ee)}registerLinkedEditingRangeProvider(U,z,H){const G=this.t(new V(this.h,H),U);return this.e.$registerLinkedEditingRangeProvider(G,this.o(z,U)),this.p(G)}$provideLinkedEditingRanges(U,z,H,G){return this.s(U,V,async ee=>{const ne=await ee.provideLinkedEditingRanges(l.URI.revive(z),H,G);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?Ne.w(ne.wordPattern):void 0}},void 0,G)}registerReferenceProvider(U,z,H){const G=this.t(new q(this.h,H),U);return this.e.$registerReferenceSupport(G,this.o(z,U)),this.p(G)}$provideReferences(U,z,H,G,ee){return this.s(U,q,ne=>ne.provideReferences(l.URI.revive(z),H,G,ee),void 0,ee)}registerCodeActionProvider(U,z,H,G){const ee=new p.$Uc,ne=this.t(new A(this.h,this.j.converter,this.k,H,this.l,U,this.m),U);return this.e.$registerQuickFixSupport(ne,this.o(z,U),{providedKinds:G?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:G?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,ee)}))},Ne.u(U),!!H.resolveCodeAction),ee.add(this.p(ne)),ee}$provideCodeActions(U,z,H,G,ee){return this.s(U,A,ne=>ne.provideCodeActions(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveCodeAction(U,z,H){return this.s(U,A,G=>G.resolveCodeAction(z,H),{},void 0)}$releaseCodeActions(U,z){this.s(U,A,H=>Promise.resolve(H.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(U,z,H){const G=this.t(new K(this.h,H),U);return this.e.$registerDocumentFormattingSupport(G,this.o(z,U),U.identifier,U.displayName||U.name),this.p(G)}$provideDocumentFormattingEdits(U,z,H,G){return this.s(U,K,ee=>ee.provideDocumentFormattingEdits(l.URI.revive(z),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(U,z,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",ee=this.t(new re(this.h,H),U);return this.e.$registerRangeFormattingSupport(ee,this.o(z,U),U.identifier,U.displayName||U.name,G),this.p(ee)}$provideDocumentRangeFormattingEdits(U,z,H,G,ee){return this.s(U,re,ne=>ne.provideDocumentRangeFormattingEdits(l.URI.revive(z),H,G,ee),void 0,ee)}$provideDocumentRangesFormattingEdits(U,z,H,G,ee){return this.s(U,re,ne=>ne.provideDocumentRangesFormattingEdits(l.URI.revive(z),H,G,ee),void 0,ee)}registerOnTypeFormattingEditProvider(U,z,H,G){const ee=this.t(new ae(this.h,H),U);return this.e.$registerOnTypeFormattingSupport(ee,this.o(z,U),G,U.identifier),this.p(ee)}$provideOnTypeFormattingEdits(U,z,H,G,ee,ne){return this.s(U,ae,Oe=>Oe.provideOnTypeFormattingEdits(l.URI.revive(z),H,G,ee,ne),void 0,ne)}registerWorkspaceSymbolProvider(U,z){const H=this.t(new we(z,this.l),U);return this.e.$registerNavigateTypeSupport(H,typeof z.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(U,z,H){return this.s(U,we,G=>G.provideWorkspaceSymbols(z,H),{symbols:[]},H)}$resolveWorkspaceSymbol(U,z,H){return this.s(U,we,G=>G.resolveWorkspaceSymbol(z,H),void 0,void 0)}$releaseWorkspaceSymbols(U,z){this.s(U,we,H=>H.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(U,z,H){const G=this.t(new Ie(this.h,H,this.l),U);return this.e.$registerRenameSupport(G,this.o(z,U),Ie.supportsResolving(H)),this.p(G)}$provideRenameEdits(U,z,H,G,ee){return this.s(U,Ie,ne=>ne.provideRenameEdits(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveRenameLocation(U,z,H,G){return this.s(U,Ie,ee=>ee.resolveRenameLocation(l.URI.revive(z),H,G),void 0,G)}registerNewSymbolNamesProvider(U,z,H){const G=this.t(new de(this.h,H,this.l),U);return this.e.$registerNewSymbolNamesProvider(G,this.o(z,U)),this.p(G)}$provideNewSymbolNames(U,z,H,G){return this.s(U,de,ee=>ee.provideNewSymbolNames(l.URI.revive(z),H,G),void 0,G)}registerDocumentSemanticTokensProvider(U,z,H,G){const ee=this.t(new Me(this.h,H),U),ne=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ee,this.o(z,U),G,ne);let Oe=this.p(ee);if(ne){const Be=H.onDidChangeSemanticTokens(Ye=>this.e.$emitDocumentSemanticTokensEvent(ne));Oe=c.$1M.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(U,z,H,G){return this.s(U,Me,ee=>ee.provideDocumentSemanticTokens(l.URI.revive(z),H,G),null,G)}$releaseDocumentSemanticTokens(U,z){this.s(U,Me,H=>H.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(U,z,H,G){const ee=this.t(new ce(this.h,H),U);return this.e.$registerDocumentRangeSemanticTokensProvider(ee,this.o(z,U),G),this.p(ee)}$provideDocumentRangeSemanticTokens(U,z,H,G){return this.s(U,ce,ee=>ee.provideDocumentRangeSemanticTokens(l.URI.revive(z),H,G),null,G)}registerCompletionItemProvider(U,z,H,G){const ee=this.t(new Re(this.h,this.j.converter,H,this.m,U),U);return this.e.$registerCompletionsProvider(ee,this.o(z,U),G,Re.supportsResolving(H),U.identifier),this.p(ee)}$provideCompletionItems(U,z,H,G,ee){return this.s(U,Re,ne=>ne.provideCompletionItems(l.URI.revive(z),H,G,ee),void 0,ee)}$resolveCompletionItem(U,z,H){return this.s(U,Re,G=>G.resolveCompletionItem(z,H),void 0,H)}$releaseCompletionItems(U,z){this.s(U,Re,H=>H.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(U,z,H,G){const ee=new L(U,this.h,H,this.j.converter),ne=this.t(ee,U);return this.e.$registerInlineCompletionsSupport(ne,this.o(z,U),ee.supportsHandleEvents,t.$Qm.toKey(U.identifier.value),G?.yieldTo?.map(Oe=>t.$Qm.toKey(Oe))||[]),this.p(ne)}$provideInlineCompletions(U,z,H,G,ee){return this.s(U,ie,ne=>ne.provideInlineCompletions(l.URI.revive(z),H,G,ee),void 0,ee)}$handleInlineCompletionDidShow(U,z,H,G){this.s(U,ie,async ee=>{ee.handleDidShowCompletionItem(z,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(U,z,H,G,ee){this.s(U,ie,async ne=>{ne.handlePartialAccept(z,H,G,ee)},void 0,void 0)}$freeInlineCompletionsList(U,z){this.s(U,ie,async H=>{H.disposeCompletions(z)},void 0,void 0)}registerInlineEditProvider(U,z,H){const G=new x(U,this.h,H,this.j.converter),ee=this.t(G,U);return this.e.$registerInlineEditProvider(ee,this.o(z,U),U.identifier),this.p(ee)}$provideInlineEdit(U,z,H,G){return this.s(U,x,ee=>ee.provideInlineEdits(l.URI.revive(z),H,G),void 0,G)}$freeInlineEdit(U,z){this.s(U,x,async H=>{H.disposeEdit(z)},void 0,void 0)}registerSignatureHelpProvider(U,z,H,G){const ee=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,ne=this.t(new Fe(this.h,H),U);return this.e.$registerSignatureHelpProvider(ne,this.o(z,U),ee),this.p(ne)}$provideSignatureHelp(U,z,H,G,ee){return this.s(U,Fe,ne=>ne.provideSignatureHelp(l.URI.revive(z),H,G,ee),void 0,ee)}$releaseSignatureHelp(U,z){this.s(U,Fe,H=>H.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(U,z,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,ee=this.t(new Ee(this.h,this.j.converter,H,this.l,U),U);this.e.$registerInlayHintsProvider(ee,this.o(z,U),typeof H.resolveInlayHint=="function",G,Ne.u(U));let ne=this.p(ee);if(G!==void 0){const Oe=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(G));ne=c.$1M.from(ne,Oe)}return ne}$provideInlayHints(U,z,H,G){return this.s(U,Ee,ee=>ee.provideInlayHints(l.URI.revive(z),H,G),void 0,G)}$resolveInlayHint(U,z,H){return this.s(U,Ee,G=>G.resolveInlayHint(z,H),void 0,H)}$releaseInlayHints(U,z){this.s(U,Ee,H=>H.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(U,z,H){const G=this.t(new pe(this.h,H),U);return this.e.$registerDocumentLinkProvider(G,this.o(z,U),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(U,z,H){return this.s(U,pe,G=>G.provideLinks(l.URI.revive(z),H),void 0,H,z.scheme==="output")}$resolveDocumentLink(U,z,H){return this.s(U,pe,G=>G.resolveLink(z,H),void 0,void 0,!0)}$releaseDocumentLinks(U,z){this.s(U,pe,H=>H.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(U,z,H){const G=this.t(new fe(this.h,H),U);return this.e.$registerDocumentColorProvider(G,this.o(z,U)),this.p(G)}$provideDocumentColors(U,z,H){return this.s(U,fe,G=>G.provideColors(l.URI.revive(z),H),[],H)}$provideColorPresentations(U,z,H,G){return this.s(U,fe,ee=>ee.provideColorPresentations(l.URI.revive(z),H,G),void 0,G)}registerFoldingRangeProvider(U,z,H){const G=this.q(),ee=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Pe(new Y(this.h,H),U)),this.e.$registerFoldingRangeProvider(G,this.o(z,U),U.identifier,ee);let ne=this.p(G);if(ee!==void 0){const Oe=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ee));ne=c.$1M.from(ne,Oe)}return ne}$provideFoldingRanges(U,z,H,G){return this.s(U,Y,ee=>ee.provideFoldingRanges(l.URI.revive(z),H,G),void 0,G)}registerSelectionRangeProvider(U,z,H){const G=this.t(new X(this.h,H,this.l),U);return this.e.$registerSelectionRangeProvider(G,this.o(z,U)),this.p(G)}$provideSelectionRanges(U,z,H,G){return this.s(U,X,ee=>ee.provideSelectionRanges(l.URI.revive(z),H,G),[],G)}registerCallHierarchyProvider(U,z,H){const G=this.t(new le(this.h,H),U);return this.e.$registerCallHierarchyProvider(G,this.o(z,U)),this.p(G)}$prepareCallHierarchy(U,z,H,G){return this.s(U,le,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(U,z,H,G){return this.s(U,le,ee=>ee.provideCallsTo(z,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(U,z,H,G){return this.s(U,le,ee=>ee.provideCallsFrom(z,H,G),void 0,G)}$releaseCallHierarchy(U,z){this.s(U,le,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(U,z,H){const G=this.t(new ue(this.h,H),U);return this.e.$registerTypeHierarchyProvider(G,this.o(z,U)),this.p(G)}$prepareTypeHierarchy(U,z,H,G){return this.s(U,ue,ee=>Promise.resolve(ee.prepareSession(l.URI.revive(z),H,G)),void 0,G)}$provideTypeHierarchySupertypes(U,z,H,G){return this.s(U,ue,ee=>ee.provideSupertypes(z,H,G),void 0,G)}$provideTypeHierarchySubtypes(U,z,H,G){return this.s(U,ue,ee=>ee.provideSubtypes(z,H,G),void 0,G)}$releaseTypeHierarchy(U,z){this.s(U,ue,H=>Promise.resolve(H.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(U,z,H,G){const ee=this.q();return this.f.set(ee,new Pe(new Te(this.e,this.h,H,ee,U),U)),this.e.$registerDocumentOnDropEditProvider(ee,this.o(z,U),(0,h.$FG)(U,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(ee)}$provideDocumentOnDropEdits(U,z,H,G,ee,ne){return this.s(U,Te,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(z,l.URI.revive(H),G,ee,ne)),void 0,void 0)}$resolveDropEdit(U,z,H){return this.s(U,Te,G=>G.resolveDropEdit(z,H),{},void 0)}$releaseDropEdits(U,z){this.s(U,Te,H=>Promise.resolve(H.releaseDropEdits(z)),void 0,void 0)}registerMappedEditsProvider(U,z,H){const G=this.t(new he(this.h,H),U);return this.e.$registerMappedEditsProvider(G,this.o(z,U)),this.p(G)}$provideMappedEdits(U,z,H,G,ee){return this.s(U,he,ne=>Promise.resolve(ne.provideMappedEdits(z,H,G,ee)),null,ee)}registerDocumentPasteEditProvider(U,z,H,G){const ee=this.q();return this.f.set(ee,new Pe(new j(this.e,this.h,H,ee,U),U)),this.e.$registerPasteEditProvider(ee,this.o(z,U),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(ne=>ne.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(ee)}$prepareDocumentPaste(U,z,H,G,ee){return this.s(U,j,ne=>ne.prepareDocumentPaste(l.URI.revive(z),H,G,ee),void 0,ee)}$providePasteEdits(U,z,H,G,ee,ne,Oe){return this.s(U,j,Be=>Be.providePasteEdits(z,l.URI.revive(H),G,ee,ne,Oe),void 0,Oe)}$resolvePasteEdit(U,z,H){return this.s(U,j,G=>G.resolvePasteEdit(z,H),{},void 0)}$releasePasteEdits(U,z){this.s(U,j,H=>Promise.resolve(H.releasePasteEdits(z)),void 0,void 0)}static w(U){return{pattern:U.source,flags:U.flags}}static y(U){return{decreaseIndentPattern:Ne.w(U.decreaseIndentPattern),increaseIndentPattern:Ne.w(U.increaseIndentPattern),indentNextLinePattern:U.indentNextLinePattern?Ne.w(U.indentNextLinePattern):void 0,unIndentedLinePattern:U.unIndentedLinePattern?Ne.w(U.unIndentedLinePattern):void 0}}static z(U){return{beforeText:Ne.w(U.beforeText),afterText:U.afterText?Ne.w(U.afterText):void 0,previousLineText:U.previousLineText?Ne.w(U.previousLineText):void 0,action:U.action}}static B(U){return U.map(Ne.z)}static C(U){return{open:U.open,close:U.close,notIn:U.notIn?U.notIn.map(z=>c.SyntaxTokenType.toString(z)):void 0}}static D(U){return U.map(Ne.C)}setLanguageConfiguration(U,z,H){const{wordPattern:G}=H;if(G&&(0,T.$jf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(z,G):this.h.setWordDefinitionFor(z,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",U,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",U,"Do not use.");const ee=this.q(),ne={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Ne.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Ne.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Ne.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Ne.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ee,z,ne),this.p(ee)}$setWordDefinitions(U){for(const z of U)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}e.$2kc=Ne}),define(Ce[88],Ae([1,0,6,4,8,7,101,20,11,5,166,106,14,3,16,84,13,40]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r){"use strict";var t;Object.defineProperty(e,"__esModule",{value:!0}),e.$Jlc=e.$Ilc=void 0,e.$Ilc=(0,w.$vi)("IExtHostLanguageModels");class n{constructor($,a){this.option=$,this.stream=new g.$Yh,this.stream=a??new g.$Yh}}class c{constructor(){this.a=new Map,this.b=new g.$Yh,this.c=!1,this.d=!1;const $=this;this.apiObject={stream:$.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,$]of this.a)yield $.stream;else yield this.b}handleFragment($){if(this.c)return;this.d=!0;let a=this.a.get($.index);a||(this.a.size===0?a=new n($.index,this.b):a=new n($.index),this.a.set($.index,a)),a.stream.emitOne($.part)}get isStreaming(){return this.d}reject($){this.c=!0;for(const a of this.f())a.reject($)}resolve(){this.c=!0;for(const $ of this.f())$.resolve()}}let h=class{static{t=this}static{this.a=1}constructor($,a,v){this.j=a,this.k=v,this.c=new E.$ee,this.d=new E.$ee,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new p.$Sm,this.i=new Map,this.o=new Set,this.b=$.getProxy(N.$YM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel($,a,v,d){const C=t.a++;this.f.set(C,{extension:$.identifier,provider:v,languageModelId:a});let u;return d.auth&&(u={providerLabel:$.displayName||$.name,accountLabel:typeof d.auth=="object"?d.auth.label:void 0}),this.b.$registerLanguageModelProvider(C,a,{extension:$.identifier,identifier:a,name:d.name??"",version:d.version,tokens:d.tokens,auth:u}),(0,S.$Tc)(()=>{this.f.delete(C),this.b.$unregisterProvider(C)})}async $provideLanguageModelResponse($,a,v,d,C,u){const D=this.f.get($);if(!D)return;const f=new M.$9v(async k=>{if(u.isCancellationRequested){this.j.warn(`[CHAT](${D.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(a,{index:k.index,part:k.part})});return D.provider.provideLanguageModelResponse2(d.map(R.LanguageModelMessage.to),C,p.$Qm.toKey(v),f,u)}$provideTokenLength($,a,v){const d=this.f.get($);return d?Promise.resolve(d.provider.provideTokenCount(a,v)):Promise.resolve(0)}$updateLanguageModels($){const a=[],v=[];if($.added)for(const d of $.added)this.g.set(d.identifier,d),a.push(d.identifier);if($.removed)for(const d of $.removed){this.g.delete(d),v.push(d);for(const[C,u]of this.i)u.languageModelId===d&&(u.res.reject(new l.$5),this.i.delete(C))}this.d.fire(Object.freeze({added:Object.freeze(a),removed:Object.freeze(v)})),$.added?.forEach(this.n,this)}getLanguageModelIds(){return Array.from(this.g.keys())}$updateModelAccesslist($){const a=new Array;for(const{from:v,to:d,enabled:C}of $){const u=this.h.get(v)??new p.$Rm;if(u.has(d)!==C){C?u.add(d):u.delete(d),this.h.set(v,u);const f={from:v,to:d};a.push(f),this.c.fire(f)}}}async sendChatRequest($,a,v,d,C){const u=$.identifier,D=await this.b.$prepareChatAccess(u,a,d.justification);if(!D||!this.g.has(a))throw O.$$O.NotFound(`Language model '${a}' is unknown.`);if(this.m(u,D)&&(!await this.l($,{identifier:D.extension,displayName:D.auth.providerLabel},d.justification,d.silent)||!this.h.get(u)?.has(D.extension)))throw O.$$O.NoPermissions(`Language model '${a}' cannot be used by '${u.value}'.`);const f=Math.random()*1e6|0,k=this.b.$fetchResponse(u,a,f,v.map(R.LanguageModelMessage.from),d.modelOptions??{},C),b=new g.$uh,P=new c;this.i.set(f,{languageModelId:a,res:P});let I;if(k.catch(W=>{b.isOpen()?P.reject(W):I=W}).finally(()=>{this.i.delete(f),P.resolve(),b.open()}),await b.wait(),I)throw new O.$$O(`Language model '${a}' errored, check cause for more details`,"Unknown",I);return P.apiObject}async $handleResponseFragment($,a){const v=this.i.get($);v&&v.res.handleFragment(a)}async l($,a,v,d){const C=y.$1L+a.identifier.value;if(await this.k.getSession($,C,[],{silent:!0}))return this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0;if(d)return!1;try{const D=v?(0,T.localize)(0,null,a.displayName,v):(0,T.localize)(1,null,a.displayName);return await this.k.getSession($,C,[],{forceNewSession:{detail:D}}),this.$updateModelAccesslist([{from:$.identifier,to:a.identifier,enabled:!0}]),!0}catch{return!1}}m($,a){return!!a.auth&&!p.$Qm.equals(a.extension,$)}async n($){for(const a of this.o)try{await this.l(a,{identifier:$.extension,displayName:""},void 0,!0)}catch(v){this.j.error("Fake Auth request failed"),this.j.error(v)}}async computeTokenLength($,a,v){const d=this.g.get($);if(!d)throw O.$$O.NotFound(`Language model '${$}' is unknown.`);const C=r.Iterable.find(this.f.values(),u=>u.languageModelId===$);return C?C.provider.provideTokenCount(a,v):this.b.$countTokens(d.identifier,typeof a=="string"?a:R.LanguageModelMessage.from(a),v)}getLanguageModelInfo($){const a=this.g.get($);if(a)return{id:a.identifier,name:a.name,version:a.version,tokens:a.tokens}}createLanguageModelAccessInformation($){this.o.add($);const a=this,v=E.Event.signal(E.Event.filter(this.c.event,C=>p.$Qm.equals(C.from,$.identifier))),d=E.Event.signal(this.d.event);return{get onDidChange(){return E.Event.any(v,d)},canSendRequest(C){const u=a.g.get(C);if(!u)return;if(!a.m($.identifier,u))return!0;const D=a.h.get($.identifier);if(D)return D.has(u.extension)}}}};e.$Jlc=h,e.$Jlc=h=t=Je([We(0,m.$lP),We(1,o.$2j),We(2,s.$4kc)],h)}),define(Ce[263],Ae([1,0,4,8,7,33,11,6,26]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$omc=void 0;class E{constructor(y,l,w,m){this.c=l,this.d=w,this.e=m,this.b=[],this.f=0,this.g=new Set,this.a=y.getProxy(S.$YM.MainThreadLanguages)}$acceptLanguageIds(y){this.b=y}async getLanguages(){return this.b.slice(0)}async changeLanguage(y,l){await this.a.$changeLanguage(y,l);const w=this.c.getDocumentData(y);if(!w)throw new Error(`document '${y.toString()}' NOT found`);return w.document}async tokenAtPosition(y,l){const w=y.version,m=N.Position.from(l),s=await this.a.$tokensAtPosition(y.uri,m),o={type:R.StandardTokenType.Other,range:y.getWordRangeAtPosition(l)??new R.$3M(l.line,l.character,l.line,l.character)};if(!s)return o;const r={range:N.Range.to(s.range),type:N.TokenType.to(s.type)};return!r.range.contains(l)||w!==y.version?o:r}createLanguageStatusItem(y,l,w){const m=this.f++,s=this.a,o=this.g,r=`${y.identifier.value}/${l}`;if(o.has(r))throw new Error(`LanguageStatusItem with id '${l}' ALREADY exists`);o.add(r);const t={selector:w,id:l,name:y.displayName??y.name,severity:R.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let n;const c=new p.$Uc,h=()=>{if(n?.dispose(),!o.has(r)){console.warn(`LanguageStatusItem (${l}) from ${y.identifier.value} has been disposed and CANNOT be updated anymore`);return}n=(0,M.$xh)(()=>{c.clear(),this.a.$setLanguageStatus(m,{id:r,name:t.name??y.displayName??y.name,source:y.displayName??y.name,selector:N.DocumentSelector.from(t.selector,this.e),label:t.text,detail:t.detail??"",severity:t.severity===R.LanguageStatusSeverity.Error?O.default.Error:t.severity===R.LanguageStatusSeverity.Warning?O.default.Warning:O.default.Info,command:t.command&&this.d.toInternal(t.command,c),accessibilityInfo:t.accessibilityInformation,busy:t.busy})},0)},i={dispose(){c.dispose(),n?.dispose(),s.$removeLanguageStatus(m),o.delete(r)},get id(){return t.id},get name(){return t.name},set name($){t.name=$,h()},get selector(){return t.selector},set selector($){t.selector=$,h()},get text(){return t.text},set text($){t.text=$,h()},set text2($){(0,g.$GG)(y,"languageStatusText"),t.text=$,h()},get text2(){return(0,g.$GG)(y,"languageStatusText"),t.text},get detail(){return t.detail},set detail($){t.detail=$,h()},get severity(){return t.severity},set severity($){t.severity=$,h()},get accessibilityInformation(){return t.accessibilityInformation},set accessibilityInformation($){t.accessibilityInformation=$,h()},get command(){return t.command},set command($){t.command=$,h()},get busy(){return t.busy},set busy($){t.busy=$,h()}};return h(),i}}e.$omc=E}),define(Ce[264],Ae([1,0,12,2,8,7,83]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class p{constructor(y,l,w,m){this.start=y,this.deletedCount=l,this.deletedItems=w,this.items=m}asApiEvent(){return{range:new O.$pO(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class g{static asModelAddData(y){return{EOL:y.eol,lines:y.source,languageId:y.language,uri:y.uri,isDirty:!1,versionId:1}}constructor(y,l,w){this.notebook=y,this.h=l,this.j=w,this.handle=w.handle,this.uri=N.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(R.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(R.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const y=this,l=this.h.getDocument(this.uri);if(!l)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:R.NotebookCellKind.to(this.j.cellKind),document:l.document,get mime(){return y.g},set mime(m){y.g=m},get outputs(){return y.a.slice(0)},get metadata(){return y.b},get executionSummary(){return y.d}};this.f=Object.freeze(w)}return this.f}setOutputs(y){this.a=y.map(R.NotebookCellOutput.to)}setOutputItems(y,l,w){const m=w.map(R.NotebookCellOutputItem.to),s=this.a.find(o=>o.id===y);if(s&&(l||(s.items.length=0),s.items.push(...m),s.items.length>1&&s.items.every(o=>M.$VK(o.mime)))){const o=new Map,r=[];s.items.forEach(t=>{let n;o.has(t.mime)?n=o.get(t.mime):(n=[],o.set(t.mime,n),r.push(t.mime)),n.push(t.data)}),s.items.length=0,r.forEach(t=>{const n=M.$WK(o.get(t));s.items.push({mime:t,data:n.data.buffer})})}}setMetadata(y){this.b=Object.freeze(y)}setInternalMetadata(y){this.e=y,this.d=Object.freeze(R.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.$amc=g;class E{static{this.a=0}constructor(y,l,w,m,s){this.k=y,this.l=l,this.m=w,this.uri=m,this.handle=E.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=s.viewType,this.f=Object.freeze(s.metadata??Object.create(null)),this.r([[0,0,s.cells]],!0,void 0),this.g=s.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const y=this,l={get uri(){return y.uri},get version(){return y.g},get notebookType(){return y.d},get isDirty(){return y.h},get isUntitled(){return y.uri.scheme===S.Schemas.untitled},get isClosed(){return y.j},get metadata(){return y.f},get cellCount(){return y.b.length},cellAt(w){return w=y.n(w),y.b[w].apiCell},getCells(w){return(w?y.p(w):y.b).map(s=>s.apiCell)},save(){return y.q()}};this.e=Object.freeze(l)}return this.e}acceptDocumentPropertiesChanged(y){y.metadata&&(this.f=Object.freeze({...this.f,...y.metadata}))}acceptDirty(y){this.h=y}acceptModelChanged(y,l,w){this.g=y.versionId,this.h=l,this.acceptDocumentPropertiesChanged({metadata:w});const m={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},s=[];for(const r of y.rawEvents)r.kind===M.NotebookCellsChangeType.ModelChange?this.r(r.changes,!1,m.contentChanges):r.kind===M.NotebookCellsChangeType.Move?this.s(r.index,r.length,r.newIdx,m.contentChanges):r.kind===M.NotebookCellsChangeType.Output?(this.t(r.index,r.outputs),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.OutputItem?(this.u(r.index,r.outputId,r.append,r.outputItems),s.push({cell:this.b[r.index].apiCell,outputs:this.b[r.index].apiCell.outputs})):r.kind===M.NotebookCellsChangeType.ChangeCellLanguage?(this.v(r.index,r.language),s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document})):r.kind===M.NotebookCellsChangeType.ChangeCellContent?s.push({cell:this.b[r.index].apiCell,document:this.b[r.index].apiCell.document}):r.kind===M.NotebookCellsChangeType.ChangeCellMime?this.w(r.index,r.mime):r.kind===M.NotebookCellsChangeType.ChangeCellMetadata?(this.x(r.index,r.metadata),s.push({cell:this.b[r.index].apiCell,metadata:this.b[r.index].apiCell.metadata})):r.kind===M.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(r.index,r.internalMetadata),s.push({cell:this.b[r.index].apiCell,executionSummary:this.b[r.index].apiCell.executionSummary}));const o=new Map;for(let r=0;r<s.length;r++){const t=s[r],n=o.get(t.cell);if(n===void 0){const c=m.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...t});o.set(t.cell,c-1)}else m.cellChanges[n]={...m.cellChanges[n],...t}}return Object.freeze(m),Object.freeze(m.cellChanges),Object.freeze(m.contentChanges),m}n(y){return y=y|0,y<0?0:y>=this.b.length?this.b.length-1:y}o(y){let l=y.start|0,w=y.end|0;return l<0&&(l=0),w>this.b.length&&(w=this.b.length),y.with({start:l,end:w})}p(y){y=this.o(y);const l=[];for(let w=y.start;w<y.end;w++)l.push(this.b[w]);return l}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(y,l,w){if(this.j)return;const m=[],s=[],o=[];if(y.reverse().forEach(r=>{const n=r[2].map(i=>{const $=new g(this,this.l,i);return l||s.push(g.asModelAddData(i)),$}),c=new p(r[0],r[1],[],n),h=this.b.splice(r[0],r[1],...n);for(const i of h)o.push(i.uri),c.deletedItems.push(i.apiCell);m.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:s,removedDocuments:o}),w)for(const r of m)w.push(r.asApiEvent())}s(y,l,w,m){const s=this.b.splice(y,l);this.b.splice(w,0,...s);const o=[new p(y,l,s.map(r=>r.apiCell),[]),new p(w,0,[],s)];for(const r of o)m.push(r.asApiEvent())}t(y,l){this.b[y].setOutputs(l)}u(y,l,w,m){this.b[y].setOutputItems(l,w,m)}v(y,l){const w=this.b[y];w.apiCell.document.languageId!==l&&this.m.$acceptModelLanguageChanged(w.uri,l)}w(y,l){const w=this.b[y];w.apiCell.mime=l}x(y,l){this.b[y].setMetadata(l)}y(y,l){this.b[y].setInternalMetadata(l)}getCellFromApiCell(y){return this.b.find(l=>l.apiCell===y)}getCellFromIndex(y){return this.b[y]}getCell(y){return this.b.find(l=>l.handle===y)}getCellIndex(y){return this.b.indexOf(y)}}e.$bmc=E}),define(Ce[265],Ae([1,0,5,2,8,7,34]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qmc=void 0;class p{constructor(E,T,y,l={timeout:1500,errors:3}){this.b=E,this.c=T,this.d=y,this.f=l,this.a=new S.$ge}dispose(){}getOnWillSaveNotebookDocumentEvent(E){return(T,y,l)=>{const w=function(s){T.call(y,s)};return w.extension=E,this.a.event(w,void 0,l)}}async $participateInSave(E,T,y){const l=N.URI.revive(E),w=this.c.getNotebookDocument(l);if(!w)throw new Error("Unable to resolve notebook document");const m=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:R.TextDocumentSaveReason.to(T)},y,async(o,r)=>{const t=Date.now(),n=await await Promise.resolve(o);Date.now()-t>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier),!y.isCancellationRequested&&n&&(n instanceof O.$$M?m.push(n):this.b.warn("onWillSaveNotebookDocument-listener from extension",r.extension.identifier,"ignored due to invalid data"))}),y.isCancellationRequested)return!1;if(m.length===0)return!0;const s={edits:[]};for(const o of m){const{edits:r}=R.WorkspaceEdit.from(o);s.edits=s.edits.concat(r)}return this.d.$tryApplyWorkspaceEdit(new M.$uw(s))}}e.$qmc=p}),define(Ce[112],Ae([1,0,14,8,7]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class O{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,g,E,T,y,l){this.id=p,this.f=g,this.notebookData=E,this.a=[],this.b=[],this.d=!1,this.a=y,this.b=T,this.c=l}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(g){this.selections=[g]},get selections(){return p.a},set selections(g){if(!Array.isArray(g)||!g.every(R.$pO.isNotebookRange))throw(0,S.$7)("selections");p.a=g,p.g(g)},get visibleRanges(){return p.b},revealRange(g,E){p.f.$tryRevealRange(p.id,N.NotebookRange.from(g),E??R.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},O.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$cmc=O}),define(Ce[266],Ae([1,0,5,13,8]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$smc=void 0;let O=class{constructor(p,g){this.c=p,this.d=g,this.a=new S.$ee,this.b=new S.$ee,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,g){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,g);const E=this.d.getEditorById(p);g.visibleRanges&&E._acceptVisibleRanges(g.visibleRanges.ranges.map(R.NotebookRange.to)),g.selections&&E._acceptSelections(g.selections.selections.map(R.NotebookRange.to)),g.visibleRanges&&this.b.fire({notebookEditor:E.apiEditor,visibleRanges:E.apiEditor.visibleRanges}),g.selections&&this.a.fire(Object.freeze({notebookEditor:E.apiEditor,selections:E.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const g in p)this.d.getEditorById(g)._acceptViewColumn(R.ViewColumn.to(p[g]))}};e.$smc=O,e.$smc=O=Je([We(0,N.$2j)],O)}),define(Ce[267],Ae([1,0,5,4,112]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vmc=void 0;class O{constructor(p,g){this.c=g,this.a=new Map,this.b=p.getProxy(N.$YM.MainThreadNotebookRenderers)}$postRendererMessage(p,g,E){const T=this.c.getEditorById(p);this.a.get(g)?.fire({editor:T.apiEditor,message:E})}createRendererMessaging(p,g){if(!p.contributes?.notebookRenderer?.some(T=>T.id===g))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${g})`);return{onDidReceiveMessage:(T,y,l)=>this.d(g).event(T,y,l),postMessage:(T,y)=>{R.$cmc.apiEditorsToExtHost.has(T)&&([T,y]=[y,T]);const l=y&&R.$cmc.apiEditorsToExtHost.get(y);return this.b.$postMessage(l?.id,g,T)}}}d(p){let g=this.a.get(p);return g||(g=new S.$ee({onDidRemoveLastListener:()=>{g?.dispose(),this.a.delete(p)}}),this.a.set(p,g),g)}}e.$vmc=O}),define(Ce[268],Ae([1,0,8,101,24,68,14]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zmc=void 0;class p{constructor(y){this.b=0,this.c=new Map,this.a=y}async withProgress(y,l,w){const m=this.b++,{title:s,location:o,cancellable:r}=l,t={label:y.displayName||y.name,id:y.identifier.value};return this.a.$startProgress(m,{location:S.ProgressLocation.from(o),title:s,source:t,cancellable:r},y.isUnderDevelopment?void 0:y.identifier.value).catch(M.$2),this.d(m,w,!!r)}d(y,l,w){let m;w&&(m=new R.$pe,this.c.set(y,m));const s=r=>{this.a.$progressEnd(r),this.c.delete(r),m?.dispose()};let o;try{o=l(new E(this.a,y),w&&m?m.token:R.CancellationToken.None)}catch(r){throw s(y),r}return o.then(r=>s(y),r=>s(y)),o}$acceptProgressCanceled(y){const l=this.c.get(y);l&&(l.cancel(),this.c.delete(y))}}e.$zmc=p;function g(T,y){return T.message=y.message,typeof y.increment=="number"&&(typeof T.increment=="number"?T.increment+=y.increment:T.increment=y.increment),T}class E extends N.$9v{constructor(y,l){super(w=>this.throttledReport(w)),this.c=y,this.d=l}throttledReport(y){this.c.$progressReport(this.d,y)}}Je([(0,O.$2h)(100,(T,y)=>g(T,y),()=>Object.create(null))],E.prototype,"throttledReport",null)}),define(Ce[269],Ae([1,0,2,4,11,8]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Amc=void 0;class M{static{this.a=0}constructor(g,E){this.d=E,this.c=new Map,this.b=g.getProxy(N.$YM.MainThreadQuickDiff)}$provideOriginalResource(g,E,T){const y=S.URI.revive(E),l=this.c.get(g);return l?(0,R.$nh)(()=>l.provideOriginalResource(y,T)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(g,E,T,y){const l=M.a++;return this.c.set(l,E),this.b.$registerQuickDiffProvider(l,O.DocumentSelector.from(g,this.d),T,y),{dispose:()=>{this.b.$unregisterQuickDiffProvider(l),this.c.delete(l)}}}}e.$Amc=M}),define(Ce[270],Ae([1,0,24,5,6,4,2,7,14,18,33,42,26,8]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=m;function m(s,o,r){const t=s.getProxy(O.$YM.MainThreadQuickOpen);class n{constructor(u,D){this.e=new Map,this.f=0,this.a=u,this.b=D}showQuickPick(u,D,f,k=S.CancellationToken.None){this.c=void 0;const b=Promise.resolve(D),P=++this.f,I=t.$show(P,{title:f?.title,placeHolder:f?.placeHolder,matchOnDescription:f?.matchOnDescription,matchOnDetail:f?.matchOnDetail,ignoreFocusLost:f?.ignoreFocusOut,canPickMany:f?.canPickMany},k),W={},V=I.then(()=>W);return Promise.race([V,b]).then(q=>{if(q===W)return;const A=(0,l.$FG)(u,"quickPickItemTooltip");return b.then(j=>{const K=[];for(let re=0;re<j.length;re++){const ae=j[re];if(typeof ae=="string")K.push({label:ae,handle:re});else if(ae.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:ae.label});else{ae.tooltip&&!A&&console.warn(`Extension '${u.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${u.identifier.value}`);const we=ae.iconPath?a(ae.iconPath):void 0;K.push({label:ae.label,iconPath:we?.iconPath,iconClass:we?.iconClass,description:ae.description,detail:ae.detail,picked:ae.picked,alwaysShow:ae.alwaysShow,tooltip:A?w.MarkdownString.fromStrict(ae.tooltip):void 0,handle:re})}}return f&&typeof f.onDidSelectItem=="function"&&(this.c=re=>{f.onDidSelectItem(j[re])}),t.$setItems(P,K),I.then(re=>{if(typeof re=="number")return j[re];if(Array.isArray(re))return re.map(ae=>j[ae])})})}).then(void 0,q=>{if(!(0,g.$4)(q))return t.$setError(P,q),Promise.reject(q)})}$onItemSelected(u){this.c?.(u)}showInput(u,D=S.CancellationToken.None){return this.d=u?.validateInput,t.$input(u,typeof this.d=="function",D).then(void 0,f=>{if(!(0,g.$4)(f))return Promise.reject(f)})}async $validateInput(u){if(!this.d)return;const D=await this.d(u);if(!D||typeof D=="string")return D;let f;switch(D.severity){case p.InputBoxValidationSeverity.Info:f=T.default.Info;break;case p.InputBoxValidationSeverity.Warning:f=T.default.Warning;break;case p.InputBoxValidationSeverity.Error:f=T.default.Error;break;default:f=D.message?T.default.Error:T.default.Ignore;break}return{content:D.message,severity:f}}async showWorkspaceFolderPick(u,D=S.CancellationToken.None){const f=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[u]);if(!f)return;const k=await this.a.getWorkspaceFolders2();if(k)return k.find(b=>b.uri.toString()===f.uri.toString())}createQuickPick(u){const D=new v(u,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}createInputBox(u){const D=new d(u,()=>this.e.delete(D._id));return this.e.set(D._id,D),D}$onDidChangeValue(u,D){this.e.get(u)?._fireDidChangeValue(D)}$onDidAccept(u){this.e.get(u)?._fireDidAccept()}$onDidChangeActive(u,D){const f=this.e.get(u);f instanceof v&&f._fireDidChangeActive(D)}$onDidChangeSelection(u,D){const f=this.e.get(u);f instanceof v&&f._fireDidChangeSelection(D)}$onDidTriggerButton(u,D){this.e.get(u)?._fireDidTriggerButton(D)}$onDidTriggerItemButton(u,D,f){const k=this.e.get(u);k instanceof v&&k._fireDidTriggerItemButton(D,f)}$onDidHide(u){this.e.get(u)?._fireDidHide()}}class c{static{this.a=1}constructor(u,D){this.x=u,this.y=D,this._id=v.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$ee,this.q=new N.$ee,this.r=new N.$ee,this.s=new N.$ee,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(u){this.b=u,this.z({title:u})}get step(){return this.c}set step(u){this.c=u,this.z({step:u})}get totalSteps(){return this.d}set totalSteps(u){this.d=u,this.z({totalSteps:u})}get enabled(){return this.g}set enabled(u){this.g=u,this.z({enabled:u})}get busy(){return this.j}set busy(u){this.j=u,this.z({busy:u})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(u){this.k=u,this.z({ignoreFocusOut:u})}get value(){return this.l}set value(u){this.l=u,this.z({value:u})}get placeholder(){return this.m}set placeholder(u){this.m=u,this.z({placeholder:u})}get buttons(){return this.n}set buttons(u){this.n=u.slice(),this.o.clear(),u.forEach((D,f)=>{const k=D===p.$mO.Back?-1:f;this.o.set(k,D)}),this.z({buttons:u.map((D,f)=>({...a(D.iconPath),tooltip:D.tooltip,handle:D===p.$mO.Back?-1:f}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(u){this.l=u,this.q.fire(u)}_fireDidTriggerButton(u){const D=this.o.get(u);D&&this.r.fire(D)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,R.$Qc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),t.$dispose(this._id))}z(u){if(!this.v){for(const D of Object.keys(u)){const f=u[D];this.u[D]=f===void 0?null:f}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){t.$createOrUpdate(this.u),this.u={id:this._id}}}function h(C){if(C instanceof p.$WN)return{id:C.id};const u=$(C),D=i(C);return{dark:typeof u=="string"?M.URI.file(u):u,light:typeof D=="string"?M.URI.file(D):D}}function i(C){return typeof C=="object"&&"light"in C?C.light:C}function $(C){return typeof C=="object"&&"dark"in C?C.dark:C}function a(C){const u=h(C);let D,f;return"id"in u?f=y.ThemeIcon.asClassName(u):D=u,{iconPath:D,iconClass:f}}class v extends c{constructor(u,D){super(u.identifier,D),this.O=u,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$ee,this.L=[],this.M=new N.$ee,this.N=new N.$ee,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(u){this.B=u.slice(),this.C.clear(),this.D.clear(),u.forEach((k,b)=>{this.C.set(b,k),this.D.set(k,b)});const D=(0,l.$FG)(this.O,"quickPickItemTooltip"),f=[];for(let k=0;k<u.length;k++){const b=u[k];if(b.kind===p.QuickPickItemKind.Separator)f.push({type:"separator",label:b.label});else{b.tooltip&&!D&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const P=b.iconPath?a(b.iconPath):void 0;f.push({handle:k,label:b.label,iconPath:P?.iconPath,iconClass:P?.iconClass,description:b.description,detail:b.detail,picked:b.picked,alwaysShow:b.alwaysShow,tooltip:D?w.MarkdownString.fromStrict(b.tooltip):void 0,buttons:b.buttons?.map((I,W)=>({...a(I.iconPath),tooltip:I.tooltip,handle:W}))})}}this.z({items:f})}get canSelectMany(){return this.E}set canSelectMany(u){this.E=u,this.z({canSelectMany:u})}get matchOnDescription(){return this.F}set matchOnDescription(u){this.F=u,this.z({matchOnDescription:u})}get matchOnDetail(){return this.G}set matchOnDetail(u){this.G=u,this.z({matchOnDetail:u})}get sortByLabel(){return this.H}set sortByLabel(u){this.H=u,this.z({sortByLabel:u})}get keepScrollPosition(){return this.I}set keepScrollPosition(u){this.I=u,this.z({keepScrollPosition:u})}get activeItems(){return this.J}set activeItems(u){this.J=u.filter(D=>this.D.has(D)),this.z({activeItems:this.J.map(D=>this.D.get(D))})}get selectedItems(){return this.L}set selectedItems(u){this.L=u.filter(D=>this.D.has(D)),this.z({selectedItems:this.L.map(D=>this.D.get(D))})}_fireDidChangeActive(u){const D=(0,E.$Hb)(u.map(f=>this.C.get(f)));this.J=D,this.K.fire(D)}_fireDidChangeSelection(u){const D=(0,E.$Hb)(u.map(f=>this.C.get(f)));this.L=D,this.M.fire(D)}_fireDidTriggerItemButton(u,D){const f=this.C.get(u);if(!f||!f.buttons||!f.buttons.length)return;const k=f.buttons[D];k&&this.N.fire({button:k,item:f})}}class d extends c{constructor(u,D){super(u.identifier,D),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(u){this.B=u,this.z({password:u})}get prompt(){return this.C}set prompt(u){this.C=u,this.z({prompt:u})}get valueSelection(){return this.D}set valueSelection(u){this.D=u,this.z({valueSelection:u})}get validationMessage(){return this.E}set validationMessage(u){this.E=u,u?typeof u=="string"?this.z({validationMessage:u,severity:T.default.Error}):this.z({validationMessage:u.message,severity:u.severity??T.default.Error}):this.z({validationMessage:void 0,severity:T.default.Ignore})}}return new n(o,r)}}),define(Ce[271],Ae([1,0,2,5,68,6,11,4,18,143,13,20,42,8,26,12,21]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o){"use strict";var r;Object.defineProperty(e,"__esModule",{value:!0}),e.$Dmc=e.$Cmc=void 0;function t(P){return P instanceof S.URI}function n(P,I){return P.scheme===s.Schemas.file&&I.scheme===s.Schemas.file&&o.$k?P.toString()===I.toString():P.toString().toLowerCase()===I.toString().toLowerCase()}function c(P){if(P)return typeof P.iconPath=="string"?S.URI.file(P.iconPath):S.URI.isUri(P.iconPath)||l.ThemeIcon.isThemeIcon(P.iconPath)?P.iconPath:void 0}function h(P){if(P.icon){if(S.URI.isUri(P.icon))return P.icon;if(l.ThemeIcon.isThemeIcon(P.icon))return P.icon;{const I=P.icon;return{light:I.light,dark:I.dark}}}else return}function i(P,I){if(!P.iconPath&&!I.iconPath)return 0;if(P.iconPath){if(!I.iconPath)return 1}else return-1;const W=typeof P.iconPath=="string"?P.iconPath:S.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id,V=typeof I.iconPath=="string"?I.iconPath:S.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id;return(0,E.$pr)(W,V)}function $(P,I){let W=0;if(P.strikeThrough!==I.strikeThrough)return P.strikeThrough?1:-1;if(P.faded!==I.faded)return P.faded?1:-1;if(P.tooltip!==I.tooltip)return(P.tooltip||"").localeCompare(I.tooltip||"");if(W=i(P,I),W!==0)return W;if(P.light&&I.light)W=i(P.light,I.light);else{if(P.light)return 1;if(I.light)return-1}if(W!==0)return W;if(P.dark&&I.dark)W=i(P.dark,I.dark);else{if(P.dark)return 1;if(I.dark)return-1}return W}function a(P,I){if(P.command!==I.command)return P.command<I.command?-1:1;if(P.title!==I.title)return P.title<I.title?-1:1;if(P.tooltip!==I.tooltip){if(P.tooltip!==void 0&&I.tooltip!==void 0)return P.tooltip<I.tooltip?-1:1;if(P.tooltip!==void 0)return 1;if(I.tooltip!==void 0)return-1}if(P.arguments===I.arguments)return 0;if(P.arguments)if(I.arguments){if(P.arguments.length!==I.arguments.length)return P.arguments.length-I.arguments.length}else return 1;else return-1;for(let W=0;W<P.arguments.length;W++){const V=P.arguments[W],q=I.arguments[W];if(V!==q&&!(t(V)&&t(q)&&n(V,q)))return V<q?-1:1}return 0}function v(P,I){let W=(0,E.$pr)(P.resourceUri.fsPath,I.resourceUri.fsPath,!0);if(W!==0)return W;if(P.command&&I.command)W=a(P.command,I.command);else{if(P.command)return 1;if(I.command)return-1}if(W!==0)return W;if(P.decorations&&I.decorations)W=$(P.decorations,I.decorations);else{if(P.decorations)return 1;if(I.decorations)return-1}if(P.multiFileDiffEditorModifiedUri&&I.multiFileDiffEditorModifiedUri)W=(0,E.$pr)(P.multiFileDiffEditorModifiedUri.fsPath,I.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(P.multiFileDiffEditorModifiedUri)return 1;if(I.multiFileDiffEditorModifiedUri)return-1}if(P.multiDiffEditorOriginalUri&&I.multiDiffEditorOriginalUri)W=(0,E.$pr)(P.multiDiffEditorOriginalUri.fsPath,I.multiDiffEditorOriginalUri.fsPath,!0);else{if(P.multiDiffEditorOriginalUri)return 1;if(I.multiDiffEditorOriginalUri)return-1}return W}function d(P,I){for(let W=0;W<P.length;W++)if(P[W]!==I[W])return!1;return!0}function C(P,I){return P.command===I.command&&P.title===I.title&&P.tooltip===I.tooltip&&(P.arguments&&I.arguments?d(P.arguments,I.arguments):P.arguments===I.arguments)}function u(P,I){return(0,g.$ub)(P,I,C)}class D{#e;#t;get value(){return this.d}set value(I){I=I??"",this.#e.$setInputBoxValue(this.l,I),this.n(I)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(I){this.#e.$setInputBoxPlaceholder(this.l,I),this.f=I}get validateInput(){return(0,m.$GG)(this.k,"scmValidation"),this.g}set validateInput(I){if((0,m.$GG)(this.k,"scmValidation"),I&&typeof I!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=I,this.#e.$setValidationProviderIsEnabled(this.l,!!I)}get enabled(){return this.h}set enabled(I){I=!!I,this.h!==I&&(this.h=I,this.#e.$setInputBoxEnablement(this.l,I))}get visible(){return this.j}set visible(I){I=!!I,this.j!==I&&(this.j=I,this.#e.$setInputBoxVisibility(this.l,I))}get document(){return(0,m.$GG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(I,W,V,q,A){this.k=I,this.l=q,this.m=A,this.d="",this.e=new N.$ee,this.f="",this.h=!0,this.j=!0,this.#t=W,this.#e=V}showValidationMessage(I,W){(0,m.$GG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,I,W)}$onInputBoxValueChange(I){this.n(I)}n(I){this.d=I,this.e.fire(I)}}e.$Cmc=D;class f{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(I){this.v=I,this.q.$updateGroupLabel(this.t,this.handle,I)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(I){this.p=I,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(I){this.f=[...I],this.k.fire()}constructor(I,W,V,q,A,j,K){this.q=I,this.s=W,this.t=V,this.u=q,this.v=A,this.multiDiffEditorEnableViewChanges=j,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$ee,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$ee,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=f.d++}getResourceState(I){return this.g.get(I)}$executeResourceCommand(I,W){const V=this.h.get(I);return V?(0,M.$nh)(()=>this.s.executeCommand(V.command,...V.arguments||[],W)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const I=[...this.f].sort(v),V=(0,g.$Db)(this.o,I,v).map(j=>{const K=j.toInsert.map(re=>{const ae=this.e++;this.g.set(ae,re);const we=re.resourceUri;let Ie;if(re.command)if(re.command.command==="vscode.open"||re.command.command==="vscode.diff"||re.command.command==="vscode.changes"){const fe=new O.$Uc;Ie=this.s.converter.toInternal(re.command,fe),this.j.set(ae,fe)}else this.h.set(ae,re.command);const de=(0,m.$FG)(this.w,"scmMultiDiffEditor"),me=de?re.multiDiffEditorOriginalUri:void 0,Me=de?re.multiFileDiffEditorModifiedUri:void 0,ce=c(re.decorations),Re=re.decorations&&c(re.decorations.light)||ce,ie=re.decorations&&c(re.decorations.dark)||ce,L=[Re,ie],x=re.decorations&&re.decorations.tooltip||"",ve=re.decorations&&!!re.decorations.strikeThrough,Fe=re.decorations&&!!re.decorations.faded,Ee=re.contextValue||"";return{rawResource:[ae,we,L,x,ve,Fe,Ee,Ie,me,Me],handle:ae}});return{start:j.start,deleteCount:j.deleteCount,toInsert:K}}),q=V.map(({start:j,deleteCount:K,toInsert:re})=>[j,K,re.map(ae=>ae.rawResource)]),A=V.reverse();for(const{start:j,deleteCount:K,toInsert:re}of A){const ae=re.map(Ie=>Ie.handle),we=this.n.splice(j,K,...ae);for(const Ie of we)this.g.delete(Ie),this.h.delete(Ie),this.j.get(Ie)?.dispose(),this.j.delete(Ie)}return this.o=I,q}dispose(){this.l=!0,this.m.fire()}}class k{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(I){this.g!==I&&(this.g=I,this.#e.$updateSourceControl(this.w,{count:I}))}get quickDiffProvider(){return this.h}set quickDiffProvider(I){this.h=I;let W;(0,m.$FG)(this.x,"quickDiffProvider")&&(W=I?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!I,quickDiffLabel:W})}get historyProvider(){return(0,m.$GG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(I){(0,m.$GG)(this.x,"scmHistoryProvider"),this.j=I,this.k.value=new O.$Uc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!I}),I&&this.k.value.add(I.onDidChangeCurrentHistoryItemGroup(()=>{this.l=I?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(I){I!==this.m&&(this.m=I,this.#e.$updateSourceControl(this.w,{commitTemplate:I}))}get acceptInputCommand(){return this.o}set acceptInputCommand(I){this.n.value=new O.$Uc,this.o=I;const W=this.y.converter.toInternal(I,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:W})}get actionButton(){return(0,m.$GG)(this.x,"scmActionButton"),this.q}set actionButton(I){(0,m.$GG)(this.x,"scmActionButton"),this.p.value=new O.$Uc,this.q=I;const W=I!==void 0?{command:this.y.converter.toInternal(I.command,this.p.value),secondaryCommands:I.secondaryCommands?.map(V=>V.map(q=>this.y.converter.toInternal(q,this.p.value))),description:I.description,enabled:I.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:W??null})}get statusBarCommands(){return this.t}set statusBarCommands(I){if(this.t&&I&&u(this.t,I))return;this.s.value=new O.$Uc,this.t=I;const W=(I||[]).map(V=>this.y.converter.toInternal(V,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:W})}get selected(){return this.u}constructor(I,W,V,q,A,j,K){this.x=I,this.y=q,this.z=A,this.A=j,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new O.$Wc,this.m=void 0,this.n=new O.$Wc,this.o=void 0,this.p=new O.$Wc,this.s=new O.$Wc,this.t=void 0,this.u=!1,this.v=new N.$ee,this.onDidChangeSelection=this.v.event,this.w=k.d++,this.C=new Map,this.D=new Set,this.#e=V;const re=S.URI.from({scheme:s.Schemas.vscodeSourceControl,path:`${A}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new D(I,W,this.#e,this.w,re),this.#e.$registerSourceControl(this.w,A,j,K,re)}createResourceGroup(I,W,V){const q=(0,m.$FG)(this.x,"scmMultiDiffEditor")&&V?.multiDiffEditorEnableViewChanges===!0,A=new f(this.#e,this.y,this.w,I,W,q,this.x),j=N.Event.once(A.onDidDispose)(()=>this.C.delete(A));return this.C.set(A,j),this.eventuallyAddResourceGroups(),A}eventuallyAddResourceGroups(){const I=[],W=[];for(const[V,q]of this.C){q.dispose();const A=V.onDidUpdateResourceStates(()=>{this.D.add(V),this.eventuallyUpdateResourceStates()});N.Event.once(V.onDidDispose)(()=>{this.D.delete(V),A.dispose(),this.e.delete(V.handle),this.#e.$unregisterGroup(this.w,V.handle)}),I.push([V.handle,V.id,V.label,V.features,V.multiDiffEditorEnableViewChanges]);const j=V._takeResourceStateSnapshot();j.length>0&&W.push([V.handle,j]),this.e.set(V.handle,V)}this.#e.$registerGroups(this.w,I,W),this.C.clear()}eventuallyUpdateResourceStates(){const I=[];this.D.forEach(W=>{const V=W._takeResourceStateSnapshot();V.length!==0&&I.push([W.handle,V])}),I.length>0&&this.#e.$spliceResourceStates(this.w,I),this.D.clear()}getResourceGroup(I){return this.e.get(I)}setSelectionState(I){this.u=I,this.v.fire(I)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(I=>I.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,R.$1h)(100)],k.prototype,"eventuallyAddResourceGroups",null),Je([(0,R.$1h)(100)],k.prototype,"eventuallyUpdateResourceStates",null);let b=class{static{r=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(I,W,V,q){this.l=W,this.m=V,this.n=q,this.g=new Map,this.h=new y.$Sm,this.j=new N.$ee,this.e=I.getProxy(p.$YM.MainThreadSCM),this.f=I.getProxy(p.$YM.MainThreadTelemetry),W.registerArgumentProcessor({processArgument:A=>{if(A&&A.$mid===3){const j=this.g.get(A.sourceControlHandle);if(!j)return A;const K=j.getResourceGroup(A.groupHandle);return K?K.getResourceState(A.handle):A}else if(A&&A.$mid===4){const j=this.g.get(A.sourceControlHandle);return j?j.getResourceGroup(A.groupHandle):A}else if(A&&A.$mid===5){const j=this.g.get(A.handle);return j||A}return A}})}createSourceControl(I,W,V,q){this.n.trace("ExtHostSCM#createSourceControl",I.identifier.value,W,V,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:I.identifier.value});const A=r.d++,j=new k(I,this.m,this.e,this.l,W,V,q);this.g.set(A,j);const K=this.h.get(I.identifier)||[];return K.push(j),this.h.set(I.identifier,K),j}getLastInputBox(I){this.n.trace("ExtHostSCM#getLastInputBox",I.identifier.value);const W=this.h.get(I.identifier),V=W&&W[W.length-1];return V&&V.inputBox}$provideOriginalResource(I,W,V){const q=S.URI.revive(W);this.n.trace("ExtHostSCM#$provideOriginalResource",I,q.toString());const A=this.g.get(I);return!A||!A.quickDiffProvider||!A.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,M.$nh)(()=>A.quickDiffProvider.provideOriginalResource(q,V)).then(j=>j||null)}$onInputBoxValueChange(I,W){this.n.trace("ExtHostSCM#$onInputBoxValueChange",I);const V=this.g.get(I);return V&&V.inputBox.$onInputBoxValueChange(W),Promise.resolve(void 0)}$executeResourceCommand(I,W,V,q){this.n.trace("ExtHostSCM#$executeResourceCommand",I,W,V);const A=this.g.get(I);if(!A)return Promise.resolve(void 0);const j=A.getResourceGroup(W);return j?j.$executeResourceCommand(V,q):Promise.resolve(void 0)}$validateInput(I,W,V){this.n.trace("ExtHostSCM#$validateInput",I);const q=this.g.get(I);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,M.$nh)(()=>q.inputBox.validateInput(W,V)).then(A=>{if(!A)return Promise.resolve(void 0);const j=w.MarkdownString.fromStrict(A.message);return j?Promise.resolve([j,A.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(I){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",I),I!==void 0&&this.g.get(I)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=I,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(I,W,V,q){return await this.g.get(I)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(W,V,q)??void 0}async $provideHistoryItems(I,W,V,q){return(await this.g.get(I)?.historyProvider?.provideHistoryItems(W,V,q))?.map(K=>({...K,icon:h(K)}))??void 0}async $provideHistoryItemSummary(I,W,V,q){const A=this.g.get(I)?.historyProvider;if(typeof A?.provideHistoryItemSummary!="function")return;const j=await A.provideHistoryItemSummary(W,V,q);return j?{...j,icon:h(j)}:void 0}async $provideHistoryItemChanges(I,W,V,q){return await this.g.get(I)?.historyProvider?.provideHistoryItemChanges(W,V,q)??void 0}};e.$Dmc=b,e.$Dmc=b=r=Je([We(3,T.$2j)],b)}),define(Ce[272],Ae([1,0,4,8,2]),function(ge,e,S,N,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class O{static{this.a=0}constructor(p,g){this.d=g,this.c=new Map,this.b=p.getProxy(S.$YM.MainThreadShare)}async $provideShare(p,g,E){return await this.c.get(p)?.provideShare({selection:N.Range.to(g.selection),resourceUri:R.URI.revive(g.resourceUri)},E)??void 0}registerShareProvider(p,g){const E=O.a++;return this.c.set(E,g),this.b.$registerShareProvider(E,N.DocumentSelector.from(p,this.d),g.id,g.label,g.priority),{dispose:()=>{this.b.$unregisterShareProvider(E),this.c.delete(E)}}}}e.$Emc=O}),define(Ce[273],Ae([1,0,7,4,169,6,8,17]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=void 0;class g{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new S.$XN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new S.$XN("statusBarItem.warningForeground")]])}#e;#t;constructor(l,w,m,s,o,r=S.StatusBarAlignment.Left,t){if(this.i=!1,this.k="",this.q=new O.$Uc,this.#e=l,this.#t=w,o&&s){this.c=(0,S.$zN)(s.identifier,o);const n=m.get(this.c);n&&(r=n.alignLeft?S.StatusBarAlignment.Left:S.StatusBarAlignment.Right,t=n.priority,this.j=!0,this.name=n.name,this.text=n.text,this.tooltip=n.tooltip,this.command=n.command,this.accessibilityInformation=n.accessibilityInformation)}else this.c=String(g.a++);this.e=s,this.f=o,this.g=r,this.h=this.u(t)}u(l){if((0,p.$_f)(l))return l===Number.POSITIVE_INFINITY?Number.MAX_VALUE:l===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:l}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(l){this.k=l,this.v()}set name(l){this.m=l,this.v()}set tooltip(l){this.l=l,this.v()}set color(l){this.n=l,this.v()}set backgroundColor(l){l&&!g.b.has(l.id)&&(l=void 0),this.o=l,this.v()}set command(l){this.r?.fromApi!==l&&(this.p&&this.q.add(this.p),this.p=new O.$Uc,typeof l=="string"?this.r={fromApi:l,internal:this.#t.toInternal({title:"",command:l},this.p)}:l?this.r={fromApi:l,internal:this.#t.toInternal(l,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(l){this.t=l,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let l;this.e?this.f?l=`${this.e.identifier.value}.${this.f}`:l=this.e.identifier.value:l=this.f;let w;this.m?w=this.m:w=(0,R.localize)(0,null,this.e.displayName||this.e.name);let m=this.n;this.o&&(m=g.b.get(this.o.id));const s=M.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,l,this.e?.identifier.value,w,this.k,s,this.r?.internal,m,this.o,this.g===S.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Gmc=g;class E{constructor(l){this.b=[],this.a=l.createStatusBarEntry(void 0,"status.extensionMessage",S.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,R.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(l){const w={message:l};return this.b.unshift(w),this.c(),new S.$1M(()=>{const m=this.b.indexOf(w);m>=0&&(this.b.splice(m,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class T{constructor(l,w){this.e=new Map,this.a=l.getProxy(N.$YM.MainThreadStatusBar),this.b=w,this.c=new E(this)}$acceptStaticEntries(l){for(const w of l)this.e.set(w.entryId,w)}createStatusBarEntry(l,w,m,s){return new g(this.a,this.b,this.e,l,w,m,s)}setStatusBarMessage(l,w){const m=this.c.setMessage(l);let s;return typeof w=="number"?s=setTimeout(()=>m.dispose(),w):typeof w<"u"&&w.then(()=>m.dispose(),()=>m.dispose()),new S.$1M(()=>{m.dispose(),clearTimeout(s)})}}e.$Hmc=T}),define(Ce[113],Ae([1,0,29,105,50,75,61,8,2]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AP=e.$zP=e.$yP=e.$xP=void 0;const E=(n,c,h,i)=>{let $=c;return{enumerable:!0,configurable:!1,get(){return $},set(a){if(!h($,a)){const v=$;$=a,n.listener?.(i(a,v))}}}},T=(n,c)=>n===c,y={range:(n,c)=>n===c?!0:!n||!c?!1:n.isEqual(c),label:T,description:T,sortText:T,busy:T,error:T,canResolveChildren:T,tags:(n,c)=>!(n.length!==c.length||n.some(h=>!c.find(i=>h.id===i.id)))},l=n=>c=>({op:4,update:n(c)}),w=(n,c)=>({range:(()=>{let h;const i=l($=>({range:S.$tt.lift(p.Range.from($))}));return{enumerable:!0,configurable:!1,get(){return h},set($){n.listener?.({op:6}),y.range(h,$)||(h=$,n.listener?.(i($)))}}})(),label:E(n,c,y.label,l(h=>({label:h}))),description:E(n,void 0,y.description,l(h=>({description:h}))),sortText:E(n,void 0,y.sortText,l(h=>({sortText:h}))),canResolveChildren:E(n,!1,y.canResolveChildren,h=>({op:2,state:h})),busy:E(n,!1,y.busy,l(h=>({busy:h}))),error:E(n,void 0,y.error,l(h=>({error:p.MarkdownString.fromStrict(h)||null}))),tags:E(n,[],y.tags,(h,i)=>({op:1,new:h.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),m=n=>{const c=R.$KL.fromString(n.extId),h=new o(c.controllerId,c.localId,n.label,g.URI.revive(n.uri)||void 0);return h.range=p.Range.to(n.range||void 0),h.description=n.description||void 0,h.sortText=n.sortText||void 0,h.tags=n.tags.map(i=>p.TestTag.to({id:(0,M.$QL)(i).tagId})),h},s=n=>{let c;for(const h of n.tests){const i=m(h.item);(0,N.$hP)(i).parent=c,c=i}return c};e.$xP=s;class o{constructor(c,h,i,$){if(h.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(h)} symbol`);const a=(0,N.$gP)(this,c);Object.defineProperties(this,{id:{value:h,enumerable:!0,writable:!1},uri:{value:$,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof r?void 0:a.parent}},children:{value:(0,O.$fP)(a,N.$hP,o),enumerable:!0,writable:!1},...w(a,i)})}}e.$yP=o;class r extends o{constructor(c,h){super(c,c,h,void 0),this._isRoot=!0}}e.$zP=r;class t extends O.$bP{constructor(c,h,i){super({controllerId:c,getDocumentVersion:$=>$&&i.getDocument($)?.version,getApiFor:N.$hP,getChildren:$=>$.children,root:new r(c,h),toITestItem:p.TestItem.from})}}e.$AP=t}),define(Ce[32],Ae([1,0,17,7,8,25,4,18,13,53,29,93,2,6,3,16,113,22,34,43,65,59,62,35]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LP=e.$KP=e.$JP=e.$IP=e.$HP=e.$GP=void 0;let a=class{#e;#t;#i;constructor(f,k,b){this.b=new Map,this.c=new Map,this.#e=f.getProxy(M.$YM.MainThreadCommands),this.d=k,this.#i=b,this.#t=f.getProxy(M.$YM.MainThreadTelemetry),this.converter=new v(this,P=>{const I=this.c.get(P);return I?.result===C.Void?I:void 0},k),this.f=[{processArgument(P){return(0,E.$5h)(P)}},{processArgument(P){return(0,O.$4n)(P,function(I){if(T.$tt.isIRange(I))return R.Range.to(I);if(y.$st.isIPosition(I))return R.Position.to(I);if(T.$tt.isIRange(I.range)&&l.URI.isUri(I.uri))return R.location.to(I);if(I instanceof r.$Fe)return I.buffer.buffer;if(!Array.isArray(I))return I})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const k=this.registerCommand(!1,f.id,async(...b)=>{const P=f.args.map((W,V)=>{if(!W.validate(b[V]))throw new Error(`Invalid argument '${W.name}' when running '${f.id}', received: ${typeof b[V]=="object"?JSON.stringify(b[V],null,"	"):b[V]} `);return W.convert(b[V])}),I=await this.executeCommand(f.internalId,...P);return f.result.convert(I,b,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new N.$1M(()=>{k.dispose(),this.c.delete(f.id)})}registerCommand(f,k,b,P,I,W){if(this.d.trace("ExtHostCommands#registerCommand",k),!k.trim().length)throw new Error("invalid id");if(this.b.has(k))throw new Error(`command '${k}' already exists`);return this.b.set(k,{callback:b,thisArg:P,metadata:I,extension:W}),f&&this.#e.$registerCommand(k),new N.$1M(()=>{this.b.delete(k)&&f&&this.#e.$unregisterCommand(k)})}executeCommand(f,...k){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,k,!0)}async g(f,k,b){if(this.b.has(f))return this.#e.$fireCommandActivationEvent(f),this.h(f,k,!1);{let P=!1;const I=(0,O.$4n)(k,function(W){if(W instanceof N.$2M)return R.Position.from(W);if(W instanceof N.$3M)return R.Range.from(W);if(W instanceof N.$aN)return R.location.from(W);if(N.$pO.isNotebookRange(W))return R.NotebookRange.from(W);if(W instanceof ArrayBuffer)return P=!0,r.$Fe.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return P=!0,r.$Fe.wrap(W);if(W instanceof r.$Fe)return P=!0,W;if(!Array.isArray(W))return W});try{const W=await this.#e.$executeCommand(f,P?new t.$uw(I):I,b);return(0,E.$5h)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this.g(f,k,!1);throw W}}}async h(f,k,b){const P=this.b.get(f);if(!P)throw new Error("Unknown command");const{callback:I,thisArg:W,metadata:V}=P;if(V?.args)for(let A=0;A<V.args.length;A++)try{(0,S.$mg)(k[A],V.args[A].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${V.args[A].name}' - ${V.args[A].description}`)}const q=c.$ae.create();try{return await I.apply(W,k)}catch(A){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...k);j&&(f=j.command)}if(this.d.error(A,f,P.extension?.identifier),!b)throw A;if(P.extension?.identifier){const j=this.#i.onExtensionError(P.extension.identifier,A);this.d.trace("forwarded error to extension?",j,P.extension?.identifier)}throw new class extends Error{constructor(){super((0,n.$gj)(A)),this.id=f,this.source=P.extension?.displayName??P.extension?.name}}}finally{this.j(P,f,q.elapsed())}}j(f,k,b){f.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new h.$ep(k),duration:b})}$executeContributedCommand(f,...k){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const b=this.b.get(f);return b?(k=k.map(P=>this.f.reduce((I,W)=>W.processArgument(I,b.extension?.identifier),P)),this.h(f,k,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),this.#e.$getCommands().then(k=>(f&&(k=k.filter(b=>b[0]!=="_")),k))}$getContributedCommandMetadata(){const f=Object.create(null);for(const[k,b]of this.b){const{metadata:P}=b;P&&(f[k]=P)}return Promise.resolve(f)}};e.$GP=a,e.$GP=a=Je([We(0,s.$lP),We(1,g.$2j),We(2,i.$FP)],a),e.$HP=(0,m.$vi)("IExtHostCommands");class v{constructor(f,k,b){this.d=f,this.f=k,this.g=b,this.delegatingCommandId=`__vsc${(0,$.$Rg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,k){if(!f)return;const b={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return b;const P=this.f(f.command);if(P)b.id=P.internalId,b.arguments=P.args.map((I,W)=>I.convert(f.arguments&&f.arguments[W]));else if((0,p.$Lb)(f.arguments)){const I=`${f.command} /${++this.c}`;this.b.set(I,f),k.add((0,w.$Tc)(()=>{this.b.delete(I),this.g.trace("CommandsConverter#DISPOSE",I)})),b.$ident=I,b.id=this.delegatingCommandId,b.arguments=[I],this.g.trace("CommandsConverter#CREATE",f.command,I)}return b}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const k=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],k?k.command:"MISSING"),k?this.d.executeCommand(k.command,...k.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.$IP=v;class d{static{this.Uri=new d("uri","Uri of a text document",f=>l.URI.isUri(f),f=>f)}static{this.Position=new d("position","A position in a text document",f=>N.$2M.isPosition(f),R.Position.from)}static{this.Range=new d("range","A range in a text document",f=>N.$3M.isRange(f),R.Range.from)}static{this.Selection=new d("selection","A selection in a text document",f=>N.$4M.isSelection(f),R.Selection.from)}static{this.Number=new d("number","",f=>typeof f=="number",f=>f)}static{this.String=new d("string","",f=>typeof f=="string",f=>f)}static{this.StringArray=d.Arr(d.String)}static Arr(f){return new d(`${f.name}_array`,`Array of ${f.name}, ${f.description}`,k=>Array.isArray(k)&&k.every(b=>f.validate(b)),k=>k.map(b=>f.convert(b)))}static{this.CallHierarchyItem=new d("item","A call hierarchy item",f=>f instanceof N.$lN,R.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new d("item","A type hierarchy item",f=>f instanceof N.$JO,R.TypeHierarchyItem.from)}static{this.TestItem=new d("testItem","A VS Code TestItem",f=>f instanceof o.$yP,R.TestItem.from)}constructor(f,k,b,P){this.name=f,this.description=k,this.validate=b,this.convert=P}optional(){return new d(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,k){return new d(f??this.name,k??this.description,this.validate,this.convert)}}e.$JP=d;class C{static{this.Void=new C("no result",f=>f)}constructor(f,k){this.description=f,this.convert=k}}e.$KP=C;class u{constructor(f,k,b,P,I){this.id=f,this.internalId=k,this.description=b,this.args=P,this.result=I}}e.$LP=u}),define(Ce[274],Ae([1,0,18,12,2,87,97,31,32,8,7]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3kc=void 0;const y=[new g.$LP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of DocumentHighlight-instances.",w(E.DocumentHighlight.to))),new g.$LP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[g.$JP.Uri],new g.$KP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(s,o)=>{if((0,S.$Kb)(s))return;class r extends T.$gN{static to(n){const c=new r(n.name,E.SymbolKind.to(n.kind),n.containerName||"",new T.$aN(o[0],E.Range.to(n.range)));return c.detail=n.detail,c.range=c.location.range,c.selectionRange=E.Range.to(n.selectionRange),c.children=n.children?n.children.map(r.to):[],c}}return s.map(r.to)})),new g.$LP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[g.$JP.Uri,new g.$JP("options","Formatting options",s=>!0,s=>s)],new g.$KP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$LP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[g.$JP.Uri,g.$JP.Range,new g.$JP("options","Formatting options",s=>!0,s=>s)],new g.$KP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$LP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[g.$JP.Uri,g.$JP.Position,new g.$JP("ch","Trigger character",s=>typeof s=="string",s=>s),new g.$JP("options","Formatting options",s=>!0,s=>s)],new g.$KP("A promise that resolves to an array of TextEdits.",w(E.TextEdit.to))),new g.$LP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$LP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$LP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$LP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Location or LocationLink instances.",m)),new g.$LP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Location-instances.",w(E.location.to))),new g.$LP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of Hover-instances.",w(E.Hover.to))),new g.$LP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[g.$JP.Uri,new g.$JP("position","A position in a text document",s=>Array.isArray(s)&&s.every(o=>T.$2M.isPosition(o)),s=>s.map(E.Position.from))],new g.$KP("A promise that resolves to an array of ranges.",s=>s.map(o=>{let r;for(const t of o.reverse())r=new T.$kN(E.Range.to(t),r);return r}))),new g.$LP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[g.$JP.String.with("query","Search string")],new g.$KP("A promise that resolves to an array of SymbolInformation-instances.",s=>s.map(E.WorkspaceSymbol.to))),new g.$LP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of CallHierarchyItem-instances",s=>s.map(E.CallHierarchyItem.to))),new g.$LP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[g.$JP.CallHierarchyItem],new g.$KP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",s=>s.map(E.CallHierarchyIncomingCall.to))),new g.$LP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[g.$JP.CallHierarchyItem],new g.$KP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",s=>s.map(E.CallHierarchyOutgoingCall.to))),new g.$LP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to a range and placeholder text.",s=>{if(s)return{range:E.Range.to(s.range),placeholder:s.text}})),new g.$LP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[g.$JP.Uri,g.$JP.Position,g.$JP.String.with("newName","The new symbol name")],new g.$KP("A promise that resolves to a WorkspaceEdit.",s=>{if(s){if(s.rejectReason)throw new Error(s.rejectReason);return E.WorkspaceEdit.to(s)}})),new g.$LP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[g.$JP.Uri,g.$JP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new g.$KP("A promise that resolves to an array of DocumentLink-instances.",s=>s.map(E.DocumentLink.to))),new g.$LP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[g.$JP.Uri],new g.$KP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$gO(s.tokenTypes,s.tokenModifiers)})),new g.$LP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[g.$JP.Uri],new g.$KP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Ybb)(s);if(o.type==="full")return new T.$iO(o.data,void 0)})),new g.$LP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[g.$JP.Uri,g.$JP.Range.optional()],new g.$KP("A promise that resolves to SemanticTokensLegend.",s=>{if(s)return new T.$gO(s.tokenTypes,s.tokenModifiers)})),new g.$LP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[g.$JP.Uri,g.$JP.Range],new g.$KP("A promise that resolves to SemanticTokens.",s=>{if(!s)return;const o=(0,M.$Ybb)(s);if(o.type==="full")return new T.$iO(o.data,void 0)})),new g.$LP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[g.$JP.Uri,g.$JP.Position,g.$JP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),g.$JP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new g.$KP("A promise that resolves to a CompletionList-instance.",(s,o,r)=>{if(!s)return new T.$wN([]);const t=s.suggestions.map(n=>E.CompletionItem.to(n,r));return new T.$wN(t,s.incomplete)})),new g.$LP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[g.$JP.Uri,g.$JP.Position,g.$JP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new g.$KP("A promise that resolves to SignatureHelp.",s=>{if(s)return E.SignatureHelp.to(s)})),new g.$LP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[g.$JP.Uri,g.$JP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new g.$KP("A promise that resolves to an array of CodeLens-instances.",(s,o,r)=>w(t=>new T.$oN(E.Range.to(t.range),t.command&&r.fromInternal(t.command)))(s))),new g.$LP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[g.$JP.Uri,new g.$JP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",s=>T.$3M.isRange(s),s=>T.$4M.isSelection(s)?E.Selection.from(s):E.Range.from(s)),g.$JP.String.with("kind","Code action kind to return code actions for").optional(),g.$JP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new g.$KP("A promise that resolves to an array of Command-instances.",(s,o,r)=>w(t=>{if(t._isSynthetic){if(!t.command)throw new Error("Synthetic code actions must have a command");return r.fromInternal(t.command)}else{const n=new T.$iN(t.title,t.kind?new T.$jN(t.kind):void 0);return t.edit&&(n.edit=E.WorkspaceEdit.to(t.edit)),t.command&&(n.command=r.fromInternal(t.command)),n.isPreferred=t.isPreferred,n}})(s))),new g.$LP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[g.$JP.Uri],new g.$KP("A promise that resolves to an array of ColorInformation objects.",s=>s?s.map(o=>new T.$CN(E.Range.to(o.range),E.Color.to(o.color))):[])),new g.$LP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new g.$JP("color","The color to show and insert",s=>s instanceof T.$BN,E.Color.from),new g.$JP("context","Context object with uri and range",s=>!0,s=>({uri:s.uri,range:E.Range.from(s.range)}))],new g.$KP("A promise that resolves to an array of ColorPresentation objects.",s=>s?s.map(E.ColorPresentation.to):[])),new g.$LP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[g.$JP.Uri,g.$JP.Range],new g.$KP("A promise that resolves to an array of Inlay objects",(s,o,r)=>s.map(E.InlayHint.to.bind(void 0,r)))),new g.$LP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[g.$JP.Uri],new g.$KP("A promise that resolves to an array of FoldingRange objects",(s,o)=>{if(s)return s.map(E.FoldingRange.to)})),new g.$LP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new g.$KP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(s=>({viewType:s.viewType,displayName:s.displayName,options:{transientOutputs:s.options.transientOutputs,transientCellMetadata:s.options.transientCellMetadata,transientDocumentMetadata:s.options.transientDocumentMetadata},filenamePattern:s.filenamePattern.map(o=>E.NotebookExclusiveDocumentPattern.to(o))})))),new g.$LP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[g.$JP.Uri,g.$JP.Range,new g.$JP("context","An InlineValueContext",s=>s&&typeof s.frameId=="number"&&s.stoppedLocation instanceof T.$3M,s=>E.InlineValueContext.from(s))],new g.$KP("A promise that resolves to an array of InlineValue objects",s=>s.map(E.InlineValue.to))),new g.$LP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new g.$JP("uriOrString","Uri-instance or string (only http/https)",s=>R.URI.isUri(s)||typeof s=="string"&&(0,N.$Fg)(s,N.Schemas.http,N.Schemas.https),s=>s),new g.$JP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional(),g.$JP.String.with("label","").optional()],g.$KP.Void),new g.$LP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[g.$JP.Uri.with("resource","Resource to open"),g.$JP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new g.$JP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="number"||typeof s=="object",s=>s&&(typeof s=="number"?[E.ViewColumn.from(s),void 0]:[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)])).optional()],g.$KP.Void),new g.$LP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[g.$JP.Uri.with("left","Left-hand side resource of the diff editor"),g.$JP.Uri.with("right","Right-hand side resource of the diff editor"),g.$JP.String.with("title","Human readable title for the diff editor").optional(),new g.$JP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",s=>s===void 0||typeof s=="object",s=>s&&[E.ViewColumn.from(s.viewColumn),E.TextEditorOpenOptions.from(s)]).optional()],g.$KP.Void),new g.$LP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[g.$JP.String.with("title","Human readable title for the changes editor"),new g.$JP("resourceList","List of resources to compare",s=>{for(const o of s){if(o.length!==3)return!1;const[r,t,n]=o;if(!R.URI.isUri(r)||!R.URI.isUri(t)&&t!==void 0&&t!==null||!R.URI.isUri(n)&&n!==void 0&&n!==null)return!1}return!0},s=>s)],g.$KP.Void),new g.$LP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[g.$JP.Uri,g.$JP.Position],new g.$KP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new g.$LP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[g.$JP.TypeHierarchyItem],new g.$KP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new g.$LP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[g.$JP.TypeHierarchyItem],new g.$KP("A promise that resolves to an array of TypeHierarchyItem-instances",s=>s.map(E.TypeHierarchyItem.to))),new g.$LP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[g.$JP.TestItem],g.$KP.Void),new g.$LP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[g.$JP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],g.$KP.Void),new g.$LP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[g.$JP.String.with("name","The context key name"),new g.$JP("value","The context key value",()=>!0,s=>s)],g.$KP.Void),new g.$LP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[g.$JP.Uri,g.$JP.StringArray,new g.$JP("MappedEditsContext","Mapped Edits Context",s=>E.MappedEditsContext.is(s),s=>E.MappedEditsContext.from(s))],new g.$KP("A promise that resolves to a workspace edit or null",s=>s?E.WorkspaceEdit.to(s):null))];class l{static register(o){y.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",p.$uj)}}e.$3kc=l;function w(s){return o=>{if(Array.isArray(o))return o.map(s)}}function m(s){if(!Array.isArray(s))return;const o=[];for(const r of s)O.$$t(r)?o.push(E.DefinitionLink.to(r)):o.push(E.location.to(r));return o}}),define(Ce[275],Ae([1,0,11,6,2,4,32,8,7]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=void 0;class E{static{this.a=0}constructor(w,m){this.extension=w,this.provider=m,this.handle=E.a++}}class T{constructor(w){this.session=w,this.responses=[]}}class y{static{this.a=0}constructor(w,m,s,o){this.f=s,this.g=o,this.b=new Map,this.d=new Map,this.e=w.getProxy(O.$YM.MainThreadInlineChat),m.registerApiCommand(new M.$LP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new M.$JP("Run arguments","",r=>!0,r=>{if(r)return{initialRange:r.initialRange?p.Range.from(r.initialRange):void 0,initialSelection:g.$4M.isSelection(r.initialSelection)?p.Selection.from(r.initialSelection):void 0,message:r.message,autoSend:r.autoSend,position:r.position?p.Position.from(r.position):void 0}})],M.$KP.Void))}registerProvider(w,m,s){const o=new E(w,m);return this.b.set(o.handle,o),this.e.$registerInteractiveEditorProvider(o.handle,s?.label??w.displayName??w.name,w.identifier,typeof m.handleInteractiveEditorResponseFeedback=="function",typeof m.provideFollowups=="function",s?.supportReportIssue??!1),(0,N.$Tc)(()=>{this.e.$unregisterInteractiveEditorProvider(o.handle),this.b.delete(o.handle)})}async $prepareSession(w,m,s,o){const r=this.b.get(w);if(!r){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.f.getDocument(R.URI.revive(m)),n=p.Selection.to(s),c=await r.provider.prepareInteractiveEditorSession({document:t,selection:n},o);if(!c)return;if(c.wholeRange&&!c.wholeRange.contains(n))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const h=y.a++;return this.d.set(h,new T(c)),{id:h,placeholder:c.placeholder,input:c.input,slashCommands:c.slashCommands?.map(i=>({command:i.command,detail:i.detail,refer:i.refer,executeImmediately:i.executeImmediately})),wholeRange:p.Range.from(c.wholeRange),message:c.message}}async $provideResponse(w,m,s,o){const r=this.b.get(w);if(!r)return;const t=this.d.get(m.id);if(!t)return;const n={prompt:s.prompt,selection:p.Selection.to(s.selection),wholeRange:p.Range.to(s.wholeRange),attempt:s.attempt,live:s.live,previewDocument:this.f.getDocument(R.URI.revive(s.previewDocument)),withIntentDetection:s.withIntentDetection};let c=!1;const h={report:async D=>{if(!s.live&&D.edits?.length)throw new Error("Progress reporting is only supported for live sessions");c||o.isCancellationRequested||await this.e.$handleProgressChunk(s.requestId,{message:D.message,edits:D.edits?.map(p.TextEdit.from),editsShouldBeInstant:D.editsShouldBeInstant,slashCommand:D.slashCommand?.command,markdownFragment:g.$pN.isMarkdownString(D.content)?D.content.value:D.content})}},i=Promise.resolve(r.provider.provideInteractiveEditorResponse(t.session,n,h,o));let $;try{$=await(0,S.$jh)(i,o)}finally{c=!0}if(!$)return;const a=t.responses.push($)-1,v={wholeRange:p.Range.from($.wholeRange),placeholder:$.placeholder};if(!y.h($))return{...v,id:a,type:"editorEdit",message:p.MarkdownString.from($.contents),edits:[]};const{edits:d,contents:C}=$,u=C!==void 0?p.MarkdownString.from(C):void 0;return d instanceof g.$$M?{...v,id:a,type:"bulkEdit",edits:p.WorkspaceEdit.from(d),message:u}:{...v,id:a,type:"editorEdit",edits:d.map(p.TextEdit.from),message:u}}async $provideFollowups(w,m,s,o){const r=this.b.get(w),t=this.d.get(m),n=t?.responses[s];if(r&&n&&r.provider.provideFollowups){const c=Promise.resolve(r.provider.provideFollowups(t.session,n,o));return(await(0,S.$jh)(c,o))?.map(p.ChatInlineFollowup.from)}}$handleFeedback(w,m,s,o){const r=this.b.get(w),t=this.d.get(m),n=t?.responses[s];if(r&&n){const c=p.InteractiveEditorResponseFeedbackKind.to(o);r.provider.handleInteractiveEditorResponseFeedback?.(t.session,n,c)}}$releaseSession(w,m){}static h(w){return typeof w=="object"&&typeof w.edits=="object"}}e.$_lc=y}),define(Ce[276],Ae([1,0,2,32]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class R{constructor(M,p,g,E,T){this.a=p,this.b=g,this.c=E;const y=new N.$LP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$JP("showOptions","Show Options",l=>!0,l=>l),new N.$JP("resource","Interactive resource Uri",l=>!0,l=>l),new N.$JP("controllerId","Notebook controller Id",l=>!0,l=>l),new N.$JP("title","Interactive editor title",l=>!0,l=>l)],new N.$KP("Notebook and input URI",l=>{if(T.debug("[ExtHostInteractive] open iw with notebook editor id",l.notebookEditorId),l.notebookEditorId!==void 0){const w=this.a.getEditorById(l.notebookEditorId);return T.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri),notebookEditor:w.apiEditor}}return T.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",l.notebookUri,l.inputUri),{notebookUri:S.URI.revive(l.notebookUri),inputUri:S.URI.revive(l.inputUri)}}));this.c.registerApiCommand(y)}$willAddInteractiveDocument(M,p,g,E){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:g,uri:M,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(M,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[M]})}}e.$mmc=R}),define(Ce[277],Ae([1,0,18,11,24,5,6,28,2,20,13,4,32,8,7,76,218,26,34,219]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tmc=void 0,e.$umc=d;let c=class{constructor(u,D,f,k,b){this.m=D,this.n=f,this.o=k,this.q=b,this.b=new p.$Bc,this.c=new p.$Bc,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new O.$ee,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=u.getProxy(y.$YM.MainThreadNotebookKernels);const P=new l.$LP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new l.$JP("options","Select kernel options",W=>!0,W=>{if(W&&"notebookEditor"in W&&"id"in W){const V=this.n.getIdByEditor(W.notebookEditor);return{id:W.id,extension:W.extension,notebookEditorId:V}}else if(W&&"notebookEditor"in W){const V=this.n.getIdByEditor(W.notebookEditor);if(V===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${W.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:V}}return W})],l.$KP.Void),I=new l.$LP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[l.$JP.Uri],new l.$KP("A promise that resolves to an array of variables",(W,V)=>W.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(P),this.o.registerApiCommand(I)}createNotebookController(u,D,f,k,b,P){for(const ce of this.j.values())if(ce.controller.id===D&&E.$Qm.equals(u.identifier,ce.extensionId))throw new Error(`notebook controller with id '${D}' ALREADY exist`);const I=this.k++,W=this;this.q.trace(`NotebookController[${I}], CREATED by ${u.identifier.value}, ${D}`);const V=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${u.identifier}'`);let q=!1;const A=new O.$ee,j=new O.$ee,K={id:d(u.identifier,D),notebookType:f,extensionId:u.identifier,extensionLocation:u.extensionLocation,label:k||u.identifier.value,preloads:P?P.map(w.NotebookRendererScript.from):[]};let re=b??V,ae,we;this.a.$addKernel(I,K).catch(ce=>{console.log(ce),q=!0});let Ie=0;const de=()=>{if(q)return;const ce=++Ie;Promise.resolve().then(()=>{ce===Ie&&this.a.$updateKernel(I,K)})},me=new p.$Bc,Me={get id(){return D},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:A.event,get label(){return K.label},set label(ce){K.label=ce??u.displayName??u.name,de()},get detail(){return K.detail??""},set detail(ce){K.detail=ce,de()},get description(){return K.description??""},set description(ce){K.description=ce,de()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(ce){K.supportedLanguages=ce,de()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(ce){K.supportsExecutionOrder=ce,de()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return re},set executeHandler(ce){re=ce??V},get interruptHandler(){return ae},set interruptHandler(ce){ae=ce,K.supportsInterrupt=!!ce,de()},set variableProvider(ce){(0,r.$GG)(u,"notebookVariableProvider"),we=ce,K.hasVariableProvider=!!ce,ce?.onDidChangeVariables(Re=>W.a.$variablesUpdated(Re.uri)),de()},get variableProvider(){return we},createNotebookCellExecution(ce){if(q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.notebook.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.notebook.uri.toString()}`);return W._createNotebookCellExecution(ce,d(u.identifier,this.id))},createNotebookExecution(ce){if((0,r.$GG)(u,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!me.has(ce.uri))throw W.q.trace(`NotebookController[${I}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(me.keys()).map(Re=>Re.toString())),new Error(`notebook controller is NOT associated to notebook: ${ce.uri.toString()}`);return W._createNotebookExecution(ce,d(u.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${I}], DISPOSED`),q=!0,this.j.delete(I),A.dispose(),j.dispose(),this.a.$removeKernel(I))},updateNotebookAffinity(ce,Re){Re===m.NotebookControllerAffinity2.Hidden&&(0,r.$GG)(u,"notebookControllerAffinityHidden"),W.a.$updateNotebookPriority(I,ce.uri,Re)},onDidReceiveMessage:j.event,postMessage(ce,Re){return(0,r.$GG)(u,"notebookMessaging"),W.a.$postMessage(I,Re&&W.n.getIdByEditor(Re),ce)},asWebviewUri(ce){return(0,r.$GG)(u,"notebookMessaging"),(0,s.$vyb)(ce,W.m.remote)}};return this.j.set(I,{extensionId:u.identifier,controller:Me,onDidReceiveMessage:j,onDidChangeSelection:A,associatedNotebooks:me}),Me}getIdByController(u){for(const[D,f]of this.j)if(f.controller===u)return d(f.extensionId,u.id);return null}createNotebookControllerDetectionTask(u,D){const f=this.g++,k=this;this.q.trace(`NotebookControllerDetectionTask[${f}], CREATED by ${u.identifier.value}`),this.a.$addKernelDetectionTask(f,D);const b={dispose:()=>{this.f.delete(f),k.a.$removeKernelDetectionTask(f)}};return this.f.set(f,b),b}registerKernelSourceActionProvider(u,D,f){const k=this.i++,b=typeof f.onDidChangeNotebookKernelSourceActions=="function"?k:void 0,P=this;this.h.set(k,f),this.q.trace(`NotebookKernelSourceActionProvider[${k}], CREATED by ${u.identifier.value}`),this.a.$addKernelSourceActionProvider(k,k,D);let I;return b!==void 0&&(I=f.onDidChangeNotebookKernelSourceActions(W=>this.a.$emitNotebookKernelSourceActionsChangeEvent(b))),{dispose:()=>{this.h.delete(k),P.a.$removeKernelSourceActionProvider(k,k),I?.dispose()}}}async $provideKernelSourceActions(u,D){const f=this.h.get(u);if(f){const k=new M.$Uc;return(await f.provideNotebookKernelSourceActions(D)??[]).map(P=>w.NotebookKernelSourceAction.from(P,this.o.converter,k))}return[]}$acceptNotebookAssociation(u,D,f){const k=this.j.get(u);if(k){const b=this.n.getNotebookDocument(g.URI.revive(D));f?k.associatedNotebooks.set(b.uri,!0):k.associatedNotebooks.delete(b.uri),this.q.trace(`NotebookController[${u}] ASSOCIATE notebook`,b.uri.toString(),f),k.onDidChangeSelection.fire({selected:f,notebook:b.apiNotebook})}}async $executeCells(u,D,f){const k=this.j.get(u);if(!k)return;const b=this.n.getNotebookDocument(g.URI.revive(D)),P=[];for(const I of f){const W=b.getCell(I);W&&P.push(W.apiCell)}try{this.q.trace(`NotebookController[${u}] EXECUTE cells`,b.uri.toString(),P.length),await k.controller.executeHandler.call(k.controller,P,b.apiNotebook,k.controller)}catch(I){this.q.error(`NotebookController[${u}] execute cells FAILED`,I),console.error(I)}}async $cancelCells(u,D,f){const k=this.j.get(u);if(!k)return;const b=this.n.getNotebookDocument(g.URI.revive(D));if(k.controller.interruptHandler)await k.controller.interruptHandler.call(k.controller,b.apiNotebook);else for(const P of f){const I=b.getCell(P);I&&this.b.get(I.uri)?.cancel()}if(k.controller.interruptHandler){const P=this.c.get(b.uri);f.length&&Array.isArray(P)&&P.length&&P.forEach(I=>I.dispose())}}async $provideVariables(u,D,f,k,b,P,I){const W=this.j.get(u);if(!W)return;const V=this.n.getNotebookDocument(g.URI.revive(f)),q=W.controller.variableProvider;if(!q)return;let A;if(k!==void 0){if(A=this.s[k],!A)return}else this.s={};const j=b==="named"?m.NotebookVariablesRequestKind.Named:m.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(V.apiNotebook,A,j,P,I);let re=0;for await(const ae of K){if(I.isCancellationRequested)return;const we={id:this.r++,name:ae.variable.name,value:ae.variable.value,type:ae.variable.type,interfaces:ae.variable.interfaces,language:ae.variable.language,expression:ae.variable.expression,hasNamedChildren:ae.hasNamedChildren,indexedChildrenCount:ae.indexedChildrenCount,extensionId:W.extensionId.value};if(this.s[we.id]=ae.variable,this.a.$receiveVariable(D,we),re++>=n.$3ib)return}}$acceptKernelMessageFromRenderer(u,D,f){const k=this.j.get(u);if(!k)return;const b=this.n.getEditorById(D);k.onDidReceiveMessage.fire(Object.freeze({editor:b.apiEditor,message:f}))}$cellExecutionChanged(u,D,f){const b=this.n.getNotebookDocument(g.URI.revive(u)).getCell(D);if(b){const P=f?w.NotebookCellExecutionState.to(f):m.NotebookCellExecutionState.Idle;P!==void 0&&this.l.fire({cell:b.apiCell,state:P})}}_createNotebookCellExecution(u,D){if(u.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const k=this.n.getNotebookDocument(u.notebook.uri).getCellFromApiCell(u);if(!k)throw new Error("invalid cell");if(this.b.has(k.uri))throw new Error(`duplicate execution for ${k.uri}`);const b=new i(D,k,this.a);this.b.set(k.uri,b);const P=b.onDidChangeState(()=>{b.state===h.Resolved&&(b.dispose(),P.dispose(),this.b.delete(k.uri))});return b.asApiObject()}_createNotebookExecution(u,D){const f=this.n.getNotebookDocument(u.uri),k=u.getCells().find(I=>{const W=f.getCellFromApiCell(I);return W&&this.b.has(W.uri)});if(k)throw new Error(`duplicate cell execution for ${k.document.uri}`);if(this.c.has(f.uri))throw new Error(`duplicate notebook execution for ${f.uri}`);const b=new a(D,f,this.a),P=b.onDidChangeState(()=>{b.state===$.Resolved&&(b.dispose(),P.dispose(),this.c.delete(f.uri))});return this.c.set(f.uri,[b,P]),b.asApiObject()}};e.$tmc=c,e.$tmc=c=Je([We(4,T.$2j)],c);var h;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})(h||(h={}));class i extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(u,D,f){super(),this.m=D,this.n=f,this.b=i.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new R.$pe),this.h=new v(10,k=>this.s(k)),this.j=D.internalMetadata.executionOrder,this.n.$createExecution(this.b,u,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(u){await this.h.addItem(u)}async s(u){const D=Array.isArray(u)?u:[u];return this.n.$updateExecution(this.b,new t.$uw(D))}t(){if(this.f===h.Init)throw new Error("Must call start before modifying cell output");if(this.f===h.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(u){let D=this.m;if(u&&(D=this.m.notebook.getCellFromApiCell(u)),!D)throw new Error("INVALID cell");return D.handle}y(u){return u.map(D=>{const f=m.$tO.ensureUniqueMimeTypes(D.items,!0);return f===D.items?w.NotebookCellOutput.from(D):w.NotebookCellOutput.from({items:f,id:D.id,metadata:D.metadata})})}async z(u,D,f){const k=this.w(D),b=this.y((0,S.$3b)(u));return this.r({editType:o.CellExecutionUpdateType.Output,cellHandle:k,append:f,outputs:b})}async C(u,D,f){return u=m.$tO.ensureUniqueMimeTypes((0,S.$3b)(u),!0),this.r({editType:o.CellExecutionUpdateType.OutputItems,items:u.map(w.NotebookCellOutputItem.from),outputId:D.id,append:f})}asApiObject(){const u=this;return Object.freeze({get token(){return u.g.token},get cell(){return u.m.apiCell},get executionOrder(){return u.j},set executionOrder(f){u.j=f,u.s([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:u.j}])},start(f){if(u.f===h.Resolved||u.f===h.Started)throw new Error("Cannot call start again");u.f=h.Started,u.c.fire(),u.s({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:f})},end(f,k,b){if(u.f===h.Resolved)throw new Error("Cannot call resolve twice");u.f=h.Resolved,u.c.fire(),u.h.flush();const P=b?{message:b.message,stack:b.stack,location:b?.location?{startLineNumber:b.location.start.line,startColumn:b.location.start.character,endLineNumber:b.location.end.line,endColumn:b.location.end.character}:void 0,uri:b.uri}:void 0;u.n.$completeExecution(u.b,new t.$uw({runEndTime:k,lastRunSuccess:f,error:P}))},clearOutput(f){return u.t(),u.z([],f,!1)},appendOutput(f,k){return u.t(),u.z(f,k,!0)},replaceOutput(f,k){return u.t(),u.z(f,k,!1)},appendOutputItems(f,k){return u.t(),u.C(f,k,!0)},replaceOutputItems(f,k){return u.t(),u.C(f,k,!1)}})}}var $;(function(C){C[C.Init=0]="Init",C[C.Started=1]="Started",C[C.Resolved=2]="Resolved"})($||($={}));class a extends M.$Vc{static{this.a=0}get state(){return this.f}constructor(u,D,f){super(),this.h=D,this.j=f,this.b=a.a++,this.c=new O.$ee,this.onDidChangeState=this.c.event,this.f=$.Init,this.g=this.B(new R.$pe),this.j.$createNotebookExecution(this.b,u,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===$.Resolved||this.f===$.Started)throw new Error("Cannot call start again");this.f=$.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===$.Resolved)throw new Error("Cannot call resolve twice");this.f=$.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class v{constructor(u,D){this.f=u,this.g=D,this.a=[],this.b=Date.now()}addItem(u){return this.a.push(u),this.c||(this.c=new N.$Sh,this.b=Date.now(),(0,N.$wh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const u=this.c;this.c=void 0;const D=this.a;return this.a=[],this.g(D).finally(()=>u.complete())}}function d(C,u){return`${C.value}/${u}`}}),define(Ce[51],Ae([1,0,5,4,3,2,16,6,7,171,14,200,24,35,201,42,11,8,32]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hlc=e.$Glc=e.$Flc=e.$Elc=void 0,e.$Elc=(0,R.$vi)("IExtHostTerminalService");class n extends p.$Vc{constructor(f,k,b,P){super(),this.u=f,this._id=k,this.w=b,this.y=P,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new S.$ee),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(W=>this.g=W);const I=this;this.value={get name(){return I.y||""},get processId(){return I.b},get creationOptions(){return I.w},get exitStatus(){return I.j},get state(){return I.m},get selection(){return I.n},get shellIntegration(){return I.shellIntegration},sendText(W,V=!0){I.C(),I.u.$sendText(I._id,W,V)},show(W){I.C(),I.u.$show(I._id,W)},hide(){I.C(),I.u.$hide(I._id)},dispose(){I.a||(I.a=!0,I.u.$dispose(I._id))},get dimensions(){if(!(I.f===void 0||I.h===void 0))return{columns:I.f,rows:I.h}}}}dispose(){this.s.fire(),super.dispose()}async create(f,k){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:f.name,shellPath:f.shellPath??void 0,shellArgs:f.shellArgs??void 0,cwd:f.cwd??k?.cwd??void 0,env:f.env??void 0,icon:d(f.iconPath)??void 0,color:s.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:f.message??void 0,strictEnv:f.strictEnv??void 0,hideFromUser:f.hideFromUser??void 0,forceShellIntegration:k?.forceShellIntegration??void 0,isFeatureTerminal:k?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:k?.useShellEnvironment??void 0,location:k?.location||this.z(f.location,k?.resolvedExtHostIdentifier),isTransient:f.isTransient??void 0})}async createExtensionTerminal(f,k,b,P,I){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:P,color:s.ThemeColor.isThemeColor(I)?I.id:void 0,location:k?.location||this.z(f,b),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(f,k){return typeof f=="object"?"parentTerminal"in f&&f.parentTerminal&&k?{parentTerminal:k}:"viewColumn"in f?{viewColumn:r.ViewColumn.from(f.viewColumn),preserveFocus:f.preserveFocus}:void 0:f}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(f){this.y=f}setExitStatus(f,k){this.j=Object.freeze({code:f,reason:k})}setDimensions(f,k){return f===this.f&&k===this.h||f===0||k===0?!1:(this.f=f,this.h=k,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(f){this.n=f}_setProcessId(f){this.g?(this.g(f),this.g=void 0):this.b.then(k=>{k!==f&&(this.b=Promise.resolve(f))})}}e.$Flc=n;class c{get onProcessReady(){return this.b.event}constructor(f){this.g=f,this.id=0,this.shouldPersist=!1,this.a=new S.$ee,this.onProcessData=this.a.event,this.b=new S.$ee,this.d=new S.$ee,this.onDidChangeProperty=this.d.event,this.f=new S.$ee,this.onProcessExit=this.f.event}refreshProperty(f){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${f}`)}updateProperty(f,k){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${f}, value: ${k}`)}async start(){}shutdown(){this.g.close()}input(f){this.g.handleInput?.(f)}resize(f,k){this.g.setDimensions?.({columns:f,rows:k})}clearBuffer(){}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(f){this.g.onDidWrite(k=>this.a.fire(k)),this.g.onDidClose?.((k=void 0)=>{this.f.fire(k===void 0?void 0:k)}),this.g.onDidOverrideDimensions?.(k=>{k&&this.d.fire({type:"overrideDimensions",value:{cols:k.columns,rows:k.rows}})}),this.g.onDidChangeName?.(k=>{this.d.fire({type:"title",value:k})}),this.g.open(f||void 0),f&&this.g.setDimensions?.(f),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let h=1,i=class extends p.$Vc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(f=>f.value)}constructor(f,k,b){super(),this.Q=k,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Wc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new S.$ee,this.onDidCloseTerminal=this.H.event,this.I=new S.$ee,this.onDidOpenTerminal=this.I.event,this.J=new S.$ee,this.onDidChangeActiveTerminal=this.J.event,this.L=new S.$ee,this.onDidChangeTerminalDimensions=this.L.event,this.M=new S.$ee,this.onDidChangeTerminalState=this.M.event,this.N=new S.$ee,this.onDidChangeShell=this.N.event,this.O=new S.$ee({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new S.$ee({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=b.getProxy(N.$YM.MainThreadTerminalService),this.y=new m.$ntb(this.a.$sendProcessData),this.a.$registerProcessSupport(f),this.Q.registerArgumentProcessor({processArgument:P=>{const I=W=>{const V=W;return this.getTerminalById(V.instanceId)?.value};switch(P?.$mid){case 15:return I(P);default:{if(Array.isArray(P))for(let W=0;W<P.length&&P[W].$mid===15;W++)P[W]=I(P[W]);return P}}}}),this.B({dispose:()=>{for(const[P,I]of this.g)I.shutdown(!0)}})}getDefaultShell(f){return(f?this.u:this.s)?.path||""}getDefaultShellArgs(f){return(f?this.u:this.s)?.args||[]}createExtensionTerminal(f,k){const b=new n(this.a,(0,w.$Rg)(),f,f.name),P=new c(f.pty);return b.createExtensionTerminal(f.location,k,this.R(f,k).resolvedExtHostIdentifier,d(f.iconPath),C(f.color)).then(I=>{const W=this.S(I,P);this.h[I]=W}),this.f.push(b),b.value}R(f,k){if(k=k||{},f.location&&typeof f.location=="object"&&"parentTerminal"in f.location){const b=f.location.parentTerminal;if(b){const P=this.f.find(I=>I.value===b);P&&(k.resolvedExtHostIdentifier=P._id)}}else f.location&&typeof f.location!="object"?k.location=f.location:k.location&&typeof k.location=="object"&&"splitActiveTerminal"in k.location&&(k.location={splitActiveTerminal:!0});return k}attachPtyToTerminal(f,k){if(!this.getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const P=new c(k),I=this.S(f,P);this.h[f]=I}async $acceptActiveTerminalChanged(f){const k=this.b;if(f===null){this.b=void 0,k!==this.b&&this.J.fire(this.b);return}const b=this.getTerminalById(f);b&&(this.b=b,k!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(f,k){const b=this.getTerminalById(f);b&&this.O.fire({terminal:b.value,data:k})}async $acceptTerminalDimensions(f,k,b){const P=this.getTerminalById(f);P&&P.setDimensions(k,b)&&this.L.fire({terminal:P.value,dimensions:P.value.dimensions})}async $acceptDidExecuteCommand(f,k){const b=this.getTerminalById(f);b&&this.P.fire({terminal:b.value,...k})}async $acceptTerminalMaximumDimensions(f,k,b){this.g.get(f)?.resize(k,b)}async $acceptTerminalTitleChange(f,k){const b=this.getTerminalById(f);b&&(b.name=k)}async $acceptTerminalClosed(f,k,b){const P=this.X(this.f,f);if(P!==null){const I=this.f.splice(P,1)[0];I.setExitStatus(k,b),this.H.fire(I.value)}}$acceptTerminalOpened(f,k,b,P){if(k){const V=this.X(this.f,k);if(V!==null){this.f[V]._id=f,this.I.fire(this.terminals[V]),this.f[V].isOpen=!0;return}}const I={name:P.name,shellPath:P.executable,shellArgs:P.args,cwd:typeof P.cwd=="string"?P.cwd:O.URI.revive(P.cwd),env:P.env,hideFromUser:P.hideFromUser},W=new n(this.a,f,I,b);this.f.push(W),this.I.fire(W.value),W.isOpen=!0}async $acceptTerminalProcessId(f,k){this.getTerminalById(f)?._setProcessId(k)}async $startExtensionTerminal(f,k){const b=this.getTerminalById(f);if(!b)return{message:(0,E.localize)(0,null,f)};b.isOpen||await new Promise(I=>{const W=this.onDidOpenTerminal(async V=>{V===b.value&&(W.dispose(),I())})});const P=this.g.get(f);P?P.startSendingEvents(k):this.j[f]={initialDimensions:k}}S(f,k){const b=new p.$Uc;b.add(k.onProcessReady(I=>this.a.$sendProcessReady(f,I.pid,I.cwd,I.windowsPty))),b.add(k.onDidChangeProperty(I=>this.a.$sendProcessProperty(f,I))),this.y.startBuffering(f,k.onProcessData),b.add(k.onProcessExit(I=>this.U(f,I))),this.g.set(f,k);const P=this.j[f];return P&&k instanceof c&&(k.startSendingEvents(P.initialDimensions),delete this.j[f]),b}$acceptProcessAckDataEvent(f,k){this.g.get(f)?.acknowledgeDataEvent(k)}$acceptProcessInput(f,k){this.g.get(f)?.input(k)}$acceptTerminalInteraction(f){const k=this.getTerminalById(f);k?.setInteractedWith()&&this.M.fire(k.value)}$acceptTerminalSelection(f,k){this.getTerminalById(f)?.setSelection(k)}$acceptProcessResize(f,k,b){try{this.g.get(f)?.resize(k,b)}catch(P){if(P.code!=="EPIPE"&&P.code!=="ERR_IPC_CHANNEL_CLOSED")throw P}}$acceptProcessShutdown(f,k){this.g.get(f)?.shutdown(k)}$acceptProcessRequestInitialCwd(f){this.g.get(f)?.getInitialCwd().then(k=>this.a.$sendProcessProperty(f,{type:"initialCwd",value:k}))}$acceptProcessRequestCwd(f){this.g.get(f)?.getCwd().then(k=>this.a.$sendProcessProperty(f,{type:"cwd",value:k}))}$acceptProcessRequestLatency(f){return Promise.resolve(f)}registerLinkProvider(f){return this.z.add(f),this.z.size===1&&this.a.$startLinkProvider(),new g.$1M(()=>{this.z.delete(f),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(f,k,b){if(this.C.has(k))throw new Error(`Terminal profile provider "${k}" already registered`);return this.C.set(k,b),this.a.$registerProfileProvider(k,f.identifier.value),new g.$1M(()=>{this.C.delete(k),this.a.$unregisterProfileProvider(k)})}registerTerminalQuickFixProvider(f,k,b){if(this.D.has(f))throw new Error(`Terminal quick fix provider "${f}" is already registered`);return this.D.set(f,b),this.a.$registerQuickFixProvider(f,k),new g.$1M(()=>{this.D.delete(f),this.a.$unregisterQuickFixProvider(f)})}async $provideTerminalQuickFixes(f,k){const b=new l.$pe().token;if(b.isCancellationRequested)return;const P=this.D.get(f);if(!P)return;const I=await P.provideTerminalQuickFixes(k,b);if(I===null||Array.isArray(I)&&I.length===0)return;const W=new p.$Uc;if(this.w.value=W,!Array.isArray(I))return I?r.TerminalQuickFix.from(I,this.Q.converter,W):void 0;const V=[];for(const q of I){const A=r.TerminalQuickFix.from(q,this.Q.converter,W);A&&V.push(A)}return V}async $createContributedProfileTerminal(f,k){const b=new l.$pe().token;let P=await this.C.get(f)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(P&&!("options"in P)&&(P={options:P}),!P||!("options"in P))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in P.options){this.createExtensionTerminal(P.options,k);return}this.createTerminalFromOptions(P.options,k)}}async $provideLinks(f,k){const b=this.getTerminalById(f);if(!b)return[];this.F.delete(f),this.G.get(f)?.dispose(!0);const I=new l.$pe;this.G.set(f,I);const W=[],V={terminal:b.value,line:k},q=[];for(const K of this.z)q.push(o.Promises.withAsyncBody(async re=>{I.token.onCancellationRequested(()=>re({provider:K,links:[]}));const ae=await K.provideTerminalLinks(V,I.token)||[];I.token.isCancellationRequested||re({provider:K,links:ae})}));const A=await Promise.all(q);if(I.token.isCancellationRequested)return[];const j=new Map;for(const K of A)K&&K.links.length>0&&W.push(...K.links.map(re=>{const ae={id:h++,startIndex:re.startIndex,length:re.length,label:re.tooltip};return j.set(ae.id,{provider:K.provider,link:re}),ae}));return this.F.set(f,j),W}$activateLink(f,k){const b=this.F.get(f)?.get(k);b&&b.provider.handleTerminalLink(b.link)}U(f,k){this.y.stopBuffering(f),this.g.delete(f),delete this.j[f];const b=this.h[f];b&&(b.dispose(),delete this.h[f]),this.a.$sendProcessExit(f,k)}getTerminalById(f){return this.W(this.f,f)}getTerminalIdByApiObject(f){const k=this.f.findIndex(b=>b.value===f);return k>=0?k:null}W(f,k){const b=this.X(f,k);return b!==null?f[b]:null}X(f,k){const b=f.findIndex(P=>P._id===k);return b>=0?b:null}getEnvironmentVariableCollection(f){let k=this.n.get(f.identifier.value);return k||(k=new $,this.Z(f.identifier.value,k)),k.getScopedEnvironmentVariableCollection(void 0)}Y(f,k){const b=(0,y.$ks)(k.map),P=(0,y.$ls)(k.descriptionMap);this.a.$setEnvironmentVariableCollection(f,k.persistent,b.length===0?void 0:b,P)}$initEnvironmentVariableCollections(f){f.forEach(k=>{const b=k[0],P=new $(k[1]);this.Z(b,P)})}$acceptDefaultProfile(f,k){const b=this.s;this.s=f,this.u=k,b?.path!==f.path&&this.N.fire(f.path)}Z(f,k){this.n.set(f,k),k.onDidChangeCollection(()=>{this.Y(f,k)})}};e.$Glc=i,e.$Glc=i=Je([We(1,t.$HP),We(2,M.$lP)],i);class ${get persistent(){return this.b}set persistent(f){this.b=f,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(f){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new S.$ee,this.map=new Map(f)}getScopedEnvironmentVariableCollection(f){const k=this.h(f);let b=this.a.get(k);return b||(b=new a(this,f),this.a.set(k,b),b.onDidChangeCollection(()=>this.d.fire())),b}replace(f,k,b,P){this.f(f,{value:k,type:g.EnvironmentVariableMutatorType.Replace,options:b??{applyAtProcessCreation:!0},scope:P})}append(f,k,b,P){this.f(f,{value:k,type:g.EnvironmentVariableMutatorType.Append,options:b??{applyAtProcessCreation:!0},scope:P})}prepend(f,k,b,P){this.f(f,{value:k,type:g.EnvironmentVariableMutatorType.Prepend,options:b??{applyAtProcessCreation:!0},scope:P})}f(f,k){if(k.options&&k.options.applyAtProcessCreation===!1&&!k.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const b=this.g(f,k.scope),P=this.map.get(b),I=k.options?{applyAtProcessCreation:k.options.applyAtProcessCreation??!1,applyAtShellIntegration:k.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!P||P.value!==k.value||P.type!==k.type||P.options?.applyAtProcessCreation!==I.applyAtProcessCreation||P.options?.applyAtShellIntegration!==I.applyAtShellIntegration||P.scope?.workspaceFolder?.index!==k.scope?.workspaceFolder?.index){const W=this.g(f,k.scope),V={variable:f,...k,options:I};this.map.set(W,V),this.d.fire()}}get(f,k){const b=this.g(f,k),P=this.map.get(b);return P?u(P):void 0}g(f,k){const b=this.h(k);return b.length?`${f}:::${b}`:f}h(f){return this.j(f?.workspaceFolder)??""}j(f){return f?f.uri.toString():void 0}getVariableMap(f){const k=new Map;for(const[b,P]of this.map)this.h(P.scope)===this.h(f)&&k.set(P.variable,u(P));return k}delete(f,k){const b=this.g(f,k);this.map.delete(b),this.d.fire()}clear(f){if(f?.workspaceFolder){for(const[k,b]of this.map)b.scope?.workspaceFolder?.index===f.workspaceFolder.index&&this.map.delete(k);this.k(f)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(f,k){const b=this.h(k),P=this.descriptionMap.get(b);if(!P||P.description!==f){let I;typeof f=="string"?I=f:I=f?.value.split(`

`)[0];const W={description:I,scope:k};this.descriptionMap.set(b,W),this.d.fire()}}getDescription(f){const k=this.h(f);return this.descriptionMap.get(k)?.description}k(f){const k=this.h(f);this.descriptionMap.delete(k)}}class a{get persistent(){return this.b.persistent}set persistent(f){this.b.persistent=f}get onDidChangeCollection(){return this.a&&this.a.event}constructor(f,k){this.b=f,this.d=k,this.a=new S.$ee}getScoped(f){return this.b.getScopedEnvironmentVariableCollection(f)}replace(f,k,b){this.b.replace(f,k,b,this.d)}append(f,k,b){this.b.append(f,k,b,this.d)}prepend(f,k,b){this.b.prepend(f,k,b,this.d)}get(f){return this.b.get(f,this.d)}forEach(f,k){this.b.getVariableMap(this.d).forEach((b,P)=>f.call(k,P,b,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(f){this.b.delete(f,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(f){this.b.setDescription(f,this.d)}get description(){return this.b.getDescription(this.d)}}let v=class extends i{constructor(f,k){super(!1,f,k)}createTerminal(f,k,b){throw new T.$_}createTerminalFromOptions(f,k){throw new T.$_}};e.$Hlc=v,e.$Hlc=v=Je([We(0,t.$HP),We(1,M.$lP)],v);function d(D){if(!(!D||typeof D=="string"))return"id"in D?{id:D.id,color:D.color}:D}function C(D){return s.ThemeColor.isThemeColor(D)?D:void 0}function u(D){const f={...D};return delete f.scope,f.options=f.options??void 0,delete f.variable,f}}),define(Ce[114],Ae([1,0,7,6,3,4,16,51,5,2,11]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mmc=e.$Lmc=void 0,e.$Lmc=(0,R.$vi)("IExtHostTerminalShellIntegration");let y=class extends N.$Vc{constructor(o,r){super(),this.h=r,this.b=new Map,this.c=new g.$ee,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new g.$ee,this.onDidStartTerminalShellExecution=this.f.event,this.g=new g.$ee,this.onDidEndTerminalShellExecution=this.g.event,this.a=o.getProxy(O.$YM.MainThreadTerminalShellIntegration),this.B((0,N.$Tc)(()=>{for(const[t,n]of this.b)n.dispose();this.b.clear()}))}$shellIntegrationChange(o){const r=this.h.getTerminalById(o);if(!r)return;const t=r.value;let n=this.b.get(o);n||(n=new l(r.value,this.f),this.b.set(o,n),n.store.add(r.onWillDispose(()=>this.b.get(o)?.dispose())),n.store.add(n.onDidRequestShellExecution(c=>this.a.$executeCommand(o,c))),n.store.add(n.onDidRequestEndExecution(c=>this.g.fire(c))),n.store.add(n.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),r.shellIntegration=n.value),this.c.fire({terminal:t,shellIntegration:n.value})}$shellExecutionStart(o,r,t,n,c){this.b.has(o)||this.$shellIntegrationChange(o);const h={value:r,confidence:t,isTrusted:n};this.b.get(o)?.startShellExecution(h,c)}$shellExecutionEnd(o,r,t,n,c){const h={value:r,confidence:t,isTrusted:n};this.b.get(o)?.endShellExecution(h,c)}$shellExecutionData(o,r){this.b.get(o)?.emitData(r)}$cwdChange(o,r){this.b.get(o)?.setCwd((0,E.$wc)(r)?E.URI.revive(r):r)}$closeTerminal(o){this.b.get(o)?.dispose(),this.b.delete(o)}};e.$Mmc=y,e.$Mmc=y=Je([We(0,M.$lP),We(1,p.$Elc)],y);class l extends N.$Vc{get currentExecution(){return this.a}constructor(o,r){super(),this.j=o,this.m=r,this.b=!1,this.store=this.B(new N.$Uc),this.f=this.B(new g.$ee),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new g.$ee),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new g.$ee),this.onDidRequestEndExecution=this.h.event;const t=this;this.value={get cwd(){return t.c},executeCommand(n,c){let h=n;c&&(h+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),t.g.fire(h);const i={value:h,confidence:S.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},$=t.startShellExecution(i,t.c,!0).value;return t.b=!0,$}}}startShellExecution(o,r,t){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const n=this.a=new w(o,r);t?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:n.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(o){this.currentExecution?.emitData(o)}endShellExecution(o,r){this.a&&(this.a.endExecution(o),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:r}),this.a=void 0)}setCwd(o){let r=!1;E.URI.isUri(this.c)?r=!E.URI.isUri(o)||this.c.toString()!==o.toString():this.c!==o&&(r=!0),r&&(this.c=o,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(o,r){this.c=o,this.cwd=r,this.b=!1;const t=this;this.value={get commandLine(){return t.c},get cwd(){return t.cwd},read(){return t.d()}}}d(){if(!this.a){if(this.b)return T.$Vh.EMPTY;this.a=new m}return this.a.createIterable()}emitData(o){this.a?.emitData(o)}endExecution(o){o&&(this.c=o),this.a?.endExecution(),this.a=void 0,this.b=!0}}class m extends N.$Vc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new T.$uh);const o=this.a;return new T.$Vh(async t=>{this.b.push(t),await o.wait()})}emitData(o){for(const r of this.b)r.emitOne(o)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Ce[278],Ae([1,0,11,22,24,5,250,99,6,17,35,13,4,16,113,8,7,50,75,61]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qmc=e.$Pmc=e.$Omc=e.$Nmc=void 0;let c=class extends g.$Vc{constructor(I,W,V,q){super(),this.w=q,this.f=this.B(new O.$ee),this.g=new Map,this.s=this.B(new O.$ee),this.onResultsChanged=this.f.event,this.results=[],this.h=I.getProxy(l.$YM.MainThreadTesting),this.m=new D(this.h),this.j=new a(this.h,W),V.registerArgumentProcessor({processArgument:A=>{switch(A?.$mid){case 16:{const j=A,K=j.tests[j.tests.length-1].item.extId;return this.g.get(r.$KL.root(K))?.collection.tree.get(K)?.actual??(0,m.$xP)(A)}case 18:{const{test:j,message:K}=A,re=j.item.extId;return{test:this.g.get(r.$KL.root(re))?.collection.tree.get(re)?.actual??(0,m.$xP)({$mid:16,tests:[j]}),message:s.TestMessage.to(K)}}default:return A}}}),V.registerCommand(!1,"testing.getExplorerSelection",async()=>{const A=await V.executeCommand("_testing.getExplorerSelection"),j=K=>{const re=this.g.get(r.$KL.root(K));if(re)return r.$KL.isRoot(K)?re.controller:re.collection.tree.get(K)?.actual};return{include:A?.include.map(j).filter(E.$dg)||[],exclude:A?.exclude.map(j).filter(E.$dg)||[]}})}createTestController(I,W,V,q){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const A=new g.$Uc,j=A.add(new m.$AP(W,V,this.w));j.root.label=V;const K=new Map,re=new Set,ae=this.h,we={items:j.root.children,get label(){return V},set label(de){V=de,j.root.label=de,ae.$updateController(W,{label:V})},get refreshHandler(){return q},set refreshHandler(de){q=de,ae.$updateController(W,{canRefresh:!!de})},get id(){return W},createRunProfile:(de,me,Me,ce,Re,ie)=>{let L=(0,p.$jj)(de);for(;K.has(L);)L++;return new k(this.h,K,re,this.s.event,W,L,de,me,Me,ce,Re,ie)},createTestItem(de,me,Me){return new m.$yP(W,de,me,Me)},createTestRun:(de,me,Me=!0)=>this.j.createTestRun(W,j,de,me,Me),invalidateTestResults:de=>{if(de===void 0)this.h.$markTestRetired(void 0);else{const me=de instanceof Array?de:[de];this.h.$markTestRetired(me.map(Me=>r.$KL.fromExtHostTestItem(Me,W).toString()))}},set resolveHandler(de){j.resolveHandler=de},get resolveHandler(){return j.resolveHandler},dispose:()=>{A.dispose()}};ae.$registerTestController(W,V,!!q),A.add((0,g.$Tc)(()=>ae.$unregisterTestController(W)));const Ie={controller:we,collection:j,profiles:K,extension:I,activeProfiles:re};return this.g.set(W,Ie),A.add((0,g.$Tc)(()=>this.g.delete(W))),A.add(j.onDidGenerateDiff(de=>ae.$publishDiff(W,de.map(n.TestsDiffOp.serialize)))),we}createTestObserver(){return this.m.checkout()}async runTests(I,W=R.CancellationToken.None){const V=v(I);if(!V)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const q=this.g.get(V.controllerId);if(!q)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:I.include?.map(A=>r.$KL.fromExtHostTestItem(A,q.collection.root.id).toString())??[q.collection.root.id],profileGroup:b[V.kind],profileId:V.profileId,controllerId:V.controllerId}],exclude:I.exclude?.map(A=>A.id)},W)}$syncTests(){for(const{collection:I}of this.g.values())I.flushDiff();return Promise.resolve()}async $getCoverageDetails(I,W){return(await this.j.getCoverageDetails(I,W))?.map(s.TestCoverage.fromDetails)}async $disposeRun(I){this.j.disposeTestRun(I)}$configureRunProfile(I,W){this.g.get(I)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(I){const W=new Map;for(const[V,q]of Object.entries(I)){const A=this.g.get(V);if(!A)continue;const j=new Map,K=q.filter(ae=>!A.activeProfiles.has(ae)),re=[...A.activeProfiles].filter(ae=>!q.includes(ae));for(const ae of K)j.set(ae,!0),A.activeProfiles.add(ae);for(const ae of re)j.set(ae,!1),A.activeProfiles.delete(ae);j.size&&W.set(V,j)}this.s.fire(W)}async $refreshTests(I,W){await this.g.get(I)?.controller.refreshHandler?.(W)}$publishTestResults(I){this.results=Object.freeze(I.map(s.TestResults.to).concat(this.results).sort((W,V)=>V.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(I,W){const V=this.g.get(r.$KL.fromString(I).controllerId)?.collection;V&&(await V.expand(I,W<0?1/0:W),V.flushDiff())}$acceptDiff(I){this.m.applyDiff(I.map(W=>n.TestsDiffOp.deserialize({asCanonicalUri:V=>V},W)))}async $runControllerTests(I,W){return Promise.all(I.map(V=>this.y(V,!1,W)))}async $startContinuousRun(I,W){const V=new R.$pe(W),q=await Promise.all(I.map(A=>this.y(A,!0,V.token)));return!W.isCancellationRequested&&!q.some(A=>A.error)&&await new Promise(A=>W.onCancellationRequested(A)),V.dispose(!0),q}async y(I,W,V){const q=this.g.get(I.controllerId);if(!q)return{};const{collection:A,profiles:j}=q,K=j.get(I.profileId);if(!K)return{};const re=I.testIds.map(de=>A.tree.get(de)).filter(E.$dg),ae=I.excludeExtIds.map(de=>q.collection.tree.get(de)).filter(E.$dg).filter(de=>re.some(me=>me.fullId.compare(de.fullId)===2));if(!re.length)return{};const we=new o.$AO(re.some(de=>de.actual instanceof m.$zP)?void 0:re.map(de=>de.actual),ae.map(de=>de.actual),K,W),Ie=(0,n.$NL)(I)&&this.j.prepareForMainThreadTestRun(we,d.fromInternal(I,q.collection),K,V);try{return await K.runHandler(we,V),{}}catch(de){return{error:String(de)}}finally{Ie&&Ie.hasRunningTasks&&!V.isCancellationRequested&&await O.Event.toPromise(Ie.onEnd)}}$cancelExtensionTestRun(I){I===void 0?this.j.cancelAllRuns():this.j.cancelRunById(I)}};e.$Nmc=c,e.$Nmc=c=Je([We(0,w.$lP),We(1,y.$2j)],c);const h=1e4;var i;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(i||(i={}));class $ extends g.$Vc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(I,W,V,q,A){super(),this.y=I,this.z=W,this.C=V,this.D=q,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new O.$ee),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new R.$pe(A));const j=this.B(new S.$Hh(()=>this.F(),h));this.B(this.j.token.onCancellationRequested(()=>j.schedule()));const K=new O.$ee;this.s=K.event,this.B((0,g.$Tc)(()=>{K.fire(),K.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.F()}getCoverageDetails(I,W){const[,V,q]=r.$KL.fromString(I).path,A=this.w.get(q);if(!A)return[];const j=this.g.get(V);if(!j)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(j.run,A,W)??[]}createRun(I){const W=this.y.id,V=this.y.controllerId,q=(0,T.$Rg)(),A=ae=>(we,...Ie)=>{if(K){this.C.warn(`Setting the state of test "${we.id}" is a no-op after the run ends.`);return}this.y.isIncluded(we)&&(this.H(we),ae(we,...Ie))},j=(ae,we)=>{const Ie=we instanceof Array?we.map(s.TestMessage.from):[s.TestMessage.from(we)];if(ae.uri&&ae.range){const de={range:s.Range.from(ae.range),uri:ae.uri};for(const me of Ie)me.location=me.location||de}this.z.$appendTestMessagesInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),Ie)};let K=!1;const re={isPersisted:this.y.isPersisted,token:this.j.token,name:I,onDidDispose:this.s,addCoverage:ae=>{const we=ae.uri.toString(),Ie=new r.$KL([W,q,we]).toString();this.w.set(we,ae),this.z.$appendCoverage(W,q,s.TestCoverage.fromFile(Ie,ae))},enqueued:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),1)}),skipped:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),5)}),started:A(ae=>{this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),2)}),errored:A((ae,we,Ie)=>{j(ae,we),this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),6,Ie)}),failed:A((ae,we,Ie)=>{j(ae,we),this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,V).toString(),4,Ie)}),passed:A((ae,we)=>{this.z.$updateTestStateInRun(W,q,r.$KL.fromExtHostTestItem(ae,this.y.controllerId).toString(),3,we)}),appendOutput:(ae,we,Ie)=>{K||(Ie&&(this.y.isIncluded(Ie)?this.H(Ie):Ie=void 0),this.z.$appendOutputToRun(W,q,N.$Fe.fromString(ae),we&&s.location.from(we),Ie&&r.$KL.fromExtHostTestItem(Ie,V).toString()))},end:()=>{K||(K=!0,this.z.$finishedTestRunTask(W,q),--this.f||this.G())}};return this.f++,this.g.set(q,{run:re}),this.z.$startedTestRunTask(W,{id:q,name:I,running:!0}),re}F(){for(const{run:I}of this.g.values())I.end()}G(){this.c!==2&&(this.c=2,this.m.fire())}H(I){if(!(I instanceof m.$yP))throw new t.$dP(I.id);if(this.h.has(r.$KL.fromExtHostTestItem(I,this.y.controllerId).toString()))return;const W=[],V=this.y.colllection.root;for(;;){const q=s.TestItem.from(I);if(W.unshift(q),this.h.has(q.extId)||(this.h.add(q.extId),I===V))break;I=I.parent||V}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.G(),super.dispose()}}class a{get trackers(){return this.c.values()}constructor(I,W){this.g=I,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(I,W){const V=r.$KL.root(I);return this.f.get(V)?.getCoverageDetails(I,W)||[]}disposeTestRun(I){this.f.get(I)?.dispose(),this.f.delete(I);for(const[W,{id:V}]of this.c)V===I&&this.c.delete(W)}prepareForMainThreadTestRun(I,W,V,q){return this.j(I,W,V,q)}cancelRunById(I){this.f.get(I)?.cancel()}cancelAllRuns(){for(const I of this.c.values())I.cancel()}createTestRun(I,W,V,q,A){const j=this.c.get(V);if(j)return j.createRun(q);const K=d.fromPublic(I,W,V,A),re=v(V);this.g.$startedExtensionTestRun({controllerId:I,continuous:!!V.continuous,profile:re&&{group:b[re.kind],id:re.profileId},exclude:V.exclude?.map(we=>r.$KL.fromExtHostTestItem(we,W.root.id).toString())??[],id:K.id,include:V.include?.map(we=>r.$KL.fromExtHostTestItem(we,W.root.id).toString())??[W.root.id],persist:A});const ae=this.j(V,K,V.profile);return O.Event.once(ae.onEnd)(()=>{this.g.$finishedExtensionTestRun(K.id)}),ae.createRun(q)}j(I,W,V,q){const A=new $(W,this.g,this.h,V,q);return this.c.set(I,A),this.f.set(A.id,A),A}}e.$Omc=a;const v=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class d{static fromPublic(I,W,V,q){return new d(I,(0,T.$Rg)(),V.include?.map(A=>r.$KL.fromExtHostTestItem(A,I).toString())??[I],V.exclude?.map(A=>r.$KL.fromExtHostTestItem(A,I).toString())??[],q,W)}static fromInternal(I,W){return new d(I.controllerId,I.runId,I.testIds,I.excludeExtIds,!0,W)}constructor(I,W,V,q,A,j){this.controllerId=I,this.id=W,this.isPersisted=A,this.colllection=j,this.c=V.map(K=>K+"\0"),this.f=q.map(K=>K+"\0")}isIncluded(I){const W=r.$KL.fromExtHostTestItem(I,this.controllerId).toString()+"\0";for(const V of this.f)if(W===V||W.startsWith(V))return!1;for(const V of this.c)if(W===V||W.startsWith(V))return!0;return!1}}e.$Pmc=d;class C{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(I){this.j=I,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(I){this.c.add(I)}update(I){Object.assign(I.revived,s.TestItem.toPlain(I.item)),this.c.has(I)||this.f.add(I)}remove(I){if(this.c.has(I)){this.c.delete(I);return}this.f.delete(I);const W=r.$KL.parentId(I.item.extId);if(W&&this.h.has(W.toString())){this.h.add(I.item.extId);return}this.g.add(I)}getChangeEvent(){const{c:I,f:W,g:V}=this;return{get added(){return[...I].map(q=>q.revived)},get updated(){return[...W].map(q=>q.revived)},get removed(){return[...V].map(q=>q.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class u extends n.$TL{constructor(){super(...arguments),this.s=new O.$ee,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(I){return this.f.get(I)}getMirroredTestDataByReference(I){return this.f.get(I.id)}w(I,W){return{...I,revived:s.TestItem.toPlain(I.item),depth:W?W.depth+1:0,children:new Set}}v(){return new C(this.s)}}class D{constructor(I){this.f=I}checkout(){this.c||(this.c=this.g());const I=this.c;return I.observers++,{onDidChangeTest:I.tests.onDidChangeTests,get tests(){return[...I.tests.rootTests].map(W=>W.revived)},dispose:(0,M.$db)(()=>{--I.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(I){return this.c?.tests.getMirroredTestDataByReference(I)}applyDiff(I){this.c?.tests.apply(I)}g(){const I=new u({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:I}}}const f=(P,I,W,V)=>{W?Object.assign(W,V):I.$updateTestRunConfig(P.controllerId,P.profileId,V)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(I){I!==this.f&&(this.f=I,f(this,this.#e,this.#n,{label:I}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(I){I!==this.g&&(this.g=I,f(this,this.#e,this.#n,{supportsContinuousRun:I}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(I){I!==this.isDefault&&(I?this.#t.add(this.profileId):this.#t.delete(this.profileId),f(this,this.#e,this.#n,{isDefault:I}))}get tag(){return this._tag}set tag(I){I?.id!==this._tag?.id&&(this._tag=I,f(this,this.#e,this.#n,{tag:I?s.TestTag.namespace(this.controllerId,I.id):null}))}get configureHandler(){return this.c}set configureHandler(I){I!==this.c&&(this.c=I,f(this,this.#e,this.#n,{hasConfigurationHandler:!!I}))}get onDidChangeDefault(){return O.Event.chain(this.#i,I=>I.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(E.$dg))}constructor(I,W,V,q,A,j,K,re,ae,we=!1,Ie=void 0,de=!1){this.controllerId=A,this.profileId=j,this.f=K,this.kind=re,this.runHandler=ae,this._tag=Ie,this.g=de,this.#e=I,this.#s=W,this.#t=V,this.#i=q,W.set(j,this);const me=b[re];if(typeof me!="number")throw new Error(`Unknown TestRunProfile.group ${re}`);we&&V.add(j),this.#n={profileId:j,controllerId:A,tag:Ie?s.TestTag.namespace(this.controllerId,Ie.id):null,label:K,group:me,isDefault:we,hasConfigurationHandler:!1,supportsContinuousRun:de},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Qmc=k;const b={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Ce[115],Ae([1,0,56,14,90,8,7]),function(ge,e,S,N,R,O,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uP=e.$tP=e.$sP=void 0;class p{static{this.c=new R.$qP("TextEditorDecorationType")}constructor(l,w,m){const s=p.c.nextId();l.$registerTextEditorDecorationType(w.identifier,s,O.DecorationRenderOptions.from(m)),this.value=Object.freeze({key:s,dispose(){l.$removeTextEditorDecorationType(s)}})}}e.$sP=p;class g{constructor(l,w){this.g=[],this.h=void 0,this.j=!1,this.c=l,this.d=l.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(l,w){this.k();let m=null;if(l instanceof M.$2M)m=new M.$3M(l,l);else if(l instanceof M.$3M)m=l;else throw new Error("Unrecognized location");this.l(m,w,!1)}insert(l,w){this.k(),this.l(new M.$3M(l,l),w,!0)}delete(l){this.k();let w=null;if(l instanceof M.$3M)w=l;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(l,w,m){const s=this.c.validateRange(l);this.g.push({range:s,text:w,forceMoveMarkers:m})}setEndOfLine(l){if(this.k(),l!==M.EndOfLine.LF&&l!==M.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=l}}class E{constructor(l,w,m,s){this.c=l,this.d=w,this._accept(m),this.e=s;const o=this;this.value={get tabSize(){return o.f},set tabSize(r){o.n(r)},get indentSize(){return o.g},set indentSize(r){o.p(r)},get insertSpaces(){return o.j},set insertSpaces(r){o.s(r)},get cursorStyle(){return o.k},set cursorStyle(r){o.t(r)},get lineNumbers(){return o.l},set lineNumbers(r){o.u(r)}}}_accept(l){this.f=l.tabSize,this.g=l.indentSize,this.h=l.originalIndentSize,this.j=l.insertSpaces,this.k=l.cursorStyle,this.l=O.TextEditorLineNumbersStyle.to(l.lineNumbers)}m(l){if(l==="auto")return"auto";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}n(l){const w=this.m(l);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(l){if(l==="tabSize")return"tabSize";if(typeof l=="number"){const w=Math.floor(l);return w>0?w:null}if(typeof l=="string"){const w=parseInt(l,10);return isNaN(w)?null:w>0?w:null}return null}p(l){const w=this.o(l);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(l){return l==="auto"?"auto":l==="false"?!1:!!l}s(l){const w=this.q(l);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(l){this.k!==l&&(this.k=l,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:l})))}u(l){this.l!==l&&(this.l=l,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:O.TextEditorLineNumbersStyle.from(l)})))}assign(l){const w={};let m=!1;if(typeof l.tabSize<"u"){const s=this.m(l.tabSize);s==="auto"?(m=!0,w.tabSize=s):typeof s=="number"&&this.f!==s&&(this.f=s,m=!0,w.tabSize=s)}if(typeof l.indentSize<"u"){const s=this.o(l.indentSize);s==="tabSize"?(m=!0,w.indentSize=s):typeof s=="number"&&this.h!==s&&(this.g=s,this.h=s,m=!0,w.indentSize=s)}if(typeof l.insertSpaces<"u"){const s=this.q(l.insertSpaces);s==="auto"?(m=!0,w.insertSpaces=s):this.j!==s&&(this.j=s,m=!0,w.insertSpaces=s)}typeof l.cursorStyle<"u"&&this.k!==l.cursorStyle&&(this.k=l.cursorStyle,m=!0,w.cursorStyle=l.cursorStyle),typeof l.lineNumbers<"u"&&this.l!==l.lineNumbers&&(this.l=l.lineNumbers,m=!0,w.lineNumbers=O.TextEditorLineNumbersStyle.from(l.lineNumbers)),m&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(l,w){w.catch(m=>{this.e.warn(`ExtHostTextEditorOptions '${l}' failed:'`),this.e.warn(m)})}}e.$tP=E;class T{constructor(l,w,m,s,o,r,t,n){this.id=l,this.j=w,this.k=m,this.g=!1,this.h=new Set,this.c=o,this.d=new E(this.j,this.id,r,m),this.e=t,this.f=n;const c=this;this.value=Object.freeze({get document(){return s.value},set document(h){throw new N.$9("document")},get selection(){return c.c&&c.c[0]},set selection(h){if(!(h instanceof M.$4M))throw(0,N.$7)("selection");c.c=[h],c.l()},get selections(){return c.c},set selections(h){if(!Array.isArray(h)||h.some(i=>!(i instanceof M.$4M)))throw(0,N.$7)("selections");c.c=h,c.l()},get visibleRanges(){return c.e},set visibleRanges(h){throw new N.$9("visibleRanges")},get options(){return c.d.value},set options(h){c.g||c.d.assign(h)},get viewColumn(){return c.f},set viewColumn(h){throw new N.$9("viewColumn")},edit(h,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const $=new g(s.value,i);return h($),c.m($)},insertSnippet(h,i,$={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map(v=>O.Range.from(v));else if(i instanceof M.$2M){const{lineNumber:v,column:d}=O.Position.from(i);a=[{startLineNumber:v,startColumn:d,endLineNumber:v,endColumn:d}]}else if(i instanceof M.$3M)a=[O.Range.from(i)];else{a=[];for(const v of i)if(v instanceof M.$3M)a.push(O.Range.from(v));else{const{lineNumber:d,column:C}=O.Position.from(v);a.push({startLineNumber:d,startColumn:C,endLineNumber:d,endColumn:C})}}return w.$tryInsertSnippet(l,s.value.version,h.value,a,$)},setDecorations(h,i){const $=i.length===0;$&&!c.h.has(h.key)||($?c.h.delete(h.key):c.h.add(h.key),c.n(()=>{if(O.$iP(i))return w.$trySetDecorations(l,h.key,O.$jP(i));{const a=new Array(4*i.length);for(let v=0,d=i.length;v<d;v++){const C=i[v];a[4*v]=C.start.line+1,a[4*v+1]=C.start.character+1,a[4*v+2]=C.end.line+1,a[4*v+3]=C.end.character+1}return w.$trySetDecorationsFast(l,h.key,a)}}))},revealRange(h,i){c.n(()=>w.$tryRevealRange(l,O.Range.from(h),i||M.TextEditorRevealType.Default))},show(h){w.$tryShowEditor(l,O.ViewColumn.from(h))},hide(){w.$tryHideEditor(l)}})}dispose(){(0,S.ok)(!this.g),this.g=!0}_acceptOptions(l){(0,S.ok)(!this.g),this.d._accept(l)}_acceptVisibleRanges(l){(0,S.ok)(!this.g),this.e=l}_acceptViewColumn(l){(0,S.ok)(!this.g),this.f=l}_acceptSelections(l){(0,S.ok)(!this.g),this.c=l}async l(){const l=this.c.map(O.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,l)),this.value}m(l){const w=l.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const m=w.edits.map(o=>o.range);m.sort((o,r)=>o.end.line===r.end.line?o.end.character===r.end.character?o.start.line===r.start.line?o.start.character-r.start.character:o.start.line-r.start.line:o.end.character-r.end.character:o.end.line-r.end.line);for(let o=0,r=m.length-1;o<r;o++){const t=m[o].end;if(m[o+1].start.isBefore(t))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const s=w.edits.map(o=>({range:O.Range.from(o.range),text:o.text,forceMoveMarkers:o.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,s,{setEndOfLine:typeof w.setEndOfLine=="number"?O.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(l){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):l().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$uP=T}),define(Ce[67],Ae([1,0,56,5,6,2,3,4,111,16,115,8,13,28,12,40,41]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wP=e.$vP=void 0;class r{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let t=class{constructor(c,h){this.h=c,this.i=h,this.a=null,this.b=new Map,this.c=new w.$Bc,this.d=new N.$ee,this.e=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const h=[],i=[],$=[];if(c.removedDocuments)for(const a of c.removedDocuments){const v=O.URI.revive(a),d=this.c.get(v);d?.unref()&&(this.c.delete(v),h.push(d.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const v=O.URI.revive(a.uri);let d=this.c.get(v);if(d&&v.scheme!==m.Schemas.vscodeNotebookCell&&v.scheme!==m.Schemas.vscodeInteractiveInput)throw new Error(`document '${v} already exists!'`);d||(d=new r(new g.$oP(this.h.getProxy(p.$YM.MainThreadDocuments),v,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(v,d),i.push(d.value)),d.ref()}if(c.removedEditors)for(const a of c.removedEditors){const v=this.b.get(a);this.b.delete(a),v&&$.push(v)}if(c.addedEditors)for(const a of c.addedEditors){const v=O.URI.revive(a.documentUri);S.ok(this.c.has(v),`document '${v}' does not exist`),S.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const d=this.c.get(v).value,C=new T.$uP(a.id,this.h.getProxy(p.$YM.MainThreadTextEditors),this.i,new o.$V(()=>d.document),a.selections.map(y.Selection.to),a.options,a.visibleRanges.map(u=>y.Range.to(u)),typeof a.editorPosition=="number"?y.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,C)}c.newActiveEditor!==void 0&&(S.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,R.$Qc)(h),(0,R.$Qc)($),c.removedDocuments&&this.e.fire(h),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return s.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const h=this.b.get(this.a);return c?h:h?.value}allEditors(){return[...this.b.values()]}};e.$vP=t,e.$vP=t=Je([We(0,E.$lP),We(1,l.$2j)],t),e.$wP=(0,M.$vi)("IExtHostDocumentsAndEditors")}),define(Ce[279],Ae([1,0,18,5,4,115,8,7]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0kc=void 0;class g{constructor(T,y){this.i=y,this.a=new N.$ee,this.b=new N.$ee,this.c=new N.$ee,this.d=new N.$ee,this.f=new N.$ee,this.g=new N.$ee,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=T.getProxy(R.$YM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(l=>this.g.fire(l)),this.i.onDidChangeActiveTextEditor(l=>this.f.fire(l))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(T){const y=this.i.allEditors();return T?y:y.map(l=>l.value)}async showTextDocument(T,y,l){let w;typeof y=="number"?w={position:M.ViewColumn.from(y),preserveFocus:l}:typeof y=="object"?w={position:M.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?M.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:w={preserveFocus:!1};const m=await this.h.$tryShowTextDocument(T.uri,w),s=m&&this.i.getEditor(m);if(s)return s.value;throw m?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}createTextEditorDecorationType(T,y){return new O.$sP(this.h,T,y).value}$acceptEditorPropertiesChanged(T,y){const l=this.i.getEditor(T);if(!l)throw new Error("unknown text editor");if(y.options&&l._acceptOptions(y.options),y.selections){const w=y.selections.selections.map(M.Selection.to);l._acceptSelections(w)}if(y.visibleRanges){const w=S.$Hb(y.visibleRanges.map(M.Range.to));l._acceptVisibleRanges(w)}if(y.options&&this.b.fire({textEditor:l.value,options:{...y.options,lineNumbers:M.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const w=p.TextEditorSelectionChangeKind.fromValue(y.selections.source),m=y.selections.selections.map(M.Selection.to);this.a.fire({textEditor:l.value,selections:m,kind:w})}if(y.visibleRanges){const w=S.$Hb(y.visibleRanges.map(M.Range.to));this.c.fire({textEditor:l.value,visibleRanges:w})}}$acceptEditorPositionData(T){for(const y in T){const l=this.i.getEditor(y);if(!l)throw new Error("Unknown text editor");const w=M.ViewColumn.to(T[y]);l.value.viewColumn!==w&&(l._acceptViewColumn(w),this.d.fire({textEditor:l.value,viewColumn:w}))}}getDiffInformation(T){return Promise.resolve(this.h.$getDiffInformation(T))}}e.$0kc=g}),define(Ce[280],Ae([1,0,2,3,4,6,7,8,20,17]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tmc=e.$Smc=void 0,e.$Smc=(0,N.$vi)("IExtHostTimeline");class T{constructor(w,m){this.b=new Map,this.c=new Map,this.a=w.getProxy(R.$YM.MainThreadTimeline),m.registerArgumentProcessor({processArgument:(s,o)=>{if(s&&s.$mid===12)if(this.b.get(s.source)&&g.$Qm.equals(o,this.b.get(s.source)?.extension)){const r=s.uri===void 0?void 0:S.URI.revive(s.uri);return this.c.get(s.source)?.get(y(r))?.get(s.handle)}else return;return s}})}async $getTimeline(w,m,s,o){return this.b.get(w)?.provider.provideTimeline(S.URI.revive(m),s,o)}registerTimelineProvider(w,m,s,o){const r=new O.$Uc,t=this.d(m.id,o,r).bind(this);let n;m.onDidChange&&(n=m.onDidChange(h=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...h,id:m.id}),this));const c=this.c;return this.f({...m,scheme:w,onDidChange:void 0,async provideTimeline(h,i,$){i?.resetCache&&(r.clear(),c.get(m.id)?.clear());const a=await m.provideTimeline(h,i,$);if(a==null)return;const v=t(h,i);return{...a,source:m.id,items:a.items.map(v)}},dispose(){for(const h of c.values())h.get(m.id)?.clear();n?.dispose(),r.dispose()}},s)}d(w,m,s){return(o,r)=>{let t;if(r?.cacheResults){let n=this.c.get(w);n===void 0&&(n=new Map,this.c.set(w,n));const c=y(o);t=n.get(c),t===void 0&&(t=new Map,n.set(c,t))}return n=>{const{iconPath:c,...h}=n,i=`${w}|${n.id??n.timestamp}`;t?.set(i,n);let $,a,v;n.iconPath&&(c instanceof M.$WN?v={id:c.id,color:c.color}:S.URI.isUri(c)?($=c,a=c):{light:$,dark:a}=c);let d;return M.$pN.isMarkdownString(h.tooltip)?d=p.MarkdownString.from(h.tooltip):(0,E.$8f)(h.tooltip)?d=h.tooltip:M.$pN.isMarkdownString(h.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=p.MarkdownString.from(h.detail)):(0,E.$8f)(h.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),d=h.detail),{...h,id:h.id??void 0,handle:i,source:w,command:n.command?m.toInternal(n.command,s):void 0,icon:$,iconDark:a,themeIcon:v,tooltip:d,accessibilityInformation:n.accessibilityInformation}}}}f(w,m){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:m}),(0,O.$Tc)(()=>{for(const o of this.c.values())o.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$Tmc=T;function y(l){return l?.toString()}}),define(Ce[281],Ae([1,0,172,23,2,5,6,211,11,7,17,18,8,54,24,137,26]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Umc=void 0;function r(c,h){if((0,T.$8f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter($=>$.length===2&&typeof $[0]=="number"&&typeof $[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class t extends M.$Vc{constructor(h,i,$){super(),this.f=h,this.g=i,this.h=$,this.a=new Map,this.b=new s.$F9;function a(v){return v&&v.$treeViewId&&(v.$treeItemHandle||v.$selectedTreeItems||v.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:v=>a(v)?this.r(v):Array.isArray(v)&&v.length>0?v.map(d=>a(d)?this.r(d):d):v})}registerTreeDataProvider(h,i,$){const a=this.createTreeView(h,{treeDataProvider:i},$);return{dispose:()=>a.dispose()}}createTreeView(h,i,$){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],v=i.dragAndDropController?.dragMimeTypes??[],d=!!i.dragAndDropController?.handleDrag,C=!!i.dragAndDropController?.handleDrop,u=this.m(h,i,$),D={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:v,hasHandleDrag:d,hasHandleDrop:C,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},f=this.f.$registerTreeViewDataProvider(h,D),k={get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get activeItem(){return(0,o.$GG)($,"treeViewActiveItem"),u.focusedElement},get onDidChangeActiveItem(){return(0,o.$GG)($,"treeViewActiveItem"),u.onDidChangeActiveItem},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get onDidChangeCheckboxState(){return u.onDidChangeCheckboxState},get message(){return u.message},set message(b){(0,w.$Uk)(b)&&(0,o.$GG)($,"treeViewMarkdownMessage"),u.message=b},get title(){return u.title},set title(b){u.title=b},get description(){return u.description},set description(b){u.description=b},get badge(){return u.badge},set badge(b){b!==void 0&&E.ViewBadge.isViewBadge(b)?u.badge={value:Math.floor(Math.abs(b.value)),tooltip:b.tooltip}:b===void 0&&(u.badge=void 0)},reveal:(b,P)=>u.reveal(b,P),dispose:async()=>{await f,this.a.delete(h),u.dispose()}};return this.B(k),k}$getChildren(h,i){const $=this.a.get(h);return $?$.getChildren(i):Promise.reject(new p.$VF(h))}async $handleDrop(h,i,$,a,v,d,C,u){const D=this.a.get(h);if(!D)return Promise.reject(new p.$VF(h));const f=l.DataTransfer.toDataTransfer($,async k=>(await this.f.$resolveDropFileData(h,i,k)).buffer);return C===h&&u&&await this.j(f,D,u,v,d),D.onDrop(f,a,v)}async j(h,i,$,a,v){const d=this.b.removeDragOperationTransfer(v);if(d)(await d)?.forEach((C,u)=>{C&&h.set(u,C)});else if(v&&i.handleDrag){const C=i.handleDrag($,h,a);this.b.addDragOperationTransfer(v,C),await C}return h}async $handleDrag(h,i,$,a){const v=this.a.get(h);if(!v)return Promise.reject(new p.$VF(h));const d=await this.j(new E.$SN,v,i,a,$);if(!(!d||a.isCancellationRequested))return l.DataTransfer.from(d)}async $hasResolve(h){const i=this.a.get(h);if(!i)throw new p.$VF(h);return i.hasResolve}$resolve(h,i,$){const a=this.a.get(h);if(!a)throw new p.$VF(h);return a.resolveTreeItem(i,$)}$setExpanded(h,i,$){const a=this.a.get(h);if(!a)throw new p.$VF(h);a.setExpanded(i,$)}$setSelectionAndFocus(h,i,$){const a=this.a.get(h);if(!a)throw new p.$VF(h);a.setSelectionAndFocus(i,$)}$setVisible(h,i){const $=this.a.get(h);if(!$){if(!i)return;throw new p.$VF(h)}$.setVisible(i)}$changeCheckboxState(h,i){const $=this.a.get(h);if(!$)throw new p.$VF(h);$.setCheckboxState(i)}m(h,i,$){const a=this.B(new n(h,i,this.f,this.g.converter,this.h,$));return this.a.set(h,a),a}r(h){const i=this.a.get(h.$treeViewId);return i&&"$treeItemHandle"in h?i.getExtensionElement(h.$treeItemHandle):i&&"$focusedTreeItem"in h&&h.$focusedTreeItem?i.focusedElement:null}}e.$Umc=t;class n extends M.$Vc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(h=>this.getExtensionElement(h)).filter(h=>!(0,T.$eg)(h))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(h,i,$,a,v,d){if(super(),this.I=h,this.J=$,this.L=a,this.M=v,this.N=d,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new O.$ee),this.onDidExpandElement=this.u.event,this.w=this.B(new O.$ee),this.onDidCollapseElement=this.w.event,this.y=this.B(new O.$ee),this.onDidChangeSelection=this.y.event,this.z=this.B(new O.$ee),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new O.$ee),this.onDidChangeVisibility=this.C.event,this.D=this.B(new O.$ee),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new O.$ee),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new m.$pe,d.contributes&&d.contributes.views)for(const f in d.contributes.views)for(const k of d.contributes.views[f])k.id===h&&(this.P=k.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(f=>this.F.fire({message:!1,element:f})));let C,u;const D=O.Event.debounce(this.F.event,(f,k)=>(f||(f={message:!1,elements:[]}),k.element!==!1&&(C||(C=new Promise(b=>u=b),this.G=this.G.then(()=>C)),Array.isArray(k.element)?f.elements.push(...k.element):f.elements.push(k.element)),k.message&&(f.message=!0),f),200,!0);this.B(D(({message:f,elements:k})=>{k.length&&(this.H=this.H.then(()=>{const b=u;return C=null,this.$(k).then(()=>b())})),f&&this.J.$setMessage(this.I,l.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(h){const i=h?this.getExtensionElement(h):void 0;if(h&&!i)return this.M.error(`No tree item with id '${h}' found.`),Promise.resolve([]);let $=this.X(h);return $||($=await this.Y(i)),$?$.map(a=>a.item):void 0}getExtensionElement(h){return this.j.get(h)}reveal(h,i){i=i||{select:!0,focus:!1};const $=(0,T.$eg)(i.select)?!0:i.select,a=(0,T.$eg)(i.focus)?!1:i.focus,v=(0,T.$eg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):h?this.G.then(()=>this.S(h)).then(d=>this.W(h,d[d.length-1]).then(C=>this.J.$reveal(this.I,{item:C.item,parentChain:d.map(u=>u.item)},{select:$,focus:a,expand:v})),d=>this.M.error(d)):this.J.$reveal(this.I,void 0,{select:$,focus:a,expand:v})}get message(){return this.O}set message(h){this.O=h,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(h){this.P=h,this.J.$setTitle(this.I,h,this.Q)}get description(){return this.Q}set description(h){this.Q=h,this.J.$setTitle(this.I,this.P,h)}get badge(){return this.R}set badge(h){this.R?.value===h?.value&&this.R?.tooltip===h?.tooltip||(this.R=l.ViewBadge.from(h),this.J.$setBadge(this.I,h))}setExpanded(h,i){const $=this.getExtensionElement(h);$&&(i?this.u.fire(Object.freeze({element:$})):this.w.fire(Object.freeze({element:$})))}setSelectionAndFocus(h,i){const $=!(0,y.$ub)(this.s,h);this.s=h;const a=this.t!==i;this.t=i,$&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(h){h!==this.r&&(this.r=h,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(h){const i=(await Promise.all(h.map(async $=>{const a=this.getExtensionElement($.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:$.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter($=>$!==void 0);i.forEach($=>{$.treeItem.checkboxState=$.newState?E.TreeItemCheckboxState.Checked:E.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map($=>[$.extensionItem,$.newState])})}async handleDrag(h,i,$){const a=[];for(const v of h){const d=this.getExtensionElement(v);d&&a.push(d)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,$),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(h,i,$){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,g.$nh)(()=>this.g?.handleDrop?this.g.handleDrop(a,h,$):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(h,i){if(!this.f.resolveTreeItem)return;const $=this.j.get(h);if($){const a=this.m.get($);if(a){const v=await this.f.resolveTreeItem(a.extensionItem,$,i)??a.extensionItem;return this.hb(v),a.item.tooltip=this.eb(v.tooltip),a.item.command=this.fb(a.disposableStore,v.command),a.item}}}S(h){return this.U(h).then(i=>i?this.S(i).then($=>this.W(i,$[$.length-1]).then(a=>($.push(a),$))):Promise.resolve([]))}U(h){const i=this.m.get(h);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,g.$nh)(()=>this.f.getParent(h))}W(h,i){const $=this.m.get(h);return $?Promise.resolve($):(0,g.$nh)(()=>this.f.getTreeItem(h)).then(a=>this.kb(h,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const v=this.getExtensionElement(a);if(v){const d=this.m.get(v);if(d)return Promise.resolve(d)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(h){if(h){let i;if(typeof h=="string"){const $=this.getExtensionElement(h);i=$?this.m.get($):void 0}else i=h;return i&&i.children||void 0}return this.h}async Y(h){this.rb(h);const i=new m.$pe(this.Z.token);try{const $=h?this.m.get(h):void 0,a=await this.f.getChildren(h);if(i.token.isCancellationRequested)return;const v=(0,y.$Hb)(a||[]),d=await Promise.all((0,y.$Hb)(v).map(u=>this.f.getTreeItem(u)));if(i.token.isCancellationRequested)return;const C=d.map((u,D)=>u?this.db(v[D],u,$):null);return(0,y.$Hb)(C)}finally{i.dispose()}}$(h){if(h.some($=>!$))return this.Z.dispose(!0),this.Z=new m.$pe,this.tb(),this.J.$refresh(this.I);{const $=this.ab(h);if($.length)return this.bb($)}return Promise.resolve(void 0)}ab(h){const i=new Set,$=h.map(v=>this.m.get(v));for(const v of $)if(v&&!i.has(v.item.handle)){let d=v;for(;d&&d.parent&&$.findIndex(C=>d&&d.parent&&C&&C.item.handle===d.parent.item.handle)===-1;){const C=this.j.get(d.parent.item.handle);d=C?this.m.get(C):void 0}d&&!d.parent&&i.add(v.item.handle)}const a=[];return i.forEach(v=>{const d=this.j.get(v);if(d){const C=this.m.get(d);C&&(!C.parent||!i.has(C.parent.item.handle))&&a.push(v)}}),a}bb(h){const i={};return Promise.all(h.map($=>this.cb($).then(a=>{a&&(i[$]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(h){const i=this.getExtensionElement(h);if(i){const $=this.m.get(i);if($)return this.rb(i),(0,g.$nh)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const v=this.ib(i,a,$.parent);return this.pb(i,v,$,$.parent),$.dispose(),v}return null})}return Promise.resolve(null)}db(h,i,$){const a=this.ib(h,i,$);if(i.id&&this.j.has(a.item.handle))throw new Error((0,S.localize)(0,null,i.id));return this.ob(h,a),this.qb(a,$),a}eb(h){return E.$pN.isMarkdownString(h)?l.MarkdownString.from(h):h}fb(h,i){return i?{...this.L.toInternal(i,h),originalId:i.command}:void 0}gb(h){if(h.checkboxState===void 0)return;let i,$,a;return typeof h.checkboxState=="number"?i=h.checkboxState:(i=h.checkboxState.state,$=h.checkboxState.tooltip,a=h.checkboxState.accessibilityInformation),{isChecked:i===E.TreeItemCheckboxState.Checked,tooltip:$,accessibilityInformation:a}}hb(h){if(!E.$NN.isTreeItem(h,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(h,i,$){this.hb(i);const a=this.B(new M.$Uc),v=this.kb(h,i,$),d=this.lb(i);return{item:{handle:v,parentHandle:$?$.item.handle:void 0,label:r(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:d,iconDark:this.mb(i)||d,themeIcon:this.jb(i),collapsibleState:(0,T.$eg)(i.collapsibleState)?E.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:$,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(h){return h.iconPath instanceof E.$WN?h.iconPath:void 0}kb(h,{id:i,label:$,resourceUri:a},v,d){if(i)return`${n.b}/${i}`;const C=r($,this.N),u=v?v.item.handle:n.a;let D=C?C.label:a?(0,N.$6g)(a):"";D=D.indexOf("/")!==-1?D.replace("/","//"):D;const f=this.m.has(h)?this.m.get(h).item.handle:void 0,k=this.X(v)||[];let b,P=0;do{if(b=`${u}/${P}:${D}`,d||!this.j.has(b)||f===b)break;P++}while(P<=k.length);return b}lb(h){if(h.iconPath&&!(h.iconPath instanceof E.$WN))return typeof h.iconPath=="string"||R.URI.isUri(h.iconPath)?this.nb(h.iconPath):this.nb(h.iconPath.light)}mb(h){if(h.iconPath&&!(h.iconPath instanceof E.$WN)&&h.iconPath.dark)return this.nb(h.iconPath.dark)}nb(h){return R.URI.isUri(h)?h:R.URI.file(h)}ob(h,i){this.j.set(i.item.handle,h),this.m.set(h,i)}pb(h,i,$,a){this.j.delete(i.item.handle),this.m.delete(h),i.item.handle!==$.item.handle&&this.j.delete($.item.handle),this.ob(h,i);const v=this.X(a)||[],d=v.filter(C=>C.item.handle===$.item.handle)[0];d&&v.splice(v.indexOf(d),1,i)}qb(h,i){i?(i.children||(i.children=[]),i.children.push(h)):(this.h||(this.h=[]),this.h.push(h))}rb(h){if(h){const i=this.m.get(h);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(h){const i=this.m.get(h);if(i){if(i.children)for(const $ of i.children){const a=this.j.get($.item.handle);a&&this.sb(a)}this.m.delete(h),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(h=>h.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Ce[282],Ae([1,0,5,6,2,35,8,63,4,7]),function(ge,e,S,N,R,O,M,p,g,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qlc=void 0;class T extends N.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(m,s,o,r){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new S.$ee),this.onDidDispose=this.#d.event,this.#h=this.B(new S.$ee),this.onDidChangeViewState=this.#h.event,this.#e=m,this.#t=s,this.#n=o,this.#i=r.viewType,this.#s=r.panelOptions,this.#o=r.viewColumn,this.#r=r.title,this.#u=r.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(m){this.c(),this.#r!==m&&(this.#r=m,this.#t.$setTitle(this.#e,m))}get iconPath(){return this.c(),this.#a}set iconPath(m){this.c(),this.#a!==m&&(this.#a=m,this.#t.$setIconPath(this.#e,R.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(m){this.#l||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(this.#u=m.active,this.#c=m.visible,this.#o=m.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(m,s){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof m>"u"?void 0:M.ViewColumn.from(m),preserveFocus:!!s})}c(){if(this.#l)throw new Error("Webview is disposed")}}class y extends N.$Vc{static c(){return(0,O.$Rg)()}constructor(m,s,o){super(),this.j=s,this.m=o,this.g=new Map,this.h=new Map,this.f=m.getProxy(g.$YM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(m=>m.dispose()),this.g.clear()}createWebviewPanel(m,s,o,r,t={}){const n=typeof r=="object"?r.viewColumn:r,c={viewColumn:M.ViewColumn.from(n),preserveFocus:typeof r=="object"&&!!r.preserveFocus},h=(0,p.$mlc)(m),i=y.c();this.f.$createWebviewPanel((0,p.$olc)(m),i,s,{title:o,panelOptions:l(t),webviewOptions:(0,p.$plc)(m,this.m,t),serializeBuffersForPostMessage:h},c);const $=this.j.createNewWebview(i,t,m);return this.createNewWebviewPanel(i,s,o,n,t,$,!0)}$onDidChangeWebviewPanelViewStates(m){const s=Object.keys(m);s.sort((o,r)=>{const t=m[o],n=m[r];return t.active?1:n.active?-1:+t.visible-+n.visible});for(const o of s){const r=this.getWebviewPanel(o);if(!r)continue;const t=m[o];r._updateViewState({active:t.active,visible:t.visible,viewColumn:M.ViewColumn.to(t.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.g.delete(m),this.j.deleteWebview(m)}registerWebviewPanelSerializer(m,s,o){if(this.h.has(s))throw new Error(`Serializer for '${s}' already registered`);return this.h.set(s,{serializer:o,extension:m}),this.f.$registerSerializer(s,{serializeBuffersForPostMessage:(0,p.$mlc)(m)}),new E.$1M(()=>{this.h.delete(s),this.f.$unregisterSerializer(s)})}async $deserializeWebviewPanel(m,s,o,r){const t=this.h.get(s);if(!t)throw new Error(`No serializer found for '${s}'`);const{serializer:n,extension:c}=t,h=this.j.createNewWebview(m,o.webviewOptions,c),i=this.createNewWebviewPanel(m,s,o.title,r,o.panelOptions,h,o.active);await n.deserializeWebviewPanel(i,o.state)}createNewWebviewPanel(m,s,o,r,t,n,c){const h=new T(m,this.f,n,{viewType:s,title:o,viewColumn:r,panelOptions:t,active:c});return this.g.set(m,h),h}getWebviewPanel(m){return this.g.get(m)}}e.$qlc=y;function l(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Ce[283],Ae([1,0,5,6,63,8,4,7]),function(ge,e,S,N,R,O,M,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=void 0;class g extends N.$Vc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(y,l,w,m,s,o){super(),this.#s=!1,this.#u=this.B(new S.$ee),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new S.$ee),this.onDidDispose=this.#l.event,this.#i=w,this.#a=m,this.#e=y,this.#t=l,this.#n=s,this.#r=o}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(y){this.a(),this.#a!==y&&(this.#a=y,this.#t.$setWebviewViewTitle(this.#e,y))}get description(){return this.a(),this.#o}set description(y){this.a(),this.#o!==y&&(this.#o=y,this.#t.$setWebviewViewDescription(this.#e,y))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(y){y===this.#r||this.#s||(this.#r=y,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(y){this.a(),!(y?.value===this.#c?.value&&y?.tooltip===this.#c?.tooltip)&&(this.#c=O.ViewBadge.from(y),this.#t.$setWebviewViewBadge(this.#e,y))}show(y){this.a(),this.#t.$show(this.#e,!!y)}a(){if(this.#s)throw new Error("Webview is disposed")}}class E{constructor(y,l){this.d=l,this.b=new Map,this.c=new Map,this.a=y.getProxy(M.$YM.MainThreadWebviewViews)}registerWebviewViewProvider(y,l,w,m){if(this.b.has(l))throw new Error(`View provider for '${l}' already registered`);return this.b.set(l,{provider:w,extension:y}),this.a.$registerWebviewViewProvider((0,R.$olc)(y),l,{retainContextWhenHidden:m?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,R.$mlc)(y)}),new p.$1M(()=>{this.b.delete(l),this.a.$unregisterWebviewViewProvider(l)})}async $resolveWebviewView(y,l,w,m,s){const o=this.b.get(l);if(!o)throw new Error(`No view provider found for '${l}'`);const{provider:r,extension:t}=o,n=this.d.createNewWebview(y,{},t),c=new g(y,this.a,l,w,n,!0);this.c.set(y,c),await r.resolveWebviewView(c,{state:m},s)}async $onDidChangeWebviewViewVisibility(y,l){this.e(y)._setVisible(l)}async $disposeWebviewView(y){const l=this.e(y);this.c.delete(y),l.dispose(),this.d.deleteWebview(y)}e(y){const l=this.c.get(y);if(!l)throw new Error("No webview found");return l}}e.$Xmc=E}),define(Ce[284],Ae([1,0,5,30,31,3]),function(ge,e,S,N,R,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iM=e.$hM=e.OutputChannelUpdateMode=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=void 0,e.$7L="text/x-code-output",e.$8L="output",e.$9L="Log",e.$0L="text/x-code-log-output",e.$$L="log",e.$_L="workbench.panel.output",e.$aM=new R.$Mj("inOutput",!1),e.$bM=new R.$Mj("activeLogOutput",!1),e.$cM=new R.$Mj("activeLogOutput.levelSettable",!1),e.$dM=new R.$Mj("activeLogOutput.level",""),e.$eM=new R.$Mj("activeLogOutput.levelIsDefault",!1),e.$fM=new R.$Mj("outputView.scrollLock",!1),e.$gM=(0,O.$vi)("outputService");var M;(function(g){g[g.Append=1]="Append",g[g.Replace=2]="Replace",g[g.Clear=3]="Clear"})(M||(e.OutputChannelUpdateMode=M={})),e.$hM={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new S.$ee,this.onDidRegisterChannel=this.b.event,this.c=new S.$ee,this.onDidRemoveChannel=this.c.event}registerChannel(E){this.a.has(E.id)||(this.a.set(E.id,E),this.b.fire(E.id))}getChannels(){const E=[];return this.a.forEach(T=>E.push(T)),E}getChannel(E){return this.a.get(E)}removeChannel(E){this.a.delete(E),this.c.fire(E)}}N.$bo.add(e.$hM.OutputChannels,new p),e.$iM=new R.$Mj("activeOutputChannel","")}),define(Ce[116],Ae([1,0,4,3,16,20,13,284,64,27,45,141,22,17,44,5,6]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xmc=e.$wmc=void 0;class r extends M.$8j{get disposed(){return this.n}constructor(h,i,$,a,v){super(),this.id=h,this.name=i,this.r=$,this.s=a,this.extension=v,this.m=0,this.n=!1,this.visible=!1,this.setLevel($.getLevel()),this.B($.onDidChangeLogLevel(d=>this.setLevel(d)))}get logLevel(){return this.getLevel()}appendLine(h){this.append(h+`
`)}append(h){this.info(h)}clear(){const h=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,h)}replace(h){const i=this.m;this.info(h),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(h,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof h=="boolean"?h:i))}hide(){this.s.$close(this.id)}g(h,i){this.m+=l.$Fe.fromString(i).byteLength,(0,M.log)(this.r,h,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class t extends r{appendLine(h){this.append(h)}}let n=class{constructor(h,i,$,a,v,d){this.i=i,this.j=$,this.k=a,this.l=v,this.m=d,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=h.getProxy(S.$YM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,y.$3m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(h){this.h=h;for(const[i,$]of this.g)$.visible=i===this.h}createOutputChannel(h,i,$){if(h=h.trim(),!h)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,v=(0,w.$8f)(i)?i:void 0;if((0,w.$8f)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");let d;const C=this.i.environment.extensionLogLevel?.find(([D])=>O.$Qm.equals($.identifier,D))?.[1];C&&(d=(0,M.$gk)(C));const u=a?this.o(h,d,$):this.n(h,v,$);return u.then(D=>{this.g.set(D.id,D),D.visible=D.id===this.h}),a?this.r(h,d??this.m.getLevel(),u):this.q(h,u)}async n(h,i,$){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,v=this.k.extUri.joinPath(a,`${this.f++}-${h.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),d=this.l.createLogger(v,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),C=await this.a.$register(h,v,i,$.identifier.value);return new r(C,h,d,this.a,$)}async o(h,i,$){const a=await this.p($),v=h.replace(/[\\/:\*\?"<>\|]/g,""),d=this.k.extUri.joinPath(a,`${v}.log`),C=`${$.identifier.value}.${v}`,u=this.l.createLogger(d,{id:C,name:h,logLevel:i,extensionId:$.identifier.value});return new t(C,h,u,this.a,$)}p(h){let i=this.d.get(h.identifier.value);if(!i){const $=this.k.extUri.joinPath(this.i.logsLocation,h.identifier.value);this.d.set(h.identifier.value,i=(async()=>{try{await this.j.value.createDirectory($)}catch(a){if((0,m.$fl)(a)!==m.FileSystemProviderErrorCode.FileExists)throw a}return $})())}return i}q(h,i){let $=!1;const a=()=>{if($)throw new Error("Channel has been closed")};return{get name(){return h},append(v){a(),i.then(d=>d.append(v))},appendLine(v){a(),i.then(d=>d.appendLine(v))},clear(){a(),i.then(v=>v.clear())},replace(v){a(),i.then(d=>d.replace(v))},show(v,d){a(),i.then(C=>C.show(v,d))},hide(){a(),i.then(v=>v.hide())},dispose(){$=!0,i.then(v=>v.dispose())}}}r(h,i,$){const a=new o.$Uc,v=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},d=a.add(new s.$ee);function C(u){i=u,d.fire(u)}return $.then(u=>{a.add(u),u.logLevel!==i&&C(u.logLevel),a.add(u.onDidChangeLogLevel(D=>C(D)))}),{...this.q(h,$),get logLevel(){return i},onDidChangeLogLevel:d.event,trace(u,...D){v(),$.then(f=>f.trace(u,...D))},debug(u,...D){v(),$.then(f=>f.debug(u,...D))},info(u,...D){v(),$.then(f=>f.info(u,...D))},warn(u,...D){v(),$.then(f=>f.warn(u,...D))},error(u,...D){v(),$.then(f=>f.error(u,...D))},dispose(){a.dispose()}}}};e.$wmc=n,e.$wmc=n=Je([We(0,R.$lP),We(1,E.$BP),We(2,g.$ilc),We(3,T.$Xkc),We(4,M.$3j),We(5,M.$2j)],n),e.$xmc=(0,N.$vi)("IExtHostOutputService")}),define(Ce[117],Ae([1,0,3,11]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gn=e.$fn=void 0,e.$fn=(0,S.$vi)("remoteAgentService"),e.$gn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(R){let O=1/0;for(let p=0;p<this.maxSampleCount;p++){const g=await R.getRoundTripTime();if(g===void 0)return;O=Math.min(O,g/2),await(0,N.$wh)(this.sampleDelay)}this.average.push(O),this.average.length>this.maxAverageCount&&this.average.shift();let M;return this.initial.length<this.maxInitialCount?this.initial.push(O):M=this.initial.reduce((p,g)=>p+g,0)/this.initial.length,this.lastMeasurement={initial:M,current:O,average:this.average.reduce((p,g)=>p+g,0)/this.average.length,high:typeof M>"u"?!1:O>this.highLatencyMaxThreshold||O>this.highLatencyMinThreshold&&O>M*this.highLatencyMultiple},this.lastMeasurement}}}),define(Ce[285],Ae([1,0,175,57,30,49,48,6,5,117,21,25,11]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=void 0,e.$zJ=Object.freeze({id:"application",order:100,title:(0,S.localize)(0,null),type:"object"}),e.$AJ=Object.freeze({id:"workbench",order:7,title:(0,S.localize)(1,null),type:"object"}),e.$BJ=Object.freeze({id:"security",scope:1,title:(0,S.localize)(2,null),type:"object",order:7}),e.$CJ=Object.freeze({id:"problems",title:(0,S.localize)(3,null),type:"object",order:101}),e.$DJ={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new g.$ee,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(t){this.migrations.push(...t)}}const m=new w;R.$bo.add(e.$DJ.ConfigurationMigration,m);let s=class extends p.$Vc{static{this.ID="workbench.contrib.configurationMigration"}constructor(t,n){super(),this.a=t,this.b=n,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const h of c.added)await this.f(h,m.migrations)})),this.c(m.migrations),this.B(m.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(t){await this.f(void 0,t);for(const n of this.b.getWorkspace().folders)await this.f(n,t)}async f(t,n){await Promise.all([n.map(c=>this.g(c,t?.uri))])}async g(t,n){const c=this.a.inspect(t.key,{resource:n}),h=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,$]of h){const a=c[i];if(!a)continue;const v=[];if(a.value!==void 0){const d=await this.h(t,i,a.value,n,void 0);for(const C of d??[])v.push([C,[]])}for(const{identifiers:d,value:C}of a.overrides??[])if(C!==void 0){const u=await this.h(t,i,C,n,d);for(const D of u??[])v.push([D,d])}v.length&&await Promise.allSettled(v.map(async([[d,C],u])=>this.a.updateValue(d,C.value,{resource:n,overrideIdentifiers:u},$)))}}async h(t,n,c,h,i){const $=v=>{const C=this.a.inspect(v,{resource:h})[n];if(C)return i?C.overrides?.find(({identifiers:u})=>(0,y.$6n)(u,i))?.value:C.value},a=await t.migrateFn(c,$);return Array.isArray(a)?a:[[t.key,a]]}};e.$EJ=s,e.$EJ=s=Je([We(0,M.$2i),We(1,O.$Ei)],s);let o=class extends p.$Vc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(t){super(),this.b=t,this.a=new l.$Sh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!T.$i&&(await this.b.getEnvironment())?.os!==1)return;R.$bo.as(N.$go.Configuration).registerConfiguration({...e.$BJ,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,S.localize)(4,null)},default:[],markdownDescription:(0,S.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,S.localize)(6,null),scope:2}}})}};e.$FJ=o,e.$FJ=o=Je([We(0,E.$fn)],o)}),define(Ce[286],Ae([1,0,36,12,19,23,184,285,57,3,30]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$3gb=e.$2gb=void 0,e.$4gb=s,e.$5gb=o,e.$2gb=(0,E.$vi)("editorResolverService"),e.$3gb="workbench.editorAssociations";const y=T.$bo.as(g.$go.Configuration),l={...p.$AJ,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,M.localize)(0,null),additionalProperties:{type:"string"}}}};y.registerConfiguration(l);var w;(function(r){r.builtin="builtin",r.option="option",r.exclusive="exclusive",r.default="default"})(w||(e.RegisteredEditorPriority=w={}));var m;(function(r){r[r.ABORT=1]="ABORT",r[r.NONE=2]="NONE"})(m||(e.ResolvedStatus=m={}));function s(r){switch(r){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function o(r,t){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(t.scheme))return!1;const h=typeof r=="string"&&r.indexOf(R.$hc.sep)>=0?`${t.scheme}:${t.path}`:(0,O.$6g)(t);return S.$ok(typeof r=="string"?r.toLowerCase():r,h.toLowerCase())}}),define(Ce[287],Ae([1,0,47,12,19,21,23,2,3,205,49,225,117]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$BM=e.$AM=void 0,e.$AM=(0,g.$vi)("pathService");let m=w=class{constructor(o,r,t,n){this.d=o,this.e=r,this.f=t,this.g=n,this.a=(async()=>(await this.e.getEnvironment())?.os||O.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??o})()}hasValidBasename(o,r,t){return typeof r=="string"||typeof r>"u"?this.a.then(n=>this.h(o,n,r)):this.h(o,r,t)}h(o,r,t){return o.scheme===N.Schemas.file||o.scheme===N.Schemas.vscodeRemote?(0,S.$sg)(t??(0,M.$6g)(o),r===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(o,r){if(o.remoteAuthority)return N.Schemas.vscodeRemote;const t=(0,E.$xM)(r.getWorkspace());if(t)return t;const n=r.getWorkspace().folders[0];if(n)return n.uri.scheme;const c=r.getWorkspace().configuration;return c?c.scheme:N.Schemas.file}userHome(o){return o?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(o=>o===1?R.$gc:R.$hc)}async fileURI(o){let r="";if(await this.a===1&&(o=o.replace(/\\/g,"/")),o[0]==="/"&&o[1]==="/"){const n=o.indexOf("/",2);n===-1?(r=o.substring(2),o="/"):(r=o.substring(2,n),o=o.substring(n)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:r,path:o,query:"",fragment:""})}};e.$BM=m,e.$BM=m=w=Je([We(1,l.$fn),We(2,y.$jM),We(3,T.$Ei)],m)}),define(Ce[118],Ae([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$7K=e.$6K=void 0;class S{constructor(M,p){this.line=M,this.character=p}isBefore(M){return!1}isBeforeOrEqual(M){return!1}isAfter(M){return!1}isAfterOrEqual(M){return!1}isEqual(M){return!1}compareTo(M){return 0}translate(M,p){return new S(0,0)}with(M){return new S(0,0)}}e.$6K=S;class N{constructor(M,p,g,E){this.isEmpty=!1,this.isSingleLine=!1,this.start=new S(M,p),this.end=new S(g,E)}contains(M){return!1}isEqual(M){return!1}intersection(M){}union(M){return new N(0,0,0,0)}with(M){return new N(0,0,0,0)}}e.$7K=N;var R;(function(O){O[O.Information=1]="Information",O[O.Warning=2]="Warning"})(R||(e.TextSearchCompleteMessageType=R={}))}),define(Ce[46],Ae([1,0,18,36,25,47,15,3,19,14,118,11]),function(ge,e,S,N,R,O,M,p,g,E,T,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tL=e.$rL=e.$kL=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$hL=e.$gL=e.$fL=e.$eL=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$aL=e.$_K=e.$$K=e.$0K=e.$9K=e.$8K=e.TextSearchCompleteMessageType=void 0,e.$bL=r,e.$cL=t,e.$dL=n,e.$iL=u,e.$jL=D,e.$lL=b,e.$mL=P,e.$nL=I,e.$oL=W,e.$pL=V,e.$qL=q,e.$sL=j,e.$uL=ae,e.$vL=we,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return T.TextSearchCompleteMessageType}}),e.$8K="workbench.view.search",e.$9K="workbench.panel.search",e.$0K="workbench.view.search",e.$$K="search-result",e.$_K="search.exclude";const l="\u27EA ",w=" characters skipped \u27EB",m=(l.length+w.length+5)*2;e.$aL=(0,p.$vi)("searchService");var s;(function(de){de[de.file=0]="file",de[de.text=1]="text",de[de.aiText=2]="aiText"})(s||(e.SearchProviderType=s={}));var o;(function(de){de[de.File=1]="File",de[de.Text=2]="Text",de[de.aiText=3]="aiText"})(o||(e.QueryType=o={}));function r(de){return!!de.preview}function t(de){return!!de.resource}function n(de){return!!de.message}var c;(function(de){de[de.Normal=0]="Normal",de[de.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class h{constructor(me){this.resource=me,this.results=[]}}e.$eL=h;class i{constructor(me,Me,ce,Re){this.ranges=Me,this.webviewIndex=Re;const ie=Array.isArray(Me)?Me:[Me];if(ce&&ce.matchLines===1&&$(ie)){me=(0,M.$1f)(me,ce.matchLines);let L="",x=0,ve=0;const Fe=Math.floor(ce.charsPerLine/5),Ee=[];for(const pe of ie){const fe=Math.max(pe.startColumn-Fe,0),Y=pe.startColumn+ce.charsPerLine;if(fe>ve+Fe+m){const X=l+(fe-ve)+w;L+=X+me.slice(fe,Y),x+=fe-(ve+X.length)}else L+=me.slice(ve,Y);Ee.push(new v(0,pe.startColumn-x,pe.endColumn-x)),ve=Y}this.preview={text:L,matches:Array.isArray(this.ranges)?Ee:Ee[0]}}else{const L=Array.isArray(Me)?Me[0].startLineNumber:Me.startLineNumber;this.preview={text:me,matches:(0,S.$2b)(Me,x=>new a(x.startLineNumber-L,x.startColumn,x.endLineNumber-L,x.endColumn))}}}}e.$fL=i;function $(de){const me=de[0].startLineNumber;for(const Me of de)if(Me.startLineNumber!==me||Me.endLineNumber!==me)return!1;return!0}class a{constructor(me,Me,ce,Re){this.startLineNumber=me,this.startColumn=Me,this.endLineNumber=ce,this.endColumn=Re}}e.$gL=a;class v extends a{constructor(me,Me,ce){super(me,Me,me,ce)}}e.$hL=v;var d;(function(de){de.List="list",de.Tree="tree"})(d||(e.ViewMode=d={}));var C;(function(de){de.Default="default",de.FileNames="fileNames",de.Type="type",de.Modified="modified",de.CountDescending="countDescending",de.CountAscending="countAscending"})(C||(e.SearchSortOrder=C={}));function u(de,me=!0){const Me=de&&de.files&&de.files.exclude,ce=me&&de&&de.search&&de.search.exclude;if(!Me&&!ce)return;if(!Me||!ce)return Me||ce;let Re=Object.create(null);return Re=R.$5n(Re,R.$2n(Me)),Re=R.$5n(Re,R.$2n(ce),!0),Re}function D(de,me){return de.excludePattern&&N.$ok(de.excludePattern,me)?!1:de.includePattern||de.usingSearchPaths?de.includePattern&&N.$ok(de.includePattern,me)?!0:de.usingSearchPaths?!!de.folderQueries&&de.folderQueries.some(Me=>{const ce=Me.folder.fsPath;if(O.$ug(me,ce)){const Re=g.$mc(ce,me);return!Me.includePattern||!!N.$ok(Me.includePattern,Re)}else return!1}):!1:!0}var f;(function(de){de[de.unknownEncoding=1]="unknownEncoding",de[de.regexParseError=2]="regexParseError",de[de.globParseError=3]="globParseError",de[de.invalidLiteral=4]="invalidLiteral",de[de.rgProcessError=5]="rgProcessError",de[de.other=6]="other",de[de.canceled=7]="canceled"})(f||(e.SearchErrorCode=f={}));class k extends Error{constructor(me,Me){super(me),this.code=Me}}e.$kL=k;function b(de){const me=de.message;if((0,E.$4)(de))return new k(me,f.canceled);try{const Me=JSON.parse(me);return new k(Me.message,Me.code)}catch{return new k(me,f.other)}}function P(de){const me={message:de.message,code:de.code};return new Error(JSON.stringify(me))}function I(de){return de.type==="error"?!0:de.type==="success"}function W(de){return de.type==="success"}function V(de){return!!de.path}function q(de,me,Me=!0){const ce=de.searchPath?de.searchPath:de.relativePath;return Me?(0,M.$Xf)(ce,me):N.$ok(me,ce)}class A{constructor(me){this.path=me,this.results=[]}addMatch(me){this.results.push(me)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$rL=A;function j(de,me){const Me={...de||{},...me||{}};return Object.keys(Me).filter(ce=>{const Re=Me[ce];return typeof Re=="boolean"&&Re})}class K{constructor(me,Me){this.c=null,this.a={...me.excludePattern||{},...Me.excludePattern||{}},this.b=N.$pk(this.a);let ce=me.includePattern;Me.includePattern&&(ce?ce={...ce,...Me.includePattern}:ce=Me.includePattern),ce&&(this.c=N.$pk(ce))}matchesExcludesSync(me,Me,ce){return!!(this.b&&this.b(me,Me,ce))}includedInQuerySync(me,Me,ce){return!(this.b&&this.b(me,Me,ce)||this.c&&!this.c(me,Me,ce))}includedInQuery(me,Me,ce){const Re=this.b(me,Me,ce),ie=()=>this.c?!!this.c(me,Me,ce):!0;return(0,y.$hh)(Re)?Re.then(L=>L?!1:ie()):ie()}hasSiblingExcludeClauses(){return re(this.a)}}e.$tL=K;function re(de){for(const me in de)if(typeof de[me]!="boolean")return!0;return!1}function ae(de){if(!de)return;let me;return Me=>(me||(me=(de()||Promise.resolve([])).then(ce=>ce?Ie(ce):{})),me.then(ce=>!!ce[Me]))}function we(de){if(!de)return;let me;return Me=>{if(!me){const ce=de();me=ce?Ie(ce):{}}return!!me[Me]}}function Ie(de){const me={};for(const Me of de)me[Me]=!0;return me}}),define(Ce[37],Ae([1,0,18,11,24,5,6,52,12,126,23,15,2,174,3,13,194,49,45,27,16,8,7,60,46,4,53]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$,a,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dlc=e.$clc=void 0;function C(W,V,q){return new T.$Xg(A=>k(A,q)).isEqual(W,V)}function u(W,V,q){return C(W.uri,V.uri,q)?0:(0,y.$qf)(W.uri.toString(),V.uri.toString())}function D(W,V,q){return W.index!==V.index?W.index<V.index?-1:1:C(W.uri,V.uri,q)?(0,y.$qf)(W.name,V.name):(0,y.$qf)(W.uri.toString(),V.uri.toString())}function f(W,V,q,A){const j=W.slice(0).sort((re,ae)=>q(re,ae,A)),K=V.slice(0).sort((re,ae)=>q(re,ae,A));return(0,S.$Eb)(j,K,(re,ae)=>q(re,ae,A))}function k(W,V){const q=V.getCapabilities(W.scheme);return!(q&&q&1024)}class b extends r.$Oi{static toExtHostWorkspace(V,q,A,j){if(!V)return{workspace:null,added:[],removed:[]};const{id:K,name:re,folders:ae,configuration:we,transient:Ie,isUntitled:de}=V,me=[],Me=q;q?ae.forEach((L,x)=>{const ve=l.URI.revive(L.uri),Fe=b.o(A||q,ve,j);Fe?(Fe.name=L.name,Fe.index=L.index,me.push(Fe)):me.push({uri:ve,name:L.name,index:x})}):me.push(...ae.map(({uri:L,name:x,index:ve})=>({uri:l.URI.revive(L),name:x,index:ve}))),me.sort((L,x)=>L.index<x.index?-1:1);const ce=new b(K,re,me,!!Ie,we?l.URI.revive(we):null,!!de,L=>k(L,j)),{added:Re,removed:ie}=f(Me?Me.workspaceFolders:[],ce.workspaceFolders,u,j);return{workspace:ce,added:Re,removed:ie}}static o(V,q,A){for(let j=0;j<V.folders.length;j++){const K=V.workspaceFolders[j];if(C(K.uri,q,A))return K}}constructor(V,q,A,j,K,re,ae){super(V,A.map(we=>new r.$Pi(we)),j,K,ae),this.t=q,this.u=re,this.q=[],this.s=p.$Bi.forUris(ae),A.forEach(we=>{this.q.push(we),this.s.set(we.uri,we)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,q){return q&&this.s.get(V)&&(V=(0,T.$8g)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let P=class{constructor(V,q,A,j,K){this.c=new O.$ee,this.onDidChangeWorkspace=this.c.event,this.g=new O.$ee,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new O.$ge,this.C=new Map,this.h=j,this.s=A,this.t=K,this.j=new E.$Cm,this.k=new N.$uh,this.o=V.getProxy(v.$YM.MainThreadWorkspace),this.q=V.getProxy(v.$YM.MainThreadMessageService);const re=q.workspace;this.l=re?new b(re.id,re.name,[],!!re.transient,re.configuration?l.URI.revive(re.configuration):null,!!re.isUntitled,ae=>k(ae,A)):void 0}$initializeWorkspace(V,q){this.v=q,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?l.URI.from({scheme:g.Schemas.untitled,path:(0,T.$6g)((0,T.$8g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,q,A,...j){const K=[];if(Array.isArray(j)&&j.forEach(de=>{l.URI.isUri(de.uri)&&!K.some(me=>C(me.uri,de.uri,this.s))&&K.push({uri:de.uri,name:de.name||(0,T.$5g)(de.uri)})}),this.n||[q,A].some(de=>typeof de!="number"||de<0)||A===0&&K.length===0)return!1;const re=this.x?this.x.workspaceFolders:[];if(q+A>re.length)return!1;const ae=re.slice(0);ae.splice(q,A,...K.map(de=>({uri:de.uri,name:de.name||(0,T.$5g)(de.uri),index:void 0})));for(let de=0;de<ae.length;de++){const me=ae[de];if(ae.some((Me,ce)=>ce!==de&&C(me.uri,Me.uri,this.s)))return!1}ae.forEach((de,me)=>de.index=me);const{added:we,removed:Ie}=f(re,ae,D,this.s);if(we.length===0&&Ie.length===0)return!1;if(this.o){const de=V.displayName||V.name;this.o.$updateWorkspaceFolders(de,q,A,K).then(void 0,me=>{this.n=void 0;const Me={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(o.Severity.Error,(0,w.localize)(0,null,de,me.toString()),Me,[])})}return this.y(ae),!0}getWorkspaceFolder(V,q){if(this.x)return this.x.getWorkspaceFolder(V,q)}async getWorkspaceFolder2(V,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,q)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,q){let A,j="";if(typeof V=="string"?(A=l.URI.file(V),j=V):typeof V<"u"&&(A=V,j=V.fsPath),!A)return j;const K=this.getWorkspaceFolder(A,!0);if(!K)return j;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let re=(0,T.$$g)(K.uri,A);return q&&K.name&&(re=`${K.name}/${re}`),re}y(V){this.x&&(this.n=b.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:q,added:A,removed:j}=b.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:A,removed:j}))}findFiles(V,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let re="",ae=!0;return q===null?ae=!1:q!==void 0&&(typeof q=="string"?re=q:re=q.pattern),this.z(V,void 0,{exclude:re,maxResults:A,useDefaultExcludes:ae,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(V,q={},A,j=R.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${A.value}, entryPoint: findFiles2`),this.z(void 0,V,q,j)}async z(V,q,A,j=R.CancellationToken.None){if(j&&j.isCancellationRequested)return Promise.resolve([]);const K=typeof A.exclude=="string"?A.exclude:A.exclude?A.exclude.pattern:void 0,re={ignoreSymlinks:typeof A.followSymlinks=="boolean"?!A.followSymlinks:void 0,disregardIgnoreFiles:typeof A.useIgnoreFiles=="boolean"?!A.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof A.useGlobalIgnoreFiles=="boolean"?!A.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof A.useParentIgnoreFiles=="boolean"?!A.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof A.useDefaultExcludes=="boolean"?!A.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof A.useDefaultSearchExcludes=="boolean"?!A.useDefaultSearchExcludes:!1,maxResults:A.maxResults,excludePattern:K,shouldGlobSearch:typeof A.fuzzy=="boolean"?!A.fuzzy:!0,_reason:"startFileSearch"};let ae;if(V){const{includePattern:we,folder:Ie}=I(h.GlobPattern.from(V));ae=Ie,re.includePattern=we}else{const{includePattern:we,folder:Ie}=I(h.GlobPattern.from(q));ae=Ie,re.filePattern=we}return this.o.$startFileSearch(ae??null,re,j).then(we=>Array.isArray(we)?we.map(Ie=>l.URI.revive(Ie)):[])}async findTextInFiles(V,q,A,j,K=R.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const re=this.j.getNext(),ae=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:we,folder:Ie}=I(h.GlobPattern.from(q.include)),de=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,me={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:ae,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:we,excludePattern:de},Me=!1;if(this.u[re]=ce=>{if(Me)return;const Re=l.URI.revive(ce.resource);ce.results.forEach(ie=>{const L=(0,d.$5h)(ie);(0,a.$bL)(L)?A({uri:Re,preview:{text:L.preview.text,matches:(0,S.$2b)(L.preview.matches,x=>new i.$3M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,S.$2b)(L.ranges,x=>new i.$3M(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):A({uri:Re,text:L.text,lineNumber:L.lineNumber})})},K.isCancellationRequested)return{};try{const ce=await this.o.$startTextSearch(V,Ie??null,me,re,K);return delete this.u[re],ce||{}}catch(ce){throw delete this.u[re],ce}}$handleTextSearchResult(V,q){this.u[q]?.(V)}async save(V){const q=await this.o.$save(V,{saveAs:!1});return l.URI.revive(q)}async saveAs(V){const q=await this.o.$save(V,{saveAs:!0});return l.URI.revive(q)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,q){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,q);const A=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerEditSessionIdentityProvider(j,A),(0,M.$Tc)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(V,q){this.h.info("Getting edit session identifier for workspaceFolder",V);const A=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!A){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",A);const j=this.w.get(A.uri.scheme);if(this.h.info(`Provider for scheme ${A.uri.scheme} is defined: `,!!j),!j)return;const K=await j.provideEditSessionIdentity(A,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(V,q,A,j){this.h.info("Getting edit session identifier for workspaceFolder",V);const K=await this.resolveWorkspaceFolder(l.URI.revive(V));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const re=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!re),!re)return;const ae=await re.provideEditSessionIdentityMatch?.(q,A,j);if(this.h.info("Provider returned edit session identifier match result: ",ae),!!ae)return ae}getOnWillCreateEditSessionIdentityEvent(V){return(q,A,j)=>{const K=function(ae){q.call(A,ae)};return K.extension=V,this.B.event(K,void 0,j)}}async $onWillCreateEditSessionIdentity(V,q,A){const j=await this.resolveWorkspaceFolder(l.URI.revive(V));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:j},q,async(K,re)=>{const ae=Date.now();await Promise.resolve(K),Date.now()-ae>A&&this.h.warn("SLOW edit session create-participant",re.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(V,q){if(this.C.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.C.set(V,q);const A=this.t.transformOutgoingScheme(V),j=this.A++;return this.o.$registerCanonicalUriProvider(j,A),(0,M.$Tc)(()=>{this.C.delete(V),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(V,q,A){const j=this.C.get(V.scheme);if(!j)return;const K=await j.provideCanonicalUri?.(l.URI.revive(V),q,A);if(K)return K}async $provideCanonicalUri(V,q,A){return this.provideCanonicalUri(l.URI.revive(V),{targetScheme:q},A)}};e.$clc=P,e.$clc=P=Je([We(0,c.$lP),We(1,n.$BP),We(2,t.$Xkc),We(3,s.$2j),We(4,$.$alc)],P),e.$dlc=(0,m.$vi)("IExtHostWorkspace");function I(W){let V,q;return W&&(typeof W=="string"?V=W:(V=W.pattern,q=l.URI.revive(W.baseUri))),{includePattern:V,folder:q}}}),define(Ce[38],Ae([1,0,25,5,37,4,7,196,57,17,11,3,16,13,2]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$glc=e.$flc=e.$elc=void 0;function s($,a){if(a){const v=a.split(".");let d=$;for(let C=0;d&&C<v.length;C++)d=d[v[C]];return d}}function o($){return $ instanceof m.URI}function r($){return $&&$.uri instanceof m.URI&&$.languageId&&typeof $.languageId=="string"}function t($){return $&&!$.uri&&$.languageId&&typeof $.languageId=="string"}function n($){return $&&$.uri instanceof m.URI&&(!$.name||typeof $.name=="string")&&(!$.index||typeof $.index=="number")}function c($){if(o($))return{resource:$};if(r($))return{resource:$.uri,overrideIdentifier:$.languageId};if(t($))return{overrideIdentifier:$.languageId};if(n($))return{resource:$.uri};if($===null)return{resource:null}}let h=class{constructor(a,v,d){this.a=a.getProxy(O.$YM.MainThreadConfiguration),this.c=v,this.b=d,this.d=new T.$uh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,v){this.getConfigProvider().then(d=>d.$acceptConfigurationChanged(a,v))}};e.$elc=h,e.$elc=h=Je([We(0,l.$lP),We(1,R.$dlc),We(2,w.$2j)],h);class i{constructor(a,v,d,C){this.a=new N.$ee,this.b=a,this.f=C,this.c=v,this.e=p.$zo.parse(d,C),this.d=this.k(d.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,v){const d={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$zo.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(v,d))}getConfiguration(a,v,d){const C=c(v)||{},u=this.g(a?s(this.e.getValue(void 0,C,this.c.workspace),a):this.e.getValue(void 0,C,this.c.workspace));a&&this.h(a,C,d?.identifier);function D(k){if(k==null)return null;if(typeof k=="boolean")return k?2:5;switch(k){case M.ConfigurationTarget.Global:return 2;case M.ConfigurationTarget.Workspace:return 5;case M.ConfigurationTarget.WorkspaceFolder:return 6}}const f={has(k){return typeof s(u,k)<"u"},get:(k,b)=>{this.h(a?`${a}.${k}`:k,C,d?.identifier);let P=s(u,k);if(typeof P>"u")P=b;else{let I;const W=(V,q)=>{if((0,E.$0f)(V)){let A;const j=()=>{I=I||(0,S.$2n)(u),A=A||s(I,q)};return new Proxy(V,{get:(K,re)=>{if(typeof re=="string"&&re.toLowerCase()==="tojson")return j(),()=>A;if(I)return A=A||s(I,q),A[re];const ae=K[re];return typeof re=="string"?W(ae,`${q}.${re}`):ae},set:(K,re,ae)=>(j(),A&&(A[re]=ae),!0),deleteProperty:(K,re)=>(j(),A&&delete A[re],!0),defineProperty:(K,re,ae)=>(j(),A&&Object.defineProperty(A,re,ae),!0)})}return Array.isArray(V)?(0,S.$2n)(V):V};P=W(P,k)}return P},update:(k,b,P,I)=>{k=a?`${a}.${k}`:k;const W=D(P);return b!==void 0?this.b.$updateConfigurationOption(W,k,b,C,I):this.b.$removeConfigurationOption(W,k,C,I)},inspect:k=>{k=a?`${a}.${k}`:k;const b=this.e.inspect(k,C,this.c.workspace);if(b)return{key:k,defaultValue:(0,S.$2n)(b.policy?.value??b.default?.value),globalValue:(0,S.$2n)(b.user?.value??b.application?.value),workspaceValue:(0,S.$2n)(b.workspace?.value),workspaceFolderValue:(0,S.$2n)(b.workspaceFolder?.value),defaultLanguageValue:(0,S.$2n)(b.default?.override),globalLanguageValue:(0,S.$2n)(b.user?.override??b.application?.override),workspaceLanguageValue:(0,S.$2n)(b.workspace?.override),workspaceFolderLanguageValue:(0,S.$2n)(b.workspaceFolder?.override),languageIds:(0,S.$2n)(b.overrideIdentifiers)}}};return typeof u=="object"&&(0,S.$5n)(f,u,!1),Object.freeze(f)}g(a){const v=d=>(0,E.$0f)(d)?new Proxy(d,{get:(C,u)=>v(C[u]),set:(C,u,D)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(u)}' of object`)},deleteProperty:(C,u)=>{throw new Error(`TypeError: Cannot delete read only property '${String(u)}' of object`)},defineProperty:(C,u)=>{throw new Error(`TypeError: Cannot define property '${String(u)}' for a readonly object`)},setPrototypeOf:C=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):d;return v(a)}h(a,v,d){const C=g.$qo.test(a)?4:this.d.get(a),u=d?`[${d.value}] `:"";if(C===4){typeof v?.resource>"u"&&this.f.warn(`${u}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if(C===3){v?.resource&&this.f.warn(`${u}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,v){const d=new p.$Bo(a,v,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:(C,u)=>d.affectsConfiguration(C,c(u))})}k(a){return a.reduce((v,d)=>(v.set(d[0],d[1]),v),new Map)}}e.$flc=i,e.$glc=(0,y.$vi)("IExtHostConfiguration")}),define(Ce[119],Ae([1,0,2,11,5,4,7,37,67,38,24,51,16,27,3,12,21,13,78,230,14]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kmc=e.$Jmc=e.$Imc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var h;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(h||(h={}));var i;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(i||(i={}));var $;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})($||($={}));var a;(function(W){function V(j){if(j){const K=j;return K&&!!K.process}else return!1}W.is=V;function q(j){if(j==null)return;const K={process:j.process,args:j.args};return j.options&&(K.options=$.from(j.options)),K}W.from=q;function A(j){if(j!=null)return new M.$JN(j.process,j.args,j.options)}W.to=A})(a||(a={}));var v;(function(W){function V(A){if(A!=null)return A}W.from=V;function q(A){if(A!=null)return A}W.to=q})(v||(v={}));var d;(function(W){function V(j){if(j){const K=j;return K&&(!!K.commandLine||!!K.command)}else return!1}W.is=V;function q(j){if(j==null)return;const K={};return j.commandLine!==void 0?K.commandLine=j.commandLine:(K.command=j.command,K.args=j.args),j.options&&(K.options=v.from(j.options)),K}W.from=q;function A(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new M.$KN(j.commandLine,j.options):new M.$KN(j.command,j.args?j.args:[],j.options)}W.to=A})(d||(d={}));var C;(function(W){function V(j){if(j){const K=j;return K&&K.customExecution==="customExecution"}else return!1}W.is=V;function q(j){return{customExecution:"customExecution"}}W.from=q;function A(j,K){return K.get(j)}W.to=A})(C||(e.CustomExecutionDTO=C={}));var u;(function(W){function V(q,A){let j;return q.scope!==void 0&&typeof q.scope!="number"?j=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===M.TaskScope.Workspace&&A&&A.workspaceFile?j=A.workspaceFile:j=n.$5H),{id:q._id,workspaceFolder:j}}W.from=V})(u||(e.TaskHandleDTO=u={}));var D;(function(W){function V(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}W.from=V})(D||(D={}));var f;(function(W){function V(j,K){if(j==null)return[];const re=[];for(const ae of j){const we=q(ae,K);we&&re.push(we)}return re}W.fromMany=V;function q(j,K){if(j==null)return;let re;j.execution instanceof M.$JN?re=a.from(j.execution):j.execution instanceof M.$KN?re=d.from(j.execution):j.execution&&j.execution instanceof M.$LN&&(re=C.from(j.execution));const ae=h.from(j.definition);let we;return j.scope?typeof j.scope=="number"?we=j.scope:we=j.scope.uri:we=M.TaskScope.Workspace,!ae||!we?void 0:{_id:j._id,definition:ae,name:j.name,source:{extensionId:K.identifier.value,label:j.source,scope:we},execution:re,isBackground:j.isBackground,group:D.from(j.group),presentationOptions:i.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}W.from=q;async function A(j,K,re){if(j==null)return;let ae;a.is(j.execution)?ae=a.to(j.execution):d.is(j.execution)?ae=d.to(j.execution):C.is(j.execution)&&(ae=C.to(j._id,re));const we=h.to(j.definition);let Ie;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Ie=j.source.scope:Ie=await K.resolveWorkspaceFolder(S.URI.revive(j.source.scope)):Ie=M.TaskScope.Workspace),!we||!Ie)return;const de=new M.$MN(we,Ie,j.name,j.source.label,ae,j.problemMatchers);return j.isBackground!==void 0&&(de.isBackground=j.isBackground),j.group!==void 0&&(de.group=M.$IN.from(j.group._id),de.group&&j.group.isDefault&&(de.group=new M.$IN(de.group.id,de.group.label),j.group.isDefault===!0&&(de.group.isDefault=j.group.isDefault))),j.presentationOptions&&(de.presentationOptions=i.to(j.presentationOptions)),j._id&&(de._id=j._id),j.detail&&(de.detail=j.detail),de}W.to=A})(f||(e.TaskDTO=f={}));var k;(function(W){function V(A){return A}W.from=V;function q(A){if(A)return Object.assign(Object.create(null),A)}W.to=q})(k||(k={}));class b{#e;constructor(V,q,A){this._id=q,this.a=A,this.#e=V}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(V){}fireDidEndProcess(V){}}let P=class{constructor(V,q,A,j,K,re,ae,we){this.q=new R.$ee,this.r=new R.$ee,this.s=new R.$ee,this.u=new R.$ee,this.a=V.getProxy(O.$YM.MainThreadTask),this.b=A,this.c=j,this.d=K,this.e=re,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ae,this.g=we,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(V,q,A){if(!A)return new M.$1M(()=>{});const j=this.x();return this.j.set(j,{type:q,provider:A,extension:V}),this.a.$registerTaskProvider(j,q),new M.$1M(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(V,q){this.a.$registerTaskSystem(V,q)}fetchTasks(V){return this.a.$fetchTasks(k.from(V)).then(async q=>{const A=[];for(const j of q){const K=await f.to(j,this.b,this.m);K&&A.push(K)}return A})}get taskExecutions(){const V=[];return this.k.forEach(q=>V.push(q)),V}terminateTask(V){if(!(V instanceof b))throw new Error("No valid task execution provided");return this.a.$terminateTask(V._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(V,q,A){const j=this.m.get(V.id);j&&(this.o.set(V.id,j),this.e.attachPtyToTerminal(q,await j.callback(A))),this.p=V.id,this.q.fire({execution:await this.z(V)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(V){if(!this.l.has(V.id))return;const q=await this.z(V);this.l.delete(V.id),this.k.delete(V.id),this.B(V),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(V){const q=await this.z(V.id);this.s.fire({execution:q,processId:V.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(V){const q=await this.z(V.id);this.u.fire({execution:q,exitCode:V.exitCode})}$provideTasks(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));const j=[],K=(0,N.$nh)(()=>A.provider.provideTasks(T.CancellationToken.None)).then(re=>this.v(q,j,A,re));return new Promise(re=>{K.then(ae=>{Promise.all(j).then(()=>{re(ae)})})})}async $resolveTask(V,q){const A=this.j.get(V);if(!A)return Promise.reject(new Error("no handler found"));if(q.definition.type!==A.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${A.type}].`);const j=await f.to(q,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const K=await A.provider.resolveTask(j,T.CancellationToken.None);if(!K)return;this.A(K,A);const re=f.from(K,A.extension);if(!re)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return C.is(re.execution)&&await this.y(re,K,!0),await this.w(re)}x(){return this.h++}async y(V,q,A){const j=await this.a.$createTaskId(V);!A&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,q.execution)),this.m.set(j,q.execution)}async z(V,q){if(typeof V=="string"){const K=this.l.get(V);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const A=this.l.get(V.id);if(A)return A;let j;return q?j=Promise.resolve(new b(this,V.id,q)):j=f.to(V.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new b(this,V.id,K)}),this.l.set(V.id,j),j.then(K=>(this.k.set(V.id,K),K))}A(V,q){V._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(V){this.o.get(V.id)&&this.o.delete(V.id),this.n.has(V.id)&&this.p!==V.id&&(this.m.delete(V.id),this.n.delete(V.id));const A=this.n.values();let j=A.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=A.next()}};e.$Imc=P,e.$Imc=P=Je([We(0,l.$lP),We(1,w.$BP),We(2,p.$dlc),We(3,g.$wP),We(4,E.$glc),We(5,y.$Elc),We(6,r.$2j),We(7,t.$Tkc)],P);let I=class extends P{constructor(V,q,A,j,K,re,ae,we){super(V,q,A,j,K,re,ae,we),this.registerTaskSystem(s.Schemas.vscodeRemote,{scheme:s.Schemas.vscodeRemote,authority:"",platform:o.$h(0)})}async executeTask(V,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const A=f.from(q,V);if(A===void 0)throw new Error("Task is not valid");if(C.is(A.execution))await this.y(A,q,!1);else throw new c.$_;const j=await this.z(await this.a.$getTaskExecution(A),q);return this.a.$executeTask(A).catch(K=>{throw new Error(K)}),j}v(V,q,A,j){const K=[];if(j)for(const re of j){if(this.A(re,A),!re.definition||!V[re.definition.type]){const we=re.source?re.source:"No task source";this.f.warn(`The task [${we}, ${re.name}] uses an undefined task type. The task will be ignored in the future.`)}const ae=f.from(re,A.extension);ae&&C.is(ae.execution)?(K.push(ae),q.push(this.y(ae,re,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:A.extension}}async w(V){if(C.is(V.execution))return V;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(V,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(V,q,A){}};e.$Jmc=I,e.$Jmc=I=Je([We(0,l.$lP),We(1,w.$BP),We(2,p.$dlc),We(3,g.$wP),We(4,E.$glc),We(5,y.$Elc),We(6,r.$2j),We(7,t.$Tkc)],I),e.$Kmc=(0,m.$vi)("IExtHostTask")}),define(Ce[288],Ae([1,0,46,29]),function(ge,e,S,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CL=void 0,e.$BL=R,e.$DL=O;function R(M){return"cellResults"in M}e.$CL="rawCell#";function O(M,p){let g=-1;const E=[];let T=[];return M.forEach(l=>{l.range.startLineNumber!==g&&T.length>0&&(E.push([...T]),T=[]),T.push(l),g=l.range.endLineNumber}),T.length>0&&E.push([...T]),E.map(l=>{const w=[],m=l[0].range.startLineNumber,s=l[l.length-1].range.endLineNumber;for(let o=m;o<=s;o++)w.push(p.getLineContent(o));return new S.$fL(w.join(`
`)+`
`,l.map(o=>new N.$tt(o.range.startLineNumber-1,o.range.startColumn-1,o.range.endLineNumber-1,o.range.endColumn-1)))})}}),define(Ce[289],Ae([1,0,168,22,5,6,28,15,17,2,44,74,4,32,8,7,34,264,112,25,12,220,288,286]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(d=>d.apiEditor)}constructor(d,C,u,D,f,k){this.q=u,this.r=D,this.s=f,this.t=k,this.f=new Map,this.g=new M.$Bc,this.h=new Map,this.j=new R.$ee,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.$ee,this.onDidOpenNotebookDocument=this.m.event,this.n=new R.$ee,this.onDidCloseNotebookDocument=this.n.event,this.o=new R.$ee,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new y.$Rkc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=d.getProxy(l.$YM.MainThreadNotebook),this.c=d.getProxy(l.$YM.MainThreadNotebookDocuments),this.d=d.getProxy(l.$YM.MainThreadNotebookEditors),this.i=C.converter,C.registerArgumentProcessor({processArgument:b=>{if(b&&b.$mid===13){const P=b.notebookEditor?.notebookUri,I=b.cell.handle,V=this.g.get(P)?.getCell(I);if(V)return V.apiCell}if(b&&b.$mid===14){const P=b.uri,I=this.g.get(P);if(I)return I.apiNotebook}return b}}),a.B(C)}getEditorById(d){const C=this.h.get(d);if(!C)throw new Error(`unknown text editor: ${d}. known editors: ${[...this.h.keys()]} `);return C}getIdByEditor(d){for(const[C,u]of this.h)if(u.apiEditor===d)return C}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(d,C){const u=this.g.get(d);if(!u&&!C)throw new Error(`NO notebook document for '${d}'`);return u}static u(d,C){if(!C)return;const u=C.filenamePattern.map(D=>m.NotebookExclusiveDocumentPattern.from(D)).filter(D=>D!==void 0);if(C.filenamePattern&&!u){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:d.identifier,providerDisplayName:d.displayName||d.name,displayName:C.displayName,filenamePattern:u,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(d,C,u){const D=a.a++,f=typeof u.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(D,u),this.b.$registerNotebookCellStatusBarItemProvider(D,f,C);let k;return f!==void 0&&(k=u.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(f))),new s.$1M(()=>{this.f.delete(D),this.b.$unregisterNotebookCellStatusBarItemProvider(D,f),k?.dispose()})}async createNotebookDocument(d){const C=await this.c.$tryCreateNotebook({viewType:d.viewType,content:d.content&&m.NotebookData.from(d.content)});return E.URI.revive(C)}async openNotebookDocument(d){const C=this.g.get(d);if(C)return C.apiNotebook;const u=await this.c.$tryOpenNotebook(d),D=this.g.get(E.URI.revive(u));return(0,g.$gg)(D?.apiNotebook)}async showNotebookDocument(d,C){E.URI.isUri(d)&&(d=await this.openNotebookDocument(d));let u;typeof C=="object"?u={position:m.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(m.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:u={preserveFocus:!1};const D=await this.d.$tryShowNotebookDocument(d.uri,d.notebookType,u),f=D&&this.h.get(D)?.apiEditor;if(f)return f;throw D?new Error(`Could NOT open editor for "${d.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${d.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(d,C,u,D){const f=this.f.get(d),k=E.URI.revive(C),b=this.g.get(k);if(!b||!f)return;const P=b.getCellFromIndex(u);if(!P)return;const I=await f.provideCellStatusBarItems(P.apiCell,D);if(!I)return;const W=new O.$Uc,V=this.p.add([W]),A=(Array.isArray(I)?I:[I]).map(j=>m.NotebookStatusBarItem.from(j,this.i,W));return{cacheId:V,items:A}}$releaseNotebookCellStatusBarItems(d){this.p.delete(d)}registerNotebookSerializer(d,C,u,D,f){if((0,p.$7e)(C))throw new Error("viewType cannot be empty or just whitespace");const k=this.w++;return this.x.set(k,{viewType:C,serializer:u,options:D}),this.b.$registerNotebookSerializer(k,{id:d.identifier,location:d.extensionLocation},C,m.NotebookDocumentContentOptions.from(D),a.u(d,f)),(0,O.$Tc)(()=>{this.b.$unregisterNotebookSerializer(k)})}async $dataToNotebook(d,C,u){const D=this.x.get(d);if(!D)throw new Error("NO serializer found");const f=await D.serializer.deserializeNotebook(C.buffer,u);return new o.$uw(m.NotebookData.from(f))}async $notebookToData(d,C,u){const D=this.x.get(d);if(!D)throw new Error("NO serializer found");const f=await D.serializer.serializeNotebook(m.NotebookData.to(C.value),u);return N.$Fe.wrap(f)}async $saveNotebook(d,C,u,D,f){const k=E.URI.revive(C),b=this.x.get(d);if(!b)throw new Error("NO serializer found");const P=this.g.get(k);if(!P)throw new Error("Document NOT found");if(P.versionId!==u)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(k.scheme))throw new T.$kl((0,S.localize)(0,null,this.z(k)),6);await this.y(k,D);const I={metadata:(0,n.$0n)(P.apiNotebook.metadata,j=>!(b.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of P.apiNotebook.getCells()){const K=new s.$qO(j.kind,j.document.getText(),j.document.languageId,j.mime,b.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);K.metadata=(0,n.$0n)(j.metadata,re=>!(b.options?.transientCellMetadata??{})[re]),I.cells.push(K)}const W=await b.serializer.serializeNotebook(I,f);await this.s.value.writeFile(k,W);const V=this.s.getFileSystemProviderExtUri(k.scheme),q=await this.s.value.stat(k);return{name:V.basename(k),isFile:(q.type&T.FileType.File)!==0,isDirectory:(q.type&T.FileType.Directory)!==0,isSymbolicLink:(q.type&T.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&T.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(k.scheme),locked:!!((q.permissions??0)&T.FilePermission.Locked),etag:T.$vl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(d,C,u,D,f){const k=this.x.get(d)?.serializer;if(!k)return{limitHit:!1,results:[]};const b=new M.$Cc;await(async(q,A,j)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(re=>{const ae={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:re};return this.t.doInternalFileSearchWithCustomCallback(ae,A,we=>{we.forEach(Ie=>{b.has(Ie)||D.some(me=>K.isFromSettings&&!me.isFromSettings?!1:me.filenamePatterns.some(Me=>(0,$.$5gb)(Me,Ie)))||b.add(Ie)})}).catch(we=>{if(we.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw we})}))))})(u,f,C);const I=new M.$Bc;let W=!1;const V=Array.from(b).map(async q=>{const A=[];try{if(f.isCancellationRequested)return;if(C.maxResults&&[...I.values()].reduce((ae,we)=>ae+we.cellResults.length,0)>C.maxResults){W=!0;return}const j=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(we=>j.push({input:we.document.getText(),outputs:we.outputs.flatMap(Ie=>Ie.items.map(de=>de.data.toString()))}));else{const ae=await this.s.value.readFile(q),we=N.$Fe.fromString(ae.toString()),Ie=await k.deserializeNotebook(we.buffer,f);if(f.isCancellationRequested)return;m.NotebookData.from(Ie).cells.forEach(me=>j.push({input:me.source,outputs:me.outputs.flatMap(Me=>Me.items.map(ce=>ce.valueBytes.toString()))}))}if(f.isCancellationRequested)return;j.forEach((ae,we)=>{const Ie=C.contentPattern.pattern,de=new h.$1Wb(ae.input,void 0,ae.outputs),me=de.findInInputs(Ie),Me=de.findInOutputs(Ie),ce=Me.flatMap(Re=>(0,i.$DL)(Re.matches,Re.textBuffer)).map((Re,ie)=>(Re.webviewIndex=ie,Re));if(me.length>0||Me.length>0){const Re={index:we,contentResults:(0,i.$DL)(me,de.inputTextBuffer),webviewResults:ce};A.push(Re)}});const re={resource:q,cellResults:A};I.set(q,re);return}catch{return}});return await Promise.all(V),{limitHit:W,results:[...I.values()]}}async y(d,C){const u=await this.s.value.stat(d);if(typeof C?.mtime=="number"&&typeof C.etag=="string"&&C.etag!==T.$ul&&typeof u.mtime=="number"&&typeof u.size=="number"&&C.mtime<u.mtime&&C.etag!==T.$vl({mtime:C.mtime,size:u.size}))throw new T.$kl((0,S.localize)(1,null),3,C)}z(d){return d.scheme===c.Schemas.file?d.fsPath:d.toString()}A(d,C,u){if(this.h.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const D=new t.$cmc(C,this.d,d,u.visibleRanges.map(m.NotebookRange.to),u.selections.map(m.NotebookRange.to),typeof u.viewColumn=="number"?m.ViewColumn.to(u.viewColumn):void 0);this.h.set(C,D)}$acceptDocumentAndEditorsDelta(d){if(d.value.removedDocuments)for(const u of d.value.removedDocuments){const D=E.URI.revive(u),f=this.g.get(D);f&&(f.dispose(),this.g.delete(D),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:f.apiNotebook.getCells().map(k=>k.document.uri)}),this.n.fire(f.apiNotebook));for(const k of this.h.values())k.notebookData.uri.toString()===D.toString()&&this.h.delete(k.id)}if(d.value.addedDocuments){const u=[];for(const D of d.value.addedDocuments){const f=E.URI.revive(D.uri);if(this.g.has(f))throw new Error(`adding EXISTING notebook ${f} `);const k=new r.$bmc(this.c,this.q,this.r,f,D);u.push(...D.cells.map(b=>r.$amc.asModelAddData(b))),this.g.get(f)?.dispose(),this.g.set(f,k),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:u}),this.m.fire(k.apiNotebook)}}if(d.value.addedEditors)for(const u of d.value.addedEditors){if(this.h.has(u.id))return;const D=E.URI.revive(u.documentUri),f=this.g.get(D);f&&this.A(f,u.id,u)}const C=[];if(d.value.removedEditors)for(const u of d.value.removedEditors){const D=this.h.get(u);D&&(this.h.delete(u),this.k?.id===D.id&&(this.k=void 0),C.push(D))}if(d.value.visibleEditors){this.l=d.value.visibleEditors.map(D=>this.h.get(D)).filter(D=>!!D);const u=new Set;this.l.forEach(D=>u.add(D.id));for(const D of this.h.values()){const f=u.has(D.id);D._acceptVisibility(f)}this.l=[...this.h.values()].map(D=>D).filter(D=>D.visible),this.o.fire(this.visibleNotebookEditors)}d.value.newActiveEditor===null?this.k=void 0:d.value.newActiveEditor&&(this.h.get(d.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${d.value.newActiveEditor}`),this.k=this.h.get(d.value.newActiveEditor)),d.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(d){const C=w.$JP.String.with("notebookType","A notebook type"),u=new w.$LP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new w.$JP("data","Bytes to convert to data",f=>f instanceof Uint8Array,f=>N.$Fe.wrap(f))],new w.$KP("Notebook Data",f=>m.NotebookData.to(f.value))),D=new w.$LP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new w.$JP("NotebookData","Notebook data to convert to bytes",f=>!0,f=>new o.$uw(m.NotebookData.from(f)))],new w.$KP("Bytes",f=>f.buffer));d.registerApiCommand(u),d.registerApiCommand(D)}}e.$lmc=a}),define(Ce[290],Ae([1,0,19,24,43,36,23,65,46]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class E{constructor(l,w,m){this.k=l,this.l=w,this.o=m,this.e=!1,this.f=0,this.g=!1,this.a=l.filePattern,this.b=l.includePattern&&O.$pk(l.includePattern),this.c=l.maxResults||void 0,this.d=l.exists,this.h=new Set,this.j=l.excludePattern&&O.$pk(l.excludePattern)}cancel(){this.g=!0,this.h.forEach(l=>l.cancel()),this.h=new Set}search(l){const w=this.k.folderQueries||[];return new Promise((m,s)=>{const o=r=>{this.f++,l(r)};if(this.g)return m({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(r=>{const t=r.toString(),n=S.$oc(t);this.j&&this.j(t,n)||this.v(o,{base:r,basename:n})}),Promise.all(w.map(r=>this.p(r,o))).then(r=>{m({limitHit:this.e,stats:r[0]||void 0})},r=>{s(new Error((0,R.$gj)(r)))})})}async p(l,w){const m=new N.$pe,s=this.q(l),o=this.r(),r=new g.$tL(this.k,l),t=!r.hasSiblingExcludeClauses();let n;try{this.h.add(m),n=p.$ae.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},s,m.token),h=n.elapsed(),i=p.$ae.create();return this.g&&!this.e||(c&&c.forEach($=>{const a=S.$hc.relative(l.folder.path,$.path);if(t){const v=S.$oc($.path);this.v(w,{base:l.folder,relativePath:a,basename:v});return}this.s(o,l.folder,a,w)}),this.g&&!this.e)?null:(this.u(o,r,w),{providerTime:h,postProcessTime:i.elapsed()})}finally{m.dispose(),this.h.delete(m)}}q(l){const w=(0,g.$sL)(this.k.includePattern,l.includePattern),m=(0,g.$sL)(this.k.excludePattern,l.excludePattern);return{folder:l.folder,excludes:m,includes:w,useIgnoreFiles:!l.disregardIgnoreFiles,useGlobalIgnoreFiles:!l.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!l.disregardParentIgnoreFiles,followSymlinks:!l.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const l={rootEntries:[],pathToEntries:Object.create(null)};return l.pathToEntries["."]=l.rootEntries,l}s({pathToEntries:l},w,m,s){if(m===this.a){const r=S.$oc(this.a);this.v(s,{base:w,relativePath:this.a,basename:r})}function o(r){const t=S.$oc(r),n=S.$nc(r);let c=l[n];c||(c=l[n]=[],o(n)),c.push({base:w,relativePath:r,basename:t})}o(m)}u({rootEntries:l,pathToEntries:w},m,s){const o=this,r=this.a;function t(n){const c=(0,g.$vL)(()=>n.map(h=>h.basename));for(let h=0,i=n.length;h<i;h++){const $=n[h],{relativePath:a,basename:v}=$;if(m.matchesExcludesSync(a,v,r!==v?c:void 0))continue;const d=w[a];if(d)t(d);else{if(a===r)continue;o.v(s,$)}if(o.e)break}}t(l)}v(l,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||l(w))}}class T{constructor(){this.b=new Map}static{this.a=512}fileSearch(l,w,m,s){const o=this.c(l.cacheKey),r=new E(l,w,o&&o.token);let t=0;const n=c=>{t+=c.length,m(c.map(h=>this.d(h)))};return this.e(r,T.a,n,s).then(c=>({limitHit:c.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:t,detailStats:c.stats}}))}clearCache(l){this.c(l)?.cancel()}c(l){if(l)return this.b.has(l)||this.b.set(l,new N.$pe),this.b.get(l)}d(l){return l.relativePath?{resource:M.$9g(l.base,l.relativePath)}:{resource:l.base}}e(l,w,m,s){const o=s.onCancellationRequested(()=>{l.cancel()}),r=n=>{n&&(t.push(n),w>0&&t.length>=w&&(m(t),t=[]))};let t=[];return l.search(r).then(n=>(t.length&&m(t),o.dispose(),n),n=>(t.length&&m(t),o.dispose(),Promise.reject(n)))}}e.$dmc=T}),define(Ce[291],Ae([1,0,18,259,36,96,28,12,19,23,15,17,2,95,186,48,13,49,107,287,46]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CM=void 0,e.$DM=D;let h=class{constructor(k,b,P,I,W){this.a=k,this.b=b,this.c=P,this.d=I,this.e=W}text(k,b,P={}){k=this.f(k,P);const I=this.a.getValue(),W=b&&b.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(b?.map(r.$Qi),P),type:2,contentPattern:k,previewOptions:P.previewOptions,maxFileSize:P.maxFileSize,usePCRE2:I.search.usePCRE2||W||!1,beforeContext:P.beforeContext,afterContext:P.afterContext,userDisabledExcludesAndIgnoreFiles:P.disregardExcludeSettings&&P.disregardIgnoreFiles}}f(k,b){const P=this.a.getValue();k.isRegExp&&(k.pattern=k.pattern.replace(/\r?\n/g,"\\n"));const I={...k,wordSeparators:P.editor.wordSeparators};return this.j(k,b)&&(I.isCaseSensitive=!0),this.k(k)&&(I.isMultiline=!0),b.notebookSearchConfig?.includeMarkupInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownInput=b.notebookSearchConfig.includeMarkupInput),b.notebookSearchConfig?.includeMarkupPreview&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookMarkdownPreview=b.notebookSearchConfig.includeMarkupPreview),b.notebookSearchConfig?.includeCodeInput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellInput=b.notebookSearchConfig.includeCodeInput),b.notebookSearchConfig?.includeOutput&&(I.notebookInfo||(I.notebookInfo={}),I.notebookInfo.isInNotebookCellOutput=b.notebookSearchConfig.includeOutput),I}file(k,b={}){return{...this.h(k,b),type:1,filePattern:b.filePattern?b.filePattern.trim():b.filePattern,exists:b.exists,sortByScore:b.sortByScore,cacheKey:b.cacheKey,shouldGlobMatchFilePattern:b.shouldGlobSearch}}g(k,b){return k?(k=Array.isArray(k)?k.map(d):d(k),b?this.parseSearchPaths(k):{pattern:$(...Array.isArray(k)?k:[k])}):{}}h(k=[],b={}){const P=this.g(b.includePattern,b.expandPatterns),I=this.g(b.excludePattern,b.expandPatterns),W=k.length>1,V=(P.searchPaths&&P.searchPaths.length?P.searchPaths.map(j=>this.q(j,b,I)):k.map(j=>this.r(j,b,I,W))).filter(j=>!!j),q={_reason:b._reason,folderQueries:V,usingSearchPaths:!!(P.searchPaths&&P.searchPaths.length),extraFileResources:b.extraFileResources,excludePattern:I.pattern,includePattern:P.pattern,onlyOpenEditors:b.onlyOpenEditors,maxResults:b.maxResults};if(b.onlyOpenEditors){const j=S.$Hb(S.$Rb(this.c.groups.map(ae=>ae.editors.map(we=>we.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const K=j.filter(ae=>(0,c.$jL)(q,ae.fsPath)),re=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(re)),{...q,...re}}const A=b.extraFileResources&&b.extraFileResources.filter(j=>(0,c.$jL)(q,j.fsPath));return q.extraFileResources=A&&A.length?A:void 0,q}i(k){const b=[],P=new M.$Bc,I={};let W=!1;return k.forEach(V=>{if(V.scheme===p.Schemas.walkThrough)return;if((0,E.$ah)(V)){const A=this.b.getWorkspaceFolder(V)?.uri??V.with({path:g.$nc(V.fsPath)});let j=P.get(A);j||(W=!0,j={folder:A,includePattern:{}},b.push(j),P.set(A,j));const K=g.$mc(A.fsPath,V.fsPath);(0,y.$gg)(j.includePattern)[K.replace(/\\/g,"/")]=!0}else V.fsPath&&(W=!0,I[V.fsPath]=!0)}),{folderQueries:b,includePattern:I,usingSearchPaths:!0,excludePattern:W?void 0:{"**/*":!0}}}j(k,b){if(b.isSmartCase){if(k.isRegExp){if(T.$Yf(k.pattern,!0))return!0}else if(T.$Yf(k.pattern))return!0}return!!k.isCaseSensitive}k(k){return k.isMultiline||k.isRegExp&&(0,w.$JC)(k.pattern)||k.pattern.indexOf(`
`)>=0?!0:!!k.isMultiline}parseSearchPaths(k){const b=re=>g.$jc(re)||/^\.\.?([\/\\]|$)/.test(re),I=(Array.isArray(k)?k:a(k)).map(re=>{const ae=this.e.resolvedUserHome;return ae?(0,O.$zw)(re,ae.scheme===p.Schemas.file?ae.fsPath:ae.path):re}),W=N.$K(I,re=>b(re)?"searchPaths":"exprSegments"),V=(W.exprSegments||[]).map(re=>T.$ff(re,"/")).map(re=>T.$ff(re,"\\")).map(re=>(re[0]==="."&&(re="*"+re),v(re))),q={},A=this.m(W.searchPaths||[]);A&&A.length&&(q.searchPaths=A);const j=S.$Rb(V),K=$(...j);return K&&(q.pattern=K),q}l(k,b){return b.disregardExcludeSettings?void 0:(0,c.$iL)(k,!b.disregardSearchExcludeSettings)}m(k){if(!k||!k.length)return[];const b=k.flatMap(I=>{let{pathPortion:W,globPortion:V}=i(I);return V&&(V=C(V)),this.n(W).flatMap(A=>this.o(A,V))}),P=new Map;return b.forEach(I=>{const W=I.searchPath.toString(),V=P.get(W);V?I.pattern&&(V.pattern=V.pattern||{},V.pattern[I.pattern]=!0):P.set(W,{searchPath:I.searchPath,pattern:I.pattern?$(I.pattern):void 0})}),Array.from(P.values())}n(k){if(g.$jc(k)){const b=this.b.getWorkspace().folders;return b[0]&&b[0].uri.scheme!==p.Schemas.file?[{searchPath:b[0].uri.with({path:k})}]:[{searchPath:l.URI.file(g.$ic(k))}]}if(this.b.getWorkbenchState()===2){const b=this.b.getWorkspace().folders[0].uri;if(k=d(k),k.startsWith("../")||k===".."){const I=g.$hc.resolve(b.path,k);return[{searchPath:b.with({path:I})}]}const P=C(k);return[{searchPath:b,pattern:P}]}else{if(k==="./"||k===".\\")return[];{const b=k.replace(/^\.[\/\\]/,""),I=this.b.getWorkspace().folders.map(W=>{const V=b.match(new RegExp(`^${T.$_e(W.name)}(?:/(.*)|$)`));return V?{match:V,folder:W}:null}).filter(y.$dg);if(I.length)return I.map(W=>{const V=W.match[1];return{searchPath:W.folder.uri,pattern:V&&C(V)}});{const W=k.match(/\.[\/\\](.+)[\/\\]?/),V=W?W[1]:k,q=m.localize(0,null,V);throw new Error(q)}}}}o(k,b){const P=k.pattern&&b?`${k.pattern}/${b}`:k.pattern||b,I=[{searchPath:k.searchPath,pattern:P}];return P&&!P.endsWith("**")&&I.push({searchPath:k.searchPath,pattern:P+"/**"}),I}q(k,b,P){const I=this.r((0,r.$Qi)(k.searchPath),b,P,!1);return I?{...I,includePattern:k.pattern}:null}r(k,b,P,I){let W;const V=l.URI.isUri(k)?k:k.uri;if(P.searchPaths){const re=P.searchPaths.filter(ae=>(0,E.$2g)(ae.searchPath,V))[0];if(re&&!re.pattern)return null;re&&(W=re.pattern)}const q=this.a.getValue({resource:V}),j={...this.l(q,b)||{},...W||{}},K=l.URI.isUri(k)?(0,E.$6g)(k):k.name;return{folder:V,folderName:I?K:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof b.disregardIgnoreFiles=="boolean"?b.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof b.disregardGlobalIgnoreFiles=="boolean"?b.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof b.disregardParentIgnoreFiles=="boolean"?b.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof b.ignoreSymlinks=="boolean"?b.ignoreSymlinks:!q.search.followSymlinks}}};e.$CM=h,e.$CM=h=Je([We(0,s.$2i),We(1,r.$Ei),We(2,t.$QD),We(3,o.$2j),We(4,n.$AM)],h);function i(f){const k=f.match(/[\*\{\}\(\)\[\]\?]/);if(k){const b=k.index,P=f.substr(0,b).match(/[/|\\][^/\\]*$/);if(P){let I=f.substr(0,P.index);return I.match(/[/\\]/)||(I+="/"),{pathPortion:I,globPortion:f.substr((P.index||0)+1)}}}return{pathPortion:f}}function $(...f){return f.length?f.reduce((k,b)=>(k[b]=!0,k),Object.create(null)):void 0}function a(f){return R.$nk(f,",").map(k=>k.trim()).filter(k=>!!k.length)}function v(f){return[`**/${f}/**`,`**/${f}`].map(b=>b.replace(/\*\*\/\*\*/g,"**"))}function d(f){return f.replace(/\\/g,"/")}function C(f){return d(f).replace(/^\.\//,"").replace(/\/+$/g,"")}function u(f){return f.replace(/([?*[\]])/g,"[$1]")}function D(f,k){f=S.$Mb(f,I=>I.toString());const b=[],P=k.getWorkspace();return f&&f.forEach(I=>{let W;if(k.getWorkbenchState()===2)W=(0,E.$$g)(P.folders[0].uri,I),W&&W!=="."&&(W="./"+W);else{const V=k.getWorkspaceFolder(I);if(V){const q=V.name;if(P.folders.filter(j=>j.name===q).length===1){const j=(0,E.$$g)(V.uri,I);j===""?W=`./${V.name}`:W=`./${V.name}/${j}`}else W=I.fsPath}}W&&b.push(u(W))}),b}}),define(Ce[292],Ae([1,0,23,2,24,14,3,291,46,49,11]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7tb=l,e.$8tb=s;const y=7e3;function l(o,r){const t=r.activationEvents;if(!t)return Promise.resolve(void 0);const n=[],c=[];for(const d of t)if(/^workspaceContains:/.test(d)){const C=d.substr(18);C.indexOf("*")>=0||C.indexOf("?")>=0||o.forceUsingSearch?c.push(C):n.push(C)}if(n.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:h,resolve:i}=(0,T.$oh)(),$=d=>i({activationEvent:d}),a=Promise.all(n.map(d=>w(o,d,$))).then(()=>{}),v=m(o,r.identifier,c,$);return Promise.all([a,v]).then(()=>{i(void 0)}),h}async function w(o,r,t){for(const n of o.folders)if(await o.exists(S.$9g(N.URI.revive(n),r))){t(`workspaceContains:${r}`);return}}async function m(o,r,t,n){if(t.length===0)return Promise.resolve(void 0);const c=new R.$pe,h=o.checkExists(o.folders,t,c.token),i=setTimeout(async()=>{c.cancel(),o.logService.info(`Not activating extension '${r.value}': Timed out while searching for 'workspaceContains' pattern ${t.join(",")}`)},y);let $=!1;try{$=await h}catch(a){O.$4(a)||O.$1(a)}c.dispose(),clearTimeout(i),$&&n(`workspaceContains:${t.join(",")}`)}function s(o,r,t,n){const c=o.get(M.$ui),h=o.get(g.$aL),$=c.createInstance(p.$CM).file(r.map(a=>(0,E.$Qi)(N.URI.revive(a))),{_reason:"checkExists",includePattern:t,exists:!0});return h.fileSearch($,n).then(a=>!!a.limitHit,a=>O.$4(a)?!1:Promise.reject(a))}}),define(Ce[39],Ae([1,0,164,19,89,23,11,6,52,2,13,4,38,226,82,37,26,108,14,20,22,207,7,102,3,27,85,16,71,86,51,88,5,292,81,209,12,79,65,21,80]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$,a,v,d,C,u,D,f,k,b,P,I,W,V,q,A,j,K){"use strict";var re;Object.defineProperty(e,"__esModule",{value:!0}),e.$Vlc=e.$Ulc=e.$Tlc=e.$Slc=e.$Rlc=void 0,e.$Rlc=(0,a.$vi)("IHostUtils");let ae=re=class extends p.$Vc{constructor(L,x,ve,Fe,Ee,pe,fe,Y,X,le,ue,Te,he){super(),this.Y=Te,this.Z=he,this.a=this.B(new b.$ee),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=fe,this.j=Fe,this.m=Ee,this.s=pe,this.t=X,this.u=le,this.w=ue,this.y=this.g.getProxy(y.$YM.MainThreadWorkspace),this.z=this.g.getProxy(y.$YM.MainThreadTelemetry),this.C=this.g.getProxy(y.$YM.MainThreadExtensionService),this.D=new M.$uh,this.F=new M.$uh,this.G=new M.$uh,this.H=new M.$uh,this.I=new Re(this.f.extensions.activationEvents),this.L=new r.$t_b(this.I,this.f.extensions.allExtensions);const Pe=new n.$Rm(this.f.extensions.myExtensions);this.J=new r.$t_b(this.I,Me(this.L,Pe)),j.$t&&(this.s.info(`Creating extension host with the following global extensions: ${de(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${de(this.J)}`)),this.M=new m.$Alc(this.g,this.s),this.N=new I.$Klc(this.g),this.O=Y,this.h=L.createChild(new u.$ti([m.$Blc,this.M],[I.$Llc,this.N])),this.P=this.B(new w.$zlc(this.J,this.L,{onExtensionActivationError:(Ne,ze,U)=>{this.C.$onExtensionActivationError(Ne,t.$3(ze),U)},actualActivateExtension:async(Ne,ze)=>{if(r.$t_b.isHostExtension(Ne,this.J,this.L))return await this.C.$activateExtension(Ne,ze),new w.$ylc;const U=this.J.getExtensionDescription(Ne);return this.fb(U,ze)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),R.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(L){t.$1(L)}}async $(){this.O.onWillDeactivateAll();let L=[];try{L=this.J.getAllExtensionDescriptions().map(Ee=>Ee.identifier).filter(Ee=>this.isActivated(Ee)).map(Ee=>this.eb(Ee))}catch{}await Promise.all(L)}terminate(L,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${L}`),this.s.flush(),this.u.dispose(),this.P.dispose(),t.setUnexpectedErrorHandler(Fe=>{this.s.error(Fe)}),this.g.dispose();const ve=this.$();Promise.race([(0,M.$wh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(L){return this.G.isOpen()?this.P.isActivated(L):!1}async getExtension(L){const x=await this.C.$getExtension(L);return x&&{...x,identifier:new n.$Qm(x.identifier.value),extensionLocation:E.URI.revive(x.extensionLocation)}}ab(L,x){return this.P.activateByEvent(L,x)}bb(L,x){return this.P.activateById(L,x)}activateByIdWithErrors(L,x){return this.bb(L,x).then(()=>{const ve=this.P.getActivatedExtension(L);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(L=>this.J)}getExtensionExports(L){if(this.G.isOpen())return this.P.getActivatedExtension(L).exports;try{return this.P.getActivatedExtension(L).exports}catch{return null}}async cb(L){if(L.scheme===V.Schemas.file&&this.c.fsRealpath){const x=L.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return E.URI.file(ve)}return L}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(L=>new ce(L))),this.Q}async db(L){const x=g.$Bi.forUris(ve=>O.$Zg.ignorePathCasing(ve));return await Promise.all(L.map(async ve=>{if(this.wb(ve)){const Fe=await this.cb(ve.extensionLocation);x.set(Fe,ve)}})),x}eb(L){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(L))return x;const ve=this.P.getActivatedExtension(L);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Fe=>(this.s.error(Fe),Promise.resolve(void 0))))}catch(Fe){this.s.error(`An error occurred when deactivating the extension '${L.value}':`),this.s.error(Fe)}try{(0,p.$Qc)(ve.subscriptions)}catch(Fe){this.s.error(`An error occurred when deactivating the subscriptions for extension '${L.value}':`),this.s.error(Fe)}return x}async fb(L,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(L.identifier):await this.C.$onWillActivateExtension(L.identifier),this.hb(L,x).then(ve=>{const Fe=ve.activationTimes;return this.C.$onDidActivateExtension(L.identifier,Fe.codeLoadingTime,Fe.activateCallTime,Fe.activateResolvedTime,x),this.gb(L,x,"success",Fe),ve},ve=>{throw this.gb(L,x,"failure"),ve})}gb(L,x,ve,Fe){const Ee=Ie(L,x);this.z.$publicLog2("extensionActivationTimes",{...Ee,...Fe||{},outcome:ve})}hb(L,x){const ve=Ie(L,x);this.z.$publicLog2("activatePlugin",ve);const Fe=this.wb(L);if(!Fe)return Promise.resolve(new w.$xlc(w.$ulc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${L.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${L.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const Ee=new w.$vlc(x.startup);return Promise.all([this.xb(L,(0,O.$9g)(L.extensionLocation,Fe),Ee),this.ib(L)]).then(pe=>(R.mark(`code/extHost/willActivateExtension/${L.identifier.value}`),re.jb(this.s,L.identifier,pe[0],pe[1],Ee))).then(pe=>(R.mark(`code/extHost/didActivateExtension/${L.identifier.value}`),pe))}ib(L){const x=this.Z.createLanguageModelAccessInformation(L),ve=new h.$Dlc(L,this.M),Fe=new h.$Clc(L.identifier.value,!1,this.M),Ee=new W.$Mlc(L,this.N),pe=L.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,fe=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${L.identifier.value}`),Promise.all([ve.whenReady,Fe.whenReady,this.O.whenReady]).then(()=>{const Y=this;let X,le;const ue=(0,o.$FG)(L,"ipc")?this.f.messagePorts?.get(n.$Qm.toKey(L.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Fe,secrets:Ee,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return L.extensionLocation},get extensionPath(){return L.extensionLocation.fsPath},asAbsolutePath(Te){return N.$kc(L.extensionLocation.fsPath,Te)},get storagePath(){return Y.O.workspaceValue(L)?.fsPath},get globalStoragePath(){return Y.O.globalValue(L).fsPath},get logPath(){return N.$kc(Y.f.logsLocation.fsPath,L.identifier.value)},get logUri(){return E.URI.joinPath(Y.f.logsLocation,L.identifier.value)},get storageUri(){return Y.O.workspaceValue(L)},get globalStorageUri(){return Y.O.globalValue(L)},get extensionMode(){return pe},get extension(){return X===void 0&&(X=new me(Y,L.identifier,L,fe,!1)),X},get extensionRuntime(){return(0,o.$GG)(L,"extensionRuntime"),Y.extensionRuntime},get environmentVariableCollection(){return Y.u.getEnvironmentVariableCollection(L)},get messagePassingProtocol(){if(!le){if(!ue)return;const Te=b.Event.buffer(b.Event.fromDOMEventEmitter(ue,"message",he=>he.data));ue.start(),le={onDidReceiveMessage:Te,postMessage:ue.postMessage.bind(ue)}}return le}})})}static jb(L,x,ve,Fe,Ee){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(L,x,ve,Fe,Ee).then(pe=>new w.$wlc(!1,null,Ee.build(),ve,pe,Fe.subscriptions))}static kb(L,x,ve,Fe,Ee){if(typeof ve.activate=="function")try{Ee.activateCallStart(),L.trace(`ExtensionService#_callActivateOptional ${x.value}`);const pe=typeof global=="object"?global:self,fe=ve.activate.apply(pe,[Fe]);return Ee.activateCallStop(),Ee.activateResolveStart(),Promise.resolve(fe).then(Y=>(Ee.activateResolveStop(),Y))}catch(pe){return Promise.reject(pe)}else return Promise.resolve(ve)}lb(L,x){this.bb(L.identifier,{startup:!1,extensionId:L.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(L,x=0){const Fe=Date.now();(0,j.$B)(()=>{for(let Ee=x;Ee<L.length;Ee+=1){const pe=L[Ee];for(const fe of pe.activationEvents??[])if(fe==="onStartupFinished")if(Date.now()-Fe>50){this.mb(L,Ee);break}else this.lb(pe,fe)}})}nb(){this.C.$setPerformanceMarks(R.getMarks()),this.m.getConfigProvider().then(L=>{const x=L.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Fe of ve)if(Fe.activationEvents)for(const Ee of Fe.activationEvents)Ee==="onStartupFinished"&&this.lb(Fe,Ee)})}ob(){const L=this.ab("*",!0).then(void 0,pe=>{this.s.error(pe)});this.B(this.j.onDidChangeWorkspace(pe=>this.pb(pe.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Fe=this.rb(),Ee=Promise.all([Fe,L,ve]).then(()=>{});return Promise.race([Ee,(0,M.$wh)(1e4)]).then(()=>{this.nb()}),Ee}pb(L){return L.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(L,x))).then(()=>{})}async qb(L,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Fe={logService:this.s,folders:L.map(pe=>pe.uri),forceUsingSearch:ve||!this.c.fsExists,exists:pe=>this.c.fsExists(pe.fsPath),checkExists:(pe,fe,Y)=>this.y.$checkExists(pe,fe,Y)},Ee=await(0,P.$7tb)(Fe,x);if(Ee)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:Ee.activationEvent}).then(void 0,pe=>this.s.error(pe))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(L){throw console.error(L),L}}async sb(){const{extensionDevelopmentLocationURI:L,extensionTestsLocationURI:x}=this.f.environment;if(!L||!x)throw new Error(S.localize(0,null));const ve=await this.xb(null,x,new w.$vlc(!1));if(!ve||typeof ve.run!="function")throw new Error(S.localize(1,null,x.toString()));return new Promise((Fe,Ee)=>{const pe=(X,le)=>{X?(j.$t&&this.s.error("Test runner called back with error",X),Ee(X)):(j.$t&&(le?this.s.info(`Test runner called back with ${le} failures.`):this.s.info("Test runner called back with successful outcome.")),Fe(typeof le=="number"&&le>0?1:0))},fe=(0,O.$Wg)(x),Y=ve.run(fe,pe);Y&&Y.then&&Y.then(()=>{j.$t&&this.s.info("Test runner finished successfully."),Fe(0)}).catch(X=>{j.$t&&this.s.error("Test runner finished with error",X),Ee(X instanceof Error&&X.stack?X.stack:String(X))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,M.$wh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(L,x){return this.S[L]=x,(0,p.$Tc)(()=>{delete this.S[L]})}async getRemoteExecServer(L){const{resolver:x}=await this.ub(L);return x?.resolveExecServer?.(L,{resolveAttempt:0})}async ub(L){const x=L.indexOf("+");if(x===-1)throw new i.$7M("Not an authority that can be resolved!",$.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=L.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(L,x){const ve=A.$ae.create(!1),Fe=()=>`[resolveAuthority(${(0,$.$Kl)(L)},${x})][${ve.elapsed()}ms] `,Ee=z=>this.s.info(`${Fe()}${z}`),pe=z=>this.s.warn(`${Fe()}${z}`),fe=(z,H=void 0)=>this.s.error(`${Fe()}${z}`,H),Y=z=>{if(z instanceof i.$7M)return{type:"error",error:{code:z._code,message:z._message,detail:z._detail}};throw z},X=async z=>{Ee(`activating resolver for ${z}...`);const{resolver:H,authorityPrefix:G}=await this.ub(z);if(!H)throw fe(`no resolver for ${G}`),new i.$7M(`No remote extension installed to resolve ${G}.`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:z}},le=L.split(/@|%40/g).reverse();Ee(`activating remote resolvers ${le.join(" -> ")}`);let ue;try{ue=await Promise.all(le.map(X)).catch(async z=>{if(!(z instanceof i.$7M)||z._code!==$.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw z;return pe(`resolving nested authorities failed: ${z.message}`),[await X(L)]})}catch(z){return Y(z)}const Te=new M.$Gh;Te.cancelAndSet(()=>Ee("waiting..."),1e3);let he,Pe;for(const[z,{authorityPrefix:H,resolver:G,remoteAuthority:ee}]of ue.entries())try{if(z===ue.length-1)Ee("invoking final resolve()..."),R.mark(`code/extHost/willResolveAuthority/${H}`),he=await G.resolve(ee,{resolveAttempt:x,execServer:Pe}),R.mark(`code/extHost/didResolveAuthorityOK/${H}`),Ee("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,i.$6M.isManagedResolvedAuthority(he)?he:void 0));else{if(Ee(`invoking resolveExecServer() for ${ee}`),R.mark(`code/extHost/willResolveExecServer/${H}`),Pe=await G.resolveExecServer?.(ee,{resolveAttempt:x,execServer:Pe}),!Pe)throw new i.$7M(`Exec server was not available for ${ee}`,$.RemoteAuthorityResolverErrorCode.NoResolverFound);R.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(ne){return R.mark(`code/extHost/didResolveAuthorityError/${H}`),fe("returned an error",ne),Te.dispose(),Y(ne)}Te.dispose();const Ne={environmentTunnels:he.environmentTunnels,features:he.tunnelFeatures?{elevation:he.tunnelFeatures.elevation,privacyOptions:he.tunnelFeatures.privacyOptions,protocol:he.tunnelFeatures.protocol===void 0?!0:he.tunnelFeatures.protocol}:void 0},ze={extensionHostEnv:he.extensionHostEnv,isTrusted:he.isTrusted,authenticationSession:he.authenticationSessionForInitializingExtensions?{id:he.authenticationSessionForInitializingExtensions.id,providerId:he.authenticationSessionForInitializingExtensions.providerId}:void 0};Ee(`returned ${i.$6M.isManagedResolvedAuthority(he)?"managed authority":`${he.host}:${he.port}`}`);let U;if(i.$6M.isManagedResolvedAuthority(he)){const z=x;this.Y.setFactory(z,he.makeConnection),U={authority:L,connectTo:new $.$Hl(z),connectionToken:he.connectionToken}}else U={authority:L,connectTo:new $.$Il(he.host,he.port),connectionToken:he.connectionToken};return{type:"ok",value:{authority:U,options:ze,tunnelInformation:Ne}}}async $getCanonicalURI(L,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,$.$Kl)(L)})`);const{resolver:ve}=await this.ub(L);if(!ve)return null;const Fe=E.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Fe;const Ee=await(0,M.$nh)(()=>ve.getCanonicalURI(Fe));return Ee||Fe}async $startExtensionHost(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=we(this.I,this.L,this.J,L),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),j.$t&&(this.s.info(`$startExtensionHost: global extensions: ${de(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${de(this.J)}`)),this.tb()}$activateByEvent(L,x){return x===1?this.D.wait().then(ve=>this.ab(L,!1)):this.G.wait().then(ve=>this.ab(L,!1))}async $activate(L,x){return await this.G.wait(),this.J.getExtensionDescription(L)?(await this.bb(L,x),!0):!1}async $deltaExtensions(L){L.toAdd.forEach(pe=>pe.extensionLocation=E.URI.revive(pe.extensionLocation));const{globalRegistry:x,myExtensions:ve}=we(this.I,this.L,this.J,L),Fe=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Fe),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),j.$t&&(this.s.info(`$deltaExtensions: global extensions: ${de(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${de(this.J)}`)),Promise.resolve(void 0)}async $test_latency(L){return L}async $test_up(L){return L.byteLength}async $test_down(L){const x=c.$Fe.alloc(L),ve=Math.random()%256;for(let Fe=0;Fe<L;Fe++)x.writeUInt8(ve,Fe);return x}async $updateRemoteConnectionData(L){this.X=L,this.a.fire()}};e.$Slc=ae,e.$Slc=ae=re=Je([We(0,a.$ui),We(1,e.$Rlc),We(2,C.$lP),We(3,s.$dlc),We(4,l.$glc),We(5,T.$2j),We(6,v.$BP),We(7,d.$jlc),We(8,D.$_Cb),We(9,f.$Elc),We(10,q.$Olc),We(11,K.$Plc),We(12,k.$Ilc)],ae);function we(ie,L,x,ve){ie.addActivationEvents(ve.addActivationEvents);const Fe=new r.$t_b(ie,L.getAllExtensionDescriptions());Fe.deltaExtensions(ve.toAdd,ve.toRemove);const Ee=new n.$Rm(x.getAllExtensionDescriptions().map(fe=>fe.identifier));for(const fe of ve.myToRemove)Ee.delete(fe);for(const fe of ve.myToAdd)Ee.add(fe);const pe=Me(Fe,Ee);return{globalRegistry:Fe,myExtensions:pe}}function Ie(ie,L){return{id:ie.identifier.value,name:ie.name,extensionVersion:ie.version,publisherDisplayName:ie.publisher,activationEvents:ie.activationEvents?ie.activationEvents.join(","):null,isBuiltin:ie.isBuiltin,reason:L.activationEvent,reasonId:L.extensionId.value}}function de(ie){return ie.getAllExtensionDescriptions().map(L=>L.identifier.value).join(",")}e.$Tlc=(0,a.$vi)("IExtHostExtensionService");class me{#e;#t;#i;constructor(L,x,ve,Fe,Ee){this.#e=L,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=N.$ic((0,O.$Wg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Fe,this.isFromDifferentExtensionHost=Ee}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ulc=me;function Me(ie,L){return ie.getAllExtensionDescriptions().filter(x=>L.has(x.identifier))}class ce{constructor(L){this.a=L}setSearchTree(L){this.a=L}findSubstr(L){return this.a.findSubstr(L)}forEach(L){return this.a.forEach(L)}}e.$Vlc=ce;class Re{constructor(L){this.a=new n.$Sm,this.addActivationEvents(L)}readActivationEvents(L){return this.a.get(L.identifier)??[]}addActivationEvents(L){for(const x of Object.keys(L))this.a.set(x,L[x])}}}),define(Ce[293],Ae([1,0,89,2,4,38,26,20,16,27,3,39,13,15]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=void 0;let s=class{constructor(c,h,i,$,a,v,d){this.c=c,this.d=h,this.e=i,this.f=$,this.g=a,this.h=v,this.i=d,this.a=new Map,this.b=[]}async install(){this.j(),S.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();S.mark("code/extHost/didWaitForConfig");const h=await this.g.getExtensionPathIndex();this.register(new r(this.c,h,this.d,c,this.i)),this.register(this.e.createInstance(o)),this.h.remote.isRemote&&this.register(this.e.createInstance(t,h,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const h of c.nodeModuleName)this.a.set(h,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(h=>c.alternativeModuleName(h))}};e.$5mc=s,e.$5mc=s=Je([We(2,T.$ui),We(3,O.$glc),We(4,y.$Tlc),We(5,E.$BP),We(6,l.$2j)],s);let o=class{static{m=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&m.a.size){const h=(0,w.$_e)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",$=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${h}/${a}\\/)(${$})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const h=this.b.exec(this.c(c));if(!h)return;const[,i,$,a]=h,v=m.a.get($);if(v!==void 0)return console.warn(`${$} as been renamed to ${v}, please update your imports`),i+v+a}c(c){return c.replace(/\\/g,"/")}};o=m=Je([We(0,E.$BP)],o);class r{constructor(c,h,i,$,a){this.c=c,this.d=h,this.e=i,this.f=$,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Sm}load(c,h){const i=this.d.findSubstr(h);if(i){let $=this.a.get(i.identifier);return $||($=this.c(i,this.e,this.f),this.a.set(i.identifier,$)),$}if(!this.b){let $="";this.d.forEach((a,v)=>$+=`	${v} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${h}. These are the extension path mappings: 
${$}`),this.b=this.c(M.$AG,this.e,this.f)}return this.b}}let t=class{constructor(c,h,i){this.e=c,this.f=h,this.nodeModuleName=["open","opn"],this.d=i.getProxy(R.$YM.MainThreadTelemetry);const $=i.getProxy(R.$YM.MainThreadWindow);this.c=(a,v)=>{const d=N.URI.parse(a);return v?this.g(a,v):d.scheme==="http"||d.scheme==="https"?$.$openUri(d,a,{allowTunneling:!0}):d.scheme==="mailto"||d.scheme===this.f?$.$openUri(d,a,{}):this.g(a,v)}}load(c,h,i){const $=this.e.findSubstr(h);return $&&(this.a=$.identifier.value,this.h()),this.b=i(c),this.c}g(c,h){return this.i(),this.b(c,h)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};t=Je([We(2,g.$lP)],t)}),define(Ce[120],Ae([1,0,41,6,19,73,3,67,66,39,7,37,223,38]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xlc=e.$Wlc=void 0,e.$Wlc=(0,M.$vi)("IExtHostVariableResolverProvider");class m extends l.$nQ{constructor(r,t,n,c,h,i,$){function a(){if(n){const v=n.activeEditor();if(v)return v.document.uri;const d=c.tabGroups.all.find(C=>C.isActive)?.activeTab;if(d!==void 0){if(d.input instanceof T.$LO||d.input instanceof T.$QO)return d.input.modified;if(d.input instanceof T.$KO||d.input instanceof T.$PO||d.input instanceof T.$NO)return d.input.uri}}}super({getFolderUri:v=>{const d=i.folders.filter(C=>C.name===v);if(d&&d.length>0)return d[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(v,d)=>h.getConfiguration(void 0,v).get(d),getAppRoot:()=>O.cwd(),getExecPath:()=>O.env.VSCODE_EXEC_PATH,getFilePath:()=>{const v=a();if(v)return R.$ic(v.fsPath)},getWorkspaceFolderPathForFile:()=>{if(t){const v=a();if(v){const d=t.getWorkspaceFolder(v);if(d)return R.$ic(d.uri.fsPath)}}},getSelectedText:()=>{if(n){const v=n.activeEditor();if(v&&!v.selection.isEmpty)return v.document.getText(v.selection)}},getLineNumber:()=>{if(n){const v=n.activeEditor();if(v)return String(v.selection.end.line+1)}},getExtension:v=>r.getExtension(v)},void 0,$?Promise.resolve($):void 0,Promise.resolve(O.env))}}let s=class extends N.$Vc{constructor(r,t,n,c,h){super(),this.b=r,this.c=t,this.g=n,this.h=c,this.j=h,this.a=new S.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async v=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new m(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$Xlc=s,e.$Xlc=s=Je([We(0,E.$Tlc),We(1,y.$dlc),We(2,p.$wP),We(3,w.$glc),We(4,g.$slc)],s)}),define(Ce[121],Ae([1,0,11,5,2,20,3,4,66,39,16,7,37,215,217,38,120,6,42,32,8]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3lc=e.$2lc=e.$1lc=e.$Zlc=e.$Ylc=void 0,e.$Ylc=(0,M.$vi)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(u,D,f,k,b,P,I){this.N=D,this.O=f,this.P=k,this.Q=b,this.R=P,this.S=I,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$ee,this.o=new N.$ee,this.q=new N.$ee,this.w=new N.$ee,this.l=u.getProxy(p.$YM.MainThreadDebugService),this.A=new N.$ee,this.C=new N.$ee,this.y=new $(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(V=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(u,D){const f=this.W(D);if(!f)return;const k=await this.H.get(u)?.getTreeItem?.(f);return k?this.U(u,k):void 0}registerDebugVisualizationTree(u,D,f){const k=O.$Qm.toKey(u.identifier),b=this.jb(k,D);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.H.set(b,f),this.l.$registerDebugVisualizerTree(b,!!f.editItem),(0,r.$Tc)(()=>{this.l.$unregisterDebugVisualizerTree(b),this.H.delete(D)})}async $getVisualizerTreeItemChildren(u,D){const f=this.J.get(D)?.item;return f?(await this.H.get(u)?.getChildren?.(f))?.map(b=>this.U(u,b))||[]:[]}async $editVisualizerTreeItem(u,D){const f=this.J.get(u);if(!f)return;const k=await this.H.get(f.provider)?.editItem?.(f.item,D);return this.U(f.provider,k||f.item)}$disposeVisualizedTree(u){const D=this.J.get(u);if(!D)return;const f=[D.children];for(const k of f)if(k)for(const b of k)f.push(this.J.get(b)?.children),this.J.delete(b)}U(u,D){let f=this.I.get(D);return f||(f=this.F++,this.I.set(D,f),this.J.set(f,{provider:u,item:D})),c.DebugTreeItem.from(D,f)}asDebugSourceUri(u,D){const f=u;if(typeof f.sourceReference=="number"&&f.sourceReference>0){let k=`debug:${encodeURIComponent(f.path||"")}`,b="?";return D&&(k+=`${b}session=${encodeURIComponent(D.id)}`,b="&"),k+=`${b}ref=${f.sourceReference}`,R.URI.parse(k)}else{if(f.path)return R.URI.file(f.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(u){const D=[];for(const f of u.getAllExtensionDescriptions())if(f.contributes){const k=f.contributes.debuggers;if(k&&k.length>0)for(const b of k)(0,m.$iH)(b)&&D.push(b.type)}this.l.$registerDebugTypes(D)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const u=[];return this.z.forEach(D=>u.push(D)),u}async $resolveDebugVisualizer(u,D){const f=this.L.get(u);if(!f)throw new Error(`No debug visualizer found with id '${u}'`);let{v:k,provider:b,extensionId:P}=f;if(k.visualization||(k=await b.resolveDebugVisualization?.(k,D)||k,f.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${b}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(u){const D=this.L.get(u);if(!D)throw new Error(`No debug visualizer found with id '${u}'`);const f=D.v.visualization;f&&"command"in f&&this.S.executeCommand(f.command,...f.arguments||[])}W(u){const D=this.m.get(u.sessionId);return D&&{session:D.api,variable:u.variable,containerId:u.containerId,frameId:u.frameId,threadId:u.threadId}}async $provideDebugVisualizers(u,D,f,k){const b=this.W(f),P=this.jb(u,D),I=this.G.get(P);if(!b||!I)return[];const W=await I.provideDebugVisualization(b,k);return W?W.map(V=>{const q=++this.M;this.L.set(q,{v:V,provider:I,extensionId:u});const A=V.iconPath?this.lb(V.iconPath):void 0;return{id:q,name:V.name,iconClass:A?.iconClass,iconPath:A?.iconPath,visualization:this.kb(u,V.visualization)}}):[]}$disposeDebugVisualizers(u){for(const D of u)this.L.delete(D)}registerDebugVisualizationProvider(u,D,f){if(!u.contributes?.debugVisualizers?.some(P=>P.id===D))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${D})`);const k=O.$Qm.toKey(u.identifier),b=this.jb(k,D);if(this.G.has(b))throw new Error(`A debug visualization provider with id '${D}' is already registered`);return this.G.set(b,f),this.l.$registerDebugVisualizer(k,D),(0,r.$Tc)(()=>{this.l.$unregisterDebugVisualizer(k,D),this.G.delete(D)})}addBreakpoints(u){const D=u.filter(b=>{const P=b.id;return this.z.has(P)?!1:(this.z.set(P,b),!0)});this.gb(D,[],[]);const f=[],k=new Map;for(const b of D)if(b instanceof y.$2N){let P=k.get(b.location.uri.toString());P||(P={type:"sourceMulti",uri:b.location.uri,lines:[]},k.set(b.location.uri.toString(),P),f.push(P)),P.lines.push({id:b.id,enabled:b.enabled,condition:b.condition,hitCondition:b.hitCondition,logMessage:b.logMessage,line:b.location.range.start.line,character:b.location.range.start.character,mode:b.mode})}else b instanceof y.$3N&&f.push({type:"function",id:b.id,enabled:b.enabled,hitCondition:b.hitCondition,logMessage:b.logMessage,condition:b.condition,functionName:b.functionName,mode:b.mode});return this.l.$registerBreakpoints(f)}removeBreakpoints(u){const D=u.filter(P=>this.z.delete(P.id));this.gb([],D,[]);const f=D.filter(P=>P instanceof y.$2N).map(P=>P.id),k=D.filter(P=>P instanceof y.$3N).map(P=>P.id),b=D.filter(P=>P instanceof y.$4N).map(P=>P.id);return this.l.$unregisterBreakpoints(f,k,b)}startDebugging(u,D,f){return this.l.$startDebugging(u?u.uri:void 0,D,{parentSessionID:f.parentSession?f.parentSession.id:void 0,lifecycleManagedByParent:f.lifecycleManagedByParent,repl:f.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:f.noDebug,compact:f.compact,suppressSaveBeforeStart:f.suppressSaveBeforeStart,suppressDebugStatusbar:f.suppressDebugStatusbar??f.debugUI?.simple,suppressDebugToolbar:f.suppressDebugToolbar??f.debugUI?.simple,suppressDebugView:f.suppressDebugView??f.debugUI?.simple})}stopDebugging(u){return this.l.$stopDebugging(u?u.id:void 0)}registerDebugConfigurationProvider(u,D,f){if(!D)return new y.$1M(()=>{});const k=this.d++;return this.f.push({type:u,handle:k,provider:D}),this.l.$registerDebugConfigurationProvider(u,f,!!D.provideDebugConfigurations,!!D.resolveDebugConfiguration,!!D.resolveDebugConfigurationWithSubstitutedVariables,k),new y.$1M(()=>{this.f=this.f.filter(b=>b.provider!==D),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(u,D,f){if(!f)return new y.$1M(()=>{});if(!this.cb(u,D))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${D}' debugger.`);if(this.$(D))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:D,handle:k,factory:f}),this.l.$registerDebugAdapterDescriptorFactory(D,k),new y.$1M(()=>{this.h=this.h.filter(b=>b.factory!==f),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(u,D){if(!D)return new y.$1M(()=>{});const f=this.j++;return this.k.push({type:u,handle:f,factory:D}),new y.$1M(()=>{this.k=this.k.filter(k=>k.factory!==D)})}async $runInTerminal(u,D){return Promise.resolve(void 0)}async $substituteVariables(u,D){let f;const k=await this.ib(u);return k&&(f={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(f,D)}X(u,D){if(u.type==="implementation")return new v(u.implementation)}Y(){}async $startDASession(u,D){const f=this,k=await this.hb(D);return this.eb(this.$(k.type),k).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(b),I=this.X(P,k);if(!I)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=I;return this.D.set(u,W),this.db(k).then(V=>(V&&this.E.set(u,V),W.onMessage(async q=>{if(q.type==="request"&&q.command==="handshake"){const A=q,j={type:"response",seq:0,command:A.command,request_seq:A.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const K=await this.K.sign(A.arguments.value);j.body={signature:K},W.sendResponse(j)}else throw new Error("no signer")}catch(K){j.success=!1,j.message=K.message,W.sendResponse(j)}}else V&&V.onDidSendMessage&&V.onDidSendMessage(q),q=(0,m.$nH)(q,!0),f.l.$acceptDAMessage(u,q)}),W.onError(q=>{V&&V.onError&&V.onError(q),this.l.$acceptDAError(u,q.name,q.message,q.stack)}),W.onExit(q=>{V&&V.onExit&&V.onExit(q??void 0,void 0),this.l.$acceptDAExit(u,q??void 0,void 0)}),V&&V.onWillStartSession&&V.onWillStartSession(),W.startSession()))})}$sendDAMessage(u,D){D=(0,m.$mH)(D,!1);const f=this.E.get(u);f&&f.onWillReceiveMessage&&f.onWillReceiveMessage(D),this.D.get(u)?.sendMessage(D)}$stopDASession(u){const D=this.E.get(u);this.E.delete(u),D&&D.onWillStopSession&&D.onWillStopSession();const f=this.D.get(u);return this.D.delete(u),f?f.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(u){const D=[],f=[],k=[];if(u.added)for(const b of u.added){const P=b.id;if(P&&!this.z.has(P)){let I;if(b.type==="function")I=new y.$3N(b.functionName,b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode);else if(b.type==="data")I=new y.$4N(b.label,b.dataId,b.canPersist,b.enabled,b.hitCondition,b.condition,b.logMessage,b.mode);else{const W=R.URI.revive(b.uri);I=new y.$2N(new y.$aN(W,new y.$2M(b.line,b.character)),b.enabled,b.condition,b.hitCondition,b.logMessage,b.mode)}(0,y.$ZN)(I,P),this.z.set(P,I),D.push(I)}}if(u.removed)for(const b of u.removed){const P=this.z.get(b);P&&(this.z.delete(b),f.push(P))}if(u.changed){for(const b of u.changed)if(b.id){const P=this.z.get(b.id);if(P){if(P instanceof y.$3N&&b.type==="function"){const I=P;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.functionName=b.functionName}else if(P instanceof y.$2N&&b.type==="source"){const I=P;I.enabled=b.enabled,I.condition=b.condition,I.hitCondition=b.hitCondition,I.logMessage=b.logMessage,I.location=new y.$aN(R.URI.revive(b.uri),new y.$2M(b.line,b.character))}k.push(P)}}}this.gb(D,f,k)}async $acceptStackFrameFocus(u){let D;if(u){const f=await this.hb(u.sessionId);u.kind==="thread"?D=new y.$0N(f.api,u.threadId):D=new y.$9N(f.api,u.threadId,u.frameId)}this.B=D,this.C.fire(this.B)}$provideDebugConfigurations(u,D,f){return(0,S.$nh)(async()=>{const k=this.bb(u);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const b=await this.ib(D);return k.provideDebugConfigurations(b,f)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(u,D,f,k){return(0,S.$nh)(async()=>{const b=this.bb(u);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(D);return b.resolveDebugConfiguration(P,f,k)})}$resolveDebugConfigurationWithSubstitutedVariables(u,D,f,k){return(0,S.$nh)(async()=>{const b=this.bb(u);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(D);return b.resolveDebugConfigurationWithSubstitutedVariables(P,f,k)})}async $provideDebugAdapter(u,D){const f=this.ab(u);if(!f)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(D);return this.eb(f,k).then(b=>{if(!b)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(b)})}async $acceptDebugSessionStarted(u){const D=await this.hb(u);this.n.fire(D.api)}async $acceptDebugSessionTerminated(u){const D=await this.hb(u);D&&(this.o.fire(D.api),this.m.delete(D.id))}async $acceptDebugSessionActiveChanged(u){this.u=u?await this.hb(u):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(u,D){(await this.hb(u))?._acceptNameChanged(D)}async $acceptDebugSessionCustomEvent(u,D){const k={session:(await this.hb(u)).api,event:D.event,body:D.body};this.w.fire(k)}Z(u){if(u instanceof y.$5N)return{type:"executable",command:u.command,args:u.args,options:u.options};if(u instanceof y.$6N)return{type:"server",port:u.port,host:u.host};if(u instanceof y.$7N)return{type:"pipeServer",path:u.path};if(u instanceof y.$8N)return{type:"implementation",implementation:u.implementation};throw new Error("convertToDto unexpected type")}$(u){const D=this.h.filter(f=>f.type===u);if(D.length>0)return D[0].factory}ab(u){const D=this.h.filter(f=>f.handle===u);if(D.length>0)return D[0].factory}bb(u){const D=this.f.filter(f=>f.handle===u);if(D.length>0)return D[0].provider}cb(u,D){if(u.contributes){const f=u.contributes.debuggers;if(f&&f.length>0){for(const k of f)if(k.label&&k.type&&k.type===D)return!0}}return!1}db(u){const f=u.configuration.type,k=this.k.filter(b=>b.type===f||b.type==="*").map(b=>(0,S.$nh)(()=>b.factory.createDebugAdapterTracker(u.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(b=>{const P=b.filter(I=>!!I);if(P.length>0)return new a(P)}),new Promise(b=>setTimeout(()=>b(void 0),1e3))]).catch(b=>{})}async eb(u,D){const f=D.configuration.debugServer;if(typeof f=="number")return Promise.resolve(new y.$6N(f));if(u){const b=await this.O.getExtensionRegistry();return(0,S.$nh)(()=>u.createDebugAdapterDescriptor(D.api,this.fb(D,b))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(D,k))}fb(u,D){}gb(u,D,f){(u.length>0||D.length>0||f.length>0)&&this.A.fire(Object.freeze({added:u,removed:D,changed:f}))}async hb(u){if(u)if(typeof u=="string"){const D=this.m.get(u);if(D)return D}else{let D=this.m.get(u.id);if(!D){const f=await this.ib(u.folderUri),k=u.parent?this.m.get(u.parent):void 0;D=new i(this.l,u.id,u.type,u.name,f,u.configuration,k?.api),this.m.set(D.id,D),this.l.$sessionCached(D.id)}return D}throw new Error("cannot find session")}ib(u){if(u){const D=R.URI.revive(u);return this.N.resolveWorkspaceFolder(D)}return Promise.resolve(void 0)}jb(u,D){return`${u}\0${D}`}kb(u,D){if(D){if("title"in D&&"command"in D)return{type:0};if("treeId"in D)return{type:1,id:`${u}\0${D.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(u){const D=this.mb(u);let f,k;return"id"in D?k=t.ThemeIcon.asClassName(D):f=D,{iconPath:f,iconClass:k}}mb(u){if(u instanceof y.$WN)return{id:u.id};const D=typeof u=="object"&&"dark"in u?u.dark:u,f=typeof u=="object"&&"light"in u?u.light:u;return{dark:typeof D=="string"?R.URI.file(D):D,light:typeof f=="string"?R.URI.file(f):f}}};e.$Zlc=h,e.$Zlc=h=Je([We(0,T.$lP),We(1,l.$dlc),We(2,E.$Tlc),We(3,s.$glc),We(4,g.$slc),We(5,o.$Wlc),We(6,n.$HP)],h);class i{constructor(u,D,f,k,b,P,I){this.f=u,this.g=D,this.h=f,this.j=k,this.k=b,this.l=P,this.m=I}get api(){const u=this;return this.d??=Object.freeze({id:u.g,type:u.h,get name(){return u.j},set name(D){u.j=D,u.f.$setDebugSessionName(u.g,D)},parentSession:u.m,workspaceFolder:u.k,configuration:u.l,customRequest(D,f){return u.f.$customDebugAdapterRequest(u.g,D,f)},getDebugProtocolBreakpoint(D){return u.f.$getDebugProtocolBreakpoint(u.g,D.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(u){this.j=u}get configuration(){return this.l}}e.$1lc=i;class ${constructor(u){this.value=Object.freeze({append(D){u.$appendDebugConsole(D)},appendLine(D){this.append(D+`
`)}})}}e.$2lc=$;class a{constructor(u){this.d=u}onWillStartSession(){this.d.forEach(u=>u.onWillStartSession?u.onWillStartSession():void 0)}onWillReceiveMessage(u){this.d.forEach(D=>D.onWillReceiveMessage?D.onWillReceiveMessage(u):void 0)}onDidSendMessage(u){this.d.forEach(D=>D.onDidSendMessage?D.onDidSendMessage(u):void 0)}onWillStopSession(){this.d.forEach(u=>u.onWillStopSession?u.onWillStopSession():void 0)}onError(u){this.d.forEach(D=>D.onError?D.onError(u):void 0)}onExit(u,D){this.d.forEach(f=>f.onExit?f.onExit(u,D):void 0)}}class v extends w.$apb{constructor(u){super(),this.h=u,u.onDidSendMessage(D=>{this.acceptMessage(D)})}startSession(){return Promise.resolve(void 0)}sendMessage(u){this.h.handleMessage(u)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends h{constructor(u,D,f,k,b,P,I){super(u,D,f,k,b,P,I)}};e.$3lc=d,e.$3lc=d=Je([We(0,T.$lP),We(1,l.$dlc),We(2,E.$Tlc),We(3,s.$glc),We(4,g.$slc),We(5,o.$Wlc),We(6,n.$HP)],d)}),define(Ce[294],Ae([1,0,14,89,2,4,243,13,55,71,27,191,16,60,39,62]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7mc=e.$6mc=void 0;class o{static async installEarlyHandler(n){Error.stackTraceLimit=100;const c=n.get(p.$2j),i=n.get(l.$lP).getProxy(O.$YM.MainThreadErrors);S.setUnexpectedErrorHandler($=>{c.error($);const a=S.$3($);i.$onUnexpectedError(a)})}static async installFullHandler(n){const c=n.get(p.$2j),h=n.get(l.$lP),i=n.get(m.$Tlc),$=n.get(s.$FP),a=h.getProxy(O.$YM.MainThreadExtensionService),v=h.getProxy(O.$YM.MainThreadErrors),d=await i.getExtensionPathIndex(),C=new WeakMap;function u(k,b){if(C.has(k))return C.get(k).stack;let P="",I,W;for(const q of b)P+=`
	at ${q.toString()}`,W=q.getFileName(),!I&&W&&(I=d.findSubstr(R.URI.file(W)));const V=`${k.name||"Error"}: ${k.message||""}${P}`;return C.set(k,{extensionIdentifier:I?.identifier,stack:V}),V}const D=Symbol("prepareStackTrace wrapped");let f=u;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return f},set(k){if(k===u||!k||k[D]){f=k||u;return}f=function(b,P){return u(b,P),k.call(Error,b,P)},Object.assign(f,{[D]:!0})}}),S.setUnexpectedErrorHandler(k=>{c.error(k);const b=S.$3(k),P=C.get(k);if(!P?.extensionIdentifier){v.$onUnexpectedError(b);return}a.$onExtensionRuntimeError(P.extensionIdentifier,b);const I=$.onExtensionError(P.extensionIdentifier,k);c.trace("forwarded error to extension?",I,P)})}}e.$6mc=o;class r{constructor(n,c,h,i,$){this.a=h,this.b=new M.$B_b(n,null,i),c=r.e(c,this.b);const a=new E.$ti(...(0,g.$xs)());a.set(T.$BP,{_serviceBrand:void 0,...c,messagePorts:$}),a.set(l.$lP,new l.$mP(this.b)),a.set(w.$alc,new w.$blc(i)),a.set(m.$Rlc,h);const v=new y.$br(a,!0);v.invokeFunction(o.installEarlyHandler),this.d=v.invokeFunction(d=>d.get(p.$2j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=v.invokeFunction(d=>d.get(m.$Tlc)),this.c.initialize(),v.invokeFunction(o.installFullHandler)}async asBrowserUri(n){const c=this.b.getProxy(O.$YM.MainThreadExtensionService);return R.URI.revive(await c.$asBrowserUri(n))}terminate(n){this.c.terminate(n)}static e(n,c){n.extensions.allExtensions.forEach(i=>{i.extensionLocation=R.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),n.environment.appRoot=R.URI.revive(c.transformIncomingURIs(n.environment.appRoot));const h=n.environment.extensionDevelopmentLocationURI;return h&&(n.environment.extensionDevelopmentLocationURI=h.map(i=>R.URI.revive(c.transformIncomingURIs(i)))),n.environment.extensionTestsLocationURI=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTestsLocationURI)),n.environment.globalStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.globalStorageHome)),n.environment.workspaceStorageHome=R.URI.revive(c.transformIncomingURIs(n.environment.workspaceStorageHome)),n.environment.extensionTelemetryLogResource=R.URI.revive(c.transformIncomingURIs(n.environment.extensionTelemetryLogResource)),n.nlsBaseUrl=R.URI.revive(c.transformIncomingURIs(n.nlsBaseUrl)),n.logsLocation=R.URI.revive(c.transformIncomingURIs(n.logsLocation)),n.workspace=c.transformIncomingURIs(n.workspace),n}}e.$7mc=r}),define(Ce[295],Ae([1,0,18,11,24,43,12,19,23,2,46]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=e.$fmc=e.$emc=void 0,e.$gmc=s;class y{constructor(t,n,c){this.d=t,this.e=n,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(t,n){const c=this.g.folderQueries||[],h=new R.$pe(n);return new Promise((i,$)=>{this.a=new w(t);let a=!1;const v=(d,C)=>{if(!a&&!this.b){const u=this.h(d);s(d)&&typeof this.g.maxResults=="number"&&this.c+u>this.g.maxResults&&(this.b=!0,a=!0,h.cancel(),d=this.j(d,this.g.maxResults-this.c));const D=this.h(d);this.c+=D,(D>0||!s(d))&&this.a.add(d,C)}};Promise.all(c.map((d,C)=>this.k(d,u=>v(u,C),h.token))).then(d=>{h.dispose(),this.a.flush();const C=d.some(u=>!!u&&!!u.limitHit);i({limitHit:this.b||C,messages:(0,S.$Rb)(d.map(u=>u?.message?Array.isArray(u.message)?u.message:[u.message]:[])),stats:{type:this.f}})},d=>{h.dispose();const C=(0,O.$gj)(d);$(new Error(C))})})}h(t){return s(t)?Array.isArray(t.ranges)?t.ranges.length:1:0}j(t,n){const c=Array.isArray(t.ranges)?t.ranges:[t.ranges],h=Array.isArray(t.preview.matches)?t.preview.matches:[t.preview.matches];return{ranges:c.slice(0,n),preview:{matches:h.slice(0,n),text:t.preview.text},uri:t.uri}}async k(t,n,c){const h=new T.$tL(this.g,t),i=[],$={report:d=>{if(!this.l(d))return;const C=t.folder.scheme===M.Schemas.file?(0,T.$uL)(()=>this.e.readdir(g.$8g(d.uri))):void 0,u=g.$$g(t.folder,d.uri);if(u){const D=h.includedInQuery(u,p.$oc(u),C);(0,N.$hh)(D)?i.push(D.then(f=>{f&&n(d)})):D&&n(d)}}},a=this.n(t);let v;return this.d.query.type===3?v=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,$,c):v=await this.d.provider.provideTextSearchResults(l(this.d.query.contentPattern),a,$,c),i.length&&await Promise.all(i),v}l(t){if(s(t)){if(Array.isArray(t.ranges)){if(!Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(t.preview.matches.length!==t.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(t.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(t){const n=(0,T.$sL)(this.g.includePattern,t.includePattern),c=(0,T.$sL)(this.g.excludePattern,t.excludePattern),h={folder:E.URI.from(t.folder),excludes:c,includes:n,useIgnoreFiles:!t.disregardIgnoreFiles,useGlobalIgnoreFiles:!t.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!t.disregardParentIgnoreFiles,followSymlinks:!t.ignoreSymlinks,encoding:t.fileEncoding&&this.e.toCanonicalName(t.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(h.usePCRE2=this.g.usePCRE2),h}}e.$emc=y;function l(r){return{isCaseSensitive:r.isCaseSensitive||!1,isRegExp:r.isRegExp||!1,isWordMatch:r.isWordMatch||!1,isMultiline:r.isMultiline||!1,pattern:r.pattern}}class w{constructor(t){this.e=t,this.b=-1,this.d=null,this.a=new o(512,n=>this.g(n))}add(t,n){this.d&&(this.b!==n||!g.$2g(this.c,t.uri))&&(this.f(),this.d=null),this.d||(this.b=n,this.d={resource:t.uri,results:[]}),this.d.results.push(m(t))}f(){const t=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,t)}flush(){this.f(),this.a.flush()}g(t){this.e(t)}}e.$fmc=w;function m(r){return s(r)?{preview:{matches:(0,S.$2b)(r.preview.matches,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character})),text:r.preview.text},ranges:(0,S.$2b)(r.ranges,t=>({startLineNumber:t.start.line,startColumn:t.start.character,endLineNumber:t.end.line,endColumn:t.end.character}))}:{text:r.text,lineNumber:r.lineNumber}}function s(r){return!!r.preview}class o{static{this.a=4e3}static{this.b=50}constructor(t,n){this.g=t,this.h=n,this.c=0,this.d=[],this.e=0}addItem(t,n){t&&this.j(t,n)}addItems(t,n){t&&this.k(t,n)}j(t,n){this.d.push(t),this.e+=n,this.l()}k(t,n){this.d=this.d.concat(t),this.e+=n,this.l()}l(){this.c<o.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},o.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$hmc=o}),define(Ce[122],Ae([1,0,6,4,3,290,16,60,13,2,295]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=e.$imc=void 0,e.$kmc=l,e.$imc=(0,R.$vi)("IExtHostSearch");let y=class{constructor(s,o,r){this.n=s,this.o=o,this.q=r,this.c=this.n.getProxy(N.$YM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new O.$dmc}s(s){return this.o.transformOutgoingScheme(s)}registerTextSearchProvider(s,o){if(this.g.has(s))throw new Error(`a text search provider for the scheme '${s}' is already registered`);this.g.add(s);const r=this.d++;return this.e.set(r,o),this.c.$registerTextSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.g.delete(s),this.e.delete(r),this.c.$unregisterProvider(r)})}registerAITextSearchProvider(s,o){if(this.i.has(s))throw new Error(`an AI text search provider for the scheme '${s}'is already registered`);this.i.add(s);const r=this.d++;return this.h.set(r,o),this.c.$registerAITextSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.i.delete(s),this.h.delete(r),this.c.$unregisterProvider(r)})}registerFileSearchProvider(s,o){if(this.k.has(s))throw new Error(`a file search provider for the scheme '${s}' is already registered`);this.k.add(s);const r=this.d++;return this.j.set(r,o),this.c.$registerFileSearchProvider(r,this.s(s)),(0,S.$Tc)(()=>{this.k.delete(s),this.j.delete(r),this.c.$unregisterProvider(r)})}$provideFileSearchResults(s,o,r,t){const n=l(r),c=this.j.get(s);if(c)return this.l.fileSearch(n,c,h=>{this.c.$handleFileMatch(s,o,h.map(i=>i.resource))},t);throw new Error("3 unknown provider: "+s)}async doInternalFileSearchWithCustomCallback(s,o,r){return{messages:[]}}$clearCache(s){return this.l.clearCache(s),Promise.resolve(void 0)}$provideTextSearchResults(s,o,r,t){const n=this.e.get(s);if(!n||!n.provideTextSearchResults)throw new Error(`2 Unknown provider ${s}`);const c=l(r);return this.t(c,n).search(i=>this.c.$handleTextMatch(s,o,i),t)}$provideAITextSearchResults(s,o,r,t){const n=this.h.get(s);if(!n||!n.provideAITextSearchResults)throw new Error(`1 Unknown provider ${s}`);const c=l(r);return this.v(c,n).search(i=>this.c.$handleTextMatch(s,o,i),t)}$enableExtensionHostSearch(){}t(s,o){return new T.$emc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"textSearchProvider")}v(s,o){return new T.$emc({query:s,provider:o},{readdir:r=>Promise.resolve([]),toCanonicalName:r=>r},"aiTextSearchProvider")}};e.$jmc=y,e.$jmc=y=Je([We(0,M.$lP),We(1,p.$alc),We(2,g.$2j)],y);function l(m){return{...m,folderQueries:m.folderQueries&&m.folderQueries.map(w),extraFileResources:m.extraFileResources&&m.extraFileResources.map(s=>E.URI.revive(s))}}function w(m){return{...m,folder:E.URI.revive(m.folder)}}}),define(Ce[296],Ae([1,0,24,14,5,6,12,33,2,151,147,135,94,20,44,13,58,59,204,4,246,274,78,84,251,252,253,232,221,32,254,38,255,121,110,256,234,247,257,258,67,66,248,39,260,64,261,45,27,275,276,235,262,88,263,79,80,237,289,265,208,266,277,267,116,238,268,269,270,16,271,122,81,272,239,273,82,85,119,62,51,114,278,279,249,280,281,86,8,7,240,60,241,63,282,283,109,37,216,77,26,118]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$,a,v,d,C,u,D,f,k,b,P,I,W,V,q,A,j,K,re,ae,we,Ie,de,me,Me,ce,Re,ie,L,x,ve,Fe,Ee,pe,fe,Y,X,le,ue,Te,he,Pe,Ne,ze,U,z,H,G,ee,ne,Oe,Be,Ye,_e,et,tt,it,nt,at,mt,je,st,Z,Q,$e,Ge,ye,ot,dt,It,Yt,Ut,xt,_t,Pt,Wt,Qt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=Zt;function Zt(lt){const wt=lt.get(ce.$BP),ti=lt.get(Me.$Xkc),Xt=lt.get(de.$ilc),Lt=lt.get(we.$Tlc),ft=lt.get(Pt.$dlc),jt=lt.get(it.$FP),Bt=lt.get(k.$glc),qt=lt.get(dt.$alc),He=lt.get(H.$lP),ui=lt.get(_e.$Blc),Gt=lt.get(et.$jlc),zt=lt.get(s.$3j),gt=lt.get(s.$2j),Tt=lt.get($e.$_Cb),At=lt.get(i.$Tkc),Ot=lt.get(_t.$Zmc),ii=lt.get(ne.$Llc),Ht=lt.get(re.$slc),ni=lt.get(pe.$Plc),Nt=lt.get($.$4kc),Rt=lt.get(ve.$Ilc);He.set(n.$ZM.ExtHostFileSystemInfo,ti),He.set(n.$ZM.ExtHostLogLevelServiceShape,zt),He.set(n.$ZM.ExtHostWorkspace,ft),He.set(n.$ZM.ExtHostConfiguration,Bt),He.set(n.$ZM.ExtHostExtensionService,Lt),He.set(n.$ZM.ExtHostStorage,ui),He.set(n.$ZM.ExtHostTunnelService,Tt),He.set(n.$ZM.ExtHostWindow,Ot),He.set(n.$ZM.ExtHostSecretState,ii),He.set(n.$ZM.ExtHostTelemetry,jt),He.set(n.$ZM.ExtHostEditorTabs,Ht),He.set(n.$ZM.ExtHostManagedSockets,ni),He.set(n.$ZM.ExtHostAuthentication,Nt),He.set(n.$ZM.ExtHostChatProvider,Rt);const Ct=He.set(n.$ZM.ExtHostDecorations,lt.get(I.$5lc)),Dt=He.set(n.$ZM.ExtHostDocumentsAndEditors,lt.get(K.$wP)),pt=He.set(n.$ZM.ExtHostCommands,lt.get(D.$HP)),St=He.set(n.$ZM.ExtHostTerminalService,lt.get(nt.$Elc)),li=He.set(n.$ZM.ExtHostTerminalShellIntegration,lt.get(at.$Lmc)),kt=He.set(n.$ZM.ExtHostDebugService,lt.get(P.$Ylc)),hi=He.set(n.$ZM.ExtHostSearch,lt.get(ee.$imc)),Kt=He.set(n.$ZM.ExtHostTask,lt.get(tt.$Kmc)),wi=He.set(n.$ZM.ExtHostOutputService,lt.get(Pe.$xmc)),ei=He.set(n.$ZM.ExtHostLocalization,lt.get(Ee.$Olc)),bi=He.set(n.$ZM.ExtHostUrls,new It.$Wmc(He)),yt=He.set(n.$ZM.ExtHostDocuments,new j.$1kc(He,Dt)),$i=He.set(n.$ZM.ExtHostDocumentContentProviders,new q.$7lc(He,Dt,gt)),be=He.set(n.$ZM.ExtHostDocumentSaveParticipant,new A.$8lc(gt,yt,He.getProxy(n.$YM.MainThreadBulkEdits))),Se=He.set(n.$ZM.ExtHostNotebook,new Y.$lmc(He,pt,Dt,yt,Xt,hi)),oe=He.set(n.$ZM.ExtHostNotebookDocuments,new le.$rmc(Se)),J=He.set(n.$ZM.ExtHostNotebookEditors,new ue.$smc(gt,Se)),ke=He.set(n.$ZM.ExtHostNotebookKernels,new Te.$tmc(He,wt,Se,pt,gt)),Ve=He.set(n.$ZM.ExtHostNotebookRenderers,new he.$vmc(He,Se)),Qe=He.set(n.$ZM.ExtHostNotebookDocumentSaveParticipant,new X.$qmc(gt,Se,He.getProxy(n.$YM.MainThreadBulkEdits))),qe=He.set(n.$ZM.ExtHostEditors,new je.$0kc(He,Dt)),ut=He.set(n.$ZM.ExtHostTreeViews,new Q.$Umc(He.getProxy(n.$YM.MainThreadTreeViews),pt,gt)),Et=He.set(n.$ZM.ExtHostEditorInsets,new u.$$kc(He.getProxy(n.$YM.MainThreadEditorInsets),qe,wt.remote)),Ft=He.set(n.$ZM.ExtHostDiagnostics,new W.$Zkc(He,gt,ti,Dt)),Vt=He.set(n.$ZM.ExtHostLanguages,new Fe.$omc(He,yt,pt.converter,qt)),ct=He.set(n.$ZM.ExtHostLanguageFeatures,new x.$2kc(He,qt,yt,pt,Ft,gt,At,jt)),ri=He.set(n.$ZM.ExtHostFileSystem,new Ie.$0lc(He,ct)),di=He.set(n.$ZM.ExtHostFileSystemEventService,new me.$$lc(He,gt,Dt)),pi=He.set(n.$ZM.ExtHostQuickOpen,(0,z.$Bmc)(He,ft,pt)),Si=He.set(n.$ZM.ExtHostSCM,new G.$Dmc(He,pt,yt,gt)),Ai=He.set(n.$ZM.ExtHostQuickDiff,new U.$Amc(He,qt)),Mi=He.set(n.$ZM.ExtHostShare,new Oe.$Emc(He,qt)),Ni=He.set(n.$ZM.ExtHostComments,(0,f.$_kc)(He,pt,yt)),Ti=He.set(n.$ZM.ExtHostProgress,new ze.$zmc(He.getProxy(n.$YM.MainThreadProgress))),cn=He.set(n.$ZM.ExtHostLabelService,new L.$nmc(He)),Oi=He.set(n.$ZM.ExtHostTheming,new st.$Rmc(He)),Fi=He.set(n.$ZM.ExtHostTimeline,new Z.$Tmc(He,pt)),yi=He.set(n.$ZM.ExtHostWebviews,new Yt.$nlc(He,wt.remote,ft,gt,At)),Ii=He.set(n.$ZM.ExtHostWebviewPanels,new Ut.$qlc(He,yi,ft)),Hi=He.set(n.$ZM.ExtHostCustomEditors,new b.$rlc(He,yt,Gt,yi,Ii)),Ki=He.set(n.$ZM.ExtHostWebviewViews,new xt.$Xmc(He,yi)),vi=He.set(n.$ZM.ExtHostTesting,new mt.$Nmc(He,gt,pt,Dt)),Ji=He.set(n.$ZM.ExtHostUriOpeners,new ot.$Vmc(He)),Yi=He.set(n.$ZM.ExtHostProfileContentHandlers,new Ne.$ymc(He));He.set(n.$ZM.ExtHostInteractive,new ie.$mmc(He,Se,Dt,pt,gt));const un=He.set(n.$ZM.ExtHostInlineChat,new Re.$_lc(He,pt,yt,gt)),Li=He.set(n.$ZM.ExtHostChatAgents2,new v.$7kc(He,gt,pt)),zi=He.set(n.$ZM.ExtHostChatVariables,new d.$8kc(He)),Pi=He.set(n.$ZM.ExtHostAiRelatedInformation,new c.$Skc(He)),ln=He.set(n.$ZM.ExtHostAiEmbeddingVector,new ae.$9lc(He)),Qi=He.set(n.$ZM.ExtHostStatusBar,new Ye.$Hmc(He,pt.converter)),Zi=He.set(n.$ZM.ExtHostSpeech,new Be.$Fmc(He)),hn=Object.values(n.$ZM);He.assertRegistered(hn);const Ui=new a.$6kc(He,Dt),Xi=new C.$9kc(He),Ci=new fe.$pmc(He,gt),ji=new V.$6lc(He);return h.$3kc.register(pt),function(Ue,oi,Bi){function xe(_){return(se,Le,rt)=>{const bt=_(Mt=>{try{se.call(Le,Mt)}catch(ki){N.$2(new Error(`[ExtensionListenerError] Extension '${Ue.identifier.value}' FAILED to handle event: ${ki.toString()}`,{cause:ki})),jt.onExtensionError(Ue.identifier,ki)}});return rt?.push(bt),bt}}const vt=function(){let _=!Ue.isUnderDevelopment;function se(){_||(gt.info(`Extension '${Ue.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Le(rt){if(Array.isArray(rt))rt.forEach(Le);else if(typeof rt=="string")se();else{const bt=rt;typeof bt.scheme>"u"&&se(),typeof bt.exclusive=="boolean"&&(0,Ze.$GG)(Ue,"documentFiltersExclusive")}return rt}}(),dn={getSession(_,se,Le){return typeof Le?.forceNewSession=="object"&&Le.forceNewSession.learnMore&&(0,Ze.$GG)(Ue,"authLearnMore"),Nt.getSession(Ue,_,se,Le)},getSessions(_,se){return(0,Ze.$GG)(Ue,"authGetSessions"),Nt.getSessions(Ue,_,se)},async hasSession(_,se){return(0,Ze.$GG)(Ue,"authSession"),!!await Nt.getSession(Ue,_,se,{silent:!0})},get onDidChangeSessions(){return xe(Nt.onDidChangeSessions)},registerAuthenticationProvider(_,se,Le,rt){return Nt.registerAuthenticationProvider(_,se,Le,rt)}},ai={registerCommand(_,se,Le){return pt.registerCommand(!0,_,se,Le,void 0,Ue)},registerTextEditorCommand(_,se,Le){return pt.registerCommand(!0,_,(...rt)=>{const bt=qe.getActiveTextEditor();if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}return bt.edit(Mt=>{se.apply(Le,[bt,Mt,...rt])}).then(Mt=>{Mt||gt.warn("Edits from command "+_+" were not applied.")},Mt=>{gt.warn("An error occurred while running command "+_,Mt)})},void 0,void 0,Ue)},registerDiffInformationCommand:(_,se,Le)=>((0,Ze.$GG)(Ue,"diffCommand"),pt.registerCommand(!0,_,async(...rt)=>{const bt=Dt.activeEditor(!0);if(!bt){gt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Mt=await qe.getDiffInformation(bt.id);se.apply(Le,[Mt,...rt])},void 0,void 0,Ue)),executeCommand(_,...se){return pt.executeCommand(_,...se)},getCommands(_=!1){return pt.getCommands(_)}},Ei={get machineId(){return wt.telemetryInfo.machineId},get sessionId(){return wt.telemetryInfo.sessionId},get language(){return wt.environment.appLanguage},get appName(){return wt.environment.appName},get appRoot(){return wt.environment.appRoot?.fsPath??""},get appHost(){return wt.environment.appHost},get uriScheme(){return wt.environment.appUriScheme},get clipboard(){return Xi.value},get shell(){return St.getDefaultShell(!1)},get onDidChangeShell(){return xe(St.onDidChangeShell)},get isTelemetryEnabled(){return jt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return xe(jt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$GG)(Ue,"telemetry"),jt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$GG)(Ue,"telemetry"),xe(jt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,it.$EP)(wt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,se){return it.$DP.validateSender(_),jt.instantiateLogger(Ue,_,se)},openExternal(_,se){return Ot.openUri(_,{allowTunneling:!!wt.remote.authority,allowContributedOpeners:se?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===wt.environment.appUriScheme)return bi.createAppUri(_);try{return await Ot.asExternalUri(_,{allowTunneling:!!wt.remote.authority})}catch(se){if((0,M.$Eg)(_,M.Schemas.http)||(0,M.$Eg)(_,M.Schemas.https))return _;throw se}},get remoteName(){return(0,o.$Hm)(wt.remote.authority)},get remoteAuthority(){return(0,Ze.$GG)(Ue,"resolvers"),wt.remote.authority},get uiKind(){return wt.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return xe(gt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$GG)(Ue,"resolvers"),wt.quality},get appCommit(){return(0,Ze.$GG)(Ue,"resolvers"),wt.commit}};wt.environment.extensionTestsLocationURI||Object.freeze(Ei);const xi={createTestController(_,se,Le){return vi.createTestController(Ue,_,se,Le)},createTestObserver(){return(0,Ze.$GG)(Ue,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$GG)(Ue,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$GG)(Ue,"testObserver"),xe(vi.onResultsChanged)},get testResults(){return(0,Ze.$GG)(Ue,"testObserver"),vi.results}},Di=wt.remote.isRemote?ye.ExtensionKind.Workspace:ye.ExtensionKind.UI,_i={getExtension(_,se){(0,Ze.$FG)(Ue,"extensionsAny")||(se=!1);const Le=oi.mine.getExtensionDescription(_);if(Le)return new we.$Ulc(Lt,Ue.identifier,Le,Di,!1);if(se){const rt=oi.all.getExtensionDescription(_);if(rt)return new we.$Ulc(Lt,Ue.identifier,rt,Di,!0)}},get all(){const _=[];for(const se of oi.mine.getAllExtensionDescriptions())_.push(new we.$Ulc(Lt,Ue.identifier,se,Di,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$GG)(Ue,"extensionsAny");const _=new w.$Rm(oi.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),se=[];for(const Le of oi.all.getAllExtensionDescriptions()){const rt=!_.has(Le.identifier);se.push(new we.$Ulc(Lt,Ue.identifier,Le,Di,rt))}return se},get onDidChange(){return(0,Ze.$FG)(Ue,"extensionsAny")?xe(R.Event.any(oi.mine.onDidChange,oi.all.onDidChange)):xe(oi.mine.onDidChange)}},en={createDiagnosticCollection(_){return Ft.createDiagnosticCollection(Ue.identifier,_)},get onDidChangeDiagnostics(){return xe(Ft.onDidChangeDiagnostics)},getDiagnostics:_=>Ft.getDiagnostics(_),getLanguages(){return Vt.getLanguages()},setTextDocumentLanguage(_,se){return Vt.changeLanguage(_.uri,se)},match(_,se){const Le=Ge.LanguageSelector.from(_);let rt;return(0,T.$5t)(Le)&&(rt=Se.notebookDocuments.find(bt=>bt.apiNotebook.getCells().find(Mt=>Mt.document===se))?.apiNotebook),(0,T.$4t)(Le,se.uri,se.languageId,!0,rt?.uri,rt?.notebookType)},registerCodeActionsProvider(_,se,Le){return ct.registerCodeActionProvider(Ue,vt(_),se,Le)},registerDocumentPasteEditProvider(_,se,Le){return(0,Ze.$GG)(Ue,"documentPaste"),ct.registerDocumentPasteEditProvider(Ue,vt(_),se,Le)},registerCodeLensProvider(_,se){return ct.registerCodeLensProvider(Ue,vt(_),se)},registerDefinitionProvider(_,se){return ct.registerDefinitionProvider(Ue,vt(_),se)},registerDeclarationProvider(_,se){return ct.registerDeclarationProvider(Ue,vt(_),se)},registerImplementationProvider(_,se){return ct.registerImplementationProvider(Ue,vt(_),se)},registerTypeDefinitionProvider(_,se){return ct.registerTypeDefinitionProvider(Ue,vt(_),se)},registerHoverProvider(_,se){return ct.registerHoverProvider(Ue,vt(_),se,Ue.identifier)},registerEvaluatableExpressionProvider(_,se){return ct.registerEvaluatableExpressionProvider(Ue,vt(_),se,Ue.identifier)},registerInlineValuesProvider(_,se){return ct.registerInlineValuesProvider(Ue,vt(_),se,Ue.identifier)},registerDocumentHighlightProvider(_,se){return ct.registerDocumentHighlightProvider(Ue,vt(_),se)},registerMultiDocumentHighlightProvider(_,se){return ct.registerMultiDocumentHighlightProvider(Ue,vt(_),se)},registerLinkedEditingRangeProvider(_,se){return ct.registerLinkedEditingRangeProvider(Ue,vt(_),se)},registerReferenceProvider(_,se){return ct.registerReferenceProvider(Ue,vt(_),se)},registerRenameProvider(_,se){return ct.registerRenameProvider(Ue,vt(_),se)},registerNewSymbolNamesProvider(_,se){return(0,Ze.$GG)(Ue,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(Ue,vt(_),se)},registerDocumentSymbolProvider(_,se,Le){return ct.registerDocumentSymbolProvider(Ue,vt(_),se,Le)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(Ue,_)},registerDocumentFormattingEditProvider(_,se){return ct.registerDocumentFormattingEditProvider(Ue,vt(_),se)},registerDocumentRangeFormattingEditProvider(_,se){return ct.registerDocumentRangeFormattingEditProvider(Ue,vt(_),se)},registerOnTypeFormattingEditProvider(_,se,Le,...rt){return ct.registerOnTypeFormattingEditProvider(Ue,vt(_),se,[Le].concat(rt))},registerDocumentSemanticTokensProvider(_,se,Le){return ct.registerDocumentSemanticTokensProvider(Ue,vt(_),se,Le)},registerDocumentRangeSemanticTokensProvider(_,se,Le){return ct.registerDocumentRangeSemanticTokensProvider(Ue,vt(_),se,Le)},registerSignatureHelpProvider(_,se,Le,...rt){return typeof Le=="object"?ct.registerSignatureHelpProvider(Ue,vt(_),se,Le):ct.registerSignatureHelpProvider(Ue,vt(_),se,typeof Le>"u"?[]:[Le,...rt])},registerCompletionItemProvider(_,se,...Le){return ct.registerCompletionItemProvider(Ue,vt(_),se,Le)},registerInlineCompletionItemProvider(_,se,Le){return se.handleDidShowCompletionItem&&(0,Ze.$GG)(Ue,"inlineCompletionsAdditions"),se.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$GG)(Ue,"inlineCompletionsAdditions"),Le&&(0,Ze.$GG)(Ue,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(Ue,vt(_),se,Le)},registerInlineEditProvider(_,se){return(0,Ze.$GG)(Ue,"inlineEdit"),ct.registerInlineEditProvider(Ue,vt(_),se)},registerDocumentLinkProvider(_,se){return ct.registerDocumentLinkProvider(Ue,vt(_),se)},registerColorProvider(_,se){return ct.registerColorProvider(Ue,vt(_),se)},registerFoldingRangeProvider(_,se){return ct.registerFoldingRangeProvider(Ue,vt(_),se)},registerSelectionRangeProvider(_,se){return ct.registerSelectionRangeProvider(Ue,_,se)},registerCallHierarchyProvider(_,se){return ct.registerCallHierarchyProvider(Ue,_,se)},registerTypeHierarchyProvider(_,se){return ct.registerTypeHierarchyProvider(Ue,_,se)},setLanguageConfiguration:(_,se)=>ct.setLanguageConfiguration(Ue,_,se),getTokenInformationAtPosition(_,se){return(0,Ze.$GG)(Ue,"tokenInformation"),Vt.tokenAtPosition(_,se)},registerInlayHintsProvider(_,se){return ct.registerInlayHintsProvider(Ue,_,se)},createLanguageStatusItem(_,se){return Vt.createLanguageStatusItem(Ue,_,se)},registerDocumentDropEditProvider(_,se,Le){return ct.registerDocumentOnDropEditProvider(Ue,_,se,(0,Ze.$FG)(Ue,"documentPaste")?Le:void 0)}},fn={get activeTextEditor(){return qe.getActiveTextEditor()},get visibleTextEditors(){return qe.getVisibleTextEditors()},get activeTerminal(){return St.activeTerminal},get terminals(){return St.terminals},async showTextDocument(_,se,Le){g.URI.isUri(_)&&_.scheme===M.Schemas.vscodeRemote&&!_.authority&&At.report("workspace.showTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority.");const rt=await(g.URI.isUri(_)?Promise.resolve(Vi.openTextDocument(_)):Promise.resolve(_));return qe.showTextDocument(rt,se,Le)},createTextEditorDecorationType(_){return qe.createTextEditorDecorationType(Ue,_)},onDidChangeActiveTextEditor(_,se,Le){return xe(qe.onDidChangeActiveTextEditor)(_,se,Le)},onDidChangeVisibleTextEditors(_,se,Le){return xe(qe.onDidChangeVisibleTextEditors)(_,se,Le)},onDidChangeTextEditorSelection(_,se,Le){return xe(qe.onDidChangeTextEditorSelection)(_,se,Le)},onDidChangeTextEditorOptions(_,se,Le){return xe(qe.onDidChangeTextEditorOptions)(_,se,Le)},onDidChangeTextEditorVisibleRanges(_,se,Le){return xe(qe.onDidChangeTextEditorVisibleRanges)(_,se,Le)},onDidChangeTextEditorViewColumn(_,se,Le){return xe(qe.onDidChangeTextEditorViewColumn)(_,se,Le)},onDidCloseTerminal(_,se,Le){return xe(St.onDidCloseTerminal)(_,se,Le)},onDidOpenTerminal(_,se,Le){return xe(St.onDidOpenTerminal)(_,se,Le)},onDidChangeActiveTerminal(_,se,Le){return xe(St.onDidChangeActiveTerminal)(_,se,Le)},onDidChangeTerminalDimensions(_,se,Le){return(0,Ze.$GG)(Ue,"terminalDimensions"),xe(St.onDidChangeTerminalDimensions)(_,se,Le)},onDidChangeTerminalState(_,se,Le){return xe(St.onDidChangeTerminalState)(_,se,Le)},onDidWriteTerminalData(_,se,Le){return(0,Ze.$GG)(Ue,"terminalDataWriteEvent"),xe(St.onDidWriteTerminalData)(_,se,Le)},onDidExecuteTerminalCommand(_,se,Le){return(0,Ze.$GG)(Ue,"terminalExecuteCommandEvent"),xe(St.onDidExecuteTerminalCommand)(_,se,Le)},onDidChangeTerminalShellIntegration(_,se,Le){return(0,Ze.$GG)(Ue,"terminalShellIntegration"),xe(li.onDidChangeTerminalShellIntegration)(_,se,Le)},onDidStartTerminalShellExecution(_,se,Le){return(0,Ze.$GG)(Ue,"terminalShellIntegration"),xe(li.onDidStartTerminalShellExecution)(_,se,Le)},onDidEndTerminalShellExecution(_,se,Le){return(0,Ze.$GG)(Ue,"terminalShellIntegration"),xe(li.onDidEndTerminalShellExecution)(_,se,Le)},get state(){return Ot.getState()},onDidChangeWindowState(_,se,Le){return xe(Ot.onDidChangeWindowState)(_,se,Le)},showInformationMessage(_,...se){return Ci.showMessage(Ue,p.default.Info,_,se[0],se.slice(1))},showWarningMessage(_,...se){return Ci.showMessage(Ue,p.default.Warning,_,se[0],se.slice(1))},showErrorMessage(_,...se){return Ci.showMessage(Ue,p.default.Error,_,se[0],se.slice(1))},showQuickPick(_,se,Le){return pi.showQuickPick(Ue,_,se,Le)},showWorkspaceFolderPick(_){return pi.showWorkspaceFolderPick(_)},showInputBox(_,se){return pi.showInput(_,se)},showOpenDialog(_){return ji.showOpenDialog(Ue,_)},showSaveDialog(_){return ji.showSaveDialog(_)},createStatusBarItem(_,se,Le){let rt,bt,Mt;return typeof _=="string"?(rt=_,bt=se,Mt=Le):(bt=_,Mt=se),Qi.createStatusBarEntry(Ue,rt,bt,Mt)},setStatusBarMessage(_,se){return Qi.setStatusBarMessage(_,se)},withScmProgress(_){return At.report("window.withScmProgress",Ue,"Use 'withProgress' instead."),Ti.withProgress(Ue,{location:ye.ProgressLocation.SourceControl},(se,Le)=>_({report(rt){}}))},withProgress(_,se){return Ti.withProgress(Ue,_,se)},createOutputChannel(_,se){return wi.createOutputChannel(_,se,Ue)},createWebviewPanel(_,se,Le,rt){return Ii.createWebviewPanel(Ue,_,se,Le,rt)},createWebviewTextEditorInset(_,se,Le,rt){return(0,Ze.$GG)(Ue,"editorInsets"),Et.createWebviewEditorInset(_,se,Le,rt,Ue)},createTerminal(_,se,Le){return typeof _=="object"?"pty"in _?St.createExtensionTerminal(_):St.createTerminalFromOptions(_):St.createTerminal(_,se,Le)},registerTerminalLinkProvider(_){return St.registerLinkProvider(_)},registerTerminalProfileProvider(_,se){return St.registerProfileProvider(Ue,_,se)},registerTerminalQuickFixProvider(_,se){return(0,Ze.$GG)(Ue,"terminalQuickFixProvider"),St.registerTerminalQuickFixProvider(_,Ue.identifier.value,se)},registerTreeDataProvider(_,se){return ut.registerTreeDataProvider(_,se,Ue)},createTreeView(_,se){return ut.createTreeView(_,se,Ue)},registerWebviewPanelSerializer:(_,se)=>Ii.registerWebviewPanelSerializer(Ue,_,se),registerCustomEditorProvider:(_,se,Le={})=>Hi.registerCustomEditorProvider(Ue,_,se,Le),registerFileDecorationProvider(_){return Ct.registerFileDecorationProvider(_,Ue)},registerUriHandler(_){return bi.registerUriHandler(Ue,_)},createQuickPick(){return pi.createQuickPick(Ue)},createInputBox(){return pi.createInputBox(Ue)},get activeColorTheme(){return Oi.activeColorTheme},onDidChangeActiveColorTheme(_,se,Le){return xe(Oi.onDidChangeActiveColorTheme)(_,se,Le)},registerWebviewViewProvider(_,se,Le){return Ki.registerWebviewViewProvider(Ue,_,se,Le?.webviewOptions)},get activeNotebookEditor(){return Se.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,se,Le){return xe(Se.onDidChangeActiveNotebookEditor)(_,se,Le)},get visibleNotebookEditors(){return Se.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return xe(Se.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,se,Le){return xe(J.onDidChangeNotebookEditorSelection)(_,se,Le)},onDidChangeNotebookEditorVisibleRanges(_,se,Le){return xe(J.onDidChangeNotebookEditorVisibleRanges)(_,se,Le)},showNotebookDocument(_,se){return Se.showNotebookDocument(_,se)},registerExternalUriOpener(_,se,Le){return(0,Ze.$GG)(Ue,"externalUriOpener"),Ji.registerExternalUriOpener(Ue.identifier,_,se,Le)},registerProfileContentHandler(_,se){return(0,Ze.$GG)(Ue,"profileContentHandlers"),Yi.registerProfileContentHandler(Ue,_,se)},registerQuickDiffProvider(_,se,Le,rt){return(0,Ze.$GG)(Ue,"quickDiffProvider"),Ai.registerQuickDiffProvider(vt(_),se,Le,rt)},get tabGroups(){return Ht.tabGroups},registerShareProvider(_,se){return(0,Ze.$GG)(Ue,"shareProvider"),Mi.registerShareProvider(vt(_),se)}},Vi={get rootPath(){return At.report("workspace.rootPath",Ue,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,se,...Le)=>ft.updateWorkspaceFolders(Ue,_,se||0,...Le),onDidChangeWorkspaceFolders:function(_,se,Le){return xe(ft.onDidChangeWorkspace)(_,se,Le)},asRelativePath:(_,se)=>ft.getRelativePath(_,se),findFiles:(_,se,Le,rt)=>ft.findFiles(_,se,Le,Ue.identifier,rt),findFiles2:(_,se,Le)=>((0,Ze.$GG)(Ue,"findFiles2"),ft.findFiles2(_,se,Ue.identifier,Le)),findTextInFiles:(_,se,Le,rt)=>{(0,Ze.$GG)(Ue,"findTextInFiles");let bt,Mt;return typeof se=="object"?(bt=se,Mt=Le):(bt={},Mt=se,rt=Le),ft.findTextInFiles(_,bt||{},Mt,Ue.identifier,rt)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,se){return Ui.applyWorkspaceEdit(_,Ue,se)},createFileSystemWatcher:(_,se,Le,rt)=>{let bt;return typeof se=="boolean"?bt={ignoreCreateEvents:!!se,ignoreChangeEvents:!!Le,ignoreDeleteEvents:!!rt,correlate:!1}:se&&((0,Ze.$GG)(Ue,"createFileSystemWatcher"),bt={...se,correlate:!0}),di.createFileSystemWatcher(ft,Ue,_,bt)},get textDocuments(){return yt.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let se;const Le=_;if(typeof _=="string")se=Promise.resolve(g.URI.file(_));else if(g.URI.isUri(_))se=Promise.resolve(_);else if(!Le||typeof Le=="object")se=yt.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return se.then(rt=>(rt.scheme===M.Schemas.vscodeRemote&&!rt.authority&&At.report("workspace.openTextDocument",Ue,"A URI of 'vscode-remote' scheme requires an authority."),yt.ensureDocumentData(rt).then(bt=>bt.document)))},onDidOpenTextDocument:(_,se,Le)=>xe(yt.onDidAddDocument)(_,se,Le),onDidCloseTextDocument:(_,se,Le)=>xe(yt.onDidRemoveDocument)(_,se,Le),onDidChangeTextDocument:(_,se,Le)=>xe(yt.onDidChangeDocument)(_,se,Le),onDidSaveTextDocument:(_,se,Le)=>xe(yt.onDidSaveDocument)(_,se,Le),onWillSaveTextDocument:(_,se,Le)=>xe(be.getOnWillSaveTextDocumentEvent(Ue))(_,se,Le),get notebookDocuments(){return Se.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,se){let Le;if(g.URI.isUri(_))Le=_,await Se.openNotebookDocument(_);else if(typeof _=="string")Le=g.URI.revive(await Se.createNotebookDocument({viewType:_,content:se}));else throw new Error("Invalid arguments");return Se.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(_,se,Le){return xe(oe.onDidSaveNotebookDocument)(_,se,Le)},onDidChangeNotebookDocument(_,se,Le){return xe(oe.onDidChangeNotebookDocument)(_,se,Le)},onWillSaveNotebookDocument(_,se,Le){return xe(Qe.getOnWillSaveNotebookDocumentEvent(Ue))(_,se,Le)},get onDidOpenNotebookDocument(){return xe(Se.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return xe(Se.onDidCloseNotebookDocument)},registerNotebookSerializer(_,se,Le,rt){return Se.registerNotebookSerializer(Ue,_,se,Le,(0,Ze.$FG)(Ue,"notebookLiveShare")?rt:void 0)},onDidChangeConfiguration:(_,se,Le)=>xe(Bi.onDidChangeConfiguration)(_,se,Le),getConfiguration(_,se){return se=arguments.length===1?void 0:se,Bi.getConfiguration(_,se,Ue)},registerTextDocumentContentProvider(_,se){return $i.registerTextDocumentContentProvider(_,se)},registerTaskProvider:(_,se)=>(At.report("window.registerTaskProvider",Ue,"Use the corresponding function on the 'tasks' namespace instead"),Kt.registerTaskProvider(Ue,_,se)),registerFileSystemProvider(_,se,Le){return(0,O.$Sc)(ri.registerFileSystemProvider(Ue,_,se,Le),Xt.addFileSystemProvider(_,se,Le))},get fs(){return Xt.value},registerFileSearchProvider:(_,se)=>((0,Ze.$GG)(Ue,"fileSearchProvider"),hi.registerFileSearchProvider(_,se)),registerTextSearchProvider:(_,se)=>((0,Ze.$GG)(Ue,"textSearchProvider"),hi.registerTextSearchProvider(_,se)),registerAITextSearchProvider:(_,se)=>((0,Ze.$GG)(Ue,"aiTextSearchProvider"),(0,Ze.$GG)(Ue,"textSearchProvider"),hi.registerAITextSearchProvider(_,se)),registerRemoteAuthorityResolver:(_,se)=>((0,Ze.$GG)(Ue,"resolvers"),Lt.registerRemoteAuthorityResolver(_,se)),registerResourceLabelFormatter:_=>((0,Ze.$GG)(Ue,"resolvers"),cn.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$GG)(Ue,"resolvers"),Lt.getRemoteExecServer(_)),onDidCreateFiles:(_,se,Le)=>xe(di.onDidCreateFile)(_,se,Le),onDidDeleteFiles:(_,se,Le)=>xe(di.onDidDeleteFile)(_,se,Le),onDidRenameFiles:(_,se,Le)=>xe(di.onDidRenameFile)(_,se,Le),onWillCreateFiles:(_,se,Le)=>xe(di.getOnWillCreateFileEvent(Ue))(_,se,Le),onWillDeleteFiles:(_,se,Le)=>xe(di.getOnWillDeleteFileEvent(Ue))(_,se,Le),onWillRenameFiles:(_,se,Le)=>xe(di.getOnWillRenameFileEvent(Ue))(_,se,Le),openTunnel:_=>((0,Ze.$GG)(Ue,"tunnels"),Tt.openTunnel(Ue,_).then(se=>{if(!se)throw new Error("cannot open tunnel");return se})),get tunnels(){return(0,Ze.$GG)(Ue,"tunnels"),Tt.getTunnels()},onDidChangeTunnels:(_,se,Le)=>((0,Ze.$GG)(Ue,"tunnels"),xe(Tt.onDidChangeTunnels)(_,se,Le)),registerPortAttributesProvider:(_,se)=>((0,Ze.$GG)(Ue,"portsAttributes"),Tt.registerPortsAttributesProvider(_,se)),registerTunnelProvider:(_,se)=>((0,Ze.$GG)(Ue,"tunnelFactory"),Tt.registerTunnelProvider(_,se)),registerTimelineProvider:(_,se)=>((0,Ze.$GG)(Ue,"timeline"),Fi.registerTimelineProvider(_,se,Ue.identifier,pt.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$GG)(Ue,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,se,Le)=>xe(ft.onDidGrantWorkspaceTrust)(_,se,Le),registerEditSessionIdentityProvider:(_,se)=>((0,Ze.$GG)(Ue,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,se)),onWillCreateEditSessionIdentity:(_,se,Le)=>((0,Ze.$GG)(Ue,"editSessionIdentityProvider"),xe(ft.getOnWillCreateEditSessionIdentityEvent(Ue))(_,se,Le)),registerCanonicalUriProvider:(_,se)=>((0,Ze.$GG)(Ue,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,se)),getCanonicalUri:(_,se,Le)=>((0,Ze.$GG)(Ue,"canonicalUriProvider"),ft.provideCanonicalUri(_,se,Le))},tn={get inputBox(){return At.report("scm.inputBox",Ue,"Use 'SourceControl.inputBox' instead"),Si.getLastInputBox(Ue)},createSourceControl(_,se,Le){return Si.createSourceControl(Ue,_,se,Le)}},gn={createCommentController(_,se){return Ni.createCommentController(Ue,_,se)}},mn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){if((0,Ze.$FG)(Ue,"debugFocus"))return kt.activeStackItem},registerDebugVisualizationProvider(_,se){return(0,Ze.$GG)(Ue,"debugVisualization"),kt.registerDebugVisualizationProvider(Ue,_,se)},registerDebugVisualizationTreeProvider(_,se){return(0,Ze.$GG)(Ue,"debugVisualization"),kt.registerDebugVisualizationTree(Ue,_,se)},onDidStartDebugSession(_,se,Le){return xe(kt.onDidStartDebugSession)(_,se,Le)},onDidTerminateDebugSession(_,se,Le){return xe(kt.onDidTerminateDebugSession)(_,se,Le)},onDidChangeActiveDebugSession(_,se,Le){return xe(kt.onDidChangeActiveDebugSession)(_,se,Le)},onDidReceiveDebugSessionCustomEvent(_,se,Le){return xe(kt.onDidReceiveDebugSessionCustomEvent)(_,se,Le)},onDidChangeBreakpoints(_,se,Le){return xe(kt.onDidChangeBreakpoints)(_,se,Le)},onDidChangeActiveStackItem(_,se,Le){return(0,Ze.$GG)(Ue,"debugFocus"),xe(kt.onDidChangeActiveStackItem)(_,se,Le)},registerDebugConfigurationProvider(_,se,Le){return kt.registerDebugConfigurationProvider(_,se,Le||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,se){return kt.registerDebugAdapterDescriptorFactory(Ue,_,se)},registerDebugAdapterTrackerFactory(_,se){return kt.registerDebugAdapterTrackerFactory(_,se)},startDebugging(_,se,Le){return!Le||typeof Le=="object"&&"configuration"in Le?kt.startDebugging(_,se,{parentSession:Le}):kt.startDebugging(_,se,Le||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,se){return kt.asDebugSourceUri(_,se)}},nn={registerTaskProvider:(_,se)=>Kt.registerTaskProvider(Ue,_,se),fetchTasks:_=>Kt.fetchTasks(_),executeTask:_=>Kt.executeTask(Ue,_),get taskExecutions(){return Kt.taskExecutions},onDidStartTask:(_,se,Le)=>xe(Kt.onDidStartTask)(_,se,Le),onDidEndTask:(_,se,Le)=>xe(Kt.onDidEndTask)(_,se,Le),onDidStartTaskProcess:(_,se,Le)=>xe(Kt.onDidStartTaskProcess)(_,se,Le),onDidEndTaskProcess:(_,se,Le)=>xe(Kt.onDidEndTaskProcess)(_,se,Le)},Wi={createNotebookController(_,se,Le,rt,bt){return ke.createNotebookController(Ue,_,se,Le,rt,(0,Ze.$FG)(Ue,"notebookMessaging")?bt:void 0)},registerNotebookCellStatusBarItemProvider:(_,se)=>Se.registerNotebookCellStatusBarItemProvider(Ue,_,se),createRendererMessaging(_){return Ve.createRendererMessaging(Ue,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$GG)(Ue,"notebookKernelSource"),ke.createNotebookControllerDetectionTask(Ue,_)},registerKernelSourceActionProvider(_,se){return(0,Ze.$GG)(Ue,"notebookKernelSource"),ke.registerKernelSourceActionProvider(Ue,_,se)},onDidChangeNotebookCellExecutionState(_,se,Le){return(0,Ze.$GG)(Ue,"notebookCellExecutionState"),xe(ke.onDidChangeNotebookCellExecutionState)(_,se,Le)}},rn={t(..._){if(typeof _[0]=="string"){const se=_.shift(),Le=!_||typeof _[0]!="object"?_:_[0];return ei.getMessage(Ue.identifier.value,{message:se,args:Le})}return ei.getMessage(Ue.identifier.value,_[0])},get bundle(){return ei.getBundle(Ue.identifier.value)},get uri(){return ei.getBundleUri(Ue.identifier.value)}},sn={_version:1,registerInteractiveEditorSessionProvider(_,se){return(0,Ze.$GG)(Ue,"interactive"),un.registerProvider(Ue,_,se)},transferActiveChat(_){return(0,Ze.$GG)(Ue,"interactive"),Li.transferActiveChat(_)}},on={getRelatedInformation(_,se){return(0,Ze.$GG)(Ue,"aiRelatedInformation"),Pi.getRelatedInformation(Ue,_,se)},registerRelatedInformationProvider(_,se){return(0,Ze.$GG)(Ue,"aiRelatedInformation"),Pi.registerRelatedInformationProvider(Ue,_,se)},registerEmbeddingVectorProvider(_,se){return(0,Ze.$GG)(Ue,"aiRelatedInformation"),ln.registerEmbeddingVectorProvider(Ue,_,se)}},$n={registerChatResponseProvider(_,se,Le){return(0,Ze.$GG)(Ue,"chatProvider"),Rt.registerLanguageModel(Ue,_,se,Le)},registerChatVariableResolver(_,se,Le){return(0,Ze.$GG)(Ue,"chatVariableResolver"),zi.registerVariableResolver(Ue,_,se,Le)},registerMappedEditsProvider(_,se){return(0,Ze.$GG)(Ue,"mappedEditsProvider"),ct.registerMappedEditsProvider(Ue,_,se)},createChatParticipant(_,se){return(0,Ze.$GG)(Ue,"chatParticipant"),Li.createChatAgent(Ue,_,se)},createDynamicChatParticipant(_,se,Le,rt){return(0,Ze.$GG)(Ue,"chatParticipantAdditions"),Li.createDynamicChatAgent(Ue,_,se,Le,rt)}},pn={get languageModels(){return(0,Ze.$GG)(Ue,"languageModels"),Rt.getLanguageModelIds()},onDidChangeLanguageModels:(_,se,Le)=>((0,Ze.$GG)(Ue,"languageModels"),Rt.onDidChangeProviders(_,se,Le)),sendChatRequest(_,se,Le,rt){return(0,Ze.$GG)(Ue,"languageModels"),Rt.sendChatRequest(Ue,_,se,Le,rt)},computeTokenLength(_,se,Le){return(0,Ze.$GG)(Ue,"languageModels"),Le??=S.CancellationToken.None,Rt.computeTokenLength(_,se,Le)},getLanguageModelInformation(_){return(0,Ze.$GG)(Ue,"languageModels"),Rt.getLanguageModelInfo(_)}},an={registerSpeechProvider(_,se){return(0,Ze.$GG)(Ue,"speech"),Zi.registerProvider(Ue.identifier,_,se)}};return{version:wt.version,ai:on,authentication:dn,commands:ai,comments:gn,chat:$n,debug:mn,env:Ei,extensions:_i,interactive:sn,l10n:rn,languages:en,lm:pn,notebooks:Wi,scm:tn,speech:an,tasks:nn,tests:xi,window:fn,workspace:Vi,Breakpoint:ye.$1N,TerminalOutputAnchor:ye.TerminalOutputAnchor,ChatResultFeedbackKind:ye.ChatResultFeedbackKind,ChatVariableLevel:ye.ChatVariableLevel,ChatCompletionItem:ye.$VO,CallHierarchyIncomingCall:ye.$mN,CallHierarchyItem:ye.$lN,CallHierarchyOutgoingCall:ye.$nN,CancellationError:N.$5,CancellationTokenSource:S.$pe,CandidatePortSource:n.CandidatePortSource,CodeAction:ye.$iN,CodeActionKind:ye.$jN,CodeActionTriggerKind:ye.CodeActionTriggerKind,CodeLens:ye.$oN,Color:ye.$BN,ColorInformation:ye.$CN,ColorPresentation:ye.$DN,ColorThemeKind:ye.ColorThemeKind,CommentMode:ye.CommentMode,CommentState:ye.CommentState,CommentThreadCollapsibleState:ye.CommentThreadCollapsibleState,CommentThreadState:ye.CommentThreadState,CommentThreadApplicability:ye.CommentThreadApplicability,CompletionItem:ye.$vN,CompletionItemKind:ye.CompletionItemKind,CompletionItemTag:ye.CompletionItemTag,CompletionList:ye.$wN,CompletionTriggerKind:ye.CompletionTriggerKind,ConfigurationTarget:ye.ConfigurationTarget,CustomExecution:ye.$LN,DebugAdapterExecutable:ye.$5N,DebugAdapterInlineImplementation:ye.$8N,DebugAdapterNamedPipeServer:ye.$7N,DebugAdapterServer:ye.$6N,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:ye.DebugConsoleMode,DebugVisualization:ye.$lO,DecorationRangeBehavior:ye.DecorationRangeBehavior,Diagnostic:ye.$cN,DiagnosticRelatedInformation:ye.$bN,DiagnosticSeverity:ye.DiagnosticSeverity,DiagnosticTag:ye.DiagnosticTag,Disposable:ye.$1M,DocumentHighlight:ye.$eN,DocumentHighlightKind:ye.DocumentHighlightKind,MultiDocumentHighlight:ye.$fN,DocumentLink:ye.$AN,DocumentSymbol:ye.$hN,EndOfLine:ye.EndOfLine,EnvironmentVariableMutatorType:ye.EnvironmentVariableMutatorType,EvaluatableExpression:ye.$$N,InlineValueText:ye.$_N,InlineValueVariableLookup:ye.$aO,InlineValueEvaluatableExpression:ye.$bO,InlineCompletionTriggerKind:ye.InlineCompletionTriggerKind,EventEmitter:R.$ee,ExtensionKind:ye.ExtensionKind,ExtensionMode:ye.ExtensionMode,ExternalUriOpenerPriority:ye.ExternalUriOpenerPriority,FileChangeType:ye.FileChangeType,FileDecoration:ye.$nO,FileDecoration2:ye.$nO,FileSystemError:ye.$eO,FileType:m.FileType,FilePermission:m.FilePermission,FoldingRange:ye.$fO,FoldingRangeKind:ye.FoldingRangeKind,FunctionBreakpoint:ye.$3N,InlineCompletionItem:ye.$xN,InlineCompletionList:ye.$yN,Hover:ye.$dN,IndentAction:y.IndentAction,Location:ye.$aN,MarkdownString:ye.$pN,OverviewRulerLane:l.OverviewRulerLane,ParameterInformation:ye.$qN,PortAutoForwardAction:ye.PortAutoForwardAction,Position:ye.$2M,ProcessExecution:ye.$JN,ProgressLocation:ye.ProgressLocation,QuickInputButtons:ye.$mO,Range:ye.$3M,RelativePattern:ye.$YN,Selection:ye.$4M,SelectionRange:ye.$kN,SemanticTokens:ye.$iO,SemanticTokensBuilder:ye.$hO,SemanticTokensEdit:ye.$jO,SemanticTokensEdits:ye.$kO,SemanticTokensLegend:ye.$gO,ShellExecution:ye.$KN,ShellQuoting:ye.ShellQuoting,SignatureHelp:ye.$sN,SignatureHelpTriggerKind:ye.SignatureHelpTriggerKind,SignatureInformation:ye.$rN,SnippetString:ye.$_M,SourceBreakpoint:ye.$2N,StandardTokenType:ye.StandardTokenType,StatusBarAlignment:ye.StatusBarAlignment,SymbolInformation:ye.$gN,SymbolKind:ye.SymbolKind,SymbolTag:ye.SymbolTag,Task:ye.$MN,TaskGroup:ye.$IN,TaskPanelKind:ye.TaskPanelKind,TaskRevealKind:ye.TaskRevealKind,TaskScope:ye.TaskScope,TerminalLink:ye.$EN,TerminalQuickFixTerminalCommand:ye.$GN,TerminalQuickFixOpener:ye.$FN,TerminalLocation:ye.TerminalLocation,TerminalProfile:ye.$HN,TerminalExitReason:ye.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:ye.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:ye.TextDocumentSaveReason,TextEdit:ye.$8M,SnippetTextEdit:ye.$0M,TextEditorCursorStyle:E.TextEditorCursorStyle,TextEditorLineNumbersStyle:ye.TextEditorLineNumbersStyle,TextEditorRevealType:ye.TextEditorRevealType,TextEditorSelectionChangeKind:ye.TextEditorSelectionChangeKind,SyntaxTokenType:ye.SyntaxTokenType,TextDocumentChangeReason:ye.TextDocumentChangeReason,ThemeColor:ye.$XN,ThemeIcon:ye.$WN,TreeItem:ye.$NN,TreeItemCheckboxState:ye.TreeItemCheckboxState,TreeItemCollapsibleState:ye.TreeItemCollapsibleState,TypeHierarchyItem:ye.$JO,UIKind:Qt.UIKind,Uri:g.URI,ViewColumn:ye.ViewColumn,WorkspaceEdit:ye.$$M,DocumentPasteTriggerKind:ye.DocumentPasteTriggerKind,DocumentDropEdit:ye.$TN,DocumentDropOrPasteEditKind:ye.$UN,DocumentPasteEdit:ye.$VN,InlayHint:ye.$uN,InlayHintLabelPart:ye.$tN,InlayHintKind:ye.InlayHintKind,RemoteAuthorityResolverError:ye.$7M,ResolvedAuthority:ye.$5M,ManagedResolvedAuthority:ye.$6M,SourceControlInputBoxValidationType:ye.SourceControlInputBoxValidationType,ExtensionRuntime:ye.ExtensionRuntime,TimelineItem:ye.$xO,NotebookRange:ye.$pO,NotebookCellKind:ye.NotebookCellKind,NotebookCellExecutionState:ye.NotebookCellExecutionState,NotebookCellData:ye.$qO,NotebookData:ye.$rO,NotebookRendererScript:ye.$vO,NotebookCellStatusBarAlignment:ye.NotebookCellStatusBarAlignment,NotebookEditorRevealType:ye.NotebookEditorRevealType,NotebookCellOutput:ye.$tO,NotebookCellOutputItem:ye.$sO,NotebookCellStatusBarItem:ye.$uO,NotebookControllerAffinity:ye.NotebookControllerAffinity,NotebookControllerAffinity2:ye.NotebookControllerAffinity2,NotebookEdit:ye.$9M,NotebookKernelSourceAction:ye.$wO,NotebookVariablesRequestKind:ye.NotebookVariablesRequestKind,PortAttributes:ye.$zO,LinkedEditingRanges:ye.$yO,TestResultState:ye.TestResultState,TestRunRequest:ye.$AO,TestMessage:ye.$BO,TestTag:ye.$CO,TestRunProfileKind:ye.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:ye.$SN,DataTransferItem:ye.$ON,TestCoverageCount:ye.$DO,FileCoverage:ye.$FO,StatementCoverage:ye.$GO,BranchCoverage:ye.$HO,DeclarationCoverage:ye.$IO,WorkspaceTrustState:ye.WorkspaceTrustState,LanguageStatusSeverity:ye.LanguageStatusSeverity,QuickPickItemKind:ye.QuickPickItemKind,InputBoxValidationSeverity:ye.InputBoxValidationSeverity,TabInputText:ye.$KO,TabInputTextDiff:ye.$LO,TabInputTextMerge:ye.$MO,TabInputCustom:ye.$NO,TabInputNotebook:ye.$PO,TabInputNotebookDiff:ye.$QO,TabInputWebview:ye.$OO,TabInputTerminal:ye.$RO,TabInputInteractiveWindow:ye.$SO,TabInputChat:ye.$TO,TabInputTextMultiDiff:ye.$UO,TelemetryTrustedValue:r.$ep,LogLevel:s.LogLevel,EditSessionIdentityMatch:t.EditSessionIdentityMatch,InteractiveSessionVoteDirection:ye.InteractiveSessionVoteDirection,ChatCopyKind:ye.ChatCopyKind,InteractiveEditorResponseFeedbackKind:ye.InteractiveEditorResponseFeedbackKind,StackFrame:ye.$9N,Thread:ye.$0N,RelatedInformationType:ye.RelatedInformationType,SpeechToTextStatus:ye.SpeechToTextStatus,PartialAcceptTriggerKind:ye.PartialAcceptTriggerKind,KeywordRecognitionStatus:ye.KeywordRecognitionStatus,ChatResponseMarkdownPart:ye.$WO,ChatResponseFileTreePart:ye.$ZO,ChatResponseAnchorPart:ye.$1O,ChatResponseProgressPart:ye.$2O,ChatResponseReferencePart:ye.$4O,ChatResponseTextEditPart:ye.$5O,ChatResponseMarkdownWithVulnerabilitiesPart:ye.$XO,ChatResponseCommandButtonPart:ye.$3O,ChatResponseDetectedParticipantPart:ye.$YO,ChatRequestTurn:ye.$6O,ChatResponseTurn:ye.$7O,ChatLocation:ye.ChatLocation,LanguageModelChatSystemMessage:ye.$8O,LanguageModelChatUserMessage:ye.$9O,LanguageModelChatAssistantMessage:ye.$0O,LanguageModelSystemMessage:ye.$8O,LanguageModelUserMessage:ye.$9O,LanguageModelAssistantMessage:ye.$0O,LanguageModelError:ye.$$O,NewSymbolName:ye.$dO,NewSymbolNameTag:ye.NewSymbolNameTag,InlineEdit:ye.$_O,InlineEditTriggerKind:ye.InlineEditTriggerKind}}}}),define(Ce[297],Ae([1,0,55,116,37,110,38,32,67,51,119,121,122,82,86,78,109,64,45,81,62,66,236,13,120,79,80,84,88,114]),function(ge,e,S,N,R,O,M,p,g,E,T,y,l,w,m,s,o,r,t,n,c,h,i,$,a,v,d,C,u,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,S.$ws)(v.$Olc,v.$Nlc,1),(0,S.$ws)($.$3j,i.$2mc,1),(0,S.$ws)(s.$Tkc,s.$Ukc,1),(0,S.$ws)(p.$HP,p.$GP,0),(0,S.$ws)(C.$4kc,C.$5kc,0),(0,S.$ws)(u.$Ilc,u.$Jlc,0),(0,S.$ws)(M.$glc,M.$elc,0),(0,S.$ws)(r.$ilc,r.$hlc,0),(0,S.$ws)(y.$Ylc,y.$3lc,0),(0,S.$ws)(O.$5lc,O.$4lc,0),(0,S.$ws)(g.$wP,g.$vP,0),(0,S.$ws)(d.$Plc,d.$Qlc,0),(0,S.$ws)(t.$Xkc,t.$Wkc,0),(0,S.$ws)(N.$xmc,N.$wmc,1),(0,S.$ws)(l.$imc,l.$jmc,0),(0,S.$ws)(w.$Blc,w.$Alc,0),(0,S.$ws)(T.$Kmc,T.$Jmc,0),(0,S.$ws)(E.$Elc,E.$Hlc,0),(0,S.$ws)(D.$Lmc,D.$Mmc,0),(0,S.$ws)(m.$_Cb,m.$aDb,0),(0,S.$ws)(o.$Zmc,o.$Ymc,0),(0,S.$ws)(R.$dlc,R.$clc,0),(0,S.$ws)(n.$Llc,n.$Klc,0),(0,S.$ws)(c.$FP,c.$CP,0),(0,S.$ws)(h.$slc,h.$tlc,0),(0,S.$ws)(a.$Wlc,a.$Xlc,0)}),define(Ce[298],Ae([1,0,296,39,2,293,7,11,242]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_oc=void 0;class E extends O.$5mc{j(){}getModule(w,m){for(const s of this.b){const o=s(w);if(o){w=o;break}}if(this.a.has(w))return this.a.get(w).load(w,m,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class T extends N.$Slc{constructor(){super(...arguments),this.extensionRuntime=M.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(g.$$oc);const w=this.h.invokeFunction(S.$1mc);this.r=this.h.createInstance(E,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,m,s){m=m.with({path:y(m.path,".js")});const o=w?.identifier.value;o&&performance.mark(`code/extHost/willFetchExtensionCode/${o}`);const r=R.URI.revive(await this.C.$asBrowserUri(m)),t=await fetch(r.toString(!0));if(o&&performance.mark(`code/extHost/didFetchExtensionCode/${o}`),t.status!==200)throw new Error(t.statusText);const n=await t.text(),c=`${m.toString(!0)}#vscode-extension`,h=`${n}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",h)}catch(d){throw console.error(o?`Loading code for extension ${o} failed: ${d.message}`:`Loading code failed: ${d.message}`),console.error(`${m.toString(!0)}${typeof d.line=="number"?` line ${d.line}`:""}${typeof d.column=="number"?` column ${d.column}`:""}`),console.error(d),d}w&&await this.w.initializeLocalizedMessages(w);const $={},a={exports:$},v=d=>{const C=this.r.getModule(d,m);if(C===void 0)throw new Error(`Cannot load module '${d}'`);return C};try{return s.codeLoadingStart(),o&&performance.mark(`code/extHost/willLoadExtensionCode/${o}`),i(a,$,v),a.exports!==$?a.exports:$}finally{o&&performance.mark(`code/extHost/didLoadExtensionCode/${o}`),s.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const m=Date.now()+w;for(;Date.now()<m&&!("__jsDebugIsReady"in globalThis);)await(0,p.$wh)(10)}}e.$_oc=T;function y(l,w){return l.endsWith(w)?l:l+w}}),define(Ce[299],Ae([1,0,70,55,13,39,206,85,298]),function(ge,e,S,N,R,O,M,p,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$ws)(R.$2j,new S.$si(M.$4mc,[!0],!0)),(0,N.$ws)(O.$Tlc,g.$_oc,0),(0,N.$ws)(p.$jlc,p.$klc,0)}),define(Ce[305],Ae([1,0,22,5,77,294,244,19,89,12,2,297,299]),function(ge,e,S,N,R,O,M,p,g,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=h;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const l=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(i){return/^(file|vscode-remote):/i.test(i)}const m=fetch.bind(self);function s(i){self.fetch=async function($,a){return $ instanceof Request||w(String($))&&($=(await i(T.URI.parse(String($)))).toString(!0)),m($,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open($,a,v,d,C){(async()=>(w(a.toString())&&(a=(await i(T.URI.parse(a.toString()))).toString(!0)),super.open($,a,v??!0,d,C)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function($,a){if(/^file:/i.test($.toString()))$=E.$Pg.uriToBrowserUri(T.URI.parse($.toString())).toString(!0);else if(/^vscode-remote:/i.test($.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const d=`(${function(f){function k(I){return typeof I=="string"||I instanceof URL?String(I).replace(/^file:\/\//i,"vscode-file://vscode-app"):I}const b=fetch.bind(self);self.fetch=function(I,W){return I instanceof Request?b(I,W):b(k(I),W)},self.XMLHttpRequest=class extends XMLHttpRequest{open(I,W,V,q,A){return super.open(I,k(W),V??!0,q,A)}};const P=importScripts.bind(self);self.importScripts=(...I)=>{P(...I.map(k))},P(f)}.toString()}('${$}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$oc($.toString())}`;const C=new Blob([d],{type:"application/javascript"}),u=URL.createObjectURL(C);return new i(u,a)}}else self.Worker=class extends M.$apc{constructor(i,$){super(l,i,{name:p.$oc(i.toString()),...$})}};const o=new class{constructor(){this.pid=void 0}exit(i){y()}};class r{constructor(){const $=new MessageChannel,a=new N.$ee;let v=!1;l($.port2,[$.port2]),$.port1.onmessage=d=>{const{data:C}=d;if(!(C instanceof ArrayBuffer)){console.warn("UNKNOWN data received",C);return}const u=S.$Fe.wrap(new Uint8Array(C,0,C.byteLength));if((0,R.$Zm)(u,2)){v=!0,n("received terminate message from renderer");return}a.fire(u)},this.protocol={onMessage:a.event,send:d=>{if(!v){const C=d.buffer.buffer.slice(d.buffer.byteOffset,d.buffer.byteOffset+d.buffer.byteLength);$.port1.postMessage(C,[C])}}}}}function t(i){return new Promise($=>{const a=i.onMessage(v=>{a.dispose();const d=JSON.parse(v.toString());i.send((0,R.$Ym)(0)),$({protocol:i,initData:d})});i.send((0,R.$Ym)(1))})}let n=i=>y();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function h(){g.mark("code/extHost/willConnectToRenderer");const i=new r;return{onmessage($){c($)&&t(i.protocol).then(a=>{g.mark("code/extHost/didWaitForInitData");const v=new O.$7mc(a.protocol,a.initData,o,null,$.data);s(d=>v.asBrowserUri(d)),n=d=>v.terminate(d)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/063d715c4504380317f9ca8eefc602d71e56adb5/core/vs/workbench/api/worker/extensionHostWorker.js.map
